/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],D=0,L=K.length;D<L;D++)e[D]=Z[K[D]];return e};define(Z[90],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(i){const v=[];for(let h in i)D.call(i,h)&&v.push(i[h]);return v}e.values=L;function R(i,v){for(let h in i)if(D.call(i,h)&&v({key:h,value:i[h]},function(){delete i[h]})===!1)return}e.forEach=R;function T(i,v){const h=Object.create(null);for(const b of i){const c=v(b);let y=h[c];y||(y=h[c]=[]),y.push(b)}return h}e.groupBy=T;function A(i){const v=Object.create(null);return i&&i.forEach((h,b)=>{v[b]=h}),v}e.fromMap=A;function P(i,v){const h=[],b=[];for(let c of i)v.has(c)||h.push(c);for(let c of v)i.has(c)||b.push(c);return{removed:h,added:b}}e.diffSets=P;function m(i,v){const h=[],b=[];for(let[c,y]of i)v.has(c)||h.push(y);for(let[c,y]of v)i.has(c)||b.push(y);return{removed:h,added:b}}e.diffMaps=m;class E{constructor(){this.map=new Map}add(v,h){let b=this.map.get(v);b||(b=new Set,this.map.set(v,b)),b.add(h)}delete(v,h){const b=this.map.get(v);!b||(b.delete(h),b.size===0&&this.map.delete(v))}forEach(v,h){const b=this.map.get(v);!b||b.forEach(h)}}e.SetMap=E}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(P,m,E)=>{let i=null,v=null;if(typeof E.value=="function"?(i="value",v=E.value):typeof E.get=="function"&&(i="get",v=E.get),!v)throw new Error("not supported");E[i]=A(v,m)}}e.createDecorator=D;function L(A,P,m){let E=null,i=null;if(typeof m.value=="function"?(E="value",i=m.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",i=m.get),!i)throw new Error("not supported");const v=`$memoize$${P}`;m[E]=function(...h){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,h)}),this[v]}}e.memoize=L;function R(A,P,m){return D((E,i)=>{const v=`$debounce$${i}`,h=`$debounce$result$${i}`;return function(...b){this[h]||(this[h]=m?m():void 0),clearTimeout(this[v]),P&&(this[h]=P(this[h],...b),b=[this[h]]),this[v]=setTimeout(()=>{E.apply(this,b),this[h]=m?m():void 0},A)}})}e.debounce=R;function T(A,P,m){return D((E,i)=>{const v=`$throttle$timer$${i}`,h=`$throttle$result$${i}`,b=`$throttle$lastRun$${i}`,c=`$throttle$pending$${i}`;return function(...y){if(this[h]||(this[h]=m?m():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...y)),this[c])return;const I=this[b]+A;I<=Date.now()?(this[b]=Date.now(),E.apply(this,[this[h]]),this[h]=m?m():void 0):(this[c]=!0,this[v]=setTimeout(()=>{this[c]=!1,this[b]=Date.now(),E.apply(this,[this[h]]),this[h]=m?m():void 0},I-Date.now()))}})}e.throttle=T}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function R(a){m(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function T(a){m(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=T;function A(a){if(a instanceof Error){let{name:t,message:r}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:n}}return a}e.transformErrorForSerialization=A;const P="Canceled";function m(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=m;class E extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=E;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=v;function h(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=h;function b(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function c(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=y;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function S(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=S;function o(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(Z[19],ee([0,1,11]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L($,H=0){return $[$.length-(1+H)]}e.tail=L;function R($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=R;function T($,H,G=(Q,X)=>Q===X){if($===H)return!0;if(!$||!H||$.length!==H.length)return!1;for(let Q=0,X=$.length;Q<X;Q++)if(!G($[Q],H[Q]))return!1;return!0}e.equals=T;function A($,H,G){let Q=0,X=$.length-1;for(;Q<=X;){const ie=(Q+X)/2|0,te=G($[ie],H);if(te<0)Q=ie+1;else if(te>0)X=ie-1;else return ie}return-(Q+1)}e.binarySearch=A;function P($,H){let G=0,Q=$.length;if(Q===0)return 0;for(;G<Q;){const X=Math.floor((G+Q)/2);H($[X])?Q=X:G=X+1}return G}e.findFirstInSorted=P;function m($,H,G){if($=$|0,$>=H.length)throw new TypeError("invalid index");let Q=H[Math.floor(H.length*Math.random())],X=[],ie=[],te=[];for(let oe of H){const ue=G(oe,Q);ue<0?X.push(oe):ue>0?ie.push(oe):te.push(oe)}return $<X.length?m($,X,G):$<X.length+te.length?te[0]:m($-(X.length+te.length),ie,G)}e.quickSelect=m;function E($,H){const G=[];let Q;for(const X of $.slice(0).sort(H))!Q||H(Q[0],X)!==0?(Q=[X],G.push(Q)):Q.push(X);return G}e.groupBy=E;function i($,H,G){const Q=[];function X(oe,ue,ye){if(ue===0&&ye.length===0)return;const ve=Q[Q.length-1];ve&&ve.start+ve.deleteCount===oe?(ve.deleteCount+=ue,ve.toInsert.push(...ye)):Q.push({start:oe,deleteCount:ue,toInsert:ye})}let ie=0,te=0;for(;;){if(ie===$.length){X(ie,0,H.slice(te));break}if(te===H.length){X(ie,$.length-ie,[]);break}const oe=$[ie],ue=H[te],ye=G(oe,ue);ye===0?(ie+=1,te+=1):ye<0?(X(ie,1,[]),ie+=1):ye>0&&(X(ie,0,[ue]),te+=1)}return Q}e.sortedDiff=i;function v($,H,G){const Q=i($,H,G),X=[],ie=[];for(const te of Q)X.push(...$.slice(te.start,te.start+te.deleteCount)),ie.push(...te.toInsert);return{removed:X,added:ie}}e.delta=v;function h($,H,G){if(G===0)return[];const Q=$.slice(0,G).sort(H);return c($,H,Q,G,$.length),Q}e.top=h;function b($,H,G,Q,X){return G===0?Promise.resolve([]):new Promise((ie,te)=>{(async()=>{const oe=$.length,ue=$.slice(0,G).sort(H);for(let ye=G,ve=Math.min(G+Q,oe);ye<oe;ye=ve,ve=Math.min(ve+Q,oe)){if(ye>G&&await new Promise(Re=>setTimeout(Re)),X&&X.isCancellationRequested)throw(0,D.canceled)();c($,H,ue,ye,ve)}return ue})().then(ie,te)})}e.topAsync=b;function c($,H,G,Q,X){for(const ie=G.length;Q<X;Q++){const te=$[Q];if(H(te,G[ie-1])<0){G.pop();const oe=P(G,ue=>H(te,ue)<0);G.splice(oe,0,te)}}}function y($){return $.filter(H=>!!H)}e.coalesce=y;function I($){let H=0;for(let G=0;G<$.length;G++)$[G]&&($[H]=$[G],H+=1);$.length=H}e.coalesceInPlace=I;function w($,H,G){$.splice(G,0,$.splice(H,1)[0])}e.move=w;function C($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=C;function S($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=S;function o($,H){if(!H)return $.filter((Q,X)=>$.indexOf(Q)===X);const G=Object.create(null);return $.filter(Q=>{const X=H(Q);return G[X]?!1:(G[X]=!0,!0)})}e.distinct=o;function a($){const H=new Set;return $.filter(G=>H.has(G)?!1:(H.add(G),!0))}e.distinctES6=a;function t($){const H=Object.create(null);return G=>{const Q=$(G);return H[Q]?!1:(H[Q]=!0,!0)}}e.uniqueFilter=t;function r($,H){for(let G=$.length-1;G>=0;G--){const Q=$[G];if(H(Q))return G}return-1}e.lastIndex=r;function n($,H){return $.length>0?$[0]:H}e.firstOrDefault=n;function s($,H,G=(Q,X)=>Q===X){let Q=0;for(let X=0,ie=Math.min($.length,H.length);X<ie&&G($[X],H[X]);X++)Q++;return Q}e.commonPrefixLength=s;function u($){return[].concat(...$)}e.flatten=u;function l($,H){let G=typeof H=="number"?$:0;typeof H=="number"?G=$:(G=0,H=$);const Q=[];if(G<=H)for(let X=G;X<H;X++)Q.push(X);else for(let X=G;X>H;X--)Q.push(X);return Q}e.range=l;function d($,H,G){return $.reduce((Q,X)=>(Q[H(X)]=G?G(X):X,Q),Object.create(null))}e.index=d;function g($,H){return $.push(H),()=>p($,H)}e.insert=g;function p($,H){const G=$.indexOf(H);if(G>-1)return $.splice(G,1),H}e.remove=p;function f($,H,G){const Q=$.slice(0,H),X=$.slice(H);return Q.concat(G,X)}e.arrayInsert=f;function k($,H){let G;if(typeof H=="number"){let Q=H;G=()=>{const X=Math.sin(Q++)*179426549;return X-Math.floor(X)}}else G=Math.random;for(let Q=$.length-1;Q>0;Q-=1){const X=Math.floor(G()*(Q+1)),ie=$[Q];$[Q]=$[X],$[X]=ie}}e.shuffle=k;function O($,H){const G=$.indexOf(H);G>-1&&($.splice(G,1),$.unshift(H))}e.pushToStart=O;function _($,H){const G=$.indexOf(H);G>-1&&($.splice(G,1),$.push(H))}e.pushToEnd=_;function z($,H){return Array.isArray($)?$.map(H):H($)}e.mapArrayOrNot=z;function V($){return Array.isArray($)?$:[$]}e.asArray=V;function W($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=W;function U($,H){for(const G of $){const Q=H(G);if(Q!==void 0)return Q}}e.mapFind=U;function M($,H,G){const Q=q($,H),X=$.length,ie=G.length;$.length=X+ie;for(let te=X-1;te>=Q;te--)$[te+ie]=$[te];for(let te=0;te<ie;te++)$[te+Q]=G[te]}e.insertInto=M;function F($,H,G,Q){const X=q($,H),ie=$.splice(X,G);return M($,X,Q),ie}e.splice=F;function q($,H){return H<0?Math.max(H+$.length,0):Math.min(H,$.length)}function x($,H){let G=Number.MAX_SAFE_INTEGER,Q=0;return $.forEach((X,ie)=>{const te=H(X);te<G&&(G=te,Q=ie)}),Q}e.minIndex=x;function N($,H){let G=Number.MIN_SAFE_INTEGER,Q=0;return $.forEach((X,ie)=>{const te=H(X);te>G&&(G=te,Q=ie)}),Q}e.maxIndex=N;class j{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let G=this.firstIdx;for(;G<this.items.length&&H(this.items[G]);)G++;const Q=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,Q}takeFromEndWhile(H){let G=this.lastIdx;for(;G>=0&&H(this.items[G]);)G--;const Q=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,Q}}e.ArrayQueue=j}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let T=!1,A;return function(){return T||(T=!0,A=L.apply(R,arguments)),A}}e.once=D}),define(Z[55],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=R;const T=Object.freeze([]);function A(){return T}L.empty=A;function*P(a){yield a}L.single=P;function m(a){return a||T}L.from=m;function E(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=E;function i(a){return a[Symbol.iterator]().next().value}L.first=i;function v(a,t){for(const r of a)if(t(r))return!0;return!1}L.some=v;function h(a,t){for(const r of a)if(t(r))return r}L.find=h;function*b(a,t){for(const r of a)t(r)&&(yield r)}L.filter=b;function*c(a,t){let r=0;for(const n of a)yield t(n,r++)}L.map=c;function*y(...a){for(const t of a)for(const r of t)yield r}L.concat=y;function*I(a){for(const t of a)for(const r of t)yield r}L.concatNested=I;function w(a,t,r){let n=r;for(const s of a)n=t(n,s);return n}L.reduce=w;function*C(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}L.slice=C;function S(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const n=a[Symbol.iterator]();for(let s=0;s<t;s++){const u=n.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return n}}]}L.consume=S;function o(a,t,r=(n,s)=>n===s){const n=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=n.next(),l=s.next();if(u.done!==l.done)return!1;if(u.done)return!0;if(!r(u.value,l.value))return!1}}L.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(Z[33],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let n=0,s=t.length,u="",l=0,d=16,g=0;function p(W){let U=0,M=0;for(;U<W;){const F=t.charCodeAt(n);if(F>=48&&F<=57)M=M*16+F-48;else if(F>=65&&F<=70)M=M*16+F-65+10;else if(F>=97&&F<=102)M=M*16+F-97+10;else break;n++,U++}return U<W&&(M=-1),M}function f(W){n=W,u="",l=0,d=16,g=0}function k(){const W=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&E(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&E(t.charCodeAt(n)))for(n++;n<t.length&&E(t.charCodeAt(n));)n++;else return g=3,t.substring(W,n);let U=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&E(t.charCodeAt(n))){for(n++;n<t.length&&E(t.charCodeAt(n));)n++;U=n}else g=3;return t.substring(W,U)}function O(){let W="",U=n;for(;;){if(n>=s){W+=t.substring(U,n),g=2;break}const M=t.charCodeAt(n);if(M===34){W+=t.substring(U,n),n++;break}if(M===92){if(W+=t.substring(U,n),n++,n>=s){g=2;break}switch(t.charCodeAt(n++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const q=p(4);q>=0?W+=String.fromCharCode(q):g=4;break;default:g=5}U=n;continue}if(M>=0&&M<=31)if(m(M)){W+=t.substring(U,n),g=2;break}else g=6;n++}return W}function _(){if(u="",g=0,l=n,n>=s)return l=s,d=17;let W=t.charCodeAt(n);if(P(W)){do n++,u+=String.fromCharCode(W),W=t.charCodeAt(n);while(P(W));return d=15}if(m(W))return n++,u+=String.fromCharCode(W),W===13&&t.charCodeAt(n)===10&&(n++,u+=`
`),d=14;switch(W){case 123:return n++,d=1;case 125:return n++,d=2;case 91:return n++,d=3;case 93:return n++,d=4;case 58:return n++,d=6;case 44:return n++,d=5;case 34:return n++,u=O(),d=10;case 47:const U=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!m(t.charCodeAt(n));)n++;return u=t.substring(U,n),d=12}if(t.charCodeAt(n+1)===42){n+=2;const M=s-1;let F=!1;for(;n<M;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,F=!0;break}n++}return F||(n++,g=1),u=t.substring(U,n),d=13}return u+=String.fromCharCode(W),n++,d=16;case 45:if(u+=String.fromCharCode(W),n++,n===s||!E(t.charCodeAt(n)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=k(),d=11;default:for(;n<s&&z(W);)n++,W=t.charCodeAt(n);if(l!==n){switch(u=t.substring(l,n),u){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return u+=String.fromCharCode(W),n++,d=16}}function z(W){if(P(W)||m(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let W;do W=_();while(W>=12&&W<=15);return W}return{setPosition:f,getPosition:()=>n,scan:r?V:_,getToken:()=>d,getTokenValue:()=>u,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>g}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function v(t,r){const n=[],s=new Object;let u;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function g(p,f,k,O){l.value=p,l.offset=f,l.length=k,l.type=O,l.colonOffset=void 0,u=l}try{S(t,{onObjectBegin:(p,f)=>{if(r<=p)throw s;u=void 0,d=r>p,n.push("")},onObjectProperty:(p,f,k)=>{if(r<f||(g(p,f,k,"property"),n[n.length-1]=p,r<=f+k))throw s},onObjectEnd:(p,f)=>{if(r<=p)throw s;u=void 0,n.pop()},onArrayBegin:(p,f)=>{if(r<=p)throw s;u=void 0,n.push(0)},onArrayEnd:(p,f)=>{if(r<=p)throw s;u=void 0,n.pop()},onLiteralValue:(p,f,k)=>{if(r<f||(g(p,f,k,a(p)),r<=f+k))throw s},onSeparator:(p,f,k)=>{if(r<=f)throw s;if(p===":"&&u&&u.type==="property")u.colonOffset=f,d=!1,u=void 0;else if(p===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(d=!0,n[n.length-1]=""),u=void 0}}})}catch(p){if(p!==s)throw p}return{path:n,previousNode:u,isAtPropertyKey:d,matches:p=>{let f=0;for(let k=0;f<p.length&&k<n.length;k++)if(p[f]===n[k]||p[f]==="*")f++;else if(p[f]!=="**")return!1;return f===p.length}}}e.getLocation=v;function h(t,r=[],n=T.DEFAULT){let s=null,u=[];const l=[];function d(p){Array.isArray(u)?u.push(p):s!==null&&(u[s]=p)}return S(t,{onObjectBegin:()=>{const p={};d(p),l.push(u),u=p,s=null},onObjectProperty:p=>{s=p},onObjectEnd:()=>{u=l.pop()},onArrayBegin:()=>{const p=[];d(p),l.push(u),u=p,s=null},onArrayEnd:()=>{u=l.pop()},onLiteralValue:d,onError:(p,f,k)=>{r.push({error:p,offset:f,length:k})}},n),u[0]}e.parse=h;function b(t,r=[],n=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(p){s.type==="property"&&(s.length=p-s.offset,s=s.parent)}function l(p){return s.children.push(p),p}S(t,{onObjectBegin:p=>{s=l({type:"object",offset:p,length:-1,parent:s,children:[]})},onObjectProperty:(p,f,k)=>{s=l({type:"property",offset:f,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:p,offset:f,length:k,parent:s})},onObjectEnd:(p,f)=>{s.length=p+f-s.offset,s=s.parent,u(p+f)},onArrayBegin:(p,f)=>{s=l({type:"array",offset:p,length:-1,parent:s,children:[]})},onArrayEnd:(p,f)=>{s.length=p+f-s.offset,s=s.parent,u(p+f)},onLiteralValue:(p,f,k)=>{l({type:a(p),offset:f,length:k,parent:s,value:p}),u(f+k)},onSeparator:(p,f,k)=>{s.type==="property"&&(p===":"?s.colonOffset=f:p===","&&u(f))},onError:(p,f,k)=>{r.push({error:p,offset:f,length:k})}},n);const g=s.children[0];return g&&delete g.parent,g}e.parseTree=b;function c(t,r){if(!t)return;let n=t;for(let s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===s){n=l.children[1],u=!0;break}if(!u)return}else{const u=s;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}e.findNodeAtLocation=c;function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}e.getNodePath=y;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const r=Object.create(null);for(let n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=I(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function w(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}e.contains=w;function C(t,r,n=!1){if(w(t,r,n)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=r;u++){const l=C(s[u],r,n);if(l)return l}return t}}e.findNodeAtOffset=C;function S(t,r,n=T.DEFAULT){const s=A(t,!1);function u(G){return G?()=>G(s.getTokenOffset(),s.getTokenLength()):()=>!0}function l(G){return G?Q=>G(Q,s.getTokenOffset(),s.getTokenLength()):()=>!0}const d=u(r.onObjectBegin),g=l(r.onObjectProperty),p=u(r.onObjectEnd),f=u(r.onArrayBegin),k=u(r.onArrayEnd),O=l(r.onLiteralValue),_=l(r.onSeparator),z=u(r.onComment),V=l(r.onError),W=n&&n.disallowComments,U=n&&n.allowTrailingComma;function M(){for(;;){const G=s.scan();switch(s.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:W||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(G){case 12:case 13:W?F(10):z();break;case 16:F(1);break;case 15:case 14:break;default:return G}}}function F(G,Q=[],X=[]){if(V(G),Q.length+X.length>0){let ie=s.getToken();for(;ie!==17;){if(Q.indexOf(ie)!==-1){M();break}else if(X.indexOf(ie)!==-1)break;ie=M()}}}function q(G){const Q=s.getTokenValue();return G?O(Q):g(Q),M(),!0}function x(){switch(s.getToken()){case 11:let G=0;try{G=JSON.parse(s.getTokenValue()),typeof G!="number"&&(F(2),G=0)}catch(Q){F(2)}O(G);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function N(){return s.getToken()!==10?(F(3,[],[2,5]),!1):(q(!1),s.getToken()===6?(_(":"),M(),H()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function j(){d(),M();let G=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(G||F(4,[],[]),_(","),M(),s.getToken()===2&&U)break}else G&&F(6,[],[]);N()||F(4,[],[2,5]),G=!0}return p(),s.getToken()!==2?F(7,[2],[]):M(),!0}function $(){f(),M();let G=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(G||F(4,[],[]),_(","),M(),s.getToken()===4&&U)break}else G&&F(6,[],[]);H()||F(4,[],[4,5]),G=!0}return k(),s.getToken()!==4?F(8,[4],[]):M(),!0}function H(){switch(s.getToken()){case 3:return $();case 1:return j();case 10:return q(!0);default:return x()}}return M(),s.getToken()===17?n.allowEmptyContent?!0:(F(4,[],[]),!1):H()?(s.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=S;function o(t,r){let n=A(t),s=[],u,l=0,d;do switch(d=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:l!==d&&s.push(t.substring(l,d)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),l=n.getPosition();break}while(u!==17);return s.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[47],ee([0,1,33]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(m,E,i){let v,h,b,c,y;if(E){for(c=E.offset,y=c+E.length,b=c;b>0&&!P(m,b-1);)b--;let l=y;for(;l<m.length&&!P(m,l);)l++;h=m.substring(b,l),v=T(h,i)}else h=m,v=0,b=0,c=0,y=m.length;const I=A(i,m);let w=!1,C=0,S;i.insertSpaces?S=R(" ",i.tabSize||4):S="	";const o=(0,D.createScanner)(h,!1);let a=!1;function t(){return I+R(S,v+C)}function r(){let l=o.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=o.scan();return a=l===16||o.getTokenError()!==0,l}const n=[];function s(l,d,g){!a&&d<y&&g>c&&m.substring(d,g)!==l&&n.push({offset:d,length:g-d,content:l})}let u=r();if(u!==17){const l=o.getTokenOffset()+b,d=R(S,v);s(d,b,l)}for(;u!==17;){let l=o.getTokenOffset()+o.getTokenLength()+b,d=r(),g="";for(;!w&&(d===12||d===13);){const f=o.getTokenOffset()+b;s(" ",l,f),l=o.getTokenOffset()+o.getTokenLength()+b,g=d===12?t():"",d=r()}if(d===2)u!==1&&(C--,g=t());else if(d===4)u!==3&&(C--,g=t());else{switch(u){case 3:case 1:C++,g=t();break;case 5:case 12:g=t();break;case 13:w?g=t():g=" ";break;case 6:g=" ";break;case 10:if(d===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?g=" ":d!==5&&d!==17&&(a=!0);break;case 16:a=!0;break}w&&(d===12||d===13)&&(g=t())}const p=o.getTokenOffset()+b;s(g,l,p),u=d}return n}e.format=L;function R(m,E){let i="";for(let v=0;v<E;v++)i+=m;return i}function T(m,E){let i=0,v=0;const h=E.tabSize||4;for(;i<m.length;){const b=m.charAt(i);if(b===" ")v++;else if(b==="	")v+=h;else break;i++}return Math.floor(v/h)}function A(m,E){for(let i=0;i<E.length;i++){const v=E.charAt(i);if(v==="\r")return i+1<E.length&&E.charAt(i+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=A;function P(m,E){return`\r
`.indexOf(m.charAt(E))!==-1}e.isEOL=P}),define(Z[43],ee([0,1,33,47]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,i,v){return T(E,i,void 0,v)}e.removeProperty=R;function T(E,i,v,h,b){const c=i.slice(),y=[],I=(0,D.parseTree)(E,y);let w,C;for(;c.length>0&&(C=c.pop(),w=(0,D.findNodeAtLocation)(I,c),w===void 0&&v!==void 0);)typeof C=="string"?v={[C]:v}:v=[v];if(w)if(w.type==="object"&&typeof C=="string"&&Array.isArray(w.children)){const S=(0,D.findNodeAtLocation)(w,[C]);if(S!==void 0)if(v===void 0){if(!S.parent)throw new Error("Malformed AST");const o=w.children.indexOf(S.parent);let a,t=S.parent.offset+S.parent.length;if(o>0){const r=w.children[o-1];a=r.offset+r.length}else a=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(E,{offset:a,length:t-a,content:""},h)}else return A(E,{offset:S.offset,length:S.length,content:JSON.stringify(v)},h);else{if(v===void 0)return[];const o=`${JSON.stringify(C)}: ${JSON.stringify(v)}`,a=b?b(w.children.map(r=>r.children[0].value)):w.children.length;let t;if(a>0){const r=w.children[a-1];t={offset:r.offset+r.length,length:0,content:","+o}}else w.children.length===0?t={offset:w.offset+1,length:0,content:o}:t={offset:w.offset+1,length:0,content:o+","};return A(E,t,h)}}else if(w.type==="array"&&typeof C=="number"&&Array.isArray(w.children))if(v!==void 0){const S=`${JSON.stringify(v)}`;let o;if(w.children.length===0||C===0)o={offset:w.offset+1,length:0,content:w.children.length===0?S:S+","};else{const a=C===-1||C>w.children.length?w.children.length:C,t=w.children[a-1];o={offset:t.offset+t.length,length:0,content:","+S}}return A(E,o,h)}else{const S=C,o=w.children[S];let a;if(w.children.length===1)a={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===S){const t=w.children[S-1],r=t.offset+t.length,n=w.offset+w.length;a={offset:r,length:n-2-r,content:""}}else a={offset:o.offset,length:w.children[S+1].offset-o.offset,content:""};return A(E,a,h)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${w.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return A(E,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(v)},h)}}e.setProperty=T;function A(E,i,v){let h=P(E,i),b=i.offset,c=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;b>0&&!(0,L.isEOL)(h,b-1);)b--;for(;c<h.length&&!(0,L.isEOL)(h,c);)c++}const y=(0,L.format)(h,{offset:b,length:c-b},v);for(let w=y.length-1;w>=0;w--){const C=y[w];h=P(h,C),b=Math.min(b,C.offset),c=Math.max(c,C.offset+C.length),c+=C.content.length-C.length}const I=E.length-(h.length-c)-b;return[{offset:b,length:I,content:h.substring(b,c)}]}e.withFormatting=A;function P(E,i){return E.substring(0,i.offset)+i.content+E.substring(i.offset+i.length)}e.applyEdit=P;function m(E,i){let v=i.slice(0).sort((b,c)=>{const y=b.offset-c.offset;return y===0?b.length-c.length:y}),h=E.length;for(let b=v.length-1;b>=0;b--){let c=v[b];if(c.offset+c.length<=h)E=P(E,c);else throw new Error("Overlapping edit");h=c.offset}return E}e.applyEdits=m}),define(Z[2],ee([0,1,65,55]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function A(n){T=n}if(e.setDisposableTracker=A,R){const n="__is_disposable_tracked__";A(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[n]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==C.None)try{s[n]=!0}catch{}}markAsDisposed(s){if(s&&s!==C.None)try{s[n]=!0}catch{}}markAsSingleton(s){}})}function P(n){return T?.trackDisposable(n),n}function m(n){T?.markAsDisposed(n)}function E(n,s){T?.setParent(n,s)}function i(n,s){if(!!T)for(const u of n)T.setParent(u,s)}function v(n){return T?.markAsSingleton(n),n}e.markAsSingleton=v;class h extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=h;function b(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=b;function c(n){if(L.Iterable.is(n)){let s=[];for(const u of n)if(u)try{u.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new h(s);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=c;function y(...n){const s=I(()=>c(n));return i(n,s),s}e.combinedDisposable=y;function I(n){const s=P({dispose:(0,D.once)(()=>{m(s),n()})});return s}e.toDisposable=I;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return E(s,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new w,P(this),E(this._store,this)}dispose(){m(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&E(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&E(s,null),s}}e.MutableDisposable=S;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(s,...u){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,l));const{object:d}=l,g=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:d,dispose:g}}}e.ReferenceCollection=a;class t{constructor(s){this.referenceCollection=s}async acquire(s,...u){const l=this.referenceCollection.acquire(s,...u);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(d){throw l.dispose(),d}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(Z[91],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const A=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(A){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function K(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function A(m){T.push(m,Date.now())}function P(){const m=[];for(let E=0;E<T.length;E+=2)m.push({name:T[E],startTime:T[E+1]});return m}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(R+A.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,T=!1,A=!1,P=!1,m=!1,E=!1,i,v=D,h,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const y=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=y&&c?.sandboxed,typeof navigator=="object"&&!y)b=navigator.userAgent,L=b.indexOf("Windows")>=0,R=b.indexOf("Macintosh")>=0,E=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=b.indexOf("Linux")>=0,m=!0,i=navigator.language,v=i;else if(typeof c=="object"){L=c.platform==="win32",R=c.platform==="darwin",T=c.platform==="linux",A=T&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,i=D,v=D;const n=c.env.VSCODE_NLS_CONFIG;if(n)try{const s=JSON.parse(n),u=s.availableLanguages["*"];i=s.locale,v=u||D,h=s._translationsConfigFile}catch(s){}P=!0}else console.error("Unable to resolve platform.");var I;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function w(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let C=0;R?C=1:L?C=3:T&&(C=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=A,e.isNative=P,e.isWeb=m,e.isIOS=E,e.platform=C,e.userAgent=b,e.language=v;var S;(function(n){function s(){return e.language}n.value=s;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=u;function l(){return e.language==="en"}n.isDefault=l})(S=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let g=0,p=u.length;g<p;g++){const f=u[g];if(f.id===d.data.vscodeSetImmediateId){u.splice(g,1),f.callback();return}}});let l=0;return d=>{const g=++l;u.push({id:g,callback:d}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof c?.nextTick=="function")return c.nextTick.bind(c);const s=Promise.resolve();return u=>s.then(u)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||E?2:L?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(Z[35],ee([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(T){return(0,D.setImmediate)(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(Z[8],ee([0,1,35]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,T=90,A=122,P=46,m=47,E=92,i=58,v=63;class h extends Error{constructor(o,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const n=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${n} ${r} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function b(S,o){if(typeof S!="string")throw new h(o,"string",S)}function c(S){return S===m||S===E}function y(S){return S===m}function I(S){return S>=L&&S<=T||S>=R&&S<=A}function w(S,o,a,t){let r="",n=0,s=-1,u=0,l=0;for(let d=0;d<=S.length;++d){if(d<S.length)l=S.charCodeAt(d);else{if(t(l))break;l=m}if(t(l)){if(!(s===d-1||u===1))if(u===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const g=r.lastIndexOf(a);g===-1?(r="",n=0):(r=r.slice(0,g),n=r.length-1-r.lastIndexOf(a)),s=d,u=0;continue}else if(r.length!==0){r="",n=0,s=d,u=0;continue}}o&&(r+=r.length>0?`${a}..`:"..",n=2)}else r.length>0?r+=`${a}${S.slice(s+1,d)}`:r=S.slice(s+1,d),n=d-s-1;s=d,u=0}else l===P&&u!==-1?++u:u=-1}return r}function C(S,o){if(o===null||typeof o!="object")throw new h("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${S}${t}`:t}e.win32={resolve(...S){let o="",a="",t=!1;for(let r=S.length-1;r>=-1;r--){let n;if(r>=0){if(n=S[r],b(n,"path"),n.length===0)continue}else o.length===0?n=D.cwd():(n=D.env[`=${o}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===E)&&(n=`${o}\\`));const s=n.length;let u=0,l="",d=!1;const g=n.charCodeAt(0);if(s===1)c(g)&&(u=1,d=!0);else if(c(g))if(d=!0,c(n.charCodeAt(1))){let p=2,f=p;for(;p<s&&!c(n.charCodeAt(p));)p++;if(p<s&&p!==f){const k=n.slice(f,p);for(f=p;p<s&&c(n.charCodeAt(p));)p++;if(p<s&&p!==f){for(f=p;p<s&&!c(n.charCodeAt(p));)p++;(p===s||p!==f)&&(l=`\\\\${k}\\${n.slice(f,p)}`,u=p)}}}else u=1;else I(g)&&n.charCodeAt(1)===i&&(l=n.slice(0,2),u=2,s>2&&c(n.charCodeAt(2))&&(d=!0,u=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(a=`${n.slice(u)}\\${a}`,t=d,d&&o.length>0)break}return a=w(a,!t,"\\",c),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(S){b(S,"path");const o=S.length;if(o===0)return".";let a=0,t,r=!1;const n=S.charCodeAt(0);if(o===1)return y(n)?"\\":S;if(c(n))if(r=!0,c(S.charCodeAt(1))){let u=2,l=u;for(;u<o&&!c(S.charCodeAt(u));)u++;if(u<o&&u!==l){const d=S.slice(l,u);for(l=u;u<o&&c(S.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&!c(S.charCodeAt(u));)u++;if(u===o)return`\\\\${d}\\${S.slice(l)}\\`;u!==l&&(t=`\\\\${d}\\${S.slice(l,u)}`,a=u)}}}else a=1;else I(n)&&S.charCodeAt(1)===i&&(t=S.slice(0,2),a=2,o>2&&c(S.charCodeAt(2))&&(r=!0,a=3));let s=a<o?w(S.slice(a),!r,"\\",c):"";return s.length===0&&!r&&(s="."),s.length>0&&c(S.charCodeAt(o-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(S){b(S,"path");const o=S.length;if(o===0)return!1;const a=S.charCodeAt(0);return c(a)||o>2&&I(a)&&S.charCodeAt(1)===i&&c(S.charCodeAt(2))},join(...S){if(S.length===0)return".";let o,a;for(let n=0;n<S.length;++n){const s=S[n];b(s,"path"),s.length>0&&(o===void 0?o=a=s:o+=`\\${s}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&c(a.charCodeAt(0))){++r;const n=a.length;n>1&&c(a.charCodeAt(1))&&(++r,n>2&&(c(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&c(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(S,o){if(b(S,"from"),b(o,"to"),S===o)return"";const a=e.win32.resolve(S),t=e.win32.resolve(o);if(a===t||(S=a.toLowerCase(),o=t.toLowerCase(),S===o))return"";let r=0;for(;r<S.length&&S.charCodeAt(r)===E;)r++;let n=S.length;for(;n-1>r&&S.charCodeAt(n-1)===E;)n--;const s=n-r;let u=0;for(;u<o.length&&o.charCodeAt(u)===E;)u++;let l=o.length;for(;l-1>u&&o.charCodeAt(l-1)===E;)l--;const d=l-u,g=s<d?s:d;let p=-1,f=0;for(;f<g;f++){const O=S.charCodeAt(r+f);if(O!==o.charCodeAt(u+f))break;O===E&&(p=f)}if(f!==g){if(p===-1)return t}else{if(d>g){if(o.charCodeAt(u+f)===E)return t.slice(u+f+1);if(f===2)return t.slice(u+f)}s>g&&(S.charCodeAt(r+f)===E?p=f:f===2&&(p=3)),p===-1&&(p=0)}let k="";for(f=r+p+1;f<=n;++f)(f===n||S.charCodeAt(f)===E)&&(k+=k.length===0?"..":"\\..");return u+=p,k.length>0?`${k}${t.slice(u,l)}`:(t.charCodeAt(u)===E&&++u,t.slice(u,l))},toNamespacedPath(S){if(typeof S!="string")return S;if(S.length===0)return"";const o=e.win32.resolve(S);if(o.length<=2)return S;if(o.charCodeAt(0)===E){if(o.charCodeAt(1)===E){const a=o.charCodeAt(2);if(a!==v&&a!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(I(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===E)return`\\\\?\\${o}`;return S},dirname(S){b(S,"path");const o=S.length;if(o===0)return".";let a=-1,t=0;const r=S.charCodeAt(0);if(o===1)return c(r)?S:".";if(c(r)){if(a=t=1,c(S.charCodeAt(1))){let u=2,l=u;for(;u<o&&!c(S.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&c(S.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&!c(S.charCodeAt(u));)u++;if(u===o)return S;u!==l&&(a=t=u+1)}}}}else I(r)&&S.charCodeAt(1)===i&&(a=o>2&&c(S.charCodeAt(2))?3:2,t=a);let n=-1,s=!0;for(let u=o-1;u>=t;--u)if(c(S.charCodeAt(u))){if(!s){n=u;break}}else s=!1;if(n===-1){if(a===-1)return".";n=a}return S.slice(0,n)},basename(S,o){o!==void 0&&b(o,"ext"),b(S,"path");let a=0,t=-1,r=!0,n;if(S.length>=2&&I(S.charCodeAt(0))&&S.charCodeAt(1)===i&&(a=2),o!==void 0&&o.length>0&&o.length<=S.length){if(o===S)return"";let s=o.length-1,u=-1;for(n=S.length-1;n>=a;--n){const l=S.charCodeAt(n);if(c(l)){if(!r){a=n+1;break}}else u===-1&&(r=!1,u=n+1),s>=0&&(l===o.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=u))}return a===t?t=u:t===-1&&(t=S.length),S.slice(a,t)}for(n=S.length-1;n>=a;--n)if(c(S.charCodeAt(n))){if(!r){a=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":S.slice(a,t)},extname(S){b(S,"path");let o=0,a=-1,t=0,r=-1,n=!0,s=0;S.length>=2&&S.charCodeAt(1)===i&&I(S.charCodeAt(0))&&(o=t=2);for(let u=S.length-1;u>=o;--u){const l=S.charCodeAt(u);if(c(l)){if(!n){t=u+1;break}continue}r===-1&&(n=!1,r=u+1),l===P?a===-1?a=u:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||r===-1||s===0||s===1&&a===r-1&&a===t+1?"":S.slice(a,r)},format:C.bind(null,"\\"),parse(S){b(S,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(S.length===0)return o;const a=S.length;let t=0,r=S.charCodeAt(0);if(a===1)return c(r)?(o.root=o.dir=S,o):(o.base=o.name=S,o);if(c(r)){if(t=1,c(S.charCodeAt(1))){let p=2,f=p;for(;p<a&&!c(S.charCodeAt(p));)p++;if(p<a&&p!==f){for(f=p;p<a&&c(S.charCodeAt(p));)p++;if(p<a&&p!==f){for(f=p;p<a&&!c(S.charCodeAt(p));)p++;p===a?t=p:p!==f&&(t=p+1)}}}}else if(I(r)&&S.charCodeAt(1)===i){if(a<=2)return o.root=o.dir=S,o;if(t=2,c(S.charCodeAt(2))){if(a===3)return o.root=o.dir=S,o;t=3}}t>0&&(o.root=S.slice(0,t));let n=-1,s=t,u=-1,l=!0,d=S.length-1,g=0;for(;d>=t;--d){if(r=S.charCodeAt(d),c(r)){if(!l){s=d+1;break}continue}u===-1&&(l=!1,u=d+1),r===P?n===-1?n=d:g!==1&&(g=1):n!==-1&&(g=-1)}return u!==-1&&(n===-1||g===0||g===1&&n===u-1&&n===s+1?o.base=o.name=S.slice(s,u):(o.name=S.slice(s,n),o.base=S.slice(s,u),o.ext=S.slice(n,u))),s>0&&s!==t?o.dir=S.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...S){let o="",a=!1;for(let t=S.length-1;t>=-1&&!a;t--){const r=t>=0?S[t]:D.cwd();b(r,"path"),r.length!==0&&(o=`${r}/${o}`,a=r.charCodeAt(0)===m)}return o=w(o,!a,"/",y),a?`/${o}`:o.length>0?o:"."},normalize(S){if(b(S,"path"),S.length===0)return".";const o=S.charCodeAt(0)===m,a=S.charCodeAt(S.length-1)===m;return S=w(S,!o,"/",y),S.length===0?o?"/":a?"./":".":(a&&(S+="/"),o?`/${S}`:S)},isAbsolute(S){return b(S,"path"),S.length>0&&S.charCodeAt(0)===m},join(...S){if(S.length===0)return".";let o;for(let a=0;a<S.length;++a){const t=S[a];b(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(S,o){if(b(S,"from"),b(o,"to"),S===o||(S=e.posix.resolve(S),o=e.posix.resolve(o),S===o))return"";const a=1,t=S.length,r=t-a,n=1,s=o.length-n,u=r<s?r:s;let l=-1,d=0;for(;d<u;d++){const p=S.charCodeAt(a+d);if(p!==o.charCodeAt(n+d))break;p===m&&(l=d)}if(d===u)if(s>u){if(o.charCodeAt(n+d)===m)return o.slice(n+d+1);if(d===0)return o.slice(n+d)}else r>u&&(S.charCodeAt(a+d)===m?l=d:d===0&&(l=0));let g="";for(d=a+l+1;d<=t;++d)(d===t||S.charCodeAt(d)===m)&&(g+=g.length===0?"..":"/..");return`${g}${o.slice(n+l)}`},toNamespacedPath(S){return S},dirname(S){if(b(S,"path"),S.length===0)return".";const o=S.charCodeAt(0)===m;let a=-1,t=!0;for(let r=S.length-1;r>=1;--r)if(S.charCodeAt(r)===m){if(!t){a=r;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":S.slice(0,a)},basename(S,o){o!==void 0&&b(o,"ext"),b(S,"path");let a=0,t=-1,r=!0,n;if(o!==void 0&&o.length>0&&o.length<=S.length){if(o===S)return"";let s=o.length-1,u=-1;for(n=S.length-1;n>=0;--n){const l=S.charCodeAt(n);if(l===m){if(!r){a=n+1;break}}else u===-1&&(r=!1,u=n+1),s>=0&&(l===o.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=u))}return a===t?t=u:t===-1&&(t=S.length),S.slice(a,t)}for(n=S.length-1;n>=0;--n)if(S.charCodeAt(n)===m){if(!r){a=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":S.slice(a,t)},extname(S){b(S,"path");let o=-1,a=0,t=-1,r=!0,n=0;for(let s=S.length-1;s>=0;--s){const u=S.charCodeAt(s);if(u===m){if(!r){a=s+1;break}continue}t===-1&&(r=!1,t=s+1),u===P?o===-1?o=s:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||t===-1||n===0||n===1&&o===t-1&&o===a+1?"":S.slice(o,t)},format:C.bind(null,"/"),parse(S){b(S,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(S.length===0)return o;const a=S.charCodeAt(0)===m;let t;a?(o.root="/",t=1):t=0;let r=-1,n=0,s=-1,u=!0,l=S.length-1,d=0;for(;l>=t;--l){const g=S.charCodeAt(l);if(g===m){if(!u){n=l+1;break}continue}s===-1&&(u=!1,s=l+1),g===P?r===-1?r=l:d!==1&&(d=1):r!==-1&&(d=-1)}if(s!==-1){const g=n===0&&a?1:n;r===-1||d===0||d===1&&r===s-1&&r===n+1?o.base=o.name=S.slice(g,s):(o.name=S.slice(g,r),o.base=S.slice(g,s),o.ext=S.slice(r,s))}return n>0?o.dir=S.slice(0,n-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:K)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return K[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=K,D.c=e,D.d=function(L,R,T){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:T})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var A in L)D.d(T,A,function(P){return L[P]}.bind(null,A));return T},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(K,e,D){(function(L){var R;e=K.exports=X,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],m=e.src=[],E=0,i=E++;m[i]="0|[1-9]\\d*";var v=E++;m[v]="[0-9]+";var h=E++;m[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=E++;m[b]="("+m[i]+")\\.("+m[i]+")\\.("+m[i]+")";var c=E++;m[c]="("+m[v]+")\\.("+m[v]+")\\.("+m[v]+")";var y=E++;m[y]="(?:"+m[i]+"|"+m[h]+")";var I=E++;m[I]="(?:"+m[v]+"|"+m[h]+")";var w=E++;m[w]="(?:-("+m[y]+"(?:\\."+m[y]+")*))";var C=E++;m[C]="(?:-?("+m[I]+"(?:\\."+m[I]+")*))";var S=E++;m[S]="[0-9A-Za-z-]+";var o=E++;m[o]="(?:\\+("+m[S]+"(?:\\."+m[S]+")*))";var a=E++,t="v?"+m[b]+m[w]+"?"+m[o]+"?";m[a]="^"+t+"$";var r="[v=\\s]*"+m[c]+m[C]+"?"+m[o]+"?",n=E++;m[n]="^"+r+"$";var s=E++;m[s]="((?:<|>)?=?)";var u=E++;m[u]=m[v]+"|x|X|\\*";var l=E++;m[l]=m[i]+"|x|X|\\*";var d=E++;m[d]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[w]+")?"+m[o]+"?)?)?";var g=E++;m[g]="[v=\\s]*("+m[u]+")(?:\\.("+m[u]+")(?:\\.("+m[u]+")(?:"+m[C]+")?"+m[o]+"?)?)?";var p=E++;m[p]="^"+m[s]+"\\s*"+m[d]+"$";var f=E++;m[f]="^"+m[s]+"\\s*"+m[g]+"$";var k=E++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;m[O]="(?:~>?)";var _=E++;m[_]="(\\s*)"+m[O]+"\\s+",P[_]=new RegExp(m[_],"g");var z=E++;m[z]="^"+m[O]+m[d]+"$";var V=E++;m[V]="^"+m[O]+m[g]+"$";var W=E++;m[W]="(?:\\^)";var U=E++;m[U]="(\\s*)"+m[W]+"\\s+",P[U]=new RegExp(m[U],"g");var M=E++;m[M]="^"+m[W]+m[d]+"$";var F=E++;m[F]="^"+m[W]+m[g]+"$";var q=E++;m[q]="^"+m[s]+"\\s*("+r+")$|^$";var x=E++;m[x]="^"+m[s]+"\\s*("+t+")$|^$";var N=E++;m[N]="(\\s*)"+m[s]+"\\s*("+r+"|"+m[d]+")",P[N]=new RegExp(m[N],"g");var j=E++;m[j]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var $=E++;m[$]="^\\s*("+m[g]+")\\s+-\\s+("+m[g]+")\\s*$";var H=E++;m[H]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)R(G,m[G]),P[G]||(P[G]=new RegExp(m[G]));function Q(J,re){if(J instanceof X)return J;if(typeof J!="string"||J.length>T||!(re?P[n]:P[a]).test(J))return null;try{return new X(J,re)}catch(se){return null}}function X(J,re){if(J instanceof X){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof X))return new X(J,re);R("SemVer",J,re),this.loose=re;var se=J.trim().match(re?P[n]:P[a]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var me=+ge;if(me>=0&&me<A)return me}return ge}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=Q,e.valid=function(J,re){var se=Q(J,re);return se?se.version:null},e.clean=function(J,re){var se=Q(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(J){return R("SemVer.compare",this.version,this.loose,J),J instanceof X||(J=new X(J,this.loose)),this.compareMain(J)||this.comparePre(J)},X.prototype.compareMain=function(J){return J instanceof X||(J=new X(J,this.loose)),te(this.major,J.major)||te(this.minor,J.minor)||te(this.patch,J.patch)},X.prototype.comparePre=function(J){if(J instanceof X||(J=new X(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],ge=J.prerelease[re];if(R("prerelease compare",re,se,ge),se===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(se===void 0)return-1;if(se!==ge)return te(se,ge)}while(++re)},X.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,ge){typeof se=="string"&&(ge=se,se=void 0);try{return new X(J,se).inc(re,ge).version}catch(me){return null}},e.diff=function(J,re){if(ve(J,re))return null;var se=Q(J),ge=Q(re);if(se.prerelease.length||ge.prerelease.length){for(var me in se)if((me==="major"||me==="minor"||me==="patch")&&se[me]!==ge[me])return"pre"+me;return"prerelease"}for(var me in se)if((me==="major"||me==="minor"||me==="patch")&&se[me]!==ge[me])return me},e.compareIdentifiers=te;var ie=/^[0-9]+$/;function te(J,re){var se=ie.test(J),ge=ie.test(re);return se&&ge&&(J=+J,re=+re),se&&!ge?-1:ge&&!se?1:J<re?-1:J>re?1:0}function oe(J,re,se){return new X(J,se).compare(new X(re,se))}function ue(J,re,se){return oe(J,re,se)>0}function ye(J,re,se){return oe(J,re,se)<0}function ve(J,re,se){return oe(J,re,se)===0}function Re(J,re,se){return oe(J,re,se)!==0}function Te(J,re,se){return oe(J,re,se)>=0}function Ne(J,re,se){return oe(J,re,se)<=0}function Oe(J,re,se,ge){var me;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),me=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),me=J!==se;break;case"":case"=":case"==":me=ve(J,se,ge);break;case"!=":me=Re(J,se,ge);break;case">":me=ue(J,se,ge);break;case">=":me=Te(J,se,ge);break;case"<":me=ye(J,se,ge);break;case"<=":me=Ne(J,se,ge);break;default:throw new TypeError("Invalid operator: "+re)}return me}function ke(J,re){if(J instanceof ke){if(J.loose===re)return J;J=J.value}if(!(this instanceof ke))return new ke(J,re);R("comparator",J,re),this.loose=re,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(J,re){return te(re,J)},e.major=function(J,re){return new X(J,re).major},e.minor=function(J,re){return new X(J,re).minor},e.patch=function(J,re){return new X(J,re).patch},e.compare=oe,e.compareLoose=function(J,re){return oe(J,re,!0)},e.rcompare=function(J,re,se){return oe(re,J,se)},e.sort=function(J,re){return J.sort(function(se,ge){return e.compare(se,ge,re)})},e.rsort=function(J,re){return J.sort(function(se,ge){return e.rcompare(se,ge,re)})},e.gt=ue,e.lt=ye,e.eq=ve,e.neq=Re,e.gte=Te,e.lte=Ne,e.cmp=Oe,e.Comparator=ke;var _e={};function Ie(J,re){if(J instanceof Ie)return J.loose===re?J:new Ie(J.raw,re);if(J instanceof ke)return new Ie(J.value,re);if(!(this instanceof Ie))return new Ie(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ae(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ye(J,re,se,ge,me,Pe,be,De,Ce,B,ne,ae,ce){return((re=Ae(se)?"":Ae(ge)?">="+se+".0.0":Ae(me)?">="+se+"."+ge+".0":">="+re)+" "+(De=Ae(Ce)?"":Ae(B)?"<"+(+Ce+1)+".0.0":Ae(ne)?"<"+Ce+"."+(+B+1)+".0":ae?"<="+Ce+"."+B+"."+ne+"-"+ae:"<="+De)).trim()}function Je(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(R(J[se].semver),J[se].semver!==_e&&J[se].semver.prerelease.length>0){var ge=J[se].semver;if(ge.major===re.major&&ge.minor===re.minor&&ge.patch===re.patch)return!0}return!1}return!0}function $e(J,re,se){try{re=new Ie(re,se)}catch(ge){return!1}return re.test(J)}function qe(J,re,se,ge){var me,Pe,be,De,Ce;switch(J=new X(J,ge),re=new Ie(re,ge),se){case">":me=ue,Pe=Ne,be=ye,De=">",Ce=">=";break;case"<":me=ye,Pe=Te,be=ue,De="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,re,ge))return!1;for(var B=0;B<re.set.length;++B){var ne=re.set[B],ae=null,ce=null;if(ne.forEach(function(fe){fe.semver===_e&&(fe=new ke(">=0.0.0")),ae=ae||fe,ce=ce||fe,me(fe.semver,ae.semver,ge)?ae=fe:be(fe.semver,ce.semver,ge)&&(ce=fe)}),ae.operator===De||ae.operator===Ce||(!ce.operator||ce.operator===De)&&Pe(J,ce.semver)||ce.operator===Ce&&be(J,ce.semver))return!1}return!0}ke.prototype.parse=function(J){var re=this.loose?P[q]:P[x],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new X(se[2],this.loose):this.semver=_e},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(J){return R("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new X(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(J,re){if(!(J instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(J.value,re),$e(this.value,se,re);if(J.operator==="")return se=new Ie(this.value,re),$e(J.semver,se,re);var ge=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Pe=this.semver.version===J.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),De=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ce=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ge||me||Pe&&be||De||Ce},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),R("range",J,re);var se=re?P[$]:P[j];J=J.replace(se,Ye),R("hyphen replace",J),J=J.replace(P[N],"$1$2$3"),R("comparator trim",J,P[N]),J=(J=(J=J.replace(P[_],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var ge=re?P[q]:P[x],me=J.split(" ").map(function(Pe){return function(be,De){return R("comp",be),be=function(Ce,B){return Ce.trim().split(/\s+/).map(function(ne){return function(ae,ce){R("caret",ae,ce);var fe=ce?P[F]:P[M];return ae.replace(fe,function(Se,de,pe,we,Ee){var le;return R("caret",ae,Se,de,pe,we,Ee),Ae(de)?le="":Ae(pe)?le=">="+de+".0.0 <"+(+de+1)+".0.0":Ae(we)?le=de==="0"?">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+".0 <"+(+de+1)+".0.0":Ee?(R("replaceCaret pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),le=de==="0"?pe==="0"?">="+de+"."+pe+"."+we+Ee+" <"+de+"."+pe+"."+(+we+1):">="+de+"."+pe+"."+we+Ee+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+we+Ee+" <"+(+de+1)+".0.0"):(R("no pr"),le=de==="0"?pe==="0"?">="+de+"."+pe+"."+we+" <"+de+"."+pe+"."+(+we+1):">="+de+"."+pe+"."+we+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+we+" <"+(+de+1)+".0.0"),R("caret return",le),le})}(ne,B)}).join(" ")}(be,De),R("caret",be),be=function(Ce,B){return Ce.trim().split(/\s+/).map(function(ne){return function(ae,ce){var fe=ce?P[V]:P[z];return ae.replace(fe,function(Se,de,pe,we,Ee){var le;return R("tilde",ae,Se,de,pe,we,Ee),Ae(de)?le="":Ae(pe)?le=">="+de+".0.0 <"+(+de+1)+".0.0":Ae(we)?le=">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":Ee?(R("replaceTilde pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),le=">="+de+"."+pe+"."+we+Ee+" <"+de+"."+(+pe+1)+".0"):le=">="+de+"."+pe+"."+we+" <"+de+"."+(+pe+1)+".0",R("tilde return",le),le})}(ne,B)}).join(" ")}(be,De),R("tildes",be),be=function(Ce,B){return R("replaceXRanges",Ce,B),Ce.split(/\s+/).map(function(ne){return function(ae,ce){ae=ae.trim();var fe=ce?P[f]:P[p];return ae.replace(fe,function(Se,de,pe,we,Ee,le){R("xRange",ae,Se,de,pe,we,Ee,le);var Le=Ae(pe),Ue=Le||Ae(we),Fe=Ue||Ae(Ee);return de==="="&&Fe&&(de=""),Le?Se=de===">"||de==="<"?"<0.0.0":"*":de&&Fe?(Ue&&(we=0),Fe&&(Ee=0),de===">"?(de=">=",Ue?(pe=+pe+1,we=0,Ee=0):Fe&&(we=+we+1,Ee=0)):de==="<="&&(de="<",Ue?pe=+pe+1:we=+we+1),Se=de+pe+"."+we+"."+Ee):Ue?Se=">="+pe+".0.0 <"+(+pe+1)+".0.0":Fe&&(Se=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0"),R("xRange return",Se),Se})}(ne,B)}).join(" ")}(be,De),R("xrange",be),be=function(Ce,B){return R("replaceStars",Ce,B),Ce.trim().replace(P[H],"")}(be,De),R("stars",be),be}(Pe,re)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Pe){return!!Pe.match(ge)})),me=me.map(function(Pe){return new ke(Pe,re)})},Ie.prototype.intersects=function(J,re){if(!(J instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(ge){return J.set.some(function(me){return me.every(function(Pe){return ge.intersects(Pe,re)})})})})},e.toComparators=function(J,re){return new Ie(J,re).set.map(function(se){return se.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new X(J,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,re,se){var ge=null,me=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(ge&&me.compare(be)!==-1||(me=new X(ge=be,se)))}),ge},e.minSatisfying=function(J,re,se){var ge=null,me=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(ge&&me.compare(be)!==1||(me=new X(ge=be,se)))}),ge},e.validRange=function(J,re){try{return new Ie(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return qe(J,re,"<",se)},e.gtr=function(J,re,se){return qe(J,re,">",se)},e.outside=qe,e.prerelease=function(J,re){var se=Q(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new Ie(J,se),re=new Ie(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof X)return J;if(typeof J!="string")return null;var re=J.match(P[k]);return re==null?null:Q((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,D(1))},function(K,e){var D,L,R=K.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(I){if(D===setTimeout)return setTimeout(I,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(I,0);try{return D(I,0)}catch(w){try{return D.call(null,I,0)}catch(C){return D.call(this,I,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch(I){D=T}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(I){L=A}})();var m,E=[],i=!1,v=-1;function h(){i&&m&&(i=!1,m.length?E=m.concat(E):v=-1,E.length&&b())}function b(){if(!i){var I=P(h);i=!0;for(var w=E.length;w;){for(m=E,E=[];++v<w;)m&&m[v].run();v=-1,w=E.length}m=null,i=!1,function(C){if(L===clearTimeout)return clearTimeout(C);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(C);try{L(C)}catch(S){try{return L.call(null,C)}catch(o){return L.call(this,C)}}}(I)}}function c(I,w){this.fun=I,this.array=w}function y(){}R.nextTick=function(I){var w=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)w[C-1]=arguments[C];E.push(new c(I,w)),E.length!==1||i||P(b)},c.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=y,R.addListener=y,R.once=y,R.off=y,R.removeListener=y,R.removeAllListeners=y,R.emit=y,R.prependListener=y,R.prependOnceListener=y,R.listeners=function(I){return[]},R.binding=function(I){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(I){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[92],ee([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new R(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[3],ee([0,1,11,65,2,91,92]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(S){S.None=()=>R.Disposable.None;function o(W){return(U,M=null,F)=>{let q=!1,x;return x=W(N=>{if(!q)return x?x.dispose():q=!0,U.call(M,N)},null,F),q&&x.dispose(),x}}S.once=o;function a(W,U){return l((M,F=null,q)=>W(x=>M.call(F,U(x)),null,q))}S.map=a;function t(W,U){return l((M,F=null,q)=>W(x=>{U(x),M.call(F,x)},null,q))}S.forEach=t;function r(W,U){return l((M,F=null,q)=>W(x=>U(x)&&M.call(F,x),null,q))}S.filter=r;function n(W){return W}S.signal=n;function s(...W){return(U,M=null,F)=>(0,R.combinedDisposable)(...W.map(q=>q(x=>U.call(M,x),null,F)))}S.any=s;function u(W,U,M){let F=M;return a(W,q=>(F=U(F,q),F))}S.reduce=u;function l(W){let U;const M=new h({onFirstListenerAdd(){U=W(M.fire,M)},onLastListenerRemove(){U.dispose()}});return M.event}function d(W,U,M=100,F=!1,q){let x,N,j,$=0;const H=new h({leakWarningThreshold:q,onFirstListenerAdd(){x=W(G=>{$++,N=U(N,G),F&&!j&&(H.fire(N),N=void 0),clearTimeout(j),j=setTimeout(()=>{const Q=N;N=void 0,j=void 0,(!F||$>1)&&H.fire(Q),$=0},M)})},onLastListenerRemove(){x.dispose()}});return H.event}S.debounce=d;function g(W,U=(M,F)=>M===F){let M=!0,F;return r(W,q=>{const x=M||!U(q,F);return M=!1,F=q,x})}S.latch=g;function p(W,U){return[S.filter(W,U),S.filter(W,M=>!U(M))]}S.split=p;function f(W,U=!1,M=[]){let F=M.slice(),q=W(j=>{F?F.push(j):N.fire(j)});const x=()=>{F&&F.forEach(j=>N.fire(j)),F=null},N=new h({onFirstListenerAdd(){q||(q=W(j=>N.fire(j)))},onFirstListenerDidAdd(){F&&(U?setTimeout(x):x())},onLastListenerRemove(){q&&q.dispose(),q=null}});return N.event}S.buffer=f;class k{constructor(U){this.event=U}map(U){return new k(a(this.event,U))}forEach(U){return new k(t(this.event,U))}filter(U){return new k(r(this.event,U))}reduce(U,M){return new k(u(this.event,U,M))}latch(){return new k(g(this.event))}debounce(U,M=100,F=!1,q){return new k(d(this.event,U,M,F,q))}on(U,M,F){return this.event(U,M,F)}once(U,M,F){return o(this.event)(U,M,F)}}function O(W){return new k(W)}S.chain=O;function _(W,U,M=F=>F){const F=(...j)=>N.fire(M(...j)),q=()=>W.on(U,F),x=()=>W.removeListener(U,F),N=new h({onFirstListenerAdd:q,onLastListenerRemove:x});return N.event}S.fromNodeEventEmitter=_;function z(W,U,M=F=>F){const F=(...j)=>N.fire(M(...j)),q=()=>W.addEventListener(U,F),x=()=>W.removeEventListener(U,F),N=new h({onFirstListenerAdd:q,onLastListenerRemove:x});return N.event}S.fromDOMEventEmitter=z;function V(W){return new Promise(U=>o(W)(U))}S.toPromise=V})(P=e.Event||(e.Event={}));class m{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${m._idPool++}`}start(o){this._stopWatch=new A.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let E=-1;function i(S){const o=E;return E=S,{dispose(){E=o}}}e.setGlobalLeakWarningThreshold=i;class v{constructor(o,a=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let a=E;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||o<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let n,s=0;for(const[u,l]of this._stacks)(!n||s<l)&&(n=u,s=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${s}):`),console.warn(n)}return()=>{const n=this._stacks.get(t)||0;this._stacks.set(t,n-1)}}}class h{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=E>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(o,a,t)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(a?[o,a]:o);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,a);const s=this._leakageMon?.check(this._listeners.size),u=(0,R.toDisposable)(()=>{s&&s(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof R.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){(0,D.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=h;class b extends h{async fireAsync(o,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,o]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[r,n]=this._asyncDeliveryQueue.shift(),s=[],u={...n,waitUntil:l=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(l=t(l,typeof r=="function"?r:r[0])),s.push(l)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(l){(0,D.onUnexpectedError)(l);continue}Object.freeze(s),await Promise.allSettled(s).then(l=>{for(const d of l)d.status==="rejected"&&(0,D.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=b;class c extends h{constructor(o){super(o);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=c;class y extends c{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=y;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const a={event:o,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const r=this.events.indexOf(a);this.events.splice(r,1)};return(0,R.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(a=>this.emitter.fire(a))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class w{constructor(){this.buffers=[]}wrapEvent(o){return(a,t,r)=>o(n=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>a.call(t,n)):a.call(t,n)},void 0,r)}bufferEvents(o){const a=[];this.buffers.push(a);const t=o();return this.buffers.pop(),a.forEach(r=>r()),t}}e.EventBufferer=w;class C{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(Z[29],ee([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,m){const E=setTimeout(P.bind(m),0);return{dispose(){clearTimeout(E)}}});var R;(function(P){function m(E){return E===P.None||E===P.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=m,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=A}),define(Z[48],ee([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(v){const h=this._icons.get(v.id);h?v.description?h.description=v.description:console.error(`Duplicate registration of codicon ${v.id}`):(this._icons.set(v.id,v),this._onDidRegister.fire(v))}get(v){return this._icons.get(v)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function T(i,v){return new P(i,v)}e.registerCodicon=T;function A(i){return i?i.replace(/\$\((.*?)\)/g,(v,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(v,h,b){this.id=v,this.definition=h,this.description=b,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function m(i,v){const h=["codicon","codicon-"+i];return v&&h.push("codicon-modifier-"+v),h}e.getClassNamesArray=m;var E;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const v=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function h(y){if(y instanceof P)return["codicon","codicon-"+y.id];const I=v.exec(y.id);if(!I)return h(P.error);let[,w,C]=I;const S=["codicon","codicon-"+w];return C&&S.push("codicon-modifier-"+C.substr(1)),S}i.asClassNameArray=h;function b(y){return h(y).join(" ")}i.asClassName=b;function c(y){return"."+h(y).join(".")}i.asCSSSelector=c})(E=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[49],ee([0,1,11,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(S){const o=S;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=R;function T(S){const o=S;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(S,o){return new P(S,o)}e.newWriteableStream=A;class P{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,D.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(S,o){const a=[];let t;for(;(t=S.read())!==null;)a.push(t);return o(a)}e.consumeReadable=m;function E(S,o,a){const t=[];let r;for(;(r=S.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const n=r;return r=void 0,n}return S.read()}}}e.peekReadable=E;function i(S,o){return new Promise((a,t)=>{const r=[];v(S,{onData:n=>{o&&r.push(n)},onError:n=>{o?t(n):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}e.consumeStream=i;function v(S,o){S.on("error",a=>o.onError(a)),S.on("end",()=>o.onEnd()),S.on("data",a=>o.onData(a))}e.listenStream=v;function h(S,o){return new Promise((a,t)=>{const r=new L.DisposableStore,n=[],s=d=>{if(n.push(d),n.length>o)return r.dispose(),S.pause(),a({stream:S,buffer:n,ended:!1})},u=d=>t(d),l=()=>a({stream:S,buffer:n,ended:!0});r.add((0,L.toDisposable)(()=>S.removeListener("error",u))),S.on("error",u),r.add((0,L.toDisposable)(()=>S.removeListener("end",l))),S.on("end",l),r.add((0,L.toDisposable)(()=>S.removeListener("data",s))),S.on("data",s)})}e.peekStream=h;function b(S,o){const a=A(o);return a.end(S),a}e.toStream=b;function c(){const S=A(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=c;function y(S){let o=!1;return{read:()=>o?null:(o=!0,S)}}e.toReadable=y;function I(S,o,a){const t=A(a);return v(S,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=I;function w(S,o,a){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?a([S,r]):S)}}}e.prefixedReadable=w;function C(S,o,a){let t=!1;const r=A(a);return v(o,{onData:n=>t?r.write(n):(t=!0,r.write(a([S,n]))),onError:n=>r.error(n),onEnd:()=>{t||(t=!0,r.write(S)),r.end()}}),r}e.prefixedStream=C}),define(Z[25],ee([0,1,49]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,T;class A{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new A(Buffer.allocUnsafe(s)):new A(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new A(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(s)):(R||(R=new TextEncoder),new A(R.encode(s)))}static concat(s,u){if(typeof u=="undefined"){u=0;for(let g=0,p=s.length;g<p;g++)u+=s[g].byteLength}const l=A.alloc(u);let d=0;for(let g=0,p=s.length;g<p;g++){const f=s[g];l.set(f,d),d+=f.byteLength}return l}toString(){return L?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(s,u){return new A(this.buffer.subarray(s,u))}set(s,u){s instanceof A?this.buffer.set(s.buffer,u):this.buffer.set(s,u)}readUInt32BE(s){return E(this.buffer,s)}writeUInt32BE(s,u){i(this.buffer,s,u)}readUInt32LE(s){return v(this.buffer,s)}writeUInt32LE(s,u){h(this.buffer,s,u)}readUInt8(s){return b(this.buffer,s)}writeUInt8(s,u){c(this.buffer,s,u)}}e.VSBuffer=A;function P(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0}e.readUInt16LE=P;function m(n,s,u){n[u+0]=s&255,s=s>>>8,n[u+1]=s&255}e.writeUInt16LE=m;function E(n,s){return n[s]*2**24+n[s+1]*2**16+n[s+2]*2**8+n[s+3]}e.readUInt32BE=E;function i(n,s,u){n[u+3]=s,s=s>>>8,n[u+2]=s,s=s>>>8,n[u+1]=s,s=s>>>8,n[u]=s}e.writeUInt32BE=i;function v(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0|n[s+2]<<16>>>0|n[s+3]<<24>>>0}e.readUInt32LE=v;function h(n,s,u){n[u+0]=s&255,s=s>>>8,n[u+1]=s&255,s=s>>>8,n[u+2]=s&255,s=s>>>8,n[u+3]=s&255}e.writeUInt32LE=h;function b(n,s){return n[s]}e.readUInt8=b;function c(n,s,u){n[u]=s}e.writeUInt8=c;function y(n){return D.consumeReadable(n,s=>A.concat(s))}e.readableToBuffer=y;function I(n){return D.toReadable(n)}e.bufferToReadable=I;function w(n){return D.consumeStream(n,s=>A.concat(s))}e.streamToBuffer=w;async function C(n){return n.ended?A.concat(n.buffer):A.concat([...n.buffer,await w(n.stream)])}e.bufferedStreamToBuffer=C;function S(n){return D.toStream(n,s=>A.concat(s))}e.bufferToStream=S;function o(n){return D.transform(n,{data:s=>typeof s=="string"?A.fromString(s):A.wrap(s)},s=>A.concat(s))}e.streamToBufferReadableStream=o;function a(n){return D.newWriteableStream(s=>A.concat(s),n)}e.newWriteableBufferStream=a;function t(n,s){return D.prefixedReadable(n,s,u=>A.concat(u))}e.prefixedBufferReadable=t;function r(n,s){return D.prefixedStream(n,s,u=>A.concat(u))}e.prefixedBufferStream=r}),define(Z[23],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(B,...ne){return ne.length===0?B:B.replace(L,function(ae,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ne.length?ae:ne[fe]})}e.format=R;const T=/{([^}]+)}/g;function A(B,ne){return B.replace(T,(ae,ce)=>ne[ce]??ae)}e.format2=A;function P(B){return B.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=P;function m(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function E(B,ne){let ae=0;const ce=ne.charCodeAt(0);for(let fe=B.length-1;fe>=0;fe--)B.charCodeAt(fe)===ce&&ae++;return ae}e.count=E;function i(B,ne,ae="\u2026"){return B.length<=ne?B:`${B.substr(0,ne)}${ae}`}e.truncate=i;function v(B,ne=" "){const ae=h(B,ne);return b(ae,ne)}e.trim=v;function h(B,ne){if(!B||!ne)return B;const ae=ne.length;if(ae===0||B.length===0)return B;let ce=0;for(;B.indexOf(ne,ce)===ce;)ce=ce+ae;return B.substring(ce)}e.ltrim=h;function b(B,ne){if(!B||!ne)return B;const ae=ne.length,ce=B.length;if(ae===0||ce===0)return B;let fe=ce,Se=-1;for(;Se=B.lastIndexOf(ne,fe-1),!(Se===-1||Se+ae!==fe);){if(Se===0)return"";fe=Se}return B.substring(0,fe)}e.rtrim=b;function c(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function y(B){return B.replace(/\*/g,"")}e.stripWildcards=y;function I(B,ne,ae={}){if(!B)throw new Error("Cannot create regex from empty string");ne||(B=m(B)),ae.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(B,ce)}e.createRegExp=I;function w(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function C(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function S(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=S;function o(B){return B.split(/\r\n|\r|\n/)}e.splitLines=o;function a(B){for(let ne=0,ae=B.length;ne<ae;ne++){const ce=B.charCodeAt(ne);if(ce!==32&&ce!==9)return ne}return-1}e.firstNonWhitespaceIndex=a;function t(B,ne=0,ae=B.length){for(let ce=ne;ce<ae;ce++){const fe=B.charCodeAt(ce);if(fe!==32&&fe!==9)return B.substring(ne,ce)}return B.substring(ne,ae)}e.getLeadingWhitespace=t;function r(B,ne=B.length-1){for(let ae=ne;ae>=0;ae--){const ce=B.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function n(B,ne){return B<ne?-1:B>ne?1:0}e.compare=n;function s(B,ne,ae=0,ce=B.length,fe=0,Se=ne.length){for(;ae<ce&&fe<Se;ae++,fe++){let we=B.charCodeAt(ae),Ee=ne.charCodeAt(fe);if(we<Ee)return-1;if(we>Ee)return 1}const de=ce-ae,pe=Se-fe;return de<pe?-1:de>pe?1:0}e.compareSubstring=s;function u(B,ne){return l(B,ne,0,B.length,0,ne.length)}e.compareIgnoreCase=u;function l(B,ne,ae=0,ce=B.length,fe=0,Se=ne.length){for(;ae<ce&&fe<Se;ae++,fe++){let we=B.charCodeAt(ae),Ee=ne.charCodeAt(fe);if(we===Ee)continue;const le=we-Ee;if(!(le===32&&g(Ee))&&!(le===-32&&g(we)))return d(we)&&d(Ee)?le:s(B.toLowerCase(),ne.toLowerCase(),ae,ce,fe,Se)}const de=ce-ae,pe=Se-fe;return de<pe?-1:de>pe?1:0}e.compareSubstringIgnoreCase=l;function d(B){return B>=97&&B<=122}e.isLowerAsciiLetter=d;function g(B){return B>=65&&B<=90}e.isUpperAsciiLetter=g;function p(B){return d(B)||g(B)}function f(B,ne){return B.length===ne.length&&k(B,ne)}e.equalsIgnoreCase=f;function k(B,ne,ae=B.length){for(let ce=0;ce<ae;ce++){const fe=B.charCodeAt(ce),Se=ne.charCodeAt(ce);if(fe!==Se){if(p(fe)&&p(Se)){const de=Math.abs(fe-Se);if(de!==0&&de!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function O(B,ne){const ae=ne.length;return ne.length>B.length?!1:k(B,ne,ae)}e.startsWithIgnoreCase=O;function _(B,ne){let ae,ce=Math.min(B.length,ne.length);for(ae=0;ae<ce;ae++)if(B.charCodeAt(ae)!==ne.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=_;function z(B,ne){let ae,ce=Math.min(B.length,ne.length);const fe=B.length-1,Se=ne.length-1;for(ae=0;ae<ce;ae++)if(B.charCodeAt(fe-ae)!==ne.charCodeAt(Se-ae))return ae;return ce}e.commonSuffixLength=z;function V(B){return 55296<=B&&B<=56319}e.isHighSurrogate=V;function W(B){return 56320<=B&&B<=57343}e.isLowSurrogate=W;function U(B,ne){return(B-55296<<10)+(ne-56320)+65536}e.computeCodePoint=U;function M(B,ne,ae){const ce=B.charCodeAt(ae);if(V(ce)&&ae+1<ne){const fe=B.charCodeAt(ae+1);if(W(fe))return U(ce,fe)}return ce}e.getNextCodePoint=M;function F(B,ne){const ae=B.charCodeAt(ne-1);if(W(ae)&&ne>1){const ce=B.charCodeAt(ne-2);if(V(ce))return U(ce,ae)}return ae}function q(B,ne){const ae=se.getInstance(),ce=ne,fe=B.length,Se=M(B,fe,ne);ne+=Se>=65536?2:1;let de=ae.getGraphemeBreakType(Se);for(;ne<fe;){const pe=M(B,fe,ne),we=ae.getGraphemeBreakType(pe);if(J(de,we))break;ne+=pe>=65536?2:1,de=we}return ne-ce}e.nextCharLength=q;function x(B,ne){const ae=se.getInstance(),ce=ne,fe=F(B,ne);ne-=fe>=65536?2:1;let Se=ae.getGraphemeBreakType(fe);for(;ne>0;){const de=F(B,ne),pe=ae.getGraphemeBreakType(de);if(J(pe,Se))break;ne-=de>=65536?2:1,Se=pe}return ce-ne}e.prevCharLength=x;function N(B,ne){const ae=se.getInstance(),ce=B.length,fe=ne,Se=M(B,ce,ne),de=ae.getGraphemeBreakType(Se);ne+=Se>=65536?2:1;let pe=de;for(;ne<ce;){const Ee=M(B,ce,ne),le=ae.getGraphemeBreakType(Ee);if(J(pe,le))break;ne+=Ee>=65536?2:1,pe=le}const we=ne;for(ne=fe,pe=de;ne>0;){const Ee=F(B,ne),le=ae.getGraphemeBreakType(Ee);if(J(le,pe))break;ne-=Ee>=65536?2:1,pe=le}return[ne,we]}function j(B,ne){return ne>0&&W(B.charCodeAt(ne))?N(B,ne-1):N(B,ne)}e.getCharContainingOffset=j;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(B){return $.test(B)}e.containsRTL=H;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Q(B){return G.test(B)}e.containsEmoji=Q;const X=/^[\t\n\r\x20-\x7E]*$/;function ie(B){return X.test(B)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function te(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=te;function oe(B){for(let ne=0,ae=B.length;ne<ae;ne++)if(ue(B.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=oe;function ue(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=ue;function ye(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=ye;function ve(B,ne){if(B.length<ne)return B;const ae=/\b/g;let ce=0;for(;ae.test(B)&&!(B.length-ae.lastIndex<ne);)ce=ae.lastIndex,ae.lastIndex+=1;return B.substring(ce).replace(/^\s/,"")}e.lcut=ve;const Re=/\x1B\x5B[12]?K/g,Te=/\x1b\[\d+m/g,Ne=/\x1b\[0?m/g;function Oe(B){return B&&(B=B.replace(Re,""),B=B.replace(Te,""),B=B.replace(Ne,"")),B}e.removeAnsiEscapeCodes=Oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function _e(B){return ke(B)?B.substr(1):B}e.stripUTF8BOM=_e;function Ie(B,ne){if(!B||!ne||B.length<ne.length)return!1;const ae=ne.length,ce=B.toLowerCase();let fe=0,Se=-1;for(;fe<ae;){const de=ce.indexOf(ne[fe],Se+1);if(de<0)return!1;Se=de,fe++}return!0}e.fuzzyContains=Ie;function Ae(B,ne=!1){return B?(ne&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Ae;function Ye(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ye;function Je(B,ne=1){if(ne===0)return"";let ae=-1;do ae=B.indexOf(`
`,ae+1),ne--;while(ne>0&&ae>=0);return ae===-1?B:(B[ae-1]==="\r"&&ae--,B.substr(0,ae))}e.getNLines=Je;function $e(B){const ne=90-65+1;return B=B%(2*ne),B<ne?String.fromCharCode(97+B):String.fromCharCode(65+B-ne)}e.singleLetterHash=$e;function qe(B){return se.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=qe;function J(B,ne){return B===0?ne!==5&&ne!==7:B===2&&ne===3?!1:B===4||B===2||B===3||ne===4||ne===2||ne===3?!0:!(B===8&&(ne===8||ne===9||ne===11||ne===12)||(B===11||B===9)&&(ne===9||ne===10)||(B===12||B===10)&&ne===10||ne===5||ne===13||ne===7||B===1||B===13&&ne===14||B===6&&ne===6)}e.breakBetweenGraphemeBreakType=J;var re;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=ge()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ae=this._data,ce=ae.length/3;let fe=1;for(;fe<=ce;)if(ne<ae[3*fe])fe=2*fe;else if(ne>ae[3*fe+1])fe=2*fe+1;else return ae[3*fe+2];return 0}}se._INSTANCE=null;function ge(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function me(B,ne){if(B===0)return 0;const ae=Pe(B,ne);if(ae!==void 0)return ae;const ce=F(ne,B);return B-=be(ce),B}e.getLeftDeleteOffset=me;function Pe(B,ne){let ae=F(ne,B);for(B-=be(ae);De(ae)||ae===65039||ae===8419;){if(B===0)return;ae=F(ne,B),B-=be(ae)}if(!!ye(ae)){if(B>=0){const ce=F(ne,B);ce===8205&&(B-=be(ce))}return B}}function be(B){return B>=65536?2:1}function De(B){return 127995<=B&&B<=127999}var Ce;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={}))}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(g){return Array.isArray(g)}e.isArray=D;function L(g){return typeof g=="string"}e.isString=L;function R(g){return Array.isArray(g)&&g.every(p=>L(p))}e.isStringArray=R;function T(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=T;function A(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=A;function P(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=P;function m(g){return g===!0||g===!1}e.isBoolean=m;function E(g){return typeof g=="undefined"}e.isUndefined=E;function i(g){return!v(g)}e.isDefined=i;function v(g){return E(g)||g===null}e.isUndefinedOrNull=v;function h(g,p){if(!g)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=h;function b(g){if(v(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=b;function c(...g){const p=[];for(let f=0;f<g.length;f++){const k=g[f];if(v(k))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);p.push(k)}return p}e.assertAllDefined=c;const y=Object.prototype.hasOwnProperty;function I(g){if(!T(g))return!1;for(let p in g)if(y.call(g,p))return!1;return!0}e.isEmptyObject=I;function w(g){return typeof g=="function"}e.isFunction=w;function C(...g){return g.length>0&&g.every(w)}e.areFunctions=C;function S(g,p){const f=Math.min(g.length,p.length);for(let k=0;k<f;k++)o(g[k],p[k])}e.validateConstraints=S;function o(g,p){if(L(p)){if(typeof g!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(w(p)){try{if(g instanceof p)return}catch{}if(!v(g)&&g.constructor===p||p.length===1&&p.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(g){let p=[],f=Object.getPrototypeOf(g);for(;Object.prototype!==f;)p=p.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return p}e.getAllPropertyNames=a;function t(g){const p=[];for(const f of a(g))typeof g[f]=="function"&&p.push(f);return p}e.getAllMethodNames=t;function r(g,p){const f=O=>function(){const _=Array.prototype.slice.call(arguments,0);return p(O,_)};let k={};for(const O of g)k[O]=f(O);return k}e.createProxyObject=r;function n(g){return g===null?void 0:g}e.withNullAsUndefined=n;function s(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=s;function u(g){return class{constructor(){return new Proxy({},{get(p,f){if(p[f])return p[f];throw new Error(`Not Implemented: ${g}->${String(f)}`)}})}}}e.NotImplementedProxy=u;function l(g,p="Unreachable"){throw new Error(p)}e.assertNever=l;function d(g){return!!g&&typeof g.then=="function"&&typeof g.catch=="function"}e.isPromise=d}),define(Z[39],ee([0,1,8,4,23,16]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(n){return n===47||n===92}e.isPathSeparator=A;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function m(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=m;function E(n,s=D.posix.sep){if(!n)return"";const u=n.length,l=n.charCodeAt(0);if(A(l)){if(A(n.charCodeAt(1))&&!A(n.charCodeAt(2))){let g=3;const p=g;for(;g<u&&!A(n.charCodeAt(g));g++);if(p!==g&&!A(n.charCodeAt(g+1))){for(g+=1;g<u;g++)if(A(n.charCodeAt(g)))return n.slice(0,g+1).replace(/[\\/]/g,s)}}return s}else if(w(l)&&n.charCodeAt(1)===58)return A(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let d=n.indexOf("://");if(d!==-1){for(d+=3;d<u;d++)if(A(n.charCodeAt(d)))return n.slice(0,d+1)}return""}e.getRoot=E;function i(n){if(!L.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let u=2;const l=u;for(;u<n.length&&(s=n.charCodeAt(u),s!==92);u++);return!(l===u||(s=n.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=i;const v=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(n,s=L.isWindows){const u=s?v:h;return!(!n||n.length===0||/^\s+$/.test(n)||(u.lastIndex=0,u.test(n))||s&&b.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=c;function y(n,s,u){const l=n===s;return!u||l?l:!n||!s?!1:(0,R.equalsIgnoreCase)(n,s)}e.isEqual=y;function I(n,s,u,l=D.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let g=s.length;return s.charAt(s.length-1)===l&&g--,n.charAt(g)===l}return s.charAt(s.length-1)!==l&&(s+=l),n.indexOf(s)===0}e.isEqualOrParent=I;function w(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=w;function C(n,s){return L.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(s,n)),n=(0,D.normalize)(n),L.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=C;function S(n){const s=(0,D.normalize)(n);return L.isWindows?n.length>3?!1:o(s)&&(n.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=S;function o(n){return L.isWindows?w(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(n){return o(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,s,u){return s.length>n.length?-1:n===s?0:(u&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=t;function r(n){const s=n.split(":");let u,l,d;if(s.forEach(g=>{const p=Number(g);(0,T.isNumber)(p)?l===void 0?l=p:d===void 0&&(d=p):u=u?[u,g].join(":"):g}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:l!==void 0?l:void 0,column:d!==void 0?d:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const I=Array.isArray(y)?[]:{};return Object.keys(y).forEach(w=>{y[w]&&typeof y[w]=="object"?I[w]=L(y[w]):I[w]=y[w]}),I}e.deepClone=L;function R(y){if(!y||typeof y!="object")return y;const I=[y];for(;I.length>0;){const w=I.shift();Object.freeze(w);for(const C in w)if(T.call(w,C)){const S=w[C];typeof S=="object"&&!Object.isFrozen(S)&&I.push(S)}}return y}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function A(y,I){return P(y,I,new Set)}e.cloneAndChange=A;function P(y,I,w){if((0,D.isUndefinedOrNull)(y))return y;const C=I(y);if(typeof C!="undefined")return C;if((0,D.isArray)(y)){const S=[];for(const o of y)S.push(P(o,I,w));return S}if((0,D.isObject)(y)){if(w.has(y))throw new Error("Cannot clone recursive data-structure");w.add(y);const S={};for(let o in y)T.call(y,o)&&(S[o]=P(y[o],I,w));return w.delete(y),S}return y}function m(y,I,w=!0){return(0,D.isObject)(y)?((0,D.isObject)(I)&&Object.keys(I).forEach(C=>{C in y?w&&((0,D.isObject)(y[C])&&(0,D.isObject)(I[C])?m(y[C],I[C],w):y[C]=I[C]):y[C]=I[C]}),y):I}e.mixin=m;function E(y,I){if(y===I)return!0;if(y==null||I===null||I===void 0||typeof y!=typeof I||typeof y!="object"||Array.isArray(y)!==Array.isArray(I))return!1;let w,C;if(Array.isArray(y)){if(y.length!==I.length)return!1;for(w=0;w<y.length;w++)if(!E(y[w],I[w]))return!1}else{const S=[];for(C in y)S.push(C);S.sort();const o=[];for(C in I)o.push(C);if(o.sort(),!E(S,o))return!1;for(w=0;w<S.length;w++)if(!E(y[S[w]],I[S[w]]))return!1}return!0}e.equals=E;function i(y){const I=new Set;return JSON.stringify(y,(w,C)=>{if((0,D.isObject)(C)||Array.isArray(C)){if(I.has(C))return"[Circular]";I.add(C)}return C})}e.safeStringify=i;function v(y,I,w){const C=I(y);return typeof C=="undefined"?w:C}e.getOrDefault=v;function h(y,I){const w=Object.create(null);return!y||!I||Object.keys(I).forEach(S=>{const o=y[S],a=I[S];E(o,a)||(w[S]=a)}),w}e.distinct=h;function b(y,I){const w=I.toLowerCase(),C=Object.keys(y).find(S=>S.toLowerCase()===w);return C?y[C]:y[I]}e.getCaseInsensitive=b;function c(y,I){const w=Object.create(null);for(const C of Object.keys(y))I(C,y[C])&&(w[C]=y[C]);return w}e.filter=c}),define(Z[7],ee([0,1,8,4]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function P(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!T.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,s){return!n&&!s?"file":n}function E(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==v&&(s=v+s):s=v;break}return s}const i="",v="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(s,u,l,d,g,p=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=m(s,p),this.authority=u||i,this.path=E(this.scheme,l||i),this.query=d||i,this.fragment=g||i,P(this,p))}static isUri(s){return s instanceof b?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return S(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:l,path:d,query:g,fragment:p}=s;return u===void 0?u=this.scheme:u===null&&(u=i),l===void 0?l=this.authority:l===null&&(l=i),d===void 0?d=this.path:d===null&&(d=i),g===void 0?g=this.query:g===null&&(g=i),p===void 0?p=this.fragment:p===null&&(p=i),u===this.scheme&&l===this.authority&&d===this.path&&g===this.query&&p===this.fragment?this:new y(u,l,d,g,p)}static parse(s,u=!1){const l=h.exec(s);return l?new y(l[2]||i,r(l[4]||i),r(l[5]||i),r(l[7]||i),r(l[9]||i),u):new y(i,i,i,i,i)}static file(s){let u=i;if(L.isWindows&&(s=s.replace(/\\/g,v)),s[0]===v&&s[1]===v){const l=s.indexOf(v,2);l===-1?(u=s.substring(2),s=v):(u=s.substring(2,l),s=s.substring(l)||v)}return new y("file",u,s,i,i)}static from(s){const u=new y(s.scheme,s.authority,s.path,s.query,s.fragment);return P(u,!0),u}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&s.scheme==="file"?l=b.file(D.win32.join(S(s,!0),...u)).path:l=D.posix.join(s.path,...u),s.with({path:l})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof b)return s;{const u=new y(s);return u._formatted=s.external,u._fsPath=s._sep===c?s.fsPath:null,u}}else return s}}e.URI=b;const c=L.isWindows?1:void 0;class y extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=c),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(n,s){let u,l=-1;for(let d=0;d<n.length;d++){const g=n.charCodeAt(d);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||s&&g===47)l!==-1&&(u+=encodeURIComponent(n.substring(l,d)),l=-1),u!==void 0&&(u+=n.charAt(d));else{u===void 0&&(u=n.substr(0,d));const p=I[g];p!==void 0?(l!==-1&&(u+=encodeURIComponent(n.substring(l,d)),l=-1),u+=p):l===-1&&(l=d)}}return l!==-1&&(u+=encodeURIComponent(n.substring(l))),u!==void 0?u:n}function C(n){let s;for(let u=0;u<n.length;u++){const l=n.charCodeAt(u);l===35||l===63?(s===void 0&&(s=n.substr(0,u)),s+=I[l]):s!==void 0&&(s+=n[u])}return s!==void 0?s:n}function S(n,s){let u;return n.authority&&n.path.length>1&&n.scheme==="file"?u=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?u=n.path.substr(1):u=n.path[1].toLowerCase()+n.path.substr(2):u=n.path,L.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=S;function o(n,s){const u=s?C:w;let l="",{scheme:d,authority:g,path:p,query:f,fragment:k}=n;if(d&&(l+=d,l+=":"),(g||d==="file")&&(l+=v,l+=v),g){let O=g.indexOf("@");if(O!==-1){const _=g.substr(0,O);g=g.substr(O+1),O=_.indexOf(":"),O===-1?l+=u(_,!1):(l+=u(_.substr(0,O),!1),l+=":",l+=u(_.substr(O+1),!1)),l+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?l+=u(g,!1):(l+=u(g.substr(0,O),!1),l+=g.substr(O))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const O=p.charCodeAt(1);O>=65&&O<=90&&(p=`/${String.fromCharCode(O+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const O=p.charCodeAt(0);O>=65&&O<=90&&(p=`${String.fromCharCode(O+32)}:${p.substr(2)}`)}l+=u(p,!0)}return f&&(l+="?",l+=u(f,!1)),k&&(l+="#",l+=s?k:w(k,!1)),l}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(t)?n.replace(t,s=>a(s)):n}}),define(Z[93],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(E){const i=E;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function R(E){const i=[];let v;try{const h=JSON.parse(E.arguments),b=h[h.length-1];b&&b.__$stack&&(h.pop(),v=b.__$stack),i.push(...h)}catch(h){i.push("Unable to log remote console arguments",E.arguments)}return{args:i,stack:v}}e.parse=R;function T(E){if(typeof E!="string")return T(R(E).stack);const i=E;if(i){const v=A(i),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=T;function A(E){if(!E)return E;const i=E.indexOf(`
`);return i===-1?E:E.substring(0,i)}function P(E,i){const{args:v,stack:h}=R(E),b=typeof v[0]=="string"&&v.length===1;let c=A(h);c&&(c=`(${c.trim()})`);let y=[];if(typeof v[0]=="string"?c&&b?y=[`%c[${i}] %c${v[0]} %c${c}`,m("blue"),m(""),m("grey")]:y=[`%c[${i}] %c${v[0]}`,m("blue"),m(""),...v.slice(1)]:y=[`%c[${i}]%`,m("blue"),...v],c&&!b&&y.push(c),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,y)}e.log=P;function m(E){return`color: ${E}`}});var ut=this&&this.__classPrivateFieldSet||function(K,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(K,D):R?R.value=D:e.set(K,D),D},ze=this&&this.__classPrivateFieldGet||function(K,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(K):L?L.value:e.get(K)};define(Z[40],ee([0,1,23,7]),function(K,e,D,L){"use strict";var R,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,n){let s=t.get(r);return s===void 0&&(s=n,t.set(r,s)),s}e.getOrSet=P;function m(t){const r=[];return t.forEach((n,s)=>{r.push(`${s} => ${n}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=m;function E(t){const r=[];return t.forEach(n=>{r.push(n)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=E;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const n=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return n-s}value(){return this._value[this._pos]}}e.StringIterator=i;class v{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,D.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class h{constructor(r=!0,n=!0){this._splitOnBackslash=r,this._caseSensitive=n}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,D.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,D.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class y{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new c(r))}static forPaths(){return new I(new h)}static forStrings(){return new I(new i)}static forConfigKeys(){return new I(new v)}clear(){this._root=void 0}set(r,n){const s=this._iter.reset(r);let u;for(this._root||(this._root=new y,this._root.segment=s.value()),u=this._root;;){const d=s.cmp(u.segment);if(d>0)u.left||(u.left=new y,u.left.segment=s.value()),u=u.left;else if(d<0)u.right||(u.right=new y,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new y,u.mid.segment=s.value()),u=u.mid;else break}const l=u.value;return u.value=n,u.key=r,l}get(r){return this._getNode(r)?.value}_getNode(r){const n=this._iter.reset(r);let s=this._root;for(;s;){const u=n.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else break}return s}has(r){const n=this._getNode(r);return!(n?.value===void 0&&n?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,n){const s=this._iter.reset(r),u=[];let l=this._root;for(;l;){const d=s.cmp(l.segment);if(d>0)u.push([1,l]),l=l.left;else if(d<0)u.push([-1,l]),l=l.right;else if(s.hasNext())s.next(),u.push([0,l]),l=l.mid;else{for(n?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;u.length>0&&l.isEmpty();){let[g,p]=u.pop();switch(g){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}l=p}break}}}findSubstr(r){const n=this._iter.reset(r);let s=this._root,u;for(;s;){const l=n.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(n.hasNext())n.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(r){const n=this._iter.reset(r);let s=this._root;for(;s;){const u=n.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[n,s]of this)r(s,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const n=[r];for(;n.length>0;){const s=n.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&n.push(s.left),s.mid&&n.push(s.mid),s.right&&n.push(s.right))}}}e.TernarySearchTree=I;class w{constructor(r,n){this[R]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=n??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,n){return this.map.set(this.toKey(r),n),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,n){typeof n!="undefined"&&(r=r.bind(n));for(let[s,u]of this.map)r(u,L.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var C;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class S{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,n=0){const s=this._map.get(r);if(!!s)return n!==0&&this.touch(s,n),s.value}set(r,n,s=0){let u=this._map.get(r);if(u)u.value=n,s!==0&&this.touch(u,s);else{switch(u={key:r,value:n,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this._map.get(r);if(!!n)return this._map.delete(r),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,n){const s=this._state;let u=this._head;for(;u;){if(n?r.bind(n)(u.value,u.key,this):r(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:s.key,done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return u}values(){const r=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:s.value,done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return u}entries(){const r=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:[s.key,s.value],done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this._head,s=this.size;for(;n&&s>r;)this._map.delete(n.key),n=n.next,s--;this._head=n,this._size=s,n&&(n.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const n=r.next,s=r.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}r.next=void 0,r.previous=void 0,this._state++}touch(r,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(r===this._head)return;const s=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(n===2){if(r===this._tail)return;const s=r.next,u=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((n,s)=>{r.push([s,n])}),r}fromJSON(r){this.clear();for(const[n,s]of r)this.set(n,s)}}e.LinkedMap=S;class o extends S{constructor(r,n=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,n=2){return super.get(r,n)}peek(r){return super.get(r,0)}set(r,n){return super.set(r,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class a{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return ze(this,A,"f").size}forEach(r,n){ze(this,A,"f").forEach(r,n)}get(r){return ze(this,A,"f").get(r)}has(r){return ze(this,A,"f").has(r)}entries(){return ze(this,A,"f").entries()}keys(){return ze(this,A,"f").keys()}values(){return ze(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return ze(this,A,"f").entries()}}e.ReadonlyMapView=a}),define(Z[94],ee([0,1,25,23,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(i){return JSON.stringify(i,m)}e.stringify=T;function A(i){let v=JSON.parse(i);return v=E(v),v}e.parse=A;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function m(i,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,L.regExpFlags)(v)}:v}function E(i,v=0){if(!i||v>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let h=0;h<i.length;++h)i[h]=E(i[h],v+1);else for(const h in i)Object.hasOwnProperty.call(i,h)&&(i[h]=E(i[h],v+1))}return i}e.revive=E}),define(Z[17],ee([0,1,4,7]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,E,i){this._hosts[m]=E,this._ports[m]=i}setConnectionToken(m,E){this._connectionTokens[m]=E}rewrite(m){if(this._delegate)return this._delegate(m);const E=m.authority;let i=this._hosts[E];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const v=this._ports[E],h=this._connectionTokens[E];let b=`path=${encodeURIComponent(m.path)}`;return typeof h=="string"&&(b+=`&tkn=${encodeURIComponent(h)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${v}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new T;class A{asBrowserUri(m,E){const i=this.toUri(m,E);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(m,E){const i=this.toUri(m,E);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==A.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(m,E){return L.URI.isUri(m)?m:L.URI.parse(E.toUrl(m))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(Z[66],ee([0,1,40]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(E){return m(E,"NFC",L)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function A(E){return m(E,"NFD",T)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function m(E,i,v){if(!E)return E;const h=v.get(E);if(h)return h;let b;return P.test(E)?b=E.normalize(i):b=E,v.set(E,b),b}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(i){return A(i).replace(E,"")}}()}),define(Z[15],ee([0,1,39,17,8,4,23,7]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(b){return(0,P.uriToFsPath)(b,!0)}e.originalFSPath=m;class E{constructor(c){this._ignorePathCasing=c}compare(c,y,I=!1){return c===y?0:(0,A.compare)(this.getComparisonKey(c,I),this.getComparisonKey(y,I))}isEqual(c,y,I=!1){return c===y?!0:!c||!y?!1:this.getComparisonKey(c,I)===this.getComparisonKey(y,I)}getComparisonKey(c,y=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,y,I=!1){if(c.scheme===y.scheme){if(c.scheme===L.Schemas.file)return D.isEqualOrParent(m(c),m(y),this._ignorePathCasing(c))&&c.query===y.query&&(I||c.fragment===y.fragment);if((0,e.isEqualAuthority)(c.authority,y.authority))return D.isEqualOrParent(c.path,y.path,this._ignorePathCasing(c),"/")&&c.query===y.query&&(I||c.fragment===y.fragment)}return!1}joinPath(c,...y){return P.URI.joinPath(c,...y)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){const y=R.posix.extname(c.path),I=y.indexOf("?");return I!==-1?y.substr(0,I):y}dirname(c){if(c.path.length===0)return c;let y;return c.scheme===L.Schemas.file?y=P.URI.file(R.dirname(m(c))).path:(y=R.posix.dirname(c.path),c.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),y="/")),c.with({path:y})}normalizePath(c){if(!c.path.length)return c;let y;return c.scheme===L.Schemas.file?y=P.URI.file(R.normalize(m(c))).path:y=R.posix.normalize(c.path),c.with({path:y})}relativePath(c,y){if(c.scheme!==y.scheme||!(0,e.isEqualAuthority)(c.authority,y.authority))return;if(c.scheme===L.Schemas.file){const C=R.relative(m(c),m(y));return T.isWindows?D.toSlashes(C):C}let I=c.path||"/",w=y.path||"/";if(this._ignorePathCasing(c)){let C=0;for(const S=Math.min(I.length,w.length);C<S&&!(I.charCodeAt(C)!==w.charCodeAt(C)&&I.charAt(C).toLowerCase()!==w.charAt(C).toLowerCase());C++);I=w.substr(0,C)+I.substr(C)}return R.posix.relative(I,w)}resolvePath(c,y){if(c.scheme===L.Schemas.file){const I=P.URI.file(R.resolve(m(c),y));return c.with({authority:I.authority,path:I.path})}return y=D.toPosixPath(y),c.with({path:R.posix.resolve(c.path,y)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,y){return c===y||(0,A.equalsIgnoreCase)(c,y)}hasTrailingPathSeparator(c,y=R.sep){if(c.scheme===L.Schemas.file){const I=m(c);return I.length>D.getRoot(I).length&&I[I.length-1]===y}else{const I=c.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,y=R.sep){return(0,e.hasTrailingPathSeparator)(c,y)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,y=R.sep){let I=!1;if(c.scheme===L.Schemas.file){const w=m(c);I=w!==void 0&&w.length===D.getRoot(w).length&&w[w.length-1]===y}else{y="/";const w=c.path;I=w.length===1&&w.charCodeAt(w.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(c,y)?c.with({path:c.path+"/"}):c}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(b=>b.scheme===L.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(b,c){const y=[];for(let I=0;I<b.length;I++){const w=c(b[I]);b.some((C,S)=>S===I?!1:(0,e.isEqualOrParent)(w,c(C)))||y.push(b[I])}return y}e.distinctParents=i;var v;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function c(y){const I=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(S=>{const[o,a]=S.split(":");o&&a&&I.set(o,a)});const C=y.path.substring(0,y.path.indexOf(";"));return C&&I.set(b.META_DATA_MIME,C),I}b.parseMetaData=c})(v=e.DataUri||(e.DataUri={}));function h(b,c,y){if(c){let I=b.path;return I&&I[0]!==R.posix.sep&&(I=R.posix.sep+I),b.with({scheme:y,authority:c,path:I})}return b.with({scheme:y})}e.toLocalResource=h}),define(Z[5],ee([0,1,29,11,3,2,15]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(M){return!!M&&typeof M.then=="function"}e.isThenable=P;function m(M){const F=new D.CancellationTokenSource,q=M(F.token),x=new Promise((N,j)=>{const $=F.token.onCancellationRequested(()=>{$.dispose(),F.dispose(),j((0,L.canceled)())});Promise.resolve(q).then(H=>{$.dispose(),F.dispose(),N(H)},H=>{$.dispose(),F.dispose(),j(H)})});return new class{cancel(){F.cancel()}then(N,j){return x.then(N,j)}catch(N){return this.then(void 0,N)}finally(N){return x.finally(N)}}}e.createCancelablePromise=m;function E(M,F,q){return Promise.race([M,new Promise(x=>F.onCancellationRequested(()=>x(q)))])}e.raceCancellation=E;async function i(M){let F=-1;const q=M.map((N,j)=>N.then($=>(F=j,$))),x=await Promise.race(q);return M.forEach((N,j)=>{j!==F&&N.cancel()}),x}e.raceCancellablePromises=i;function v(M,F,q){let x;const N=setTimeout(()=>{x?.(void 0),q?.()},F);return Promise.race([M.finally(()=>clearTimeout(N)),new Promise(j=>x=j)])}e.raceTimeout=v;function h(M){return new Promise((F,q)=>{const x=M();P(x)?x.then(F,q):F(x)})}e.asPromise=h;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(q,q).then(x)})}return new Promise((q,x)=>{this.queuedPromise.then(q,x)})}return this.activePromise=F(),new Promise((q,x)=>{this.activePromise.then(N=>{this.activePromise=null,q(N)},N=>{this.activePromise=null,x(N)})})}}e.Throttler=b;class c{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=c;class y{constructor(){this.promiseMap=new Map}queue(F,q){const N=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(F)===N&&this.promiseMap.delete(F)});return this.promiseMap.set(F,N),N}}e.SequencerByKey=y;class I{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,q=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,N)=>{this.doResolve=x,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class w{constructor(F){this.delayer=new I(F),this.throttler=new b}trigger(F,q){return this.delayer.trigger(()=>this.throttler.queue(F),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class C{constructor(){this._isOpen=!1,this._promise=new Promise((F,q)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=C;class S extends C{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function o(M,F){return F?new Promise((q,x)=>{const N=setTimeout(()=>{j.dispose(),q()},M),j=F.onCancellationRequested(()=>{clearTimeout(N),j.dispose(),x((0,L.canceled)())})}):m(q=>o(M,q))}e.timeout=o;function a(M,F=0){const q=setTimeout(M,F);return(0,T.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=a;function t(M){const F=[];let q=0;const x=M.length;function N(){return q<x?M[q++]():null}function j($){$!=null&&F.push($);const H=N();return H?H.then(j):Promise.resolve(F)}return Promise.resolve(null).then(j)}e.sequence=t;function r(M,F=x=>!!x,q=null){let x=0;const N=M.length,j=()=>{if(x>=N)return Promise.resolve(q);const $=M[x++];return Promise.resolve($()).then(G=>F(G)?Promise.resolve(G):j())};return j()}e.first=r;function n(M,F=x=>!!x,q=null){if(M.length===0)return Promise.resolve(q);let x=M.length;const N=()=>{x=-1;for(const j of M)j.cancel?.()};return new Promise((j,$)=>{for(const H of M)H.then(G=>{--x>=0&&F(G)?(N(),j(G)):x===0&&j(q)}).catch(G=>{--x>=0&&(N(),$(G))})})}e.firstParallel=n;class s{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((q,x)=>{this.outstandingPromises.push({factory:F,c:q,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const q=F.factory();q.then(F.c,F.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class l{constructor(){this.queues=new Map}queueFor(F,q=A.extUri){const x=q.getComparisonKey(F);let N=this.queues.get(x);return N||(N=new u,R.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(x)}),this.queues.set(x,N)),N}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=l;class d{constructor(F,q){this._token=-1,typeof F=="function"&&typeof q=="number"&&this.setIfNotSet(F,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},q)}setIfNotSet(F,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},q))}}e.TimeoutTimer=d;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,q){this.cancel(),this._token=setInterval(()=>{F()},q)}}e.IntervalTimer=g;class p{constructor(F,q){this.timeoutToken=-1,this.runner=F,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=p;class f extends p{constructor(F,q){super(F,q);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=f;class k extends T.Disposable{constructor(F,q,x,N){super();this.maxWorkChunkSize=F,this.maxPendingWork=q,this.throttleDelay=x,this.handler=N,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new p(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const q=setTimeout(()=>F(M));let x=!1;return{dispose(){x||(x=!0,clearTimeout(q))}}}}else e.runWhenIdle=(M,F)=>{const q=requestIdleCallback(M,typeof F=="number"?{timeout:F}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(q))}}}}();class O{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function _(M,F,q){let x;for(let N=0;N<q;N++)try{return await M()}catch(j){x=j,await o(F)}throw x}e.retry=_;class z{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,q,x){return this._pending={taskId:F,cancel:()=>x?.(),promise:q},q.then(()=>this.donePending(F),()=>this.donePending(F)),q}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let q,x;const N=new Promise((j,$)=>{q=j,x=$});this._next={run:F,promise:N,promiseResolve:q,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=z;class V{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,q)=>{this.completeCallback=F,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(q=>{this.completeCallback(F),this.resolved=!0,q()})}error(F){return new Promise(q=>{this.errorCallback(F),this.rejected=!0,q()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=W;var U;(function(M){async function F(q){let x;const N=await Promise.all(q.map(j=>j.then($=>$,$=>{x||(x=$)})));if(typeof x!="undefined")throw x;return N}M.settled=F})(U=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,5,39,40,8,23]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const m="**",E="/",i="[/\\\\]",v="[^/\\\\]",h=/\//g;function b(N){switch(N){case 0:return"";case 1:return`${v}*?`;default:return`(?:${i}|${v}+${i}|${i}${v}+)*?`}}function c(N,j){if(!N)return[];const $=[];let H=!1,G=!1,Q="";for(const X of N){switch(X){case j:if(!H&&!G){$.push(Q),Q="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":G=!0;break;case"]":G=!1;break}Q+=X}return Q&&$.push(Q),$}e.splitGlobAware=c;function y(N){if(!N)return"";let j="";const $=c(N,E);if($.every(H=>H===m))j=".*";else{let H=!1;$.forEach((G,Q)=>{if(G===m){H||(j+=b(2),H=!0);return}let X=!1,ie="",te=!1,oe="";for(const ue of G){if(ue!=="}"&&X){ie+=ue;continue}if(te&&(ue!=="]"||!oe)){let ye;ue==="-"?ye=ue:(ue==="^"||ue==="!")&&!oe?ye="^":ue===E?ye="":ye=A.escapeRegExpCharacters(ue),oe+=ye;continue}switch(ue){case"{":X=!0;continue;case"[":te=!0;continue;case"}":j+=`(?:${c(ie,",").map(Re=>y(Re)).join("|")})`,X=!1,ie="";break;case"]":j+="["+oe+"]",te=!1,oe="";break;case"?":j+=v;continue;case"*":j+=b(1);continue;default:j+=A.escapeRegExpCharacters(ue)}}Q<$.length-1&&($[Q+1]!==m||Q+2<$.length)&&(j+=i),H=!1})}return j}const I=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,S=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),r=function(){return!1},n=function(){return null};function s(N,j){if(!N)return n;let $;typeof N!="string"?$=N.pattern:$=N,$=$.trim();const H=`${$}_${!!j.trimForExclusions}`;let G=t.get(H);if(G)return u(G,N);let Q;if(I.test($)){const X=$.substr(4);G=function(ie,te){return typeof ie=="string"&&ie.endsWith(X)?$:null}}else(Q=w.exec(l($,j)))?G=d(Q[1],$):(j.trimForExclusions?S:C).test($)?G=g($,j):(Q=o.exec(l($,j)))?G=p(Q[1].substr(1),$,!0):(Q=a.exec(l($,j)))?G=p(Q[1],$,!1):G=f($);return t.set(H,G),u(G,N)}function u(N,j){return typeof j=="string"?N:function($,H){return L.isEqualOrParent($,j.base)?N(T.relative(j.base,$),H):null}}function l(N,j){return j.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function d(N,j){const $=`/${N}`,H=`\\${N}`,G=function(X,ie){return typeof X!="string"?null:ie?ie===N?j:null:X===N||X.endsWith($)||X.endsWith(H)?j:null},Q=[N];return G.basenames=Q,G.patterns=[j],G.allBasenames=Q,G}function g(N,j){const $=x(N.slice(1,-1).split(",").map(ie=>s(ie,j)).filter(ie=>ie!==n),N),H=$.length;if(!H)return n;if(H===1)return $[0];const G=function(ie,te){for(let oe=0,ue=$.length;oe<ue;oe++)if($[oe](ie,te))return N;return null},Q=$.find(ie=>!!ie.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const X=$.reduce((ie,te)=>te.allPaths?ie.concat(te.allPaths):ie,[]);return X.length&&(G.allPaths=X),G}function p(N,j,$){const H=T.sep===T.posix.sep,G=H?N:N.replace(h,T.sep),Q=T.sep+G,X=T.posix.sep+N,ie=$?function(te,oe){return typeof te=="string"&&(te===G||te.endsWith(Q)||!H&&(te===N||te.endsWith(X)))?j:null}:function(te,oe){return typeof te=="string"&&(te===G||!H&&te===N)?j:null};return ie.allPaths=[($?"*/":"./")+N],ie}function f(N){try{const j=new RegExp(`^${y(N)}$`);return function($){return j.lastIndex=0,typeof $=="string"&&j.test($)?N:null}}catch(j){return n}}function k(N,j,$){return!N||typeof j!="string"?!1:O(N)(j,void 0,$)}e.match=k;function O(N,j={}){if(!N)return r;if(typeof N=="string"||W(N)){const $=s(N,j);if($===n)return r;const H=function(G,Q){return!!$(G,Q)};return $.allBasenames&&(H.allBasenames=$.allBasenames),$.allPaths&&(H.allPaths=$.allPaths),H}return F(N,j)}e.parse=O;function _(N){if(!N)return;let j;return $=>(j||(j=(N()||Promise.resolve([])).then(H=>H?V(H):{})),j.then(H=>!!H[$]))}e.hasSiblingPromiseFn=_;function z(N){if(!N)return;let j;return $=>{if(!j){const H=N();j=H?V(H):{}}return!!j[$]}}e.hasSiblingFn=z;function V(N){const j={};for(const $ of N)j[$]=!0;return j}function W(N){const j=N;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=W;function U(N){return N.allBasenames||[]}e.getBasenameTerms=U;function M(N){return N.allPaths||[]}e.getPathTerms=M;function F(N,j){const $=x(Object.getOwnPropertyNames(N).map(ie=>q(ie,N[ie],j)).filter(ie=>ie!==n)),H=$.length;if(!H)return n;if(!$.some(ie=>!!ie.requiresSiblings)){if(H===1)return $[0];const ie=function(ue,ye){for(let ve=0,Re=$.length;ve<Re;ve++){const Te=$[ve](ue,ye);if(Te)return Te}return null},te=$.find(ue=>!!ue.allBasenames);te&&(ie.allBasenames=te.allBasenames);const oe=$.reduce((ue,ye)=>ye.allPaths?ue.concat(ye.allPaths):ue,[]);return oe.length&&(ie.allPaths=oe),ie}const G=function(ie,te,oe){let ue;for(let ye=0,ve=$.length;ye<ve;ye++){const Re=$[ye];Re.requiresSiblings&&oe&&(te||(te=T.basename(ie)),ue||(ue=te.substr(0,te.length-T.extname(ie).length)));const Te=Re(ie,te,ue,oe);if(Te)return Te}return null},Q=$.find(ie=>!!ie.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const X=$.reduce((ie,te)=>te.allPaths?ie.concat(te.allPaths):ie,[]);return X.length&&(G.allPaths=X),G}function q(N,j,$){if(j===!1)return n;const H=s(N,$);if(H===n)return n;if(typeof j=="boolean")return H;if(j){const G=j.when;if(typeof G=="string"){const Q=(X,ie,te,oe)=>{if(!oe||!H(X,ie))return null;const ue=G.replace("$(basename)",te),ye=oe(ue);return(0,D.isThenable)(ye)?ye.then(ve=>ve?N:null):ye?N:null};return Q.requiresSiblings=!0,Q}}return H}function x(N,j){const $=N.filter(ie=>!!ie.basenames);if($.length<2)return N;const H=$.reduce((ie,te)=>{const oe=te.basenames;return oe?ie.concat(oe):ie},[]);let G;if(j){G=[];for(let ie=0,te=H.length;ie<te;ie++)G.push(j)}else G=$.reduce((ie,te)=>{const oe=te.patterns;return oe?ie.concat(oe):ie},[]);const Q=function(ie,te){if(typeof ie!="string")return null;if(!te){let ue;for(ue=ie.length;ue>0;ue--){const ye=ie.charCodeAt(ue-1);if(ye===47||ye===92)break}te=ie.substr(ue)}const oe=H.indexOf(te);return oe!==-1?G[oe]:null};Q.basenames=H,Q.patterns=G,Q.allBasenames=H;const X=N.filter(ie=>!ie.basenames);return X.push(Q),X}}),define(Z[95],ee([0,1,67,17,8,15,23]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let m=[],E=[],i=[];function v(s,u=!1){const l=h(s);m.push(l),l.userConfigured?i.push(l):E.push(l),u&&!l.userConfigured&&m.forEach(d=>{d.mime===l.mime||d.userConfigured||(l.extension&&d.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&d.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&d.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&d.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=v;function h(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(R.posix.sep)>=0:!1}}function b(s){s?(m=m.filter(u=>!u.userConfigured),i=[]):(m=[],E=[],i=[])}e.clearTextMimes=b;function c(s,u){let l;if(s)switch(s.scheme){case L.Schemas.file:l=s.fsPath;break;case L.Schemas.data:l=T.DataUri.parseMetaData(s).get(T.DataUri.META_DATA_LABEL);break;default:l=s.path}if(!l)return[P.unknown];l=l.toLowerCase();const d=(0,R.basename)(l),g=y(l,d,i);if(g)return[g,P.text];const p=y(l,d,E);if(p)return[p,P.text];if(u){const f=I(u);if(f)return[f,P.text]}return[P.unknown]}e.guessMimeTypes=c;function y(s,u,l){let d=null,g=null,p=null;for(let f=l.length-1;f>=0;f--){const k=l[f];if(u===k.filenameLowercase){d=k;break}if(k.filepattern&&(!g||k.filepattern.length>g.filepattern.length)){const O=k.filepatternOnPath?s:u;(0,D.match)(k.filepatternLowercase,O)&&(g=k)}k.extension&&(!p||k.extension.length>p.extension.length)&&u.endsWith(k.extensionLowercase)&&(p=k)}return d?d.mime:g?g.mime:p?p.mime:null}function I(s){if((0,A.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let u=m.length-1;u>=0;u--){const l=m[u];if(!l.firstline)continue;const d=s.match(l.firstline);if(d&&d.length>0)return l.mime}return null}function w(s){return s?typeof s=="string"?s===P.binary||s===P.text||s===P.unknown:s.length===1&&w(s[0]):!0}e.isUnspecific=w;const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(s){const u=(0,R.extname)(s),l=C[u.toLowerCase()];return l!==void 0?l:a(s)}e.getMediaOrTextMime=o;function a(s){const u=(0,R.extname)(s);return S[u.toLowerCase()]}e.getMediaMime=a;function t(s){for(const u in S)if(S[u]===s)return u}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function n(s,u){const l=r.exec(s);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:u?void 0:s}e.normalizeMimeType=n}),define(Z[96],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class R{constructor(v){this._uriTransformer=v}transformIncoming(v){const h=this._uriTransformer.transformIncoming(v);return h===v?v:L(D.URI.from(h))}transformOutgoing(v){const h=this._uriTransformer.transformOutgoing(v);return h===v?v:L(D.URI.from(h))}transformOutgoingURI(v){const h=this._uriTransformer.transformOutgoing(v);return h===v?v:D.URI.from(h)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,v,h){if(!i||h>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return v.transformOutgoing(i);for(let b in i)if(Object.hasOwnProperty.call(i,b)){const c=T(i[b],v,h+1);c!==null&&(i[b]=c)}}return null}function A(i,v){const h=T(i,v,0);return h===null?i:h}e.transformOutgoingURIs=A;function P(i,v,h,b){if(!i||b>200)return null;if(typeof i=="object"){if(i.$mid===1)return h?D.URI.revive(v.transformIncoming(i)):v.transformIncoming(i);for(let c in i)if(Object.hasOwnProperty.call(i,c)){const y=P(i[c],v,h,b+1);y!==null&&(i[c]=y)}}return null}function m(i,v){const h=P(i,v,!1,0);return h===null?i:h}e.transformIncomingURIs=m;function E(i,v){const h=P(i,v,!0,0);return h===null?i:h}e.transformAndReviveIncomingURIs=E}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(m){return D.test(m)}e.isUUID=L;const R=new Uint8Array(16),T=[];for(let m=0;m<256;m++)T.push(m.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(m){for(let E=0;E<m.length;E++)m[E]=Math.floor(Math.random()*256);return m};function P(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,E="";return E+=T[R[m++]],E+=T[R[m++]],E+=T[R[m++]],E+=T[R[m++]],E+="-",E+=T[R[m++]],E+=T[R[m++]],E+="-",E+=T[R[m++]],E+=T[R[m++]],E+="-",E+=T[R[m++]],E+=T[R[m++]],E+="-",E+=T[R[m++]],E+=T[R[m++]],E+=T[R[m++]],E+=T[R[m++]],E+=T[R[m++]],E+=T[R[m++]],E}e.generateUuid=P}),define(Z[68],ee([0,1,218]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return A;let m=0,E,i=m;for(;i<P.length;)if(E=P.charCodeAt(i),E===13||E===10){if(A.push(P.substring(m,i)),i++,i<P.length){const v=E;E=P.charCodeAt(i),(v===13&&E===10||v===10&&E===13)&&i++}m=i}else i++;return this.remaining=m<P.length?P.substr(m):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(Z[97],ee([0,1,34]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const m=P.replace(/\-/g,":").toLowerCase();return!L.has(m)}function T(){return new Promise(async(P,m)=>{const E=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(i){m(i)}finally{clearTimeout(E)}})}e.getMac=T;function A(){return new Promise((P,m)=>{try{const E=(0,D.networkInterfaces)();for(let i in E){const v=E[i];if(v){for(const{mac:h}of v)if(R(h))return P(h)}}m("Unable to retrieve mac address (unexpected format)")}catch(E){m(E)}})}}),define(Z[98],ee([0,1,34,11,40,30,97]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,v=0;const h=(0,D.networkInterfaces)();for(let b in h){const c=h[b];if(c)for(const{mac:y,internal:I}of c)I||(v+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(i+=1))}this._value=v>0?i/v:0}return this._value}};let P;async function m(){return P||(P=(async()=>await E()||T.generateUuid())()),P}e.getMachineId=m;async function E(){try{const i=await new Promise((h,b)=>{K(["crypto"],h,b)}),v=await(0,A.getMac)();return i.createHash("sha256").update(v,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[18],ee([0,1,50,34,219,5,39,66,8,4,15,7,30]),function(K,e,D,L,R,T,A,P,m,E,i,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function c(U,M=b.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return M===b.UNLINK?I(U):y(U)}async function y(U){try{const M=(0,m.join)((0,L.tmpdir)(),(0,h.generateUuid)());try{await e.Promises.rename(U,M)}catch(F){return I(U)}I(M).catch(F=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function I(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function w(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=w;async function C(U,M){return a(await(M?S(U):(0,R.promisify)(D.readdir)(U)))}async function S(U){try{return await(0,R.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const M=[],F=await C(U);for(const q of F){let x=!1,N=!1,j=!1;try{const $=await e.Promises.lstat((0,m.join)(U,q));x=$.isFile(),N=$.isDirectory(),j=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}M.push({name:q,isFile:()=>x,isDirectory:()=>N,isSymbolicLink:()=>j})}return M}function o(U){return a(D.readdirSync(U))}e.readdirSync=o;function a(U){return U.map(M=>typeof M=="string"?E.isMacintosh?(0,P.normalizeNFC)(M):M:(M.name=E.isMacintosh?(0,P.normalizeNFC)(M.name):M.name,M))}async function t(U){const M=await C(U),F=[];for(const q of M)await n.existsDirectory((0,m.join)(U,q))&&F.push(q);return F}function r(U,M=1e3){return new Promise(F=>{let q=!1;const x=setInterval(()=>{q||(q=!0,D.access(U,N=>{q=!1,N&&(clearInterval(x),F(void 0))}))},M)})}e.whenDeleted=r;var n;(function(U){async function M(x){let N;try{if(N=await e.Promises.lstat(x),!N.isSymbolicLink())return{stat:N}}catch(j){}try{return{stat:await e.Promises.stat(x),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(E.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw $}throw j}}U.stat=M;async function F(x){try{const{stat:N,symbolicLink:j}=await U.stat(x);return N.isFile()&&j?.dangling!==!0}catch(N){}return!1}U.existsFile=F;async function q(x){try{const{stat:N,symbolicLink:j}=await U.stat(x);return N.isDirectory()&&j?.dangling!==!0}catch(N){}return!1}U.existsDirectory=q})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new T.ResourceQueue;function u(U,M,F){return s.queueFor(v.URI.file(U),i.extUriBiasedIgnorePathCase).queue(()=>{const q=p(F);return new Promise((x,N)=>d(U,M,q,j=>j?N(j):x()))})}let l=!0;function d(U,M,F,q){if(!l)return D.writeFile(U,M,{mode:F.mode,flag:F.flag},q);D.open(U,F.flag,F.mode,(x,N)=>{if(x)return q(x);D.writeFile(N,M,j=>{if(j)return D.close(N,()=>q(j));D.fdatasync(N,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),l=!1),D.close(N,H=>q(H))))})})}function g(U,M,F){const q=p(F);if(!l)return D.writeFileSync(U,M,{mode:q.mode,flag:q.flag});const x=D.openSync(U,q.flag,q.mode);try{D.writeFileSync(x,M);try{D.fdatasyncSync(x)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l=!1}}finally{D.closeSync(x)}}e.writeFileSync=g;function p(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function f(U,M){if(U===M)return;async function F(q){try{const x=await e.Promises.lstat(q);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(q,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(U,M),await F(M)}catch(q){if(U.toLowerCase()!==M.toLowerCase()&&q.code==="EXDEV"||U.endsWith("."))await k(U,M,{preserveSymlinks:!1}),await c(U,b.MOVE),await F(M);else throw q}}async function k(U,M,F){return _(U,M,{root:{source:U,target:M},options:F,handledSourcePaths:new Set})}const O=511;async function _(U,M,F){if(F.handledSourcePaths.has(U))return;F.handledSourcePaths.add(U);const{stat:q,symbolicLink:x}=await n.stat(U);if(x){if(F.options.preserveSymlinks)try{return await W(U,M,F)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(x.dangling)return}return q.isDirectory()?z(U,M,q.mode&O,F):V(U,M,q.mode&O)}async function z(U,M,F,q){await e.Promises.mkdir(M,{recursive:!0,mode:F});const x=await C(U);for(const N of x)await _((0,m.join)(U,N),(0,m.join)(M,N),q)}async function V(U,M,F){await e.Promises.copyFile(U,M),await e.Promises.chmod(M,F)}async function W(U,M,F){let q=await e.Promises.readlink(U);(0,A.isEqualOrParent)(q,F.root.source,!E.isLinux)&&(q=(0,m.join)(F.root.target,q.substr(F.root.source.length+1))),await e.Promises.symlink(q,M)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return C}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return c}get move(){return f}get copy(){return k}}}),define(Z[99],ee([0,1,50,8,23,18]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(i){const v=(0,L.dirname)(i);if(i===v)return i;const h=((0,L.basename)(i)||i).toLowerCase();try{const c=(0,T.readdirSync)(v).filter(y=>y.toLowerCase()===h);if(c.length===1){const y=A(v);if(y)return(0,L.join)(y,c[0])}else if(c.length>1){const y=c.indexOf(h);if(y>=0){const I=A(v);if(I)return(0,L.join)(I,c[y])}}}catch(b){}return null}e.realcaseSync=A;async function P(i){try{return await T.Promises.realpath(i)}catch(v){const h=E(i);return await T.Promises.access(h,D.constants.R_OK),h}}e.realpath=P;function m(i){try{return D.realpathSync(i)}catch(v){const h=E(i);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=m;function E(i){return(0,R.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[69],ee([0,1,34,8,18]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var m;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(m||(m={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class v{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:o=!1}={}){return o?E===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=h({useAlternateBitness:o});if(!t)return null;const r=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let n=-1,s=null;for(const d of await R.Promises.readdir(r)){let g=-1;if(a){const f=d.indexOf("-");if(f<0)continue;const k=d.substring(0,f);if(!T.test(k)||d.substring(f+1)!=="preview")continue;g=parseInt(k,10)}else{if(!T.test(d))continue;g=parseInt(d,10)}if(g<=n)continue;const p=L.join(r,d,"pwsh.exe");!await R.SymlinkSupport.existsFile(p)||(s=p,n=g)}if(!s)return null;const u=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new v(s,`PowerShell${l}${u}`,!0)}async function c({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(a))if(t.test(n)){const s=L.join(a,n,"pwsh.exe");return new v(s,r)}return null}function y(){const o=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new v(o,".NET Core PowerShell Global Tool")}function I(){const o=L.join(process.env.windir,E===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(o,"Windows PowerShell",!0)}async function*w(){let o=await b();o&&(yield o),o=await b({useAlternateBitness:!0}),o&&(yield o),o=await c(),o&&(yield o),o=y(),o&&(yield o),o=await b({findPreview:!0}),o&&(yield o),o=await c({findPreview:!0}),o&&(yield o),o=await b({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=I(),o&&(yield o)}async function*C(){for await(const o of w())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=C;async function S(){for await(const o of C())return o;return null}e.getFirstAvailablePowerShellInstallation=S}),define(Z[100],ee([0,1,41,17]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(A){return new Promise((P,m)=>{let E;const i=new Map;function v(b,c,y,I,w){const C=i.get(c);if(b===A||C){const S={name:h(y),cmd:y,pid:b,ppid:c,load:I,mem:w};i.set(b,S),b===A&&(E=S),C&&(C.children||(C.children=[]),C.children.push(S),C.children.length>1&&(C.children=C.children.sort((o,a)=>o.pid-a.pid)))}}function h(b){const c=/--disable-blink-features=Auxclick/,y=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,w=/\\pipe\\winpty-control/,C=/conhost\.exe/,S=/--type=([a-zA-Z-]+)/;if(y.exec(b))return"watcherService ";if(I.exec(b))return"electron-crash-reporter";if(w.exec(b))return"winpty-process";if(C.exec(b))return"console-window-host (Windows internal process)";let o=S.exec(b);if(o&&o.length===2)return o[1]==="renderer"?c.exec(b)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(b),o&&(t+=o+" ");while(o);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${t}`:b}if(process.platform==="win32"){const b=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substr(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substr(5):c;new Promise((c,y)=>{K(["windows-process-tree"],c,y)}).then(c=>{c.getProcessList(A,y=>{c.getProcessCpuUsage(y,I=>{const w=new Map;I.forEach(C=>{const S=b(C.commandLine||"");w.set(C.pid,{name:h(S),cmd:S,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),E=w.get(A),E?(w.forEach(C=>{const S=w.get(C.ppid);S&&(S.children||(S.children=[]),S.children.push(C))}),w.forEach(C=>{C.children&&(C.children=C.children.sort((S,o)=>S.pid-o.pid))}),P(E)):m(new Error(`Root process ${A} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let b=function(){let c=[E];const y=[];for(;c.length;){const w=c.shift();w&&(y.push(w.pid),w.children&&(c=c.concat(w.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);I+=" "+y.join(" "),(0,D.exec)(I,{},(w,C,S)=>{if(w||S)m(w||new Error(S.toString()));else{const o=C.toString().split(`
`);for(let a=0;a<y.length;a++){const t=i.get(y[a]);t.load=parseFloat(o[a])}if(!E){m(new Error(`Root process ${A} not found`));return}P(E)}})};(0,D.exec)("which ps",{},(c,y,I)=>{if(c||I)if(process.platform!=="linux")m(c||new Error(I.toString()));else{const w=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,D.exec)(w,{},(C,S,o)=>{C||o?m(C||new Error(o.toString())):(T(S,v),b())})}else{const w=y.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${w} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(S,o,a)=>{S||a&&!a.includes("screen size is bogus")?m(S||new Error(a.toString())):(T(o,v),process.platform==="linux"?b():E?P(E):m(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=R;function T(A,P){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=A.toString().split(`
`);for(const i of E){const v=m.exec(i.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(Z[101],ee([0,1,50,39,2,66,8,4,18]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function E(h,b,c){return v({path:h,isDirectory:!1},b,c)}e.watchFile=E;function i(h,b,c){return v({path:h,isDirectory:!0},b,c)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function v(h,b,c){if(P.isMacintosh&&(0,L.isEqualOrParent)(h.path,"/Volumes/"))return c(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const y=(0,A.basename)(h.path),I=new Map;let w=!1,C=[(0,R.toDisposable)(()=>{I.forEach(S=>(0,R.dispose)(S)),I.clear()})];try{const S=(0,D.watch)(h.path);C.push((0,R.toDisposable)(()=>{S.removeAllListeners(),S.close()}));const o=new Set;h.isDirectory&&m.Promises.readdir(h.path).then(a=>a.forEach(t=>o.add(t))),S.on("error",(a,t)=>{w||c(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${t})`)}),S.on("change",(a,t)=>{if(w)return;let r="";if(t&&(r=t.toString(),P.isMacintosh&&(r=(0,T.normalizeNFC)(r))),!r||a!=="change"&&a!=="rename")return;const n=h.isDirectory?(0,A.join)(h.path,r):h.path;if(h.isDirectory)if(a==="rename"){const s=I.get(n);s&&(0,R.dispose)(s);const u=setTimeout(async()=>{I.delete(n);const l=await m.Promises.exists(n);if(w)return;let d;l?o.has(r)?d="changed":(d="added",o.add(r)):(o.delete(r),d="deleted"),b(d,n)},e.CHANGE_BUFFER_DELAY);I.set(n,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let s;o.has(r)?s="changed":(s="added",o.add(r)),b(s,n)}else if(a==="rename"||r!==y){const s=setTimeout(async()=>{const u=await m.Promises.exists(n);w||(u?(b("changed",n),C=[v(h,b,c)]):b("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(C),C=[(0,R.toDisposable)(()=>clearTimeout(s))]}else b("changed",n)})}catch(S){m.Promises.exists(h.path).then(o=>{o&&!w&&c(`Failed to watch ${h.path} for changes using fs.watch() (${S.toString()})`)})}return(0,R.toDisposable)(()=>{w=!0,C=(0,R.dispose)(C)})}});var he=this&&this.__decorate||function(K,e,D,L){var R=arguments.length,T=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,D,L);else for(var P=K.length-1;P>=0;P--)(A=K[P])&&(T=(R<3?A(T):R>3?A(e,D,T):A(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(Z[36],ee([0,1,19,5,25,29,64,11,3,2,94,23,16]),function(K,e,D,L,R,T,A,P,m,E,i,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function c(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function I(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(w||(w={}));class C{constructor(N){this.buffer=N,this.pos=0}read(N){const j=this.buffer.slice(this.pos,this.pos+N);return this.pos+=j.byteLength,j}}class S{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(o||(o={}));function a(x){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE(x,0),N}function t(x){return x.read(4).readUInt32BE(0)}function r(x){const N=R.VSBuffer.alloc(1);return N.writeUInt8(x,0),N}const n={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},s=typeof Buffer!="undefined";function u(x,N){if(typeof N=="undefined")x.write(n.Undefined);else if(typeof N=="string"){const j=R.VSBuffer.fromString(N);x.write(n.String),x.write(a(j.byteLength)),x.write(j)}else if(s&&Buffer.isBuffer(N)){const j=R.VSBuffer.wrap(N);x.write(n.Buffer),x.write(a(j.byteLength)),x.write(j)}else if(N instanceof R.VSBuffer)x.write(n.VSBuffer),x.write(a(N.byteLength)),x.write(N);else if(Array.isArray(N)){x.write(n.Array),x.write(a(N.length));for(const j of N)u(x,j)}else{const j=R.VSBuffer.fromString(JSON.stringify(N));x.write(n.Object),x.write(a(j.byteLength)),x.write(j)}}function l(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(t(x)).toString();case o.Buffer:return x.read(t(x)).buffer;case o.VSBuffer:return x.read(t(x));case o.Array:{const j=t(x),$=[];for(let H=0;H<j;H++)$.push(l(x));return $}case o.Object:return JSON.parse(x.read(t(x)).toString())}}class d{constructor(N,j,$=null,H=1e3){this.protocol=N,this.ctx=j,this.logger=$,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:200})}registerChannel(N,j){this.channels.set(N,j),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const j=this.send([N.type]);this.logger&&this.logger.logOutgoing(j,0,1,I(N.type));return}case 201:case 202:case 204:case 203:{const j=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(j,N.id,1,I(N.type),N.data);return}}}send(N,j=void 0){const $=new S;return u($,N),u($,j),this.sendBuffer($.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onRawMessage(N){const j=new C(N),$=l(j),H=l(j),G=$[0];switch(G){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${c(G)}: ${$[2]}.${$[3]}`,H),this.onPromise({type:G,id:$[1],channelName:$[2],name:$[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${c(G)}: ${$[2]}.${$[3]}`,H),this.onEventListen({type:G,id:$[1],channelName:$[2],name:$[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${c(G)}`),this.disposeActiveRequest({type:G,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${c(G)}`),this.disposeActiveRequest({type:G,id:$[1]})}}onPromise(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const $=new T.CancellationTokenSource;let H;try{H=j.call(this.ctx,N.name,N.arg,$.token)}catch(X){H=Promise.reject(X)}const G=N.id;H.then(X=>{this.sendResponse({id:G,data:X,type:201}),this.activeRequests.delete(N.id)},X=>{X instanceof Error?this.sendResponse({id:G,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:G,data:X,type:203}),this.activeRequests.delete(N.id)});const Q=(0,E.toDisposable)(()=>$.cancel());this.activeRequests.set(N.id,Q)}onEventListen(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const $=N.id,G=j.listen(this.ctx,N.name,N.arg)(Q=>this.sendResponse({id:$,data:Q,type:204}));this.activeRequests.set(N.id,G)}disposeActiveRequest(N){const j=this.activeRequests.get(N.id);j&&(j.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let j=this.pendingRequests.get(N.channelName);j||(j=[],this.pendingRequests.set(N.channelName,j));const $=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:N,timeoutTimer:$})}flushPendingRequests(N){const j=this.pendingRequests.get(N);if(j){for(const $ of j)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var g;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(N,j=null){this.protocol=N,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=j}getChannel(N){const j=this;return{call($,H,G){return j.isDisposed?Promise.reject(P.canceled()):j.requestPromise(N,$,H,G)},listen($,H){return j.isDisposed?Promise.reject(P.canceled()):j.requestEvent(N,$,H)}}}requestPromise(N,j,$,H=T.CancellationToken.None){const G=this.lastRequestId++,X={id:G,type:100,channelName:N,name:j,arg:$};if(H.isCancellationRequested)return Promise.reject(P.canceled());let ie;return new Promise((oe,ue)=>{if(H.isCancellationRequested)return ue(P.canceled());const ye=()=>{const Ne=Oe=>{switch(Oe.type){case 201:this.handlers.delete(G),oe(Oe.data);break;case 202:this.handlers.delete(G);const ke=new Error(Oe.data.message);ke.stack=Oe.data.stack,ke.name=Oe.data.name,ue(ke);break;case 203:this.handlers.delete(G),ue(Oe.data);break}};this.handlers.set(G,Ne),this.sendRequest(X)};let ve=null;this.state===w.Idle?ye():(ve=(0,L.createCancelablePromise)(Ne=>this.whenInitialized()),ve.then(()=>{ve=null,ye()}));const Re=()=>{ve?(ve.cancel(),ve=null):this.sendRequest({id:G,type:101}),ue(P.canceled())},Te=H.onCancellationRequested(Re);ie=(0,E.combinedDisposable)((0,E.toDisposable)(Re),Te),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(N,j,$){const H=this.lastRequestId++,Q={id:H,type:102,channelName:N,name:j,arg:$};let X=null;const ie=new m.Emitter({onFirstListenerAdd:()=>{X=(0,L.createCancelablePromise)(oe=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(ie),this.sendRequest(Q)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(ie),this.sendRequest({id:H,type:103}))}}),te=oe=>ie.fire(oe.data);return this.handlers.set(H,te),ie.event}sendRequest(N){switch(N.type){case 100:case 102:{const j=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(j,N.id,0,`${c(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const j=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(j,N.id,0,c(N.type));return}}}send(N,j=void 0){const $=new S;return u($,N),u($,j),this.sendBuffer($.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onBuffer(N){const j=new C(N),$=l(j),H=l(j),G=$[0];switch(G){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,I(G)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],0,I(G),H),this.onResponse({type:$[0],id:$[1],data:H})}}onResponse(N){if(N.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(N.id);j&&j(N)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}he([A.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class f{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:j,onDidClientDisconnect:$})=>{m.Event.once(j.onMessage)(G=>{const Q=new C(G),X=l(Q),ie=new d(j,X),te=new p(j);this.channels.forEach((ue,ye)=>ie.registerChannel(ye,ue));const oe={channelServer:ie,channelClient:te,ctx:X};this._connections.add(oe),this._onDidAddConnection.fire(oe),$(()=>{ie.dispose(),te.dispose(),this._connections.delete(oe),this._onDidRemoveConnection.fire(oe)})})})}get connections(){const N=[];return this._connections.forEach(j=>N.push(j)),N}getChannel(N,j){const $=this;return{call(H,G,Q){let X;if((0,h.isFunction)(j)){let te=(0,D.getRandomElement)($.connections.filter(j));X=te?Promise.resolve(te):m.Event.toPromise(m.Event.filter($.onDidAddConnection,j))}else X=j.routeCall($,H,G);const ie=X.then(te=>te.channelClient.getChannel(N));return O(ie).call(H,G,Q)},listen(H,G){if((0,h.isFunction)(j))return $.getMulticastEvent(N,j,H,G);const Q=j.routeEvent($,H,G).then(X=>X.channelClient.getChannel(N));return O(Q).listen(H,G)}}}getMulticastEvent(N,j,$,H){const G=this;let Q=new E.DisposableStore;const X=new m.Emitter({onFirstListenerAdd:()=>{Q=new E.DisposableStore;const ie=new m.EventMultiplexer,te=new Map,oe=ye=>{const Re=ye.channelClient.getChannel(N).listen($,H),Te=ie.add(Re);te.set(ye,Te)},ue=ye=>{const ve=te.get(ye);!ve||(ve.dispose(),te.delete(ye))};G.connections.filter(j).forEach(oe),m.Event.filter(G.onDidAddConnection,j)(oe,void 0,Q),G.onDidRemoveConnection(ue,void 0,Q),ie.event(X.fire,X,Q),Q.add(ie)},onLastListenerRemove:()=>{Q.dispose()}});return X.event}registerChannel(N,j){this.channels.set(N,j),this._connections.forEach($=>{$.channelServer.registerChannel(N,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class k{constructor(N,j,$=null){const H=new S;u(H,j),N.send(H.buffer),this.channelClient=new p(N,$),this.channelServer=new d(N,j,$)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,j){this.channelServer.registerChannel(N,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function O(x){return{call(N,j,$){return x.then(H=>H.call(N,j,$))},listen(N,j){const $=new m.Relay;return x.then(H=>$.input=H.listen(N,j)),$.event}}}e.getDelayedChannel=O;function _(x){let N=!1;return{call(j,$,H){return N?x.call(j,$,H):(0,L.timeout)(0).then(()=>N=!0).then(()=>x.call(j,$,H))},listen(j,$){if(N)return x.listen(j,$);const H=new m.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>H.input=x.listen(j,$)),H.event}}}e.getNextTickChannel=_;class z{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const j of N.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await m.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=z;var V;(function(x){function N(H,G){const Q=H,X=G&&G.disableMarshalling,ie=new Map;for(const te in Q)$(te)&&ie.set(te,m.Event.buffer(Q[te],!0));return new class{listen(te,oe){const ue=ie.get(oe);if(ue)return ue;throw new Error(`Event not found: ${oe}`)}call(te,oe,ue){const ye=Q[oe];if(typeof ye=="function"){if(!X&&Array.isArray(ue))for(let ve=0;ve<ue.length;ve++)ue[ve]=(0,i.revive)(ue[ve]);return ye.apply(Q,ue)}throw new Error(`Method not found: ${oe}`)}}}x.fromService=N;function j(H,G){const Q=G&&G.disableMarshalling;return new Proxy({},{get(X,ie){if(typeof ie=="string")return G?.properties?.has(ie)?G.properties.get(ie):$(ie)?H.listen(ie):async function(...te){let oe;G&&!(0,h.isUndefinedOrNull)(G.context)?oe=[G.context,...te]:oe=te;const ue=await H.call(ie,oe);return Q?ue:(0,i.revive)(ue)};throw new Error(`Property not found: ${String(ie)}`)}})}x.toService=j;function $(H){return H[0]==="o"&&H[1]==="n"&&v.isUpperAsciiLetter(H.charCodeAt(2))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let N=x.toString();if(N!=="[object Object]")return N}return x}function M(x){return Array.isArray(x)?x.map(U):U(x)}function F(x,N,j,$,H,G,Q){Q=M(Q);const X=W[H],ie=X[$%X.length];let te=[`%c[${x}]%c[${String(N).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String($).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(G)?(te=te.concat(Q),te.push(")")):te.push(Q),console.log.apply(console,te)}e.logWithColors=F;class q{constructor(N,j){this._outgoingPrefix=N,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,j,$,H,G){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,j,$,H,G)}logIncoming(N,j,$,H,G){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,j,$,H,G)}}e.IPCLogger=q}),define(Z[102],ee([0,1,25,3,36]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(m){this.port=m,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends R.IPCClient{constructor(m,E){const i=new T(m);super(i,E);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=A}),define(Z[103],ee([0,1,104,3,36,102]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends R.IPCServer{static getOnDidClientConnect(){const m=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,i)=>i);return L.Event.map(m,E=>{const{port1:i,port2:v}=new MessageChannel,b={protocol:new T.Protocol(i),onDidClientDisconnect:L.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[v]),b})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(Z[105],ee([0,1,25,11]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,m){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((i,v)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(E,P),E.responseType="arraybuffer",E.onerror=h=>v(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=h=>{i({res:{statusCode:E.status,headers:A(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=h=>v(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),m.onCancellationRequested(()=>{E.abort(),v((0,L.canceled)())})})}e.request=R;function T(P,m){if(m.headers){e:for(let E in m.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,m.headers[E])}}}function A(P){const m=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const i=E.indexOf(":");m[E.substr(0,i).trim().toLowerCase()]=E.substr(i+1).trim()}return m}}),define(Z[70],ee([0,1,5,3,2,16]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var P;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(P||(P={}));class m extends R.Disposable{constructor(v,h=Object.create(null)){super();this.database=v,this.options=h,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((h,b)=>this.accept(b,h)),v.deleted?.forEach(h=>this.accept(h,void 0))}accept(v,h){if(this.state===P.Closed)return;let b=!1;(0,T.isUndefinedOrNull)(h)?b=this.cache.delete(v):this.cache.get(v)!==h&&(this.cache.set(v,h),b=!0),b&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,h){const b=this.cache.get(v);return(0,T.isUndefinedOrNull)(b)?h:b}getBoolean(v,h){const b=this.get(v);return(0,T.isUndefinedOrNull)(b)?h:b==="true"}getNumber(v,h){const b=this.get(v);return(0,T.isUndefinedOrNull)(b)?h:parseInt(b,10)}async set(v,h){if(this.state===P.Closed)return;if((0,T.isUndefinedOrNull)(h))return this.delete(v);const b=String(h);if(this.cache.get(v)!==b)return this.cache.set(v,b),this.pendingInserts.set(v,b),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async delete(v){if(!(this.state===P.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((h,b)=>this.items.set(b,h)),v.delete&&v.delete.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=E}),define(Z[106],ee([9,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,106]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,T=R*24,A=T*7,P=T*30,m=T*365;function E(v,h){typeof v!="number"&&(v=v.getTime());const b=Math.round((new Date().getTime()-v)/1e3);if(b<-30)return(0,D.localize)(0,null,E(new Date().getTime()+b*1e3,!1));if(b<30)return(0,D.localize)(1,null);let c;return b<L?(c=b,h?c===1?(0,D.localize)(2,null,c):(0,D.localize)(3,null,c):c===1?(0,D.localize)(4,null,c):(0,D.localize)(5,null,c)):b<R?(c=Math.floor(b/L),h?c===1?(0,D.localize)(6,null,c):(0,D.localize)(7,null,c):c===1?(0,D.localize)(8,null,c):(0,D.localize)(9,null,c)):b<T?(c=Math.floor(b/R),h?c===1?(0,D.localize)(10,null,c):(0,D.localize)(11,null,c):c===1?(0,D.localize)(12,null,c):(0,D.localize)(13,null,c)):b<A?(c=Math.floor(b/T),h?c===1?(0,D.localize)(14,null,c):(0,D.localize)(15,null,c):c===1?(0,D.localize)(16,null,c):(0,D.localize)(17,null,c)):b<P?(c=Math.floor(b/A),h?c===1?(0,D.localize)(18,null,c):(0,D.localize)(19,null,c):c===1?(0,D.localize)(20,null,c):(0,D.localize)(21,null,c)):b<m?(c=Math.floor(b/P),h?c===1?(0,D.localize)(22,null,c):(0,D.localize)(23,null,c):c===1?(0,D.localize)(24,null,c):(0,D.localize)(25,null,c)):(c=Math.floor(b/m),h?c===1?(0,D.localize)(26,null,c):(0,D.localize)(27,null,c):c===1?(0,D.localize)(28,null,c):(0,D.localize)(29,null,c))}e.fromNow=E;function i(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[107],ee([9,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[37],ee([0,1,19,16,107]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(E,i){return i&&(E.stack||E.stacktrace)?R.localize(0,null,P(E),A(E.stack)||A(E.stacktrace)):P(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function m(E=null,i=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const v=D.coalesce(E),h=m(v[0],i);return v.length>1?R.localize(4,null,h,v.length):h}if(L.isString(E))return E;if(E.detail){const v=E.detail;if(v.error)return T(v.error,i);if(v.exception)return T(v.exception,i)}return E.stack?T(E,i):E.message?E.message:R.localize(5,null)}e.toErrorMessage=m}),define(Z[108],ee([9,10]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],ee([0,1,41,39,17,26,8,4,35,16,68,18,108]),function(K,e,D,L,R,T,A,P,m,E,i,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function b(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(o,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(n=>{r.once("error",s=>{n({success:!1,error:s})}),r.once("exit",(s,u)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?b(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,u)=>{r(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function y(o=m.env){return o.comspec||"cmd.exe"}e.getWindowsShell=y;class I{constructor(a,t,r,n){if(t!==void 0&&r!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=n;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(m.env).forEach(u=>{s[u]=m.env[u]}),Object.keys(this.options.env).forEach(u=>{s[u]=this.options.env[u]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(A.sep);return t!==-1&&(a=a.substring(t+1)),I.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(m.cwd()))?Promise.reject(new Error(h.localize(0,null))):this.useExec().then(t=>{let r,n;const s=new Promise((u,l)=>{r=u,n=l});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(l,d,g)=>{this.childProcess=null;const p=l;p&&p.killed?n({killed:this.terminateRequested,stdout:d.toString(),stderr:g.toString()}):this.handleExec(r,a,l,d,g)})}else{let u=null;const l=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,r,a,n);const g={terminated:this.terminateRequested};E.isNumber(d)&&(g.cmdCode=d),r(g)};if(this.shell&&P.isWindows){const d=T.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let g=!1,p=!1;const f=[];let k=this.ensureQuotes(this.cmd);f.push(k.value),g=k.quoted,this.args&&this.args.forEach(_=>{k=this.ensureQuotes(_),f.push(k.value),p=p&&k.quoted});const O=["/s","/c"];g?p?O.push('"'+f.join(" ")+'"'):f.length>1?O.push('"'+f[0]+'" '+f.slice(1).join(" ")):O.push('"'+f[0]+'"'):O.push(f.join(" ")),u=D.spawn(y(),O,d)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(E.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",d=>{this.childProcess=null,n({terminated:this.terminateRequested,error:d})}),u.pid&&(this.childProcess.on("close",l),this.handleSpawn(u,r,a,n,!0)))}return s})}handleClose(a,t,r,n){}ensureQuotes(a){return I.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,c(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=D.spawn(y(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class w extends I{constructor(a,t,r,n){super(a,t,r,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,n,s){[n,s].forEach((u,l)=>{const d=new i.LineDecoder;d.write(u).forEach(f=>{t({line:f,source:l===0?0:1})});const p=d.end();p&&t({line:p,source:l===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,n,s){const u=new i.LineDecoder,l=new i.LineDecoder;a.stdout.on("data",d=>{u.write(d).forEach(p=>r({line:p,source:0}))}),a.stderr.on("data",d=>{l.write(d).forEach(p=>r({line:p,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=l}handleClose(a,t,r,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=w;function C(o){let a=[],t=!1;const r=function(n){if(t){a.push(n);return}(!o.send(n,u=>{if(u&&console.error(u),t=!1,a.length>0){const l=a.slice(0);a=[],l.forEach(d=>r(d))}})||P.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=C;var S;(function(o){async function a(t,r,n){if(A.isAbsolute(t))return t;if(r===void 0&&(r=m.cwd()),A.dirname(t)!=="."||(n===void 0&&E.isString(m.env.PATH)&&(n=m.env.PATH.split(A.delimiter)),n===void 0||n.length===0))return A.join(r,t);async function u(l){if(await v.Promises.exists(l)){let d;try{d=await v.Promises.stat(l)}catch(g){g.message.startsWith("EACCES")&&(d=await v.Promises.lstat(l))}return d?!d.isDirectory():!1}return!1}for(let l of n){let d;if(A.isAbsolute(l)?d=A.join(l,t):d=A.join(r,l,t),await u(d))return d;let g=d+".com";if(await u(g)||(g=d+".exe",await u(g)))return g}return A.join(r,t)}o.findExecutable=a})(S=e.win32||(e.win32={}))}),define(Z[109],ee([0,1,34,4,69,71]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(b,c){return b===1?L.isWindows?v():T.getWindowsShell(c):E(b,c)}e.getSystemShell=A;function P(b,c){return b===1?L.isWindows?h(c):T.getWindowsShell(c):E(b,c)}e.getSystemShellSync=P;let m=null;function E(b,c){if(L.isLinux&&b===2||L.isMacintosh&&b===3)return"/bin/bash";if(!m){let y;if(L.isWindows)y="/bin/bash";else{if(y=c.SHELL,!y)try{y=(0,D.userInfo)().shell}catch(I){}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}m=y}return m}let i=null;async function v(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function h(b){if(i)return i;const c=L.isWindows&&parseFloat((0,D.release)())>=10,y=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${b.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?I:T.getWindowsShell(b)}}),define(Z[51],ee([0,1,41,5,25,29,93,11,3,2,26,4,71,36]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends b.ChannelServer{constructor(w){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(S){}},onMessage:m.Event.fromNodeEventEmitter(process,"message",C=>R.VSBuffer.wrap(Buffer.from(C,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=c;class y{constructor(w,C){this.modulePath=w,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new L.Delayer(S),this.child=null,this._client=null}getChannel(w){const C=this;return{call(S,o,a){return C.requestPromise(w,S,o,a)},listen(S,o){return C.requestEvent(w,S,o)}}}requestPromise(w,C,S,o=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(w),t=(0,L.createCancelablePromise)(s=>a.call(C,S,s)),r=o.onCancellationRequested(()=>t.cancel()),n=(0,E.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,C,S){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let o;const a=new m.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(w).listen(C,S)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(C.env={...C.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),v.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,w,C);const S=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,A.isRemoteConsoleLog)(u)){(0,A.log)(u,`IPC Library: ${this.options.serverName}`);return}S.fire(R.VSBuffer.wrap(Buffer.from(u,"base64")))});const a=this.options.useQueue?(0,h.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&a.send(u.buffer.toString("base64")),r=S.event,n={send:t,onMessage:r};this._client=new b.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(d=>(0,E.dispose)(d)),this.activeRequests.clear(),u!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:l})})}return this._client}getCachedChannel(w){let C=this.channels.get(w);return C||(C=this.client.getChannel(w),this.channels.set(w,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(Z[110],ee([9,10]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[111],ee([9,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[112],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[113],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[114],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[115],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[116],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[117],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[118],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[119],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[120],ee([9,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[121],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[122],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[123],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[124],ee([9,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[125],ee([9,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[126],ee([9,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[127],ee([9,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[128],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[129],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[130],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[131],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[132],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[133],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[134],ee([0,1,56,64,17,8,35,15,7]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(c,y,I){this._args=c,this.paths=y,this.productService=I}get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",K).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(m.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=A.env.VSCODE_PORTABLE;return c?m.URI.file((0,T.join)(c,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,T.resolve)(c):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,T.resolve)(c):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,T.resolve)(c);const y=A.env.VSCODE_EXTENSIONS;if(y)return y;const I=A.env.VSCODE_PORTABLE;return I?(0,T.join)(I,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(y=>/^[^:/?#]+?:\/\//.test(y)?m.URI.parse(y):m.URI.file((0,T.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?m.URI.parse(c):m.URI.file((0,T.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],E.prototype,"appRoot",null),he([L.memoize],E.prototype,"userHome",null),he([L.memoize],E.prototype,"userDataPath",null),he([L.memoize],E.prototype,"appSettingsHome",null),he([L.memoize],E.prototype,"tmpDir",null),he([L.memoize],E.prototype,"userRoamingDataHome",null),he([L.memoize],E.prototype,"settingsResource",null),he([L.memoize],E.prototype,"userDataSyncHome",null),he([L.memoize],E.prototype,"userDataSyncLogResource",null),he([L.memoize],E.prototype,"sync",null),he([L.memoize],E.prototype,"machineSettingsResource",null),he([L.memoize],E.prototype,"globalStorageHome",null),he([L.memoize],E.prototype,"workspaceStorageHome",null),he([L.memoize],E.prototype,"keybindingsResource",null),he([L.memoize],E.prototype,"keyboardLayoutResource",null),he([L.memoize],E.prototype,"argvResource",null),he([L.memoize],E.prototype,"snippetsHome",null),he([L.memoize],E.prototype,"isExtensionDevelopment",null),he([L.memoize],E.prototype,"untitledWorkspacesHome",null),he([L.memoize],E.prototype,"installSourcePath",null),he([L.memoize],E.prototype,"builtinExtensionsPath",null),he([L.memoize],E.prototype,"extensionsPath",null),he([L.memoize],E.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],E.prototype,"extensionDevelopmentKind",null),he([L.memoize],E.prototype,"extensionTestsLocationURI",null),he([L.memoize],E.prototype,"debugExtensionHost",null),he([L.memoize],E.prototype,"serviceMachineIdResource",null),he([L.memoize],E.prototype,"telemetryLogResource",null),he([L.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function i(b,c){return h(b["inspect-extensions"],b["inspect-brk-extensions"],5870,c,b.debugId)}e.parseExtensionHostPort=i;function v(b,c){return h(b["inspect-search"],b["inspect-brk-search"],5876,c)}e.parseSearchPort=v;function h(b,c,y,I,w){const S=Number(c||b)||(I?null:y),o=S?Boolean(!!c):!1;return{port:S,break:o,debugId:w}}}),define(Z[135],ee([0,1,220,4,112]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(c,y,I=A){const w={},C=[],S=[];for(let r in y){const n=y[r];n.alias&&(w[r]=n.alias),n.type==="string"||n.type==="string[]"?(C.push(r),n.deprecates&&C.push(n.deprecates)):n.type==="boolean"&&(S.push(r),n.deprecates&&S.push(n.deprecates))}const o=D(c,{string:C,boolean:S,alias:w}),a={},t=o;a._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in y){const n=y[r];n.alias&&delete t[n.alias];let s=t[r];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(s||(s=t[n.deprecates]),delete t[n.deprecates]),typeof s!="undefined"&&(n.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):n.type==="string"&&Array.isArray(s)&&(s=s.pop(),I.onMultipleValues(r,s)),a[r]=s),delete t[r]}for(let r in t)I.onUnknownOption(r);return a}e.parseArgs=P;function m(c,y){let I="";return y.args&&(Array.isArray(y.args)?I=` <${y.args.join("> <")}>`:I=` <${y.args}>`),y.alias?`-${y.alias} --${c}${I}`:`--${c}${I}`}function E(c,y){let I=0,w=[];for(const a in c){const t=c[a],r=m(a,t);I=Math.max(I,r.length),w.push([r,t.description])}let C=I+2+1;if(y-C<25)return w.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let S=y-C-1,o=[];for(const a of w){let t=a[0],r=v(a[1],S),n=i(C-t.length-2);o.push("  "+t+n+r[0]);for(let s=1;s<r.length;s++)o.push(i(C)+r[s])}return o}e.formatOptions=E;function i(c){return" ".repeat(c)}function v(c,y){let I=[];for(;c.length;){let w=c.length<y?c.length:c.lastIndexOf(" ",y),C=c.slice(0,w).trim();c=c.slice(w),I.push(C)}return I}function h(c,y,I,w,C=!0){const S=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${c} ${I}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${y} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),C&&(L.isWindows?o.push((0,R.localize)(35,null,y)):o.push((0,R.localize)(36,null,y)),o.push(""));const a={};for(const t in w){const r=w[t];if(r.description&&r.cat){let n=a[r.cat];n||(a[r.cat]=n={}),n[t]=r}}for(let t in a){const r=t;let n=a[r];n&&(o.push(T[r]),o.push(...E(n,S)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=h;function b(c,y){return`${c||(0,R.localize)(37,null)}
${y||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=b}),function(){"use strict";function K(e,D,L,R){function T(P){const m=A(P),E=[m];return e.isAbsolute(m)||E.unshift(R),e.resolve(...E)}function A(P){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,L);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(v,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,L)}return{getUserDataPath:T}}if(typeof define=="function")define(Z[136],ee([0,137,34,17,15,35]),function(e,D,L,R,T,A){const P=T.dirname(R.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return K(D,L,m.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=K(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[138],ee([0,1,34,134,136]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends L.AbstractNativeEnvironmentService{constructor(P,m){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},m)}}e.NativeEnvironmentService=T}),define(Z[139],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(I){const w=I.match(A);return w?w[1]:null}function i(I){if(I.indexOf("://")===-1){const w=I.match(L);return w?E(w[2]):null}try{const w=D.URI.parse(I);if(w.authority)return E(w.authority)}catch(w){}return null}function v(I,w){const C=new Set;let S;for(;S=P.exec(I);){const a=i(S[1]);a&&C.add(a)}const o=new Set(w);return Array.from(C).map(a=>o.has(a)?a:a.replace(m,"a"))}e.getDomainsOfRemotes=v;function h(I){const w=I.match(T);return w?w[2]:null}function b(I,w,C){return I&&w?(C&&w.endsWith(".git")&&(w=w.substr(0,w.length-4)),w.indexOf("/")===0?`${I}${w}`:`${I}/${w}`):null}function c(I,w){if(I.indexOf("://")===-1){const C=I.match(R);if(C)return b(C[2],C[3],w)}try{const C=D.URI.parse(I);if(C.authority)return b(h(C.authority),C.path,w)}catch(C){}return null}function y(I,w=!1){const C=[];let S;for(;S=P.exec(I);){const o=c(S[1],w);o&&C.push(o)}return C}e.getRemotes=y}),define(Z[140],ee([0,1,3,2,26,7,96]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(c,y){return T.URI.revive(y?y.transformIncoming(c):c)}function m(c,y){return y?y.transformOutgoingURI(c):c}function E(c,y){y=y||A.DefaultURITransformer;const I=c.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...c,manifest:void 0},y),manifest:I}}function i(c,y){return y?(0,R.cloneAndChange)(c,I=>I instanceof T.URI?y.transformOutgoingURI(I):void 0):c}class v{constructor(y,I){this.service=y,this.getUriTransformer=I,this.onInstallExtension=D.Event.buffer(y.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(y.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(y.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(y.onDidUninstallExtension,!0)}listen(y,I){const w=this.getUriTransformer(y);switch(I){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,C=>C.map(S=>({...S,local:S.local?i(S.local,w):S.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(y,I,w){const C=this.getUriTransformer(y);switch(I){case"zip":return this.service.zip(E(w[0],C)).then(S=>m(S,C));case"unzip":return this.service.unzip(P(w[0],C));case"install":return this.service.install(P(w[0],C),w[1]);case"getManifest":return this.service.getManifest(P(w[0],C));case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(E(w[0],C),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(E(w[0],C));case"getInstalled":return this.service.getInstalled(w[0]).then(S=>S.map(o=>i(o,C)));case"updateMetadata":return this.service.updateMetadata(E(w[0],C),w[1]).then(S=>i(S,C));case"updateExtensionScope":return this.service.updateExtensionScope(E(w[0],C),w[1]).then(S=>i(S,C));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends L.Disposable{constructor(y){super();this.channel=y,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(I=>this._onInstallExtension.fire({identifier:I.identifier,source:this.isUriComponents(I.source)?T.URI.revive(I.source):I.source}))),this._register(this.channel.listen("onDidInstallExtensions")(I=>this._onDidInstallExtensions.fire(I.map(w=>({...w,local:w.local?E(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(I=>this._onUninstallExtension.fire(I))),this._register(this.channel.listen("onDidUninstallExtension")(I=>this._onDidUninstallExtension.fire(I)))}isUriComponents(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}zip(y){return Promise.resolve(this.channel.call("zip",[y]).then(I=>T.URI.revive(I)))}unzip(y){return Promise.resolve(this.channel.call("unzip",[y]))}install(y,I){return Promise.resolve(this.channel.call("install",[y,I])).then(w=>E(w,null))}getManifest(y){return Promise.resolve(this.channel.call("getManifest",[y]))}async canInstall(y){return!0}installFromGallery(y,I){return Promise.resolve(this.channel.call("installFromGallery",[y,I])).then(w=>E(w,null))}uninstall(y,I){return Promise.resolve(this.channel.call("uninstall",[y,I]))}reinstallFromGallery(y){return Promise.resolve(this.channel.call("reinstallFromGallery",[y]))}getInstalled(y=null){return Promise.resolve(this.channel.call("getInstalled",[y])).then(I=>I.map(w=>E(w,null)))}updateMetadata(y,I){return Promise.resolve(this.channel.call("updateMetadata",[y,I])).then(w=>E(w,null))}updateExtensionScope(y,I){return Promise.resolve(this.channel.call("updateExtensionScope",[y,I])).then(w=>E(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class b{constructor(y){this.service=y}listen(y,I){throw new Error("Invalid listen")}call(y,I,w){switch(I){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Z[141],ee([0,1,26]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(T,A){const P=m=>{if(typeof m!="string")return;const E=L.exec(m);if(!E)return;const i=A[E[1]]??m;return typeof i=="string"?i:typeof i.message=="string"?i.message:m};return(0,D.cloneAndChange)(T,P)}e.localizeManifest=R}),define(Z[142],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,P,m){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,P,m])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[72],ee([0,1,120]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function T(h){return h=h.trim(),h==="*"||L.test(h)}e.isValidVersionStr=T;function A(h){if(!T(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=h.match(L);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=A;function P(h){if(!h)return null;let b=h.majorBase,c=h.majorMustEqual,y=h.minorBase,I=h.minorMustEqual,w=h.patchBase,C=h.patchMustEqual;h.hasCaret&&(b===0||(I=!1),C=!1);let S=0;if(h.preRelease){const o=R.exec(h.preRelease);if(o){const[,a,t,r]=o;S=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:b,majorMustEqual:c,minorBase:y,minorMustEqual:I,patchBase:w,patchMustEqual:C,isMinimum:h.hasGreaterEquals,notBefore:S}}e.normalizeVersion=P;function m(h,b,c){let y;typeof h=="string"?y=P(A(h)):y=h;let I;b instanceof Date?I=b.getTime():typeof b=="string"&&(I=new Date(b).getTime());let w;if(typeof c=="string"?w=P(A(c)):w=c,!y||!w)return!1;let C=y.majorBase,S=y.minorBase,o=y.patchBase,a=w.majorBase,t=w.minorBase,r=w.patchBase,n=w.notBefore,s=w.majorMustEqual,u=w.minorMustEqual,l=w.patchMustEqual;return w.isMinimum?C>a?!0:C<a?!1:S>t?!0:S<t||I&&I<n?!1:o>=r:(C===1&&a===0&&(!s||!u||!l)&&(a=1,t=0,r=0,s=!0,u=!1,l=!1),C<a?!1:C>a?!s:S<t?!1:S>t?!u:o<r?!1:o>r?!l:!(I&&I<n))}e.isValidVersion=m;function E(h,b,c,y){return c.isBuiltin||typeof c.main=="undefined"?!0:v(h,b,c.engines.vscode,y)}e.isValidExtensionVersion=E;function i(h,b,c){return h==="*"||v(b,c,h)}e.isEngineValid=i;function v(h,b,c,y=[]){let I=P(A(c));if(!I)return y.push(D.localize(0,null,c)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return y.push(D.localize(1,null,c)),!1}else if(!I.majorMustEqual)return y.push(D.localize(2,null,c)),!1;return m(h,b,I)?!0:(y.push(D.localize(3,null,h,c)),!1)}}),define(Z[143],ee([0,1,2,17,36,51]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends D.Disposable{constructor(m,E,i,v){super();this.folders=m,this.onDidFilesChange=E,this.onLogMessage=i,this.verboseLogging=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[144],ee([0,1,2,17,36,51]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends D.Disposable{constructor(m,E,i,v,h={}){super();this.folders=m,this.onDidFilesChange=E,this.onLogMessage=i,this.verboseLogging=v,this.watcherOptions=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[145],ee([0,1,41,67,17,68]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(m,E,i,v,h){this.watchedFolder=m,this.eventCallback=i,this.logCallback=v,this.verboseLogging=h,this.restartCounter=0,Array.isArray(E)?this.ignored=E.map(b=>(0,L.parse)(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}, excludes: ${E.join(",")}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,m);const E=new T.LineDecoder;this.handle.stdout.on("data",i=>{const v=[];for(const h of E.write(i)){const b=h.split("|");if(b.length===2){const c=Number(b[0]),y=b[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(I=>I(y))){this.verboseLogging&&this.log(y);continue}v.push({type:A.changeTypeMap[c],path:y})}else this.log(b[1])}}v.length>0&&this.eventCallback(v)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,v)=>this.onExit(i,v))}onError(m){this.error("process error: "+m.toString())}onExit(m,E){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${E})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Z[146],ee([0,1,8,23,145]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(P,m,E,i){this.onDidFilesChange=m,this.onLogMessage=E,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(Z[52],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],A=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(Z[147],ee([0,1,52]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(A,P,m){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],m)),L.push([A,P])}e.registerSingleton=R;function T(){return L}e.getSingletonServiceDescriptors=T}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const P=this.lookupOrInsertNode(T),m=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),m),m.incoming.set(this._hashFn(T),P)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let P=this._nodes.get(A);return P||(P=new D(T),this._nodes.set(A,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,P]of this._nodes)T.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const P=new Set([T]),m=this._findCycle(A,P);if(m)return m}}_findCycle(T,A){for(let[P,m]of T.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const E=this._findCycle(m,A);if(E)return E;A.delete(P)}}}e.Graph=L}),define(Z[6],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(E){return E[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,m,E,i){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:P,index:E,optional:i}):(m[D.DI_DEPENDENCIES]=[{id:P,index:E,optional:i}],m[D.DI_TARGET]=m)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const m=function(E,i,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(m,E,v,!1)};return m.toString=()=>P,D.serviceIds.set(P,m),m}e.createDecorator=R;function T(P){return P}e.refineServiceDecorator=T;function A(P){return function(m,E,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,m,i,!0)}}e.optional=A}),define(Z[149],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(Z[150],ee([0,1,4,23,6]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",D.isMacintosh),A.set("isLinux",D.isLinux),A.set("isWindows",D.isWindows),A.set("isWeb",D.isWeb),A.set("isMacNative",D.isMacintosh&&!D.isWeb),A.set("isEdge",T.indexOf("Edg/")>=0),A.set("isFirefox",T.indexOf("Firefox")>=0),A.set("isChrome",T.indexOf("Chrome")>=0),A.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var m;(function(p){p[p.False=0]="False",p[p.True=1]="True",p[p.Defined=2]="Defined",p[p.Not=3]="Not",p[p.Equals=4]="Equals",p[p.NotEquals=5]="NotEquals",p[p.And=6]="And",p[p.Regex=7]="Regex",p[p.NotRegex=8]="NotRegex",p[p.Or=9]="Or",p[p.In=10]="In",p[p.NotIn=11]="NotIn",p[p.Greater=12]="Greater",p[p.GreaterEquals=13]="GreaterEquals",p[p.Smaller=14]="Smaller",p[p.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return v.INSTANCE}static true(){return h.INSTANCE}static has(f){return b.create(f)}static equals(f,k){return c.create(f,k)}static notEquals(f,k){return w.create(f,k)}static regex(f,k){return r.create(f,k)}static in(f,k){return y.create(f,k)}static not(f){return C.create(f)}static and(...f){return s.create(f)}static or(...f){return u.create(f)}static greater(f,k){return S.create(f,k)}static less(f,k){return a.create(f,k)}static deserialize(f,k=!1){if(!!f)return this._deserializeOrExpression(f,k)}static _deserializeOrExpression(f,k){let O=f.split("||");return u.create(O.map(_=>this._deserializeAndExpression(_,k)))}static _deserializeAndExpression(f,k){let O=f.split("&&");return s.create(O.map(_=>this._deserializeOne(_,k)))}static _deserializeOne(f,k){if(f=f.trim(),f.indexOf("!=")>=0){let O=f.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],k))}if(f.indexOf("==")>=0){let O=f.split("==");return c.create(O[0].trim(),this._deserializeValue(O[1],k))}if(f.indexOf("=~")>=0){let O=f.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],k))}if(f.indexOf(" in ")>=0){let O=f.split(" in ");return y.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const O=f.split(">=");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const O=f.split(">");return S.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const O=f.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const O=f.split("<");return a.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(f)?C.create(f.substr(1).trim()):b.create(f)}static _deserializeValue(f,k){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let O=/^'([^']*)'$/.exec(f);return O?O[1].trim():f}static _deserializeRegexValue(f,k){if((0,L.isFalsyOrWhitespace)(f)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=f.indexOf("/"),_=f.lastIndexOf("/");if(O===_||O<0){if(k)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let z=f.slice(O+1,_),V=f[_+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(W){if(k)throw new Error(`bad regexp-value '${f}', parse error: ${W}`);return console.warn(`bad regexp-value '${f}', parse error: ${W}`),null}}}e.ContextKeyExpr=E;function i(p,f){return p.cmp(f)}class v{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class h{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class b{constructor(f){this.key=f,this.type=2}static create(f){const k=A.get(f);return typeof k=="boolean"?k?h.INSTANCE:v.INSTANCE:new b(f)}cmp(f){return f.type!==this.type?this.type-f.type:d(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return C.create(this.key)}}e.ContextKeyDefinedExpr=b;class c{constructor(f,k){this.key=f,this.value=k,this.type=4}static create(f,k){if(typeof k=="boolean")return k?b.create(f):C.create(f);const O=A.get(f);return typeof O=="boolean"?k===(O?"true":"false")?h.INSTANCE:v.INSTANCE:new c(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class y{constructor(f,k){this.key=f,this.valueKey=k,this.type=10}static create(f,k){return new y(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const k=f.getValue(this.valueKey),O=f.getValue(this.key);return Array.isArray(k)?k.indexOf(O)>=0:typeof O=="string"&&typeof k=="object"&&k!==null?P.call(k,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return I.create(this)}}e.ContextKeyInExpr=y;class I{constructor(f){this._actual=f,this.type=11}static create(f){return new I(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new I(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class w{constructor(f,k){this.key=f,this.value=k,this.type=5}static create(f,k){if(typeof k=="boolean")return k?C.create(f):b.create(f);const O=A.get(f);return typeof O=="boolean"?k===(O?"true":"false")?v.INSTANCE:h.INSTANCE:new w(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class C{constructor(f){this.key=f,this.type=3}static create(f){const k=A.get(f);return typeof k=="boolean"?k?v.INSTANCE:h.INSTANCE:new C(f)}cmp(f){return f.type!==this.type?this.type-f.type:d(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=C;class S{constructor(f,k){this.key=f,this.value=k,this.type=12}static create(f,k){return new S(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=S;class o{constructor(f,k){this.key=f,this.value=k,this.type=13}static create(f,k){return new o(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(f,k){this.key=f,this.value=k,this.type=14}static create(f,k){return new a(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(f,k){this.key=f,this.value=k,this.type=15}static create(f,k){return new t(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return S.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(f,k){this.key=f,this.regexp=k,this.type=7}static create(f,k){return new r(f,k)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const k=this.regexp?this.regexp.source:"",O=f.regexp?f.regexp.source:"";return k<O?-1:k>O?1:0}equals(f){if(f.type===this.type){const k=this.regexp?this.regexp.source:"",O=f.regexp?f.regexp.source:"";return this.key===f.key&&k===O}return!1}evaluate(f){let k=f.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=r;class n{constructor(f){this._actual=f,this.type=8}static create(f){return new n(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new n(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class s{constructor(f){this.expr=f,this.type=6}static create(f){return s._normalizeArr(f)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const _=i(this.expr[k],f.expr[k]);if(_!==0)return _}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(f.expr[k]))return!1;return!0}return!1}evaluate(f){for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].evaluate(f))return!1;return!0}static _normalizeArr(f){const k=[];let O=!1;for(const _ of f)if(!!_){if(_.type===1){O=!0;continue}if(_.type===0)return v.INSTANCE;if(_.type===6){k.push(..._.expr);continue}k.push(_)}if(k.length===0&&O)return h.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(i);k.length>1;){const _=k[k.length-1];if(_.type!==9)break;k.pop();const z=k.pop(),V=u.create(_.expr.map(W=>s.create([W,z])));V&&(k.push(V),k.sort(i))}return k.length===1?k[0]:new s(k)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let k of this.expr)f.push(...k.keys());return f}map(f){return new s(this.expr.map(k=>k.map(f)))}negate(){let f=[];for(let k of this.expr)f.push(k.negate());return u.create(f)}}e.ContextKeyAndExpr=s;class u{constructor(f){this.expr=f,this.type=9}static create(f){const k=u._normalizeArr(f);if(k.length!==0)return k.length===1?k[0]:new u(k)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const _=i(this.expr[k],f.expr[k]);if(_!==0)return _}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(f.expr[k]))return!1;return!0}return!1}evaluate(f){for(let k=0,O=this.expr.length;k<O;k++)if(this.expr[k].evaluate(f))return!0;return!1}static _normalizeArr(f){let k=[],O=!1;if(f){for(let _=0,z=f.length;_<z;_++){const V=f[_];if(!!V){if(V.type===0){O=!0;continue}if(V.type===1)return[h.INSTANCE];if(V.type===9){k=k.concat(V.expr);continue}k.push(V)}}if(k.length===0&&O)return[v.INSTANCE];k.sort(i)}return k}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let k of this.expr)f.push(...k.keys());return f}map(f){return new u(this.expr.map(k=>k.map(f)))}negate(){let f=[];for(let O of this.expr)f.push(O.negate());const k=O=>O.type===9?O.expr:[O];for(;f.length>1;){const O=f.shift(),_=f.shift(),z=[];for(const V of k(O))for(const W of k(_))z.push(E.and(V,W));f.unshift(E.or(...z))}return f[0]}}e.ContextKeyOrExpr=u;class l extends b{constructor(f,k,O){super(f);this._defaultValue=k,typeof O=="object"?l._info.push({...O,key:f}):O!==!0&&l._info.push({key:f,description:O,type:k!=null?typeof k:void 0})}static all(){return l._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return E.not(this.key)}isEqualTo(f){return E.equals(this.key,f)}notEqualsTo(f){return E.notEquals(this.key,f)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(p,f){return p<f?-1:p>f?1:0}function g(p,f,k,O){return p<k?-1:p>k?1:f<O?-1:f>O?1:0}}),define(Z[73],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[74],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Z[12],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,17,115,6]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=T;var A;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var m;(function(v){v.Install="install",v.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var E;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(h,b){super(h);this.code=b,this.name=b}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var Y=this&&this.__param||function(K,e){return function(D,L){e(D,L,K)}};define(Z[151],ee([0,1,2,27]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=he([Y(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(Z[75],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[76],ee([0,1,23,6]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=R;function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,h){if(typeof v=="undefined"||v===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof v=="string"||typeof h=="string"){let b=typeof v=="string"?v:v.value,c=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(b,c)}return v._lower===h._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=P;function m(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function E(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[31],ee([0,1,23,76]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(c,y){return c.uuid&&y.uuid?c.uuid===y.uuid:c.id===y.id?!0:(0,D.compareIgnoreCase)(c.id,y.id)===0}e.areSameExtensions=R;class T{constructor(y,I){this.version=I,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof T?R(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(c,y){return`${c}.${y}`}e.getExtensionId=A;function P(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function m(c,y){return P(A(c,y))}e.getGalleryExtensionId=m;function E(c,y){const I=[],w=C=>{for(const S of I)if(S.some(o=>R(y(o),y(C))))return S;return null};for(const C of c){const S=w(C);S?S.push(C):I.push([C])}return I}e.groupByExtension=E;function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function v(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function h(c){const y=new Set;for(const I of c)I.malicious&&y.add(I.id.id);return y}e.getMaliciousExtensionsSet=h;function b(c,y){const I=[],w=y.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const C=w.shift();if(C&&I.every(S=>!R(S.identifier,{id:C}))){const S=c.filter(o=>R(o.identifier,{id:C}));S.length===1&&(I.push(S[0]),w.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=b}),define(Z[152],ee([0,1,2,8,18,76]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(m,E){super();this.environmentService=m,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(E.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(m){m.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(Z[13],ee([0,1,40,8,23,16,7,122,6]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var v;(function(U){U[U.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var h;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=b;function c(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=c;function y(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function I(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=I;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor(M,F){super(M);this.code=F}}e.FileSystemProviderError=C;function S(U,M){const F=new C(U.toString(),M);return a(F,M),F}e.createFileSystemProviderError=S;function o(U){return U||S((0,P.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=o;function a(U,M){return U.name=M?`${M} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=a;function t(U){if(!U)return w.Unknown;if(U instanceof C)return U.code;const M=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!M)return w.Unknown;switch(M[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof g)return U.fileOperationResult;switch(t(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(M,F,q){this.resource=M,this.operation=F,this.target=q}isOperation(M){return this.operation===M}}e.FileOperationEvent=s;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class l{constructor(M,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const q of M)switch(q.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>F)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>F)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>F)),this.deleted.set(q.resource,q);break}}contains(M,...F){return this.doContains(M,{includeChildren:!1},...F)}affects(M,...F){return this.doContains(M,{includeChildren:!0},...F)}doContains(M,F,...q){if(!M)return!1;const x=q.length>0;return!!((!x||q.includes(1))&&(this.added?.get(M)||F.includeChildren&&this.added?.findSuperstr(M))||(!x||q.includes(0))&&(this.updated?.get(M)||F.includeChildren&&this.updated?.findSuperstr(M))||(!x||q.includes(2))&&(this.deleted?.findSubstr(M)||F.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function d(U,M,F){return!U||!M||U===M||M.length>U.length?!1:(M.charAt(M.length-1)!==L.sep&&(M+=L.sep),F?(0,R.startsWithIgnoreCase)(U,M):U.indexOf(M)===0)}e.isParent=d;class g extends Error{constructor(M,F,q){super(M);this.fileOperationResult=F,this.options=q}}e.FileOperationError=g;class p extends g{constructor(M,F,q){super(M,2,q);this.stat=F}}e.NotModifiedSinceFileOperationError=p;var f;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(f=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function _(U,M){if(!M.canHandleResource(A.URI.from({scheme:U.scheme})))return new Promise(F=>{const q=M.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===U.scheme&&x.added&&(q.dispose(),F())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(M){return(0,T.isNumber)(M)||(M=0),M<z.KB?(0,P.localize)(1,null,M.toFixed(0)):M<z.MB?(0,P.localize)(2,null,(M/z.KB).toFixed(2)):M<z.GB?(0,P.localize)(3,null,(M/z.MB).toFixed(2)):M<z.TB?(0,P.localize)(4,null,(M/z.GB).toFixed(2)):(0,P.localize)(5,null,(M/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var V;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function W(U){return{maxFileSize:U===0?300*z.MB:16*z.GB,maxHeapSize:U===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=W}),define(Z[153],ee([0,1,154,49,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(m,E)=>{const i=(0,D.createHash)("md5"),v=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(v,{onData:h=>i.update(h.buffer),onError:h=>E(h),onEnd:()=>m(i.digest("base64").replace(/=+$/,""))})})}};T=he([Y(0,R.IFileService)],T),e.ChecksumService=T}),define(Z[155],ee([0,1,221,113,135,13]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(h,b){const c={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,w)=>{console.warn((0,L.localize)(1,null,I,w))}},y=(0,R.parseArgs)(h,R.OPTIONS,b?c:void 0);return y.goto&&y._.forEach(I=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),y["max-memory"]&&D(parseInt(y["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function P(h){const b=h.findIndex(c=>!/^-/.test(c));if(b>-1)return[...h.slice(0,b),...h.slice(b+1)]}function m(h){let[,...b]=h;process.env.VSCODE_DEV&&(b=P(b)||[]);const c=!v(process.env);return A(b,c)}e.parseMainProcessArgv=m;function E(h){const[,,...b]=h;return A(b,!0)}e.parseCLIProcessArgv=E;function i(h,...b){const c=h.indexOf("--");return c===-1?h.push(...b):h.splice(c,0,...b),h}e.addArg=i;function v(h){return h.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),define(Z[156],ee([0,1,41,137,29,37,11,4,30,109,155]),function(K,e,D,L,R,T,A,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function v(c,y,I){return y["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(I)&&!y["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(I)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=new Promise(async w=>{const C=new R.CancellationTokenSource,S=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),C.dispose(!0),w({})},1e4);try{const o=await b(c,C.token);w(o)}catch(o){(0,A.isPromiseCanceledError)(o)||c.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),w({})}finally{clearTimeout(S),C.dispose()}})),h)}e.resolveShellEnv=v;let h;async function b(c,y){const I=new Promise(async(w,C)=>{const S=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",S);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",o);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",r);const n=await(0,E.getSystemShell)(P.OS,r);if(c.trace("getUnixShellEnvironment#shell",n),y.isCancellationRequested)return C(A.canceled);const s=L.basename(n);let u,l;/^pwsh(-preview)?$/.test(s)?(u=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,l=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),u);const d=(0,D.spawn)(n,[...l,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});y.onCancellationRequested(()=>(d.kill(),C(A.canceled))),d.on("error",f=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(f)),w({})});const g=[];d.stdout.on("data",f=>g.push(f));const p=[];d.stderr.on("data",f=>p.push(f)),d.on("close",(f,k)=>{const O=Buffer.concat(g).toString("utf8");c.trace("getUnixShellEnvironment#raw",O);const _=Buffer.concat(p).toString("utf8");if(_.trim()&&c.trace("getUnixShellEnvironment#stderr",_),f||k)return C(new Error(`Failed to get environment (code ${f}, signal ${k})`));const z=t.exec(O),V=z?z[1]:"{}";try{const W=JSON.parse(V);S?W.ELECTRON_RUN_AS_NODE=S:delete W.ELECTRON_RUN_AS_NODE,o?W.ELECTRON_NO_ATTACH_CONSOLE=o:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",W),w(W)}catch(W){c.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(W)),C(W)}})});try{return await I}catch(w){return c.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(w)),{}}}}),define(Z[77],ee([0,1,4,7,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(m){return m.map(E=>({type:E.type,resource:L.URI.file(E.path)}))}e.toFileChanges=T;function A(m){const E=new P;for(const i of m)E.processEvent(i);return E.normalize()}e.normalizeFileChanges=A;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(E){const i=this.mapPathToChange.get(E.path);if(i){const v=i.type,h=E.type;v===1&&h===2?(this.mapPathToChange.delete(E.path),this.normalized.splice(this.normalized.indexOf(i),1)):v===2&&h===1?i.type=0:v===1&&h===0||(i.type=h)}else this.normalized.push(E),this.mapPathToChange.set(E.path,E)}normalize(){const E=[],i=[];return this.normalized.filter(v=>v.type!==2?(E.push(v),!1):!0).sort((v,h)=>v.path.length-h.path.length).filter(v=>i.some(h=>(0,R.isParent)(v.path,h,!D.isLinux))?!1:(i.push(v.path),!0)).concat(E)}}}),define(Z[157],ee([0,1,5,2,8,99,18,101,77]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends L.Disposable{constructor(v,h,b,c){super();this.path=v,this.onDidFilesChange=h,this.onLogMessage=b,this.verboseLogging=c,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(v){this.verboseLogging=v}async startWatching(){try{const{stat:v,symbolicLink:h}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(h)try{b=await(0,T.realpath)(b)}catch(c){if(this.onError(c),h.dangling)return}v.isDirectory()?this._register((0,P.watchFolder)(b,(c,y)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(y))})},c=>this.onError(c))):this._register((0,P.watchFile)(b,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(v){v.code!=="ENOENT"&&this.onError(v)}}onFileChange(v){this.fileChangesBuffer.push(v),this.verboseLogging&&this.onVerbose(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,m.normalizeFileChanges)(h);if(this.verboseLogging)for(const c of b)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(v){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${v}`})}onVerbose(v){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[T,A]of R)this.set(T,A)}set(R,T){const A=this._entries.get(R);return this._entries.set(R,T),A}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(Z[158],ee([0,1,5,11,52,148,6,78]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class E extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class i{constructor(c=new P.ServiceCollection,y=!1,I){this._activeInstantiations=new Set,this._services=c,this._strict=y,this._parent=I,this._services.set(A.IInstantiationService,this)}createChild(c){return new i(c,this._strict,this)}invokeFunction(c,...y){let I=h.traceInvocation(c),w=!1;try{return c({get:(S,o)=>{if(w)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(S,I);if(!a&&o!==A.optional)throw new Error(`[invokeFunction] unknown service '${S}'`);return a}},...y)}finally{w=!0,I.stop()}}createInstance(c,...y){let I,w;return c instanceof R.SyncDescriptor?(I=h.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(y),I)):(I=h.traceCreation(c),w=this._createInstance(c,y,I)),I.stop(),w}_createInstance(c,y=[],I){let w=A._util.getServiceDependencies(c).sort((o,a)=>o.index-a.index),C=[];for(const o of w){let a=this._getOrCreateServiceInstance(o.id,I);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`);C.push(a)}let S=w.length>0?w[0].index:y.length;if(y.length!==S){console.warn(`[createInstance] First service dependency of ${c.name} at position ${S+1} conflicts with ${y.length} static arguments`);let o=S-y.length;o>0?y=y.concat(new Array(o)):y=y.slice(0,S)}return new c(...[...y,...C])}_setServiceInstance(c,y){if(this._services.get(c)instanceof R.SyncDescriptor)this._services.set(c,y);else if(this._parent)this._parent._setServiceInstance(c,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let y=this._services.get(c);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):y}_getOrCreateServiceInstance(c,y){let I=this._getServiceInstanceOrDescriptor(c);return I instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,I,y.branch(c,!0)):(y.branch(c,!1),I)}_safeCreateAndCacheServiceInstance(c,y,I){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,y,I)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,y,I){const w=new T.Graph(o=>o.id.toString());let C=0;const S=[{id:c,desc:y,_trace:I}];for(;S.length;){const o=S.pop();if(w.lookupOrInsertNode(o),C++>1e3)throw new E(w);for(let a of A._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${c} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};w.insertEdge(o,r),S.push(r)}}}for(;;){const o=w.roots();if(o.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}w.removeNode(a)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,y,I=[],w,C){if(this._services.get(c)instanceof R.SyncDescriptor)return this._createServiceInstance(y,I,w,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,y,I,w,C);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(c,y=[],I,w){if(I){const C=new D.IdleValue(()=>this._createInstance(c,y,w));return new Proxy(Object.create(null),{get(S,o){if(o in S)return S[o];let a=C.value,t=a[o];return typeof t!="function"||(t=t.bind(a),S[o]=t),t},set(S,o,a){return C.value[o]=a,!0}})}else return this._createInstance(c,y,w)}}e.InstantiationService=i;var v;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(v||(v={}));class h{constructor(c,y){this.type=c,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return m?new h(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(c){return m?new h(0,c.name):h._None}branch(c,y){let I=new h(2,c.toString());return this._dep.push([c,y,I]),I}stop(){let c=Date.now()-this._start;h._totals+=c;let y=!1;function I(C,S){let o=[],a=new Array(C+1).join("	");for(const[t,r,n]of S._dep)if(r&&n){y=!0,o.push(`${a}CREATES -> ${t}`);let s=I(C+1,n);s&&o.push(s)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(c>2||y)&&console.log(w.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(Z[159],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(Z[160],ee([0,1,36,52,147,6]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(b,c,y){const I=y.getChannel(b);return P(c)?new c.channelClientCtor(I):D.ProxyChannel.toService(I,c?.proxyOptions)}}function P(h){return!!h?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let m=class extends A{constructor(b,c,y){super(b,c,y)}};m=he([Y(2,e.IMainProcessService)],m);function E(h,b,c){(0,R.registerSingleton)(h,new L.SyncDescriptor(m,[b,c],c?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let i=class extends A{constructor(b,c,y){super(b,c,y)}};i=he([Y(2,e.ISharedProcessService)],i);function v(h,b,c){(0,R.registerSingleton)(h,new L.SyncDescriptor(i,[b,c],c?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=v}),define(Z[57],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const T of R.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[161],ee([0,1,2,57]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=he([Y(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(Z[14],ee([0,1,37,3,2,4,6]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var m;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class E extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class i extends E{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let n=0;n<t.length;n++){let s=t[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}r+=(n>0?" ":"")+s}return r}}e.AbstractMessageLogger=i;class v extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...r){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class b extends E{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class c extends E{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const n of this.logServices)n.trace(t,...r)}debug(t,...r){for(const n of this.logServices)n.debug(t,...r)}info(t,...r){for(const n of this.logServices)n.info(t,...r)}warn(t,...r){for(const n of this.logServices)n.warn(t,...r)}error(t,...r){for(const n of this.logServices)n.error(t,...r)}critical(t,...r){for(const n of this.logServices)n.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class y extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=y;class I extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,r?.always?m.Trace:this.logLevel,r),this.loggers.set(t.toString(),n),r?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class w{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function C(a){if(a.verbose)return m.Trace;if(typeof a.logLevel=="string"){const t=S(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function S(a){switch(a){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=S;function o(a){switch(a){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=o}),define(Z[162],ee([0,1,5,11,2,8,18,12,14]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(v,h){super();this.environmentService=v,this.logService=h,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const v=(0,T.basename)(this.environmentService.logsPath),h=(0,T.dirname)(this.environmentService.logsPath),y=(await A.Promises.readdir(h)).filter(w=>/^\d{8}T\d{6}$/.test(w)).sort().filter(w=>w!==v),I=y.slice(0,Math.max(0,y.length-9));I.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${I.join(", ")}'`),await Promise.all(I.map(w=>A.Promises.rm((0,T.join)(h,w)))))}catch(v){(0,L.onUnexpectedError)(v)}}};E=he([Y(0,P.IEnvironmentService),Y(1,m.ILogService)],E),e.LogsDataCleaner=E}),define(Z[163],ee([0,1,5,11,2,8,18,12,14]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class lt extends R.Disposable{constructor(v,h,b){super();this.backupWorkspacesPath=v,this.environmentService=h,this.logService=b,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const v=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(v).emptyWorkspaceInfos.map(y=>y.backupFolder),c=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(c.map(async y=>{y.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(y)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${y}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(v){(0,L.onUnexpectedError)(v)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E=he([Y(1,P.INativeEnvironmentService),Y(2,m.ILogService)],E),e.StorageDataCleaner=E}),define(Z[164],ee([0,1,5,11,2,4,15,58,7,30,18,12,27,31,13,14]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let w=class extends R.Disposable{constructor(S,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=m.URI.file(S.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(S,o){await this.cleanUpPromise;const a=this.getName(S),t=(0,A.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(S,r,o);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",S.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,r.path),n}}return t}async delete(S){}async rename(S,o,a){try{await i.Promises.rename(S.fsPath,o.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${S} to ${o} with 'EPERM' error. Trying again...`),this.rename(S,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const S=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(S.children){const o=[],a=[];for(const n of S.children){const s=this.parse(n.name);s&&a.push([s,n])}const t=(0,b.groupByExtension)(a,([n])=>n),r=[];for(const n of t)n.sort((s,u)=>P.rcompare(s[0].version,u[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),r.push(n[0][1]);r.sort((n,s)=>n.mtime-s.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(S){this.logService.error(S)}}getName(S){return this.cache?new b.ExtensionIdentifierWithVersion(S.identifier,S.version).key().toLowerCase():(0,E.generateUuid)()}parse(S){const o=I.exec(S);return o&&o[1]&&o[2]?new b.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};w=he([Y(0,v.INativeEnvironmentService),Y(1,c.IFileService),Y(2,h.IExtensionGalleryService),Y(3,y.ILogService)],w),e.ExtensionsDownloader=w}),define(Z[165],ee([0,1,41,5,37,3,2,17,8,18,12,14]),function(K,e,D,L,R,T,A,P,m,E,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends A.Disposable{constructor(c,y){super();this.environmentService=c,this.logService=y,this.processesLimiter=new L.Limiter(5)}async postUninstall(c){const y=this.parseScript(c,"uninstall");return y&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${I}`)))),E.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(c,y){const I=`vscode:${y}`;if(c.location.scheme===P.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[I]=="string"){const w=c.manifest.scripts[I].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${I} should be a node script`),null):{script:(0,m.join)(c.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(c,y,I,w,C){return new Promise((S,o)=>{const a=this.start(c,y,I,C);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?o(n):S(void 0)};a.on("error",n=>{r((0,R.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,s)=>{r(n?`post-${y} process exited with code ${n}`:void 0)}),w&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(c,y,I,w){const C={silent:!0,execArgv:void 0},S=(0,D.fork)(c,[`--type=extension-post-${y}`,...I],C);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const o=T.Event.fromNodeEventEmitter(S.stdout,"data"),a=T.Event.fromNodeEventEmitter(S.stderr,"data");o(n=>this.logService.info(w.identifier.id,w.manifest.version,`post-${y}`,n)),a(n=>this.logService.error(w.identifier.id,w.manifest.version,`post-${y}`,n));const t=T.Event.any(T.Event.map(o,n=>({data:`%c${n}`,format:[""]})),T.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(w.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),S}getExtensionStoragePath(c){return(0,m.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};h=he([Y(0,i.IEnvironmentService),Y(1,v.ILogService)],h),e.ExtensionsLifecycle=h}),define(Z[166],ee([0,1,3,2,15,7,12,31,13,14]),function(K,e,D,L,R,T,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends L.Disposable{constructor(h,b,c,y){super();this.extensionsManagementService=h,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(S=>S.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(C=>this.onInstallExtension(C))),this._register(h.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(h.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const I=T.URI.file(c.extensionsPath),w=new R.ExtUri(C=>!b.hasCapability(C,1024));this._register(b.watch(I)),this._register(D.Event.filter(b.onDidChangeFilesRaw,C=>C.changes.some(S=>this.doesChangeAffects(S,I,w)))(()=>this.onDidChange()))}doesChangeAffects(h,b,c){return c.isEqual(c.dirname(h.resource),b)?c.isEqual(h.resource,c.joinPath(b,".obsolete"))?!0:!(h.type!==1&&h.type!==2||c.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const b of h)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(b=>!(0,P.areSameExtensions)(b,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,P.areSameExtensions)(b,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),b=h.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,P.areSameExtensions)(I,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),c=this.installedExtensions.filter(y=>this.installingExtensions.some(I=>(0,P.areSameExtensions)(I,y))?!1:h.every(I=>!(0,P.areSameExtensions)(I.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=h.map(y=>y.identifier),(b.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:c})}}};i=he([Y(1,m.IFileService),Y(2,A.INativeEnvironmentService),Y(3,E.ILogService)],i),e.ExtensionsWatcher=i}),define(Z[167],ee([0,1,154,19,5,2,17,8,18,12,27,31,57,14]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let c=class extends T.Disposable{constructor(w,C,S){super();this.extensionManagementService=w,this.logService=S,this.cache=this._register(new y(C,S)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const w=await this.cache.getLanguagePacks(),C=["en",...Object.keys(w)];return(0,L.distinct)(C)}async postInstallExtension(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",w.identifier.id),await this.update())}async postUninstallExtension(w){const C=await this.cache.getLanguagePacks();Object.keys(C).some(S=>C[S]&&C[S].extensions.some(o=>(0,v.areSameExtensions)(o.extensionIdentifier,w.identifier)))&&(this.logService.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,C]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),S=await this.cache.update(C);return!(0,L.equals)(Object.keys(w),Object.keys(S))}};c=he([Y(0,i.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,b.ILogService)],c),e.LocalizationsService=c;let y=class extends T.Disposable{constructor(w,C){super();this.logService=C,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(w.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(w){return this.withLanguagePacks(C=>{Object.keys(C).forEach(S=>delete C[S]),this.createLanguagePacksFromExtensions(C,...w)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(w,...C){for(const S of C)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(w,S);Object.keys(w).forEach(S=>this.updateHash(w[S]))}createLanguagePacksFromExtension(w,C){const S=C.identifier,o=C.manifest.contributes&&C.manifest.contributes.localizations?C.manifest.contributes.localizations:[];for(const a of o)if(C.location.scheme===A.Schemas.file&&(0,h.isValidLocalization)(a)){let t=w[a.languageId];t||(t={hash:"",extensions:[],translations:{}},w[a.languageId]=t);let r=t.extensions.filter(n=>(0,v.areSameExtensions)(n.extensionIdentifier,S))[0];r?r.version=C.manifest.version:t.extensions.push({extensionIdentifier:S,version:C.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,P.join)(C.location.fsPath,n.path)}}updateHash(w){if(w){const C=(0,D.createHash)("md5");for(const S of w.extensions)C.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);w.hash=C.digest("hex")}}withLanguagePacks(w=()=>null){return this.languagePacksFileLimiter.queue(()=>{let C=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch(o){return{}}}).then(S=>(C=w(S),S)).then(S=>{for(const a of Object.keys(S))S[a]||delete S[a];this.languagePacks=S,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>C,S=>this.logService.error(S))})}};y=he([Y(0,E.INativeEnvironmentService),Y(1,b.ILogService)],y)}),define(Z[79],ee([0,1,3,7,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(h){this.service=h,this.onDidChangeLogLevel=D.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(h,b,c){switch(b){case"setLevel":return this.service.setLevel(c)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=T;class A{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){A.setLevel(this.channel,h)}static setLevel(h,b){return h.call("setLevel",b)}}e.LogLevelChannelClient=A;class P{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,b){throw new Error(`Event not found: ${b}`)}async call(h,b,c){switch(b){case"createLogger":this.createLogger(L.URI.revive(c[0]),c[1]);return;case"log":return this.log(L.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1])}throw new Error(`Call not found: ${b}`)}createLogger(h,b){this.loggers.set(h.toString(),this.loggerService.createLogger(h,b))}consoleLog(h,b){let c=console.log;switch(h){case R.LogLevel.Error:c=console.error;break;case R.LogLevel.Warning:c=console.warn;break;case R.LogLevel.Info:c=console.info;break}c.call(console,...b)}log(h,b){const c=this.loggers.get(h.toString());if(!c)throw new Error("Create the logger before logging");for(const[y,I]of b)switch(y){case R.LogLevel.Trace:c.trace(I);break;case R.LogLevel.Debug:c.debug(I);break;case R.LogLevel.Info:c.info(I);break;case R.LogLevel.Warning:c.warn(I);break;case R.LogLevel.Error:c.error(I);break;case R.LogLevel.Critical:c.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class m extends R.AbstractLoggerService{constructor(h,b,c){super(h,b);this.channel=c}createConsoleMainLogger(){return new R.AdapterLogger({log:(h,b)=>{this.channel.call("consoleLog",[h,b])}})}doCreateLogger(h,b,c){return new E(this.channel,h,b,c)}}e.LoggerChannelClient=m;class E extends R.AbstractMessageLogger{constructor(h,b,c,y){super(y?.always);this.channel=h,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[b,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,b){const c=[[h,b]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(h){this.channel.call("log",[this.file,h])}}class i extends R.LogService{constructor(h,b){super(b);this.parent=h,this._register(h.onDidChangeLogLevel(c=>b.setLevel(c)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=i}),define(Z[59],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(Z[44],ee([0,1,17,4,35,15]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const m=K.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:m.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(Z[80],ee([0,1,25,11,123,13,44]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(v,h,b,c,y,I){let w;try{await m(v,h,b,c,y,I)}catch(C){w=C}finally{w&&y.errorTransformer&&(w=y.errorTransformer(w)),typeof w!="undefined"&&b.error(w),b.end()}}e.readFileIntoStream=P;async function m(v,h,b,c,y,I){E(I);const w=await v.open(h,{create:!1});try{E(I);let C=0,S=0,o=y&&typeof y.length=="number"?y.length:void 0,a=D.VSBuffer.alloc(Math.min(y.bufferSize,typeof o=="number"?o:y.bufferSize)),t=y&&typeof y.position=="number"?y.position:0,r=0;do S=await v.read(w,t,a.buffer,r,a.byteLength-r),t+=S,r+=S,C+=S,typeof o=="number"&&(o-=S),r===a.byteLength&&(await b.write(c(a)),a=D.VSBuffer.alloc(Math.min(y.bufferSize,typeof o=="number"?o:y.bufferSize)),r=0);while(S>0&&(typeof o!="number"||o>0)&&E(I)&&i(C,y));if(r>0){let n=r;typeof o=="number"&&(n=Math.min(r,o)),b.write(c(a.slice(0,n)))}}catch(C){throw(0,T.ensureFileSystemProviderError)(C)}finally{await v.close(w)}}function E(v){if(v.isCancellationRequested)throw(0,L.canceled)();return!0}function i(v,h){if(h?.limits){if(typeof h.limits.memory=="number"&&v>h.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null,A.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&v>h.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[168],ee([0,1,19,5,25,29,3,55,2,40,17,169,15,49,121,13,80,14]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class je extends m.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new y.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new y.FileChangesEvent(a,!0)))),this.watchedResources=E.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new m.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,m.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new y.FileOperationError((0,c.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,c.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a)||(0,y.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,y.toFileSystemProviderErrorCode)(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,c.localize)(2,null,this.resourceForError(o)),1):(0,y.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),n=a?.resolveTo,s=a?.resolveSingleChildDescendants,u=a?.resolveMetadata,l=await t.stat(o);let d;return this.toFileStat(t,o,l,void 0,!!u,(g,p)=>{if(!d&&(d=E.TernarySearchTree.forUris(()=>!r),d.set(o,!0),n))for(const f of n)d.set(f,!0);return d.get(g.resource)||d.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&s?p===1:!1})}async toFileStat(o,a,t,r,n,s){const{providerExtUri:u}=this.getExtUri(o),l={resource:a,name:u.basename(a),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&y.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,y.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&s(l,r)){try{const d=await o.readdir(a),g=await L.Promises.settled(d.map(async([p,f])=>{try{const k=u.joinPath(a,p),O=n?await o.stat(k):{type:f};return await this.toFileStat(o,k,O,d.length,n,s)}catch(k){return this.logService.trace(k),null}}));l.children=(0,D.coalesce)(g)}catch(d){this.logService.trace(d),l.children=[]}return l}return l}async resolveAll(o){return L.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new y.FileOperationError((0,c.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new y.FileOperationEvent(o,0,r)),r}async writeFile(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,n.dirname(o));let u;if((0,y.hasReadWriteCapability)(r)&&!(a instanceof R.VSBuffer))if((0,b.isReadableStream)(a)){const l=await(0,b.peekStream)(a,3);l.ended?u=R.VSBuffer.concat(l.buffer):u=l}else u=(0,b.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else u=a;!(0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r)&&u instanceof R.VSBuffer?await this.doWriteUnbuffered(r,o,t,u):await this.doWriteBuffered(r,o,t,u instanceof R.VSBuffer?(0,R.bufferToReadable)(u):u)}catch(s){throw new y.FileOperationError((0,c.localize)(4,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,c.localize)(5,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch(s){return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,c.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,y.etag)({mtime:t.mtime,size:n.size}))throw new y.FileOperationError((0,c.localize)(7,null),3,t);return n}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((r,n)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,a,t);r(s)}catch(s){n(s)}})})}async doReadFile(o,a,t){const r=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const r=new T.CancellationTokenSource,n=this.validateReadFile(a,t).then(u=>u,u=>{throw r.cancel(),u});let s;try{return typeof t?.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await n,!((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasFileReadStreamCapability)(o))||(0,y.hasReadWriteCapability)(o)&&t?.preferUnbuffered?s=this.readFileUnbuffered(o,a,t):(0,y.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,a,r.token,t):s=this.readFileBuffered(o,a,r.token,t),{...await n,value:s}}catch(u){s&&await(0,b.consumeStream)(s);const l=(0,c.localize)(8,null,this.resourceForError(a),(0,y.ensureFileSystemProviderError)(u).toString());throw u instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(l,u.stat,t):new y.FileOperationError(l,(0,y.toFileOperationResult)(u),t)}}readFileStreamed(o,a,t,r=Object.create(null)){const n=o.readFileStream(a,r,t);return(0,b.transform)(n,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,c.localize)(9,null,this.resourceForError(a),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)},s=>R.VSBuffer.concat(s))}readFileBuffered(o,a,t,r=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,I.readFileIntoStream)(o,a,n,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,c.localize)(10,null,this.resourceForError(a),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)},t),n}readFileUnbuffered(o,a,t){const r=(0,b.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),r.end(R.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError((0,c.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==y.ETAG_DISABLED&&a.etag===t.etag)throw new y.NotModifiedSinceFileOperationError((0,c.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new y.FileOperationError((0,c.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,r){if(o.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,o,s,a,t,r)}catch(n){return n}return!0}async move(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,n,a,"move",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,s==="move"?2:3,u)),u}async copy(o,a,t){const r=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,n,a,"copy",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,s==="copy"?3:2,u)),u}async doMoveCopy(o,a,t,r,n,s){if(a.toString()===r.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,a,t,r,n,s);if(u&&!l&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),n==="copy"){if(o===t&&(0,y.hasFileFolderCopyCapability)(o))await o.copy(a,r,{overwrite:s});else{const d=await this.resolve(a);d.isDirectory?await this.doCopyFolder(o,d,t,r):await this.doCopyFile(o,a,t,r)}return n}else return o===t?(await o.rename(a,r,{overwrite:s}),n):(await this.doMoveCopy(o,a,t,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,r){if((0,y.hasOpenReadWriteCloseCapability)(o)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,r);if((0,y.hasOpenReadWriteCloseCapability)(o)&&(0,y.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,r);if((0,y.hasReadWriteCapability)(o)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,r);if((0,y.hasReadWriteCapability)(o)&&(0,y.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,r)}async doCopyFolder(o,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async n=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),t,s):this.doCopyFile(o,n.resource,t,s)}))}async doValidateMoveCopy(o,a,t,r,n,s){let u=!1;if(o===t){const{providerExtUri:d,isPathCaseSensitive:g}=this.getExtUri(o);if(g||(u=d.isEqual(a,r)),u&&n==="copy")throw new Error((0,c.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!u&&d.isEqualOrParent(r,a))throw new Error((0,c.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!u){if(!s)throw new y.FileOperationError((0,c.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===t){const{providerExtUri:d}=this.getExtUri(o);if(d.isEqualOrParent(a,r))throw new Error((0,c.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:u}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&y.FileType.Directory)==0)throw new Error((0,c.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(r.basename(a)),a=r.dirname(a)}for(let n=t.length-1;n>=0;n--){a=r.joinPath(a,t[n]);try{await o.mkdir(a)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,c.localize)(19,null,this.resourceForError(o)));let n;try{n=await t.stat(o)}catch(u){}if(n)this.throwIfFileIsReadonly(o,n);else throw new y.FileOperationError((0,c.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const u=await this.resolve(o);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,c.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),r=!!a?.useTrash,n=!!a?.recursive;await t.delete(o,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new y.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,r;{for(const n of o)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(r||(r=[]),r.push(n));t&&this._onDidFilesChange.fire(new y.FileChangesEvent(t,!a))}if(r){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(r)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new m.DisposableStore;{let r=!1,n=()=>{r=!0};t.add((0,m.toDisposable)(()=>n())),this.doWatch(o,a).then(s=>{r?(0,m.dispose)(s):n=()=>(0,m.dispose)(s)},s=>this.logService.error(s))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,m.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),r=this.toWatchKey(t,o,a),n=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,n),n.count+=1,(0,m.toDisposable)(()=>{n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,a,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,b.isReadableStream)(r)||(0,b.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,n,r):await this.doWriteReadableBufferedQueued(o,n,r)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,a,t){let r=0,n;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(s,u)=>{(0,b.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(o,a,l,l.byteLength,r,0)}catch(d){return u(d)}r+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>u(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,a,t){let r=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(o,a,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(o,a,t,r,n,s){let u=0;for(;u<r;)u+=await o.write(a,n+u,t.buffer,s+u,r-u)}async doWriteUnbuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,r))}async doWriteUnbufferedQueued(o,a,t,r){let n;r instanceof R.VSBuffer?n=r:(0,b.isReadableStream)(r)?n=await(0,R.streamToBuffer)(r):(0,b.isReadableBufferedStream)(r)?n=await(0,R.bufferedStreamToBuffer)(r):n=(0,R.readableToBuffer)(r),await o.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,r))}async doPipeBufferedQueued(o,a,t,r){let n,s;try{n=await o.open(a,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const u=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,d=0,g=0;do g=await o.read(n,l,u.buffer,d,u.byteLength-d),await this.doWriteBuffer(t,s,u,g,l,d),l+=g,d+=g,d===u.byteLength&&(d=0);while(g>0)}catch(u){throw(0,y.ensureFileSystemProviderError)(u)}finally{await L.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,r))}async doPipeUnbufferedQueued(o,a,t,r){return t.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,r))}async doPipeUnbufferedToBufferedQueued(o,a,t,r){const n=await t.open(r,{create:!0,unlock:!1});try{const s=await o.readFile(a);await this.doWriteBuffer(t,n,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(o,a,t,r){const n=await(0,R.streamToBuffer)(this.readFileBuffered(o,a,T.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,n)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new y.FileOperationError((0,c.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,c.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};C.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},C=he([Y(0,w.ILogService)],C),e.FileService=C}),define(Z[170],ee([0,1,19,5,25,3,39,2,8,4,15,49,18,124,13,80,157,143,144,77,146,14]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends P.Disposable{constructor(n,s){super();this.logService=n,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:u}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async l=>{try{let d;l.isSymbolicLink()?d=(await this.stat((0,i.joinPath)(n,l.name))).type:d=this.toType(l),u.push([l.name,d])}catch(d){this.logService.trace(d)}})),u}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let u;return s?.dangling?u=c.FileType.Unknown:n.isFile()?u=c.FileType.File:n.isDirectory()?u=c.FileType.Directory:u=c.FileType.Unknown,s&&(u|=c.FileType.SymbolicLink),u}async readFile(n){try{const s=this.toFilePath(n);return await h.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,u){const l=(0,v.newWriteableStream)(d=>R.VSBuffer.concat(d.map(g=>R.VSBuffer.wrap(g))).buffer);return(0,y.readFileIntoStream)(this,n,l,d=>d.buffer,{...s,bufferSize:this.BUFFER_SIZE},u),l}async writeFile(n,s,u){let l;try{const d=this.toFilePath(n);if(!u.create||!u.overwrite){if(await h.Promises.exists(d)){if(!u.overwrite)throw(0,c.createFileSystemProviderError)((0,b.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,c.createFileSystemProviderError)((0,b.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(n,{create:!0,unlock:u.unlock}),await this.write(l,0,s,0,s.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(n,d)}finally{typeof l=="number"&&await this.close(l)}}async open(n,s){try{const u=this.toFilePath(n);if((0,c.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:g}=await h.SymlinkSupport.stat(u);g.mode&128||await h.Promises.chmod(u,g.mode|128)}catch(g){this.logService.trace(g)}let l;if((0,c.isFileOpenForWriteOptions)(s)){if(E.isWindows)try{await h.Promises.truncate(u,0),l="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}l||(l="w")}else l="r";const d=await h.Promises.open(u,l);return this.mapHandleToPos.set(d,0),(0,c.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(d,n),d}catch(u){throw(0,c.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await h.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await h.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,u,l,d){const g=this.normalizePos(n,s);let p=null;try{const f=await h.Promises.read(n,u,l,d,g);return typeof f=="number"?p=f:p=f.bytesRead,p}catch(f){throw this.toFileSystemProviderError(f)}finally{this.updatePos(n,g,p)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,u){const l=this.mapHandleToPos.get(n);typeof l=="number"&&(typeof s=="number"||(typeof u=="number"?this.mapHandleToPos.set(n,l+u):this.mapHandleToPos.delete(n)))}async write(n,s,u,l,d){return(0,L.retry)(()=>this.doWrite(n,s,u,l,d),100,3)}async doWrite(n,s,u,l,d){const g=this.normalizePos(n,s);let p=null;try{const f=await h.Promises.write(n,u,l,d,g);return typeof f=="number"?p=f:p=f.bytesWritten,p}catch(f){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),f)}finally{this.updatePos(n,g,p)}}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const u=this.toFilePath(n);await this.doDelete(u,s)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(n,s){s.recursive?await h.Promises.rm(n,h.RimRafMode.MOVE):await h.Promises.unlink(n)}async rename(n,s,u){const l=this.toFilePath(n),d=this.toFilePath(s);if(l!==d)try{await this.validateTargetDeleted(n,s,"move",u.overwrite),await h.Promises.move(l,d)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,b.localize)(2,null,(0,m.basename)(l),(0,m.basename)((0,m.dirname)(d)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(n,s,u){const l=this.toFilePath(n),d=this.toFilePath(s);if(l!==d)try{await this.validateTargetDeleted(n,s,"copy",u.overwrite),await h.Promises.copy(l,d,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,b.localize)(3,null,(0,m.basename)(l),(0,m.basename)((0,m.dirname)(d)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(n,s,u,l){const d=this.toFilePath(n),g=this.toFilePath(s);let p=!1;if(!!(this.capabilities&1024)||(p=(0,A.isEqual)(d,g,!0)),p&&u==="copy")throw(0,c.createFileSystemProviderError)((0,b.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!p&&await h.Promises.exists(g)){if(!l)throw(0,c.createFileSystemProviderError)((0,b.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const u={path:this.toFilePath(n),excludes:s},l=(0,D.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{l(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof w.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,s;this.options?.watcher?.usePolling?(n=C.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?E.isWindows?n=o.FileWatcher:n=C.FileWatcher:n=w.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,S.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===a.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new I.FileWatcher(this.toFilePath(n),l=>this._onDidChangeFile.fire((0,S.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(s,u)}toFilePath(n){return(0,m.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof c.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=c.FileSystemProviderErrorCode.NoPermissions;break;default:s=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(n,s)}async toFileSystemProviderWriteError(n,s){let u=this.toFileSystemProviderError(s);if(n&&u.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await h.SymlinkSupport.stat(this.toFilePath(n));l.mode&128||(u=(0,c.createFileSystemProviderError)(s,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return u}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[28],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(Z[171],ee([0,1,5,11,2,8,18,14,28]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(v,h,b){super();this.productService=h,this.logService=b,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,v&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(v)},30*1e3)).schedule()}async cleanUpCodeCaches(v){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),b=(0,T.dirname)(v),c=(0,T.basename)(v),y=await A.Promises.readdir(b);await Promise.all(y.map(async I=>{if(I===c)return;const w=(0,T.join)(b,I),C=await A.Promises.stat(w);if(C.isDirectory()&&h-C.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${I}.`),A.Promises.rm(w)}))}catch(h){(0,L.onUnexpectedError)(h)}}};E=he([Y(1,m.IProductService),Y(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(Z[172],ee([0,1,5,11,2,8,18,12,14,28]),function(K,e,D,L,R,T,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(h,b,c){super();this.environmentService=h,this.logService=b,this.productService=c,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),b=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let C of Object.keys(b)){const S=b[C];h[`${S.hash}.${C}`]=!0}const c=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(c))return;const I=await A.Promises.readdir(c);for(const C of I){if(h[C]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${C}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${C}`),await A.Promises.rm((0,T.join)(c,C))}const w=Date.now();for(const C of Object.keys(h)){const S=(0,T.join)(c,C),o=await A.Promises.readdir(S);for(const a of o){if(a==="tcf.json")continue;const t=(0,T.join)(S,a),r=await A.Promises.stat(t);r.isDirectory()&&w-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(C,a)}`),await A.Promises.rm(t))}}}catch(h){(0,L.onUnexpectedError)(h)}}};i=he([Y(0,P.INativeEnvironmentService),Y(1,m.ILogService),Y(2,E.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(Z[32],ee([0,1,90,16]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(A,P){D.ok(L.isString(A)),D.ok(L.isObject(P)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new R}),define(Z[81],ee([0,1,3,32]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,E){this.schemasById[R(m)]=E,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;L.Registry.add(e.Extensions.JSONContribution,A)}),define(Z[38],ee([0,1,3,16,111,81,32]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=A.Registry.as(T.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,S=!0){this.registerConfigurations([C],S)}registerConfigurations(C,S=!0){const o=[];C.forEach(a=>{o.push(...this.validateAndRegisterProperties(a,S,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(C){const S=[],o=a=>{if(a.properties)for(const t in a.properties)S.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,a.properties[t]);a.allOf&&a.allOf.forEach(t=>o(t))};for(const a of C){o(a);const t=this.configurationContributors.indexOf(a);t!==-1&&this.configurationContributors.splice(t,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(C){const S=[],o=[];for(const a of C)for(const t in a)if(S.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...a[t]};const r={type:"object",default:this.defaultValues[t],description:R.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(h(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=a[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(C){const S=[];for(const o of C)for(const a in o)if(S.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const S of C)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,S=!0,o,a=3){a=L.isUndefinedOrNull(C.scope)?a:C.scope;let t=[],r=C.properties;if(r)for(let s in r){if(S&&y(s)){delete r[s];continue}const u=r[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=L.isUndefinedOrNull(u.scope)?a:u.scope,u.restricted=L.isUndefinedOrNull(u.restricted)?!!o?.restrictedConfigurations?.includes(s):u.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let n=C.allOf;if(n)for(let s of n)t.push(...this.validateAndRegisterProperties(s,S,o,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const S=o=>{let a=o.properties;if(a)for(const r in a)this.updateSchema(r,a[r]);let t=o.allOf;t&&t.forEach(S)};S(C)}updateSchema(C,S){switch(e.allSettings.properties[C]=S,S.scope){case 1:e.applicationSettings.properties[C]=S;break;case 2:e.machineSettings.properties[C]=S;break;case 6:e.machineOverridableSettings.properties[C]=S;break;case 3:e.windowSettings.properties[C]=S;break;case 4:e.resourceSettings.properties[C]=S;break;case 5:e.resourceSettings.properties[C]=S,this.resourceLanguageSettingsSchema.properties[C]=S;break}}removeFromSchema(C,S){switch(delete e.allSettings.properties[C],S.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const S=`[${C}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,o),e.allSettings.properties[S]=o,e.applicationSettings.properties[S]=o,e.machineSettings.properties[S]=o,e.machineOverridableSettings.properties[S]=o,e.windowSettings.properties[S]=o,e.resourceSettings.properties[S]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,S){let o=this.defaultValues[C];L.isUndefined(o)&&(o=S.default),L.isUndefined(o)&&(o=b(S.type)),S.default=o}}const v="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(v);function h(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=h;function b(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const c=new i;A.Registry.add(e.Extensions.Configuration,c);function y(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?R.localize(5,null,w):c.getConfigurationProperties()[w]!==void 0?R.localize(6,null,w):null:R.localize(4,null)}e.validateProperty=y;function I(){const w=[],C=c.getConfigurationProperties();for(const S of Object.keys(C))w.push([S,C[S].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=I}),define(Z[24],ee([0,1,26,16,7,38,6,32]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function m(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=m;var E;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function v(r,n){const s=n?r?n.keys.filter(k=>r.keys.indexOf(k)===-1):[...n.keys]:[],u=r?n?r.keys.filter(k=>n.keys.indexOf(k)===-1):[...r.keys]:[],l=[];if(n&&r){for(const k of r.keys)if(n.keys.indexOf(k)!==-1){const O=w(r.contents,k),_=w(n.contents,k);D.equals(O,_)||l.push(k)}}const d=[],g=k=>{const O={};for(const _ of k)for(const z of _.identifiers)O[a(z)]=_;return O},p=n?g(n.overrides):{},f=r?g(r.overrides):{};if(Object.keys(p).length)for(const k of s){const O=p[k];O&&d.push([(0,T.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(f).length)for(const k of u){const O=f[k];O&&d.push([(0,T.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(p).length&&Object.keys(f).length)for(const k of l){const O=f[k],_=p[k];if(O&&_){const z=v({contents:O.contents,keys:O.keys,overrides:[]},{contents:_.contents,keys:_.keys,overrides:[]});d.push([(0,T.overrideIdentifierFromKey)(k),[...z.added,...z.removed,...z.updated]])}}return{added:s,removed:u,updated:l,overrides:d}}e.compare=v;function h(r,n){const s=[];for(const u of Object.keys(r))if(T.OVERRIDE_PROPERTY_PATTERN.test(u)){const l={};for(const d in r[u])l[d]=r[u][d];s.push({identifiers:[(0,T.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(l),contents:b(l,n)})}return s}e.toOverrides=h;function b(r,n){const s=Object.create(null);for(let u in r)c(s,u,r[u],n);return s}e.toValuesTree=b;function c(r,n,s,u){const l=n.split("."),d=l.pop();let g=r;for(let p=0;p<l.length;p++){let f=l[p],k=g[f];switch(typeof k){case"undefined":k=g[f]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${l.slice(0,p+1).join(".")} is ${JSON.stringify(k)}`);return}g=k}if(typeof g=="object"&&g!==null)try{g[d]=s}catch(p){u(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(g)}`)}else u(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=c;function y(r,n){const s=n.split(".");I(r,s)}e.removeFromValueTree=y;function I(r,n){const s=n.shift();if(n.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const u=r[s];typeof u=="object"&&!Array.isArray(u)&&(I(u,n),Object.keys(u).length===0&&delete r[s])}}function w(r,n,s){function u(g,p){let f=g;for(const k of p){if(typeof f!="object"||f===null)return;f=f[k]}return f}const l=n.split("."),d=u(r,l);return typeof d=="undefined"?s:d}e.getConfigurationValue=w;function C(r,n,s){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(n[u])?C(r[u],n[u],s):s&&(r[u]=n[u]):r[u]=n[u])})}e.merge=C;function S(){const r=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=S;function o(){const r=Object.create(null),n=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let s in n){let u=n[s].default;c(r,s,u,l=>console.error(`Conflict in default settings: ${l}`))}return r}e.getDefaultValues=o;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,n,s){const u=r.inspect(n),l=r.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[173],ee([0,1,19,3,33,2,40,26,16,7,24,38,32]),function(K,e,D,L,R,T,A,P,m,E,i,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},r=[],n=[]){this._contents=t,this._keys=r,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const n=this.getContentsForOverrideIdentifer(r);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let n={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[s],l=r[s];l&&(typeof u=="object"&&typeof l=="object"?(u=P.deepClone(u),this.mergeContents(u,l)):u=l),n[s]=u}return new b(n,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),n=P.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const l of u.overrides){const[d]=n.filter(g=>D.equals(g.identifiers,l.identifiers));d?this.mergeContents(d.contents,l.contents):n.push(P.deepClone(l))}for(const l of u.keys)s.indexOf(l)===-1&&s.push(l)}return new b(r,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const n of Object.keys(r)){if(n in t&&m.isObject(t[n])&&m.isObject(r[n])){this.mergeContents(t[n],r[n]);continue}t[n]=P.deepClone(r[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let n=0;n<r;n++)t.indexOf(this.keys[n])===0&&(r=n);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=b;class c extends b{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),n=[];for(const s of Object.keys(t))v.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,v.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,i.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,n)}}e.DefaultConfigurationModel=c;class y{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!m.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:n,keys:s,overrides:u,restricted:l}=this.doParseRaw(t,r);this._configurationModel=new b(n,s,u),this._restrictedConfigurations=l||[]}doParseContent(t){let r={},n=null,s=[],u=[],l=[];function d(p){Array.isArray(s)?s.push(p):n!==null&&(s[n]=p)}let g={onObjectBegin:()=>{let p={};d(p),u.push(s),s=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let p=[];d(p),u.push(s),s=p,n=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:d,onError:(p,f,k)=>{l.push({error:p,offset:f,length:k})}};if(t)try{R.visit(t,g),r=s[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return r}doParseRaw(t,r){const n=h.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,n,!0,r);t=s.raw;const u=(0,i.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),l=Object.keys(t),d=(0,i.toOverrides)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:u,keys:l,overrides:d,restricted:s.restricted}}filter(t,r,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const u={},l=[];for(let d in t)if(v.OVERRIDE_PROPERTY_PATTERN.test(d)&&n){const g=this.filter(t[d],r,!1,s);u[d]=g.raw,l.push(...g.restricted)}else{const g=r[d],p=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&l.push(d),(p===void 0||s.scopes===void 0||s.scopes.includes(p))&&(s.skipRestricted&&g?.restricted||(u[d]=t[d]))}return{raw:u,restricted:l}}}e.ConfigurationModelParser=y;class I extends T.Disposable{constructor(t,r,n,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class w{constructor(t,r,n=new b,s=new b,u=new A.ResourceMap,l=new b,d=new A.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=l,this._memoryConfigurationByResource=d,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,n){return this.getConsolidateConfigurationModel(r,n).getValue(t)}updateValue(t,r,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new b,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,n){const s=this.getConsolidateConfigurationModel(r,n),u=this.getFolderConfigurationModelForResource(r.resource,n),l=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=n?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,_=r.overrideIdentifier?l.override(r.overrideIdentifier).getValue(t):l.getValue(t),z=s.getValue(t),V=D.distinct(D.flatten(s.overrides.map(W=>W.identifiers))).filter(W=>s.getOverrideValue(t,W)!==void 0);return{defaultValue:d,userValue:g,userLocalValue:p,userRemoteValue:f,workspaceValue:k,workspaceFolderValue:O,memoryValue:_,value:z,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:_!==void 0?{value:l.getValue(t),override:r.overrideIdentifier?l.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const n=r.filter(s=>v.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,v.overrideIdentifierFromKey)(s),l=this._defaultConfiguration.getKeysForOverrideIdentifier(u),d=t.getKeysForOverrideIdentifier(u),g=[...d.filter(p=>l.indexOf(p)===-1),...l.filter(p=>d.indexOf(p)===-1),...l.filter(p=>!P.equals(this._defaultConfiguration.override(u).getValue(p),t.override(u).getValue(p)))];return[u,g]});return this.updateDefaultConfiguration(t),{keys:r,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:n,removed:s,overrides:u}=(0,i.compare)(this.localUserConfiguration,t),l=[...r,...n,...s];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:n,removed:s,overrides:u}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...r,...n,...s];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:n,removed:s,overrides:u}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...r,...n,...s];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const n=this.folderConfigurations.get(t),{added:s,updated:u,removed:l,overrides:d}=(0,i.compare)(n,r);let g=[...s,...u,...l];return(g.length||!n)&&this.updateFolderConfiguration(t,r),{keys:g,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:s,removed:u,overrides:l}=(0,i.compare)(r,void 0);return{keys:[...n,...s,...u],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let n=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},r){let n=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const u=this._memoryConfigurationByResource.get(t);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=n.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=n}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const n=r.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:n,overrides:s,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:n,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((l,d)=>(l.set(E.URI.revive(d[0]),this.parseConfigurationModel(d[1])),l),new A.ResourceMap);return new w(r,n,new b,s,u,new b,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function C(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const s of a)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,l])=>{const d=(0,A.getOrSet)(r,u,new Set);l.forEach(g=>d.add(g))});const n=[];return r.forEach((s,u)=>n.push([u,[...s.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=C;class S{constructor(t,r,n,s){this.change=t,this.previous=r,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(d=>u.add(d)),t.overrides.forEach(([,d])=>d.forEach(g=>u.add(g))),this.affectedKeys=[...u.values()];const l=new b;this.affectedKeys.forEach(d=>l.setValue(d,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let n=(0,i.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(t=t[s],!t)return!1;n=n[s]}return!0}}e.ConfigurationChangeEvent=S;class o extends S{constructor(t,r,n,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=n,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[174],ee([0,1,5,3,2,15,24,173,38,32]),function(K,e,D,L,R,T,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(h,b){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,b)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,b){const c=typeof h=="string"?h:void 0,y=(0,A.isConfigurationOverrides)(h)?h:(0,A.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(c,y,void 0)}updateValue(h,b,c,y){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const b=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(c,b,1)}onDidDefaultConfigurationChange(h){const b=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,h);this.trigger(c,b,6)}trigger(h,b,c){const y=new P.ConfigurationChangeEvent(h,{data:b},this.configuration);y.source=c,y.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[175],ee([0,1,105,24,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,m){this.configurationService=P,this.logService=m}request(P,m){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,m)}async resolveProxy(P){}};T=he([Y(0,L.IConfigurationService),Y(1,R.ILogService)],T),e.RequestService=T}),define(Z[42],ee([0,1,25,125,38,6,32]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.isSuccess=P;function m(c){return c.res.statusCode===204}async function E(c){if(!P(c))throw new Error("Server returned "+c.res.statusCode);return m(c)?null:(await(0,D.streamToBuffer)(c.stream)).toString()}e.asText=E;async function i(c){if(!P(c))throw new Error("Server returned "+c.res.statusCode);if(m(c))return null;const I=(await(0,D.streamToBuffer)(c.stream)).toString();try{return JSON.parse(I)}catch(w){throw w.message+=`:
`+I,w}}e.asJson=i;function v(c){b(c)}e.updateProxyConfigurationsScope=v;let h;function b(c){const y=A.Registry.as(R.Extensions.Configuration);h&&y.deregisterConfigurations([h]),h={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},y.registerConfiguration(h)}b(2)}),define(Z[176],ee([0,1,29,17,13,42]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(m,E){this.requestService=m,this.fileService=E}async download(m,E,i=D.CancellationToken.None){if(m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(m,E);return}const v={type:"GET",url:m.toString()},h=await this.requestService.request(v,i);if(h.res.statusCode===200)await this.fileService.writeFile(E,h.stream);else{const b=await(0,T.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${b}`)}}};A=he([Y(0,T.IRequestService),Y(1,R.IFileService)],A),e.DownloadService=A}),define(Z[177],ee([0,1,19,29,63,2,15,139,13,14,28,42]),function(K,e,D,L,R,T,A,P,m,E,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let h=class extends T.Disposable{constructor(c,y,I,w){super();this.fileService=c,this.productService=y,this.requestService=I,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:C})=>this.allConfigBasedTips.set(C.configPath,C))}getConfigBasedTips(c){return this.getValidConfigBasedTips(c)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(c){const y=[];for(const[I,w]of this.allConfigBasedTips)try{const C=await this.fileService.readFile((0,A.joinPath)(c,I)),S=new Map;(0,R.forEach)(w.recommendations,({key:a,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const r of t.remotes)S.set(r,{extensionId:a,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else y.push({extensionId:a,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,P.getDomainsOfRemotes)(C.value.toString(),[...S.keys()]);for(const a of o){const t=S.get(a);t&&y.push(t)}}catch(C){}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const c=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(c.res.statusCode!==200)return[];const y=await(0,v.asJson)(c);return y?y.workspaceRecommendations||[]:[]}catch(c){return this.logService.error(c),[]}}};h=he([Y(0,m.IFileService),Y(1,i.IProductService),Y(2,v.IRequestService),Y(3,E.ILogService)],h),e.ExtensionTipsService=h}),define(Z[45],ee([0,1,25,30]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,A,P){let m=P&&P.get("storage.serviceMachineId",0)||null;if(m)return m;try{const i=(await A.readFile(T.serviceMachineIdResource)).value.toString();m=(0,L.isUUID)(i)?i:null}catch(E){m=null}if(!m){m=(0,L.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(m))}catch(E){}}return P&&P.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=R}),define(Z[20],ee([0,1,5,3,2,16,70,6]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var E;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var v;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));class h extends R.Disposable{constructor(I={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,w){w===m?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:w,target:this.getKeyTargets(I)[w]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,w,C){return this.getStorage(w)?.get(I,C)}getBoolean(I,w,C){return this.getStorage(w)?.getBoolean(I,C)}getNumber(I,w,C){return this.getStorage(w)?.getNumber(I,C)}store(I,w,C,S){if((0,T.isUndefinedOrNull)(w)){this.remove(I,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,C,S),this.getStorage(C)?.set(I,w)})}remove(I,w){this.withPausedEmitters(()=>{this.updateKeyTarget(I,w,void 0),this.getStorage(w)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,w){const C=[],S=this.getKeyTargets(I);for(const o of Object.keys(S))S[o]===w&&C.push(o);return C}updateKeyTarget(I,w,C){const S=this.getKeyTargets(w);typeof C=="number"?S[I]!==C&&(S[I]=C,this.getStorage(w)?.set(m,JSON.stringify(S))):typeof S[I]=="number"&&(delete S[I],this.getStorage(w)?.set(m,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const w=this.get(m,I);if(w)try{return JSON.parse(w)}catch(C){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=E.NONE){this._onWillSaveState.fire({reason:I}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return c(I,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends h{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=b;async function c(y,I,w,C){const S=u=>{try{return JSON.parse(u)}catch(l){return u}},o=new Map,a=new Map;y.forEach((u,l)=>{o.set(l,u),a.set(l,S(u))});const t=new Map,r=new Map;I.forEach((u,l)=>{t.set(l,u),r.set(l,S(u))}),console.group(`Storage: Global (path: ${w})`);let n=[];o.forEach((u,l)=>{n.push({key:l,value:u})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${C})`);let s=[];t.forEach((u,l)=>{s.push({key:l,value:u})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=c}),define(Z[178],ee([0,1,3,2,16,27,31,20]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends L.Disposable{constructor(v){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(v)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"})))}async enableExtension(v,h){return this._removeFromDisabledExtensions(v)?(this._onDidChangeEnablement.fire({extensions:[v],source:h}),!0):!1}async disableExtension(v,h){return this._addToDisabledExtensions(v)?(this._onDidChangeEnablement.fire({extensions:[v],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(v){let h=this.getDisabledExtensions();return h.every(b=>!(0,A.areSameExtensions)(b,v))?(h.push(v),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(v){let h=this.getDisabledExtensions();for(let b=0;b<h.length;b++){const c=h[b];if((0,A.areSameExtensions)(c,v))return h.splice(b,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(v){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,v)}_getExtensions(v){return this.storageManger.get(v,0)}_setExtensions(v,h){this.storageManger.set(v,h,0)}};m=he([Y(0,P.IStorageService)],m),e.GlobalExtensionEnablementService=m;class E extends L.Disposable{constructor(v){super();this.storageService=v,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(v.onDidChangeValue(h=>this.onDidStorageChange(h)))}get(v,h){let b;return h===0?((0,R.isUndefinedOrNull)(this.storage[v])&&(this.storage[v]=this._get(v,h)),b=this.storage[v]):b=this._get(v,h),JSON.parse(b)}set(v,h,b){let c=JSON.stringify(h.map(({id:I,uuid:w})=>({id:I,uuid:w})));this._get(v,b)!==c&&(b===0&&(h.length?this.storage[v]=c:delete this.storage[v]),this._set(v,h.length?c:void 0,b))}onDidStorageChange(v){if(v.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[v.key])&&this._get(v.key,v.scope)!==this.storage[v.key]){const b=this.get(v.key,v.scope);delete this.storage[v.key];const c=this.get(v.key,v.scope),y=b.filter(w=>!c.some(C=>(0,A.areSameExtensions)(w,C))),I=c.filter(w=>!b.some(C=>(0,A.areSameExtensions)(C,w)));(y.length||I.length)&&this._onDidChange.fire([...y,...I])}}_get(v,h){return this.storageService.get(v,h,"[]")}_set(v,h,b){h?this.storageService.store(v,h,b,1):this.storageService.remove(v,b)}}e.StorageManager=E}),define(Z[179],ee([0,1,3,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(E,i){super();this.channel=E,this.workspace=i}async getItems(){const E={workspace:this.workspace},i=await this.channel.call("getItems",E);return new Map(i)}updateItems(E){const i={workspace:this.workspace};return E.insert&&(i.insert=Array.from(E.insert.entries())),E.delete&&(i.delete=Array.from(E.delete.values())),this.channel.call("updateItems",i)}}class T extends R{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class A extends R{constructor(E,i){super(E,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class P extends L.Disposable{constructor(E,i){super();this.channel=E,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[180],ee([0,1,5,2,169,15,70,20,179]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends P.AbstractStorageService{constructor(v,h,b){super();this.mainProcessService=h,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(v)}createGlobalStorage(){const v=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),h=new A.Storage(v.globalStorage);return this._register(h.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),h}createWorkspaceStorage(v){const h=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),v);if(h.workspaceStorage){const b=new A.Storage(h.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(c=>this.emitDidChangeValue(1,c)),this.workspaceStorageId=v?.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(v){const h=this.workspaceStorage,b=h?.items??new Map;h&&(await h.close(),h.dispose()),this.workspaceStorage=this.createWorkspaceStorage(v),await this.workspaceStorage.init();for(const[c,y]of b)this.workspaceStorage.set(c,y)}}e.NativeStorageService=E}),define(Z[181],ee([0,1,4,35,7,30]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,i,v,h,b,c,y,I,w,C){const S=Object.create(null);S["common.machineId"]=y,S.sessionID=(0,T.generateUuid)()+Date.now(),S.commitHash=b,S.version=c,S["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,D.PlatformToString)(D.platform),S["common.nodePlatform"]=L.platform,S["common.nodeArch"]=h,S["common.product"]=C||"desktop";const o=m(I||[]);o&&(S["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(S["common.snap"]="true");const r=A(v);r&&(S["common.platformDetail"]=r);try{const n=await E.readFile(R.URI.file(w));S["common.source"]=n.value.toString().slice(0,30)}catch(n){}return S}e.resolveCommonProperties=P;function m(E){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const v=i.toLowerCase();return E.some(h=>v===h)}e.verifyMicrosoftInternalDomain=m}),define(Z[21],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[182],ee([0,1,34,55,33,17,8,4,7,98,18,100,73,13,28,21]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,s=new Map,u=2e4;function l(p,f,k,O){const _=f.substring(p.length+1);return new Promise(async z=>{let V;try{V=await i.Promises.readdir(f,{withFileTypes:!0})}catch(M){z();return}if(O.count>=u){O.count+=V.length,O.maxReached=!0,z();return}let W=V.length;if(W===0){z();return}let U=V;O.count+V.length>u&&(O.maxReached=!0,W=u-O.count,U=V.slice(0,W)),O.count+=V.length;for(const M of U)if(M.isDirectory()){if(k.includes(M.name)||await l(p,(0,A.join)(f,M.name),k,O),--W==0){z();return}}else{const F=M.name.lastIndexOf(".");if(F>=0){const q=M.name.substring(F+1);q&&n.set(q,(n.get(q)??0)+1)}for(const q of r)q.relativePathPattern?.test(_)!==!1&&q.filePattern.test(M.name)&&s.set(q.tag,(s.get(q.tag)??0)+1);if(--W==0){z();return}}})}const d={count:0,maxReached:!1};await l(a,a,t,d);const g=await S(a);return{configFiles:w(s),fileTypes:w(n),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:g}}e.collectWorkspaceStats=I;function w(a){return[...L.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function C(){const a={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=C;async function S(a){try{const t=new Map,r=(0,A.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(r),s=[],u=(0,R.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(u)==="object"&&u.configurations)for(const l of u.configurations){const d=l.type;d&&(t.has(d)?t.set(d,t.get(d)+1):t.set(d,1))}return w(t)}catch(t){return[]}}e.collectLaunchConfigs=S;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||r.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,v.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[s,u]=n,l=this.formatProcessList(t,s);return r.forEach(d=>{if((0,h.isRemoteDiagnosticError)(d))l+=`
${d.errorMessage}`,u+=`
${d.errorMessage}`;else if(l+=`

Remote: ${d.hostName}`,d.processes&&(l+=`
${this.formatProcessList(t,d.processes)}`),d.workspaceMetadata){u+=`
|  Remote: ${d.hostName}`;for(const g of Object.keys(d.workspaceMetadata)){const p=d.workspaceMetadata[g];let f=`${p.fileCount} files`;p.maxFilesReached&&(f=`more than ${f}`),u+=`|    Folder (${g}): ${f}`,u+=this.formatWorkspaceStats(p)}}}),{processInfo:l,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:n,vmHint:s,os:u,cpus:l}=C(),d={os:u,memory:n,cpus:l,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return P.isWindows||(d.load=`${D.loadavg().map(g=>Math.round(g)).join(", ")}`),P.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(t,r){const n=[];return(0,v.listProcesses)(t.mainPID).then(async s=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,s)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if((0,h.isRemoteDiagnosticError)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.formatMachineInfo(u.machineInfo)),u.processes&&n.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const l of Object.keys(u.workspaceMetadata)){const d=u.workspaceMetadata[l];let g=`${d.fileCount} files`;d.maxFilesReached&&(g=`more than ${g}`),n.push(`Folder (${l}): ${g}`),n.push(this.formatWorkspaceStats(d))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const r=[],n=60;let s=0;const u=(p,f)=>{const k=` ${p}(${f})`;s+k.length>n?(r.push(l),l="|                 ",s=l.length):s+=k.length,l+=k};let l="|      File types:";const d=10;let g=t.fileTypes.length>d?d:t.fileTypes.length;for(let p=0;p<g;p++){const f=t.fileTypes[p];u(f.name,f.count)}if(r.push(l),t.configFiles.length>=0&&(l="|      Conf files:",s=0,t.configFiles.forEach(p=>{u(p.name,p.count)}),r.push(l)),t.launchConfigFiles.length>0){let p="|      Launch Configs:";t.launchConfigFiles.forEach(f=>{p+=f.count>1?` ${f.name}(${f.count})`:` ${f.name}`}),r.push(p)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],n=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const l=m.URI.revive(u);if(l.scheme===T.Schemas.file){const d=l.fsPath;n.push(I(d,["node_modules",".git"]).then(g=>{let p=`${g.fileCount} files`;g.maxFilesReached&&(p=`more than ${p}`),r.push(`|    Folder (${(0,A.basename)(d)}): ${p}`),r.push(this.formatWorkspaceStats(g))}).catch(g=>{r.push(`|      Error: Unable to collect workspace stats for folder ${d} (${g.toString()})`)}))}else r.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const n=new Map;t.windows.forEach(u=>n.set(u.pid,u.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,n,s,r,0),s.join(`
`)}formatProcessItem(t,r,n,s,u){const l=u===0;let d;l?d=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(u)} ${s.name}`,s.name==="window"&&(d=`${d} (${r.get(s.pid)})`));const g=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(g/b.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(s.children)&&s.children.forEach(p=>this.formatProcessItem(t,r,n,p,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const n=m.URI.revive(r);if(n.scheme!==T.Schemas.file)continue;const s=n.fsPath;try{const u=await I(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),u.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),u.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};o=he([Y(0,y.ITelemetryService),Y(1,c.IProductService)],o),e.DiagnosticsService=o}),define(Z[183],ee([0,1,19,5,29,11,3,2,4,7,114,27,31,14,44,21]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let I=class extends P.Disposable{constructor(a,t,r){super();this.galleryService=a,this.telemetryService=t,this.logService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));try{a=await this.checkAndGetCompatibleVersion(a)}catch(n){throw this.logService.error((0,T.getErrorMessage)(n)),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(!await this.canInstall(a)){const n=new v.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",a.identifier.id,n.message),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}const r=await this.galleryService.getManifest(a,R.CancellationToken.None);if(r===null){const n=new v.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(r,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(1,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,r){if(!E.URI.isUri(t)){let d=this.installingExtensions.get(new h.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(d)return this.logService.info("Extensions is already requested to install",t.identifier.id),d.waitUntilTaskIsFinished();r={...r,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],s=[],u=this.createInstallExtensionTask(a,t,r);E.URI.isUri(t)||this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(u.identifier,a.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:t}),this.logService.info("Installing extension:",u.identifier.id),n.push({task:u,manifest:a});let l=!1;try{if(r.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const g=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,a,!!r.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:f}of g)if(l=l||!!f.extensionDependencies?.some(k=>(0,h.areSameExtensions)({id:k},u.identifier)),this.installingExtensions.has(new h.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const k=this.createInstallExtensionTask(f,p,{...r,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(k.identifier,f.version).key(),k),this._onInstallExtension.fire({identifier:k.identifier,source:p}),this.logService.info("Installing extension:",k.identifier.id),n.push({task:k,manifest:f})}}catch(g){if(E.URI.isUri(u.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,g.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,g.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),this.logService.error(g),g}const d=n.reduce((g,{task:p,manifest:f})=>(g.set(p.identifier.id.toLowerCase(),{task:p,manifest:f}),g),new Map);for(;d.size;){let g;const p=[...d.values()].filter(({manifest:f})=>!f.extensionDependencies?.some(k=>d.has(k.toLowerCase())));p.length?g=d.size===1?p:p.filter(({task:f})=>!(f===u&&!l)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:f})=>f.identifier.id)),g=[...d.values()]),await this.joinAllSettled(g.map(async({task:f})=>{const k=new Date().getTime();try{const O=await f.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(O,f.source,r,R.CancellationToken.None))),!E.URI.isUri(f.source)&&(C(this.telemetryService,f.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(f.source),new Date().getTime()-k,void 0),m.isWeb&&f.operation===1))try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch(_){}s.push({local:O,identifier:f.identifier,operation:f.operation,source:f.source})}catch(O){throw E.URI.isUri(f.source)||C(this.telemetryService,f.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(f.source),new Date().getTime()-k,O),this.logService.error("Error while installing the extension:",f.identifier.id),this.logService.error(O),O}finally{d.delete(f.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:g})=>this.logService.info("Extension installed successfully:",g.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:g})=>(0,h.areSameExtensions)(g,u.identifier))[0].local}catch(d){if(n.forEach(({task:g})=>g.cancel()),s.length)try{const g=await Promise.allSettled(s.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<g.length;p++){const f=g[p],{identifier:k}=s[p];f.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",k.id):this.logService.warn("Rollback: Error while uninstalling extension",k.id,(0,T.getErrorMessage)(f.reason))}}catch(g){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(g),s.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",u.identifier.id,(0,T.getErrorMessage)(d)),this._onDidInstallExtensions.fire(n.map(({task:g})=>({identifier:g.identifier,operation:1,source:g.source}))),d instanceof Error&&(d.name=d&&d.code?d.code:e.ERROR_UNKNOWN),d}finally{for(const{task:d,manifest:g}of n)if(!E.URI.isUri(d.source)){const p=new h.ExtensionIdentifierWithVersion(d.identifier,g.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(a){const t=[],r=[],n=await Promise.allSettled(a);for(const s of n)s.status==="fulfilled"?t.push(s.value):r.push(s.reason);if(r.length)throw w(r);return t}async getAllDepsAndPackExtensionsToInstall(a,t,r){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const s=[a,...n.map(d=>d.identifier)],u=[],l=async(d,g)=>{const p=g.extensionDependencies||[];if(g.extensionPack){const f=r?n.find(k=>(0,h.areSameExtensions)(k.identifier,d)):void 0;for(const k of g.extensionPack)f&&f.manifest.extensionPack&&f.manifest.extensionPack.some(O=>(0,h.areSameExtensions)({id:O},{id:k}))||p.every(O=>!(0,h.areSameExtensions)({id:O},{id:k}))&&p.push(k)}if(p.length){const f=[...s,...u.map(O=>O.gallery.identifier)],k=p.filter(O=>f.every(_=>!(0,h.areSameExtensions)(_,{id:O})));if(k.length){const O=await this.galleryService.query({names:k,pageSize:p.length},R.CancellationToken.None);for(const _ of O.firstPage){if(f.find(W=>(0,h.areSameExtensions)(W,_.identifier)))continue;const z=await this.checkAndGetCompatibleVersion(_);if(!await this.canInstall(z)){this.logService.info("Skipping the extension as it cannot be installed",z.identifier.id);continue}const V=await this.galleryService.getManifest(z,R.CancellationToken.None);if(V===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${z.identifier.id}`,e.INSTALL_ERROR_VALIDATING);u.push({gallery:z,manifest:V}),await l(z.identifier,V)}}}};return await l(a,t),n=await this.getInstalled(),u.filter(d=>!n.some(g=>(0,h.areSameExtensions)(g.identifier,d.gallery.identifier)))}async checkAndGetCompatibleVersion(a){if(await this.isMalicious(a))throw new v.ExtensionManagementError(i.localize(3,null,a.identifier.id),v.INSTALL_ERROR_MALICIOUS);const t=await this.galleryService.getCompatibleExtension(a);if(!t)throw new v.ExtensionManagementError(i.localize(4,null,a.identifier.id,c.default.version),v.INSTALL_ERROR_INCOMPATIBLE);return t}async isMalicious(a){const t=await this.getExtensionsReport();return(0,h.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const r=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(r)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),r.waitUntilTaskIsFinished();const n=(d,g)=>{const p=this.createUninstallExtensionTask(d,g);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",d.identifier.id),this._onUninstallExtension.fire(d.identifier),p},s=(d,g)=>{g?this.logService.error("Failed to uninstall extension:",d.identifier.id,g.message):this.logService.info("Successfully uninstalled extension:",d.identifier.id),C(this.telemetryService,"extensionGallery:uninstall",(0,h.getLocalExtensionTelemetryData)(d),void 0,g),this._onDidUninstallExtension.fire({identifier:d.identifier,error:g?.code})},u=[],l=[];try{u.push(n(a,{}));const d=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const g=this.getAllPackExtensionsToUninstall(a,d);for(const p of g)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):u.push(n(p,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(u.map(g=>g.extension),d,a),await this.joinAllSettled(u.map(async g=>{try{if(await g.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(g.extension,t,R.CancellationToken.None))),g.extension.identifier.uuid)try{await this.galleryService.reportStatistic(g.extension.manifest.publisher,g.extension.manifest.name,g.extension.manifest.version,"uninstall")}catch(p){}s(g.extension)}catch(p){const f=p instanceof v.ExtensionManagementError?p:new v.ExtensionManagementError((0,T.getErrorMessage)(p),e.ERROR_UNKNOWN);throw s(g.extension,f),f}finally{l.push(g)}}))}catch(d){const g=d instanceof v.ExtensionManagementError?d:new v.ExtensionManagementError((0,T.getErrorMessage)(d),e.ERROR_UNKNOWN);for(const p of u){try{p.cancel()}catch(f){}l.includes(p)||s(p.extension,g)}throw g}finally{for(const d of u)this.uninstallingExtensions.delete(d.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",d.extension.identifier.id)}}checkForDependents(a,t,r){for(const n of a){const s=this.getDependents(n,t);if(s.length){const u=s.filter(l=>!a.some(d=>(0,h.areSameExtensions)(d.identifier,l.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(n,u,r))}}}getDependentsErrorMessage(a,t,r){return r===a?t.length===1?i.localize(5,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(6,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(7,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(8,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(9,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(10,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,r=[]){if(r.indexOf(a)!==-1)return[];r.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const s=t.filter(l=>!l.isBuiltin&&n.some(d=>(0,h.areSameExtensions)({id:d},l.identifier))),u=[];for(const l of s)u.push(...this.getAllPackExtensionsToUninstall(l,t,r));return[...s,...u]}return[]}getDependents(a,t){return t.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(n=>(0,h.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};I=he([Y(0,v.IExtensionGalleryService),Y(1,y.ITelemetryService),Y(2,b.ILogService)],I),e.AbstractExtensionManagementService=I;function w(o){const a=Array.isArray(o)?o:[o];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,r)=>new Error(`${t.message}${t.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}e.joinErrors=w;function C(o,a,t,r,n){const s=n?n instanceof v.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;o.publicLogError(a,{...t,success:!n,duration:r,errorcode:s})}e.reportTelemetry=C;class S{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>new Promise((t,r)=>{const n=a.onCancellationRequested(()=>{n.dispose(),r((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=S}),define(Z[184],ee([0,1,29,11,26,4,12,27,31,72,13,6,14,28,42,45,20,21]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var C;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(C||(C={}));function S(...M){return String(M.reduce((F,q)=>F|q,0))}var o;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},n={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:C.None,criteria:[],assetTypes:[]};class s{constructor(F=n){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,q=this.state.pageSize){return new s({...this.state,pageNumber:F,pageSize:q})}withFilter(F,...q){const x=[...this.state.criteria,...q.length?q.map(N=>({filterType:F,value:N})):[{filterType:F}]];return new s({...this.state,criteria:x})}withSortBy(F){return new s({...this.state,sortBy:F})}withSortOrder(F){return new s({...this.state,sortOrder:F})}withFlags(...F){return new s({...this.state,flags:F.reduce((q,x)=>q|x,0)})}withAssetTypes(...F){return new s({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:q,pageSize:x,sortBy:N,sortOrder:j,flags:$,assetTypes:H}=this.state;return{filters:[{criteria:F,pageNumber:q,pageSize:x,sortBy:N,sortOrder:j}],assetTypes:H,flags:$}}get searchText(){const F=this.state.criteria.filter(q=>q.filterType===o.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function u(M,F){const q=(M||[]).filter(x=>x.statisticName===F)[0];return q?q.value:0}function l(M){const F="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(x=>x.assetType.indexOf(F)===0).reduce((x,N)=>{const j=f(M,N.assetType);return j&&x.push([N.assetType.substring(F.length),j]),x},[])}function d(M){if(M.properties){const F=M.properties.filter(N=>N.key===a.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=F.filter(N=>q.test(N.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return f(M,a.Repository)}function g(M){return{uri:`${M.fallbackAssetUri}/${a.VSIX}?redirect=true`,fallbackUri:`${M.fallbackAssetUri}/${a.VSIX}`}}function p(M){const F=f(M,a.Icon);if(F)return F;const q=P.DefaultIconPath;return{uri:q,fallbackUri:q}}function f(M,F){return M.files.filter(x=>x.assetType===F)[0]?{uri:`${M.assetUri}/${F}`,fallbackUri:`${M.fallbackAssetUri}/${F}`}:null}function k(M,F){const q=M.properties?M.properties.filter(N=>N.key===F):[],x=q.length>0&&q[0].value;return x?x.split(",").map(N=>(0,m.adoptToGalleryExtensionId)(N)):[]}function O(M){const F=M.properties?M.properties.filter(q=>q.key===t.Engine):[];return F.length>0&&F[0].value||""}function _(M){const F=M.properties?M.properties.filter(x=>x.key===t.LocalizedLanguages):[],q=F.length>0&&F[0].value||"";return q?q.split(","):[]}function z(M){return M.indexOf("preview")!==-1}function V(M,F,q,x,N){const j={manifest:f(F,a.Manifest),readme:f(F,a.Details),changelog:f(F,a.Changelog),license:f(F,a.License),repository:d(F),download:g(F),icon:p(F),coreTranslations:l(F)};return{identifier:{id:(0,m.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:F.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,description:M.shortDescription||"",installCount:u(M.statistics,"install"),rating:u(M.statistics,"averagerating"),ratingCount:u(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),webExtension:!!M.tags?.includes(P.WEB_EXTENSION_TAG),assets:j,properties:{dependencies:k(F,t.Dependency),extensionPack:k(F,t.ExtensionPack),engine:O(F),localizedLanguages:_(F)},telemetryData:{index:(x.pageNumber-1)*x.pageSize+q,querySource:N},preview:z(M.flags)}}let W=class{constructor(F,q,x,N,j,$,H){this.requestService=F,this.logService=q,this.environmentService=x,this.telemetryService=N,this.fileService=j,this.productService=$;const G=$.extensionsGallery;this.extensionsGalleryUrl=G&&G.serviceUrl,this.extensionsControlUrl=G&&G.controlUrl,this.commonHeadersPromise=U($.version,this.environmentService,this.fileService,H)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,q){const x=[];let{total:N,firstPage:j,getPage:$}=await this.query({names:F,pageSize:F.length},q);x.push(...j);for(let H=1;x.length<N&&(j=await $(H,q),j.length);H++)x.push(...j);return x}async getCompatibleExtension(F,q){return this.getCompatibleExtensionByEngine(F,q)}async getCompatibleExtensionByEngine(F,q){const x=(0,P.isIExtensionIdentifier)(F)?null:F;if(x&&x.properties.engine&&(0,E.isEngineValid)(x.properties.engine,this.productService.version,this.productService.date))return x;const{id:N,uuid:j}=x?x.identifier:F;let $=new s().withFlags(C.IncludeAssetUri,C.IncludeStatistics,C.IncludeCategoryAndTags,C.IncludeFiles,C.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");j?$=$.withFilter(o.ExtensionId,j):$=$.withFilter(o.ExtensionName,N);const{galleryExtensions:H}=await this.queryGallery($,D.CancellationToken.None),[G]=H;if(!G||!G.versions.length)return null;if(q){const X=G.versions.filter(ie=>ie.version===q)[0];if(X){const ie=V(G,X,0,$);if(ie.properties.engine&&(0,E.isEngineValid)(ie.properties.engine,this.productService.version,this.productService.date))return ie}return null}const Q=await this.getLastValidExtensionVersion(G,G.versions);return Q?V(G,Q,0,$):null}async query(F,q){const x=D.CancellationToken.isCancellationToken(F)?{}:F,N=D.CancellationToken.isCancellationToken(F)?F:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=x.text||"";const $=(0,R.getOrDefault)(x,te=>te.pageSize,50);let H=new s().withFlags(C.IncludeLatestVersionOnly,C.IncludeAssetUri,C.IncludeStatistics,C.IncludeCategoryAndTags,C.IncludeFiles,C.IncludeVersionProperties).withPage(1,$).withFilter(o.Target,"Microsoft.VisualStudio.Code");j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,ue)=>(H=H.withFilter(o.Category,ue||oe),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,ue)=>(H=H.withFilter(o.Tag,ue||oe),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(o.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),H=H.withFilter(o.SearchText,j)),H=H.withSortBy(0)):x.ids?H=H.withFilter(o.ExtensionId,...x.ids):x.names?H=H.withFilter(o.ExtensionName,...x.names):H=H.withSortBy(4),typeof x.sortBy=="number"&&(H=H.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(H=H.withSortOrder(x.sortOrder));const{galleryExtensions:G,total:Q}=await this.queryGallery(H,N),X=G.map((te,oe)=>V(te,te.versions[0],oe,H,x.source)),ie=async(te,oe)=>{if(oe.isCancellationRequested)throw(0,L.canceled)();const ue=H.withPage(te+1),{galleryExtensions:ye}=await this.queryGallery(ue,oe);return ye.map((ve,Re)=>V(ve,ve.versions[0],Re,ue,x.source))};return{firstPage:X,total:Q,pageSize:H.pageSize,getPage:ie}}async queryGallery(F,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,C.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,S(C.Unpublished));const x=await this.commonHeadersPromise,N=JSON.stringify(F.raw),j={...x,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)},$=new Date().getTime();let H,G,Q=0;try{if(H=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:j},q),H.res.statusCode&&H.res.statusCode>=400&&H.res.statusCode<500)return{galleryExtensions:[],total:Q};const X=await(0,c.asJson)(H);if(X){const ie=X.results[0],te=ie.extensions,oe=ie.resultMetadata&&ie.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return Q=oe&&oe.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:te,total:Q}}return{galleryExtensions:[],total:Q}}catch(X){throw G=X,X}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(N.length),duration:new Date().getTime()-$,success:!!H&&(0,c.isSuccess)(H),responseBodySize:H?.res.headers["Content-Length"],statusCode:H?String(H.res.statusCode):void 0,errorCode:G?(0,L.isPromiseCanceledError)(G)?"canceled":(0,L.getErrorMessage)(G).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(F,q,x,N){if(!this.isEnabled())return;const j=T.isWeb?this.api(`/itemName/${F}.${q}/version/${x}/statType/${N==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${q}/${x}/stats?statType=${N}`),$=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",G={...await this.commonHeadersPromise,Accept:$};try{await this.requestService.request({type:"POST",url:j,headers:G},D.CancellationToken.None)}catch(Q){}}async download(F,q,x){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const N=(0,m.getGalleryExtensionTelemetryData)(F),j=new Date().getTime(),$=X=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...N,duration:X}),H=x===1?"install":x===2?"update":"",G=H?{uri:`${F.assets.download.uri}&${H}=true`,fallbackUri:`${F.assets.download.fallbackUri}?${H}=true`}:F.assets.download,Q=await this.getAsset(G);await this.fileService.writeFile(q,Q.stream),$(new Date().getTime()-j)}async getReadme(F,q){if(F.assets.readme){const x=await this.getAsset(F.assets.readme,{},q);return await(0,c.asText)(x)||""}return""}async getManifest(F,q){if(F.assets.manifest){const x=await this.getAsset(F.assets.manifest,{},q),N=await(0,c.asText)(x);return N?JSON.parse(N):null}return null}async getCoreTranslation(F,q){const x=F.assets.coreTranslations.filter(N=>N[0]===q.toUpperCase())[0];if(x){const N=await this.getAsset(x[1]),j=await(0,c.asText)(N);return j?JSON.parse(j):null}return null}async getChangelog(F,q){if(F.assets.changelog){const x=await this.getAsset(F.assets.changelog,{},q);return await(0,c.asText)(x)||""}return""}async getAllVersions(F,q){let x=new s().withFlags(C.IncludeVersions,C.IncludeCategoryAndTags,C.IncludeFiles,C.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?x=x.withFilter(o.ExtensionId,F.identifier.uuid):x=x.withFilter(o.ExtensionName,F.identifier.id);const N=[],{galleryExtensions:j}=await this.queryGallery(x,D.CancellationToken.None);return j.length&&(q?await Promise.all(j[0].versions.map(async $=>{let H;try{H=await this.getEngine($)}catch(G){}H&&(0,E.isEngineValid)(H,this.productService.version,this.productService.date)&&N.push({version:$.version,date:$.lastUpdated})})):N.push(...j[0].versions.map($=>({version:$.version,date:$.lastUpdated})))),N}async getAsset(F,q={},x=D.CancellationToken.None){const N=await this.commonHeadersPromise,j={type:"GET"},$={...N,...q.headers||{}};q={...q,...j,headers:$};const H=F.uri,G=F.fallbackUri,Q={...q,url:H};try{const X=await this.requestService.request(Q,x);if(X.res.statusCode===200)return X;const ie=await(0,c.asText)(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${ie}`)}catch(X){if((0,L.isPromiseCanceledError)(X))throw X;const ie=(0,L.getErrorMessage)(X);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:H,message:ie});const te={...q,url:G};return this.requestService.request(te,x)}}async getLastValidExtensionVersion(F,q){const x=this.getLastValidExtensionVersionFromProperties(F,q);return x||this.getLastValidExtensionVersionRecursively(F,q)}getLastValidExtensionVersionFromProperties(F,q){for(const x of q){const N=O(x);if(!N)return null;if((0,E.isEngineValid)(N,this.productService.version,this.productService.date))return x}return null}async getEngine(F){const q=O(F);if(q)return q;const x=f(F,a.Manifest);if(!x)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},j=await this.getAsset(x,{headers:N}),$=await(0,c.asJson)(j);if($)return $.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(F,q){if(!q.length)return null;const x=q[0],N=await this.getEngine(x);return(0,E.isEngineValid)(N,this.productService.version,this.productService.date)?{...x,properties:[...x.properties||[],{key:t.Engine,value:N}]}:this.getLastValidExtensionVersionRecursively(F,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,c.asJson)(F),x=new Map;if(q)for(const N of q.malicious){const j=x.get(N)||{id:{id:N},malicious:!0,slow:!1};j.malicious=!0,x.set(N,j)}return[...x.values()]}};W=he([Y(0,c.IRequestService),Y(1,h.ILogService),Y(2,A.IEnvironmentService),Y(3,w.ITelemetryService),Y(4,i.IFileService),Y(5,b.IProductService),Y(6,(0,v.optional)(I.IStorageService))],W),e.ExtensionGalleryService=W;async function U(M,F,q,x){const N={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},j=await(0,y.getServiceMachineId)(F,q,x);return N["X-Market-User-Id"]=j,N}e.resolveMarketplaceHeaders=U}),define(Z[185],ee([0,1,19,5,63,3,8,4,35,7,116,12,27,177,75,13,14,59,28,42,20,21]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let n=class extends b.ExtensionTipsService{constructor(u,l,d,g,p,f,k,O,_,z){super(k,O,_,z);this.environmentService=u,this.telemetryService=l,this.extensionManagementService=d,this.storageService=g,this.nativeHostService=p,this.extensionRecommendationNotificationService=f,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,R.forEach)(O.exeBasedExtensionTips,({key:V,value:W})=>{const U=[],M=[],F=[];(0,R.forEach)(W.recommendations,({key:q,value:x})=>{x.important?W.important?U.push({extensionId:q,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):M.push({extensionId:q,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):F.push({extensionId:q,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(V,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:U}),M.length&&this.mediumImportanceExecutableTips.set(V,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:M}),F.length&&this.allOtherExecutableTips.set(V,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:F})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),d=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,d),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,d)}groupImportantTipsByExe(u,l){const d=new Map;u.forEach(O=>d.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:p}=this.groupByInstalled([...d.keys()],l);for(const O of g){const _=d.get(O);_&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:_.exeName})}for(const O of p){const _=d.get(O);_&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:_.exeName})}const f=this.getPromptedExecutableTips(),k=new Map;for(const O of p){const _=d.get(O);if(_&&(!f[_.exeName]||!f[_.exeName].includes(_.extensionId))){let z=k.get(_.exeName);z||(z=[],k.set(_.exeName,z)),z.push(_)}}return k}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(d=>{switch(d){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const g=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const p=this._register((0,L.disposableTimeout)(()=>{p.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),l=Date.now()-u,d=7*24*60*60*1e3;if(l<d){const f=this._register((0,L.disposableTimeout)(()=>{f.dispose(),this.promptMediumImportanceExeBasedTip()},d-l));return}const[g,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(f=>{switch(f){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(p[0].exeName,p);const k=this._register((0,L.disposableTimeout)(()=>{k.dispose(),this.promptMediumImportanceExeBasedTip()},d));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const _=this._register((0,L.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const l=u.map(({extensionId:g})=>g.toLowerCase()),d=(0,i.localize)(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,d,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,l){const d=this.getPromptedExecutableTips();d[u]=l.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(t,JSON.stringify(d),0,0)}groupByInstalled(u,l){const d=[],g=[],p=l.reduce((f,k)=>(f.add(k.identifier.id.toLowerCase()),f),new Set);return u.forEach(f=>{p.has(f.toLowerCase())?d.push(f):g.push(f)}),{installed:d,uninstalled:g}}async getValidExecutableBasedExtensionTips(u){const l=[],d=new Map;for(const g of u.keys()){const p=u.get(g);if(!p||!(0,D.isNonEmptyArray)(p.recommendations))continue;const f=[];P.isWindows?p.windowsPath&&f.push(p.windowsPath.replace("%USERPROFILE%",m.env.USERPROFILE).replace("%ProgramFiles(x86)%",m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",m.env.ProgramFiles).replace("%APPDATA%",m.env.APPDATA).replace("%WINDIR%",m.env.WINDIR)):(f.push((0,A.join)("/usr/local/bin",g)),f.push((0,A.join)("/usr/bin",g)),f.push((0,A.join)(this.environmentService.userHome.fsPath,g)));for(const k of f){let O=d.get(k);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(k)),d.set(k,O)),O)for(const{extensionId:_,extensionName:z,isExtensionPack:V}of p.recommendations)l.push({extensionId:_,extensionName:z,isExtensionPack:V,exeName:g,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}return l}};n=he([Y(0,v.INativeEnvironmentService),Y(1,a.ITelemetryService),Y(2,h.IExtensionManagementService),Y(3,o.IStorageService),Y(4,w.INativeHostService),Y(5,c.IExtensionRecommendationNotificationService),Y(6,y.IFileService),Y(7,C.IProductService),Y(8,S.IRequestService),Y(9,I.ILogService)],n),e.ExtensionTipsService=n}),define(Z[82],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appender=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:P,data:m}){return this.appender.log(P,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[83],ee([0,1,2,26,23,126,24,38,6,44,32]),function(K,e,D,L,R,T,A,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(c,y){this._configurationService=y,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const w=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})}))}setExperimentProperty(c,y){this._experimentProperties[c]=y}setEnabled(c){this._enabled=c}_updateUserOptIn(){const c=this._configurationService?.getValue(h);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let y=c.sessionID,I=c["common.instanceId"],w=c["common.machineId"],C=c["common.firstSessionDate"],S=c["common.msftInternal"];return{sessionId:y,instanceId:I,machineId:w,firstSessionDate:C,msftInternal:S}}dispose(){this._disposables.dispose()}publicLog(c,y,I){return this.isOptedIn?this._commonProperties.then(w=>{y=(0,L.mixin)(y,w),y=(0,L.mixin)(y,this._experimentProperties),y=(0,L.cloneAndChange)(y,C=>{if(typeof C=="string")return this._cleanupInfo(C,I)}),this._appender.log(c,y)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(c,y,I){return this.publicLog(c,y,I)}publicLogError(c,y){return this.sendErrorTelemetry?this.publicLog(c,y,!0):Promise.resolve(void 0)}publicLogError2(c,y){return this.publicLogError(c,y)}_cleanupInfo(c,y){let I=c;if(y){const w=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(c);if(!t)break;w.push([t.index,a.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(I="";;){const a=S.exec(c);if(!a)break;!C.test(a[0])&&w.every(([t,r])=>a.index<t||a.index>=r)&&(I+=c.substring(o,a.index)+"<REDACTED: user-file-path>",o=S.lastIndex)}o<c.length&&(I+=c.substr(o))}for(let w of this._cleanupPatterns)I=I.replace(w,"");return I}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=he([Y(1,(0,m.optional)(A.IConfigurationService))],v),e.TelemetryService=v;const h="telemetry";i.Registry.as(P.Extensions.Configuration).registerConfiguration({id:h,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,T.localize)(2,null,E.default.nameLong,E.default.privacyStatementUrl):(0,T.localize)(1,null,E.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[53],ee([0,1,5,26,16,24]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,y){return Promise.resolve(void 0)}publicLog2(c,y){return this.publicLog(c,y)}publicLogError(c,y){return Promise.resolve(void 0)}publicLogError2(c,y){return this.publicLogError(c,y)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(y,I,w){}async publicLogError(y,I,w){}}e.NullEndpointTelemetryService=A;function P(...c){return{log:(y,I)=>c.forEach(w=>w.log(y,I)),flush:()=>D.Promises.settled(c.map(y=>y.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(c,y){return y.onDidChangeConfiguration(I=>{I.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(I.source),configurationKeys:h(I.sourceConfig)})})}e.configurationTelemetry=m;function E(c){const y=Object.create(null),I=Object.create(null),w=Object.create(null);v(c,w);for(let C in w){C=C.length>150?C.substr(C.length-149):C;const S=w[C];typeof S=="number"?I[C]=S:typeof S=="boolean"?I[C]=S?1:0:typeof S=="string"?y[C]=S.substring(0,1023):typeof S!="undefined"&&S!==null&&(y[C]=S)}return{properties:y,measurements:I}}e.validateTelemetryData=E;function i(c){if(!c)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(w=>{c.indexOf(`${w}+`)===0&&(y=w)}),y}e.cleanRemoteAuthority=i;function v(c,y,I=0,w){if(!!c)for(let C of Object.getOwnPropertyNames(c)){const S=c[C],o=w?w+C:C;Array.isArray(S)?y[o]=(0,L.safeStringify)(S):S instanceof Date?y[o]=S.toISOString():(0,R.isObject)(S)?I<2?v(S,y,I+1,o+"."):y[o]=(0,L.safeStringify)(S):y[o]=S}}function h(c){if(!c)return[];const y=[];return b(y,"",c),y}function b(c,y,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(w=>b(c,y?`${y}.${w}`:w,I[w])):c.push(y)}}),define(Z[84],ee([0,1,2,12,14,53]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(m,E,i=""){super();this.prefix=i;const v=m.getLogger(E.telemetryLogResource);v?this.logger=this._register(v):(this.logger=this._register(m.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(m,E){this.logger.trace(`${this.prefix}telemetry/${m}`,(0,T.validateTelemetryData)(E))}};A=he([Y(0,R.ILoggerService),Y(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(Z[186],ee([0,1,11,26,53]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P){const m=await new Promise((i,v)=>{K(["applicationinsights"],i,v)});let E;return m.defaultClient?(E=new m.TelemetryClient(P),E.channel.setUseDiskRetryCaching(!0)):(m.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=m.defaultClient),P.indexOf("AIF-")===0&&(E.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),E}class A{constructor(m,E,i){this._eventPrefix=m,this._defaultData=E,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(E=>{m(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(m,E){!this._aiClient||(E=(0,L.mixin)(E,this._defaultData),E=(0,R.validateTelemetryData)(E),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+m,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(Z[187],ee([0,1,17,51,24,12,14,21,82,84,83,53]),function(K,e,D,L,R,T,A,P,m,E,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let h=class{constructor(c,y,I,w){this.configurationService=c,this.telemetryService=y,this.loggerService=I,this.environmentService=w,this.customTelemetryServices=new Map}async getCustomTelemetryService(c){if(!this.customTelemetryServices.has(c.id)){const{machineId:y,sessionId:I}=await this.telemetryService.getTelemetryInfo(),w=Object.create(null);w["common.vscodemachineid"]=y,w["common.vscodesessionid"]=I;const C=[c.id,JSON.stringify(w),c.aiKey],o=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:C,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=(0,v.combinedAppender)(new m.TelemetryAppenderClient(o),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${c.id}] `));this.customTelemetryServices.set(c.id,new i.TelemetryService({appender:a,sendErrorTelemetry:c.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(c.id)}async publicLog(c,y,I){await(await this.getCustomTelemetryService(c)).publicLog(y,I)}async publicLogError(c,y,I){await(await this.getCustomTelemetryService(c)).publicLogError(y,I)}};h=he([Y(0,R.IConfigurationService),Y(1,P.ITelemetryService),Y(2,A.ILoggerService),Y(3,T.IEnvironmentService)],h),e.CustomEndpointTelemetryService=h}),define(Z[188],ee([0,1,5,29,3,2,14]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(E,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((i,v)=>{const h=++this._lastRequestId;this._pendingRequests.set(h,i),this._onCreateRequest.fire({requestId:h,...E});const b=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,b.token).then(()=>v(`Request ${h} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(h,[(0,T.toDisposable)(()=>b.cancel())])})}acceptReply(E,i){const v=this._pendingRequests.get(E);v?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),v(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=he([Y(1,A.ILogService)],P),e.RequestStore=P}),define(Z[85],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.TitleMode="terminal.integrated.titleMode",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var m;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m=e.HeartbeatConstants||(e.HeartbeatConstants={}));var E;(function(c){c[c.Panel=0]="Panel",c[c.Editor=1]="Editor"})(E=e.TerminalLocation||(e.TerminalLocation={}));var i;(function(c){c.TerminalView="view",c.Editor="editor"})(i=e.TerminalLocationString||(e.TerminalLocationString={}));var v;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(v=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(Z[189],ee([0,1,6]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(Z[190],ee([0,1,34,26,8,4,35,16,18]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let h=0;return v&&v.length===4&&(h=parseInt(v[3])),h}e.getWindowsBuildNumber=E;async function i(v,h,b,c=A.env,y=m.Promises.exists){if(R.isAbsolute(v))return await y(v)?v:void 0;if(h===void 0&&(h=A.cwd()),R.dirname(v)!=="."){const S=R.join(h,v);return await y(S)?S:void 0}const w=(0,L.getCaseInsensitive)(c,"PATH");if(b===void 0&&(0,P.isString)(w)&&(b=w.split(R.delimiter)),b===void 0||b.length===0){const S=R.join(h,v);return await y(S)?S:void 0}for(let S of b){let o;if(R.isAbsolute(S)?o=R.join(S,v):o=R.join(h,S,v),await y(o))return o;if(T.isWindows){let a=o+".com";if(await y(a)||(a=o+".exe",await y(a)))return a}}const C=R.join(h,v);return await y(C)?C:void 0}e.findExecutable=i}),define(Z[191],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(Z[86],ee([0,1,48,3,2,6,32,191]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var m;(function(I){function w(C){return C&&typeof C=="object"&&typeof C.id=="string"}I.isThemeColor=w})(m=e.ThemeColor||(e.ThemeColor={}));function E(I){return{id:I}}e.themeColorFromId=E;var i;(function(I){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||m.isThemeColor(r.color))}I.isThemeIcon=w;const C=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function S(r){const n=C.exec(r);if(!n)return;let[,s]=n;return{id:s}}I.fromString=S;function o(r,n){let s=r.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),n&&(s=`${s}~${n}`),{id:s}}I.modify=o;function a(r,n){return r.id===n.id&&r.color?.id===n.color?.id}I.isEqual=a;function t(r,n){return{id:r.id,color:n?E(n):void 0}}I.asThemeIcon=t,I.asClassNameArray=D.CSSIcon.asClassNameArray,I.asClassName=D.CSSIcon.asClassName,I.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function v(I){switch(I){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=v,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,R.toDisposable)(()=>{const C=this.themingParticipants.indexOf(w);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new h;A.Registry.add(e.Extensions.ThemingContribution,b);function c(I){return b.onColorThemeChange(I)}e.registerThemingParticipant=c;class y extends R.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,C){let S=this.theme.getColor(w);return S&&C&&(S=C(S,this.theme)),S?S.toString():null}}e.Themable=y}),define(Z[192],ee([0,1,48,86]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,m){const E=P.map(i=>({name:i.profileName,description:T(i)}));return m&&E.push(...m.map(i=>({name:i.title,description:A(i)}))),{values:E.map(i=>i.name),markdownDescriptions:E.map(i=>i.description)}}e.createProfileSchemaEnums=R;function T(P){let m=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?m+=`
- args: "${P.args}"`:m+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(m+=`
- overrideName: ${P.overrideName}`),P.color&&(m+=`
- color: ${P.color}`),P.env&&(m+=`
- env: ${JSON.stringify(P.env)}`),m}function A(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[193],ee([0,1,48,127,38,32,192]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,I=>I.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,I=>`$(${I.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),h={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.persistentSessionExperimentalSerializer"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(38,null),type:"boolean",default:!0}}};function b(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(h),y()}e.registerTerminalPlatformConfiguration=b;let c;function y(I,w){const C=T.Registry.as(R.Extensions.Configuration);c&&C.deregisterConfigurations([c]);let S;I&&(S=(0,A.createProfileSchemaEnums)(I?.profiles,w)),c={id:"terminal",order:100,title:(0,L.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:I?.os===3?S?.values:void 0,markdownEnumDescriptions:I?.os===3?S?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:I?.os===2?S?.values:void 0,markdownEnumDescriptions:I?.os===2?S?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:I?.os===1?S?.values:void 0,markdownEnumDescriptions:I?.os===1?S?.markdownDescriptions:void 0}}},C.registerConfiguration(c)}e.registerTerminalDefaultProfileConfiguration=y}),define(Z[194],ee([0,1,41,48,8,4,18,69,190,86]),function(K,e,D,L,R,T,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function v(t,r,n,s,u=process.env,l,d,g,p){return l=l||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?h(n,l,u,d,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),p,g):S(l,d,n,t&&typeof t=="object"?{...t}:s.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),p,g,u)}e.detectAvailableProfiles=v;async function h(t,r,n,s,u,l,d,g,p){const f=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),k=`${process.env.windir}\\${f?"Sysnative":"System32"}`;let O=!1;(0,m.getWindowsBuildNumber)()>=16299&&(O=!0),await y(g);const _=new Map;t&&(_.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${k}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),_.set("Command Prompt",{path:`${k}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),o(l,_);const z=await b(_.entries(),d,r,n,s,p);if(t||!t&&u)try{const V=await w(`${k}\\${O?"wsl":"bash"}.exe`,d);for(const W of V)(!l||!(W.profileName in l))&&z.push(W)}catch(V){s?.info("WSL is not installed, so could not detect WSL profiles")}return z}async function b(t,r,n,s=process.env,u,l){const d=[];for(const[g,p]of t){if(p===null)continue;let f,k,O;if("source"in p){const V=i?.get(p.source);if(!V)continue;f=V.paths,k=p.args||V.args,p.icon?O=c(p.icon):V.icon&&(O=V.icon)}else f=Array.isArray(p.path)?p.path:[p.path],k=T.isWindows||Array.isArray(p.args)?p.args:void 0,O=c(p.icon)||void 0;const _=await l?.(f)||f.slice(),z=await a(g,r,_,n,s,k,p.env,p.overrideName,p.isAutoDetected,u);z?(z.isAutoDetected=p.isAutoDetected,z.icon=O,z.color=p.color,d.push(z)):u?.trace("profile not validated",g,f)}return d}function c(t){return typeof t=="string"?{id:t}:t}async function y(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await I(),icon:E.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function I(){const t=[];for await(const r of(0,P.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function w(t,r){const n=[],s=await new Promise((d,g)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(p,f)=>{if(p)return g("Problem occurred when getting wsl distros");d(f)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),l=s.split(u).filter(d=>d.trim().length>0&&d!=="");for(const d of l){if(d===""||d.startsWith("docker-desktop"))continue;const g=`${d} (WSL)`,p={profileName:g,path:t,args:["-d",`${d}`],isDefault:g===r,icon:C(d)};n.push(p)}return n}function C(t){return t.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function S(t,r,n,s,u,l,d,g){const p=new Map;if(n){const f=(await t.readFile("/etc/shells")).toString(),k=l||f.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),O=new Map;for(const _ of k){let z=(0,R.basename)(_),V=O.get(z)||0;V++,V>1&&(z=`${z} (${V})`),O.set(z,V),p.set(z,{path:_,isAutoDetected:!0})}}return o(s,p),await b(p.entries(),u,t,g,r,d)}function o(t,r){if(!!t)for(const[n,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(n):r.set(n,s)}async function a(t,r,n,s,u,l,d,g,p,f){if(n.length===0)return Promise.resolve(void 0);const k=n.shift();if(k==="")return a(t,r,n,s,u,l,d,g,p);const O={profileName:t,path:k,args:l,env:d,overrideName:g,isAutoDetected:p,isDefault:t===r};if((0,R.basename)(k)===k){const z=u.PATH?u.PATH.split(R.delimiter):void 0;return await(0,m.findExecutable)(k,void 0,z,void 0,s.existsFile)?O:a(t,r,n,s,u,l)}return await s.existsFile((0,R.normalize)(k))?O:a(t,r,n,s,u,l,d,g,p)}}),define(Z[195],ee([0,1,3,2,17,4,36,51,24,156,14,79,21,188,85,193,194]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let C=0,S=class extends L.Disposable{constructor(a,t,r,n){super();this._reconnectConstants=a,this._configurationService=t,this._logService=r,this._telemetryService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=T.isWindows?Promise.resolve(process.env):(0,E.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new b.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback,VSCODE_RECONNECT_EXPERIMENTAL_SERIALIZATION:this._reconnectConstants.useExperimentalSerialization?1:0}});this._onPtyHostStart.fire(),A.ProxyChannel.toService(a.getChannel(c.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(s=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const r=a.getChannel(c.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const n=A.ProxyChannel.toService(a.getChannel(c.TerminalIpcChannels.PtyHost));return this._register(n.onProcessData(s=>this._onProcessData.fire(s))),this._register(n.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(n.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(n.onProcessTitleChanged(s=>this._onProcessTitleChanged.fire(s))),this._register(n.onProcessShellTypeChanged(s=>this._onProcessShellTypeChanged.fire(s))),this._register(n.onProcessOverrideDimensions(s=>this._onProcessOverrideDimensions.fire(s))),this._register(n.onProcessResolvedShellLaunchConfig(s=>this._onProcessResolvedShellLaunchConfig.fire(s))),this._register(n.onProcessDidChangeHasChildProcesses(s=>this._onProcessDidChangeHasChildProcesses.fire(s))),this._register(n.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(n.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(n.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[a,n]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,r,n,s,u,l,d,g,p,f){const k=setTimeout(()=>this._handleUnresponsiveCreateProcess(),c.HeartbeatConstants.CreateProcessTimeout),O=await this._proxy.createProcess(a,t,r,n,s,u,l,d,g,p,f);return clearTimeout(k),C=Math.max(C,O),O}updateTitle(a,t,r){return this._proxy.updateTitle(a,t,r)}updateIcon(a,t,r){return this._proxy.updateIcon(a,t,r)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,r){return this._proxy.resize(a,t,r)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}setUnicodeVersion(a,t){return this._proxy.setUnicodeVersion(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,r,n=!1){const s=await this._shellEnv;return(0,I.detectAvailableProfiles)(t,r,n,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier+c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${c.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};S=he([Y(1,m.IConfigurationService),Y(2,i.ILogService),Y(3,h.ITelemetryService)],S),e.PtyHostService=S}),define(Z[54],ee([0,1,43]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,P,m,E){const i=(0,D.setProperty)(A,P,m,E)[0];return i&&(A=A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)),A}e.edit=L;function R(A,P,m){let E=m;for(;E>=0;){if(A.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&A.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function T(A,P,m){let E=m;for(;E>=0;)if(A.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&A.charAt(E)===P.charAt(1)))return E;return A.length-1}e.getLineEndOffset=T}),define(Z[196],ee([0,1,26,58]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(v,h,b,c,y){const I=[],w=[],C=[];if(!h){const k=v.filter(({identifier:O})=>y.every(_=>_.toLowerCase()!==O.id.toLowerCase()));return{local:{added:I,removed:w,updated:C},remote:k.length>0?{added:k,updated:[],removed:[],all:k}:null}}v=v.map(E),h=h.map(E),b=b?b.map(E):null;const S=new Map,o=k=>{k.uuid&&S.set(k.id.toLowerCase(),k.uuid)};v.forEach(({identifier:k})=>o(k)),h.forEach(({identifier:k})=>o(k)),b&&b.forEach(({identifier:k})=>o(k));const a=k=>{const O=k.identifier.uuid||S.get(k.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${k.identifier.id.toLowerCase()}`},t=(k,O)=>(k.set(a(O),O),k),r=v.reduce(t,new Map),n=h.reduce(t,new Map),s=h.reduce((k,O)=>{const _=a(O);O=(0,D.deepClone)(O);const z=r.get(_);return z&&(z.installed&&(O.installed=!0),O.version||(O.version=z.version)),t(k,O)},new Map),u=b?b.reduce(t,new Map):null,l=c.reduce(t,new Map),d=y.reduce((k,O)=>{const _=S.get(O.toLowerCase());return k.add(_?`uuid:${_}`:`id:${O.toLowerCase()}`)},new Set),g=T(r,n,d);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const k=T(u,r,d),O=T(u,n,d),_=(z,V)=>{const W=r.get(z);if(W){const U=n.get(z);return{...V?U:W,version:(U.version&&L.gt(U.version,W.version),W.version),state:A(W,U,u?.get(z))}}};for(const z of O.removed.values()){const V=r.get(z);V&&w.push(V.identifier)}for(const z of O.added.values())if(k.added.has(z)){if(g.updated.has(z)){const V=_(z,!0);V&&(C.push(i(V,z)),s.set(z,V))}}else{const V=n.get(z);V.installed&&I.push(i(V,z))}for(const z of O.updated.values()){const V=_(z,!0);V&&(C.push(i(V,z)),s.set(z,V))}for(const z of k.added.values())O.added.has(z)||s.set(z,r.get(z));for(const z of k.updated.values())if(!O.removed.has(z)&&!O.updated.has(z)){const V=_(z,!1);V&&(s.get(z)?.installed&&(V.installed=!0),s.set(z,V))}for(const z of k.removed.values())!l.has(z)&&!O.updated.has(z)&&u?.get(z)?.installed&&s.delete(z)}const p=[],f=T(n,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(f.added.size>0||f.updated.size>0||f.removed.size>0)&&s.forEach((k,O)=>p.push(i(k,O))),{local:{added:I,removed:w,updated:C},remote:p.length?{added:[...f.added].map(k=>s.get(k)),updated:[...f.updated].map(k=>s.get(k)),removed:[...f.removed].map(k=>n.get(k)),all:p}:null}}e.merge=R;function T(v,h,b,{checkInstalledProperty:c,checkVersionProperty:y}={checkInstalledProperty:!1,checkVersionProperty:!1}){const I=v?[...v.keys()].filter(a=>!b.has(a)):[],w=[...h.keys()].filter(a=>!b.has(a)),C=w.filter(a=>I.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),S=I.filter(a=>w.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of I){if(S.has(a))continue;const t=v.get(a),r=h.get(a);(!r||t.disabled!==r.disabled||!m(t.state,r.state)||y&&t.version!==r.version||c&&t.installed!==r.installed)&&o.add(a)}return{added:C,removed:S,updated:o}}function A(v,h,b){const c=v.state,y=h.state,I=b?.state;if(!h.version||c&&L.gt(v.version,h.version))return c;if(y&&L.gt(h.version,v.version)||!c)return y;if(!y)return c;const w=(0,D.deepClone)(c),C=I?P(I,y):{added:Object.keys(y).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},S=I?P(I,c):{added:Object.keys(c).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...C.added.values(),...C.updated.values()])w[o]=y[o];for(const o of C.removed.values())S.updated.has(o)||delete w[o];return w}function P(v,h){const b=Object.keys(v),c=Object.keys(h),y=c.filter(C=>b.indexOf(C)===-1).reduce((C,S)=>(C.add(S),C),new Set),I=b.filter(C=>c.indexOf(C)===-1).reduce((C,S)=>(C.add(S),C),new Set),w=new Set;for(const C of b){if(I.has(C))continue;const S=v[C],o=h[C];(0,D.equals)(S,o)||w.add(C)}return{added:y,removed:I,updated:w}}function m(v={},h={}){const{added:b,removed:c,updated:y}=P(v,h);return b.size===0&&c.size===0&&y.size===0}function E(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function i(v,h){const b={identifier:{id:v.identifier.id,uuid:h.startsWith("uuid:")?h.substring("uuid:".length):void 0}};return v.version&&(b.version=v.version),v.disabled&&(b.disabled=!0),v.installed&&(b.installed=!0),v.state&&(b.state=v.state),b}}),define(Z[87],ee([0,1,19,3,2,31,6,28,20]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class Ze extends R.Disposable{constructor(h,b){super();this.storageService=h,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(c=>this.onDidChangeStorageValue(c)))}static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const b=E.exec(h);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const h=this.storageService.keys(0,1);for(const b of h){const c=Ze.fromKey(b);c&&this.extensionsWithKeysForSync.add(c.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Ze.fromKey(h.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(h,b){this.storageService.store(Ze.toKey(h),JSON.stringify(b),0,1)}getKeysForSync(h){const b=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],c=this.storageService.get(Ze.toKey(h),0),y=c?JSON.parse(c):void 0;return y&&b?(0,D.distinct)([...y,...b]):y||b}};i=he([Y(0,m.IStorageService),Y(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(Z[88],ee([0,1,19,24,6]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,m){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return E=E.filter(i=>i!==P&&i!==`-${P}`),m&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(P,m){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return E=E.filter(i=>i!==P&&i!==`-${P}`),m&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(P){const m=P.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),i=[],v=[];if(Array.isArray(E))for(const h of E)h.startsWith("-")?v.push(h.substring(1)):i.push(h);return(0,D.distinct)([...m,...i].filter(h=>v.indexOf(h)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};T=he([Y(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(Z[197],ee([0,1,19,33,26,150,54]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,L.parse)(o)||[]}e.parseKeybindings=P;async function m(o,a,t,r,n){const s=P(o),u=P(a),l=t?P(t):null,d=[...s,...u,...l||[]].map(M=>M.key),g=await n.resolveUserBindings(d);let p=i(s,u,l,g);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const f=h(s),k=h(u),O=l?h(l):null,_=c(f,k,g),z=O?c(O,f,g):{added:[...f.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set},V=O?c(O,k,g):{added:[...k.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set},W=E(_,z,V);let U=o;for(const M of W.removed.values())W.conflicts.has(M)||(U=C(U,M,r));for(const M of W.added.values()){if(W.conflicts.has(M))continue;const F=k.get(M);if(F.some(q=>q.command!==`-${M}`&&p.conflicts.has(g[q.key]))){W.conflicts.add(M);continue}U=w(U,F,r)}for(const M of W.updated.values()){if(W.conflicts.has(M))continue;const F=k.get(M);if(F.some(q=>q.command!==`-${M}`&&p.conflicts.has(g[q.key]))){W.conflicts.add(M);continue}U=S(U,M,F,r)}return{mergeContent:U,hasChanges:!0,hasConflicts:W.conflicts.size>0}}e.merge=m;function E(o,a,t){const r=new Set,n=new Set,s=new Set,u=new Set;for(const l of a.removed.values())t.updated.has(l)&&u.add(l);for(const l of t.removed.values())u.has(l)||(a.updated.has(l)?u.add(l):n.add(l));for(const l of a.added.values())u.has(l)||t.added.has(l)&&o.updated.has(l)&&u.add(l);for(const l of t.added.values())u.has(l)||(a.added.has(l)?o.updated.has(l)&&u.add(l):r.add(l));for(const l of a.updated.values())u.has(l)||t.updated.has(l)&&o.updated.has(l)&&u.add(l);for(const l of t.updated.values())u.has(l)||(a.updated.has(l)?o.updated.has(l)&&u.add(l):s.add(l));return{added:r,removed:n,updated:s,conflicts:u}}function i(o,a,t,r){const n=new Set,s=v(o,r),u=v(a,r),l=t?v(t,r):null,d=b(s,u);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const g=l?b(l,s):{added:[...s.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=l?b(l,u):{added:[...u.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:k,updated:O,conflicts:_}=E(d,g,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:k,updated:O,conflicts:_}}function v(o,a){const t=new Map;for(const r of o){const n=a[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function h(o){const a=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=a.get(r);n||(n=[],a.set(r,n)),n.push(t)}return a}function b(o,a){const t=[...o.keys()],r=[...a.keys()],n=r.filter(l=>t.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),s=t.filter(l=>r.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),u=new Set;for(const l of t){if(s.has(l))continue;const d=o.get(l).map(p=>({...p,key:l})),g=a.get(l).map(p=>({...p,key:l}));(0,D.equals)(d,g,(p,f)=>I(p,f))||u.add(l)}return{added:n,removed:s,updated:u}}function c(o,a,t){const r=[...o.keys()],n=[...a.keys()],s=n.filter(d=>r.indexOf(d)===-1).reduce((d,g)=>(d.add(g),d),new Set),u=r.filter(d=>n.indexOf(d)===-1).reduce((d,g)=>(d.add(g),d),new Set),l=new Set;for(const d of r){if(u.has(d))continue;const g=o.get(d).map(f=>({...f,key:t[f.key]})),p=a.get(d).map(f=>({...f,key:t[f.key]}));y(g,p)||l.add(d)}return{added:s,removed:u,updated:l}}function y(o,a){return!(!(0,D.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,r)=>I(t,r))||!(0,D.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,r)=>I(t,r)))}function I(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=T.ContextKeyExpr.deserialize(o.when),r=T.ContextKeyExpr.deserialize(a.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!R.equals(o.args,a.args))}function w(o,a,t){for(const r of a)o=A.edit(o,[-1],r,t);return o}function C(o,a,t){const r=P(o);for(let n=r.length-1;n>=0;n--)(r[n].command===a||r[n].command===`-${a}`)&&(o=A.edit(o,[n],void 0,t));return o}function S(o,a,t,r){const n=P(o),s=n.findIndex(u=>u.command===a||u.command===`-${a}`);for(let u=n.length-1;u>=0;u--)(n[u].command===a||n[u].command===`-${a}`)&&(o=A.edit(o,[u],void 0,r));for(let u=t.length-1;u>=0;u--)o=A.edit(o,[s],t[u],r);return o}}),define(Z[198],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,A,P){const m={},E={},i=new Set;if(!A)return{local:{added:m,updated:E,removed:[...i.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const v=L(T,A);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{local:{added:m,updated:E,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=L(P,T),b=L(P,A),c={},y={},I=new Set,w=new Set;for(const C of h.removed.values())b.updated.has(C)?m[C]=A[C]:I.add(C);for(const C of b.removed.values())w.has(C)||(h.updated.has(C)?w.add(C):i.add(C));for(const C of h.updated.values())w.has(C)||(b.updated.has(C)?v.updated.has(C)&&w.add(C):y[C]=T[C]);for(const C of b.updated.values())w.has(C)||(h.updated.has(C)?v.updated.has(C)&&w.add(C):T[C]!==void 0&&(E[C]=A[C]));for(const C of h.added.values())w.has(C)||(b.added.has(C)?v.updated.has(C)&&w.add(C):c[C]=T[C]);for(const C of b.added.values())w.has(C)||(h.added.has(C)?v.updated.has(C)&&w.add(C):m[C]=A[C]);return{local:{added:m,removed:[...i.values()],updated:E},remote:{added:c,removed:[...I.values()],updated:y},conflicts:[...w.values()]}}e.merge=D;function L(T,A){const P=T?Object.keys(T):[],m=A?Object.keys(A):[],E=m.filter(h=>P.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),i=P.filter(h=>m.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),v=new Set;for(const h of P){if(i.has(h))continue;const b=T[h],c=A[h];b!==c&&v.add(h)}return{added:E,removed:i,updated:v}}function R(T,A){const{added:P,removed:m,updated:E}=L(T,A);return P.size===0&&m.size===0&&E.size===0}e.areSame=R}),define(Z[22],ee([0,1,19,15,16,132,38,27,6,81,32]),function(K,e,D,L,R,T,A,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function v(){const l=i.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(d=>!!l[d].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=v;function h(){const l=i.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(l).filter(f=>!!l[f].ignoreSync),g=Object.keys(l).filter(f=>l[f].scope===2||l[f].scope===6),p=v();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...d,...g,...p])}e.getDefaultIgnoredSettings=h;function b(){const l="vscode://schemas/ignoredSettings",d=i.Registry.as(A.Extensions.Configuration);d.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=i.Registry.as(E.Extensions.JSONContribution),p=()=>{const f=v(),k=h().filter(V=>V!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(V=>k.indexOf(V)===-1),_=k.filter(V=>f.indexOf(V)===-1),z={items:{type:"string",enum:[...O,..._.map(V=>`-${V}`)]}};g.registerSchema(l,z)};return d.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=b;function c(l){return l&&(0,R.isObject)(l)&&(0,R.isString)(l.id)&&(0,R.isArray)(l.scopes)}e.isAuthenticationProvider=c;var y;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function I(l,d,g){return g.joinPath(d.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=I,e.IUserDataSyncStoreManagementService=(0,m.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,m.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,m.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function w(l){const d={};return d[e.HEADER_EXECUTION_ID]=l,d}e.createSyncHeaders=w;var C;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class S extends Error{constructor(d,g,p,f){super(d);this.code=g,this.resource=p,this.operationId=f,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=S;class o extends S{constructor(d,g,p,f,k){super(d,p,void 0,k);this.url=g,this.serverCode=f}}e.UserDataSyncStoreError=o;class a extends S{constructor(d,g){super(d,g)}}e.UserDataAutoSyncError=a,function(l){function d(g){if(g instanceof l)return g;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(p&&p[1]){const f=p[2]==="unknown"?void 0:p[2],k=p[3]==="unknown"?void 0:p[3];return new l(g.message,p[1],f,k)}return new l(g.message,"Unknown")}l.toUserDataSyncError=d}(S=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var n;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(l){return`sync.enable.${l}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,m.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,m.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,m.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,m.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,m.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,m.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(l,d){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:d.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,L.isEqualOrParent)(l,(0,L.joinPath)(d.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(Z[46],ee([0,1,19,5,25,29,3,33,2,15,23,16,7,128,24,12,13,45,20,21,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=a;let t=class extends m.Disposable{constructor(l,d,g,p,f,k,O,_,z,V){super();this.resource=l,this.fileService=d,this.environmentService=g,this.userDataSyncStoreService=f,this.userDataSyncBackupStoreService=k,this.userDataSyncResourceEnablementService=O,this.telemetryService=_,this.logService=z,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(g.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,o.PREVIEW_DIR_NAME),this.lastSyncResource=(0,o.getLastSyncResourceUri)(l,g,this.extUri),this.currentMachineIdPromise=(0,w.getServiceMachineId)(g,d,p)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,T.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const d=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,d={}){await this._sync(l,!0,d)}async preview(l,d={}){return this._sync(l,!1,d)}async apply(l,d={}){try{this.syncHeaders={...d};const g=await this.doApply(l);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,d,g){try{if(this.syncHeaders={...g},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let p="idle";try{const f=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(l,f);return p=await this.performSync(k,f,d),p==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):p==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(p)}}finally{this.syncHeaders={}}}async replace(l){const d=await this.resolveContent(l);if(!d)return!1;const g=this.parseSyncData(d);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const p=await this.getLastSyncUserData(),f=await this.getLatestRemoteUserData(null,p),k=await this.isRemoteDataFromCurrentMachine(f),O=await this.generateSyncPreview({ref:f.ref,syncData:g},p,k,T.CancellationToken.None),_=[];for(const z of O){const V=await this.getAcceptResult(z,z.remoteResource,void 0,T.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,T.CancellationToken.None);_.push([z,{...V,remoteChange:W!==0?W:2}])}await this.applyResult(f,p,_,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const d=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===d}async getLatestRemoteUserData(l,d){if(d){const g=l&&l.latest?l.latest[this.resource]:void 0;if(d.ref===g||g===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(l,d,g){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new o.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,d,g)}catch(p){if(p instanceof o.UserDataSyncError)switch(p.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,d,g);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(l,d,g)}throw p}}async doSync(l,d,g){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(f=>this.doGenerateSyncResourcePreview(l,d,g,f)));const p=await this.syncPreviewPromise;return this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(p){throw this.syncPreviewPromise=null,p}}async merge(l){return await this.updateSyncResourcePreview(l,async d=>{const g=await this.getMergeResult(d,T.CancellationToken.None);await this.fileService.writeFile(d.previewResource,R.VSBuffer.fromString(g?.content||""));const p=g&&!g.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,T.CancellationToken.None):void 0;return d.acceptResult=p,d.mergeState=g.hasConflicts?"conflict":p?"accepted":"preview",d.localChange=p?p.localChange:g.localChange,d.remoteChange=p?p.remoteChange:g.remoteChange,d}),this.syncPreviewPromise}async accept(l,d){return await this.updateSyncResourcePreview(l,async g=>{const p=await this.getAcceptResult(g,l,d,T.CancellationToken.None);return g.acceptResult=p,g.mergeState="accepted",g.localChange=p.localChange,g.remoteChange=p.remoteChange,g}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async d=>{const g=await this.getMergeResult(d,T.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,R.VSBuffer.fromString(g.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=g.localChange,d.remoteChange=g.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(l,d){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const p=g.resourcePreviews.findIndex(({localResource:f,remoteResource:k,previewResource:O})=>this.extUri.isEqual(f,l)||this.extUri.isEqual(k,l)||this.extUri.isEqual(O,l));p!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async f=>{const k=[...g.resourcePreviews];return k[p]=await d(k[p]),{...g,resourcePreviews:k}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:f})=>f==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(g=>[g,g.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const d=l.filter(({mergeState:g})=>g==="conflict");(0,D.equals)(this._conflicts,d,(g,p)=>this.extUri.isEqual(g.previewResource,p.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:g})=>({created:d,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:g})=>({created:d,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(l){return h.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return h.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const d=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(d))){const{content:g}=await this.getUserData(d);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(l){const d=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(d))){const{content:g}=await this.getUserData(d);return g}return this.extUri.isEqual(l,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(l){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const g of d.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,l))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,l))return g.remoteContent;if(this.extUri.isEqual(g.localResource,l))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,d,g,p){const f=await this.isRemoteDataFromCurrentMachine(l),k=await this.generateSyncPreview(l,d,f,p),O=[];for(const _ of k){const z=_.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)O.push({..._,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const V=g?await this.getMergeResult(_,p):void 0;if(p.isCancellationRequested)break;await this.fileService.writeFile(_.previewResource,R.VSBuffer.fromString(V?.content||""));const W=V&&!V.hasConflicts?await this.getAcceptResult(_,_.previewResource,void 0,p):void 0;O.push({..._,acceptResult:W,mergeState:V?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:V?V.localChange:_.localChange,remoteChange:W?W.remoteChange:V?V.remoteChange:_.remoteChange})}}return{remoteUserData:l,lastSyncUserData:d,resourcePreviews:O,isLastSyncFromCurrentMachine:f}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(l.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&g&&d.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const p=d;if(p.content===null)return{ref:d.ref,syncData:null};const f=JSON.parse(p.content);if(a(f))return{...d,syncData:f,content:void 0}}catch(l){l instanceof I.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),p={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:g,...d};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(p)))}async getRemoteUserData(l){const{ref:d,content:g}=await this.getUserData(l);let p=null;return g!==null&&(p=this.parseSyncData(g)),{ref:d,syncData:p}}parseSyncData(l){try{const d=JSON.parse(l);if(a(d))return d}catch(d){this.logService.error(d)}throw new o.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,v.isString)(l)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:d}}else{const d=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(l,d){const g=await this.currentMachineIdPromise,p={version:this.version,machineId:g,content:l};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(p),d,this.syncHeaders),{ref:d,syncData:p}}async backupLocal(l){const d={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=he([Y(1,I.IFileService),Y(2,y.IEnvironmentService),Y(3,C.IStorageService),Y(4,o.IUserDataSyncStoreService),Y(5,o.IUserDataSyncBackupStoreService),Y(6,o.IUserDataSyncResourceEnablementService),Y(7,S.ITelemetryService),Y(8,o.IUserDataSyncLogService),Y(9,c.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(l,d,g,p,f,k,O,_,z,V,W){super(d,g,p,f,k,O,_,z,V,W);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,d,g){try{d?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l),g?void 0:d):await this.fileService.createFile(this.file,R.VSBuffer.fromString(l),{overwrite:g})}catch(p){throw p instanceof I.FileOperationError&&p.fileOperationResult===1||p instanceof I.FileOperationError&&p.fileOperationResult===3?new o.UserDataSyncError(p.message,"LocalPreconditionFailed"):p}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};r=he([Y(2,I.IFileService),Y(3,y.IEnvironmentService),Y(4,C.IStorageService),Y(5,o.IUserDataSyncStoreService),Y(6,o.IUserDataSyncBackupStoreService),Y(7,o.IUserDataSyncResourceEnablementService),Y(8,S.ITelemetryService),Y(9,o.IUserDataSyncLogService),Y(10,c.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let n=class extends r{constructor(l,d,g,p,f,k,O,_,z,V,W,U){super(l,d,g,p,f,k,O,_,z,V,U);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(l){const d=[];return(0,P.parse)(l,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=he([Y(2,I.IFileService),Y(3,y.IEnvironmentService),Y(4,C.IStorageService),Y(5,o.IUserDataSyncStoreService),Y(6,o.IUserDataSyncBackupStoreService),Y(7,o.IUserDataSyncResourceEnablementService),Y(8,S.ITelemetryService),Y(9,o.IUserDataSyncLogService),Y(10,o.IUserDataSyncUtilService),Y(11,c.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let s=class{constructor(l,d,g,p){this.resource=l,this.environmentService=d,this.logService=g,this.fileService=p,this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.lastSyncResource=(0,o.getLastSyncResourceUri)(this.resource,d,E.extUri)}async initialize({ref:l,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(d);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:g})}catch(f){this.logService.error(f)}}parseSyncData(l){try{const d=JSON.parse(l);if(a(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,d={}){const g={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...d};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(g)))}};s=he([Y(1,y.IEnvironmentService),Y(2,o.IUserDataSyncLogService),Y(3,I.IFileService)],s),e.AbstractInitializer=s}),define(Z[199],ee([0,1,5,11,3,43,47,23,7,24,12,27,31,13,20,21,46,196,87,88,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(u,l){const d=JSON.parse(u.content);if(u.version===1||u.version===2){const g=(await l.getInstalled(0)).filter(p=>p.isBuiltin);for(const p of d)u.version===1&&(p.enabled===!1&&(p.disabled=!0),delete p.enabled),u.version===2&&g.every(f=>!(0,h.areSameExtensions)(f.identifier,p.identifier))&&(p.installed=!0)}return d}function t(u,l,d){const g=d.get((0,h.getExtensionId)(u,l),0)||"{}";return JSON.parse(g)}e.getExtensionStorageState=t;function r(u,l,d,g){g.store((0,h.getExtensionId)(u,l),JSON.stringify(d),0,1)}e.storeExtensionStorageState=r;let n=class at extends I.AbstractSynchroniser{constructor(l,d,g,p,f,k,O,_,z,V,W,U,M,F){super("extensions",d,l,g,p,f,U,M,z,W);this.storageService=g,this.extensionManagementService=k,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=_,this.extensionGalleryService=V,this.extensionsStorageSyncService=F,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,q=>q.some(({local:x})=>!!x)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(l,d){const g=l.syncData?await a(l.syncData,this.extensionManagementService):null,p=d?.skippedExtensions||[],f=d?.syncData?await a(d.syncData,this.extensionManagementService):null,k=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(k),_=this.ignoredExtensionsManagementService.getIgnoredExtensions(k);g?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:V}=(0,w.merge)(O,g,f,p,_),W={local:z,remote:V,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:p,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:g?this.format(g):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(l,d,g,p){const f=[...d,...g],k=new Set,O=_=>{k.add(_.id.toLowerCase()),_.uuid&&k.add(_.uuid)};f.forEach(({identifier:_})=>O(_)),p.forEach(O);for(const _ of l)k.has(_.identifier.id.toLowerCase())||_.identifier.uuid&&k.has(_.identifier.uuid)||f.push(_);return this.format(f)}async getMergeResult(l,d){return{...l.previewResult,hasConflicts:!1}}async getAcceptResult(l,d,g,p){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(l){const d=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),p=(0,w.merge)(l.localExtensions,null,null,l.skippedExtensions,g),{local:f,remote:k}=p;return{content:l.localContent,local:f,remote:k,localChange:f.added.length>0||f.removed.length>0||f.updated.length>0?2:0,remoteChange:k!==null?2:0}}async acceptRemote(l){const d=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),p=l.remoteContent?JSON.parse(l.remoteContent):null;if(p!==null){const f=(0,w.merge)(l.localExtensions,p,l.localExtensions,[],g),{local:k,remote:O}=f;return{content:l.remoteContent,local:k,remote:O,localChange:k.added.length>0||k.removed.length>0||k.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(l,d,g,p){let{skippedExtensions:f,localExtensions:k}=g[0][0],{local:O,remote:_,localChange:z,remoteChange:V}=g[0][1];if(z===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(k)),f=await this.updateLocalExtensions(O.added,O.removed,O.updated,f)),_){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const W=JSON.stringify(_.all);l=await this.updateRemoteUserData(W,p?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${_.added.length?` Added: ${JSON.stringify(_.added.map(U=>U.identifier.id))}.`:""}${_.updated.length?` Updated: ${JSON.stringify(_.updated.map(U=>U.identifier.id))}.`:""}${_.removed.length?` Removed: ${JSON.stringify(_.removed.map(U=>U.identifier.id))}.`:""}`)}d?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(l,{skippedExtensions:f}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${f.length?` Skipped: ${JSON.stringify(f.map(W=>W.identifier.id))}.`:""}`))}async getAssociatedResources({uri:l}){return[{resource:this.extUri.joinPath(l,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(l){if(this.extUri.isEqual(l,at.EXTENSIONS_DATA_URI)){const g=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),f=this.getLocalExtensions(g).filter(k=>!p.some(O=>(0,h.areSameExtensions)({id:O},k.identifier)));return this.format(f)}if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l))return this.resolvePreviewContent(l);let d=await super.resolveContent(l);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(l)),d){const g=this.parseSyncData(d);if(g)switch(this.extUri.basename(l)){case"extensions.json":return this.format(this.parseExtensions(g))}}return null}format(l){l.sort((p,f)=>!p.identifier.uuid&&f.identifier.uuid?-1:p.identifier.uuid&&!f.identifier.uuid?1:(0,P.compare)(p.identifier.id,f.identifier.id));const d=JSON.stringify(l),g=(0,A.format)(d,void 0,{});return(0,T.applyEdits)(d,g)}async hasLocalData(){try{const l=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(l).some(g=>g.installed||g.disabled))return!0}catch(l){}return!1}async updateLocalExtensions(l,d,g,p){const f=[],k=[],O=await this.extensionManagementService.getInstalled();if(d.length){const z=O.filter(({identifier:V,isBuiltin:W})=>!W&&d.some(U=>(0,h.areSameExtensions)(V,U)));await D.Promises.settled(z.map(async V=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,V.identifier.id),await this.extensionManagementService.uninstall(V,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,V.identifier.id),f.push(V.identifier)}))}(l.length||g.length)&&await D.Promises.settled([...l,...g].map(async z=>{const V=O.find(U=>(0,h.areSameExtensions)(U.identifier,z.identifier));if(V&&V.isBuiltin){z.state&&V.manifest.version===z.version&&this.updateExtensionState(z.state,V.manifest.publisher,V.manifest.name,V.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),f.push(z.identifier);return}const W=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(V?V.manifest.version===z.version:!!W)){const U=V?V.manifest.publisher:W.publisher,M=V?V.manifest.name:W.name;this.updateExtensionState(z.state,U,M,V?.manifest.version)}if(W)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,W.version),await this.extensionEnablementService.disableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,W.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,W.version),await this.extensionEnablementService.enableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,W.version)),V||(await this.extensionManagementService.canInstall(W)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,W.version),await this.extensionManagementService.installFromGallery(W,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,W.version),f.push(W.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,W.displayName||W.identifier.id),k.push(z)))}catch(U){k.push(z),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,W.displayName||W.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.identifier.id),k.push(z)}));const _=[];for(const z of p)f.some(V=>(0,h.areSameExtensions)(V,z.identifier))||_.push(z);for(const z of k)_.some(V=>(0,h.areSameExtensions)(V.identifier,z.identifier))||_.push(z);return _}updateExtensionState(l,d,g,p){const f=t(d,g,this.storageService),k=p?this.extensionsStorageSyncService.getKeysForSync({id:(0,h.getGalleryExtensionId)(d,g),version:p}):void 0;k?k.forEach(O=>{f[O]=l[O]}):Object.keys(l).forEach(O=>f[O]=l[O]),r(d,g,f,this.storageService)}parseExtensions(l){return JSON.parse(l.content)}getLocalExtensions(l){const d=this.extensionEnablementService.getDisabledExtensions();return l.map(({identifier:g,isBuiltin:p,manifest:f})=>{const k={identifier:g,version:f.version};d.some(O=>(0,h.areSameExtensions)(O,g))&&(k.disabled=!0),p||(k.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:g.id,version:f.version});if(O){const _=t(f.publisher,f.name,this.storageService);k.state=Object.keys(_).reduce((z,V)=>(O.includes(V)&&(z[V]=_[V]),z),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(O))}return k})}};n.EXTENSIONS_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=he([Y(0,i.IEnvironmentService),Y(1,b.IFileService),Y(2,c.IStorageService),Y(3,o.IUserDataSyncStoreService),Y(4,o.IUserDataSyncBackupStoreService),Y(5,v.IExtensionManagementService),Y(6,v.IGlobalExtensionEnablementService),Y(7,S.IIgnoredExtensionsManagementService),Y(8,o.IUserDataSyncLogService),Y(9,v.IExtensionGalleryService),Y(10,E.IConfigurationService),Y(11,o.IUserDataSyncResourceEnablementService),Y(12,y.ITelemetryService),Y(13,C.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let s=class extends I.AbstractInitializer{constructor(l,d,g,p,f){super("extensions",p,f,g);this.extensionManagementService=l,this.ignoredExtensionsManagementService=d}async parseExtensions(l){return l.syncData?await a(l.syncData,this.extensionManagementService):null}generatePreview(l,d){const g=[],p=[],f=[];for(const k of l){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(k.identifier.id))continue;const O=d.find(_=>(0,h.areSameExtensions)(_.identifier,k.identifier));O?(g.push(O),k.disabled&&f.push(k.identifier)):k.installed&&(p.push(k.identifier),k.disabled&&f.push(k.identifier))}return{installedExtensions:g,newExtensions:p,disabledExtensions:f,remoteExtensions:l}}};s=he([Y(0,v.IExtensionManagementService),Y(1,S.IIgnoredExtensionsManagementService),Y(2,b.IFileService),Y(3,i.IEnvironmentService),Y(4,o.IUserDataSyncLogService)],s),e.AbstractExtensionsInitializer=s}),define(Z[200],ee([0,1,26,22]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,m,E,i,v){if(!m)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const h=T(P,m);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=E?T(E,m):{added:Object.keys(m).reduce((C,S)=>(C.add(S),C),new Set),removed:new Set,updated:new Set},c=E?T(E,P):{added:Object.keys(P).reduce((C,S)=>(C.add(S),C),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},I=D.deepClone(m),w=!E;for(const C of c.added.values())C!==L.SYNC_SERVICE_URL_TYPE&&w&&b.added.has(C)||(I[C]=P[C]);for(const C of c.updated.values())I[C]=P[C];for(const C of c.removed.values())i.unregistered.includes(C)||delete I[C];for(const C of b.added.values()){const S=m[C];if(i.machine.includes(C)){v.info(`GlobalState: Skipped adding ${C} in local storage because it is declared as machine scoped.`);continue}if(E&&c.added.has(C))continue;const o=P[C];o&&o.value===S.value||C===L.SYNC_SERVICE_URL_TYPE&&w&&c.added.has(C)||(o?y.updated[C]=S:y.added[C]=S)}for(const C of b.updated.values()){const S=m[C];if(i.machine.includes(C)){v.info(`GlobalState: Skipped updating ${C} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(C)||c.removed.has(C))continue;const o=P[C];o&&o.value===S.value||(y.updated[C]=S)}for(const C of b.removed.values()){if(i.machine.includes(C)){v.trace(`GlobalState: Skipped removing ${C} in local storage because it is declared as machine scoped.`);continue}c.updated.has(C)||c.removed.has(C)||y.removed.push(C)}return{local:y,remote:A(I,m)?null:I}}e.merge=R;function T(P,m){const E=Object.keys(P),i=Object.keys(m),v=i.filter(c=>E.indexOf(c)===-1).reduce((c,y)=>(c.add(y),c),new Set),h=E.filter(c=>i.indexOf(c)===-1).reduce((c,y)=>(c.add(y),c),new Set),b=new Set;for(const c of E){if(h.has(c))continue;const y=P[c],I=m[c];D.equals(y,I)||b.add(c)}return{added:v,removed:h,updated:b}}function A(P,m){const{added:E,removed:i,updated:v}=T(P,m);return E.size===0&&i.size===0&&v.size===0}}),define(Z[201],ee([0,1,25,3,33,43,47,4,7,30,24,12,13,14,45,20,21,46,54,200,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function r(d){const g=d.storage?Object.keys(d.storage).sort():[],p={};g.forEach(O=>p[O]=d.storage[O]),d.storage=p;const f=JSON.stringify(d),k=(0,A.format)(f,void 0,{});return(0,T.applyEdits)(f,k)}const n=1;let s=class ot extends w.AbstractSynchroniser{constructor(g,p,f,k,O,_,z,V,W){super("globalState",g,O,W,p,f,_,z,k,V);this.storageService=W,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(g.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter(W.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:W.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,p,f,k){const O=g.syncData?JSON.parse(g.syncData.content):null;p=p===null&&f?g:p;const _=p&&p.syncData?JSON.parse(p.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=this.getStorageKeys(_),{local:W,remote:U}=(0,S.merge)(z.storage,O?O.storage:null,_?_.storage:null,V,this.logService),M={content:null,local:W,remote:U,localChange:Object.keys(W.added).length>0||Object.keys(W.updated).length>0||W.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource,storageKeys:V}]}async getMergeResult(g,p){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,p,f,k){if(this.extUri.isEqual(p,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(p,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(p,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const p=JSON.parse(g.remoteContent),{local:f,remote:k}=(0,S.merge)(g.localUserData.storage,p.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:f,remote:k,localChange:Object.keys(f.added).length>0||Object.keys(f.updated).length>0||f.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,p,f,k){let{localUserData:O}=f[0][0],{local:_,remote:z,localChange:V,remoteChange:W}=f[0][1];if(V===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState(_),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),W!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:z});g=await this.updateRemoteUserData(U,k?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}p?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,ot.GLOBAL_STATE_DATA_URI)){const f=await this.getLocalGlobalState();return r(f)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let p=await super.resolveContent(g);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(g)),p){const f=this.parseSyncData(p);if(f)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(f.content))}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${a}.locale`]?.value!=="en")return!0}catch(g){}return!1}async getLocalGlobalState(){const g={},p=await this.getLocalArgvContent(),f=(0,R.parse)(p);for(const k of t)f[k]!==void 0&&(g[`${a}${k}`]={version:1,value:f[k]});for(const k of this.storageService.keys(0,0)){const O=this.storageService.get(k,0);O&&(g[k]={version:1,value:O})}return{storage:g}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(g){}return"{}"}async writeLocalGlobalState({added:g,removed:p,updated:f}){const k={},O={},_=(V,W)=>{for(const U of V){if(U.startsWith(a)){k[U.substring(a.length)]=W?W[U].value:void 0;continue}if(W){const M=W[U];M.value!==String(this.storageService.get(U,0))&&(O[U]=M.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if(_(Object.keys(g),g),_(Object.keys(f),f),_(p),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(O))this.storageService.store(V,O[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(g){const p=await this.getLocalArgvContent();let f=p;for(const k of Object.keys(g))f=(0,C.edit)(f,[k],g[k],{});p!==f&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(f)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const p=this.storageService.keys(0,0),f=this.storageService.keys(0,1),k=[...p,...f],O=g?.storage?Object.keys(g.storage).filter(_=>!_.startsWith(a)&&!k.includes(_)&&this.storageService.get(_,0)!==void 0):[];if(!P.isWeb){const _=[...o.ALL_SYNC_RESOURCES.map(z=>(0,o.getEnablementKey)(z)),o.SYNC_SERVICE_URL_TYPE];O.push(..._),f.push(..._)}return{user:p,machine:f,unregistered:O}}};s.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=he([Y(0,h.IFileService),Y(1,o.IUserDataSyncStoreService),Y(2,o.IUserDataSyncBackupStoreService),Y(3,o.IUserDataSyncLogService),Y(4,v.IEnvironmentService),Y(5,o.IUserDataSyncResourceEnablementService),Y(6,I.ITelemetryService),Y(7,i.IConfigurationService),Y(8,y.IStorageService)],s),e.GlobalStateSynchroniser=s;let u=class extends w.AbstractInitializer{constructor(g,p,f,k){super("globalState",f,k,p);this.storageService=g}async doInitialize(g){const p=g.syncData?JSON.parse(g.syncData.content):null;if(!p){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const f={},k={};for(const O of Object.keys(p.storage))O.startsWith(a)?f[O.substring(a.length)]=p.storage[O].value:this.storageService.get(O,0)===void 0&&(k[O]=p.storage[O].value);if(Object.keys(f).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(_){}for(const _ of Object.keys(f))O=(0,C.edit)(O,[_],f[_],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(O))}if(Object.keys(k).length)for(const O of Object.keys(k))this.storageService.store(O,k[O],0,0)}};u=he([Y(0,y.IStorageService),Y(1,h.IFileService),Y(2,v.IEnvironmentService),Y(3,o.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let l=class{constructor(g,p,f,k,O){this.userDataSyncStoreClient=g,this.storageService=p,this.environmentService=f,this.fileService=k,this.logService=O}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[o.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const p=(0,o.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(g,p)}catch(f){if(f instanceof o.UserDataSyncError)switch(f.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,p)}throw f}}async doSync(g,p){const f=await this.userDataSyncStoreClient.read("globalState",null,p),k=this.parseGlobalState(f)||{storage:{}};k.storage[o.SYNC_SERVICE_URL_TYPE]={value:g,version:n};const O=await(0,c.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),_={version:n,machineId:O,content:r(k)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(_),f.ref,p)}parseGlobalState({content:g}){if(!g)return null;const p=JSON.parse(g);if((0,w.isSyncData)(p))return p?JSON.parse(p.content):null;throw new Error("Invalid remote data")}};l=he([Y(1,y.IStorageService),Y(2,v.IEnvironmentService),Y(3,h.IFileService),Y(4,b.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[202],ee([0,1,19,25,3,33,4,16,129,24,12,13,20,21,46,197,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(o,a){const t=JSON.parse(o);if(!a)return(0,P.isUndefined)(t.all)?null:t.all;switch(A.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=w;let C=class extends c.AbstractJsonFileSynchroniser{constructor(a,t,r,n,s,u,l,d,g,p){super(l.keybindingsResource,"keybindings",u,l,d,a,t,s,p,r,g,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(n.onDidChangeConfiguration,f=>f.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,r,n){const s=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&r?a:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),d=await this.getFormattingOptions();let g=null,p=!1,f=!1,k=!1;if(s){let _=l?l.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new I.UserDataSyncError((0,m.localize)(0,null),"LocalInvalidContent",this.resource);if(!u||u!==_||u!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,y.merge)(_,s,u,d,this.userDataSyncUtilService);z.hasChanges&&(g=z.mergeContent,k=z.hasConflicts,p=k||z.mergeContent!==_,f=k||z.mergeContent!==s)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=l.value.toString(),f=!0);const O={content:g,localChange:p?l?2:1:0,remoteChange:f?2:0,hasConflicts:k};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,r,n){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,r,n){const{fileContent:s}=r[0][0];let{content:u,localChange:l,remoteChange:d}=r[0][1];if(l===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new I.UserDataSyncError((0,m.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(u||"[]",s,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(u||"[]",a.syncData?.content);a=await this.updateRemoteUserData(g,n?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(g){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,T.parse)(a.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return w(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let r={};try{r=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=a,A.OS){case 2:r.mac=a;break;case 3:r.linux=a;break;case 1:r.windows=a;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let a=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return a!==void 0||(a=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,a!==void 0)?a:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};C=he([Y(0,I.IUserDataSyncStoreService),Y(1,I.IUserDataSyncBackupStoreService),Y(2,I.IUserDataSyncLogService),Y(3,E.IConfigurationService),Y(4,I.IUserDataSyncResourceEnablementService),Y(5,v.IFileService),Y(6,i.IEnvironmentService),Y(7,h.IStorageService),Y(8,I.IUserDataSyncUtilService),Y(9,b.ITelemetryService)],C),e.KeybindingsSynchroniser=C;let S=class extends c.AbstractInitializer{constructor(a,t,r){super("keybindings",t,r,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(a.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return w(a,!0)}catch(t){return this.logService.error(t),null}}};S=he([Y(0,v.IFileService),Y(1,i.IEnvironmentService),Y(2,I.IUserDataSyncLogService)],S),e.KeybindingsInitializer=S}),define(Z[203],ee([0,1,19,33,43,47,26,54,22]),function(K,e,D,L,R,T,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(l,d,g){let p=[];g?p=v(g):p=i(d);const f=[],k=[...(0,m.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const O of p)O.startsWith("-")?k.push(O.substring(1)):f.push(O);return(0,D.distinct)([...l,...f].filter(O=>k.indexOf(O)===-1))}e.getIgnoredSettings=E;function i(l){let d=l.inspect("settingsSync.ignoredSettings").userValue;return d!==void 0||(d=l.inspect("sync.ignoredSettings").userValue,d!==void 0)?d:l.getValue("settingsSync.ignoredSettings")||[]}function v(l){const d=(0,L.parse)(l);return d?d["settingsSync.ignoredSettings"]||d["sync.ignoredSettings"]||[]:[]}function h(l,d,g,p){if(g.length){const f=u(d),k=(0,L.parse)(d),O=(0,L.parse)(l),_=[];for(const z of g){const V=k[z],W=O[z];V===void 0?l=P.edit(l,[z],void 0,p):W!==void 0?l=P.edit(l,[z],V,p):_.push(a(z,f))}_.sort((z,V)=>z.startOffset-V.startOffset),_.forEach(z=>l=w(z.setting.key,d,l,p))}return l}e.updateIgnoredSettings=h;function b(l,d,g,p,f,k){const O=h(l,d,p,k),_=g!==O,z=g!==d;if(!_&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(_&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!_)return{conflictsSettings:[],localContent:h(d,l,p,k),remoteContent:null,hasConflicts:!1};if(g===null&&y(l)){const te=c(l,d,p)?null:h(d,l,p,k);return{conflictsSettings:[],localContent:te,remoteContent:null,hasConflicts:!1}}let V=l,W=d;const U=(0,L.parse)(l),M=(0,L.parse)(d),F=g?(0,L.parse)(g):null,q=p.reduce((te,oe)=>(te.add(oe),te),new Set),x=I(U,M,q),N=I(F,U,q),j=I(F,M,q),$=new Map,H=new Set,G=te=>{H.add(te);const oe=f.filter(({key:ue})=>ue===te)[0];oe?(V=P.edit(V,[te],oe.value,k),W=P.edit(W,[te],oe.value,k)):$.set(te,{key:te,localValue:U[te],remoteValue:M[te]})};for(const te of N.removed.values())j.updated.has(te)?G(te):W=P.edit(W,[te],void 0,k);for(const te of j.removed.values())H.has(te)||(N.updated.has(te)?G(te):V=P.edit(V,[te],void 0,k));for(const te of N.updated.values())H.has(te)||(j.updated.has(te)?x.updated.has(te)&&G(te):W=P.edit(W,[te],U[te],k));for(const te of j.updated.values())H.has(te)||(N.updated.has(te)?x.updated.has(te)&&G(te):V=P.edit(V,[te],M[te],k));for(const te of N.added.values())H.has(te)||(j.added.has(te)?x.updated.has(te)&&G(te):W=w(te,V,W,k));for(const te of j.added.values())H.has(te)||(N.added.has(te)?x.updated.has(te)&&G(te):V=w(te,W,V,k));const Q=$.size>0||!c(V,W,p),X=Q||!c(V,l,[]),ie=Q||!c(W,d,[]);return{localContent:X?V:null,remoteContent:ie?W:null,conflictsSettings:[...$.values()],hasConflicts:Q}}e.merge=b;function c(l,d,g){if(l===d)return!0;const p=(0,L.parse)(l),f=(0,L.parse)(d),k=g.reduce((z,V)=>(z.add(V),z),new Set),O=u(l).filter(z=>!(z.setting&&k.has(z.setting.key))),_=u(d).filter(z=>!(z.setting&&k.has(z.setting.key)));if(O.length!==_.length)return!1;for(let z=0;z<O.length;z++){const V=O[z],W=_[z];if(V.setting&&W.setting){if(V.setting.key!==W.setting.key||!A.equals(p[V.setting.key],f[V.setting.key]))return!1}else if(!V.setting&&!W.setting){if(V.value!==W.value)return!1}else return!1}return!0}e.areSame=c;function y(l){return l?u(l).length===0:!0}e.isEmpty=y;function I(l,d,g){const p=l?Object.keys(l).filter(z=>!g.has(z)):[],f=Object.keys(d).filter(z=>!g.has(z)),k=f.filter(z=>p.indexOf(z)===-1).reduce((z,V)=>(z.add(V),z),new Set),O=p.filter(z=>f.indexOf(z)===-1).reduce((z,V)=>(z.add(V),z),new Set),_=new Set;if(l)for(const z of p){if(O.has(z))continue;const V=l[z],W=d[z];A.equals(V,W)||_.add(z)}return{added:k,removed:O,updated:_}}function w(l,d,g,p){const f=(0,L.parse)(d),k=u(d),O=u(g),_=C(l,k,O);return S(g,l,f[l],_,O,p)}e.addSetting=w;function C(l,d,g){const p=d.findIndex(k=>k.setting?.key===l),f=d[p-1];if(f){if(f.setting){const O=a(f.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!0}}else{const O=t(p,d);if(O){const _=a(O.setting.key,g);if(_){const z=r(g.indexOf(_),g),V=n(d,O,d[p]);if(z){const W=n(g,_,z),U=s(V,W);return U?{index:g.indexOf(U),insertAfter:!0}:{index:g.indexOf(z),insertAfter:!1}}else{const W=n(g,_,g[g.length-1]),U=s(V,W);return U?{index:g.indexOf(U),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const k=d[p+1];if(k)if(k.setting){const O=a(k.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!1}}else{const O=r(p,d);if(O){const _=a(O.setting.key,g);if(_){const z=t(g.indexOf(_),g),V=n(d,d[p],O);if(z){const W=n(g,z,_),U=s(V.reverse(),W.reverse());return U?{index:g.indexOf(U),insertAfter:!1}:{index:g.indexOf(z),insertAfter:!0}}else{const W=n(g,g[0],_),U=s(V.reverse(),W.reverse());return U?{index:g.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function S(l,d,g,p,f,k){let O;return p.index===-1?O=(0,R.setProperty)(l,[d],g,k):O=o(l,d,g,p,f,k).map(_=>(0,R.withFormatting)(l,_,k)[0]),(0,R.applyEdits)(l,O)}function o(l,d,g,p,f,k){const O=`${JSON.stringify(d)}: ${JSON.stringify(g)}`,_=(0,T.getEOL)(k,l),z=f[p.index];if(p.insertAfter){const V=[];if(z.setting)V.push({offset:z.endOffset,length:0,content:","+O});else{const W=r(p.index,f),U=t(p.index,f),M=U?.setting?.commaOffset;U&&M===void 0&&V.push({offset:U.endOffset,length:0,content:","});const F=M!==void 0&&M>z.endOffset;V.push({offset:F?M+1:z.endOffset,length:0,content:W?_+O+",":_+O})}return V}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const V=(f[p.index-1]&&!f[p.index-1].setting?_:"")+O+(r(p.index,f)?",":"")+_;return[{offset:z.startOffset,length:0,content:V}]}}function a(l,d){return d.filter(g=>g.setting?.key===l)[0]}function t(l,d){for(let g=l-1;g>=0;g--)if(d[g].setting)return d[g]}function r(l,d){for(let g=l+1;g<d.length;g++)if(d[g].setting)return d[g]}function n(l,d,g){const p=l.indexOf(d),f=l.indexOf(g);return l.filter((k,O)=>p<O&&O<f)}function s(l,d){if(l.length&&d.length){let g=0;for(;g<d.length&&g<l.length;g++)if(l[g].value!==d[g].value)return d[g-1];return d[g-1]}}function u(l){const d=[];let g=-1,p,f;const k={onObjectBegin:O=>{g++},onObjectProperty:(O,_,z)=>{g===0&&(p=_,f=O)},onObjectEnd:(O,_)=>{g--,g===0&&d.push({startOffset:p,endOffset:O+_,value:l.substring(p,O+_),setting:{key:f,commaOffset:void 0}})},onArrayBegin:(O,_)=>{g++},onArrayEnd:(O,_)=>{g--,g===0&&d.push({startOffset:p,endOffset:O+_,value:l.substring(p,O+_),setting:{key:f,commaOffset:void 0}})},onLiteralValue:(O,_,z)=>{g===0&&d.push({startOffset:p,endOffset:_+z,value:l.substring(p,_+z),setting:{key:f,commaOffset:void 0}})},onSeparator:(O,_,z)=>{if(g===0&&O===","){let V=d.length-1;for(;V>=0&&!d[V].setting;V--);const W=d[V];W&&d.splice(V,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:_}})}},onComment:(O,_)=>{g===0&&d.push({startOffset:O,endOffset:O+_,value:l.substring(O,O+_)})}};return(0,L.visit)(l,k),d}}),define(Z[204],ee([0,1,25,3,43,130,24,12,27,13,20,21,46,54,203,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function I(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function w(a){const t=JSON.parse(a);return I(t)?t:{settings:a}}e.parseSettingsSyncContent=w;let C=class extends h.AbstractJsonFileSynchroniser{constructor(t,r,n,s,u,l,d,g,p,f,k){super(r.settingsResource,"settings",t,r,n,s,u,p,f,l,d,g);this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,n,s){const u=await this.getLocalFileContent(),l=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t);r=r===null&&n?t:r;const g=r?this.getSettingsSyncContent(r):null,p=await this.getIgnoredSettings();let f=null,k=!1,O=!1,_=!1;if(d){let V=u?u.value.toString().trim():"{}";V=V||"{}",this.validateContent(V),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const W=(0,c.merge)(V,d.settings,g?g.settings:null,p,[],l);f=W.localContent||W.remoteContent,k=W.localContent!==null,O=W.remoteContent!==null,_=W.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),f=u.value.toString(),O=!0);const z={content:f,localChange:k?2:0,remoteChange:O?2:0,hasConflicts:_};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:d?d.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,c.updateIgnoredSettings)(t.previewResult.content,"{}",s,n):null}}async getAcceptResult(t,r,n,s){const u=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,c.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,c.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,c.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,n,s){const{fileContent:u}=n[0][0];let{content:l,localChange:d,remoteChange:g}=n[0][1];if(d===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(l,u,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const p=await this.getFormattingOptions(),f=this.getSettingsSyncContent(t),k=await this.getIgnoredSettings(l);l=(0,c.updateIgnoredSettings)(l,f?f.settings:"{}",k,p),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(p){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),n=(0,b.edit)(t.value.toString(),[y.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,c.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const n=this.parseSyncData(r);if(n){const s=this.parseSettingsSyncContent(n.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,c.updateIgnoredSettings)(r,"{}",s,n)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return w(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:u})=>!!u)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,c.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new y.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(r.content);if(!n||!n.settings)return;let s=n.settings;const u=await this.getFormattingOptions();for(const l in r)if(["version","content","machineId"].indexOf(l)===-1&&r[l]!==void 0){const d=(0,R.setProperty)(s,[l],r[l],u);d.length&&(s=(0,R.applyEdits)(s,d))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(s))}catch(t){}}};C=he([Y(0,E.IFileService),Y(1,P.IEnvironmentService),Y(2,i.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,y.IUserDataSyncUtilService),Y(7,A.IConfigurationService),Y(8,y.IUserDataSyncResourceEnablementService),Y(9,v.ITelemetryService),Y(10,m.IExtensionManagementService)],C),e.SettingsSynchroniser=C;let S=class extends h.AbstractInitializer{constructor(t,r,n){super("settings",r,n,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,c.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return w(t)}catch(r){this.logService.error(r)}return null}};S=he([Y(0,E.IFileService),Y(1,P.IEnvironmentService),Y(2,y.IUserDataSyncLogService)],S),e.SettingsInitializer=S;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(Z[205],ee([0,1,25,3,26,24,12,13,20,21,46,198,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends i.AbstractSynchroniser{constructor(I,w,C,S,o,a,t,r,n){super("snippets",w,I,C,S,o,r,n,a,t);this.version=1,this.snippetsFolder=I.snippetsHome,this._register(this.fileService.watch(I.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(I,w,C,S){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=I.syncData?this.parseSnippets(I.syncData):null;w=w===null&&C?I:w;const r=w&&w.syncData?this.parseSnippets(w.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,v.merge)(a,t,r);return this.getResourcePreviews(n,o,t||{})}async getMergeResult(I,w){return I.previewResult}async getAcceptResult(I,w,C,S){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:0,remoteChange:I.fileContent?I.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return C===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:C,localChange:C===null?I.fileContent!==null?3:0:2,remoteChange:C===null?I.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(I,w,C,S){const o=C.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,S)),o.some(({remoteChange:a})=>a!==0)&&(I=await this.updateRemoteSnippets(o,I,S)),w?.ref!==I.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(I),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(I,w,C){const S=new Map;for(const o of Object.keys(I.local.added)){const a={content:I.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};S.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(I.local.updated)){const a={content:I.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of I.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(I.remote.added)){const a={content:I.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(I.remote.updated)){const a={content:I.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of I.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of I.conflicts){const a={content:w[o]?w[o].value.toString():null,hasConflicts:!0,localChange:w[o]?2:1,remoteChange:C[o]?2:1};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o]||null,localContent:w[o]?w[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(w))if(!S.has(o)){const a={content:w[o]?w[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o]||null,localContent:w[o]?w[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:I}){let w=await super.resolveContent(I);if(w){const C=this.parseSyncData(w);if(C){const S=this.parseSnippets(C),o=[];for(const a of Object.keys(S)){const t=this.extUri.joinPath(I,a),r=this.extUri.joinPath(this.snippetsFolder,a),n=await this.fileService.exists(r);o.push({resource:t,comparableResource:n?r:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(I){if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(I);let w=await super.resolveContent(I);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(I)),w){const C=this.parseSyncData(w);if(C)return this.parseSnippets(C)[this.extUri.basename(I)]||null}return null}async hasLocalData(){try{const I=await this.getSnippetsFileContents();if(Object.keys(I).length)return!0}catch(I){}return!1}async updateLocalBackup(I){const w={};for(const C of I)C.fileContent&&(w[this.extUri.basename(C.localResource)]=C.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(I,w){for(const{fileContent:C,acceptResult:S,localResource:o,remoteResource:a,localChange:t}of I)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(o),n=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,D.VSBuffer.fromString(S.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,D.VSBuffer.fromString(S.content),w?void 0:C),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(I,w,C){const S=w.syncData?this.parseSnippets(w.syncData):{},o=(0,R.deepClone)(S);for(const{acceptResult:a,localResource:t,remoteResource:r,remoteChange:n}of I)if(n!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);n===3?delete o[s]:o[s]=a.content}return(0,v.areSame)(S,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(o),C?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(I){return JSON.parse(I.content)}toSnippetsContents(I){const w={};for(const C of Object.keys(I))w[C]=I[C].value.toString();return w}async getSnippetsFileContents(){const I={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(C){if(C instanceof P.FileOperationError&&C.fileOperationResult===1)return I;throw C}for(const C of w.children||[]){const S=C.resource,o=this.extUri.extname(S);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,S),t=await this.fileService.readFile(S);I[a]=t}}return I}};b=he([Y(0,A.IEnvironmentService),Y(1,P.IFileService),Y(2,m.IStorageService),Y(3,h.IUserDataSyncStoreService),Y(4,h.IUserDataSyncBackupStoreService),Y(5,h.IUserDataSyncLogService),Y(6,T.IConfigurationService),Y(7,h.IUserDataSyncResourceEnablementService),Y(8,E.ITelemetryService)],b),e.SnippetsSynchroniser=b;let c=class extends i.AbstractInitializer{constructor(I,w,C){super("snippets",w,C,I)}async doInitialize(I){const w=I.syncData?JSON.parse(I.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(w)){const o=w[S];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(a,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(I)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===1}}};c=he([Y(0,P.IFileService),Y(1,A.IEnvironmentService),Y(2,h.IUserDataSyncLogService)],c),e.SnippetsInitializer=c}),define(Z[60],ee([0,1,3,2,6,22]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};A=he([Y(0,T.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(Z[206],ee([0,1,5,25,56,2,15,24,12,13,22]),function(K,e,D,L,R,T,A,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let v=class extends T.Disposable{constructor(b,c,y,I){super();this.environmentService=b,this.fileService=c,this.configurationService=y,this.logService=I,i.ALL_SYNC_RESOURCES.forEach(w=>this.cleanUpBackup(w))}async getAllRefs(b){const c=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),y=await this.fileService.resolve(c);return y.children?y.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort().reverse().map(w=>({ref:w.name,created:this.getCreationTime(w)})):[]}async resolveContent(b,c){if(!c){const y=await this.getAllRefs(b);y.length&&(c=y[y.length-1].ref)}if(c){const y=(0,A.joinPath)(this.environmentService.userDataSyncHome,b,c);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(b,c){const y=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),I=(0,A.joinPath)(y,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(I,L.VSBuffer.fromString(c))}catch(w){this.logService.error(w)}try{this.cleanUpBackup(b)}catch(w){}}async cleanUpBackup(b){const c=(0,A.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(c))return}catch(I){return}const y=await this.fileService.resolve(c);if(y.children){const I=y.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),w=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let C=I.filter(o=>Date.now()-this.getCreationTime(o)>w);const S=I.length-C.length;S<10&&(C=C.slice(10-S)),await D.Promises.settled(C.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};v=he([Y(0,m.IEnvironmentService),Y(1,E.IFileService),Y(2,P.IConfigurationService),Y(3,i.IUserDataSyncLogService)],v),e.UserDataSyncBackupStoreService=v}),define(Z[207],ee([0,1,2,7]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(h){this.service=h}listen(h,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(h,b,c){switch(b){case"triggerSync":return this.service.triggerSync(c[0],c[1],c[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(c[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(h){this.service=h}listen(h,b){throw new Error(`Event not found: ${b}`)}call(h,b,c){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(c[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(c[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(h){this.channel=h}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(h){return this.channel.call("resolveUserKeybindings",[h])}async resolveFormattingOptions(h){return this.channel.call("resolveFormattingOptions",[h])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(h,b,c){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(c[0],c[1]);case"setEnablement":return this.service.setEnablement(c[0],c[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class m{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(h,b,c){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(c)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class E{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(h,b,c){switch(b){case"switch":return this.service.switch(c[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class i extends D.Disposable{constructor(h){super();this.channel=h,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(h){return this.channel.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(h)}revive(h){return{url:L.URI.revive(h.url),type:h.type,defaultUrl:L.URI.revive(h.defaultUrl),insidersUrl:L.URI.revive(h.insidersUrl),stableUrl:L.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(Z[208],ee([0,1,12,14]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};R=he([Y(0,L.ILoggerService),Y(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(Z[61],ee([0,1,3,2,4,23,133,12,13,6,28,45,20,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const c="sync.currentMachineName";let y=class Ke extends L.Disposable{constructor(w,C,S,o,a,t){super();this.storageService=S,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,v.getServiceMachineId)(w,C,S)}async getMachines(w){const C=await this.currentMachineIdPromise;return(await this.readMachinesData(w)).machines.map(o=>({...o,isCurrent:o.id===C}))}async addCurrentMachine(w){const C=await this.currentMachineIdPromise,S=await this.readMachinesData(w);S.machines.some(({id:o})=>o===C)||(S.machines.push({id:C,name:this.computeCurrentMachineName(S.machines)}),await this.writeMachinesData(S))}async removeCurrentMachine(w){const C=await this.currentMachineIdPromise,S=await this.readMachinesData(w),o=S.machines.filter(({id:a})=>a!==C);o.length!==S.machines.length&&(S.machines=o,await this.writeMachinesData(S))}async renameMachine(w,C,S){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(S),t=a.machines.find(({id:r})=>r===w);t&&(t.name=C,await this.writeMachinesData(a),a.machines.some(({id:r})=>r===o)&&this.storageService.store(c,C,0,1))}async setEnablement(w,C){const S=await this.readMachinesData(),o=S.machines.find(({id:a})=>a===w);o&&(o.disabled=C?void 0:!0,await this.writeMachinesData(S))}computeCurrentMachineName(w){const C=this.storageService.get(c,0);if(C)return C;const S=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,o=new RegExp(`${(0,T.escapeRegExpCharacters)(S)}\\s#(\\d+)`);let a=0;for(const t of w){const r=o.exec(t.name),n=r?parseInt(r[1]):0;a=n>a?n:a}return`${S} #${a+1}`}async readMachinesData(w){this.userData=await this.readUserData(w);const C=this.parse(this.userData);if(C.version!==Ke.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return C}async writeMachinesData(w){const C=JSON.stringify(w),S=await this.userDataSyncStoreService.write(Ke.RESOURCE,C,this.userData?.ref||null);this.userData={ref:S,content:C},this._onDidChange.fire()}async readUserData(w){if(this.userData){const C=w&&w.latest?w.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===C)return this.userData;if(C===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(w){if(w.content!==null)try{return JSON.parse(w.content)}catch(C){this.logService.error(C)}return{version:Ke.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=he([Y(0,P.IEnvironmentService),Y(1,m.IFileService),Y(2,h.IStorageService),Y(3,b.IUserDataSyncStoreService),Y(4,b.IUserDataSyncLogService),Y(5,i.IProductService)],y),e.UserDataSyncMachinesService=y}),define(Z[89],ee([0,1,5,56,37,11,3,2,4,15,7,131,12,28,20,21,22,60,61]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const S="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let n=class extends P.Disposable{constructor(d,g,p){super();this.storageService=d,this.environmentService=g,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new A.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(d.onDidChangeValue(f=>this.onDidStorageChange(f)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(S,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||this.storageService.store(S,d,0,1)}onDidStorageChange(d){if(d.scope===0&&S===d.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=he([Y(0,c.IStorageService),Y(1,h.IEnvironmentService),Y(2,I.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let s=class extends P.Disposable{constructor(d,g,p,f,k,O,_,z,V,W,U){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=p,this.userDataSyncResourceEnablementService=f,this.userDataSyncService=k,this.logService=O,this.userDataSyncAccountService=_,this.telemetryService=z,this.userDataSyncMachinesService=V,this.storageService=W,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=d.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(p.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(k.onDidChangeLocal,(M,F)=>M?[...M,F]:[F],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(A.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const d=this.storageService.get(t,0);return d?i.URI.parse(d):void 0}set syncUrl(d){d?this.storageService.store(t,d.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(d){d?this.storageService.store(r,d,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:d,message:g}=this.isAutoSyncEnabled();d?this.autoSync.value===void 0&&(this.autoSync.value=new u(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(p=>this.onDidFinishSync(p))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(d,g,p){try{this.userDataSyncAccountService.account&&!p&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),d?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(f){if(g)this.logService.error(f),this.updateEnablement(!1);else throw f}}updateEnablement(d){this.userDataAutoSyncEnablementService.isEnabled()!==d&&(this.telemetryService.publicLog2(S,{enabled:d}),this.userDataAutoSyncEnablementService.setEnablement(d),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(d){if(!d){this.successiveFailures=0;return}const g=I.UserDataSyncError.toUserDataSyncError(d);g instanceof I.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?m.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(d,g,p){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...d),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",p)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=he([Y(0,b.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncResourceEnablementService),Y(4,I.IUserDataSyncService),Y(5,I.IUserDataSyncLogService),Y(6,w.IUserDataSyncAccountService),Y(7,y.ITelemetryService),Y(8,C.IUserDataSyncMachinesService),Y(9,c.IStorageService),Y(10,I.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class u extends P.Disposable{constructor(d,g,p,f,k,O,_,z){super();this.lastSyncUrl=d,this.interval=g,this.userDataSyncStoreManagementService=p,this.userDataSyncStoreService=f,this.userDataSyncService=k,this.userDataSyncMachinesService=O,this.logService=_,this.storageService=z,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(u.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(u.INTERVAL_SYNCING,!1),this.interval)}sync(d,g){const p=(0,D.createCancelablePromise)(async f=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(k){if((0,T.isPromiseCanceledError)(k))return}return this.doSync(d,g,f)});return this.syncPromise=p,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const d=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!d&&(!(0,E.isEqual)(g.defaultUrl,d.defaultUrl)||!(0,E.isEqual)(g.insidersUrl,d.insidersUrl)||!(0,E.isEqual)(g.stableUrl,d.stableUrl))}async doSync(d,g,p){this.logService.info(`Auto Sync: Triggered by ${d}`),this._onDidStartSync.fire();let f;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),p.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new I.UserDataAutoSyncError((0,v.localize)(0,null),"DefaultServiceChanged"):new I.UserDataAutoSyncError((0,v.localize)(1,null),"ServiceChanged"):new I.UserDataAutoSyncError((0,v.localize)(2,null),"TurnedOff");const k=this.storageService.get(a,0);if(k&&this.manifest&&k!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new I.UserDataAutoSyncError((0,v.localize)(3,null),"DefaultServiceChanged"):new I.UserDataAutoSyncError((0,v.localize)(4,null),"ServiceChanged"):new I.UserDataAutoSyncError((0,v.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(p.isCancellationRequested)return;const _=O.find(z=>z.isCurrent);if(_?.disabled)throw new I.UserDataAutoSyncError((0,v.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(z){throw new I.UserDataAutoSyncError((0,R.toErrorMessage)(z),z instanceof I.UserDataSyncError?z.code:"Unknown")}if(this.manifest&&this.manifest.session!==k&&this.storageService.store(a,this.manifest.session,0,1),p.isCancellationRequested)return;_||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(k){this.logService.error(k),f=k}this._onDidFinishSync.fire(f)}register(d){return super._register(d)}}u.INTERVAL_SYNCING="Interval"}),define(Z[209],ee([0,1,3,2,4,20,21,22]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends L.Disposable{constructor(i,v){super();this.storageService=i,this.telemetryService=v,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(h=>this.onDidStorageChange(h)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,v){if(this.isResourceEnabled(i)!==v){const h=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(h,{enabled:v}),this.storeResourceEnablement(h,v)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,v){this.storageService.store(i,v,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const v=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===i.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}}};m=he([Y(0,T.IStorageService),Y(1,A.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(Z[210],ee([0,1,19,5,37,11,3,2,15,30,6,20,21,199,201,202,204,205,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const S="sync.lastSyncTime";let o=class extends P.Disposable{constructor(n,s,u,l,d,g){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=s,this.instantiationService=u,this.logService=l,this.telemetryService=d,this.storageService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(I.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(y.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(w.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(c.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(b.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(p=>A.Event.map(p.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(p=>A.Event.map(p.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(S,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(p=>A.Event.map(p.onDidChangeLocal,()=>p.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,s){await this.checkEnablement();const u=(0,E.generateUuid)();try{const p=(0,C.createSyncHeaders)(u);s&&(p["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,p)}catch(p){const f=C.UserDataSyncError.toUserDataSyncError(p);throw this.reportUserDataSyncError(f,u),f}let l=!1;const d=this;let g;return{manifest:n,run(){if(l)throw new Error("Can run a task only once");return g=(0,L.createCancelablePromise)(p=>d.sync(n,u,p)),g.finally(()=>g=void 0)},async stop(){if(g&&g.cancel(),d.status!=="idle")return d.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,E.generateUuid)(),s=(0,C.createSyncHeaders)(n);let u;try{u=await this.userDataSyncStoreService.manifest(null,s)}catch(l){const d=C.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(d,n),d}return new a(n,u,s,this.synchronisers,this.logService)}async sync(n,s,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const d=(0,C.createSyncHeaders)(s);for(const g of this.synchronisers){if(u.isCancellationRequested)return;try{await g.sync(n,d)}catch(p){let f=!1;if(p instanceof C.UserDataSyncError)switch(p.code){case"TooLarge":p=new C.UserDataSyncError(p.message,p.code,g.resource),f=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":f=!0;break}const k=C.UserDataSyncError.toUserDataSyncError(p);if(this.reportUserDataSyncError(k,s),f)throw k;this.logService.error(p),this.logService.error(`${g.resource}: ${(0,R.toErrorMessage)(p)}`),this._syncErrors.push([g.resource,k])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(d){const g=C.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(g,s),g}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(s){this.logService.error(s)}}async replace(n){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(n))return}async accept(n,s,u,l){await this.checkEnablement();const d=this.getSynchroniser(n);await d.accept(s,u),l&&await d.apply(!1,(0,C.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(n){for(const s of this.synchronisers){const u=await s.resolveContent(n);if(u)return u}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,s){return this.getSynchroniser(n).getAssociatedResources(s)}getMachineId(n,s){return this.getSynchroniser(n).getMachineId(s)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of n)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(S,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(s){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const s=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([s,u],[l,d])=>s===s&&(0,D.equals)(u,d,(g,p)=>(0,m.isEqual)(g.previewResource,p.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(S,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,s){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof C.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof C.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(s=>s.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=he([Y(0,C.IUserDataSyncStoreService),Y(1,C.IUserDataSyncStoreManagementService),Y(2,i.IInstantiationService),Y(3,C.IUserDataSyncLogService),Y(4,h.ITelemetryService),Y(5,v.IStorageService)],o),e.UserDataSyncService=o;class a extends P.Disposable{constructor(n,s,u,l,d){super();this.id=n,this.manifest=s,this.syncHeaders=u,this.synchronisers=l,this.logService=d,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,s){try{return await this.performAction(n,u=>u.accept(n,s))}catch(u){throw this.logService.error(u),u}}async merge(n){try{return n?await this.performAction(n,s=>s.merge(n)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(n){try{return await this.performAction(n,s=>s.discard(n))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,s]of this.previews)for(const u of s.resourcePreviews)u.mergeState==="conflict"&&n.push(u.previewResource);for(const s of n)await this.discard(s);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(g=>g.resource===s);for(const g of u.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&await l.merge(g.previewResource);const d=await l.apply(!1,this.syncHeaders);d&&n.push(this.toSyncResourcePreview(l.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,s]of this.previews){this.synchronizingResources.push([n,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(l=>l.resource===n);for(const l of s.resourcePreviews)await u.accept(l.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,s]of this.previews){this.synchronizingResources.push([n,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(l=>l.resource===n);for(const l of s.resourcePreviews)await u.accept(l.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(s){(0,T.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(n,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,_])=>_.resourcePreviews.some(({localResource:z,previewResource:V,remoteResource:W})=>(0,m.isEqual)(n,z)||(0,m.isEqual)(n,V)||(0,m.isEqual)(n,W)));if(u===-1)return this.previews;const[l,d]=this.previews[u],g=d.resourcePreviews.find(({localResource:_,remoteResource:z,previewResource:V})=>(0,m.isEqual)(_,n)||(0,m.isEqual)(z,n)||(0,m.isEqual)(V,n));if(!g)return this.previews;let p=this.synchronizingResources.find(_=>_[0]===l);p||(p=[l,[]],this.synchronizingResources.push(p)),p[1].some(_=>(0,m.isEqual)(_,g.localResource))||(p[1].push(g.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const f=this.synchronisers.find(_=>_.resource===this.previews[u][0]),k=await s(f);k?this.previews.splice(u,1,this.toSyncResourcePreview(f.resource,k)):this.previews.splice(u,1);const O=this.synchronizingResources.findIndex(_=>_[0]===l);return this.synchronizingResources[O][1].splice(p[1].findIndex(_=>(0,m.isEqual)(_,g.localResource)),1),p[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(g=>g.resource===s);let d=u;for(const g of u.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&(d=await l.merge(g.previewResource));d&&n.push(this.toSyncResourcePreview(l.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const s=[];for(const u of this.synchronisers){if(n.isCancellationRequested)return[];const l=await u.preview(this.manifest,this.syncHeaders);l&&s.push(this.toSyncResourcePreview(u.resource,l))}return s}toSyncResourcePreview(n,s){return[n,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[211],ee([0,1,3,2,16,7,22]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(v,h){this.service=v,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(v,h){switch(h){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${h}`)}async call(v,h,b){try{return await this._call(v,h,b)}catch(c){throw this.logService.error(c),c}}async _call(v,h,b){switch(h){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],T.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:T.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:T.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(h.startsWith("manualSync/")){const c=h.substring("manualSync/".length),y=b[0],I=this.getManualSyncTask(y);switch(b=b.slice(1),c){case"preview":return I.preview();case"accept":return I.accept(T.URI.revive(b[0]),b[1]);case"merge":return I.merge(T.URI.revive(b[0]));case"discard":return I.discard(T.URI.revive(b[0]));case"discardConflicts":return I.discardConflicts();case"apply":return I.apply();case"pull":return I.pull();case"push":return I.push();case"stop":return I.stop();case"_getStatus":return I.status;case"dispose":return this.disposeManualSyncTask(I)}}throw new Error("Invalid call")}getManualSyncTask(v){const h=this.manualSyncTasks.get(this.createKey(v));if(!h)throw new Error(`Manual sync taks not found: ${v}`);return h.manualSyncTask}async createManualSyncTask(){const v=new L.DisposableStore,h=v.add(await this.service.createManualSyncTask());return v.add(h.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:h.id,data:b}))),this.manualSyncTasks.set(this.createKey(h.id),{manualSyncTask:h,disposables:v}),{id:h.id,manifest:h.manifest,status:h.status}}disposeManualSyncTask(v){v.dispose();const h=this.createKey(v.id);this.manualSyncTasks.get(h)?.disposables.dispose(),this.manualSyncTasks.delete(h)}createKey(v){return`manualSyncTask-${v}`}}e.UserDataSyncChannel=P;class m extends L.Disposable{constructor(v){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,b,c){return v.call(h,b,c).then(null,y=>{throw A.UserDataSyncError.toUserDataSyncError(y)})},listen(h,b){return v.listen(h,b)}},this.channel.call("_getInitialData").then(([h,b,c])=>{this.updateStatus(h),this.updateConflicts(b),c&&this.updateLastSyncTime(c),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(([b,c])=>[b,A.UserDataSyncError.toUserDataSyncError(c)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:v,manifest:h,status:b}=await this.channel.call("createManualSyncTask"),c=this,y=new E(v,h,b,{async call(I,w,C){return c.channel.call(`manualSync/${I}`,[v,...(0,R.isArray)(w)?w:[w]],C)},listen(I,w){return D.Event.map(D.Event.filter(c.channel.listen(`manualSync/${I}`,w),C=>!y.isDiposed()&&C.manualSyncTaskId===v),C=>C.data)}});return y}replace(v){return this.channel.call("replace",[v])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(v,h,b,c){return this.channel.call("accept",[v,h,b,c])}resolveContent(v){return this.channel.call("resolveContent",[v])}async getLocalSyncResourceHandles(v){return(await this.channel.call("getLocalSyncResourceHandles",[v])).map(({created:b,uri:c})=>({created:b,uri:T.URI.revive(c)}))}async getRemoteSyncResourceHandles(v){return(await this.channel.call("getRemoteSyncResourceHandles",[v])).map(({created:b,uri:c})=>({created:b,uri:T.URI.revive(c)}))}async getAssociatedResources(v,h){return(await this.channel.call("getAssociatedResources",[v,h])).map(({resource:c,comparableResource:y})=>({resource:T.URI.revive(c),comparableResource:T.URI.revive(y)}))}async getMachineId(v,h){return this.channel.call("getMachineId",[v,h])}async updateStatus(v){this._status=v,this._onDidChangeStatus.fire(v)}async updateConflicts(v){this._conflicts=v.map(([h,b])=>[h,b.map(c=>({...c,localResource:T.URI.revive(c.localResource),remoteResource:T.URI.revive(c.remoteResource),previewResource:T.URI.revive(c.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(v){this._lastSyncTime!==v&&(this._lastSyncTime=v,this._onDidChangeLastSyncTime.fire(v))}}e.UserDataSyncChannelClient=m;class E extends L.Disposable{constructor(v,h,b,c){super();this.id=v,this.manifest=h,this._disposed=!1,this._status=b;const y=this;this.channel={async call(I,w,C){try{const S=await c.call(I,w,C);return y.isDiposed()||(y._status=await c.call("_getStatus")),S}catch(S){throw A.UserDataSyncError.toUserDataSyncError(S)}},listen(I,w){return c.listen(I,w)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const v=await this.channel.call("preview");return this.deserializePreviews(v)}async accept(v,h){const b=await this.channel.call("accept",[v,h]);return this.deserializePreviews(b)}async merge(v){const h=await this.channel.call("merge",[v]);return this.deserializePreviews(h)}async discard(v){const h=await this.channel.call("discard",[v]);return this.deserializePreviews(h)}async discardConflicts(){const v=await this.channel.call("discardConflicts");return this.deserializePreviews(v)}async apply(){const v=await this.channel.call("apply");return this.deserializePreviews(v)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(v){return v.map(([h,b])=>[h,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(c=>({...c,localResource:T.URI.revive(c.localResource),remoteResource:T.URI.revive(c.remoteResource),previewResource:T.URI.revive(c.previewResource),acceptedResource:T.URI.revive(c.acceptedResource)}))}])}}}),define(Z[212],ee([0,1,5,29,11,3,2,95,4,15,16,7,30,24,12,13,28,42,45,20,22]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",n="sync.machine-session-id",s=100,u=1e3*60*5;let l=class extends A.Disposable{constructor(O,_,z){super();this.productService=O,this.configurationService=_,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(z.onDidChangeValue,V=>V.key===o.SYNC_SERVICE_URL_TYPE&&V.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(o.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(o.SYNC_SERVICE_URL_TYPE,O,0,m.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[o.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(o.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,_){O=m.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},..._||{}};if(z&&(0,i.isString)(z.url)&&(0,i.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(V=>(0,i.isArray)(z.authenticationProviders[V].scopes))){const V=z,W=!!V.canSwitch&&!_?.url,U=V.url===V.insidersUrl?"insiders":"stable",M=(W?this.userDataSyncStoreType:void 0)||U,F=_?.url||(M==="insiders"?V.insidersUrl:M==="stable"?V.stableUrl:V.url);return{url:v.URI.parse(F),type:M,defaultType:U,defaultUrl:v.URI.parse(V.url),stableUrl:v.URI.parse(V.stableUrl),insidersUrl:v.URI.parse(V.insidersUrl),canSwitch:W,authenticationProviders:Object.keys(V.authenticationProviders).reduce((q,x)=>(q.push({id:x,scopes:V.authenticationProviders[x].scopes}),q),[])}}}};l=he([Y(0,I.IProductService),Y(1,b.IConfigurationService),Y(2,S.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let d=class extends l{constructor(O,_,z){super(O,_,z);const V=this.storageService.get(a,0);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const W=this.productService[o.CONFIGURATION_SYNC_STORE_KEY];W?this.storageService.store(a,JSON.stringify(W),0,1):this.storageService.remove(a,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};d=he([Y(0,I.IProductService),Y(1,b.IConfigurationService),Y(2,S.IStorageService)],d),e.UserDataSyncStoreManagementService=d;let g=class extends A.Disposable{constructor(O,_,z,V,W,U,M){super();this.requestService=z,this.logService=V,this.storageService=M,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,C.getServiceMachineId)(W,U,M).then(F=>{const q={"X-Client-Name":`${_.applicationName}${m.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":F};return _.commit&&(q["X-Client-Commit"]=_.commit),q}),this.session=new f(s,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,_){this.authToken={token:O,type:_}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(_=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),_).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,_=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},V=await this.request(_.toString(),{type:"GET",headers:z},[],L.CancellationToken.None);return(await(0,w.asJson)(V)||[]).map(({url:U,created:M})=>({ref:(0,E.relativePath)(_,_.with({path:U})),created:M*1e3}))}async resolveContent(O,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,_).toString(),V={};V["Cache-Control"]="no-cache";const W=await this.request(z,{type:"GET",headers:V},[],L.CancellationToken.None);return await(0,w.asText)(W)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request(_,{type:"DELETE",headers:z},[],L.CancellationToken.None)}async read(O,_,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",_&&(z["If-None-Match"]=_.ref);const W=await this.request(V,{type:"GET",headers:z},[304],L.CancellationToken.None);let U=null;if(W.res.statusCode===304&&(U=_),U===null){const M=W.res.headers.etag;if(!M)throw new o.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",W.res.statusCode,W.res.headers[o.HEADER_OPERATION_ID]);const F=await(0,w.asText)(W);if(!F&&W.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",V,"EmptyResponse",W.res.statusCode,W.res.headers[o.HEADER_OPERATION_ID]);U={ref:M,content:F}}return U}async write(O,_,z,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();V={...V},V["Content-Type"]=P.Mimes.text,z&&(V["If-Match"]=z);const U=await this.request(W,{type:"POST",data:_,headers:V},[],L.CancellationToken.None),M=U.res.headers.etag;if(!M)throw new o.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",U.res.statusCode,U.res.headers[o.HEADER_OPERATION_ID]);return M}async manifest(O,_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();_={..._},_["Content-Type"]="application/json",O&&(_["If-None-Match"]=O.ref);const V=await this.request(z,{type:"GET",headers:_},[304],L.CancellationToken.None);let W=null;if(V.res.statusCode===304&&(W=O),!W){const M=V.res.headers.etag;if(!M)throw new o.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",V.res.statusCode,V.res.headers[o.HEADER_OPERATION_ID]);const F=await(0,w.asText)(V);if(!F&&V.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",z,"EmptyResponse",V.res.statusCode,V.res.headers[o.HEADER_OPERATION_ID]);F&&(W={...JSON.parse(F),ref:M})}const U=this.storageService.get(r,0);return U&&W&&U!==W.session&&this.clearSession(),W===null&&U&&this.clearSession(),W&&this.storageService.store(r,W.session,0,1),W}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:_},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(n,0)}async request(O,_,z,V){if(!this.authToken)throw new o.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new o.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const W=await this.commonHeadersPromise;_.headers={..._.headers||{},...W,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:O,type:_.type,headers:{..._.headers,authorization:void 0}});let U;try{U=await this.session.request(O,_,V)}catch(x){if(!(x instanceof o.UserDataSyncStoreError)){let N="RequestFailed";const j=(0,R.getErrorMessage)(x).toLowerCase();j.includes("xhr timeout")?N="RequestTimeout":j.includes("protocol")&&j.includes("not supported")?N="RequestProtocolNotSupported":j.includes("request path contains unescaped characters")?N="RequestPathNotEscaped":j.includes("headers must be an object")?N="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(x)&&(N="RequestCanceled"),x=new o.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,N,void 0,void 0)}throw this.logService.info("Request failed",O),x}const M=U.res.headers[o.HEADER_OPERATION_ID],F={url:O,status:U.res.statusCode,"execution-id":_.headers[o.HEADER_EXECUTION_ID],"operation-id":M},q=(0,w.isSuccess)(U)||U.res.statusCode&&z.indexOf(U.res.statusCode)!==-1;if(q?this.logService.trace("Request succeeded",F):this.logService.info("Request failed",F),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new o.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,M);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new o.UserDataSyncStoreError(`${_.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,M);if(U.res.statusCode===410)throw new o.UserDataSyncStoreError(`${_.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,M);if(U.res.statusCode===412)throw new o.UserDataSyncStoreError(`${_.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,M);if(U.res.statusCode===413)throw new o.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,M);if(U.res.statusCode===426)throw new o.UserDataSyncStoreError(`${_.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,M);if(U.res.statusCode===429){const x=U.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new o.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,M)):new o.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,M)}if(!q)throw new o.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,M);return U}addSessionHeaders(O){let _=this.storageService.get(n,0);_===void 0&&(_=(0,h.generateUuid)(),this.storageService.store(n,_,0,1)),O["X-Machine-Session-Id"]=_;const z=this.storageService.get(r,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};g=he([Y(1,I.IProductService),Y(2,w.IRequestService),Y(3,o.IUserDataSyncLogService),Y(4,c.IEnvironmentService),Y(5,y.IFileService),Y(6,S.IStorageService)],g),e.UserDataSyncStoreClient=g;let p=class extends g{constructor(O,_,z,V,W,U,M){super(O.userDataSyncStore?.url,_,z,V,W,U,M);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};p=he([Y(0,o.IUserDataSyncStoreManagementService),Y(1,I.IProductService),Y(2,w.IRequestService),Y(3,o.IUserDataSyncLogService),Y(4,c.IEnvironmentService),Y(5,y.IFileService),Y(6,S.IStorageService)],p),e.UserDataSyncStoreService=p;class f{constructor(O,_,z,V){this.limit=O,this.interval=_,this.requestService=z,this.logService=V,this.requests=[],this.startTime=void 0}request(O,_,z){if(this.isExpired()&&this.reset(),_.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new o.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(_,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=f}),define(Z[213],ee([0,1,3,59,28,20,21,89,22,60,61]),function(K,e,D,L,R,T,A,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let v=class extends P.UserDataAutoSyncService{constructor(b,c,y,I,w,C,S,o,a,t,r,n){super(b,c,y,I,w,S,o,a,t,r,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(C.onDidFocusWindow,()=>"windowFocus"),D.Event.map(C.onDidOpenWindow,()=>"windowOpen")),(s,u)=>s?[...s,u]:[u],1e3)(s=>this.triggerSync(s,!0,!1)))}};v=he([Y(0,R.IProductService),Y(1,m.IUserDataSyncStoreManagementService),Y(2,m.IUserDataSyncStoreService),Y(3,m.IUserDataSyncResourceEnablementService),Y(4,m.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,m.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,A.ITelemetryService),Y(9,i.IUserDataSyncMachinesService),Y(10,T.IStorageService),Y(11,m.IUserDataAutoSyncEnablementService)],v),e.UserDataAutoSyncService=v}),define(Z[214],ee([0,1,5,3,2]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:m,getActiveWindowId:E}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const v=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:v}catch(v){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(Z[62],ee([0,1,50,5,8,16,18,110,222,223]),function(K,e,D,L,R,T,A,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,r){let n=r.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=r}}e.ExtractError=i;function v(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,n)=>r+n,t&61440)}function h(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function b(a,t,r,n,s,u){const l=R.dirname(t),d=R.join(n,l);if(!d.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const g=R.join(n,t);let p;return u.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(A.Promises.mkdir(d,{recursive:!0})).then(()=>new Promise((f,k)=>{if(!u.isCancellationRequested)try{p=(0,D.createWriteStream)(g,{mode:r}),p.once("close",()=>f()),p.once("error",k),a.once("error",k),a.pipe(p)}catch(O){k(O)}}))}function c(a,t,r,n){let s=(0,L.createCancelablePromise)(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{s.cancel(),a.close()}),new Promise((l,d)=>{const g=new L.Sequencer,p=f=>{f.isCancellationRequested||(u++,a.readEntry())};a.once("error",d),a.once("close",()=>s.then(()=>{n.isCancellationRequested||a.entryCount===u?l():d(new i("Incomplete",new Error(P.localize(1,null,u,a.entryCount))))},d)),a.readEntry(),a.on("entry",f=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(f.fileName)){p(n);return}const k=f.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(k)){const z=R.join(t,k);s=(0,L.createCancelablePromise)(V=>A.Promises.mkdir(z,{recursive:!0}).then(()=>p(V)).then(void 0,d));return}const O=I(a,f),_=v(f);s=(0,L.createCancelablePromise)(z=>g.queue(()=>O.then(V=>b(V,k,_,t,r,z).then(()=>p(z)))).then(null,d))})})}function y(a,t=!1){return new Promise((r,n)=>{(0,m.open)(a,t?{lazyEntries:!0}:void 0,(s,u)=>{s?n(h(s)):r((0,T.assertIsDefined)(u))})})}function I(a,t){return new Promise((r,n)=>{a.openReadStream(t,(s,u)=>{s?n(h(s)):r((0,T.assertIsDefined)(u))})})}function w(a,t){return new Promise((r,n)=>{const s=new E.ZipFile;t.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const u=(0,D.createWriteStream)(a);s.outputStream.pipe(u),s.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>r(a))})}e.zip=w;function C(a,t,r={},n){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=y(a,!0);return r.overwrite&&(u=u.then(l=>A.Promises.rm(t).then(()=>l))),u.then(l=>c(l,t,{sourcePathRegex:s},n))}e.extract=C;function S(a,t){return y(a).then(r=>new Promise((n,s)=>{r.on("entry",u=>{u.fileName===t&&I(r,u).then(l=>n(l),l=>s(l))}),r.once("close",()=>s(new Error(P.localize(2,null,t))))}))}function o(a,t){return S(a,t).then(r=>new Promise((n,s)=>{const u=[];r.once("error",s),r.on("data",l=>u.push(l)),r.on("end",()=>n(Buffer.concat(u)))}))}e.buffer=o}),define(Z[215],ee([0,1,62,118]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(Z[216],ee([0,1,19,5,11,2,17,8,4,15,58,7,30,18,62,119,12,27,31,141,13,14,28]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",n="scanningUser",s="extracting",u="deleting",l="renaming";let d=class extends T.Disposable{constructor(p,f,k,O,_){super();this.beforeRemovingExtension=p,this.fileService=f,this.logService=k,this.environmentService=O,this.productService=_,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const f=[];(p===null||p===0)&&f.push(this.scanSystemExtensions().then(null,k=>Promise.reject(new w.ExtensionManagementError(this.joinErrors(k).message,r)))),(p===null||p===1)&&f.push(this.scanUserExtensions(!0).then(null,k=>Promise.reject(new w.ExtensionManagementError(this.joinErrors(k).message,n))));try{const k=await Promise.all(f);return(0,D.flatten)(k)}catch(k){throw this.joinErrors(k)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[f,k]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return k=k.filter(O=>!f[new C.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),p&&(k=(0,C.groupByExtension)(k,_=>_.identifier).map(_=>_.sort((z,V)=>i.rcompare(z.manifest.version,V.manifest.version))[0])),this.logService.trace("Scanned user extensions:",k.length),k}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,f,k){const O=p.key(),_=P.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),z=P.join(this.extensionsPath,O);try{await b.Promises.rm(z)}catch(W){try{await b.Promises.rm(z)}catch(U){}throw new w.ExtensionManagementError((0,y.localize)(0,null,z,p.id),u)}await this.extractAtLocation(p,f,_,k);let V=await this.scanExtension(v.URI.file(_),1);if(!V)throw new Error((0,y.localize)(1,null,_));await this.storeMetadata(V,{installedTimestamp:Date.now()});try{await this.rename(p,_,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(W){try{await b.Promises.rm(_)}catch(U){}if(W.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(W)}. Deleted from extracted location`,_),W}try{V=await this.scanExtension(v.URI.file(z),1)}catch(W){}if(V)return V;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,f){return this.setMetadata(p,f),await this.storeMetadata(p,{...f,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,f){f.isMachineScoped=f.isMachineScoped||void 0,f.isBuiltin=f.isBuiltin||void 0,f.installedTimestamp=f.installedTimestamp||void 0;const k=P.join(p.location.fsPath,"package.json"),O=await b.Promises.readFile(k,"utf8"),{manifest:_}=await this.parseManifest(O);return _.__metadata=f,await b.Promises.writeFile(k,JSON.stringify(_,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const f=p.map(k=>new C.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version));await this.withUninstalledExtensions(k=>{f.forEach(O=>k[O.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(O=>delete O[p.key()]);const k=(await this.scanExtensions(1)).find(O=>new C.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(p))||null;return k?(await this.storeMetadata(k,{installedTimestamp:Date.now()}),this.scanExtension(k.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let f;try{f=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let k={};if(f)try{k=JSON.parse(f)}catch(O){}return p&&(p(k),Object.keys(k).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(k)):await b.Promises.rm(this.uninstalledPath)),k})}async removeExtension(p,f){this.logService.trace(`Deleting ${f} extension from disk`,p.identifier.id,p.location.fsPath),await b.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(f=>delete f[new C.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,f,k,O){this.logService.trace(`Started extracting the extension from ${f} to ${k}`);try{await b.Promises.rm(k)}catch(_){throw new w.ExtensionManagementError(this.joinErrors(_).message,u)}try{await(0,c.extract)(f,k,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${k}:`,p.id)}catch(_){try{await b.Promises.rm(k)}catch(z){}throw new w.ExtensionManagementError(_.message,_ instanceof c.ExtractError&&_.type?_.type:s)}}async rename(p,f,k,O){try{await b.Promises.rename(f,k)}catch(_){if(m.isWindows&&_&&_.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${f} to ${k} with 'EPERM' error. Trying again...`,p.id),this.rename(p,f,k,O);throw new w.ExtensionManagementError(_.message||(0,y.localize)(3,null,f,k),_.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const f=this.scanDevSystemExtensions(),[k,O]=await Promise.all([p,f]);return[...k,...O]}async scanExtensionsInDir(p,f){const k=new L.Limiter(10),O=await this.fileService.resolve(v.URI.file(p));return O.children?(await Promise.all(O.children.filter(z=>z.isDirectory).map(z=>k.queue(async()=>f===1&&(0,E.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,f))))).filter(z=>z&&z.identifier):[]}async scanExtension(p,f){try{const k=await this.fileService.resolve(p);if(k.children){const{manifest:O,metadata:_}=await this.readManifest(p.fsPath),z=k.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,V=k.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource,W={id:(0,C.getGalleryExtensionId)(O.publisher,O.name)},U={type:f,identifier:W,manifest:O,location:p,readmeUrl:z,changelogUrl:V,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:f===0};return _&&(this.setMetadata(U,_),U.installedTimestamp=_.installedTimestamp),U}}catch(k){f!==0&&this.logService.trace(k)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const f=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",f.length),f.filter(k=>p.some(O=>(0,C.areSameExtensions)(k.identifier,{id:O})))}else return[]}setMetadata(p,f){p.publisherDisplayName=f.publisherDisplayName||null,p.publisherId=f.publisherId||null,p.identifier.uuid=f.id,p.isMachineScoped=!!f.isMachineScoped,p.isBuiltin=p.type===0||!!f.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),f=await this.scanAllUserExtensions(),k=new Set;for(const z of f)p[new C.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||k.add(z.identifier.id.toLowerCase());const O=(0,C.groupByExtension)(f,z=>z.identifier);await L.Promises.settled(O.map(async z=>{const V=z.sort((W,U)=>i.rcompare(W.manifest.version,U.manifest.version))[0];k.has(V.identifier.id.toLowerCase())||await this.beforeRemovingExtension(V)}));const _=f.filter(z=>p[new C.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await L.Promises.settled(_.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),f=[],k=(0,C.groupByExtension)(p,O=>O.identifier);f.push(...(0,D.flatten)(k.map(O=>O.sort((_,z)=>i.rcompare(_.manifest.version,z.manifest.version)).slice(1)))),await L.Promises.settled(f.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const f=Array.isArray(p)?p:[p];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((k,O)=>new Error(`${k.message}${k.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(A.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const f=[b.Promises.readFile(P.join(p,"package.json"),"utf8").then(z=>this.parseManifest(z)),b.Promises.readFile(P.join(p,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:k,metadata:O},_]=await Promise.all(f);return{manifest:(0,S.localizeManifest)(k,_),metadata:O}}parseManifest(p){return new Promise((f,k)=>{try{const O=JSON.parse(p),_=O.__metadata||null;f({manifest:O,metadata:_})}catch(O){k(new Error((0,y.localize)(4,null)))}})}};d=he([Y(1,o.IFileService),Y(2,a.ILogService),Y(3,I.INativeEnvironmentService),Y(4,t.IProductService)],d),e.ExtensionsScanner=d}),define(Z[217],ee([0,1,37,17,8,4,15,58,7,30,18,62,117,74,12,183,27,31,164,165,215,152,216,166,72,13,6,14,44,21]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o,a,t,r,n,s,u,l,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const p="unsetUninstalled",f="downloading";let k=class extends y.AbstractExtensionManagementService{constructor(U,M,F,q,x,N,j){super(U,M,F);this.environmentService=q,this.downloadService=x;const $=this._register(N.createInstance(S.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(t.ExtensionsScanner,G=>$.postUninstall(G))),this.manifestCache=this._register(new a.ExtensionsManifestCache(q,this)),this.extensionsDownloader=this._register(N.createInstance(C.ExtensionsDownloader));const H=this._register(new r.ExtensionsWatcher(this,j,q,F));this._register(H.onDidChangeExtensionsByAnotherSource(({added:G,removed:Q})=>{G.length&&this._onDidInstallExtensions.fire(G.map(X=>({identifier:X.identifier,operation:0,local:X}))),Q.forEach(X=>this._onDidUninstallExtension.fire({identifier:X}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const M=await this.collectFiles(U),F=await(0,v.zip)((0,A.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,M);return m.URI.file(F)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const M=await this.downloadVsix(U),F=R.resolve(M.fsPath);return(0,o.getManifest)(F)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,M={}){this.logService.trace("ExtensionManagementService#install",U.toString());const F=await this.downloadVsix(U),q=await(0,o.getManifest)(R.resolve(F.fsPath));if(q.engines&&q.engines.vscode&&!(0,n.isEngineValid)(q.engines.vscode,d.default.version,d.default.date))throw new Error(h.localize(0,null,(0,w.getGalleryExtensionId)(q.publisher,q.name),d.default.version));return this.installExtension(q,F,M)}async updateMetadata(U,M){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...M}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,M){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:M}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===L.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const M=(0,A.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(U,M),M}createInstallExtensionTask(U,M,F){return m.URI.isUri(M)?new z(U,M,F,this.galleryService,this.extensionsScanner,this.logService):new _(M,F,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,M){return new V(U,M,this.extensionsScanner)}async collectFiles(U){const M=async q=>{let x=await i.Promises.readdir(q);x=x.map($=>R.join(q,$));const N=await Promise.all(x.map($=>i.Promises.stat($)));let j=Promise.resolve([]);return N.forEach(($,H)=>{const G=x[H];$.isFile()&&(j=j.then(Q=>[...Q,G])),$.isDirectory()&&(j=j.then(Q=>M(G).then(X=>[...Q,...X])))}),j};return(await M(U.location.fsPath)).map(q=>({path:`extension/${R.relative(U.location.fsPath,q)}`,localPath:q}))}};k=he([Y(0,I.IExtensionGalleryService),Y(1,g.ITelemetryService),Y(2,l.ILogService),Y(3,c.INativeEnvironmentService),Y(4,(0,u.optional)(b.IDownloadService)),Y(5,u.IInstantiationService),Y(6,s.IFileService)],k),e.ExtensionManagementService=k;class O extends y.AbstractExtensionTask{constructor(U,M,F,q){super();this.identifier=U,this.source=M,this.extensionsScanner=F,this.logService=q,this._operation=1}get operation(){return this._operation}async installExtension(U,M){try{const F=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(F)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,U.metadata):F}catch(F){throw T.isMacintosh?new I.ExtensionManagementError(h.localize(1,null),p):new I.ExtensionManagementError(h.localize(2,null),p)}return this.extract(U,M)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const F=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),F}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:M,metadata:F},q){let x=await this.extensionsScanner.extractUserExtension(M,U,q);return this.logService.info("Extracting completed.",M.id),F&&(x=await this.extensionsScanner.saveMetadataForLocalExtension(x,F)),x}}class _ extends O{constructor(U,M,F,q,x){super(U.identifier,U,q,x);this.gallery=U,this.options=M,this.extensionsDownloader=F}async doRun(U){const F=(await this.extensionsScanner.scanExtensions(null)).find(N=>(0,w.areSameExtensions)(N.identifier,this.gallery.identifier));F&&(this._operation=2);const q=await this.downloadInstallableExtension(this.gallery,this._operation);q.metadata.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,q.metadata.isBuiltin=this.options.isBuiltin||F?.isBuiltin;const x=await this.installExtension(q,U);F&&P.neq(F.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(F);try{await this.extensionsDownloader.delete(m.URI.file(q.zipPath))}catch(N){}return x}async downloadInstallableExtension(U,M){const F={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let q;try{this.logService.trace("Started downloading extension:",U.identifier.id),q=(await this.extensionsDownloader.downloadExtension(U,M)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,q)}catch(x){throw new I.ExtensionManagementError((0,y.joinErrors)(x).message,f)}try{const x=await(0,o.getManifest)(q);return{zipPath:q,identifierWithVersion:new w.ExtensionIdentifierWithVersion(U.identifier,x.version),metadata:F}}catch(x){throw new I.ExtensionManagementError((0,y.joinErrors)(x).message,y.INSTALL_ERROR_VALIDATING)}}}class z extends O{constructor(U,M,F,q,x,N){super({id:(0,w.getGalleryExtensionId)(U.publisher,U.name)},M,x,N);this.manifest=U,this.location=M,this.options=F,this.galleryService=q}async doRun(U){const M=new w.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),q=(await this.extensionsScanner.scanExtensions(1)).find(N=>(0,w.areSameExtensions)(this.identifier,N.identifier)),x=await this.getMetadata(this.identifier.id,U);if(q)if(x.isMachineScoped=this.options.isMachineScoped||q.isMachineScoped,x.isBuiltin=this.options.isBuiltin||q.isBuiltin,this._operation=2,M.equals(new w.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch(N){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else P.gt(q.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(q);else{const N=await this.unsetUninstalledAndGetLocal(M);if(N)try{await this.extensionsScanner.removeExtension(N,"existing")}catch(j){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:M,metadata:x},U)}async getMetadata(U,M){try{const F=(await this.galleryService.query({names:[U],pageSize:1},M)).firstPage[0];if(F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId}}catch(F){}return{}}}class V extends y.AbstractExtensionTask{constructor(U,M,F){super();this.extension=U,this.options=M,this.extensionsScanner=F}async doRun(U){const M=[],F=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const q=new w.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);M.push(...F.filter(x=>q.equals(new w.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version))))}else M.push(...F.filter(q=>(0,w.areSameExtensions)(q.identifier,this.extension.identifier)));if(!M.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...M),this.options.remove)for(const q of M)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(q)}catch(x){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(x)))}}}}),define(Z[224],ee([0,1,104,50,225,34,37,11,2,17,15,7,36,103,171,151,172,161,162,163,149,153,24,174,73,182,74,176,12,138,178,184,27,140,185,217,75,142,13,168,170,52,6,158,78,159,160,57,167,14,79,59,44,28,175,42,20,180,181,21,82,84,83,53,186,187,85,189,195,87,88,89,22,60,206,207,208,61,209,210,211,212,213,214]),function(K,e,D,L,R,T,A,P,m,E,i,v,h,b,c,y,I,w,C,S,o,a,t,r,n,s,u,l,d,g,p,f,k,O,_,z,V,W,U,M,F,q,x,N,j,$,H,G,Q,X,ie,te,oe,ue,ye,ve,Re,Te,Ne,Oe,ke,_e,Ie,Ae,Ye,Je,$e,qe,J,re,se,ge,me,Pe,be,De,Ce,B,ne,ae,ce,fe,Se,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends m.Disposable{constructor(le){super();this.configuration=le,this.server=this._register(new b.Server),(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const le=()=>this.dispose();process.once("exit",le),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",le)}async open(){const le=await this.initServices();(0,me.registerConfiguration)(),le.invokeFunction(Le=>{const Ue=Le.get(X.ILogService);Ue.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(Ue)}),this._register((0,m.combinedDisposable)(le.createInstance(c.CodeCacheCleaner,this.configuration.codeCachePath),le.createInstance(I.LanguagePackCachedDataCleaner),le.createInstance(S.StorageDataCleaner,this.configuration.backupWorkspacesPath),le.createInstance(C.LogsDataCleaner),le.createInstance(w.LocalizationsUpdater),le.createInstance(y.DeprecatedExtensionsCleaner)))}async initServices(){const le=new j.ServiceCollection,Le={_serviceBrand:void 0,...oe.default};le.set(ue.IProductService,Le);const Ue=new h.StaticRouter(We=>We==="main"),Fe=new $.MessagePortMainProcessService(this.server,Ue);le.set(H.IMainProcessService,Fe);const Me=new g.NativeEnvironmentService(this.configuration.args,Le);le.set(d.INativeEnvironmentService,Me);const et=new ie.LogLevelChannelClient(this.server.getChannel("logLevel",Ue)),Be=new ie.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));le.set(X.ILoggerService,Be);const nt=this._register(new X.MultiplexLogService([this._register(new X.ConsoleLogger(this.configuration.logLevel)),this._register(Be.createLogger((0,i.joinPath)(v.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new ie.FollowerLogService(et,nt));le.set(X.ILogService,Ve);const He=this._register(new M.FileService(Ve));le.set(U.IFileService,He);const it=this._register(new F.DiskFileSystemProvider(Ve));He.registerProvider(E.Schemas.file,it);const xe=this._register(new r.ConfigurationService(Me.settingsResource,He));le.set(t.IConfigurationService,xe),await xe.initialize();const Xe=new Te.NativeStorageService(void 0,Fe,Me);le.set(Re.IStorageService,Xe),await Xe.initialize(),this._register((0,m.toDisposable)(()=>Xe.flush())),le.set(ve.IRequestService,new q.SyncDescriptor(ye.RequestService)),le.set(o.IChecksumService,new q.SyncDescriptor(a.ChecksumService));const tt=h.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});le.set(te.INativeHostService,tt),le.set(u.IDownloadService,new q.SyncDescriptor(l.DownloadService));const rt=this._register(new de.ActiveWindowManager(tt)),ht=new h.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));le.set(V.IExtensionRecommendationNotificationService,new W.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,Ge;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Le.enableTelemetry){Ge=new _e.TelemetryLogAppender(Be,Me);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Me;if(Le.aiConfig&&Le.aiConfig.asimovKey&&dt){const ct=new Ye.AppInsightsAppender("monacoworkbench",null,Le.aiConfig.asimovKey);this._register((0,m.toDisposable)(()=>ct.flush())),Ge=(0,Ae.combinedAppender)(ct,Ge)}Qe=new Ie.TelemetryService({appender:Ge,commonProperties:(0,Ne.resolveCommonProperties)(He,(0,T.release)(),(0,T.hostname)(),process.arch,Le.commit,Le.version,this.configuration.machineId,Le.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},xe)}else Qe=Ae.NullTelemetryService,Ge=Ae.NullAppender;this.server.registerChannel("telemetryAppender",new ke.TelemetryAppenderChannel(Ge)),le.set(Oe.ITelemetryService,Qe);const ft=new Je.CustomEndpointTelemetryService(xe,Qe,Be,Me);return le.set(Oe.ICustomEndpointTelemetryService,ft),le.set(k.IExtensionManagementService,new q.SyncDescriptor(z.ExtensionManagementService)),le.set(k.IExtensionGalleryService,new q.SyncDescriptor(f.ExtensionGalleryService)),le.set(k.IExtensionTipsService,new q.SyncDescriptor(_.ExtensionTipsService)),le.set(G.ILocalizationsService,new q.SyncDescriptor(Q.LocalizationsService)),le.set(n.IDiagnosticsService,new q.SyncDescriptor(s.DiagnosticsService)),le.set(Pe.IUserDataSyncAccountService,new q.SyncDescriptor(Pe.UserDataSyncAccountService)),le.set(me.IUserDataSyncLogService,new q.SyncDescriptor(Ce.UserDataSyncLogService)),le.set(me.IUserDataSyncUtilService,new De.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),le.set(k.IGlobalExtensionEnablementService,new q.SyncDescriptor(p.GlobalExtensionEnablementService)),le.set(se.IIgnoredExtensionsManagementService,new q.SyncDescriptor(se.IgnoredExtensionsManagementService)),le.set(re.IExtensionsStorageSyncService,new q.SyncDescriptor(re.ExtensionsStorageSyncService)),le.set(me.IUserDataSyncStoreManagementService,new q.SyncDescriptor(fe.UserDataSyncStoreManagementService)),le.set(me.IUserDataSyncStoreService,new q.SyncDescriptor(fe.UserDataSyncStoreService)),le.set(B.IUserDataSyncMachinesService,new q.SyncDescriptor(B.UserDataSyncMachinesService)),le.set(me.IUserDataSyncBackupStoreService,new q.SyncDescriptor(be.UserDataSyncBackupStoreService)),le.set(me.IUserDataAutoSyncEnablementService,new q.SyncDescriptor(ge.UserDataAutoSyncEnablementService)),le.set(me.IUserDataSyncResourceEnablementService,new q.SyncDescriptor(ne.UserDataSyncResourceEnablementService)),le.set(me.IUserDataSyncService,new q.SyncDescriptor(ae.UserDataSyncService)),le.set(qe.ILocalPtyService,this._register(new J.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100,useExperimentalSerialization:xe.getValue("terminal.integrated.persistentSessionExperimentalSerializer")??!0},xe,Ve,Qe))),new N.InstantiationService(le)}initChannels(le){const Le=new O.ExtensionManagementChannel(le.get(k.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const Ue=h.ProxyChannel.fromService(le.get(G.ILocalizationsService));this.server.registerChannel("localizations",Ue);const Fe=h.ProxyChannel.fromService(le.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new O.ExtensionTipsChannel(le.get(k.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const et=h.ProxyChannel.fromService(le.get(o.IChecksumService));this.server.registerChannel("checksum",et);const Be=new De.UserDataSyncMachinesServiceChannel(le.get(B.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Be);const nt=h.ProxyChannel.fromService(le.get(Oe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ve=new De.UserDataSyncAccountServiceChannel(le.get(Pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new De.UserDataSyncStoreManagementServiceChannel(le.get(me.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const it=new ce.UserDataSyncChannel(le.get(me.IUserDataSyncService),le.get(X.ILogService));this.server.registerChannel("userDataSync",it);const xe=this._register(le.get(x.IInstantiationService).createInstance(Se.UserDataAutoSyncService)),Xe=new De.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",Xe);const tt=le.get(qe.ILocalPtyService),rt=h.ProxyChannel.fromService(tt);this.server.registerChannel($e.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(le){window.addEventListener("unhandledrejection",Le=>{(0,P.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Le=>{const Ue=(0,A.toErrorMessage)(Le,!0);!Ue||le.error(`[uncaught exception in sharedProcess]: ${Ue}`)})}}async function we(Ee){const le=new pe(Ee);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await le.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89bbd372f459ce72e9c0b60eb3b26b924f64f62d/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
