/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/base/common/extpath","fs","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(H){for(var e=[],w=0,L=H.length;w<L;w++)e[w]=J[H[w]];return e};define(J[102],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=w}),define(J[46],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(b){return(n,f,m)=>{let t=null,y=null;if(typeof m.value=="function"?(t="value",y=m.value):typeof m.get=="function"&&(t="get",y=m.get),!y)throw new Error("not supported");m[t]=b(y,f)}}e.createDecorator=w;function L(b,n,f){let m=null,t=null;if(typeof f.value=="function"?(m="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(m="get",t=f.get),!t)throw new Error("not supported");const y=`$memoize$${n}`;f[m]=function(...I){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,I)}),this[y]}}e.memoize=L;function k(b,n,f){return w((m,t)=>{const y=`$debounce$${t}`,I=`$debounce$result$${t}`;return function(...v){this[I]||(this[I]=f?f():void 0),clearTimeout(this[y]),n&&(this[I]=n(this[I],...v),v=[this[I]]),this[y]=setTimeout(()=>{m.apply(this,v),this[I]=f?f():void 0},b)}})}e.debounce=k;function M(b,n,f){return w((m,t)=>{const y=`$throttle$timer$${t}`,I=`$throttle$result$${t}`,v=`$throttle$lastRun$${t}`,h=`$throttle$pending$${t}`;return function(...g){if(this[I]||(this[I]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),n&&(this[I]=n(this[I],...g)),this[h])return;const P=this[v]+b;P<=Date.now()?(this[v]=Date.now(),m.apply(this,[this[I]]),this[I]=f?f():void 0):(this[h]=!0,this[y]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),m.apply(this,[this[I]]),this[I]=f?f():void 0},P-Date.now()))}})}e.throttle=M}),define(J[16],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=w,e.errorHandler=new w;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function k(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function M(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function b(c){if(c instanceof Error){let{name:i,message:s}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:i,message:s,stack:r}}return c}e.transformErrorForSerialization=b;const n="Canceled";function f(c){return c instanceof Error&&c.name===n&&c.message===n}e.isPromiseCanceledError=f;class m extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=m;function t(){const c=new Error(n);return c.name=c.message,c}e.canceled=t;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=y;function I(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=I;function v(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function g(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=g;class P extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=P;class S extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=S;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=u;function d(c){const i=c;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=d;function a(c,i=Object.create(null)){const s=new Error(c);return i.actions&&(s.actions=i.actions),s}e.createErrorWithActions=a}),define(J[36],Z([0,1,16]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(F,A=0){return F[F.length-(1+A)]}e.tail=L;function k(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=k;function M(F,A,_=(j,Y)=>j===Y){if(F===A)return!0;if(!F||!A||F.length!==A.length)return!1;for(let j=0,Y=F.length;j<Y;j++)if(!_(F[j],A[j]))return!1;return!0}e.equals=M;function b(F,A,_){let j=0,Y=F.length-1;for(;j<=Y;){const q=(j+Y)/2|0,X=_(F[q],A);if(X<0)j=q+1;else if(X>0)Y=q-1;else return q}return-(j+1)}e.binarySearch=b;function n(F,A){let _=0,j=F.length;if(j===0)return 0;for(;_<j;){const Y=Math.floor((_+j)/2);A(F[Y])?j=Y:_=Y+1}return _}e.findFirstInSorted=n;function f(F,A,_){if(F=F|0,F>=A.length)throw new TypeError("invalid index");let j=A[Math.floor(A.length*Math.random())],Y=[],q=[],X=[];for(let ie of A){const se=_(ie,j);se<0?Y.push(ie):se>0?q.push(ie):X.push(ie)}return F<Y.length?f(F,Y,_):F<Y.length+X.length?X[0]:f(F-(Y.length+X.length),q,_)}e.quickSelect=f;function m(F,A){const _=[];let j;for(const Y of F.slice(0).sort(A))!j||A(j[0],Y)!==0?(j=[Y],_.push(j)):j.push(Y);return _}e.groupBy=m;function t(F,A,_){const j=[];function Y(ie,se,ae){if(se===0&&ae.length===0)return;const ue=j[j.length-1];ue&&ue.start+ue.deleteCount===ie?(ue.deleteCount+=se,ue.toInsert.push(...ae)):j.push({start:ie,deleteCount:se,toInsert:ae})}let q=0,X=0;for(;;){if(q===F.length){Y(q,0,A.slice(X));break}if(X===A.length){Y(q,F.length-q,[]);break}const ie=F[q],se=A[X],ae=_(ie,se);ae===0?(q+=1,X+=1):ae<0?(Y(q,1,[]),q+=1):ae>0&&(Y(q,0,[se]),X+=1)}return j}e.sortedDiff=t;function y(F,A,_){const j=t(F,A,_),Y=[],q=[];for(const X of j)Y.push(...F.slice(X.start,X.start+X.deleteCount)),q.push(...X.toInsert);return{removed:Y,added:q}}e.delta=y;function I(F,A,_){if(_===0)return[];const j=F.slice(0,_).sort(A);return h(F,A,j,_,F.length),j}e.top=I;function v(F,A,_,j,Y){return _===0?Promise.resolve([]):new Promise((q,X)=>{(async()=>{const ie=F.length,se=F.slice(0,_).sort(A);for(let ae=_,ue=Math.min(_+j,ie);ae<ie;ae=ue,ue=Math.min(ue+j,ie)){if(ae>_&&await new Promise(re=>setTimeout(re)),Y&&Y.isCancellationRequested)throw(0,w.canceled)();h(F,A,se,ae,ue)}return se})().then(q,X)})}e.topAsync=v;function h(F,A,_,j,Y){for(const q=_.length;j<Y;j++){const X=F[j];if(A(X,_[q-1])<0){_.pop();const ie=n(_,se=>A(X,se)<0);_.splice(ie,0,X)}}}function g(F){return F.filter(A=>!!A)}e.coalesce=g;function P(F){let A=0;for(let _=0;_<F.length;_++)F[_]&&(F[A]=F[_],A+=1);F.length=A}e.coalesceInPlace=P;function S(F,A,_){F.splice(_,0,F.splice(A,1)[0])}e.move=S;function u(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=u;function d(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=d;function a(F,A){if(!A)return F.filter((j,Y)=>F.indexOf(j)===Y);const _=Object.create(null);return F.filter(j=>{const Y=A(j);return _[Y]?!1:(_[Y]=!0,!0)})}e.distinct=a;function c(F){const A=new Set;return F.filter(_=>A.has(_)?!1:(A.add(_),!0))}e.distinctES6=c;function i(F){const A=Object.create(null);return _=>{const j=F(_);return A[j]?!1:(A[j]=!0,!0)}}e.uniqueFilter=i;function s(F,A){for(let _=F.length-1;_>=0;_--){const j=F[_];if(A(j))return _}return-1}e.lastIndex=s;function r(F,A){return F.length>0?F[0]:A}e.firstOrDefault=r;function o(F,A,_=(j,Y)=>j===Y){let j=0;for(let Y=0,q=Math.min(F.length,A.length);Y<q&&_(F[Y],A[Y]);Y++)j++;return j}e.commonPrefixLength=o;function l(F){return[].concat(...F)}e.flatten=l;function p(F,A){let _=typeof A=="number"?F:0;typeof A=="number"?_=F:(_=0,A=F);const j=[];if(_<=A)for(let Y=_;Y<A;Y++)j.push(Y);else for(let Y=_;Y>A;Y--)j.push(Y);return j}e.range=p;function E(F,A,_){return F.reduce((j,Y)=>(j[A(Y)]=_?_(Y):Y,j),Object.create(null))}e.index=E;function D(F,A){return F.push(A),()=>R(F,A)}e.insert=D;function R(F,A){const _=F.indexOf(A);if(_>-1)return F.splice(_,1),A}e.remove=R;function W(F,A,_){const j=F.slice(0,A),Y=F.slice(A);return j.concat(_,Y)}e.arrayInsert=W;function N(F,A){let _;if(typeof A=="number"){let j=A;_=()=>{const Y=Math.sin(j++)*179426549;return Y-Math.floor(Y)}}else _=Math.random;for(let j=F.length-1;j>0;j-=1){const Y=Math.floor(_()*(j+1)),q=F[j];F[j]=F[Y],F[Y]=q}}e.shuffle=N;function G(F,A){const _=F.indexOf(A);_>-1&&(F.splice(_,1),F.unshift(A))}e.pushToStart=G;function x(F,A){const _=F.indexOf(A);_>-1&&(F.splice(_,1),F.push(A))}e.pushToEnd=x;function ne(F,A){return Array.isArray(F)?F.map(A):A(F)}e.mapArrayOrNot=ne;function V(F){return Array.isArray(F)?F:[F]}e.asArray=V;function Q(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=Q;function U(F,A){for(const _ of F){const j=A(_);if(j!==void 0)return j}}e.mapFind=U;function C(F,A,_){const j=z(F,A),Y=F.length,q=_.length;F.length=Y+q;for(let X=Y-1;X>=j;X--)F[X+q]=F[X];for(let X=0;X<q;X++)F[X+j]=_[X]}e.insertInto=C;function T(F,A,_,j){const Y=z(F,A),q=F.splice(Y,_);return C(F,Y,j),q}e.splice=T;function z(F,A){return A<0?Math.max(A+F.length,0):Math.min(A,F.length)}function B(F,A){let _=Number.MAX_SAFE_INTEGER,j=0;return F.forEach((Y,q)=>{const X=A(Y);X<_&&(_=X,j=q)}),j}e.minIndex=B;function O(F,A){let _=Number.MIN_SAFE_INTEGER,j=0;return F.forEach((Y,q)=>{const X=A(Y);X>_&&(_=X,j=q)}),j}e.maxIndex=O;class ${constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let _=this.firstIdx;for(;_<this.items.length&&A(this.items[_]);)_++;const j=_===this.firstIdx?null:this.items.slice(this.firstIdx,_);return this.firstIdx=_,j}takeFromEndWhile(A){let _=this.lastIdx;for(;_>=0&&A(this.items[_]);)_--;const j=_===this.lastIdx?null:this.items.slice(_+1,this.lastIdx+1);return this.lastIdx=_,j}}e.ArrayQueue=$}),define(J[43],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(L){const k=this;let M=!1,b;return function(){return M||(M=!0,b=L.apply(k,arguments)),b}}e.once=w}),define(J[63],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(L){function k(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function b(){return M}L.empty=b;function*n(c){yield c}L.single=n;function f(c){return c||M}L.from=f;function m(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=m;function t(c){return c[Symbol.iterator]().next().value}L.first=t;function y(c,i){for(const s of c)if(i(s))return!0;return!1}L.some=y;function I(c,i){for(const s of c)if(i(s))return s}L.find=I;function*v(c,i){for(const s of c)i(s)&&(yield s)}L.filter=v;function*h(c,i){let s=0;for(const r of c)yield i(r,s++)}L.map=h;function*g(...c){for(const i of c)for(const s of i)yield s}L.concat=g;function*P(c){for(const i of c)for(const s of i)yield s}L.concatNested=P;function S(c,i,s){let r=s;for(const o of c)r=i(r,o);return r}L.reduce=S;function*u(c,i,s=c.length){for(i<0&&(i+=c.length),s<0?s+=c.length:s>c.length&&(s=c.length);i<s;i++)yield c[i]}L.slice=u;function d(c,i=Number.POSITIVE_INFINITY){const s=[];if(i===0)return[s,c];const r=c[Symbol.iterator]();for(let o=0;o<i;o++){const l=r.next();if(l.done)return[s,L.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=d;function a(c,i,s=(r,o)=>r===o){const r=c[Symbol.iterator](),o=i[Symbol.iterator]();for(;;){const l=r.next(),p=o.next();if(l.done!==p.done)return!1;if(l.done)return!0;if(!s(l.value,p.value))return!1}}L.equals=a})(w=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function b(i,s=!1){let r=0,o=i.length,l="",p=0,E=16,D=0;function R(Q){let U=0,C=0;for(;U<Q;){const T=i.charCodeAt(r);if(T>=48&&T<=57)C=C*16+T-48;else if(T>=65&&T<=70)C=C*16+T-65+10;else if(T>=97&&T<=102)C=C*16+T-97+10;else break;r++,U++}return U<Q&&(C=-1),C}function W(Q){r=Q,l="",p=0,E=16,D=0}function N(){const Q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&m(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&m(i.charCodeAt(r)))for(r++;r<i.length&&m(i.charCodeAt(r));)r++;else return D=3,i.substring(Q,r);let U=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&m(i.charCodeAt(r))){for(r++;r<i.length&&m(i.charCodeAt(r));)r++;U=r}else D=3;return i.substring(Q,U)}function G(){let Q="",U=r;for(;;){if(r>=o){Q+=i.substring(U,r),D=2;break}const C=i.charCodeAt(r);if(C===34){Q+=i.substring(U,r),r++;break}if(C===92){if(Q+=i.substring(U,r),r++,r>=o){D=2;break}switch(i.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const z=R(4);z>=0?Q+=String.fromCharCode(z):D=4;break;default:D=5}U=r;continue}if(C>=0&&C<=31)if(f(C)){Q+=i.substring(U,r),D=2;break}else D=6;r++}return Q}function x(){if(l="",D=0,p=r,r>=o)return p=o,E=17;let Q=i.charCodeAt(r);if(n(Q)){do r++,l+=String.fromCharCode(Q),Q=i.charCodeAt(r);while(n(Q));return E=15}if(f(Q))return r++,l+=String.fromCharCode(Q),Q===13&&i.charCodeAt(r)===10&&(r++,l+=`
`),E=14;switch(Q){case 123:return r++,E=1;case 125:return r++,E=2;case 91:return r++,E=3;case 93:return r++,E=4;case 58:return r++,E=6;case 44:return r++,E=5;case 34:return r++,l=G(),E=10;case 47:const U=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<o&&!f(i.charCodeAt(r));)r++;return l=i.substring(U,r),E=12}if(i.charCodeAt(r+1)===42){r+=2;const C=o-1;let T=!1;for(;r<C;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,T=!0;break}r++}return T||(r++,D=1),l=i.substring(U,r),E=13}return l+=String.fromCharCode(Q),r++,E=16;case 45:if(l+=String.fromCharCode(Q),r++,r===o||!m(i.charCodeAt(r)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=N(),E=11;default:for(;r<o&&ne(Q);)r++,Q=i.charCodeAt(r);if(p!==r){switch(l=i.substring(p,r),l){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return l+=String.fromCharCode(Q),r++,E=16}}function ne(Q){if(n(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let Q;do Q=x();while(Q>=12&&Q<=15);return Q}return{setPosition:W,getPosition:()=>r,scan:s?V:x,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>D}}e.createScanner=b;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function y(i,s){const r=[],o=new Object;let l;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(R,W,N,G){p.value=R,p.offset=W,p.length=N,p.type=G,p.colonOffset=void 0,l=p}try{d(i,{onObjectBegin:(R,W)=>{if(s<=R)throw o;l=void 0,E=s>R,r.push("")},onObjectProperty:(R,W,N)=>{if(s<W||(D(R,W,N,"property"),r[r.length-1]=R,s<=W+N))throw o},onObjectEnd:(R,W)=>{if(s<=R)throw o;l=void 0,r.pop()},onArrayBegin:(R,W)=>{if(s<=R)throw o;l=void 0,r.push(0)},onArrayEnd:(R,W)=>{if(s<=R)throw o;l=void 0,r.pop()},onLiteralValue:(R,W,N)=>{if(s<W||(D(R,W,N,c(R)),s<=W+N))throw o},onSeparator:(R,W,N)=>{if(s<=W)throw o;if(R===":"&&l&&l.type==="property")l.colonOffset=W,E=!1,l=void 0;else if(R===","){const G=r[r.length-1];typeof G=="number"?r[r.length-1]=G+1:(E=!0,r[r.length-1]=""),l=void 0}}})}catch(R){if(R!==o)throw R}return{path:r,previousNode:l,isAtPropertyKey:E,matches:R=>{let W=0;for(let N=0;W<R.length&&N<r.length;N++)if(R[W]===r[N]||R[W]==="*")W++;else if(R[W]!=="**")return!1;return W===R.length}}}e.getLocation=y;function I(i,s=[],r=M.DEFAULT){let o=null,l=[];const p=[];function E(R){Array.isArray(l)?l.push(R):o!==null&&(l[o]=R)}return d(i,{onObjectBegin:()=>{const R={};E(R),p.push(l),l=R,o=null},onObjectProperty:R=>{o=R},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const R=[];E(R),p.push(l),l=R,o=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:E,onError:(R,W,N)=>{s.push({error:R,offset:W,length:N})}},r),l[0]}e.parse=I;function v(i,s=[],r=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){o.type==="property"&&(o.length=R-o.offset,o=o.parent)}function p(R){return o.children.push(R),R}d(i,{onObjectBegin:R=>{o=p({type:"object",offset:R,length:-1,parent:o,children:[]})},onObjectProperty:(R,W,N)=>{o=p({type:"property",offset:W,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:R,offset:W,length:N,parent:o})},onObjectEnd:(R,W)=>{o.length=R+W-o.offset,o=o.parent,l(R+W)},onArrayBegin:(R,W)=>{o=p({type:"array",offset:R,length:-1,parent:o,children:[]})},onArrayEnd:(R,W)=>{o.length=R+W-o.offset,o=o.parent,l(R+W)},onLiteralValue:(R,W,N)=>{p({type:c(R),offset:W,length:N,parent:o,value:R}),l(W+N)},onSeparator:(R,W,N)=>{o.type==="property"&&(R===":"?o.colonOffset=W:R===","&&l(W))},onError:(R,W,N)=>{s.push({error:R,offset:W,length:N})}},r);const D=o.children[0];return D&&delete D.parent,D}e.parseTree=v;function h(i,s){if(!i)return;let r=i;for(let o of s)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===o){r=p.children[1],l=!0;break}if(!l)return}else{const l=o;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=h;function g(i){if(!i.parent||!i.parent.children)return[];const s=g(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;s.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&s.push(r)}return s}e.getNodePath=g;function P(i){switch(i.type){case"array":return i.children.map(P);case"object":const s=Object.create(null);for(let r of i.children){const o=r.children[1];o&&(s[r.children[0].value]=P(o))}return s;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=P;function S(i,s,r=!1){return s>=i.offset&&s<i.offset+i.length||r&&s===i.offset+i.length}e.contains=S;function u(i,s,r=!1){if(S(i,s,r)){const o=i.children;if(Array.isArray(o))for(let l=0;l<o.length&&o[l].offset<=s;l++){const p=u(o[l],s,r);if(p)return p}return i}}e.findNodeAtOffset=u;function d(i,s,r=M.DEFAULT){const o=b(i,!1);function l(_){return _?()=>_(o.getTokenOffset(),o.getTokenLength()):()=>!0}function p(_){return _?j=>_(j,o.getTokenOffset(),o.getTokenLength()):()=>!0}const E=l(s.onObjectBegin),D=p(s.onObjectProperty),R=l(s.onObjectEnd),W=l(s.onArrayBegin),N=l(s.onArrayEnd),G=p(s.onLiteralValue),x=p(s.onSeparator),ne=l(s.onComment),V=p(s.onError),Q=r&&r.disallowComments,U=r&&r.allowTrailingComma;function C(){for(;;){const _=o.scan();switch(o.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:Q||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(_){case 12:case 13:Q?T(10):ne();break;case 16:T(1);break;case 15:case 14:break;default:return _}}}function T(_,j=[],Y=[]){if(V(_),j.length+Y.length>0){let q=o.getToken();for(;q!==17;){if(j.indexOf(q)!==-1){C();break}else if(Y.indexOf(q)!==-1)break;q=C()}}}function z(_){const j=o.getTokenValue();return _?G(j):D(j),C(),!0}function B(){switch(o.getToken()){case 11:let _=0;try{_=JSON.parse(o.getTokenValue()),typeof _!="number"&&(T(2),_=0)}catch(j){T(2)}G(_);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return C(),!0}function O(){return o.getToken()!==10?(T(3,[],[2,5]),!1):(z(!1),o.getToken()===6?(x(":"),C(),A()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function $(){E(),C();let _=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(_||T(4,[],[]),x(","),C(),o.getToken()===2&&U)break}else _&&T(6,[],[]);O()||T(4,[],[2,5]),_=!0}return R(),o.getToken()!==2?T(7,[2],[]):C(),!0}function F(){W(),C();let _=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(_||T(4,[],[]),x(","),C(),o.getToken()===4&&U)break}else _&&T(6,[],[]);A()||T(4,[],[4,5]),_=!0}return N(),o.getToken()!==4?T(8,[4],[]):C(),!0}function A(){switch(o.getToken()){case 3:return F();case 1:return $();case 10:return z(!0);default:return B()}}return C(),o.getToken()===17?r.allowEmptyContent?!0:(T(4,[],[]),!1):A()?(o.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.visit=d;function a(i,s){let r=b(i),o=[],l,p=0,E;do switch(E=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:p!==E&&o.push(i.substring(p,E)),s!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,s)),p=r.getPosition();break}while(l!==17);return o.join("")}e.stripComments=a;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[103],Z([0,1,40]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,m,t){let y,I,v,h,g;if(m){for(h=m.offset,g=h+m.length,v=h;v>0&&!n(f,v-1);)v--;let p=g;for(;p<f.length&&!n(f,p);)p++;I=f.substring(v,p),y=M(I,t)}else I=f,y=0,v=0,h=0,g=f.length;const P=b(t,f);let S=!1,u=0,d;t.insertSpaces?d=k(" ",t.tabSize||4):d="	";const a=(0,w.createScanner)(I,!1);let c=!1;function i(){return P+k(d,y+u)}function s(){let p=a.scan();for(S=!1;p===15||p===14;)S=S||p===14,p=a.scan();return c=p===16||a.getTokenError()!==0,p}const r=[];function o(p,E,D){!c&&E<g&&D>h&&f.substring(E,D)!==p&&r.push({offset:E,length:D-E,content:p})}let l=s();if(l!==17){const p=a.getTokenOffset()+v,E=k(d,y);o(E,v,p)}for(;l!==17;){let p=a.getTokenOffset()+a.getTokenLength()+v,E=s(),D="";for(;!S&&(E===12||E===13);){const W=a.getTokenOffset()+v;o(" ",p,W),p=a.getTokenOffset()+a.getTokenLength()+v,D=E===12?i():"",E=s()}if(E===2)l!==1&&(u--,D=i());else if(E===4)l!==3&&(u--,D=i());else{switch(l){case 3:case 1:u++,D=i();break;case 5:case 12:D=i();break;case 13:S?D=i():D=" ";break;case 6:D=" ";break;case 10:if(E===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?D=" ":E!==5&&E!==17&&(c=!0);break;case 16:c=!0;break}S&&(E===12||E===13)&&(D=i())}const R=a.getTokenOffset()+v;o(D,p,R),l=E}return r}e.format=L;function k(f,m){let t="";for(let y=0;y<m;y++)t+=f;return t}function M(f,m){let t=0,y=0;const I=m.tabSize||4;for(;t<f.length;){const v=f.charAt(t);if(v===" ")y++;else if(v==="	")y+=I;else break;t++}return Math.floor(y/I)}function b(f,m){for(let t=0;t<m.length;t++){const y=m.charAt(t);if(y==="\r")return t+1<m.length&&m.charAt(t+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=b;function n(f,m){return`\r
`.indexOf(f.charAt(m))!==-1}e.isEOL=n}),define(J[76],Z([0,1,40,103]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,t,y){return M(m,t,void 0,y)}e.removeProperty=k;function M(m,t,y,I,v){const h=t.slice(),g=[],P=(0,w.parseTree)(m,g);let S,u;for(;h.length>0&&(u=h.pop(),S=(0,w.findNodeAtLocation)(P,h),S===void 0&&y!==void 0);)typeof u=="string"?y={[u]:y}:y=[y];if(S)if(S.type==="object"&&typeof u=="string"&&Array.isArray(S.children)){const d=(0,w.findNodeAtLocation)(S,[u]);if(d!==void 0)if(y===void 0){if(!d.parent)throw new Error("Malformed AST");const a=S.children.indexOf(d.parent);let c,i=d.parent.offset+d.parent.length;if(a>0){const s=S.children[a-1];c=s.offset+s.length}else c=S.offset+1,S.children.length>1&&(i=S.children[1].offset);return b(m,{offset:c,length:i-c,content:""},I)}else return b(m,{offset:d.offset,length:d.length,content:JSON.stringify(y)},I);else{if(y===void 0)return[];const a=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,c=v?v(S.children.map(s=>s.children[0].value)):S.children.length;let i;if(c>0){const s=S.children[c-1];i={offset:s.offset+s.length,length:0,content:","+a}}else S.children.length===0?i={offset:S.offset+1,length:0,content:a}:i={offset:S.offset+1,length:0,content:a+","};return b(m,i,I)}}else if(S.type==="array"&&typeof u=="number"&&Array.isArray(S.children))if(y!==void 0){const d=`${JSON.stringify(y)}`;let a;if(S.children.length===0||u===0)a={offset:S.offset+1,length:0,content:S.children.length===0?d:d+","};else{const c=u===-1||u>S.children.length?S.children.length:u,i=S.children[c-1];a={offset:i.offset+i.length,length:0,content:","+d}}return b(m,a,I)}else{const d=u,a=S.children[d];let c;if(S.children.length===1)c={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===d){const i=S.children[d-1],s=i.offset+i.length,r=S.offset+S.length;c={offset:s,length:r-2-s,content:""}}else c={offset:a.offset,length:S.children[d+1].offset-a.offset,content:""};return b(m,c,I)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${S.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return b(m,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(y)},I)}}e.setProperty=M;function b(m,t,y){let I=n(m,t),v=t.offset,h=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;v>0&&!(0,L.isEOL)(I,v-1);)v--;for(;h<I.length&&!(0,L.isEOL)(I,h);)h++}const g=(0,L.format)(I,{offset:v,length:h-v},y);for(let S=g.length-1;S>=0;S--){const u=g[S];I=n(I,u),v=Math.min(v,u.offset),h=Math.max(h,u.offset+u.length),h+=u.content.length-u.length}const P=m.length-(I.length-h)-v;return[{offset:v,length:P,content:I.substring(v,h)}]}e.withFormatting=b;function n(m,t){return m.substring(0,t.offset)+t.content+m.substring(t.offset+t.length)}e.applyEdit=n;function f(m,t){let y=t.slice(0).sort((v,h)=>{const g=v.offset-h.offset;return g===0?v.length-h.length:g}),I=m.length;for(let v=y.length-1;v>=0;v--){let h=y[v];if(h.offset+h.length<=I)m=n(m,h);else throw new Error("Overlapping edit");I=h.offset}return m}e.applyEdits=f}),define(J[57],Z([0,1,16]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(u){u[u.DependsOnKbLayout=-1]="DependsOnKbLayout",u[u.Unknown=0]="Unknown",u[u.Backspace=1]="Backspace",u[u.Tab=2]="Tab",u[u.Enter=3]="Enter",u[u.Shift=4]="Shift",u[u.Ctrl=5]="Ctrl",u[u.Alt=6]="Alt",u[u.PauseBreak=7]="PauseBreak",u[u.CapsLock=8]="CapsLock",u[u.Escape=9]="Escape",u[u.Space=10]="Space",u[u.PageUp=11]="PageUp",u[u.PageDown=12]="PageDown",u[u.End=13]="End",u[u.Home=14]="Home",u[u.LeftArrow=15]="LeftArrow",u[u.UpArrow=16]="UpArrow",u[u.RightArrow=17]="RightArrow",u[u.DownArrow=18]="DownArrow",u[u.Insert=19]="Insert",u[u.Delete=20]="Delete",u[u.KEY_0=21]="KEY_0",u[u.KEY_1=22]="KEY_1",u[u.KEY_2=23]="KEY_2",u[u.KEY_3=24]="KEY_3",u[u.KEY_4=25]="KEY_4",u[u.KEY_5=26]="KEY_5",u[u.KEY_6=27]="KEY_6",u[u.KEY_7=28]="KEY_7",u[u.KEY_8=29]="KEY_8",u[u.KEY_9=30]="KEY_9",u[u.KEY_A=31]="KEY_A",u[u.KEY_B=32]="KEY_B",u[u.KEY_C=33]="KEY_C",u[u.KEY_D=34]="KEY_D",u[u.KEY_E=35]="KEY_E",u[u.KEY_F=36]="KEY_F",u[u.KEY_G=37]="KEY_G",u[u.KEY_H=38]="KEY_H",u[u.KEY_I=39]="KEY_I",u[u.KEY_J=40]="KEY_J",u[u.KEY_K=41]="KEY_K",u[u.KEY_L=42]="KEY_L",u[u.KEY_M=43]="KEY_M",u[u.KEY_N=44]="KEY_N",u[u.KEY_O=45]="KEY_O",u[u.KEY_P=46]="KEY_P",u[u.KEY_Q=47]="KEY_Q",u[u.KEY_R=48]="KEY_R",u[u.KEY_S=49]="KEY_S",u[u.KEY_T=50]="KEY_T",u[u.KEY_U=51]="KEY_U",u[u.KEY_V=52]="KEY_V",u[u.KEY_W=53]="KEY_W",u[u.KEY_X=54]="KEY_X",u[u.KEY_Y=55]="KEY_Y",u[u.KEY_Z=56]="KEY_Z",u[u.Meta=57]="Meta",u[u.ContextMenu=58]="ContextMenu",u[u.F1=59]="F1",u[u.F2=60]="F2",u[u.F3=61]="F3",u[u.F4=62]="F4",u[u.F5=63]="F5",u[u.F6=64]="F6",u[u.F7=65]="F7",u[u.F8=66]="F8",u[u.F9=67]="F9",u[u.F10=68]="F10",u[u.F11=69]="F11",u[u.F12=70]="F12",u[u.F13=71]="F13",u[u.F14=72]="F14",u[u.F15=73]="F15",u[u.F16=74]="F16",u[u.F17=75]="F17",u[u.F18=76]="F18",u[u.F19=77]="F19",u[u.NumLock=78]="NumLock",u[u.ScrollLock=79]="ScrollLock",u[u.US_SEMICOLON=80]="US_SEMICOLON",u[u.US_EQUAL=81]="US_EQUAL",u[u.US_COMMA=82]="US_COMMA",u[u.US_MINUS=83]="US_MINUS",u[u.US_DOT=84]="US_DOT",u[u.US_SLASH=85]="US_SLASH",u[u.US_BACKTICK=86]="US_BACKTICK",u[u.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",u[u.US_BACKSLASH=88]="US_BACKSLASH",u[u.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",u[u.US_QUOTE=90]="US_QUOTE",u[u.OEM_8=91]="OEM_8",u[u.OEM_102=92]="OEM_102",u[u.NUMPAD_0=93]="NUMPAD_0",u[u.NUMPAD_1=94]="NUMPAD_1",u[u.NUMPAD_2=95]="NUMPAD_2",u[u.NUMPAD_3=96]="NUMPAD_3",u[u.NUMPAD_4=97]="NUMPAD_4",u[u.NUMPAD_5=98]="NUMPAD_5",u[u.NUMPAD_6=99]="NUMPAD_6",u[u.NUMPAD_7=100]="NUMPAD_7",u[u.NUMPAD_8=101]="NUMPAD_8",u[u.NUMPAD_9=102]="NUMPAD_9",u[u.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",u[u.NUMPAD_ADD=104]="NUMPAD_ADD",u[u.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",u[u.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",u[u.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",u[u.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",u[u.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",u[u.ABNT_C1=110]="ABNT_C1",u[u.ABNT_C2=111]="ABNT_C2",u[u.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,a){this._keyCodeToStr[d]=a,this._strToKeyCode[a.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new k,b=new k,n=new k;(function(){function u(d,a,c=a,i=c){M.define(d,a),b.define(d,c),n.define(d,i)}u(0,"unknown"),u(1,"Backspace"),u(2,"Tab"),u(3,"Enter"),u(4,"Shift"),u(5,"Ctrl"),u(6,"Alt"),u(7,"PauseBreak"),u(8,"CapsLock"),u(9,"Escape"),u(10,"Space"),u(11,"PageUp"),u(12,"PageDown"),u(13,"End"),u(14,"Home"),u(15,"LeftArrow","Left"),u(16,"UpArrow","Up"),u(17,"RightArrow","Right"),u(18,"DownArrow","Down"),u(19,"Insert"),u(20,"Delete"),u(21,"0"),u(22,"1"),u(23,"2"),u(24,"3"),u(25,"4"),u(26,"5"),u(27,"6"),u(28,"7"),u(29,"8"),u(30,"9"),u(31,"A"),u(32,"B"),u(33,"C"),u(34,"D"),u(35,"E"),u(36,"F"),u(37,"G"),u(38,"H"),u(39,"I"),u(40,"J"),u(41,"K"),u(42,"L"),u(43,"M"),u(44,"N"),u(45,"O"),u(46,"P"),u(47,"Q"),u(48,"R"),u(49,"S"),u(50,"T"),u(51,"U"),u(52,"V"),u(53,"W"),u(54,"X"),u(55,"Y"),u(56,"Z"),u(57,"Meta"),u(58,"ContextMenu"),u(59,"F1"),u(60,"F2"),u(61,"F3"),u(62,"F4"),u(63,"F5"),u(64,"F6"),u(65,"F7"),u(66,"F8"),u(67,"F9"),u(68,"F10"),u(69,"F11"),u(70,"F12"),u(71,"F13"),u(72,"F14"),u(73,"F15"),u(74,"F16"),u(75,"F17"),u(76,"F18"),u(77,"F19"),u(78,"NumLock"),u(79,"ScrollLock"),u(80,";",";","OEM_1"),u(81,"=","=","OEM_PLUS"),u(82,",",",","OEM_COMMA"),u(83,"-","-","OEM_MINUS"),u(84,".",".","OEM_PERIOD"),u(85,"/","/","OEM_2"),u(86,"`","`","OEM_3"),u(110,"ABNT_C1"),u(111,"ABNT_C2"),u(87,"[","[","OEM_4"),u(88,"\\","\\","OEM_5"),u(89,"]","]","OEM_6"),u(90,"'","'","OEM_7"),u(91,"OEM_8"),u(92,"OEM_102"),u(93,"NumPad0"),u(94,"NumPad1"),u(95,"NumPad2"),u(96,"NumPad3"),u(97,"NumPad4"),u(98,"NumPad5"),u(99,"NumPad6"),u(100,"NumPad7"),u(101,"NumPad8"),u(102,"NumPad9"),u(103,"NumPad_Multiply"),u(104,"NumPad_Add"),u(105,"NumPad_Separator"),u(106,"NumPad_Subtract"),u(107,"NumPad_Decimal"),u(108,"NumPad_Divide")})();var f;(function(u){function d(r){return M.keyCodeToStr(r)}u.toString=d;function a(r){return M.strToKeyCode(r)}u.fromString=a;function c(r){return b.keyCodeToStr(r)}u.toUserSettingsUS=c;function i(r){return n.keyCodeToStr(r)}u.toUserSettingsGeneral=i;function s(r){return b.strToKeyCode(r)||n.strToKeyCode(r)}u.fromUserSettings=s})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl",u[u.KeyCode=255]="KeyCode"})(m||(m={}));var t;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function y(u,d){const a=(d&65535)<<16>>>0;return(u|a)>>>0}e.KeyChord=y;function I(u,d){if(u===0)return null;const a=(u&65535)>>>0,c=(u&4294901760)>>>16;return c!==0?new g([v(a,d),v(c,d)]):new g([v(a,d)])}e.createKeybinding=I;function v(u,d){const a=!!(u&2048),c=!!(u&256),i=d===2?c:a,s=!!(u&1024),r=!!(u&512),o=d===2?a:c,l=u&255;return new h(i,s,r,o,l)}e.createSimpleKeybinding=v;class h{constructor(d,a,c,i,s){this.ctrlKey=d,this.shiftKey=a,this.altKey=c,this.metaKey=i,this.keyCode=s}equals(d){return this.ctrlKey===d.ctrlKey&&this.shiftKey===d.shiftKey&&this.altKey===d.altKey&&this.metaKey===d.metaKey&&this.keyCode===d.keyCode}getHashCode(){const d=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",c=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${d}${a}${c}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=h;class g{constructor(d){if(d.length===0)throw(0,w.illegalArgument)("parts");this.parts=d}getHashCode(){let d="";for(let a=0,c=this.parts.length;a<c;a++)a!==0&&(d+=";"),d+=this.parts[a].getHashCode();return d}equals(d){if(d===null||this.parts.length!==d.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(d.parts[a]))return!1;return!0}}e.ChordKeybinding=g;class P{constructor(d,a,c,i,s,r){this.ctrlKey=d,this.shiftKey=a,this.altKey=c,this.metaKey=i,this.keyLabel=s,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=P;class S{}e.ResolvedKeybinding=S}),define(J[2],Z([0,1,43,63]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function b(r){M=r}if(e.setDisposableTracker=b,k){const r="__is_disposable_tracked__";b(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==u.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==u.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function n(r){return M?.trackDisposable(r),r}function f(r){M?.markAsDisposed(r)}function m(r,o){M?.setParent(r,o)}function t(r,o){if(!!M)for(const l of r)M.setParent(l,o)}function y(r){return M?.markAsSingleton(r),r}e.markAsSingleton=y;class I extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=I;function v(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=v;function h(r){if(L.Iterable.is(r)){let o=[];for(const l of r)if(l)try{l.dispose()}catch(p){o.push(p)}if(o.length===1)throw o[0];if(o.length>1)throw new I(o);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function g(...r){const o=P(()=>h(r));return t(r,o),o}e.combinedDisposable=g;function P(r){const o=n({dispose:(0,w.once)(()=>{f(o),r()})});return o}e.toDisposable=P;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return m(o,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new S,n(this),m(this._store,this)}dispose(){f(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&m(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&m(o,null),o}}e.MutableDisposable=d;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class c{constructor(){this.references=new Map}acquire(o,...l){let p=this.references.get(o);p||(p={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,p));const{object:E}=p,D=(0,w.once)(()=>{--p.counter==0&&(this.destroyReferencedObject(o,p.object),this.references.delete(o))});return p.counter++,{object:E,dispose:D}}}e.ReferenceCollection=c;class i{constructor(o){this.referenceCollection=o}async acquire(o,...l){const p=this.referenceCollection.acquire(o,...l);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(E){throw p.dispose(),E}}}e.AsyncReferenceCollection=i;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s}),define(J[104],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(M){this.element=M,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class L{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let M=this._first;for(;M!==w.Undefined;){const b=M.next;M.prev=w.Undefined,M.next=w.Undefined,M=b}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,b){const n=new w(M);if(this._first===w.Undefined)this._first=n,this._last=n;else if(b){const m=this._last;this._last=n,n.prev=m,m.next=n}else{const m=this._first;this._first=n,n.next=m,m.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==w.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==w.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==w.Undefined&&M.next!==w.Undefined){const b=M.prev;b.next=M.next,M.next.prev=b}else M.prev===w.Undefined&&M.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):M.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):M.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==w.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function H(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function b(f){M.push(f,Date.now())}function n(){const f=[];for(let m=0;m<M.length;m+=2)f.push({name:M[m],startTime:M[m+1]});return f}return{mark:b,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const b of performance.getEntriesByType("mark"))M.push({name:b.name,startTime:Math.round(k+b.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),define(J[3],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const w="en";let L=!1,k=!1,M=!1,b=!1,n=!1,f=!1,m=!1,t,y=w,I,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const g=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=g&&h?.sandboxed,typeof navigator=="object"&&!g)v=navigator.userAgent,L=v.indexOf("Windows")>=0,k=v.indexOf("Macintosh")>=0,m=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=v.indexOf("Linux")>=0,f=!0,t=navigator.language,y=t;else if(typeof h=="object"){L=h.platform==="win32",k=h.platform==="darwin",M=h.platform==="linux",b=M&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,t=w,y=w;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),l=o.availableLanguages["*"];t=o.locale,y=l||w,I=o._translationsConfigFile}catch(o){}n=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let u=0;k?u=1:L?u=3:M&&(u=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=b,e.isNative=n,e.isWeb=f,e.isIOS=m,e.platform=u,e.userAgent=v,e.language=y;var d;(function(r){function o(){return e.language}r.value=o;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function p(){return e.language==="en"}r.isDefault=p})(d=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=I,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let D=0,R=l.length;D<R;D++){const W=l[D];if(W.id===E.data.vscodeSetImmediateId){l.splice(D,1),W.callback();return}}});let p=0;return E=>{const D=++p;l.push({id:D,callback:E}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const o=Promise.resolve();return l=>o.then(l)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||m?2:L?1:3;let c=!0,i=!1;function s(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=s}),define(J[33],Z([0,1,3]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const k=w.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,w.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(k){return(0,w.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(J[7],Z([0,1,33]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,M=90,b=122,n=46,f=47,m=92,t=58,y=63;class I extends Error{constructor(a,c,i){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${s} of type ${c}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function v(d,a){if(typeof d!="string")throw new I(a,"string",d)}function h(d){return d===f||d===m}function g(d){return d===f}function P(d){return d>=L&&d<=M||d>=k&&d<=b}function S(d,a,c,i){let s="",r=0,o=-1,l=0,p=0;for(let E=0;E<=d.length;++E){if(E<d.length)p=d.charCodeAt(E);else{if(i(p))break;p=f}if(i(p)){if(!(o===E-1||l===1))if(l===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==n||s.charCodeAt(s.length-2)!==n){if(s.length>2){const D=s.lastIndexOf(c);D===-1?(s="",r=0):(s=s.slice(0,D),r=s.length-1-s.lastIndexOf(c)),o=E,l=0;continue}else if(s.length!==0){s="",r=0,o=E,l=0;continue}}a&&(s+=s.length>0?`${c}..`:"..",r=2)}else s.length>0?s+=`${c}${d.slice(o+1,E)}`:s=d.slice(o+1,E),r=E-o-1;o=E,l=0}else p===n&&l!==-1?++l:l=-1}return s}function u(d,a){if(a===null||typeof a!="object")throw new I("pathObject","Object",a);const c=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return c?c===a.root?`${c}${i}`:`${c}${d}${i}`:i}e.win32={resolve(...d){let a="",c="",i=!1;for(let s=d.length-1;s>=-1;s--){let r;if(s>=0){if(r=d[s],v(r,"path"),r.length===0)continue}else a.length===0?r=w.cwd():(r=w.env[`=${a}`]||w.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${a}\\`));const o=r.length;let l=0,p="",E=!1;const D=r.charCodeAt(0);if(o===1)h(D)&&(l=1,E=!0);else if(h(D))if(E=!0,h(r.charCodeAt(1))){let R=2,W=R;for(;R<o&&!h(r.charCodeAt(R));)R++;if(R<o&&R!==W){const N=r.slice(W,R);for(W=R;R<o&&h(r.charCodeAt(R));)R++;if(R<o&&R!==W){for(W=R;R<o&&!h(r.charCodeAt(R));)R++;(R===o||R!==W)&&(p=`\\\\${N}\\${r.slice(W,R)}`,l=R)}}}else l=1;else P(D)&&r.charCodeAt(1)===t&&(p=r.slice(0,2),l=2,o>2&&h(r.charCodeAt(2))&&(E=!0,l=3));if(p.length>0)if(a.length>0){if(p.toLowerCase()!==a.toLowerCase())continue}else a=p;if(i){if(a.length>0)break}else if(c=`${r.slice(l)}\\${c}`,i=E,E&&a.length>0)break}return c=S(c,!i,"\\",h),i?`${a}\\${c}`:`${a}${c}`||"."},normalize(d){v(d,"path");const a=d.length;if(a===0)return".";let c=0,i,s=!1;const r=d.charCodeAt(0);if(a===1)return g(r)?"\\":d;if(h(r))if(s=!0,h(d.charCodeAt(1))){let l=2,p=l;for(;l<a&&!h(d.charCodeAt(l));)l++;if(l<a&&l!==p){const E=d.slice(p,l);for(p=l;l<a&&h(d.charCodeAt(l));)l++;if(l<a&&l!==p){for(p=l;l<a&&!h(d.charCodeAt(l));)l++;if(l===a)return`\\\\${E}\\${d.slice(p)}\\`;l!==p&&(i=`\\\\${E}\\${d.slice(p,l)}`,c=l)}}}else c=1;else P(r)&&d.charCodeAt(1)===t&&(i=d.slice(0,2),c=2,a>2&&h(d.charCodeAt(2))&&(s=!0,c=3));let o=c<a?S(d.slice(c),!s,"\\",h):"";return o.length===0&&!s&&(o="."),o.length>0&&h(d.charCodeAt(a-1))&&(o+="\\"),i===void 0?s?`\\${o}`:o:s?`${i}\\${o}`:`${i}${o}`},isAbsolute(d){v(d,"path");const a=d.length;if(a===0)return!1;const c=d.charCodeAt(0);return h(c)||a>2&&P(c)&&d.charCodeAt(1)===t&&h(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let a,c;for(let r=0;r<d.length;++r){const o=d[r];v(o,"path"),o.length>0&&(a===void 0?a=c=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,s=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++s;const r=c.length;r>1&&h(c.charCodeAt(1))&&(++s,r>2&&(h(c.charCodeAt(2))?++s:i=!1))}if(i){for(;s<a.length&&h(a.charCodeAt(s));)s++;s>=2&&(a=`\\${a.slice(s)}`)}return e.win32.normalize(a)},relative(d,a){if(v(d,"from"),v(a,"to"),d===a)return"";const c=e.win32.resolve(d),i=e.win32.resolve(a);if(c===i||(d=c.toLowerCase(),a=i.toLowerCase(),d===a))return"";let s=0;for(;s<d.length&&d.charCodeAt(s)===m;)s++;let r=d.length;for(;r-1>s&&d.charCodeAt(r-1)===m;)r--;const o=r-s;let l=0;for(;l<a.length&&a.charCodeAt(l)===m;)l++;let p=a.length;for(;p-1>l&&a.charCodeAt(p-1)===m;)p--;const E=p-l,D=o<E?o:E;let R=-1,W=0;for(;W<D;W++){const G=d.charCodeAt(s+W);if(G!==a.charCodeAt(l+W))break;G===m&&(R=W)}if(W!==D){if(R===-1)return i}else{if(E>D){if(a.charCodeAt(l+W)===m)return i.slice(l+W+1);if(W===2)return i.slice(l+W)}o>D&&(d.charCodeAt(s+W)===m?R=W:W===2&&(R=3)),R===-1&&(R=0)}let N="";for(W=s+R+1;W<=r;++W)(W===r||d.charCodeAt(W)===m)&&(N+=N.length===0?"..":"\\..");return l+=R,N.length>0?`${N}${i.slice(l,p)}`:(i.charCodeAt(l)===m&&++l,i.slice(l,p))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const a=e.win32.resolve(d);if(a.length<=2)return d;if(a.charCodeAt(0)===m){if(a.charCodeAt(1)===m){const c=a.charCodeAt(2);if(c!==y&&c!==n)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(P(a.charCodeAt(0))&&a.charCodeAt(1)===t&&a.charCodeAt(2)===m)return`\\\\?\\${a}`;return d},dirname(d){v(d,"path");const a=d.length;if(a===0)return".";let c=-1,i=0;const s=d.charCodeAt(0);if(a===1)return h(s)?d:".";if(h(s)){if(c=i=1,h(d.charCodeAt(1))){let l=2,p=l;for(;l<a&&!h(d.charCodeAt(l));)l++;if(l<a&&l!==p){for(p=l;l<a&&h(d.charCodeAt(l));)l++;if(l<a&&l!==p){for(p=l;l<a&&!h(d.charCodeAt(l));)l++;if(l===a)return d;l!==p&&(c=i=l+1)}}}}else P(s)&&d.charCodeAt(1)===t&&(c=a>2&&h(d.charCodeAt(2))?3:2,i=c);let r=-1,o=!0;for(let l=a-1;l>=i;--l)if(h(d.charCodeAt(l))){if(!o){r=l;break}}else o=!1;if(r===-1){if(c===-1)return".";r=c}return d.slice(0,r)},basename(d,a){a!==void 0&&v(a,"ext"),v(d,"path");let c=0,i=-1,s=!0,r;if(d.length>=2&&P(d.charCodeAt(0))&&d.charCodeAt(1)===t&&(c=2),a!==void 0&&a.length>0&&a.length<=d.length){if(a===d)return"";let o=a.length-1,l=-1;for(r=d.length-1;r>=c;--r){const p=d.charCodeAt(r);if(h(p)){if(!s){c=r+1;break}}else l===-1&&(s=!1,l=r+1),o>=0&&(p===a.charCodeAt(o)?--o==-1&&(i=r):(o=-1,i=l))}return c===i?i=l:i===-1&&(i=d.length),d.slice(c,i)}for(r=d.length-1;r>=c;--r)if(h(d.charCodeAt(r))){if(!s){c=r+1;break}}else i===-1&&(s=!1,i=r+1);return i===-1?"":d.slice(c,i)},extname(d){v(d,"path");let a=0,c=-1,i=0,s=-1,r=!0,o=0;d.length>=2&&d.charCodeAt(1)===t&&P(d.charCodeAt(0))&&(a=i=2);for(let l=d.length-1;l>=a;--l){const p=d.charCodeAt(l);if(h(p)){if(!r){i=l+1;break}continue}s===-1&&(r=!1,s=l+1),p===n?c===-1?c=l:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||s===-1||o===0||o===1&&c===s-1&&c===i+1?"":d.slice(c,s)},format:u.bind(null,"\\"),parse(d){v(d,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return a;const c=d.length;let i=0,s=d.charCodeAt(0);if(c===1)return h(s)?(a.root=a.dir=d,a):(a.base=a.name=d,a);if(h(s)){if(i=1,h(d.charCodeAt(1))){let R=2,W=R;for(;R<c&&!h(d.charCodeAt(R));)R++;if(R<c&&R!==W){for(W=R;R<c&&h(d.charCodeAt(R));)R++;if(R<c&&R!==W){for(W=R;R<c&&!h(d.charCodeAt(R));)R++;R===c?i=R:R!==W&&(i=R+1)}}}}else if(P(s)&&d.charCodeAt(1)===t){if(c<=2)return a.root=a.dir=d,a;if(i=2,h(d.charCodeAt(2))){if(c===3)return a.root=a.dir=d,a;i=3}}i>0&&(a.root=d.slice(0,i));let r=-1,o=i,l=-1,p=!0,E=d.length-1,D=0;for(;E>=i;--E){if(s=d.charCodeAt(E),h(s)){if(!p){o=E+1;break}continue}l===-1&&(p=!1,l=E+1),s===n?r===-1?r=E:D!==1&&(D=1):r!==-1&&(D=-1)}return l!==-1&&(r===-1||D===0||D===1&&r===l-1&&r===o+1?a.base=a.name=d.slice(o,l):(a.name=d.slice(o,r),a.base=d.slice(o,l),a.ext=d.slice(r,l))),o>0&&o!==i?a.dir=d.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let a="",c=!1;for(let i=d.length-1;i>=-1&&!c;i--){const s=i>=0?d[i]:w.cwd();v(s,"path"),s.length!==0&&(a=`${s}/${a}`,c=s.charCodeAt(0)===f)}return a=S(a,!c,"/",g),c?`/${a}`:a.length>0?a:"."},normalize(d){if(v(d,"path"),d.length===0)return".";const a=d.charCodeAt(0)===f,c=d.charCodeAt(d.length-1)===f;return d=S(d,!a,"/",g),d.length===0?a?"/":c?"./":".":(c&&(d+="/"),a?`/${d}`:d)},isAbsolute(d){return v(d,"path"),d.length>0&&d.charCodeAt(0)===f},join(...d){if(d.length===0)return".";let a;for(let c=0;c<d.length;++c){const i=d[c];v(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.posix.normalize(a)},relative(d,a){if(v(d,"from"),v(a,"to"),d===a||(d=e.posix.resolve(d),a=e.posix.resolve(a),d===a))return"";const c=1,i=d.length,s=i-c,r=1,o=a.length-r,l=s<o?s:o;let p=-1,E=0;for(;E<l;E++){const R=d.charCodeAt(c+E);if(R!==a.charCodeAt(r+E))break;R===f&&(p=E)}if(E===l)if(o>l){if(a.charCodeAt(r+E)===f)return a.slice(r+E+1);if(E===0)return a.slice(r+E)}else s>l&&(d.charCodeAt(c+E)===f?p=E:E===0&&(p=0));let D="";for(E=c+p+1;E<=i;++E)(E===i||d.charCodeAt(E)===f)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(r+p)}`},toNamespacedPath(d){return d},dirname(d){if(v(d,"path"),d.length===0)return".";const a=d.charCodeAt(0)===f;let c=-1,i=!0;for(let s=d.length-1;s>=1;--s)if(d.charCodeAt(s)===f){if(!i){c=s;break}}else i=!1;return c===-1?a?"/":".":a&&c===1?"//":d.slice(0,c)},basename(d,a){a!==void 0&&v(a,"ext"),v(d,"path");let c=0,i=-1,s=!0,r;if(a!==void 0&&a.length>0&&a.length<=d.length){if(a===d)return"";let o=a.length-1,l=-1;for(r=d.length-1;r>=0;--r){const p=d.charCodeAt(r);if(p===f){if(!s){c=r+1;break}}else l===-1&&(s=!1,l=r+1),o>=0&&(p===a.charCodeAt(o)?--o==-1&&(i=r):(o=-1,i=l))}return c===i?i=l:i===-1&&(i=d.length),d.slice(c,i)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===f){if(!s){c=r+1;break}}else i===-1&&(s=!1,i=r+1);return i===-1?"":d.slice(c,i)},extname(d){v(d,"path");let a=-1,c=0,i=-1,s=!0,r=0;for(let o=d.length-1;o>=0;--o){const l=d.charCodeAt(o);if(l===f){if(!s){c=o+1;break}continue}i===-1&&(s=!1,i=o+1),l===n?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===c+1?"":d.slice(a,i)},format:u.bind(null,"/"),parse(d){v(d,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return a;const c=d.charCodeAt(0)===f;let i;c?(a.root="/",i=1):i=0;let s=-1,r=0,o=-1,l=!0,p=d.length-1,E=0;for(;p>=i;--p){const D=d.charCodeAt(p);if(D===f){if(!l){r=p+1;break}continue}o===-1&&(l=!1,o=p+1),D===n?s===-1?s=p:E!==1&&(E=1):s!==-1&&(E=-1)}if(o!==-1){const D=r===0&&c?1:r;s===-1||E===0||E===1&&s===o-1&&s===r+1?a.base=a.name=d.slice(D,o):(a.name=d.slice(D,s),a.base=d.slice(D,o),a.ext=d.slice(s,o))}return r>0?a.dir=d.slice(0,r-1):c&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...b){const n=b.reduce((t,y)=>(t[y]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(t=>!n[t]).forEach(t=>{for(let y=0;y<f.length;y++)if(t.search(f[y])!==-1){delete M[t];break}})}e.sanitizeProcessEnvironment=k}),define(J[77],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var w;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(w=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>k[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class b{constructor(f,m,t,y,I){this.ctrlKey=f,this.shiftKey=m,this.altKey=t,this.metaKey=y,this.scanCode=I}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=b,function(){function n(f,m){L[f]=m,k[m]=f,M[m.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,m){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=m,m!==0&&m!==3&&m!==5&&m!==4&&m!==6&&m!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[m]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],Z([0,1,57,77]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(b){b=b.toLowerCase().trim();let n=!1,f=!1,m=!1,t=!1,y;do y=!1,/^ctrl(\+|\-)/.test(b)&&(n=!0,b=b.substr("ctrl-".length),y=!0),/^shift(\+|\-)/.test(b)&&(f=!0,b=b.substr("shift-".length),y=!0),/^alt(\+|\-)/.test(b)&&(m=!0,b=b.substr("alt-".length),y=!0),/^meta(\+|\-)/.test(b)&&(t=!0,b=b.substr("meta-".length),y=!0),/^win(\+|\-)/.test(b)&&(t=!0,b=b.substr("win-".length),y=!0),/^cmd(\+|\-)/.test(b)&&(t=!0,b=b.substr("cmd-".length),y=!0);while(y);let I;const v=b.indexOf(" ");return v>0?(I=b.substring(0,v),b=b.substring(v)):(I=b,b=""),{remains:b,ctrl:n,shift:f,alt:m,meta:t,key:I}}static parseSimpleKeybinding(b){const n=this._readModifiers(b),f=w.KeyCodeUtils.fromUserSettings(n.key);return[new w.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(b,n){if(!b)return null;const f=[];let m;do[m,b]=this.parseSimpleKeybinding(b),f.push(m);while(b.length>0);return new w.ChordKeybinding(f)}static parseSimpleUserBinding(b){const n=this._readModifiers(b),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],y=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}const m=w.KeyCodeUtils.fromUserSettings(n.key);return[new w.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,m),n.remains]}static parseUserBinding(b){if(!b)return[];const n=[];let f;for(;b.length>0;)[f,b]=this.parseSimpleUserBinding(b),n.push(f);return n}}e.KeybindingParser=k}),define(J[107],Z([0,1,3]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=w.globals.performance&&typeof w.globals.performance.now=="function";class k{constructor(b){this._highResolution=L&&b,this._startTime=this._now(),this._stopTime=-1}static create(b=!0){return new k(b)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[5],Z([0,1,16,43,2,104,107]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(d){d.None=()=>k.Disposable.None;function a(Q){return(U,C=null,T)=>{let z=!1,B;return B=Q(O=>{if(!z)return B?B.dispose():z=!0,U.call(C,O)},null,T),z&&B.dispose(),B}}d.once=a;function c(Q,U){return p((C,T=null,z)=>Q(B=>C.call(T,U(B)),null,z))}d.map=c;function i(Q,U){return p((C,T=null,z)=>Q(B=>{U(B),C.call(T,B)},null,z))}d.forEach=i;function s(Q,U){return p((C,T=null,z)=>Q(B=>U(B)&&C.call(T,B),null,z))}d.filter=s;function r(Q){return Q}d.signal=r;function o(...Q){return(U,C=null,T)=>(0,k.combinedDisposable)(...Q.map(z=>z(B=>U.call(C,B),null,T)))}d.any=o;function l(Q,U,C){let T=C;return c(Q,z=>(T=U(T,z),T))}d.reduce=l;function p(Q){let U;const C=new I({onFirstListenerAdd(){U=Q(C.fire,C)},onLastListenerRemove(){U.dispose()}});return C.event}function E(Q,U,C=100,T=!1,z){let B,O,$,F=0;const A=new I({leakWarningThreshold:z,onFirstListenerAdd(){B=Q(_=>{F++,O=U(O,_),T&&!$&&(A.fire(O),O=void 0),clearTimeout($),$=setTimeout(()=>{const j=O;O=void 0,$=void 0,(!T||F>1)&&A.fire(j),F=0},C)})},onLastListenerRemove(){B.dispose()}});return A.event}d.debounce=E;function D(Q,U=(C,T)=>C===T){let C=!0,T;return s(Q,z=>{const B=C||!U(z,T);return C=!1,T=z,B})}d.latch=D;function R(Q,U){return[d.filter(Q,U),d.filter(Q,C=>!U(C))]}d.split=R;function W(Q,U=!1,C=[]){let T=C.slice(),z=Q($=>{T?T.push($):O.fire($)});const B=()=>{T&&T.forEach($=>O.fire($)),T=null},O=new I({onFirstListenerAdd(){z||(z=Q($=>O.fire($)))},onFirstListenerDidAdd(){T&&(U?setTimeout(B):B())},onLastListenerRemove(){z&&z.dispose(),z=null}});return O.event}d.buffer=W;class N{constructor(U){this.event=U}map(U){return new N(c(this.event,U))}forEach(U){return new N(i(this.event,U))}filter(U){return new N(s(this.event,U))}reduce(U,C){return new N(l(this.event,U,C))}latch(){return new N(D(this.event))}debounce(U,C=100,T=!1,z){return new N(E(this.event,U,C,T,z))}on(U,C,T){return this.event(U,C,T)}once(U,C,T){return a(this.event)(U,C,T)}}function G(Q){return new N(Q)}d.chain=G;function x(Q,U,C=T=>T){const T=(...$)=>O.fire(C(...$)),z=()=>Q.on(U,T),B=()=>Q.removeListener(U,T),O=new I({onFirstListenerAdd:z,onLastListenerRemove:B});return O.event}d.fromNodeEventEmitter=x;function ne(Q,U,C=T=>T){const T=(...$)=>O.fire(C(...$)),z=()=>Q.addEventListener(U,T),B=()=>Q.removeEventListener(U,T),O=new I({onFirstListenerAdd:z,onLastListenerRemove:B});return O.event}d.fromDOMEventEmitter=ne;function V(Q){return new Promise(U=>a(Q)(U))}d.toPromise=V})(n=e.Event||(e.Event={}));class f{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${f._idPool++}`}start(a){this._stopWatch=new b.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let m=-1;function t(d){const a=m;return m=d,{dispose(){m=a}}}e.setGlobalLeakWarningThreshold=t;class y{constructor(a,c=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let c=m;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||a<c)return;this._stacks||(this._stacks=new Map);const i=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(i)||0;if(this._stacks.set(i,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let r,o=0;for(const[l,p]of this._stacks)(!r||o<p)&&(r=l,o=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${o}):`),console.warn(r)}return()=>{const r=this._stacks.get(i)||0;this._stacks.set(i,r-1)}}}class I{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=m>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(a,c,i)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[a,c]:a);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,c);const o=this._leakageMon?.check(this._listeners.size),l=(0,k.toDisposable)(()=>{o&&o(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof k.DisposableStore?i.add(l):Array.isArray(i)&&i.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,i]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,i):c[0].call(c[1],i)}catch(s){(0,w.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=I;class v extends I{async fireAsync(a,c,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,a]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),o=[],l={...r,waitUntil:p=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");i&&(p=i(p,typeof s=="function"?s:s[0])),o.push(p)}};try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(p){(0,w.onUnexpectedError)(p);continue}Object.freeze(o),await Promise.allSettled(o).then(p=>{for(const E of p)E.status==="rejected"&&(0,w.onUnexpectedError)(E.reason)})}}}}e.AsyncEmitter=v;class h extends I{constructor(a){super(a);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=h;class g extends h{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=g;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new I({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const c={event:a,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const i=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,k.toDisposable)((0,L.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(c=>this.emitter.fire(c))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class S{constructor(){this.buffers=[]}wrapEvent(a){return(c,i,s)=>a(r=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>c.call(i,r)):c.call(i,r)},void 0,s)}bufferEvents(a){const c=[];this.buffers.push(c);const i=a();return this.buffers.pop(),c.forEach(s=>s()),i}}e.EventBufferer=S;class u{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=k.Disposable.None,this.emitter=new I({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(J[24],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const m=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(m)}}});var k;(function(n){function f(m){return m===n.None||m===n.Cancelled||m instanceof M?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class b{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=b}),define(J[108],Z([0,1,5]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(y){const I=this._icons.get(y.id);I?y.description?I.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function M(t,y){return new n(t,y)}e.registerCodicon=M;function b(t){return t?t.replace(/\$\((.*?)\)/g,(y,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=b;class n{constructor(y,I,v){this.id=y,this.definition=I,this.description=v,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(t,y){const I=["codicon","codicon-"+t];return y&&I.push("codicon-modifier-"+y),I}e.getClassNamesArray=f;var m;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function I(g){if(g instanceof n)return["codicon","codicon-"+g.id];const P=y.exec(g.id);if(!P)return I(n.error);let[,S,u]=P;const d=["codicon","codicon-"+S];return u&&d.push("codicon-modifier-"+u.substr(1)),d}t.asClassNameArray=I;function v(g){return I(g).join(" ")}t.asClassName=v;function h(g){return"."+I(g).join(".")}t.asCSSSelector=h})(m=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,16,2]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(d){const a=d;return a?[a.on,a.pause,a.resume,a.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=k;function M(d){const a=d;return a?k(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function b(d,a){return new n(d,a)}e.newWriteableStream=b;class n{constructor(a,c){this.reducer=a,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(c=>c(a))}emitError(a){this.listeners.error.length===0?(0,w.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(c=>c(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,c){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(a,c){if(this.state.destroyed)return;let i;switch(a){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(c);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(d,a){const c=[];let i;for(;(i=d.read())!==null;)c.push(i);return a(c)}e.consumeReadable=f;function m(d,a,c){const i=[];let s;for(;(s=d.read())!==null&&i.length<c;)i.push(s);return s===null&&i.length>0?a(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return d.read()}}}e.peekReadable=m;function t(d,a){return new Promise((c,i)=>{const s=[];y(d,{onData:r=>{a&&s.push(r)},onError:r=>{a?i(r):c(void 0)},onEnd:()=>{c(a?a(s):void 0)}})})}e.consumeStream=t;function y(d,a){d.on("error",c=>a.onError(c)),d.on("end",()=>a.onEnd()),d.on("data",c=>a.onData(c))}e.listenStream=y;function I(d,a){return new Promise((c,i)=>{const s=new L.DisposableStore,r=[],o=E=>{if(r.push(E),r.length>a)return s.dispose(),d.pause(),c({stream:d,buffer:r,ended:!1})},l=E=>i(E),p=()=>c({stream:d,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>d.removeListener("error",l))),d.on("error",l),s.add((0,L.toDisposable)(()=>d.removeListener("end",p))),d.on("end",p),s.add((0,L.toDisposable)(()=>d.removeListener("data",o))),d.on("data",o)})}e.peekStream=I;function v(d,a){const c=b(a);return c.end(d),c}e.toStream=v;function h(){const d=b(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=h;function g(d){let a=!1;return{read:()=>a?null:(a=!0,d)}}e.toReadable=g;function P(d,a,c){const i=b(c);return y(d,{onData:s=>i.write(a.data(s)),onError:s=>i.error(a.error?a.error(s):s),onEnd:()=>i.end()}),i}e.transform=P;function S(d,a,c){let i=!1;return{read:()=>{const s=a.read();return i?s:(i=!0,s!==null?c([d,s]):d)}}}e.prefixedReadable=S;function u(d,a,c){let i=!1;const s=b(c);return y(a,{onData:r=>i?s.write(r):(i=!0,s.write(c([d,r]))),onError:r=>s.error(r),onEnd:()=>{i||(i=!0,s.write(d)),s.end()}}),s}e.prefixedStream=u}),define(J[17],Z([0,1,64]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,M;class b{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return L?new b(Buffer.allocUnsafe(o)):new b(new Uint8Array(o))}static wrap(o){return L&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new b(o)}static fromString(o,l){return!(l?.dontUseNodeBuffer||!1)&&L?new b(Buffer.from(o)):(k||(k=new TextEncoder),new b(k.encode(o)))}static concat(o,l){if(typeof l=="undefined"){l=0;for(let D=0,R=o.length;D<R;D++)l+=o[D].byteLength}const p=b.alloc(l);let E=0;for(let D=0,R=o.length;D<R;D++){const W=o[D];p.set(W,E),E+=W.byteLength}return p}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(o,l){return new b(this.buffer.subarray(o,l))}set(o,l){o instanceof b?this.buffer.set(o.buffer,l):this.buffer.set(o,l)}readUInt32BE(o){return m(this.buffer,o)}writeUInt32BE(o,l){t(this.buffer,o,l)}readUInt32LE(o){return y(this.buffer,o)}writeUInt32LE(o,l){I(this.buffer,o,l)}readUInt8(o){return v(this.buffer,o)}writeUInt8(o,l){h(this.buffer,o,l)}}e.VSBuffer=b;function n(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0}e.readUInt16LE=n;function f(r,o,l){r[l+0]=o&255,o=o>>>8,r[l+1]=o&255}e.writeUInt16LE=f;function m(r,o){return r[o]*2**24+r[o+1]*2**16+r[o+2]*2**8+r[o+3]}e.readUInt32BE=m;function t(r,o,l){r[l+3]=o,o=o>>>8,r[l+2]=o,o=o>>>8,r[l+1]=o,o=o>>>8,r[l]=o}e.writeUInt32BE=t;function y(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0|r[o+2]<<16>>>0|r[o+3]<<24>>>0}e.readUInt32LE=y;function I(r,o,l){r[l+0]=o&255,o=o>>>8,r[l+1]=o&255,o=o>>>8,r[l+2]=o&255,o=o>>>8,r[l+3]=o&255}e.writeUInt32LE=I;function v(r,o){return r[o]}e.readUInt8=v;function h(r,o,l){r[l]=o}e.writeUInt8=h;function g(r){return w.consumeReadable(r,o=>b.concat(o))}e.readableToBuffer=g;function P(r){return w.toReadable(r)}e.bufferToReadable=P;function S(r){return w.consumeStream(r,o=>b.concat(o))}e.streamToBuffer=S;async function u(r){return r.ended?b.concat(r.buffer):b.concat([...r.buffer,await S(r.stream)])}e.bufferedStreamToBuffer=u;function d(r){return w.toStream(r,o=>b.concat(o))}e.bufferToStream=d;function a(r){return w.transform(r,{data:o=>typeof o=="string"?b.fromString(o):b.wrap(o)},o=>b.concat(o))}e.streamToBufferReadableStream=a;function c(r){return w.newWriteableStream(o=>b.concat(o),r)}e.newWriteableBufferStream=c;function i(r,o){return w.prefixedReadable(r,o,l=>b.concat(l))}e.prefixedBufferReadable=i;function s(r,o){return w.prefixedStream(r,o,l=>b.concat(l))}e.prefixedBufferStream=s}),define(J[25],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function w(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=w;const L=/{(\d+)}/g;function k(K,...te){return te.length===0?K:K.replace(L,function(oe,de){const me=parseInt(de,10);return isNaN(me)||me<0||me>=te.length?oe:te[me]})}e.format=k;const M=/{([^}]+)}/g;function b(K,te){return K.replace(M,(oe,de)=>te[de]??oe)}e.format2=b;function n(K){return K.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=n;function f(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function m(K,te){let oe=0;const de=te.charCodeAt(0);for(let me=K.length-1;me>=0;me--)K.charCodeAt(me)===de&&oe++;return oe}e.count=m;function t(K,te,oe="\u2026"){return K.length<=te?K:`${K.substr(0,te)}${oe}`}e.truncate=t;function y(K,te=" "){const oe=I(K,te);return v(oe,te)}e.trim=y;function I(K,te){if(!K||!te)return K;const oe=te.length;if(oe===0||K.length===0)return K;let de=0;for(;K.indexOf(te,de)===de;)de=de+oe;return K.substring(de)}e.ltrim=I;function v(K,te){if(!K||!te)return K;const oe=te.length,de=K.length;if(oe===0||de===0)return K;let me=de,ke=-1;for(;ke=K.lastIndexOf(te,me-1),!(ke===-1||ke+oe!==me);){if(ke===0)return"";me=ke}return K.substring(0,me)}e.rtrim=v;function h(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(K){return K.replace(/\*/g,"")}e.stripWildcards=g;function P(K,te,oe={}){if(!K)throw new Error("Cannot create regex from empty string");te||(K=f(K)),oe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let de="";return oe.global&&(de+="g"),oe.matchCase||(de+="i"),oe.multiline&&(de+="m"),oe.unicode&&(de+="u"),new RegExp(K,de)}e.createRegExp=P;function S(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function u(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function d(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=d;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function c(K){for(let te=0,oe=K.length;te<oe;te++){const de=K.charCodeAt(te);if(de!==32&&de!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function i(K,te=0,oe=K.length){for(let de=te;de<oe;de++){const me=K.charCodeAt(de);if(me!==32&&me!==9)return K.substring(te,de)}return K.substring(te,oe)}e.getLeadingWhitespace=i;function s(K,te=K.length-1){for(let oe=te;oe>=0;oe--){const de=K.charCodeAt(oe);if(de!==32&&de!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function r(K,te){return K<te?-1:K>te?1:0}e.compare=r;function o(K,te,oe=0,de=K.length,me=0,ke=te.length){for(;oe<de&&me<ke;oe++,me++){let Ce=K.charCodeAt(oe),ze=te.charCodeAt(me);if(Ce<ze)return-1;if(Ce>ze)return 1}const Fe=de-oe,We=ke-me;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=o;function l(K,te){return p(K,te,0,K.length,0,te.length)}e.compareIgnoreCase=l;function p(K,te,oe=0,de=K.length,me=0,ke=te.length){for(;oe<de&&me<ke;oe++,me++){let Ce=K.charCodeAt(oe),ze=te.charCodeAt(me);if(Ce===ze)continue;const he=Ce-ze;if(!(he===32&&D(ze))&&!(he===-32&&D(Ce)))return E(Ce)&&E(ze)?he:o(K.toLowerCase(),te.toLowerCase(),oe,de,me,ke)}const Fe=de-oe,We=ke-me;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=p;function E(K){return K>=97&&K<=122}e.isLowerAsciiLetter=E;function D(K){return K>=65&&K<=90}e.isUpperAsciiLetter=D;function R(K){return E(K)||D(K)}function W(K,te){return K.length===te.length&&N(K,te)}e.equalsIgnoreCase=W;function N(K,te,oe=K.length){for(let de=0;de<oe;de++){const me=K.charCodeAt(de),ke=te.charCodeAt(de);if(me!==ke){if(R(me)&&R(ke)){const Fe=Math.abs(me-ke);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(me).toLowerCase()!==String.fromCharCode(ke).toLowerCase())return!1}}return!0}function G(K,te){const oe=te.length;return te.length>K.length?!1:N(K,te,oe)}e.startsWithIgnoreCase=G;function x(K,te){let oe,de=Math.min(K.length,te.length);for(oe=0;oe<de;oe++)if(K.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return de}e.commonPrefixLength=x;function ne(K,te){let oe,de=Math.min(K.length,te.length);const me=K.length-1,ke=te.length-1;for(oe=0;oe<de;oe++)if(K.charCodeAt(me-oe)!==te.charCodeAt(ke-oe))return oe;return de}e.commonSuffixLength=ne;function V(K){return 55296<=K&&K<=56319}e.isHighSurrogate=V;function Q(K){return 56320<=K&&K<=57343}e.isLowSurrogate=Q;function U(K,te){return(K-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function C(K,te,oe){const de=K.charCodeAt(oe);if(V(de)&&oe+1<te){const me=K.charCodeAt(oe+1);if(Q(me))return U(de,me)}return de}e.getNextCodePoint=C;function T(K,te){const oe=K.charCodeAt(te-1);if(Q(oe)&&te>1){const de=K.charCodeAt(te-2);if(V(de))return U(de,oe)}return oe}function z(K,te){const oe=Be.getInstance(),de=te,me=K.length,ke=C(K,me,te);te+=ke>=65536?2:1;let Fe=oe.getGraphemeBreakType(ke);for(;te<me;){const We=C(K,me,te),Ce=oe.getGraphemeBreakType(We);if(Ue(Fe,Ce))break;te+=We>=65536?2:1,Fe=Ce}return te-de}e.nextCharLength=z;function B(K,te){const oe=Be.getInstance(),de=te,me=T(K,te);te-=me>=65536?2:1;let ke=oe.getGraphemeBreakType(me);for(;te>0;){const Fe=T(K,te),We=oe.getGraphemeBreakType(Fe);if(Ue(We,ke))break;te-=Fe>=65536?2:1,ke=We}return de-te}e.prevCharLength=B;function O(K,te){const oe=Be.getInstance(),de=K.length,me=te,ke=C(K,de,te),Fe=oe.getGraphemeBreakType(ke);te+=ke>=65536?2:1;let We=Fe;for(;te<de;){const ze=C(K,de,te),he=oe.getGraphemeBreakType(ze);if(Ue(We,he))break;te+=ze>=65536?2:1,We=he}const Ce=te;for(te=me,We=Fe;te>0;){const ze=T(K,te),he=oe.getGraphemeBreakType(ze);if(Ue(he,We))break;te-=ze>=65536?2:1,We=he}return[te,Ce]}function $(K,te){return te>0&&Q(K.charCodeAt(te))?O(K,te-1):O(K,te)}e.getCharContainingOffset=$;const F=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(K){return F.test(K)}e.containsRTL=A;const _=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function j(K){return _.test(K)}e.containsEmoji=j;const Y=/^[\t\n\r\x20-\x7E]*$/;function q(K){return Y.test(K)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=X;function ie(K){for(let te=0,oe=K.length;te<oe;te++)if(se(K.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ie;function se(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=se;function ae(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ae;function ue(K,te){if(K.length<te)return K;const oe=/\b/g;let de=0;for(;oe.test(K)&&!(K.length-oe.lastIndex<te);)de=oe.lastIndex,oe.lastIndex+=1;return K.substring(de).replace(/^\s/,"")}e.lcut=ue;const re=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,be=/\x1b\[0?m/g;function pe(K){return K&&(K=K.replace(re,""),K=K.replace(le,""),K=K.replace(be,"")),K}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function Re(K){return Se(K)?K.substr(1):K}e.stripUTF8BOM=Re;function ve(K,te){if(!K||!te||K.length<te.length)return!1;const oe=te.length,de=K.toLowerCase();let me=0,ke=-1;for(;me<oe;){const Fe=de.indexOf(te[me],ke+1);if(Fe<0)return!1;ke=Fe,me++}return!0}e.fuzzyContains=ve;function ge(K,te=!1){return K?(te&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=ge;function Ee(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ee;function De(K,te=1){if(te===0)return"";let oe=-1;do oe=K.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?K:(K[oe-1]==="\r"&&oe--,K.substr(0,oe))}e.getNLines=De;function Te(K){const te=90-65+1;return K=K%(2*te),K<te?String.fromCharCode(97+K):String.fromCharCode(65+K-te)}e.singleLetterHash=Te;function Ne(K){return Be.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ne;function Ue(K,te){return K===0?te!==5&&te!==7:K===2&&te===3?!1:K===4||K===2||K===3||te===4||te===2||te===3?!0:!(K===8&&(te===8||te===9||te===11||te===12)||(K===11||K===9)&&(te===9||te===10)||(K===12||K===10)&&te===10||te===5||te===13||te===7||K===1||K===13&&te===14||K===6&&te===6)}e.breakBetweenGraphemeBreakType=Ue;var Ge;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,de=oe.length/3;let me=1;for(;me<=de;)if(te<oe[3*me])me=2*me;else if(te>oe[3*me+1])me=2*me+1;else return oe[3*me+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(K,te){if(K===0)return 0;const oe=ot(K,te);if(oe!==void 0)return oe;const de=T(te,K);return K-=Ye(de),K}e.getLeftDeleteOffset=Ze;function ot(K,te){let oe=T(te,K);for(K-=Ye(oe);ut(oe)||oe===65039||oe===8419;){if(K===0)return;oe=T(te,K),K-=Ye(oe)}if(!!ae(oe)){if(K>=0){const de=T(te,K);de===8205&&(K-=Ye(de))}return K}}function Ye(K){return K>=65536?2:1}function ut(K){return 127995<=K&&K<=127999}var xe;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(J[78],Z([0,1,25]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(S){return k(S,0)}e.hash=L;function k(S,u){switch(typeof S){case"object":return S===null?M(349,u):Array.isArray(S)?f(S,u):m(S,u);case"string":return n(S,u);case"boolean":return b(S,u);case"number":return M(S,u);case"undefined":return M(937,u);default:return M(617,u)}}e.doHash=k;function M(S,u){return(u<<5)-u+S|0}function b(S,u){return M(S?433:863,u)}function n(S,u){u=M(149417,u);for(let d=0,a=S.length;d<a;d++)u=M(S.charCodeAt(d),u);return u}e.stringHash=n;function f(S,u){return u=M(104579,u),S.reduce((d,a)=>k(a,d),u)}function m(S,u){return u=M(181387,u),Object.keys(S).sort().reduce((d,a)=>(d=n(a,d),k(S[a],d)),u)}class t{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=k(u,this._value),this._value}}e.Hasher=t;var y;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function I(S,u,d=32){const a=d-u,c=~((1<<a)-1);return(S<<u|(c&S)>>>a)>>>0}function v(S,u=0,d=S.byteLength,a=0){for(let c=0;c<d;c++)S[u+c]=a}function h(S,u,d="0"){for(;S.length<u;)S=d+S;return S}function g(S,u=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(d=>d.toString(16).padStart(2,"0")).join(""):h((S>>>0).toString(16),u/4)}e.toHexString=g;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const d=u.length;if(d===0)return;const a=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,s,r;for(i!==0?(s=i,r=-1,i=0):(s=u.charCodeAt(0),r=0);;){let o=s;if(w.isHighSurrogate(s))if(r+1<d){const l=u.charCodeAt(r+1);w.isLowSurrogate(l)?(r++,o=w.computeCodePoint(s,l)):o=65533}else{i=s;break}else w.isLowSurrogate(s)&&(o=65533);if(c=this._push(a,c,o),r++,r<d)s=u.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(u,d,a){return a<128?u[d++]=a:a<2048?(u[d++]=192|(a&1984)>>>6,u[d++]=128|(a&63)>>>0):a<65536?(u[d++]=224|(a&61440)>>>12,u[d++]=128|(a&4032)>>>6,u[d++]=128|(a&63)>>>0):(u[d++]=240|(a&1835008)>>>18,u[d++]=128|(a&258048)>>>12,u[d++]=128|(a&4032)>>>6,u[d++]=128|(a&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=P._bigBlock32,d=this._buffDV;for(let E=0;E<64;E+=4)u.setUint32(E,d.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)u.setUint32(E,I(u.getUint32(E-12,!1)^u.getUint32(E-32,!1)^u.getUint32(E-56,!1)^u.getUint32(E-64,!1),1),!1);let a=this._h0,c=this._h1,i=this._h2,s=this._h3,r=this._h4,o,l,p;for(let E=0;E<80;E++)E<20?(o=c&i|~c&s,l=1518500249):E<40?(o=c^i^s,l=1859775393):E<60?(o=c&i|c&s|i&s,l=2400959708):(o=c^i^s,l=3395469782),p=I(a,5)+o+r+l+u.getUint32(E*4,!1)&4294967295,r=s,s=i,i=I(c,30),c=a,a=p;this._h0=this._h0+a&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(D){return Array.isArray(D)}e.isArray=w;function L(D){return typeof D=="string"}e.isString=L;function k(D){return Array.isArray(D)&&D.every(R=>L(R))}e.isStringArray=k;function M(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=M;function b(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=b;function n(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=n;function f(D){return D===!0||D===!1}e.isBoolean=f;function m(D){return typeof D=="undefined"}e.isUndefined=m;function t(D){return!y(D)}e.isDefined=t;function y(D){return m(D)||D===null}e.isUndefinedOrNull=y;function I(D,R){if(!D)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=I;function v(D){if(y(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=v;function h(...D){const R=[];for(let W=0;W<D.length;W++){const N=D[W];if(y(N))throw new Error(`Assertion Failed: argument at index ${W} is undefined or null`);R.push(N)}return R}e.assertAllDefined=h;const g=Object.prototype.hasOwnProperty;function P(D){if(!M(D))return!1;for(let R in D)if(g.call(D,R))return!1;return!0}e.isEmptyObject=P;function S(D){return typeof D=="function"}e.isFunction=S;function u(...D){return D.length>0&&D.every(S)}e.areFunctions=u;function d(D,R){const W=Math.min(D.length,R.length);for(let N=0;N<W;N++)a(D[N],R[N])}e.validateConstraints=d;function a(D,R){if(L(R)){if(typeof D!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(S(R)){try{if(D instanceof R)return}catch{}if(!y(D)&&D.constructor===R||R.length===1&&R.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function c(D){let R=[],W=Object.getPrototypeOf(D);for(;Object.prototype!==W;)R=R.concat(Object.getOwnPropertyNames(W)),W=Object.getPrototypeOf(W);return R}e.getAllPropertyNames=c;function i(D){const R=[];for(const W of c(D))typeof D[W]=="function"&&R.push(W);return R}e.getAllMethodNames=i;function s(D,R){const W=G=>function(){const x=Array.prototype.slice.call(arguments,0);return R(G,x)};let N={};for(const G of D)N[G]=W(G);return N}e.createProxyObject=s;function r(D){return D===null?void 0:D}e.withNullAsUndefined=r;function o(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=o;function l(D){return class{constructor(){return new Proxy({},{get(R,W){if(R[W])return R[W];throw new Error(`Not Implemented: ${D}->${String(W)}`)}})}}}e.NotImplementedProxy=l;function p(D,R="Unreachable"){throw new Error(R)}e.assertNever=p;function E(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=E}),define(J[29],Z([0,1,7,3,25,13]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function b(r){return r===47||r===92}e.isPathSeparator=b;function n(r){return r.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function m(r,o=w.posix.sep){if(!r)return"";const l=r.length,p=r.charCodeAt(0);if(b(p)){if(b(r.charCodeAt(1))&&!b(r.charCodeAt(2))){let D=3;const R=D;for(;D<l&&!b(r.charCodeAt(D));D++);if(R!==D&&!b(r.charCodeAt(D+1))){for(D+=1;D<l;D++)if(b(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,o)}}return o}else if(S(p)&&r.charCodeAt(1)===58)return b(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let E=r.indexOf("://");if(E!==-1){for(E+=3;E<l;E++)if(b(r.charCodeAt(E)))return r.slice(0,E+1)}return""}e.getRoot=m;function t(r){if(!L.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let l=2;const p=l;for(;l<r.length&&(o=r.charCodeAt(l),o!==92);l++);return!(p===l||(o=r.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=t;const y=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,o=L.isWindows){const l=o?y:I;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||o&&v.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function g(r,o,l){const p=r===o;return!l||p?p:!r||!o?!1:(0,k.equalsIgnoreCase)(r,o)}e.isEqual=g;function P(r,o,l,p=w.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let D=o.length;return o.charAt(o.length-1)===p&&D--,r.charAt(D)===p}return o.charAt(o.length-1)!==p&&(o+=p),r.indexOf(o)===0}e.isEqualOrParent=P;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function u(r,o){return L.isWindows&&r.endsWith(":")&&(r+=w.sep),(0,w.isAbsolute)(r)||(r=(0,w.join)(o,r)),r=(0,w.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,w.sep),r.endsWith(":")&&(r+=w.sep)):(r=(0,k.rtrim)(r,w.sep),r||(r=w.sep)),r}e.sanitizeFilePath=u;function d(r){const o=(0,w.normalize)(r);return L.isWindows?r.length>3?!1:a(o)&&(r.length===2||o.charCodeAt(2)===92):o===w.posix.sep}e.isRootOrDriveLetter=d;function a(r){return L.isWindows?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function c(r){return a(r)?r[0]:void 0}e.getDriveLetter=c;function i(r,o,l){return o.length>r.length?-1:r===o?0:(l&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=i;function s(r){const o=r.split(":");let l,p,E;if(o.forEach(D=>{const R=Number(D);(0,M.isNumber)(R)?p===void 0?p=R:E===void 0&&(E=R):l=l?[l,D].join(":"):D}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:p!==void 0?p:void 0,column:E!==void 0?E:p!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(J[44],Z([0,1,13]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const P=Array.isArray(g)?[]:{};return Object.keys(g).forEach(S=>{g[S]&&typeof g[S]=="object"?P[S]=L(g[S]):P[S]=g[S]}),P}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const P=[g];for(;P.length>0;){const S=P.shift();Object.freeze(S);for(const u in S)if(M.call(S,u)){const d=S[u];typeof d=="object"&&!Object.isFrozen(d)&&P.push(d)}}return g}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function b(g,P){return n(g,P,new Set)}e.cloneAndChange=b;function n(g,P,S){if((0,w.isUndefinedOrNull)(g))return g;const u=P(g);if(typeof u!="undefined")return u;if((0,w.isArray)(g)){const d=[];for(const a of g)d.push(n(a,P,S));return d}if((0,w.isObject)(g)){if(S.has(g))throw new Error("Cannot clone recursive data-structure");S.add(g);const d={};for(let a in g)M.call(g,a)&&(d[a]=n(g[a],P,S));return S.delete(g),d}return g}function f(g,P,S=!0){return(0,w.isObject)(g)?((0,w.isObject)(P)&&Object.keys(P).forEach(u=>{u in g?S&&((0,w.isObject)(g[u])&&(0,w.isObject)(P[u])?f(g[u],P[u],S):g[u]=P[u]):g[u]=P[u]}),g):P}e.mixin=f;function m(g,P){if(g===P)return!0;if(g==null||P===null||P===void 0||typeof g!=typeof P||typeof g!="object"||Array.isArray(g)!==Array.isArray(P))return!1;let S,u;if(Array.isArray(g)){if(g.length!==P.length)return!1;for(S=0;S<g.length;S++)if(!m(g[S],P[S]))return!1}else{const d=[];for(u in g)d.push(u);d.sort();const a=[];for(u in P)a.push(u);if(a.sort(),!m(d,a))return!1;for(S=0;S<d.length;S++)if(!m(g[d[S]],P[d[S]]))return!1}return!0}e.equals=m;function t(g){const P=new Set;return JSON.stringify(g,(S,u)=>{if((0,w.isObject)(u)||Array.isArray(u)){if(P.has(u))return"[Circular]";P.add(u)}return u})}e.safeStringify=t;function y(g,P,S){const u=P(g);return typeof u=="undefined"?S:u}e.getOrDefault=y;function I(g,P){const S=Object.create(null);return!g||!P||Object.keys(P).forEach(d=>{const a=g[d],c=P[d];m(a,c)||(S[d]=c)}),S}e.distinct=I;function v(g,P){const S=P.toLowerCase(),u=Object.keys(g).find(d=>d.toLowerCase()===S);return u?g[u]:g[P]}e.getCaseInsensitive=v;function h(g,P){const S=Object.create(null);for(const u of Object.keys(g))P(u,g[u])&&(S[u]=g[u]);return S}e.filter=h}),define(J[8],Z([0,1,7,3]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,b=/^\/\//;function n(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,o){return!r&&!o?"file":r}function m(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==y&&(o=y+o):o=y;break}return o}const t="",y="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(o,l,p,E,D,R=!1){typeof o=="object"?(this.scheme=o.scheme||t,this.authority=o.authority||t,this.path=o.path||t,this.query=o.query||t,this.fragment=o.fragment||t):(this.scheme=f(o,R),this.authority=l||t,this.path=m(this.scheme,p||t),this.query=E||t,this.fragment=D||t,n(this,R))}static isUri(o){return o instanceof v?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return d(this,!1)}with(o){if(!o)return this;let{scheme:l,authority:p,path:E,query:D,fragment:R}=o;return l===void 0?l=this.scheme:l===null&&(l=t),p===void 0?p=this.authority:p===null&&(p=t),E===void 0?E=this.path:E===null&&(E=t),D===void 0?D=this.query:D===null&&(D=t),R===void 0?R=this.fragment:R===null&&(R=t),l===this.scheme&&p===this.authority&&E===this.path&&D===this.query&&R===this.fragment?this:new g(l,p,E,D,R)}static parse(o,l=!1){const p=I.exec(o);return p?new g(p[2]||t,s(p[4]||t),s(p[5]||t),s(p[7]||t),s(p[9]||t),l):new g(t,t,t,t,t)}static file(o){let l=t;if(L.isWindows&&(o=o.replace(/\\/g,y)),o[0]===y&&o[1]===y){const p=o.indexOf(y,2);p===-1?(l=o.substring(2),o=y):(l=o.substring(2,p),o=o.substring(p)||y)}return new g("file",l,o,t,t)}static from(o){const l=new g(o.scheme,o.authority,o.path,o.query,o.fragment);return n(l,!0),l}static joinPath(o,...l){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return L.isWindows&&o.scheme==="file"?p=v.file(w.win32.join(d(o,!0),...l)).path:p=w.posix.join(o.path,...l),o.with({path:p})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof v)return o;{const l=new g(o);return l._formatted=o.external,l._fsPath=o._sep===h?o.fsPath:null,l}}else return o}}e.URI=v;const h=L.isWindows?1:void 0;class g extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=h),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(r,o){let l,p=-1;for(let E=0;E<r.length;E++){const D=r.charCodeAt(E);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||o&&D===47)p!==-1&&(l+=encodeURIComponent(r.substring(p,E)),p=-1),l!==void 0&&(l+=r.charAt(E));else{l===void 0&&(l=r.substr(0,E));const R=P[D];R!==void 0?(p!==-1&&(l+=encodeURIComponent(r.substring(p,E)),p=-1),l+=R):p===-1&&(p=E)}}return p!==-1&&(l+=encodeURIComponent(r.substring(p))),l!==void 0?l:r}function u(r){let o;for(let l=0;l<r.length;l++){const p=r.charCodeAt(l);p===35||p===63?(o===void 0&&(o=r.substr(0,l)),o+=P[p]):o!==void 0&&(o+=r[l])}return o!==void 0?o:r}function d(r,o){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=d;function a(r,o){const l=o?u:S;let p="",{scheme:E,authority:D,path:R,query:W,fragment:N}=r;if(E&&(p+=E,p+=":"),(D||E==="file")&&(p+=y,p+=y),D){let G=D.indexOf("@");if(G!==-1){const x=D.substr(0,G);D=D.substr(G+1),G=x.indexOf(":"),G===-1?p+=l(x,!1):(p+=l(x.substr(0,G),!1),p+=":",p+=l(x.substr(G+1),!1)),p+="@"}D=D.toLowerCase(),G=D.indexOf(":"),G===-1?p+=l(D,!1):(p+=l(D.substr(0,G),!1),p+=D.substr(G))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const G=R.charCodeAt(1);G>=65&&G<=90&&(R=`/${String.fromCharCode(G+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const G=R.charCodeAt(0);G>=65&&G<=90&&(R=`${String.fromCharCode(G+32)}:${R.substr(2)}`)}p+=l(R,!0)}return W&&(p+="?",p+=l(W,!1)),N&&(p+="#",p+=o?N:S(N,!1)),p}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(i)?r.replace(i,o=>c(o)):r}}),define(J[109],Z([0,1,8]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(m){const t=m;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function k(m){const t=[];let y;try{const I=JSON.parse(m.arguments),v=I[I.length-1];v&&v.__$stack&&(I.pop(),y=v.__$stack),t.push(...I)}catch(I){t.push("Unable to log remote console arguments",m.arguments)}return{args:t,stack:y}}e.parse=k;function M(m){if(typeof m!="string")return M(k(m).stack);const t=m;if(t){const y=b(t),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(I&&I.length===4)return{uri:w.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=M;function b(m){if(!m)return m;const t=m.indexOf(`
`);return t===-1?m:m.substring(0,t)}function n(m,t){const{args:y,stack:I}=k(m),v=typeof y[0]=="string"&&y.length===1;let h=b(I);h&&(h=`(${h.trim()})`);let g=[];if(typeof y[0]=="string"?h&&v?g=[`%c[${t}] %c${y[0]} %c${h}`,f("blue"),f(""),f("grey")]:g=[`%c[${t}] %c${y[0]}`,f("blue"),f(""),...y.slice(1)]:g=[`%c[${t}]%`,f("blue"),...y],h&&!v&&g.push(h),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,g)}e.log=n;function f(m){return`color: ${m}`}});var bt=this&&this.__classPrivateFieldSet||function(H,e,w,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?H!==e||!k:!e.has(H))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(H,w):k?k.value=w:e.set(H,w),w},qe=this&&this.__classPrivateFieldGet||function(H,e,w,L){if(w==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?H!==e||!L:!e.has(H))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?L:w==="a"?L.call(H):L?L.value:e.get(H)};define(J[37],Z([0,1,25,8]),function(H,e,w,L){"use strict";var k,M,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(i,s,r){let o=i.get(s);return o===void 0&&(o=r,i.set(s,o)),o}e.getOrSet=n;function f(i){const s=[];return i.forEach((r,o)=>{s.push(`${o} => ${r}`)}),`Map(${i.size}) {${s.join(", ")}}`}e.mapToString=f;function m(i){const s=[];return i.forEach(r=>{s.push(r)}),`Set(${i.size}) {${s.join(", ")}}`}e.setToString=m;class t{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=t;class y{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,w.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,w.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class I{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,w.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,w.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var v;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,w.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,w.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,w.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,w.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(s){this._iter=s}static forUris(s=()=>!1){return new P(new h(s))}static forPaths(){return new P(new I)}static forStrings(){return new P(new t)}static forConfigKeys(){return new P(new y)}clear(){this._root=void 0}set(s,r){const o=this._iter.reset(s);let l;for(this._root||(this._root=new g,this._root.segment=o.value()),l=this._root;;){const E=o.cmp(l.segment);if(E>0)l.left||(l.left=new g,l.left.segment=o.value()),l=l.left;else if(E<0)l.right||(l.right=new g,l.right.segment=o.value()),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new g,l.mid.segment=o.value()),l=l.mid;else break}const p=l.value;return l.value=r,l.key=s,p}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const o=this._iter.reset(s),l=[];let p=this._root;for(;p;){const E=o.cmp(p.segment);if(E>0)l.push([1,p]),p=p.left;else if(E<0)l.push([-1,p]),p=p.right;else if(o.hasNext())o.next(),l.push([0,p]),p=p.mid;else{for(r?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;l.length>0&&p.isEmpty();){let[D,R]=l.pop();switch(D){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}p=R}break}}}findSubstr(s){const r=this._iter.reset(s);let o=this._root,l;for(;o;){const p=r.cmp(o.segment);if(p>0)o=o.left;else if(p<0)o=o.right;else if(r.hasNext())r.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(s){const r=this._iter.reset(s);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(s){for(const[r,o]of this)s(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const o=r.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&r.push(o.left),o.mid&&r.push(o.mid),o.right&&r.push(o.right))}}}e.TernarySearchTree=P;class S{constructor(s,r){this[k]="ResourceMap",s instanceof S?(this.map=new Map(s.map),this.toKey=r??S.defaultToKey):(this.map=new Map,this.toKey=s??S.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[o,l]of this.map)s(l,L.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield L.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[L.URI.parse(s[0]),s[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[L.URI.parse(s[0]),s[1]]}}e.ResourceMap=S,S.defaultToKey=i=>i.toString();var u;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class d{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const o=this._map.get(s);if(!!o)return r!==0&&this.touch(o,r),o.value}set(s,r,o=0){let l=this._map.get(s);if(l)l.value=r,o!==0&&this.touch(l,o);else{switch(l={key:s,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(s,l),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const o=this._state;let l=this._head;for(;l;){if(r?s.bind(r)(l.value,l.key,this):s(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.key,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return l}values(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.value,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return l}entries(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:[o.key,o.value],done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return l}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>s;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,o=s.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const o=s.next,l=s.previous;s===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const o=s.next,l=s.previous;s===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,o)=>{s.push([o,r])}),s}fromJSON(s){this.clear();for(const[r,o]of s)this.set(r,o)}}e.LinkedMap=d;class a extends d{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class c{constructor(s){b.set(this,void 0),bt(this,b,s,"f")}get size(){return qe(this,b,"f").size}forEach(s,r){qe(this,b,"f").forEach(s,r)}get(s){return qe(this,b,"f").get(s)}has(s){return qe(this,b,"f").has(s)}entries(){return qe(this,b,"f").entries()}keys(){return qe(this,b,"f").keys()}values(){return qe(this,b,"f").values()}[(b=new WeakMap,Symbol.iterator)](){return qe(this,b,"f").entries()}}e.ReadonlyMapView=c}),define(J[110],Z([0,1,17,25,8]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(t){return JSON.stringify(t,f)}e.stringify=M;function b(t){let y=JSON.parse(t);return y=m(y),y}e.parse=b;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(t,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,L.regExpFlags)(y)}:y}function m(t,y=0){if(!t||y>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return k.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof w.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let I=0;I<t.length;++I)t[I]=m(t[I],y+1);else for(const I in t)Object.hasOwnProperty.call(t,I)&&(t[I]=m(t[I],y+1))}return t}e.revive=m}),define(J[10],Z([0,1,3,8]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,m,t){this._hosts[f]=m,this._ports[f]=t}setConnectionToken(f,m){this._connectionTokens[f]=m}rewrite(f){if(this._delegate)return this._delegate(f);const m=f.authority;let t=this._hosts[m];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const y=this._ports[m],I=this._connectionTokens[m];let v=`path=${encodeURIComponent(f.path)}`;return typeof I=="string"&&(v+=`&tkn=${encodeURIComponent(I)}`),L.URI.from({scheme:w.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${t}:${y}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new M;class b{asBrowserUri(f,m){const t=this.toUri(f,m);return t.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===k.file&&(w.isNative||typeof w.globals.importScripts=="function"&&w.globals.origin===`${k.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?t.with({scheme:k.vscodeFileResource,authority:t.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,m){const t=this.toUri(f,m);return t.scheme===k.vscodeFileResource?t.with({scheme:k.file,authority:t.authority!==b.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,m){return L.URI.isUri(f)?f:L.URI.parse(m.toUrl(f))}}b.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new b}),define(J[65],Z([0,1,37]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new w.LRUCache(1e4);function k(m){return f(m,"NFC",L)}e.normalizeNFC=k;const M=new w.LRUCache(1e4);function b(m){return f(m,"NFD",M)}e.normalizeNFD=b;const n=/[^\u0000-\u0080]/;function f(m,t,y){if(!m)return m;const I=y.get(m);if(I)return I;let v;return n.test(m)?v=m.normalize(t):v=m,y.set(m,v),v}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(t){return b(t).replace(m,"")}}()}),define(J[15],Z([0,1,29,10,7,3,25,8]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(v){return(0,n.uriToFsPath)(v,!0)}e.originalFSPath=f;class m{constructor(h){this._ignorePathCasing=h}compare(h,g,P=!1){return h===g?0:(0,b.compare)(this.getComparisonKey(h,P),this.getComparisonKey(g,P))}isEqual(h,g,P=!1){return h===g?!0:!h||!g?!1:this.getComparisonKey(h,P)===this.getComparisonKey(g,P)}getComparisonKey(h,g=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,g,P=!1){if(h.scheme===g.scheme){if(h.scheme===L.Schemas.file)return w.isEqualOrParent(f(h),f(g),this._ignorePathCasing(h))&&h.query===g.query&&(P||h.fragment===g.fragment);if((0,e.isEqualAuthority)(h.authority,g.authority))return w.isEqualOrParent(h.path,g.path,this._ignorePathCasing(h),"/")&&h.query===g.query&&(P||h.fragment===g.fragment)}return!1}joinPath(h,...g){return n.URI.joinPath(h,...g)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){const g=k.posix.extname(h.path),P=g.indexOf("?");return P!==-1?g.substr(0,P):g}dirname(h){if(h.path.length===0)return h;let g;return h.scheme===L.Schemas.file?g=n.URI.file(k.dirname(f(h))).path:(g=k.posix.dirname(h.path),h.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),g="/")),h.with({path:g})}normalizePath(h){if(!h.path.length)return h;let g;return h.scheme===L.Schemas.file?g=n.URI.file(k.normalize(f(h))).path:g=k.posix.normalize(h.path),h.with({path:g})}relativePath(h,g){if(h.scheme!==g.scheme||!(0,e.isEqualAuthority)(h.authority,g.authority))return;if(h.scheme===L.Schemas.file){const u=k.relative(f(h),f(g));return M.isWindows?w.toSlashes(u):u}let P=h.path||"/",S=g.path||"/";if(this._ignorePathCasing(h)){let u=0;for(const d=Math.min(P.length,S.length);u<d&&!(P.charCodeAt(u)!==S.charCodeAt(u)&&P.charAt(u).toLowerCase()!==S.charAt(u).toLowerCase());u++);P=S.substr(0,u)+P.substr(u)}return k.posix.relative(P,S)}resolvePath(h,g){if(h.scheme===L.Schemas.file){const P=n.URI.file(k.resolve(f(h),g));return h.with({authority:P.authority,path:P.path})}return g=w.toPosixPath(g),h.with({path:k.posix.resolve(h.path,g)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,g){return h===g||(0,b.equalsIgnoreCase)(h,g)}hasTrailingPathSeparator(h,g=k.sep){if(h.scheme===L.Schemas.file){const P=f(h);return P.length>w.getRoot(P).length&&P[P.length-1]===g}else{const P=h.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,g=k.sep){return(0,e.hasTrailingPathSeparator)(h,g)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,g=k.sep){let P=!1;if(h.scheme===L.Schemas.file){const S=f(h);P=S!==void 0&&S.length===w.getRoot(S).length&&S[S.length-1]===g}else{g="/";const S=h.path;P=S.length===1&&S.charCodeAt(S.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(h,g)?h.with({path:h.path+"/"}):h}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(v=>v.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new m(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(v,h){const g=[];for(let P=0;P<v.length;P++){const S=h(v[P]);v.some((u,d)=>d===P?!1:(0,e.isEqualOrParent)(S,h(u)))||g.push(v[P])}return g}e.distinctParents=t;var y;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(g){const P=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[a,c]=d.split(":");a&&c&&P.set(a,c)});const u=g.path.substring(0,g.path.indexOf(";"));return u&&P.set(v.META_DATA_MIME,u),P}v.parseMetaData=h})(y=e.DataUri||(e.DataUri={}));function I(v,h,g){if(h){let P=v.path;return P&&P[0]!==k.posix.sep&&(P=k.posix.sep+P),v.with({scheme:g,authority:h,path:P})}return v.with({scheme:g})}e.toLocalResource=I}),define(J[9],Z([0,1,24,16,5,2,15]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(C){return!!C&&typeof C.then=="function"}e.isThenable=n;function f(C){const T=new w.CancellationTokenSource,z=C(T.token),B=new Promise((O,$)=>{const F=T.token.onCancellationRequested(()=>{F.dispose(),T.dispose(),$((0,L.canceled)())});Promise.resolve(z).then(A=>{F.dispose(),T.dispose(),O(A)},A=>{F.dispose(),T.dispose(),$(A)})});return new class{cancel(){T.cancel()}then(O,$){return B.then(O,$)}catch(O){return this.then(void 0,O)}finally(O){return B.finally(O)}}}e.createCancelablePromise=f;function m(C,T,z){return Promise.race([C,new Promise(B=>T.onCancellationRequested(()=>B(z)))])}e.raceCancellation=m;async function t(C){let T=-1;const z=C.map((O,$)=>O.then(F=>(T=$,F))),B=await Promise.race(z);return C.forEach((O,$)=>{$!==T&&O.cancel()}),B}e.raceCancellablePromises=t;function y(C,T,z){let B;const O=setTimeout(()=>{B?.(void 0),z?.()},T);return Promise.race([C.finally(()=>clearTimeout(O)),new Promise($=>B=$)])}e.raceTimeout=y;function I(C){return new Promise((T,z)=>{const B=C();n(B)?B.then(T,z):T(B)})}e.asPromise=I;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(z,z).then(B)})}return new Promise((z,B)=>{this.queuedPromise.then(z,B)})}return this.activePromise=T(),new Promise((z,B)=>{this.activePromise.then(O=>{this.activePromise=null,z(O)},O=>{this.activePromise=null,B(O)})})}}e.Throttler=v;class h{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=h;class g{constructor(){this.promiseMap=new Map}queue(T,z){const O=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(T)===O&&this.promiseMap.delete(T)});return this.promiseMap.set(T,O),O}}e.SequencerByKey=g;class P{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,z=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,O)=>{this.doResolve=B,this.doReject=O}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class S{constructor(T){this.delayer=new P(T),this.throttler=new v}trigger(T,z){return this.delayer.trigger(()=>this.throttler.queue(T),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class u{constructor(){this._isOpen=!1,this._promise=new Promise((T,z)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class d extends u{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function a(C,T){return T?new Promise((z,B)=>{const O=setTimeout(()=>{$.dispose(),z()},C),$=T.onCancellationRequested(()=>{clearTimeout(O),$.dispose(),B((0,L.canceled)())})}):f(z=>a(C,z))}e.timeout=a;function c(C,T=0){const z=setTimeout(C,T);return(0,M.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=c;function i(C){const T=[];let z=0;const B=C.length;function O(){return z<B?C[z++]():null}function $(F){F!=null&&T.push(F);const A=O();return A?A.then($):Promise.resolve(T)}return Promise.resolve(null).then($)}e.sequence=i;function s(C,T=B=>!!B,z=null){let B=0;const O=C.length,$=()=>{if(B>=O)return Promise.resolve(z);const F=C[B++];return Promise.resolve(F()).then(_=>T(_)?Promise.resolve(_):$())};return $()}e.first=s;function r(C,T=B=>!!B,z=null){if(C.length===0)return Promise.resolve(z);let B=C.length;const O=()=>{B=-1;for(const $ of C)$.cancel?.()};return new Promise(($,F)=>{for(const A of C)A.then(_=>{--B>=0&&T(_)?(O(),$(_)):B===0&&$(z)}).catch(_=>{--B>=0&&(O(),F(_))})})}e.firstParallel=r;class o{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((z,B)=>{this.outstandingPromises.push({factory:T,c:z,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const z=T.factory();z.then(T.c,T.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class l extends o{constructor(){super(1)}}e.Queue=l;class p{constructor(){this.queues=new Map}queueFor(T,z=b.extUri){const B=z.getComparisonKey(T);let O=this.queues.get(B);return O||(O=new l,k.Event.once(O.onFinished)(()=>{O?.dispose(),this.queues.delete(B)}),this.queues.set(B,O)),O}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=p;class E{constructor(T,z){this._token=-1,typeof T=="function"&&typeof z=="number"&&this.setIfNotSet(T,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},z)}setIfNotSet(T,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},z))}}e.TimeoutTimer=E;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,z){this.cancel(),this._token=setInterval(()=>{T()},z)}}e.IntervalTimer=D;class R{constructor(T,z){this.timeoutToken=-1,this.runner=T,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class W extends R{constructor(T,z){super(T,z);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class N extends M.Disposable{constructor(T,z,B,O){super();this.maxWorkChunkSize=T,this.maxPendingWork=z,this.throttleDelay=B,this.handler=O,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.maxPendingWork)return!1}else if(this.pending+T.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...T),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const C=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const z=setTimeout(()=>T(C));let B=!1;return{dispose(){B||(B=!0,clearTimeout(z))}}}}else e.runWhenIdle=(C,T)=>{const z=requestIdleCallback(C,typeof T=="number"?{timeout:T}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(z))}}}}();class G{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=G;async function x(C,T,z){let B;for(let O=0;O<z;O++)try{return await C()}catch($){B=$,await a(T)}throw B}e.retry=x;class ne{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(T,z,B){return this._pending={taskId:T,cancel:()=>B?.(),promise:z},z.then(()=>this.donePending(T),()=>this.donePending(T)),z}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let z,B;const O=new Promise(($,F)=>{z=$,B=F});this._next={run:T,promise:O,promiseResolve:z,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=ne;class V{constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,z)=>{this.completeCallback=T,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(z=>{this.completeCallback(T),this.resolved=!0,z()})}error(T){return new Promise(z=>{this.errorCallback(T),this.rejected=!0,z()})}cancel(){new Promise(T=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=Q;var U;(function(C){async function T(z){let B;const O=await Promise.all(z.map($=>$.then(F=>F,F=>{B||(B=F)})));if(typeof B!="undefined")throw B;return O}C.settled=T})(U=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,9,29,37,7,25]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",m="/",t="[/\\\\]",y="[^/\\\\]",I=/\//g;function v(O){switch(O){case 0:return"";case 1:return`${y}*?`;default:return`(?:${t}|${y}+${t}|${t}${y}+)*?`}}function h(O,$){if(!O)return[];const F=[];let A=!1,_=!1,j="";for(const Y of O){switch(Y){case $:if(!A&&!_){F.push(j),j="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":_=!0;break;case"]":_=!1;break}j+=Y}return j&&F.push(j),F}e.splitGlobAware=h;function g(O){if(!O)return"";let $="";const F=h(O,m);if(F.every(A=>A===f))$=".*";else{let A=!1;F.forEach((_,j)=>{if(_===f){A||($+=v(2),A=!0);return}let Y=!1,q="",X=!1,ie="";for(const se of _){if(se!=="}"&&Y){q+=se;continue}if(X&&(se!=="]"||!ie)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!ie?ae="^":se===m?ae="":ae=b.escapeRegExpCharacters(se),ie+=ae;continue}switch(se){case"{":Y=!0;continue;case"[":X=!0;continue;case"}":$+=`(?:${h(q,",").map(re=>g(re)).join("|")})`,Y=!1,q="";break;case"]":$+="["+ie+"]",X=!1,ie="";break;case"?":$+=y;continue;case"*":$+=v(1);continue;default:$+=b.escapeRegExpCharacters(se)}}j<F.length-1&&(F[j+1]!==f||j+2<F.length)&&($+=t),A=!1})}return $}const P=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),s=function(){return!1},r=function(){return null};function o(O,$){if(!O)return r;let F;typeof O!="string"?F=O.pattern:F=O,F=F.trim();const A=`${F}_${!!$.trimForExclusions}`;let _=i.get(A);if(_)return l(_,O);let j;if(P.test(F)){const Y=F.substr(4);_=function(q,X){return typeof q=="string"&&q.endsWith(Y)?F:null}}else(j=S.exec(p(F,$)))?_=E(j[1],F):($.trimForExclusions?d:u).test(F)?_=D(F,$):(j=a.exec(p(F,$)))?_=R(j[1].substr(1),F,!0):(j=c.exec(p(F,$)))?_=R(j[1],F,!1):_=W(F);return i.set(A,_),l(_,O)}function l(O,$){return typeof $=="string"?O:function(F,A){return L.isEqualOrParent(F,$.base)?O(M.relative($.base,F),A):null}}function p(O,$){return $.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function E(O,$){const F=`/${O}`,A=`\\${O}`,_=function(Y,q){return typeof Y!="string"?null:q?q===O?$:null:Y===O||Y.endsWith(F)||Y.endsWith(A)?$:null},j=[O];return _.basenames=j,_.patterns=[$],_.allBasenames=j,_}function D(O,$){const F=B(O.slice(1,-1).split(",").map(q=>o(q,$)).filter(q=>q!==r),O),A=F.length;if(!A)return r;if(A===1)return F[0];const _=function(q,X){for(let ie=0,se=F.length;ie<se;ie++)if(F[ie](q,X))return O;return null},j=F.find(q=>!!q.allBasenames);j&&(_.allBasenames=j.allBasenames);const Y=F.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return Y.length&&(_.allPaths=Y),_}function R(O,$,F){const A=M.sep===M.posix.sep,_=A?O:O.replace(I,M.sep),j=M.sep+_,Y=M.posix.sep+O,q=F?function(X,ie){return typeof X=="string"&&(X===_||X.endsWith(j)||!A&&(X===O||X.endsWith(Y)))?$:null}:function(X,ie){return typeof X=="string"&&(X===_||!A&&X===O)?$:null};return q.allPaths=[(F?"*/":"./")+O],q}function W(O){try{const $=new RegExp(`^${g(O)}$`);return function(F){return $.lastIndex=0,typeof F=="string"&&$.test(F)?O:null}}catch($){return r}}function N(O,$,F){return!O||typeof $!="string"?!1:G(O)($,void 0,F)}e.match=N;function G(O,$={}){if(!O)return s;if(typeof O=="string"||Q(O)){const F=o(O,$);if(F===r)return s;const A=function(_,j){return!!F(_,j)};return F.allBasenames&&(A.allBasenames=F.allBasenames),F.allPaths&&(A.allPaths=F.allPaths),A}return T(O,$)}e.parse=G;function x(O){if(!O)return;let $;return F=>($||($=(O()||Promise.resolve([])).then(A=>A?V(A):{})),$.then(A=>!!A[F]))}e.hasSiblingPromiseFn=x;function ne(O){if(!O)return;let $;return F=>{if(!$){const A=O();$=A?V(A):{}}return!!$[F]}}e.hasSiblingFn=ne;function V(O){const $={};for(const F of O)$[F]=!0;return $}function Q(O){const $=O;return $&&typeof $.base=="string"&&typeof $.pattern=="string"}e.isRelativePattern=Q;function U(O){return O.allBasenames||[]}e.getBasenameTerms=U;function C(O){return O.allPaths||[]}e.getPathTerms=C;function T(O,$){const F=B(Object.getOwnPropertyNames(O).map(q=>z(q,O[q],$)).filter(q=>q!==r)),A=F.length;if(!A)return r;if(!F.some(q=>!!q.requiresSiblings)){if(A===1)return F[0];const q=function(se,ae){for(let ue=0,re=F.length;ue<re;ue++){const le=F[ue](se,ae);if(le)return le}return null},X=F.find(se=>!!se.allBasenames);X&&(q.allBasenames=X.allBasenames);const ie=F.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return ie.length&&(q.allPaths=ie),q}const _=function(q,X,ie){let se;for(let ae=0,ue=F.length;ae<ue;ae++){const re=F[ae];re.requiresSiblings&&ie&&(X||(X=M.basename(q)),se||(se=X.substr(0,X.length-M.extname(q).length)));const le=re(q,X,se,ie);if(le)return le}return null},j=F.find(q=>!!q.allBasenames);j&&(_.allBasenames=j.allBasenames);const Y=F.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return Y.length&&(_.allPaths=Y),_}function z(O,$,F){if($===!1)return r;const A=o(O,F);if(A===r)return r;if(typeof $=="boolean")return A;if($){const _=$.when;if(typeof _=="string"){const j=(Y,q,X,ie)=>{if(!ie||!A(Y,q))return null;const se=_.replace("$(basename)",X),ae=ie(se);return(0,w.isThenable)(ae)?ae.then(ue=>ue?O:null):ae?O:null};return j.requiresSiblings=!0,j}}return A}function B(O,$){const F=O.filter(q=>!!q.basenames);if(F.length<2)return O;const A=F.reduce((q,X)=>{const ie=X.basenames;return ie?q.concat(ie):q},[]);let _;if($){_=[];for(let q=0,X=A.length;q<X;q++)_.push($)}else _=F.reduce((q,X)=>{const ie=X.patterns;return ie?q.concat(ie):q},[]);const j=function(q,X){if(typeof q!="string")return null;if(!X){let se;for(se=q.length;se>0;se--){const ae=q.charCodeAt(se-1);if(ae===47||ae===92)break}X=q.substr(se)}const ie=A.indexOf(X);return ie!==-1?_[ie]:null};j.basenames=A,j.patterns=_,j.allBasenames=A;const Y=O.filter(q=>!q.basenames);return Y.push(j),Y}}),define(J[31],Z([0,1,29,10,7,3,15,25,8]),function(H,e,w,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function m(o,l,p){if(typeof o=="string"&&(o=f.URI.file(o)),p){const D=p.getWorkspaceFolder(o);if(D){const R=p.getWorkspace().folders.length>1;let W;if((0,b.isEqual)(D.uri,o)?W="":W=(0,b.relativePath)(D.uri,o),R){const N=D.name?D.name:(0,b.basename)(D.uri);W=W?N+" \u2022 "+W:N}return W}}if(o.scheme!==L.Schemas.file&&o.scheme!==L.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(o.fsPath))return(0,k.normalize)(y(o.fsPath));let E=(0,k.normalize)(o.fsPath);return!M.isWindows&&l?.userHome&&(E=v(E,l.userHome.fsPath)),E}e.getPathLabel=m;function t(o){if(!o)return;typeof o=="string"&&(o=f.URI.file(o));const l=(0,b.basename)(o)||(o.scheme===L.Schemas.file?o.fsPath:o.path);return M.isWindows&&(0,w.isRootOrDriveLetter)(l)?y(l):l}e.getBaseLabel=t;function y(o){return(0,w.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=y;let I=Object.create(null);function v(o,l){if(M.isWindows||!o||!l)return o;let p=I.original===l?I.normalized:void 0;return p||(p=`${(0,n.rtrim)(l,k.posix.sep)}${k.posix.sep}`,I={original:l,normalized:p}),(M.isLinux?o.startsWith(p):(0,n.startsWithIgnoreCase)(o,p))&&(o=`~/${o.substr(p.length)}`),o}e.tildify=v;function h(o,l){return o.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=h;const g="\u2026",P="\\\\",S="~";function u(o,l=k.sep){const p=new Array(o.length);let E=!1;for(let D=0;D<o.length;D++){let R=o[D];if(R===""){p[D]=`.${l}`;continue}if(!R){p[D]=R;continue}E=!0;let W="";R.indexOf(P)===0?(W=R.substr(0,R.indexOf(P)+P.length),R=R.substr(R.indexOf(P)+P.length)):R.indexOf(l)===0?(W=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(S)===0&&(W=R.substr(0,R.indexOf(S)+S.length),R=R.substr(R.indexOf(S)+S.length));const N=R.split(l);for(let G=1;E&&G<=N.length;G++)for(let x=N.length-G;E&&x>=0;x--){E=!1;let ne=N.slice(x,x+G).join(l);for(let V=0;!E&&V<o.length;V++)if(V!==D&&o[V]&&o[V].indexOf(ne)>-1){const Q=x+G===N.length,U=x>0&&o[V].indexOf(l)>-1?l+ne:ne,C=o[V].endsWith(U);E=!Q||C}if(!E){let V="";(N[0].endsWith(":")||W!=="")&&(x===1&&(x=0,G++,ne=N[0]+l+ne),x>0&&(V=N[0]+l),V=W+V),x>0&&(V=V+g+l),V=V+ne,x+G<N.length&&(V=V+l+g),p[D]=V}}E&&(p[D]=R)}return p}e.shorten=u;var d;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function a(o,l=Object.create(null)){const p=[];let E=!1,D="";for(const R of o)if(R==="$"||E&&R==="{")D&&p.push({value:D,type:d.TEXT}),D="",E=!0;else if(R==="}"&&E){const W=l[D];if(typeof W=="string")W.length&&p.push({value:W,type:d.VARIABLE});else if(W){const N=p[p.length-1];(!N||N.type!==d.SEPARATOR)&&p.push({value:W.label,type:d.SEPARATOR})}D="",E=!1}else D+=R;return D&&!E&&p.push({value:D,type:d.TEXT}),p.filter((R,W)=>{if(R.type===d.SEPARATOR){const N=p[W-1],G=p[W+1];return[N,G].every(x=>x&&(x.type===d.VARIABLE||x.type===d.TEXT)&&x.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=a;function c(o,l){return M.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):o.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function i(o,l){return M.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,""):M.isWindows?o.replace(/&&|&/g,p=>p==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(o){const l=o.indexOf("/")!==-1?k.posix:k.win32,p=l.basename(o),E=l.dirname(o);return p.length?{name:p,parentPath:E}:{name:E,parentPath:""}}e.splitName=r}),define(J[28],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return w.test(f)}e.isUUID=L;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(f){for(let m=0;m<f.length;m++)f[m]=Math.floor(Math.random()*256);return f};function n(){b(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,m="";return m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m}e.generateUuid=n}),define(J[112],Z([0,1,58,30,43]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(b,n){if(await new Promise((t,y)=>{const I=L.createReadStream(b),v=w.createHash("sha1");I.pipe(v);const h=(0,k.once)((g,P)=>{I.removeAllListeners(),v.removeAllListeners(),g?y(g):t(P)});I.once("error",h),I.once("end",h),v.once("error",h),v.once("data",g=>h(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(J[79],Z([0,1,239]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new w.StringDecoder(M),this.remaining=null}write(M){const b=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return b;let f=0,m,t=f;for(;t<n.length;)if(m=n.charCodeAt(t),m===13||m===10){if(b.push(n.substring(f,t)),t++,t<n.length){const y=m;m=n.charCodeAt(t),(y===13&&m===10||y===10&&m===13)&&t++}f=t}else t++;return this.remaining=f<n.length?n.substr(f):null,b}end(){return this.remaining}}e.LineDecoder=L}),define(J[113],Z([0,1,26]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function M(){return new Promise(async(n,f)=>{const m=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await b())}catch(t){f(t)}finally{clearTimeout(m)}})}e.getMac=M;function b(){return new Promise((n,f)=>{try{const m=(0,w.networkInterfaces)();for(let t in m){const y=m[t];if(y){for(const{mac:I}of y)if(k(I))return n(I)}}f("Unable to retrieve mac address (unexpected format)")}catch(m){f(m)}})}}),define(J[66],Z([0,1,26,16,37,28,113]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,y=0;const I=(0,w.networkInterfaces)();for(let v in I){const h=I[v];if(h)for(const{mac:g,internal:P}of h)P||(y+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(t+=1))}this._value=y>0?t/y:0}return this._value}};let n;async function f(){return n||(n=(async()=>await m()||M.generateUuid())()),n}e.getMachineId=f;async function m(){try{const t=await new Promise((I,v)=>{H(["crypto"],I,v)}),y=await(0,b.getMac)();return t.createHash("sha256").update(y,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(J[18],Z([0,1,30,26,114,9,29,65,7,3,15,8,28]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function h(U,C=v.UNLINK){if((0,b.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return C===v.UNLINK?P(U):g(U)}async function g(U){try{const C=(0,f.join)((0,L.tmpdir)(),(0,I.generateUuid)());try{await e.Promises.rename(U,C)}catch(T){return P(U)}P(C).catch(T=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function P(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function S(U){if((0,b.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(U,{recursive:!0})}e.rimrafSync=S;async function u(U,C){return c(await(C?d(U):(0,k.promisify)(w.readdir)(U)))}async function d(U){try{return await(0,k.promisify)(w.readdir)(U,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const C=[],T=await u(U);for(const z of T){let B=!1,O=!1,$=!1;try{const F=await e.Promises.lstat((0,f.join)(U,z));B=F.isFile(),O=F.isDirectory(),$=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}C.push({name:z,isFile:()=>B,isDirectory:()=>O,isSymbolicLink:()=>$})}return C}function a(U){return c(w.readdirSync(U))}e.readdirSync=a;function c(U){return U.map(C=>typeof C=="string"?m.isMacintosh?(0,n.normalizeNFC)(C):C:(C.name=m.isMacintosh?(0,n.normalizeNFC)(C.name):C.name,C))}async function i(U){const C=await u(U),T=[];for(const z of C)await r.existsDirectory((0,f.join)(U,z))&&T.push(z);return T}function s(U,C=1e3){return new Promise(T=>{let z=!1;const B=setInterval(()=>{z||(z=!0,w.access(U,O=>{z=!1,O&&(clearInterval(B),T(void 0))}))},C)})}e.whenDeleted=s;var r;(function(U){async function C(B){let O;try{if(O=await e.Promises.lstat(B),!O.isSymbolicLink())return{stat:O}}catch($){}try{return{stat:await e.Promises.stat(B),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(m.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw F}throw $}}U.stat=C;async function T(B){try{const{stat:O,symbolicLink:$}=await U.stat(B);return O.isFile()&&$?.dangling!==!0}catch(O){}return!1}U.existsFile=T;async function z(B){try{const{stat:O,symbolicLink:$}=await U.stat(B);return O.isDirectory()&&$?.dangling!==!0}catch(O){}return!1}U.existsDirectory=z})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new M.ResourceQueue;function l(U,C,T){return o.queueFor(y.URI.file(U),t.extUriBiasedIgnorePathCase).queue(()=>{const z=R(T);return new Promise((B,O)=>E(U,C,z,$=>$?O($):B()))})}let p=!0;function E(U,C,T,z){if(!p)return w.writeFile(U,C,{mode:T.mode,flag:T.flag},z);w.open(U,T.flag,T.mode,(B,O)=>{if(B)return z(B);w.writeFile(O,C,$=>{if($)return w.close(O,()=>z($));w.fdatasync(O,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),p=!1),w.close(O,A=>z(A))))})})}function D(U,C,T){const z=R(T);if(!p)return w.writeFileSync(U,C,{mode:z.mode,flag:z.flag});const B=w.openSync(U,z.flag,z.mode);try{w.writeFileSync(B,C);try{w.fdatasyncSync(B)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),p=!1}}finally{w.closeSync(B)}}e.writeFileSync=D;function R(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function W(U,C){if(U===C)return;async function T(z){try{const B=await e.Promises.lstat(z);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(z,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(U,C),await T(C)}catch(z){if(U.toLowerCase()!==C.toLowerCase()&&z.code==="EXDEV"||U.endsWith("."))await N(U,C,{preserveSymlinks:!1}),await h(U,v.MOVE),await T(C);else throw z}}async function N(U,C,T){return x(U,C,{root:{source:U,target:C},options:T,handledSourcePaths:new Set})}const G=511;async function x(U,C,T){if(T.handledSourcePaths.has(U))return;T.handledSourcePaths.add(U);const{stat:z,symbolicLink:B}=await r.stat(U);if(B){if(T.options.preserveSymlinks)try{return await Q(U,C,T)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(B.dangling)return}return z.isDirectory()?ne(U,C,z.mode&G,T):V(U,C,z.mode&G)}async function ne(U,C,T,z){await e.Promises.mkdir(C,{recursive:!0,mode:T});const B=await u(U);for(const O of B)await x((0,f.join)(U,O),(0,f.join)(C,O),z)}async function V(U,C,T){await e.Promises.copyFile(U,C),await e.Promises.chmod(C,T)}async function Q(U,C,T){let z=await e.Promises.readlink(U);(0,b.isEqualOrParent)(z,T.root.source,!m.isLinux)&&(z=(0,f.join)(T.root.target,z.substr(T.root.source.length+1))),await e.Promises.symlink(z,C)}e.Promises=new class{get access(){return(0,k.promisify)(w.access)}get stat(){return(0,k.promisify)(w.stat)}get lstat(){return(0,k.promisify)(w.lstat)}get utimes(){return(0,k.promisify)(w.utimes)}get read(){return(0,k.promisify)(w.read)}get readFile(){return(0,k.promisify)(w.readFile)}get write(){return(0,k.promisify)(w.write)}get appendFile(){return(0,k.promisify)(w.appendFile)}get fdatasync(){return(0,k.promisify)(w.fdatasync)}get truncate(){return(0,k.promisify)(w.truncate)}get rename(){return(0,k.promisify)(w.rename)}get copyFile(){return(0,k.promisify)(w.copyFile)}get open(){return(0,k.promisify)(w.open)}get close(){return(0,k.promisify)(w.close)}get symlink(){return(0,k.promisify)(w.symlink)}get readlink(){return(0,k.promisify)(w.readlink)}get chmod(){return(0,k.promisify)(w.chmod)}get mkdir(){return(0,k.promisify)(w.mkdir)}get unlink(){return(0,k.promisify)(w.unlink)}get rmdir(){return(0,k.promisify)(w.rmdir)}get realpath(){return(0,k.promisify)(w.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return i}get writeFile(){return l}get rm(){return h}get move(){return W}get copy(){return N}}}),define(J[80],Z([0,1,30,7,25,18]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function b(t){const y=(0,L.dirname)(t);if(t===y)return t;const I=((0,L.basename)(t)||t).toLowerCase();try{const h=(0,M.readdirSync)(y).filter(g=>g.toLowerCase()===I);if(h.length===1){const g=b(y);if(g)return(0,L.join)(g,h[0])}else if(h.length>1){const g=h.indexOf(I);if(g>=0){const P=b(y);if(P)return(0,L.join)(P,h[g])}}}catch(v){}return null}e.realcaseSync=b;async function n(t){try{return await M.Promises.realpath(t)}catch(y){const I=m(t);return await M.Promises.access(I,w.constants.R_OK),I}}e.realpath=n;function f(t){try{return w.realpathSync(t)}catch(y){const I=m(t);return w.accessSync(I,w.constants.R_OK),I}}e.realpathSync=f;function m(t){return(0,k.rtrim)((0,L.normalize)(t),L.sep)}}),define(J[115],Z([0,1,59]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,m,t=1){let y=!1;return new Promise(I=>{const v=setTimeout(()=>{if(!y)return y=!0,I(0)},m);k(n,f,t,h=>{if(!y)return y=!0,clearTimeout(v),I(h)})})}e.findFreePort=L;function k(n,f,m,t){if(f===0)return t(0);const y=new w.Socket;y.once("connect",()=>(b(y),k(n+m,f-1,m,t))),y.once("data",()=>{}),y.once("error",I=>(b(y),I.code!=="ECONNREFUSED"?k(n+m,f-1,m,t):t(n))),y.connect(n,"127.0.0.1")}function M(n,f,m){let t=!1,y,I=1;const v=w.createServer({pauseOnConnect:!0});function h(g,P){t||(t=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),P(g))}return new Promise(g=>{y=setTimeout(()=>{h(0,g)},m),v.on("listening",()=>{h(n,g)}),v.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&I<f?(n++,I++,v.listen(n,"127.0.0.1")):h(0,g)}),v.on("close",()=>{h(0,g)}),v.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function b(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(J[116],Z([0,1,26,7,18]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,b=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(f||(f={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class y{constructor(c,i,s){this.exePath=c,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:a=!1}={}){return a?m===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:c=!1}={}){const i=I({useAlternateBitness:a});if(!i)return null;const s=L.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let r=-1,o=null;for(const E of await k.Promises.readdir(s)){let D=-1;if(c){const W=E.indexOf("-");if(W<0)continue;const N=E.substring(0,W);if(!M.test(N)||E.substring(W+1)!=="preview")continue;D=parseInt(N,10)}else{if(!M.test(E))continue;D=parseInt(E,10)}if(D<=r)continue;const R=L.join(s,E,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(o=R,r=D)}if(!o)return null;const l=i.includes("x86")?" (x86)":"",p=c?" Preview":"";return new y(o,`PowerShell${p}${l}`,!0)}async function h({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=a?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:b,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(c))if(i.test(r)){const o=L.join(c,r,"pwsh.exe");return new y(o,s)}return null}function g(){const a=L.join(w.homedir(),".dotnet","tools","pwsh.exe");return new y(a,".NET Core PowerShell Global Tool")}function P(){const a=L.join(process.env.windir,m===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(a,"Windows PowerShell",!0)}async function*S(){let a=await v();a&&(yield a),a=await v({useAlternateBitness:!0}),a&&(yield a),a=await h(),a&&(yield a),a=g(),a&&(yield a),a=await v({findPreview:!0}),a&&(yield a),a=await h({findPreview:!0}),a&&(yield a),a=await v({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=P(),a&&(yield a)}async function*u(){for await(const a of S())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=u;async function d(){for await(const a of u())return a;return null}e.getFirstAvailablePowerShellInstallation=d}),define(J[81],Z([0,1,41,10]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(b){return new Promise((n,f)=>{let m;const t=new Map;function y(v,h,g,P,S){const u=t.get(h);if(v===b||u){const d={name:I(g),cmd:g,pid:v,ppid:h,load:P,mem:S};t.set(v,d),v===b&&(m=d),u&&(u.children||(u.children=[]),u.children.push(d),u.children.length>1&&(u.children=u.children.sort((a,c)=>a.pid-c.pid)))}}function I(v){const h=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,S=/\\pipe\\winpty-control/,u=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(g.exec(v))return"watcherService ";if(P.exec(v))return"electron-crash-reporter";if(S.exec(v))return"winpty-process";if(u.exec(v))return"console-window-host (Windows internal process)";let a=d.exec(v);if(a&&a.length===2)return a[1]==="renderer"?h.exec(v)?"shared-process":"window":a[1];const c=/[a-zA-Z-]+\.js/g;let i="";do a=c.exec(v),a&&(i+=a+" ");while(a);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,g)=>{H(["windows-process-tree"],h,g)}).then(h=>{h.getProcessList(b,g=>{h.getProcessCpuUsage(g,P=>{const S=new Map;P.forEach(u=>{const d=v(u.commandLine||"");S.set(u.pid,{name:I(d),cmd:d,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),m=S.get(b),m?(S.forEach(u=>{const d=S.get(u.ppid);d&&(d.children||(d.children=[]),d.children.push(u))}),S.forEach(u=>{u.children&&(u.children=u.children.sort((d,a)=>d.pid-a.pid))}),n(m)):f(new Error(`Root process ${b} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[m];const g=[];for(;h.length;){const S=h.shift();S&&(g.push(S.pid),S.children&&(h=h.concat(S.children)))}let P=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);P+=" "+g.join(" "),(0,w.exec)(P,{},(S,u,d)=>{if(S||d)f(S||new Error(d.toString()));else{const a=u.toString().split(`
`);for(let c=0;c<g.length;c++){const i=t.get(g[c]);i.load=parseFloat(a[c])}if(!m){f(new Error(`Root process ${b} not found`));return}n(m)}})};(0,w.exec)("which ps",{},(h,g,P)=>{if(h||P)if(process.platform!=="linux")f(h||new Error(P.toString()));else{const S=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,w.exec)(S,{},(u,d,a)=>{u||a?f(u||new Error(a.toString())):(M(d,y),v())})}else{const S=g.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${S} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,a,c)=>{d||c&&!c.includes("screen size is bogus")?f(d||new Error(c.toString())):(M(a,y),process.platform==="linux"?v():m?n(m):f(new Error(`Root process ${b} not found`)))})}})}})}e.listProcesses=k;function M(b,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=b.toString().split(`
`);for(const t of m){const y=f.exec(t.trim());y&&y.length===6&&n(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(J[117],Z([0,1,30,29,2,65,7,3,18]),function(H,e,w,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function m(I,v,h){return y({path:I,isDirectory:!1},v,h)}e.watchFile=m;function t(I,v,h){return y({path:I,isDirectory:!0},v,h)}e.watchFolder=t,e.CHANGE_BUFFER_DELAY=100;function y(I,v,h){if(n.isMacintosh&&(0,L.isEqualOrParent)(I.path,"/Volumes/"))return h(`Refusing to watch ${I.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=(0,b.basename)(I.path),P=new Map;let S=!1,u=[(0,k.toDisposable)(()=>{P.forEach(d=>(0,k.dispose)(d)),P.clear()})];try{const d=(0,w.watch)(I.path);u.push((0,k.toDisposable)(()=>{d.removeAllListeners(),d.close()}));const a=new Set;I.isDirectory&&f.Promises.readdir(I.path).then(c=>c.forEach(i=>a.add(i))),d.on("error",(c,i)=>{S||h(`Failed to watch ${I.path} for changes using fs.watch() (${c}, ${i})`)}),d.on("change",(c,i)=>{if(S)return;let s="";if(i&&(s=i.toString(),n.isMacintosh&&(s=(0,M.normalizeNFC)(s))),!s||c!=="change"&&c!=="rename")return;const r=I.isDirectory?(0,b.join)(I.path,s):I.path;if(I.isDirectory)if(c==="rename"){const o=P.get(r);o&&(0,k.dispose)(o);const l=setTimeout(async()=>{P.delete(r);const p=await f.Promises.exists(r);if(S)return;let E;p?a.has(s)?E="changed":(E="added",a.add(s)):(a.delete(s),E="deleted"),v(E,r)},e.CHANGE_BUFFER_DELAY);P.set(r,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let o;a.has(s)?o="changed":(o="added",a.add(s)),v(o,r)}else if(c==="rename"||s!==g){const o=setTimeout(async()=>{const l=await f.Promises.exists(r);S||(l?(v("changed",r),u=[y(I,v,h)]):v("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(u),u=[(0,k.toDisposable)(()=>clearTimeout(o))]}else v("changed",r)})}catch(d){f.Promises.exists(I.path).then(a=>{a&&!S&&h(`Failed to watch ${I.path} for changes using fs.watch() (${d.toString()})`)})}return(0,k.toDisposable)(()=>{S=!0,u=(0,k.dispose)(u)})}}),define(J[118],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,13,118]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){w.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(n,f,m,t,y)=>{const I=b(n,t,m);I.popup({window:(0,L.withNullAsUndefined)(w.BrowserWindow.fromWebContents(n.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{I&&n.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function b(n,f,m){const t=new w.Menu;return m.forEach(y=>{let I;y.type==="separator"?I=new w.MenuItem({type:y.type}):Array.isArray(y.submenu)?I=new w.MenuItem({submenu:b(n,f,y.submenu),label:y.label}):I=new w.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(v,h,g)=>n.sender.send(f,y.id,g)}),t.append(I)}),t}});var ce=this&&this.__decorate||function(H,e,w,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,b;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(H,e,w,L);else for(var n=H.length-1;n>=0;n--)(b=H[n])&&(M=(k<3?b(M):k>3?b(e,w,M):b(e,w))||M);return k>3&&M&&Object.defineProperty(e,w,M),M};define(J[34],Z([0,1,36,9,17,24,46,16,5,2,110,25,13]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function P(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(S||(S={}));class u{constructor(O){this.buffer=O,this.pos=0}read(O){const $=this.buffer.slice(this.pos,this.pos+O);return this.pos+=$.byteLength,$}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var a;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(a||(a={}));function c(B){const O=k.VSBuffer.alloc(4);return O.writeUInt32BE(B,0),O}function i(B){return B.read(4).readUInt32BE(0)}function s(B){const O=k.VSBuffer.alloc(1);return O.writeUInt8(B,0),O}const r={Undefined:s(a.Undefined),String:s(a.String),Buffer:s(a.Buffer),VSBuffer:s(a.VSBuffer),Array:s(a.Array),Object:s(a.Object)},o=typeof Buffer!="undefined";function l(B,O){if(typeof O=="undefined")B.write(r.Undefined);else if(typeof O=="string"){const $=k.VSBuffer.fromString(O);B.write(r.String),B.write(c($.byteLength)),B.write($)}else if(o&&Buffer.isBuffer(O)){const $=k.VSBuffer.wrap(O);B.write(r.Buffer),B.write(c($.byteLength)),B.write($)}else if(O instanceof k.VSBuffer)B.write(r.VSBuffer),B.write(c(O.byteLength)),B.write(O);else if(Array.isArray(O)){B.write(r.Array),B.write(c(O.length));for(const $ of O)l(B,$)}else{const $=k.VSBuffer.fromString(JSON.stringify(O));B.write(r.Object),B.write(c($.byteLength)),B.write($)}}function p(B){switch(B.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return B.read(i(B)).toString();case a.Buffer:return B.read(i(B)).buffer;case a.VSBuffer:return B.read(i(B));case a.Array:{const $=i(B),F=[];for(let A=0;A<$;A++)F.push(p(B));return F}case a.Object:return JSON.parse(B.read(i(B)).toString())}}class E{constructor(O,$,F=null,A=1e3){this.protocol=O,this.ctx=$,this.logger=F,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(O,$){this.channels.set(O,$),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const $=this.send([O.type]);this.logger&&this.logger.logOutgoing($,0,1,P(O.type));return}case 201:case 202:case 204:case 203:{const $=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing($,O.id,1,P(O.type),O.data);return}}}send(O,$=void 0){const F=new d;return l(F,O),l(F,$),this.sendBuffer(F.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch($){return 0}}onRawMessage(O){const $=new u(O),F=p($),A=p($),_=F[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,F[1],1,`${h(_)}: ${F[2]}.${F[3]}`,A),this.onPromise({type:_,id:F[1],channelName:F[2],name:F[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,F[1],1,`${h(_)}: ${F[2]}.${F[3]}`,A),this.onEventListen({type:_,id:F[1],channelName:F[2],name:F[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,F[1],1,`${h(_)}`),this.disposeActiveRequest({type:_,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,F[1],1,`${h(_)}`),this.disposeActiveRequest({type:_,id:F[1]})}}onPromise(O){const $=this.channels.get(O.channelName);if(!$){this.collectPendingRequest(O);return}const F=new M.CancellationTokenSource;let A;try{A=$.call(this.ctx,O.name,O.arg,F.token)}catch(Y){A=Promise.reject(Y)}const _=O.id;A.then(Y=>{this.sendResponse({id:_,data:Y,type:201}),this.activeRequests.delete(O.id)},Y=>{Y instanceof Error?this.sendResponse({id:_,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:_,data:Y,type:203}),this.activeRequests.delete(O.id)});const j=(0,m.toDisposable)(()=>F.cancel());this.activeRequests.set(O.id,j)}onEventListen(O){const $=this.channels.get(O.channelName);if(!$){this.collectPendingRequest(O);return}const F=O.id,_=$.listen(this.ctx,O.name,O.arg)(j=>this.sendResponse({id:F,data:j,type:204}));this.activeRequests.set(O.id,_)}disposeActiveRequest(O){const $=this.activeRequests.get(O.id);$&&($.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let $=this.pendingRequests.get(O.channelName);$||($=[],this.pendingRequests.set(O.channelName,$));const F=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:O,timeoutTimer:F})}flushPendingRequests(O){const $=this.pendingRequests.get(O);if($){for(const F of $)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=E;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(O,$=null){this.protocol=O,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=$}getChannel(O){const $=this;return{call(F,A,_){return $.isDisposed?Promise.reject(n.canceled()):$.requestPromise(O,F,A,_)},listen(F,A){return $.isDisposed?Promise.reject(n.canceled()):$.requestEvent(O,F,A)}}}requestPromise(O,$,F,A=M.CancellationToken.None){const _=this.lastRequestId++,Y={id:_,type:100,channelName:O,name:$,arg:F};if(A.isCancellationRequested)return Promise.reject(n.canceled());let q;return new Promise((ie,se)=>{if(A.isCancellationRequested)return se(n.canceled());const ae=()=>{const be=pe=>{switch(pe.type){case 201:this.handlers.delete(_),ie(pe.data);break;case 202:this.handlers.delete(_);const Se=new Error(pe.data.message);Se.stack=pe.data.stack,Se.name=pe.data.name,se(Se);break;case 203:this.handlers.delete(_),se(pe.data);break}};this.handlers.set(_,be),this.sendRequest(Y)};let ue=null;this.state===S.Idle?ae():(ue=(0,L.createCancelablePromise)(be=>this.whenInitialized()),ue.then(()=>{ue=null,ae()}));const re=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:_,type:101}),se(n.canceled())},le=A.onCancellationRequested(re);q=(0,m.combinedDisposable)((0,m.toDisposable)(re),le),this.activeRequests.add(q)}).finally(()=>{this.activeRequests.delete(q)})}requestEvent(O,$,F){const A=this.lastRequestId++,j={id:A,type:102,channelName:O,name:$,arg:F};let Y=null;const q=new f.Emitter({onFirstListenerAdd:()=>{Y=(0,L.createCancelablePromise)(ie=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(q),this.sendRequest(j)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(q),this.sendRequest({id:A,type:103}))}}),X=ie=>q.fire(ie.data);return this.handlers.set(A,X),q.event}sendRequest(O){switch(O.type){case 100:case 102:{const $=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing($,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const $=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing($,O.id,0,h(O.type));return}}}send(O,$=void 0){const F=new d;return l(F,O),l(F,$),this.sendBuffer(F.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch($){return 0}}onBuffer(O){const $=new u(O),F=p($),A=p($),_=F[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,P(_)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,F[1],0,P(_),A),this.onResponse({type:F[0],id:F[1],data:A})}}onResponse(O){if(O.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(O.id);$&&$(O)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}ce([b.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class W{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:$,onDidClientDisconnect:F})=>{f.Event.once($.onMessage)(_=>{const j=new u(_),Y=p(j),q=new E($,Y),X=new R($);this.channels.forEach((se,ae)=>q.registerChannel(ae,se));const ie={channelServer:q,channelClient:X,ctx:Y};this._connections.add(ie),this._onDidAddConnection.fire(ie),F(()=>{q.dispose(),X.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const O=[];return this._connections.forEach($=>O.push($)),O}getChannel(O,$){const F=this;return{call(A,_,j){let Y;if((0,I.isFunction)($)){let X=(0,w.getRandomElement)(F.connections.filter($));Y=X?Promise.resolve(X):f.Event.toPromise(f.Event.filter(F.onDidAddConnection,$))}else Y=$.routeCall(F,A,_);const q=Y.then(X=>X.channelClient.getChannel(O));return G(q).call(A,_,j)},listen(A,_){if((0,I.isFunction)($))return F.getMulticastEvent(O,$,A,_);const j=$.routeEvent(F,A,_).then(Y=>Y.channelClient.getChannel(O));return G(j).listen(A,_)}}}getMulticastEvent(O,$,F,A){const _=this;let j=new m.DisposableStore;const Y=new f.Emitter({onFirstListenerAdd:()=>{j=new m.DisposableStore;const q=new f.EventMultiplexer,X=new Map,ie=ae=>{const re=ae.channelClient.getChannel(O).listen(F,A),le=q.add(re);X.set(ae,le)},se=ae=>{const ue=X.get(ae);!ue||(ue.dispose(),X.delete(ae))};_.connections.filter($).forEach(ie),f.Event.filter(_.onDidAddConnection,$)(ie,void 0,j),_.onDidRemoveConnection(se,void 0,j),q.event(Y.fire,Y,j),j.add(q)},onLastListenerRemove:()=>{j.dispose()}});return Y.event}registerChannel(O,$){this.channels.set(O,$),this._connections.forEach(F=>{F.channelServer.registerChannel(O,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=W;class N{constructor(O,$,F=null){const A=new d;l(A,$),O.send(A.buffer),this.channelClient=new R(O,F),this.channelServer=new E(O,$,F)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,$){this.channelServer.registerChannel(O,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function G(B){return{call(O,$,F){return B.then(A=>A.call(O,$,F))},listen(O,$){const F=new f.Relay;return B.then(A=>F.input=A.listen(O,$)),F.event}}}e.getDelayedChannel=G;function x(B){let O=!1;return{call($,F,A){return O?B.call($,F,A):(0,L.timeout)(0).then(()=>O=!0).then(()=>B.call($,F,A))},listen($,F){if(O)return B.listen($,F);const A=new f.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>A.input=B.listen($,F)),A.event}}}e.getNextTickChannel=x;class ne{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const $ of O.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await f.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=ne;var V;(function(B){function O(A,_){const j=A,Y=_&&_.disableMarshalling,q=new Map;for(const X in j)F(X)&&q.set(X,f.Event.buffer(j[X],!0));return new class{listen(X,ie){const se=q.get(ie);if(se)return se;throw new Error(`Event not found: ${ie}`)}call(X,ie,se){const ae=j[ie];if(typeof ae=="function"){if(!Y&&Array.isArray(se))for(let ue=0;ue<se.length;ue++)se[ue]=(0,t.revive)(se[ue]);return ae.apply(j,se)}throw new Error(`Method not found: ${ie}`)}}}B.fromService=O;function $(A,_){const j=_&&_.disableMarshalling;return new Proxy({},{get(Y,q){if(typeof q=="string")return _?.properties?.has(q)?_.properties.get(q):F(q)?A.listen(q):async function(...X){let ie;_&&!(0,I.isUndefinedOrNull)(_.context)?ie=[_.context,...X]:ie=X;const se=await A.call(q,ie);return j?se:(0,t.revive)(se)};throw new Error(`Property not found: ${String(q)}`)}})}B.toService=$;function F(A){return A[0]==="o"&&A[1]==="n"&&y.isUpperAsciiLetter(A.charCodeAt(2))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let O=B.toString();if(O!=="[object Object]")return O}return B}function C(B){return Array.isArray(B)?B.map(U):U(B)}function T(B,O,$,F,A,_,j){j=C(j);const Y=Q[A],q=Y[F%Y.length];let X=[`%c[${B}]%c[${String(O).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(_)?(X=X.concat(j),X.push(")")):X.push(j),console.log.apply(console,X)}e.logWithColors=T;class z{constructor(O,$){this._outgoingPrefix=O,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,$,F,A,_){this._totalOutgoing+=O,T(this._outgoingPrefix,this._totalOutgoing,O,$,F,A,_)}logIncoming(O,$,F,A,_){this._totalIncoming+=O,T(this._incomingPrefix,this._totalIncoming,O,$,F,A,_)}}e.IPCLogger=z}),define(J[120],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(J[121],Z([0,1,17,5,34]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",m=>w.VSBuffer.wrap(m.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class b extends k.IPCClient{constructor(f,m){const t=new M(f);super(t,m);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=b}),define(J[82],Z([0,1,17,5,2,3,33,34]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function t(){return m||(m=w.VSBuffer.alloc(0)),m}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,l){if(o===0)return t();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return l&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}let p=w.VSBuffer.alloc(o),E=0,D=0;for(;o>0;){const R=this._chunks[D];if(R.byteLength>o){const W=R.slice(0,o);p.set(W,E),E+=o,l&&(this._chunks[D]=R.slice(o),this._totalLength-=o),o-=o}else p.set(R,E),E+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):D++,o-=R.byteLength}return p}}e.ChunkStream=y;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var v;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(o,l,p,E){this.type=o,this.id=l,this.ack=p,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(o){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const p=this._state.messageType,E=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(p,E,D,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=w.VSBuffer.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this._writeSoon(l,o.data)}_bufferAdd(o,l){const p=this._totalLength===0;return this._data.push(o,l),this._totalLength+=o.byteLength+l.byteLength,p}_bufferTake(){const o=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,l){this._bufferAdd(o,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends k.Disposable{constructor(o){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new h(1,0,0,o))}}e.Protocol=S;class u extends n.IPCClient{constructor(o,l,p=null){super(o,l,p);this.protocol=o}static fromSocket(o,l){return new u(new S(o),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=u;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,b.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class a{constructor(o){this.data=o,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],l=0,p=this._first;for(;p;)o[l++]=p.data,p=p.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const l=new a(o);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{constructor(){this.lastRuns=[];const o=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=o-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const o=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let p=0;for(let E=0;E<i._HISTORY_LENGTH;E++)o-this.lastRuns[E]<=l&&p++;return 1-p/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class s{constructor(o,l=null){this._loadEstimator=i.getInstance(),this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new h(5,0,0,t());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const l=new h(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let l=0,p=o.length;l<p;l++)this._socketWriter.write(o[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new h(6,0,0,t())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const l=this._outgoingUnackMsg.toArray();for(let p=0,E=l.length;p<E;p++)this._socketWriter.write(l[p]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new h(1,l,this._incomingAckId,o);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(o){const l=new h(2,0,0,o);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const o=this._outgoingUnackMsg.peek(),l=Date.now()-o.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,t());this._socketWriter.write(o)}}e.PersistentProtocol=s}),define(J[122],Z([0,1,14,17,5,2,34,120]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,y){const I=k.Event.fromNodeEventEmitter(w.ipcMain,y,(h,g)=>({event:h,message:g})),v=k.Event.filter(I,({event:h})=>h.sender.id===t);return k.Event.map(v,({message:h})=>h&&L.VSBuffer.wrap(h))}class m extends b.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const y=k.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:I})=>I);return k.Event.map(y,I=>{const v=I.id,h=m.Clients.get(v);h&&h.dispose();const g=new k.Emitter;m.Clients.set(v,(0,M.toDisposable)(()=>g.fire()));const P=f(v,"vscode:message"),S=k.Event.any(k.Event.signal(f(v,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(I,P),onDidClientDisconnect:S}})}}e.Server=m,m.Clients=new Map}),define(J[83],Z([0,1,14,5,28,121]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class b extends M.Client{constructor(m,t){super({addEventListener:(y,I)=>m.addListener(y,I),removeEventListener:(y,I)=>m.removeListener(y,I),postMessage:y=>m.postMessage(y),start:()=>m.start(),close:()=>m.close()},t)}}e.Client=b;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",m);const t=L.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(I,v)=>({nonce:v,port:I.ports[0]})),{port:y}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,I=>I.nonce===m)));return y}e.connect=n}),define(J[84],Z([0,1,9,5,2,13]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var b;(function(t){t[t.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(b=e.StorageHint||(e.StorageHint={}));var n;(function(t){t[t.None=0]="None",t[t.Initialized=1]="Initialized",t[t.Closed=2]="Closed"})(n||(n={}));class f extends k.Disposable{constructor(y,I=Object.create(null)){super();this.database=y,this.options=I,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((I,v)=>this.accept(v,I)),y.deleted?.forEach(I=>this.accept(I,void 0))}accept(y,I){if(this.state===n.Closed)return;let v=!1;(0,M.isUndefinedOrNull)(I)?v=this.cache.delete(y):this.cache.get(y)!==I&&(this.cache.set(y,I),v=!0),v&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,I){const v=this.cache.get(y);return(0,M.isUndefinedOrNull)(v)?I:v}getBoolean(y,I){const v=this.get(y);return(0,M.isUndefinedOrNull)(v)?I:v==="true"}getNumber(y,I){const v=this.get(y);return(0,M.isUndefinedOrNull)(v)?I:parseInt(v,10)}async set(y,I){if(this.state===n.Closed)return;if((0,M.isUndefinedOrNull)(I))return this.delete(y);const v=String(I);if(this.cache.get(y)!==v)return this.cache.set(y,v),this.pendingInserts.set(y,v),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===n.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((I,v)=>this.items.set(v,I)),y.delete&&y.delete.forEach(I=>this.items.delete(I))}async close(){}}e.InMemoryStorageDatabase=m}),define(J[123],Z([0,1,9,5,37,7,18]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,y=Object.create(null)){this.path=t,this.options=y,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,y=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(v=>y.set(v.key,v.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${y.size} rows`),y}async updateItems(t){const y=await this.whenConnected;return this.doUpdateItems(y,t)}doUpdateItems(t,y){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${y.insert?(0,k.mapToString)(y.insert):"0"}), delete(${y.delete?(0,k.setToString)(y.delete):"0"})`),this.transaction(t,()=>{const I=y.insert,v=y.delete;if(I&&I.size>0){const h=[];h.push([]);let g=0;I.forEach((P,S)=>{let u=h[g];u.length>n.MAX_HOST_PARAMETERS&&(g++,u=[],h.push(u)),u.push(S,P)}),h.forEach(P=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,S=>S.run(P),()=>{const S=[];let u=0;return I.forEach((d,a)=>{S.push(a),u+=d.length}),`Keys: ${S.join(", ")} Length: ${u}`})})}if(v&&v.size){const h=[];h.push([]);let g=0;v.forEach(P=>{let S=h[g];S.length>n.MAX_HOST_PARAMETERS&&(g++,S=[],h.push(S)),S.push(P)}),h.forEach(P=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,S=>S.run(P),()=>{const S=[];return v.forEach(u=>{S.push(u)}),`Keys: ${S.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const y=await this.whenConnected;return this.doClose(y,t)}doClose(t,y){return new Promise((I,v)=>{t.db.close(h=>(h&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${h}`),this.path===n.IN_MEMORY_PATH?I():!t.isErroneous&&!t.isInMemory?this.backup().then(I,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),I())):typeof y=="function"?b.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const P=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:y()}).then(()=>P(),S=>(P(),Promise.reject(S)))})).then(I,v):v(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return b.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const y=await this.whenConnected,I=await this.get(y,t?"PRAGMA integrity_check":"PRAGMA quick_check"),v=t?I.integrity_check:I.quick_check;return y.isErroneous?`${v} (last error: ${y.lastError})`:y.isInMemory?`${v} (in-memory!)`:v}async connect(t,y=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${y})`);try{return await this.doConnect(t)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&y)return await(0,w.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await b.Promises.unlink(t);try{await b.Promises.rename(this.toBackupPath(t),t)}catch(v){}return await this.doConnect(t)}catch(v){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${v}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,y){t.isErroneous=!0,t.lastError=y,this.logger.error(y)}doConnect(t){return new Promise((y,I)=>{new Promise((v,h)=>{H(["@vscode/sqlite3"],v,h)}).then(v=>{const h={db:new(this.logger.isTracing?v.verbose().Database:v.Database)(t,g=>g?h.db?h.db.close(()=>I(g)):I(g):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(h),P=>h.db.close(()=>I(P)))),isInMemory:t===n.IN_MEMORY_PATH};h.db.on("error",g=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&h.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},I)})}exec(t,y){return new Promise((I,v)=>{t.db.exec(y,h=>h?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${h}`),v(h)):I())})}get(t,y){return new Promise((I,v)=>{t.db.get(y,(h,g)=>h?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${h}`),v(h)):I(g))})}all(t,y){return new Promise((I,v)=>{t.db.all(y,(h,g)=>h?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${h}`),v(h)):I(g))})}transaction(t,y){return new Promise((I,v)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),y(),t.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${h}`),v(h)):I())})})}prepare(t,y,I,v){const h=t.db.prepare(y),g=P=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${P} (${y}). Details: ${v()}`)};h.on("error",g),I(h),h.finalize(P=>{P&&g(P),h.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(H,e){return H.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,M=k*24,b=M*7,n=M*30,f=M*365;function m(y,I){typeof y!="number"&&(y=y.getTime());const v=Math.round((new Date().getTime()-y)/1e3);if(v<-30)return(0,w.localize)(0,null,m(new Date().getTime()+v*1e3,!1));if(v<30)return(0,w.localize)(1,null);let h;return v<L?(h=v,I?h===1?(0,w.localize)(2,null,h):(0,w.localize)(3,null,h):h===1?(0,w.localize)(4,null,h):(0,w.localize)(5,null,h)):v<k?(h=Math.floor(v/L),I?h===1?(0,w.localize)(6,null,h):(0,w.localize)(7,null,h):h===1?(0,w.localize)(8,null,h):(0,w.localize)(9,null,h)):v<M?(h=Math.floor(v/k),I?h===1?(0,w.localize)(10,null,h):(0,w.localize)(11,null,h):h===1?(0,w.localize)(12,null,h):(0,w.localize)(13,null,h)):v<b?(h=Math.floor(v/M),I?h===1?(0,w.localize)(14,null,h):(0,w.localize)(15,null,h):h===1?(0,w.localize)(16,null,h):(0,w.localize)(17,null,h)):v<n?(h=Math.floor(v/b),I?h===1?(0,w.localize)(18,null,h):(0,w.localize)(19,null,h):h===1?(0,w.localize)(20,null,h):(0,w.localize)(21,null,h)):v<f?(h=Math.floor(v/n),I?h===1?(0,w.localize)(22,null,h):(0,w.localize)(23,null,h):h===1?(0,w.localize)(24,null,h):(0,w.localize)(25,null,h)):(h=Math.floor(v/f),I?h===1?(0,w.localize)(26,null,h):(0,w.localize)(27,null,h):h===1?(0,w.localize)(28,null,h):(0,w.localize)(29,null,h))}e.fromNow=m;function t(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(J[126],Z([12,11]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,36,13,126]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(m,t){return t&&(m.stack||m.stacktrace)?k.localize(0,null,n(m),b(m.stack)||b(m.stacktrace)):n(m)}function b(m){return Array.isArray(m)?m.join(`
`):m}function n(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?k.localize(1,null,m.message):m.message||k.localize(2,null)}function f(m=null,t=!1){if(!m)return k.localize(3,null);if(Array.isArray(m)){const y=w.coalesce(m),I=f(y[0],t);return y.length>1?k.localize(4,null,I,y.length):I}if(L.isString(m))return m;if(m.detail){const y=m.detail;if(y.error)return M(y.error,t);if(y.exception)return M(y.exception,t)}return m.stack?M(m,t):m.message?m.message:k.localize(5,null)}e.toErrorMessage=f}),define(J[127],Z([12,11]),function(H,e){return H.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(b,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=b,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(b,n,f){if(n.length===0)return null;const m=[];for(let t=0,y=n.length;t<y;t++){const I=n[t],v=f(I);if(v===null)return null;m[t]=k(I,v,this.modifierLabels[b])}return m.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,b,n){if(b===null)return"";const f=[];return M.ctrlKey&&f.push(n.ctrlKey),M.shiftKey&&f.push(n.shiftKey),M.altKey&&f.push(n.altKey),M.metaKey&&f.push(n.metaKey),b!==""&&f.push(b),f.join(n.separator)}}),define(J[129],Z([12,11]),function(H,e){return H.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,41,29,10,44,7,3,33,13,79,18,129]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(a,c){if(n.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const s=w.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],i);return new Promise(r=>{s.once("error",o=>{r({success:!1,error:o})}),s.once("exit",(o,l)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?v(i.status):1})}else if(n.isLinux||n.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(s=>{w.execFile(i,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,o,l)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function g(a=f.env){return a.comspec||"cmd.exe"}e.getWindowsShell=g;class P{constructor(c,i,s,r){if(i!==void 0&&s!==void 0&&r!==void 0)this.cmd=c,this.args=i,this.shell=s,this.options=r;else{const o=c;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(f.env).forEach(l=>{o[l]=f.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(b.sep);return i!==-1&&(c=c.substring(i+1)),P.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(I.localize(0,null))):this.useExec().then(i=>{let s,r;const o=new Promise((l,p)=>{s=l,r=p});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=w.exec(l,this.options,(p,E,D)=>{this.childProcess=null;const R=p;R&&R.killed?r({killed:this.terminateRequested,stdout:E.toString(),stderr:D.toString()}):this.handleExec(s,c,p,E,D)})}else{let l=null;const p=E=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(E,s,c,r);const D={terminated:this.terminateRequested};m.isNumber(E)&&(D.cmdCode=E),s(D)};if(this.shell&&n.isWindows){const E=M.deepClone(this.options);E.windowsVerbatimArguments=!0,E.detached=!1;let D=!1,R=!1;const W=[];let N=this.ensureQuotes(this.cmd);W.push(N.value),D=N.quoted,this.args&&this.args.forEach(x=>{N=this.ensureQuotes(x),W.push(N.value),R=R&&N.quoted});const G=["/s","/c"];D?R?G.push('"'+W.join(" ")+'"'):W.length>1?G.push('"'+W[0]+'" '+W.slice(1).join(" ")):G.push('"'+W[0]+'"'):G.push(W.join(" ")),l=w.spawn(g(),G,E)}else this.cmd&&(l=w.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(m.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",E=>{this.childProcess=null,r({terminated:this.terminateRequested,error:E})}),l.pid&&(this.childProcess.on("close",p),this.handleSpawn(l,s,c,r,!0)))}return o})}handleClose(c,i,s,r){}ensureQuotes(c){return P.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,h(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const i=w.spawn(g(),["/s","/c"]);i.on("error",s=>c(!0)),i.on("exit",s=>c(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class S extends P{constructor(c,i,s,r){super(c,i,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,s,r,o){[r,o].forEach((l,p)=>{const E=new t.LineDecoder;E.write(l).forEach(W=>{i({line:W,source:p===0?0:1})});const R=E.end();R&&i({line:R,source:p===0?0:1})}),c({terminated:this.terminateRequested,error:s})}handleSpawn(c,i,s,r,o){const l=new t.LineDecoder,p=new t.LineDecoder;c.stdout.on("data",E=>{l.write(E).forEach(R=>s({line:R,source:0}))}),c.stderr.on("data",E=>{p.write(E).forEach(R=>s({line:R,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=p}handleClose(c,i,s,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&s({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&s({line:l,source:1})}}e.LineProcess=S;function u(a){let c=[],i=!1;const s=function(r){if(i){c.push(r);return}(!a.send(r,l=>{if(l&&console.error(l),i=!1,c.length>0){const p=c.slice(0);c=[],p.forEach(E=>s(E))}})||n.isWindows)&&(i=!0)};return{send:s}}e.createQueuedSender=u;var d;(function(a){async function c(i,s,r){if(b.isAbsolute(i))return i;if(s===void 0&&(s=f.cwd()),b.dirname(i)!=="."||(r===void 0&&m.isString(f.env.PATH)&&(r=f.env.PATH.split(b.delimiter)),r===void 0||r.length===0))return b.join(s,i);async function l(p){if(await y.Promises.exists(p)){let E;try{E=await y.Promises.stat(p)}catch(D){D.message.startsWith("EACCES")&&(E=await y.Promises.lstat(p))}return E?!E.isDirectory():!1}return!1}for(let p of r){let E;if(b.isAbsolute(p)?E=b.join(p,i):E=b.join(s,p,i),await l(E))return E;let D=E+".com";if(await l(D)||(D=E+".exe",await l(D)))return D}return b.join(s,i)}a.findExecutable=c})(d=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function b(v,h){return v===1?L.isWindows?y():M.getWindowsShell(h):m(v,h)}e.getSystemShell=b;function n(v,h){return v===1?L.isWindows?I(h):M.getWindowsShell(h):m(v,h)}e.getSystemShellSync=n;let f=null;function m(v,h){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=h.SHELL,!g)try{g=(0,w.userInfo)().shell}catch(P){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let t=null;async function y(){return t||(t=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),t}function I(v){if(t)return t;const h=L.isWindows&&parseFloat((0,w.release)())>=10,g=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${v.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?P:M.getWindowsShell(v)}}),define(J[85],Z([0,1,41,9,17,24,109,16,5,2,44,3,68,34]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(S){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch(d){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>k.VSBuffer.wrap(Buffer.from(u,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=h;class g{constructor(S,u){this.modulePath=S,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new L.Delayer(d),this.child=null,this._client=null}getChannel(S){const u=this;return{call(d,a,c){return u.requestPromise(S,d,a,c)},listen(d,a){return u.requestEvent(S,d,a)}}}requestPromise(S,u,d,a=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(S),i=(0,L.createCancelablePromise)(o=>c.call(u,d,o)),s=a.onCancellationRequested(()=>i.cancel()),r=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(S,u,d){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let a;const c=new f.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(S).listen(u,d)(c.fire,c),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),y.isMacintosh&&u.env&&delete u.env.DYLD_LIBRARY_PATH,this.child=(0,w.fork)(this.modulePath,S,u);const d=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,b.isRemoteConsoleLog)(l)){(0,b.log)(l,`IPC Library: ${this.options.serverName}`);return}d.fire(k.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,i=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),s=d.event,r={send:i,onMessage:s};this._client=new v.ChannelClient(r);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,p)=>{process.removeListener("exit",o),this.activeRequests.forEach(E=>(0,m.dispose)(E)),this.activeRequests.clear(),l!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:p})})}return this._client}getCachedChannel(S){let u=this.channels.get(S);return u||(u=this.client.getChannel(S),this.channels.set(S,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(J[131],Z([12,11]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(H,e){return H.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(H,e){return H.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(n,f,m){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(n,f,m){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,m){this.channel.call("attach",[n,f,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,m){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},m])}}e.ExtensionHostDebugChannelClient=M}),define(J[155],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class w{constructor(b){this.driver=b}listen(b,n){throw new Error(`No event found: ${n}`)}call(b,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=w;class L{constructor(b){this.channel=b}click(b,n,f){return this.channel.call("click",[b,n,f])}doubleClick(b){return this.channel.call("doubleClick",b)}setValue(b,n){return this.channel.call("setValue",[b,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(b){return this.channel.call("isActiveElement",b)}getElements(b,n){return this.channel.call("getElements",[b,n])}getElementXY(b,n,f){return this.channel.call("getElementXY",[b,n,f])}typeInEditor(b,n){return this.channel.call("typeInEditor",[b,n])}getTerminalBuffer(b){return this.channel.call("getTerminalBuffer",b)}writeInTerminal(b,n){return this.channel.call("writeInTerminal",[b,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(b){this.channel=b}registerWindowDriver(b){return this.channel.call("registerWindowDriver",b)}reloadWindowDriver(b){return this.channel.call("reloadWindowDriver",b)}}e.WindowDriverRegistryChannelClient=k}),define(J[156],Z([0,1,125,46,10,7,33,15,8]),function(H,e,w,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(h,g,P){this._args=h,this.paths=g,this.productService=P}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",H).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=b.env.VSCODE_PORTABLE;return h?f.URI.file((0,M.join)(h,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,M.resolve)(h):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,M.resolve)(h):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,M.resolve)(h);const g=b.env.VSCODE_EXTENSIONS;if(g)return g;const P=b.env.VSCODE_PORTABLE;return P?(0,M.join)(P,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,M.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,M.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!b.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ce([L.memoize],m.prototype,"appRoot",null),ce([L.memoize],m.prototype,"userHome",null),ce([L.memoize],m.prototype,"userDataPath",null),ce([L.memoize],m.prototype,"appSettingsHome",null),ce([L.memoize],m.prototype,"tmpDir",null),ce([L.memoize],m.prototype,"userRoamingDataHome",null),ce([L.memoize],m.prototype,"settingsResource",null),ce([L.memoize],m.prototype,"userDataSyncHome",null),ce([L.memoize],m.prototype,"userDataSyncLogResource",null),ce([L.memoize],m.prototype,"sync",null),ce([L.memoize],m.prototype,"machineSettingsResource",null),ce([L.memoize],m.prototype,"globalStorageHome",null),ce([L.memoize],m.prototype,"workspaceStorageHome",null),ce([L.memoize],m.prototype,"keybindingsResource",null),ce([L.memoize],m.prototype,"keyboardLayoutResource",null),ce([L.memoize],m.prototype,"argvResource",null),ce([L.memoize],m.prototype,"snippetsHome",null),ce([L.memoize],m.prototype,"isExtensionDevelopment",null),ce([L.memoize],m.prototype,"untitledWorkspacesHome",null),ce([L.memoize],m.prototype,"installSourcePath",null),ce([L.memoize],m.prototype,"builtinExtensionsPath",null),ce([L.memoize],m.prototype,"extensionsPath",null),ce([L.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ce([L.memoize],m.prototype,"extensionDevelopmentKind",null),ce([L.memoize],m.prototype,"extensionTestsLocationURI",null),ce([L.memoize],m.prototype,"debugExtensionHost",null),ce([L.memoize],m.prototype,"serviceMachineIdResource",null),ce([L.memoize],m.prototype,"telemetryLogResource",null),ce([L.memoize],m.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=m;function t(v,h){return I(v["inspect-extensions"],v["inspect-brk-extensions"],5870,h,v.debugId)}e.parseExtensionHostPort=t;function y(v,h){return I(v["inspect-search"],v["inspect-brk-search"],5876,h)}e.parseSearchPort=y;function I(v,h,g,P,S){const d=Number(h||v)||(P?null:g),a=d?Boolean(!!h):!1;return{port:d,break:a,debugId:S}}}),define(J[86],Z([0,1,240,3,134]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const b={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(h,g,P=b){const S={},u=[],d=[];for(let s in g){const r=g[s];r.alias&&(S[s]=r.alias),r.type==="string"||r.type==="string[]"?(u.push(s),r.deprecates&&u.push(r.deprecates)):r.type==="boolean"&&(d.push(s),r.deprecates&&d.push(r.deprecates))}const a=w(h,{string:u,boolean:d,alias:S}),c={},i=a;c._=a._.map(s=>String(s)).filter(s=>s.length>0),delete i._;for(let s in g){const r=g[s];r.alias&&delete i[r.alias];let o=i[s];r.deprecates&&i.hasOwnProperty(r.deprecates)&&(o||(o=i[r.deprecates]),delete i[r.deprecates]),typeof o!="undefined"&&(r.type==="string[]"?o&&!Array.isArray(o)&&(o=[o]):r.type==="string"&&Array.isArray(o)&&(o=o.pop(),P.onMultipleValues(s,o)),c[s]=o),delete i[s]}for(let s in i)P.onUnknownOption(s);return c}e.parseArgs=n;function f(h,g){let P="";return g.args&&(Array.isArray(g.args)?P=` <${g.args.join("> <")}>`:P=` <${g.args}>`),g.alias?`-${g.alias} --${h}${P}`:`--${h}${P}`}function m(h,g){let P=0,S=[];for(const c in h){const i=h[c],s=f(c,i);P=Math.max(P,s.length),S.push([s,i.description])}let u=P+2+1;if(g-u<25)return S.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let d=g-u-1,a=[];for(const c of S){let i=c[0],s=y(c[1],d),r=t(u-i.length-2);a.push("  "+i+r+s[0]);for(let o=1;o<s.length;o++)a.push(t(u)+s[o])}return a}e.formatOptions=m;function t(h){return" ".repeat(h)}function y(h,g){let P=[];for(;h.length;){let S=h.length<g?h.length:h.lastIndexOf(" ",g),u=h.slice(0,S).trim();h=h.slice(S),P.push(u)}return P}function I(h,g,P,S,u=!0){const d=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${h} ${P}`];a.push(""),a.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),a.push(""),u&&(L.isWindows?a.push((0,k.localize)(35,null,g)):a.push((0,k.localize)(36,null,g)),a.push(""));const c={};for(const i in S){const s=S[i];if(s.description&&s.cat){let r=c[s.cat];r||(c[s.cat]=r={}),r[i]=s}}for(let i in c){const s=i;let r=c[s];r&&(a.push(M[s]),a.push(...m(r,d)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=I;function v(h,g){return`${h||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=v}),define(J[157],Z([0,1,59,154,86]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,m){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1],m[2]):super.call(n,f,m)}async openExtensionDevelopmentHostWindow(n,f,m){const t=(0,k.parseArgs)(n,k.OPTIONS);t.debugRenderer=m;const y=t.extensionDevelopmentPath;if(!y)return{success:!1};let I;const v=Object.keys(f);for(let d of v){let a=f[d];a===null||(I||(I=Object.create(null)),I[d]=a)}const[h]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:t,userEnv:I});if(!m)return{success:!0};const g=h.win;if(!g)return{success:!0};const P=g.webContents.debugger;let S=P.isAttached()?Infinity:0;const u=(0,w.createServer)(d=>{S++==0&&P.attach();let a=!1;const c=r=>{a||d.write(JSON.stringify(r)+"\0")},i=(r,o,l,p)=>c({method:o,params:l,sessionId:p});g.on("close",()=>{P.removeListener("message",i),d.end(),a=!0}),P.addListener("message",i);let s=Buffer.alloc(0);d.on("data",r=>{s=Buffer.concat([s,r]);for(let o=s.indexOf(0);o!==-1;o=s.indexOf(0)){let l;try{const p=s.slice(0,o).toString("utf8");s=s.slice(o+1),l=JSON.parse(p)}catch(p){console.error("error reading cdp line",p)}P.sendCommand(l.method,l.params,l.sessionId).then(p=>c({id:l.id,sessionId:l.sessionId,result:p})).catch(p=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:p.message}}))}}),d.on("error",r=>{console.error("error on cdp pipe:",r)}),d.on("close",()=>{a=!0,--S==0&&P.detach()})});return await new Promise(d=>u.listen(0,d)),g.on("close",()=>u.close()),{rendererDebugPort:u.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function H(e,w,L,k){function M(n){const f=b(n),m=[f];return e.isAbsolute(f)||m.unshift(k),e.resolve(...m)}function b(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,L);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(y,"AppData","Roaming")}break;case"darwin":m=e.join(w.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,L)}return{getUserDataPath:M}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,33]),function(e,w,L,k,M,b){const n=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return H(w,L,f.name,b.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),L=require("os");module.exports=H(w,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,156,158]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,k.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=M}),define(J[161],Z([0,1,30,26,7]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(b){const n=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return w.writeFileSync(n,""),b&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){b&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(J[162],Z([0,1,137]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(I){return I=I.trim(),I==="*"||L.test(I)}e.isValidVersionStr=M;function b(I){if(!M(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=I.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=b;function n(I){if(!I)return null;let v=I.majorBase,h=I.majorMustEqual,g=I.minorBase,P=I.minorMustEqual,S=I.patchBase,u=I.patchMustEqual;I.hasCaret&&(v===0||(P=!1),u=!1);let d=0;if(I.preRelease){const a=k.exec(I.preRelease);if(a){const[,c,i,s]=a;d=Date.UTC(Number(c),Number(i)-1,Number(s))}}return{majorBase:v,majorMustEqual:h,minorBase:g,minorMustEqual:P,patchBase:S,patchMustEqual:u,isMinimum:I.hasGreaterEquals,notBefore:d}}e.normalizeVersion=n;function f(I,v,h){let g;typeof I=="string"?g=n(b(I)):g=I;let P;v instanceof Date?P=v.getTime():typeof v=="string"&&(P=new Date(v).getTime());let S;if(typeof h=="string"?S=n(b(h)):S=h,!g||!S)return!1;let u=g.majorBase,d=g.minorBase,a=g.patchBase,c=S.majorBase,i=S.minorBase,s=S.patchBase,r=S.notBefore,o=S.majorMustEqual,l=S.minorMustEqual,p=S.patchMustEqual;return S.isMinimum?u>c?!0:u<c?!1:d>i?!0:d<i||P&&P<r?!1:a>=s:(u===1&&c===0&&(!o||!l||!p)&&(c=1,i=0,s=0,o=!0,l=!1,p=!1),u<c?!1:u>c?!o:d<i?!1:d>i?!l:a<s?!1:a>s?!p:!(P&&P<r))}e.isValidVersion=f;function m(I,v,h,g){return h.isBuiltin||typeof h.main=="undefined"?!0:y(I,v,h.engines.vscode,g)}e.isValidExtensionVersion=m;function t(I,v,h){return I==="*"||y(v,h,I)}e.isEngineValid=t;function y(I,v,h,g=[]){let P=n(b(h));if(!P)return g.push(w.localize(0,null,h)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return g.push(w.localize(1,null,h)),!1}else if(!P.majorMustEqual)return g.push(w.localize(2,null,h)),!1;return f(I,v,P)?!0:(g.push(w.localize(3,null,I,h)),!1)}}),define(J[163],Z([0,1,2,10,34,85]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends w.Disposable{constructor(f,m,t,y){super();this.folders=f,this.onDidFilesChange=m,this.onLogMessage=t,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=b.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b,b.MAX_RESTARTS=5}),define(J[164],Z([0,1,2,10,34,85]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends w.Disposable{constructor(f,m,t,y,I={}){super();this.folders=f,this.onDidFilesChange=m,this.onLogMessage=t,this.verboseLogging=y,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=b.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b,b.MAX_RESTARTS=5}),define(J[165],Z([0,1,41,111,10,79]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class b{constructor(f,m,t,y,I){this.watchedFolder=f,this.eventCallback=t,this.logCallback=y,this.verboseLogging=I,this.restartCounter=0,Array.isArray(m)?this.ignored=m.map(v=>(0,L.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${m.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,w.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",H).fsPath,f);const m=new M.LineDecoder;this.handle.stdout.on("data",t=>{const y=[];for(const I of m.write(t)){const v=I.split("|");if(v.length===2){const h=Number(v[0]),g=v[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(P=>P(g))){this.verboseLogging&&this.log(g);continue}y.push({type:b.changeTypeMap[h],path:g})}else this.log(v[1])}}y.length>0&&this.eventCallback(y)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,y)=>this.onExit(t,y))}onError(f){this.error("process error: "+f.toString())}onExit(f,m){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${m})`),this.restartCounter<=b.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=b,b.MAX_RESTARTS=5,b.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,7,25,165]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(n,f,m,t){this.onDidFilesChange=f,this.onLogMessage=m,this.verboseLogging=t,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(w.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,w.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(J[69],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,M=[],b=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=b}}e.SyncDescriptor=w}),define(J[167],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=w;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let b of this._nodes.values())b.outgoing.size===0&&M.push(b);return M}insertEdge(M,b){const n=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(b);n.outgoing.set(this._hashFn(b),f),f.incoming.set(this._hashFn(M),n)}removeNode(M){const b=this._hashFn(M);this._nodes.delete(b);for(let n of this._nodes.values())n.outgoing.delete(b),n.incoming.delete(b)}lookupOrInsertNode(M){const b=this._hashFn(M);let n=this._nodes.get(b);return n||(n=new w(M),this._nodes.set(b,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[b,n]of this._nodes)M.push(`${b}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,b]of this._nodes){const n=new Set([M]),f=this._findCycle(b,n);if(f)return f}}_findCycle(M,b){for(let[n,f]of M.outgoing){if(b.has(n))return[...b,n].join(" -> ");b.add(n);const m=this._findCycle(f,b);if(m)return m;b.delete(n)}}}e.Graph=L}),define(J[4],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(m){return m[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(w=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(n,f,m,t){f[w.DI_TARGET]===f?f[w.DI_DEPENDENCIES].push({id:n,index:m,optional:t}):(f[w.DI_DEPENDENCIES]=[{id:n,index:m,optional:t}],f[w.DI_TARGET]=f)}function k(n){if(w.serviceIds.has(n))return w.serviceIds.get(n);const f=function(m,t,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,m,y,!1)};return f.toString=()=>n,w.serviceIds.set(n,f),f}e.createDecorator=k;function M(n){return n}e.refineServiceDecorator=M;function b(n){return function(f,m,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,t,!0)}}e.optional=b}),define(J[70],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(J[87],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,b)=>H(["vscode-encrypt"],M,b))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(b){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(b){return M}}}e.EncryptionMainService=L}),define(J[47],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(J[168],Z([0,1,10,136,4]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function M(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=M;var b;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var n;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var f;(function(y){y.Install="install",y.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var m;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class t extends Error{constructor(I,v){super(I);this.code=v,this.name=v}}e.ExtensionManagementError=t,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=w.FileAccess.asBrowserUri("./media/defaultIcon.png",H).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(J[170],Z([0,1,25,4]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=k;function M(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class n{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,I){if(typeof y=="undefined"||y===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof y=="string"||typeof I=="string"){let v=typeof y=="string"?y:y.value,h=typeof I=="string"?I:I.value;return w.equalsIgnoreCase(v,h)}return y._lower===I._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=n;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function m(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=m,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,25,170]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,g){return h.uuid&&g.uuid?h.uuid===g.uuid:h.id===g.id?!0:(0,w.compareIgnoreCase)(h.id,g.id)===0}e.areSameExtensions=k;class M{constructor(g,P){this.version=P,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function b(h,g){return`${h}.${g}`}e.getExtensionId=b;function n(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(h,g){return n(b(h,g))}e.getGalleryExtensionId=f;function m(h,g){const P=[],S=u=>{for(const d of P)if(d.some(a=>k(g(a),g(u))))return d;return null};for(const u of h){const d=S(u);d?d.push(u):P.push([u])}return P}e.groupByExtension=m;function t(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function y(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function I(h){const g=new Set;for(const P of h)P.malicious&&g.add(P.id.id);return g}e.getMaliciousExtensionsSet=I;function v(h,g){const P=[],S=g.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const u=S.shift();if(u&&P.every(d=>!k(d.identifier,{id:u}))){const d=h.filter(a=>k(a.identifier,{id:u}));d.length===1&&(P.push(d[0]),S.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=v}),define(J[88],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(J[172],Z([0,1,41,10,7,3,105,18,68,138,88]),function(H,e,w,L,k,M,b,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=m.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends I{openTerminal(a,c){return this.spawnTerminal(w,a,f.getWindowsShell(),c)}spawnTerminal(a,c,i,s){const r=c.windowsExec||v.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=k.basename(r).toLowerCase();if(o==="cmder"||o==="cmder.exe")return a.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(o==="wt"||o==="wt.exe")&&l.push("-d ."),new Promise((p,E)=>{const D=P(process),R=a.spawn(i,l,{cwd:s,env:D});R.on("error",E),R.on("exit",()=>p())})}runInTerminal(a,c,i,s,r){const o="windowsExec"in r&&r.windowsExec?r.windowsExec:v.getDefaultTerminalWindows();return new Promise((l,p)=>{const E=`"${c} - ${y}"`,D=`""${i.join('" "')}" & pause"`,R=["/c","start",E,"/wait",o,"/c",D],W=Object.assign({},P(process),s);Object.keys(W).filter(x=>W[x]===null).forEach(x=>delete W[x]);const N={cwd:c,env:W,windowsVerbatimArguments:!0};w.spawn(v.CMD,R,N).on("error",x=>{p(S(x))}),l(void 0)})}static getDefaultTerminalWindows(){if(!v._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return v._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=v,v.CMD="cmd.exe";class h extends I{openTerminal(a,c){return this.spawnTerminal(w,a,c)}runInTerminal(a,c,i,s,r){const o=r.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,p)=>{if(o===t.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const E=o===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`,H).fsPath,"-t",a||y,"-w",c];for(let G of i)R.push("-a"),R.push(G);if(s){const G=Object.assign({},P(process),s);for(let x in G){const ne=G[x];ne===null?(R.push("-u"),R.push(x)):(R.push("-e"),R.push(`${x}=${ne}`))}}let W="";const N=w.spawn(h.OSASCRIPT,R);N.on("error",G=>{p(S(G))}),N.stderr.on("data",G=>{W+=G.toString()}),N.on("exit",G=>{if(G===0)l(void 0);else if(W){const x=W.split(`
`,1);p(new Error(x[0]))}else p(new Error(m.localize(1,null,E,G)))})}else p(new Error(m.localize(2,null,o)))})}spawnTerminal(a,c,i){const s=c.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{const l=["-a",s];i&&l.push(i);const p=P(process),E=a.spawn("/usr/bin/open",l,{cwd:i,env:p});E.on("error",o),E.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class g extends I{openTerminal(a,c){return this.spawnTerminal(w,a,c)}runInTerminal(a,c,i,s,r){const o=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,p)=>{let E=[];o.then(D=>{D.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const R=`${u(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;E.push(`''${R}''`);const W=Object.assign({},P(process),s);Object.keys(W).filter(ne=>W[ne]===null).forEach(ne=>delete W[ne]);const N={cwd:c,env:W};let G="";const x=w.spawn(D,E,N);x.on("error",ne=>{p(S(ne))}),x.stderr.on("data",ne=>{G+=ne.toString()}),x.on("exit",ne=>{if(ne===0)l(void 0);else if(G){const V=G.split(`
`,1);p(new Error(V[0]))}else p(new Error(m.localize(4,null,D,ne)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{M.isLinux?await n.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,c,i){const s=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{s.then(l=>{const p=P(process),E=a.spawn(l,[],{cwd:i,env:p});E.on("error",o),E.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=m.localize(3,null);function P(d){const a={...d.env};return(0,b.sanitizeProcessEnvironment)(a),a}function S(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(m.localize(5,null,d.path)):d}function u(d){let a="";for(let c of d)c.indexOf(" ")>=0?a+='"'+c+'"':a+=c,a+=" ";return a}}),define(J[19],Z([0,1,37,7,25,13,8,140,4]),function(H,e,w,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function m(U){return U.create===!0}e.isFileOpenForWriteOptions=m;var t;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var y;(function(U){U[U.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var I;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=v;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function g(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function P(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=P;var S;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(C,T){super(C);this.code=T}}e.FileSystemProviderError=u;function d(U,C){const T=new u(U.toString(),C);return c(T,C),T}e.createFileSystemProviderError=d;function a(U){return U||d((0,n.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=a;function c(U,C){return U.name=C?`${C} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=c;function i(U){if(!U)return S.Unknown;if(U instanceof u)return U.code;const C=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!C)return S.Unknown;switch(C[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=i;function s(U){if(U instanceof D)return U.fileOperationResult;switch(i(U)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor(C,T,z){this.resource=C,this.operation=T,this.target=z}isOperation(C){return this.operation===C}}e.FileOperationEvent=o;var l;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class p{constructor(C,T){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of C)switch(z.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>T)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>T)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>T)),this.deleted.set(z.resource,z);break}}contains(C,...T){return this.doContains(C,{includeChildren:!1},...T)}affects(C,...T){return this.doContains(C,{includeChildren:!0},...T)}doContains(C,T,...z){if(!C)return!1;const B=z.length>0;return!!((!B||z.includes(1))&&(this.added?.get(C)||T.includeChildren&&this.added?.findSuperstr(C))||(!B||z.includes(0))&&(this.updated?.get(C)||T.includeChildren&&this.updated?.findSuperstr(C))||(!B||z.includes(2))&&(this.deleted?.findSubstr(C)||T.includeChildren&&this.deleted?.findSuperstr(C)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function E(U,C,T){return!U||!C||U===C||C.length>U.length?!1:(C.charAt(C.length-1)!==L.sep&&(C+=L.sep),T?(0,k.startsWithIgnoreCase)(U,C):U.indexOf(C)===0)}e.isParent=E;class D extends Error{constructor(C,T,z){super(C);this.fileOperationResult=T,this.options=z}}e.FileOperationError=D;class R extends D{constructor(C,T,z){super(C,2,z);this.stat=T}}e.NotModifiedSinceFileOperationError=R;var W;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=G;async function x(U,C){if(!C.canHandleResource(b.URI.from({scheme:U.scheme})))return new Promise(T=>{const z=C.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===U.scheme&&B.added&&(z.dispose(),T())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(C){return(0,M.isNumber)(C)||(C=0),C<ne.KB?(0,n.localize)(1,null,C.toFixed(0)):C<ne.MB?(0,n.localize)(2,null,(C/ne.KB).toFixed(2)):C<ne.GB?(0,n.localize)(3,null,(C/ne.MB).toFixed(2)):C<ne.TB?(0,n.localize)(4,null,(C/ne.GB).toFixed(2)):(0,n.localize)(5,null,(C/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var V;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function Q(U){return{maxFileSize:U===0?300*ne.MB:16*ne.GB,maxHeapSize:U===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,241,135,86,19]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function b(I,v){const h={onUnknownOption:P=>{console.warn((0,L.localize)(0,null,P))},onMultipleValues:(P,S)=>{console.warn((0,L.localize)(1,null,P,S))}},g=(0,k.parseArgs)(I,k.OPTIONS,v?h:void 0);return g.goto&&g._.forEach(P=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,L.localize)(2,null))),g["max-memory"]&&w(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(I){const v=I.findIndex(h=>!/^-/.test(h));if(v>-1)return[...I.slice(0,v),...I.slice(v+1)]}function f(I){let[,...v]=I;process.env.VSCODE_DEV&&(v=n(v)||[]);const h=!y(process.env);return b(v,h)}e.parseMainProcessArgv=f;function m(I){const[,,...v]=I;return b(v,!0)}e.parseCLIProcessArgv=m;function t(I,...v){const h=I.indexOf("--");return h===-1?I.push(...v):I.splice(h,0,...v),I}e.addArg=t;function y(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),define(J[89],Z([0,1,41,159,24,67,16,3,28,130,54]),function(H,e,w,L,k,M,b,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(h,g,P){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(P)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(P)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),I||(I=new Promise(async S=>{const u=new k.CancellationTokenSource,d=setTimeout(()=>{h.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),u.dispose(!0),S({})},1e4);try{const a=await v(h,u.token);S(a)}catch(a){(0,b.isPromiseCanceledError)(a)||h.error(`[resolve shell env] Unable to resolve shell environment (${a}). Proceeding without shell environment...`),S({})}finally{clearTimeout(d),u.dispose()}})),I)}e.resolveShellEnv=y;let I;async function v(h,g){const P=new Promise(async(S,u)=>{const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",a);const c=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",s);const r=await(0,m.getSystemShell)(n.OS,s);if(h.trace("getUnixShellEnvironment#shell",r),g.isCancellationRequested)return u(b.canceled);const o=L.basename(r);let l,p;/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,p=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,p=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),l);const E=(0,w.spawn)(r,[...p,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(E.kill(),u(b.canceled))),E.on("error",W=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(W)),S({})});const D=[];E.stdout.on("data",W=>D.push(W));const R=[];E.stderr.on("data",W=>R.push(W)),E.on("close",(W,N)=>{const G=Buffer.concat(D).toString("utf8");h.trace("getUnixShellEnvironment#raw",G);const x=Buffer.concat(R).toString("utf8");if(x.trim()&&h.trace("getUnixShellEnvironment#stderr",x),W||N)return u(new Error(`Failed to get environment (code ${W}, signal ${N})`));const ne=i.exec(G),V=ne?ne[1]:"{}";try{const Q=JSON.parse(V);d?Q.ELECTRON_RUN_AS_NODE=d:delete Q.ELECTRON_RUN_AS_NODE,a?Q.ELECTRON_NO_ATTACH_CONSOLE=a:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",Q),S(Q)}catch(Q){h.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(Q)),u(Q)}})});try{return await P}catch(S){return h.error("getUnixShellEnvironment#error",(0,M.toErrorMessage)(S)),{}}}}),define(J[90],Z([0,1,3,8,19]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(m=>({type:m.type,resource:L.URI.file(m.path)}))}e.toFileChanges=M;function b(f){const m=new n;for(const t of f)m.processEvent(t);return m.normalize()}e.normalizeFileChanges=b;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(m){const t=this.mapPathToChange.get(m.path);if(t){const y=t.type,I=m.type;y===1&&I===2?(this.mapPathToChange.delete(m.path),this.normalized.splice(this.normalized.indexOf(t),1)):y===2&&I===1?t.type=0:y===1&&I===0||(t.type=I)}else this.normalized.push(m),this.mapPathToChange.set(m.path,m)}normalize(){const m=[],t=[];return this.normalized.filter(y=>y.type!==2?(m.push(y),!1):!0).sort((y,I)=>y.path.length-I.path.length).filter(y=>t.some(I=>(0,k.isParent)(y.path,I,!w.isLinux))?!1:(t.push(y.path),!0)).concat(m)}}}),define(J[173],Z([0,1,9,2,7,80,18,117,90]),function(H,e,w,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class m extends L.Disposable{constructor(y,I,v,h){super();this.path=y,this.onDidFilesChange=I,this.onLogMessage=v,this.verboseLogging=h,this.fileChangesDelayer=this._register(new w.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:I}=await b.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(I)try{v=await(0,M.realpath)(v)}catch(h){if(this.onError(h),I.dangling)return}y.isDirectory()?this._register((0,n.watchFolder)(v,(h,g)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},h=>this.onError(h))):this._register((0,n.watchFile)(v,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,f.normalizeFileChanges)(I);if(this.verboseLogging)for(const h of v)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=m}),define(J[71],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(let[M,b]of k)this.set(M,b)}set(k,M){const b=this._entries.get(k);return this._entries.set(k,M),b}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(J[174],Z([0,1,9,16,69,167,4,71]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class m extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class t{constructor(h=new n.ServiceCollection,g=!1,P){this._activeInstantiations=new Set,this._services=h,this._strict=g,this._parent=P,this._services.set(b.IInstantiationService,this)}createChild(h){return new t(h,this._strict,this)}invokeFunction(h,...g){let P=I.traceInvocation(h),S=!1;try{return h({get:(d,a)=>{if(S)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(d,P);if(!c&&a!==b.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return c}},...g)}finally{S=!0,P.stop()}}createInstance(h,...g){let P,S;return h instanceof k.SyncDescriptor?(P=I.traceCreation(h.ctor),S=this._createInstance(h.ctor,h.staticArguments.concat(g),P)):(P=I.traceCreation(h),S=this._createInstance(h,g,P)),P.stop(),S}_createInstance(h,g=[],P){let S=b._util.getServiceDependencies(h).sort((a,c)=>a.index-c.index),u=[];for(const a of S){let c=this._getOrCreateServiceInstance(a.id,P);if(!c&&this._strict&&!a.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${a.id}.`);u.push(c)}let d=S.length>0?S[0].index:g.length;if(g.length!==d){console.warn(`[createInstance] First service dependency of ${h.name} at position ${d+1} conflicts with ${g.length} static arguments`);let a=d-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,d)}return new h(...[...g,...u])}_setServiceInstance(h,g){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,g);else if(this._parent)this._parent._setServiceInstance(h,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let g=this._services.get(h);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):g}_getOrCreateServiceInstance(h,g){let P=this._getServiceInstanceOrDescriptor(h);return P instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,P,g.branch(h,!0)):(g.branch(h,!1),P)}_safeCreateAndCacheServiceInstance(h,g,P){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,g,P)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,g,P){const S=new M.Graph(a=>a.id.toString());let u=0;const d=[{id:h,desc:g,_trace:P}];for(;d.length;){const a=d.pop();if(S.lookupOrInsertNode(a),u++>1e3)throw new m(S);for(let c of b._util.getServiceDependencies(a.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(c.id);if(!i&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),i instanceof k.SyncDescriptor){const s={id:c.id,desc:i,_trace:a._trace.branch(c.id,!0)};S.insertEdge(a,s),d.push(s)}}}for(;;){const a=S.roots();if(a.length===0){if(!S.isEmpty())throw new m(S);break}for(const{data:c}of a){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}S.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,g,P=[],S,u){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(g,P,S,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,g,P,S,u);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(h,g=[],P,S){if(P){const u=new w.IdleValue(()=>this._createInstance(h,g,S));return new Proxy(Object.create(null),{get(d,a){if(a in d)return d[a];let c=u.value,i=c[a];return typeof i!="function"||(i=i.bind(c),d[a]=i),i},set(d,a,c){return u.value[a]=c,!0}})}else return this._createInstance(h,g,S)}}e.InstantiationService=t;var y;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(y||(y={}));class I{constructor(h,g){this.type=h,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return f?new I(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(h){return f?new I(0,h.name):I._None}branch(h,g){let P=new I(2,h.toString());return this._dep.push([h,g,P]),P}stop(){let h=Date.now()-this._start;I._totals+=h;let g=!1;function P(u,d){let a=[],c=new Array(u+1).join("	");for(const[i,s,r]of d._dep)if(s&&r){g=!0,a.push(`${c}CREATES -> ${i}`);let o=P(u+1,r);o&&a.push(o)}else a.push(`${c}uses -> ${i}`);return a.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(h>2||g)&&console.log(S.join(`
`))}}I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(J[175],Z([0,1,16,128,57]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,w.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new k.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(J[176],Z([0,1,57,175]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(b,n){super(n,b.parts)}_keyCodeToUILabel(b){if(this._os===2)switch(b){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(b)}_getLabel(b){return b.isDuplicateModifierCase()?"":this._keyCodeToUILabel(b.keyCode)}_getAriaLabel(b){return b.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(b.keyCode)}_keyCodeToElectronAccelerator(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return w.KeyCodeUtils.toString(b)}_getElectronAccelerator(b){return b.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(b.keyCode)}_getUserSettingsLabel(b){if(b.isDuplicateModifierCase())return"";const n=w.KeyCodeUtils.toUserSettingsUS(b.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(b){return k.getDispatchStr(b)}static getDispatchStr(b){if(b.isModifierKey())return null;let n="";return b.ctrlKey&&(n+="ctrl+"),b.shiftKey&&(n+="shift+"),b.altKey&&(n+="alt+"),b.metaKey&&(n+="meta+"),n+=w.KeyCodeUtils.toString(b.keyCode),n}_getSingleModifierDispatchPart(b){return b.keyCode===5&&!b.shiftKey&&!b.altKey&&!b.metaKey?"ctrl":b.keyCode===4&&!b.ctrlKey&&!b.altKey&&!b.metaKey?"shift":b.keyCode===6&&!b.ctrlKey&&!b.shiftKey&&!b.metaKey?"alt":b.keyCode===57&&!b.ctrlKey&&!b.shiftKey&&!b.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(J[177],Z([0,1,9]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,M){if(k.length===0)return Promise.resolve(!1);const b=[];let n=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,w.isThenable)(f)&&b.push(f.then(m=>{m&&(n=!0)},m=>{M(m),n=!0}))}return w.Promises.settled(b).then(()=>n)}e.handleVetos=L}),define(J[6],Z([0,1,67,5,2,3,4]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class m extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class t extends m{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...s]))}debug(i,...s){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...s]))}info(i,...s){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...s]))}warn(i,...s){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...s]))}error(i,...s){if(this.checkLogLevel(f.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([i,...s]))}critical(i,...s){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...s]))}flush(){}format(i){let s="";for(let r=0;r<i.length;r++){let o=i[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(l){}s+=(r>0?" ":"")+o}return s}}e.AbstractMessageLogger=t;class y extends m{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!M.isWindows}trace(i,...s){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}debug(i,...s){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}info(i,...s){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}warn(i,...s){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...s):console.warn(`[main ${n()}]`,i,...s))}error(i,...s){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...s):console.error(`[main ${n()}]`,i,...s))}critical(i,...s){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...s):console.error(`[main ${n()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class I extends m{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=I;class v extends m{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,w.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class h extends m{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const r of this.logServices)r.trace(i,...s)}debug(i,...s){for(const r of this.logServices)r.debug(i,...s)}info(i,...s){for(const r of this.logServices)r.info(i,...s)}warn(i,...s){for(const r of this.logServices)r.warn(i,...s)}error(i,...s){for(const r of this.logServices)r.error(i,...s)}critical(i,...s){for(const r of this.logServices)r.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=h;class g extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=g;class P extends k.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,s?.always?f.Trace:this.logLevel,s),this.loggers.set(i.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class S{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=S;function u(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const i=d(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function d(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=d;function a(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=a});var ee=this&&this.__param||function(H,e){return function(w,L){e(w,L,H)}};define(J[178],Z([0,1,9,17,40,76,47,19,4,6]),function(H,e,w,L,k,M,b,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(I){I.ERROR_INVALID_FILE="ERROR_INVALID_FILE",I.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let y=class{constructor(v,h,g){this.environmentService=v,this.fileService=h,this.logService=g,this.queue=new w.Queue}async updateSettings(v,h){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,v,h))}async doWrite(v,h,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,v.toString(),h);const{value:P,mtime:S,etag:u}=await this.fileService.readFile(v,{atomic:!0});let d=P.toString();const a=[];if((0,k.parse)(d,a,{allowTrailingComma:!0,allowEmptyContent:!0}),a.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(h,d,g)[0];if(c){d=d.substring(0,c.offset)+c.content+d.substring(c.offset+c.length);try{await this.fileService.writeFile(v,L.VSBuffer.fromString(d),{etag:u,mtime:S})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:v,path:h},g,P){return h.length?(0,M.setProperty)(g,h,v,P):[{content:JSON.stringify(v,null,P.insertSpaces&&P.tabSize?" ".repeat(P.tabSize):"	"),length:g.length,offset:0}]}};y=ce([ee(0,b.IEnvironmentService),ee(1,n.IFileService),ee(2,m.ILogService)],y),e.UserConfigurationFileService=y}),define(J[91],Z([0,1,6]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,b){switch(b){case w.LogLevel.Trace:return M.trace;case w.LogLevel.Debug:return M.debug;case w.LogLevel.Info:return M.info;case w.LogLevel.Warning:return M.warn;case w.LogLevel.Error:return M.error;case w.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends w.AbstractLogger{constructor(b=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(b),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(b){this._logger=b;for(const{level:n,args:f}of this.buffer)L(b,n).apply(b,f);this.buffer=[]}_log(b,...n){this._logger?L(this._logger,b).apply(this._logger,n):this.getLevel()<=b&&this.buffer.push({level:b,args:n})}trace(b,...n){this._log(w.LogLevel.Trace,b,...n)}debug(b,...n){this._log(w.LogLevel.Debug,b,...n)}info(b,...n){this._log(w.LogLevel.Info,b,...n)}warn(b,...n){this._log(w.LogLevel.Warning,b,...n)}error(b,...n){this._log(w.LogLevel.Error,b,...n)}critical(b,...n){this._log(w.LogLevel.Critical,b,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(J[179],Z([0,1,9,17,15,19,4,91,6]),function(H,e,w,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*M.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(v,h,g,P,S){super();this.name=v,this.resource=h,this.donotUseFormatters=P,this.fileService=S,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const v=arguments[0];if(v instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=v.stack,this._log(f.LogLevel.Error,this.format(h))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(v,h){this._log(v,this.format(h))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(v){if(v.fileOperationResult!==3)throw v}}_log(v,h){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>m&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=h:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(v)}] ${h}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const v=P=>P<10?`0${P}`:P,h=P=>P<10?`00${P}`:P<100?`0${P}`:P,g=new Date;return`${g.getFullYear()}-${v(g.getMonth()+1)}-${v(g.getDate())} ${v(g.getHours())}:${v(g.getMinutes())}:${v(g.getSeconds())}.${h(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(v){return""}}stringifyLogLevel(v){switch(v){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(v){let h="";for(let g=0;g<v.length;g++){let P=v[g];if(typeof P=="object")try{P=JSON.stringify(P)}catch(S){}h+=(g>0?" ":"")+P}return h}};t=ce([ee(4,M.IFileService)],t),e.FileLogger=t;let y=class extends f.AbstractLoggerService{constructor(v,h,g){super(v.getLevel(),v.onDidChangeLogLevel);this.instantiationService=h,this.fileService=g}doCreateLogger(v,h,g){const P=new n.BufferLogService(h);return(0,M.whenProviderRegistered)(v,this.fileService).then(()=>P.logger=this.instantiationService.createInstance(t,(0,k.basename)(v),v,P.getLevel(),!!g?.donotUseFormatters)),P}};y=ce([ee(0,f.ILogService),ee(1,b.IInstantiationService),ee(2,M.IFileService)],y),e.FileLoggerService=y}),define(J[180],Z([0,1,5,8,6]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(I){this.service=I,this.onDidChangeLogLevel=w.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(I,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=M;class b{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){b.setLevel(this.channel,I)}static setLevel(I,v){return I.call("setLevel",v)}}e.LogLevelChannelClient=b;class n{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,v){throw new Error(`Event not found: ${v}`)}async call(I,v,h){switch(v){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(I,v){this.loggers.set(I.toString(),this.loggerService.createLogger(I,v))}consoleLog(I,v){let h=console.log;switch(I){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(I,v){const h=this.loggers.get(I.toString());if(!h)throw new Error("Create the logger before logging");for(const[g,P]of v)switch(g){case k.LogLevel.Trace:h.trace(P);break;case k.LogLevel.Debug:h.debug(P);break;case k.LogLevel.Info:h.info(P);break;case k.LogLevel.Warning:h.warn(P);break;case k.LogLevel.Error:h.error(P);break;case k.LogLevel.Critical:h.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends k.AbstractLoggerService{constructor(I,v,h){super(I,v);this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(I,v)=>{this.channel.call("consoleLog",[I,v])}})}doCreateLogger(I,v,h){return new m(this.channel,I,v,h)}}e.LoggerChannelClient=f;class m extends k.AbstractMessageLogger{constructor(I,v,h,g){super(g?.always);this.channel=I,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,v){const h=[[I,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(I){this.channel.call("log",[this.file,I])}}class t extends k.LogService{constructor(I,v){super(v);this.parent=I,this._register(I.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=t}),define(J[92],Z([0,1,19,6]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,m,t,y){try{const I=await new Promise((v,h)=>{H(["spdlog"],v,h)});return I.setFlushOn(L.LogLevel.Trace),I.createAsyncRotatingLogger(f,m,t,y)}catch(I){console.error(I)}return null}function M(f,m,t,y){const I=H.__$__nodeRequire("spdlog");return I.setFlushOn(L.LogLevel.Trace),I.createRotatingLogger(f,m,t,y)}e.createRotatingLogger=M;function b(f,m,t){switch(m){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(m,t,y,I){super();this.name=m,this.filepath=t,this.rotating=y,this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){const m=this.rotating?6:1,t=30/m*w.ByteSize.MB;return k(this.name,this.filepath,t,m).then(y=>{if(y){this._logger=y,this._logger.setLevel(this.getLevel());for(const{level:I,message:v}of this.buffer)b(this._logger,I,v);this.buffer=[]}})}log(m,t){this._logger?b(this._logger,m,t):this.getLevel()<=m&&this.buffer.push({level:m,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[181],Z([0,1,10,15,28,19,179,6,92]),function(H,e,w,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends n.AbstractLoggerService{constructor(y,I){super(y.getLevel(),y.onDidChangeLogLevel);this.fileService=I}doCreateLogger(y,I,v){if(y.scheme===w.Schemas.file){const h=new f.SpdLogLogger(v?.name||(0,k.generateUuid)(),y.fsPath,!v?.donotRotate,I);return v?.donotUseFormatters&&h.clearFormatters(),h}else return new b.FileLogger(v?.name??(0,L.basename)(y),y,I,!!v?.donotUseFormatters,this.fileService)}};m=ce([ee(0,n.ILogService),ee(1,M.IFileService)],m),e.LoggerService=m}),define(J[182],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(b){return b.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function L(b){return b.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(b){return b.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(b){return!w(b)&&!L(b)&&!k(b)}e.isMenubarMenuItemAction=M}),define(J[48],Z([0,1,10,3,33,15]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let b;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)b=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof H?.__$__nodeRequire=="function"){const n=(0,M.dirname)(w.FileAccess.asFileUri("",H));b=H.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const f=H.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(b,{nameShort:`${b.nameShort} Dev`,nameLong:`${b.nameLong} Dev`,dataFolderName:`${b.dataFolderName}-dev`}),Object.assign(b,{version:f.version})}else b={},Object.keys(b).length===0&&Object.assign(b,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=b}),define(J[93],Z([0,1,17,16,141,19,48]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(y,I,v,h,g,P){let S;try{await f(y,I,v,h,g,P)}catch(u){S=u}finally{S&&g.errorTransformer&&(S=g.errorTransformer(S)),typeof S!="undefined"&&v.error(S),v.end()}}e.readFileIntoStream=n;async function f(y,I,v,h,g,P){m(P);const S=await y.open(I,{create:!1});try{m(P);let u=0,d=0,a=g&&typeof g.length=="number"?g.length:void 0,c=w.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,s=0;do d=await y.read(S,i,c.buffer,s,c.byteLength-s),i+=d,s+=d,u+=d,typeof a=="number"&&(a-=d),s===c.byteLength&&(await v.write(h(c)),c=w.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),s=0);while(d>0&&(typeof a!="number"||a>0)&&m(P)&&t(u,g));if(s>0){let r=s;typeof a=="number"&&(r=Math.min(s,a)),v.write(h(c.slice(0,r)))}}catch(u){throw(0,M.ensureFileSystemProviderError)(u)}finally{await y.close(S)}}function m(y){if(y.isCancellationRequested)throw(0,L.canceled)();return!0}function t(y,I){if(I?.limits){if(typeof I.limits.memory=="number"&&y>I.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,b.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&y>I.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[183],Z([0,1,36,9,17,24,5,63,2,37,10,72,15,64,139,19,93,6]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class Ve extends f.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new b.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new b.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new b.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new b.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new b.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new b.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!0)))),this.watchedResources=m.TernarySearchTree.forUris(c=>{const i=this.getProvider(c.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(a,c){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:c});const i=new f.DisposableStore;return i.add(c.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(c)))),i.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:a}))),typeof c.onDidErrorOccur=="function"&&i.add(c.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:c}),this.provider.delete(a),(0,f.dispose)(i)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(i){c.push(i)}}),!this.provider.has(a)&&await L.Promises.settled(c)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,c){const i=this.provider.get(a.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return n.Iterable.map(this.provider,([a,c])=>({scheme:a,capabilities:c.capabilities}))}async withProvider(a){if(!(0,I.isAbsolutePath)(a))throw new g.FileOperationError((0,h.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const c=this.provider.get(a.scheme);if(!c){const i=new Error;throw i.name="ENOPRO",i.message=(0,h.localize)(1,null,a.toString()),i}return c}async withReadProvider(a){const c=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c)||(0,g.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const c=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,c){try{return await this.doResolveFile(a,c)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,h.localize)(2,null,this.resourceForError(a)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(a,c){const i=await this.withProvider(a),s=this.isPathCaseSensitive(i),r=c?.resolveTo,o=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,p=await i.stat(a);let E;return this.toFileStat(i,a,p,void 0,!!l,(D,R)=>{if(!E&&(E=m.TernarySearchTree.forUris(()=>!s),E.set(a,!0),r))for(const W of r)E.set(W,!0);return E.get(D.resource)||E.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&o?R===1:!1})}async toFileStat(a,c,i,s,r,o){const{providerExtUri:l}=this.getExtUri(a),p={resource:c,name:l.basename(c),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(p.isDirectory&&o(p,s)){try{const E=await a.readdir(c),D=await L.Promises.settled(E.map(async([R,W])=>{try{const N=l.joinPath(c,R),G=r?await a.stat(N):{type:W};return await this.toFileStat(a,N,G,E.length,r,o)}catch(N){return this.logService.trace(N),null}}));p.children=(0,w.coalesce)(D)}catch(E){this.logService.trace(E),p.children=[]}return p}return p}async resolveAll(a){return L.Promises.settled(a.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(a){const c=await this.withProvider(a);try{return!!await c.stat(a)}catch(i){return!1}}async canCreateFile(a,c){try{await this.doValidateCreateFile(a,c)}catch(i){return i}return!0}async doValidateCreateFile(a,c){if(!c?.overwrite&&await this.exists(a))throw new g.FileOperationError((0,h.localize)(3,null,this.resourceForError(a)),3,c)}async createFile(a,c=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(a,i);const s=await this.writeFile(a,c);return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,s)),s}async writeFile(a,c,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,a,i)||await this.mkdirp(s,r.dirname(a));let l;if((0,g.hasReadWriteCapability)(s)&&!(c instanceof k.VSBuffer))if((0,v.isReadableStream)(c)){const p=await(0,v.peekStream)(c,3);p.ended?l=k.VSBuffer.concat(p.buffer):l=p}else l=(0,v.peekReadable)(c,p=>k.VSBuffer.concat(p),3);else l=c;!(0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(s,a,i,l):await this.doWriteBuffered(s,a,i,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l)}catch(o){throw new g.FileOperationError((0,h.localize)(4,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),i)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,c,i){if(!!i?.unlock&&!(a.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(c)));let r;try{r=await a.stat(c)}catch(o){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,h.localize)(6,null,this.resourceForError(c)),0,i);if(this.throwIfFileIsReadonly(c,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:r.size}))throw new g.FileOperationError((0,h.localize)(7,null),3,i);return r}async readFile(a,c){const i=await this.withReadProvider(a);return c?.atomic?this.doReadFileAtomic(i,a,c):this.doReadFile(i,a,c)}async doReadFileAtomic(a,c,i){return new Promise((s,r)=>{this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(a,c,i);s(o)}catch(o){r(o)}})})}async doReadFile(a,c,i){const s=await this.doReadFileStream(a,c,{...i,preferUnbuffered:!0});return{...s,value:await(0,k.streamToBuffer)(s.value)}}async readFileStream(a,c){const i=await this.withReadProvider(a);return this.doReadFileStream(i,a,c)}async doReadFileStream(a,c,i){const s=new M.CancellationTokenSource,r=this.validateReadFile(c,i).then(l=>l,l=>{throw s.cancel(),l});let o;try{return typeof i?.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasFileReadStreamCapability)(a))||(0,g.hasReadWriteCapability)(a)&&i?.preferUnbuffered?o=this.readFileUnbuffered(a,c,i):(0,g.hasFileReadStreamCapability)(a)?o=this.readFileStreamed(a,c,s.token,i):o=this.readFileBuffered(a,c,s.token,i),{...await r,value:o}}catch(l){o&&await(0,v.consumeStream)(o);const p=(0,h.localize)(8,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(p,l.stat,i):new g.FileOperationError(p,(0,g.toFileOperationResult)(l),i)}}readFileStreamed(a,c,i,s=Object.create(null)){const r=a.readFileStream(c,s,i);return(0,v.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new g.FileOperationError((0,h.localize)(9,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),s)},o=>k.VSBuffer.concat(o))}readFileBuffered(a,c,i,s=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,P.readFileIntoStream)(a,c,r,o=>o,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new g.FileOperationError((0,h.localize)(10,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),s)},i),r}readFileUnbuffered(a,c,i){const s=(0,v.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(c);typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(c,r.byteLength,i),s.end(k.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(a,c){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,h.localize)(11,null,this.resourceForError(a)),0,c);if(typeof c?.etag=="string"&&c.etag!==g.ETAG_DISABLED&&c.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,h.localize)(12,null),i,c);return this.validateReadFileLimits(a,i.size,c),i}validateReadFileLimits(a,c,i){if(i?.limits){let s;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(s=9),typeof i.limits.size=="number"&&c>i.limits.size&&(s=7),typeof s=="number")throw new g.FileOperationError((0,h.localize)(13,null,this.resourceForError(a)),s)}}async canMove(a,c,i){return this.doCanMoveCopy(a,c,"move",i)}async canCopy(a,c,i){return this.doCanMoveCopy(a,c,"copy",i)}async doCanMoveCopy(a,c,i,s){if(a.toString()!==c.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,a,o,c,i,s)}catch(r){return r}return!0}async move(a,c,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=await this.doMoveCopy(s,a,r,c,"move",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,o==="move"?2:3,l)),l}async copy(a,c,i){const s=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=await this.doMoveCopy(s,a,r,c,"copy",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,o==="copy"?3:2,l)),l}async doMoveCopy(a,c,i,s,r,o){if(c.toString()===s.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(a,c,i,s,r,o);if(l&&!p&&o&&await this.del(s,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s)),r==="copy"){if(a===i&&(0,g.hasFileFolderCopyCapability)(a))await a.copy(c,s,{overwrite:o});else{const E=await this.resolve(c);E.isDirectory?await this.doCopyFolder(a,E,i,s):await this.doCopyFile(a,c,i,s)}return r}else return a===i?(await a.rename(c,s,{overwrite:o}),r):(await this.doMoveCopy(a,c,i,s,"copy",o),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(a,c,i,s){if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(a,c,i,s);if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(a,c,i,s);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(a,c,i,s);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(a,c,i,s)}async doCopyFolder(a,c,i,s){await i.mkdir(s),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async r=>{const o=this.getExtUri(i).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),i,o):this.doCopyFile(a,r.resource,i,o)}))}async doValidateMoveCopy(a,c,i,s,r,o){let l=!1;if(a===i){const{providerExtUri:E,isPathCaseSensitive:D}=this.getExtUri(a);if(D||(l=E.isEqual(c,s)),l&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(c),this.resourceForError(s)));if(!l&&E.isEqualOrParent(s,c))throw new Error((0,h.localize)(15,null,this.resourceForError(c),this.resourceForError(s)))}const p=await this.exists(s);if(p&&!l){if(!o)throw new g.FileOperationError((0,h.localize)(16,null,this.resourceForError(c),this.resourceForError(s)),4);if(a===i){const{providerExtUri:E}=this.getExtUri(a);if(E.isEqualOrParent(c,s))throw new Error((0,h.localize)(17,null,this.resourceForError(c),this.resourceForError(s)))}}return{exists:p,isSameResourceWithDifferentPathCase:l}}getExtUri(a){const c=this.isPathCaseSensitive(a);return{providerExtUri:c?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(c,a);const i=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,i)),i}async mkdirp(a,c){const i=[],{providerExtUri:s}=this.getExtUri(a);for(;!s.isEqual(c,s.dirname(c));)try{if(((await a.stat(c)).type&g.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(s.basename(c)),c=s.dirname(c)}for(let r=i.length-1;r>=0;r--){c=s.joinPath(c,i[r]);try{await a.mkdir(c)}catch(o){if((0,g.toFileSystemProviderErrorCode)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,c){try{await this.doValidateDelete(a,c)}catch(i){return i}return!0}async doValidateDelete(a,c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(a)));let r;try{r=await i.stat(a)}catch(l){}if(r)this.throwIfFileIsReadonly(a,r);else throw new g.FileOperationError((0,h.localize)(20,null,this.resourceForError(a)),1);if(!!!c?.recursive){const l=await this.resolve(a);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(a)))}return i}async del(a,c){const i=await this.doValidateDelete(a,c),s=!!c?.useTrash,r=!!c?.recursive;await i.delete(a,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new g.FileOperationEvent(a,1))}onDidChangeFile(a,c){this._onDidChangeFilesRaw.fire({changes:a});let i,s;{for(const r of a)this.watchedResources.has(r.resource)?(i||(i=[]),i.push(r)):(s||(s=[]),s.push(r));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!c))}if(s){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,c={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let s=!1,r=()=>{s=!0};i.add((0,f.toDisposable)(()=>r())),this.doWatch(a,c).then(o=>{s?(0,f.dispose)(o):r=()=>(0,f.dispose)(o)},o=>this.logService.error(o))}return c.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),i.add((0,f.toDisposable)(()=>{const s=this.watchedResources.get(a);typeof s=="number"&&(s<=1?this.watchedResources.delete(a):this.watchedResources.set(a,s-1))}))),i}async doWatch(a,c){const i=await this.withProvider(a),s=this.toWatchKey(i,a,c),r=this.activeWatchers.get(s)||{count:0,disposable:i.watch(a,c)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(a,c,i){const{providerExtUri:s}=this.getExtUri(a);return[s.getComparisonKey(c),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,f.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,c,i,s){return this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,v.isReadableStream)(s)||(0,v.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(a,r,s):await this.doWriteReadableBufferedQueued(a,r,s)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,c,i){let s=0,r;if((0,v.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(a,c,o,o.byteLength,s,0),s+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise(async(o,l)=>{(0,v.listenStream)(r,{onData:async p=>{r.pause();try{await this.doWriteBuffer(a,c,p,p.byteLength,s,0)}catch(E){return l(E)}s+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>l(p),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(a,c,i){let s=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(a,c,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(a,c,i,s,r,o){let l=0;for(;l<s;)l+=await a.write(c,r+l,i.buffer,o+l,s-l)}async doWriteUnbuffered(a,c,i,s){return this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,c,i,s))}async doWriteUnbufferedQueued(a,c,i,s){let r;s instanceof k.VSBuffer?r=s:(0,v.isReadableStream)(s)?r=await(0,k.streamToBuffer)(s):(0,v.isReadableBufferedStream)(s)?r=await(0,k.bufferedStreamToBuffer)(s):r=(0,k.readableToBuffer)(s),await a.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(a,c,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,c,i,s))}async doPipeBufferedQueued(a,c,i,s){let r,o;try{r=await a.open(c,{create:!1}),o=await i.open(s,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,E=0,D=0;do D=await a.read(r,p,l.buffer,E,l.byteLength-E),await this.doWriteBuffer(i,o,l,D,p,E),p+=D,E+=D,E===l.byteLength&&(E=0);while(D>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(a,c,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,c,i,s))}async doPipeUnbufferedQueued(a,c,i,s){return i.writeFile(s,await a.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,c,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,c,i,s))}async doPipeUnbufferedToBufferedQueued(a,c,i,s){const r=await i.open(s,{create:!0,unlock:!1});try{const o=await a.readFile(c);await this.doWriteBuffer(i,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(a,c,i,s){const r=await(0,k.streamToBuffer)(this.readFileBuffered(a,c,M.CancellationToken.None));await this.doWriteUnbuffered(i,s,void 0,r)}throwIfFileSystemIsReadonly(a,c){if(a.capabilities&2048)throw new g.FileOperationError((0,h.localize)(22,null,this.resourceForError(c)),6);return a}throwIfFileIsReadonly(a,c){if((c.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,h.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===t.Schemas.file?a.fsPath:a.toString(!0)}};u.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},u=ce([ee(0,S.ILogService)],u),e.FileService=u}),define(J[184],Z([0,1,36,9,17,5,29,2,7,3,15,64,18,142,19,93,173,163,164,90,166,6]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class i extends n.Disposable{constructor(r,o){super();this.logService=r,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,m.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:o,symbolicLink:l}=await I.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(o,l),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(r){try{const o=await I.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(o.map(async p=>{try{let E;p.isSymbolicLink()?E=(await this.stat((0,t.joinPath)(r,p.name))).type:E=this.toType(p),l.push([p.name,E])}catch(E){this.logService.trace(E)}})),l}catch(o){throw this.toFileSystemProviderError(o)}}toType(r,o){let l;return o?.dangling?l=h.FileType.Unknown:r.isFile()?l=h.FileType.File:r.isDirectory()?l=h.FileType.Directory:l=h.FileType.Unknown,o&&(l|=h.FileType.SymbolicLink),l}async readFile(r){try{const o=this.toFilePath(r);return await I.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(r,o,l){const p=(0,y.newWriteableStream)(E=>k.VSBuffer.concat(E.map(D=>k.VSBuffer.wrap(D))).buffer);return(0,g.readFileIntoStream)(this,r,p,E=>E.buffer,{...o,bufferSize:this.BUFFER_SIZE},l),p}async writeFile(r,o,l){let p;try{const E=this.toFilePath(r);if(!l.create||!l.overwrite){if(await I.Promises.exists(E)){if(!l.overwrite)throw(0,h.createFileSystemProviderError)((0,v.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,h.createFileSystemProviderError)((0,v.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(p,0,o,0,o.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(r,E)}finally{typeof p=="number"&&await this.close(p)}}async open(r,o){try{const l=this.toFilePath(r);if((0,h.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:D}=await I.SymlinkSupport.stat(l);D.mode&128||await I.Promises.chmod(l,D.mode|128)}catch(D){this.logService.trace(D)}let p;if((0,h.isFileOpenForWriteOptions)(o)){if(m.isWindows)try{await I.Promises.truncate(l,0),p="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}p||(p="w")}else p="r";const E=await I.Promises.open(l,p);return this.mapHandleToPos.set(E,0),(0,h.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(E,r),E}catch(l){throw(0,h.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await I.Promises.fdatasync(r)}catch(o){this.canFlush=!1,this.logService.error(o)}return await I.Promises.close(r)}catch(o){throw this.toFileSystemProviderError(o)}}async read(r,o,l,p,E){const D=this.normalizePos(r,o);let R=null;try{const W=await I.Promises.read(r,l,p,E,D);return typeof W=="number"?R=W:R=W.bytesRead,R}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(r,D,R)}}normalizePos(r,o){return o===this.mapHandleToPos.get(r)?null:o}updatePos(r,o,l){const p=this.mapHandleToPos.get(r);typeof p=="number"&&(typeof o=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,p+l):this.mapHandleToPos.delete(r)))}async write(r,o,l,p,E){return(0,L.retry)(()=>this.doWrite(r,o,l,p,E),100,3)}async doWrite(r,o,l,p,E){const D=this.normalizePos(r,o);let R=null;try{const W=await I.Promises.write(r,l,p,E,D);return typeof W=="number"?R=W:R=W.bytesWritten,R}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),W)}finally{this.updatePos(r,D,R)}}async mkdir(r){try{await I.Promises.mkdir(this.toFilePath(r))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(r,o){try{const l=this.toFilePath(r);await this.doDelete(l,o)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(r,o){o.recursive?await I.Promises.rm(r,I.RimRafMode.MOVE):await I.Promises.unlink(r)}async rename(r,o,l){const p=this.toFilePath(r),E=this.toFilePath(o);if(p!==E)try{await this.validateTargetDeleted(r,o,"move",l.overwrite),await I.Promises.move(p,E)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,v.localize)(2,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(E)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(r,o,l){const p=this.toFilePath(r),E=this.toFilePath(o);if(p!==E)try{await this.validateTargetDeleted(r,o,"copy",l.overwrite),await I.Promises.copy(p,E,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,v.localize)(3,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(E)),D.toString()))),this.toFileSystemProviderError(D)}}async validateTargetDeleted(r,o,l,p){const E=this.toFilePath(r),D=this.toFilePath(o);let R=!1;if(!!(this.capabilities&1024)||(R=(0,b.isEqual)(E,D,!0)),R&&l==="copy")throw(0,h.createFileSystemProviderError)((0,v.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!R&&await I.Promises.exists(D)){if(!p)throw(0,h.createFileSystemProviderError)((0,v.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(r,o){return o.recursive?this.watchRecursive(r,o.excludes):this.watchNonRecursive(r)}watchRecursive(r,o){const l={path:this.toFilePath(r),excludes:o},p=(0,w.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,o;this.options?.watcher?.usePolling?(r=u.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?m.isWindows?r=a.FileWatcher:r=u.FileWatcher:r=S.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,d.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===c.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(r){const o=new P.FileWatcher(this.toFilePath(r),p=>this._onDidChangeFile.fire((0,d.toFileChanges)(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===c.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,n.combinedDisposable)(o,l)}toFilePath(r){return(0,f.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof h.FileSystemProviderError)return r;let o;switch(r.code){case"ENOENT":o=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=h.FileSystemProviderErrorCode.NoPermissions;break;default:o=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(r,o)}async toFileSystemProviderWriteError(r,o){let l=this.toFileSystemProviderError(o);if(r&&l.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await I.SymlinkSupport.stat(this.toFilePath(r));p.mode&128||(l=(0,h.createFileSystemProviderError)(o,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return l}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=i}),define(J[20],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService")}),define(J[185],Z([0,1,58,6,20]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(f);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,y]=m;let I=this.trustedExtensionUrlPublicKeys.get(n);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[n],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...I])}const v=Buffer.from(decodeURIComponent(y),"base64");if(v.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const h=v.slice(0,6),g=v.readUIntBE(0,6),P=Date.now()-g;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const S=v.slice(6),u=w.createVerify("SHA256");u.write(h),u.write(Buffer.from(t)),u.end();for(let d=0;d<I.length;d++){let a=I[d];if(a!==null){if(typeof a=="string")try{a=w.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),I[d]=a}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${n}:`,c),I[d]=null;continue}if(u.verify(a,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=ce([ee(0,k.IProductService),ee(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(J[55],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(J[186],Z([0,1,14,2,37,10,3,15,8,28,47,6]),function(H,e,w,L,k,M,b,n,f,m,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends L.Disposable{constructor(h,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!b.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(h.appRoot)),this.addValidFileRoot(f.URI.file(h.extensionsPath)),this.addValidFileRoot(h.globalStorageHome),this.addValidFileRoot(h.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:h}=w.session;h.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,P)=>this.handleResourceRequest(g,P)),h.protocol.interceptFileProtocol(M.Schemas.file,(g,P)=>this.handleFileRequest(g,P)),this._register((0,L.toDisposable)(()=>{h.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(h){return this.validRoots.get(h)?L.Disposable.None:(this.validRoots.set(h,!0),(0,L.toDisposable)(()=>this.validRoots.delete(h)))}handleFileRequest(h,g){const P=f.URI.parse(h.url);return this.logService.error(`Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${h.url})`),g({error:-3})}handleResourceRequest(h,g){const P=f.URI.parse(h.url),S=M.FileAccess.asFileUri(P);return this.validRoots.findSubstr(S)?g({path:S.fsPath}):this.validExtensions.has((0,n.extname)(S))?g({path:S.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),g({error:-3}))}createIPCObjectUrl(){let h;const g=f.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),P=g.toString(),S=async()=>h;return w.ipcMain.handle(P,S),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:g,update:u=>h=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),w.ipcMain.removeHandler(P)}}}};I=ce([ee(0,t.INativeEnvironmentService),ee(1,y.ILogService)],I),e.ProtocolMainService=I}),define(J[38],Z([0,1,102,13]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(b,n){w.ok(L.isString(b)),w.ok(L.isObject(n)),w.ok(!this.data.has(b),"There is already an extension with this id"),this.data.set(b,n)}knows(b){return this.data.has(b)}as(b){return this.data.get(b)||null}}e.Registry=new k}),define(J[187],Z([0,1,5,38]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,m){this.schemasById[k(f)]=m,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const b=new M;L.Registry.add(e.Extensions.JSONContribution,b)}),define(J[49],Z([0,1,5,13,132,187,38]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var n;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(n=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=b.Registry.as(M.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new w.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new w.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,d=!0){this.registerConfigurations([u],d)}registerConfigurations(u,d=!0){const a=[];u.forEach(c=>{a.push(...this.validateAndRegisterProperties(c,d,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(u){const d=[],a=c=>{if(c.properties)for(const i in c.properties)d.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,c.properties[i]);c.allOf&&c.allOf.forEach(i=>a(i))};for(const c of u){a(c);const i=this.configurationContributors.indexOf(c);i!==-1&&this.configurationContributors.splice(i,1)}m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(u){const d=[],a=[];for(const c of u)for(const i in c)if(d.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...c[i]};const s={type:"object",default:this.defaultValues[i],description:k.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};a.push(I(i)),this.configurationProperties[i]=s,this.defaultLanguageConfigurationOverridesNode.properties[i]=s}else{this.defaultValues[i]=c[i];const s=this.configurationProperties[i];s&&(this.updatePropertyDefaultValue(i,s),this.updateSchema(i,s))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(u){const d=[];for(const a of u)for(const c in a)if(d.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const i=this.configurationProperties[c];i&&(this.updatePropertyDefaultValue(c,i),this.updateSchema(c,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const d of u)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(u,d=!0,a,c=3){c=L.isUndefinedOrNull(u.scope)?c:u.scope;let i=[],s=u.properties;if(s)for(let o in s){if(d&&g(o)){delete s[o];continue}const l=s[o];if(this.updatePropertyDefaultValue(o,l),e.OVERRIDE_PROPERTY_PATTERN.test(o)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?c:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(o):l.restricted),s[o].hasOwnProperty("included")&&!s[o].included){this.excludedConfigurationProperties[o]=s[o],delete s[o];continue}else this.configurationProperties[o]=s[o];!s[o].deprecationMessage&&s[o].markdownDeprecationMessage&&(s[o].deprecationMessage=s[o].markdownDeprecationMessage),i.push(o)}let r=u.allOf;if(r)for(let o of r)i.push(...this.validateAndRegisterProperties(o,d,a,c));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const d=a=>{let c=a.properties;if(c)for(const s in c)this.updateSchema(s,c[s]);let i=a.allOf;i&&i.forEach(d)};d(u)}updateSchema(u,d){switch(e.allSettings.properties[u]=d,d.scope){case 1:e.applicationSettings.properties[u]=d;break;case 2:e.machineSettings.properties[u]=d;break;case 6:e.machineOverridableSettings.properties[u]=d;break;case 3:e.windowSettings.properties[u]=d;break;case 4:e.resourceSettings.properties[u]=d;break;case 5:e.resourceSettings.properties[u]=d,this.resourceLanguageSettingsSchema.properties[u]=d;break}}removeFromSchema(u,d){switch(delete e.allSettings.properties[u],d.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const d=`[${u}]`,a={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,a),e.allSettings.properties[d]=a,e.applicationSettings.properties[d]=a,e.machineSettings.properties[d]=a,e.machineOverridableSettings.properties[d]=a,e.windowSettings.properties[d]=a,e.resourceSettings.properties[d]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,d){let a=this.defaultValues[u];L.isUndefined(a)&&(a=d.default),L.isUndefined(a)&&(a=v(d.type)),d.default=a}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function I(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=I;function v(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const h=new t;b.Registry.add(e.Extensions.Configuration,h);function g(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?k.localize(5,null,S):h.getConfigurationProperties()[S]!==void 0?k.localize(6,null,S):null:k.localize(4,null)}e.validateProperty=g;function P(){const S=[],u=h.getConfigurationProperties();for(const d of Object.keys(u))S.push([d,u[d].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=P}),define(J[21],Z([0,1,44,13,8,49,4,38]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function f(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof k.URI)}e.isConfigurationOverrides=f;var m;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(m=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function y(s,r){const o=r?s?r.keys.filter(N=>s.keys.indexOf(N)===-1):[...r.keys]:[],l=s?r?s.keys.filter(N=>r.keys.indexOf(N)===-1):[...s.keys]:[],p=[];if(r&&s){for(const N of s.keys)if(r.keys.indexOf(N)!==-1){const G=S(s.contents,N),x=S(r.contents,N);w.equals(G,x)||p.push(N)}}const E=[],D=N=>{const G={};for(const x of N)for(const ne of x.identifiers)G[c(ne)]=x;return G},R=r?D(r.overrides):{},W=s?D(s.overrides):{};if(Object.keys(R).length)for(const N of o){const G=R[N];G&&E.push([(0,M.overrideIdentifierFromKey)(N),G.keys])}if(Object.keys(W).length)for(const N of l){const G=W[N];G&&E.push([(0,M.overrideIdentifierFromKey)(N),G.keys])}if(Object.keys(R).length&&Object.keys(W).length)for(const N of p){const G=W[N],x=R[N];if(G&&x){const ne=y({contents:G.contents,keys:G.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});E.push([(0,M.overrideIdentifierFromKey)(N),[...ne.added,...ne.removed,...ne.updated]])}}return{added:o,removed:l,updated:p,overrides:E}}e.compare=y;function I(s,r){const o=[];for(const l of Object.keys(s))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const p={};for(const E in s[l])p[E]=s[l][E];o.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(p),contents:v(p,r)})}return o}e.toOverrides=I;function v(s,r){const o=Object.create(null);for(let l in s)h(o,l,s[l],r);return o}e.toValuesTree=v;function h(s,r,o,l){const p=r.split("."),E=p.pop();let D=s;for(let R=0;R<p.length;R++){let W=p[R],N=D[W];switch(typeof N){case"undefined":N=D[W]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${p.slice(0,R+1).join(".")} is ${JSON.stringify(N)}`);return}D=N}if(typeof D=="object"&&D!==null)try{D[E]=o}catch(R){l(`Ignoring ${r} as ${p.join(".")} is ${JSON.stringify(D)}`)}else l(`Ignoring ${r} as ${p.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=h;function g(s,r){const o=r.split(".");P(s,o)}e.removeFromValueTree=g;function P(s,r){const o=r.shift();if(r.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const l=s[o];typeof l=="object"&&!Array.isArray(l)&&(P(l,r),Object.keys(l).length===0&&delete s[o])}}function S(s,r,o){function l(D,R){let W=D;for(const N of R){if(typeof W!="object"||W===null)return;W=W[N]}return W}const p=r.split("."),E=l(s,p);return typeof E=="undefined"?o:E}e.getConfigurationValue=S;function u(s,r,o){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in s?L.isObject(s[l])&&L.isObject(r[l])?u(s[l],r[l],o):o&&(s[l]=r[l]):s[l]=r[l])})}e.merge=u;function d(){const s=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=d;function a(){const s=Object.create(null),r=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let o in r){let l=r[o].default;h(s,o,l,p=>console.error(`Conflict in default settings: ${p}`))}return s}e.getDefaultValues=a;function c(s){return`[${s}]`}e.keyFromOverrideIdentifier=c;function i(s,r,o){const l=s.inspect(r),p=s.inspect(o);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:l.defaultValue}e.getMigratedSettingValue=i}),define(J[188],Z([0,1,36,5,40,2,37,44,13,8,21,49,38]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(i={},s=[],r=[]){this._contents=i,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const r=this.getContentsForOverrideIdentifer(s);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.keys;return[]}override(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const o of w.distinct([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[o],p=s[o];p&&(typeof l=="object"&&typeof p=="object"?(l=n.deepClone(l),this.mergeContents(l,p)):l=p),r[o]=l}return new v(r,this.keys,this.overrides)}merge(...i){const s=n.deepClone(this.contents),r=n.deepClone(this.overrides),o=[...this.keys];for(const l of i){this.mergeContents(s,l.contents);for(const p of l.overrides){const[E]=r.filter(D=>w.equals(D.identifiers,p.identifiers));E?this.mergeContents(E.contents,p.contents):r.push(n.deepClone(p))}for(const p of l.keys)o.indexOf(p)===-1&&o.push(p)}return new v(s,o,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,s){for(const r of Object.keys(s)){if(r in i&&f.isObject(i[r])&&f.isObject(s[r])){this.mergeContents(i[r],s[r]);continue}i[r]=n.deepClone(s[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,t.addToValueTree)(this.contents,i,s,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let r=0;r<s;r++)i.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=v;class h extends v{constructor(){const i=(0,t.getDefaultValues)(),s=(0,t.getConfigurationKeys)(),r=[];for(const o of Object.keys(i))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&r.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,s,r)}}e.DefaultConfigurationModel=h;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!f.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:r,keys:o,overrides:l,restricted:p}=this.doParseRaw(i,s);this._configurationModel=new v(r,o,l),this._restrictedConfigurations=p||[]}doParseContent(i){let s={},r=null,o=[],l=[],p=[];function E(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}let D={onObjectBegin:()=>{let R={};E(R),l.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let R=[];E(R),l.push(o),o=R,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:E,onError:(R,W,N)=>{p.push({error:R,offset:W,length:N})}};if(i)try{k.visit(i,D),s=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(i,s){const r=I.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,s);i=o.raw;const l=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),p=Object.keys(i),E=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:l,keys:p,overrides:E,restricted:o.restricted}}filter(i,s,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const l={},p=[];for(let E in i)if(y.OVERRIDE_PROPERTY_PATTERN.test(E)&&r){const D=this.filter(i[E],s,!1,o);l[E]=D.raw,p.push(...D.restricted)}else{const D=s[E],R=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&p.push(E),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&(o.skipRestricted&&D?.restricted||(l[E]=i[E]))}return{raw:l,restricted:p}}}e.ConfigurationModelParser=g;class P extends M.Disposable{constructor(i,s,r,o){super();this.userSettingsResource=i,this.scopes=s,this.fileService=o,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class S{constructor(i,s,r=new v,o=new v,l=new b.ResourceMap,p=new v,E=new b.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=p,this._memoryConfigurationByResource=E,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new b.ResourceMap,this._userConfiguration=null}getValue(i,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(i)}updateValue(i,s,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new v,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(i):o.setValue(i,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,r){const o=this.getConsolidateConfigurationModel(s,r),l=this.getFolderConfigurationModelForResource(s.resource,r),p=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,E=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),W=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),N=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,G=l?s.overrideIdentifier?l.freeze().override(s.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,x=s.overrideIdentifier?p.override(s.overrideIdentifier).getValue(i):p.getValue(i),ne=o.getValue(i),V=w.distinct(w.flatten(o.overrides.map(Q=>Q.identifiers))).filter(Q=>o.getOverrideValue(i,Q)!==void 0);return{defaultValue:E,userValue:D,userLocalValue:R,userRemoteValue:W,workspaceValue:N,workspaceFolderValue:G,memoryValue:x,value:ne,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:W!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:l?.freeze().getValue(i),override:s.overrideIdentifier?l?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:p.getValue(i),override:s.overrideIdentifier?p.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const r=s.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const l=(0,y.overrideIdentifierFromKey)(o),p=this._defaultConfiguration.getKeysForOverrideIdentifier(l),E=i.getKeysForOverrideIdentifier(l),D=[...E.filter(R=>p.indexOf(R)===-1),...p.filter(R=>E.indexOf(R)===-1),...p.filter(R=>!n.equals(this._defaultConfiguration.override(l).getValue(R),i.override(l).getValue(R)))];return[l,D]});return this.updateDefaultConfiguration(i),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:r,removed:o,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),p=[...s,...r,...o];return p.length&&this.updateLocalUserConfiguration(i),{keys:p,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:r,removed:o,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let p=[...s,...r,...o];return p.length&&this.updateRemoteUserConfiguration(i),{keys:p,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:r,removed:o,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let p=[...s,...r,...o];return p.length&&this.updateWorkspaceConfiguration(i),{keys:p,overrides:l}}compareAndUpdateFolderConfiguration(i,s){const r=this.folderConfigurations.get(i),{added:o,updated:l,removed:p,overrides:E}=(0,t.compare)(r,s);let D=[...o,...l,...p];return(D.length||!r)&&this.updateFolderConfiguration(i,s),{keys:D,overrides:E}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:l,overrides:p}=(0,t.compare)(s,void 0);return{keys:[...r,...o,...l],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let r=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const o=s.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const l=this._memoryConfigurationByResource.get(i);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(s=r.merge(o),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=r}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const r=s.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:r,overrides:o,keys:l}=this._folderConfigurations.get(s);return i.push([s,{contents:r,overrides:o,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((p,E)=>(p.set(m.URI.revive(E[0]),this.parseConfigurationModel(E[1])),p),new b.ResourceMap);return new S(s,r,new v,o,l,new v,new b.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=S;function u(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,s=new Map;for(const o of c)o.keys.forEach(l=>i.add(l)),o.overrides.forEach(([l,p])=>{const E=(0,b.getOrSet)(s,l,new Set);p.forEach(D=>E.add(D))});const r=[];return s.forEach((o,l)=>r.push([l,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=u;class d{constructor(i,s,r,o){this.change=i,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(E=>l.add(E)),i.overrides.forEach(([,E])=>E.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const p=new v;this.affectedKeys.forEach(E=>p.setValue(E,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!n.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let r=(0,t.toValuesTree)({[s]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(i=i[o],!i)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=d;class a extends d{constructor(i,s,r,o){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=a}),define(J[189],Z([0,1,9,5,2,15,21,188,49,38]),function(H,e,w,L,k,M,b,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends k.Disposable{constructor(I,v){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,v)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,v){const h=typeof I=="string"?I:void 0,g=(0,b.isConfigurationOverrides)(I)?I:(0,b.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,g,void 0)}updateValue(I,v,h,g){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(h,v,1)}onDidDefaultConfigurationChange(I){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,I);this.trigger(h,v,6)}trigger(I,v,h){const g=new n.ConfigurationChangeEvent(I,{data:v},this.configuration);g.source=h,g.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(J[190],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(b,n=L.Unknown,f){super(b);this._message=b,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(b){return b instanceof k&&b._code===L.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof k&&b._code===L.NoResolverFound}static isHandled(b){return b instanceof k&&b.isHandled}}e.RemoteAuthorityResolverError=k}),define(J[191],Z([0,1,9,17,24,16,5,2,28,82,190]),function(H,e,w,L,k,M,b,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var I;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function v(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(F){const A=new k.CancellationTokenSource;return setTimeout(()=>A.cancel(),F),A.token}function g(F,A){if(F.isCancellationRequested||A.isCancellationRequested)return k.CancellationToken.Cancelled;const _=new k.CancellationTokenSource;return F.onCancellationRequested(()=>_.cancel()),A.onCancellationRequested(()=>_.cancel()),_.token}class P{constructor(A){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((_,j)=>{this._resolvePromise=_,this._rejectPromise=j}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function S(F,A){const _=new P(A);return _.registerDisposable(F.onControlMessage(j=>{const Y=JSON.parse(j.toString()),q=T(Y);q?_.reject(q):_.resolve(Y)})),_.promise}function u(F,A,_,j,Y,q){const X=new P(q);return A.connect(_,j,Y,(ie,se)=>{X.didTimeout?(ie&&F.error(ie),se?.dispose()):ie||!se?X.reject(ie):X.resolve(se)}),X.promise}function d(F,A){const _=new P(A);return F.then(j=>{_.didTimeout||_.resolve(j)},j=>{_.didTimeout||_.reject(j)}),_.promise}async function a(F,A,_,j){const Y=O(F,A);F.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let q;try{q=await u(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,j)}catch(ae){throw F.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),F.logService.error(ae),ae}F.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let X,ie;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(q,null),X=F.reconnectionProtocol,ie=!1):(X=new m.PersistentProtocol(q,null),ie=!0),F.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:F.connectionToken||"00000000000000000000"};X.sendControl(L.VSBuffer.fromString(JSON.stringify(se)));try{const ae=await S(X,g(j,h(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const le=new Error("Unexpected handshake message");throw le.code="VSCODE_CONNECTION_ERROR",le}F.logService.trace(`${Y} 4/6. received SignRequest control message.`);const ue=await d(F.signService.sign(ae.data),j),re={type:"connectionType",commit:F.commit,signedData:ue,desiredConnectionType:A};return _&&(re.args=_),F.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(L.VSBuffer.fromString(JSON.stringify(re))),{protocol:X,ownsProtocol:ie}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(F.logService.error(`${Y} the handshake timed out. Error:`),F.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${Y} received error control message when negotiating connection. Error:`),F.logService.error(ae)),ie&&C(X),ae}}async function c(F,A,_,j){const Y=Date.now(),q=O(F,A),{protocol:X,ownsProtocol:ie}=await a(F,A,_,j),se=new P(j);return se.registerDisposable(X.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),re=T(ue);re?(F.logService.error(`${q} received error control message when negotiating connection. Error:`),F.logService.error(re),ie&&C(X),se.reject(re)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${$(Y)}!`),se.resolve({protocol:X,firstMessage:ue}))})),se.promise}async function i(F,A){const{protocol:_}=await c(F,1,void 0,A);return{protocol:_}}async function s(F,A,_){const{protocol:j,firstMessage:Y}=await c(F,2,A,_),q=Y&&Y.debugPort;return{protocol:j,debugPort:q}}async function r(F,A,_){const j=Date.now(),Y=O(F,3),{protocol:q}=await a(F,3,A,_);return F.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${$(j)}!`),q}async function o(F,A,_){const{host:j,port:Y,connectionToken:q}=await F.addressProvider.getAddress();return{commit:F.commit,host:j,port:Y,connectionToken:q,reconnectionToken:A,reconnectionProtocol:_,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function l(F,A,_){try{const j=(0,f.generateUuid)(),Y=await o(F,j,null),{protocol:q}=await i(Y,k.CancellationToken.None);return new Q(F,A,_,j,q)}catch(j){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(j),V.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(j)),j}}e.connectRemoteAgentManagement=l;async function p(F,A){try{const _=(0,f.generateUuid)(),j=await o(F,_,null),{protocol:Y,debugPort:q}=await s(j,A,k.CancellationToken.None);return new U(F,A,_,Y,q)}catch(_){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(_),V.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=p;async function E(F,A){const _=await o(F,(0,f.generateUuid)(),null);return await r(_,{port:A},k.CancellationToken.None)}e.connectRemoteAgentTunnel=E;function D(F){return(0,w.createCancelablePromise)(A=>new Promise((_,j)=>{const Y=setTimeout(_,F*1e3);A.onCancellationRequested(()=>{clearTimeout(Y),_()})}))}var R;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class W{constructor(A,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=W;class N{constructor(A,_,j,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=_,this.durationSeconds=j,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=N;class G{constructor(A,_,j){this.reconnectionToken=A,this.millisSinceLastIncomingData=_,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=G;class x{constructor(A,_,j){this.reconnectionToken=A,this.millisSinceLastIncomingData=_,this.attempt=j,this.type=4}}e.ConnectionGainEvent=x;class ne{constructor(A,_,j,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=_,this.attempt=j,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class V extends n.Disposable{constructor(A,_,j,Y){super();this._connectionType=A,this._onDidStateChange=this._register(new b.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=j,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(q=>{const X=B(this._connectionType,this.reconnectionToken,!0);q?q.type===0?(this._options.logService.info(`${X} received socket close event (hadError: ${q.hadError}).`),q.error&&this._options.logService.error(q.error)):(this._options.logService.info(`${X} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this._options.logService.error(q.event)):this._options.logService.info(`${X} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const q=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${q} received socket timeout event.`),this._beginReconnecting()})),V._instances.push(this),V._permanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(A,_,j){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=_,this._permanentFailureHandled=j,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(V._permanentFailure)return;const A=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const Y=j<_.length?_[j]:_[_.length-1];try{if(Y>0){const X=D(Y);this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,X)),this._options.logService.info(`${A} waiting for ${Y} seconds before reconnecting...`);try{await X}catch{}}if(V._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this._options.logService.info(`${A} resolving connection...`);const q=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,h(y)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,M.isPromiseCanceledError)(q)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,t.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!V._permanentFailure)}_gotoPermanentFailure(A,_,j){this._onDidStateChange.fire(new ne(this.reconnectionToken,A,_,j)),C(this.protocol)}}V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class Q extends V{constructor(A,_,j,Y,q){super(1,A,Y,q);this.client=this._register(new m.Client(q,{remoteAuthority:_,clientId:j},A.ipcLogger))}async _reconnect(A,_){await i(A,_)}}e.ManagementPersistentConnection=Q;class U extends V{constructor(A,_,j,Y,q){super(2,A,j,Y);this._startArguments=_,this.debugPort=q}async _reconnect(A,_){await s(A,this._startArguments,_)}}e.ExtensionHostPersistentConnection=U;function C(F){try{F.acceptDisconnect();const A=F.getSocket();F.dispose(),A.dispose()}catch(A){(0,M.onUnexpectedError)(A)}}function T(F){if(F&&F.type==="error"){const A=new Error(`Connection error: ${F.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function z(F,A){for(;F.length<A;)F+=" ";return F}function B(F,A,_){return`[remote-connection][${z(v(F),13)}][${A.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function O(F,A){return`${B(A,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function $(F){return`${Date.now()-F} ms`}}),define(J[73],Z([0,1,10]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=L;function k(m){if(!m)return;const t=m.indexOf("+");return t<0?m:m.substr(0,t)}e.getRemoteName=k;function M(m){return m.scheme!==w.Schemas.file&&m.scheme!==w.Schemas.vscodeRemote}e.isVirtualResource=M;function b(m){if(m.folders.length)return m.folders.every(t=>M(t.uri))?m.folders[0].uri:void 0;if(m.configuration&&M(m.configuration))return m.configuration}e.getVirtualWorkspaceLocation=b;function n(m){return b(m)?.scheme}e.getVirtualWorkspaceScheme=n;function f(m){return b(m)!==void 0}e.isVirtualWorkspace=f}),define(J[94],Z([0,1,5,3,4,6]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var b;(function(v){v.Http="http",v.Https="https"})(b=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=m,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function t(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=t;function y(v,h){return h?h!==1&&v<1024:!L.isWindows&&v<1024}e.isPortPrivileged=y;let I=class{constructor(h){this.logService=h,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,g){return this._tunnelProvider=h,h?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async h=>{const g=[],P=Array.from(this._tunnels.values());for(let S of P){const u=Array.from(S.values());for(let d of u){const a=await d.value;a&&g.push(a)}}h(g)})}async dispose(){for(const h of this._tunnels.values()){for(const{value:g}of h.values())await g.then(P=>P?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,g,P,S,u=!1,d=!1,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${P} on local port ${S}.`),!h)return;g||(g="localhost");const c=this.retainOrCreateTunnel(h,g,P,S,u,d,a);return c?c.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,public:h.public,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const g=this._tunnels.get(h.tunnelRemoteHost);if(g){const P=g.get(h.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,P))}}}}async tryDisposeTunnel(h,g,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${g}.`);const S=P.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(g),S}}async closeTunnel(h,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${g} `);const P=this._tunnels.get(h);if(P&&P.has(g)){const S=P.get(g);S.refcount=0,await this.tryDisposeTunnel(h,g,S)}}addTunnelToMap(h,g,P){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(g,{refcount:1,value:P})}async removeEmptyTunnelFromMap(h,g){const P=this._tunnels.get(h);P&&(await P.get(g)||P.delete(g),P.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,g){let P=[h];m(h)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):t(h)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const S=P.map(u=>this._tunnels.get(u));for(const u of S){const d=u?.get(g);if(d)return d}}canTunnel(h){return!!f(h)}createWithProvider(h,g,P,S,u,d,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${P} on local port ${S}.`);const i={elevationRequired:u?y(S===void 0?P:S):!1},s={remoteAddress:{host:g,port:P},localAddressPort:S,public:d,protocol:a},r=h.forwardPort(s,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,P,r),r}};I=ce([ee(0,M.ILogService)],I),e.AbstractTunnelService=I}),define(J[50],Z([0,1,17,146,49,4,38]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=n;function f(h){return h.res.statusCode===204}async function m(h){if(!n(h))throw new Error("Server returned "+h.res.statusCode);return f(h)?null:(await(0,w.streamToBuffer)(h.stream)).toString()}e.asText=m;async function t(h){if(!n(h))throw new Error("Server returned "+h.res.statusCode);if(f(h))return null;const P=(await(0,w.streamToBuffer)(h.stream)).toString();try{return JSON.parse(P)}catch(S){throw S.message+=`:
`+P,S}}e.asJson=t;function y(h){v(h)}e.updateProxyConfigurationsScope=y;let I;function v(h){const g=b.Registry.as(k.Extensions.Configuration);I&&g.deregisterConfigurations([I]),I={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.registerConfiguration(I)}v(2)}),define(J[192],Z([0,1,193,13]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(b,n){return b.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:b.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(b,n,f={}){const m=(0,w.parse)(b),t=f.proxyUrl||k(m,n);if(!t)return null;const y=(0,w.parse)(t);if(!/^https?:$/.test(y.protocol||""))return null;const I={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((v,h)=>{H(["http-proxy-agent"],v,h)}))(I):new(await new Promise((v,h)=>{H(["https-proxy-agent"],v,h)}))(I)}e.getProxyAgent=M}),define(J[194],Z([0,1,17,28]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,b,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await b.readFile(M.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(m){f=null}if(!f){f=(0,L.generateUuid)();try{await b.writeFile(M.serviceMachineIdResource,w.VSBuffer.fromString(f))}catch(m){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(J[74],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[195],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{vsda(){return new Promise((k,M)=>H(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),b=new M.signer;if(b)return b.sign(k)}catch(M){}return k}}e.SignService=w}),define(J[39],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(J[22],Z([0,1,14,9,5,2,3,33,13,4,177,6,39]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var v;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let h=class lt extends M.Disposable{constructor(P,S){super();this.logService=P,this.stateMainService=S,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),b.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};w.app.addListener("before-quit",P);const S=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!b.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",S),w.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",P),w.app.removeListener("window-all-closed",S),w.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(S){P.push(S)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(P)}catch(S){this.logService.error(S)}try{await this.stateMainService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const S=this.phaseWhen.get(this._phase);S&&(S.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let S=this.phaseWhen.get(P);S||(S=new L.Barrier,this.phaseWhen.set(P,S)),await S.wait()}registerWindow(P){const S=new M.DisposableStore;this.windowCounter++,S.add(P.onWillLoad(d=>this._onWillLoadWindow.fire({window:P,workspace:d.workspace,reason:d.reason})));const u=(0,f.assertIsDefined)(P.win);u.on("close",d=>{const a=P.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),d.preventDefault(),this.unload(P,1).then(c=>{if(c){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(P),P.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,S.dispose(),this.windowCounter===0&&(!b.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,S){await this.unload(P,3)||P.reload(S)}async unload(P,S){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const u=this._quitRequested?2:S;let d=await this.onBeforeUnloadWindowInRenderer(P,u);return d?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(d)):(d=await this.onBeforeUnloadWindowInMain(P,u),d?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(d)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,u),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,S){return new Promise(u=>{const d=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${d}`,c=`vscode:cancel${d}`;w.ipcMain.once(a,()=>{u(!1)}),w.ipcMain.once(c,()=>{u(!0)}),P.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:c,reason:S})})}onBeforeUnloadWindowInMain(P,S){const u=[];return this._onBeforeUnloadWindow.fire({reason:S,window:P,veto(d){u.push(d)}}),(0,t.handleVetos)(u,d=>this.logService.error(d))}onWillUnloadWindowInRenderer(P,S){return new Promise(u=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(a,()=>u()),P.send("vscode:onWillUnload",{replyChannel:a,reason:S})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(S=>{this.pendingQuitPromiseResolve=S,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const S=process.argv.slice(1);if(P?.addArgs&&S.push(...P.addArgs),P?.removeArgs)for(const a of P.removeArgs){const c=S.indexOf(a);c>=0&&S.splice(c,1)}const u=()=>{try{if(b.isWindows){const a=(0,n.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:S})};w.app.once("quit",u),await this.quit(!0)&&w.app.removeListener("quit",u)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const S of w.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let u;S.webContents&&!S.webContents.isDestroyed()?u=new Promise(d=>S.once("closed",d)):u=Promise.resolve(),S.destroy(),await u}})()]),w.app.exit(P)}};h.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",h=ce([ee(0,y.ILogService),ee(1,I.IStateMainService)],h),e.LifecycleMainService=h}),define(J[196],Z([0,1,5,2,4,22]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let b=class extends L.Disposable{constructor(m){super();this._onDidChangeKeyboardLayout=this._register(new w.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((t,y)=>{H(["native-keymap"],t,y)});this._keyboardLayoutData=n(m),m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};b=ce([ee(0,M.ILifecycleMainService)],b),e.KeyboardLayoutMainService=b;function n(f){const m=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:t}}}),define(J[95],Z([0,1,9,5,2,13,84,4]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var y;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class I extends k.Disposable{constructor(P={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,S){S===f?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:S,target:this.getKeyTargets(P)[S]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,S,u){return this.getStorage(S)?.get(P,u)}getBoolean(P,S,u){return this.getStorage(S)?.getBoolean(P,u)}getNumber(P,S,u){return this.getStorage(S)?.getNumber(P,u)}store(P,S,u,d){if((0,M.isUndefinedOrNull)(S)){this.remove(P,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,u,d),this.getStorage(u)?.set(P,S)})}remove(P,S){this.withPausedEmitters(()=>{this.updateKeyTarget(P,S,void 0),this.getStorage(S)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,S){const u=[],d=this.getKeyTargets(P);for(const a of Object.keys(d))d[a]===S&&u.push(a);return u}updateKeyTarget(P,S,u){const d=this.getKeyTargets(S);typeof u=="number"?d[P]!==u&&(d[P]=u,this.getStorage(S)?.set(f,JSON.stringify(d))):typeof d[P]=="number"&&(delete d[P],this.getStorage(S)?.set(f,JSON.stringify(d)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const S=this.get(f,P);if(S)try{return JSON.parse(S)}catch(u){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(P=m.NONE){this._onWillSaveState.fire({reason:P}),await w.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return h(P,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=I,I.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends I{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=v;async function h(g,P,S,u){const d=l=>{try{return JSON.parse(l)}catch(p){return l}},a=new Map,c=new Map;g.forEach((l,p)=>{a.set(p,l),c.set(p,d(l))});const i=new Map,s=new Map;P.forEach((l,p)=>{i.set(p,l),s.set(p,d(l))}),console.group(`Storage: Global (path: ${S})`);let r=[];a.forEach((l,p)=>{r.push({key:p,value:l})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${u})`);let o=[];i.forEach((l,p)=>{o.push({key:p,value:l})}),console.table(o),console.groupEnd(),console.log(s)}e.logStorage=h}),define(J[197],Z([0,1,3,33,8,28]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function b(m){if(w.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function n(m,t,y,I,v,h,g,P,S,u){const d=Object.create(null);d["common.machineId"]=g,d.sessionID=(0,M.generateUuid)()+Date.now(),d.commitHash=v,d.version=h,d["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,w.PlatformToString)(w.platform),d["common.nodePlatform"]=L.platform,d["common.nodeArch"]=I,d["common.product"]=u||"desktop";const a=f(P||[]);a&&(d["common.msftInternal"]=a);let c=0;const i=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),w.isLinuxSnap&&(d["common.snap"]="true");const s=b(y);s&&(d["common.platformDetail"]=s);try{const r=await m.readFile(k.URI.file(S));d["common.source"]=r.value.toString().slice(0,30)}catch(r){}return d}e.resolveCommonProperties=n;function f(m){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const y=t.toLowerCase();return m.some(I=>y===I)}e.verifyMicrosoftInternalDomain=f}),define(J[32],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[198],Z([0,1,26,63,40,10,7,3,8,66,18,81,70,19,20,32]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(c,i){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,o=new Map,l=2e4;function p(R,W,N,G){const x=W.substring(R.length+1);return new Promise(async ne=>{let V;try{V=await t.Promises.readdir(W,{withFileTypes:!0})}catch(C){ne();return}if(G.count>=l){G.count+=V.length,G.maxReached=!0,ne();return}let Q=V.length;if(Q===0){ne();return}let U=V;G.count+V.length>l&&(G.maxReached=!0,Q=l-G.count,U=V.slice(0,Q)),G.count+=V.length;for(const C of U)if(C.isDirectory()){if(N.includes(C.name)||await p(R,(0,b.join)(W,C.name),N,G),--Q==0){ne();return}}else{const T=C.name.lastIndexOf(".");if(T>=0){const z=C.name.substring(T+1);z&&r.set(z,(r.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(x)!==!1&&z.filePattern.test(C.name)&&o.set(z.tag,(o.get(z.tag)??0)+1);if(--Q==0){ne();return}}})}const E={count:0,maxReached:!1};await p(c,c,i,E);const D=await d(c);return{configFiles:S(o),fileTypes:S(r),fileCount:E.count,maxFilesReached:E.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=P;function S(c){return[...L.Iterable.map(c.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function u(){const c={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},i=w.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=u;async function d(c){try{const i=new Map,s=(0,b.join)(c,".vscode","launch.json"),r=await t.Promises.readFile(s),o=[],l=(0,k.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const p of l.configurations){const E=p.type;E&&(i.has(E)?i.set(E,i.get(E)+1):i.set(E,1))}return S(i)}catch(i){return[]}}e.collectLaunchConfigs=d;let a=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const r=w.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(w.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||s.push(`Load (avg):       ${w.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,y.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[o,l]=r,p=this.formatProcessList(i,o);return s.forEach(E=>{if((0,I.isRemoteDiagnosticError)(E))p+=`
${E.errorMessage}`,l+=`
${E.errorMessage}`;else if(p+=`

Remote: ${E.hostName}`,E.processes&&(p+=`
${this.formatProcessList(i,E.processes)}`),E.workspaceMetadata){l+=`
|  Remote: ${E.hostName}`;for(const D of Object.keys(E.workspaceMetadata)){const R=E.workspaceMetadata[D];let W=`${R.fileCount} files`;R.maxFilesReached&&(W=`more than ${W}`),l+=`|    Folder (${D}): ${W}`,l+=this.formatWorkspaceStats(R)}}}),{processInfo:p,workspaceInfo:l}})}async getSystemInfo(i,s){const{memory:r,vmHint:o,os:l,cpus:p}=u(),E={os:l,memory:r,cpus:p,vmHint:o,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return n.isWindows||(E.load=`${w.loadavg().map(D=>Math.round(D)).join(", ")}`),n.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(i,s){const r=[];return(0,y.listProcesses)(i.mainPID).then(async o=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,o)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),s.forEach(l=>{if((0,I.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const p of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[p];let D=`${E.fileCount} files`;E.maxFilesReached&&(D=`more than ${D}`),r.push(`Folder (${p}): ${D}`),r.push(this.formatWorkspaceStats(E))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const s=[],r=60;let o=0;const l=(R,W)=>{const N=` ${R}(${W})`;o+N.length>r?(s.push(p),p="|                 ",o=p.length):o+=N.length,p+=N};let p="|      File types:";const E=10;let D=i.fileTypes.length>E?E:i.fileTypes.length;for(let R=0;R<D;R++){const W=i.fileTypes[R];l(W.name,W.count)}if(s.push(p),i.configFiles.length>=0&&(p="|      Conf files:",o=0,i.configFiles.forEach(R=>{l(R.name,R.count)}),s.push(p)),i.launchConfigFiles.length>0){let R="|      Launch Configs:";i.launchConfigFiles.forEach(W=>{R+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(R)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],r=[];return i.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const p=f.URI.revive(l);if(p.scheme===M.Schemas.file){const E=p.fsPath;r.push(P(E,["node_modules",".git"]).then(D=>{let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),s.push(`|    Folder (${(0,b.basename)(E)}): ${R}`),s.push(this.formatWorkspaceStats(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${E} (${D.toString()})`)}))}else s.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(i,s){const r=new Map;i.windows.forEach(l=>r.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,r,o,s,0),o.join(`
`)}formatProcessItem(i,s,r,o,l){const p=l===0;let E;p?E=o.pid===i?`${this.productService.applicationName} main`:"remote agent":(E=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(E=`${E} (${s.get(o.pid)})`));const D=process.platform==="win32"?o.mem:w.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(D/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(o.children)&&o.children.forEach(R=>this.formatProcessItem(i,s,r,R,l+1))}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const r=f.URI.revive(s);if(r.scheme!==M.Schemas.file)continue;const o=r.fsPath;try{const l=await P(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})}),l.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})}),l.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};a=ce([ee(0,g.ITelemetryService),ee(1,h.IProductService)],a),e.DiagnosticsService=a}),define(J[199],Z([0,1,24,16,44,3,47,168,171,162,19,4,6,20,50,194,95,32]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished"})(u||(u={}));function d(...C){return String(C.reduce((T,z)=>T|z,0))}var a;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},r={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class o{constructor(T=r){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,z=this.state.pageSize){return new o({...this.state,pageNumber:T,pageSize:z})}withFilter(T,...z){const B=[...this.state.criteria,...z.length?z.map(O=>({filterType:T,value:O})):[{filterType:T}]];return new o({...this.state,criteria:B})}withSortBy(T){return new o({...this.state,sortBy:T})}withSortOrder(T){return new o({...this.state,sortOrder:T})}withFlags(...T){return new o({...this.state,flags:T.reduce((z,B)=>z|B,0)})}withAssetTypes(...T){return new o({...this.state,assetTypes:T})}get raw(){const{criteria:T,pageNumber:z,pageSize:B,sortBy:O,sortOrder:$,flags:F,assetTypes:A}=this.state;return{filters:[{criteria:T,pageNumber:z,pageSize:B,sortBy:O,sortOrder:$}],assetTypes:A,flags:F}}get searchText(){const T=this.state.criteria.filter(z=>z.filterType===a.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(C,T){const z=(C||[]).filter(B=>B.statisticName===T)[0];return z?z.value:0}function p(C){const T="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(B=>B.assetType.indexOf(T)===0).reduce((B,O)=>{const $=W(C,O.assetType);return $&&B.push([O.assetType.substring(T.length),$]),B},[])}function E(C){if(C.properties){const T=C.properties.filter(O=>O.key===c.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=T.filter(O=>z.test(O.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return W(C,c.Repository)}function D(C){return{uri:`${C.fallbackAssetUri}/${c.VSIX}?redirect=true`,fallbackUri:`${C.fallbackAssetUri}/${c.VSIX}`}}function R(C){const T=W(C,c.Icon);if(T)return T;const z=n.DefaultIconPath;return{uri:z,fallbackUri:z}}function W(C,T){return C.files.filter(B=>B.assetType===T)[0]?{uri:`${C.assetUri}/${T}`,fallbackUri:`${C.fallbackAssetUri}/${T}`}:null}function N(C,T){const z=C.properties?C.properties.filter(O=>O.key===T):[],B=z.length>0&&z[0].value;return B?B.split(",").map(O=>(0,f.adoptToGalleryExtensionId)(O)):[]}function G(C){const T=C.properties?C.properties.filter(z=>z.key===i.Engine):[];return T.length>0&&T[0].value||""}function x(C){const T=C.properties?C.properties.filter(B=>B.key===i.LocalizedLanguages):[],z=T.length>0&&T[0].value||"";return z?z.split(","):[]}function ne(C){return C.indexOf("preview")!==-1}function V(C,T,z,B,O){const $={manifest:W(T,c.Manifest),readme:W(T,c.Details),changelog:W(T,c.Changelog),license:W(T,c.License),repository:E(T),download:D(T),icon:R(T),coreTranslations:p(T)};return{identifier:{id:(0,f.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:T.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,description:C.shortDescription||"",installCount:l(C.statistics,"install"),rating:l(C.statistics,"averagerating"),ratingCount:l(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),webExtension:!!C.tags?.includes(n.WEB_EXTENSION_TAG),assets:$,properties:{dependencies:N(T,i.Dependency),extensionPack:N(T,i.ExtensionPack),engine:G(T),localizedLanguages:x(T)},telemetryData:{index:(B.pageNumber-1)*B.pageSize+z,querySource:O},preview:ne(C.flags)}}let Q=class{constructor(T,z,B,O,$,F,A){this.requestService=T,this.logService=z,this.environmentService=B,this.telemetryService=O,this.fileService=$,this.productService=F;const _=F.extensionsGallery;this.extensionsGalleryUrl=_&&_.serviceUrl,this.extensionsControlUrl=_&&_.controlUrl,this.commonHeadersPromise=U(F.version,this.environmentService,this.fileService,A)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,z){const B=[];let{total:O,firstPage:$,getPage:F}=await this.query({names:T,pageSize:T.length},z);B.push(...$);for(let A=1;B.length<O&&($=await F(A,z),$.length);A++)B.push(...$);return B}async getCompatibleExtension(T,z){return this.getCompatibleExtensionByEngine(T,z)}async getCompatibleExtensionByEngine(T,z){const B=(0,n.isIExtensionIdentifier)(T)?null:T;if(B&&B.properties.engine&&(0,m.isEngineValid)(B.properties.engine,this.productService.version,this.productService.date))return B;const{id:O,uuid:$}=B?B.identifier:T;let F=new o().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");$?F=F.withFilter(a.ExtensionId,$):F=F.withFilter(a.ExtensionName,O);const{galleryExtensions:A}=await this.queryGallery(F,w.CancellationToken.None),[_]=A;if(!_||!_.versions.length)return null;if(z){const Y=_.versions.filter(q=>q.version===z)[0];if(Y){const q=V(_,Y,0,F);if(q.properties.engine&&(0,m.isEngineValid)(q.properties.engine,this.productService.version,this.productService.date))return q}return null}const j=await this.getLastValidExtensionVersion(_,_.versions);return j?V(_,j,0,F):null}async query(T,z){const B=w.CancellationToken.isCancellationToken(T)?{}:T,O=w.CancellationToken.isCancellationToken(T)?T:z;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let $=B.text||"";const F=(0,k.getOrDefault)(B,X=>X.pageSize,50);let A=new o().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,F).withFilter(a.Target,"Microsoft.VisualStudio.Code");$?($=$.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(X,ie,se)=>(A=A.withFilter(a.Category,se||ie),"")),$=$.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(X,ie,se)=>(A=A.withFilter(a.Tag,se||ie),"")),$=$.replace(/\bfeatured(\s+|\b|$)/g,()=>(A=A.withFilter(a.Featured),"")),$=$.trim(),$&&($=$.length<200?$:$.substring(0,200),A=A.withFilter(a.SearchText,$)),A=A.withSortBy(0)):B.ids?A=A.withFilter(a.ExtensionId,...B.ids):B.names?A=A.withFilter(a.ExtensionName,...B.names):A=A.withSortBy(4),typeof B.sortBy=="number"&&(A=A.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(A=A.withSortOrder(B.sortOrder));const{galleryExtensions:_,total:j}=await this.queryGallery(A,O),Y=_.map((X,ie)=>V(X,X.versions[0],ie,A,B.source)),q=async(X,ie)=>{if(ie.isCancellationRequested)throw(0,L.canceled)();const se=A.withPage(X+1),{galleryExtensions:ae}=await this.queryGallery(se,ie);return ae.map((ue,re)=>V(ue,ue.versions[0],re,se,B.source))};return{firstPage:Y,total:j,pageSize:A.pageSize,getPage:q}}async queryGallery(T,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,u.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,d(u.Unpublished));const B=await this.commonHeadersPromise,O=JSON.stringify(T.raw),$={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(O.length)},F=new Date().getTime();let A,_,j=0;try{if(A=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:O,headers:$},z),A.res.statusCode&&A.res.statusCode>=400&&A.res.statusCode<500)return{galleryExtensions:[],total:j};const Y=await(0,h.asJson)(A);if(Y){const q=Y.results[0],X=q.extensions,ie=q.resultMetadata&&q.resultMetadata.filter(se=>se.metadataType==="ResultCount")[0];return j=ie&&ie.metadataItems.filter(se=>se.name==="TotalCount")[0].count||0,{galleryExtensions:X,total:j}}return{galleryExtensions:[],total:j}}catch(Y){throw _=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(O.length),duration:new Date().getTime()-F,success:!!A&&(0,h.isSuccess)(A),responseBodySize:A?.res.headers["Content-Length"],statusCode:A?String(A.res.statusCode):void 0,errorCode:_?(0,L.isPromiseCanceledError)(_)?"canceled":(0,L.getErrorMessage)(_).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(T,z,B,O){if(!this.isEnabled())return;const $=M.isWeb?this.api(`/itemName/${T}.${z}/version/${B}/statType/${O==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${T}/extensions/${z}/${B}/stats?statType=${O}`),F=M.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",_={...await this.commonHeadersPromise,Accept:F};try{await this.requestService.request({type:"POST",url:$,headers:_},w.CancellationToken.None)}catch(j){}}async download(T,z,B){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const O=(0,f.getGalleryExtensionTelemetryData)(T),$=new Date().getTime(),F=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...O,duration:Y}),A=B===1?"install":B===2?"update":"",_=A?{uri:`${T.assets.download.uri}&${A}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${A}=true`}:T.assets.download,j=await this.getAsset(_);await this.fileService.writeFile(z,j.stream),F(new Date().getTime()-$)}async getReadme(T,z){if(T.assets.readme){const B=await this.getAsset(T.assets.readme,{},z);return await(0,h.asText)(B)||""}return""}async getManifest(T,z){if(T.assets.manifest){const B=await this.getAsset(T.assets.manifest,{},z),O=await(0,h.asText)(B);return O?JSON.parse(O):null}return null}async getCoreTranslation(T,z){const B=T.assets.coreTranslations.filter(O=>O[0]===z.toUpperCase())[0];if(B){const O=await this.getAsset(B[1]),$=await(0,h.asText)(O);return $?JSON.parse($):null}return null}async getChangelog(T,z){if(T.assets.changelog){const B=await this.getAsset(T.assets.changelog,{},z);return await(0,h.asText)(B)||""}return""}async getAllVersions(T,z){let B=new o().withFlags(u.IncludeVersions,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?B=B.withFilter(a.ExtensionId,T.identifier.uuid):B=B.withFilter(a.ExtensionName,T.identifier.id);const O=[],{galleryExtensions:$}=await this.queryGallery(B,w.CancellationToken.None);return $.length&&(z?await Promise.all($[0].versions.map(async F=>{let A;try{A=await this.getEngine(F)}catch(_){}A&&(0,m.isEngineValid)(A,this.productService.version,this.productService.date)&&O.push({version:F.version,date:F.lastUpdated})})):O.push(...$[0].versions.map(F=>({version:F.version,date:F.lastUpdated})))),O}async getAsset(T,z={},B=w.CancellationToken.None){const O=await this.commonHeadersPromise,$={type:"GET"},F={...O,...z.headers||{}};z={...z,...$,headers:F};const A=T.uri,_=T.fallbackUri,j={...z,url:A};try{const Y=await this.requestService.request(j,B);if(Y.res.statusCode===200)return Y;const q=await(0,h.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${q}`)}catch(Y){if((0,L.isPromiseCanceledError)(Y))throw Y;const q=(0,L.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:A,message:q});const X={...z,url:_};return this.requestService.request(X,B)}}async getLastValidExtensionVersion(T,z){const B=this.getLastValidExtensionVersionFromProperties(T,z);return B||this.getLastValidExtensionVersionRecursively(T,z)}getLastValidExtensionVersionFromProperties(T,z){for(const B of z){const O=G(B);if(!O)return null;if((0,m.isEngineValid)(O,this.productService.version,this.productService.date))return B}return null}async getEngine(T){const z=G(T);if(z)return z;const B=W(T,c.Manifest);if(!B)throw new Error("Manifest was not found");const O={"Accept-Encoding":"gzip"},$=await this.getAsset(B,{headers:O}),F=await(0,h.asJson)($);if(F)return F.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,z){if(!z.length)return null;const B=z[0],O=await this.getEngine(B);return(0,m.isEngineValid)(O,this.productService.version,this.productService.date)?{...B,properties:[...B.properties||[],{key:i.Engine,value:O}]}:this.getLastValidExtensionVersionRecursively(T,z.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},w.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,h.asJson)(T),B=new Map;if(z)for(const O of z.malicious){const $=B.get(O)||{id:{id:O},malicious:!0,slow:!1};$.malicious=!0,B.set(O,$)}return[...B.values()]}};Q=ce([ee(0,h.IRequestService),ee(1,I.ILogService),ee(2,b.IEnvironmentService),ee(3,S.ITelemetryService),ee(4,t.IFileService),ee(5,v.IProductService),ee(6,(0,y.optional)(P.IStorageService))],Q),e.ExtensionGalleryService=Q;async function U(C,T,z,B){const O={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C}`},$=await(0,g.getServiceMachineId)(T,z,B);return O["X-Market-User-Id"]=$,O}e.resolveMarketplaceHeaders=U}),define(J[200],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(M){this.appender=M}listen(M,b){throw new Error(`Event not found: ${b}`)}call(M,b,{eventName:n,data:f}){return this.appender.log(n,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class L{constructor(M){this.channel=M}log(M,b){return this.channel.call("log",{eventName:M,data:b}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(J[201],Z([0,1,2,44,25,147,21,49,4,48,38]),function(H,e,w,L,k,M,b,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(h,g){this._configurationService=g,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const S=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!S})}))}setExperimentProperty(h,g){this._experimentProperties[h]=g}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(I);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let g=h.sessionID,P=h["common.instanceId"],S=h["common.machineId"],u=h["common.firstSessionDate"],d=h["common.msftInternal"];return{sessionId:g,instanceId:P,machineId:S,firstSessionDate:u,msftInternal:d}}dispose(){this._disposables.dispose()}publicLog(h,g,P){return this.isOptedIn?this._commonProperties.then(S=>{g=(0,L.mixin)(g,S),g=(0,L.mixin)(g,this._experimentProperties),g=(0,L.cloneAndChange)(g,u=>{if(typeof u=="string")return this._cleanupInfo(u,P)}),this._appender.log(h,g)},S=>{console.error(S)}):Promise.resolve(void 0)}publicLog2(h,g,P){return this.publicLog(h,g,P)}publicLogError(h,g){return this.sendErrorTelemetry?this.publicLog(h,g,!0):Promise.resolve(void 0)}publicLogError2(h,g){return this.publicLogError(h,g)}_cleanupInfo(h,g){let P=h;if(g){const S=[];for(let c of this._cleanupPatterns)for(;;){const i=c.exec(h);if(!i)break;S.push([i.index,c.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(P="";;){const c=d.exec(h);if(!c)break;!u.test(c[0])&&S.every(([i,s])=>c.index<i||c.index>=s)&&(P+=h.substring(a,c.index)+"<REDACTED: user-file-path>",a=d.lastIndex)}a<h.length&&(P+=h.substr(a))}for(let S of this._cleanupPatterns)P=P.replace(S,"");return P}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ce([ee(1,(0,f.optional)(b.IConfigurationService))],y),e.TelemetryService=y;const I="telemetry";t.Registry.as(n.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:(0,M.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,M.localize)(2,null,m.default.nameLong,m.default.privacyStatementUrl):(0,M.localize)(1,null,m.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[96],Z([0,1,9,44,13,21]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,g){return Promise.resolve(void 0)}publicLog2(h,g){return this.publicLog(h,g)}publicLogError(h,g){return Promise.resolve(void 0)}publicLogError2(h,g){return this.publicLogError(h,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class b{async publicLog(g,P,S){}async publicLogError(g,P,S){}}e.NullEndpointTelemetryService=b;function n(...h){return{log:(g,P)=>h.forEach(S=>S.log(g,P)),flush:()=>w.Promises.settled(h.map(g=>g.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(h,g){return g.onDidChangeConfiguration(P=>{P.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(P.source),configurationKeys:I(P.sourceConfig)})})}e.configurationTelemetry=f;function m(h){const g=Object.create(null),P=Object.create(null),S=Object.create(null);y(h,S);for(let u in S){u=u.length>150?u.substr(u.length-149):u;const d=S[u];typeof d=="number"?P[u]=d:typeof d=="boolean"?P[u]=d?1:0:typeof d=="string"?g[u]=d.substring(0,1023):typeof d!="undefined"&&d!==null&&(g[u]=d)}return{properties:g,measurements:P}}e.validateTelemetryData=m;function t(h){if(!h)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(S=>{h.indexOf(`${S}+`)===0&&(g=S)}),g}e.cleanRemoteAuthority=t;function y(h,g,P=0,S){if(!!h)for(let u of Object.getOwnPropertyNames(h)){const d=h[u],a=S?S+u:u;Array.isArray(d)?g[a]=(0,L.safeStringify)(d):d instanceof Date?g[a]=d.toISOString():(0,k.isObject)(d)?P<2?y(d,g,P+1,a+"."):g[a]=(0,L.safeStringify)(d):g[a]=d}}function I(h){if(!h)return[];const g=[];return v(g,"",h),g}function v(h,g,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(S=>v(h,g?`${g}.${S}`:S,P[S])):h.push(g)}}),define(J[202],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(J[203],Z([0,1,108,5,2,4,38,202]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(P){function S(u){return u&&typeof u=="object"&&typeof u.id=="string"}P.isThemeColor=S})(f=e.ThemeColor||(e.ThemeColor={}));function m(P){return{id:P}}e.themeColorFromId=m;var t;(function(P){function S(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||f.isThemeColor(s.color))}P.isThemeIcon=S;const u=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function d(s){const r=u.exec(s);if(!r)return;let[,o]=r;return{id:o}}P.fromString=d;function a(s,r){let o=s.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),r&&(o=`${o}~${r}`),{id:o}}P.modify=a;function c(s,r){return s.id===r.id&&s.color?.id===r.color?.id}P.isEqual=c;function i(s,r){return{id:s.id,color:r?m(r):void 0}}P.asThemeIcon=i,P.asClassNameArray=w.CSSIcon.asClassNameArray,P.asClassName=w.CSSIcon.asClassName,P.asCSSSelector=w.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function y(P){switch(P){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,k.toDisposable)(()=>{const u=this.themingParticipants.indexOf(S);this.themingParticipants.splice(u,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new I;b.Registry.add(e.Extensions.ThemingContribution,v);function h(P){return v.onColorThemeChange(P)}e.registerThemingParticipant=h;class g extends k.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(u=>this.onThemeChange(u)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,u){let d=this.theme.getColor(S);return d&&u&&(d=u(d,this.theme)),d?d.toString():null}}e.Themable=g}),define(J[60],Z([0,1,14,3,4,39]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const b="#FFFFFF",n="#1E1E1E",f="#000000",m="theme",t="themeBackground",y="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let I=class{constructor(h){this.stateMainService=h}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme)return f;let h=this.stateMainService.getItem(t,null);if(!h){let g;(L.isWindows||L.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(m,"vs-dark").split(" ")[0],h=g==="hc-black"?f:g==="vs"?b:n}return L.isMacintosh&&h.toUpperCase()===n&&(h="#171717"),h}saveWindowSplash(h,g){this.stateMainService.setItems([{key:m,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:y,data:g}]),typeof h=="number"&&this.updateBackgroundColor(h,g)}updateBackgroundColor(h,g){for(const P of w.BrowserWindow.getAllWindows())if(P.id===h){P.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(y)}};I=ce([ee(0,M.IStateMainService)],I),e.ThemeMainService=I}),define(J[42],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,b)=>({type:"idle",updateType:M,error:b}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(J[204],Z([0,1,3,148,49,38]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[205],Z([0,1,5,42]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,m){switch(f){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(n){this.channel=n,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(J[97],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(J[206],Z([0,1,8]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,m){switch(f){case"handleURL":return this.handler.handleURL(w.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(n){this.next=n}async routeCall(n,f,m,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(m){const y=w.URI.revive(m);if(y&&y.query){const I=/\bwindowId=(\d+)/.exec(y.query);if(I){const v=I[1],h=new RegExp(`window:${v}`),g=n.connections.find(P=>h.test(P.ctx));if(g)return g}}}return this.next.routeCall(n,f,m,t)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(J[207],Z([0,1,9,2,8,20]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class b extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(m,t){const y=[...this.handlers.values()];return(0,w.first)(y.map(I=>()=>I.handleURL(m,t)),void 0,!1).then(I=>I||!1)}registerHandler(m){return this.handlers.add(m),(0,L.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=b;let n=class extends b{constructor(m){super();this.productService=m}create(m){let{authority:t,path:y,query:I,fragment:v}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&y&&y.indexOf("/")!==0&&(y=`/${y}`),k.URI.from({scheme:this.productService.urlProtocol,authority:t,path:y,query:I,fragment:v})}};n=ce([ee(0,M.IProductService)],n),e.NativeURLService=n}),define(J[208],Z([0,1,14,9,5,2,3,8]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return n.URI.parse(t)}catch(y){return null}}class m{constructor(y,I,v,h,g){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=y,b.isWindows){const u=h.isBuilt?[]:[`"${h.appRoot}"`];u.push("--open-url","--"),w.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,u)}const P=k.Event.map(k.Event.fromNodeEventEmitter(w.app,"open-url",(u,d)=>({event:u,url:d})),({event:u,url:d})=>(u.preventDefault(),d));this.disposables.add(P(u=>{const d=f(u);!d||this.urlService.open(d,{originalUrl:u})})),v.getWindows().filter(u=>u.isReady).length>0?this.flush():k.Event.once(v.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const y=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||y.push(I);y.length!==0&&(this.uris=y,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(J[209],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(J[210],Z([0,1,14,2,10,8]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class b extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,m){try{const t=M.URI.parse(f.url),y=b.validWebviewFilePaths.get(t.path);if(typeof y=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${y}`,v=k.FileAccess.asFileUri(I,H);return m(decodeURIComponent(v.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=b,b.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(m){return!!m.workspaceUri}e.isWorkspaceToOpen=L;function k(m){return!!m.folderUri}e.isFolderToOpen=k;function M(m){return!!m.fileUri}e.isFileToOpen=M;function b(m){const t=n(m),y=m.getValue("window.menuBarVisibility");return y==="default"||t==="native"&&y==="compact"||w.isMacintosh&&w.isNative?"classic":y}e.getMenuBarVisibility=b;function n(m){if(w.isWeb)return"custom";const t=m.getValue("window");if(t){if(w.isMacintosh&&t.nativeTabs===!0||w.isMacintosh&&t.nativeFullScreen===!1)return"native";const v=t.titleBarStyle;if(v==="native"||v==="custom")return v}return w.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=f}),define(J[35],Z([0,1,4]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(m){m[m.INITIAL=1]="INITIAL",m[m.LOAD=2]="LOAD",m[m.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(m){m[m.CLOSE=1]="CLOSE",m[m.QUIT=2]="QUIT",m[m.RELOAD=3]="RELOAD",m[m.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const b=function(m=1){return{width:1024,height:768,mode:m}};e.defaultWindowState=b;var n;(function(m){m[m.Maximized=0]="Maximized",m[m.Normal=1]="Normal",m[m.Minimized=2]="Minimized",m[m.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(m){m[m.UNRESPONSIVE=1]="UNRESPONSIVE",m[m.CRASHED=2]="CRASHED",m[m.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,w.createDecorator)("windowsMainService")}),define(J[211],Z([0,1,14,5,2,210,35]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends k.Disposable{constructor(m){super();this.windowsMainService=m,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,t){let y;if(typeof m.windowId=="number"){const{windowId:I}=m,v=this.windowsMainService.getWindowById(I);if(!v?.win)throw new Error(`Invalid windowId: ${I}`);y=v.win.webContents}else{const{webContentsId:I}=m;if(y=w.webContents.fromId(I),!y)throw new Error(`Invalid webContentsId: ${I}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(t)}async findInFrame(m,t,y,I){const v=this.getFrameByName(m,t),h=v;if(typeof h.findInFrame=="function"){h.findInFrame(y,{findNext:I.findNext,forward:I.forward});const g=(P,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),v.removeListener("found-in-frame",g))};v.on("found-in-frame",g)}}async stopFindInFrame(m,t,y){const v=this.getFrameByName(m,t);typeof v.stopFindInFrame=="function"&&v.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,t){const y=this.windowsMainService.getWindowById(m.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${m}`);const I=y.win.webContents.mainFrame.framesInSubtree.find(v=>v.name===t);if(!I)throw new Error(`Unknown frame: ${t}`);return I}};n=ce([ee(0,b.IWindowsMainService)],n),e.WebviewMainService=n}),define(J[212],Z([0,1,9,5,2]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:m}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>m()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch(y){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(J[213],Z([0,1,37,15,8,4]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var b;(function(I){I[I.EMPTY=1]="EMPTY",I[I.FOLDER=2]="FOLDER",I[I.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function n(I){const v=I;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=n;function f(I){const v=I;return!!(v&&typeof v=="object"&&k.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=f;class m{constructor(v,h,g,P){this._id=v,this._configuration=g,this._ignorePathCasing=P,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(v){this._id=v.id,this._configuration=v.configuration,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=m;class t{constructor(v,h){this.raw=h,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,L.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function y(I){return new t({uri:I,index:0,name:(0,L.basenameOrAuthority)(I)},{uri:I.toString()})}e.toWorkspaceFolder=y}),define(J[27],Z([0,1,29,40,76,31,10,7,3,15,8,151,4,73,213]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(U){return(typeof U=="string"?(0,n.extname)(U):(0,m.extname)(U))===g}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function S(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function u(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=u;function d(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=d;function a(U){const C=U;return typeof C?.id=="string"&&t.URI.isUri(C.uri)}e.isSingleFolderWorkspaceIdentifier=a;function c(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=c;function i(U){const C=U;return typeof C?.id=="string"&&t.URI.isUri(C.configPath)}e.isWorkspaceIdentifier=i;function s(U){const C=U;if(C?.uri)return{id:C.id,uri:t.URI.revive(C.uri)};const T=U;if(T?.configPath)return{id:T.id,configPath:t.URI.revive(T.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=s;function r(U,C){return m.extUriBiasedIgnorePathCase.isEqualOrParent(U,C.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function o(U){return l(U)||p(U)}e.isStoredWorkspaceFolder=o;function l(U){const C=U;return typeof C?.path=="string"&&(!C.name||typeof C.name=="string")}e.isRawFileWorkspaceFolder=l;function p(U){const C=U;return typeof C?.uri=="string"&&(!C.name||typeof C.name=="string")}e.isRawUriWorkspaceFolder=p;function E(U,C,T,z,B=!f.isWindows,O){if(U.scheme!==z.scheme)return{name:T,uri:U.toString(!0)};let $=C?void 0:O.relativePath(z,U);if($!==void 0)$.length===0?$=".":f.isWindows&&U.scheme===b.Schemas.file&&!B&&($=$.replace(/\//g,"\\"));else if(U.scheme===b.Schemas.file)$=U.fsPath,f.isWindows&&($=(0,M.normalizeDriveLetter)($),B&&($=(0,w.toSlashes)($)));else{if(!O.isEqualAuthority(U.authority,z.authority))return{name:T,uri:U.toString(!0)};$=U.path}return{name:T,path:$}}e.getStoredWorkspaceFolder=E;function D(U,C,T){let z=[],B=new Set;const O=T.dirname(C);for(let $ of U){let F;if(l($))$.path&&(F=T.resolvePath(O,$.path));else if(p($))try{F=t.URI.parse($.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(A){console.warn(A)}if(F){let A=T.getComparisonKey(F);if(!B.has(A)){B.add(A);const _=$.name||T.basenameOrAuthority(F);z.push(new h.WorkspaceFolder({uri:F,name:_,index:z.length},$))}}}return z}e.toWorkspaceFolders=D;function R(U,C,T,z,B){let O=W(C,U);const $=B.dirname(C),F=B.dirname(z),A=[],_=N(O.folders);for(const X of O.folders){const ie=l(X)?B.resolvePath($,X.path):t.URI.parse(X.uri);let se;T?se=!1:se=!l(X)||(0,n.isAbsolute)(X.path),A.push(E(ie,se,X.name,F,_,B))}const j={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},Y=k.setProperty(U,["folders"],A,j);let q=k.applyEdits(U,Y);return O.remoteAuthority===(0,v.getRemoteAuthority)(z)&&(q=k.applyEdits(q,k.removeProperty(q,["remoteAuthority"],j))),q}e.rewriteWorkspaceFileForNewLocation=R;function W(U,C){let T=L.parse(C);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(z=>o(z));else throw new Error(`${U} looks like an invalid workspace file.`);return T}function N(U){return f.isWindows?U.some(C=>l(C)&&C.path.indexOf("/")>=0):!0}e.useSlashForPath=N;function G(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function x(U){return typeof U.folderUri=="string"}function ne(U){return typeof U.fileUri=="string"}function V(U,C){const T={workspaces:[],files:[]};if(U){const z=function(O,$){for(let F=0;F<O.length;F++)try{$(O[F],F)}catch(A){C.warn(`Error restoring recent entry ${JSON.stringify(O[F])}: ${A.toString()}. Skip entry.`)}},B=U;if(Array.isArray(B.entries))z(B.entries,O=>{const $=O.label,F=O.remoteAuthority;G(O)?T.workspaces.push({label:$,remoteAuthority:F,workspace:{id:O.workspace.id,configPath:t.URI.parse(O.workspace.configPath)}}):x(O)?T.workspaces.push({label:$,remoteAuthority:F,folderUri:t.URI.parse(O.folderUri)}):ne(O)&&T.files.push({label:$,remoteAuthority:F,fileUri:t.URI.parse(O.fileUri)})});else{const O=U;Array.isArray(O.workspaces3)&&z(O.workspaces3,($,F)=>{const A=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[F]||void 0;typeof $=="object"&&typeof $.id=="string"&&typeof $.configURIPath=="string"?T.workspaces.push({label:A,workspace:{id:$.id,configPath:t.URI.parse($.configURIPath)}}):typeof $=="string"&&T.workspaces.push({label:A,folderUri:t.URI.parse($)})}),Array.isArray(O.files2)&&z(O.files2,($,F)=>{const A=Array.isArray(O.fileLabels)&&O.fileLabels[F]||void 0;typeof $=="string"&&T.files.push({label:A,fileUri:t.URI.parse($)})})}}return T}e.restoreRecentlyOpened=V;function Q(U){const C={entries:[]};for(const T of U.workspaces)u(T)?C.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):C.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of U.files)C.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return C}e.toStoreData=Q}),define(J[51],Z([0,1,4,27]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService");function k(M){const b=M;return b&&(0,L.isWorkspaceIdentifier)(b.workspace)}e.isWorkspaceBackupInfo=k}),define(J[52],Z([0,1,14,9,78,31,2,65,7,3,13,18,133,4,39,27]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let P=class gt{constructor(u){this.stateMainService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(u,d){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},d)}pickFolder(u,d){return this.doPick({...u,pickFolders:!0,title:(0,I.localize)(1,null)},d)}pickFile(u,d){return this.doPick({...u,pickFiles:!0,title:(0,I.localize)(2,null)},d)}pickWorkspace(u,d){const a=(0,I.localize)(3,null),c=(0,M.mnemonicButtonLabel)((0,I.localize)(4,null)),i=g.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:a,filters:i,buttonLabel:c},d)}async doPick(u,d){const a={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};a.defaultPath=u.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(a.properties=void 0,u.pickFiles&&u.pickFolders&&(a.properties=["multiSelections","openDirectory","openFile","createDirectory"])),a.properties||(a.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),m.isMacintosh&&a.properties.push("treatPackageAsDirectory");const c=d||w.BrowserWindow.getFocusedWindow(),i=await this.showOpenDialog(a,(0,t.withNullAsUndefined)(c));if(i&&i.filePaths&&i.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(i.filePaths[0])),i.filePaths}getWindowDialogQueue(u){if(u){let d=this.windowDialogQueues.get(u.id);return d||(d=new L.Queue,this.windowDialogQueues.set(u.id,d)),d}else return this.noWindowDialogueQueue}showMessageBox(u,d){return this.getWindowDialogQueue(d).queue(async()=>d?w.dialog.showMessageBox(d,u):w.dialog.showMessageBox(u))}async showSaveDialog(u,d){const a=this.acquireFileDialogLock(u,d);if(!a)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(d).queue(async()=>{let c;return d?c=await w.dialog.showSaveDialog(d,u):c=await w.dialog.showSaveDialog(u),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,b.dispose)(a)}}normalizePath(u){return u&&m.isMacintosh&&(u=(0,n.normalizeNFC)(u)),u}normalizePaths(u){return u.map(d=>this.normalizePath(d))}async showOpenDialog(u,d){u.defaultPath&&(await y.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const a=this.acquireFileDialogLock(u,d);if(!a)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(d).queue(async()=>{let c;return d?c=await w.dialog.showOpenDialog(d,u):c=await w.dialog.showOpenDialog(u),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,b.dispose)(a)}}acquireFileDialogLock(u,d){if(!d)return b.Disposable.None;let a=this.windowFileDialogLocks.get(d.id);a||(a=new Set,this.windowFileDialogLocks.set(d.id,a));const c=(0,k.hash)(u);if(!a.has(c))return a.add(c),(0,b.toDisposable)(()=>{a?.delete(c),a?.size===0&&this.windowFileDialogLocks.delete(d.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=ce([ee(0,h.IStateMainService)],P),e.DialogMainService=P}),define(J[214],Z([0,1,5,2,27]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,m=new Set;return n.forEach(t=>{const y=this.storageMainService.globalStorage.get(t.key);typeof y=="string"?f.set(t.key,y):m.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(m.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,m){const t=(0,k.reviveIdentifier)(m.workspace),y=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(y.items.entries());case"updateItems":{const I=m;if(I.insert)for(const[v,h]of I.insert)y.set(v,h);I.delete&&I.delete.forEach(v=>y.delete(v));break}case"close":{if(t)return y.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(m){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${m}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[215],Z([0,1,5,2,7,28,18,84,123,6,95,32,27]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class v extends L.Disposable{constructor(S){super();this.logService=S,this._onDidChangeStorage=this._register(new w.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new w.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const S=await this.doCreate();this.storage.dispose(),this.storage=S,this._register(S.onDidChangeStorage(d=>this._onDidChangeStorage.fire({key:d}))),await this.doInit(S);const u=S.getBoolean(t.IS_NEW_KEY);u===void 0?S.set(t.IS_NEW_KEY,!0):u&&S.set(t.IS_NEW_KEY,!1)}catch(S){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${S}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===m.LogLevel.Trace?S=>this.logService.trace(S):void 0,logError:S=>this.logService.error(S)}}doInit(S){return S.init()}get items(){return this.storage.items}get(S,u){return this.storage.get(S,u)}set(S,u){return this.storage.set(S,u)}delete(S){return this.storage.delete(S)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class h extends v{constructor(S,u,d){super(u);this.options=S,this.environmentService=d}async doCreate(){let S;return this.options.useInMemoryStorage?S=f.SQLiteStorageDatabase.IN_MEMORY_PATH:S=(0,k.join)(this.environmentService.globalStorageHome.fsPath,h.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(S,{logging:this.createLoggingOptions()}))}async doInit(S){await super.doInit(S),this.updateTelemetryState(S)}updateTelemetryState(S){S.get(y.instanceStorageKey,void 0)===void 0&&S.set(y.instanceStorageKey,(0,M.generateUuid)()),S.get(y.firstSessionDateStorageKey,void 0)===void 0&&S.set(y.firstSessionDateStorageKey,new Date().toUTCString());const a=S.get(y.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();S.set(y.lastSessionDateStorageKey,typeof a=="undefined"?null:a),S.set(y.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=h,h.STORAGE_NAME="state.vscdb";class g extends v{constructor(S,u,d,a){super(d);this.workspace=S,this.options=u,this.environmentService=a}async doCreate(){const{storageFilePath:S,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(S,{logging:this.createLoggingOptions()}),{hint:u?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const S=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,k.join)(S,g.WORKSPACE_STORAGE_NAME);return await b.Promises.exists(S)?{storageFilePath:u,wasCreated:!1}:(await b.Promises.mkdir(S,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(S),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(S){let u;if((0,I.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,I.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const d=(0,k.join)(S,g.WORKSPACE_META_NAME);await b.Promises.exists(d)||await b.Promises.writeFile(d,JSON.stringify(u,void 0,2))}catch(d){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${d}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(J[98],Z([0,1,43,2,47,4,22,6,215]),function(H,e,w,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let m=class extends L.Disposable{constructor(y,I,v){super();this.logService=y,this.environmentService=I,this.lifecycleMainService=v,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async y=>{y.workspace&&this.workspaceStorage(y.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(y=>{y.join(this.globalStorage.close());for(const[,I]of this.mapWorkspaceToStorage)y.join(I.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const y=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(y.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),y}createWorkspaceStorage(y){return new f.WorkspaceStorageMain(y,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(y){let I=this.mapWorkspaceToStorage.get(y.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${y.id})`),I=this.createWorkspaceStorage(y),this.mapWorkspaceToStorage.set(y.id,I),(0,w.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${y.id})`),this.mapWorkspaceToStorage.delete(y.id)})),I}};m=ce([ee(0,n.ILogService),ee(1,k.IEnvironmentService),ee(2,b.ILifecycleMainService)],m),e.StorageMainService=m}),define(J[99],Z([0,1,15,8,27]),function(H,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,m,t){for(const I of f){const v=I.openedWorkspace;if((0,k.isWorkspaceIdentifier)(v)){const h=t(v);if(h){if(h.folders.some(g=>w.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.uri)))return I}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(m,v.configPath))return I}}const y=f.filter(I=>(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(m,I.openedWorkspace.uri));if(y.length)return y.sort((I,v)=>-(I.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function b(f,m){for(const t of f)if((0,k.isWorkspaceIdentifier)(t.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,m))return t}e.findWindowOnWorkspaceOrFolder=b;function n(f,m){const t=y=>m.some(I=>w.extUriBiasedIgnorePathCase.isEqual(L.URI.file(I),L.URI.file(y)));for(const y of f)if(y.config?.extensionDevelopmentPath?.some(I=>t(I)))return y}e.findWindowOnExtensionDevelopmentPath=n}),define(J[216],Z([0,1,14,2,3,15,8,21,22,6,39,35,27]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class mt extends L.Disposable{constructor(d,a,c,i,s){super();this.windowsMainService=d,this.stateMainService=a,this.lifecycleMainService=c,this.logService=i,this.configurationService=s,this._state=h(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(d=>this.onBeforeCloseWindow(d)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(d=>{d.newCount-d.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(d=>this.onBeforeCloseWindow(d))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const d={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!d.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(d.lastActiveWindow=this.toWindowState(i))}const a=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);a&&(d.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(d.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const c=P(d);this.stateMainService.setItem(mt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(d){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(d);d.isExtensionDevelopmentHost&&!d.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!d.isExtensionDevelopmentHost&&d.openedWorkspace&&this._state.openedWindows.forEach(c=>{const i=(0,I.isWorkspaceIdentifier)(d.openedWorkspace)&&c.workspace?.id===d.openedWorkspace.id,s=(0,I.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)&&c.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(c.folderUri,d.openedWorkspace.uri);(i||s)&&(c.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(d){return{workspace:(0,I.isWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace:void 0,folderUri:(0,I.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace.uri:void 0,backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.serializeWindowState()}}getNewWindowState(d){const a=this.doGetNewWindowState(d),c=this.configurationService.getValue("window");let i;return a.hasDefaultState?i=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),i&&k.isMacintosh&&this.windowsMainService.getWindows().some(s=>s.isFullScreen)&&(i=!1)),a.mode===3&&!i&&(a.mode=1),a}doGetNewWindowState(d){const a=this.windowsMainService.getLastActiveWindow();if(!d.extensionTestsPath){if(!!d.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=d.workspace;if((0,I.isWorkspaceIdentifier)(l)){const E=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(E.length)return E[0]}if((0,I.isSingleFolderWorkspaceIdentifier)(l)){const E=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(E.length)return E[0]}else if(d.backupPath){const E=this.state.openedWindows.filter(D=>D.backupPath===d.backupPath).map(D=>D.uiState);if(E.length)return E[0]}const p=this.lastClosedState||this.state.lastActiveWindow;if(!a&&p)return p.uiState}let c;const i=w.screen.getAllDisplays();if(i.length===1)c=i[0];else{if(k.isMacintosh){const l=w.screen.getCursorScreenPoint();c=w.screen.getDisplayNearestPoint(l)}!c&&a&&(c=w.screen.getDisplayMatching(a.getBounds())),c||(c=w.screen.getPrimaryDisplay()||i[0])}let s=(0,y.defaultWindowState)();s.x=Math.round(c.bounds.x+c.bounds.width/2-s.width/2),s.y=Math.round(c.bounds.y+c.bounds.height/2-s.height/2);const r=this.configurationService.getValue("window");let o=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")s.mode=0,o=!1;else if(r.newWindowDimensions==="fullscreen")s.mode=3,o=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const l=a.serializeWindowState();l.mode===3?s.mode=3:s=l,o=s.mode!==3&&r.newWindowDimensions==="offset"}}return o&&(s=this.ensureNoOverlap(s)),s.hasDefaultState=!0,s}ensureNoOverlap(d){if(this.windowsMainService.getWindows().length===0)return d;d.x=typeof d.x=="number"?d.x:0,d.y=typeof d.y=="number"?d.y:0;const a=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;a.some(c=>c.x===d.x||c.y===d.y);)d.x+=30,d.y+=30;return d}};v.windowsStateStorageKey="windowsState",v=ce([ee(0,y.IWindowsMainService),ee(1,t.IStateMainService),ee(2,f.ILifecycleMainService),ee(3,m.ILogService),ee(4,n.IConfigurationService)],v),e.WindowsStateHandler=v;function h(u){const d={openedWindows:[]},a=u||{openedWindows:[]};return a.lastActiveWindow&&(d.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(d.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(d.openedWindows=a.openedWindows.map(c=>g(c))),d}e.restoreWindowsState=h;function g(u){const d={uiState:u.uiState};return u.backupPath&&(d.backupPath=u.backupPath),u.remoteAuthority&&(d.remoteAuthority=u.remoteAuthority),u.folder&&(d.folderUri=b.URI.parse(u.folder)),u.workspaceIdentifier&&(d.workspace={id:u.workspaceIdentifier.id,configPath:b.URI.parse(u.workspaceIdentifier.configURIPath)}),d}function P(u){return{lastActiveWindow:u.lastActiveWindow&&S(u.lastActiveWindow),lastPluginDevelopmentHostWindow:u.lastPluginDevelopmentHostWindow&&S(u.lastPluginDevelopmentHostWindow),openedWindows:u.openedWindows.map(d=>S(d))}}e.getWindowsStateStoreData=P;function S(u){return{workspaceIdentifier:u.workspace&&{id:u.workspace.id,configURIPath:u.workspace.configPath.toString()},folder:u.folderUri&&u.folderUri.toString(),backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.uiState}}}),define(J[100],Z([0,1,58,30,10,3,15]),function(H,e,w,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(m){function t(){let y=m.scheme===k.Schemas.file?(0,b.originalFSPath)(m):m.toString();return M.isLinux||(y=y.toLowerCase()),(0,w.createHash)("md5").update(y).digest("hex")}return{id:t(),configPath:m}}e.getWorkspaceIdentifier=n;function f(m,t){function y(){if(m.scheme!==k.Schemas.file)return(0,w.createHash)("md5").update(m.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(m.fsPath)}catch(h){return}let v;return M.isLinux?v=t.ino:M.isMacintosh?v=t.birthtime.getTime():M.isWindows&&(typeof t.birthtimeMs=="number"?v=Math.floor(t.birthtimeMs):v=t.birthtime.getTime()),(0,w.createHash)("md5").update(m.fsPath).update(v?String(v):"").digest("hex")}const I=y();if(typeof I=="string")return{id:I,uri:m}}e.getSingleFolderWorkspaceIdentifier=f}),define(J[56],Z([0,1,58,59,26,17,16,5,2,7,3,28,34,82,217]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(E){this.socket=E,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(E){const D=R=>E(M.VSBuffer.wrap(R));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(E){const D=R=>{E({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(E){return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(E){if(!this.socket.destroyed)try{this.socket.write(E.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((E,D)=>{if(this.socket.bufferSize===0){E();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),E()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var P;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var S;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(S||(S={}));class u extends f.Disposable{constructor(E,D,R,W){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=E,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=W,D?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",N=>{console.error(N),(0,b.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})}),this._zlibInflate.on("data",N=>{this._pendingInflateData.push(N)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",N=>{console.error(N),(0,b.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})}),this._zlibDeflate.on("data",N=>{this._pendingDeflateData.push(N)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){this._totalOutgoingDataBytes+=E.byteLength,this._zlibDeflate?(this._zlibDeflate.write(E.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(M.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(E,!1)}_write(E,D){let R=2;E.byteLength<126?R+=0:E.byteLength<2**16?R+=2:R+=8;const W=M.VSBuffer.alloc(R);if(D?W.writeUInt8(194,0):W.writeUInt8(130,0),E.byteLength<126)W.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){W.writeUInt8(126,1);let N=1;W.writeUInt8(E.byteLength>>>8&255,++N),W.writeUInt8(E.byteLength>>>0&255,++N)}else{W.writeUInt8(127,1);let N=1;W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(0,++N),W.writeUInt8(E.byteLength>>>24&255,++N),W.writeUInt8(E.byteLength>>>16&255,++N),W.writeUInt8(E.byteLength>>>8&255,++N),W.writeUInt8(E.byteLength>>>0&255,++N)}this._totalOutgoingWireBytes+=W.byteLength+E.byteLength,this.socket.write(M.VSBuffer.concat([W,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._totalIncomingWireBytes+=E.byteLength,this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),W=(D.readUInt8(0)&128)>>>7,N=D.readUInt8(1),G=(N&128)>>>7,x=N&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=W,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),W=(R&128)>>>7;let N=R&127,G=1;N===126?N=D.readUInt8(++G)*2**8+D.readUInt8(++G):N===127&&(N=D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G));let x=0;W&&(x=D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G)),this._state.state=3,this._state.readLen=N,this._state.mask=x}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);d(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=u;function d(p,E){if(E===0)return;let D=p.byteLength>>>2;for(let ne=0;ne<D;ne++){const V=p.readUInt32BE(ne*4);p.writeUInt32BE(V^E,ne*4)}let R=D*4,W=p.byteLength-R;const N=E>>>24&255,G=E>>>16&255,x=E>>>8&255;W>=1&&p.writeUInt8(p.readUInt8(R)^N,R),W>=2&&p.writeUInt8(p.readUInt8(R+1)^G,R+1),W>=3&&p.writeUInt8(p.readUInt8(R+2)^x,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function c(){const p=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let E;return e.XDG_RUNTIME_DIR?E=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):E=(0,m.join)((0,k.tmpdir)(),`vscode-ipc-${p}.sock`),s(E),E}e.createRandomIPCHandle=c;function i(p,E,D){const R=(0,w.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${E}-sock`;let W;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${E}.sock`):W=(0,m.join)(p,`${D}-${E}.sock`),s(W),W}e.createStaticIPCHandle=i;function s(p){const E=a[t.platform];typeof E=="number"&&p.length>=E&&console.warn(`WARNING: IPC handle "${p}" is longer than ${E} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{constructor(E){super(r.toClientConnectionEvent(E));this.server=E}static toClientConnectionEvent(E){const D=n.Event.fromNodeEventEmitter(E,"connection");return n.Event.map(D,R=>({protocol:new v.Protocol(new g(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function o(p){return new Promise((E,D)=>{const R=(0,L.createServer)();R.on("error",D),R.listen(p,()=>{R.removeListener("error",D),E(new r(R))})})}e.serve=o;function l(p,E){return new Promise((D,R)=>{const W=(0,L.createConnection)(p,()=>{W.removeListener("error",R),D(v.Client.fromSocket(new g(W),E))});W.once("error",R)})}e.connect=l}),define(J[218],Z([0,1,56]),function(H,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,m){throw new Error("No event found")}call(f,m,t){switch(m){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${m}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,m){return this.channel.call("dispatchKeybinding",[f,m])}click(f,m,t,y){return this.channel.call("click",[f,m,t,y])}doubleClick(f,m){return this.channel.call("doubleClick",[f,m])}setValue(f,m,t){return this.channel.call("setValue",[f,m,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,m){return this.channel.call("isActiveElement",[f,m])}getElements(f,m,t){return this.channel.call("getElements",[f,m,t])}getElementXY(f,m,t,y){return this.channel.call("getElementXY",[f,m,t,y])}typeInEditor(f,m,t){return this.channel.call("typeInEditor",[f,m,t])}getTerminalBuffer(f,m){return this.channel.call("getTerminalBuffer",[f,m])}writeInTerminal(f,m,t){return this.channel.call("writeInTerminal",[f,m,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,m){throw new Error(`Event not found: ${m}`)}call(f,m,t){switch(m){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${m}`)}}e.WindowDriverRegistryChannel=M;async function b(n){const f=await(0,w.connect)(n,"driverClient"),m=f.getChannel("driver"),t=new k(m);return{client:f,driver:t}}e.connect=b}),define(J[219],Z([0,1,9,5,106,57,2,3,77,34,56,155,218,176,22,35]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(d){return d<21}let S=class{constructor(a,c,i,s){this.windowServer=a,this.options=c,this.windowsMainService=i,this.lifecycleMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(a){return this.registeredWindowIds.add(a),this.reloadingWindowIds.delete(a),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(a){this.reloadingWindowIds.add(a)}async getWindowIds(){return this.windowsMainService.getWindows().map(a=>a.id).filter(a=>this.registeredWindowIds.has(a)&&!this.reloadingWindowIds.has(a))}async capturePage(a){await this.whenUnfrozen(a);const c=this.windowsMainService.getWindowById(a);if(!c?.win)throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(a){await this.whenUnfrozen(a);const c=this.windowsMainService.getWindowById(a);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(a),this.lifecycleMainService.reload(c)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(a,c){await this.whenUnfrozen(a);const i=k.KeybindingParser.parseUserBinding(c);for(let s of i)await this._dispatchKeybinding(a,s)}async _dispatchKeybinding(a,c){if(c instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(a);if(!i?.win)throw new Error("Invalid window");const s=i.win.webContents,r=new M.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),l=new v.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),p=[];c.ctrlKey&&p.push("ctrl"),c.metaKey&&p.push("meta"),c.shiftKey&&p.push("shift"),c.altKey&&p.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:l,modifiers:p}),P(c.keyCode)||s.sendInputEvent({type:"char",keyCode:l,modifiers:p}),s.sendInputEvent({type:"keyUp",keyCode:l,modifiers:p}),await(0,w.timeout)(100)}async click(a,c,i,s){await(await this.getWindowDriver(a)).click(c,i,s)}async doubleClick(a,c){await(await this.getWindowDriver(a)).doubleClick(c)}async setValue(a,c,i){await(await this.getWindowDriver(a)).setValue(c,i)}async getTitle(a){return await(await this.getWindowDriver(a)).getTitle()}async isActiveElement(a,c){return await(await this.getWindowDriver(a)).isActiveElement(c)}async getElements(a,c,i){return await(await this.getWindowDriver(a)).getElements(c,i)}async getElementXY(a,c,i,s){return await(await this.getWindowDriver(a)).getElementXY(c,i,s)}async typeInEditor(a,c,i){await(await this.getWindowDriver(a)).typeInEditor(c,i)}async getTerminalBuffer(a,c){return await(await this.getWindowDriver(a)).getTerminalBuffer(c)}async writeInTerminal(a,c,i){await(await this.getWindowDriver(a)).writeInTerminal(c,i)}async getLocaleInfo(a){return await(await this.getWindowDriver(a)).getLocaleInfo()}async getLocalizedStrings(a){return await(await this.getWindowDriver(a)).getLocalizedStrings()}async getWindowDriver(a){await this.whenUnfrozen(a);const c=`window:${a}`,i=new m.StaticRouter(r=>r===c),s=this.windowServer.getChannel("windowDriver",i);return new y.WindowDriverChannelClient(s)}async whenUnfrozen(a){for(;this.reloadingWindowIds.has(a);)await L.Event.toPromise(this.onDidReloadingChange.event)}};S=ce([ee(2,g.IWindowsMainService),ee(3,h.ILifecycleMainService)],S),e.Driver=S;async function u(d,a,c,i){const s=c.driverVerbose,r=i.createInstance(S,d,{verbose:s}),o=new I.WindowDriverRegistryChannel(r);d.registerChannel("windowDriverRegistry",o);const l=await(0,t.serve)(a),p=new I.DriverChannel(r);return l.registerChannel("driver",p),(0,b.combinedDisposable)(l,d)}e.serve=u}),define(J[23],Z([0,1,46,7,56,47,160,4]),function(H,e,w,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class f extends b.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ce([w.memoize],f.prototype,"cachedLanguagesPath",null),ce([w.memoize],f.prototype,"backupHome",null),ce([w.memoize],f.prototype,"backupWorkspacesPath",null),ce([w.memoize],f.prototype,"mainIPCHandle",null),ce([w.memoize],f.prototype,"mainLockfile",null),ce([w.memoize],f.prototype,"sandbox",null),ce([w.memoize],f.prototype,"driverVerbose",null),ce([w.memoize],f.prototype,"disableUpdates",null),ce([w.memoize],f.prototype,"disableKeytar",null),ce([w.memoize],f.prototype,"codeCachePath",null),ce([w.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(J[220],Z([0,1,58,30,29,10,7,3,15,8,18,51,21,23,19,6,27]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(d,a,c){this.configurationService=a,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,s)=>(0,k.isEqual)(i,s,!n.isLinux)},this.backupHome=d.backupHome,this.workspacesJsonPath=d.backupWorkspacesPath}async initialize(){let d;try{d=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){d=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(d.emptyWorkspaceInfos);let a=[];try{Array.isArray(d.rootURIWorkspaces)&&(a=d.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:m.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(a);let c=[];try{Array.isArray(d.folderURIWorkspaces)&&(c=d.folderURIWorkspaces.map(i=>m.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(d,a){this.workspaces.some(i=>d.workspace.id===i.workspace.id)||(this.workspaces.push(d),this.saveSync());const c=this.getBackupPath(d.workspace.id);return a&&this.moveBackupFolderSync(c,a),c}moveBackupFolderSync(d,a){if(L.existsSync(d)&&this.convertToEmptyWindowBackupSync(d),L.existsSync(a))try{L.renameSync(a,d)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(d){const a=d.id,c=this.workspaces.findIndex(i=>i.workspace.id===a);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(d){return this.folders.some(a=>this.backupUriComparer.isEqual(d,a))||(this.folders.push(d),this.saveSync()),this.getBackupPath(this.getFolderHash(d))}unregisterFolderBackupSync(d){const a=this.folders.findIndex(c=>this.backupUriComparer.isEqual(d,c));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(d,a){const c=d||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:a}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(d){const a=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,d));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(d){return(0,b.join)(this.backupHome,d)}async validateWorkspaces(d){if(!Array.isArray(d))return[];const a=new Set,c=[];for(let i of d){const s=i.workspace;if(!(0,P.isWorkspaceIdentifier)(s))return[];if(!a.has(s.id)){a.add(s.id);const r=this.getBackupPath(s.id);await this.doHasBackups(r)?s.configPath.scheme!==M.Schemas.file||await t.Promises.exists(s.configPath.fsPath)?c.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return c}async validateFolders(d){if(!Array.isArray(d))return[];const a=[],c=new Set;for(let i of d){const s=this.backupUriComparer.getComparisonKey(i);if(!c.has(s)){c.add(s);const r=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(r)?i.scheme!==M.Schemas.file||await t.Promises.exists(i.fsPath)?a.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return a}async validateEmptyWorkspaces(d){if(!Array.isArray(d))return[];const a=[],c=new Set;for(let i of d){const s=i.backupFolder;if(typeof s!="string")return[];if(!c.has(s)){c.add(s);const r=this.getBackupPath(s);await this.doHasBackups(r)?a.push(i):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(d){try{await t.Promises.exists(d)&&await t.Promises.rm(d,t.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(d){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,a));)a=this.getRandomEmptyWindowId();const c=this.getBackupPath(a);try{await t.Promises.rename(d,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(d){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,a));)a=this.getRandomEmptyWindowId();const c=this.getBackupPath(a);try{L.renameSync(d,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const d=[];for(const a of this.workspaces)await this.hasBackups(a)&&d.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&d.push(a);return d}hasBackups(d){let a;return m.URI.isUri(d)?a=this.getBackupPath(this.getFolderHash(d)):(0,y.isWorkspaceBackupInfo)(d)?a=this.getBackupPath(d.workspace.id):a=d.backupFolder,this.doHasBackups(a)}async doHasBackups(d){try{const a=await t.Promises.readdir(d);for(const c of a)try{if((await t.Promises.readdir((0,b.join)(d,c))).length>0)return!0}catch(i){}}catch(a){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(d){this.logService.error(`Backup: Could not save workspaces.json: ${d.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(d){this.logService.error(`Backup: Could not save workspaces.json: ${d.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(d=>({id:d.workspace.id,configURIPath:d.workspace.configPath.toString(),remoteAuthority:d.remoteAuthority})),folderURIWorkspaces:this.folders.map(d=>d.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(d){let a;return d.scheme===M.Schemas.file?a=n.isLinux?d.fsPath:d.fsPath.toLowerCase():a=d.toString().toLowerCase(),(0,w.createHash)("md5").update(a).digest("hex")}};S=ce([ee(0,v.IEnvironmentMainService),ee(1,I.IConfigurationService),ee(2,g.ILogService)],S),e.BackupMainService=S}),define(J[221],Z([0,1,59,56]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,b,n){const f=t=>n(t,void 0),m=w.createConnection({host:k,port:M},()=>{m.removeListener("error",f);const t=Buffer.alloc(16);for(let h=0;h<16;h++)t[h]=Math.round(Math.random()*256);const y=t.toString("base64");let I=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];m.write(I.join(`\r
`)+`\r
\r
`);const v=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",v),n(void 0,new L.NodeSocket(m)))};m.on("data",v)});m.once("error",f)}}}),define(J[222],Z([0,1,59,9,2,115,21,6,20,191,94,221,74]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function v(S,u,d,a,c){return new h(S,u,d,a,c).waitForReady()}class h extends k.Disposable{constructor(u,d,a,c,i){super();this.defaultTunnelHost=d,this.suggestedLocalPort=i,this.public=!1,this._socketsDispose=new Map,this._options=u,this._server=w.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(d=>{d()})}async waitForReady(){let u=await(0,M.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),d=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address(),d||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address()),this.tunnelLocalPort=d.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${d.port}`,this}async _onConnection(u){u.pause();const d=await(0,m.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),a=d.getSocket().socket,c=d.readEntireBuffer();d.dispose(),c.byteLength>0&&u.write(c.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),a.end()}),u.on("close",()=>a.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),a.destroy()}),a.on("end",()=>u.end()),a.on("close",()=>u.end()),a.on("error",()=>{u.destroy()}),u.pipe(a),a.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),a.end()})}}let g=class extends t.AbstractTunnelService{constructor(u,d,a,c,i){super(d);this.socketFactory=u,this.signService=a,this.productService=c,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,d,a,c,i,s,r){const o=this.getTunnelFromMap(d,a);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,d,a,c,i,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${a} on local port ${c}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},p=v(l,this.defaultTunnelHost,d,a,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(d,a,p),p}}};g=ce([ee(1,n.ILogService),ee(2,I.ISignService),ee(3,f.IProductService),ee(4,b.IConfigurationService)],g),e.BaseTunnelService=g;let P=class extends g{constructor(u,d,a,c){super(y.nodeSocketFactory,u,d,a,c)}};P=ce([ee(0,n.ILogService),ee(1,I.ISignService),ee(2,f.IProductService),ee(3,b.IConfigurationService)],P),e.TunnelService=P}),define(J[223],Z([0,1,193,17,16,2,13,21,47,89,6,192,217]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends M.Disposable{constructor(g,P,S){super();this.environmentService=P,this.logService=S,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,P){this.logService.trace("RequestService#request",g.url);const{proxyUrl:S,strictSSL:u}=this,d={...process.env,...await(0,m.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},a=g.agent?g.agent:await(0,y.getProxyAgent)(g.url||"",d,{proxyUrl:S,strictSSL:u});return g.agent=a,g.strictSSL=u,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,P)}async getNodeRequest(g){return((0,w.parse)(g.url).protocol==="https:"?await new Promise((u,d)=>{H(["https"],u,d)}):await new Promise((u,d)=>{H(["http"],u,d)})).request}_request(g,P){return new Promise(async(S,u)=>{let d;const a=(0,w.parse)(g.url),c=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,b.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),d=c(i,s=>{const r=(0,b.isNumber)(g.followRedirects)?g.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...g,url:s.headers.location,followRedirects:r-1},P).then(S,u);else{let o=s;s.headers["content-encoding"]==="gzip"&&(o=s.pipe((0,I.createGunzip)())),S({res:s,stream:(0,L.streamToBufferReadableStream)(o)})}}),d.on("error",u),g.timeout&&d.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&d.write(g.data),d.end(),P.onCancellationRequested(()=>{d.abort(),u((0,k.canceled)())})})}async resolveProxy(g){}};v=ce([ee(0,n.IConfigurationService),ee(1,f.INativeEnvironmentService),ee(2,t.ILogService)],v),e.RequestService=v}),define(J[224],Z([0,1,14,223]),function(H,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(b){return w.net.request}class M extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(J[225],Z([0,1,14,9,5,2,10,13,83,23,22,6,48,55,60]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(S,u,d,a,c,i,s){super();this.machineId=S,this.userEnv=u,this.environmentMainService=d,this.lifecycleMainService=a,this.logService=c,this.themeMainService=i,this.protocolMainService=s,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),w.ipcMain.on("vscode:createSharedProcessMessageChannel",async(S,u)=>this.onWindowConnection(S,u))}async onWindowConnection(S,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const d=await this.connect();if(S.sender.isDestroyed())return d.close();S.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[d])}onWillShutdown(){const S=this.window;!S||(!S.isDestroyed()&&!S.webContents.isDestroyed()&&S.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(S.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{S.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(S=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),S()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(S=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),S()}))})()),this._whenIpcReady}createWindow(){const S=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),S.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:I.default}),this.window.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=S=>{this.logService.trace("SharedProcess#close prevented"),S.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(S,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(S,u,d)=>this._onDidError.fire({type:3,details:{reason:d,exitCode:u}})))}async connect(){await this.whenIpcReady;const S=(0,n.assertIsDefined)(this.window);return(0,f.connect)(S)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=ce([ee(2,m.IEnvironmentMainService),ee(3,t.ILifecycleMainService),ee(4,y.ILogService),ee(5,h.IThemeMainService),ee(6,v.IProtocolMainService)],g),e.SharedProcess=g}),define(J[226],Z([0,1,9,17,7,13,8,23,19,6]),function(H,e,w,L,k,M,b,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(v,h,g){this.storagePath=v,this.logService=h,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}}getItem(v,h){const g=this.storage[v];return(0,M.isUndefinedOrNull)(g)?h:g}setItem(v,h){this.setItems([{key:v,data:h}])}setItems(v){let h=!1;for(const{key:g,data:P}of v)this.storage[g]!==P&&((0,M.isUndefinedOrNull)(P)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,h=!0):(this.storage[g]=P,h=!0));h&&this.save()}removeItem(v){(0,M.isUndefined)(this.storage[v])||(this.storage[v]=void 0,this.save())}async save(v){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),v)}async doSave(){if(!this.initializing)return;await this.initializing;const v=JSON.stringify(this.storage,null,4);if(v!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(v)),this.lastSavedStorageContents=v}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let y=class yt{constructor(v,h,g){this.fileStorage=new t(b.URI.file((0,k.join)(v.userDataPath,yt.STATE_FILE)),h,g)}async init(){return this.fileStorage.init()}getItem(v,h){return this.fileStorage.getItem(v,h)}setItem(v,h){this.fileStorage.setItem(v,h)}setItems(v){this.fileStorage.setItems(v)}removeItem(v){this.fileStorage.removeItem(v)}close(){return this.fileStorage.close()}};y.STATE_FILE="storage.json",y=ce([ee(0,n.IEnvironmentMainService),ee(1,m.ILogService),ee(2,f.IFileService)],y),e.StateMainService=y}),define(J[75],Z([0,1,9,24,5,21,23,22,6,20,50,42]),function(H,e,w,L,k,M,b,n,f,m,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(h,g,P){return`${P.updateUrl}/api/update/${h}/${g}/${P.commit}`}e.createUpdateURL=I;let v=class{constructor(g,P,S,u,d,a){this.lifecycleMainService=g,this.configurationService=P,this.environmentMainService=S,this.requestService=u,this.logService=d,this.productService=a,this._state=y.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(g);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(y.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,w.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};v=ce([ee(0,n.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,b.IEnvironmentMainService),ee(3,t.IRequestService),ee(4,f.ILogService),ee(5,m.IProductService)],v),e.AbstractUpdateService=v}),define(J[227],Z([0,1,14,46,5,2,21,23,22,6,20,50,32,42,75]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends h.AbstractUpdateService{constructor(S,u,d,a,c,i,s){super(S,u,a,c,i,s);this.telemetryService=d,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"error",(S,u)=>u)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(S,u,d)=>({url:u,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(S,u,d,a)=>({releaseNotes:u,version:d,productVersion:d,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(v.State.Idle(1,d))}buildUpdateFeedUrl(S){let u;this.productService.darwinUniversalAssetId?u=this.productService.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,h.createUpdateURL)(u,S,this.productService);try{w.autoUpdater.setFeedURL({url:d})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return d}doCheckForUpdates(S){this.setState(v.State.CheckingForUpdates(S)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(v.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([L.memoize],g.prototype,"onRawError",null),ce([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),ce([L.memoize],g.prototype,"onRawUpdateAvailable",null),ce([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ce([ee(0,f.ILifecycleMainService),ee(1,b.IConfigurationService),ee(2,I.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,y.IRequestService),ee(5,m.ILogService),ee(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(J[228],Z([0,1,41,30,9,5,7,23,22,6,32,42]),function(H,e,w,L,k,M,b,n,f,m,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(g,P,S){if(this.lifecycleMainService=g,this.logService=S,this._state=y.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=ce([ee(0,f.ILifecycleMainService),ee(1,n.IEnvironmentMainService),ee(2,m.ILogService)],I);let v=class extends I{constructor(g,P,S,u,d,a){super(S,u,d);this.snap=g,this.snapRevision=P,this.telemetryService=a;const c=(0,L.watch)(b.dirname(this.snap)),i=M.Event.fromNodeEventEmitter(c,"change",(l,p)=>p),s=M.Event.filter(i,l=>l==="current"),o=M.Event.debounce(s,(l,p)=>p,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{o.dispose(),c.close()})}doCheckForUpdates(){this.setState(y.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(y.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+b.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((S,u)=>(0,L.realpath)(`${b.dirname(this.snap)}/current`,(d,a)=>d?u(d):S(a))),P=b.basename(g);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};v=ce([ee(2,f.ILifecycleMainService),ee(3,n.IEnvironmentMainService),ee(4,m.ILogService),ee(5,t.ITelemetryService)],v),e.SnapUpdateService=v}),define(J[45],Z([0,1,14,30,5,40,31,2,10,7,3,15,13,18,153,51,52,23,4,6,20,99,27,100]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,u.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(l,p,E,D,R){super();this.environmentMainService=l,this.logService=p,this.backupMainService=E,this.dialogMainService=D,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,p=>(0,L.readFileSync)(p,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,p=>v.Promises.readFile(p,"utf8"))}doResolveLocalWorkspace(l,p){if(!!this.isWorkspacePath(l)&&l.scheme===f.Schemas.file)try{const E=p(l.fsPath);return E instanceof Promise?E.then(D=>this.doResolveWorkspace(l,D),D=>{}):this.doResolveWorkspace(l,E)}catch{return}}isWorkspacePath(l){return(0,i.isUntitledWorkspace)(l,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,p){try{const E=this.doParseStoredWorkspace(l,p),D=(0,s.getWorkspaceIdentifier)(l);return{id:D.id,configPath:D.configPath,folders:(0,i.toWorkspaceFolders)(E.folders,D.configPath,y.extUriBiasedIgnorePathCase),remoteAuthority:E.remoteAuthority,transient:E.transient}}catch(E){this.logService.warn(E.toString())}}doParseStoredWorkspace(l,p){const E=(0,M.parse)(p);if(E&&Array.isArray(E.folders))E.folders=E.folders.filter(D=>(0,i.isStoredWorkspaceFolder)(D));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return E}async createUntitledWorkspace(l,p){const{workspace:E,storedWorkspace:D}=this.newUntitledWorkspace(l,p),R=E.configPath.fsPath;return await v.Promises.mkdir((0,m.dirname)(R),{recursive:!0}),await v.Promises.writeFile(R,JSON.stringify(D,null,"	")),E}createUntitledWorkspaceSync(l,p){const{workspace:E,storedWorkspace:D}=this.newUntitledWorkspace(l,p),R=E.configPath.fsPath;return(0,L.mkdirSync)((0,m.dirname)(R),{recursive:!0}),(0,v.writeFileSync)(R,JSON.stringify(D,null,"	")),E}newUntitledWorkspace(l=[],p){const E=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,y.joinPath)(this.untitledWorkspacesHome,E),R=(0,y.joinPath)(D,i.UNTITLED_WORKSPACE_NAME),W=[];for(const N of l)W.push((0,i.getStoredWorkspaceFolder)(N.uri,!0,N.name,D,!t.isWindows,y.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(R),storedWorkspace:{folders:W,remoteAuthority:p}}}async getWorkspaceIdentifier(l){return(0,s.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,i.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const p=(0,y.originalFSPath)(l.configPath);try{(0,v.rimrafSync)((0,m.dirname)(p));const E=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(E)&&(0,v.writeFileSync)((0,m.join)(E,"obsolete"),"")}catch(E){this.logService.warn(`Unable to delete untitled workspace ${p} (${E}).`)}}getUntitledWorkspacesSync(){const l=[];try{const p=(0,v.readdirSync)(this.untitledWorkspacesHome.fsPath).map(E=>(0,y.joinPath)(this.untitledWorkspacesHome,E,i.UNTITLED_WORKSPACE_NAME));for(const E of p){const D=(0,s.getWorkspaceIdentifier)(E),R=this.resolveLocalWorkspaceSync(E);R?l.push({workspace:D,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(p){p.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${p}).`)}return l}async enterWorkspace(l,p,E){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,p,E))return;const R=this.doEnterWorkspace(l,(0,s.getWorkspaceIdentifier)(E));if(!!R)return this._onDidEnterWorkspace.fire({window:l,workspace:R.workspace}),R}async isValidTargetWorkspacePath(l,p,E){if(!E)return!0;if((0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,E))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(p,E)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,h.localize)(0,null))],message:(0,h.localize)(1,null,(0,y.basename)(E)),detail:(0,h.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,I.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,p){if(!l.config)return;l.focus();let E;return l.config.extensionDevelopmentPath||(E=this.backupMainService.registerWorkspaceBackupSync({workspace:p,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=p,l.config.backupPath=E,{workspace:p,backupPath:E}}};r=ce([ee(0,S.IEnvironmentMainService),ee(1,d.ILogService),ee(2,g.IBackupMainService),ee(3,P.IDialogMainService),ee(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(J[101],Z([0,1,14,36,24,3,13,8,18,21,54,4,6,97,35,27,45]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,y.createDecorator)(e.ID);let S=class{constructor(d,a,c,i,s){this.logService=d,this.windowsMainService=a,this.urlService=c,this.workspacesManagementMainService=i,this.configurationService=s}async start(d,a){this.logService.trace("Received data from other instance: ",d,a),M.isMacintosh&&w.app.focus({steal:!0});const c=this.parseOpenUrl(d);if(c.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:s,url:r}of c)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(d,a)}parseOpenUrl(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,L.coalesce)(d._urls.map(a=>{try{return{uri:n.URI.parse(a),url:a}}catch(c){return null}})):[]}async startOpenWindow(d,a){const c=(0,t.isLaunchedFromCli)(a)?0:4;let i=[];const s=d.wait&&d.waitMarkerFilePath?n.URI.file(d.waitMarkerFilePath):void 0,r=d.remote||void 0;if(d.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,{context:c,cli:d,userEnv:a,waitMarkerFileURI:s,remoteAuthority:r});else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let o=!1;if(d["new-window"]||d["unity-launch"])o=!0;else if(d["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!M.isMacintosh}if(o)i=this.windowsMainService.open({context:c,cli:d,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:s,remoteAuthority:r});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),i=[l]):i=this.windowsMainService.open({context:c,cli:d,forceEmpty:!0,remoteAuthority:r})}}else i=this.windowsMainService.open({context:c,cli:d,userEnv:a,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],waitMarkerFileURI:s,gotoLineMode:d.goto,remoteAuthority:r});if(s&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const d=[];return w.BrowserWindow.getAllWindows().forEach(a=>{const c=this.windowsMainService.getWindowById(a.id);c?d.push(this.codeWindowToInfo(c)):d.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(d){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(i=>new Promise(s=>{const r=i.remoteAuthority;if(r){const o=`vscode:getDiagnosticInfoResponse${i.id}`,l={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:o,args:l}),w.ipcMain.once(o,(p,E)=>{E||s({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),s(E)}),setTimeout(()=>{s({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else s(void 0)})))).filter(i=>!!i)}getFolderURIs(d){const a=[],c=d.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(c))a.push(c.uri);else if((0,g.isWorkspaceIdentifier)(c)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);i&&i.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(d){const a=this.getFolderURIs(d),c=(0,b.assertIsDefined)(d.win);return this.browserWindowToInfo(c,a,d.remoteAuthority)}browserWindowToInfo(d,a=[],c){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:a,remoteAuthority:c}}};S=ce([ee(0,I.ILogService),ee(1,h.IWindowsMainService),ee(2,v.IURLService),ee(3,P.IWorkspacesManagementMainService),ee(4,m.IConfigurationService)],S),e.LaunchMainService=S}),define(J[53],Z([0,1,41,14,26,114,46,5,31,2,10,7,3,8,80,66,18,145,52,23,4,22,6,20,32,60,35,27,45]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c,i,s,r,o,l,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let D=class ct extends m.Disposable{constructor(W,N,G,x,ne,V,Q,U,C,T){super();this.sharedProcess=W,this.windowsMainService=N,this.dialogMainService=G,this.lifecycleMainService=x,this.environmentMainService=ne,this.telemetryService=V,this.logService=Q,this.productService=U,this.themeMainService=C,this.workspacesManagementMainService=T,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,z=>z.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(z,B)=>B.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(z,B)=>B.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(z,B)=>B.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),z=>!!z),z=>z.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(z,B)=>B.id),z=>!!this.windowsMainService.getWindowById(z))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(z,B,O)=>O),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(N=>({id:N.id,workspace:N.openedWorkspace,title:N.win?.getTitle()??"",filename:N.getRepresentedFilename(),dirty:N.isDocumentEdited()}))}async getWindowCount(W){return this.windowsMainService.getWindowCount()}async getActiveWindowId(W){const N=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(N)return N.id}openWindow(W,N,G){return Array.isArray(N)?this.doOpenWindow(W,N,G):this.doOpenEmptyWindow(W,N)}async doOpenWindow(W,N,G=Object.create(null)){N.length>0&&this.windowsMainService.open({context:5,contextWindowId:W,urisToOpen:N,cli:this.environmentMainService.args,forceNewWindow:G.forceNewWindow,forceReuseWindow:G.forceReuseWindow,preferNewWindow:G.preferNewWindow,diffMode:G.diffMode,addMode:G.addMode,gotoLineMode:G.gotoLineMode,noRecentEntry:G.noRecentEntry,waitMarkerFileURI:G.waitMarkerFileURI,remoteAuthority:G.remoteAuthority||void 0})}async doOpenEmptyWindow(W,N){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:W},N)}async toggleFullScreen(W){const N=this.windowById(W);N&&N.toggleFullScreen()}async handleTitleDoubleClick(W){const N=this.windowById(W);N&&N.handleTitleDoubleClick()}async isMaximized(W){const N=this.windowById(W);return N?.win?N.win.isMaximized():!1}async maximizeWindow(W){const N=this.windowById(W);N?.win&&N.win.maximize()}async unmaximizeWindow(W){const N=this.windowById(W);N?.win&&N.win.unmaximize()}async minimizeWindow(W){const N=this.windowById(W);N?.win&&N.win.minimize()}async focusWindow(W,N){N&&typeof N.windowId=="number"&&(W=N.windowId);const G=this.windowById(W);G&&G.focus({force:N?.force??!1})}async setMinimumSize(W,N,G){const x=this.windowById(W);if(x?.win){const[ne,V]=x.win.getSize(),[Q,U]=x.win.getMinimumSize(),[C,T]=[N??Q,G??U],[z,B]=[Math.max(ne,C),Math.max(V,T)];(Q!==C||U!==T)&&x.win.setMinimumSize(C,T),(ne!==z||V!==B)&&x.win.setSize(z,B)}}async saveWindowSplash(W,N){this.themeMainService.saveWindowSplash(W,N)}async installShellCommand(W){const{source:N,target:G}=await this.getShellCommandLink();try{const{symbolicLink:x}=await P.SymlinkSupport.stat(N);if(x&&!x.dangling){const ne=await(0,h.realpath)(N);if(G===ne)return}await P.Promises.unlink(N)}catch(x){if(x.code!=="ENOENT")throw x}try{await P.Promises.symlink(G,N)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:ne}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${G}' '${N}'\\" with administrator privileges"`;await(0,M.promisify)(w.exec)(V)}catch(V){throw new Error((0,S.localize)(3,null,N))}}}async uninstallShellCommand(W){const{source:N}=await this.getShellCommandLink();try{await P.Promises.unlink(N)}catch(G){switch(G.code){case"EACCES":const{response:x}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const ne=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,M.promisify)(w.exec)(ne)}catch(ne){throw new Error((0,S.localize)(7,null,N))}break;case"ENOENT":break;default:throw G}}}async getShellCommandLink(){const W=(0,y.resolve)(this.environmentMainService.appRoot,"bin","code"),N=`/usr/local/bin/${this.productService.applicationName}`;if(!await P.Promises.exists(W))throw new Error((0,S.localize)(8,null,W));return{source:N,target:W}}async showMessageBox(W,N){return this.dialogMainService.showMessageBox(N,this.toBrowserWindow(W))}async showSaveDialog(W,N){return this.dialogMainService.showSaveDialog(N,this.toBrowserWindow(W))}async showOpenDialog(W,N){return this.dialogMainService.showOpenDialog(N,this.toBrowserWindow(W))}toBrowserWindow(W){const N=this.windowById(W);if(N?.win)return N.win}async pickFileFolderAndOpen(W,N){const G=await this.dialogMainService.pickFileFolder(N);G&&(this.sendPickerTelemetry(G,N.telemetryEventName||"openFileFolder",N.telemetryExtraData),this.doOpenPicked(await Promise.all(G.map(async x=>await P.SymlinkSupport.existsDirectory(x)?{folderUri:v.URI.file(x)}:{fileUri:v.URI.file(x)})),N,W))}async pickFolderAndOpen(W,N){const G=await this.dialogMainService.pickFolder(N);G&&(this.sendPickerTelemetry(G,N.telemetryEventName||"openFolder",N.telemetryExtraData),this.doOpenPicked(G.map(x=>({folderUri:v.URI.file(x)})),N,W))}async pickFileAndOpen(W,N){const G=await this.dialogMainService.pickFile(N);G&&(this.sendPickerTelemetry(G,N.telemetryEventName||"openFile",N.telemetryExtraData),this.doOpenPicked(G.map(x=>({fileUri:v.URI.file(x)})),N,W))}async pickWorkspaceAndOpen(W,N){const G=await this.dialogMainService.pickWorkspace(N);G&&(this.sendPickerTelemetry(G,N.telemetryEventName||"openWorkspace",N.telemetryExtraData),this.doOpenPicked(G.map(x=>({workspaceUri:v.URI.file(x)})),N,W))}doOpenPicked(W,N,G){this.windowsMainService.open({context:3,contextWindowId:G,cli:this.environmentMainService.args,urisToOpen:W,forceNewWindow:N.forceNewWindow})}sendPickerTelemetry(W,N,G){const x=W?W.length:0;this.telemetryService.publicLog(N,{...G,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(W,N){L.shell.showItemInFolder(N)}async setRepresentedFilename(W,N){const G=this.windowById(W);G&&G.setRepresentedFilename(N)}async setDocumentEdited(W,N){const G=this.windowById(W);G&&G.setDocumentEdited(N)}async openExternal(W,N){return I.isLinuxSnap?this.safeSnapOpenExternal(N):L.shell.openExternal(N),!0}safeSnapOpenExternal(W){const N=process.env.GDK_PIXBUF_MODULE_FILE,G=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(W),process.env.GDK_PIXBUF_MODULE_FILE=N,process.env.GDK_PIXBUF_MODULEDIR=G}moveItemToTrash(W,N){return L.shell.trashItem(N)}async isAdmin(){let W;return I.isWindows?W=(await new Promise((N,G)=>{H(["native-is-elevated"],N,G)}))():W=process.getuid()===0,W}async writeElevated(W,N,G,x){const ne=await new Promise((V,Q)=>{H(["sudo-prompt"],V,Q)});return new Promise((V,Q)=>{const U=[`"${this.cliPath}"`];x?.unlock&&U.push("--file-chmod"),U.push("--file-write",`"${N.fsPath}"`,`"${G.fsPath}"`);const C={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ne.exec(U.join(" "),C,(T,z,B)=>{z&&this.logService.trace(`[sudo-prompt] received stdout: ${z}`),B&&this.logService.trace(`[sudo-prompt] received stderr: ${B}`),T?Q(T):V(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,y.join)(this.environmentMainService.appRoot,"bin","code"):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(W,N,G){process.kill(N,G)}async readClipboardText(W,N){return L.clipboard.readText(N)}async writeClipboardText(W,N,G){return L.clipboard.writeText(N,G)}async readClipboardFindText(W){return L.clipboard.readFindText()}async writeClipboardFindText(W,N){return L.clipboard.writeFindText(N)}async writeClipboardBuffer(W,N,G,x){return L.clipboard.writeBuffer(N,Buffer.from(G),x)}async readClipboardBuffer(W,N){return L.clipboard.readBuffer(N)}async hasClipboard(W,N,G){return L.clipboard.has(N,G)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,N){const G=this.windowById(W);G&&G.updateTouchBar(N)}async notifyReady(W){const N=this.windowById(W);N&&N.setReady()}async relaunch(W,N){return this.lifecycleMainService.relaunch(N)}async reload(W,N){const G=this.windowById(W);if(G){if((0,p.isWorkspaceIdentifier)(G.openedWorkspace)){const x=G.openedWorkspace.configPath;if(x.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(G.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(G,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(W){this.closeWindowById(W,W)}async closeWindowById(W,N){const G=this.windowById(N);if(G?.win)return G.win.close()}async quit(W){const N=this.windowsMainService.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&N.win?N.win.close():this.lifecycleMainService.quit()}async exit(W,N){await this.lifecycleMainService.kill(N)}async resolveProxy(W,N){const x=this.windowById(W)?.win?.webContents?.session;if(x)return x.resolveProxy(N)}async openDevTools(W,N){const G=this.windowById(W);G?.win&&G.win.webContents.openDevTools(N)}async toggleDevTools(W){const N=this.windowById(W);N?.win&&N.win.webContents.toggleDevTools()}async sendInputEvent(W,N){const G=this.windowById(W);G?.win&&(N.type==="mouseDown"||N.type==="mouseUp")&&G.win.webContents.sendInputEvent(N)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(W,N,G,x){if(!I.isWindows)return;const ne=await new Promise((V,Q)=>{H(["vscode-windows-registry"],V,Q)});try{return ne.GetStringRegKey(N,G,x)}catch{return}}async getPassword(W,N,G){const x=await this.withKeytar(),ne=await x.getPassword(N,G);if(ne)try{let{content:V,hasNextChunk:Q}=JSON.parse(ne);if(!V||!Q)return ne;let U=1;for(;Q;){const C=await x.getPassword(N,`${G}-${U}`),T=JSON.parse(C);V+=T.content,Q=T.hasNextChunk,U++}return V}catch{return ne}return ne}async setPassword(W,N,G,x){const ne=await this.withKeytar(),V=3,Q=async(U,C,T)=>{let z=0,B;for(;z<V;)try{await ne.setPassword(U,C,T);return}catch(O){B=O,this.logService.warn("Error attempting to set a password: ",O),z++,await new Promise($=>setTimeout($,200))}throw B};if(I.isWindows&&x.length>ct.MAX_PASSWORD_LENGTH){let U=0,C=0,T=!0;for(;T;){const z=x.substring(U,U+ct.PASSWORD_CHUNK_SIZE);U+=ct.PASSWORD_CHUNK_SIZE,T=x.length-U>0;const B={content:z,hasNextChunk:T};await Q(N,C?`${G}-${C}`:G,JSON.stringify(B)),C++}}else await Q(N,G,x);this._onDidChangePassword.fire({service:N,account:G})}async deletePassword(W,N,G){const ne=await(await this.withKeytar()).deletePassword(N,G);return ne&&this._onDidChangePassword.fire({service:N,account:G}),ne}async findPassword(W,N){return(await this.withKeytar()).findPassword(N)}async findCredentials(W,N){return(await this.withKeytar()).findCredentials(N)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((W,N)=>{H(["keytar"],W,N)})}windowById(W){if(typeof W=="number")return this.windowsMainService.getWindowById(W)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,ce([b.memoize],D.prototype,"cliPath",null),D=ce([ee(1,l.IWindowsMainService),ee(2,u.IDialogMainService),ee(3,c.ILifecycleMainService),ee(4,d.IEnvironmentMainService),ee(5,r.ITelemetryService),ee(6,i.ILogService),ee(7,s.IProductService),ee(8,o.IThemeMainService),ee(9,E.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(J[229],Z([0,1,14,24,5,78,2,28,87,6,53,20,35]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var v;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let h=class extends b.Disposable{constructor(P,S,u,d,a){super();this.logService=P,this.windowsMainService=S,this.nativeHostMainService=u,this.encryptionMainService=d,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=v.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=k.Event.fromNodeEventEmitter(w.app,"login",(S,u,d,a,c)=>({event:S,webContents:u,req:d,authInfo:a,callback:c}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:S,req:u,callback:d}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===v.LoginDialogShown&&u.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(a?.username,a?.password)}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(P);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){this.logService.trace("auth#doResolveProxyCredentials - enter",P);const S=String((0,M.hash)({scheme:P.scheme,host:P.host,port:P.port}));let u,d;try{const s=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(s){const r=JSON.parse(await this.encryptionMainService.decrypt(s));u=r.username,d=r.password}}catch(s){this.logService.error(s)}if(this.state!==v.StoredCredentialsUsed&&typeof u=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=v.StoredCredentialsUsed,{username:u,password:d};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const c={authInfo:P,username:this.sessionCredentials?.username??u,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,c),this.state=v.LoginDialogShown;const i=await new Promise(s=>{const r=async(o,l,p)=>{if(l===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),p){const E={username:p.username,password:p.password};try{if(p.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(E));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(D){this.logService.error(D)}s({username:E.username,password:E.password})}else s(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};h=ce([ee(0,m.ILogService),ee(1,I.IWindowsMainService),ee(2,t.INativeHostMainService),ee(3,f.IEncryptionMainService),ee(4,y.IProductService)],h),e.ProxyAuthHandler=h}),define(J[230],Z([0,1,14,26,31,2,10,3,81,143,70,52,23,4,101,6,53,48,20,55,61]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");let c=class St{constructor(s,r,o,l,p,E,D,R,W){this.userEnv=s,this.environmentMainService=r,this.launchMainService=o,this.logService=l,this.diagnosticsService=p,this.dialogMainService=E,this.nativeHostMainService=D,this.protocolMainService=R,this.productService=W,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[r,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(r,o);this.safeSend(s,"vscode:issueSystemInfoResponse",l)}),w.ipcMain.on("vscode:listProcesses",async s=>{const r=[];try{const o=await this.launchMainService.getMainProcessId();r.push({name:(0,m.localize)(0,null),rootProcess:await(0,f.listProcesses)(o)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(p=>{(0,t.isRemoteDiagnosticError)(p)?r.push({name:p.hostName,rootProcess:p}):p.processes&&r.push({name:p.hostName,rootProcess:p.processes})})}catch(o){this.logService.error(`Listing processes failed: ${o}`)}this.safeSend(s,"vscode:listProcessesResponse",r)}),w.ipcMain.on("vscode:issueReporterClipboard",async s=>{const r={title:this.productService.nameLong,message:(0,m.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,m.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const o=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",o.response===0)}}),w.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const r=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",r)}),w.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,m.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),w.ipcMain.on("vscode:workbenchCommand",(s,r)=>{const{id:o,from:l,args:p}=r;let E;switch(l){case"issueReporter":E=this.issueReporterParentWindow;break;case"processExplorer":E=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}E&&E.webContents.send("vscode:runAction",{id:o,from:l,args:p})}),w.ipcMain.on("vscode:openExternal",(s,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),w.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),w.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),w.ipcMain.on("vscode:windowsInfoRequest",async s=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",r.windows)})}safeSend(s,r,...o){s.sender.isDestroyed()||s.sender.send(r,...o)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,o=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,o,{backgroundColor:s.styles.backgroundColor,title:(0,m.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1}),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:S.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",H).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,o=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,o,{backgroundColor:s.styles.backgroundColor,title:(0,m.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0}),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:S.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",H).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(s,r,o){const l=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o.title,backgroundColor:o.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,r)}getWindowPosition(s,r,o){let l;const p=w.screen.getAllDisplays();if(p.length===1)l=p[0];else{if(n.isMacintosh){const R=w.screen.getCursorScreenPoint();l=w.screen.getDisplayNearestPoint(R)}!l&&s&&(l=w.screen.getDisplayMatching(s.getBounds())),l||(l=w.screen.getPrimaryDisplay()||p[0])}const E={width:r,height:o},D=l.bounds;return E.x=D.x+D.width/2-E.width/2,E.y=D.y+D.height/2-E.height/2,D.width>0&&D.height>0&&(E.x<D.x&&(E.x=D.x),E.y<D.y&&(E.y=D.y),E.x>D.x+D.width&&(E.x=D.x),E.y>D.y+D.height&&(E.y=D.y),E.width>D.width&&(E.width=D.width),E.height>D.height&&(E.height=D.height)),E}async getPerformanceInfo(){try{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,r)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ce([ee(1,I.IEnvironmentMainService),ee(2,h.ILaunchMainService),ee(3,g.ILogService),ee(4,t.IDiagnosticsService),ee(5,y.IDialogMainService),ee(6,P.INativeHostMainService),ee(7,d.IProtocolMainService),ee(8,u.IProductService)],c),e.IssueMainService=c}),define(J[231],Z([0,1,24,21,23,22,6,53,20,50,32,42,75]),function(H,e,w,L,k,M,b,n,f,m,t,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends I.AbstractUpdateService{constructor(g,P,S,u,d,a,c,i){super(g,P,u,d,a,i);this.telemetryService=S,this.nativeHostMainService=c}buildUpdateFeedUrl(g){return(0,I.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(y.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},w.CancellationToken.None).then(m.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const S=g?P.message||P:void 0;this.setState(y.State.Idle(1,S))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(y.State.Idle(1))}};v=ce([ee(0,M.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,t.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,m.IRequestService),ee(5,b.ILogService),ee(6,n.INativeHostMainService),ee(7,f.IProductService)],v),e.LinuxUpdateService=v}),define(J[232],Z([0,1,41,30,26,9,24,46,7,8,112,18,21,23,19,22,6,53,20,50,32,42,75]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(p,E=1e3){for(;!p();)await(0,M.timeout)(E)}let r;function o(){return typeof r=="undefined"&&(r=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let l=class extends i.AbstractUpdateService{constructor(E,D,R,W,N,G,x,ne,V){super(E,D,W,N,G,V);this.telemetryService=R,this.fileService=x,this.nativeHostMainService=ne}get cachePath(){const E=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return y.Promises.mkdir(E,{recursive:!0}).then(()=>E)}initialize(){super.initialize(),o()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(E){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),o()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,i.createUpdateURL)(D,E,this.productService)}doCheckForUpdates(E){!this.url||(this.setState(c.State.CheckingForUpdates(E)),this.requestService.request({url:this.url},b.CancellationToken.None).then(d.asJson).then(D=>{const R=o();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(c.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(W=>y.Promises.exists(W).then(N=>{if(N)return Promise.resolve(W);const G=D.url,x=D.hash,ne=`${W}.tmp`;return this.requestService.request({url:G},b.CancellationToken.None).then(V=>this.fileService.writeFile(m.URI.file(ne),V.stream)).then(x?()=>(0,t.checksum)(ne,D.hash):()=>{}).then(()=>y.Promises.rename(ne,W)).then(()=>W)})).then(W=>{const N=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:W},N&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(D)):this.setState(c.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E});const R=E?D.message||D:void 0;this.setState(c.State.Idle(o(),R))}))}async doDownloadUpdate(E){E.update.url&&this.nativeHostMainService.openExternal(void 0,E.update.url),this.setState(c.State.Idle(o()))}async getUpdatePackagePath(E){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${E}.exe`)}async cleanup(E=null){const D=E?G=>!new RegExp(`${this.productService.quality}-${E}\\.exe$`).test(G):()=>!0,R=await this.cachePath,N=(await y.Promises.readdir(R)).filter(D).map(async G=>{try{await y.Promises.unlink(f.join(R,G))}catch(x){}});await Promise.all(N)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const E=this.state.update;this.setState(c.State.Updating(E));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${E.version}.flag`),await y.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(o()))});const W=`${this.productService.win32MutexName}-ready`,N=await new Promise((G,x)=>{H(["windows-mutex"],G,x)});s(()=>N.isActive(W)).then(()=>this.setState(c.State.Ready(E)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}};ce([n.memoize],l.prototype,"cachePath",null),l=ce([ee(0,g.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,a.ITelemetryService),ee(3,v.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,P.ILogService),ee(6,h.IFileService),ee(7,S.INativeHostMainService),ee(8,u.IProductService)],l),e.Win32UpdateService=l}),define(J[233],Z([0,1,14,9,24,5,31,2,10,7,72,3,8,149,51,21,52,23,54,199,19,22,6,20,55,98,32,203,60,61,35,27,45]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c,i,s,r,o,l,p,E,D,R,W,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.LOADING=1]="LOADING",ne[ne.NAVIGATING=2]="NAVIGATING",ne[ne.READY=3]="READY"})(G||(G={}));let x=class extends n.Disposable{constructor(V,Q,U,C,T,z,B,O,$,F,A,_,j,Y){super();this.logService=Q,this.environmentMainService=U,this.fileService=C,this.configurationService=z,this.themeMainService=B,this.workspacesManagementMainService=O,this.backupMainService=$,this.telemetryService=F,this.dialogMainService=A,this.lifecycleMainService=_,this.productService=j,this.protocolMainService=Y,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[q,X]=this.restoreWindowState(V.state);this.windowState=q,this.logService.trace("window#ctor: using window state",q);const ie=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),ae={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!ie,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};y.isLinux?ae.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(ae.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(ae.fullscreenable=!1),y.isMacintosh&&(ae.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(ae.acceptFirstMouse=!1));const ue=y.isMacintosh&&se?.nativeTabs===!0;ue&&(ae.tabbingIdentifier=this.productService.nameShort);const re=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(re&&(ae.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,y.isMacintosh||(ae.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(ae),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),y.isMacintosh&&re&&this._win.setSheetOffset(22),y.isMacintosh&&X&&(!ue||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(le=>typeof le=="number")){const le=this.windowState;this._win.setBounds({width:le.width,height:le.height,x:le.x,y:le.y})}ie&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,d.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:q=>T.globalStorage.get(q),store:(q,X)=>T.globalStorage.set(q,X)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(V){y.isMacintosh?this._win.setRepresentedFilename(V):this.representedFilename=V}getRepresentedFilename(){return y.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(V){y.isMacintosh&&this._win.setDocumentEdited(V),this.documentEdited=V}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(V){y.isMacintosh&&V?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(V=>{if(this.isReady)return V(this);this.whenReadyCallbacks.push(V)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(V=>{function Q(){U.dispose(),C.dispose(),V()}const U=this.onDidClose(()=>Q()),C=this.onWillLoad(()=>Q())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(T,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(T,z,B)=>this.onWindowError(3,{reason:B,exitCode:z})),this._win.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const V=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Q=T=>{for(let z=T;z;z=z.parent)if(z.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},U=T=>T.resourceType==="xhr"||Q(T.frame);this._win.webContents.session.webRequest.onBeforeRequest((T,z)=>{const B=I.URI.parse(T.url);return B.path.endsWith(".svg")&&!(V.has(B.scheme)||B.path.includes(f.Schemas.vscodeRemoteResource))?z({cancel:!U(T)}):z({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((T,z)=>{const B=T.responseHeaders,O=B["content-type"]||B["Content-Type"];if(O&&Array.isArray(O)){const $=I.URI.parse(T.url);if($.path.endsWith(".svg")&&V.has($.scheme))return B["Content-Type"]=["image/svg+xml"],z({cancel:!1,responseHeaders:B});if(!$.path.includes(f.Schemas.vscodeRemoteResource)&&O.some(F=>F.toLowerCase().includes("image/svg")))return z({cancel:!U(T)})}return z({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",T=>{this.currentConfig&&(this.currentConfig.maximized=!0),w.app.emit("browser-window-maximize",T,this._win)}),this._win.on("unmaximize",T=>{this.currentConfig&&(this.currentConfig.maximized=!1),w.app.emit("browser-window-unmaximize",T,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(T=>this.onDidDeleteUntitledWorkspace(T)));const C=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:C},async(T,z)=>{const B=await this.marketplaceHeadersPromise;z({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,B)})})}async onWindowError(V,Q){switch(V){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:V,reason:Q?.reason,code:Q?.exitCode}),V){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(V===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,v.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,v.localize)(2,null))],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;U.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):U.response===2&&this.destroyWindow()}else if(V===2){let U;Q?U=(0,v.localize)(6,null,Q.reason,Q.exitCode??"<unknown>"):U=(0,v.localize)(5,null);const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,v.localize)(7,null)),(0,b.mnemonicButtonLabel)((0,v.localize)(8,null))],message:U,detail:(0,v.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;C.response===0?this.reload():C.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(V){this.openedWorkspace?.id===V.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const V=this.getMenuBarVisibility();V!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=V,this.setMenuBarVisibility(V));let Q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Q?.endsWith("/")&&(Q=Q.substr(0,Q.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Q||"").indexOf("@")===-1&&(Q!==this.currentHttpProxy||U!==this.currentNoProxy)){this.currentHttpProxy=Q,this.currentNoProxy=U;const C=Q||"",T=U?`${U},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${T}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:T,pacScript:""})}}addTabbedWindow(V){y.isMacintosh&&V.win&&this._win.addTabbedWindow(V.win)}load(V,Q=Object.create(null)){this.isDocumentEdited()&&(!Q.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(V,Q),this.readyState===0?this.currentConfig=V:(this.pendingLoadConfig=V,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",H).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:V.workspace,reason:Q.isReload?3:U?2:1})}updateConfiguration(V,Q){const U=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(U){const C=(0,u.isLaunchedFromCli)(U)&&!(0,u.isLaunchedFromCli)(V.userEnv),T=this.isExtensionDevelopmentHost;(C||T)&&(V.userEnv={...U,...V.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(V.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Q.disableExtensions!==void 0&&(V["disable-extensions"]=Q.disableExtensions),V.fullscreen=this.isFullScreen,V.maximized=this._win.isMaximized(),V.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),V.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(V)}async reload(V){const Q=Object.assign({},this.currentConfig);Q.workspace=await this.validateWorkspaceBeforeReload(Q),delete Q.filesToOpenOrCreate,delete Q.filesToDiff,delete Q.filesToWait,this.isExtensionDevelopmentHost&&V&&(Q.verbose=V.verbose,Q.debugId=V.debugId,Q["inspect-extensions"]=V["inspect-extensions"],Q["inspect-brk-extensions"]=V["inspect-brk-extensions"],Q["extensions-dir"]=V["extensions-dir"]),Q.isInitialStartup=!1,this.load(Q,{isReload:!0,disableExtensions:V?.["disable-extensions"]})}async validateWorkspaceBeforeReload(V){if((0,W.isWorkspaceIdentifier)(V.workspace)){const Q=V.workspace.configPath;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(V.workspace)){const Q=V.workspace.uri;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}return V.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let U;try{U=w.screen.getDisplayMatching(this.getBounds())}catch(z){}const C=(0,R.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const V=Object.create(null);let Q;if(!y.isMacintosh&&this._win.isMaximized()?Q=0:Q=1,Q===0?V.mode=0:V.mode=1,Q===1||Q===0){let U;Q===1?U=this.getBounds():U=this._win.getNormalBounds(),V.x=U.x,V.y=U.y,V.width=U.width,V.height=U.height}return V}restoreWindowState(V){(0,t.mark)("code/willRestoreCodeWindowState");let Q=!1;if(V)try{const U=w.screen.getAllDisplays();Q=U.length>1,V=this.validateWindowState(V,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[V||(0,R.defaultWindowState)(),Q]}validateWindowState(V,Q){if(this.logService.trace(`window#validateWindowState: validating window state on ${Q.length} display(s)`,V),typeof V.x!="number"||typeof V.y!="number"||typeof V.width!="number"||typeof V.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(V.width<=0||V.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Q.length===1){const T=this.getWorkingArea(Q[0]);if(T){let z=function(){!V||typeof V.x!="number"||typeof V.y!="number"||!T||(V.x<T.x&&(V.x=T.x),V.y<T.y&&(V.y=T.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",T),z(),V.width>T.width&&(V.width=T.width),V.height>T.height&&(V.height=T.height),V.x>T.x+T.width-128&&(V.x=T.x+T.width-V.width),V.y>T.y+T.height-128&&(V.y=T.y+T.height-V.height),z()}return V}if(V.display&&V.mode===3){const T=Q.find(z=>z.id===V.display);if(T&&typeof T.bounds?.x=="number"&&typeof T.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const z=(0,R.defaultWindowState)(3);return z.x=T.bounds.x,z.y=T.bounds.y,z}}let U,C;try{U=w.screen.getDisplayMatching({x:V.x,y:V.y,width:V.width,height:V.height}),C=this.getWorkingArea(U)}catch(T){}if(U&&C&&V.x+V.width>C.x&&V.y+V.height>C.y&&V.x<C.x+C.width&&V.y<C.y+C.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",C),V}getWorkingArea(V){if(V.workArea.width>0&&V.workArea.height>0)return V.workArea;if(V.bounds.width>0&&V.bounds.height>0)return V.bounds}getBounds(){const[V,Q]=this._win.getPosition(),[U,C]=this._win.getSize();return{x:V,y:Q,width:U,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(V){this.useNativeFullScreen()?this.setNativeFullScreen(V):this.setSimpleFullScreen(V),this.sendWhenReady(V?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(V){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(V)}setSimpleFullScreen(V){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(V),this._win.webContents.focus()}useNativeFullScreen(){const V=this.configurationService.getValue("window");return!V||typeof V.nativeFullScreen!="boolean"||V.nativeTabs?!0:V.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let V=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(V)<0&&(V="classic"),V}setMenuBarVisibility(V,Q=!0){y.isMacintosh||(V==="toggle"&&Q&&this.send("vscode:showInfoMessage",(0,v.localize)(10,null)),V==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(V)}):this.doSetMenuBarVisibility(V))}doSetMenuBarVisibility(V){const Q=this.isFullScreen;switch(V){case"classic":this._win.setMenuBarVisibility(!Q),this._win.autoHideMenuBar=Q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(V,Q,...U){this.isReady?this.send(V,...U):this.ready().then(()=>{Q.isCancellationRequested||this.send(V,...U)})}send(V,...Q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${V} for window that is destroyed`);return}this._win.webContents.send(V,...Q)}}updateTouchBar(V){!y.isMacintosh||this.touchBarGroups.forEach((Q,U)=>{const C=V[U];Q.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!y.isMacintosh){for(let V=0;V<10;V++){const Q=this.createTouchBarGroup();this.touchBarGroups.push(Q)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(V=[]){const Q=this.createTouchBarGroupSegments(V),U=new w.TouchBar.TouchBarSegmentedControl({segments:Q,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:U.segments[C].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(V=[]){return V.map(U=>{let C;U.icon&&!p.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===f.Schemas.file&&(C=w.nativeImage.createFromPath(I.URI.revive(U.icon.dark).fsPath),C.isEmpty()&&(C=void 0));let T;return typeof U.title=="string"?T=U.title:T=U.title.value,{id:U.id,label:C?void 0:T,icon:C}})}dispose(){super.dispose(),this._win=null}};x=ce([ee(1,i.ILogService),ee(2,S.IEnvironmentMainService),ee(3,a.IFileService),ee(4,o.IStorageMainService),ee(5,g.IConfigurationService),ee(6,E.IThemeMainService),ee(7,N.IWorkspacesManagementMainService),ee(8,h.IBackupMainService),ee(9,l.ITelemetryService),ee(10,P.IDialogMainService),ee(11,c.ILifecycleMainService),ee(12,s.IProductService),ee(13,r.IProtocolMainService)],x),e.CodeWindow=x}),define(J[62],Z([0,1,14,36,9,5,31,2,10,3,15,8,18,152,4,22,6,39,27,45]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,h.createDecorator)("workspacesHistoryMainService");let a=class He extends n.Disposable{constructor(p,E,D,R){super();this.stateMainService=p,this.logService=E,this.workspacesManagementMainService=D,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(p=>this.addRecentlyOpened([{workspace:p.workspace}])))}handleWindowsJumpList(){!m.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(p){const E=[],D=[];for(let R of p)if((0,u.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&s(E,R.workspace)===-1&&E.push(R);else if((0,u.isRecentFolder)(R))r(E,R.folderUri)===-1&&E.push(R);else{const W=o(D,R.fileUri)>=0,N=R.fileUri.scheme===f.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,t.basename)(R.fileUri))>=0;!W&&!N&&(D.push(R),m.isWindows&&R.fileUri.scheme===f.Schemas.file&&w.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(E,D),E.length>He.MAX_TOTAL_RECENT_ENTRIES&&(E.length=He.MAX_TOTAL_RECENT_ENTRIES),D.length>He.MAX_TOTAL_RECENT_ENTRIES&&(D.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:E,files:D}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(p){const E=N=>{const G=i(N);for(const x of p)if(t.extUriBiasedIgnorePathCase.isEqual(x,G))return!1;return!0},D=this.getRecentlyOpened(),R=D.workspaces.filter(E),W=D.files.filter(E);(R.length!==D.workspaces.length||W.length!==D.files.length)&&(this.saveRecentlyOpened({files:W,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;w.app.clearRecentDocuments();const p=this.getRecentlyOpened(),E=[];let D=0;for(let W=0;W<p.workspaces.length&&D<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;W++){const N=i(p.workspaces[W]);if(N.scheme===f.Schemas.file){const G=(0,t.originalFSPath)(N);await I.Promises.exists(G)&&(E.push(G),D++)}}const R=[];for(let W=0;W<p.files.length&&D<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;W++){const N=i(p.files[W]);if(N.scheme===f.Schemas.file){const G=(0,t.originalFSPath)(N);if(He.COMMON_FILES_FILTER.includes((0,t.basename)(N))||E.includes(G))continue;await I.Promises.exists(G)&&(R.push(G),D++)}}R.reverse().forEach(W=>w.app.addRecentDocument(W)),E.reverse().forEach(W=>w.app.addRecentDocument(W))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(p){const E=[],D=[],R=p?.config?.workspace;(0,u.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?E.push({workspace:R}):(0,u.isSingleFolderWorkspaceIdentifier)(R)&&E.push({folderUri:R.uri});const W=p?.config?.filesToOpenOrCreate;if(W)for(let N of W){const G=N.fileUri;G&&o(D,G)===-1&&D.push({fileUri:G})}return this.addEntriesFromStorage(E,D),{workspaces:E,files:D}}addEntriesFromStorage(p,E){let D=this.getRecentlyOpenedFromStorage();for(let R of D.workspaces){let W=(0,u.isRecentFolder)(R)?r(p,R.folderUri):s(p,R.workspace);W>=0?p[W].label=p[W].label||R.label:p.push(R)}for(let R of D.files){let W=o(E,R.fileUri);W>=0?E[W].label=E[W].label||R.label:E.push(R)}}getRecentlyOpenedFromStorage(){const p=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,u.restoreRecentlyOpened)(p,this.logService)}saveRecentlyOpened(p){const E=(0,u.toStoreData)(p);this.stateMainService.setItem(He.recentlyOpenedStorageKey,E)}updateWindowsJumpList(){if(!m.isWindows)return;const p=[];if(p.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let E=[];for(let W of w.app.getJumpListSettings().removedItems){const N=W.args;if(N){const G=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(N);G&&E.push(y.URI.parse(G[2]))}}this.removeRecentlyOpened(E);let D=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(W=>{const N=(0,u.isRecentWorkspace)(W)?W.workspace:W.folderUri,{title:G,description:x}=this.getWindowsJumpListLabel(N,W.label);let ne;return y.URI.isUri(N)?ne=`--folder-uri "${N.toString()}"`:(D=!0,ne=`--file-uri "${N.configPath.toString()}"`),{type:"task",title:G.substr(0,255),description:x.substr(0,255),program:process.execPath,args:ne,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&p.push({type:"custom",name:D?(0,v.localize)(2,null):(0,v.localize)(3,null),items:R})}p.push({type:"recent"});try{w.app.setJumpList(p)}catch(E){this.logService.warn("updateWindowsJumpList#setJumpList",E)}}getWindowsJumpListLabel(p,E){if(E)return{title:(0,b.splitName)(E).name,description:E};if(y.URI.isUri(p))return{title:(0,t.basename)(p),description:c(p)};if(this.workspacesManagementMainService.isUntitledWorkspace(p))return{title:(0,v.localize)(4,null),description:""};let D=(0,t.basename)(p.configPath);return D.endsWith(u.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,D),description:c(p.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=ce([ee(0,S.IStateMainService),ee(1,P.ILogService),ee(2,d.IWorkspacesManagementMainService),ee(3,g.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function c(l){return l.scheme==="file"?(0,b.normalizeDriveLetter)(l.fsPath):l.toString()}function i(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function s(l,p){return l.findIndex(E=>(0,u.isRecentWorkspace)(E)&&E.workspace.id===p.id)}function r(l,p){return l.findIndex(E=>(0,u.isRecentFolder)(E)&&t.extUriBiasedIgnorePathCase.isEqual(E.folderUri,p))}function o(l,p){return l.findIndex(E=>t.extUriBiasedIgnorePathCase.isEqual(E.fileUri,p))}}),define(J[234],Z([0,1,14,9,24,31,3,8,144,21,23,22,6,182,53,20,39,32,42,61,35,62]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let s=class wt{constructor(l,p,E,D,R,W,N,G,x,ne,V){this.updateService=l,this.configurationService=p,this.windowsMainService=E,this.environmentMainService=D,this.telemetryService=R,this.workspacesHistoryMainService=W,this.stateMainService=N,this.lifecycleMainService=G,this.logService=x,this.nativeHostMainService=ne,this.productService=V,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(b.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(W,N,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(W,N,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(W,N,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(W,N,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const p=this.productService.requestFeatureUrl;p&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(p,"openUserVoiceUrl"));const E=this.productService.reportIssueUrl;E&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(E,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(b.language){const W=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${W}lang=${b.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!b.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,p){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!b.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!b.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=w.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(b.isMacintosh?new w.Menu:null);return}const p=new w.Menu;let E;if(b.isMacintosh){const R=new w.Menu;E=new w.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),p.append(E)}if(b.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new w.Menu;R.append(new w.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),p.append(W)}if(this.shouldDrawMenu("Edit")){const R=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),p.append(W)}if(this.shouldDrawMenu("Selection")){const R=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),p.append(W)}if(this.shouldDrawMenu("View")){const R=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),p.append(W)}if(this.shouldDrawMenu("Go")){const R=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),p.append(W)}if(this.shouldDrawMenu("Run")){const R=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),p.append(W)}if(this.shouldDrawMenu("Terminal")){const R=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),p.append(W)}let D;if(this.shouldDrawMenu("Window")){const R=new w.Menu;D=new w.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(D&&p.append(D),this.shouldDrawMenu("Help")){const R=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),p.append(W)}p.items&&p.items.length>0?w.Menu.setApplicationMenu(p):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const p=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),E=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const Q=new w.Menu;this.setMenuById(Q,"Preferences"),D=new w.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:Q})}const R=new w.Menu,W=new w.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),N=new w.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new w.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new w.MenuItem({label:f.localize(15,null),role:"unhide"}),ne=new w.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),V=[p];V.push(...E),D&&V.push(r(),D),V.push(r(),W,r(),N,G,x,r(),ne),V.forEach(Q=>l.append(Q))}shouldDrawMenu(l){if(!b.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(b.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(b.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,p){p.forEach(E=>{if((0,v.isMenubarMenuItemSeparator)(E))l.append(r());else if((0,v.isMenubarMenuItemSubmenu)(E)){const D=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(E.label),submenu:D});this.setMenu(D,E.submenu.items),l.append(R)}else(0,v.isMenubarMenuItemRecentAction)(E)?l.append(this.createOpenRecentMenuItem(E)):(0,v.isMenubarMenuItemAction)(E)&&(E.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),b.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[E.id]?l.append(new w.MenuItem(this.likeAction(E.id,{label:this.mnemonicLabel(E.label),click:this.fallbackMenuHandlers[E.id]}))):l.append(this.createMenuItem(E.label,E.id,!1,E.checked)):l.append(this.createMenuItem(E.label,E.id,E.enabled!==!1,!!E.checked)):l.append(this.createMenuItem(E.label,E.id,E.enabled!==!1,!!E.checked)))})}setMenuById(l,p){this.menubarMenus&&this.menubarMenus[p]&&this.setMenu(l,this.menubarMenus[p].items)}insertCheckForUpdatesItems(l){const p=this.getUpdateMenuItems();p.length&&(p.forEach(E=>l.append(E)),l.append(r()))}createOpenRecentMenuItem(l){const p=n.URI.revive(l.uri),E=l.id,D=E==="openRecentFile"?{fileUri:p}:E==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new w.MenuItem(this.likeAction(E,{label:l.label,click:(R,W,N)=>{const G=this.isOptionClick(N);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([p])}},!1))}isOptionClick(l){return!!(l&&(!b.isMacintosh&&(l.ctrlKey||l.shiftKey)||b.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,p,E){const D={label:this.mnemonicLabel(l),role:E,enabled:!0};return new w.MenuItem(this.withKeybinding(p,D))}setMacWindowMenu(l){const p=new w.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),E=new w.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new w.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),W=[];this.currentEnableNativeTabs&&(W.push(r()),W.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),W.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),W.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),W.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),W.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,E,r(),R,...W,r(),D].forEach(N=>l.append(N))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,p,E,D){const R=this.mnemonicLabel(l),W=typeof p=="function"?p:(V,Q,U)=>{const C=V?V.userSettingsLabel:null;let T=p;Array.isArray(p)&&(T=this.isOptionClick(U)?p[1]:p[0]),C&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:C}):this.runActionInRenderer({type:"commandId",commandId:T})},N=typeof E=="boolean"?E:this.windowsMainService.getWindowCount()>0,G=typeof D=="boolean"?D:!1,x={label:R,click:W,enabled:N};G&&(x.type="checkbox",x.checked=G);let ne;return typeof p=="string"?ne=p:Array.isArray(p)&&(ne=p[0]),b.isMacintosh&&(ne==="editor.action.clipboardCutAction"?x.role="cut":ne==="editor.action.clipboardCopyAction"?x.role="copy":ne==="editor.action.clipboardPasteAction"&&(x.role="paste"),ne==="undo"?x.click=this.makeContextAwareClickHandler(W,{inDevTools:V=>V.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?x.click=this.makeContextAwareClickHandler(W,{inDevTools:V=>V.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(W,{inDevTools:V=>V.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(ne,x))}makeContextAwareClickHandler(l,p){return(E,D,R)=>{const W=w.BrowserWindow.getFocusedWindow();if(!W)return p.inNoWindow();if(W.webContents.isDevToolsFocused()&&W.webContents.devToolsWebContents)return p.inDevTools(W.webContents.devToolsWebContents);l(E,D||W,R)}}runActionInRenderer(l){let p=w.BrowserWindow.getFocusedWindow();if(!p){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(p=D.win)}const E=p?this.windowsMainService.getWindowById(p.id):void 0;if(E){if(this.logService.trace("menubar#runActionInRenderer",l),b.isMacintosh&&!this.environmentMainService.isBuilt&&!E.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const D={id:l.commandId,from:"menu"};E.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:l.userSettingsLabel};E.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,p){const E=typeof l=="string"?this.keybindings[l]:void 0;if(E?.label){if(E.isNative!==!1)p.accelerator=E.label,p.userSettingsLabel=E.userSettingsLabel;else if(typeof p.label=="string"){const D=p.label.indexOf("[");D>=0?p.label=`${p.label.substr(0,D)} [${E.label}]`:p.label=`${p.label} [${E.label}]`}}else p.accelerator=void 0;return p}likeAction(l,p,E=!p.accelerator){E&&(p=this.withKeybinding(l,p));const D=p.click;return p.click=(R,W,N)=>{this.reportMenuActionTelemetry(l),D&&D(R,W,N)},p}openUrl(l,p){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(p)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:i})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=ce([ee(0,u.IUpdateService),ee(1,m.IConfigurationService),ee(2,a.IWindowsMainService),ee(3,t.IEnvironmentMainService),ee(4,S.ITelemetryService),ee(5,c.IWorkspacesHistoryMainService),ee(6,P.IStateMainService),ee(7,y.ILifecycleMainService),ee(8,I.ILogService),ee(9,h.INativeHostMainService),ee(10,g.IProductService)],s),e.Menubar=s;function r(){return new w.MenuItem({type:"separator"})}}),define(J[235],Z([0,1,4,22,6,234]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let b=class{constructor(f,m,t){this.instantiationService=f,this.lifecycleMainService=m,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,m){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(m,f)}};b=ce([ee(0,w.IInstantiationService),ee(1,L.ILifecycleMainService),ee(2,k.ILogService)],b),e.MenubarMainService=b}),define(J[236],Z([0,1,14,30,26,36,24,5,29,43,31,2,10,7,72,3,33,15,13,8,150,51,21,52,23,19,4,22,6,48,20,55,73,39,61,233,99,216,27,100,62,45]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c,i,s,r,o,l,p,E,D,R,W,N,G,x,ne,V,Q,U,C,T,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function B(F){return(0,U.isWorkspaceIdentifier)(F?.workspace)}function O(F){return(0,U.isSingleFolderWorkspaceIdentifier)(F?.workspace)}let $=class Je extends y.Disposable{constructor(A,_,j,Y,q,X,ie,se,ae,ue,re,le,be,pe,Se){super();this.machineId=A,this.initialUserEnv=_,this.logService=j,this.stateMainService=Y,this.environmentMainService=q,this.lifecycleMainService=X,this.backupMainService=ie,this.configurationService=se,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=ue,this.instantiationService=re,this.dialogMainService=le,this.fileService=be,this.productService=pe,this.protocolMainService=Se,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const _=new y.DisposableStore;if(_.add(n.Event.any(A.onDidClose,A.onDidDestroy)(()=>_.dispose())),A.config.extensionDevelopmentPath)for(const j of A.config.extensionDevelopmentPath)_.add(this.protocolMainService.addValidFileRoot(d.URI.file(j)));A.config.extensionTestsPath&&_.add(this.protocolMainService.addValidFileRoot(d.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,_){let j=this.environmentMainService.args;const Y=_?.remoteAuthority||void 0,q=!0,X=_?.forceReuseWindow,ie=!X;return this.open({...A,cli:j,forceEmpty:q,forceNewWindow:ie,forceReuseWindow:X,remoteAuthority:Y})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const _=[],j=[],Y=[],q=[],X=[];let ie,se=0;const ae=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const pe of ae)O(pe)?A.addMode?_.push(pe):j.push(pe):B(pe)?Y.push(pe):pe.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:pe.remoteAuthority}),ie.filesToOpenOrCreate.push(pe)):pe.backupPath?X.push({backupFolder:(0,v.basename)(pe.backupPath),remoteAuthority:pe.remoteAuthority}):se++;A.diffMode&&ie?.filesToOpenOrCreate.length===2&&(ie.filesToDiff=ie.filesToOpenOrCreate,ie.filesToOpenOrCreate=[]),ie&&A.waitMarkerFileURI&&(ie.filesToWait={paths:[...ie.filesToDiff,...ie.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(q.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(...q),X.push(...this.backupMainService.getEmptyWindowBackupPaths())):X.length=0;const{windows:ue,filesOpenedInWindow:re}=this.doOpen(A,Y,j,X,se,ie,_);if(this.logService.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${j.length}, emptyToRestore: ${X.length}, emptyToOpen: ${se})`),ue.length>1)if(re)re.focus();else{const pe=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Se=!0,Re=!0;if(pe){const ve=ue.filter(ge=>this.windowsStateHandler.state.lastActiveWindow&&ge.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ve.length&&(ve[0].focus(),Se=!1,Re=!1)}if(Se)for(let ve=ue.length-1;ve>=0;ve--){const ge=ue[ve];if(!(ge.openedWorkspace&&q.some(Ee=>ge.openedWorkspace&&Ee.workspace.id===ge.openedWorkspace.id)||ge.backupPath&&X.some(Ee=>ge.backupPath&&Ee.backupFolder===(0,v.basename)(ge.backupPath)))){ge.focus(),Re=!1;break}}Re&&ue[ue.length-1].focus()}const le=ie&&ie.filesToDiff.length>0;if(!ue.some(pe=>pe.isExtensionDevelopmentHost)&&!le&&!A.noRecentEntry){const pe=[];for(const Se of ae)B(Se)&&!Se.transient?pe.push({label:Se.label,workspace:Se.workspace,remoteAuthority:Se.remoteAuthority}):O(Se)?pe.push({label:Se.label,folderUri:Se.workspace.uri,remoteAuthority:Se.remoteAuthority}):Se.fileUri&&pe.push({label:Se.label,fileUri:Se.fileUri,remoteAuthority:Se.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(pe)}const be=A.waitMarkerFileURI;return A.context===0&&be&&ue.length===1&&ue[0]&&(async()=>{await ue[0].whenClosedOrLoaded;try{await this.fileService.del(be)}catch(pe){}})(),ue}doOpen(A,_,j,Y,q,X,ie){const se=[];let ae;function ue(ve,ge){se.push(ve),ge&&(ae=ve,X=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:le}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&ie.length>0){const ve=ie[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(ve);ge&&ue(this.doAddFoldersToExistingWindow(ge,ie.map(Ee=>Ee.workspace.uri)))}const be=j.length+_.length+Y.length;if(X&&be===0){const ve=X.filesToOpenOrCreate[0]||X.filesToDiff[0],ge=this.getWindows().filter(De=>X&&De.remoteAuthority===X.remoteAuthority);let Ee;ve?.fileUri&&!le&&((A.context===4||A.context===0||A.context===1)&&(Ee=(0,V.findWindowOnFile)(ge,ve.fileUri,De=>De.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(ge))),Ee?(0,U.isWorkspaceIdentifier)(Ee.openedWorkspace)?_.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,U.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?j.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ue(this.doOpenFilesInExistingWindow(A,Ee,X),!0):ue(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:X,forceNewWindow:!0,remoteAuthority:X.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const pe=(0,M.distinct)(_,ve=>ve.workspace.id);if(pe.length>0){const ve=(0,M.coalesce)(pe.map(ge=>(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(ve.length>0){const ge=ve[0],Ee=X?.remoteAuthority===ge.remoteAuthority?X:void 0;ue(this.doOpenFilesInExistingWindow(A,ge,Ee),!!Ee),re=!0}pe.forEach(ge=>{if(ve.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===ge.workspace.id))return;const Ee=ge.remoteAuthority,De=X?.remoteAuthority===Ee?X:void 0;ue(this.doOpenFolderOrWorkspace(A,ge,re,De),!!De),re=!0})}const Se=(0,M.distinct)(j,ve=>S.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Se.length>0){const ve=(0,M.coalesce)(Se.map(ge=>(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(ve.length>0){const ge=ve[0],Ee=X?.remoteAuthority===ge.remoteAuthority?X:void 0;ue(this.doOpenFilesInExistingWindow(A,ge,Ee),!!Ee),re=!0}Se.forEach(ge=>{if(ve.some(Te=>(0,U.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,ge.workspace.uri)))return;const Ee=ge.remoteAuthority,De=X?.remoteAuthority===Ee?X:void 0;ue(this.doOpenFolderOrWorkspace(A,ge,re,De),!!De),re=!0})}const Re=(0,M.distinct)(Y,ve=>ve.backupFolder);if(Re.length>0&&Re.forEach(ve=>{const ge=ve.remoteAuthority,Ee=X?.remoteAuthority===ge?X:void 0;ue(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:Ee,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:ve}),!!Ee),re=!0}),se.length===0||X){X&&!q&&q++;const ve=X?X.remoteAuthority:A.remoteAuthority;for(let ge=0;ge<q;ge++)ue(this.doOpenEmpty(A,re,ve,X),!!X),re=!0}return{windows:(0,M.distinct)(se),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(A,_,j){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),_.focus();const Y={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToWait:j?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",b.CancellationToken.None,Y),_}doAddFoldersToExistingWindow(A,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const j={foldersToAdd:_};return A.sendWhenReady("vscode:addFolders",b.CancellationToken.None,j),A}doOpenEmpty(A,_,j,Y,q){return!_&&!q&&typeof A.contextWindowId=="number"&&(q=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:j,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:q})}doOpenFolderOrWorkspace(A,_,j,Y,q){return!j&&!q&&typeof A.contextWindowId=="number"&&(q=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:q})}getPathsToOpen(A){let _,j=!1,Y=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(A),j=!0):A.forceEmpty?_=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(_=this.doExtractPathsFromCLI(A.cli),_.length===0&&_.push(Object.create(null)),j=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),Y=!0),!A.addMode&&j){const q=_.filter(X=>O(X));if(q.length>1){const X=q[0].remoteAuthority;if(q.every(ie=>ie.remoteAuthority===X)){const ie=this.workspacesManagementMainService.createUntitledWorkspaceSync(q.map(se=>({uri:se.workspace.uri})));_.push({workspace:ie,remoteAuthority:X}),_=_.filter(se=>!O(se))}}}return A.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter(q=>B(q)||O(q)||q.backupPath)),_}doExtractPathsFromAPI(A){const _=[],j={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const Y of(0,M.coalesce)(A.urisToOpen||[])){const q=this.resolveOpenable(Y,j);if(q)q.label=Y.label,_.push(q);else{const X=this.resourceFromOpenable(Y),ie={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:X.scheme===I.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:X.scheme===I.Schemas.file?(0,a.localize)(3,null,(0,t.getPathLabel)(X.fsPath,this.environmentMainService)):(0,a.localize)(4,null,X.toString()),noLink:!0};this.dialogMainService.showMessageBox(ie,(0,u.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return _}doExtractPathsFromCLI(A){const _=[],j={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=A["folder-uri"];if(Y)for(const ie of Y){const se=this.cliArgToUri(ie);if(se){const ae=this.resolveOpenable({folderUri:se},j);ae&&_.push(ae)}}const q=A["file-uri"];if(q)for(const ie of q){const se=this.cliArgToUri(ie);if(se){const ae=this.resolveOpenable((0,U.hasWorkspaceFileExtension)(ie)?{workspaceUri:se}:{fileUri:se},j);ae&&_.push(ae)}}const X=A._;for(const ie of X){const se=j.remoteAuthority?this.doResolvePathRemote(ie,j):this.doResolveFilePath(ie,j);se&&_.push(se)}return _}cliArgToUri(A){try{const _=d.URI.parse(A);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return _}catch(_){this.logService.error(`Invalid URI input string: ${A}, ${_.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const _=[];A!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const j=[];for(const Y of _)if(Y.workspace){const q=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});B(q)&&j.push(q)}else if(Y.folderUri){const q=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});O(q)&&j.push(q)}else A!=="folders"&&Y.backupPath&&j.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return j}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,_=Object.create(null)){let j=this.resourceFromOpenable(A);return j.scheme===I.Schemas.file?((0,x.isFileToOpen)(A)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(j.fsPath,_)):this.doResolveRemoteOpenable(A,_)}doResolveRemoteOpenable(A,_){let j=this.resourceFromOpenable(A);const Y=(0,N.getRemoteAuthority)(j)||_.remoteAuthority;if(j=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)(j)),(0,x.isFileToOpen)(A)){if(_.gotoLineMode){const{path:q,line:X,column:ie}=(0,f.parseLineAndColumnAware)(j.path);return{fileUri:j.with({path:q}),selection:X?{startLineNumber:X,startColumn:ie||1}:void 0,remoteAuthority:Y}}return{fileUri:j,remoteAuthority:Y}}else if((0,x.isWorkspaceToOpen)(A))return{workspace:(0,C.getWorkspaceIdentifier)(j),remoteAuthority:Y};return{workspace:(0,C.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:Y}}resourceFromOpenable(A){return(0,x.isWorkspaceToOpen)(A)?A.workspaceUri:(0,x.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,_){let j,Y;_.gotoLineMode&&({path:A,line:j,column:Y}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,v.normalize)(A),(0,P.cwd)());try{const q=(0,L.statSync)(A);if(q.isFile()){if(!_.forceOpenWorkspaceAsFile){const X=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(A));if(X)return X.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:X.id,configPath:X.configPath},remoteAuthority:X.remoteAuthority,exists:!0,transient:X.transient}}return{fileUri:d.URI.file(A),selection:j?{startLineNumber:j,startColumn:Y||1}:void 0,exists:!0}}else if(q.isDirectory())return{workspace:(0,C.getSingleFolderWorkspaceIdentifier)(d.URI.file(A),q),exists:!0}}catch(q){const X=d.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([X]),_.ignoreFileNotFound)return{fileUri:X,exists:!1}}}doResolvePathRemote(A,_){const j=A.charCodeAt(0),Y=_.remoteAuthority;let q,X;_.gotoLineMode&&({path:A,line:q,column:X}=(0,f.parseLineAndColumnAware)(A)),j!==47&&((0,f.isWindowsDriveLetter)(j)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const ie=d.URI.from({scheme:I.Schemas.vscodeRemote,authority:Y,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,U.hasWorkspaceFileExtension)(A))return _.forceOpenWorkspaceAsFile?{fileUri:ie,selection:q?{startLineNumber:q,startColumn:X||1}:void 0,remoteAuthority:_.remoteAuthority}:{workspace:(0,C.getWorkspaceIdentifier)(ie),remoteAuthority:Y};if(_.gotoLineMode||v.posix.basename(A).indexOf(".")!==-1)return{fileUri:ie,selection:q?{startLineNumber:q,startColumn:X||1}:void 0,remoteAuthority:Y}}return{workspace:(0,C.getSingleFolderWorkspaceIdentifier)(ie),remoteAuthority:Y}}shouldOpenNewWindow(A){const _=this.configurationService.getValue("window"),j=_?.openFoldersInNewWindow||"default",Y=_?.openFilesInNewWindow||"off";let q=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(j==="on"||j==="off")&&(q=j==="on");let X=!1;return A.forceNewWindow||A.forceReuseWindow?X=!!A.forceNewWindow&&!A.forceReuseWindow:(g.isMacintosh?A.context===1&&(X=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(X=!0),!A.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(X=Y==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:X}}openExtensionDevelopmentHostWindow(A,_){const j=(0,V.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(j)return this.lifecycleMainService.reload(j,_.cli),j.focus(),[j];let Y=_.cli["folder-uri"]||[],q=_.cli["file-uri"]||[],X=_.cli._;if(!X.length&&!Y.length&&!q.length&&!_.cli.extensionTestsPath){const ue=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=ue&&(ue.workspace||ue.folderUri);re&&(d.URI.isUri(re)?re.scheme===I.Schemas.file?X=[re.fsPath]:Y=[re.toString()]:re.configPath.scheme===I.Schemas.file?X=[(0,S.originalFSPath)(re.configPath)]:q=[re.configPath.toString()])}let ie=_.remoteAuthority;for(const ue of A)if(ue.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=d.URI.parse(ue),le=(0,N.getRemoteAuthority)(re);le&&(ie?le!==ie&&this.logService.error("more than one extension development path authority"):ie=le)}X=X.filter(ue=>{const re=d.URI.file(ue);return(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,N.getRemoteAuthority)(re)===ie}),Y=Y.filter(ue=>{const re=this.cliArgToUri(ue);return re&&!!(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,N.getRemoteAuthority)(re)===ie:!1}),q=q.filter(ue=>{const re=this.cliArgToUri(ue);return re&&!!(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,N.getRemoteAuthority)(re)===ie:!1}),_.cli._=X,_.cli["folder-uri"]=Y,_.cli["file-uri"]=q;const se=!X.length&&!Y.length&&!q.length,ae={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:se,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:ie};return this.open(ae)}openInBrowserWindow(A){const _=this.configurationService.getValue("window"),j={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,v.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,h.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof _?.zoomLevel=="number"?_.zoomLevel:void 0,autoDetectHighContrast:_?.autoDetectHighContrast??!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}};let Y;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const q=Y.config;!j.extensionDevelopmentPath&&q&&!!q.extensionDevelopmentPath&&(j.extensionDevelopmentPath=q.extensionDevelopmentPath,j.verbose=q.verbose,j["inspect-brk-extensions"]=q["inspect-brk-extensions"],j.debugId=q.debugId,j["inspect-extensions"]=q["inspect-extensions"],j["extensions-dir"]=q["extensions-dir"])}else{const q=this.windowsStateHandler.getNewWindowState(j);(0,h.mark)("code/willCreateCodeWindow");const X=Y=this.instantiationService.createInstance(ne.CodeWindow,{state:q,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});if((0,h.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const se=this.getLastActiveWindow();se&&se.addTabbedWindow(X)}Je.WINDOWS.push(X),this._onDidOpenWindow.fire(X),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(X.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(X)),(0,m.once)(X.onDidClose)(()=>this.onWindowClosed(X)),(0,m.once)(X.onDidDestroy)(()=>this._onDidDestroyWindow.fire(X));const ie=(0,u.assertIsDefined)(X.win?.webContents);ie.removeAllListeners("devtools-reload-page"),ie.on("devtools-reload-page",()=>this.lifecycleMainService.reload(X)),this.lifecycleMainService.registerWindow(X)}return j.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then(q=>{q||this.doOpenInBrowserWindow(Y,j,A)}):this.doOpenInBrowserWindow(Y,j,A),Y}doOpenInBrowserWindow(A,_,j){if(!_.extensionDevelopmentPath)if((0,U.isWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:_.workspace,remoteAuthority:_.remoteAuthority});else if((0,U.isSingleFolderWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerFolderBackupSync(_.workspace.uri);else{const Y=j.emptyWindowBackupInfo&&j.emptyWindowBackupInfo.backupFolder;_.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,_.remoteAuthority)}A.load(_)}onWindowClosed(A){const _=Je.WINDOWS.indexOf(A);Je.WINDOWS.splice(_,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=w.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(_=>_.remoteAuthority===A))}doGetLastActiveWindow(A){const _=Math.max.apply(Math,A.map(j=>j.lastFocusTime));return A.find(j=>j.lastFocusTime===_)}sendToFocused(A,..._){const j=this.getFocusedWindow()||this.getLastActiveWindow();j&&j.sendWhenReady(A,b.CancellationToken.None,..._)}sendToAll(A,_,j){for(const Y of this.getWindows())j&&j.indexOf(Y.id)>=0||Y.sendWhenReady(A,b.CancellationToken.None,_)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(A){const _=this.getWindows().filter(j=>j.id===A);return(0,M.firstOrDefault)(_)}getWindowByWebContents(A){const _=w.BrowserWindow.fromWebContents(A);if(!!_)return this.getWindowById(_.id)}};$.WINDOWS=[],$=ce([ee(2,E.ILogService),ee(3,G.IStateMainService),ee(4,r.IEnvironmentMainService),ee(5,p.ILifecycleMainService),ee(6,c.IBackupMainService),ee(7,i.IConfigurationService),ee(8,T.IWorkspacesHistoryMainService),ee(9,z.IWorkspacesManagementMainService),ee(10,l.IInstantiationService),ee(11,s.IDialogMainService),ee(12,o.IFileService),ee(13,R.IProductService),ee(14,W.IProtocolMainService)],$),e.WindowsMainService=$}),define(J[237],Z([0,1,51,35,62,45]),function(H,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let b=class{constructor(f,m,t,y){this.workspacesManagementMainService=f,this.windowsMainService=m,this.workspacesHistoryMainService=t,this.backupMainService=y,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,m){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(f,m,t){return this.workspacesManagementMainService.createUntitledWorkspace(m,t)}deleteUntitledWorkspace(f,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(f,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}async removeRecentlyOpened(f,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};b=ce([ee(0,M.IWorkspacesManagementMainService),ee(1,L.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,w.IBackupMainService)],b),e.WorkspacesMainService=b}),define(J[238],Z([0,1,14,30,26,17,16,29,43,40,31,2,10,7,3,15,13,8,28,66,119,34,122,83,229,131,51,220,21,178,157,70,52,219,87,23,54,89,169,185,88,172,19,69,4,71,230,196,101,22,6,180,235,53,20,73,225,74,39,214,98,197,32,200,201,96,42,205,227,231,228,232,97,206,207,208,209,211,35,236,212,27,62,237,45]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c,i,s,r,o,l,p,E,D,R,W,N,G,x,ne,V,Q,U,C,T,z,B,O,$,F,A,_,j,Y,q,X,ie,se,ae,ue,re,le,be,pe,Se,Re,ve,ge,Ee,De,Te,Ne,Ue,Ge,Be,st,Ze,ot,Ye,ut,xe,K,te,oe,de,me,ke,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ce=class extends y.Disposable{constructor(he,we,ye,fe,Ie,Me,Pe,Le,Ae,$e){super();this.mainProcessNodeIpcServer=he,this.userEnv=we,this.mainInstantiationService=ye,this.logService=fe,this.environmentMainService=Ie,this.lifecycleMainService=Me,this.configurationService=Pe,this.stateMainService=Le,this.fileService=Ae,this.productService=$e,this.configureSession(),this.registerListeners()}configureSession(){const he=fe=>fe?.startsWith(`${I.Schemas.vscodeWebview}://`),we=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((fe,Ie,Me,Pe)=>he(Pe.requestingUrl)?Me(we.has(Ie)):Me(!1)),w.session.defaultSession.setPermissionCheckHandler((fe,Ie,Me,Pe)=>he(Pe.requestingUrl)?we.has(Ie):!1);const ye=w.session.defaultSession;typeof ye.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&ye.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(ye=>this.onUnexpectedError(ye)),process.on("uncaughtException",ye=>(0,b.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,b.onUnexpectedError)(ye)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,a.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(ye,fe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",fe)}),w.app.on("activate",(ye,fe)=>{this.logService.trace("app#activate"),fe||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(ye,fe)=>{fe.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),fe.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let he=[],we;w.app.on("open-file",(ye,fe)=>{this.logService.trace("app#open-file: ",fe),ye.preventDefault(),he.push(this.getWindowOpenableFromPathSync(fe)),we!==void 0&&(clearTimeout(we),we=void 0),we=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],we=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),w.ipcMain.handle("vscode:fetchShellEnv",ye=>{const fe=this.windowsMainService?.getWindowByWebContents(ye.sender);let Ie,Me;return fe?.config?(Ie=fe.config,Me={...process.env,...fe.config.userEnv}):(Ie=this.environmentMainService.args,Me=process.env),(0,Q.resolveShellEnv)(this.logService,Ie,Me)}),w.ipcMain.handle("vscode:writeNlsFile",(ye,fe,Ie)=>{const Me=this.validateNlsPath([fe]);if(!Me||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Me,M.VSBuffer.fromString(Ie))}),w.ipcMain.handle("vscode:readNlsFile",async(ye,...fe)=>{const Ie=this.validateNlsPath(fe);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}validateNlsPath(he){let we;for(const ye of he)typeof ye=="string"&&(typeof we!="string"?we=ye:we=(0,v.join)(we,ye));if(!(typeof we!="string"||!(0,v.isAbsolute)(we)||!(0,n.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return S.URI.file(we)}onUnexpectedError(he){if(he){const we={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(we))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const he=this.productService.win32AppUserModelId;h.isWindows&&he&&w.app.setAppUserModelId(he);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const we=new i.Server;this.logService.trace("Resolving machine identifier...");const ye=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:fe,sharedProcessReady:Ie,sharedProcessClient:Me}=this.setupSharedProcess(ye),Pe=await this.initServices(ye,fe,Ie);if(this.environmentMainService.driverHandle){const Ae=await(0,G.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Pe);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(Pe.createInstance(r.ProxyAuthHandler)),Pe.invokeFunction(Ae=>this.initChannels(Ae,we,Me));const Le=Pe.invokeFunction(Ae=>this.openFirstWindow(Ae,we));Pe.invokeFunction(Ae=>this.afterWindowOpen(Ae,fe)),this.environmentMainService.args.trace&&Pe.invokeFunction(Ae=>this.stopTracingEventually(Ae,Le))}async resolveMachineId(){let he=this.stateMainService.getItem(ve.machineIdKey);return(!he||h.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,d.getMachineId)(),this.stateMainService.setItem(ve.machineIdKey,he)),he}setupSharedProcess(he){const we=this._register(this.mainInstantiationService.createInstance(re.SharedProcess,he,this.userEnv)),ye=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Ie,"main")})(),fe=(async()=>(await we.whenReady(),ye))();return{sharedProcess:we,sharedProcessReady:fe,sharedProcessClient:ye}}async initServices(he,we,ye){const fe=new F.ServiceCollection;switch(process.platform){case"win32":fe.set(Te.IUpdateService,new O.SyncDescriptor(st.Win32UpdateService));break;case"linux":h.isLinuxSnap?fe.set(Te.IUpdateService,new O.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):fe.set(Te.IUpdateService,new O.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":fe.set(Te.IUpdateService,new O.SyncDescriptor(Ue.DarwinUpdateService));break}fe.set(te.IWindowsMainService,new O.SyncDescriptor(oe.WindowsMainService,[he,this.userEnv])),fe.set(N.IDialogMainService,new O.SyncDescriptor(N.DialogMainService)),fe.set(j.ILaunchMainService,new O.SyncDescriptor(j.LaunchMainService)),fe.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(ye.then(Me=>Me.getChannel("diagnostics"))))),fe.set(A.IIssueMainService,new O.SyncDescriptor(A.IssueMainService,[this.userEnv])),fe.set(x.IEncryptionMainService,new O.SyncDescriptor(x.EncryptionMainService,[he])),fe.set(_.IKeyboardLayoutMainService,new O.SyncDescriptor(_.KeyboardLayoutMainService)),fe.set(se.INativeHostMainService,new O.SyncDescriptor(se.NativeHostMainService,[we])),fe.set(xe.IWebviewManagerService,new O.SyncDescriptor(K.WebviewMainService)),fe.set(me.IWorkspacesService,new O.SyncDescriptor(Fe.WorkspacesMainService)),fe.set(We.IWorkspacesManagementMainService,new O.SyncDescriptor(We.WorkspacesManagementMainService)),fe.set(ke.IWorkspacesHistoryMainService,new O.SyncDescriptor(ke.WorkspacesHistoryMainService)),fe.set(ie.IMenubarMainService,new O.SyncDescriptor(ie.MenubarMainService)),fe.set(U.IExtensionUrlTrustService,new O.SyncDescriptor(C.ExtensionUrlTrustService)),fe.set(Se.IStorageMainService,new O.SyncDescriptor(Se.StorageMainService)),h.isWindows?fe.set(T.IExternalTerminalMainService,new O.SyncDescriptor(z.WindowsExternalTerminalService)):h.isMacintosh?fe.set(T.IExternalTerminalMainService,new O.SyncDescriptor(z.MacExternalTerminalService)):h.isLinux&&fe.set(T.IExternalTerminalMainService,new O.SyncDescriptor(z.LinuxExternalTerminalService));const Ie=new p.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(fe.set(l.IBackupMainService,Ie),fe.set(Ze.IURLService,new O.SyncDescriptor(Ye.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Me=(0,c.getDelayedChannel)(ye.then(Ke=>Ke.getChannel("telemetryAppender"))),Pe=new ge.TelemetryAppenderClient(Me),Le=(0,Re.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],$e={appender:Pe,commonProperties:Le,piiPaths:Ae,sendErrorTelemetry:!0};fe.set(ve.ITelemetryService,new O.SyncDescriptor(Ee.TelemetryService,[$e]))}else fe.set(ve.ITelemetryService,De.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(fe)}initChannels(he,we,ye){const fe=c.ProxyChannel.fromService(he.get(j.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",fe),we.registerChannel(D.UserConfigurationFileServiceId,c.ProxyChannel.fromService(new D.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ne.UpdateChannel(he.get(Te.IUpdateService));we.registerChannel("update",Ie);const Me=c.ProxyChannel.fromService(he.get(A.IIssueMainService));we.registerChannel("issue",Me);const Pe=c.ProxyChannel.fromService(he.get(x.IEncryptionMainService));we.registerChannel("encryption",Pe);const Le=c.ProxyChannel.fromService(he.get(le.ISignService));we.registerChannel("sign",Le);const Ae=c.ProxyChannel.fromService(he.get(_.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",Ae),this.nativeHostMainService=he.get(se.INativeHostMainService);const $e=c.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",$e),ye.then(je=>je.registerChannel("nativeHost",$e));const Ke=c.ProxyChannel.fromService(he.get(me.IWorkspacesService));we.registerChannel("workspaces",Ke);const et=c.ProxyChannel.fromService(he.get(ie.IMenubarMainService));we.registerChannel("menubar",et);const tt=c.ProxyChannel.fromService(he.get(Ze.IURLService));we.registerChannel("url",tt);const ht=c.ProxyChannel.fromService(he.get(U.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",ht);const _e=c.ProxyChannel.fromService(he.get(xe.IWebviewManagerService));we.registerChannel("webview",_e);const it=this._register(new pe.StorageDatabaseChannel(this.logService,he.get(Se.IStorageMainService)));we.registerChannel("storage",it),ye.then(je=>je.registerChannel("storage",it));const nt=c.ProxyChannel.fromService(he.get(T.IExternalTerminalMainService));we.registerChannel("externalTerminal",nt);const Xe=new X.LogLevelChannel(he.get(q.ILogService));we.registerChannel("logLevel",Xe),ye.then(je=>je.registerChannel("logLevel",Xe));const rt=new X.LoggerChannel(he.get(q.ILoggerService));we.registerChannel("logger",rt),ye.then(je=>je.registerChannel("logger",rt));const at=new R.ElectronExtensionHostDebugBroadcastChannel(he.get(te.IWindowsMainService));we.registerChannel("extensionhostdebugservice",at)}openFirstWindow(he,we){const ye=this.windowsMainService=he.get(te.IWindowsMainService),fe=he.get(Ze.IURLService),Ie=he.get(se.INativeHostMainService);this.lifecycleMainService.phase=2;const Me=[],Pe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:S.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Me.push(Qe),!1):!0}),Le=this,Ae=this.environmentMainService,$e=this.productService;fe.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===$e.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:S.URI.parse(Oe.query).path,query:""})),Le.shouldBlockURI(Oe))return!0;const vt=Le.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=ye.open({context:5,cli:{...Ae.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(h.isMacintosh&&ye.getWindowCount()===0){const[ft]=ye.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.getRemoteAuthority)(Oe)});return await ft.ready(),fe.open(Oe,Qe)}return!1}});const Ke=this._register(new de.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new c.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),tt=new ot.URLHandlerRouter(et),ht=we.getChannel("urlHandler",tt);fe.registerHandler(new ot.URLHandlerChannelClient(ht)),this._register(new ut.ElectronURLListener(Pe,fe,ye,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=(0,V.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],je=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?S.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Me.length>0?ye.open({context:nt,cli:_e,urisToOpen:Me,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!rt&&!at?ye.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:je,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):it.length&&!Xe&&!rt&&!at?ye.open({context:1,cli:_e,urisToOpen:it.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:je,waitMarkerFileURI:dt,initialStartup:!0}):ye.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:je,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(he){return!!(he.authority===I.Schemas.file&&h.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,t.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===I.Schemas.file)return{fileUri:S.URI.file(he.fsPath)};if(he.authority===I.Schemas.vscodeRemote){const we=he.path.indexOf(v.posix.sep,1);if(we!==-1){const ye=he.path.substring(1,we),fe=he.path.substring(we),Ie=S.URI.from({scheme:I.Schemas.vscodeRemote,authority:ye,path:fe,query:he.query,fragment:he.fragment});return(0,me.hasWorkspaceFileExtension)(fe)?{workspaceUri:Ie}:/:[\d]+$/.test(fe)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(he){try{if((0,L.statSync)(he).isDirectory())return{folderUri:S.URI.file(he)};if((0,me.hasWorkspaceFileExtension)(he))return{workspaceUri:S.URI.file(he)}}catch(we){}return{fileUri:S.URI.file(he)}}async afterWindowOpen(he,we){this.lifecycleMainService.phase=3;let ye=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>ye=!0);const fe=he.get(ve.ITelemetryService);this._register(we.onDidError(({type:Pe,details:Le})=>{let Ae;switch(Pe){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error(Ae)),fe.publicLog2("sharedprocesserror",{type:Pe,reason:Le?.reason,code:Le?.exitCode,visible:we.isVisible(),shuttingdown:ye})}));const Ie=this.productService.win32MutexName;if(h.isWindows&&Ie)try{const Pe=H.__$__nodeRequire("windows-mutex").Mutex,Le=new Pe(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Pe){this.logService.error(Pe)}w.protocol.registerHttpProtocol(I.Schemas.vscodeRemoteResource,(Pe,Le)=>{Le({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})});const Me=he.get(Te.IUpdateService);(Me instanceof st.Win32UpdateService||Me instanceof Ge.LinuxUpdateService||Me instanceof Ue.DarwinUpdateService)&&Me.initialize(),(0,Q.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,m.stripComments)(Le))["enable-crash-reporter"]===void 0){const $e=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof $e=="boolean"?$e:!0,et=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],tt=Le.substring(0,Le.length-2).concat(`,
`,et.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(tt))}}catch(Pe){this.logService.error(Pe)}}stopTracingEventually(he,we){this.logService.info("Tracing: waiting for windows to get ready...");const ye=he.get(N.IDialogMainService);let fe=!1;const Ie=async Pe=>{if(fe)return;fe=!0;const Le=await w.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Pe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):ye.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Le),buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,P.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},Me=setTimeout(()=>Ie(!0),3e4);Promise.all(we.map(Pe=>Pe.ready())).then(()=>{clearTimeout(Me),Ie(!1)})}};Ce=ce([ee(2,$.IInstantiationService),ee(3,q.ILogService),ee(4,ne.IEnvironmentMainService),ee(5,Y.ILifecycleMainService),ee(6,E.IConfigurationService),ee(7,be.IStateMainService),ee(8,B.IFileService),ee(9,ae.IProductService)],Ce),e.CodeApplication=Ce}),define(J[242],Z([0,1,14,30,36,9,67,16,29,43,31,10,7,72,3,33,25,18,34,56,238,11,21,189,198,23,54,161,19,183,184,69,174,71,22,91,6,181,92,48,20,55,186,94,222,50,224,74,195,39,226,96,60,204]),function(H,e,w,L,k,M,b,n,f,m,t,y,I,v,h,g,P,S,u,d,a,c,i,s,r,o,l,p,E,D,R,W,N,G,x,ne,V,Q,U,C,T,z,B,O,$,F,A,_,j,Y,q,X,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class se{main(){try{this.startup()}catch(re){console.error(re.message),w.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(ge=>console.error(ge));const[re,le,be,pe,Se,Re,ve]=this.createServices();try{try{await this.initServices(be,pe,Se)}catch(ge){throw this.handleStartupDataDirError(be,ve.nameLong,ge),ge}await re.invokeFunction(async ge=>{const Ee=ge.get(V.ILogService),De=ge.get(x.ILifecycleMainService),Te=ge.get(E.IFileService),Ne=await this.claimInstance(Ee,be,De,re,ve,!0);return S.Promises.writeFile(be.mainLockfile,String(process.pid)).catch(Ue=>{Ee.warn(`Error writing main lockfile: ${Ue.stack}`)}),Re.logger=new U.SpdLogLogger("main",(0,I.join)(be.logsPath,"main.log"),!0,Re.getLevel()),(0,m.once)(De.onWillShutdown)(Ue=>{Te.dispose(),pe.dispose(),Ue.join(S.Promises.unlink(be.mainLockfile).catch(()=>{}))}),re.createInstance(a.CodeApplication,Ne,le).startup()})}catch(ge){re.invokeFunction(this.quit,ge)}}createServices(){const re=new G.ServiceCollection,le={_serviceBrand:void 0,...C.default};re.set(T.IProductService,le);const be=new o.EnvironmentMainService(this.resolveArgs(),le),pe=this.patchEnvironment(be);re.set(o.IEnvironmentMainService,be);const Se=new ne.BufferLogService,Re=new V.MultiplexLogService([new V.ConsoleMainLogger((0,V.getLogLevel)(be)),Se]);process.once("exit",()=>Re.dispose()),re.set(V.ILogService,Re);const ve=new D.FileService(Re);re.set(E.IFileService,ve);const ge=new R.DiskFileSystemProvider(Re);ve.registerProvider(y.Schemas.file,ge),re.set(V.ILoggerService,new Q.LoggerService(Re,ve));const Ee=new s.ConfigurationService(be.settingsResource,ve);re.set(i.IConfigurationService,Ee),re.set(x.ILifecycleMainService,new W.SyncDescriptor(x.LifecycleMainService));const De=new q.StateMainService(be,Re,ve);return re.set(Y.IStateMainService,De),re.set(F.IRequestService,new W.SyncDescriptor(A.RequestMainService)),re.set(ie.IThemeMainService,new W.SyncDescriptor(ie.ThemeMainService)),re.set(_.ISignService,new W.SyncDescriptor(j.SignService)),re.set(O.ITunnelService,new W.SyncDescriptor($.TunnelService)),re.set(z.IProtocolMainService,new W.SyncDescriptor(B.ProtocolMainService)),[new N.InstantiationService(re,!0),pe,be,Ee,De,Se,le]}patchEnvironment(re){const le={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(be=>{const pe=process.env[be];typeof pe=="string"&&(le[be]=pe)}),Object.assign(process.env,le),le}initServices(re,le,be){return M.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.backupHome].map(pe=>pe?S.Promises.mkdir(pe,{recursive:!0}):void 0)),le.initialize(),be.init()])}async claimInstance(re,le,be,pe,Se,Re){let ve;try{(0,v.mark)("code/willStartMainServer"),ve=await(0,d.serve)(le.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),(0,m.once)(be.onWillShutdown)(()=>ve.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,Se.nameLong,ge),ge;let Ee;try{Ee=await(0,d.connect)(le.mainIPCHandle,"main")}catch(Ne){if(!Re||h.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,Se.nameShort),(0,c.localize)(1,null),Se.nameLong),Ne;try{(0,L.unlinkSync)(le.mainIPCHandle)}catch(Ue){throw re.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(re,le,be,pe,Se,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(Ne),Ee.dispose(),new Error(Ne)}let De;!le.args.wait&&!le.args.status&&(De=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,Se.nameShort),(0,c.localize)(3,null),Se.nameLong)},1e4));const Te=u.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(le.args.status)return pe.invokeFunction(async()=>{const Ne=new r.DiagnosticsService(X.NullTelemetryService,Se),Ue=await Te.getMainProcessInfo(),Ge=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(Ue,Ge);throw console.log(Be),new n.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(Te,re),re.trace("Sending env to running instance..."),await Te.start(le.args,process.env),Ee.dispose(),De&&clearTimeout(De),new n.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ve}handleStartupDataDirError(re,le,be){if(be.code==="EACCES"||be.code==="EPERM"){const pe=(0,k.coalesce)([re.userDataPath,re.extensionsPath,d.XDG_RUNTIME_DIR]).map(Se=>(0,t.getPathLabel)(Se,re));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,b.toErrorMessage)(be),pe.join(`
`)),le)}}showStartupWarningDialog(re,le,be){w.dialog.showMessageBoxSync({title:be,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,c.localize)(6,null))],message:re,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,le){if(h.isWindows){const be=await re.getMainProcessId();le.trace("Sending some foreground love to the running instance:",be);try{(await new Promise((pe,Se)=>{H(["windows-foreground-love"],pe,Se)})).allowSetForegroundWindow(be)}catch(pe){le.error(pe)}}}quit(re,le){const be=re.get(V.ILogService),pe=re.get(x.ILifecycleMainService);let Se=0;le&&(le.isExpected?le.message&&be.trace(le.message):(Se=1,le.stack?be.error(le.stack):be.error(`Startup error: ${le.toString()}`))),pe.kill(Se)}resolveArgs(){const re=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(re.wait&&!re.waitMarkerFilePath){const le=(0,p.createWaitMarkerFile)(re.verbose);le&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",le),re.waitMarkerFilePath=le)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const le=this.doValidatePaths(re._,re.goto);re._=le}return re}doValidatePaths(re,le){const be=(0,g.cwd)(),pe=re.map(ve=>{let ge=String(ve),Ee;le&&(Ee=(0,f.parseLineAndColumnAware)(ge),ge=Ee.path),ge&&(ge=this.preparePath(be,ge));const De=(0,f.sanitizeFilePath)(ge,be),Te=(0,I.basename)(De);return Te&&!(0,f.isValidBasename)(Te)?null:le&&Ee?(Ee.path=De,this.toPath(Ee)):De}),Se=h.isWindows||h.isMacintosh,Re=(0,k.distinct)(pe,ve=>ve&&Se?ve.toLowerCase():ve||"");return(0,k.coalesce)(Re)}preparePath(re,le){return h.isWindows&&(le=(0,P.rtrim)(le,'"')),le=(0,P.trim)((0,P.trim)(le," "),"	"),h.isWindows&&(le=(0,I.resolve)(re,le),le=(0,P.rtrim)(le,".")),le}toPath(re){const le=[re.path];return typeof re.line=="number"&&le.push(String(re.line)),typeof re.column=="number"&&le.push(String(re.column)),le.join(":")}}new se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89bbd372f459ce72e9c0b60eb3b26b924f64f62d/core/vs/code/electron-main/main.js.map
