/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ee=function(G){for(var t=[],A=0,P=G.length;A<P;A++)t[A]=Z[G[A]];return t};define(Z[57],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function A(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=A}),define(Z[44],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function A(F){return(L,u,h)=>{let g=null,p=null;if(typeof h.value=="function"?(g="value",p=h.value):typeof h.get=="function"&&(g="get",p=h.get),!p)throw new Error("not supported");h[g]=F(p,u)}}t.createDecorator=A;function P(F,L,u){let h=null,g=null;if(typeof u.value=="function"?(h="value",g=u.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(h="get",g=u.get),!g)throw new Error("not supported");const p=`$memoize$${L}`;u[h]=function(...d){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,d)}),this[p]}}t.memoize=P;function S(F,L,u){return A((h,g)=>{const p=`$debounce$${g}`,d=`$debounce$result$${g}`;return function(...D){this[d]||(this[d]=u?u():void 0),clearTimeout(this[p]),L&&(this[d]=L(this[d],...D),D=[this[d]]),this[p]=setTimeout(()=>{h.apply(this,D),this[d]=u?u():void 0},F)}})}t.debounce=S;function k(F,L,u){return A((h,g)=>{const p=`$throttle$timer$${g}`,d=`$throttle$result$${g}`,D=`$throttle$lastRun$${g}`,a=`$throttle$pending$${g}`;return function(...c){if(this[d]||(this[d]=u?u():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),L&&(this[d]=L(this[d],...c)),this[a])return;const b=this[D]+F;b<=Date.now()?(this[D]=Date.now(),h.apply(this,[this[d]]),this[d]=u?u():void 0):(this[a]=!0,this[p]=setTimeout(()=>{this[a]=!1,this[D]=Date.now(),h.apply(this,[this[d]]),this[d]=u?u():void 0},b-Date.now()))}})}t.throttle=k}),define(Z[21],ee([0,1,7]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function P(w,C=0){return w[w.length-(1+C)]}t.tail=P;function S(w){if(w.length===0)throw new Error("Invalid tail call");return[w.slice(0,w.length-1),w[w.length-1]]}t.tail2=S;function k(w,C,T=(j,B)=>j===B){if(w===C)return!0;if(!w||!C||w.length!==C.length)return!1;for(let j=0,B=w.length;j<B;j++)if(!T(w[j],C[j]))return!1;return!0}t.equals=k;function F(w,C,T){let j=0,B=w.length-1;for(;j<=B;){const _=(j+B)/2|0,K=T(w[_],C);if(K<0)j=_+1;else if(K>0)B=_-1;else return _}return-(j+1)}t.binarySearch=F;function L(w,C){let T=0,j=w.length;if(j===0)return 0;for(;T<j;){const B=Math.floor((T+j)/2);C(w[B])?j=B:T=B+1}return T}t.findFirstInSorted=L;function u(w,C,T){if(w=w|0,w>=C.length)throw new TypeError("invalid index");let j=C[Math.floor(C.length*Math.random())],B=[],_=[],K=[];for(let te of C){const ne=T(te,j);ne<0?B.push(te):ne>0?_.push(te):K.push(te)}return w<B.length?u(w,B,T):w<B.length+K.length?K[0]:u(w-(B.length+K.length),_,T)}t.quickSelect=u;function h(w,C){const T=[];let j;for(const B of w.slice(0).sort(C))!j||C(j[0],B)!==0?(j=[B],T.push(j)):j.push(B);return T}t.groupBy=h;function g(w,C,T){const j=[];function B(te,ne,oe){if(ne===0&&oe.length===0)return;const le=j[j.length-1];le&&le.start+le.deleteCount===te?(le.deleteCount+=ne,le.toInsert.push(...oe)):j.push({start:te,deleteCount:ne,toInsert:oe})}let _=0,K=0;for(;;){if(_===w.length){B(_,0,C.slice(K));break}if(K===C.length){B(_,w.length-_,[]);break}const te=w[_],ne=C[K],oe=T(te,ne);oe===0?(_+=1,K+=1):oe<0?(B(_,1,[]),_+=1):oe>0&&(B(_,0,[ne]),K+=1)}return j}t.sortedDiff=g;function p(w,C,T){const j=g(w,C,T),B=[],_=[];for(const K of j)B.push(...w.slice(K.start,K.start+K.deleteCount)),_.push(...K.toInsert);return{removed:B,added:_}}t.delta=p;function d(w,C,T){if(T===0)return[];const j=w.slice(0,T).sort(C);return a(w,C,j,T,w.length),j}t.top=d;function D(w,C,T,j,B){return T===0?Promise.resolve([]):new Promise((_,K)=>{(async()=>{const te=w.length,ne=w.slice(0,T).sort(C);for(let oe=T,le=Math.min(T+j,te);oe<te;oe=le,le=Math.min(le+j,te)){if(oe>T&&await new Promise(pe=>setTimeout(pe)),B&&B.isCancellationRequested)throw(0,A.canceled)();a(w,C,ne,oe,le)}return ne})().then(_,K)})}t.topAsync=D;function a(w,C,T,j,B){for(const _=T.length;j<B;j++){const K=w[j];if(C(K,T[_-1])<0){T.pop();const te=L(T,ne=>C(K,ne)<0);T.splice(te,0,K)}}}function c(w){return w.filter(C=>!!C)}t.coalesce=c;function b(w){let C=0;for(let T=0;T<w.length;T++)w[T]&&(w[C]=w[T],C+=1);w.length=C}t.coalesceInPlace=b;function v(w,C,T){w.splice(T,0,w.splice(C,1)[0])}t.move=v;function m(w){return!Array.isArray(w)||w.length===0}t.isFalsyOrEmpty=m;function f(w){return Array.isArray(w)&&w.length>0}t.isNonEmptyArray=f;function o(w,C){if(!C)return w.filter((j,B)=>w.indexOf(j)===B);const T=Object.create(null);return w.filter(j=>{const B=C(j);return T[B]?!1:(T[B]=!0,!0)})}t.distinct=o;function s(w){const C=new Set;return w.filter(T=>C.has(T)?!1:(C.add(T),!0))}t.distinctES6=s;function e(w){const C=Object.create(null);return T=>{const j=w(T);return C[j]?!1:(C[j]=!0,!0)}}t.uniqueFilter=e;function n(w,C){for(let T=w.length-1;T>=0;T--){const j=w[T];if(C(j))return T}return-1}t.lastIndex=n;function i(w,C){return w.length>0?w[0]:C}t.firstOrDefault=i;function r(w,C,T=(j,B)=>j===B){let j=0;for(let B=0,_=Math.min(w.length,C.length);B<_&&T(w[B],C[B]);B++)j++;return j}t.commonPrefixLength=r;function l(w){return[].concat(...w)}t.flatten=l;function y(w,C){let T=typeof C=="number"?w:0;typeof C=="number"?T=w:(T=0,C=w);const j=[];if(T<=C)for(let B=T;B<C;B++)j.push(B);else for(let B=T;B>C;B--)j.push(B);return j}t.range=y;function R(w,C,T){return w.reduce((j,B)=>(j[C(B)]=T?T(B):B,j),Object.create(null))}t.index=R;function N(w,C){return w.push(C),()=>E(w,C)}t.insert=N;function E(w,C){const T=w.indexOf(C);if(T>-1)return w.splice(T,1),C}t.remove=E;function O(w,C,T){const j=w.slice(0,C),B=w.slice(C);return j.concat(T,B)}t.arrayInsert=O;function z(w,C){let T;if(typeof C=="number"){let j=C;T=()=>{const B=Math.sin(j++)*179426549;return B-Math.floor(B)}}else T=Math.random;for(let j=w.length-1;j>0;j-=1){const B=Math.floor(T()*(j+1)),_=w[j];w[j]=w[B],w[B]=_}}t.shuffle=z;function $(w,C){const T=w.indexOf(C);T>-1&&(w.splice(T,1),w.unshift(C))}t.pushToStart=$;function Q(w,C){const T=w.indexOf(C);T>-1&&(w.splice(T,1),w.push(C))}t.pushToEnd=Q;function ie(w,C){return Array.isArray(w)?w.map(C):C(w)}t.mapArrayOrNot=ie;function re(w){return Array.isArray(w)?w:[w]}t.asArray=re;function Y(w){return w[Math.floor(Math.random()*w.length)]}t.getRandomElement=Y;function J(w,C){for(const T of w){const j=C(T);if(j!==void 0)return j}}t.mapFind=J;function W(w,C,T){const j=q(w,C),B=w.length,_=T.length;w.length=B+_;for(let K=B-1;K>=j;K--)w[K+_]=w[K];for(let K=0;K<_;K++)w[K+j]=T[K]}t.insertInto=W;function x(w,C,T,j){const B=q(w,C),_=w.splice(B,T);return W(w,B,j),_}t.splice=x;function q(w,C){return C<0?Math.max(C+w.length,0):Math.min(C,w.length)}function U(w,C){let T=Number.MAX_SAFE_INTEGER,j=0;return w.forEach((B,_)=>{const K=C(B);K<T&&(T=K,j=_)}),j}t.minIndex=U;function I(w,C){let T=Number.MIN_SAFE_INTEGER,j=0;return w.forEach((B,_)=>{const K=C(B);K>T&&(T=K,j=_)}),j}t.maxIndex=I;class M{constructor(C){this.items=C,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(C){let T=this.firstIdx;for(;T<this.items.length&&C(this.items[T]);)T++;const j=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,j}takeFromEndWhile(C){let T=this.lastIdx;for(;T>=0&&C(this.items[T]);)T--;const j=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,j}}t.ArrayQueue=M}),define(Z[58],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var A;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(A=t.ScanError||(t.ScanError={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var k;(function(e){e.DEFAULT={allowTrailingComma:!0}})(k=t.ParseOptions||(t.ParseOptions={}));function F(e,n=!1){let i=0,r=e.length,l="",y=0,R=16,N=0;function E(Y){let J=0,W=0;for(;J<Y;){const x=e.charCodeAt(i);if(x>=48&&x<=57)W=W*16+x-48;else if(x>=65&&x<=70)W=W*16+x-65+10;else if(x>=97&&x<=102)W=W*16+x-97+10;else break;i++,J++}return J<Y&&(W=-1),W}function O(Y){i=Y,l="",y=0,R=16,N=0}function z(){const Y=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&h(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&h(e.charCodeAt(i)))for(i++;i<e.length&&h(e.charCodeAt(i));)i++;else return N=3,e.substring(Y,i);let J=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&h(e.charCodeAt(i))){for(i++;i<e.length&&h(e.charCodeAt(i));)i++;J=i}else N=3;return e.substring(Y,J)}function $(){let Y="",J=i;for(;;){if(i>=r){Y+=e.substring(J,i),N=2;break}const W=e.charCodeAt(i);if(W===34){Y+=e.substring(J,i),i++;break}if(W===92){if(Y+=e.substring(J,i),i++,i>=r){N=2;break}switch(e.charCodeAt(i++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const q=E(4);q>=0?Y+=String.fromCharCode(q):N=4;break;default:N=5}J=i;continue}if(W>=0&&W<=31)if(u(W)){Y+=e.substring(J,i),N=2;break}else N=6;i++}return Y}function Q(){if(l="",N=0,y=i,i>=r)return y=r,R=17;let Y=e.charCodeAt(i);if(L(Y)){do i++,l+=String.fromCharCode(Y),Y=e.charCodeAt(i);while(L(Y));return R=15}if(u(Y))return i++,l+=String.fromCharCode(Y),Y===13&&e.charCodeAt(i)===10&&(i++,l+=`
`),R=14;switch(Y){case 123:return i++,R=1;case 125:return i++,R=2;case 91:return i++,R=3;case 93:return i++,R=4;case 58:return i++,R=6;case 44:return i++,R=5;case 34:return i++,l=$(),R=10;case 47:const J=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<r&&!u(e.charCodeAt(i));)i++;return l=e.substring(J,i),R=12}if(e.charCodeAt(i+1)===42){i+=2;const W=r-1;let x=!1;for(;i<W;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,x=!0;break}i++}return x||(i++,N=1),l=e.substring(J,i),R=13}return l+=String.fromCharCode(Y),i++,R=16;case 45:if(l+=String.fromCharCode(Y),i++,i===r||!h(e.charCodeAt(i)))return R=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=z(),R=11;default:for(;i<r&&ie(Y);)i++,Y=e.charCodeAt(i);if(y!==i){switch(l=e.substring(y,i),l){case"true":return R=8;case"false":return R=9;case"null":return R=7}return R=16}return l+=String.fromCharCode(Y),i++,R=16}}function ie(Y){if(L(Y)||u(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Y;do Y=Q();while(Y>=12&&Y<=15);return Y}return{setPosition:O,getPosition:()=>i,scan:n?re:Q,getToken:()=>R,getTokenValue:()=>l,getTokenOffset:()=>y,getTokenLength:()=>i-y,getTokenError:()=>N}}t.createScanner=F;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function h(e){return e>=48&&e<=57}var g;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(g||(g={}));function p(e,n){const i=[],r=new Object;let l;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let R=!1;function N(E,O,z,$){y.value=E,y.offset=O,y.length=z,y.type=$,y.colonOffset=void 0,l=y}try{f(e,{onObjectBegin:(E,O)=>{if(n<=E)throw r;l=void 0,R=n>E,i.push("")},onObjectProperty:(E,O,z)=>{if(n<O||(N(E,O,z,"property"),i[i.length-1]=E,n<=O+z))throw r},onObjectEnd:(E,O)=>{if(n<=E)throw r;l=void 0,i.pop()},onArrayBegin:(E,O)=>{if(n<=E)throw r;l=void 0,i.push(0)},onArrayEnd:(E,O)=>{if(n<=E)throw r;l=void 0,i.pop()},onLiteralValue:(E,O,z)=>{if(n<O||(N(E,O,z,s(E)),n<=O+z))throw r},onSeparator:(E,O,z)=>{if(n<=O)throw r;if(E===":"&&l&&l.type==="property")l.colonOffset=O,R=!1,l=void 0;else if(E===","){const $=i[i.length-1];typeof $=="number"?i[i.length-1]=$+1:(R=!0,i[i.length-1]=""),l=void 0}}})}catch(E){if(E!==r)throw E}return{path:i,previousNode:l,isAtPropertyKey:R,matches:E=>{let O=0;for(let z=0;O<E.length&&z<i.length;z++)if(E[O]===i[z]||E[O]==="*")O++;else if(E[O]!=="**")return!1;return O===E.length}}}t.getLocation=p;function d(e,n=[],i=k.DEFAULT){let r=null,l=[];const y=[];function R(E){Array.isArray(l)?l.push(E):r!==null&&(l[r]=E)}return f(e,{onObjectBegin:()=>{const E={};R(E),y.push(l),l=E,r=null},onObjectProperty:E=>{r=E},onObjectEnd:()=>{l=y.pop()},onArrayBegin:()=>{const E=[];R(E),y.push(l),l=E,r=null},onArrayEnd:()=>{l=y.pop()},onLiteralValue:R,onError:(E,O,z)=>{n.push({error:E,offset:O,length:z})}},i),l[0]}t.parse=d;function D(e,n=[],i=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(E){r.type==="property"&&(r.length=E-r.offset,r=r.parent)}function y(E){return r.children.push(E),E}f(e,{onObjectBegin:E=>{r=y({type:"object",offset:E,length:-1,parent:r,children:[]})},onObjectProperty:(E,O,z)=>{r=y({type:"property",offset:O,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:E,offset:O,length:z,parent:r})},onObjectEnd:(E,O)=>{r.length=E+O-r.offset,r=r.parent,l(E+O)},onArrayBegin:(E,O)=>{r=y({type:"array",offset:E,length:-1,parent:r,children:[]})},onArrayEnd:(E,O)=>{r.length=E+O-r.offset,r=r.parent,l(E+O)},onLiteralValue:(E,O,z)=>{y({type:s(E),offset:O,length:z,parent:r,value:E}),l(O+z)},onSeparator:(E,O,z)=>{r.type==="property"&&(E===":"?r.colonOffset=O:E===","&&l(O))},onError:(E,O,z)=>{n.push({error:E,offset:O,length:z})}},i);const N=r.children[0];return N&&delete N.parent,N}t.parseTree=D;function a(e,n){if(!e)return;let i=e;for(let r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let l=!1;for(const y of i.children)if(Array.isArray(y.children)&&y.children[0].value===r){i=y.children[1],l=!0;break}if(!l)return}else{const l=r;if(i.type!=="array"||l<0||!Array.isArray(i.children)||l>=i.children.length)return;i=i.children[l]}return i}t.findNodeAtLocation=a;function c(e){if(!e.parent||!e.parent.children)return[];const n=c(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;n.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&n.push(i)}return n}t.getNodePath=c;function b(e){switch(e.type){case"array":return e.children.map(b);case"object":const n=Object.create(null);for(let i of e.children){const r=i.children[1];r&&(n[i.children[0].value]=b(r))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=b;function v(e,n,i=!1){return n>=e.offset&&n<e.offset+e.length||i&&n===e.offset+e.length}t.contains=v;function m(e,n,i=!1){if(v(e,n,i)){const r=e.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=n;l++){const y=m(r[l],n,i);if(y)return y}return e}}t.findNodeAtOffset=m;function f(e,n,i=k.DEFAULT){const r=F(e,!1);function l(T){return T?()=>T(r.getTokenOffset(),r.getTokenLength()):()=>!0}function y(T){return T?j=>T(j,r.getTokenOffset(),r.getTokenLength()):()=>!0}const R=l(n.onObjectBegin),N=y(n.onObjectProperty),E=l(n.onObjectEnd),O=l(n.onArrayBegin),z=l(n.onArrayEnd),$=y(n.onLiteralValue),Q=y(n.onSeparator),ie=l(n.onComment),re=y(n.onError),Y=i&&i.disallowComments,J=i&&i.allowTrailingComma;function W(){for(;;){const T=r.scan();switch(r.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:Y||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(T){case 12:case 13:Y?x(10):ie();break;case 16:x(1);break;case 15:case 14:break;default:return T}}}function x(T,j=[],B=[]){if(re(T),j.length+B.length>0){let _=r.getToken();for(;_!==17;){if(j.indexOf(_)!==-1){W();break}else if(B.indexOf(_)!==-1)break;_=W()}}}function q(T){const j=r.getTokenValue();return T?$(j):N(j),W(),!0}function U(){switch(r.getToken()){case 11:let T=0;try{T=JSON.parse(r.getTokenValue()),typeof T!="number"&&(x(2),T=0)}catch(j){x(2)}$(T);break;case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return W(),!0}function I(){return r.getToken()!==10?(x(3,[],[2,5]),!1):(q(!1),r.getToken()===6?(Q(":"),W(),C()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function M(){R(),W();let T=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(T||x(4,[],[]),Q(","),W(),r.getToken()===2&&J)break}else T&&x(6,[],[]);I()||x(4,[],[2,5]),T=!0}return E(),r.getToken()!==2?x(7,[2],[]):W(),!0}function w(){O(),W();let T=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(T||x(4,[],[]),Q(","),W(),r.getToken()===4&&J)break}else T&&x(6,[],[]);C()||x(4,[],[4,5]),T=!0}return z(),r.getToken()!==4?x(8,[4],[]):W(),!0}function C(){switch(r.getToken()){case 3:return w();case 1:return M();case 10:return q(!0);default:return U()}}return W(),r.getToken()===17?i.allowEmptyContent?!0:(x(4,[],[]),!1):C()?(r.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}t.visit=f;function o(e,n){let i=F(e),r=[],l,y=0,R;do switch(R=i.getPosition(),l=i.scan(),l){case 12:case 13:case 17:y!==R&&r.push(e.substring(y,R)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),y=i.getPosition();break}while(l!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function G(S){const k=[];typeof S=="number"&&k.push("code/timeOrigin",S);function F(u){k.push(u,Date.now())}function L(){const u=[];for(let h=0;h<k.length;h+=2)u.push({name:k[h],startTime:k[h+1]});return u}return{mark:F,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const F of performance.getEntriesByType("mark"))k.push({name:F.name,startTime:Math.round(S+F.startTime)});return k}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function A(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=A(P))}(),function(G,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var A=t();for(var P in A)(typeof exports=="object"?exports:G)[P]=A[P]}}(typeof self!="undefined"?self:this,function(){return function(G){var t={};function A(P){if(t[P])return t[P].exports;var S=t[P]={i:P,l:!1,exports:{}};return G[P].call(S.exports,S,S.exports,A),S.l=!0,S.exports}return A.m=G,A.c=t,A.d=function(P,S,k){A.o(P,S)||Object.defineProperty(P,S,{enumerable:!0,get:k})},A.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},A.t=function(P,S){if(1&S&&(P=A(P)),8&S||4&S&&typeof P=="object"&&P&&P.__esModule)return P;var k=Object.create(null);if(A.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:P}),2&S&&typeof P!="string")for(var F in P)A.d(k,F,function(L){return P[L]}.bind(null,F));return k},A.n=function(P){var S=P&&P.__esModule?function(){return P.default}:function(){return P};return A.d(S,"a",S),S},A.o=function(P,S){return Object.prototype.hasOwnProperty.call(P,S)},A.p="",A(A.s=0)}([function(G,t,A){(function(P){var S;t=G.exports=B,S=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var k=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],u=t.src=[],h=0,g=h++;u[g]="0|[1-9]\\d*";var p=h++;u[p]="[0-9]+";var d=h++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=h++;u[D]="("+u[g]+")\\.("+u[g]+")\\.("+u[g]+")";var a=h++;u[a]="("+u[p]+")\\.("+u[p]+")\\.("+u[p]+")";var c=h++;u[c]="(?:"+u[g]+"|"+u[d]+")";var b=h++;u[b]="(?:"+u[p]+"|"+u[d]+")";var v=h++;u[v]="(?:-("+u[c]+"(?:\\."+u[c]+")*))";var m=h++;u[m]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var f=h++;u[f]="[0-9A-Za-z-]+";var o=h++;u[o]="(?:\\+("+u[f]+"(?:\\."+u[f]+")*))";var s=h++,e="v?"+u[D]+u[v]+"?"+u[o]+"?";u[s]="^"+e+"$";var n="[v=\\s]*"+u[a]+u[m]+"?"+u[o]+"?",i=h++;u[i]="^"+n+"$";var r=h++;u[r]="((?:<|>)?=?)";var l=h++;u[l]=u[p]+"|x|X|\\*";var y=h++;u[y]=u[g]+"|x|X|\\*";var R=h++;u[R]="[v=\\s]*("+u[y]+")(?:\\.("+u[y]+")(?:\\.("+u[y]+")(?:"+u[v]+")?"+u[o]+"?)?)?";var N=h++;u[N]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[m]+")?"+u[o]+"?)?)?";var E=h++;u[E]="^"+u[r]+"\\s*"+u[R]+"$";var O=h++;u[O]="^"+u[r]+"\\s*"+u[N]+"$";var z=h++;u[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=h++;u[$]="(?:~>?)";var Q=h++;u[Q]="(\\s*)"+u[$]+"\\s+",L[Q]=new RegExp(u[Q],"g");var ie=h++;u[ie]="^"+u[$]+u[R]+"$";var re=h++;u[re]="^"+u[$]+u[N]+"$";var Y=h++;u[Y]="(?:\\^)";var J=h++;u[J]="(\\s*)"+u[Y]+"\\s+",L[J]=new RegExp(u[J],"g");var W=h++;u[W]="^"+u[Y]+u[R]+"$";var x=h++;u[x]="^"+u[Y]+u[N]+"$";var q=h++;u[q]="^"+u[r]+"\\s*("+n+")$|^$";var U=h++;u[U]="^"+u[r]+"\\s*("+e+")$|^$";var I=h++;u[I]="(\\s*)"+u[r]+"\\s*("+n+"|"+u[R]+")",L[I]=new RegExp(u[I],"g");var M=h++;u[M]="^\\s*("+u[R]+")\\s+-\\s+("+u[R]+")\\s*$";var w=h++;u[w]="^\\s*("+u[N]+")\\s+-\\s+("+u[N]+")\\s*$";var C=h++;u[C]="(<|>)?=?\\s*\\*";for(var T=0;T<35;T++)S(T,u[T]),L[T]||(L[T]=new RegExp(u[T]));function j(V,H){if(V instanceof B)return V;if(typeof V!="string"||V.length>k||!(H?L[i]:L[s]).test(V))return null;try{return new B(V,H)}catch(X){return null}}function B(V,H){if(V instanceof B){if(V.loose===H)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof B))return new B(V,H);S("SemVer",V,H),this.loose=H;var X=V.trim().match(H?L[i]:L[s]);if(!X)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ae=+se;if(ae>=0&&ae<F)return ae}return se}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}t.parse=j,t.valid=function(V,H){var X=j(V,H);return X?X.version:null},t.clean=function(V,H){var X=j(V.trim().replace(/^[=v]+/,""),H);return X?X.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(V){return S("SemVer.compare",this.version,this.loose,V),V instanceof B||(V=new B(V,this.loose)),this.compareMain(V)||this.comparePre(V)},B.prototype.compareMain=function(V){return V instanceof B||(V=new B(V,this.loose)),K(this.major,V.major)||K(this.minor,V.minor)||K(this.patch,V.patch)},B.prototype.comparePre=function(V){if(V instanceof B||(V=new B(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var H=0;do{var X=this.prerelease[H],se=V.prerelease[H];if(S("prerelease compare",H,X,se),X===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(X===void 0)return-1;if(X!==se)return K(X,se)}while(++H)},B.prototype.inc=function(V,H){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,H,X,se){typeof X=="string"&&(se=X,X=void 0);try{return new B(V,X).inc(H,se).version}catch(ae){return null}},t.diff=function(V,H){if(le(V,H))return null;var X=j(V),se=j(H);if(X.prerelease.length||se.prerelease.length){for(var ae in X)if((ae==="major"||ae==="minor"||ae==="patch")&&X[ae]!==se[ae])return"pre"+ae;return"prerelease"}for(var ae in X)if((ae==="major"||ae==="minor"||ae==="patch")&&X[ae]!==se[ae])return ae},t.compareIdentifiers=K;var _=/^[0-9]+$/;function K(V,H){var X=_.test(V),se=_.test(H);return X&&se&&(V=+V,H=+H),X&&!se?-1:se&&!X?1:V<H?-1:V>H?1:0}function te(V,H,X){return new B(V,X).compare(new B(H,X))}function ne(V,H,X){return te(V,H,X)>0}function oe(V,H,X){return te(V,H,X)<0}function le(V,H,X){return te(V,H,X)===0}function pe(V,H,X){return te(V,H,X)!==0}function De(V,H,X){return te(V,H,X)>=0}function ke(V,H,X){return te(V,H,X)<=0}function Te(V,H,X,se){var ae;switch(H){case"===":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),ae=V===X;break;case"!==":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),ae=V!==X;break;case"":case"=":case"==":ae=le(V,X,se);break;case"!=":ae=pe(V,X,se);break;case">":ae=ne(V,X,se);break;case">=":ae=De(V,X,se);break;case"<":ae=oe(V,X,se);break;case"<=":ae=ke(V,X,se);break;default:throw new TypeError("Invalid operator: "+H)}return ae}function we(V,H){if(V instanceof we){if(V.loose===H)return V;V=V.value}if(!(this instanceof we))return new we(V,H);S("comparator",V,H),this.loose=H,this.parse(V),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(V,H){return K(H,V)},t.major=function(V,H){return new B(V,H).major},t.minor=function(V,H){return new B(V,H).minor},t.patch=function(V,H){return new B(V,H).patch},t.compare=te,t.compareLoose=function(V,H){return te(V,H,!0)},t.rcompare=function(V,H,X){return te(H,V,X)},t.sort=function(V,H){return V.sort(function(X,se){return t.compare(X,se,H)})},t.rsort=function(V,H){return V.sort(function(X,se){return t.rcompare(X,se,H)})},t.gt=ne,t.lt=oe,t.eq=le,t.neq=pe,t.gte=De,t.lte=ke,t.cmp=Te,t.Comparator=we;var Fe={};function ve(V,H){if(V instanceof ve)return V.loose===H?V:new ve(V.raw,H);if(V instanceof we)return new ve(V.value,H);if(!(this instanceof ve))return new ve(V,H);if(this.loose=H,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Re(V){return!V||V.toLowerCase()==="x"||V==="*"}function je(V,H,X,se,ae,Se,de,Le,ye,Pe,Ae,Ee,be){return((H=Re(X)?"":Re(se)?">="+X+".0.0":Re(ae)?">="+X+"."+se+".0":">="+H)+" "+(Le=Re(ye)?"":Re(Pe)?"<"+(+ye+1)+".0.0":Re(Ae)?"<"+ye+"."+(+Pe+1)+".0":Ee?"<="+ye+"."+Pe+"."+Ae+"-"+Ee:"<="+Le)).trim()}function Be(V,H){for(var X=0;X<V.length;X++)if(!V[X].test(H))return!1;if(H.prerelease.length){for(X=0;X<V.length;X++)if(S(V[X].semver),V[X].semver!==Fe&&V[X].semver.prerelease.length>0){var se=V[X].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function xe(V,H,X){try{H=new ve(H,X)}catch(se){return!1}return H.test(V)}function ze(V,H,X,se){var ae,Se,de,Le,ye;switch(V=new B(V,se),H=new ve(H,se),X){case">":ae=ne,Se=ke,de=oe,Le=">",ye=">=";break;case"<":ae=oe,Se=De,de=ne,Le="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(V,H,se))return!1;for(var Pe=0;Pe<H.set.length;++Pe){var Ae=H.set[Pe],Ee=null,be=null;if(Ae.forEach(function(Ce){Ce.semver===Fe&&(Ce=new we(">=0.0.0")),Ee=Ee||Ce,be=be||Ce,ae(Ce.semver,Ee.semver,se)?Ee=Ce:de(Ce.semver,be.semver,se)&&(be=Ce)}),Ee.operator===Le||Ee.operator===ye||(!be.operator||be.operator===Le)&&Se(V,be.semver)||be.operator===ye&&de(V,be.semver))return!1}return!0}we.prototype.parse=function(V){var H=this.loose?L[q]:L[U],X=V.match(H);if(!X)throw new TypeError("Invalid comparator: "+V);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new B(X[2],this.loose):this.semver=Fe},we.prototype.toString=function(){return this.value},we.prototype.test=function(V){return S("Comparator.test",V,this.loose),this.semver===Fe||(typeof V=="string"&&(V=new B(V,this.loose)),Te(V,this.operator,this.semver,this.loose))},we.prototype.intersects=function(V,H){if(!(V instanceof we))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new ve(V.value,H),xe(this.value,X,H);if(V.operator==="")return X=new ve(this.value,H),xe(V.semver,X,H);var se=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Se=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=Te(this.semver,"<",V.semver,H)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ye=Te(this.semver,">",V.semver,H)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return se||ae||Se&&de||Le||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var H=this.loose;V=V.trim(),S("range",V,H);var X=H?L[w]:L[M];V=V.replace(X,je),S("hyphen replace",V),V=V.replace(L[I],"$1$2$3"),S("comparator trim",V,L[I]),V=(V=(V=V.replace(L[Q],"$1~")).replace(L[J],"$1^")).split(/\s+/).join(" ");var se=H?L[q]:L[U],ae=V.split(" ").map(function(Se){return function(de,Le){return S("comp",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){S("caret",Ee,be);var Ce=be?L[x]:L[W];return Ee.replace(Ce,function(Oe,ce,he,ge,me){var Ie;return S("caret",Ee,Oe,ce,he,ge,me),Re(ce)?Ie="":Re(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(ge)?Ie=ce==="0"?">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+".0 <"+(+ce+1)+".0.0":me?(S("replaceCaret pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+me+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+me+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+me+" <"+(+ce+1)+".0.0"):(S("no pr"),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+" <"+(+ce+1)+".0.0"),S("caret return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),S("caret",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){var Ce=be?L[re]:L[ie];return Ee.replace(Ce,function(Oe,ce,he,ge,me){var Ie;return S("tilde",Ee,Oe,ce,he,ge,me),Re(ce)?Ie="":Re(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(ge)?Ie=">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":me?(S("replaceTilde pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=">="+ce+"."+he+"."+ge+me+" <"+ce+"."+(+he+1)+".0"):Ie=">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0",S("tilde return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),S("tildes",de),de=function(ye,Pe){return S("replaceXRanges",ye,Pe),ye.split(/\s+/).map(function(Ae){return function(Ee,be){Ee=Ee.trim();var Ce=be?L[O]:L[E];return Ee.replace(Ce,function(Oe,ce,he,ge,me,Ie){S("xRange",Ee,Oe,ce,he,ge,me,Ie);var Ve=Re(he),Me=Ve||Re(ge),Ue=Me||Re(me);return ce==="="&&Ue&&(ce=""),Ve?Oe=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Ue?(Me&&(ge=0),Ue&&(me=0),ce===">"?(ce=">=",Me?(he=+he+1,ge=0,me=0):Ue&&(ge=+ge+1,me=0)):ce==="<="&&(ce="<",Me?he=+he+1:ge=+ge+1),Oe=ce+he+"."+ge+"."+me):Me?Oe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Oe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),S("xRange return",Oe),Oe})}(Ae,Pe)}).join(" ")}(de,Le),S("xrange",de),de=function(ye,Pe){return S("replaceStars",ye,Pe),ye.trim().replace(L[C],"")}(de,Le),S("stars",de),de}(Se,H)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(Se){return!!Se.match(se)})),ae=ae.map(function(Se){return new we(Se,H)})},ve.prototype.intersects=function(V,H){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(se){return V.set.some(function(ae){return ae.every(function(Se){return se.intersects(Se,H)})})})})},t.toComparators=function(V,H){return new ve(V,H).set.map(function(X){return X.map(function(se){return se.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new B(V,this.loose));for(var H=0;H<this.set.length;H++)if(Be(this.set[H],V))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(V,H,X){var se=null,ae=null;try{var Se=new ve(H,X)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(se&&ae.compare(de)!==-1||(ae=new B(se=de,X)))}),se},t.minSatisfying=function(V,H,X){var se=null,ae=null;try{var Se=new ve(H,X)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(se&&ae.compare(de)!==1||(ae=new B(se=de,X)))}),se},t.validRange=function(V,H){try{return new ve(V,H).range||"*"}catch(X){return null}},t.ltr=function(V,H,X){return ze(V,H,"<",X)},t.gtr=function(V,H,X){return ze(V,H,">",X)},t.outside=ze,t.prerelease=function(V,H){var X=j(V,H);return X&&X.prerelease.length?X.prerelease:null},t.intersects=function(V,H,X){return V=new ve(V,X),H=new ve(H,X),V.intersects(H)},t.coerce=function(V){if(V instanceof B)return V;if(typeof V!="string")return null;var H=V.match(L[z]);return H==null?null:j((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,A(1))},function(G,t){var A,P,S=G.exports={};function k(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function L(b){if(A===setTimeout)return setTimeout(b,0);if((A===k||!A)&&setTimeout)return A=setTimeout,setTimeout(b,0);try{return A(b,0)}catch(v){try{return A.call(null,b,0)}catch(m){return A.call(this,b,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:k}catch(b){A=k}try{P=typeof clearTimeout=="function"?clearTimeout:F}catch(b){P=F}})();var u,h=[],g=!1,p=-1;function d(){g&&u&&(g=!1,u.length?h=u.concat(h):p=-1,h.length&&D())}function D(){if(!g){var b=L(d);g=!0;for(var v=h.length;v;){for(u=h,h=[];++p<v;)u&&u[p].run();p=-1,v=h.length}u=null,g=!1,function(m){if(P===clearTimeout)return clearTimeout(m);if((P===F||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(m);try{P(m)}catch(f){try{return P.call(null,m)}catch(o){return P.call(this,m)}}}(b)}}function a(b,v){this.fun=b,this.array=v}function c(){}S.nextTick=function(b){var v=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)v[m-1]=arguments[m];h.push(new a(b,v)),h.length!==1||g||L(D)},a.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=c,S.addListener=c,S.once=c,S.off=c,S.removeListener=c,S.removeAllListeners=c,S.emit=c,S.prependListener=c,S.prependOnceListener=c,S.listeners=function(b){return[]},S.binding=function(b){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(b){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Z[37],ee([0,1,7,2]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(f){const o=f;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=S;function k(f){const o=f;return o?S(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=k;function F(f,o){return new L(f,o)}t.newWriteableStream=F;class L{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,A.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const n=e.indexOf(s);n>=0&&e.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(f,o){const s=[];let e;for(;(e=f.read())!==null;)s.push(e);return o(s)}t.consumeReadable=u;function h(f,o,s){const e=[];let n;for(;(n=f.read())!==null&&e.length<s;)e.push(n);return n===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return f.read()}}}t.peekReadable=h;function g(f,o){return new Promise((s,e)=>{const n=[];p(f,{onData:i=>{o&&n.push(i)},onError:i=>{o?e(i):s(void 0)},onEnd:()=>{s(o?o(n):void 0)}})})}t.consumeStream=g;function p(f,o){f.on("error",s=>o.onError(s)),f.on("end",()=>o.onEnd()),f.on("data",s=>o.onData(s))}t.listenStream=p;function d(f,o){return new Promise((s,e)=>{const n=new P.DisposableStore,i=[],r=R=>{if(i.push(R),i.length>o)return n.dispose(),f.pause(),s({stream:f,buffer:i,ended:!1})},l=R=>e(R),y=()=>s({stream:f,buffer:i,ended:!0});n.add((0,P.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),n.add((0,P.toDisposable)(()=>f.removeListener("end",y))),f.on("end",y),n.add((0,P.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}t.peekStream=d;function D(f,o){const s=F(o);return s.end(f),s}t.toStream=D;function a(){const f=F(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=a;function c(f){let o=!1;return{read:()=>o?null:(o=!0,f)}}t.toReadable=c;function b(f,o,s){const e=F(s);return p(f,{onData:n=>e.write(o.data(n)),onError:n=>e.error(o.error?o.error(n):n),onEnd:()=>e.end()}),e}t.transform=b;function v(f,o,s){let e=!1;return{read:()=>{const n=o.read();return e?n:(e=!0,n!==null?s([f,n]):f)}}}t.prefixedReadable=v;function m(f,o,s){let e=!1;const n=F(s);return p(o,{onData:i=>e?n.write(i):(e=!0,n.write(s([f,i]))),onError:i=>n.error(i),onEnd:()=>{e||(e=!0,n.write(f)),n.end()}}),n}t.prefixedStream=m}),define(Z[16],ee([0,1,37]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer!="undefined";let S,k;class F{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return P?new F(Buffer.allocUnsafe(r)):new F(new Uint8Array(r))}static wrap(r){return P&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new F(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&P?new F(Buffer.from(r)):(S||(S=new TextEncoder),new F(S.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let N=0,E=r.length;N<E;N++)l+=r[N].byteLength}const y=F.alloc(l);let R=0;for(let N=0,E=r.length;N<E;N++){const O=r[N];y.set(O,R),R+=O.byteLength}return y}toString(){return P?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(r,l){return new F(this.buffer.subarray(r,l))}set(r,l){r instanceof F?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return h(this.buffer,r)}writeUInt32BE(r,l){g(this.buffer,r,l)}readUInt32LE(r){return p(this.buffer,r)}writeUInt32LE(r,l){d(this.buffer,r,l)}readUInt8(r){return D(this.buffer,r)}writeUInt8(r,l){a(this.buffer,r,l)}}t.VSBuffer=F;function L(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}t.readUInt16LE=L;function u(i,r,l){i[l+0]=r&255,r=r>>>8,i[l+1]=r&255}t.writeUInt16LE=u;function h(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}t.readUInt32BE=h;function g(i,r,l){i[l+3]=r,r=r>>>8,i[l+2]=r,r=r>>>8,i[l+1]=r,r=r>>>8,i[l]=r}t.writeUInt32BE=g;function p(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}t.readUInt32LE=p;function d(i,r,l){i[l+0]=r&255,r=r>>>8,i[l+1]=r&255,r=r>>>8,i[l+2]=r&255,r=r>>>8,i[l+3]=r&255}t.writeUInt32LE=d;function D(i,r){return i[r]}t.readUInt8=D;function a(i,r,l){i[l]=r}t.writeUInt8=a;function c(i){return A.consumeReadable(i,r=>F.concat(r))}t.readableToBuffer=c;function b(i){return A.toReadable(i)}t.bufferToReadable=b;function v(i){return A.consumeStream(i,r=>F.concat(r))}t.streamToBuffer=v;async function m(i){return i.ended?F.concat(i.buffer):F.concat([...i.buffer,await v(i.stream)])}t.bufferedStreamToBuffer=m;function f(i){return A.toStream(i,r=>F.concat(r))}t.bufferToStream=f;function o(i){return A.transform(i,{data:r=>typeof r=="string"?F.fromString(r):F.wrap(r)},r=>F.concat(r))}t.streamToBufferReadableStream=o;function s(i){return A.newWriteableStream(r=>F.concat(r),i)}t.newWriteableBufferStream=s;function e(i,r){return A.prefixedReadable(i,r,l=>F.concat(l))}t.prefixedBufferReadable=e;function n(i,r){return A.prefixedStream(i,r,l=>F.concat(l))}t.prefixedBufferStream=n}),define(Z[18],ee([0,1,13]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const b=Array.isArray(c)?[]:{};return Object.keys(c).forEach(v=>{c[v]&&typeof c[v]=="object"?b[v]=P(c[v]):b[v]=c[v]}),b}t.deepClone=P;function S(c){if(!c||typeof c!="object")return c;const b=[c];for(;b.length>0;){const v=b.shift();Object.freeze(v);for(const m in v)if(k.call(v,m)){const f=v[m];typeof f=="object"&&!Object.isFrozen(f)&&b.push(f)}}return c}t.deepFreeze=S;const k=Object.prototype.hasOwnProperty;function F(c,b){return L(c,b,new Set)}t.cloneAndChange=F;function L(c,b,v){if((0,A.isUndefinedOrNull)(c))return c;const m=b(c);if(typeof m!="undefined")return m;if((0,A.isArray)(c)){const f=[];for(const o of c)f.push(L(o,b,v));return f}if((0,A.isObject)(c)){if(v.has(c))throw new Error("Cannot clone recursive data-structure");v.add(c);const f={};for(let o in c)k.call(c,o)&&(f[o]=L(c[o],b,v));return v.delete(c),f}return c}function u(c,b,v=!0){return(0,A.isObject)(c)?((0,A.isObject)(b)&&Object.keys(b).forEach(m=>{m in c?v&&((0,A.isObject)(c[m])&&(0,A.isObject)(b[m])?u(c[m],b[m],v):c[m]=b[m]):c[m]=b[m]}),c):b}t.mixin=u;function h(c,b){if(c===b)return!0;if(c==null||b===null||b===void 0||typeof c!=typeof b||typeof c!="object"||Array.isArray(c)!==Array.isArray(b))return!1;let v,m;if(Array.isArray(c)){if(c.length!==b.length)return!1;for(v=0;v<c.length;v++)if(!h(c[v],b[v]))return!1}else{const f=[];for(m in c)f.push(m);f.sort();const o=[];for(m in b)o.push(m);if(o.sort(),!h(f,o))return!1;for(v=0;v<f.length;v++)if(!h(c[f[v]],b[f[v]]))return!1}return!0}t.equals=h;function g(c){const b=new Set;return JSON.stringify(c,(v,m)=>{if((0,A.isObject)(m)||Array.isArray(m)){if(b.has(m))return"[Circular]";b.add(m)}return m})}t.safeStringify=g;function p(c,b,v){const m=b(c);return typeof m=="undefined"?v:m}t.getOrDefault=p;function d(c,b){const v=Object.create(null);return!c||!b||Object.keys(b).forEach(f=>{const o=c[f],s=b[f];h(o,s)||(v[f]=s)}),v}t.distinct=d;function D(c,b){const v=b.toLowerCase(),m=Object.keys(c).find(f=>f.toLowerCase()===v);return m?c[m]:c[b]}t.getCaseInsensitive=D;function a(c,b){const v=Object.create(null);for(const m of Object.keys(c))b(m,c[m])&&(v[m]=c[m]);return v}t.filter=a}),define(Z[59],ee([0,1,8]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function P(h){const g=h;return g&&typeof g.type=="string"&&typeof g.severity=="string"}t.isRemoteConsoleLog=P;function S(h){const g=[];let p;try{const d=JSON.parse(h.arguments),D=d[d.length-1];D&&D.__$stack&&(d.pop(),p=D.__$stack),g.push(...d)}catch(d){g.push("Unable to log remote console arguments",h.arguments)}return{args:g,stack:p}}t.parse=S;function k(h){if(typeof h!="string")return k(S(h).stack);const g=h;if(g){const p=F(g),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(d&&d.length===4)return{uri:A.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=k;function F(h){if(!h)return h;const g=h.indexOf(`
`);return g===-1?h:h.substring(0,g)}function L(h,g){const{args:p,stack:d}=S(h),D=typeof p[0]=="string"&&p.length===1;let a=F(d);a&&(a=`(${a.trim()})`);let c=[];if(typeof p[0]=="string"?a&&D?c=[`%c[${g}] %c${p[0]} %c${a}`,u("blue"),u(""),u("grey")]:c=[`%c[${g}] %c${p[0]}`,u("blue"),u(""),...p.slice(1)]:c=[`%c[${g}]%`,u("blue"),...p],a&&!D&&c.push(a),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,c)}t.log=L;function u(h){return`color: ${h}`}}),define(Z[60],ee([0,1,16,22,8]),function(G,t,A,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function k(g){return JSON.stringify(g,u)}t.stringify=k;function F(g){let p=JSON.parse(g);return p=h(p),p}t.parse=F;var L;(function(g){g[g.Uri=1]="Uri",g[g.Regexp=2]="Regexp",g[g.ScmResource=3]="ScmResource",g[g.ScmResourceGroup=4]="ScmResourceGroup",g[g.ScmProvider=5]="ScmProvider",g[g.CommentController=6]="CommentController",g[g.CommentThread=7]="CommentThread",g[g.CommentThreadReply=8]="CommentThreadReply",g[g.CommentNode=9]="CommentNode",g[g.CommentThreadNode=10]="CommentThreadNode",g[g.TimelineActionContext=11]="TimelineActionContext",g[g.NotebookCellActionContext=12]="NotebookCellActionContext",g[g.TestItemContext=13]="TestItemContext"})(L=t.MarshalledId||(t.MarshalledId={}));function u(g,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,P.regExpFlags)(p)}:p}function h(g,p=0){if(!g||p>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return S.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof A.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let d=0;d<g.length;++d)g[d]=h(g[d],p+1);else for(const d in g)Object.hasOwnProperty.call(g,d)&&(g[d]=h(g[d],p+1))}return g}t.revive=h}),define(Z[61],ee([0,1,3,31,45,4,22]),function(G,t,A,P,S,k,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function L(){return Object.create(null)}t.getEmptyExpression=L;const u="**",h="/",g="[/\\\\]",p="[^/\\\\]",d=/\//g;function D(I){switch(I){case 0:return"";case 1:return`${p}*?`;default:return`(?:${g}|${p}+${g}|${g}${p}+)*?`}}function a(I,M){if(!I)return[];const w=[];let C=!1,T=!1,j="";for(const B of I){switch(B){case M:if(!C&&!T){w.push(j),j="";continue}break;case"{":C=!0;break;case"}":C=!1;break;case"[":T=!0;break;case"]":T=!1;break}j+=B}return j&&w.push(j),w}t.splitGlobAware=a;function c(I){if(!I)return"";let M="";const w=a(I,h);if(w.every(C=>C===u))M=".*";else{let C=!1;w.forEach((T,j)=>{if(T===u){C||(M+=D(2),C=!0);return}let B=!1,_="",K=!1,te="";for(const ne of T){if(ne!=="}"&&B){_+=ne;continue}if(K&&(ne!=="]"||!te)){let oe;ne==="-"?oe=ne:(ne==="^"||ne==="!")&&!te?oe="^":ne===h?oe="":oe=F.escapeRegExpCharacters(ne),te+=oe;continue}switch(ne){case"{":B=!0;continue;case"[":K=!0;continue;case"}":M+=`(?:${a(_,",").map(pe=>c(pe)).join("|")})`,B=!1,_="";break;case"]":M+="["+te+"]",K=!1,te="";break;case"?":M+=p;continue;case"*":M+=D(1);continue;default:M+=F.escapeRegExpCharacters(ne)}}j<w.length-1&&(w[j+1]!==u||j+2<w.length)&&(M+=g),C=!1})}return M}const b=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),n=function(){return!1},i=function(){return null};function r(I,M){if(!I)return i;let w;typeof I!="string"?w=I.pattern:w=I,w=w.trim();const C=`${w}_${!!M.trimForExclusions}`;let T=e.get(C);if(T)return l(T,I);let j;if(b.test(w)){const B=w.substr(4);T=function(_,K){return typeof _=="string"&&_.endsWith(B)?w:null}}else(j=v.exec(y(w,M)))?T=R(j[1],w):(M.trimForExclusions?f:m).test(w)?T=N(w,M):(j=o.exec(y(w,M)))?T=E(j[1].substr(1),w,!0):(j=s.exec(y(w,M)))?T=E(j[1],w,!1):T=O(w);return e.set(C,T),l(T,I)}function l(I,M){return typeof M=="string"?I:function(w,C){return P.isEqualOrParent(w,M.base)?I(k.relative(M.base,w),C):null}}function y(I,M){return M.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function R(I,M){const w=`/${I}`,C=`\\${I}`,T=function(B,_){return typeof B!="string"?null:_?_===I?M:null:B===I||B.endsWith(w)||B.endsWith(C)?M:null},j=[I];return T.basenames=j,T.patterns=[M],T.allBasenames=j,T}function N(I,M){const w=U(I.slice(1,-1).split(",").map(_=>r(_,M)).filter(_=>_!==i),I),C=w.length;if(!C)return i;if(C===1)return w[0];const T=function(_,K){for(let te=0,ne=w.length;te<ne;te++)if(w[te](_,K))return I;return null},j=w.find(_=>!!_.allBasenames);j&&(T.allBasenames=j.allBasenames);const B=w.reduce((_,K)=>K.allPaths?_.concat(K.allPaths):_,[]);return B.length&&(T.allPaths=B),T}function E(I,M,w){const C=k.sep===k.posix.sep,T=C?I:I.replace(d,k.sep),j=k.sep+T,B=k.posix.sep+I,_=w?function(K,te){return typeof K=="string"&&(K===T||K.endsWith(j)||!C&&(K===I||K.endsWith(B)))?M:null}:function(K,te){return typeof K=="string"&&(K===T||!C&&K===I)?M:null};return _.allPaths=[(w?"*/":"./")+I],_}function O(I){try{const M=new RegExp(`^${c(I)}$`);return function(w){return M.lastIndex=0,typeof w=="string"&&M.test(w)?I:null}}catch(M){return i}}function z(I,M,w){return!I||typeof M!="string"?!1:$(I)(M,void 0,w)}t.match=z;function $(I,M={}){if(!I)return n;if(typeof I=="string"||Y(I)){const w=r(I,M);if(w===i)return n;const C=function(T,j){return!!w(T,j)};return w.allBasenames&&(C.allBasenames=w.allBasenames),w.allPaths&&(C.allPaths=w.allPaths),C}return x(I,M)}t.parse=$;function Q(I){if(!I)return;let M;return w=>(M||(M=(I()||Promise.resolve([])).then(C=>C?re(C):{})),M.then(C=>!!C[w]))}t.hasSiblingPromiseFn=Q;function ie(I){if(!I)return;let M;return w=>{if(!M){const C=I();M=C?re(C):{}}return!!M[w]}}t.hasSiblingFn=ie;function re(I){const M={};for(const w of I)M[w]=!0;return M}function Y(I){const M=I;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=Y;function J(I){return I.allBasenames||[]}t.getBasenameTerms=J;function W(I){return I.allPaths||[]}t.getPathTerms=W;function x(I,M){const w=U(Object.getOwnPropertyNames(I).map(_=>q(_,I[_],M)).filter(_=>_!==i)),C=w.length;if(!C)return i;if(!w.some(_=>!!_.requiresSiblings)){if(C===1)return w[0];const _=function(ne,oe){for(let le=0,pe=w.length;le<pe;le++){const De=w[le](ne,oe);if(De)return De}return null},K=w.find(ne=>!!ne.allBasenames);K&&(_.allBasenames=K.allBasenames);const te=w.reduce((ne,oe)=>oe.allPaths?ne.concat(oe.allPaths):ne,[]);return te.length&&(_.allPaths=te),_}const T=function(_,K,te){let ne;for(let oe=0,le=w.length;oe<le;oe++){const pe=w[oe];pe.requiresSiblings&&te&&(K||(K=k.basename(_)),ne||(ne=K.substr(0,K.length-k.extname(_).length)));const De=pe(_,K,ne,te);if(De)return De}return null},j=w.find(_=>!!_.allBasenames);j&&(T.allBasenames=j.allBasenames);const B=w.reduce((_,K)=>K.allPaths?_.concat(K.allPaths):_,[]);return B.length&&(T.allPaths=B),T}function q(I,M,w){if(M===!1)return i;const C=r(I,w);if(C===i)return i;if(typeof M=="boolean")return C;if(M){const T=M.when;if(typeof T=="string"){const j=(B,_,K,te)=>{if(!te||!C(B,_))return null;const ne=T.replace("$(basename)",K),oe=te(ne);return(0,A.isThenable)(oe)?oe.then(le=>le?I:null):oe?I:null};return j.requiresSiblings=!0,j}}return C}function U(I,M){const w=I.filter(_=>!!_.basenames);if(w.length<2)return I;const C=w.reduce((_,K)=>{const te=K.basenames;return te?_.concat(te):_},[]);let T;if(M){T=[];for(let _=0,K=C.length;_<K;_++)T.push(M)}else T=w.reduce((_,K)=>{const te=K.patterns;return te?_.concat(te):_},[]);const j=function(_,K){if(typeof _!="string")return null;if(!K){let ne;for(ne=_.length;ne>0;ne--){const oe=_.charCodeAt(ne-1);if(oe===47||oe===92)break}K=_.substr(ne)}const te=C.indexOf(K);return te!==-1?T[te]:null};j.basenames=C,j.patterns=T,j.allBasenames=C;const B=I.filter(_=>!_.basenames);return B.push(j),B}}),define(Z[62],ee([0,1,31,9,4,10,19,22,8]),function(G,t,A,P,S,k,F,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function h(r,l,y){if(typeof r=="string"&&(r=u.URI.file(r)),y){const N=y.getWorkspaceFolder(r);if(N){const E=y.getWorkspace().folders.length>1;let O;if((0,F.isEqual)(N.uri,r)?O="":O=(0,F.relativePath)(N.uri,r),E){const z=N.name?N.name:(0,F.basename)(N.uri);O=O?z+" \u2022 "+O:z}return O}}if(r.scheme!==P.Schemas.file&&r.scheme!==P.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,A.hasDriveLetter)(r.fsPath))return(0,S.normalize)(p(r.fsPath));let R=(0,S.normalize)(r.fsPath);return!k.isWindows&&l?.userHome&&(R=D(R,l.userHome.fsPath)),R}t.getPathLabel=h;function g(r){if(!r)return;typeof r=="string"&&(r=u.URI.file(r));const l=(0,F.basename)(r)||(r.scheme===P.Schemas.file?r.fsPath:r.path);return k.isWindows&&(0,A.isRootOrDriveLetter)(l)?p(l):l}t.getBaseLabel=g;function p(r){return(0,A.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=p;let d=Object.create(null);function D(r,l){if(k.isWindows||!r||!l)return r;let y=d.original===l?d.normalized:void 0;return y||(y=`${(0,L.rtrim)(l,S.posix.sep)}${S.posix.sep}`,d={original:l,normalized:y}),(k.isLinux?r.startsWith(y):(0,L.startsWithIgnoreCase)(r,y))&&(r=`~/${r.substr(y.length)}`),r}t.tildify=D;function a(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=a;const c="\u2026",b="\\\\",v="~";function m(r,l=S.sep){const y=new Array(r.length);let R=!1;for(let N=0;N<r.length;N++){let E=r[N];if(E===""){y[N]=`.${l}`;continue}if(!E){y[N]=E;continue}R=!0;let O="";E.indexOf(b)===0?(O=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length)):E.indexOf(l)===0?(O=E.substr(0,E.indexOf(l)+l.length),E=E.substr(E.indexOf(l)+l.length)):E.indexOf(v)===0&&(O=E.substr(0,E.indexOf(v)+v.length),E=E.substr(E.indexOf(v)+v.length));const z=E.split(l);for(let $=1;R&&$<=z.length;$++)for(let Q=z.length-$;R&&Q>=0;Q--){R=!1;let ie=z.slice(Q,Q+$).join(l);for(let re=0;!R&&re<r.length;re++)if(re!==N&&r[re]&&r[re].indexOf(ie)>-1){const Y=Q+$===z.length,J=Q>0&&r[re].indexOf(l)>-1?l+ie:ie,W=r[re].endsWith(J);R=!Y||W}if(!R){let re="";(z[0].endsWith(":")||O!=="")&&(Q===1&&(Q=0,$++,ie=z[0]+l+ie),Q>0&&(re=z[0]+l),re=O+re),Q>0&&(re=re+c+l),re=re+ie,Q+$<z.length&&(re=re+l+c),y[N]=re}}R&&(y[N]=E)}return y}t.shorten=m;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function o(r,l=Object.create(null)){const y=[];let R=!1,N="";for(const E of r)if(E==="$"||R&&E==="{")N&&y.push({value:N,type:f.TEXT}),N="",R=!0;else if(E==="}"&&R){const O=l[N];if(typeof O=="string")O.length&&y.push({value:O,type:f.VARIABLE});else if(O){const z=y[y.length-1];(!z||z.type!==f.SEPARATOR)&&y.push({value:O.label,type:f.SEPARATOR})}N="",R=!1}else N+=E;return N&&!R&&y.push({value:N,type:f.TEXT}),y.filter((E,O)=>{if(E.type===f.SEPARATOR){const z=y[O-1],$=y[O+1];return[z,$].every(Q=>Q&&(Q.type===f.VARIABLE||Q.type===f.TEXT)&&Q.value.length>0)}return!0}).map(E=>E.value).join("")}t.template=o;function s(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,y=>y==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,y=>y==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=n;function i(r){const l=r.indexOf("/")!==-1?S.posix:S.win32,y=l.basename(r),R=l.dirname(r);return y.length?{name:y,parentPath:R}:{name:R,parentPath:""}}t.splitName=i}),define(Z[46],ee([0,1,126]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class P{constructor(k="utf8"){this.stringDecoder=new A.StringDecoder(k),this.remaining=null}write(k){const F=[],L=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(L.length<1)return F;let u=0,h,g=u;for(;g<L.length;)if(h=L.charCodeAt(g),h===13||h===10){if(F.push(L.substring(u,g)),g++,g<L.length){const p=h;h=L.charCodeAt(g),(p===13&&h===10||p===10&&h===13)&&g++}u=g}else g++;return this.remaining=u<L.length?L.substr(u):null,F}end(){return this.remaining}}t.LineDecoder=P}),define(Z[63],ee([0,1,38,4,22,11]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function F(g){const p=(0,P.dirname)(g);if(g===p)return g;const d=((0,P.basename)(g)||g).toLowerCase();try{const a=(0,k.readdirSync)(p).filter(c=>c.toLowerCase()===d);if(a.length===1){const c=F(p);if(c)return(0,P.join)(c,a[0])}else if(a.length>1){const c=a.indexOf(d);if(c>=0){const b=F(p);if(b)return(0,P.join)(b,a[c])}}}catch(D){}return null}t.realcaseSync=F;async function L(g){try{return await k.Promises.realpath(g)}catch(p){const d=h(g);return await k.Promises.access(d,A.constants.R_OK),d}}t.realpath=L;function u(g){try{return A.realpathSync(g)}catch(p){const d=h(g);return A.accessSync(d,A.constants.R_OK),d}}t.realpathSync=u;function h(g){return(0,S.rtrim)((0,P.normalize)(g),P.sep)}}),define(Z[64],ee([0,1,32,4,11]),function(G,t,A,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,F=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var u;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(u||(u={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class p{constructor(s,e,n){this.exePath=s,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:o=!1}={}){return o?h===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function D({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=d({useAlternateBitness:o});if(!e)return null;const n=P.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const R of await S.Promises.readdir(n)){let N=-1;if(s){const O=R.indexOf("-");if(O<0)continue;const z=R.substring(0,O);if(!k.test(z)||R.substring(O+1)!=="preview")continue;N=parseInt(z,10)}else{if(!k.test(R))continue;N=parseInt(R,10)}if(N<=i)continue;const E=P.join(n,R,"pwsh.exe");!await S.SymlinkSupport.existsFile(E)||(r=E,i=N)}if(!r)return null;const l=e.includes("x86")?" (x86)":"",y=s?" Preview":"";return new p(r,`PowerShell${y}${l}`,!0)}async function a({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=o?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const i of await S.Promises.readdir(s))if(e.test(i)){const r=P.join(s,i,"pwsh.exe");return new p(r,n)}return null}function c(){const o=P.join(A.homedir(),".dotnet","tools","pwsh.exe");return new p(o,".NET Core PowerShell Global Tool")}function b(){const o=P.join(process.env.windir,h===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(o,"Windows PowerShell",!0)}async function*v(){let o=await D();o&&(yield o),o=await D({useAlternateBitness:!0}),o&&(yield o),o=await a(),o&&(yield o),o=c(),o&&(yield o),o=await D({findPreview:!0}),o&&(yield o),o=await a({findPreview:!0}),o&&(yield o),o=await D({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=b(),o&&(yield o)}async function*m(){for await(const o of v())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=m;async function f(){for await(const o of m())return o;return null}t.getFirstAvailablePowerShellInstallation=f}),define(Z[65],ee([0,1,38,31,2,127,4,10,11]),function(G,t,A,P,S,k,F,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function h(d,D,a){return p({path:d,isDirectory:!1},D,a)}t.watchFile=h;function g(d,D,a){return p({path:d,isDirectory:!0},D,a)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function p(d,D,a){if(L.isMacintosh&&(0,P.isEqualOrParent)(d.path,"/Volumes/"))return a(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const c=(0,F.basename)(d.path),b=new Map;let v=!1,m=[(0,S.toDisposable)(()=>{b.forEach(f=>(0,S.dispose)(f)),b.clear()})];try{const f=(0,A.watch)(d.path);m.push((0,S.toDisposable)(()=>{f.removeAllListeners(),f.close()}));const o=new Set;d.isDirectory&&u.Promises.readdir(d.path).then(s=>s.forEach(e=>o.add(e))),f.on("error",(s,e)=>{v||a(`Failed to watch ${d.path} for changes using fs.watch() (${s}, ${e})`)}),f.on("change",(s,e)=>{if(v)return;let n="";if(e&&(n=e.toString(),L.isMacintosh&&(n=(0,k.normalizeNFC)(n))),!n||s!=="change"&&s!=="rename")return;const i=d.isDirectory?(0,F.join)(d.path,n):d.path;if(d.isDirectory)if(s==="rename"){const r=b.get(i);r&&(0,S.dispose)(r);const l=setTimeout(async()=>{b.delete(i);const y=await u.Promises.exists(i);if(v)return;let R;y?o.has(n)?R="changed":(R="added",o.add(n)):(o.delete(n),R="deleted"),D(R,i)},t.CHANGE_BUFFER_DELAY);b.set(i,(0,S.toDisposable)(()=>clearTimeout(l)))}else{let r;o.has(n)?r="changed":(r="added",o.add(n)),D(r,i)}else if(s==="rename"||n!==c){const r=setTimeout(async()=>{const l=await u.Promises.exists(i);v||(l?(D("changed",i),m=[p(d,D,a)]):D("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,S.dispose)(m),m=[(0,S.toDisposable)(()=>clearTimeout(r))]}else D("changed",i)})}catch(f){u.Promises.exists(d.path).then(o=>{o&&!v&&a(`Failed to watch ${d.path} for changes using fs.watch() (${f.toString()})`)})}return(0,S.toDisposable)(()=>{v=!0,m=(0,S.dispose)(m)})}});var ue=this&&this.__decorate||function(G,t,A,P){var S=arguments.length,k=S<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,A):P,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(G,t,A,P);else for(var L=G.length-1;L>=0;L--)(F=G[L])&&(k=(S<3?F(k):S>3?F(t,A,k):F(t,A))||k);return S>3&&k&&Object.defineProperty(t,A,k),k};define(Z[39],ee([0,1,21,3,16,26,44,7,14,2,60,22,13]),function(G,t,A,P,S,k,F,L,u,h,g,p,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var D;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(D=t.RequestType||(t.RequestType={}));function a(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function b(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(v||(v={}));class m{constructor(I){this.buffer=I,this.pos=0}read(I){const M=this.buffer.slice(this.pos,this.pos+I);return this.pos+=M.byteLength,M}}class f{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(I){this.buffers.push(I)}}var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(o||(o={}));function s(U){const I=S.VSBuffer.alloc(4);return I.writeUInt32BE(U,0),I}function e(U){return U.read(4).readUInt32BE(0)}function n(U){const I=S.VSBuffer.alloc(1);return I.writeUInt8(U,0),I}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object)},r=typeof Buffer!="undefined";function l(U,I){if(typeof I=="undefined")U.write(i.Undefined);else if(typeof I=="string"){const M=S.VSBuffer.fromString(I);U.write(i.String),U.write(s(M.byteLength)),U.write(M)}else if(r&&Buffer.isBuffer(I)){const M=S.VSBuffer.wrap(I);U.write(i.Buffer),U.write(s(M.byteLength)),U.write(M)}else if(I instanceof S.VSBuffer)U.write(i.VSBuffer),U.write(s(I.byteLength)),U.write(I);else if(Array.isArray(I)){U.write(i.Array),U.write(s(I.length));for(const M of I)l(U,M)}else{const M=S.VSBuffer.fromString(JSON.stringify(I));U.write(i.Object),U.write(s(M.byteLength)),U.write(M)}}function y(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(e(U)).toString();case o.Buffer:return U.read(e(U)).buffer;case o.VSBuffer:return U.read(e(U));case o.Array:{const M=e(U),w=[];for(let C=0;C<M;C++)w.push(y(U));return w}case o.Object:return JSON.parse(U.read(e(U)).toString())}}class R{constructor(I,M,w=null,C=1e3){this.protocol=I,this.ctx=M,this.logger=w,this.timeoutDelay=C,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel(I,M){this.channels.set(I,M),setTimeout(()=>this.flushPendingRequests(I),0)}sendResponse(I){switch(I.type){case 200:{const M=this.send([I.type]);this.logger&&this.logger.logOutgoing(M,0,1,b(I.type));return}case 201:case 202:case 204:case 203:{const M=this.send([I.type,I.id],I.data);this.logger&&this.logger.logOutgoing(M,I.id,1,b(I.type),I.data);return}}}send(I,M=void 0){const w=new f;return l(w,I),l(w,M),this.sendBuffer(w.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(M){return 0}}onRawMessage(I){const M=new m(I),w=y(M),C=y(M),T=w[0];switch(T){case 100:return this.logger&&this.logger.logIncoming(I.byteLength,w[1],1,`${a(T)}: ${w[2]}.${w[3]}`,C),this.onPromise({type:T,id:w[1],channelName:w[2],name:w[3],arg:C});case 102:return this.logger&&this.logger.logIncoming(I.byteLength,w[1],1,`${a(T)}: ${w[2]}.${w[3]}`,C),this.onEventListen({type:T,id:w[1],channelName:w[2],name:w[3],arg:C});case 101:return this.logger&&this.logger.logIncoming(I.byteLength,w[1],1,`${a(T)}`),this.disposeActiveRequest({type:T,id:w[1]});case 103:return this.logger&&this.logger.logIncoming(I.byteLength,w[1],1,`${a(T)}`),this.disposeActiveRequest({type:T,id:w[1]})}}onPromise(I){const M=this.channels.get(I.channelName);if(!M){this.collectPendingRequest(I);return}const w=new k.CancellationTokenSource;let C;try{C=M.call(this.ctx,I.name,I.arg,w.token)}catch(B){C=Promise.reject(B)}const T=I.id;C.then(B=>{this.sendResponse({id:T,data:B,type:201}),this.activeRequests.delete(I.id)},B=>{B instanceof Error?this.sendResponse({id:T,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:T,data:B,type:203}),this.activeRequests.delete(I.id)});const j=(0,h.toDisposable)(()=>w.cancel());this.activeRequests.set(I.id,j)}onEventListen(I){const M=this.channels.get(I.channelName);if(!M){this.collectPendingRequest(I);return}const w=I.id,T=M.listen(this.ctx,I.name,I.arg)(j=>this.sendResponse({id:w,data:j,type:204}));this.activeRequests.set(I.id,T)}disposeActiveRequest(I){const M=this.activeRequests.get(I.id);M&&(M.dispose(),this.activeRequests.delete(I.id))}collectPendingRequest(I){let M=this.pendingRequests.get(I.channelName);M||(M=[],this.pendingRequests.set(I.channelName,M));const w=setTimeout(()=>{console.error(`Unknown channel: ${I.channelName}`),I.type===100&&this.sendResponse({id:I.id,data:{name:"Unknown channel",message:`Channel name '${I.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:I,timeoutTimer:w})}flushPendingRequests(I){const M=this.pendingRequests.get(I);if(M){for(const w of M)switch(clearTimeout(w.timeoutTimer),w.request.type){case 100:this.onPromise(w.request);break;case 102:this.onEventListen(w.request);break}this.pendingRequests.delete(I)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}t.ChannelServer=R;var N;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(N=t.RequestInitiator||(t.RequestInitiator={}));class E{constructor(I,M=null){this.protocol=I,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(w=>this.onBuffer(w)),this.logger=M}getChannel(I){const M=this;return{call(w,C,T){return M.isDisposed?Promise.reject(L.canceled()):M.requestPromise(I,w,C,T)},listen(w,C){return M.isDisposed?Promise.reject(L.canceled()):M.requestEvent(I,w,C)}}}requestPromise(I,M,w,C=k.CancellationToken.None){const T=this.lastRequestId++,B={id:T,type:100,channelName:I,name:M,arg:w};if(C.isCancellationRequested)return Promise.reject(L.canceled());let _;return new Promise((te,ne)=>{if(C.isCancellationRequested)return ne(L.canceled());const oe=()=>{const ke=Te=>{switch(Te.type){case 201:this.handlers.delete(T),te(Te.data);break;case 202:this.handlers.delete(T);const we=new Error(Te.data.message);we.stack=Te.data.stack,we.name=Te.data.name,ne(we);break;case 203:this.handlers.delete(T),ne(Te.data);break}};this.handlers.set(T,ke),this.sendRequest(B)};let le=null;this.state===v.Idle?oe():(le=(0,P.createCancelablePromise)(ke=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const pe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:T,type:101}),ne(L.canceled())},De=C.onCancellationRequested(pe);_=(0,h.combinedDisposable)((0,h.toDisposable)(pe),De),this.activeRequests.add(_)}).finally(()=>{this.activeRequests.delete(_)})}requestEvent(I,M,w){const C=this.lastRequestId++,j={id:C,type:102,channelName:I,name:M,arg:w};let B=null;const _=new u.Emitter({onFirstListenerAdd:()=>{B=(0,P.createCancelablePromise)(te=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add(_),this.sendRequest(j)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete(_),this.sendRequest({id:C,type:103}))}}),K=te=>_.fire(te.data);return this.handlers.set(C,K),_.event}sendRequest(I){switch(I.type){case 100:case 102:{const M=this.send([I.type,I.id,I.channelName,I.name],I.arg);this.logger&&this.logger.logOutgoing(M,I.id,0,`${a(I.type)}: ${I.channelName}.${I.name}`,I.arg);return}case 101:case 103:{const M=this.send([I.type,I.id]);this.logger&&this.logger.logOutgoing(M,I.id,0,a(I.type));return}}}send(I,M=void 0){const w=new f;return l(w,I),l(w,M),this.sendBuffer(w.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(M){return 0}}onBuffer(I){const M=new m(I),w=y(M),C=y(M),T=w[0];switch(T){case 200:return this.logger&&this.logger.logIncoming(I.byteLength,0,0,b(T)),this.onResponse({type:w[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(I.byteLength,w[1],0,b(T),C),this.onResponse({type:w[0],id:w[1],data:C})}}onResponse(I){if(I.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(I.id);M&&M(I)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}ue([F.memoize],E.prototype,"onDidInitializePromise",null),t.ChannelClient=E;class O{constructor(I){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,I(({protocol:M,onDidClientDisconnect:w})=>{u.Event.once(M.onMessage)(T=>{const j=new m(T),B=y(j),_=new R(M,B),K=new E(M);this.channels.forEach((ne,oe)=>_.registerChannel(oe,ne));const te={channelServer:_,channelClient:K,ctx:B};this._connections.add(te),this._onDidAddConnection.fire(te),w(()=>{_.dispose(),K.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)})})})}get connections(){const I=[];return this._connections.forEach(M=>I.push(M)),I}getChannel(I,M){const w=this;return{call(C,T,j){let B;if((0,d.isFunction)(M)){let K=(0,A.getRandomElement)(w.connections.filter(M));B=K?Promise.resolve(K):u.Event.toPromise(u.Event.filter(w.onDidAddConnection,M))}else B=M.routeCall(w,C,T);const _=B.then(K=>K.channelClient.getChannel(I));return $(_).call(C,T,j)},listen(C,T){if((0,d.isFunction)(M))return w.getMulticastEvent(I,M,C,T);const j=M.routeEvent(w,C,T).then(B=>B.channelClient.getChannel(I));return $(j).listen(C,T)}}}getMulticastEvent(I,M,w,C){const T=this;let j=new h.DisposableStore;const B=new u.Emitter({onFirstListenerAdd:()=>{j=new h.DisposableStore;const _=new u.EventMultiplexer,K=new Map,te=oe=>{const pe=oe.channelClient.getChannel(I).listen(w,C),De=_.add(pe);K.set(oe,De)},ne=oe=>{const le=K.get(oe);!le||(le.dispose(),K.delete(oe))};T.connections.filter(M).forEach(te),u.Event.filter(T.onDidAddConnection,M)(te,void 0,j),T.onDidRemoveConnection(ne,void 0,j),_.event(B.fire,B,j),j.add(_)},onLastListenerRemove:()=>{j.dispose()}});return B.event}registerChannel(I,M){this.channels.set(I,M),this._connections.forEach(w=>{w.channelServer.registerChannel(I,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class z{constructor(I,M,w=null){const C=new f;l(C,M),I.send(C.buffer),this.channelClient=new E(I,w),this.channelServer=new R(I,M,w)}getChannel(I){return this.channelClient.getChannel(I)}registerChannel(I,M){this.channelServer.registerChannel(I,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=z;function $(U){return{call(I,M,w){return U.then(C=>C.call(I,M,w))},listen(I,M){const w=new u.Relay;return U.then(C=>w.input=C.listen(I,M)),w.event}}}t.getDelayedChannel=$;function Q(U){let I=!1;return{call(M,w,C){return I?U.call(M,w,C):(0,P.timeout)(0).then(()=>I=!0).then(()=>U.call(M,w,C))},listen(M,w){if(I)return U.listen(M,w);const C=new u.Relay;return(0,P.timeout)(0).then(()=>I=!0).then(()=>C.input=U.listen(M,w)),C.event}}}t.getNextTickChannel=Q;class ie{constructor(I){this.fn=I}routeCall(I){return this.route(I)}routeEvent(I){return this.route(I)}async route(I){for(const M of I.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await u.Event.toPromise(I.onDidAddConnection),await this.route(I)}}t.StaticRouter=ie;var re;(function(U){function I(C,T){const j=C,B=T&&T.disableMarshalling,_=new Map;for(const K in j)w(K)&&_.set(K,u.Event.buffer(j[K],!0));return new class{listen(K,te){const ne=_.get(te);if(ne)return ne;throw new Error(`Event not found: ${te}`)}call(K,te,ne){const oe=j[te];if(typeof oe=="function"){if(!B&&Array.isArray(ne))for(let le=0;le<ne.length;le++)ne[le]=(0,g.revive)(ne[le]);return oe.apply(j,ne)}throw new Error(`Method not found: ${te}`)}}}U.fromService=I;function M(C,T){const j=T&&T.disableMarshalling;return new Proxy({},{get(B,_){if(typeof _=="string")return T?.properties?.has(_)?T.properties.get(_):w(_)?C.listen(_):async function(...K){let te;T&&!(0,d.isUndefinedOrNull)(T.context)?te=[T.context,...K]:te=K;const ne=await C.call(_,te);return j?ne:(0,g.revive)(ne)};throw new Error(`Property not found: ${String(_)}`)}})}U.toService=M;function w(C){return C[0]==="o"&&C[1]==="n"&&p.isUpperAsciiLetter(C.charCodeAt(2))}})(re=t.ProxyChannel||(t.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let I=U.toString();if(I!=="[object Object]")return I}return U}function W(U){return Array.isArray(U)?U.map(J):J(U)}function x(U,I,M,w,C,T,j){j=W(j);const B=Y[C],_=B[w%B.length];let K=[`%c[${U}]%c[${String(I).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(w).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(T)?(K=K.concat(j),K.push(")")):K.push(j),console.log.apply(console,K)}t.logWithColors=x;class q{constructor(I,M){this._outgoingPrefix=I,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(I,M,w,C,T){this._totalOutgoing+=I,x(this._outgoingPrefix,this._totalOutgoing,I,M,w,C,T)}logIncoming(I,M,w,C,T){this._totalIncoming+=I,x(this._incomingPrefix,this._totalIncoming,I,M,w,C,T)}}t.IPCLogger=q}),define(Z[66],ee([0,1,3,14,2,13]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var L;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(L||(L={}));class u extends S.Disposable{constructor(p,d=Object.create(null)){super();this.database=p,this.options=d,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((d,D)=>this.accept(D,d)),p.deleted?.forEach(d=>this.accept(d,void 0))}accept(p,d){if(this.state===L.Closed)return;let D=!1;(0,k.isUndefinedOrNull)(d)?D=this.cache.delete(p):this.cache.get(p)!==d&&(this.cache.set(p,d),D=!0),D&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,d){const D=this.cache.get(p);return(0,k.isUndefinedOrNull)(D)?d:D}getBoolean(p,d){const D=this.get(p);return(0,k.isUndefinedOrNull)(D)?d:D==="true"}getNumber(p,d){const D=this.get(p);return(0,k.isUndefinedOrNull)(D)?d:parseInt(D,10)}async set(p,d){if(this.state===L.Closed)return;if((0,k.isUndefinedOrNull)(d))return this.delete(p);const D=String(d);if(this.cache.get(p)!==D)return this.cache.set(p,D),this.pendingInserts.set(p,D),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async delete(p){if(!(this.state===L.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(p){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class h{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((d,D)=>this.items.set(D,d)),p.delete&&p.delete.forEach(d=>this.items.delete(d))}async close(){}}t.InMemoryStorageDatabase=h}),define(Z[67],ee([5,6]),function(G,t){return G.create("vs/base/common/date",t)}),define(Z[68],ee([0,1,67]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const P=60,S=P*60,k=S*24,F=k*7,L=k*30,u=k*365;function h(p,d){typeof p!="number"&&(p=p.getTime());const D=Math.round((new Date().getTime()-p)/1e3);if(D<-30)return(0,A.localize)(0,null,h(new Date().getTime()+D*1e3,!1));if(D<30)return(0,A.localize)(1,null);let a;return D<P?(a=D,d?a===1?(0,A.localize)(2,null,a):(0,A.localize)(3,null,a):a===1?(0,A.localize)(4,null,a):(0,A.localize)(5,null,a)):D<S?(a=Math.floor(D/P),d?a===1?(0,A.localize)(6,null,a):(0,A.localize)(7,null,a):a===1?(0,A.localize)(8,null,a):(0,A.localize)(9,null,a)):D<k?(a=Math.floor(D/S),d?a===1?(0,A.localize)(10,null,a):(0,A.localize)(11,null,a):a===1?(0,A.localize)(12,null,a):(0,A.localize)(13,null,a)):D<F?(a=Math.floor(D/k),d?a===1?(0,A.localize)(14,null,a):(0,A.localize)(15,null,a):a===1?(0,A.localize)(16,null,a):(0,A.localize)(17,null,a)):D<L?(a=Math.floor(D/F),d?a===1?(0,A.localize)(18,null,a):(0,A.localize)(19,null,a):a===1?(0,A.localize)(20,null,a):(0,A.localize)(21,null,a)):D<u?(a=Math.floor(D/L),d?a===1?(0,A.localize)(22,null,a):(0,A.localize)(23,null,a):a===1?(0,A.localize)(24,null,a):(0,A.localize)(25,null,a)):(a=Math.floor(D/u),d?a===1?(0,A.localize)(26,null,a):(0,A.localize)(27,null,a):a===1?(0,A.localize)(28,null,a):(0,A.localize)(29,null,a))}t.fromNow=h;function g(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=g}),define(Z[69],ee([5,6]),function(G,t){return G.create("vs/base/common/errorMessage",t)}),define(Z[28],ee([0,1,21,13,69]),function(G,t,A,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function k(h,g){return g&&(h.stack||h.stacktrace)?S.localize(0,null,L(h),F(h.stack)||F(h.stacktrace)):L(h)}function F(h){return Array.isArray(h)?h.join(`
`):h}function L(h){return typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?S.localize(1,null,h.message):h.message||S.localize(2,null)}function u(h=null,g=!1){if(!h)return S.localize(3,null);if(Array.isArray(h)){const p=A.coalesce(h),d=u(p[0],g);return p.length>1?S.localize(4,null,d,p.length):d}if(P.isString(h))return h;if(h.detail){const p=h.detail;if(p.error)return k(p.error,g);if(p.exception)return k(p.exception,g)}return h.stack?k(h,g):h.message?h.message:S.localize(5,null)}t.toErrorMessage=u}),define(Z[70],ee([5,6]),function(G,t){return G.create("vs/base/node/processes",t)}),define(Z[47],ee([0,1,33,31,9,18,4,10,34,13,46,11,70]),function(G,t,A,P,S,k,F,L,u,h,g,p,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function D(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(o,s){if(L.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const n=A.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(i=>{n.once("error",r=>{i({success:!1,error:r})}),n.once("exit",(r,l)=>{i(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?D(e.status):1})}else if(L.isLinux||L.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(n=>{A.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,r,l)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function c(o=u.env){return o.comspec||"cmd.exe"}t.getWindowsShell=c;class b{constructor(s,e,n,i){if(e!==void 0&&n!==void 0&&i!==void 0)this.cmd=s,this.args=e,this.shell=n,this.options=i;else{const r=s;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(u.env).forEach(l=>{r[l]=u.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(F.sep);return e!==-1&&(s=s.substring(e+1)),b.WellKnowCommands[s]?s:"other"}start(s){return L.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(u.cwd()))?Promise.reject(new Error(d.localize(0,null))):this.useExec().then(e=>{let n,i;const r=new Promise((l,y)=>{n=l,i=y});if(e){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=A.exec(l,this.options,(y,R,N)=>{this.childProcess=null;const E=y;E&&E.killed?i({killed:this.terminateRequested,stdout:R.toString(),stderr:N.toString()}):this.handleExec(n,s,y,R,N)})}else{let l=null;const y=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,n,s,i);const N={terminated:this.terminateRequested};h.isNumber(R)&&(N.cmdCode=R),n(N)};if(this.shell&&L.isWindows){const R=k.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let N=!1,E=!1;const O=[];let z=this.ensureQuotes(this.cmd);O.push(z.value),N=z.quoted,this.args&&this.args.forEach(Q=>{z=this.ensureQuotes(Q),O.push(z.value),E=E&&z.quoted});const $=["/s","/c"];N?E?$.push('"'+O.join(" ")+'"'):O.length>1?$.push('"'+O[0]+'" '+O.slice(1).join(" ")):$.push('"'+O[0]+'"'):$.push(O.join(" ")),l=A.spawn(c(),$,R)}else this.cmd&&(l=A.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(h.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",R=>{this.childProcess=null,i({terminated:this.terminateRequested,error:R})}),l.pid&&(this.childProcess.on("close",y),this.handleSpawn(l,n,s,i,!0)))}return r})}handleClose(s,e,n,i){}ensureQuotes(s){return b.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,a(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!L.isWindows)return s(!1);const e=A.spawn(c(),["/s","/c"]);e.on("error",n=>s(!0)),e.on("exit",n=>s(!1))})}}t.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class v extends b{constructor(s,e,n,i){super(s,e,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,n,i,r){[i,r].forEach((l,y)=>{const R=new g.LineDecoder;R.write(l).forEach(O=>{e({line:O,source:y===0?0:1})});const E=R.end();E&&e({line:E,source:y===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,e,n,i,r){const l=new g.LineDecoder,y=new g.LineDecoder;s.stdout.on("data",R=>{l.write(R).forEach(E=>n({line:E,source:0}))}),s.stderr.on("data",R=>{y.write(R).forEach(E=>n({line:E,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=y}handleClose(s,e,n,i){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&n({line:l,source:1})}}t.LineProcess=v;function m(o){let s=[],e=!1;const n=function(i){if(e){s.push(i);return}(!o.send(i,l=>{if(l&&console.error(l),e=!1,s.length>0){const y=s.slice(0);s=[],y.forEach(R=>n(R))}})||L.isWindows)&&(e=!0)};return{send:n}}t.createQueuedSender=m;var f;(function(o){async function s(e,n,i){if(F.isAbsolute(e))return e;if(n===void 0&&(n=u.cwd()),F.dirname(e)!=="."||(i===void 0&&h.isString(u.env.PATH)&&(i=u.env.PATH.split(F.delimiter)),i===void 0||i.length===0))return F.join(n,e);async function l(y){if(await p.Promises.exists(y)){let R;try{R=await p.Promises.stat(y)}catch(N){N.message.startsWith("EACCES")&&(R=await p.Promises.lstat(y))}return R?!R.isDirectory():!1}return!1}for(let y of i){let R;if(F.isAbsolute(y)?R=F.join(y,e):R=F.join(n,y,e),await l(R))return R;let N=R+".com";if(await l(N)||(N=R+".exe",await l(N)))return N}return F.join(n,e)}o.findExecutable=s})(f=t.win32||(t.win32={}))}),define(Z[71],ee([0,1,32,10,64,47]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(D,a){return D===1?P.isWindows?p():k.getWindowsShell(a):h(D,a)}t.getSystemShell=F;function L(D,a){return D===1?P.isWindows?d(a):k.getWindowsShell(a):h(D,a)}t.getSystemShellSync=L;let u=null;function h(D,a){if(P.isLinux&&D===2||P.isMacintosh&&D===3)return"/bin/bash";if(!u){let c;if(P.isWindows)c="/bin/bash";else{if(c=a.SHELL,!c)try{c=(0,A.userInfo)().shell}catch(b){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}u=c}return u}let g=null;async function p(){return g||(g=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),g}function d(D){if(g)return g;const a=P.isWindows&&parseFloat((0,A.release)())>=10,c=D.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${D.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?b:k.getWindowsShell(D)}}),define(Z[48],ee([0,1,33,3,16,26,59,7,14,2,18,10,47,39]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class a extends D.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(f){}},onMessage:u.Event.fromNodeEventEmitter(process,"message",m=>S.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=a;class c{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new P.Delayer(f),this.child=null,this._client=null}getChannel(v){const m=this;return{call(f,o,s){return m.requestPromise(v,f,o,s)},listen(f,o){return m.requestEvent(v,f,o)}}}requestPromise(v,m,f,o=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(v),e=(0,P.createCancelablePromise)(r=>s.call(m,f,r)),n=o.onCancellationRequested(()=>e.cancel()),i=(0,h.toDisposable)(()=>e.cancel());return this.activeRequests.add(i),e.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(v,m,f){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let o;const s=new u.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(v).listen(m,f)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,g.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),p.isMacintosh&&m.env&&delete m.env.DYLD_LIBRARY_PATH,this.child=(0,A.fork)(this.modulePath,v,m);const f=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,F.isRemoteConsoleLog)(l)){(0,F.log)(l,`IPC Library: ${this.options.serverName}`);return}f.fire(S.VSBuffer.wrap(Buffer.from(l,"base64")))});const s=this.options.useQueue?(0,d.createQueuedSender)(this.child):this.child,e=l=>this.child&&this.child.connected&&s.send(l.buffer.toString("base64")),n=f.event,i={send:e,onMessage:n};this._client=new D.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,y)=>{process.removeListener("exit",r),this.activeRequests.forEach(R=>(0,h.dispose)(R)),this.activeRequests.clear(),l!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+y),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:y})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=c}),define(Z[72],ee([5,6]),function(G,t){return G.create("vs/base/node/zip",t)}),define(Z[73],ee([5,6]),function(G,t){return G.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[74],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[75],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[76],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[77],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[78],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[79],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Z[80],ee([5,6]),function(G,t){return G.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[81],ee([5,6]),function(G,t){return G.create("vs/platform/files/common/fileService",t)}),define(Z[82],ee([5,6]),function(G,t){return G.create("vs/platform/files/common/io",t)}),define(Z[83],ee([5,6]),function(G,t){return G.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[84],ee([5,6]),function(G,t){return G.create("vs/platform/request/common/request",t)}),define(Z[85],ee([5,6]),function(G,t){return G.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[86],ee([0,1,68,44,9,4,34,19,8]),function(G,t,A,P,S,k,F,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class h{constructor(a,c,b){this._args=a,this.paths=c,this.productService=b}get appRoot(){return(0,k.dirname)(S.FileAccess.asFileUri("",G).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(u.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return u.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return u.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=F.env.VSCODE_PORTABLE;return a?u.URI.file((0,k.join)(a,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,k.resolve)(a):(0,k.normalize)((0,k.join)(S.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,k.resolve)(a):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,k.resolve)(a);const c=F.env.VSCODE_EXTENSIONS;if(c)return c;const b=F.env.VSCODE_PORTABLE;return b?(0,k.join)(b,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(c=>/^[^:/?#]+?:\/\//.test(c)?u.URI.parse(c):u.URI.file((0,k.normalize)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?u.URI.parse(a):u.URI.file((0,k.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!F.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return u.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([P.memoize],h.prototype,"appRoot",null),ue([P.memoize],h.prototype,"userHome",null),ue([P.memoize],h.prototype,"userDataPath",null),ue([P.memoize],h.prototype,"appSettingsHome",null),ue([P.memoize],h.prototype,"tmpDir",null),ue([P.memoize],h.prototype,"userRoamingDataHome",null),ue([P.memoize],h.prototype,"settingsResource",null),ue([P.memoize],h.prototype,"userDataSyncHome",null),ue([P.memoize],h.prototype,"userDataSyncLogResource",null),ue([P.memoize],h.prototype,"sync",null),ue([P.memoize],h.prototype,"machineSettingsResource",null),ue([P.memoize],h.prototype,"globalStorageHome",null),ue([P.memoize],h.prototype,"workspaceStorageHome",null),ue([P.memoize],h.prototype,"keybindingsResource",null),ue([P.memoize],h.prototype,"keyboardLayoutResource",null),ue([P.memoize],h.prototype,"argvResource",null),ue([P.memoize],h.prototype,"snippetsHome",null),ue([P.memoize],h.prototype,"isExtensionDevelopment",null),ue([P.memoize],h.prototype,"untitledWorkspacesHome",null),ue([P.memoize],h.prototype,"installSourcePath",null),ue([P.memoize],h.prototype,"builtinExtensionsPath",null),ue([P.memoize],h.prototype,"extensionsPath",null),ue([P.memoize],h.prototype,"extensionDevelopmentLocationURI",null),ue([P.memoize],h.prototype,"extensionDevelopmentKind",null),ue([P.memoize],h.prototype,"extensionTestsLocationURI",null),ue([P.memoize],h.prototype,"debugExtensionHost",null),ue([P.memoize],h.prototype,"serviceMachineIdResource",null),ue([P.memoize],h.prototype,"telemetryLogResource",null),ue([P.memoize],h.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=h;function g(D,a){return d(D["inspect-extensions"],D["inspect-brk-extensions"],5870,a,D.debugId)}t.parseExtensionHostPort=g;function p(D,a){return d(D["inspect-search"],D["inspect-brk-search"],5876,a)}t.parseSearchPort=p;function d(D,a,c,b,v){const f=Number(a||D)||(b?null:c),o=f?Boolean(!!a):!1;return{port:f,break:o,debugId:v}}}),function(){"use strict";function G(t,A,P,S){function k(L){const u=F(L),h=[u];return t.isAbsolute(u)||h.unshift(S),t.resolve(...h)}function F(L){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return t.join(h,P);const g=L["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=t.join(p,"AppData","Roaming")}break;case"darwin":h=t.join(A.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||t.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(h,P)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[87],ee([0,88,32,9,19,34]),function(t,A,P,S,k,F){const L=k.dirname(S.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(k.joinPath(L,"package.json").fsPath);return G(A,P,u.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),A=require("path"),P=require("os");module.exports=G(A,P,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[89],ee([0,1,32,86,87]),function(G,t,A,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class k extends P.AbstractNativeEnvironmentService{constructor(L,u){super(L,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,S.getUserDataPath)(L)},u)}}t.NativeEnvironmentService=k}),define(Z[90],ee([0,1,18]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function S(k,F){const L=u=>{if(typeof u!="string")return;const h=P.exec(u);if(!h)return;const g=F[h[1]]??u;return typeof g=="string"?g:typeof g.message=="string"?g.message:u};return(0,A.cloneAndChange)(k,L)}t.localizeManifest=S}),define(Z[49],ee([0,1,80]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function k(d){return d=d.trim(),d==="*"||P.test(d)}t.isValidVersionStr=k;function F(d){if(!k(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let D=d.match(P);return D?{hasCaret:D[1]==="^",hasGreaterEquals:D[1]===">=",majorBase:D[2]==="x"?0:parseInt(D[2],10),majorMustEqual:D[2]!=="x",minorBase:D[4]==="x"?0:parseInt(D[4],10),minorMustEqual:D[4]!=="x",patchBase:D[6]==="x"?0:parseInt(D[6],10),patchMustEqual:D[6]!=="x",preRelease:D[8]||null}:null}t.parseVersion=F;function L(d){if(!d)return null;let D=d.majorBase,a=d.majorMustEqual,c=d.minorBase,b=d.minorMustEqual,v=d.patchBase,m=d.patchMustEqual;d.hasCaret&&(D===0||(b=!1),m=!1);let f=0;if(d.preRelease){const o=S.exec(d.preRelease);if(o){const[,s,e,n]=o;f=Date.UTC(Number(s),Number(e)-1,Number(n))}}return{majorBase:D,majorMustEqual:a,minorBase:c,minorMustEqual:b,patchBase:v,patchMustEqual:m,isMinimum:d.hasGreaterEquals,notBefore:f}}t.normalizeVersion=L;function u(d,D,a){let c;typeof d=="string"?c=L(F(d)):c=d;let b;D instanceof Date?b=D.getTime():typeof D=="string"&&(b=new Date(D).getTime());let v;if(typeof a=="string"?v=L(F(a)):v=a,!c||!v)return!1;let m=c.majorBase,f=c.minorBase,o=c.patchBase,s=v.majorBase,e=v.minorBase,n=v.patchBase,i=v.notBefore,r=v.majorMustEqual,l=v.minorMustEqual,y=v.patchMustEqual;return v.isMinimum?m>s?!0:m<s?!1:f>e?!0:f<e||b&&b<i?!1:o>=n:(m===1&&s===0&&(!r||!l||!y)&&(s=1,e=0,n=0,r=!0,l=!1,y=!1),m<s?!1:m>s?!r:f<e?!1:f>e?!l:o<n?!1:o>n?!y:!(b&&b<i))}t.isValidVersion=u;function h(d,D,a,c){return a.isBuiltin||typeof a.main=="undefined"?!0:p(d,D,a.engines.vscode,c)}t.isValidExtensionVersion=h;function g(d,D,a){return d==="*"||p(D,a,d)}t.isEngineValid=g;function p(d,D,a,c=[]){let b=L(F(a));if(!b)return c.push(A.localize(0,null,a)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return c.push(A.localize(1,null,a)),!1}else if(!b.majorMustEqual)return c.push(A.localize(2,null,a)),!1;return u(d,D,b)?!0:(c.push(A.localize(3,null,d,a)),!1)}}),define(Z[91],ee([0,1,2,9,39,48]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends A.Disposable{constructor(u,h,g,p){super();this.folders=u,this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new k.Client(P.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Z[92],ee([0,1,2,9,39,48]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends A.Disposable{constructor(u,h,g,p,d={}){super();this.folders=u,this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=p,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new k.Client(P.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(u.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Z[93],ee([0,1,33,61,9,46]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(u,h,g,p,d){this.watchedFolder=u,this.eventCallback=g,this.logCallback=p,this.verboseLogging=d,this.restartCounter=0,Array.isArray(h)?this.ignored=h.map(D=>(0,P.parse)(D)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${h.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=(0,A.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,u);const h=new k.LineDecoder;this.handle.stdout.on("data",g=>{const p=[];for(const d of h.write(g)){const D=d.split("|");if(D.length===2){const a=Number(D[0]),c=D[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(b=>b(c))){this.verboseLogging&&this.log(c);continue}p.push({type:F.changeTypeMap[a],path:c})}else this.log(D[1])}}p.length>0&&this.eventCallback(p)}),this.handle.on("error",g=>this.onError(g)),this.handle.stderr.on("data",g=>this.onError(g)),this.handle.on("exit",(g,p)=>this.onExit(g,p))}onError(u){this.error("process error: "+u.toString())}onExit(u,h){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${h})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(Z[94],ee([0,1,4,22,93]),function(G,t,A,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class k{constructor(L,u,h,g){this.onDidFilesChange=u,this.onLogMessage=h,this.verboseLogging=g,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,P.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=k}),define(Z[50],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class A{constructor(S,k=[],F=!1){this.ctor=S,this.staticArguments=k,this.supportsDelayedInstantiation=F}}t.SyncDescriptor=A}),define(Z[95],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class A{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}t.Node=A;class P{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let F of this._nodes.values())F.outgoing.size===0&&k.push(F);return k}insertEdge(k,F){const L=this.lookupOrInsertNode(k),u=this.lookupOrInsertNode(F);L.outgoing.set(this._hashFn(F),u),u.incoming.set(this._hashFn(k),L)}removeNode(k){const F=this._hashFn(k);this._nodes.delete(F);for(let L of this._nodes.values())L.outgoing.delete(F),L.incoming.delete(F)}lookupOrInsertNode(k){const F=this._hashFn(k);let L=this._nodes.get(F);return L||(L=new A(k),this._nodes.set(F,L)),L}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[F,L]of this._nodes)k.push(`${F}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,F]of this._nodes){const L=new Set([k]),u=this._findCycle(F,L);if(u)return u}}_findCycle(k,F){for(let[L,u]of k.outgoing){if(F.has(L))return[...F,L].join(" -> ");F.add(L);const h=this._findCycle(u,F);if(h)return h;F.delete(L)}}}t.Graph=P}),define(Z[96],ee([0,1,12]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,A.createDecorator)("downloadService")}),define(Z[20],ee([0,1,12]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,A.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,A.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[23],ee([0,1,9,75,12]),function(G,t,A,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function k(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}t.isIExtensionIdentifier=k;var F;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var L;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(L=t.SortOrder||(t.SortOrder={}));var u;(function(p){p.Install="install",p.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var h;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(h=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class g extends Error{constructor(d,D){super(d);this.code=D,this.name=D}}t.ExtensionManagementError=g,t.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),t.ExtensionsLabel=(0,P.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,P.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(Z[40],ee([0,1,22,12]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=S;function k(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=k,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(F=t.ExtensionType||(t.ExtensionType={}));class L{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,d){if(typeof p=="undefined"||p===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof p=="string"||typeof d=="string"){let D=typeof p=="string"?p:p.value,a=typeof d=="string"?d:d.value;return A.equalsIgnoreCase(D,a)}return p._lower===d._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}t.ExtensionIdentifier=L;function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function h(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=h,t.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[24],ee([0,1,22,40]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(a,c){return a.uuid&&c.uuid?a.uuid===c.uuid:a.id===c.id?!0:(0,A.compareIgnoreCase)(a.id,c.id)===0}t.areSameExtensions=S;class k{constructor(c,b){this.version=b,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof k?S(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=k;function F(a,c){return`${a}.${c}`}t.getExtensionId=F;function L(a){return a.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function u(a,c){return L(F(a,c))}t.getGalleryExtensionId=u;function h(a,c){const b=[],v=m=>{for(const f of b)if(f.some(o=>S(c(o),c(m))))return f;return null};for(const m of a){const f=v(m);f?f.push(m):b.push([m])}return b}t.groupByExtension=h;function g(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=g;function p(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}t.getGalleryExtensionTelemetryData=p,t.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function d(a){const c=new Set;for(const b of a)b.malicious&&c.add(b.id.id);return c}t.getMaliciousExtensionsSet=d;function D(a,c){const b=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const m=v.shift();if(m&&b.every(f=>!S(f.identifier,{id:m}))){const f=a.filter(o=>S(o.identifier,{id:m}));f.length===1&&(b.push(f[0]),v.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}t.getExtensionDependencies=D});var fe=this&&this.__param||function(G,t){return function(A,P){t(A,P,G)}};define(Z[97],ee([0,1,26,7,62,9,41,8,76,23,24,40]),function(G,t,A,P,S,k,F,L,u,h,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const d=m=>(0,u.localize)(0,null,m),D=(0,u.localize)(1,null,"ms-dotnettools.csharp");function a(m,f){return f?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(m){const f=c.exec(m);return f&&f[1]?[(0,g.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,g.adoptToGalleryExtensionId)(m),void 0]}t.getIdAndVersion=b;let v=class{constructor(f,o){this.extensionManagementService=f,this.extensionGalleryService=o}get location(){}async listExtensions(f,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const n=p.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(n.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(y=>y.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),n.forEach(r=>{s.log(r)});return}this.location&&s.log((0,u.localize)(2,null,this.location)),e=e.sort((r,l)=>r.identifier.id.localeCompare(l.identifier.id));let i;for(let r of e)i!==r.identifier.id&&(i=r.identifier.id,s.log(a(r.manifest,f)))}async installExtensions(f,o,s,e,n=console){const i=[],r=[];f.length&&n.log(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const l=await this.extensionManagementService.getInstalled(1),y=(E,O)=>{const z=l.find($=>(0,g.areSameExtensions)($.identifier,{id:E}));if(z){if(!O&&!e)return n.log((0,u.localize)(5,null,E,z.manifest.version,E)),!1;if(O&&z.manifest.version===O)return n.log((0,u.localize)(6,null,`${E}@${O}`)),!1}return!0},R=[],N=[];for(const E of f)if(E instanceof L.URI)R.push(E);else{const[O,z]=b(E);y(O,z)&&N.push({id:O,version:z,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const E of o){const[O,z]=b(E);y(O,z)&&N.push({id:O,version:z,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(R.length&&await Promise.all(R.map(async E=>{try{const O=await this.installVSIX(E,{isBuiltin:!1,isMachineScoped:s},e,n);O&&r.push(O)}catch(O){n.error(O.message||O.stack||O),i.push(E.toString())}})),N.length){const E=await this.getGalleryExtensions(N);await Promise.all(N.map(async O=>{const z=E.get(O.id.toLowerCase());if(z)try{const $=await this.installFromGallery(O,z,l,e,n);$&&r.push($)}catch($){n.error($.message||$.stack||$),i.push(O.id)}else n.error(`${d(O.version?`${O.id}@${O.version}`:O.id)}
${D}`),i.push(O.id)}))}if(i.length)throw new Error((0,u.localize)(7,null,i.join(", ")))}async installVSIX(f,o,s,e){const n=await this.extensionManagementService.getManifest(f);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,s,e))try{return await this.extensionManagementService.install(f,o),e.log((0,u.localize)(8,null,(0,S.getBaseLabel)(f))),n}catch(r){if((0,P.isPromiseCanceledError)(r))return e.log((0,u.localize)(9,null,(0,S.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const o=f.filter(({version:n})=>n===void 0).map(({id:n})=>n),s=f.filter(({version:n})=>n!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(o,A.CancellationToken.None)).forEach(i=>e.set(i.identifier.id.toLowerCase(),i))})(),Promise.all(s.map(async({id:n,version:i})=>{const r=await this.extensionGalleryService.getCompatibleExtension({id:n},i);r&&e.set(r.identifier.id.toLowerCase(),r)}))]),e}async installFromGallery({id:f,version:o,installOptions:s},e,n,i,r){const l=await this.extensionGalleryService.getManifest(e,A.CancellationToken.None);if(l&&!this.validateExtensionKind(l,r))return null;const y=n.find(R=>(0,g.areSameExtensions)(R.identifier,e.identifier));if(y){if(e.version===y.manifest.version)return r.log((0,u.localize)(10,null,o?`${f}@${o}`:f)),null;r.log((0,u.localize)(11,null,f,e.version))}try{return s.isBuiltin?r.log(o?(0,u.localize)(12,null,f,o):(0,u.localize)(13,null,f)):r.log(o?(0,u.localize)(14,null,f,o):(0,u.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,s),r.log((0,u.localize)(16,null,f,e.version)),l}catch(R){if((0,P.isPromiseCanceledError)(R))return r.log((0,u.localize)(17,null,f)),null;throw R}}validateExtensionKind(f,o){return!0}async validateVSIX(f,o,s){const e={id:(0,g.getGalleryExtensionId)(f.publisher,f.name)},i=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,g.areSameExtensions)(e,r.identifier)&&(0,F.gt)(r.manifest.version,f.version));return i&&!o?(s.log((0,u.localize)(18,null,i.identifier.id,i.manifest.version,f.version)),!1):this.validateExtensionKind(f,s)}async uninstallExtensions(f,o,s=console){const e=async i=>{if(i instanceof L.URI){const r=await this.extensionManagementService.getManifest(i);return a(r)}return i},n=[];for(const i of f){const r=await e(i),y=(await this.extensionManagementService.getInstalled()).filter(R=>(0,g.areSameExtensions)(R.identifier,{id:r}));if(!y.length)throw new Error(`${this.notInstalled(r)}
${D}`);if(y.some(R=>R.type===0)){s.log((0,u.localize)(19,null,r));return}if(!o&&y.some(R=>R.isBuiltin)){s.log((0,u.localize)(20,null,r));return}s.log((0,u.localize)(21,null,r));for(const R of y)await this.extensionManagementService.uninstall(R),n.push(R);this.location?s.log((0,u.localize)(22,null,r,this.location)):s.log((0,u.localize)(23,null,r))}}async locateExtension(f,o=console){const s=await this.extensionManagementService.getInstalled();f.forEach(e=>{s.forEach(n=>{if(n.identifier.id===e&&n.location.scheme===k.Schemas.file){o.log(n.location.fsPath);return}})})}notInstalled(f){return this.location?(0,u.localize)(24,null,f,this.location):(0,u.localize)(25,null,f)}};v=ue([fe(0,h.IExtensionManagementService),fe(1,h.IExtensionGalleryService)],v),t.ExtensionManagementCLIService=v}),define(Z[98],ee([0,1,2,4,11,40]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends A.Disposable{constructor(u,h){super();this.environmentService=u,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(h.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(u){u.some(h=>!!h.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(Z[99],ee([0,1,33,88,26,28,7,10,29,71,128]),function(G,t,A,P,S,k,F,L,u,h,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function p(a,c,b){return c["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):L.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,g.isLaunchedFromCli)(b)&&!c["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,g.isLaunchedFromCli)(b)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=new Promise(async v=>{const m=new S.CancellationTokenSource,f=setTimeout(()=>{a.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),m.dispose(!0),v({})},1e4);try{const o=await D(a,m.token);v(o)}catch(o){(0,F.isPromiseCanceledError)(o)||a.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),v({})}finally{clearTimeout(f),m.dispose()}})),d)}t.resolveShellEnv=p;let d;async function D(a,c){const b=new Promise(async(v,m)=>{const f=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",f);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",o);const s=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",n);const i=await(0,h.getSystemShell)(L.OS,n);if(a.trace("getUnixShellEnvironment#shell",i),c.isCancellationRequested)return m(F.canceled);const r=P.basename(i);let l,y;/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,y=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,y=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),l);const R=(0,A.spawn)(i,[...y,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});c.onCancellationRequested(()=>(R.kill(),m(F.canceled))),R.on("error",O=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(O)),v({})});const N=[];R.stdout.on("data",O=>N.push(O));const E=[];R.stderr.on("data",O=>E.push(O)),R.on("close",(O,z)=>{const $=Buffer.concat(N).toString("utf8");a.trace("getUnixShellEnvironment#raw",$);const Q=Buffer.concat(E).toString("utf8");if(Q.trim()&&a.trace("getUnixShellEnvironment#stderr",Q),O||z)return m(new Error(`Failed to get environment (code ${O}, signal ${z})`));const ie=e.exec($),re=ie?ie[1]:"{}";try{const Y=JSON.parse(re);f?Y.ELECTRON_RUN_AS_NODE=f:delete Y.ELECTRON_RUN_AS_NODE,o?Y.ELECTRON_NO_ATTACH_CONSOLE=o:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",Y),v(Y)}catch(Y){a.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(Y)),m(Y)}})});try{return await b}catch(v){return a.error("getUnixShellEnvironment#error",(0,k.toErrorMessage)(v)),{}}}}),define(Z[51],ee([0,1,10,8,17]),function(G,t,A,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function k(u){return u.map(h=>({type:h.type,resource:P.URI.file(h.path)}))}t.toFileChanges=k;function F(u){const h=new L;for(const g of u)h.processEvent(g);return h.normalize()}t.normalizeFileChanges=F;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(h){const g=this.mapPathToChange.get(h.path);if(g){const p=g.type,d=h.type;p===1&&d===2?(this.mapPathToChange.delete(h.path),this.normalized.splice(this.normalized.indexOf(g),1)):p===2&&d===1?g.type=0:p===1&&d===0||(g.type=d)}else this.normalized.push(h),this.mapPathToChange.set(h.path,h)}normalize(){const h=[],g=[];return this.normalized.filter(p=>p.type!==2?(h.push(p),!1):!0).sort((p,d)=>p.path.length-d.path.length).filter(p=>g.some(d=>(0,S.isParent)(p.path,d,!A.isLinux))?!1:(g.push(p.path),!0)).concat(h)}}}),define(Z[100],ee([0,1,3,2,4,63,11,65,51]),function(G,t,A,P,S,k,F,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class h extends P.Disposable{constructor(p,d,D,a){super();this.path=p,this.onDidFilesChange=d,this.onLogMessage=D,this.verboseLogging=a,this.fileChangesDelayer=this._register(new A.ThrottledDelayer(L.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(p){this.verboseLogging=p}async startWatching(){try{const{stat:p,symbolicLink:d}=await F.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let D=this.path;if(d)try{D=await(0,k.realpath)(D)}catch(a){if(this.onError(a),d.dangling)return}p.isDirectory()?this._register((0,L.watchFolder)(D,(a,c)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(c))})},a=>this.onError(a))):this._register((0,L.watchFile)(D,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(p){p.code!=="ENOENT"&&this.onError(p)}}onFileChange(p){this.fileChangesBuffer.push(p),this.verboseLogging&&this.onVerbose(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const D=(0,u.normalizeFileChanges)(d);if(this.verboseLogging)for(const a of D)this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);D.length>0&&this.onDidFilesChange(D)})}onError(p){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${p}`})}onVerbose(p){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=h}),define(Z[52],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class A{constructor(...S){this._entries=new Map;for(let[k,F]of S)this.set(k,F)}set(S,k){const F=this._entries.get(S);return this._entries.set(S,k),F}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=A}),define(Z[101],ee([0,1,3,7,50,95,12,52]),function(G,t,A,P,S,k,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class h extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class g{constructor(a=new L.ServiceCollection,c=!1,b){this._activeInstantiations=new Set,this._services=a,this._strict=c,this._parent=b,this._services.set(F.IInstantiationService,this)}createChild(a){return new g(a,this._strict,this)}invokeFunction(a,...c){let b=d.traceInvocation(a),v=!1;try{return a({get:(f,o)=>{if(v)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,b);if(!s&&o!==F.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...c)}finally{v=!0,b.stop()}}createInstance(a,...c){let b,v;return a instanceof S.SyncDescriptor?(b=d.traceCreation(a.ctor),v=this._createInstance(a.ctor,a.staticArguments.concat(c),b)):(b=d.traceCreation(a),v=this._createInstance(a,c,b)),b.stop(),v}_createInstance(a,c=[],b){let v=F._util.getServiceDependencies(a).sort((o,s)=>o.index-s.index),m=[];for(const o of v){let s=this._getOrCreateServiceInstance(o.id,b);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`);m.push(s)}let f=v.length>0?v[0].index:c.length;if(c.length!==f){console.warn(`[createInstance] First service dependency of ${a.name} at position ${f+1} conflicts with ${c.length} static arguments`);let o=f-c.length;o>0?c=c.concat(new Array(o)):c=c.slice(0,f)}return new a(...[...c,...m])}_setServiceInstance(a,c){if(this._services.get(a)instanceof S.SyncDescriptor)this._services.set(a,c);else if(this._parent)this._parent._setServiceInstance(a,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let c=this._services.get(a);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):c}_getOrCreateServiceInstance(a,c){let b=this._getServiceInstanceOrDescriptor(a);return b instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,b,c.branch(a,!0)):(c.branch(a,!1),b)}_safeCreateAndCacheServiceInstance(a,c,b){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,c,b)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,c,b){const v=new k.Graph(o=>o.id.toString());let m=0;const f=[{id:a,desc:c,_trace:b}];for(;f.length;){const o=f.pop();if(v.lookupOrInsertNode(o),m++>1e3)throw new h(v);for(let s of F._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const n={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};v.insertEdge(o,n),f.push(n)}}}for(;;){const o=v.roots();if(o.length===0){if(!v.isEmpty())throw new h(v);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof S.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,c,b=[],v,m){if(this._services.get(a)instanceof S.SyncDescriptor)return this._createServiceInstance(c,b,v,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,c,b,v,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(a,c=[],b,v){if(b){const m=new A.IdleValue(()=>this._createInstance(a,c,v));return new Proxy(Object.create(null),{get(f,o){if(o in f)return f[o];let s=m.value,e=s[o];return typeof e!="function"||(e=e.bind(s),f[o]=e),e},set(f,o,s){return m.value[o]=s,!0}})}else return this._createInstance(a,c,v)}}t.InstantiationService=g;var p;(function(D){D[D.Creation=0]="Creation",D[D.Invocation=1]="Invocation",D[D.Branch=2]="Branch"})(p||(p={}));class d{constructor(a,c){this.type=a,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return u?new d(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(a){return u?new d(0,a.name):d._None}branch(a,c){let b=new d(2,a.toString());return this._dep.push([a,c,b]),b}stop(){let a=Date.now()-this._start;d._totals+=a;let c=!1;function b(m,f){let o=[],s=new Array(m+1).join("	");for(const[e,n,i]of f._dep)if(n&&i){c=!0,o.push(`${s}CREATES -> ${e}`);let r=b(m+1,i);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(a>2||c)&&console.log(v.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Z[53],ee([0,1,12]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,A.createDecorator)("localizationsService");function P(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const k of S.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=P}),define(Z[15],ee([0,1,28,14,2,10,12]),function(G,t,A,P,S,k,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,F.createDecorator)("logService"),t.ILoggerService=(0,F.createDecorator)("loggerService");function L(){return new Date().toISOString()}var u;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class h extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=h;class g extends h{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...n]))}debug(e,...n){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...n]))}info(e,...n){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...n]))}warn(e,...n){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...n]))}error(e,...n){if(this.checkLogLevel(u.Error))if(e instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=e.stack,this.log(u.Error,this.format(i))}else this.log(u.Error,this.format([e,...n]))}critical(e,...n){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...n]))}flush(){}format(e){let n="";for(let i=0;i<e.length;i++){let r=e[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}n+=(i>0?" ":"")+r}return n}}t.AbstractMessageLogger=g;class p extends h{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!k.isWindows}trace(e,...n){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...n):console.log(`[main ${L()}]`,e,...n))}debug(e,...n){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...n):console.log(`[main ${L()}]`,e,...n))}info(e,...n){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...n):console.log(`[main ${L()}]`,e,...n))}warn(e,...n){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...n):console.warn(`[main ${L()}]`,e,...n))}error(e,...n){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...n):console.error(`[main ${L()}]`,e,...n))}critical(e,...n){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...n):console.error(`[main ${L()}]`,e,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=p;class d extends h{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}t.ConsoleLogger=d;class D extends h{constructor(e,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,A.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=D;class a extends h{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const i of this.logServices)i.trace(e,...n)}debug(e,...n){for(const i of this.logServices)i.debug(e,...n)}info(e,...n){for(const i of this.logServices)i.info(e,...n)}warn(e,...n){for(const i of this.logServices)i.warn(e,...n)}error(e,...n){for(const i of this.logServices)i.error(e,...n)}critical(e,...n){for(const i of this.logServices)i.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=a;class c extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}t.LogService=c;class b extends S.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let i=this.loggers.get(e.toString());return i||(i=this.doCreateLogger(e,n?.always?u.Trace:this.logLevel,n),this.loggers.set(e.toString(),i),n?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=b;class v{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}t.NullLogService=v;function m(s){if(s.verbose)return u.Trace;if(typeof s.logLevel=="string"){const e=f(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=m;function f(s){switch(s){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=f;function o(s){switch(s){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=o}),define(Z[102],ee([0,1,3,7,2,10,19,41,8,29,11,20,23,24,17,15]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends S.Disposable{constructor(f,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=u.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,o){await this.cleanUpPromise;const s=this.getName(f),e=(0,F.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const n=(0,F.joinPath)(this.extensionsDownloadDir,`.${(0,h.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(f,n,o);try{await this.rename(n,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(n)}catch(r){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,n.path),i}}return e}async delete(f){}async rename(f,o,s){try{await g.Promises.rename(f.fsPath,o.fsPath)}catch(e){if(k.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${f} to ${o} with 'EPERM' error. Trying again...`),this.rename(f,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const o=[],s=[];for(const i of f.children){const r=this.parse(i.name);r&&s.push([r,i])}const e=(0,D.groupByExtension)(s,([i])=>i),n=[];for(const i of e)i.sort((r,l)=>L.rcompare(r[0].version,l[0].version)),o.push(...i.slice(1).map(r=>r[1].resource)),n.push(i[0][1]);n.sort((i,r)=>i.mtime-r.mtime),o.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(i=>i.resource)),await A.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new D.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,h.generateUuid)()}parse(f){const o=b.exec(f);return o&&o[1]&&o[2]?new D.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};v=ue([fe(0,p.INativeEnvironmentService),fe(1,a.IFileService),fe(2,d.IExtensionGalleryService),fe(3,c.ILogService)],v),t.ExtensionsDownloader=v}),define(Z[103],ee([0,1,33,3,28,14,2,9,4,11,20,15]),function(G,t,A,P,S,k,F,L,u,h,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends F.Disposable{constructor(a,c){super();this.environmentService=a,this.logService=c,this.processesLimiter=new P.Limiter(5)}async postUninstall(a){const c=this.parseScript(a,"uninstall");return c&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${b}`)))),h.Promises.rm(this.getExtensionStoragePath(a)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(a,c){const b=`vscode:${c}`;if(a.location.scheme===L.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[b]=="string"){const v=a.manifest.scripts[b].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${b} should be a node script`),null):{script:(0,u.join)(a.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(a,c,b,v,m){return new Promise((f,o)=>{const s=this.start(a,c,b,m);let e;const n=i=>{e&&(clearTimeout(e),e=null),i?o(i):f(void 0)};s.on("error",i=>{n((0,S.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${c} process exited with code ${i}`:void 0)}),v&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(a,c,b,v){const m={silent:!0,execArgv:void 0},f=(0,A.fork)(a,[`--type=extension-post-${c}`,...b],m);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const o=k.Event.fromNodeEventEmitter(f.stdout,"data"),s=k.Event.fromNodeEventEmitter(f.stderr,"data");o(i=>this.logService.info(v.identifier.id,v.manifest.version,`post-${c}`,i)),s(i=>this.logService.error(v.identifier.id,v.manifest.version,`post-${c}`,i));const e=k.Event.any(k.Event.map(o,i=>({data:`%c${i}`,format:[""]})),k.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return k.Event.debounce(e,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(v.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),f}getExtensionStoragePath(a){return(0,u.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};d=ue([fe(0,g.IEnvironmentService),fe(1,p.ILogService)],d),t.ExtensionsLifecycle=d}),define(Z[104],ee([0,1,14,2,19,8,20,24,17,15]),function(G,t,A,P,S,k,F,L,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let g=class extends P.Disposable{constructor(d,D,a,c){super();this.extensionsManagementService=d,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(m=>{this.installedExtensions=m.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(m=>this.onInstallExtension(m))),this._register(d.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(d.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const b=k.URI.file(a.extensionsPath),v=new S.ExtUri(m=>!D.hasCapability(m,1024));this._register(D.watch(b)),this._register(A.Event.filter(D.onDidChangeFilesRaw,m=>m.changes.some(f=>this.doesChangeAffects(f,b,v)))(()=>this.onDidChange()))}doesChangeAffects(d,D,a){return a.isEqual(a.dirname(d.resource),D)?a.isEqual(d.resource,a.joinPath(D,".obsolete"))?!0:!(d.type!==1&&d.type!==2||a.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const D of d)this.removeInstallingExtension(D.identifier),D.local&&this.addInstalledExtension(D.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(D=>!(0,L.areSameExtensions)(D,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(D=>!(0,L.areSameExtensions)(D,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),D=d.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(b=>(0,L.areSameExtensions)(b,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),a=this.installedExtensions.filter(c=>this.installingExtensions.some(b=>(0,L.areSameExtensions)(b,c))?!1:d.every(b=>!(0,L.areSameExtensions)(b.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=d.map(c=>c.identifier),(D.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D,removed:a})}}};g=ue([fe(1,u.IFileService),fe(2,F.INativeEnvironmentService),fe(3,h.ILogService)],g),t.ExtensionsWatcher=g}),define(Z[105],ee([0,1,129,21,3,2,9,4,11,20,23,24,53,15]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let a=class extends k.Disposable{constructor(v,m,f){super();this.extensionManagementService=v,this.logService=f,this.cache=this._register(new c(m,f)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),m=["en",...Object.keys(v)];return(0,P.distinct)(m)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const m=await this.cache.getLanguagePacks();Object.keys(m).some(f=>m[f]&&m[f].extensions.some(o=>(0,p.areSameExtensions)(o.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(m);return!(0,P.equals)(Object.keys(v),Object.keys(f))}};a=ue([fe(0,g.IExtensionManagementService),fe(1,h.INativeEnvironmentService),fe(2,D.ILogService)],a),t.LocalizationsService=a;let c=class extends k.Disposable{constructor(v,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,L.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(m=>{Object.keys(m).forEach(f=>delete m[f]),this.createLanguagePacksFromExtensions(m,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...m){for(const f of m)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,f);Object.keys(v).forEach(f=>this.updateHash(v[f]))}createLanguagePacksFromExtension(v,m){const f=m.identifier,o=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const s of o)if(m.location.scheme===F.Schemas.file&&(0,d.isValidLocalization)(s)){let e=v[s.languageId];e||(e={hash:"",extensions:[],translations:{}},v[s.languageId]=e);let n=e.extensions.filter(i=>(0,p.areSameExtensions)(i.extensionIdentifier,f))[0];n?n.version=m.manifest.version:e.extensions.push({extensionIdentifier:f,version:m.manifest.version});for(const i of s.translations)e.translations[i.id]=(0,L.join)(m.location.fsPath,i.path)}}updateHash(v){if(v){const m=(0,A.createHash)("md5");for(const f of v.extensions)m.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);v.hash=m.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(o){return{}}}).then(f=>(m=v(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),u.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>m,f=>this.logService.error(f))})}};c=ue([fe(0,h.INativeEnvironmentService),fe(1,D.ILogService)],c)}),define(Z[106],ee([0,1,17,15]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(u,h,g,p){try{const d=await new Promise((D,a)=>{G(["spdlog"],D,a)});return d.setFlushOn(P.LogLevel.Trace),d.createAsyncRotatingLogger(u,h,g,p)}catch(d){console.error(d)}return null}function k(u,h,g,p){const d=G.__$__nodeRequire("spdlog");return d.setFlushOn(P.LogLevel.Trace),d.createRotatingLogger(u,h,g,p)}t.createRotatingLogger=k;function F(u,h,g){switch(h){case P.LogLevel.Trace:u.trace(g);break;case P.LogLevel.Debug:u.debug(g);break;case P.LogLevel.Info:u.info(g);break;case P.LogLevel.Warning:u.warn(g);break;case P.LogLevel.Error:u.error(g);break;case P.LogLevel.Critical:u.critical(g);break;default:throw new Error("Invalid log level")}}class L extends P.AbstractMessageLogger{constructor(h,g,p,d){super();this.name=h,this.filepath=g,this.rotating=p,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(D=>{this._logger&&this._logger.setLevel(D)}))}_createSpdLogLogger(){const h=this.rotating?6:1,g=30/h*A.ByteSize.MB;return S(this.name,this.filepath,g,h).then(p=>{if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:d,message:D}of this.buffer)F(this._logger,d,D);this.buffer=[]}})}log(h,g){this._logger?F(this._logger,h,g):this.getLevel()<=h&&this.buffer.push({level:h,message:g})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Z[54],ee([0,1,16,7,82,17,35]),function(G,t,A,P,S,k,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(p,d,D,a,c,b){let v;try{await u(p,d,D,a,c,b)}catch(m){v=m}finally{v&&c.errorTransformer&&(v=c.errorTransformer(v)),typeof v!="undefined"&&D.error(v),D.end()}}t.readFileIntoStream=L;async function u(p,d,D,a,c,b){h(b);const v=await p.open(d,{create:!1});try{h(b);let m=0,f=0,o=c&&typeof c.length=="number"?c.length:void 0,s=A.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),e=c&&typeof c.position=="number"?c.position:0,n=0;do f=await p.read(v,e,s.buffer,n,s.byteLength-n),e+=f,n+=f,m+=f,typeof o=="number"&&(o-=f),n===s.byteLength&&(await D.write(a(s)),s=A.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),n=0);while(f>0&&(typeof o!="number"||o>0)&&h(b)&&g(m,c));if(n>0){let i=n;typeof o=="number"&&(i=Math.min(n,o)),D.write(a(s.slice(0,i)))}}catch(m){throw(0,k.ensureFileSystemProviderError)(m)}finally{await p.close(v)}}function h(p){if(p.isCancellationRequested)throw(0,P.canceled)();return!0}function g(p,d){if(d?.limits){if(typeof d.limits.memory=="number"&&p>d.limits.memory)throw(0,k.createFileSystemProviderError)((0,S.localize)(0,null,F.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&p>d.limits.size)throw(0,k.createFileSystemProviderError)((0,S.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[107],ee([0,1,21,3,16,26,14,130,2,45,9,131,19,37,81,17,54,15]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D,a,c,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let m=class Ne extends u.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new F.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!0)))),this.watchedResources=h.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new u.DisposableStore;return e.add(s.onDidChangeFile(n=>this.onDidChangeFile(n,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,u.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await P.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return L.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,d.isAbsolutePath)(o))throw new c.FileOperationError((0,a.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,a.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,c.toFileSystemProviderErrorCode)(e)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,a.localize)(2,null,this.resourceForError(o)),1):(0,c.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),i=s?.resolveTo,r=s?.resolveSingleChildDescendants,l=s?.resolveMetadata,y=await e.stat(o);let R;return this.toFileStat(e,o,y,void 0,!!l,(N,E)=>{if(!R&&(R=h.TernarySearchTree.forUris(()=>!n),R.set(o,!0),i))for(const O of i)R.set(O,!0);return R.get(N.resource)||R.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&r?E===1:!1})}async toFileStat(o,s,e,n,i,r){const{providerExtUri:l}=this.getExtUri(o),y={resource:s,name:l.basename(s),isFile:(e.type&c.FileType.File)!=0,isDirectory:(e.type&c.FileType.Directory)!=0,isSymbolicLink:(e.type&c.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&c.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,c.etag)({mtime:e.mtime,size:e.size})};if(y.isDirectory&&r(y,n)){try{const R=await o.readdir(s),N=await P.Promises.settled(R.map(async([E,O])=>{try{const z=l.joinPath(s,E),$=i?await o.stat(z):{type:O};return await this.toFileStat(o,z,$,R.length,i,r)}catch(z){return this.logService.trace(z),null}}));y.children=(0,A.coalesce)(N)}catch(R){this.logService.trace(R),y.children=[]}return y}return y}async resolveAll(o){return P.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new c.FileOperationError((0,a.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,s);return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,n)),n}async writeFile(o,s,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,i.dirname(o));let l;if((0,c.hasReadWriteCapability)(n)&&!(s instanceof S.VSBuffer))if((0,D.isReadableStream)(s)){const y=await(0,D.peekStream)(s,3);y.ended?l=S.VSBuffer.concat(y.buffer):l=y}else l=(0,D.peekReadable)(s,y=>S.VSBuffer.concat(y),3);else l=s;!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&l instanceof S.VSBuffer?await this.doWriteUnbuffered(n,o,e,l):await this.doWriteBuffered(n,o,e,l instanceof S.VSBuffer?(0,S.bufferToReadable)(l):l)}catch(r){throw new c.FileOperationError((0,a.localize)(4,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,a.localize)(5,null,this.resourceForError(s)));let i;try{i=await o.stat(s)}catch(r){return}if((i.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,a.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,i),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==c.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&e.mtime<i.mtime&&e.etag!==(0,c.etag)({mtime:e.mtime,size:i.size}))throw new c.FileOperationError((0,a.localize)(7,null),3,e);return i}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((n,i)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);n(r)}catch(r){i(r)}})})}async doReadFile(o,s,e){const n=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...n,value:await(0,S.streamToBuffer)(n.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const n=new k.CancellationTokenSource,i=this.validateReadFile(s,e).then(l=>l,l=>{throw n.cancel(),l});let r;try{return typeof e?.etag=="string"&&e.etag!==c.ETAG_DISABLED&&await i,!((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasFileReadStreamCapability)(o))||(0,c.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,c.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,n.token,e):r=this.readFileBuffered(o,s,n.token,e),{...await i,value:r}}catch(l){r&&await(0,D.consumeStream)(r);const y=(0,a.localize)(8,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(l).toString());throw l instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(y,l.stat,e):new c.FileOperationError(y,(0,c.toFileOperationResult)(l),e)}}readFileStreamed(o,s,e,n=Object.create(null)){const i=o.readFileStream(s,n,e);return(0,D.transform)(i,{data:r=>r instanceof S.VSBuffer?r:S.VSBuffer.wrap(r),error:r=>new c.FileOperationError((0,a.localize)(9,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),n)},r=>S.VSBuffer.concat(r))}readFileBuffered(o,s,e,n=Object.create(null)){const i=(0,S.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,s,i,r=>r,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new c.FileOperationError((0,a.localize)(10,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),n)},e),i}readFileUnbuffered(o,s,e){const n=(0,D.newWriteableStream)(i=>S.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(s);typeof e?.position=="number"&&(i=i.slice(e.position)),typeof e?.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(s,i.byteLength,e),n.end(S.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new c.FileOperationError((0,a.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===e.etag)throw new c.NotModifiedSinceFileOperationError((0,a.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let n;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&s>e.limits.size&&(n=7),typeof n=="number")throw new c.FileOperationError((0,a.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,n){if(o.toString()!==s.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,o,r,s,e,n)}catch(i){return i}return!0}async move(o,s,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,o,i,s,"move",!!e),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="move"?2:3,l)),l}async copy(o,s,e){const n=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,o,i,s,"copy",!!e),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="copy"?3:2,l)),l}async doMoveCopy(o,s,e,n,i,r){if(s.toString()===n.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(o,s,e,n,i,r);if(l&&!y&&r&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),i==="copy"){if(o===e&&(0,c.hasFileFolderCopyCapability)(o))await o.copy(s,n,{overwrite:r});else{const R=await this.resolve(s);R.isDirectory?await this.doCopyFolder(o,R,e,n):await this.doCopyFile(o,s,e,n)}return i}else return o===e?(await o.rename(s,n,{overwrite:r}),i):(await this.doMoveCopy(o,s,e,n,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,n){if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,n);if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,n);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,n);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,n)}async doCopyFolder(o,s,e,n){await e.mkdir(n),Array.isArray(s.children)&&await P.Promises.settled(s.children.map(async i=>{const r=this.getExtUri(e).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),e,r):this.doCopyFile(o,i.resource,e,r)}))}async doValidateMoveCopy(o,s,e,n,i,r){let l=!1;if(o===e){const{providerExtUri:R,isPathCaseSensitive:N}=this.getExtUri(o);if(N||(l=R.isEqual(s,n)),l&&i==="copy")throw new Error((0,a.localize)(14,null,this.resourceForError(s),this.resourceForError(n)));if(!l&&R.isEqualOrParent(n,s))throw new Error((0,a.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}const y=await this.exists(n);if(y&&!l){if(!r)throw new c.FileOperationError((0,a.localize)(16,null,this.resourceForError(s),this.resourceForError(n)),4);if(o===e){const{providerExtUri:R}=this.getExtUri(o);if(R.isEqualOrParent(s,n))throw new Error((0,a.localize)(17,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:y,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(s,n.dirname(s));)try{if(((await o.stat(s)).type&c.FileType.Directory)==0)throw new Error((0,a.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,c.toFileSystemProviderErrorCode)(i)!==c.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(n.basename(s)),s=n.dirname(s)}for(let i=e.length-1;i>=0;i--){s=n.joinPath(s,e[i]);try{await o.mkdir(s)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,a.localize)(19,null,this.resourceForError(o)));let i;try{i=await e.stat(o)}catch(l){}if(i)this.throwIfFileIsReadonly(o,i);else throw new c.FileOperationError((0,a.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,a.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),n=!!s?.useTrash,i=!!s?.recursive;await e.delete(o,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new c.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,n;{for(const i of o)this.watchedResources.has(i.resource)?(e||(e=[]),e.push(i)):(n||(n=[]),n.push(i));e&&this._onDidFilesChange.fire(new c.FileChangesEvent(e,!s))}if(n){const i=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(n)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new u.DisposableStore;{let n=!1,i=()=>{n=!0};e.add((0,u.toDisposable)(()=>i())),this.doWatch(o,s).then(r=>{n?(0,u.dispose)(r):i=()=>(0,u.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,u.toDisposable)(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),n=this.toWatchKey(e,o,s),i=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,i),i.count+=1,(0,u.toDisposable)(()=>{i.count--,i.count===0&&((0,u.dispose)(i.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,s,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,u.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,D.isReadableStream)(n)||(0,D.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,i,n):await this.doWriteReadableBufferedQueued(o,i,n)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,s,e){let n=0,i;if((0,D.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,n,0),n+=r.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise(async(r,l)=>{(0,D.listenStream)(i,{onData:async y=>{i.pause();try{await this.doWriteBuffer(o,s,y,y.byteLength,n,0)}catch(R){return l(R)}n+=y.byteLength,setTimeout(()=>i.resume())},onError:y=>l(y),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let n=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(o,s,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(o,s,e,n,i,r){let l=0;for(;l<n;)l+=await o.write(s,i+l,e.buffer,r+l,n-l)}async doWriteUnbuffered(o,s,e,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,n))}async doWriteUnbufferedQueued(o,s,e,n){let i;n instanceof S.VSBuffer?i=n:(0,D.isReadableStream)(n)?i=await(0,S.streamToBuffer)(n):(0,D.isReadableBufferedStream)(n)?i=await(0,S.bufferedStreamToBuffer)(n):i=(0,S.readableToBuffer)(n),await o.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,n))}async doPipeBufferedQueued(o,s,e,n){let i,r;try{i=await o.open(s,{create:!1}),r=await e.open(n,{create:!0,unlock:!1});const l=S.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,R=0,N=0;do N=await o.read(i,y,l.buffer,R,l.byteLength-R),await this.doWriteBuffer(e,r,l,N,y,R),y+=N,R+=N,R===l.byteLength&&(R=0);while(N>0)}catch(l){throw(0,c.ensureFileSystemProviderError)(l)}finally{await P.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,n))}async doPipeUnbufferedQueued(o,s,e,n){return e.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,n))}async doPipeUnbufferedToBufferedQueued(o,s,e,n){const i=await e.open(n,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,i,S.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(o,s,e,n){const i=await(0,S.streamToBuffer)(this.readFileBuffered(o,s,k.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,i)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new c.FileOperationError((0,a.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,a.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===g.Schemas.file?o.fsPath:o.toString(!0)}};m.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},m=ue([fe(0,v.ILogService)],m),t.FileService=m}),define(Z[108],ee([0,1,21,3,16,14,31,2,4,10,19,37,11,83,17,54,100,91,92,51,94,15]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D,a,c,b,v,m,f,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends L.Disposable{constructor(i,r){super();this.logService=i,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,h.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:l}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,l),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),l=[];return await Promise.all(r.map(async y=>{try{let R;y.isSymbolicLink()?R=(await this.stat((0,g.joinPath)(i,y.name))).type:R=this.toType(y),l.push([y.name,R])}catch(R){this.logService.trace(R)}})),l}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let l;return r?.dangling?l=a.FileType.Unknown:i.isFile()?l=a.FileType.File:i.isDirectory()?l=a.FileType.Directory:l=a.FileType.Unknown,r&&(l|=a.FileType.SymbolicLink),l}async readFile(i){try{const r=this.toFilePath(i);return await d.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(i,r,l){const y=(0,p.newWriteableStream)(R=>S.VSBuffer.concat(R.map(N=>S.VSBuffer.wrap(N))).buffer);return(0,c.readFileIntoStream)(this,i,y,R=>R.buffer,{...r,bufferSize:this.BUFFER_SIZE},l),y}async writeFile(i,r,l){let y;try{const R=this.toFilePath(i);if(!l.create||!l.overwrite){if(await d.Promises.exists(R)){if(!l.overwrite)throw(0,a.createFileSystemProviderError)((0,D.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,a.createFileSystemProviderError)((0,D.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(i,{create:!0,unlock:l.unlock}),await this.write(y,0,r,0,r.byteLength)}catch(R){throw await this.toFileSystemProviderWriteError(i,R)}finally{typeof y=="number"&&await this.close(y)}}async open(i,r){try{const l=this.toFilePath(i);if((0,a.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:N}=await d.SymlinkSupport.stat(l);N.mode&128||await d.Promises.chmod(l,N.mode|128)}catch(N){this.logService.trace(N)}let y;if((0,a.isFileOpenForWriteOptions)(r)){if(h.isWindows)try{await d.Promises.truncate(l,0),y="r+"}catch(N){N.code!=="ENOENT"&&this.logService.trace(N)}y||(y="w")}else y="r";const R=await d.Promises.open(l,y);return this.mapHandleToPos.set(R,0),(0,a.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(R,i),R}catch(l){throw(0,a.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await d.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}}async read(i,r,l,y,R){const N=this.normalizePos(i,r);let E=null;try{const O=await d.Promises.read(i,l,y,R,N);return typeof O=="number"?E=O:E=O.bytesRead,E}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(i,N,E)}}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,l){const y=this.mapHandleToPos.get(i);typeof y=="number"&&(typeof r=="number"||(typeof l=="number"?this.mapHandleToPos.set(i,y+l):this.mapHandleToPos.delete(i)))}async write(i,r,l,y,R){return(0,P.retry)(()=>this.doWrite(i,r,l,y,R),100,3)}async doWrite(i,r,l,y,R){const N=this.normalizePos(i,r);let E=null;try{const O=await d.Promises.write(i,l,y,R,N);return typeof O=="number"?E=O:E=O.bytesWritten,E}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),O)}finally{this.updatePos(i,N,E)}}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const l=this.toFilePath(i);await this.doDelete(l,r)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(i,r){r.recursive?await d.Promises.rm(i,d.RimRafMode.MOVE):await d.Promises.unlink(i)}async rename(i,r,l){const y=this.toFilePath(i),R=this.toFilePath(r);if(y!==R)try{await this.validateTargetDeleted(i,r,"move",l.overwrite),await d.Promises.move(y,R)}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,D.localize)(2,null,(0,u.basename)(y),(0,u.basename)((0,u.dirname)(R)),N.toString()))),this.toFileSystemProviderError(N)}}async copy(i,r,l){const y=this.toFilePath(i),R=this.toFilePath(r);if(y!==R)try{await this.validateTargetDeleted(i,r,"copy",l.overwrite),await d.Promises.copy(y,R,{preserveSymlinks:!0})}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,D.localize)(3,null,(0,u.basename)(y),(0,u.basename)((0,u.dirname)(R)),N.toString()))),this.toFileSystemProviderError(N)}}async validateTargetDeleted(i,r,l,y){const R=this.toFilePath(i),N=this.toFilePath(r);let E=!1;if(!!(this.capabilities&1024)||(E=(0,F.isEqual)(R,N,!0)),E&&l==="copy")throw(0,a.createFileSystemProviderError)((0,D.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!E&&await d.Promises.exists(N)){if(!y)throw(0,a.createFileSystemProviderError)((0,D.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(i,r){return r.recursive?this.watchRecursive(i,r.excludes):this.watchNonRecursive(i)}watchRecursive(i,r){const l={path:this.toFilePath(i),excludes:r},y=(0,A.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,r;this.options?.watcher?.usePolling?(i=m.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?h.isWindows?i=o.FileWatcher:i=m.FileWatcher:i=v.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,f.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===s.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(i){const r=new b.FileWatcher(this.toFilePath(i),y=>this._onDidChangeFile.fire((0,f.toFileChanges)(y)),y=>{y.type==="error"&&this._onDidWatchErrorOccur.fire(y.message),this.logService[y.type](y.message)},this.logService.getLevel()===s.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,L.combinedDisposable)(r,l)}toFilePath(i){return(0,u.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof a.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let l=this.toFileSystemProviderError(r);if(i&&l.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:y}=await d.SymlinkSupport.stat(this.toFilePath(i));y.mode&128||(l=(0,a.createFileSystemProviderError)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(y){this.logService.trace(y)}return l}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Z[42],ee([0,1,12]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,A.createDecorator)("productService")}),define(Z[25],ee([0,1,57,13]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(F,L){A.ok(P.isString(F)),A.ok(P.isObject(L)),A.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,L)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new S}),define(Z[109],ee([0,1,14,25]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class k{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,h){this.schemasById[S(u)]=h,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new k;P.Registry.add(t.Extensions.JSONContribution,F)}),define(Z[30],ee([0,1,14,13,73,109,25]),function(G,t,A,P,S,k,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var L;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(L=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var u;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(u=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=F.Registry.as(k.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,f=!0){this.registerConfigurations([m],f)}registerConfigurations(m,f=!0){const o=[];m.forEach(s=>{o.push(...this.validateAndRegisterProperties(s,f,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(m){const f=[],o=s=>{if(s.properties)for(const e in s.properties)f.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>o(e))};for(const s of m){o(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(m){const f=[],o=[];for(const s of m)for(const e in s)if(f.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const n={type:"object",default:this.defaultValues[e],description:S.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};o.push(d(e)),this.configurationProperties[e]=n,this.defaultLanguageConfigurationOverridesNode.properties[e]=n}else{this.defaultValues[e]=s[e];const n=this.configurationProperties[e];n&&(this.updatePropertyDefaultValue(e,n),this.updateSchema(e,n))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(m){const f=[];for(const o of m)for(const s in o)if(f.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const f of m)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,f=!0,o,s=3){s=P.isUndefinedOrNull(m.scope)?s:m.scope;let e=[],n=m.properties;if(n)for(let r in n){if(f&&c(r)){delete n[r];continue}const l=n[r];if(this.updatePropertyDefaultValue(r,l),t.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=P.isUndefinedOrNull(l.scope)?s:l.scope,l.restricted=P.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(r):l.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),e.push(r)}let i=m.allOf;if(i)for(let r of i)e.push(...this.validateAndRegisterProperties(r,f,o,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const f=o=>{let s=o.properties;if(s)for(const n in s)this.updateSchema(n,s[n]);let e=o.allOf;e&&e.forEach(f)};f(m)}updateSchema(m,f){switch(t.allSettings.properties[m]=f,f.scope){case 1:t.applicationSettings.properties[m]=f;break;case 2:t.machineSettings.properties[m]=f;break;case 6:t.machineOverridableSettings.properties[m]=f;break;case 3:t.windowSettings.properties[m]=f;break;case 4:t.resourceSettings.properties[m]=f;break;case 5:t.resourceSettings.properties[m]=f,this.resourceLanguageSettingsSchema.properties[m]=f;break}}removeFromSchema(m,f){switch(delete t.allSettings.properties[m],f.scope){case 1:delete t.applicationSettings.properties[m];break;case 2:delete t.machineSettings.properties[m];break;case 6:delete t.machineOverridableSettings.properties[m];break;case 3:delete t.windowSettings.properties[m];break;case 4:case 5:delete t.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const f=`[${m}]`,o={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,o),t.allSettings.properties[f]=o,t.applicationSettings.properties[f]=o,t.machineSettings.properties[f]=o,t.machineOverridableSettings.properties[f]=o,t.windowSettings.properties[f]=o,t.resourceSettings.properties[f]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,f){let o=this.defaultValues[m];P.isUndefined(o)&&(o=f.default),P.isUndefined(o)&&(o=D(f.type)),f.default=o}}const p="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(p);function d(v){return v.substring(1,v.length-1)}t.overrideIdentifierFromKey=d;function D(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=D;const a=new g;F.Registry.add(t.Extensions.Configuration,a);function c(v){return v.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(v)?S.localize(5,null,v):a.getConfigurationProperties()[v]!==void 0?S.localize(6,null,v):null:S.localize(4,null)}t.validateProperty=c;function b(){const v=[],m=a.getConfigurationProperties();for(const f of Object.keys(m))v.push([f,m[f].scope]);return v.push(["launch",4]),v.push(["task",4]),v}t.getScopes=b}),define(Z[27],ee([0,1,18,13,8,30,12,25]),function(G,t,A,P,S,k,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,F.createDecorator)("configurationService");function u(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof S.URI)}t.isConfigurationOverrides=u;var h;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(h=t.ConfigurationTarget||(t.ConfigurationTarget={}));function g(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=g;function p(n,i){const r=i?n?i.keys.filter(z=>n.keys.indexOf(z)===-1):[...i.keys]:[],l=n?i?n.keys.filter(z=>i.keys.indexOf(z)===-1):[...n.keys]:[],y=[];if(i&&n){for(const z of n.keys)if(i.keys.indexOf(z)!==-1){const $=v(n.contents,z),Q=v(i.contents,z);A.equals($,Q)||y.push(z)}}const R=[],N=z=>{const $={};for(const Q of z)for(const ie of Q.identifiers)$[s(ie)]=Q;return $},E=i?N(i.overrides):{},O=n?N(n.overrides):{};if(Object.keys(E).length)for(const z of r){const $=E[z];$&&R.push([(0,k.overrideIdentifierFromKey)(z),$.keys])}if(Object.keys(O).length)for(const z of l){const $=O[z];$&&R.push([(0,k.overrideIdentifierFromKey)(z),$.keys])}if(Object.keys(E).length&&Object.keys(O).length)for(const z of y){const $=O[z],Q=E[z];if($&&Q){const ie=p({contents:$.contents,keys:$.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});R.push([(0,k.overrideIdentifierFromKey)(z),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:l,updated:y,overrides:R}}t.compare=p;function d(n,i){const r=[];for(const l of Object.keys(n))if(k.OVERRIDE_PROPERTY_PATTERN.test(l)){const y={};for(const R in n[l])y[R]=n[l][R];r.push({identifiers:[(0,k.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(y),contents:D(y,i)})}return r}t.toOverrides=d;function D(n,i){const r=Object.create(null);for(let l in n)a(r,l,n[l],i);return r}t.toValuesTree=D;function a(n,i,r,l){const y=i.split("."),R=y.pop();let N=n;for(let E=0;E<y.length;E++){let O=y[E],z=N[O];switch(typeof z){case"undefined":z=N[O]=Object.create(null);break;case"object":break;default:l(`Ignoring ${i} as ${y.slice(0,E+1).join(".")} is ${JSON.stringify(z)}`);return}N=z}if(typeof N=="object"&&N!==null)try{N[R]=r}catch(E){l(`Ignoring ${i} as ${y.join(".")} is ${JSON.stringify(N)}`)}else l(`Ignoring ${i} as ${y.join(".")} is ${JSON.stringify(N)}`)}t.addToValueTree=a;function c(n,i){const r=i.split(".");b(n,r)}t.removeFromValueTree=c;function b(n,i){const r=i.shift();if(i.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const l=n[r];typeof l=="object"&&!Array.isArray(l)&&(b(l,i),Object.keys(l).length===0&&delete n[r])}}function v(n,i,r){function l(N,E){let O=N;for(const z of E){if(typeof O!="object"||O===null)return;O=O[z]}return O}const y=i.split("."),R=l(n,y);return typeof R=="undefined"?r:R}t.getConfigurationValue=v;function m(n,i,r){Object.keys(i).forEach(l=>{l!=="__proto__"&&(l in n?P.isObject(n[l])&&P.isObject(i[l])?m(n[l],i[l],r):r&&(n[l]=i[l]):n[l]=i[l])})}t.merge=m;function f(){const n=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=f;function o(){const n=Object.create(null),i=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in i){let l=i[r].default;a(n,r,l,y=>console.error(`Conflict in default settings: ${y}`))}return n}t.getDefaultValues=o;function s(n){return`[${n}]`}t.keyFromOverrideIdentifier=s;function e(n,i,r){const l=n.inspect(i),y=n.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:l.defaultValue}t.getMigratedSettingValue=e}),define(Z[110],ee([0,1,21,14,58,2,45,18,13,8,27,30,25]),function(G,t,A,P,S,k,F,L,u,h,g,p,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class D{constructor(e={},n=[],i=[]){this._contents=e,this._keys=n,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,g.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const i=this.getContentsForOverrideIdentifer(n);return i?e?(0,g.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let i={};for(const r of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r],y=n[r];y&&(typeof l=="object"&&typeof y=="object"?(l=L.deepClone(l),this.mergeContents(l,y)):l=y),i[r]=l}return new D(i,this.keys,this.overrides)}merge(...e){const n=L.deepClone(this.contents),i=L.deepClone(this.overrides),r=[...this.keys];for(const l of e){this.mergeContents(n,l.contents);for(const y of l.overrides){const[R]=i.filter(N=>A.equals(N.identifiers,y.identifiers));R?this.mergeContents(R.contents,y.contents):i.push(L.deepClone(y))}for(const y of l.keys)r.indexOf(y)===-1&&r.push(y)}return new D(n,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const i of Object.keys(n)){if(i in e&&u.isObject(e[i])&&u.isObject(n[i])){this.mergeContents(e[i],n[i]);continue}e[i]=L.deepClone(n[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?L.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,g.addToValueTree)(this.contents,e,n,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,g.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let i=0;i<n;i++)e.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=D;class a extends D{constructor(){const e=(0,g.getDefaultValues)(),n=(0,g.getConfigurationKeys)(),i=[];for(const r of Object.keys(e))p.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[(0,p.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,g.toValuesTree)(e[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,n,i)}}t.DefaultConfigurationModel=a;class c{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new D}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!u.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:i,keys:r,overrides:l,restricted:y}=this.doParseRaw(e,n);this._configurationModel=new D(i,r,l),this._restrictedConfigurations=y||[]}doParseContent(e){let n={},i=null,r=[],l=[],y=[];function R(E){Array.isArray(r)?r.push(E):i!==null&&(r[i]=E)}let N={onObjectBegin:()=>{let E={};R(E),l.push(r),r=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let E=[];R(E),l.push(r),r=E,i=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:R,onError:(E,O,z)=>{y.push({error:E,offset:O,length:z})}};if(e)try{S.visit(e,N),n=r[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return n}doParseRaw(e,n){const i=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,i,!0,n);e=r.raw;const l=(0,g.toValuesTree)(e,N=>console.error(`Conflict in settings file ${this._name}: ${N}`)),y=Object.keys(e),R=(0,g.toOverrides)(e,N=>console.error(`Conflict in settings file ${this._name}: ${N}`));return{contents:l,keys:y,overrides:R,restricted:r.restricted}}filter(e,n,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const l={},y=[];for(let R in e)if(p.OVERRIDE_PROPERTY_PATTERN.test(R)&&i){const N=this.filter(e[R],n,!1,r);l[R]=N.raw,y.push(...N.restricted)}else{const N=n[R],E=N?typeof N.scope!="undefined"?N.scope:3:void 0;N?.restricted&&y.push(R),(E===void 0||r.scopes===void 0||r.scopes.includes(E))&&(r.skipRestricted&&N?.restricted||(l[R]=e[R]))}return{raw:l,restricted:y}}}t.ConfigurationModelParser=c;class b extends k.Disposable{constructor(e,n,i,r){super();this.userSettingsResource=e,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new D}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=b;class v{constructor(e,n,i=new D,r=new D,l=new F.ResourceMap,y=new D,R=new F.ResourceMap,N=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=y,this._memoryConfigurationByResource=R,this._freeze=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(e,n,i){return this.getConsolidateConfigurationModel(n,i).getValue(e)}updateValue(e,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new D,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(e):r.setValue(e,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,i){const r=this.getConsolidateConfigurationModel(n,i),l=this.getFolderConfigurationModelForResource(n.resource,i),y=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,R=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),E=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),z=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,$=l?n.overrideIdentifier?l.freeze().override(n.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,Q=n.overrideIdentifier?y.override(n.overrideIdentifier).getValue(e):y.getValue(e),ie=r.getValue(e),re=A.distinct(A.flatten(r.overrides.map(Y=>Y.identifiers))).filter(Y=>r.getOverrideValue(e,Y)!==void 0);return{defaultValue:R,userValue:N,userLocalValue:E,userRemoteValue:O,workspaceValue:z,workspaceFolderValue:$,memoryValue:Q,value:ie,default:R!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:N!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:z!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:l?.freeze().getValue(e),override:n.overrideIdentifier?l?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:y.getValue(e),override:n.overrideIdentifier?y.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const i=n.filter(r=>p.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,p.overrideIdentifierFromKey)(r),y=this._defaultConfiguration.getKeysForOverrideIdentifier(l),R=e.getKeysForOverrideIdentifier(l),N=[...R.filter(E=>y.indexOf(E)===-1),...y.filter(E=>R.indexOf(E)===-1),...y.filter(E=>!L.equals(this._defaultConfiguration.override(l).getValue(E),e.override(l).getValue(E)))];return[l,N]});return this.updateDefaultConfiguration(e),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:i,removed:r,overrides:l}=(0,g.compare)(this.localUserConfiguration,e),y=[...n,...i,...r];return y.length&&this.updateLocalUserConfiguration(e),{keys:y,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:i,removed:r,overrides:l}=(0,g.compare)(this.remoteUserConfiguration,e);let y=[...n,...i,...r];return y.length&&this.updateRemoteUserConfiguration(e),{keys:y,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:i,removed:r,overrides:l}=(0,g.compare)(this.workspaceConfiguration,e);let y=[...n,...i,...r];return y.length&&this.updateWorkspaceConfiguration(e),{keys:y,overrides:l}}compareAndUpdateFolderConfiguration(e,n){const i=this.folderConfigurations.get(e),{added:r,updated:l,removed:y,overrides:R}=(0,g.compare)(i,n);let N=[...r,...l,...y];return(N.length||!i)&&this.updateFolderConfiguration(e,n),{keys:N,overrides:R}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:r,removed:l,overrides:y}=(0,g.compare)(n,void 0);return{keys:[...i,...r,...l],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let i=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const r=n.getFolder(e);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const l=this._memoryConfigurationByResource.get(e);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=i}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const i=n.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:i,overrides:r,keys:l}=this._folderConfigurations.get(n);return e.push([n,{contents:i,overrides:r,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((y,R)=>(y.set(h.URI.revive(R[0]),this.parseConfigurationModel(R[1])),y),new F.ResourceMap);return new v(n,i,new D,r,l,new D,new F.ResourceMap,!1)}static parseConfigurationModel(e){return new D(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v;function m(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const r of s)r.keys.forEach(l=>e.add(l)),r.overrides.forEach(([l,y])=>{const R=(0,F.getOrSet)(n,l,new Set);y.forEach(N=>R.add(N))});const i=[];return n.forEach((r,l)=>i.push([l,[...r.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=m;class f{constructor(e,n,i,r){this.change=e,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(R=>l.add(R)),e.overrides.forEach(([,R])=>R.forEach(N=>l.add(N))),this.affectedKeys=[...l.values()];const y=new D;this.affectedKeys.forEach(R=>y.setValue(R,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!L.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let i=(0,g.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(e=e[r],!e)return!1;i=i[r]}return!0}}t.ConfigurationChangeEvent=f;class o extends f{constructor(e,n,i,r){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=i,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(Z[111],ee([0,1,3,14,2,19,27,110,30,25]),function(G,t,A,P,S,k,F,L,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class g extends S.Disposable{constructor(d,D){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new L.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,D)),this.configuration=new L.Configuration(new L.DefaultConfigurationModel,new L.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new A.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(h.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new L.Configuration(new L.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,D){const a=typeof d=="string"?d:void 0,c=(0,F.isConfigurationOverrides)(d)?d:(0,F.isConfigurationOverrides)(D)?D:{};return this.configuration.getValue(a,c,void 0)}updateValue(d,D,a,c){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const D=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(a,D,1)}onDidDefaultConfigurationChange(d){const D=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new L.DefaultConfigurationModel,d);this.trigger(a,D,6)}trigger(d,D,a){const c=new L.ConfigurationChangeEvent(d,{data:D},this.configuration);c.source=a,c.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=g}),define(Z[55],ee([0,1,16,84,30,12,25]),function(G,t,A,P,S,k,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,k.createDecorator)("requestService");function L(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}t.isSuccess=L;function u(a){return a.res.statusCode===204}async function h(a){if(!L(a))throw new Error("Server returned "+a.res.statusCode);return u(a)?null:(await(0,A.streamToBuffer)(a.stream)).toString()}t.asText=h;async function g(a){if(!L(a))throw new Error("Server returned "+a.res.statusCode);if(u(a))return null;const b=(await(0,A.streamToBuffer)(a.stream)).toString();try{return JSON.parse(b)}catch(v){throw v.message+=`:
`+b,v}}t.asJson=g;function p(a){D(a)}t.updateProxyConfigurationsScope=p;let d;function D(a){const c=F.Registry.as(S.Extensions.Configuration);d&&c.deregisterConfigurations([d]),d={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},c.registerConfiguration(d)}D(2)}),define(Z[112],ee([0,1,113,13]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(F,L){return F.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:F.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function k(F,L,u={}){const h=(0,A.parse)(F),g=u.proxyUrl||S(h,L);if(!g)return null;const p=(0,A.parse)(g);if(!/^https?:$/.test(p.protocol||""))return null;const d={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,P.isBoolean)(u.strictSSL)?u.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((D,a)=>{G(["http-proxy-agent"],D,a)}))(d):new(await new Promise((D,a)=>{G(["https-proxy-agent"],D,a)}))(d)}t.getProxyAgent=k}),define(Z[114],ee([0,1,16,29]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(k,F,L){let u=L&&L.get("storage.serviceMachineId",0)||null;if(u)return u;try{const g=(await F.readFile(k.serviceMachineIdResource)).value.toString();u=(0,P.isUUID)(g)?g:null}catch(h){u=null}if(!u){u=(0,P.generateUuid)();try{await F.writeFile(k.serviceMachineIdResource,A.VSBuffer.fromString(u))}catch(h){}}return L&&L.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=S}),define(Z[115],ee([0,1,3,14,2,13,66,12]),function(G,t,A,P,S,k,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=(0,L.createDecorator)("storageService");var h;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(h=t.WillSaveStateReason||(t.WillSaveStateReason={}));var g;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(g=t.StorageScope||(t.StorageScope={}));var p;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(p=t.StorageTarget||(t.StorageTarget={}));class d extends S.Disposable{constructor(b={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new A.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,A.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,v){v===u?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:v,target:this.getKeyTargets(b)[v]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,v,m){return this.getStorage(v)?.get(b,m)}getBoolean(b,v,m){return this.getStorage(v)?.getBoolean(b,m)}getNumber(b,v,m){return this.getStorage(v)?.getNumber(b,m)}store(b,v,m,f){if((0,k.isUndefinedOrNull)(v)){this.remove(b,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,m,f),this.getStorage(m)?.set(b,v)})}remove(b,v){this.withPausedEmitters(()=>{this.updateKeyTarget(b,v,void 0),this.getStorage(v)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,v){const m=[],f=this.getKeyTargets(b);for(const o of Object.keys(f))f[o]===v&&m.push(o);return m}updateKeyTarget(b,v,m){const f=this.getKeyTargets(v);typeof m=="number"?f[b]!==m&&(f[b]=m,this.getStorage(v)?.set(u,JSON.stringify(f))):typeof f[b]=="number"&&(delete f[b],this.getStorage(v)?.set(u,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const v=this.get(u,b);if(v)try{return JSON.parse(v)}catch(m){}return Object.create(null)}isNew(b){return this.getBoolean(t.IS_NEW_KEY,b)===!0}async flush(b=h.NONE){this._onWillSaveState.fire({reason:b}),await A.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return a(b,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class D extends d{constructor(){super();this.globalStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}t.InMemoryStorageService=D;async function a(c,b,v,m){const f=l=>{try{return JSON.parse(l)}catch(y){return l}},o=new Map,s=new Map;c.forEach((l,y)=>{o.set(y,l),s.set(y,f(l))});const e=new Map,n=new Map;b.forEach((l,y)=>{e.set(y,l),n.set(y,f(l))}),console.group(`Storage: Global (path: ${v})`);let i=[];o.forEach((l,y)=>{i.push({key:y,value:l})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${m})`);let r=[];e.forEach((l,y)=>{r.push({key:y,value:l})}),console.table(r),console.groupEnd(),console.log(n)}t.logStorage=a}),define(Z[116],ee([0,1,10,34,8,29]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function F(h){if(A.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function L(h,g,p,d,D,a,c,b,v,m){const f=Object.create(null);f["common.machineId"]=c,f.sessionID=(0,k.generateUuid)()+Date.now(),f.commitHash=D,f.version=a,f["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,A.PlatformToString)(A.platform),f["common.nodePlatform"]=P.platform,f["common.nodeArch"]=d,f["common.product"]=m||"desktop";const o=u(b||[]);o&&(f["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),A.isLinuxSnap&&(f["common.snap"]="true");const n=F(p);n&&(f["common.platformDetail"]=n);try{const i=await h.readFile(S.URI.file(v));f["common.source"]=i.value.toString().slice(0,30)}catch(i){}return f}t.resolveCommonProperties=L;function u(h){const g=P.env.USERDNSDOMAIN;if(!g)return!1;const p=g.toLowerCase();return h.some(d=>p===d)}t.verifyMicrosoftInternalDomain=u}),define(Z[36],ee([0,1,12]),function(G,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,A.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,A.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Z[117],ee([0,1,21,3,26,7,14,2,10,8,74,23,24,15,35,36]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let b=class extends L.Disposable{constructor(s,e,n){super();this.galleryService=s,this.telemetryService=e,this.logService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new F.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new F.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new F.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new F.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(g.localize(0,null));try{s=await this.checkAndGetCompatibleVersion(s)}catch(i){throw this.logService.error((0,k.getErrorMessage)(i)),m(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(!await this.canInstall(s)){const i=new p.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",s.identifier.id,i.message),m(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,i),i}const n=await this.galleryService.getManifest(s,S.CancellationToken.None);if(n===null){const i=new p.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,i.message),m(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,i),i}return this.installExtension(n,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(1,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(g.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,n){if(!h.URI.isUri(e)){let R=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(R)return this.logService.info("Extensions is already requested to install",e.identifier.id),R.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],r=[],l=this.createInstallExtensionTask(s,e,n);h.URI.isUri(e)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(l.identifier,s.version).key(),l),this._onInstallExtension.fire({identifier:l.identifier,source:e}),this.logService.info("Installing extension:",l.identifier.id),i.push({task:l,manifest:s});let y=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",l.identifier.id);else try{const N=await this.getAllDepsAndPackExtensionsToInstall(l.identifier,s,!!n.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:E,manifest:O}of N)if(y=y||!!O.extensionDependencies?.some(z=>(0,d.areSameExtensions)({id:z},l.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(E.identifier,E.version).key()))this.logService.info("Extension is already requested to install",E.identifier.id);else{const z=this.createInstallExtensionTask(O,E,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(z.identifier,O.version).key(),z),this._onInstallExtension.fire({identifier:z.identifier,source:E}),this.logService.info("Installing extension:",z.identifier.id),i.push({task:z,manifest:O})}}catch(N){if(h.URI.isUri(l.source))(0,A.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",l.identifier.id,N.message),(0,A.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",l.identifier.id,N.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",l.identifier.id),this.logService.error(N),N}const R=i.reduce((N,{task:E,manifest:O})=>(N.set(E.identifier.id.toLowerCase(),{task:E,manifest:O}),N),new Map);for(;R.size;){let N;const E=[...R.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(z=>R.has(z.toLowerCase())));E.length?N=R.size===1?E:E.filter(({task:O})=>!(O===l&&!y)):(this.logService.info("Found extensions with circular dependencies",E.map(({task:O})=>O.identifier.id)),N=[...R.values()]),await this.joinAllSettled(N.map(async({task:O})=>{const z=new Date().getTime();try{const $=await O.run();if(await this.joinAllSettled(this.participants.map(Q=>Q.postInstall($,O.source,n,S.CancellationToken.None))),!h.URI.isUri(O.source)&&(m(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-z,void 0),u.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch(Q){}r.push({local:$,identifier:O.identifier,operation:O.operation,source:O.source})}catch($){throw h.URI.isUri(O.source)||m(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-z,$),this.logService.error("Error while installing the extension:",O.identifier.id),this.logService.error($),$}finally{R.delete(O.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:N})=>this.logService.info("Extension installed successfully:",N.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:N})=>(0,d.areSameExtensions)(N,l.identifier))[0].local}catch(R){if(i.forEach(({task:N})=>N.cancel()),r.length)try{const N=await Promise.allSettled(r.map(({local:E})=>this.createUninstallExtensionTask(E,{versionOnly:!0}).run()));for(let E=0;E<N.length;E++){const O=N[E],{identifier:z}=r[E];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",z.id):this.logService.warn("Rollback: Error while uninstalling extension",z.id,(0,k.getErrorMessage)(O.reason))}}catch(N){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(N),r.map(({identifier:E})=>E.id))}throw this.logService.error("Failed to install extension:",l.identifier.id,(0,k.getErrorMessage)(R)),this._onDidInstallExtensions.fire(i.map(({task:N})=>({identifier:N.identifier,operation:1,source:N.source}))),R instanceof Error&&(R.name=R&&R.code?R.code:t.ERROR_UNKNOWN),R}finally{for(const{task:R,manifest:N}of i)if(!h.URI.isUri(R.source)){const E=new d.ExtensionIdentifierWithVersion(R.identifier,N.version).key();this.installingExtensions.delete(E)||this.logService.warn("Installation task is not found in the cache",E)}}}async joinAllSettled(s){const e=[],n=[],i=await Promise.allSettled(s);for(const r of i)r.status==="fulfilled"?e.push(r.value):n.push(r.reason);if(n.length)throw v(n);return e}async getAllDepsAndPackExtensionsToInstall(s,e,n){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const r=[s,...i.map(R=>R.identifier)],l=[],y=async(R,N)=>{const E=N.extensionDependencies||[];if(N.extensionPack){const O=n?i.find(z=>(0,d.areSameExtensions)(z.identifier,R)):void 0;for(const z of N.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some($=>(0,d.areSameExtensions)({id:$},{id:z}))||E.every($=>!(0,d.areSameExtensions)({id:$},{id:z}))&&E.push(z)}if(E.length){const O=[...r,...l.map($=>$.gallery.identifier)],z=E.filter($=>O.every(Q=>!(0,d.areSameExtensions)(Q,{id:$})));if(z.length){const $=await this.galleryService.query({names:z,pageSize:E.length},S.CancellationToken.None);for(const Q of $.firstPage){if(O.find(Y=>(0,d.areSameExtensions)(Y,Q.identifier)))continue;const ie=await this.checkAndGetCompatibleVersion(Q);if(!await this.canInstall(ie)){this.logService.info("Skipping the extension as it cannot be installed",ie.identifier.id);continue}const re=await this.galleryService.getManifest(ie,S.CancellationToken.None);if(re===null)throw new p.ExtensionManagementError(`Missing manifest for extension ${ie.identifier.id}`,t.INSTALL_ERROR_VALIDATING);l.push({gallery:ie,manifest:re}),await y(ie.identifier,re)}}}};return await y(s,e),i=await this.getInstalled(),l.filter(R=>!i.some(N=>(0,d.areSameExtensions)(N.identifier,R.gallery.identifier)))}async checkAndGetCompatibleVersion(s){if(await this.isMalicious(s))throw new p.ExtensionManagementError(g.localize(3,null,s.identifier.id),p.INSTALL_ERROR_MALICIOUS);const e=await this.galleryService.getCompatibleExtension(s);if(!e)throw new p.ExtensionManagementError(g.localize(4,null,s.identifier.id,a.default.version),p.INSTALL_ERROR_INCOMPATIBLE);return e}async isMalicious(s){const e=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const n=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),n.waitUntilTaskIsFinished();const i=(R,N)=>{const E=this.createUninstallExtensionTask(R,N);return this.uninstallingExtensions.set(E.extension.identifier.id.toLowerCase(),E),this.logService.info("Uninstalling extension:",R.identifier.id),this._onUninstallExtension.fire(R.identifier),E},r=(R,N)=>{N?this.logService.error("Failed to uninstall extension:",R.identifier.id,N.message):this.logService.info("Successfully uninstalled extension:",R.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(R),void 0,N),this._onDidUninstallExtension.fire({identifier:R.identifier,error:N?.code})},l=[],y=[];try{l.push(i(s,{}));const R=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const N=this.getAllPackExtensionsToUninstall(s,R);for(const E of N)this.uninstallingExtensions.has(E.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",E.identifier.id):l.push(i(E,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(l.map(N=>N.extension),R,s),await this.joinAllSettled(l.map(async N=>{try{if(await N.run(),await this.joinAllSettled(this.participants.map(E=>E.postUninstall(N.extension,e,S.CancellationToken.None))),N.extension.identifier.uuid)try{await this.galleryService.reportStatistic(N.extension.manifest.publisher,N.extension.manifest.name,N.extension.manifest.version,"uninstall")}catch(E){}r(N.extension)}catch(E){const O=E instanceof p.ExtensionManagementError?E:new p.ExtensionManagementError((0,k.getErrorMessage)(E),t.ERROR_UNKNOWN);throw r(N.extension,O),O}finally{y.push(N)}}))}catch(R){const N=R instanceof p.ExtensionManagementError?R:new p.ExtensionManagementError((0,k.getErrorMessage)(R),t.ERROR_UNKNOWN);for(const E of l){try{E.cancel()}catch(O){}y.includes(E)||r(E.extension,N)}throw N}finally{for(const R of l)this.uninstallingExtensions.delete(R.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",R.extension.identifier.id)}}checkForDependents(s,e,n){for(const i of s){const r=this.getDependents(i,e);if(r.length){const l=r.filter(y=>!s.some(R=>(0,d.areSameExtensions)(R.identifier,y.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(i,l,n))}}}getDependentsErrorMessage(s,e,n){return n===s?e.length===1?g.localize(5,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?g.localize(6,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):g.localize(7,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?g.localize(8,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?g.localize(9,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):g.localize(10,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,n=[]){if(n.indexOf(s)!==-1)return[];n.push(s);const i=s.manifest.extensionPack?s.manifest.extensionPack:[];if(i.length){const r=e.filter(y=>!y.isBuiltin&&i.some(R=>(0,d.areSameExtensions)({id:R},y.identifier))),l=[];for(const y of r)l.push(...this.getAllPackExtensionsToUninstall(y,e,n));return[...r,...l]}return[]}getDependents(s,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(i=>(0,d.areSameExtensions)({id:i},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};b=ue([fe(0,p.IExtensionGalleryService),fe(1,c.ITelemetryService),fe(2,D.ILogService)],b),t.AbstractExtensionManagementService=b;function v(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}t.joinErrors=v;function m(o,s,e,n,i){const r=i?i instanceof p.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!i,duration:n,errorcode:r})}t.reportTelemetry=m;class f{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(s=>new Promise((e,n)=>{const i=s.onCancellationRequested(()=>{i.dispose(),n((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=f}),define(Z[118],ee([0,1,26,7,18,10,20,23,24,49,17,12,15,42,55,114,115,36]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D,a,c,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var m;(function(W){W[W.None=0]="None",W[W.IncludeVersions=1]="IncludeVersions",W[W.IncludeFiles=2]="IncludeFiles",W[W.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",W[W.IncludeSharedAccounts=8]="IncludeSharedAccounts",W[W.IncludeVersionProperties=16]="IncludeVersionProperties",W[W.ExcludeNonValidated=32]="ExcludeNonValidated",W[W.IncludeInstallationTargets=64]="IncludeInstallationTargets",W[W.IncludeAssetUri=128]="IncludeAssetUri",W[W.IncludeStatistics=256]="IncludeStatistics",W[W.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",W[W.Unpublished=4096]="Unpublished"})(m||(m={}));function f(...W){return String(W.reduce((x,q)=>x|q,0))}var o;(function(W){W[W.Tag=1]="Tag",W[W.ExtensionId=4]="ExtensionId",W[W.Category=5]="Category",W[W.ExtensionName=7]="ExtensionName",W[W.Target=8]="Target",W[W.Featured=9]="Featured",W[W.SearchText=10]="SearchText",W[W.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},e={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},i={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class r{constructor(x=i){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(x,q=this.state.pageSize){return new r({...this.state,pageNumber:x,pageSize:q})}withFilter(x,...q){const U=[...this.state.criteria,...q.length?q.map(I=>({filterType:x,value:I})):[{filterType:x}]];return new r({...this.state,criteria:U})}withSortBy(x){return new r({...this.state,sortBy:x})}withSortOrder(x){return new r({...this.state,sortOrder:x})}withFlags(...x){return new r({...this.state,flags:x.reduce((q,U)=>q|U,0)})}withAssetTypes(...x){return new r({...this.state,assetTypes:x})}get raw(){const{criteria:x,pageNumber:q,pageSize:U,sortBy:I,sortOrder:M,flags:w,assetTypes:C}=this.state;return{filters:[{criteria:x,pageNumber:q,pageSize:U,sortBy:I,sortOrder:M}],assetTypes:C,flags:w}}get searchText(){const x=this.state.criteria.filter(q=>q.filterType===o.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(W,x){const q=(W||[]).filter(U=>U.statisticName===x)[0];return q?q.value:0}function y(W){const x="Microsoft.VisualStudio.Code.Translation.";return W.files.filter(U=>U.assetType.indexOf(x)===0).reduce((U,I)=>{const M=O(W,I.assetType);return M&&U.push([I.assetType.substring(x.length),M]),U},[])}function R(W){if(W.properties){const x=W.properties.filter(I=>I.key===s.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=x.filter(I=>q.test(I.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return O(W,s.Repository)}function N(W){return{uri:`${W.fallbackAssetUri}/${s.VSIX}?redirect=true`,fallbackUri:`${W.fallbackAssetUri}/${s.VSIX}`}}function E(W){const x=O(W,s.Icon);if(x)return x;const q=L.DefaultIconPath;return{uri:q,fallbackUri:q}}function O(W,x){return W.files.filter(U=>U.assetType===x)[0]?{uri:`${W.assetUri}/${x}`,fallbackUri:`${W.fallbackAssetUri}/${x}`}:null}function z(W,x){const q=W.properties?W.properties.filter(I=>I.key===x):[],U=q.length>0&&q[0].value;return U?U.split(",").map(I=>(0,u.adoptToGalleryExtensionId)(I)):[]}function $(W){const x=W.properties?W.properties.filter(q=>q.key===e.Engine):[];return x.length>0&&x[0].value||""}function Q(W){const x=W.properties?W.properties.filter(U=>U.key===e.LocalizedLanguages):[],q=x.length>0&&x[0].value||"";return q?q.split(","):[]}function ie(W){return W.indexOf("preview")!==-1}function re(W,x,q,U,I){const M={manifest:O(x,s.Manifest),readme:O(x,s.Details),changelog:O(x,s.Changelog),license:O(x,s.License),repository:R(x),download:N(x),icon:E(x),coreTranslations:y(x)};return{identifier:{id:(0,u.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},name:W.extensionName,version:x.version,displayName:W.displayName,publisherId:W.publisher.publisherId,publisher:W.publisher.publisherName,publisherDisplayName:W.publisher.displayName,description:W.shortDescription||"",installCount:l(W.statistics,"install"),rating:l(W.statistics,"averagerating"),ratingCount:l(W.statistics,"ratingcount"),categories:W.categories||[],tags:W.tags||[],releaseDate:Date.parse(W.releaseDate),lastUpdated:Date.parse(W.lastUpdated),webExtension:!!W.tags?.includes(L.WEB_EXTENSION_TAG),assets:M,properties:{dependencies:z(x,e.Dependency),extensionPack:z(x,e.ExtensionPack),engine:$(x),localizedLanguages:Q(x)},telemetryData:{index:(U.pageNumber-1)*U.pageSize+q,querySource:I},preview:ie(W.flags)}}let Y=class{constructor(x,q,U,I,M,w,C){this.requestService=x,this.logService=q,this.environmentService=U,this.telemetryService=I,this.fileService=M,this.productService=w;const T=w.extensionsGallery;this.extensionsGalleryUrl=T&&T.serviceUrl,this.extensionsControlUrl=T&&T.controlUrl,this.commonHeadersPromise=J(w.version,this.environmentService,this.fileService,C)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,q){const U=[];let{total:I,firstPage:M,getPage:w}=await this.query({names:x,pageSize:x.length},q);U.push(...M);for(let C=1;U.length<I&&(M=await w(C,q),M.length);C++)U.push(...M);return U}async getCompatibleExtension(x,q){return this.getCompatibleExtensionByEngine(x,q)}async getCompatibleExtensionByEngine(x,q){const U=(0,L.isIExtensionIdentifier)(x)?null:x;if(U&&U.properties.engine&&(0,h.isEngineValid)(U.properties.engine,this.productService.version,this.productService.date))return U;const{id:I,uuid:M}=U?U.identifier:x;let w=new r().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeCategoryAndTags,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");M?w=w.withFilter(o.ExtensionId,M):w=w.withFilter(o.ExtensionName,I);const{galleryExtensions:C}=await this.queryGallery(w,A.CancellationToken.None),[T]=C;if(!T||!T.versions.length)return null;if(q){const B=T.versions.filter(_=>_.version===q)[0];if(B){const _=re(T,B,0,w);if(_.properties.engine&&(0,h.isEngineValid)(_.properties.engine,this.productService.version,this.productService.date))return _}return null}const j=await this.getLastValidExtensionVersion(T,T.versions);return j?re(T,j,0,w):null}async query(x,q){const U=A.CancellationToken.isCancellationToken(x)?{}:x,I=A.CancellationToken.isCancellationToken(x)?x:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=U.text||"";const w=(0,S.getOrDefault)(U,K=>K.pageSize,50);let C=new r().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeCategoryAndTags,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,w).withFilter(o.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(K,te,ne)=>(C=C.withFilter(o.Category,ne||te),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(K,te,ne)=>(C=C.withFilter(o.Tag,ne||te),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(C=C.withFilter(o.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),C=C.withFilter(o.SearchText,M)),C=C.withSortBy(0)):U.ids?C=C.withFilter(o.ExtensionId,...U.ids):U.names?C=C.withFilter(o.ExtensionName,...U.names):C=C.withSortBy(4),typeof U.sortBy=="number"&&(C=C.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(C=C.withSortOrder(U.sortOrder));const{galleryExtensions:T,total:j}=await this.queryGallery(C,I),B=T.map((K,te)=>re(K,K.versions[0],te,C,U.source)),_=async(K,te)=>{if(te.isCancellationRequested)throw(0,P.canceled)();const ne=C.withPage(K+1),{galleryExtensions:oe}=await this.queryGallery(ne,te);return oe.map((le,pe)=>re(le,le.versions[0],pe,ne,U.source))};return{firstPage:B,total:j,pageSize:C.pageSize,getPage:_}}async queryGallery(x,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,m.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,f(m.Unpublished));const U=await this.commonHeadersPromise,I=JSON.stringify(x.raw),M={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(I.length)},w=new Date().getTime();let C,T,j=0;try{if(C=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:I,headers:M},q),C.res.statusCode&&C.res.statusCode>=400&&C.res.statusCode<500)return{galleryExtensions:[],total:j};const B=await(0,a.asJson)(C);if(B){const _=B.results[0],K=_.extensions,te=_.resultMetadata&&_.resultMetadata.filter(ne=>ne.metadataType==="ResultCount")[0];return j=te&&te.metadataItems.filter(ne=>ne.name==="TotalCount")[0].count||0,{galleryExtensions:K,total:j}}return{galleryExtensions:[],total:j}}catch(B){throw T=B,B}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(I.length),duration:new Date().getTime()-w,success:!!C&&(0,a.isSuccess)(C),responseBodySize:C?.res.headers["Content-Length"],statusCode:C?String(C.res.statusCode):void 0,errorCode:T?(0,P.isPromiseCanceledError)(T)?"canceled":(0,P.getErrorMessage)(T).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(x,q,U,I){if(!this.isEnabled())return;const M=k.isWeb?this.api(`/itemName/${x}.${q}/version/${U}/statType/${I==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${q}/${U}/stats?statType=${I}`),w=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",T={...await this.commonHeadersPromise,Accept:w};try{await this.requestService.request({type:"POST",url:M,headers:T},A.CancellationToken.None)}catch(j){}}async download(x,q,U){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const I=(0,u.getGalleryExtensionTelemetryData)(x),M=new Date().getTime(),w=B=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...I,duration:B}),C=U===1?"install":U===2?"update":"",T=C?{uri:`${x.assets.download.uri}&${C}=true`,fallbackUri:`${x.assets.download.fallbackUri}?${C}=true`}:x.assets.download,j=await this.getAsset(T);await this.fileService.writeFile(q,j.stream),w(new Date().getTime()-M)}async getReadme(x,q){if(x.assets.readme){const U=await this.getAsset(x.assets.readme,{},q);return await(0,a.asText)(U)||""}return""}async getManifest(x,q){if(x.assets.manifest){const U=await this.getAsset(x.assets.manifest,{},q),I=await(0,a.asText)(U);return I?JSON.parse(I):null}return null}async getCoreTranslation(x,q){const U=x.assets.coreTranslations.filter(I=>I[0]===q.toUpperCase())[0];if(U){const I=await this.getAsset(U[1]),M=await(0,a.asText)(I);return M?JSON.parse(M):null}return null}async getChangelog(x,q){if(x.assets.changelog){const U=await this.getAsset(x.assets.changelog,{},q);return await(0,a.asText)(U)||""}return""}async getAllVersions(x,q){let U=new r().withFlags(m.IncludeVersions,m.IncludeCategoryAndTags,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");x.identifier.uuid?U=U.withFilter(o.ExtensionId,x.identifier.uuid):U=U.withFilter(o.ExtensionName,x.identifier.id);const I=[],{galleryExtensions:M}=await this.queryGallery(U,A.CancellationToken.None);return M.length&&(q?await Promise.all(M[0].versions.map(async w=>{let C;try{C=await this.getEngine(w)}catch(T){}C&&(0,h.isEngineValid)(C,this.productService.version,this.productService.date)&&I.push({version:w.version,date:w.lastUpdated})})):I.push(...M[0].versions.map(w=>({version:w.version,date:w.lastUpdated})))),I}async getAsset(x,q={},U=A.CancellationToken.None){const I=await this.commonHeadersPromise,M={type:"GET"},w={...I,...q.headers||{}};q={...q,...M,headers:w};const C=x.uri,T=x.fallbackUri,j={...q,url:C};try{const B=await this.requestService.request(j,U);if(B.res.statusCode===200)return B;const _=await(0,a.asText)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${_}`)}catch(B){if((0,P.isPromiseCanceledError)(B))throw B;const _=(0,P.getErrorMessage)(B);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:C,message:_});const K={...q,url:T};return this.requestService.request(K,U)}}async getLastValidExtensionVersion(x,q){const U=this.getLastValidExtensionVersionFromProperties(x,q);return U||this.getLastValidExtensionVersionRecursively(x,q)}getLastValidExtensionVersionFromProperties(x,q){for(const U of q){const I=$(U);if(!I)return null;if((0,h.isEngineValid)(I,this.productService.version,this.productService.date))return U}return null}async getEngine(x){const q=$(x);if(q)return q;const U=O(x,s.Manifest);if(!U)throw new Error("Manifest was not found");const I={"Accept-Encoding":"gzip"},M=await this.getAsset(U,{headers:I}),w=await(0,a.asJson)(M);if(w)return w.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(x,q){if(!q.length)return null;const U=q[0],I=await this.getEngine(U);return(0,h.isEngineValid)(I,this.productService.version,this.productService.date)?{...U,properties:[...U.properties||[],{key:e.Engine,value:I}]}:this.getLastValidExtensionVersionRecursively(x,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},A.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,a.asJson)(x),U=new Map;if(q)for(const I of q.malicious){const M=U.get(I)||{id:{id:I},malicious:!0,slow:!1};M.malicious=!0,U.set(I,M)}return[...U.values()]}};Y=ue([fe(0,a.IRequestService),fe(1,d.ILogService),fe(2,F.IEnvironmentService),fe(3,v.ITelemetryService),fe(4,g.IFileService),fe(5,D.IProductService),fe(6,(0,p.optional)(b.IStorageService))],Y),t.ExtensionGalleryService=Y;async function J(W,x,q,U){const I={"X-Market-Client-Id":`VSCode ${W}`,"User-Agent":`VSCode ${W}`},M=await(0,c.getServiceMachineId)(x,q,U);return I["X-Market-User-Id"]=M,I}t.resolveMarketplaceHeaders=J}),define(Z[119],ee([0,1,2,18,22,85,27,30,12,35,25]),function(G,t,A,P,S,k,F,L,u,h,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let p=class{constructor(a,c){this._configurationService=c,this._experimentProperties={},this._disposables=new A.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,S.escapeRegExpCharacters)(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const v=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})}))}setExperimentProperty(a,c){this._experimentProperties[a]=c}setEnabled(a){this._enabled=a}_updateUserOptIn(){const a=this._configurationService?.getValue(d);this._userOptIn=a?a.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let c=a.sessionID,b=a["common.instanceId"],v=a["common.machineId"],m=a["common.firstSessionDate"],f=a["common.msftInternal"];return{sessionId:c,instanceId:b,machineId:v,firstSessionDate:m,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(a,c,b){return this.isOptedIn?this._commonProperties.then(v=>{c=(0,P.mixin)(c,v),c=(0,P.mixin)(c,this._experimentProperties),c=(0,P.cloneAndChange)(c,m=>{if(typeof m=="string")return this._cleanupInfo(m,b)}),this._appender.log(a,c)},v=>{console.error(v)}):Promise.resolve(void 0)}publicLog2(a,c,b){return this.publicLog(a,c,b)}publicLogError(a,c){return this.sendErrorTelemetry?this.publicLog(a,c,!0):Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}_cleanupInfo(a,c){let b=a;if(c){const v=[];for(let s of this._cleanupPatterns)for(;;){const e=s.exec(a);if(!e)break;v.push([e.index,s.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(b="";;){const s=f.exec(a);if(!s)break;!m.test(s[0])&&v.every(([e,n])=>s.index<e||s.index>=n)&&(b+=a.substring(o,s.index)+"<REDACTED: user-file-path>",o=f.lastIndex)}o<a.length&&(b+=a.substr(o))}for(let v of this._cleanupPatterns)b=b.replace(v,"");return b}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([fe(1,(0,u.optional)(F.IConfigurationService))],p),t.TelemetryService=p;const d="telemetry";g.Registry.as(L.Extensions.Configuration).registerConfiguration({id:d,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,k.localize)(2,null,h.default.nameLong,h.default.privacyStatementUrl):(0,k.localize)(1,null,h.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[56],ee([0,1,3,18,13,27]),function(G,t,A,P,S,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,c){return Promise.resolve(void 0)}publicLog2(a,c){return this.publicLog(a,c)}publicLogError(a,c){return Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(c,b,v){}async publicLogError(c,b,v){}}t.NullEndpointTelemetryService=F;function L(...a){return{log:(c,b)=>a.forEach(v=>v.log(c,b)),flush:()=>A.Promises.settled(a.map(c=>c.flush()))}}t.combinedAppender=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(a,c){return c.onDidChangeConfiguration(b=>{b.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(b.source),configurationKeys:d(b.sourceConfig)})})}t.configurationTelemetry=u;function h(a){const c=Object.create(null),b=Object.create(null),v=Object.create(null);p(a,v);for(let m in v){m=m.length>150?m.substr(m.length-149):m;const f=v[m];typeof f=="number"?b[m]=f:typeof f=="boolean"?b[m]=f?1:0:typeof f=="string"?c[m]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(c[m]=f)}return{properties:c,measurements:b}}t.validateTelemetryData=h;function g(a){if(!a)return"none";let c="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{a.indexOf(`${v}+`)===0&&(c=v)}),c}t.cleanRemoteAuthority=g;function p(a,c,b=0,v){if(!!a)for(let m of Object.getOwnPropertyNames(a)){const f=a[m],o=v?v+m:m;Array.isArray(f)?c[o]=(0,P.safeStringify)(f):f instanceof Date?c[o]=f.toISOString():(0,S.isObject)(f)?b<2?p(f,c,b+1,o+"."):c[o]=(0,P.safeStringify)(f):c[o]=f}}function d(a){if(!a)return[];const c=[];return D(c,"",a),c}function D(a,c,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(v=>D(a,c?`${c}.${v}`:v,b[v])):a.push(c)}}),define(Z[120],ee([0,1,7,18,56]),function(G,t,A,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function k(L){const u=await new Promise((g,p)=>{G(["applicationinsights"],g,p)});let h;return u.defaultClient?(h=new u.TelemetryClient(L),h.channel.setUseDiskRetryCaching(!0)):(u.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),h=u.defaultClient),L.indexOf("AIF-")===0&&(h.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),h}class F{constructor(u,h,g){this._eventPrefix=u,this._defaultData=h,this._defaultData||(this._defaultData=Object.create(null)),typeof g=="function"?this._aiClient=g():this._aiClient=g,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(h=>{u(h)},h=>{(0,A.onUnexpectedError)(h),console.error(h)})}}log(u,h){!this._aiClient||(h=(0,P.mixin)(h,this._defaultData),h=(0,S.validateTelemetryData)(h),this._withAIClient(g=>g.trackEvent({name:this._eventPrefix+"/"+u,properties:h.properties,measurements:h.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(h=>{h.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(Z[121],ee([0,1,4,11]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(k,F){const L=Object.create(null),u=(g,p)=>{const d=JSON.parse(g);L[p]=d};if(F){const g=[],p=await P.Promises.readdir(F);for(const D of p)try{(await P.Promises.stat((0,A.join)(F,D))).isDirectory()&&g.push(D)}catch{}const d=[];for(const D of g)(await P.Promises.readdir((0,A.join)(F,D))).filter(c=>c==="telemetry.json").length===1&&d.push(D);for(const D of d){const a=(await P.Promises.readFile((0,A.join)(F,D,"telemetry.json"))).toString();u(a,D)}}let h=(await P.Promises.readFile((0,A.join)(k,"telemetry-core.json"))).toString();return u(h,"vscode-core"),h=(await P.Promises.readFile((0,A.join)(k,"telemetry-extensions.json"))).toString(),u(h,"vscode-extensions"),JSON.stringify(L,null,4)}t.buildTelemetryMessage=S}),define(Z[43],ee([0,1,38,3,4,13,11,72,132,133]),function(G,t,A,P,S,k,F,L,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class g extends Error{constructor(e,n){let i=n.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=n}}t.ExtractError=g;function p(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,i)=>n+i,e&61440)}function d(s){if(s instanceof g)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new g(e,s)}function D(s,e,n,i,r,l){const y=S.dirname(e),R=S.join(i,y);if(!R.startsWith(i))return Promise.reject(new Error(L.localize(0,null,e)));const N=S.join(i,e);let E;return l.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(F.Promises.mkdir(R,{recursive:!0})).then(()=>new Promise((O,z)=>{if(!l.isCancellationRequested)try{E=(0,A.createWriteStream)(N,{mode:n}),E.once("close",()=>O()),E.once("error",z),s.once("error",z),s.pipe(E)}catch($){z($)}}))}function a(s,e,n,i){let r=(0,P.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((y,R)=>{const N=new P.Sequencer,E=O=>{O.isCancellationRequested||(l++,s.readEntry())};s.once("error",R),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===l?y():R(new g("Incomplete",new Error(L.localize(1,null,l,s.entryCount))))},R)),s.readEntry(),s.on("entry",O=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(O.fileName)){E(i);return}const z=O.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(z)){const ie=S.join(e,z);r=(0,P.createCancelablePromise)(re=>F.Promises.mkdir(ie,{recursive:!0}).then(()=>E(re)).then(void 0,R));return}const $=b(s,O),Q=p(O);r=(0,P.createCancelablePromise)(ie=>N.queue(()=>$.then(re=>D(re,z,Q,e,n,ie).then(()=>E(ie)))).then(null,R))})})}function c(s,e=!1){return new Promise((n,i)=>{(0,u.open)(s,e?{lazyEntries:!0}:void 0,(r,l)=>{r?i(d(r)):n((0,k.assertIsDefined)(l))})})}function b(s,e){return new Promise((n,i)=>{s.openReadStream(e,(r,l)=>{r?i(d(r)):n((0,k.assertIsDefined)(l))})})}function v(s,e){return new Promise((n,i)=>{const r=new h.ZipFile;e.forEach(y=>{y.contents?r.addBuffer(typeof y.contents=="string"?Buffer.from(y.contents,"utf8"):y.contents,y.path):y.localPath&&r.addFile(y.localPath,y.path)}),r.end();const l=(0,A.createWriteStream)(s);r.outputStream.pipe(l),r.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>n(s))})}t.zip=v;function m(s,e,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let l=c(s,!0);return n.overwrite&&(l=l.then(y=>F.Promises.rm(e).then(()=>y))),l.then(y=>a(y,e,{sourcePathRegex:r},i))}t.extract=m;function f(s,e){return c(s).then(n=>new Promise((i,r)=>{n.on("entry",l=>{l.fileName===e&&b(n,l).then(y=>i(y),y=>r(y))}),n.once("close",()=>r(new Error(L.localize(2,null,e))))}))}function o(s,e){return f(s,e).then(n=>new Promise((i,r)=>{const l=[];n.once("error",r),n.on("data",y=>l.push(y)),n.on("end",()=>i(Buffer.concat(l)))}))}t.buffer=o}),define(Z[122],ee([0,1,43,78]),function(G,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(k){return(0,A.buffer)(k,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(L){throw new Error((0,P.localize)(0,null))}})}t.getManifest=S}),define(Z[123],ee([0,1,21,3,7,2,9,4,10,19,41,8,29,11,43,79,20,23,24,90,17,15,42]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D,a,c,b,v,m,f,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",i="scanningUser",r="extracting",l="deleting",y="renaming";let R=class extends k.Disposable{constructor(E,O,z,$,Q){super();this.beforeRemovingExtension=E,this.fileService=O,this.logService=z,this.environmentService=$,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=$.builtinExtensionsPath,this.extensionsPath=$.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(E){const O=[];(E===null||E===0)&&O.push(this.scanSystemExtensions().then(null,z=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(z).message,n)))),(E===null||E===1)&&O.push(this.scanUserExtensions(!0).then(null,z=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(z).message,i))));try{const z=await Promise.all(O);return(0,A.flatten)(z)}catch(z){throw this.joinErrors(z)}}async scanUserExtensions(E){this.logService.trace("Started scanning user extensions");let[O,z]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return z=z.filter($=>!O[new m.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]),E&&(z=(0,m.groupByExtension)(z,Q=>Q.identifier).map(Q=>Q.sort((ie,re)=>g.rcompare(ie.manifest.version,re.manifest.version))[0])),this.logService.trace("Scanned user extensions:",z.length),z}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(E,O,z){const $=E.key(),Q=L.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),ie=L.join(this.extensionsPath,$);try{await D.Promises.rm(ie)}catch(Y){try{await D.Promises.rm(ie)}catch(J){}throw new v.ExtensionManagementError((0,c.localize)(0,null,ie,E.id),l)}await this.extractAtLocation(E,O,Q,z);let re=await this.scanExtension(p.URI.file(Q),1);if(!re)throw new Error((0,c.localize)(1,null,Q));await this.storeMetadata(re,{installedTimestamp:Date.now()});try{await this.rename(E,Q,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(Y){try{await D.Promises.rm(Q)}catch(J){}if(Y.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",E.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(Y)}. Deleted from extracted location`,Q),Y}try{re=await this.scanExtension(p.URI.file(ie),1)}catch(Y){}if(re)return re;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(E,O){return this.setMetadata(E,O),await this.storeMetadata(E,{...O,installedTimestamp:E.installedTimestamp}),E}async storeMetadata(E,O){O.isMachineScoped=O.isMachineScoped||void 0,O.isBuiltin=O.isBuiltin||void 0,O.installedTimestamp=O.installedTimestamp||void 0;const z=L.join(E.location.fsPath,"package.json"),$=await D.Promises.readFile(z,"utf8"),{manifest:Q}=await this.parseManifest($);return Q.__metadata=O,await D.Promises.writeFile(z,JSON.stringify(Q,null,"	")),E}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...E){const O=E.map(z=>new m.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version));await this.withUninstalledExtensions(z=>{O.forEach($=>z[$.key()]=!0)})}async setInstalled(E){await this.withUninstalledExtensions($=>delete $[E.key()]);const z=(await this.scanExtensions(1)).find($=>new m.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(E))||null;return z?(await this.storeMetadata(z,{installedTimestamp:Date.now()}),this.scanExtension(z.location,1)):null}async withUninstalledExtensions(E){return this.uninstalledFileLimiter.queue(async()=>{let O;try{O=await D.Promises.readFile(this.uninstalledPath,"utf8")}catch($){if($.code!=="ENOENT")throw $}let z={};if(O)try{z=JSON.parse(O)}catch($){}return E&&(E(z),Object.keys(z).length?await D.Promises.writeFile(this.uninstalledPath,JSON.stringify(z)):await D.Promises.rm(this.uninstalledPath)),z})}async removeExtension(E,O){this.logService.trace(`Deleting ${O} extension from disk`,E.identifier.id,E.location.fsPath),await D.Promises.rm(E.location.fsPath),this.logService.info("Deleted from disk",E.identifier.id,E.location.fsPath)}async removeUninstalledExtension(E){await this.removeExtension(E,"uninstalled"),await this.withUninstalledExtensions(O=>delete O[new m.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()])}async extractAtLocation(E,O,z,$){this.logService.trace(`Started extracting the extension from ${O} to ${z}`);try{await D.Promises.rm(z)}catch(Q){throw new v.ExtensionManagementError(this.joinErrors(Q).message,l)}try{await(0,a.extract)(O,z,{sourcePath:"extension",overwrite:!0},$),this.logService.info(`Extracted extension to ${z}:`,E.id)}catch(Q){try{await D.Promises.rm(z)}catch(ie){}throw new v.ExtensionManagementError(Q.message,Q instanceof a.ExtractError&&Q.type?Q.type:r)}}async rename(E,O,z,$){try{await D.Promises.rename(O,z)}catch(Q){if(u.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<$)return this.logService.info(`Failed renaming ${O} to ${z} with 'EPERM' error. Trying again...`,E.id),this.rename(E,O,z,$);throw new v.ExtensionManagementError(Q.message||(0,c.localize)(3,null,O,z),Q.code||y)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const E=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return E;const O=this.scanDevSystemExtensions(),[z,$]=await Promise.all([E,O]);return[...z,...$]}async scanExtensionsInDir(E,O){const z=new P.Limiter(10),$=await this.fileService.resolve(p.URI.file(E));return $.children?(await Promise.all($.children.filter(ie=>ie.isDirectory).map(ie=>z.queue(async()=>O===1&&(0,h.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,O))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(E,O){try{const z=await this.fileService.resolve(E);if(z.children){const{manifest:$,metadata:Q}=await this.readManifest(E.fsPath),ie=z.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,re=z.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,Y={id:(0,m.getGalleryExtensionId)($.publisher,$.name)},J={type:O,identifier:Y,manifest:$,location:E,readmeUrl:ie,changelogUrl:re,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:O===0};return Q&&(this.setMetadata(J,Q),J.installedTimestamp=Q.installedTimestamp),J}}catch(z){O!==0&&this.logService.trace(z)}return null}async scanDefaultSystemExtensions(){const E=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",E.length),E}async scanDevSystemExtensions(){const E=this.getDevSystemExtensionsList();if(E.length){const O=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",O.length),O.filter(z=>E.some($=>(0,m.areSameExtensions)(z.identifier,{id:$})))}else return[]}setMetadata(E,O){E.publisherDisplayName=O.publisherDisplayName||null,E.publisherId=O.publisherId||null,E.identifier.uuid=O.id,E.isMachineScoped=!!O.isMachineScoped,E.isBuiltin=E.type===0||!!O.isBuiltin}async removeUninstalledExtensions(){const E=await this.getUninstalledExtensions(),O=await this.scanAllUserExtensions(),z=new Set;for(const ie of O)E[new m.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||z.add(ie.identifier.id.toLowerCase());const $=(0,m.groupByExtension)(O,ie=>ie.identifier);await P.Promises.settled($.map(async ie=>{const re=ie.sort((Y,J)=>g.rcompare(Y.manifest.version,J.manifest.version))[0];z.has(re.identifier.id.toLowerCase())||await this.beforeRemovingExtension(re)}));const Q=O.filter(ie=>E[new m.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await P.Promises.settled(Q.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const E=await this.scanAllUserExtensions(),O=[],z=(0,m.groupByExtension)(E,$=>$.identifier);O.push(...(0,A.flatten)(z.map($=>$.sort((Q,ie)=>g.rcompare(Q.manifest.version,ie.manifest.version)).slice(1)))),await P.Promises.settled(O.map($=>this.removeExtension($,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(E=>E.name)}joinErrors(E){const O=Array.isArray(E)?E:[E];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((z,$)=>new Error(`${z.message}${z.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(F.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(E){const O=[D.Promises.readFile(L.join(E,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),D.Promises.readFile(L.join(E,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:z,metadata:$},Q]=await Promise.all(O);return{manifest:(0,f.localizeManifest)(z,Q),metadata:$}}parseManifest(E){return new Promise((O,z)=>{try{const $=JSON.parse(E),Q=$.__metadata||null;O({manifest:$,metadata:Q})}catch($){z(new Error((0,c.localize)(4,null)))}})}};R=ue([fe(1,o.IFileService),fe(2,s.ILogService),fe(3,b.INativeEnvironmentService),fe(4,e.IProductService)],R),t.ExtensionsScanner=R}),define(Z[124],ee([0,1,28,9,4,10,19,41,8,29,11,43,77,96,20,117,23,24,102,103,122,98,123,104,49,17,12,15,35,36]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D,a,c,b,v,m,f,o,s,e,n,i,r,l,y,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const E="unsetUninstalled",O="downloading";let z=class extends c.AbstractExtensionManagementService{constructor(J,W,x,q,U,I,M){super(J,W,x);this.environmentService=q,this.downloadService=U;const w=this._register(I.createInstance(f.ExtensionsLifecycle));this.extensionsScanner=this._register(I.createInstance(e.ExtensionsScanner,T=>w.postUninstall(T))),this.manifestCache=this._register(new s.ExtensionsManifestCache(q,this)),this.extensionsDownloader=this._register(I.createInstance(m.ExtensionsDownloader));const C=this._register(new n.ExtensionsWatcher(this,M,q,x));this._register(C.onDidChangeExtensionsByAnotherSource(({added:T,removed:j})=>{T.length&&this._onDidInstallExtensions.fire(T.map(B=>({identifier:B.identifier,operation:0,local:B}))),j.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}async zip(J){this.logService.trace("ExtensionManagementService#zip",J.identifier.id);const W=await this.collectFiles(J),x=await(0,p.zip)((0,F.joinPath)(this.environmentService.tmpDir,(0,h.generateUuid)()).fsPath,W);return u.URI.file(x)}async unzip(J){return this.logService.trace("ExtensionManagementService#unzip",J.toString()),(await this.install(J)).identifier}async getManifest(J){const W=await this.downloadVsix(J),x=S.resolve(W.fsPath);return(0,o.getManifest)(x)}getInstalled(J=null){return this.extensionsScanner.scanExtensions(J)}async canInstall(J){return!0}async install(J,W={}){this.logService.trace("ExtensionManagementService#install",J.toString());const x=await this.downloadVsix(J),q=await(0,o.getManifest)(S.resolve(x.fsPath));if(q.engines&&q.engines.vscode&&!(0,i.isEngineValid)(q.engines.vscode,R.default.version,R.default.date))throw new Error(d.localize(0,null,(0,v.getGalleryExtensionId)(q.publisher,q.name),R.default.version));return this.installExtension(q,x,W)}async updateMetadata(J,W){return this.logService.trace("ExtensionManagementService#updateMetadata",J.identifier.id),J=await this.extensionsScanner.saveMetadataForLocalExtension(J,{...J.manifest.__metadata||{},...W}),this.manifestCache.invalidate(),J}async updateExtensionScope(J,W){return this.logService.trace("ExtensionManagementService#updateExtensionScope",J.identifier.id),J=await this.extensionsScanner.saveMetadataForLocalExtension(J,{...J.manifest.__metadata||{},isMachineScoped:W}),this.manifestCache.invalidate(),J}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(J){if(J.scheme===P.Schemas.file)return J;if(!this.downloadService)throw new Error("Download service is not available");const W=(0,F.joinPath)(this.environmentService.tmpDir,(0,h.generateUuid)());return await this.downloadService.download(J,W),W}createInstallExtensionTask(J,W,x){return u.URI.isUri(W)?new ie(J,W,x,this.galleryService,this.extensionsScanner,this.logService):new Q(W,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(J,W){return new re(J,W,this.extensionsScanner)}async collectFiles(J){const W=async q=>{let U=await g.Promises.readdir(q);U=U.map(w=>S.join(q,w));const I=await Promise.all(U.map(w=>g.Promises.stat(w)));let M=Promise.resolve([]);return I.forEach((w,C)=>{const T=U[C];w.isFile()&&(M=M.then(j=>[...j,T])),w.isDirectory()&&(M=M.then(j=>W(T).then(B=>[...j,...B])))}),M};return(await W(J.location.fsPath)).map(q=>({path:`extension/${S.relative(J.location.fsPath,q)}`,localPath:q}))}};z=ue([fe(0,b.IExtensionGalleryService),fe(1,N.ITelemetryService),fe(2,y.ILogService),fe(3,a.INativeEnvironmentService),fe(4,(0,l.optional)(D.IDownloadService)),fe(5,l.IInstantiationService),fe(6,r.IFileService)],z),t.ExtensionManagementService=z;class $ extends c.AbstractExtensionTask{constructor(J,W,x,q){super();this.identifier=J,this.source=W,this.extensionsScanner=x,this.logService=q,this._operation=1}get operation(){return this._operation}async installExtension(J,W){try{const x=await this.unsetUninstalledAndGetLocal(J.identifierWithVersion);if(x)return J.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,J.metadata):x}catch(x){throw k.isMacintosh?new b.ExtensionManagementError(d.localize(1,null),E):new b.ExtensionManagementError(d.localize(2,null),E)}return this.extract(J,W)}async unsetUninstalledAndGetLocal(J){if(!await this.isUninstalled(J))return null;this.logService.trace("Removing the extension from uninstalled list:",J.id);const x=await this.extensionsScanner.setInstalled(J);return this.logService.info("Removed the extension from uninstalled list:",J.id),x}async isUninstalled(J){return!!(await this.extensionsScanner.getUninstalledExtensions())[J.key()]}async extract({zipPath:J,identifierWithVersion:W,metadata:x},q){let U=await this.extensionsScanner.extractUserExtension(W,J,q);return this.logService.info("Extracting completed.",W.id),x&&(U=await this.extensionsScanner.saveMetadataForLocalExtension(U,x)),U}}class Q extends ${constructor(J,W,x,q,U){super(J.identifier,J,q,U);this.gallery=J,this.options=W,this.extensionsDownloader=x}async doRun(J){const x=(await this.extensionsScanner.scanExtensions(null)).find(I=>(0,v.areSameExtensions)(I.identifier,this.gallery.identifier));x&&(this._operation=2);const q=await this.downloadInstallableExtension(this.gallery,this._operation);q.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,q.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin;const U=await this.installExtension(q,J);x&&L.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x);try{await this.extensionsDownloader.delete(u.URI.file(q.zipPath))}catch(I){}return U}async downloadInstallableExtension(J,W){const x={id:J.identifier.uuid,publisherId:J.publisherId,publisherDisplayName:J.publisherDisplayName};let q;try{this.logService.trace("Started downloading extension:",J.identifier.id),q=(await this.extensionsDownloader.downloadExtension(J,W)).fsPath,this.logService.info("Downloaded extension:",J.identifier.id,q)}catch(U){throw new b.ExtensionManagementError((0,c.joinErrors)(U).message,O)}try{const U=await(0,o.getManifest)(q);return{zipPath:q,identifierWithVersion:new v.ExtensionIdentifierWithVersion(J.identifier,U.version),metadata:x}}catch(U){throw new b.ExtensionManagementError((0,c.joinErrors)(U).message,c.INSTALL_ERROR_VALIDATING)}}}class ie extends ${constructor(J,W,x,q,U,I){super({id:(0,v.getGalleryExtensionId)(J.publisher,J.name)},W,U,I);this.manifest=J,this.location=W,this.options=x,this.galleryService=q}async doRun(J){const W=new v.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),q=(await this.extensionsScanner.scanExtensions(1)).find(I=>(0,v.areSameExtensions)(this.identifier,I.identifier)),U=await this.getMetadata(this.identifier.id,J);if(q)if(U.isMachineScoped=this.options.isMachineScoped||q.isMachineScoped,U.isBuiltin=this.options.isBuiltin||q.isBuiltin,this._operation=2,W.equals(new v.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch(I){throw new Error(d.localize(3,null,this.manifest.displayName||this.manifest.name))}else L.gt(q.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(q);else{const I=await this.unsetUninstalledAndGetLocal(W);if(I)try{await this.extensionsScanner.removeExtension(I,"existing")}catch(M){throw new Error(d.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:S.resolve(this.location.fsPath),identifierWithVersion:W,metadata:U},J)}async getMetadata(J,W){try{const x=(await this.galleryService.query({names:[J],pageSize:1},W)).firstPage[0];if(x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId}}catch(x){}return{}}}class re extends c.AbstractExtensionTask{constructor(J,W,x){super();this.extension=J,this.options=W,this.extensionsScanner=x}async doRun(J){const W=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const q=new v.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);W.push(...x.filter(U=>q.equals(new v.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version))))}else W.push(...x.filter(q=>(0,v.areSameExtensions)(q.identifier,this.extension.identifier)));if(!W.length)throw new Error(d.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...W),this.options.remove)for(const q of W)try{J.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(q)}catch(U){throw new Error(d.localize(6,null,(0,A.toErrorMessage)(U)))}}}}),define(Z[125],ee([0,1,113,16,7,2,13,27,20,99,15,112,134]),function(G,t,A,P,S,k,F,L,u,h,g,p,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let D=class extends k.Disposable{constructor(c,b,v){super();this.environmentService=b,this.logService=v,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,b){this.logService.trace("RequestService#request",c.url);const{proxyUrl:v,strictSSL:m}=this,f={...process.env,...await(0,h.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=c.agent?c.agent:await(0,p.getProxyAgent)(c.url||"",f,{proxyUrl:v,strictSSL:m});return c.agent=o,c.strictSSL=m,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,b)}async getNodeRequest(c){return((0,A.parse)(c.url).protocol==="https:"?await new Promise((m,f)=>{G(["https"],m,f)}):await new Promise((m,f)=>{G(["http"],m,f)})).request}_request(c,b){return new Promise(async(v,m)=>{let f;const o=(0,A.parse)(c.url),s=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,F.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(e.auth=c.user+":"+c.password),f=s(e,n=>{const i=(0,F.isNumber)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...c,url:n.headers.location,followRedirects:i-1},b).then(v,m);else{let r=n;n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,d.createGunzip)())),v({res:n,stream:(0,P.streamToBufferReadableStream)(r)})}}),f.on("error",m),c.timeout&&f.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&f.write(c.data),f.end(),b.onCancellationRequested(()=>{f.abort(),m((0,S.canceled)())})})}async resolveProxy(c){}};D=ue([fe(0,L.IConfigurationService),fe(1,u.INativeEnvironmentService),fe(2,g.ILogService)],D),t.RequestService=D}),define(Z[135],ee([0,1,38,136,32,3,16,28,7,2,9,4,34,8,11,27,111,20,89,118,23,97,124,17,107,108,50,101,52,53,105,15,106,35,42,55,125,116,36,119,56,120,121]),function(G,t,A,P,S,k,F,L,u,h,g,p,d,D,a,c,b,v,m,f,o,s,e,n,i,r,l,y,R,N,E,O,z,$,Q,ie,re,Y,J,W,x,q,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class I extends h.Disposable{constructor(C){super();this.argv=C,(0,P.gracefulify)(A),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[C,T]=await this.initServices();return C.invokeFunction(async j=>{const B=j.get(O.ILogService),_=j.get(n.IFileService),K=j.get(v.INativeEnvironmentService),te=j.get(o.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(K,te,_),(0,k.raceTimeout)((0,x.combinedAppender)(...T).flush(),1e3)})}async initServices(){const C=new R.ServiceCollection,T={_serviceBrand:void 0,...$.default};C.set(Q.IProductService,T);const j=new m.NativeEnvironmentService(this.argv,T);C.set(v.INativeEnvironmentService,j),await Promise.all([j.appSettingsHome.fsPath,j.extensionsPath].map(pe=>pe?a.Promises.mkdir(pe,{recursive:!0}):void 0));const B=(0,O.getLogLevel)(j),_=[];_.push(new z.SpdLogLogger("cli",(0,p.join)(j.logsPath,"cli.log"),!0,B)),B===O.LogLevel.Trace&&_.push(new O.ConsoleLogger(B));const K=this._register(new O.MultiplexLogService(_));C.set(O.ILogService,K);const te=this._register(new i.FileService(K));C.set(n.IFileService,te);const ne=this._register(new r.DiskFileSystemProvider(K));te.registerProvider(g.Schemas.file,ne);const oe=this._register(new b.ConfigurationService(j.settingsResource,te));C.set(c.IConfigurationService,oe),await oe.initialize(),C.set(ie.IRequestService,new l.SyncDescriptor(re.RequestService)),C.set(o.IExtensionManagementService,new l.SyncDescriptor(e.ExtensionManagementService)),C.set(o.IExtensionGalleryService,new l.SyncDescriptor(f.ExtensionGalleryService)),C.set(o.IExtensionManagementCLIService,new l.SyncDescriptor(s.ExtensionManagementCLIService)),C.set(N.ILocalizationsService,new l.SyncDescriptor(E.LocalizationsService));const le=[];if(j.isBuilt&&!j.isExtensionDevelopment&&!j.disableTelemetry&&T.enableTelemetry){T.aiConfig&&T.aiConfig.asimovKey&&le.push(new q.AppInsightsAppender("monacoworkbench",null,T.aiConfig.asimovKey));const{appRoot:pe,extensionsPath:De,installSourcePath:ke}=j,Te={appender:(0,x.combinedAppender)(...le),sendErrorTelemetry:!1,commonProperties:(async()=>{let we;try{const Fe=await a.Promises.readFile((0,p.join)(j.userDataPath,"storage.json"));we=JSON.parse(Fe.toString())[J.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&K.error(Fe)}return(0,Y.resolveCommonProperties)(te,(0,S.release)(),(0,S.hostname)(),process.arch,T.commit,T.version,we,T.msftInternalDomains,ke)})(),piiPaths:[pe,De]};C.set(J.ITelemetryService,new l.SyncDescriptor(W.TelemetryService,[Te]))}else C.set(J.ITelemetryService,x.NullTelemetryService);return[new y.InstantiationService(C),le]}registerErrorHandler(C){(0,u.setUnexpectedErrorHandler)(T=>{const j=(0,L.toErrorMessage)(T,!0);!j||C.error(`[uncaught exception in CLI]: ${j}`)}),process.on("uncaughtException",T=>(0,u.onUnexpectedError)(T)),process.on("unhandledRejection",T=>(0,u.onUnexpectedError)(T))}async doRun(C,T,j){if(this.argv["install-source"])return this.setInstallSource(C,j,this.argv["install-source"]);if(this.argv["list-extensions"])return T.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return T.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return T.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return T.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(C.appRoot,C.extensionsPath))}asExtensionIdOrVSIX(C){return C.map(T=>/\.vsix$/i.test(T)?D.URI.file((0,p.isAbsolute)(T)?T:(0,p.join)((0,d.cwd)(),T)):T)}async setInstallSource(C,T,j){await T.writeFile(D.URI.file(C.installSourcePath),F.VSBuffer.fromString(j.slice(0,30)))}}async function M(w){const C=new I(w);try{await C.run()}finally{C.dispose()}}t.main=M})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89bbd372f459ce72e9c0b60eb3b26b924f64f62d/core/vs/code/node/cliProcessMain.js.map
