/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/product/common/product","vs/editor/common/config/editorOptions","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=me[Y[g]];return e};define(me[54],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,I){if(!L)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=g}),define(me[55],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(n){const k=[];for(let d in n)g.call(n,d)&&k.push(n[d]);return k}e.values=L;function I(n,k){for(let d in n)if(g.call(n,d)&&k({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=I;function C(n,k){const d=Object.create(null);for(const f of n){const u=k(f);let p=d[u];p||(p=d[u]=[]),p.push(f)}return d}e.groupBy=C;function T(n){const k=Object.create(null);return n&&n.forEach((d,f)=>{k[f]=d}),k}e.fromMap=T;function D(n,k){const d=[],f=[];for(let u of n)k.has(u)||d.push(u);for(let u of k)n.has(u)||f.push(u);return{removed:d,added:f}}e.diffSets=D;function y(n,k){const d=[],f=[];for(let[u,p]of n)k.has(u)||d.push(p);for(let[u,p]of k)n.has(u)||f.push(p);return{removed:d,added:f}}e.diffMaps=y;class P{constructor(){this.map=new Map}add(k,d){let f=this.map.get(k);f||(f=new Set,this.map.set(k,f)),f.add(d)}delete(k,d){const f=this.map.get(k);!f||(f.delete(d),f.size===0&&this.map.delete(k))}forEach(k,d){const f=this.map.get(k);!f||f.forEach(d)}}e.SetMap=P}),define(me[56],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(T){return(D,y,P)=>{let n=null,k=null;if(typeof P.value=="function"?(n="value",k=P.value):typeof P.get=="function"&&(n="get",k=P.get),!k)throw new Error("not supported");P[n]=T(k,y)}}e.createDecorator=g;function L(T,D,y){let P=null,n=null;if(typeof y.value=="function"?(P="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",n=y.get),!n)throw new Error("not supported");const k=`$memoize$${D}`;y[P]=function(...d){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[k]}}e.memoize=L;function I(T,D,y){return g((P,n)=>{const k=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...f){this[d]||(this[d]=y?y():void 0),clearTimeout(this[k]),D&&(this[d]=D(this[d],...f),f=[this[d]]),this[k]=setTimeout(()=>{P.apply(this,f),this[d]=y?y():void 0},T)}})}e.debounce=I;function C(T,D,y){return g((P,n)=>{const k=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...p){if(this[d]||(this[d]=y?y():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),D&&(this[d]=D(this[d],...p)),this[u])return;const _=this[f]+T;_<=Date.now()?(this[f]=Date.now(),P.apply(this,[this[d]]),this[d]=y?y():void 0):(this[u]=!0,this[k]=setTimeout(()=>{this[u]=!1,this[f]=Date.now(),P.apply(this,[this[d]]),this[d]=y?y():void 0},_-Date.now()))}})}e.throttle=C}),define(me[16],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function I(v){y(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=I;function C(v){y(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=C;function T(v){if(v instanceof Error){let{name:t,message:r}=v;const o=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:o}}return v}e.transformErrorForSerialization=T;const D="Canceled";function y(v){return v instanceof Error&&v.name===D&&v.message===D}e.isPromiseCanceledError=y;class P extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=P;function n(){const v=new Error(D);return v.name=v.message,v}e.canceled=n;function k(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=k;function d(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=d;function f(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function u(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function p(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=p;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class A extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=A;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function a(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function l(v,t=Object.create(null)){const r=new Error(v);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=l}),define(me[20],ge([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,Q=0){return W[W.length-(1+Q)]}e.tail=L;function I(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=I;function C(W,Q,J=(fe,_e)=>fe===_e){if(W===Q)return!0;if(!W||!Q||W.length!==Q.length)return!1;for(let fe=0,_e=W.length;fe<_e;fe++)if(!J(W[fe],Q[fe]))return!1;return!0}e.equals=C;function T(W,Q,J){let fe=0,_e=W.length-1;for(;fe<=_e;){const ye=(fe+_e)/2|0,Le=J(W[ye],Q);if(Le<0)fe=ye+1;else if(Le>0)_e=ye-1;else return ye}return-(fe+1)}e.binarySearch=T;function D(W,Q){let J=0,fe=W.length;if(fe===0)return 0;for(;J<fe;){const _e=Math.floor((J+fe)/2);Q(W[_e])?fe=_e:J=_e+1}return J}e.findFirstInSorted=D;function y(W,Q,J){if(W=W|0,W>=Q.length)throw new TypeError("invalid index");let fe=Q[Math.floor(Q.length*Math.random())],_e=[],ye=[],Le=[];for(let Be of Q){const xe=J(Be,fe);xe<0?_e.push(Be):xe>0?ye.push(Be):Le.push(Be)}return W<_e.length?y(W,_e,J):W<_e.length+Le.length?Le[0]:y(W-(_e.length+Le.length),ye,J)}e.quickSelect=y;function P(W,Q){const J=[];let fe;for(const _e of W.slice(0).sort(Q))!fe||Q(fe[0],_e)!==0?(fe=[_e],J.push(fe)):fe.push(_e);return J}e.groupBy=P;function n(W,Q,J){const fe=[];function _e(Be,xe,Ke){if(xe===0&&Ke.length===0)return;const z=fe[fe.length-1];z&&z.start+z.deleteCount===Be?(z.deleteCount+=xe,z.toInsert.push(...Ke)):fe.push({start:Be,deleteCount:xe,toInsert:Ke})}let ye=0,Le=0;for(;;){if(ye===W.length){_e(ye,0,Q.slice(Le));break}if(Le===Q.length){_e(ye,W.length-ye,[]);break}const Be=W[ye],xe=Q[Le],Ke=J(Be,xe);Ke===0?(ye+=1,Le+=1):Ke<0?(_e(ye,1,[]),ye+=1):Ke>0&&(_e(ye,0,[xe]),Le+=1)}return fe}e.sortedDiff=n;function k(W,Q,J){const fe=n(W,Q,J),_e=[],ye=[];for(const Le of fe)_e.push(...W.slice(Le.start,Le.start+Le.deleteCount)),ye.push(...Le.toInsert);return{removed:_e,added:ye}}e.delta=k;function d(W,Q,J){if(J===0)return[];const fe=W.slice(0,J).sort(Q);return u(W,Q,fe,J,W.length),fe}e.top=d;function f(W,Q,J,fe,_e){return J===0?Promise.resolve([]):new Promise((ye,Le)=>{(async()=>{const Be=W.length,xe=W.slice(0,J).sort(Q);for(let Ke=J,z=Math.min(J+fe,Be);Ke<Be;Ke=z,z=Math.min(z+fe,Be)){if(Ke>J&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();u(W,Q,xe,Ke,z)}return xe})().then(ye,Le)})}e.topAsync=f;function u(W,Q,J,fe,_e){for(const ye=J.length;fe<_e;fe++){const Le=W[fe];if(Q(Le,J[ye-1])<0){J.pop();const Be=D(J,xe=>Q(Le,xe)<0);J.splice(Be,0,Le)}}}function p(W){return W.filter(Q=>!!Q)}e.coalesce=p;function _(W){let Q=0;for(let J=0;J<W.length;J++)W[J]&&(W[Q]=W[J],Q+=1);W.length=Q}e.coalesceInPlace=_;function A(W,Q,J){W.splice(J,0,W.splice(Q,1)[0])}e.move=A;function E(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=E;function a(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=a;function l(W,Q){if(!Q)return W.filter((fe,_e)=>W.indexOf(fe)===_e);const J=Object.create(null);return W.filter(fe=>{const _e=Q(fe);return J[_e]?!1:(J[_e]=!0,!0)})}e.distinct=l;function v(W){const Q=new Set;return W.filter(J=>Q.has(J)?!1:(Q.add(J),!0))}e.distinctES6=v;function t(W){const Q=Object.create(null);return J=>{const fe=W(J);return Q[fe]?!1:(Q[fe]=!0,!0)}}e.uniqueFilter=t;function r(W,Q){for(let J=W.length-1;J>=0;J--){const fe=W[J];if(Q(fe))return J}return-1}e.lastIndex=r;function o(W,Q){return W.length>0?W[0]:Q}e.firstOrDefault=o;function i(W,Q,J=(fe,_e)=>fe===_e){let fe=0;for(let _e=0,ye=Math.min(W.length,Q.length);_e<ye&&J(W[_e],Q[_e]);_e++)fe++;return fe}e.commonPrefixLength=i;function c(W){return[].concat(...W)}e.flatten=c;function h(W,Q){let J=typeof Q=="number"?W:0;typeof Q=="number"?J=W:(J=0,Q=W);const fe=[];if(J<=Q)for(let _e=J;_e<Q;_e++)fe.push(_e);else for(let _e=J;_e>Q;_e--)fe.push(_e);return fe}e.range=h;function m(W,Q,J){return W.reduce((fe,_e)=>(fe[Q(_e)]=J?J(_e):_e,fe),Object.create(null))}e.index=m;function w(W,Q){return W.push(Q),()=>S(W,Q)}e.insert=w;function S(W,Q){const J=W.indexOf(Q);if(J>-1)return W.splice(J,1),Q}e.remove=S;function s(W,Q,J){const fe=W.slice(0,Q),_e=W.slice(Q);return fe.concat(J,_e)}e.arrayInsert=s;function b(W,Q){let J;if(typeof Q=="number"){let fe=Q;J=()=>{const _e=Math.sin(fe++)*179426549;return _e-Math.floor(_e)}}else J=Math.random;for(let fe=W.length-1;fe>0;fe-=1){const _e=Math.floor(J()*(fe+1)),ye=W[fe];W[fe]=W[_e],W[_e]=ye}}e.shuffle=b;function R(W,Q){const J=W.indexOf(Q);J>-1&&(W.splice(J,1),W.unshift(Q))}e.pushToStart=R;function O(W,Q){const J=W.indexOf(Q);J>-1&&(W.splice(J,1),W.push(Q))}e.pushToEnd=O;function $(W,Q){return Array.isArray(W)?W.map(Q):Q(W)}e.mapArrayOrNot=$;function G(W){return Array.isArray(W)?W:[W]}e.asArray=G;function Z(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=Z;function U(W,Q){for(const J of W){const fe=Q(J);if(fe!==void 0)return fe}}e.mapFind=U;function x(W,Q,J){const fe=H(W,Q),_e=W.length,ye=J.length;W.length=_e+ye;for(let Le=_e-1;Le>=fe;Le--)W[Le+ye]=W[Le];for(let Le=0;Le<ye;Le++)W[Le+fe]=J[Le]}e.insertInto=x;function M(W,Q,J,fe){const _e=H(W,Q),ye=W.splice(_e,J);return x(W,_e,fe),ye}e.splice=M;function H(W,Q){return Q<0?Math.max(Q+W.length,0):Math.min(Q,W.length)}function F(W,Q){let J=Number.MAX_SAFE_INTEGER,fe=0;return W.forEach((_e,ye)=>{const Le=Q(_e);Le<J&&(J=Le,fe=ye)}),fe}e.minIndex=F;function N(W,Q){let J=Number.MIN_SAFE_INTEGER,fe=0;return W.forEach((_e,ye)=>{const Le=Q(_e);Le>J&&(J=Le,fe=ye)}),fe}e.maxIndex=N;class j{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let J=this.firstIdx;for(;J<this.items.length&&Q(this.items[J]);)J++;const fe=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,fe}takeFromEndWhile(Q){let J=this.lastIdx;for(;J>=0&&Q(this.items[J]);)J--;const fe=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,fe}}e.ArrayQueue=j}),define(me[74],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const I=this;let C=!1,T;return function(){return C||(C=!0,T=L.apply(I,arguments)),T}}e.once=g}),define(me[75],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(me[76],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function I(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=I;const C=Object.freeze([]);function T(){return C}L.empty=T;function*D(v){yield v}L.single=D;function y(v){return v||C}L.from=y;function P(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=P;function n(v){return v[Symbol.iterator]().next().value}L.first=n;function k(v,t){for(const r of v)if(t(r))return!0;return!1}L.some=k;function d(v,t){for(const r of v)if(t(r))return r}L.find=d;function*f(v,t){for(const r of v)t(r)&&(yield r)}L.filter=f;function*u(v,t){let r=0;for(const o of v)yield t(o,r++)}L.map=u;function*p(...v){for(const t of v)for(const r of t)yield r}L.concat=p;function*_(v){for(const t of v)for(const r of t)yield r}L.concatNested=_;function A(v,t,r){let o=r;for(const i of v)o=t(o,i);return o}L.reduce=A;function*E(v,t,r=v.length){for(t<0&&(t+=v.length),r<0?r+=v.length:r>v.length&&(r=v.length);t<r;t++)yield v[t]}L.slice=E;function a(v,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,v];const o=v[Symbol.iterator]();for(let i=0;i<t;i++){const c=o.next();if(c.done)return[r,L.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return o}}]}L.consume=a;function l(v,t,r=(o,i)=>o===i){const o=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const c=o.next(),h=i.next();if(c.done!==h.done)return!1;if(c.done)return!0;if(!r(c.value,h.value))return!1}}L.equals=l})(g=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function T(t,r=!1){let o=0,i=t.length,c="",h=0,m=16,w=0;function S(Z){let U=0,x=0;for(;U<Z;){const M=t.charCodeAt(o);if(M>=48&&M<=57)x=x*16+M-48;else if(M>=65&&M<=70)x=x*16+M-65+10;else if(M>=97&&M<=102)x=x*16+M-97+10;else break;o++,U++}return U<Z&&(x=-1),x}function s(Z){o=Z,c="",h=0,m=16,w=0}function b(){const Z=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&P(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&P(t.charCodeAt(o)))for(o++;o<t.length&&P(t.charCodeAt(o));)o++;else return w=3,t.substring(Z,o);let U=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&P(t.charCodeAt(o))){for(o++;o<t.length&&P(t.charCodeAt(o));)o++;U=o}else w=3;return t.substring(Z,U)}function R(){let Z="",U=o;for(;;){if(o>=i){Z+=t.substring(U,o),w=2;break}const x=t.charCodeAt(o);if(x===34){Z+=t.substring(U,o),o++;break}if(x===92){if(Z+=t.substring(U,o),o++,o>=i){w=2;break}switch(t.charCodeAt(o++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const H=S(4);H>=0?Z+=String.fromCharCode(H):w=4;break;default:w=5}U=o;continue}if(x>=0&&x<=31)if(y(x)){Z+=t.substring(U,o),w=2;break}else w=6;o++}return Z}function O(){if(c="",w=0,h=o,o>=i)return h=i,m=17;let Z=t.charCodeAt(o);if(D(Z)){do o++,c+=String.fromCharCode(Z),Z=t.charCodeAt(o);while(D(Z));return m=15}if(y(Z))return o++,c+=String.fromCharCode(Z),Z===13&&t.charCodeAt(o)===10&&(o++,c+=`
`),m=14;switch(Z){case 123:return o++,m=1;case 125:return o++,m=2;case 91:return o++,m=3;case 93:return o++,m=4;case 58:return o++,m=6;case 44:return o++,m=5;case 34:return o++,c=R(),m=10;case 47:const U=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!y(t.charCodeAt(o));)o++;return c=t.substring(U,o),m=12}if(t.charCodeAt(o+1)===42){o+=2;const x=i-1;let M=!1;for(;o<x;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,M=!0;break}o++}return M||(o++,w=1),c=t.substring(U,o),m=13}return c+=String.fromCharCode(Z),o++,m=16;case 45:if(c+=String.fromCharCode(Z),o++,o===i||!P(t.charCodeAt(o)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=b(),m=11;default:for(;o<i&&$(Z);)o++,Z=t.charCodeAt(o);if(h!==o){switch(c=t.substring(h,o),c){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return c+=String.fromCharCode(Z),o++,m=16}}function $(Z){if(D(Z)||y(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let Z;do Z=O();while(Z>=12&&Z<=15);return Z}return{setPosition:s,getPosition:()=>o,scan:r?G:O,getToken:()=>m,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>w}}e.createScanner=T;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function k(t,r){const o=[],i=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function w(S,s,b,R){h.value=S,h.offset=s,h.length=b,h.type=R,h.colonOffset=void 0,c=h}try{a(t,{onObjectBegin:(S,s)=>{if(r<=S)throw i;c=void 0,m=r>S,o.push("")},onObjectProperty:(S,s,b)=>{if(r<s||(w(S,s,b,"property"),o[o.length-1]=S,r<=s+b))throw i},onObjectEnd:(S,s)=>{if(r<=S)throw i;c=void 0,o.pop()},onArrayBegin:(S,s)=>{if(r<=S)throw i;c=void 0,o.push(0)},onArrayEnd:(S,s)=>{if(r<=S)throw i;c=void 0,o.pop()},onLiteralValue:(S,s,b)=>{if(r<s||(w(S,s,b,v(S)),r<=s+b))throw i},onSeparator:(S,s,b)=>{if(r<=s)throw i;if(S===":"&&c&&c.type==="property")c.colonOffset=s,m=!1,c=void 0;else if(S===","){const R=o[o.length-1];typeof R=="number"?o[o.length-1]=R+1:(m=!0,o[o.length-1]=""),c=void 0}}})}catch(S){if(S!==i)throw S}return{path:o,previousNode:c,isAtPropertyKey:m,matches:S=>{let s=0;for(let b=0;s<S.length&&b<o.length;b++)if(S[s]===o[b]||S[s]==="*")s++;else if(S[s]!=="**")return!1;return s===S.length}}}e.getLocation=k;function d(t,r=[],o=C.DEFAULT){let i=null,c=[];const h=[];function m(S){Array.isArray(c)?c.push(S):i!==null&&(c[i]=S)}return a(t,{onObjectBegin:()=>{const S={};m(S),h.push(c),c=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const S=[];m(S),h.push(c),c=S,i=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:m,onError:(S,s,b)=>{r.push({error:S,offset:s,length:b})}},o),c[0]}e.parse=d;function f(t,r=[],o=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function h(S){return i.children.push(S),S}a(t,{onObjectBegin:S=>{i=h({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,s,b)=>{i=h({type:"property",offset:s,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:s,length:b,parent:i})},onObjectEnd:(S,s)=>{i.length=S+s-i.offset,i=i.parent,c(S+s)},onArrayBegin:(S,s)=>{i=h({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,s)=>{i.length=S+s-i.offset,i=i.parent,c(S+s)},onLiteralValue:(S,s,b)=>{h({type:v(S),offset:s,length:b,parent:i,value:S}),c(s+b)},onSeparator:(S,s,b)=>{i.type==="property"&&(S===":"?i.colonOffset=s:S===","&&c(s))},onError:(S,s,b)=>{r.push({error:S,offset:s,length:b})}},o);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=f;function u(t,r){if(!t)return;let o=t;for(let i of r)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let c=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===i){o=h.children[1],c=!0;break}if(!c)return}else{const c=i;if(o.type!=="array"||c<0||!Array.isArray(o.children)||c>=o.children.length)return;o=o.children[c]}return o}e.findNodeAtLocation=u;function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=p;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let o of t.children){const i=o.children[1];i&&(r[o.children[0].value]=_(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function A(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=A;function E(t,r,o=!1){if(A(t,r,o)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const h=E(i[c],r,o);if(h)return h}return t}}e.findNodeAtOffset=E;function a(t,r,o=C.DEFAULT){const i=T(t,!1);function c(J){return J?()=>J(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(J){return J?fe=>J(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const m=c(r.onObjectBegin),w=h(r.onObjectProperty),S=c(r.onObjectEnd),s=c(r.onArrayBegin),b=c(r.onArrayEnd),R=h(r.onLiteralValue),O=h(r.onSeparator),$=c(r.onComment),G=h(r.onError),Z=o&&o.disallowComments,U=o&&o.allowTrailingComma;function x(){for(;;){const J=i.scan();switch(i.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:Z||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(J){case 12:case 13:Z?M(10):$();break;case 16:M(1);break;case 15:case 14:break;default:return J}}}function M(J,fe=[],_e=[]){if(G(J),fe.length+_e.length>0){let ye=i.getToken();for(;ye!==17;){if(fe.indexOf(ye)!==-1){x();break}else if(_e.indexOf(ye)!==-1)break;ye=x()}}}function H(J){const fe=i.getTokenValue();return J?R(fe):w(fe),x(),!0}function F(){switch(i.getToken()){case 11:let J=0;try{J=JSON.parse(i.getTokenValue()),typeof J!="number"&&(M(2),J=0)}catch(fe){M(2)}R(J);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return x(),!0}function N(){return i.getToken()!==10?(M(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(O(":"),x(),Q()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function j(){m(),x();let J=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(J||M(4,[],[]),O(","),x(),i.getToken()===2&&U)break}else J&&M(6,[],[]);N()||M(4,[],[2,5]),J=!0}return S(),i.getToken()!==2?M(7,[2],[]):x(),!0}function W(){s(),x();let J=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(J||M(4,[],[]),O(","),x(),i.getToken()===4&&U)break}else J&&M(6,[],[]);Q()||M(4,[],[4,5]),J=!0}return b(),i.getToken()!==4?M(8,[4],[]):x(),!0}function Q(){switch(i.getToken()){case 3:return W();case 1:return j();case 10:return H(!0);default:return F()}}return x(),i.getToken()===17?o.allowEmptyContent?!0:(M(4,[],[]),!1):Q()?(i.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=a;function l(t,r){let o=T(t),i=[],c,h=0,m;do switch(m=o.getPosition(),c=o.scan(),c){case 12:case 13:case 17:h!==m&&i.push(t.substring(h,m)),r!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,r)),h=o.getPosition();break}while(c!==17);return i.join("")}e.stripComments=l;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(me[138],ge([0,1,57]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(y,P,n){let k,d,f,u,p;if(P){for(u=P.offset,p=u+P.length,f=u;f>0&&!D(y,f-1);)f--;let h=p;for(;h<y.length&&!D(y,h);)h++;d=y.substring(f,h),k=C(d,n)}else d=y,k=0,f=0,u=0,p=y.length;const _=T(n,y);let A=!1,E=0,a;n.insertSpaces?a=I(" ",n.tabSize||4):a="	";const l=(0,g.createScanner)(d,!1);let v=!1;function t(){return _+I(a,k+E)}function r(){let h=l.scan();for(A=!1;h===15||h===14;)A=A||h===14,h=l.scan();return v=h===16||l.getTokenError()!==0,h}const o=[];function i(h,m,w){!v&&m<p&&w>u&&y.substring(m,w)!==h&&o.push({offset:m,length:w-m,content:h})}let c=r();if(c!==17){const h=l.getTokenOffset()+f,m=I(a,k);i(m,f,h)}for(;c!==17;){let h=l.getTokenOffset()+l.getTokenLength()+f,m=r(),w="";for(;!A&&(m===12||m===13);){const s=l.getTokenOffset()+f;i(" ",h,s),h=l.getTokenOffset()+l.getTokenLength()+f,w=m===12?t():"",m=r()}if(m===2)c!==1&&(E--,w=t());else if(m===4)c!==3&&(E--,w=t());else{switch(c){case 3:case 1:E++,w=t();break;case 5:case 12:w=t();break;case 13:A?w=t():w=" ";break;case 6:w=" ";break;case 10:if(m===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?w=" ":m!==5&&m!==17&&(v=!0);break;case 16:v=!0;break}A&&(m===12||m===13)&&(w=t())}const S=l.getTokenOffset()+f;i(w,h,S),c=m}return o}e.format=L;function I(y,P){let n="";for(let k=0;k<P;k++)n+=y;return n}function C(y,P){let n=0,k=0;const d=P.tabSize||4;for(;n<y.length;){const f=y.charAt(n);if(f===" ")k++;else if(f==="	")k+=d;else break;n++}return Math.floor(k/d)}function T(y,P){for(let n=0;n<P.length;n++){const k=P.charAt(n);if(k==="\r")return n+1<P.length&&P.charAt(n+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=T;function D(y,P){return`\r
`.indexOf(y.charAt(P))!==-1}e.isEOL=D}),define(me[139],ge([0,1,57,138]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(P,n,k){return C(P,n,void 0,k)}e.removeProperty=I;function C(P,n,k,d,f){const u=n.slice(),p=[],_=(0,g.parseTree)(P,p);let A,E;for(;u.length>0&&(E=u.pop(),A=(0,g.findNodeAtLocation)(_,u),A===void 0&&k!==void 0);)typeof E=="string"?k={[E]:k}:k=[k];if(A)if(A.type==="object"&&typeof E=="string"&&Array.isArray(A.children)){const a=(0,g.findNodeAtLocation)(A,[E]);if(a!==void 0)if(k===void 0){if(!a.parent)throw new Error("Malformed AST");const l=A.children.indexOf(a.parent);let v,t=a.parent.offset+a.parent.length;if(l>0){const r=A.children[l-1];v=r.offset+r.length}else v=A.offset+1,A.children.length>1&&(t=A.children[1].offset);return T(P,{offset:v,length:t-v,content:""},d)}else return T(P,{offset:a.offset,length:a.length,content:JSON.stringify(k)},d);else{if(k===void 0)return[];const l=`${JSON.stringify(E)}: ${JSON.stringify(k)}`,v=f?f(A.children.map(r=>r.children[0].value)):A.children.length;let t;if(v>0){const r=A.children[v-1];t={offset:r.offset+r.length,length:0,content:","+l}}else A.children.length===0?t={offset:A.offset+1,length:0,content:l}:t={offset:A.offset+1,length:0,content:l+","};return T(P,t,d)}}else if(A.type==="array"&&typeof E=="number"&&Array.isArray(A.children))if(k!==void 0){const a=`${JSON.stringify(k)}`;let l;if(A.children.length===0||E===0)l={offset:A.offset+1,length:0,content:A.children.length===0?a:a+","};else{const v=E===-1||E>A.children.length?A.children.length:E,t=A.children[v-1];l={offset:t.offset+t.length,length:0,content:","+a}}return T(P,l,d)}else{const a=E,l=A.children[a];let v;if(A.children.length===1)v={offset:A.offset+1,length:A.length-2,content:""};else if(A.children.length-1===a){const t=A.children[a-1],r=t.offset+t.length,o=A.offset+A.length;v={offset:r,length:o-2-r,content:""}}else v={offset:l.offset,length:A.children[a+1].offset-l.offset,content:""};return T(P,v,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${A.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return T(P,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(k)},d)}}e.setProperty=C;function T(P,n,k){let d=D(P,n),f=n.offset,u=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;f>0&&!(0,L.isEOL)(d,f-1);)f--;for(;u<d.length&&!(0,L.isEOL)(d,u);)u++}const p=(0,L.format)(d,{offset:f,length:u-f},k);for(let A=p.length-1;A>=0;A--){const E=p[A];d=D(d,E),f=Math.min(f,E.offset),u=Math.max(u,E.offset+E.length),u+=E.content.length-E.length}const _=P.length-(d.length-u)-f;return[{offset:f,length:_,content:d.substring(f,u)}]}e.withFormatting=T;function D(P,n){return P.substring(0,n.offset)+n.content+P.substring(n.offset+n.length)}e.applyEdit=D;function y(P,n){let k=n.slice(0).sort((f,u)=>{const p=f.offset-u.offset;return p===0?f.length-u.length:p}),d=P.length;for(let f=k.length-1;f>=0;f--){let u=k[f];if(u.offset+u.length<=d)P=D(P,u);else throw new Error("Overlapping edit");d=u.offset}return P}e.applyEdits=y}),define(me[140],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new g(()=>I(this.getValue()))}}e.Lazy=g}),define(me[6],ge([0,1,74,76]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let C=null;function T(o){C=o}if(e.setDisposableTracker=T,I){const o="__is_disposable_tracked__";T(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[o]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==E.None)try{i[o]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[o]=!0}catch{}}markAsSingleton(i){}})}function D(o){return C?.trackDisposable(o),o}function y(o){C?.markAsDisposed(o)}function P(o,i){C?.setParent(o,i)}function n(o,i){if(!!C)for(const c of o)C.setParent(c,i)}function k(o){return C?.markAsSingleton(o),o}e.markAsSingleton=k;class d extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=d;function f(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=f;function u(o){if(L.Iterable.is(o)){let i=[];for(const c of o)if(c)try{c.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new d(i);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=u;function p(...o){const i=_(()=>u(o));return n(o,i),i}e.combinedDisposable=p;function _(o){const i=D({dispose:(0,g.once)(()=>{y(i),o()})});return i}e.toDisposable=_;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return P(i,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new A,D(this),P(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&P(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&P(i,null),i}}e.MutableDisposable=a;class l{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class v{constructor(){this.references=new Map}acquire(i,...c){let h=this.references.get(i);h||(h={counter:0,object:this.createReferencedObject(i,...c)},this.references.set(i,h));const{object:m}=h,w=(0,g.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(i,h.object),this.references.delete(i))});return h.counter++,{object:m,dispose:w}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...c){const h=this.referenceCollection.acquire(i,...c);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(m){throw h.dispose(),m}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(me[95],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(C){this.element=C,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let C=this._first;for(;C!==g.Undefined;){const T=C.next;C.prev=g.Undefined,C.next=g.Undefined,C=T}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,T){const D=new g(C);if(this._first===g.Undefined)this._first=D,this._last=D;else if(T){const P=this._last;this._last=D,D.prev=P,P.next=D}else{const P=this._first;this._first=D,D.next=P,P.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==g.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==g.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==g.Undefined&&C.next!==g.Undefined){const T=C.prev;T.next=C.next,C.next.prev=T}else C.prev===g.Undefined&&C.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):C.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):C.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==g.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,Se){for(var Ce=0;Ce<Se.length;Ce++){var ne=Se[Ce];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Re,ne.key,ne)}}function e(Re,Se,Ce){return Se&&Y(Re.prototype,Se),Ce&&Y(Re,Ce),Re}function g(Re,Se){if(!!Re){if(typeof Re=="string")return L(Re,Se);var Ce=Object.prototype.toString.call(Re).slice(8,-1);if(Ce==="Object"&&Re.constructor&&(Ce=Re.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Re);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return L(Re,Se)}}function L(Re,Se){(Se==null||Se>Re.length)&&(Se=Re.length);for(var Ce=0,ne=new Array(Se);Ce<Se;Ce++)ne[Ce]=Re[Ce];return ne}function I(Re,Se){var Ce=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Ce)return(Ce=Ce.call(Re)).next.bind(Ce);if(Array.isArray(Re)||(Ce=g(Re))||Se&&Re&&typeof Re.length=="number"){Ce&&(Re=Ce);var ne=0;return function(){return ne>=Re.length?{done:!0}:{done:!1,value:Re[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function D(Re){C.exports.defaults=Re}C.exports={defaults:T(),getDefaults:T,changeDefaults:D};var y=/[&<>"']/,P=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(Se){return d[Se]};function u(Re,Se){if(Se){if(y.test(Re))return Re.replace(P,f)}else if(n.test(Re))return Re.replace(k,f);return Re}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Re){return Re.replace(p,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var A=/(^|[^\[])\^/g;function E(Re,Se){Re=Re.source||Re,Se=Se||"";var Ce={replace:function(de,be){return be=be.source||be,be=be.replace(A,"$1"),Re=Re.replace(de,be),Ce},getRegex:function(){return new RegExp(Re,Se)}};return Ce}var a=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,Se,Ce){if(Re){var ne;try{ne=decodeURIComponent(_(Ce)).replace(a,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Se&&!l.test(Ce)&&(Ce=c(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(de){return null}return Ce}var t={},r=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Re,Se){t[" "+Re]||(r.test(Re)?t[" "+Re]=Re+"/":t[" "+Re]=S(Re,"/",!0)),Re=t[" "+Re];var Ce=Re.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:Re.replace(o,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:Re.replace(i,"$1")+Se:Re+Se}var h={exec:function(){}};function m(Re){for(var Se=1,Ce,ne;Se<arguments.length;Se++){Ce=arguments[Se];for(ne in Ce)Object.prototype.hasOwnProperty.call(Ce,ne)&&(Re[ne]=Ce[ne])}return Re}function w(Re,Se){var Ce=Re.replace(/\|/g,function(be,we,Fe){for(var qe=!1,He=we;--He>=0&&Fe[He]==="\\";)qe=!qe;return qe?"|":" |"}),ne=Ce.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>Se)ne.splice(Se);else for(;ne.length<Se;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function S(Re,Se,Ce){var ne=Re.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Re.charAt(ne-de-1);if(be===Se&&!Ce)de++;else if(be!==Se&&Ce)de++;else break}return Re.substr(0,ne-de)}function s(Re,Se){if(Re.indexOf(Se[1])===-1)return-1;for(var Ce=Re.length,ne=0,de=0;de<Ce;de++)if(Re[de]==="\\")de++;else if(Re[de]===Se[0])ne++;else if(Re[de]===Se[1]&&(ne--,ne<0))return de;return-1}function b(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=Re),Se>>=1,Re+=Re;return Ce+Re}var O={escape:u,unescape:_,edit:E,cleanUrl:v,resolveUrl:c,noopTest:h,merge:m,splitCells:w,rtrim:S,findClosingBracket:s,checkSanitizeDeprecation:b,repeatString:R},$=C.exports.defaults,G=O.rtrim,Z=O.splitCells,U=O.escape,x=O.findClosingBracket;function M(Re,Se,Ce,ne){var de=Se.href,be=Se.title?U(Se.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");return Re[0].charAt(0)!=="!"?(ne.state.inLink=!0,{type:"link",raw:Ce,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])}):{type:"image",raw:Ce,href:de,title:be,text:U(we)}}function H(Re,Se){var Ce=Re.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var ne=Ce[1];return Se.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var F=function(){function Re(Ce){this.options=Ce||$}var Se=Re.prototype;return Se.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Se.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:G(be,`
`)}}},Se.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=H(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},Se.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=G(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},Se.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},Se.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Se.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Fe,qe,He,Je,nt,ae,Ee,ce,q=de[1].trim(),Te=q.length>1,Pe={type:"list",raw:"",ordered:Te,start:Te?+q.slice(0,-1):"",loose:!1,items:[]};q=Te?"\\d{1,9}\\"+q.slice(-1):"\\"+q,this.options.pedantic&&(q=Te?q:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+q+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ye.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(qe=2,ce=Ee[0].trimLeft()):(qe=de[2].search(/[^ ]/),qe=de[1].length+(qe>4?1:qe),ce=Ee[0].slice(qe-de[1].length)),Je=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Pe.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<Ee.length;He++){if(ae=Ee[He],this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(ae)){be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}if(!Je){ae.trim()||(Je=!0),ae.search(/[^ ]/)>=qe?ce+=`
`+ae.slice(qe):ce+=`
`+ae;continue}if(ae.search(/[^ ]/)>=qe||!ae.trim()){ce+=`
`+ae.slice(qe);continue}else{be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}}Pe.loose||(nt?Pe.loose=!0:/\n *\n *$/.test(be)&&(nt=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Fe=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:ce}),Pe.raw+=be,ne=ne.slice(be.length)}Pe.items[Pe.items.length-1].raw=be.trimRight(),Pe.items[Pe.items.length-1].text=ce.trimRight(),Pe.raw=Pe.raw.trimRight();var at=Pe.items.length;for(He=0;He<at;He++)this.lexer.state.top=!1,Pe.items[He].tokens=this.lexer.blockTokens(Pe.items[He].text,[]),Pe.items[He].tokens.some(function(wt){return wt.type==="space"})&&(Pe.loose=!0,Pe.items[He].loose=!0);return Pe}},Se.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Se.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},Se.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:Z(de[1]).map(function(nt){return{text:nt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Fe,qe,He,Je;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=Z(be.rows[Fe],be.header.length).map(function(nt){return{text:nt}});for(we=be.header.length,qe=0;qe<we;qe++)be.header[qe].tokens=[],this.lexer.inlineTokens(be.header[qe].text,be.header[qe].tokens);for(we=be.rows.length,qe=0;qe<we;qe++)for(Je=be.rows[qe],He=0;He<Je.length;He++)Je[He].tokens=[],this.lexer.inlineTokens(Je[He].text,Je[He].tokens);return be}}},Se.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Se.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Se.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Se.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:U(de[1])}},Se.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]):de[0]}},Se.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=G(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=x(de[2],"()");if(Fe>-1){var qe=de[0].indexOf("!")===0?5:4,He=qe+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Je=de[2],nt="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Je);ae&&(Je=ae[1],nt=ae[3])}else nt=de[3]?de[3].slice(1,-1):"";return Je=Je.trim(),/^</.test(Je)&&(this.options.pedantic&&!/>$/.test(be)?Je=Je.slice(1):Je=Je.slice(1,-1)),M(de,{href:Je&&Je.replace(this.rules.inline._escapes,"$1"),title:nt&&nt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Se.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return M(be,we,be[0],this.lexer)}},Se.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var qe=we[0].length-1,He,Je,nt=qe,ae=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+qe);(we=Ee.exec(de))!=null;)if(He=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!He){if(Je=He.length,we[3]||we[4]){nt+=Je;continue}else if((we[5]||we[6])&&qe%3&&!((qe+Je)%3)){ae+=Je;continue}if(nt-=Je,!(nt>0)){if(Je=Math.min(Je,Je+nt+ae),Math.min(qe,Je)%2){var ce=ne.slice(1,qe+we.index+Je);return{type:"em",raw:ne.slice(0,qe+we.index+Je+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var q=ne.slice(2,qe+we.index+Je-1);return{type:"strong",raw:ne.slice(0,qe+we.index+Je+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}}}}},Se.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=U(be,!0),{type:"codespan",raw:de[0],text:be}}},Se.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},Se.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Se.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Fe;return be[2]==="@"?(we=U(this.options.mangle?de(be[1]):be[1]),Fe="mailto:"+we):(we=U(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},Se.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Fe;if(be[2]==="@")we=U(this.options.mangle?de(be[0]):be[0]),Fe="mailto:"+we;else{var qe;do qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(qe!==be[0]);we=U(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},Se.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):U(be[0]):be[0]:we=U(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),N=O.noopTest,j=O.edit,W=O.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=j(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=j(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=j(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=j(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=j(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=j(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=W({},Q),Q.gfm=W({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=j(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=W({},Q.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:j(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=j(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=j(Q._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=j(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=j(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=j(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=j(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=j(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=j(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=j(J.reflink).replace("label",J._label).getRegex(),J.reflinkSearch=j(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=W({},J),J.pedantic=W({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=W({},J.normal,{escape:j(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),J.gfm.url=j(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=W({},J.gfm,{br:j(J.br).replace("{2,}","*").getRegex(),text:j(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:Q,inline:J},_e=F,ye=C.exports.defaults,Le=fe.block,Be=fe.inline,xe=O.repeatString;function Ke(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Re){var Se="",Ce,ne,de=Re.length;for(Ce=0;Ce<de;Ce++)ne=Re.charCodeAt(Ce),Math.random()>.5&&(ne="x"+ne.toString(16)),Se+="&#"+ne+";";return Se}var ee=function(){function Re(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||ye,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Le.normal,inline:Be.normal};this.options.pedantic?(ne.block=Le.pedantic,ne.inline=Be.pedantic):this.options.gfm&&(ne.block=Le.gfm,this.options.breaks?ne.inline=Be.breaks:ne.inline=Be.gfm),this.tokenizer.rules=ne}Re.lex=function(ne,de){var be=new Re(de);return be.lex(ne)},Re.lexInline=function(ne,de){var be=new Re(de);return be.inlineTokens(ne)};var Se=Re.prototype;return Se.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Se.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,qe,He;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(nt){return(we=nt.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(qe=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var nt=Infinity,ae=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ce){Ee=ce.call({lexer:this},ae),typeof Ee=="number"&&Ee>=0&&(nt=Math.min(nt,Ee))}),nt<Infinity&&nt>=0&&(qe=ne.substring(0,nt+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Fe=de[de.length-1],He&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we),He=qe.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(ne){var Je="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Je);break}else throw new Error(Je)}}return this.state.top=!0,de},Se.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},Se.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Fe,qe,He=ne,Je,nt,ae;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Je=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)Ee.includes(Je[0].slice(Je[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Je.index)+"["+xe("a",Je[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Je=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Je.index)+"["+xe("a",Je[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Je=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Je.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(nt||(ae=""),nt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(we=q.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,He,ae)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,z)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,z))){ne=ne.substring(we.raw.length),de.push(we);continue}if(qe=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var q=Infinity,Te=ne.slice(1),Pe=void 0;be.options.extensions.startInline.forEach(function(Ye){Pe=Ye.call({lexer:this},Te),typeof Pe=="number"&&Pe>=0&&(q=Math.min(q,Pe))}),q<Infinity&&q>=0&&(qe=ne.substring(0,q+1))}(),we=this.tokenizer.inlineText(qe,Ke)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(ae=we.raw.slice(-1)),nt=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(ne){var ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:Le,inline:Be}}}]),Re}(),re=C.exports.defaults,le=O.cleanUrl,X=O.escape,oe=function(){function Re(Ce){this.options=Ce||re}var Se=Re.prototype;return Se.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(be=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+X(we,!0)+'">'+(be?ne:X(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:X(ne,!0))+`</code></pre>
`},Se.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Se.html=function(ne){return ne},Se.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ne,de,be){var we=de?"ol":"ul",Fe=de&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},Se.listitem=function(ne){return"<li>"+ne+`</li>
`},Se.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ne){return"<p>"+ne+`</p>
`},Se.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},Se.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Se.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},Se.strong=function(ne){return"<strong>"+ne+"</strong>"},Se.em=function(ne){return"<em>"+ne+"</em>"},Se.codespan=function(ne){return"<code>"+ne+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ne){return"<del>"+ne+"</del>"},Se.link=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+X(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},Se.image=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},Se.text=function(ne){return ne},Re}(),ve=function(){function Re(){}var Se=Re.prototype;return Se.strong=function(ne){return ne},Se.em=function(ne){return ne},Se.codespan=function(ne){return ne},Se.del=function(ne){return ne},Se.html=function(ne){return ne},Se.text=function(ne){return ne},Se.link=function(ne,de,be){return""+be},Se.image=function(ne,de,be){return""+be},Se.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var Se=Re.prototype;return Se.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},Se.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Re}(),ze=oe,Qe=ve,et=Me,ke=C.exports.defaults,ct=O.unescape,K=function(){function Re(Ce){this.options=Ce||ke,this.options.renderer=this.options.renderer||new ze,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Qe,this.slugger=new et}Re.parse=function(ne,de){var be=new Re(de);return be.parse(ne)},Re.parseInline=function(ne,de){var be=new Re(de);return be.parseInline(ne)};var Se=Re.prototype;return Se.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Fe,qe,He,Je,nt,ae,Ee,ce,q,Te,Pe,Ye,Xe,at,wt,_t,ht,gt,ft=ne.length;for(we=0;we<ft;we++){if(q=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(gt=this.options.extensions.renderers[q.type].call({parser:this},q),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){be+=gt||"";continue}switch(q.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(q.tokens),q.depth,ct(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(Ee="",ae="",He=q.header.length,Fe=0;Fe<He;Fe++)ae+=this.renderer.tablecell(this.parseInline(q.header[Fe].tokens),{header:!0,align:q.align[Fe]});for(Ee+=this.renderer.tablerow(ae),ce="",He=q.rows.length,Fe=0;Fe<He;Fe++){for(nt=q.rows[Fe],ae="",Je=nt.length,qe=0;qe<Je;qe++)ae+=this.renderer.tablecell(this.parseInline(nt[qe].tokens),{header:!1,align:q.align[qe]});ce+=this.renderer.tablerow(ae)}be+=this.renderer.table(Ee,ce);continue}case"blockquote":{ce=this.parse(q.tokens),be+=this.renderer.blockquote(ce);continue}case"list":{for(Te=q.ordered,Pe=q.start,Ye=q.loose,He=q.items.length,ce="",Fe=0;Fe<He;Fe++)at=q.items[Fe],wt=at.checked,_t=at.task,Xe="",at.task&&(ht=this.renderer.checkbox(wt),Ye?at.tokens.length>0&&at.tokens[0].type==="paragraph"?(at.tokens[0].text=ht+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=ht+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:ht}):Xe+=ht),Xe+=this.parse(at.tokens,Ye),ce+=this.renderer.listitem(Xe,_t,wt);be+=this.renderer.list(ce,Te,Pe);continue}case"html":{be+=this.renderer.html(q.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(ce=q.tokens?this.parseInline(q.tokens):q.text;we+1<ft&&ne[we+1].type==="text";)q=ne[++we],ce+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);be+=de?this.renderer.paragraph(ce):ce;continue}default:{var Tt='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Tt);return}else throw new Error(Tt)}}}return be},Se.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Fe,qe,He=ne.length;for(we=0;we<He;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=qe||"";continue}switch(Fe.type){case"escape":{be+=de.text(Fe.text);break}case"html":{be+=de.html(Fe.text);break}case"link":{be+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{be+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{be+=de.codespan(Fe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{be+=de.text(Fe.text);break}default:{var Je='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return be},Re}(),te=ee,pe=K,Ve=F,tt=oe,st=ve,lt=Me,vt=O.merge,Dt=O.checkSanitizeDeprecation,ue=O.escape,Ie=C.exports.getDefaults,Ne=C.exports.changeDefaults,Ge=C.exports.defaults;function We(Re,Se,Ce){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=vt({},We.defaults,Se||{}),Dt(Se),Ce){var ne=Se.highlight,de;try{de=te.lex(Re,Se)}catch(qe){return Ce(qe)}var be=function(He){var Je;if(!He)try{Se.walkTokens&&We.walkTokens(de,Se.walkTokens),Je=pe.parse(de,Se)}catch(nt){He=nt}return Se.highlight=ne,He?Ce(He):Ce(null,Je)};if(!ne||ne.length<3||(delete Se.highlight,!de.length))return be();var we=0;We.walkTokens(de,function(qe){qe.type==="code"&&(we++,setTimeout(function(){ne(qe.text,qe.lang,function(He,Je){if(He)return be(He);Je!=null&&Je!==qe.text&&(qe.text=Je,qe.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=te.lex(Re,Se);return Se.walkTokens&&We.walkTokens(Fe,Se.walkTokens),pe.parse(Fe,Se)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ue(qe.message+"",!0)+"</pre>";throw qe}}We.options=We.setOptions=function(Re){return vt(We.defaults,Re),Ne(We.defaults),We},We.getDefaults=Ie,We.defaults=Ge,We.use=function(){for(var Re=this,Se=arguments.length,Ce=new Array(Se),ne=0;ne<Se;ne++)Ce[ne]=arguments[ne];var de=vt.apply(void 0,[{}].concat(Ce)),be=We.defaults.extensions||{renderers:{},childTokens:{}},we;Ce.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Je=be.renderers?be.renderers[He.name]:null;Je?be.renderers[He.name]=function(){for(var nt=arguments.length,ae=new Array(nt),Ee=0;Ee<nt;Ee++)ae[Ee]=arguments[Ee];var ce=He.renderer.apply(this,ae);return ce===!1&&(ce=Je.apply(this,ae)),ce}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Fe.renderer&&function(){var He=We.defaults.renderer||new tt,Je=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Te=new Array(q),Pe=0;Pe<q;Pe++)Te[Pe]=arguments[Pe];var Ye=Fe.renderer[Ee].apply(He,Te);return Ye===!1&&(Ye=ce.apply(He,Te)),Ye}};for(var nt in Fe.renderer)Je(nt);de.renderer=He}(),Fe.tokenizer&&function(){var He=We.defaults.tokenizer||new Ve,Je=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Te=new Array(q),Pe=0;Pe<q;Pe++)Te[Pe]=arguments[Pe];var Ye=Fe.tokenizer[Ee].apply(He,Te);return Ye===!1&&(Ye=ce.apply(He,Te)),Ye}};for(var nt in Fe.tokenizer)Je(nt);de.tokenizer=He}(),Fe.walkTokens){var qe=We.defaults.walkTokens;de.walkTokens=function(He){Fe.walkTokens.call(Re,He),qe&&qe(He)}}we&&(de.extensions=be),We.setOptions(de)})},We.walkTokens=function(Re,Se){for(var Ce=function(){var we=de.value;switch(Se(we),we.type){case"table":{for(var Fe=I(we.header),qe;!(qe=Fe()).done;){var He=qe.value;We.walkTokens(He.tokens,Se)}for(var Je=I(we.rows),nt;!(nt=Je()).done;)for(var ae=nt.value,Ee=I(ae),ce;!(ce=Ee()).done;){var q=ce.value;We.walkTokens(q.tokens,Se)}break}case"list":{We.walkTokens(we.items,Se);break}default:We.defaults.extensions&&We.defaults.extensions.childTokens&&We.defaults.extensions.childTokens[we.type]?We.defaults.extensions.childTokens[we.type].forEach(function(Te){We.walkTokens(we[Te],Se)}):we.tokens&&We.walkTokens(we.tokens,Se)}},ne=I(Re),de;!(de=ne()).done;)Ce()},We.parseInline=function(Re,Se){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Se=vt({},We.defaults,Se||{}),Dt(Se);try{var Ce=te.lexInline(Re,Se);return Se.walkTokens&&We.walkTokens(Ce,Se.walkTokens),pe.parseInline(Ce,Se)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ue(ne.message+"",!0)+"</pre>";throw ne}},We.Parser=pe,We.parser=pe.parse,We.Renderer=tt,We.TextRenderer=st,We.Lexer=te,We.lexer=te.lex,We.Tokenizer=Ve,We.Slugger=lt,We.parse=We;var ot=We;return ot}),define(me[77],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(T,D,y){return Math.min(Math.max(T,D),y)}e.clamp=g;function L(T,D){return(D+T%D)%D}e.rot=L;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class C{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(I){const C=[];typeof I=="number"&&C.push("code/timeOrigin",I);function T(y){C.push(y,Date.now())}function D(){const y=[];for(let P=0;P<C.length;P+=2)y.push({name:C[P],startTime:C[P+1]});return y}return{mark:T,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(I+T.startTime)});return C}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(me[11],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,I=!1,C=!1,T=!1,D=!1,y=!1,P=!1,n,k=g,d,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const p=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=p&&u?.sandboxed,typeof navigator=="object"&&!p)f=navigator.userAgent,L=f.indexOf("Windows")>=0,I=f.indexOf("Macintosh")>=0,P=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=f.indexOf("Linux")>=0,y=!0,n=navigator.language,k=n;else if(typeof u=="object"){L=u.platform==="win32",I=u.platform==="darwin",C=u.platform==="linux",T=C&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=g,k=g;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const i=JSON.parse(o),c=i.availableLanguages["*"];n=i.locale,k=c||g,d=i._translationsConfigFile}catch(i){}D=!0}else console.error("Unable to resolve platform.");var _;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function A(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=A;let E=0;I?E=1:L?E=3:C&&(E=2),e.isWindows=L,e.isMacintosh=I,e.isLinux=C,e.isLinuxSnap=T,e.isNative=D,e.isWeb=y,e.isIOS=P,e.platform=E,e.userAgent=f,e.language=k;var a;(function(o){function i(){return e.language}o.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function h(){return e.language==="en"}o.isDefault=h})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let w=0,S=c.length;w<S;w++){const s=c[w];if(s.id===m.data.vscodeSetImmediateId){c.splice(w,1),s.callback();return}}});let h=0;return m=>{const w=++h;c.push({id:w,callback:m}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const i=Promise.resolve();return c=>i.then(c)}();var l;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||P?2:L?1:3;let v=!0,t=!1;function r(){if(!t){t=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,v=new Uint16Array(o.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=r}),define(me[38],ge([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const I=g.globals.vscode.process;L={get platform(){return I.platform},get env(){return I.env},cwd(){return I.cwd()},nextTick(C){return(0,g.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(I){return(0,g.setImmediate)(I)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(me[8],ge([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,I=97,C=90,T=122,D=46,y=47,P=92,n=58,k=63;class d extends Error{constructor(l,v,t){let r;typeof v=="string"&&v.indexOf("not ")===0?(r="must not be",v=v.replace(/^not /,"")):r="must be";const o=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${o} ${r} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function f(a,l){if(typeof a!="string")throw new d(l,"string",a)}function u(a){return a===y||a===P}function p(a){return a===y}function _(a){return a>=L&&a<=C||a>=I&&a<=T}function A(a,l,v,t){let r="",o=0,i=-1,c=0,h=0;for(let m=0;m<=a.length;++m){if(m<a.length)h=a.charCodeAt(m);else{if(t(h))break;h=y}if(t(h)){if(!(i===m-1||c===1))if(c===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==D||r.charCodeAt(r.length-2)!==D){if(r.length>2){const w=r.lastIndexOf(v);w===-1?(r="",o=0):(r=r.slice(0,w),o=r.length-1-r.lastIndexOf(v)),i=m,c=0;continue}else if(r.length!==0){r="",o=0,i=m,c=0;continue}}l&&(r+=r.length>0?`${v}..`:"..",o=2)}else r.length>0?r+=`${v}${a.slice(i+1,m)}`:r=a.slice(i+1,m),o=m-i-1;i=m,c=0}else h===D&&c!==-1?++c:c=-1}return r}function E(a,l){if(l===null||typeof l!="object")throw new d("pathObject","Object",l);const v=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return v?v===l.root?`${v}${t}`:`${v}${a}${t}`:t}e.win32={resolve(...a){let l="",v="",t=!1;for(let r=a.length-1;r>=-1;r--){let o;if(r>=0){if(o=a[r],f(o,"path"),o.length===0)continue}else l.length===0?o=g.cwd():(o=g.env[`=${l}`]||g.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===P)&&(o=`${l}\\`));const i=o.length;let c=0,h="",m=!1;const w=o.charCodeAt(0);if(i===1)u(w)&&(c=1,m=!0);else if(u(w))if(m=!0,u(o.charCodeAt(1))){let S=2,s=S;for(;S<i&&!u(o.charCodeAt(S));)S++;if(S<i&&S!==s){const b=o.slice(s,S);for(s=S;S<i&&u(o.charCodeAt(S));)S++;if(S<i&&S!==s){for(s=S;S<i&&!u(o.charCodeAt(S));)S++;(S===i||S!==s)&&(h=`\\\\${b}\\${o.slice(s,S)}`,c=S)}}}else c=1;else _(w)&&o.charCodeAt(1)===n&&(h=o.slice(0,2),c=2,i>2&&u(o.charCodeAt(2))&&(m=!0,c=3));if(h.length>0)if(l.length>0){if(h.toLowerCase()!==l.toLowerCase())continue}else l=h;if(t){if(l.length>0)break}else if(v=`${o.slice(c)}\\${v}`,t=m,m&&l.length>0)break}return v=A(v,!t,"\\",u),t?`${l}\\${v}`:`${l}${v}`||"."},normalize(a){f(a,"path");const l=a.length;if(l===0)return".";let v=0,t,r=!1;const o=a.charCodeAt(0);if(l===1)return p(o)?"\\":a;if(u(o))if(r=!0,u(a.charCodeAt(1))){let c=2,h=c;for(;c<l&&!u(a.charCodeAt(c));)c++;if(c<l&&c!==h){const m=a.slice(h,c);for(h=c;c<l&&u(a.charCodeAt(c));)c++;if(c<l&&c!==h){for(h=c;c<l&&!u(a.charCodeAt(c));)c++;if(c===l)return`\\\\${m}\\${a.slice(h)}\\`;c!==h&&(t=`\\\\${m}\\${a.slice(h,c)}`,v=c)}}}else v=1;else _(o)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),v=2,l>2&&u(a.charCodeAt(2))&&(r=!0,v=3));let i=v<l?A(a.slice(v),!r,"\\",u):"";return i.length===0&&!r&&(i="."),i.length>0&&u(a.charCodeAt(l-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){f(a,"path");const l=a.length;if(l===0)return!1;const v=a.charCodeAt(0);return u(v)||l>2&&_(v)&&a.charCodeAt(1)===n&&u(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let l,v;for(let o=0;o<a.length;++o){const i=a[o];f(i,"path"),i.length>0&&(l===void 0?l=v=i:l+=`\\${i}`)}if(l===void 0)return".";let t=!0,r=0;if(typeof v=="string"&&u(v.charCodeAt(0))){++r;const o=v.length;o>1&&u(v.charCodeAt(1))&&(++r,o>2&&(u(v.charCodeAt(2))?++r:t=!1))}if(t){for(;r<l.length&&u(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(a,l){if(f(a,"from"),f(l,"to"),a===l)return"";const v=e.win32.resolve(a),t=e.win32.resolve(l);if(v===t||(a=v.toLowerCase(),l=t.toLowerCase(),a===l))return"";let r=0;for(;r<a.length&&a.charCodeAt(r)===P;)r++;let o=a.length;for(;o-1>r&&a.charCodeAt(o-1)===P;)o--;const i=o-r;let c=0;for(;c<l.length&&l.charCodeAt(c)===P;)c++;let h=l.length;for(;h-1>c&&l.charCodeAt(h-1)===P;)h--;const m=h-c,w=i<m?i:m;let S=-1,s=0;for(;s<w;s++){const R=a.charCodeAt(r+s);if(R!==l.charCodeAt(c+s))break;R===P&&(S=s)}if(s!==w){if(S===-1)return t}else{if(m>w){if(l.charCodeAt(c+s)===P)return t.slice(c+s+1);if(s===2)return t.slice(c+s)}i>w&&(a.charCodeAt(r+s)===P?S=s:s===2&&(S=3)),S===-1&&(S=0)}let b="";for(s=r+S+1;s<=o;++s)(s===o||a.charCodeAt(s)===P)&&(b+=b.length===0?"..":"\\..");return c+=S,b.length>0?`${b}${t.slice(c,h)}`:(t.charCodeAt(c)===P&&++c,t.slice(c,h))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const l=e.win32.resolve(a);if(l.length<=2)return a;if(l.charCodeAt(0)===P){if(l.charCodeAt(1)===P){const v=l.charCodeAt(2);if(v!==k&&v!==D)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(_(l.charCodeAt(0))&&l.charCodeAt(1)===n&&l.charCodeAt(2)===P)return`\\\\?\\${l}`;return a},dirname(a){f(a,"path");const l=a.length;if(l===0)return".";let v=-1,t=0;const r=a.charCodeAt(0);if(l===1)return u(r)?a:".";if(u(r)){if(v=t=1,u(a.charCodeAt(1))){let c=2,h=c;for(;c<l&&!u(a.charCodeAt(c));)c++;if(c<l&&c!==h){for(h=c;c<l&&u(a.charCodeAt(c));)c++;if(c<l&&c!==h){for(h=c;c<l&&!u(a.charCodeAt(c));)c++;if(c===l)return a;c!==h&&(v=t=c+1)}}}}else _(r)&&a.charCodeAt(1)===n&&(v=l>2&&u(a.charCodeAt(2))?3:2,t=v);let o=-1,i=!0;for(let c=l-1;c>=t;--c)if(u(a.charCodeAt(c))){if(!i){o=c;break}}else i=!1;if(o===-1){if(v===-1)return".";o=v}return a.slice(0,o)},basename(a,l){l!==void 0&&f(l,"ext"),f(a,"path");let v=0,t=-1,r=!0,o;if(a.length>=2&&_(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(v=2),l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let i=l.length-1,c=-1;for(o=a.length-1;o>=v;--o){const h=a.charCodeAt(o);if(u(h)){if(!r){v=o+1;break}}else c===-1&&(r=!1,c=o+1),i>=0&&(h===l.charCodeAt(i)?--i==-1&&(t=o):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=a.length),a.slice(v,t)}for(o=a.length-1;o>=v;--o)if(u(a.charCodeAt(o))){if(!r){v=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":a.slice(v,t)},extname(a){f(a,"path");let l=0,v=-1,t=0,r=-1,o=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&_(a.charCodeAt(0))&&(l=t=2);for(let c=a.length-1;c>=l;--c){const h=a.charCodeAt(c);if(u(h)){if(!o){t=c+1;break}continue}r===-1&&(o=!1,r=c+1),h===D?v===-1?v=c:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===t+1?"":a.slice(v,r)},format:E.bind(null,"\\"),parse(a){f(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const v=a.length;let t=0,r=a.charCodeAt(0);if(v===1)return u(r)?(l.root=l.dir=a,l):(l.base=l.name=a,l);if(u(r)){if(t=1,u(a.charCodeAt(1))){let S=2,s=S;for(;S<v&&!u(a.charCodeAt(S));)S++;if(S<v&&S!==s){for(s=S;S<v&&u(a.charCodeAt(S));)S++;if(S<v&&S!==s){for(s=S;S<v&&!u(a.charCodeAt(S));)S++;S===v?t=S:S!==s&&(t=S+1)}}}}else if(_(r)&&a.charCodeAt(1)===n){if(v<=2)return l.root=l.dir=a,l;if(t=2,u(a.charCodeAt(2))){if(v===3)return l.root=l.dir=a,l;t=3}}t>0&&(l.root=a.slice(0,t));let o=-1,i=t,c=-1,h=!0,m=a.length-1,w=0;for(;m>=t;--m){if(r=a.charCodeAt(m),u(r)){if(!h){i=m+1;break}continue}c===-1&&(h=!1,c=m+1),r===D?o===-1?o=m:w!==1&&(w=1):o!==-1&&(w=-1)}return c!==-1&&(o===-1||w===0||w===1&&o===c-1&&o===i+1?l.base=l.name=a.slice(i,c):(l.name=a.slice(i,o),l.base=a.slice(i,c),l.ext=a.slice(o,c))),i>0&&i!==t?l.dir=a.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let l="",v=!1;for(let t=a.length-1;t>=-1&&!v;t--){const r=t>=0?a[t]:g.cwd();f(r,"path"),r.length!==0&&(l=`${r}/${l}`,v=r.charCodeAt(0)===y)}return l=A(l,!v,"/",p),v?`/${l}`:l.length>0?l:"."},normalize(a){if(f(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===y,v=a.charCodeAt(a.length-1)===y;return a=A(a,!l,"/",p),a.length===0?l?"/":v?"./":".":(v&&(a+="/"),l?`/${a}`:a)},isAbsolute(a){return f(a,"path"),a.length>0&&a.charCodeAt(0)===y},join(...a){if(a.length===0)return".";let l;for(let v=0;v<a.length;++v){const t=a[v];f(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(a,l){if(f(a,"from"),f(l,"to"),a===l||(a=e.posix.resolve(a),l=e.posix.resolve(l),a===l))return"";const v=1,t=a.length,r=t-v,o=1,i=l.length-o,c=r<i?r:i;let h=-1,m=0;for(;m<c;m++){const S=a.charCodeAt(v+m);if(S!==l.charCodeAt(o+m))break;S===y&&(h=m)}if(m===c)if(i>c){if(l.charCodeAt(o+m)===y)return l.slice(o+m+1);if(m===0)return l.slice(o+m)}else r>c&&(a.charCodeAt(v+m)===y?h=m:m===0&&(h=0));let w="";for(m=v+h+1;m<=t;++m)(m===t||a.charCodeAt(m)===y)&&(w+=w.length===0?"..":"/..");return`${w}${l.slice(o+h)}`},toNamespacedPath(a){return a},dirname(a){if(f(a,"path"),a.length===0)return".";const l=a.charCodeAt(0)===y;let v=-1,t=!0;for(let r=a.length-1;r>=1;--r)if(a.charCodeAt(r)===y){if(!t){v=r;break}}else t=!1;return v===-1?l?"/":".":l&&v===1?"//":a.slice(0,v)},basename(a,l){l!==void 0&&f(l,"ext"),f(a,"path");let v=0,t=-1,r=!0,o;if(l!==void 0&&l.length>0&&l.length<=a.length){if(l===a)return"";let i=l.length-1,c=-1;for(o=a.length-1;o>=0;--o){const h=a.charCodeAt(o);if(h===y){if(!r){v=o+1;break}}else c===-1&&(r=!1,c=o+1),i>=0&&(h===l.charCodeAt(i)?--i==-1&&(t=o):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=a.length),a.slice(v,t)}for(o=a.length-1;o>=0;--o)if(a.charCodeAt(o)===y){if(!r){v=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":a.slice(v,t)},extname(a){f(a,"path");let l=-1,v=0,t=-1,r=!0,o=0;for(let i=a.length-1;i>=0;--i){const c=a.charCodeAt(i);if(c===y){if(!r){v=i+1;break}continue}t===-1&&(r=!1,t=i+1),c===D?l===-1?l=i:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||t===-1||o===0||o===1&&l===t-1&&l===v+1?"":a.slice(l,t)},format:E.bind(null,"/"),parse(a){f(a,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return l;const v=a.charCodeAt(0)===y;let t;v?(l.root="/",t=1):t=0;let r=-1,o=0,i=-1,c=!0,h=a.length-1,m=0;for(;h>=t;--h){const w=a.charCodeAt(h);if(w===y){if(!c){o=h+1;break}continue}i===-1&&(c=!1,i=h+1),w===D?r===-1?r=h:m!==1&&(m=1):r!==-1&&(m=-1)}if(i!==-1){const w=o===0&&v?1:o;r===-1||m===0||m===1&&r===i-1&&r===o+1?l.base=l.name=a.slice(w,i):(l.name=a.slice(w,r),l.base=a.slice(w,i),l.ext=a.slice(r,i))}return o>0?l.dir=a.slice(0,o-1):v&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[141],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(C,...T){const D=T.reduce((n,k)=>(n[k]=!0,n),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(n=>!D[n]).forEach(n=>{for(let k=0;k<y.length;k++)if(n.search(y[k])!==-1){delete C[n];break}})}e.sanitizeProcessEnvironment=I}),define(me[46],ge([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class I{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new I(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=I}),define(me[3],ge([0,1,16,74,6,95,46]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(a){a.None=()=>I.Disposable.None;function l(Z){return(U,x=null,M)=>{let H=!1,F;return F=Z(N=>{if(!H)return F?F.dispose():H=!0,U.call(x,N)},null,M),H&&F.dispose(),F}}a.once=l;function v(Z,U){return h((x,M=null,H)=>Z(F=>x.call(M,U(F)),null,H))}a.map=v;function t(Z,U){return h((x,M=null,H)=>Z(F=>{U(F),x.call(M,F)},null,H))}a.forEach=t;function r(Z,U){return h((x,M=null,H)=>Z(F=>U(F)&&x.call(M,F),null,H))}a.filter=r;function o(Z){return Z}a.signal=o;function i(...Z){return(U,x=null,M)=>(0,I.combinedDisposable)(...Z.map(H=>H(F=>U.call(x,F),null,M)))}a.any=i;function c(Z,U,x){let M=x;return v(Z,H=>(M=U(M,H),M))}a.reduce=c;function h(Z){let U;const x=new d({onFirstListenerAdd(){U=Z(x.fire,x)},onLastListenerRemove(){U.dispose()}});return x.event}function m(Z,U,x=100,M=!1,H){let F,N,j,W=0;const Q=new d({leakWarningThreshold:H,onFirstListenerAdd(){F=Z(J=>{W++,N=U(N,J),M&&!j&&(Q.fire(N),N=void 0),clearTimeout(j),j=setTimeout(()=>{const fe=N;N=void 0,j=void 0,(!M||W>1)&&Q.fire(fe),W=0},x)})},onLastListenerRemove(){F.dispose()}});return Q.event}a.debounce=m;function w(Z,U=(x,M)=>x===M){let x=!0,M;return r(Z,H=>{const F=x||!U(H,M);return x=!1,M=H,F})}a.latch=w;function S(Z,U){return[a.filter(Z,U),a.filter(Z,x=>!U(x))]}a.split=S;function s(Z,U=!1,x=[]){let M=x.slice(),H=Z(j=>{M?M.push(j):N.fire(j)});const F=()=>{M&&M.forEach(j=>N.fire(j)),M=null},N=new d({onFirstListenerAdd(){H||(H=Z(j=>N.fire(j)))},onFirstListenerDidAdd(){M&&(U?setTimeout(F):F())},onLastListenerRemove(){H&&H.dispose(),H=null}});return N.event}a.buffer=s;class b{constructor(U){this.event=U}map(U){return new b(v(this.event,U))}forEach(U){return new b(t(this.event,U))}filter(U){return new b(r(this.event,U))}reduce(U,x){return new b(c(this.event,U,x))}latch(){return new b(w(this.event))}debounce(U,x=100,M=!1,H){return new b(m(this.event,U,x,M,H))}on(U,x,M){return this.event(U,x,M)}once(U,x,M){return l(this.event)(U,x,M)}}function R(Z){return new b(Z)}a.chain=R;function O(Z,U,x=M=>M){const M=(...j)=>N.fire(x(...j)),H=()=>Z.on(U,M),F=()=>Z.removeListener(U,M),N=new d({onFirstListenerAdd:H,onLastListenerRemove:F});return N.event}a.fromNodeEventEmitter=O;function $(Z,U,x=M=>M){const M=(...j)=>N.fire(x(...j)),H=()=>Z.addEventListener(U,M),F=()=>Z.removeEventListener(U,M),N=new d({onFirstListenerAdd:H,onLastListenerRemove:F});return N.event}a.fromDOMEventEmitter=$;function G(Z){return new Promise(U=>l(Z)(U))}a.toPromise=G})(D=e.Event||(e.Event={}));class y{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${y._idPool++}`}start(l){this._stopWatch=new T.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let P=-1;function n(a){const l=P;return P=a,{dispose(){P=l}}}e.setGlobalLeakWarningThreshold=n;class k{constructor(l,v=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let v=P;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||l<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let o,i=0;for(const[c,h]of this._stacks)(!o||i<h)&&(o=c,i=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${i}):`),console.warn(o)}return()=>{const o=this._stacks.get(t)||0;this._stacks.set(t,o-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=P>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(l,v,t)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(v?[l,v]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,v);const i=this._leakageMon?.check(this._listeners.size),c=(0,I.toDisposable)(()=>{i&&i(),this._disposed||(o(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof I.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class f extends d{async fireAsync(l,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[r,o]=this._asyncDeliveryQueue.shift(),i=[],c={...o,waitUntil:h=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(h=t(h,typeof r=="function"?r:r[0])),i.push(h)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(h){(0,g.onUnexpectedError)(h);continue}Object.freeze(i),await Promise.allSettled(i).then(h=>{for(const m of h)m.status==="rejected"&&(0,g.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=f;class u extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class p extends u{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=p;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const v={event:l,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const r=this.events.indexOf(v);this.events.splice(r,1)};return(0,I.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(v=>this.emitter.fire(v))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class A{constructor(){this.buffers=[]}wrapEvent(l){return(v,t,r)=>l(o=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,o)):v.call(t,o)},void 0,r)}bufferEvents(l){const v=[];this.buffers.push(v);const t=l();return this.buffers.pop(),v.forEach(r=>r()),t}}e.EventBufferer=A;class E{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=I.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(D,y){const P=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(P)}}});var I;(function(D){function y(P){return P===D.None||P===D.Cancelled||P instanceof C?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(I=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=I.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=T}),define(me[47],ge([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(k){const d=this._icons.get(k.id);d?k.description?d.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new L;e.iconRegistry=I;function C(n,k){return new D(n,k)}e.registerCodicon=C;function T(n){return n?n.replace(/\$\((.*?)\)/g,(k,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=T;class D{constructor(k,d,f){this.id=k,this.definition=d,this.description=f,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function y(n,k){const d=["codicon","codicon-"+n];return k&&d.push("codicon-modifier-"+k),d}e.getClassNamesArray=y;var P;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(p){if(p instanceof D)return["codicon","codicon-"+p.id];const _=k.exec(p.id);if(!_)return d(D.error);let[,A,E]=_;const a=["codicon","codicon-"+A];return E&&a.push("codicon-modifier-"+E.substr(1)),a}n.asClassNameArray=d;function f(p){return d(p).join(" ")}n.asClassName=f;function u(p){return"."+d(p).join(".")}n.asCSSSelector=u})(P=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=I;function C(a){const l=a;return l?I(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=C;function T(a,l){return new D(a,l)}e.newWriteableStream=T;class D{constructor(l,v){this.reducer=l,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(v=>v(l))}emitError(l){this.listeners.error.length===0?(0,g.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(v=>v(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,v){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(l,v){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(v);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(a,l){const v=[];let t;for(;(t=a.read())!==null;)v.push(t);return l(v)}e.consumeReadable=y;function P(a,l,v){const t=[];let r;for(;(r=a.read())!==null&&t.length<v;)t.push(r);return r===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const o=r;return r=void 0,o}return a.read()}}}e.peekReadable=P;function n(a,l){return new Promise((v,t)=>{const r=[];k(a,{onData:o=>{l&&r.push(o)},onError:o=>{l?t(o):v(void 0)},onEnd:()=>{v(l?l(r):void 0)}})})}e.consumeStream=n;function k(a,l){a.on("error",v=>l.onError(v)),a.on("end",()=>l.onEnd()),a.on("data",v=>l.onData(v))}e.listenStream=k;function d(a,l){return new Promise((v,t)=>{const r=new L.DisposableStore,o=[],i=m=>{if(o.push(m),o.length>l)return r.dispose(),a.pause(),v({stream:a,buffer:o,ended:!1})},c=m=>t(m),h=()=>v({stream:a,buffer:o,ended:!0});r.add((0,L.toDisposable)(()=>a.removeListener("error",c))),a.on("error",c),r.add((0,L.toDisposable)(()=>a.removeListener("end",h))),a.on("end",h),r.add((0,L.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=d;function f(a,l){const v=T(l);return v.end(a),v}e.toStream=f;function u(){const a=T(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=u;function p(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}e.toReadable=p;function _(a,l,v){const t=T(v);return k(a,{onData:r=>t.write(l.data(r)),onError:r=>t.error(l.error?l.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function A(a,l,v){let t=!1;return{read:()=>{const r=l.read();return t?r:(t=!0,r!==null?v([a,r]):a)}}}e.prefixedReadable=A;function E(a,l,v){let t=!1;const r=T(v);return k(l,{onData:o=>t?r.write(o):(t=!0,r.write(v([a,o]))),onError:o=>r.error(o),onEnd:()=>{t||(t=!0,r.write(a)),r.end()}}),r}e.prefixedStream=E}),define(me[22],ge([0,1,96]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let I,C;class T{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new T(Buffer.allocUnsafe(i)):new T(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new T(i)}static fromString(i,c){return!(c?.dontUseNodeBuffer||!1)&&L?new T(Buffer.from(i)):(I||(I=new TextEncoder),new T(I.encode(i)))}static concat(i,c){if(typeof c=="undefined"){c=0;for(let w=0,S=i.length;w<S;w++)c+=i[w].byteLength}const h=T.alloc(c);let m=0;for(let w=0,S=i.length;w<S;w++){const s=i[w];h.set(s,m),m+=s.byteLength}return h}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,c){return new T(this.buffer.subarray(i,c))}set(i,c){i instanceof T?this.buffer.set(i.buffer,c):this.buffer.set(i,c)}readUInt32BE(i){return P(this.buffer,i)}writeUInt32BE(i,c){n(this.buffer,i,c)}readUInt32LE(i){return k(this.buffer,i)}writeUInt32LE(i,c){d(this.buffer,i,c)}readUInt8(i){return f(this.buffer,i)}writeUInt8(i,c){u(this.buffer,i,c)}}e.VSBuffer=T;function D(o,i){return o[i+0]<<0>>>0|o[i+1]<<8>>>0}e.readUInt16LE=D;function y(o,i,c){o[c+0]=i&255,i=i>>>8,o[c+1]=i&255}e.writeUInt16LE=y;function P(o,i){return o[i]*2**24+o[i+1]*2**16+o[i+2]*2**8+o[i+3]}e.readUInt32BE=P;function n(o,i,c){o[c+3]=i,i=i>>>8,o[c+2]=i,i=i>>>8,o[c+1]=i,i=i>>>8,o[c]=i}e.writeUInt32BE=n;function k(o,i){return o[i+0]<<0>>>0|o[i+1]<<8>>>0|o[i+2]<<16>>>0|o[i+3]<<24>>>0}e.readUInt32LE=k;function d(o,i,c){o[c+0]=i&255,i=i>>>8,o[c+1]=i&255,i=i>>>8,o[c+2]=i&255,i=i>>>8,o[c+3]=i&255}e.writeUInt32LE=d;function f(o,i){return o[i]}e.readUInt8=f;function u(o,i,c){o[c]=i}e.writeUInt8=u;function p(o){return g.consumeReadable(o,i=>T.concat(i))}e.readableToBuffer=p;function _(o){return g.toReadable(o)}e.bufferToReadable=_;function A(o){return g.consumeStream(o,i=>T.concat(i))}e.streamToBuffer=A;async function E(o){return o.ended?T.concat(o.buffer):T.concat([...o.buffer,await A(o.stream)])}e.bufferedStreamToBuffer=E;function a(o){return g.toStream(o,i=>T.concat(i))}e.bufferToStream=a;function l(o){return g.transform(o,{data:i=>typeof i=="string"?T.fromString(i):T.wrap(i)},i=>T.concat(i))}e.streamToBufferReadableStream=l;function v(o){return g.newWriteableStream(i=>T.concat(i),o)}e.newWriteableBufferStream=v;function t(o,i){return g.prefixedReadable(o,i,c=>T.concat(c))}e.prefixedBufferReadable=t;function r(o,i){return g.prefixedStream(o,i,c=>T.concat(c))}e.prefixedBufferStream=r}),define(me[9],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function I(ue,...Ie){return Ie.length===0?ue:ue.replace(L,function(Ne,Ge){const We=parseInt(Ge,10);return isNaN(We)||We<0||We>=Ie.length?Ne:Ie[We]})}e.format=I;const C=/{([^}]+)}/g;function T(ue,Ie){return ue.replace(C,(Ne,Ge)=>Ie[Ge]??Ne)}e.format2=T;function D(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=D;function y(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(ue,Ie){let Ne=0;const Ge=Ie.charCodeAt(0);for(let We=ue.length-1;We>=0;We--)ue.charCodeAt(We)===Ge&&Ne++;return Ne}e.count=P;function n(ue,Ie,Ne="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Ne}`}e.truncate=n;function k(ue,Ie=" "){const Ne=d(ue,Ie);return f(Ne,Ie)}e.trim=k;function d(ue,Ie){if(!ue||!Ie)return ue;const Ne=Ie.length;if(Ne===0||ue.length===0)return ue;let Ge=0;for(;ue.indexOf(Ie,Ge)===Ge;)Ge=Ge+Ne;return ue.substring(Ge)}e.ltrim=d;function f(ue,Ie){if(!ue||!Ie)return ue;const Ne=Ie.length,Ge=ue.length;if(Ne===0||Ge===0)return ue;let We=Ge,ot=-1;for(;ot=ue.lastIndexOf(Ie,We-1),!(ot===-1||ot+Ne!==We);){if(ot===0)return"";We=ot}return ue.substring(0,We)}e.rtrim=f;function u(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function p(ue){return ue.replace(/\*/g,"")}e.stripWildcards=p;function _(ue,Ie,Ne={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=y(ue)),Ne.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Ge="";return Ne.global&&(Ge+="g"),Ne.matchCase||(Ge+="i"),Ne.multiline&&(Ge+="m"),Ne.unicode&&(Ge+="u"),new RegExp(ue,Ge)}e.createRegExp=_;function A(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=A;function E(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function a(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=a;function l(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=l;function v(ue){for(let Ie=0,Ne=ue.length;Ie<Ne;Ie++){const Ge=ue.charCodeAt(Ie);if(Ge!==32&&Ge!==9)return Ie}return-1}e.firstNonWhitespaceIndex=v;function t(ue,Ie=0,Ne=ue.length){for(let Ge=Ie;Ge<Ne;Ge++){const We=ue.charCodeAt(Ge);if(We!==32&&We!==9)return ue.substring(Ie,Ge)}return ue.substring(Ie,Ne)}e.getLeadingWhitespace=t;function r(ue,Ie=ue.length-1){for(let Ne=Ie;Ne>=0;Ne--){const Ge=ue.charCodeAt(Ne);if(Ge!==32&&Ge!==9)return Ne}return-1}e.lastNonWhitespaceIndex=r;function o(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=o;function i(ue,Ie,Ne=0,Ge=ue.length,We=0,ot=Ie.length){for(;Ne<Ge&&We<ot;Ne++,We++){let Ce=ue.charCodeAt(Ne),ne=Ie.charCodeAt(We);if(Ce<ne)return-1;if(Ce>ne)return 1}const Re=Ge-Ne,Se=ot-We;return Re<Se?-1:Re>Se?1:0}e.compareSubstring=i;function c(ue,Ie){return h(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=c;function h(ue,Ie,Ne=0,Ge=ue.length,We=0,ot=Ie.length){for(;Ne<Ge&&We<ot;Ne++,We++){let Ce=ue.charCodeAt(Ne),ne=Ie.charCodeAt(We);if(Ce===ne)continue;const de=Ce-ne;if(!(de===32&&w(ne))&&!(de===-32&&w(Ce)))return m(Ce)&&m(ne)?de:i(ue.toLowerCase(),Ie.toLowerCase(),Ne,Ge,We,ot)}const Re=Ge-Ne,Se=ot-We;return Re<Se?-1:Re>Se?1:0}e.compareSubstringIgnoreCase=h;function m(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=m;function w(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=w;function S(ue){return m(ue)||w(ue)}function s(ue,Ie){return ue.length===Ie.length&&b(ue,Ie)}e.equalsIgnoreCase=s;function b(ue,Ie,Ne=ue.length){for(let Ge=0;Ge<Ne;Ge++){const We=ue.charCodeAt(Ge),ot=Ie.charCodeAt(Ge);if(We!==ot){if(S(We)&&S(ot)){const Re=Math.abs(We-ot);if(Re!==0&&Re!==32)return!1}else if(String.fromCharCode(We).toLowerCase()!==String.fromCharCode(ot).toLowerCase())return!1}}return!0}function R(ue,Ie){const Ne=Ie.length;return Ie.length>ue.length?!1:b(ue,Ie,Ne)}e.startsWithIgnoreCase=R;function O(ue,Ie){let Ne,Ge=Math.min(ue.length,Ie.length);for(Ne=0;Ne<Ge;Ne++)if(ue.charCodeAt(Ne)!==Ie.charCodeAt(Ne))return Ne;return Ge}e.commonPrefixLength=O;function $(ue,Ie){let Ne,Ge=Math.min(ue.length,Ie.length);const We=ue.length-1,ot=Ie.length-1;for(Ne=0;Ne<Ge;Ne++)if(ue.charCodeAt(We-Ne)!==Ie.charCodeAt(ot-Ne))return Ne;return Ge}e.commonSuffixLength=$;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function Z(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=Z;function U(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=U;function x(ue,Ie,Ne){const Ge=ue.charCodeAt(Ne);if(G(Ge)&&Ne+1<Ie){const We=ue.charCodeAt(Ne+1);if(Z(We))return U(Ge,We)}return Ge}e.getNextCodePoint=x;function M(ue,Ie){const Ne=ue.charCodeAt(Ie-1);if(Z(Ne)&&Ie>1){const Ge=ue.charCodeAt(Ie-2);if(G(Ge))return U(Ge,Ne)}return Ne}function H(ue,Ie){const Ne=pe.getInstance(),Ge=Ie,We=ue.length,ot=x(ue,We,Ie);Ie+=ot>=65536?2:1;let Re=Ne.getGraphemeBreakType(ot);for(;Ie<We;){const Se=x(ue,We,Ie),Ce=Ne.getGraphemeBreakType(Se);if(K(Re,Ce))break;Ie+=Se>=65536?2:1,Re=Ce}return Ie-Ge}e.nextCharLength=H;function F(ue,Ie){const Ne=pe.getInstance(),Ge=Ie,We=M(ue,Ie);Ie-=We>=65536?2:1;let ot=Ne.getGraphemeBreakType(We);for(;Ie>0;){const Re=M(ue,Ie),Se=Ne.getGraphemeBreakType(Re);if(K(Se,ot))break;Ie-=Re>=65536?2:1,ot=Se}return Ge-Ie}e.prevCharLength=F;function N(ue,Ie){const Ne=pe.getInstance(),Ge=ue.length,We=Ie,ot=x(ue,Ge,Ie),Re=Ne.getGraphemeBreakType(ot);Ie+=ot>=65536?2:1;let Se=Re;for(;Ie<Ge;){const ne=x(ue,Ge,Ie),de=Ne.getGraphemeBreakType(ne);if(K(Se,de))break;Ie+=ne>=65536?2:1,Se=de}const Ce=Ie;for(Ie=We,Se=Re;Ie>0;){const ne=M(ue,Ie),de=Ne.getGraphemeBreakType(ne);if(K(de,Se))break;Ie-=ne>=65536?2:1,Se=de}return[Ie,Ce]}function j(ue,Ie){return Ie>0&&Z(ue.charCodeAt(Ie))?N(ue,Ie-1):N(ue,Ie)}e.getCharContainingOffset=j;const W=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(ue){return W.test(ue)}e.containsRTL=Q;const J=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function fe(ue){return J.test(ue)}e.containsEmoji=fe;const _e=/^[\t\n\r\x20-\x7E]*$/;function ye(ue){return _e.test(ue)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=Le;function Be(ue){for(let Ie=0,Ne=ue.length;Ie<Ne;Ie++)if(xe(ue.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=Be;function xe(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=xe;function Ke(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129750}e.isEmojiImprecise=Ke;function z(ue,Ie){if(ue.length<Ie)return ue;const Ne=/\b/g;let Ge=0;for(;Ne.test(ue)&&!(ue.length-Ne.lastIndex<Ie);)Ge=Ne.lastIndex,Ne.lastIndex+=1;return ue.substring(Ge).replace(/^\s/,"")}e.lcut=z;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function X(ue){return ue&&(ue=ue.replace(ee,""),ue=ue.replace(re,""),ue=ue.replace(le,"")),ue}e.removeAnsiEscapeCodes=X,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function ve(ue){return oe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ve;function Me(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Ne=Ie.length,Ge=ue.toLowerCase();let We=0,ot=-1;for(;We<Ne;){const Re=Ge.indexOf(Ie[We],ot+1);if(Re<0)return!1;ot=Re,We++}return!0}e.fuzzyContains=Me;function ze(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=ze;function Qe(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Qe;function et(ue,Ie=1){if(Ie===0)return"";let Ne=-1;do Ne=ue.indexOf(`
`,Ne+1),Ie--;while(Ie>0&&Ne>=0);return Ne===-1?ue:(ue[Ne-1]==="\r"&&Ne--,ue.substr(0,Ne))}e.getNLines=et;function ke(ue){const Ie=90-65+1;return ue=ue%(2*Ie),ue<Ie?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ie)}e.singleLetterHash=ke;function ct(ue){return pe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=ct;function K(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}e.breakBetweenGraphemeBreakType=K;var te;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=Ve()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ne=this._data,Ge=Ne.length/3;let We=1;for(;We<=Ge;)if(Ie<Ne[3*We])We=2*We;else if(Ie>Ne[3*We+1])We=2*We+1;else return Ne[3*We+2];return 0}}pe._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(ue,Ie){if(ue===0)return 0;const Ne=st(ue,Ie);if(Ne!==void 0)return Ne;const Ge=M(Ie,ue);return ue-=lt(Ge),ue}e.getLeftDeleteOffset=tt;function st(ue,Ie){let Ne=M(Ie,ue);for(ue-=lt(Ne);vt(Ne)||Ne===65039||Ne===8419;){if(ue===0)return;Ne=M(Ie,ue),ue-=lt(Ne)}if(!!Ke(Ne)){if(ue>=0){const Ge=M(Ie,ue);Ge===8205&&(ue-=lt(Ge))}return ue}}function lt(ue){return ue>=65536?2:1}function vt(ue){return 127995<=ue&&ue<=127999}var Dt;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Dt||(Dt={}))}),define(me[58],ge([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(A){return I(A,0)}e.hash=L;function I(A,E){switch(typeof A){case"object":return A===null?C(349,E):Array.isArray(A)?y(A,E):P(A,E);case"string":return D(A,E);case"boolean":return T(A,E);case"number":return C(A,E);case"undefined":return C(937,E);default:return C(617,E)}}e.doHash=I;function C(A,E){return(E<<5)-E+A|0}function T(A,E){return C(A?433:863,E)}function D(A,E){E=C(149417,E);for(let a=0,l=A.length;a<l;a++)E=C(A.charCodeAt(a),E);return E}e.stringHash=D;function y(A,E){return E=C(104579,E),A.reduce((a,l)=>I(l,a),E)}function P(A,E){return E=C(181387,E),Object.keys(A).sort().reduce((a,l)=>(a=D(l,a),I(A[l],a)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=I(E,this._value),this._value}}e.Hasher=n;var k;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function d(A,E,a=32){const l=a-E,v=~((1<<l)-1);return(A<<E|(v&A)>>>l)>>>0}function f(A,E=0,a=A.byteLength,l=0){for(let v=0;v<a;v++)A[E+v]=l}function u(A,E,a="0"){for(;A.length<E;)A=a+A;return A}function p(A,E=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(a=>a.toString(16).padStart(2,"0")).join(""):u((A>>>0).toString(16),E/4)}e.toHexString=p;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const a=E.length;if(a===0)return;const l=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=E.charCodeAt(0),o=0);;){let i=r;if(g.isHighSurrogate(r))if(o+1<a){const c=E.charCodeAt(o+1);g.isLowSurrogate(c)?(o++,i=g.computeCodePoint(r,c)):i=65533}else{t=r;break}else g.isLowSurrogate(r)&&(i=65533);if(v=this._push(l,v,i),o++,o<a)r=E.charCodeAt(o);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(E,a,l){return l<128?E[a++]=l:l<2048?(E[a++]=192|(l&1984)>>>6,E[a++]=128|(l&63)>>>0):l<65536?(E[a++]=224|(l&61440)>>>12,E[a++]=128|(l&4032)>>>6,E[a++]=128|(l&63)>>>0):(E[a++]=240|(l&1835008)>>>18,E[a++]=128|(l&258048)>>>12,E[a++]=128|(l&4032)>>>6,E[a++]=128|(l&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=_._bigBlock32,a=this._buffDV;for(let m=0;m<64;m+=4)E.setUint32(m,a.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)E.setUint32(m,d(E.getUint32(m-12,!1)^E.getUint32(m-32,!1)^E.getUint32(m-56,!1)^E.getUint32(m-64,!1),1),!1);let l=this._h0,v=this._h1,t=this._h2,r=this._h3,o=this._h4,i,c,h;for(let m=0;m<80;m++)m<20?(i=v&t|~v&r,c=1518500249):m<40?(i=v^t^r,c=1859775393):m<60?(i=v&t|v&r|t&r,c=2400959708):(i=v^t^r,c=3395469782),h=d(l,5)+i+o+c+E.getUint32(m*4,!1)&4294967295,o=r,r=t,t=d(v,30),v=l,l=h;this._h0=this._h0+l&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[48],ge([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(L||(L={})),function(I){const C="error",T="warning",D="warn",y="info",P="ignore";function n(d){return d?g.equalsIgnoreCase(C,d)?I.Error:g.equalsIgnoreCase(T,d)||g.equalsIgnoreCase(D,d)?I.Warning:g.equalsIgnoreCase(y,d)?I.Info:I.Ignore:I.Ignore}I.fromValue=n;function k(d){switch(d){case I.Error:return C;case I.Warning:return T;case I.Info:return y;default:return P}}I.toString=k}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(w){return Array.isArray(w)}e.isArray=g;function L(w){return typeof w=="string"}e.isString=L;function I(w){return Array.isArray(w)&&w.every(S=>L(S))}e.isStringArray=I;function C(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=C;function T(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=T;function D(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=D;function y(w){return w===!0||w===!1}e.isBoolean=y;function P(w){return typeof w=="undefined"}e.isUndefined=P;function n(w){return!k(w)}e.isDefined=n;function k(w){return P(w)||w===null}e.isUndefinedOrNull=k;function d(w,S){if(!w)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=d;function f(w){if(k(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=f;function u(...w){const S=[];for(let s=0;s<w.length;s++){const b=w[s];if(k(b))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);S.push(b)}return S}e.assertAllDefined=u;const p=Object.prototype.hasOwnProperty;function _(w){if(!C(w))return!1;for(let S in w)if(p.call(w,S))return!1;return!0}e.isEmptyObject=_;function A(w){return typeof w=="function"}e.isFunction=A;function E(...w){return w.length>0&&w.every(A)}e.areFunctions=E;function a(w,S){const s=Math.min(w.length,S.length);for(let b=0;b<s;b++)l(w[b],S[b])}e.validateConstraints=a;function l(w,S){if(L(S)){if(typeof w!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(A(S)){try{if(w instanceof S)return}catch{}if(!k(w)&&w.constructor===S||S.length===1&&S.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function v(w){let S=[],s=Object.getPrototypeOf(w);for(;Object.prototype!==s;)S=S.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return S}e.getAllPropertyNames=v;function t(w){const S=[];for(const s of v(w))typeof w[s]=="function"&&S.push(s);return S}e.getAllMethodNames=t;function r(w,S){const s=R=>function(){const O=Array.prototype.slice.call(arguments,0);return S(R,O)};let b={};for(const R of w)b[R]=s(R);return b}e.createProxyObject=r;function o(w){return w===null?void 0:w}e.withNullAsUndefined=o;function i(w){return typeof w=="undefined"?null:w}e.withUndefinedAsNull=i;function c(w){return class{constructor(){return new Proxy({},{get(S,s){if(S[s])return S[s];throw new Error(`Not Implemented: ${w}->${String(s)}`)}})}}}e.NotImplementedProxy=c;function h(w,S="Unreachable"){throw new Error(S)}e.assertNever=h;function m(w){return!!w&&typeof w.then=="function"&&typeof w.catch=="function"}e.isPromise=m}),define(me[29],ge([0,1,8,11,9,13]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function D(o){return o.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=D;function y(o){return o.indexOf("/")===-1&&(o=D(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=y;function P(o,i=g.posix.sep){if(!o)return"";const c=o.length,h=o.charCodeAt(0);if(T(h)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let w=3;const S=w;for(;w<c&&!T(o.charCodeAt(w));w++);if(S!==w&&!T(o.charCodeAt(w+1))){for(w+=1;w<c;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1).replace(/[\\/]/g,i)}}return i}else if(A(h)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+i:o.slice(0,2);let m=o.indexOf("://");if(m!==-1){for(m+=3;m<c;m++)if(T(o.charCodeAt(m)))return o.slice(0,m+1)}return""}e.getRoot=P;function n(o){if(!L.isWindows||!o||o.length<5)return!1;let i=o.charCodeAt(0);if(i!==92||(i=o.charCodeAt(1),i!==92))return!1;let c=2;const h=c;for(;c<o.length&&(i=o.charCodeAt(c),i!==92);c++);return!(h===c||(i=o.charCodeAt(c+1),isNaN(i)||i===92))}e.isUNC=n;const k=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,i=L.isWindows){const c=i?k:d;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||i&&f.test(o)||o==="."||o===".."||i&&o[o.length-1]==="."||i&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function p(o,i,c){const h=o===i;return!c||h?h:!o||!i?!1:(0,I.equalsIgnoreCase)(o,i)}e.isEqual=p;function _(o,i,c,h=g.sep){if(o===i)return!0;if(!o||!i||i.length>o.length)return!1;if(c){if(!(0,I.startsWithIgnoreCase)(o,i))return!1;if(i.length===o.length)return!0;let w=i.length;return i.charAt(i.length-1)===h&&w--,o.charAt(w)===h}return i.charAt(i.length-1)!==h&&(i+=h),o.indexOf(i)===0}e.isEqualOrParent=_;function A(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=A;function E(o,i){return L.isWindows&&o.endsWith(":")&&(o+=g.sep),(0,g.isAbsolute)(o)||(o=(0,g.join)(i,o)),o=(0,g.normalize)(o),L.isWindows?(o=(0,I.rtrim)(o,g.sep),o.endsWith(":")&&(o+=g.sep)):(o=(0,I.rtrim)(o,g.sep),o||(o=g.sep)),o}e.sanitizeFilePath=E;function a(o){const i=(0,g.normalize)(o);return L.isWindows?o.length>3?!1:l(i)&&(o.length===2||i.charCodeAt(2)===92):i===g.posix.sep}e.isRootOrDriveLetter=a;function l(o){return L.isWindows?A(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function v(o){return l(o)?o[0]:void 0}e.getDriveLetter=v;function t(o,i,c){return i.length>o.length?-1:o===i?0:(c&&(o=o.toLowerCase(),i=i.toLowerCase()),o.indexOf(i))}e.indexOfPath=t;function r(o){const i=o.split(":");let c,h,m;if(i.forEach(w=>{const S=Number(w);(0,C.isNumber)(S)?h===void 0?h=S:m===void 0&&(m=S):c=c?[c,w].join(":"):w}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:m!==void 0?m:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(me[23],ge([0,1,13]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const _=Array.isArray(p)?[]:{};return Object.keys(p).forEach(A=>{p[A]&&typeof p[A]=="object"?_[A]=L(p[A]):_[A]=p[A]}),_}e.deepClone=L;function I(p){if(!p||typeof p!="object")return p;const _=[p];for(;_.length>0;){const A=_.shift();Object.freeze(A);for(const E in A)if(C.call(A,E)){const a=A[E];typeof a=="object"&&!Object.isFrozen(a)&&_.push(a)}}return p}e.deepFreeze=I;const C=Object.prototype.hasOwnProperty;function T(p,_){return D(p,_,new Set)}e.cloneAndChange=T;function D(p,_,A){if((0,g.isUndefinedOrNull)(p))return p;const E=_(p);if(typeof E!="undefined")return E;if((0,g.isArray)(p)){const a=[];for(const l of p)a.push(D(l,_,A));return a}if((0,g.isObject)(p)){if(A.has(p))throw new Error("Cannot clone recursive data-structure");A.add(p);const a={};for(let l in p)C.call(p,l)&&(a[l]=D(p[l],_,A));return A.delete(p),a}return p}function y(p,_,A=!0){return(0,g.isObject)(p)?((0,g.isObject)(_)&&Object.keys(_).forEach(E=>{E in p?A&&((0,g.isObject)(p[E])&&(0,g.isObject)(_[E])?y(p[E],_[E],A):p[E]=_[E]):p[E]=_[E]}),p):_}e.mixin=y;function P(p,_){if(p===_)return!0;if(p==null||_===null||_===void 0||typeof p!=typeof _||typeof p!="object"||Array.isArray(p)!==Array.isArray(_))return!1;let A,E;if(Array.isArray(p)){if(p.length!==_.length)return!1;for(A=0;A<p.length;A++)if(!P(p[A],_[A]))return!1}else{const a=[];for(E in p)a.push(E);a.sort();const l=[];for(E in _)l.push(E);if(l.sort(),!P(a,l))return!1;for(A=0;A<a.length;A++)if(!P(p[a[A]],_[a[A]]))return!1}return!0}e.equals=P;function n(p){const _=new Set;return JSON.stringify(p,(A,E)=>{if((0,g.isObject)(E)||Array.isArray(E)){if(_.has(E))return"[Circular]";_.add(E)}return E})}e.safeStringify=n;function k(p,_,A){const E=_(p);return typeof E=="undefined"?A:E}e.getOrDefault=k;function d(p,_){const A=Object.create(null);return!p||!_||Object.keys(_).forEach(a=>{const l=p[a],v=_[a];P(l,v)||(A[a]=v)}),A}e.distinct=d;function f(p,_){const A=_.toLowerCase(),E=Object.keys(p).find(a=>a.toLowerCase()===A);return E?p[E]:p[_]}e.getCaseInsensitive=f;function u(p,_){const A=Object.create(null);for(const E of Object.keys(p))_(E,p[E])&&(A[E]=p[E]);return A}e.filter=u}),define(me[97],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function I(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=I}),define(me[2],ge([0,1,8,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,C=/^\//,T=/^\/\//;function D(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!I.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!C.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,i){return!o&&!i?"file":o}function P(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const n="",k="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,c,h,m,w,S=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=y(i,S),this.authority=c||n,this.path=P(this.scheme,h||n),this.query=m||n,this.fragment=w||n,D(this,S))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:c,authority:h,path:m,query:w,fragment:S}=i;return c===void 0?c=this.scheme:c===null&&(c=n),h===void 0?h=this.authority:h===null&&(h=n),m===void 0?m=this.path:m===null&&(m=n),w===void 0?w=this.query:w===null&&(w=n),S===void 0?S=this.fragment:S===null&&(S=n),c===this.scheme&&h===this.authority&&m===this.path&&w===this.query&&S===this.fragment?this:new p(c,h,m,w,S)}static parse(i,c=!1){const h=d.exec(i);return h?new p(h[2]||n,r(h[4]||n),r(h[5]||n),r(h[7]||n),r(h[9]||n),c):new p(n,n,n,n,n)}static file(i){let c=n;if(L.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const h=i.indexOf(k,2);h===-1?(c=i.substring(2),i=k):(c=i.substring(2,h),i=i.substring(h)||k)}return new p("file",c,i,n,n)}static from(i){const c=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return D(c,!0),c}static joinPath(i,...c){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return L.isWindows&&i.scheme==="file"?h=f.file(g.win32.join(a(i,!0),...c)).path:h=g.posix.join(i.path,...c),i.with({path:h})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const c=new p(i);return c._formatted=i.external,c._fsPath=i._sep===u?i.fsPath:null,c}}else return i}}e.URI=f;const u=L.isWindows?1:void 0;class p extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(o,i){let c,h=-1;for(let m=0;m<o.length;m++){const w=o.charCodeAt(m);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||i&&w===47)h!==-1&&(c+=encodeURIComponent(o.substring(h,m)),h=-1),c!==void 0&&(c+=o.charAt(m));else{c===void 0&&(c=o.substr(0,m));const S=_[w];S!==void 0?(h!==-1&&(c+=encodeURIComponent(o.substring(h,m)),h=-1),c+=S):h===-1&&(h=m)}}return h!==-1&&(c+=encodeURIComponent(o.substring(h))),c!==void 0?c:o}function E(o){let i;for(let c=0;c<o.length;c++){const h=o.charCodeAt(c);h===35||h===63?(i===void 0&&(i=o.substr(0,c)),i+=_[h]):i!==void 0&&(i+=o[c])}return i!==void 0?i:o}function a(o,i){let c;return o.authority&&o.path.length>1&&o.scheme==="file"?c=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?c=o.path.substr(1):c=o.path[1].toLowerCase()+o.path.substr(2):c=o.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=a;function l(o,i){const c=i?E:A;let h="",{scheme:m,authority:w,path:S,query:s,fragment:b}=o;if(m&&(h+=m,h+=":"),(w||m==="file")&&(h+=k,h+=k),w){let R=w.indexOf("@");if(R!==-1){const O=w.substr(0,R);w=w.substr(R+1),R=O.indexOf(":"),R===-1?h+=c(O,!1):(h+=c(O.substr(0,R),!1),h+=":",h+=c(O.substr(R+1),!1)),h+="@"}w=w.toLowerCase(),R=w.indexOf(":"),R===-1?h+=c(w,!1):(h+=c(w.substr(0,R),!1),h+=w.substr(R))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const R=S.charCodeAt(1);R>=65&&R<=90&&(S=`/${String.fromCharCode(R+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const R=S.charCodeAt(0);R>=65&&R<=90&&(S=`${String.fromCharCode(R+32)}:${S.substr(2)}`)}h+=c(S,!0)}return s&&(h+="?",h+=c(s,!1)),b&&(h+="#",h+=i?b:A(b,!1)),h}function v(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+v(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,i=>v(i)):o}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[24],ge([0,1,9,2]),function(Y,e,g,L){"use strict";var I,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,r,o){let i=t.get(r);return i===void 0&&(i=o,t.set(r,i)),i}e.getOrSet=D;function y(t){const r=[];return t.forEach((o,i)=>{r.push(`${i} => ${o}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function P(t){const r=[];return t.forEach(o=>{r.push(o)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=P;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return o-i}value(){return this._value[this._pos]}}e.StringIterator=n;class k{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,g.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class d{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,g.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,g.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,g.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,g.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,g.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class p{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new u(r))}static forPaths(){return new _(new d)}static forStrings(){return new _(new n)}static forConfigKeys(){return new _(new k)}clear(){this._root=void 0}set(r,o){const i=this._iter.reset(r);let c;for(this._root||(this._root=new p,this._root.segment=i.value()),c=this._root;;){const m=i.cmp(c.segment);if(m>0)c.left||(c.left=new p,c.left.segment=i.value()),c=c.left;else if(m<0)c.right||(c.right=new p,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new p,c.mid.segment=i.value()),c=c.mid;else break}const h=c.value;return c.value=o,c.key=r,h}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let i=this._root;for(;i;){const c=o.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else break}return i}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const i=this._iter.reset(r),c=[];let h=this._root;for(;h;){const m=i.cmp(h.segment);if(m>0)c.push([1,h]),h=h.left;else if(m<0)c.push([-1,h]),h=h.right;else if(i.hasNext())i.next(),c.push([0,h]),h=h.mid;else{for(o?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;c.length>0&&h.isEmpty();){let[w,S]=c.pop();switch(w){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}h=S}break}}}findSubstr(r){const o=this._iter.reset(r);let i=this._root,c;for(;i;){const h=o.cmp(i.segment);if(h>0)i=i.left;else if(h<0)i=i.right;else if(o.hasNext())o.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(r){const o=this._iter.reset(r);let i=this._root;for(;i;){const c=o.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[o,i]of this)r(i,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const o=[r];for(;o.length>0;){const i=o.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&o.push(i.left),i.mid&&o.push(i.mid),i.right&&o.push(i.right))}}}e.TernarySearchTree=_;class A{constructor(r,o){this[I]="ResourceMap",r instanceof A?(this.map=new Map(r.map),this.toKey=o??A.defaultToKey):(this.map=new Map,this.toKey=r??A.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),o),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o!="undefined"&&(r=r.bind(o));for(let[i,c]of this.map)r(c,L.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=A,A.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class a{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const i=this._map.get(r);if(!!i)return o!==0&&this.touch(i,o),i.value}set(r,o,i=0){let c=this._map.get(r);if(c)c.value=o,i!==0&&this.touch(c,i);else{switch(c={key:r,value:o,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const i=this._state;let c=this._head;for(;c;){if(o?r.bind(o)(c.value,c.key,this):r(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,o=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:i.key,done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return c}values(){const r=this,o=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:i.value,done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return c}entries(){const r=this,o=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:[i.key,i.value],done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return c}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,i=this.size;for(;o&&i>r;)this._map.delete(o.key),o=o.next,i--;this._head=o,this._size=i,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,i=r.previous;if(!o||!i)throw new Error("Invalid list");o.previous=i,i.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const i=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const i=r.next,c=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,i)=>{r.push([i,o])}),r}fromJSON(r){this.clear();for(const[o,i]of r)this.set(o,i)}}e.LinkedMap=a;class l extends a{constructor(r,o=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class v{constructor(r){T.set(this,void 0),rt(this,T,r,"f")}get size(){return $e(this,T,"f").size}forEach(r,o){$e(this,T,"f").forEach(r,o)}get(r){return $e(this,T,"f").get(r)}has(r){return $e(this,T,"f").has(r)}entries(){return $e(this,T,"f").entries()}keys(){return $e(this,T,"f").keys()}values(){return $e(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return $e(this,T,"f").entries()}}e.ReadonlyMapView=v}),define(me[98],ge([0,1,24,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...X){return function(oe,ve){for(let Me=0,ze=X.length;Me<ze;Me++){const Qe=X[Me](oe,ve);if(Qe)return Qe}return null}}e.or=I,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(X,oe,ve){if(!ve||ve.length<oe.length)return null;let Me;return X?Me=L.startsWithIgnoreCase(ve,oe):Me=ve.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function T(X,oe){const ve=oe.toLowerCase().indexOf(X.toLowerCase());return ve===-1?null:[{start:ve,end:ve+X.length}]}e.matchesContiguousSubString=T;function D(X,oe){return y(X.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=D;function y(X,oe,ve,Me){if(ve===X.length)return[];if(Me===oe.length)return null;if(X[ve]===oe[Me]){let ze=null;return(ze=y(X,oe,ve+1,Me+1))?A({start:Me,end:Me+1},ze):null}return y(X,oe,ve,Me+1)}function P(X){return 97<=X&&X<=122}function n(X){return 65<=X&&X<=90}e.isUpper=n;function k(X){return 48<=X&&X<=57}function d(X){return X===32||X===9||X===10||X===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(X=>f.add(X.charCodeAt(0)));function u(X){return d(X)||f.has(X)}function p(X,oe){return X===oe||u(X)&&u(oe)}function _(X){return P(X)||n(X)||k(X)}function A(X,oe){return oe.length===0?oe=[X]:X.end===oe[0].start?oe[0].start=X.start:oe.unshift(X),oe}function E(X,oe){for(let ve=oe;ve<X.length;ve++){const Me=X.charCodeAt(ve);if(n(Me)||k(Me)||ve>0&&!_(X.charCodeAt(ve-1)))return ve}return X.length}function a(X,oe,ve,Me){if(ve===X.length)return[];if(Me===oe.length)return null;if(X[ve]!==oe[Me].toLowerCase())return null;{let ze=null,Qe=Me+1;for(ze=a(X,oe,ve+1,Me+1);!ze&&(Qe=E(oe,Qe))<oe.length;)ze=a(X,oe,ve+1,Qe),Qe++;return ze===null?null:A({start:Me,end:Me+1},ze)}}function l(X){let oe=0,ve=0,Me=0,ze=0,Qe=0;for(let te=0;te<X.length;te++)Qe=X.charCodeAt(te),n(Qe)&&oe++,P(Qe)&&ve++,_(Qe)&&Me++,k(Qe)&&ze++;const et=oe/X.length,ke=ve/X.length,ct=Me/X.length,K=ze/X.length;return{upperPercent:et,lowerPercent:ke,alphaPercent:ct,numericPercent:K}}function v(X){const{upperPercent:oe,lowerPercent:ve}=X;return ve===0&&oe>.6}function t(X){const{upperPercent:oe,lowerPercent:ve,alphaPercent:Me,numericPercent:ze}=X;return ve>.2&&oe<.8&&Me>.6&&ze<.2}function r(X){let oe=0,ve=0,Me=0,ze=0;for(let Qe=0;Qe<X.length;Qe++)Me=X.charCodeAt(Qe),n(Me)&&oe++,P(Me)&&ve++,d(Me)&&ze++;return(oe===0||ve===0)&&ze===0?X.length<=30:oe<=5}function o(X,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(X)||oe.length>60)return null;const ve=l(oe);if(!t(ve)){if(!v(ve))return null;oe=oe.toLowerCase()}let Me=null,ze=0;for(X=X.toLowerCase();ze<oe.length&&(Me=a(X,oe,0,ze))===null;)ze=E(oe,ze+1);return Me}e.matchesCamelCase=o;function i(X,oe,ve=!1){if(!oe||oe.length===0)return null;let Me=null,ze=0;for(X=X.toLowerCase(),oe=oe.toLowerCase();ze<oe.length&&(Me=c(X,oe,0,ze,ve))===null;)ze=h(oe,ze+1);return Me}e.matchesWords=i;function c(X,oe,ve,Me,ze){if(ve===X.length)return[];if(Me===oe.length)return null;if(p(X.charCodeAt(ve),oe.charCodeAt(Me))){let Qe=null,et=Me+1;if(Qe=c(X,oe,ve+1,Me+1,ze),!ze)for(;!Qe&&(et=h(oe,et))<oe.length;)Qe=c(X,oe,ve+1,et,ze),et++;return Qe===null?null:A({start:Me,end:Me+1},Qe)}else return null}function h(X,oe){for(let ve=oe;ve<X.length;ve++)if(u(X.charCodeAt(ve))||ve>0&&u(X.charCodeAt(ve-1)))return ve;return X.length}const m=I(e.matchesPrefix,o,T),w=I(e.matchesPrefix,o,D),S=new g.LRUCache(1e4);function s(X,oe,ve=!1){if(typeof X!="string"||typeof oe!="string")return null;let Me=S.get(X);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(X),"i"),S.set(X,Me));const ze=Me.exec(oe);return ze?[{start:ze.index,end:ze.index+ze[0].length}]:ve?w(X,oe):m(X,oe)}e.matchesFuzzy=s;function b(X,oe){const ve=Be(X,X.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return ve?O(ve):null}e.matchesFuzzy2=b;function R(X,oe,ve,Me,ze,Qe){const et=Math.min(13,X.length);for(;ve<et;ve++){const ke=Be(X,oe,ve,Me,ze,Qe,!1);if(ke)return ke}return[0,Qe]}e.anyScore=R;function O(X){if(typeof X=="undefined")return[];const oe=[],ve=X[1];for(let Me=X.length-1;Me>1;Me--){const ze=X[Me]+ve,Qe=oe[oe.length-1];Qe&&Qe.end===ze?Qe.end=ze+1:oe.push({start:ze,end:ze+1})}return oe}e.createMatches=O;const $=128;function G(){const X=[],oe=[];for(let ve=0;ve<=$;ve++)oe[ve]=0;for(let ve=0;ve<=$;ve++)X.push(oe.slice(0));return X}function Z(X){const oe=[];for(let ve=0;ve<=X;ve++)oe[ve]=0;return oe}const U=Z(2*$),x=Z(2*$),M=G(),H=G(),F=G(),N=!1;function j(X,oe,ve,Me,ze){function Qe(ke,ct,K=" "){for(;ke.length<ct;)ke=K+ke;return ke}let et=` |   |${Me.split("").map(ke=>Qe(ke,3)).join("|")}
`;for(let ke=0;ke<=ve;ke++)ke===0?et+=" |":et+=`${oe[ke-1]}|`,et+=X[ke].slice(0,ze+1).map(ct=>Qe(ct.toString(),3)).join("|")+`
`;return et}function W(X,oe,ve,Me){X=X.substr(oe),ve=ve.substr(Me),console.log(j(H,X,X.length,ve,ve.length)),console.log(j(F,X,X.length,ve,ve.length)),console.log(j(M,X,X.length,ve,ve.length))}function Q(X,oe){if(oe<0||oe>=X.length)return!1;const ve=X.codePointAt(oe);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function J(X,oe){if(oe<0||oe>=X.length)return!1;switch(X.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function fe(X,oe,ve){return oe[X]!==ve[X]}function _e(X,oe,ve,Me,ze,Qe,et=!1){for(;oe<ve&&ze<Qe;)X[oe]===Me[ze]&&(et&&(U[oe]=ze),oe+=1),ze+=1;return oe===ve}e.isPatternInWord=_e;var ye;(function(X){X[X.Diag=1]="Diag",X[X.Left=2]="Left",X[X.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Le;(function(X){X.Default=[-100,0];function oe(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}X.isDefault=oe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function Be(X,oe,ve,Me,ze,Qe,et){const ke=X.length>$?$:X.length,ct=Me.length>$?$:Me.length;if(ve>=ke||Qe>=ct||ke-ve>ct-Qe||!_e(oe,ve,ke,ze,Qe,ct,!0))return;xe(ke,ct,ve,Qe,oe,ze);let K=1,te=1,pe=ve,Ve=Qe;const tt=[!1];for(K=1,pe=ve;pe<ke;K++,pe++){const ue=U[pe],Ie=x[pe],Ne=pe+1<ke?x[pe+1]:ct;for(te=ue-Qe+1,Ve=ue;Ve<Ne;te++,Ve++){let Ge=Number.MIN_SAFE_INTEGER,We=!1;Ve<=Ie&&(Ge=Ke(X,oe,pe,ve,Me,ze,Ve,ct,Qe,M[K-1][te-1]===0,tt));let ot=0;Ge!==Number.MAX_SAFE_INTEGER&&(We=!0,ot=Ge+H[K-1][te-1]);const Re=Ve>ue,Se=Re?H[K][te-1]+(M[K][te-1]>0?-5:0):0,Ce=Ve>ue+1&&M[K][te-1]>0,ne=Ce?H[K][te-2]+(M[K][te-2]>0?-5:0):0;if(Ce&&(!Re||ne>=Se)&&(!We||ne>=ot))H[K][te]=ne,F[K][te]=3,M[K][te]=0;else if(Re&&(!We||Se>=ot))H[K][te]=Se,F[K][te]=2,M[K][te]=0;else if(We)H[K][te]=ot,F[K][te]=1,M[K][te]=M[K-1][te-1]+1;else throw new Error("not possible")}}if(N&&W(X,ve,Me,Qe),!tt[0]&&!et)return;K--,te--;const st=[H[K][te],Qe];let lt=0,vt=0;for(;K>=1;){let ue=te;do{const Ie=F[K][ue];if(Ie===3)ue=ue-2;else if(Ie===2)ue=ue-1;else break}while(ue>=1);lt>1&&oe[ve+K-1]===ze[Qe+te-1]&&!fe(ue+Qe-1,Me,ze)&&lt+1>M[K][ue]&&(ue=te),ue===te?lt++:lt=1,vt||(vt=ue),K--,te=ue-1,st.push(te)}ct===ke&&(st[0]+=2);const Dt=vt-ke;return st[0]-=Dt,st}e.fuzzyScore=Be;function xe(X,oe,ve,Me,ze,Qe){let et=X-1,ke=oe-1;for(;et>=ve&&ke>=Me;)ze[et]===Qe[ke]&&(x[et]=ke,et--),ke--}function Ke(X,oe,ve,Me,ze,Qe,et,ke,ct,K,te){if(oe[ve]!==Qe[et])return Number.MIN_SAFE_INTEGER;let pe=1,Ve=!1;return et===ve-Me?pe=X[ve]===ze[et]?7:5:fe(et,ze,Qe)&&(et===0||!fe(et-1,ze,Qe))?(pe=X[ve]===ze[et]?7:5,Ve=!0):Q(Qe,et)&&(et===0||!Q(Qe,et-1))?pe=5:(Q(Qe,et-1)||J(Qe,et-1))&&(pe=5,Ve=!0),pe>1&&ve===Me&&(te[0]=!0),Ve||(Ve=fe(et,ze,Qe)||Q(Qe,et-1)||J(Qe,et-1)),ve===Me?et>ct&&(pe-=Ve?3:5):K?pe+=Ve?2:0:pe+=Ve?0:1,et+1===ke&&(pe-=Ve?3:5),pe}function z(X,oe,ve,Me,ze,Qe,et){return re(X,oe,ve,Me,ze,Qe,!0,et)}e.fuzzyScoreGracefulAggressive=z;function ee(X,oe,ve,Me,ze,Qe,et){return re(X,oe,ve,Me,ze,Qe,!1,et)}e.fuzzyScoreGraceful=ee;function re(X,oe,ve,Me,ze,Qe,et,ke){let ct=Be(X,oe,ve,Me,ze,Qe,ke);if(ct&&!et)return ct;if(X.length>=3){const K=Math.min(7,X.length-1);for(let te=ve+1;te<K;te++){const pe=le(X,te);if(pe){const Ve=Be(pe,pe.toLowerCase(),ve,Me,ze,Qe,ke);Ve&&(Ve[0]-=3,(!ct||Ve[0]>ct[0])&&(ct=Ve))}}}return ct}function le(X,oe){if(oe+1>=X.length)return;const ve=X[oe],Me=X[oe+1];if(ve!==Me)return X.slice(0,oe)+Me+ve+X.slice(oe+2)}}),define(me[142],ge([0,1,47,98,9]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${C.source}`,"g");function D(p){return p.replace(T,(_,A)=>A?_:`\\${_}`)}e.escapeIcons=D;const y=new RegExp(`\\\\${C.source}`,"g");function P(p){return p.replace(y,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=P;const n=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function k(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(n,(_,A,E,a)=>E?_:A||a||"")}e.stripIcons=k;function d(p){const _=p.indexOf(e.iconStartMarker);return _===-1?{text:p}:f(p,_)}e.parseLabelWithIcons=d;function f(p,_){const A=[];let E="";function a(h){if(h){E+=h;for(const m of h)A.push(t)}}let l=-1,v="",t=0,r,o,i=_;const c=p.length;for(a(p.substr(0,_));i<c;)r=p[i],o=p[i+1],r===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(l=i,a(v),v=e.iconStartMarker,i++):r===")"&&l!==-1?(t+=i-l+1,l=-1,v=""):l!==-1?/^[a-z0-9\-]$/i.test(r)?v+=r:(a(v),l=-1,v=""):a(r),i++;return a(v),{text:E,iconOffsets:A}}function u(p,_,A=!1){const{text:E,iconOffsets:a}=_;if(!a||a.length===0)return(0,L.matchesFuzzy)(p,E,A);const l=(0,I.ltrim)(E," "),v=E.length-l.length,t=(0,L.matchesFuzzy)(p,l,A);if(t)for(const r of t){const o=a[r.start+v]+v;r.start+=o,r.end+=o}return t}e.matchesFuzzyIconAware=u}),define(me[99],ge([0,1,16,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(f="",u=!1){if(this.value=f,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(f,u=0){return this.value+=P(this.supportThemeIcons?(0,L.escapeIcons)(f):f).replace(/([ \t]+)/g,(p,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,u){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=C;function T(d){return D(d)?!d.value:Array.isArray(d)?d.every(T):!0}e.isEmptyMarkdownString=T;function D(d){return d instanceof C?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function y(d,f){return d===f?!0:!d||!f?!1:d.value===f.value&&d.isTrusted===f.isTrusted&&d.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=y;function P(d){return d.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function n(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function k(d){const f=[],u=d.split("|").map(_=>_.trim());d=u[0];const p=u[1];if(p){const _=/height=(\d+)/.exec(p),A=/width=(\d+)/.exec(p),E=_?_[1]:"",a=A?A[1]:"",l=isFinite(parseInt(a)),v=isFinite(parseInt(E));l&&f.push(`width="${a}"`),v&&f.push(`height="${E}"`)}return{href:d,dimensions:f}}e.parseHrefAndDimensions=k}),define(me[59],ge([0,1,22,9,2]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(n){return JSON.stringify(n,y)}e.stringify=C;function T(n){let k=JSON.parse(n);return k=P(k),k}e.parse=T;var D;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function y(n,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,L.regExpFlags)(k)}:k}function P(n,k=0){if(!n||k>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return I.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof g.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let d=0;d<n.length;++d)n[d]=P(n[d],k+1);else for(const d in n)Object.hasOwnProperty.call(n,d)&&(n[d]=P(n[d],k+1))}return n}e.revive=P}),define(me[10],ge([0,1,11,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(I=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,P,n){this._hosts[y]=P,this._ports[y]=n}setConnectionToken(y,P){this._connectionTokens[y]=P}rewrite(y){if(this._delegate)return this._delegate(y);const P=y.authority;let n=this._hosts[P];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const k=this._ports[P],d=this._connectionTokens[P];let f=`path=${encodeURIComponent(y.path)}`;return typeof d=="string"&&(f+=`&tkn=${encodeURIComponent(d)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${n}:${k}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new C;class T{asBrowserUri(y,P){const n=this.toUri(y,P);return n.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===I.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${I.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?n.with({scheme:I.vscodeFileResource,authority:n.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(y,P){const n=this.toUri(y,P);return n.scheme===I.vscodeFileResource?n.with({scheme:I.file,authority:n.authority!==T.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,P){return L.URI.isUri(y)?y:L.URI.parse(P.toUrl(y))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(me[78],ge([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function I(P){return y(P,"NFC",L)}e.normalizeNFC=I;const C=new g.LRUCache(1e4);function T(P){return y(P,"NFD",C)}e.normalizeNFD=T;const D=/[^\u0000-\u0080]/;function y(P,n,k){if(!P)return P;const d=k.get(P);if(d)return d;let f;return D.test(P)?f=P.normalize(n):f=P,k.set(P,f),f}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(n){return T(n).replace(P,"")}}()}),define(me[25],ge([0,1,29,10,8,11,9,2]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,D.uriToFsPath)(f,!0)}e.originalFSPath=y;class P{constructor(u){this._ignorePathCasing=u}compare(u,p,_=!1){return u===p?0:(0,T.compare)(this.getComparisonKey(u,_),this.getComparisonKey(p,_))}isEqual(u,p,_=!1){return u===p?!0:!u||!p?!1:this.getComparisonKey(u,_)===this.getComparisonKey(p,_)}getComparisonKey(u,p=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,p,_=!1){if(u.scheme===p.scheme){if(u.scheme===L.Schemas.file)return g.isEqualOrParent(y(u),y(p),this._ignorePathCasing(u))&&u.query===p.query&&(_||u.fragment===p.fragment);if((0,e.isEqualAuthority)(u.authority,p.authority))return g.isEqualOrParent(u.path,p.path,this._ignorePathCasing(u),"/")&&u.query===p.query&&(_||u.fragment===p.fragment)}return!1}joinPath(u,...p){return D.URI.joinPath(u,...p)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return I.posix.basename(u.path)}extname(u){const p=I.posix.extname(u.path),_=p.indexOf("?");return _!==-1?p.substr(0,_):p}dirname(u){if(u.path.length===0)return u;let p;return u.scheme===L.Schemas.file?p=D.URI.file(I.dirname(y(u))).path:(p=I.posix.dirname(u.path),u.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),p="/")),u.with({path:p})}normalizePath(u){if(!u.path.length)return u;let p;return u.scheme===L.Schemas.file?p=D.URI.file(I.normalize(y(u))).path:p=I.posix.normalize(u.path),u.with({path:p})}relativePath(u,p){if(u.scheme!==p.scheme||!(0,e.isEqualAuthority)(u.authority,p.authority))return;if(u.scheme===L.Schemas.file){const E=I.relative(y(u),y(p));return C.isWindows?g.toSlashes(E):E}let _=u.path||"/",A=p.path||"/";if(this._ignorePathCasing(u)){let E=0;for(const a=Math.min(_.length,A.length);E<a&&!(_.charCodeAt(E)!==A.charCodeAt(E)&&_.charAt(E).toLowerCase()!==A.charAt(E).toLowerCase());E++);_=A.substr(0,E)+_.substr(E)}return I.posix.relative(_,A)}resolvePath(u,p){if(u.scheme===L.Schemas.file){const _=D.URI.file(I.resolve(y(u),p));return u.with({authority:_.authority,path:_.path})}return p=g.toPosixPath(p),u.with({path:I.posix.resolve(u.path,p)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,p){return u===p||(0,T.equalsIgnoreCase)(u,p)}hasTrailingPathSeparator(u,p=I.sep){if(u.scheme===L.Schemas.file){const _=y(u);return _.length>g.getRoot(_).length&&_[_.length-1]===p}else{const _=u.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,p=I.sep){return(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,p=I.sep){let _=!1;if(u.scheme===L.Schemas.file){const A=y(u);_=A!==void 0&&A.length===g.getRoot(A).length&&A[A.length-1]===p}else{p="/";const A=u.path;_=A.length===1&&A.charCodeAt(A.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path+"/"}):u}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(f=>f.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new P(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,u){const p=[];for(let _=0;_<f.length;_++){const A=u(f[_]);f.some((E,a)=>a===_?!1:(0,e.isEqualOrParent)(A,u(E)))||p.push(f[_])}return p}e.distinctParents=n;var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function u(p){const _=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(a=>{const[l,v]=a.split(":");l&&v&&_.set(l,v)});const E=p.path.substring(0,p.path.indexOf(";"));return E&&_.set(f.META_DATA_MIME,E),_}f.parseMetaData=u})(k=e.DataUri||(e.DataUri={}));function d(f,u,p){if(u){let _=f.path;return _&&_[0]!==I.posix.sep&&(_=I.posix.sep+_),f.with({scheme:p,authority:u,path:_})}return f.with({scheme:p})}e.toLocalResource=d}),define(me[17],ge([0,1,21,16,3,6,25]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(x){return!!x&&typeof x.then=="function"}e.isThenable=D;function y(x){const M=new g.CancellationTokenSource,H=x(M.token),F=new Promise((N,j)=>{const W=M.token.onCancellationRequested(()=>{W.dispose(),M.dispose(),j((0,L.canceled)())});Promise.resolve(H).then(Q=>{W.dispose(),M.dispose(),N(Q)},Q=>{W.dispose(),M.dispose(),j(Q)})});return new class{cancel(){M.cancel()}then(N,j){return F.then(N,j)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=y;function P(x,M,H){return Promise.race([x,new Promise(F=>M.onCancellationRequested(()=>F(H)))])}e.raceCancellation=P;async function n(x){let M=-1;const H=x.map((N,j)=>N.then(W=>(M=j,W))),F=await Promise.race(H);return x.forEach((N,j)=>{j!==M&&N.cancel()}),F}e.raceCancellablePromises=n;function k(x,M,H){let F;const N=setTimeout(()=>{F?.(void 0),H?.()},M);return Promise.race([x.finally(()=>clearTimeout(N)),new Promise(j=>F=j)])}e.raceTimeout=k;function d(x){return new Promise((M,H)=>{const F=x();D(F)?F.then(M,H):M(F)})}e.asPromise=d;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(H,H).then(F)})}return new Promise((H,F)=>{this.queuedPromise.then(H,F)})}return this.activePromise=M(),new Promise((H,F)=>{this.activePromise.then(N=>{this.activePromise=null,H(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=f;class u{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=u;class p{constructor(){this.promiseMap=new Map}queue(M,H){const N=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(M)===N&&this.promiseMap.delete(M)});return this.promiseMap.set(M,N),N}}e.SequencerByKey=p;class _{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,H=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class A{constructor(M){this.delayer=new _(M),this.throttler=new f}trigger(M,H){return this.delayer.trigger(()=>this.throttler.queue(M),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=A;class E{constructor(){this._isOpen=!1,this._promise=new Promise((M,H)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class a extends E{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(x,M){return M?new Promise((H,F)=>{const N=setTimeout(()=>{j.dispose(),H()},x),j=M.onCancellationRequested(()=>{clearTimeout(N),j.dispose(),F((0,L.canceled)())})}):y(H=>l(x,H))}e.timeout=l;function v(x,M=0){const H=setTimeout(x,M);return(0,C.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=v;function t(x){const M=[];let H=0;const F=x.length;function N(){return H<F?x[H++]():null}function j(W){W!=null&&M.push(W);const Q=N();return Q?Q.then(j):Promise.resolve(M)}return Promise.resolve(null).then(j)}e.sequence=t;function r(x,M=F=>!!F,H=null){let F=0;const N=x.length,j=()=>{if(F>=N)return Promise.resolve(H);const W=x[F++];return Promise.resolve(W()).then(J=>M(J)?Promise.resolve(J):j())};return j()}e.first=r;function o(x,M=F=>!!F,H=null){if(x.length===0)return Promise.resolve(H);let F=x.length;const N=()=>{F=-1;for(const j of x)j.cancel?.()};return new Promise((j,W)=>{for(const Q of x)Q.then(J=>{--F>=0&&M(J)?(N(),j(J)):F===0&&j(H)}).catch(J=>{--F>=0&&(N(),W(J))})})}e.firstParallel=o;class i{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((H,F)=>{this.outstandingPromises.push({factory:M,c:H,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const H=M.factory();H.then(M.c,M.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class h{constructor(){this.queues=new Map}queueFor(M,H=T.extUri){const F=H.getComparisonKey(M);let N=this.queues.get(F);return N||(N=new c,I.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=h;class m{constructor(M,H){this._token=-1,typeof M=="function"&&typeof H=="number"&&this.setIfNotSet(M,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},H)}setIfNotSet(M,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},H))}}e.TimeoutTimer=m;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,H){this.cancel(),this._token=setInterval(()=>{M()},H)}}e.IntervalTimer=w;class S{constructor(M,H){this.timeoutToken=-1,this.runner=M,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=S;class s extends S{constructor(M,H){super(M,H);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=s;class b extends C.Disposable{constructor(M,H,F,N){super();this.maxWorkChunkSize=M,this.maxPendingWork=H,this.throttleDelay=F,this.handler=N,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new S(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=b,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const H=setTimeout(()=>M(x));let F=!1;return{dispose(){F||(F=!0,clearTimeout(H))}}}}else e.runWhenIdle=(x,M)=>{const H=requestIdleCallback(x,typeof M=="number"?{timeout:M}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(H))}}}}();class R{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function O(x,M,H){let F;for(let N=0;N<H;N++)try{return await x()}catch(j){F=j,await l(M)}throw F}e.retry=O;class ${hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,H,F){return this._pending={taskId:M,cancel:()=>F?.(),promise:H},H.then(()=>this.donePending(M),()=>this.donePending(M)),H}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let H,F;const N=new Promise((j,W)=>{H=j,F=W});this._next={run:M,promise:N,promiseResolve:H,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=$;class G{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class Z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,H)=>{this.completeCallback=M,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(H=>{this.completeCallback(M),this.resolved=!0,H()})}error(M){return new Promise(H=>{this.errorCallback(M),this.rejected=!0,H()})}cancel(){new Promise(M=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=Z;var U;(function(x){async function M(H){let F;const N=await Promise.all(H.map(j=>j.then(W=>W,W=>{F||(F=W)})));if(typeof F!="undefined")throw F;return N}x.settled=M})(U=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,17,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new g.IdleValue(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),C=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(S,s,b=!1){const R=S||"",O=s||"",$=I.value.collator.compare(R,O);return I.value.collatorIsNumeric&&$===0&&R!==O?R<O?-1:1:$}e.compareFileNames=D;function y(S,s){const b=C.value.collator;return S=S||"",s=s||"",v(b,S,s)}e.compareFileNamesDefault=y;function P(S,s){const b=C.value.collator;return S=S||"",s=s||"",i(S,s)||v(b,S,s)}e.compareFileNamesUpper=P;function n(S,s){const b=C.value.collator;return S=S||"",s=s||"",o(S,s)||v(b,S,s)}e.compareFileNamesLower=n;function k(S,s){return S=S||"",s=s||"",S===s?0:S<s?-1:1}e.compareFileNamesUnicode=k;function d(S,s,b=!1){b||(S=S&&S.toLowerCase(),s=s&&s.toLowerCase());const[R,O]=a(S),[$,G]=a(s);return R!==$?R<$?-1:1:O===G?0:O<G?-1:1}e.noIntlCompareFileNames=d;function f(S,s){const[b,R]=a(S),[O,$]=a(s);let G=I.value.collator.compare(R,$);if(G===0){if(I.value.collatorIsNumeric&&R!==$)return R<$?-1:1;if(G=I.value.collator.compare(b,O),I.value.collatorIsNumeric&&G===0&&b!==O)return b<O?-1:1}return G}e.compareFileExtensions=f;function u(S,s){S=S||"",s=s||"";const b=l(S),R=l(s),O=C.value.collator,$=T.value.collator;return v($,b,R)||v(O,S,s)}e.compareFileExtensionsDefault=u;function p(S,s){S=S||"",s=s||"";const b=l(S),R=l(s),O=C.value.collator,$=T.value.collator;return v($,b,R)||i(S,s)||v(O,S,s)}e.compareFileExtensionsUpper=p;function _(S,s){S=S||"",s=s||"";const b=l(S),R=l(s),O=C.value.collator,$=T.value.collator;return v($,b,R)||o(S,s)||v(O,S,s)}e.compareFileExtensionsLower=_;function A(S,s){S=S||"",s=s||"";const b=l(S).toLowerCase(),R=l(s).toLowerCase();return b!==R?b<R?-1:1:S!==s?S<s?-1:1:0}e.compareFileExtensionsUnicode=A;const E=/^(.*?)(\.([^.]*))?$/;function a(S,s=!1){const b=S?E.exec(S):[];let R=[b&&b[1]||"",b&&b[3]||""];return s&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function l(S){const s=S?E.exec(S):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function v(S,s,b){let R=S.compare(s,b);return R!==0?R:s.length!==b.length?s.length<b.length?-1:1:0}function t(S){const s=S.charAt(0);return s.toLocaleUpperCase()!==s}function r(S){const s=S.charAt(0);return s.toLocaleLowerCase()!==s}function o(S,s){return t(S)&&r(s)?-1:r(S)&&t(s)?1:0}function i(S,s){return r(S)&&t(s)?-1:t(S)&&r(s)?1:0}function c(S,s,b=!1){return b||(S=S&&S.toLowerCase(),s=s&&s.toLowerCase()),S===s?0:S<s?-1:1}function h(S,s,b=!1){const R=S.split(L.sep),O=s.split(L.sep),$=R.length-1,G=O.length-1;let Z,U;for(let x=0;;x++){if(Z=$===x,U=G===x,Z&&U)return D(R[x],O[x],b);if(Z)return-1;if(U)return 1;const M=c(R[x],O[x],b);if(M!==0)return M}}e.comparePaths=h;function m(S,s,b){const R=S.toLowerCase(),O=s.toLowerCase(),$=w(S,s,b);if($)return $;const G=R.endsWith(b),Z=O.endsWith(b);if(G!==Z)return G?-1:1;const U=D(R,O);return U!==0?U:R.localeCompare(O)}e.compareAnything=m;function w(S,s,b){const R=S.toLowerCase(),O=s.toLowerCase(),$=R.startsWith(b),G=O.startsWith(b);if($!==G)return $?-1:1;if($&&G){if(R.length<O.length)return-1;if(R.length>O.length)return 1}return 0}e.compareByPrefix=w}),define(me[101],ge([0,1,100,98,8,11,9]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,y=[D,[]];function P(U,x,M,H){if(!U||!x)return y;const F=U.length,N=x.length;if(F<N)return y;const j=U.toLowerCase();return!H&&!j.includes(M)?y:n(x,M,N,U,j,F)}e.scoreFuzzy=P;function n(U,x,M,H,F,N){const j=[],W=[];for(let _e=0;_e<M;_e++){const ye=_e*N,Le=ye-N,Be=_e>0,xe=U[_e],Ke=x[_e];for(let z=0;z<N;z++){const ee=z>0,re=ye+z,le=re-1,X=Le+z-1,oe=ee?j[le]:0,ve=Be&&ee?j[X]:0,Me=Be&&ee?W[X]:0;let ze;!ve&&Be?ze=0:ze=k(xe,Ke,H,F,z,Me),ze&&ve+ze>=oe?(W[re]=Me+1,j[re]=ve+ze):(W[re]=D,j[re]=oe)}}const Q=[];let J=M-1,fe=N-1;for(;J>=0&&fe>=0;){const _e=J*N+fe;W[_e]===D||(Q.push(fe),J--),fe--}return[j[M*N-1],Q.reverse()]}function k(U,x,M,H,F,N){let j=0;if(!d(x,H[F]))return j;if(j+=1,N>0&&(j+=N*5),U===M[F]&&(j+=1),F===0)j+=8;else{const W=f(M.charCodeAt(F-1));W?j+=W:(0,L.isUpper)(M.charCodeAt(F))&&(j+=2)}return j}function d(U,x){return U===x?!0:U==="/"||U==="\\"?x==="/"||x==="\\":!1}function f(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function p(U,x,M=0,H=0){const F=x;return F.values&&F.values.length>1?_(U,F.values,M,H):A(U,x,M,H)}e.scoreFuzzy2=p;function _(U,x,M,H){let F=0;const N=[];for(const j of x){const[W,Q]=A(U,j,M,H);if(typeof W!="number")return u;F+=W,N.push(...Q)}return[F,h(N)]}function A(U,x,M,H){const F=(0,L.fuzzyScore)(x.original,x.originalLowercase,M,U,U.toLowerCase(),H,!0);return F?[F[0],(0,L.createMatches)(F)]:u}const E=Object.freeze({score:0}),a=1<<18,l=1<<17,v=1<<16;function t(U,x,M,H,F){if(!U||!x.normalized)return E;const N=H.getItemLabel(U);if(!N)return E;const j=H.getItemDescription(U);let W;j?W=`${N}${j}${x.normalized}${Array.isArray(x.values)?x.values.length:""}${M}${x.expectExactMatch}`:W=`${N}${x.normalized}${Array.isArray(x.values)?x.values.length:""}${M}${x.expectExactMatch}`;const Q=F[W];if(Q)return Q;const J=r(N,j,H.getItemPath(U),x,M);return F[W]=J,J}e.scoreItemFuzzy=t;function r(U,x,M,H,F){const N=!M||!H.containsPathSeparator;return M&&(C.isLinux?H.pathNormalized===M:(0,T.equalsIgnoreCase)(H.pathNormalized,M))?{score:a,labelMatch:[{start:0,end:U.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:H.values&&H.values.length>1?o(U,x,M,H.values,N,F):i(U,x,M,H,N,F)}function o(U,x,M,H,F,N){let j=0;const W=[],Q=[];for(const J of H){const{score:fe,labelMatch:_e,descriptionMatch:ye}=i(U,x,M,J,F,N);if(fe===D)return E;j+=fe,_e&&W.push(..._e),ye&&Q.push(...ye)}return{score:j,labelMatch:h(W),descriptionMatch:h(Q)}}function i(U,x,M,H,F,N){if(F||!x){const[j,W]=P(U,H.normalized,H.normalizedLowercase,N&&!H.expectExactMatch);if(j){const Q=(0,L.matchesPrefix)(H.normalized,U);let J;return Q?(J=l,J+=Math.round(H.normalized.length/U.length*100)):J=v,{score:J+j,labelMatch:Q||c(W)}}}if(x){let j=x;M&&(j=`${x}${I.sep}`);const W=j.length,Q=`${j}${U}`,[J,fe]=P(Q,H.normalized,H.normalizedLowercase,N&&!H.expectExactMatch);if(J){const _e=c(fe),ye=[],Le=[];return _e.forEach(Be=>{Be.start<W&&Be.end>W?(ye.push({start:0,end:Be.end-W}),Le.push({start:Be.start,end:W})):Be.start>=W?ye.push({start:Be.start-W,end:Be.end-W}):Le.push(Be)}),{score:J,labelMatch:ye,descriptionMatch:Le}}}return E}function c(U){const x=[];if(!U)return x;let M;for(const H of U)M&&M.end===H?M.end+=1:(M={start:H,end:H+1},x.push(M));return x}function h(U){const x=U.sort((F,N)=>F.start-N.start),M=[];let H;for(const F of x)!H||!m(H,F)?(H=F,M.push(F)):(H.start=Math.min(H.start,F.start),H.end=Math.max(H.end,F.end));return M}function m(U,x){return!(U.end<x.start||x.end<U.start)}function w(U,x,M,H,F,N){const j=t(U,M,H,F,N),W=t(x,M,H,F,N),Q=j.score,J=W.score;if((Q===a||J===a)&&Q!==J)return Q===a?-1:1;if(Q>v||J>v){if(Q!==J)return Q>J?-1:1;if(Q<l&&J<l){const Ke=s(j.labelMatch,W.labelMatch);if(Ke!==0)return Ke}const Be=F.getItemLabel(U)||"",xe=F.getItemLabel(x)||"";if(Be.length!==xe.length)return Be.length-xe.length}if(Q!==J)return Q>J?-1:1;const fe=Array.isArray(j.labelMatch)&&j.labelMatch.length>0,_e=Array.isArray(W.labelMatch)&&W.labelMatch.length>0;if(fe&&!_e)return-1;if(_e&&!fe)return 1;const ye=S(U,j,F),Le=S(x,W,F);return ye&&Le&&ye!==Le?Le>ye?-1:1:b(U,x,M,F)}e.compareItemsByFuzzyScore=w;function S(U,x,M){let H=-1,F=-1;if(x.descriptionMatch&&x.descriptionMatch.length?H=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(H=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(F=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const N=M.getItemDescription(U);N&&(F+=N.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(F=x.descriptionMatch[x.descriptionMatch.length-1].end);return F-H}function s(U,x){if(!U&&!x||(!U||!U.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!U||!U.length)return 1;const M=U[0].start,F=U[U.length-1].end-M,N=x[0].start,W=x[x.length-1].end-N;return F===W?0:W<F?1:-1}function b(U,x,M,H){const F=H.getItemLabel(U)||"",N=H.getItemLabel(x)||"",j=H.getItemDescription(U),W=H.getItemDescription(x),Q=F.length+(j?j.length:0),J=N.length+(W?W.length:0);if(Q!==J)return Q-J;const fe=H.getItemPath(U),_e=H.getItemPath(x);return fe&&_e&&fe.length!==_e.length?fe.length-_e.length:F!==N?(0,g.compareAnything)(F,N,M.normalized):j&&W&&j!==W?(0,g.compareAnything)(j,W,M.normalized):fe&&_e&&fe!==_e?(0,g.compareAnything)(fe,_e,M.normalized):0}function R(U){return U.startsWith('"')&&U.endsWith('"')}const O=" ";function $(U){typeof U!="string"&&(U="");const x=U.toLowerCase(),{pathNormalized:M,normalized:H,normalizedLowercase:F}=G(U),N=M.indexOf(I.sep)>=0,j=R(U);let W;const Q=U.split(O);if(Q.length>1)for(const J of Q){const fe=R(J),{pathNormalized:_e,normalized:ye,normalizedLowercase:Le}=G(J);ye&&(W||(W=[]),W.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:_e,normalized:ye,normalizedLowercase:Le,expectExactMatch:fe}))}return{original:U,originalLowercase:x,pathNormalized:M,normalized:H,normalizedLowercase:F,values:W,containsPathSeparator:N,expectExactMatch:j}}e.prepareQuery=$;function G(U){let x;C.isWindows?x=U.replace(/\//g,I.sep):x=U.replace(/\\/g,I.sep);const M=(0,T.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:M,normalizedLowercase:M.toLowerCase()}}function Z(U){return Array.isArray(U)?$(U.map(x=>x.original).join(O)):$(U.original)}e.pieceToQuery=Z}),define(me[30],ge([0,1,17,29,24,8,9]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",P="/",n="[/\\\\]",k="[^/\\\\]",d=/\//g;function f(N){switch(N){case 0:return"";case 1:return`${k}*?`;default:return`(?:${n}|${k}+${n}|${n}${k}+)*?`}}function u(N,j){if(!N)return[];const W=[];let Q=!1,J=!1,fe="";for(const _e of N){switch(_e){case j:if(!Q&&!J){W.push(fe),fe="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":J=!0;break;case"]":J=!1;break}fe+=_e}return fe&&W.push(fe),W}e.splitGlobAware=u;function p(N){if(!N)return"";let j="";const W=u(N,P);if(W.every(Q=>Q===y))j=".*";else{let Q=!1;W.forEach((J,fe)=>{if(J===y){Q||(j+=f(2),Q=!0);return}let _e=!1,ye="",Le=!1,Be="";for(const xe of J){if(xe!=="}"&&_e){ye+=xe;continue}if(Le&&(xe!=="]"||!Be)){let Ke;xe==="-"?Ke=xe:(xe==="^"||xe==="!")&&!Be?Ke="^":xe===P?Ke="":Ke=T.escapeRegExpCharacters(xe),Be+=Ke;continue}switch(xe){case"{":_e=!0;continue;case"[":Le=!0;continue;case"}":j+=`(?:${u(ye,",").map(ee=>p(ee)).join("|")})`,_e=!1,ye="";break;case"]":j+="["+Be+"]",Le=!1,Be="";break;case"?":j+=k;continue;case"*":j+=f(1);continue;default:j+=T.escapeRegExpCharacters(xe)}}fe<W.length-1&&(W[fe+1]!==y||fe+2<W.length)&&(j+=n),Q=!1})}return j}const _=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),r=function(){return!1},o=function(){return null};function i(N,j){if(!N)return o;let W;typeof N!="string"?W=N.pattern:W=N,W=W.trim();const Q=`${W}_${!!j.trimForExclusions}`;let J=t.get(Q);if(J)return c(J,N);let fe;if(_.test(W)){const _e=W.substr(4);J=function(ye,Le){return typeof ye=="string"&&ye.endsWith(_e)?W:null}}else(fe=A.exec(h(W,j)))?J=m(fe[1],W):(j.trimForExclusions?a:E).test(W)?J=w(W,j):(fe=l.exec(h(W,j)))?J=S(fe[1].substr(1),W,!0):(fe=v.exec(h(W,j)))?J=S(fe[1],W,!1):J=s(W);return t.set(Q,J),c(J,N)}function c(N,j){return typeof j=="string"?N:function(W,Q){return L.isEqualOrParent(W,j.base)?N(C.relative(j.base,W),Q):null}}function h(N,j){return j.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function m(N,j){const W=`/${N}`,Q=`\\${N}`,J=function(_e,ye){return typeof _e!="string"?null:ye?ye===N?j:null:_e===N||_e.endsWith(W)||_e.endsWith(Q)?j:null},fe=[N];return J.basenames=fe,J.patterns=[j],J.allBasenames=fe,J}function w(N,j){const W=F(N.slice(1,-1).split(",").map(ye=>i(ye,j)).filter(ye=>ye!==o),N),Q=W.length;if(!Q)return o;if(Q===1)return W[0];const J=function(ye,Le){for(let Be=0,xe=W.length;Be<xe;Be++)if(W[Be](ye,Le))return N;return null},fe=W.find(ye=>!!ye.allBasenames);fe&&(J.allBasenames=fe.allBasenames);const _e=W.reduce((ye,Le)=>Le.allPaths?ye.concat(Le.allPaths):ye,[]);return _e.length&&(J.allPaths=_e),J}function S(N,j,W){const Q=C.sep===C.posix.sep,J=Q?N:N.replace(d,C.sep),fe=C.sep+J,_e=C.posix.sep+N,ye=W?function(Le,Be){return typeof Le=="string"&&(Le===J||Le.endsWith(fe)||!Q&&(Le===N||Le.endsWith(_e)))?j:null}:function(Le,Be){return typeof Le=="string"&&(Le===J||!Q&&Le===N)?j:null};return ye.allPaths=[(W?"*/":"./")+N],ye}function s(N){try{const j=new RegExp(`^${p(N)}$`);return function(W){return j.lastIndex=0,typeof W=="string"&&j.test(W)?N:null}}catch(j){return o}}function b(N,j,W){return!N||typeof j!="string"?!1:R(N)(j,void 0,W)}e.match=b;function R(N,j={}){if(!N)return r;if(typeof N=="string"||Z(N)){const W=i(N,j);if(W===o)return r;const Q=function(J,fe){return!!W(J,fe)};return W.allBasenames&&(Q.allBasenames=W.allBasenames),W.allPaths&&(Q.allPaths=W.allPaths),Q}return M(N,j)}e.parse=R;function O(N){if(!N)return;let j;return W=>(j||(j=(N()||Promise.resolve([])).then(Q=>Q?G(Q):{})),j.then(Q=>!!Q[W]))}e.hasSiblingPromiseFn=O;function $(N){if(!N)return;let j;return W=>{if(!j){const Q=N();j=Q?G(Q):{}}return!!j[W]}}e.hasSiblingFn=$;function G(N){const j={};for(const W of N)j[W]=!0;return j}function Z(N){const j=N;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=Z;function U(N){return N.allBasenames||[]}e.getBasenameTerms=U;function x(N){return N.allPaths||[]}e.getPathTerms=x;function M(N,j){const W=F(Object.getOwnPropertyNames(N).map(ye=>H(ye,N[ye],j)).filter(ye=>ye!==o)),Q=W.length;if(!Q)return o;if(!W.some(ye=>!!ye.requiresSiblings)){if(Q===1)return W[0];const ye=function(xe,Ke){for(let z=0,ee=W.length;z<ee;z++){const re=W[z](xe,Ke);if(re)return re}return null},Le=W.find(xe=>!!xe.allBasenames);Le&&(ye.allBasenames=Le.allBasenames);const Be=W.reduce((xe,Ke)=>Ke.allPaths?xe.concat(Ke.allPaths):xe,[]);return Be.length&&(ye.allPaths=Be),ye}const J=function(ye,Le,Be){let xe;for(let Ke=0,z=W.length;Ke<z;Ke++){const ee=W[Ke];ee.requiresSiblings&&Be&&(Le||(Le=C.basename(ye)),xe||(xe=Le.substr(0,Le.length-C.extname(ye).length)));const re=ee(ye,Le,xe,Be);if(re)return re}return null},fe=W.find(ye=>!!ye.allBasenames);fe&&(J.allBasenames=fe.allBasenames);const _e=W.reduce((ye,Le)=>Le.allPaths?ye.concat(Le.allPaths):ye,[]);return _e.length&&(J.allPaths=_e),J}function H(N,j,W){if(j===!1)return o;const Q=i(N,W);if(Q===o)return o;if(typeof j=="boolean")return Q;if(j){const J=j.when;if(typeof J=="string"){const fe=(_e,ye,Le,Be)=>{if(!Be||!Q(_e,ye))return null;const xe=J.replace("$(basename)",Le),Ke=Be(xe);return(0,g.isThenable)(Ke)?Ke.then(z=>z?N:null):Ke?N:null};return fe.requiresSiblings=!0,fe}}return Q}function F(N,j){const W=N.filter(ye=>!!ye.basenames);if(W.length<2)return N;const Q=W.reduce((ye,Le)=>{const Be=Le.basenames;return Be?ye.concat(Be):ye},[]);let J;if(j){J=[];for(let ye=0,Le=Q.length;ye<Le;ye++)J.push(j)}else J=W.reduce((ye,Le)=>{const Be=Le.patterns;return Be?ye.concat(Be):ye},[]);const fe=function(ye,Le){if(typeof ye!="string")return null;if(!Le){let xe;for(xe=ye.length;xe>0;xe--){const Ke=ye.charCodeAt(xe-1);if(Ke===47||Ke===92)break}Le=ye.substr(xe)}const Be=Q.indexOf(Le);return Be!==-1?J[Be]:null};fe.basenames=Q,fe.patterns=J,fe.allBasenames=Q;const _e=N.filter(ye=>!ye.basenames);return _e.push(fe),_e}}),define(me[79],ge([0,1,29,10,8,11,25,9,2]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,c,h){if(typeof i=="string"&&(i=y.URI.file(i)),h){const w=h.getWorkspaceFolder(i);if(w){const S=h.getWorkspace().folders.length>1;let s;if((0,T.isEqual)(w.uri,i)?s="":s=(0,T.relativePath)(w.uri,i),S){const b=w.name?w.name:(0,T.basename)(w.uri);s=s?b+" \u2022 "+s:b}return s}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(i.fsPath))return(0,I.normalize)(k(i.fsPath));let m=(0,I.normalize)(i.fsPath);return!C.isWindows&&c?.userHome&&(m=f(m,c.userHome.fsPath)),m}e.getPathLabel=P;function n(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const c=(0,T.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,g.isRootOrDriveLetter)(c)?k(c):c}e.getBaseLabel=n;function k(i){return(0,g.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=k;let d=Object.create(null);function f(i,c){if(C.isWindows||!i||!c)return i;let h=d.original===c?d.normalized:void 0;return h||(h=`${(0,D.rtrim)(c,I.posix.sep)}${I.posix.sep}`,d={original:c,normalized:h}),(C.isLinux?i.startsWith(h):(0,D.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=f;function u(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const p="\u2026",_="\\\\",A="~";function E(i,c=I.sep){const h=new Array(i.length);let m=!1;for(let w=0;w<i.length;w++){let S=i[w];if(S===""){h[w]=`.${c}`;continue}if(!S){h[w]=S;continue}m=!0;let s="";S.indexOf(_)===0?(s=S.substr(0,S.indexOf(_)+_.length),S=S.substr(S.indexOf(_)+_.length)):S.indexOf(c)===0?(s=S.substr(0,S.indexOf(c)+c.length),S=S.substr(S.indexOf(c)+c.length)):S.indexOf(A)===0&&(s=S.substr(0,S.indexOf(A)+A.length),S=S.substr(S.indexOf(A)+A.length));const b=S.split(c);for(let R=1;m&&R<=b.length;R++)for(let O=b.length-R;m&&O>=0;O--){m=!1;let $=b.slice(O,O+R).join(c);for(let G=0;!m&&G<i.length;G++)if(G!==w&&i[G]&&i[G].indexOf($)>-1){const Z=O+R===b.length,U=O>0&&i[G].indexOf(c)>-1?c+$:$,x=i[G].endsWith(U);m=!Z||x}if(!m){let G="";(b[0].endsWith(":")||s!=="")&&(O===1&&(O=0,R++,$=b[0]+c+$),O>0&&(G=b[0]+c),G=s+G),O>0&&(G=G+p+c),G=G+$,O+R<b.length&&(G=G+c+p),h[w]=G}}m&&(h[w]=S)}return h}e.shorten=E;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function l(i,c=Object.create(null)){const h=[];let m=!1,w="";for(const S of i)if(S==="$"||m&&S==="{")w&&h.push({value:w,type:a.TEXT}),w="",m=!0;else if(S==="}"&&m){const s=c[w];if(typeof s=="string")s.length&&h.push({value:s,type:a.VARIABLE});else if(s){const b=h[h.length-1];(!b||b.type!==a.SEPARATOR)&&h.push({value:s.label,type:a.SEPARATOR})}w="",m=!1}else w+=S;return w&&!m&&h.push({value:w,type:a.TEXT}),h.filter((S,s)=>{if(S.type===a.SEPARATOR){const b=h[s-1],R=h[s+1];return[b,R].every(O=>O&&(O.type===a.VARIABLE||O.type===a.TEXT)&&O.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=l;function v(i,c){return C.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,c){return C.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(i){const c=i.indexOf("/")!==-1?I.posix:I.win32,h=c.basename(i),m=c.dirname(i);return h.length?{name:h,parentPath:m}:{name:m,parentPath:""}}e.splitName=o}),define(me[102],ge([0,1,30,10,8,25,9]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let y=[],P=[],n=[];function k(i,c=!1){const h=d(i);y.push(h),h.userConfigured?n.push(h):P.push(h),c&&!h.userConfigured&&y.forEach(m=>{m.mime===h.mime||m.userConfigured||(h.extension&&m.extension===h.extension&&console.warn(`Overwriting extension <<${h.extension}>> to now point to mime <<${h.mime}>>`),h.filename&&m.filename===h.filename&&console.warn(`Overwriting filename <<${h.filename}>> to now point to mime <<${h.mime}>>`),h.filepattern&&m.filepattern===h.filepattern&&console.warn(`Overwriting filepattern <<${h.filepattern}>> to now point to mime <<${h.mime}>>`),h.firstline&&m.firstline===h.firstline&&console.warn(`Overwriting firstline <<${h.firstline}>> to now point to mime <<${h.mime}>>`))})}e.registerTextMime=k;function d(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(I.posix.sep)>=0:!1}}function f(i){i?(y=y.filter(c=>!c.userConfigured),n=[]):(y=[],P=[],n=[])}e.clearTextMimes=f;function u(i,c){let h;if(i)switch(i.scheme){case L.Schemas.file:h=i.fsPath;break;case L.Schemas.data:h=C.DataUri.parseMetaData(i).get(C.DataUri.META_DATA_LABEL);break;default:h=i.path}if(!h)return[D.unknown];h=h.toLowerCase();const m=(0,I.basename)(h),w=p(h,m,n);if(w)return[w,D.text];const S=p(h,m,P);if(S)return[S,D.text];if(c){const s=_(c);if(s)return[s,D.text]}return[D.unknown]}e.guessMimeTypes=u;function p(i,c,h){let m=null,w=null,S=null;for(let s=h.length-1;s>=0;s--){const b=h[s];if(c===b.filenameLowercase){m=b;break}if(b.filepattern&&(!w||b.filepattern.length>w.filepattern.length)){const R=b.filepatternOnPath?i:c;(0,g.match)(b.filepatternLowercase,R)&&(w=b)}b.extension&&(!S||b.extension.length>S.extension.length)&&c.endsWith(b.extensionLowercase)&&(S=b)}return m?m.mime:w?w.mime:S?S.mime:null}function _(i){if((0,T.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let c=y.length-1;c>=0;c--){const h=y[c];if(!h.firstline)continue;const m=i.match(h.firstline);if(m&&m.length>0)return h.mime}return null}function A(i){return i?typeof i=="string"?i===D.binary||i===D.text||i===D.unknown:i.length===1&&A(i[0]):!0}e.isUnspecific=A;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(i){const c=(0,I.extname)(i),h=E[c.toLowerCase()];return h!==void 0?h:v(i)}e.getMediaOrTextMime=l;function v(i){const c=(0,I.extname)(i);return a[c.toLowerCase()]}e.getMediaMime=v;function t(i){for(const c in a)if(a[c]===i)return c}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function o(i,c){const h=r.exec(i);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:c?void 0:i}e.normalizeMimeType=o}),define(me[103],ge([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class I{constructor(k){this._uriTransformer=k}transformIncoming(k){const d=this._uriTransformer.transformIncoming(k);return d===k?k:L(g.URI.from(d))}transformOutgoing(k){const d=this._uriTransformer.transformOutgoing(k);return d===k?k:L(g.URI.from(d))}transformOutgoingURI(k){const d=this._uriTransformer.transformOutgoing(k);return d===k?k:g.URI.from(d)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function C(n,k,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return k.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const u=C(n[f],k,d+1);u!==null&&(n[f]=u)}}return null}function T(n,k){const d=C(n,k,0);return d===null?n:d}e.transformOutgoingURIs=T;function D(n,k,d,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?g.URI.revive(k.transformIncoming(n)):k.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const p=D(n[u],k,d,f+1);p!==null&&(n[u]=p)}}return null}function y(n,k){const d=D(n,k,!1,0);return d===null?n:d}e.transformIncomingURIs=y;function P(n,k){const d=D(n,k,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=P}),define(me[32],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(y){return g.test(y)}e.isUUID=L;const I=new Uint8Array(16),C=[];for(let y=0;y<256;y++)C.push(y.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(y){for(let P=0;P<y.length;P++)y[P]=Math.floor(Math.random()*256);return y};function D(){T(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let y=0,P="";return P+=C[I[y++]],P+=C[I[y++]],P+=C[I[y++]],P+=C[I[y++]],P+="-",P+=C[I[y++]],P+=C[I[y++]],P+="-",P+=C[I[y++]],P+=C[I[y++]],P+="-",P+=C[I[y++]],P+=C[I[y++]],P+="-",P+=C[I[y++]],P+=C[I[y++]],P+=C[I[y++]],P+=C[I[y++]],P+=C[I[y++]],P+=C[I[y++]],P}e.generateUuid=D}),define(me[143],ge([0,1,104]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new g.StringDecoder(C),this.remaining=null}write(C){const T=[],D=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(D.length<1)return T;let y=0,P,n=y;for(;n<D.length;)if(P=D.charCodeAt(n),P===13||P===10){if(T.push(D.substring(y,n)),n++,n<D.length){const k=P;P=D.charCodeAt(n),(k===13&&P===10||k===10&&P===13)&&n++}y=n}else n++;return this.remaining=y<D.length?D.substr(y):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,49,80,290,17,29,78,8,11,25,2,32]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function u(U,x=f.UNLINK){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return x===f.UNLINK?_(U):p(U)}async function p(U){try{const x=(0,y.join)((0,L.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(U,x)}catch(M){return _(U)}_(x).catch(M=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function _(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function A(U){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(U,{recursive:!0})}e.rimrafSync=A;async function E(U,x){return v(await(x?a(U):(0,I.promisify)(g.readdir)(U)))}async function a(U){try{return await(0,I.promisify)(g.readdir)(U,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const x=[],M=await E(U);for(const H of M){let F=!1,N=!1,j=!1;try{const W=await e.Promises.lstat((0,y.join)(U,H));F=W.isFile(),N=W.isDirectory(),j=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}x.push({name:H,isFile:()=>F,isDirectory:()=>N,isSymbolicLink:()=>j})}return x}function l(U){return v(g.readdirSync(U))}e.readdirSync=l;function v(U){return U.map(x=>typeof x=="string"?P.isMacintosh?(0,D.normalizeNFC)(x):x:(x.name=P.isMacintosh?(0,D.normalizeNFC)(x.name):x.name,x))}async function t(U){const x=await E(U),M=[];for(const H of x)await o.existsDirectory((0,y.join)(U,H))&&M.push(H);return M}function r(U,x=1e3){return new Promise(M=>{let H=!1;const F=setInterval(()=>{H||(H=!0,g.access(U,N=>{H=!1,N&&(clearInterval(F),M(void 0))}))},x)})}e.whenDeleted=r;var o;(function(U){async function x(F){let N;try{if(N=await e.Promises.lstat(F),!N.isSymbolicLink())return{stat:N}}catch(j){}try{return{stat:await e.Promises.stat(F),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(P.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw W}throw j}}U.stat=x;async function M(F){try{const{stat:N,symbolicLink:j}=await U.stat(F);return N.isFile()&&j?.dangling!==!0}catch(N){}return!1}U.existsFile=M;async function H(F){try{const{stat:N,symbolicLink:j}=await U.stat(F);return N.isDirectory()&&j?.dangling!==!0}catch(N){}return!1}U.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function c(U,x,M){return i.queueFor(k.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const H=S(M);return new Promise((F,N)=>m(U,x,H,j=>j?N(j):F()))})}let h=!0;function m(U,x,M,H){if(!h)return g.writeFile(U,x,{mode:M.mode,flag:M.flag},H);g.open(U,M.flag,M.mode,(F,N)=>{if(F)return H(F);g.writeFile(N,x,j=>{if(j)return g.close(N,()=>H(j));g.fdatasync(N,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),h=!1),g.close(N,Q=>H(Q))))})})}function w(U,x,M){const H=S(M);if(!h)return g.writeFileSync(U,x,{mode:H.mode,flag:H.flag});const F=g.openSync(U,H.flag,H.mode);try{g.writeFileSync(F,x);try{g.fdatasyncSync(F)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),h=!1}}finally{g.closeSync(F)}}e.writeFileSync=w;function S(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function s(U,x){if(U===x)return;async function M(H){try{const F=await e.Promises.lstat(H);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(H,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(U,x),await M(x)}catch(H){if(U.toLowerCase()!==x.toLowerCase()&&H.code==="EXDEV"||U.endsWith("."))await b(U,x,{preserveSymlinks:!1}),await u(U,f.MOVE),await M(x);else throw H}}async function b(U,x,M){return O(U,x,{root:{source:U,target:x},options:M,handledSourcePaths:new Set})}const R=511;async function O(U,x,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:H,symbolicLink:F}=await o.stat(U);if(F){if(M.options.preserveSymlinks)try{return await Z(U,x,M)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(F.dangling)return}return H.isDirectory()?$(U,x,H.mode&R,M):G(U,x,H.mode&R)}async function $(U,x,M,H){await e.Promises.mkdir(x,{recursive:!0,mode:M});const F=await E(U);for(const N of F)await O((0,y.join)(U,N),(0,y.join)(x,N),H)}async function G(U,x,M){await e.Promises.copyFile(U,x),await e.Promises.chmod(x,M)}async function Z(U,x,M){let H=await e.Promises.readlink(U);(0,T.isEqualOrParent)(H,M.root.source,!P.isLinux)&&(H=(0,y.join)(M.root.target,H.substr(M.root.source.length+1))),await e.Promises.symlink(H,x)}e.Promises=new class{get access(){return(0,I.promisify)(g.access)}get stat(){return(0,I.promisify)(g.stat)}get lstat(){return(0,I.promisify)(g.lstat)}get utimes(){return(0,I.promisify)(g.utimes)}get read(){return(0,I.promisify)(g.read)}get readFile(){return(0,I.promisify)(g.readFile)}get write(){return(0,I.promisify)(g.write)}get appendFile(){return(0,I.promisify)(g.appendFile)}get fdatasync(){return(0,I.promisify)(g.fdatasync)}get truncate(){return(0,I.promisify)(g.truncate)}get rename(){return(0,I.promisify)(g.rename)}get copyFile(){return(0,I.promisify)(g.copyFile)}get open(){return(0,I.promisify)(g.open)}get close(){return(0,I.promisify)(g.close)}get symlink(){return(0,I.promisify)(g.symlink)}get readlink(){return(0,I.promisify)(g.readlink)}get chmod(){return(0,I.promisify)(g.chmod)}get mkdir(){return(0,I.promisify)(g.mkdir)}get unlink(){return(0,I.promisify)(g.unlink)}get rmdir(){return(0,I.promisify)(g.rmdir)}get realpath(){return(0,I.promisify)(g.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return u}get move(){return s}get copy(){return b}}}),define(me[105],ge([0,1,49,8,9,28]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(n){const k=(0,L.dirname)(n);if(n===k)return n;const d=((0,L.basename)(n)||n).toLowerCase();try{const u=(0,C.readdirSync)(k).filter(p=>p.toLowerCase()===d);if(u.length===1){const p=T(k);if(p)return(0,L.join)(p,u[0])}else if(u.length>1){const p=u.indexOf(d);if(p>=0){const _=T(k);if(_)return(0,L.join)(_,u[p])}}}catch(f){}return null}e.realcaseSync=T;async function D(n){try{return await C.Promises.realpath(n)}catch(k){const d=P(n);return await C.Promises.access(d,g.constants.R_OK),d}}e.realpath=D;function y(n){try{return g.realpathSync(n)}catch(k){const d=P(n);return g.accessSync(d,g.constants.R_OK),d}}e.realpathSync=y;function P(n){return(0,I.rtrim)((0,L.normalize)(n),L.sep)}});var je=this&&this.__decorate||function(Y,e,g,L){var I=arguments.length,C=I<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,g,L);else for(var D=Y.length-1;D>=0;D--)(T=Y[D])&&(C=(I<3?T(C):I>3?T(e,g,C):T(e,g))||C);return I>3&&C&&Object.defineProperty(e,g,C),C};define(me[106],ge([0,1,20,17,22,21,56,16,3,6,59,9,13]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function u(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function _(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(A||(A={}));class E{constructor(N){this.buffer=N,this.pos=0}read(N){const j=this.buffer.slice(this.pos,this.pos+N);return this.pos+=j.byteLength,j}}class a{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var l;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(l||(l={}));function v(F){const N=I.VSBuffer.alloc(4);return N.writeUInt32BE(F,0),N}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const N=I.VSBuffer.alloc(1);return N.writeUInt8(F,0),N}const o={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object)},i=typeof Buffer!="undefined";function c(F,N){if(typeof N=="undefined")F.write(o.Undefined);else if(typeof N=="string"){const j=I.VSBuffer.fromString(N);F.write(o.String),F.write(v(j.byteLength)),F.write(j)}else if(i&&Buffer.isBuffer(N)){const j=I.VSBuffer.wrap(N);F.write(o.Buffer),F.write(v(j.byteLength)),F.write(j)}else if(N instanceof I.VSBuffer)F.write(o.VSBuffer),F.write(v(N.byteLength)),F.write(N);else if(Array.isArray(N)){F.write(o.Array),F.write(v(N.length));for(const j of N)c(F,j)}else{const j=I.VSBuffer.fromString(JSON.stringify(N));F.write(o.Object),F.write(v(j.byteLength)),F.write(j)}}function h(F){switch(F.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return F.read(t(F)).toString();case l.Buffer:return F.read(t(F)).buffer;case l.VSBuffer:return F.read(t(F));case l.Array:{const j=t(F),W=[];for(let Q=0;Q<j;Q++)W.push(h(F));return W}case l.Object:return JSON.parse(F.read(t(F)).toString())}}class m{constructor(N,j,W=null,Q=1e3){this.protocol=N,this.ctx=j,this.logger=W,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(N,j){this.channels.set(N,j),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const j=this.send([N.type]);this.logger&&this.logger.logOutgoing(j,0,1,_(N.type));return}case 201:case 202:case 204:case 203:{const j=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(j,N.id,1,_(N.type),N.data);return}}}send(N,j=void 0){const W=new a;return c(W,N),c(W,j),this.sendBuffer(W.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onRawMessage(N){const j=new E(N),W=h(j),Q=h(j),J=W[0];switch(J){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,W[1],1,`${u(J)}: ${W[2]}.${W[3]}`,Q),this.onPromise({type:J,id:W[1],channelName:W[2],name:W[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,W[1],1,`${u(J)}: ${W[2]}.${W[3]}`,Q),this.onEventListen({type:J,id:W[1],channelName:W[2],name:W[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,W[1],1,`${u(J)}`),this.disposeActiveRequest({type:J,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,W[1],1,`${u(J)}`),this.disposeActiveRequest({type:J,id:W[1]})}}onPromise(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const W=new C.CancellationTokenSource;let Q;try{Q=j.call(this.ctx,N.name,N.arg,W.token)}catch(_e){Q=Promise.reject(_e)}const J=N.id;Q.then(_e=>{this.sendResponse({id:J,data:_e,type:201}),this.activeRequests.delete(N.id)},_e=>{_e instanceof Error?this.sendResponse({id:J,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:J,data:_e,type:203}),this.activeRequests.delete(N.id)});const fe=(0,P.toDisposable)(()=>W.cancel());this.activeRequests.set(N.id,fe)}onEventListen(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const W=N.id,J=j.listen(this.ctx,N.name,N.arg)(fe=>this.sendResponse({id:W,data:fe,type:204}));this.activeRequests.set(N.id,J)}disposeActiveRequest(N){const j=this.activeRequests.get(N.id);j&&(j.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let j=this.pendingRequests.get(N.channelName);j||(j=[],this.pendingRequests.set(N.channelName,j));const W=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:N,timeoutTimer:W})}flushPendingRequests(N){const j=this.pendingRequests.get(N);if(j){for(const W of j)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var w;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(N,j=null){this.protocol=N,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=j}getChannel(N){const j=this;return{call(W,Q,J){return j.isDisposed?Promise.reject(D.canceled()):j.requestPromise(N,W,Q,J)},listen(W,Q){return j.isDisposed?Promise.reject(D.canceled()):j.requestEvent(N,W,Q)}}}requestPromise(N,j,W,Q=C.CancellationToken.None){const J=this.lastRequestId++,_e={id:J,type:100,channelName:N,name:j,arg:W};if(Q.isCancellationRequested)return Promise.reject(D.canceled());let ye;return new Promise((Be,xe)=>{if(Q.isCancellationRequested)return xe(D.canceled());const Ke=()=>{const le=X=>{switch(X.type){case 201:this.handlers.delete(J),Be(X.data);break;case 202:this.handlers.delete(J);const oe=new Error(X.data.message);oe.stack=X.data.stack,oe.name=X.data.name,xe(oe);break;case 203:this.handlers.delete(J),xe(X.data);break}};this.handlers.set(J,le),this.sendRequest(_e)};let z=null;this.state===A.Idle?Ke():(z=(0,L.createCancelablePromise)(le=>this.whenInitialized()),z.then(()=>{z=null,Ke()}));const ee=()=>{z?(z.cancel(),z=null):this.sendRequest({id:J,type:101}),xe(D.canceled())},re=Q.onCancellationRequested(ee);ye=(0,P.combinedDisposable)((0,P.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(N,j,W){const Q=this.lastRequestId++,fe={id:Q,type:102,channelName:N,name:j,arg:W};let _e=null;const ye=new y.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(ye),this.sendRequest(fe)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(ye),this.sendRequest({id:Q,type:103}))}}),Le=Be=>ye.fire(Be.data);return this.handlers.set(Q,Le),ye.event}sendRequest(N){switch(N.type){case 100:case 102:{const j=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(j,N.id,0,`${u(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const j=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(j,N.id,0,u(N.type));return}}}send(N,j=void 0){const W=new a;return c(W,N),c(W,j),this.sendBuffer(W.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onBuffer(N){const j=new E(N),W=h(j),Q=h(j),J=W[0];switch(J){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,_(J)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,W[1],0,_(J),Q),this.onResponse({type:W[0],id:W[1],data:Q})}}onResponse(N){if(N.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(N.id);j&&j(N)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}je([T.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class s{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:j,onDidClientDisconnect:W})=>{y.Event.once(j.onMessage)(J=>{const fe=new E(J),_e=h(fe),ye=new m(j,_e),Le=new S(j);this.channels.forEach((xe,Ke)=>ye.registerChannel(Ke,xe));const Be={channelServer:ye,channelClient:Le,ctx:_e};this._connections.add(Be),this._onDidAddConnection.fire(Be),W(()=>{ye.dispose(),Le.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const N=[];return this._connections.forEach(j=>N.push(j)),N}getChannel(N,j){const W=this;return{call(Q,J,fe){let _e;if((0,d.isFunction)(j)){let Le=(0,g.getRandomElement)(W.connections.filter(j));_e=Le?Promise.resolve(Le):y.Event.toPromise(y.Event.filter(W.onDidAddConnection,j))}else _e=j.routeCall(W,Q,J);const ye=_e.then(Le=>Le.channelClient.getChannel(N));return R(ye).call(Q,J,fe)},listen(Q,J){if((0,d.isFunction)(j))return W.getMulticastEvent(N,j,Q,J);const fe=j.routeEvent(W,Q,J).then(_e=>_e.channelClient.getChannel(N));return R(fe).listen(Q,J)}}}getMulticastEvent(N,j,W,Q){const J=this;let fe=new P.DisposableStore;const _e=new y.Emitter({onFirstListenerAdd:()=>{fe=new P.DisposableStore;const ye=new y.EventMultiplexer,Le=new Map,Be=Ke=>{const ee=Ke.channelClient.getChannel(N).listen(W,Q),re=ye.add(ee);Le.set(Ke,re)},xe=Ke=>{const z=Le.get(Ke);!z||(z.dispose(),Le.delete(Ke))};J.connections.filter(j).forEach(Be),y.Event.filter(J.onDidAddConnection,j)(Be,void 0,fe),J.onDidRemoveConnection(xe,void 0,fe),ye.event(_e.fire,_e,fe),fe.add(ye)},onLastListenerRemove:()=>{fe.dispose()}});return _e.event}registerChannel(N,j){this.channels.set(N,j),this._connections.forEach(W=>{W.channelServer.registerChannel(N,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=s;class b{constructor(N,j,W=null){const Q=new a;c(Q,j),N.send(Q.buffer),this.channelClient=new S(N,W),this.channelServer=new m(N,j,W)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,j){this.channelServer.registerChannel(N,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=b;function R(F){return{call(N,j,W){return F.then(Q=>Q.call(N,j,W))},listen(N,j){const W=new y.Relay;return F.then(Q=>W.input=Q.listen(N,j)),W.event}}}e.getDelayedChannel=R;function O(F){let N=!1;return{call(j,W,Q){return N?F.call(j,W,Q):(0,L.timeout)(0).then(()=>N=!0).then(()=>F.call(j,W,Q))},listen(j,W){if(N)return F.listen(j,W);const Q=new y.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>Q.input=F.listen(j,W)),Q.event}}}e.getNextTickChannel=O;class ${constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const j of N.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await y.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=$;var G;(function(F){function N(Q,J){const fe=Q,_e=J&&J.disableMarshalling,ye=new Map;for(const Le in fe)W(Le)&&ye.set(Le,y.Event.buffer(fe[Le],!0));return new class{listen(Le,Be){const xe=ye.get(Be);if(xe)return xe;throw new Error(`Event not found: ${Be}`)}call(Le,Be,xe){const Ke=fe[Be];if(typeof Ke=="function"){if(!_e&&Array.isArray(xe))for(let z=0;z<xe.length;z++)xe[z]=(0,n.revive)(xe[z]);return Ke.apply(fe,xe)}throw new Error(`Method not found: ${Be}`)}}}F.fromService=N;function j(Q,J){const fe=J&&J.disableMarshalling;return new Proxy({},{get(_e,ye){if(typeof ye=="string")return J?.properties?.has(ye)?J.properties.get(ye):W(ye)?Q.listen(ye):async function(...Le){let Be;J&&!(0,d.isUndefinedOrNull)(J.context)?Be=[J.context,...Le]:Be=Le;const xe=await Q.call(ye,Be);return fe?xe:(0,n.revive)(xe)};throw new Error(`Property not found: ${String(ye)}`)}})}F.toService=j;function W(Q){return Q[0]==="o"&&Q[1]==="n"&&k.isUpperAsciiLetter(Q.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let N=F.toString();if(N!=="[object Object]")return N}return F}function x(F){return Array.isArray(F)?F.map(U):U(F)}function M(F,N,j,W,Q,J,fe){fe=x(fe);const _e=Z[Q],ye=_e[W%_e.length];let Le=[`%c[${F}]%c[${String(N).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(J)?(Le=Le.concat(fe),Le.push(")")):Le.push(fe),console.log.apply(console,Le)}e.logWithColors=M;class H{constructor(N,j){this._outgoingPrefix=N,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,j,W,Q,J){this._totalOutgoing+=N,M(this._outgoingPrefix,this._totalOutgoing,N,j,W,Q,J)}logIncoming(N,j,W,Q,J){this._totalIncoming+=N,M(this._incomingPrefix,this._totalIncoming,N,j,W,Q,J)}}e.IPCLogger=H}),define(me[107],ge([0,1,22,3,6,11,38,106]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function n(){return P||(P=g.VSBuffer.alloc(0)),P}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,c){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const S=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=i),S}if(this._chunks[0].byteLength>i){const S=this._chunks[0].slice(0,i);return c&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),S}let h=g.VSBuffer.alloc(i),m=0,w=0;for(;i>0;){const S=this._chunks[w];if(S.byteLength>i){const s=S.slice(0,i);h.set(s,m),m+=i,c&&(this._chunks[w]=S.slice(i),this._totalLength-=i),i-=i}else h.set(S,m),m+=S.byteLength,c?(this._chunks.shift(),this._totalLength-=S.byteLength):w++,i-=S.byteLength}return h}}e.ChunkStream=k;var d;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.KeepAlive=4]="KeepAlive",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest"})(d||(d={}));var f;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",o[o.KeepAliveTime=5e3]="KeepAliveTime",o[o.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(i,c,h,m){this.type=i,this.id=c,this.ack=h,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends I.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const h=this._state.messageType,m=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new u(h,m,w,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=g.VSBuffer.alloc(13);c.writeUInt8(i.type,0),c.writeUInt32BE(i.id,1),c.writeUInt32BE(i.ack,5),c.writeUInt32BE(i.data.byteLength,9),this._writeSoon(c,i.data)}_bufferAdd(i,c){const h=this._totalLength===0;return this._data.push(i,c),this._totalLength+=i.byteLength+c.byteLength,h}_bufferTake(){const i=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,c){this._bufferAdd(i,c)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class A extends I.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new u(1,0,0,i))}}e.Protocol=A;class E extends D.IPCClient{constructor(i,c,h=null){super(i,c,h);this.protocol=i}static fromSocket(i,c){return new E(new A(i),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,T.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(i){this.data=i,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],c=0,h=this._first;for(;h;)i[c++]=h.data,h=h.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const c=new l(i);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let c=0;c<t._HISTORY_LENGTH;c++)this.lastRuns[c]=i-1e3*c;setInterval(()=>{for(let c=t._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),c=(1+t._HISTORY_LENGTH)*1e3;let h=0;for(let m=0;m<t._HISTORY_LENGTH;m++)i-this.lastRuns[m]<=c&&h++;return 1-h/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(i,c=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new u(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const c=new u(4,0,0,n());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,c){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let c=0,h=i.length;c<h;c++)this._socketWriter.write(i[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new u(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const c=this._outgoingUnackMsg.toArray();for(let h=0,m=c.length;h<m;h++)this._socketWriter.write(c[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new u(1,c,this._incomingAckId,i);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(i){const c=new u(2,0,0,i);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const i=this._outgoingUnackMsg.peek(),c=Date.now()-i.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new u(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(me[108],ge([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(D){let y=(0,g.toUint8)(D);this._defaultValue=y,this._asciiMap=L._createAsciiMap(y),this._map=new Map}static _createAsciiMap(D){let y=new Uint8Array(256);for(let P=0;P<256;P++)y[P]=D;return y}set(D,y){let P=(0,g.toUint8)(y);D>=0&&D<256?this._asciiMap[D]=P:this._map.set(D,P)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=L;var I;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(I||(I={}));class C{constructor(){this._actual=new L(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=C}),define(me[144],ge([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends g.CharacterClassifier{constructor(D){super(0);for(let y=0,P=D.length;y<P;y++)this.set(D.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function C(T){let D={};return y=>(D.hasOwnProperty(y)||(D[y]=T(y)),D[y])}e.getMapForWordSeparators=C(T=>new I(T))}),define(me[50],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(I,C){this.lineNumber=I,this.column=C}with(I=this.lineNumber,C=this.column){return I===this.lineNumber&&C===this.column?this:new g(I,C)}delta(I=0,C=0){return this.with(this.lineNumber+I,this.column+C)}equals(I){return g.equals(this,I)}static equals(I,C){return!I&&!C?!0:!!I&&!!C&&I.lineNumber===C.lineNumber&&I.column===C.column}isBefore(I){return g.isBefore(this,I)}static isBefore(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<C.column}isBeforeOrEqual(I){return g.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<=C.column}static compare(I,C){let T=I.lineNumber|0,D=C.lineNumber|0;if(T===D){let y=I.column|0,P=C.column|0;return y-P}return T-D}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new g(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=g}),define(me[41],ge([0,1,50]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,T,D,y){C>D||C===D&&T>y?(this.startLineNumber=D,this.startColumn=y,this.endLineNumber=C,this.endColumn=T):(this.startLineNumber=C,this.startColumn=T,this.endLineNumber=D,this.endColumn=y)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<C.startColumn||T.lineNumber===C.endLineNumber&&T.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<=C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,T){let D,y,P,n;return T.startLineNumber<C.startLineNumber?(D=T.startLineNumber,y=T.startColumn):T.startLineNumber===C.startLineNumber?(D=T.startLineNumber,y=Math.min(T.startColumn,C.startColumn)):(D=C.startLineNumber,y=C.startColumn),T.endLineNumber>C.endLineNumber?(P=T.endLineNumber,n=T.endColumn):T.endLineNumber===C.endLineNumber?(P=T.endLineNumber,n=Math.max(T.endColumn,C.endColumn)):(P=C.endLineNumber,n=C.endColumn),new L(D,y,P,n)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,T){let D=C.startLineNumber,y=C.startColumn,P=C.endLineNumber,n=C.endColumn,k=T.startLineNumber,d=T.startColumn,f=T.endLineNumber,u=T.endColumn;return D<k?(D=k,y=d):D===k&&(y=Math.max(y,d)),P>f?(P=f,n=u):P===f&&(n=Math.min(n,u)),D>P||D===P&&y>n?null:new L(D,y,P,n)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,T){return!!C&&!!T&&C.startLineNumber===T.startLineNumber&&C.startColumn===T.startColumn&&C.endLineNumber===T.endLineNumber&&C.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new g.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new g.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,T){return new L(this.startLineNumber,this.startColumn,C,T)}setStartPosition(C,T){return new L(C,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,T=C){return new L(C.lineNumber,C.column,T.lineNumber,T.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn)}static areIntersecting(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,T){if(C&&T){const P=C.startLineNumber|0,n=T.startLineNumber|0;if(P===n){const k=C.startColumn|0,d=T.startColumn|0;if(k===d){const f=C.endLineNumber|0,u=T.endLineNumber|0;if(f===u){const p=C.endColumn|0,_=T.endColumn|0;return p-_}return f-u}return k-d}return P-n}return(C?1:0)-(T?1:0)}static compareRangesUsingEnds(C,T){return C.endLineNumber===T.endLineNumber?C.endColumn===T.endColumn?C.startLineNumber===T.startLineNumber?C.startColumn-T.startColumn:C.startLineNumber-T.startLineNumber:C.endColumn-T.endColumn:C.endLineNumber-T.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(me[145],ge([0,1,50,41]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(D,y,P,n){super(D,y,P,n);this.selectionStartLineNumber=D,this.selectionStartColumn=y,this.positionLineNumber=P,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return C.selectionsEqual(this,D)}static selectionsEqual(D,y){return D.selectionStartLineNumber===y.selectionStartLineNumber&&D.selectionStartColumn===y.selectionStartColumn&&D.positionLineNumber===y.positionLineNumber&&D.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,y){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,D,y):new C(D,y,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,y){return this.getDirection()===0?new C(D,y,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,D,y)}static fromPositions(D,y=D){return new C(D.lineNumber,D.column,y.lineNumber,y.column)}static liftSelection(D){return new C(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,y){if(D&&!y||!D&&y)return!1;if(!D&&!y)return!0;if(D.length!==y.length)return!1;for(let P=0,n=D.length;P<n;P++)if(!this.selectionsEqual(D[P],y[P]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,y,P,n,k){return k===0?new C(D,y,P,n):new C(P,n,D,y)}}e.Selection=C}),define(me[109],ge([0,1,23]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class P{constructor(_,A){this._findMatchBrand=void 0,this.range=_,this.matches=A}}e.FindMatch=P;var n;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var k;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(k=e.PositionAffinity||(e.PositionAffinity={}));var d;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d=e.ModelConstants||(e.ModelConstants={}));class f{constructor(_,A,E,a,l,v){this.identifier=_,this.range=A,this.text=E,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=l,this._isTracked=v}}e.ValidAnnotatedEditOperation=f;class u{constructor(_,A,E){this.reverseEdits=_,this.changes=A,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=u}),define(me[146],ge([0,1,9,144,50,41,109]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class y{constructor(a,l,v,t){this.searchString=a,this.isRegex=l,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=P(this.searchString):a=this.searchString.indexOf(`
`)>=0;let l=null;try{l=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let v=!this.isRegex&&!a;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(l,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=y;function P(E){if(!E||E.length===0)return!1;for(let a=0,l=E.length;a<l;a++)if(E.charCodeAt(a)===92){if(a++,a>=l)break;const t=E.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class n{constructor(a,l,v){this.regex=a,this.wordSeparators=l,this.simpleSearch=v}}e.SearchData=n;function k(E,a,l){if(!l)return new T.FindMatch(E,null);let v=[];for(let t=0,r=a.length;t<r;t++)v[t]=a[t];return new T.FindMatch(E,v)}e.createFindMatch=k;class d{constructor(a){let l=[],v=0;for(let t=0,r=a.length;t<r;t++)a.charCodeAt(t)===10&&(l[v++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(a){const l=this._lineFeedsOffsets;let v=0,t=l.length-1;if(t===-1||a<=l[0])return 0;for(;v<t;){const r=v+((t-v)/2>>0);l[r]>=a?t=r-1:l[r+1]>=a?(v=r,t=r):v=r+1}return v+1}}class f{static findMatches(a,l,v,t,r){const o=l.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(a,v,new A(o.wordSeparators,o.regex),t,r):this._doFindMatchesLineByLine(a,v,o,t,r):[]}static _getMultilineMatchRange(a,l,v,t,r,o){let i,c=0;t?(c=t.findLineFeedCountBeforeOffset(r),i=l+r+c):i=l+r;let h;if(t){let s=t.findLineFeedCountBeforeOffset(r+o.length)-c;h=i+o.length+s}else h=i+o.length;const m=a.getPositionAt(i),w=a.getPositionAt(h);return new C.Range(m.lineNumber,m.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(a,l,v,t,r){const o=a.getOffsetAt(l.getStartPosition()),i=a.getValueInRange(l,1),c=a.getEOL()===`\r
`?new d(i):null,h=[];let m=0,w;for(v.reset(0);w=v.next(i);)if(h[m++]=k(this._getMultilineMatchRange(a,o,i,c,w.index,w[0]),w,t),m>=r)return h;return h}static _doFindMatchesLineByLine(a,l,v,t,r){const o=[];let i=0;if(l.startLineNumber===l.endLineNumber){const h=a.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return i=this._findMatchesInLine(v,h,l.startLineNumber,l.startColumn-1,i,o,t,r),o}const c=a.getLineContent(l.startLineNumber).substring(l.startColumn-1);i=this._findMatchesInLine(v,c,l.startLineNumber,l.startColumn-1,i,o,t,r);for(let h=l.startLineNumber+1;h<l.endLineNumber&&i<r;h++)i=this._findMatchesInLine(v,a.getLineContent(h),h,0,i,o,t,r);if(i<r){const h=a.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);i=this._findMatchesInLine(v,h,l.endLineNumber,0,i,o,t,r)}return o}static _findMatchesInLine(a,l,v,t,r,o,i,c){const h=a.wordSeparators;if(!i&&a.simpleSearch){const S=a.simpleSearch,s=S.length,b=l.length;let R=-s;for(;(R=l.indexOf(S,R+s))!==-1;)if((!h||_(h,l,b,R,s))&&(o[r++]=new T.FindMatch(new C.Range(v,R+1+t,v,R+1+s+t),null),r>=c))return r;return r}const m=new A(a.wordSeparators,a.regex);let w;m.reset(0);do if(w=m.next(l),w&&(o[r++]=k(new C.Range(v,w.index+1+t,v,w.index+1+w[0].length+t),w,i),r>=c))return r;while(w);return r}static findNextMatch(a,l,v,t){const r=l.parseSearchRequest();if(!r)return null;const o=new A(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(a,v,o,t):this._doFindNextMatchLineByLine(a,v,o,t)}static _doFindNextMatchMultiline(a,l,v,t){const r=new I.Position(l.lineNumber,1),o=a.getOffsetAt(r),i=a.getLineCount(),c=a.getValueInRange(new C.Range(r.lineNumber,r.column,i,a.getLineMaxColumn(i)),1),h=a.getEOL()===`\r
`?new d(c):null;v.reset(l.column-1);let m=v.next(c);return m?k(this._getMultilineMatchRange(a,o,c,h,m.index,m[0]),m,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(a,new I.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(a,l,v,t){const r=a.getLineCount(),o=l.lineNumber,i=a.getLineContent(o),c=this._findFirstMatchInLine(v,i,o,l.column,t);if(c)return c;for(let h=1;h<=r;h++){const m=(o+h-1)%r,w=a.getLineContent(m+1),S=this._findFirstMatchInLine(v,w,m+1,1,t);if(S)return S}return null}static _findFirstMatchInLine(a,l,v,t,r){a.reset(t-1);const o=a.next(l);return o?k(new C.Range(v,o.index+1,v,o.index+1+o[0].length),o,r):null}static findPreviousMatch(a,l,v,t){const r=l.parseSearchRequest();if(!r)return null;const o=new A(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(a,v,o,t):this._doFindPreviousMatchLineByLine(a,v,o,t)}static _doFindPreviousMatchMultiline(a,l,v,t){const r=this._doFindMatchesMultiline(a,new C.Range(1,1,l.lineNumber,l.column),v,t,10*D);if(r.length>0)return r[r.length-1];const o=a.getLineCount();return l.lineNumber!==o||l.column!==a.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(a,new I.Position(o,a.getLineMaxColumn(o)),v,t):null}static _doFindPreviousMatchLineByLine(a,l,v,t){const r=a.getLineCount(),o=l.lineNumber,i=a.getLineContent(o).substring(0,l.column-1),c=this._findLastMatchInLine(v,i,o,t);if(c)return c;for(let h=1;h<=r;h++){const m=(r+o-h-1)%r,w=a.getLineContent(m+1),S=this._findLastMatchInLine(v,w,m+1,t);if(S)return S}return null}static _findLastMatchInLine(a,l,v,t){let r=null,o;for(a.reset(0);o=a.next(l);)r=k(new C.Range(v,o.index+1,v,o.index+1+o[0].length),o,t);return r}}e.TextModelSearch=f;function u(E,a,l,v,t){if(v===0)return!0;const r=a.charCodeAt(v-1);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=a.charCodeAt(v);if(E.get(o)!==0)return!0}return!1}function p(E,a,l,v,t){if(v+t===l)return!0;const r=a.charCodeAt(v+t);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=a.charCodeAt(v+t-1);if(E.get(o)!==0)return!0}return!1}function _(E,a,l,v,t){return u(E,a,l,v,t)&&p(E,a,l,v,t)}e.isValidMatch=_;class A{constructor(a,l){this._wordSeparators=a,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const l=a.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(v=this._searchRegex.exec(a),!v))return null;const t=v.index,r=v[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(a,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,a,l,t,r))return v}while(v);return null}}e.Searcher=A}),define(me[110],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(D=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)D.indexOf(P)>=0||(y+="\\"+P);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=g();function L(D){let y=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)y=D;else{let P="g";D.ignoreCase&&(P+="i"),D.multiline&&(P+="m"),D.unicode&&(P+="u"),y=new RegExp(D.source,P)}return y.lastIndex=0,y}e.ensureValidWordDefinition=L;const I={maxLen:1e3,windowSize:15,timeBudget:150};function C(D,y,P,n,k=I){if(P.length>k.maxLen){let _=D-k.maxLen/2;return _<0?_=0:n+=_,P=P.substring(_,D+k.maxLen/2),C(D,y,P,n,k)}const d=Date.now(),f=D-1-n;let u=-1,p=null;for(let _=1;!(Date.now()-d>=k.timeBudget);_++){const A=f-k.windowSize*_;y.lastIndex=Math.max(0,A);const E=T(y,P,f,u);if(!E&&p||(p=E,A<=0))break;u=A}if(p){let _={word:p[0],startColumn:n+1+p.index,endColumn:n+1+p.index+p[0].length};return y.lastIndex=0,_}return null}e.getWordAtText=C;function T(D,y,P,n){let k;for(;k=D.exec(y);){const d=k.index||0;if(d<=P&&D.lastIndex>=P)return k;if(n>0&&d>n)return null}return null}}),define(me[147],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(D){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let y=0,P=D.notIn.length;y<P;y++)switch(D.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=L;class I{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of D)C(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),C(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),C(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),C(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&C(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function C(T,D,y){T.has(D)?T.get(D).push(y):T.set(D,[y])}}),define(me[81],ge([0,1,30,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(C,T,D,y){if(Array.isArray(C)){let P=0;for(const n of C){const k=I(n,T,D,y);if(k===10)return k;k>P&&(P=k)}return P}else{if(typeof C=="string")return y?C==="*"?5:C===D?10:0:0;if(C){const{language:P,pattern:n,scheme:k,hasAccessToAllModels:d}=C;if(!y&&!d)return 0;let f=0;if(k)if(k===T.scheme)f=10;else if(k==="*")f=5;else return 0;if(P)if(P===D)f=10;else if(P==="*")f=Math.max(f,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,L.normalize)(n.base)},u===T.fsPath||(0,g.match)(u,T.fsPath))f=10;else return 0}return f}else return 0}}e.score=I}),define(me[148],ge([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class I{constructor(u,p,_){const A=new Uint8Array(u*p);for(let E=0,a=u*p;E<a;E++)A[E]=_;this._data=A,this.rows=u,this.cols=p}get(u,p){return this._data[u*this.cols+p]}set(u,p,_){this._data[u*this.cols+p]=_}}e.Uint8Matrix=I;class C{constructor(u){let p=0,_=0;for(let E=0,a=u.length;E<a;E++){let[l,v,t]=u[E];v>p&&(p=v),l>_&&(_=l),t>_&&(_=t)}p++,_++;let A=new I(_,p,0);for(let E=0,a=u.length;E<a;E++){let[l,v,t]=u[E];A.set(l,v,t)}this._states=A,this._maxCharCode=p}nextState(u,p){return p<0||p>=this._maxCharCode?0:this._states.get(u,p)}}e.StateMachine=C;let T=null;function D(){return T===null&&(T=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let P=null;function n(){if(P===null){P=new g.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<f.length;p++)P.set(f.charCodeAt(p),1);const u=".,;";for(let p=0;p<u.length;p++)P.set(u.charCodeAt(p),2)}return P}class k{static _createLink(u,p,_,A,E){let a=E-1;do{const l=p.charCodeAt(a);if(u.get(l)!==2)break;a--}while(a>A);if(A>0){const l=p.charCodeAt(A-1),v=p.charCodeAt(a);(l===40&&v===41||l===91&&v===93||l===123&&v===125)&&a--}return{range:{startLineNumber:_,startColumn:A+1,endLineNumber:_,endColumn:a+2},url:p.substring(A,a+1)}}static computeLinks(u,p=D()){const _=n();let A=[];for(let E=1,a=u.getLineCount();E<=a;E++){const l=u.getLineContent(E),v=l.length;let t=0,r=0,o=0,i=1,c=!1,h=!1,m=!1,w=!1;for(;t<v;){let S=!1;const s=l.charCodeAt(t);if(i===13){let b;switch(s){case 40:c=!0,b=0;break;case 41:b=c?0:1;break;case 91:m=!0,h=!0,b=0;break;case 93:m=!1,b=h?0:1;break;case 123:w=!0,b=0;break;case 125:b=w?0:1;break;case 39:b=o===34||o===96?0:1;break;case 34:b=o===39||o===96?0:1;break;case 96:b=o===39||o===34?0:1;break;case 42:b=o===42?1:0;break;case 124:b=o===124?1:0;break;case 32:b=m?0:1;break;default:b=_.get(s)}b===1&&(A.push(k._createLink(_,l,E,r,t)),S=!0)}else if(i===12){let b;s===91?(h=!0,b=0):b=_.get(s),b===1?S=!0:i=13}else i=p.nextState(i,s),i===0&&(S=!0);S&&(i=1,c=!1,h=!1,w=!1,r=t+1,o=s),t++}i===13&&A.push(k._createLink(_,l,E,r,v))}return A}}e.LinkComputer=k;function d(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:k.computeLinks(f)}e.computeLinks=d}),define(me[149],ge([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,D){return this._map.set(T,D),this.fire([T]),(0,L.toDisposable)(()=>{this._map.get(T)===D&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,D){let y=null,P=!1;return this._promises.set(T,D.then(n=>{this._promises.delete(T),!(P||!n)&&(y=this.register(T,n))})),(0,L.toDisposable)(()=>{P=!0,y&&y.dispose()})}getPromise(T){const D=this.get(T);if(D)return Promise.resolve(D);const y=this._promises.get(T);return y?y.then(P=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(me[111],ge([0,1,22,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function C(k){for(let d=0,f=k.length;d<f;d+=4){const u=k[d+0],p=k[d+1],_=k[d+2],A=k[d+3];k[d+0]=A,k[d+1]=_,k[d+2]=p,k[d+3]=u}}function T(k){const d=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return L.isLittleEndian()||C(d),g.VSBuffer.wrap(d)}function D(k){const d=k.buffer;if(L.isLittleEndian()||C(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const f=new Uint8Array(d.byteLength);return f.set(d),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(k){const d=new Uint32Array(P(k));let f=0;if(d[f++]=k.id,k.type==="full")d[f++]=1,d[f++]=k.data.length,d.set(k.data,f),f+=k.data.length;else{d[f++]=2,d[f++]=k.deltas.length;for(const u of k.deltas)d[f++]=u.start,d[f++]=u.deleteCount,u.data?(d[f++]=u.data.length,d.set(u.data,f),f+=u.data.length):d[f++]=0}return T(d)}e.encodeSemanticTokensDto=y;function P(k){let d=0;if(d+=1+1,k.type==="full")d+=1+k.data.length;else{d+=1,d+=(1+1+1)*k.deltas.length;for(const f of k.deltas)f.data&&(d+=f.data.length)}return d}function n(k){const d=D(k);let f=0;const u=d[f++];if(d[f++]===1){const E=d[f++],a=d.subarray(f,f+E);return f+=E,{id:u,type:"full",data:a}}const _=d[f++];let A=[];for(let E=0;E<_;E++){const a=d[f++],l=d[f++],v=d[f++];let t;v>0&&(t=d.subarray(f,f+v),f+=v),A[E]={start:a,deleteCount:l,data:t}}return{id:u,type:"delta",deltas:A}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(T,D){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=D}}e.PrefixSumIndexOfResult=L;class I{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,D){T=(0,g.toUint32)(T);const y=this.values,P=this.prefixSum,n=D.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,T),0),this.values.set(y.subarray(T),T+n),this.values.set(D,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,D){return T=(0,g.toUint32)(T),D=(0,g.toUint32)(D),this.values[T]===D?!1:(this.values[T]=D,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,D){T=(0,g.toUint32)(T),D=(0,g.toUint32)(D);const y=this.values,P=this.prefixSum;if(T>=y.length)return!1;let n=y.length-T;return D>=n&&(D=n),D===0?!1:(this.values=new Uint32Array(y.length-D),this.values.set(y.subarray(0,T),0),this.values.set(y.subarray(T+D),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,g.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),T>=this.values.length&&(T=this.values.length-1);for(let y=D;y<=T;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let D=0,y=this.values.length-1,P=0,n=0,k=0;for(;D<=y;)if(P=D+(y-D)/2|0,n=this.prefixSum[P],k=n-this.values[P],T<k)y=P-1;else if(T>=n)D=P+1;else break;return new L(P,T-k)}}e.PrefixSumComputer=I}),define(me[150],ge([0,1,9,50,112]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(D,y,P,n){this._uri=D,this._lines=y,this._eol=P,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const y=D.changes;for(const P of y)this._acceptDeleteRange(P.range),this._acceptInsertText(new L.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,y=this._lines.length,P=new Uint32Array(y);for(let n=0;n<y;n++)P[n]=this._lines[n].length+D;this._lineStarts=new I.PrefixSumComputer(P)}}_setLineText(D,y){this._lines[D]=y,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,y){if(y.length===0)return;let P=(0,g.splitLines)(y);if(P.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+P[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}P[P.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+P[0]);let n=new Uint32Array(P.length-1);for(let k=1;k<P.length;k++)this._lines.splice(D.lineNumber+k-1,0,P[k]),n[k-1]=P[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,n)}}e.MirrorTextModel=C}),define(me[151],ge([18,19]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(me[152],ge([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,I=L*60,C=I*24,T=C*7,D=C*30,y=C*365;function P(k,d){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,g.localize)(0,null,P(new Date().getTime()+f*1e3,!1));if(f<30)return(0,g.localize)(1,null);let u;return f<L?(u=f,d?u===1?(0,g.localize)(2,null,u):(0,g.localize)(3,null,u):u===1?(0,g.localize)(4,null,u):(0,g.localize)(5,null,u)):f<I?(u=Math.floor(f/L),d?u===1?(0,g.localize)(6,null,u):(0,g.localize)(7,null,u):u===1?(0,g.localize)(8,null,u):(0,g.localize)(9,null,u)):f<C?(u=Math.floor(f/I),d?u===1?(0,g.localize)(10,null,u):(0,g.localize)(11,null,u):u===1?(0,g.localize)(12,null,u):(0,g.localize)(13,null,u)):f<T?(u=Math.floor(f/C),d?u===1?(0,g.localize)(14,null,u):(0,g.localize)(15,null,u):u===1?(0,g.localize)(16,null,u):(0,g.localize)(17,null,u)):f<D?(u=Math.floor(f/T),d?u===1?(0,g.localize)(18,null,u):(0,g.localize)(19,null,u):u===1?(0,g.localize)(20,null,u):(0,g.localize)(21,null,u)):f<y?(u=Math.floor(f/D),d?u===1?(0,g.localize)(22,null,u):(0,g.localize)(23,null,u):u===1?(0,g.localize)(24,null,u):(0,g.localize)(25,null,u)):(u=Math.floor(f/y),d?u===1?(0,g.localize)(26,null,u):(0,g.localize)(27,null,u):u===1?(0,g.localize)(28,null,u):(0,g.localize)(29,null,u))}e.fromNow=P;function n(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[153],ge([18,19]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,20,13,153]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(P,n){return n&&(P.stack||P.stacktrace)?I.localize(0,null,D(P),T(P.stack)||T(P.stacktrace)):D(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function D(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function y(P=null,n=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const k=g.coalesce(P),d=y(k[0],n);return k.length>1?I.localize(4,null,d,k.length):d}if(L.isString(P))return P;if(P.detail){const k=P.detail;if(k.error)return C(k.error,n);if(k.exception)return C(k.exception,n)}return P.stack?C(P,n):P.message?P.message:I.localize(5,null)}e.toErrorMessage=y}),define(me[154],ge([18,19]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,23,8,11,38,13,143,28,154]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(l,v){if(D.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};v&&(t.cwd=v);const r=g.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],t);return new Promise(o=>{r.once("error",i=>{o({success:!1,error:i})}),r.once("exit",(i,c)=>{o(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(D.isLinux||D.isMacintosh)try{const t=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{g.execFile(t,[l.pid.toString()],{encoding:"utf8",shell:!0},(o,i,c)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function p(l=y.env){return l.comspec||"cmd.exe"}e.getWindowsShell=p;class _{constructor(v,t,r,o){if(t!==void 0&&r!==void 0&&o!==void 0)this.cmd=v,this.args=t,this.shell=r,this.options=o;else{const i=v;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(y.env).forEach(c=>{i[c]=y.env[c]}),Object.keys(this.options.env).forEach(c=>{i[c]=this.options.env[c]}),this.options.env=i}}getSanitizedCommand(){let v=this.cmd.toLowerCase();const t=v.lastIndexOf(T.sep);return t!==-1&&(v=v.substring(t+1)),_.WellKnowCommands[v]?v:"other"}start(v){return D.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(y.cwd()))?Promise.reject(new Error(d.localize(0,null))):this.useExec().then(t=>{let r,o;const i=new Promise((c,h)=>{r=c,o=h});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=g.exec(c,this.options,(h,m,w)=>{this.childProcess=null;const S=h;S&&S.killed?o({killed:this.terminateRequested,stdout:m.toString(),stderr:w.toString()}):this.handleExec(r,v,h,m,w)})}else{let c=null;const h=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,r,v,o);const w={terminated:this.terminateRequested};P.isNumber(m)&&(w.cmdCode=m),r(w)};if(this.shell&&D.isWindows){const m=C.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let w=!1,S=!1;const s=[];let b=this.ensureQuotes(this.cmd);s.push(b.value),w=b.quoted,this.args&&this.args.forEach(O=>{b=this.ensureQuotes(O),s.push(b.value),S=S&&b.quoted});const R=["/s","/c"];w?S?R.push('"'+s.join(" ")+'"'):s.length>1?R.push('"'+s[0]+'" '+s.slice(1).join(" ")):R.push('"'+s[0]+'"'):R.push(s.join(" ")),c=g.spawn(p(),R,m)}else this.cmd&&(c=g.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",m=>{this.childProcess=null,o({terminated:this.terminateRequested,error:m})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,r,v,o,!0)))}return i})}handleClose(v,t,r,o){}ensureQuotes(v){return _.regexp.test(v)?{value:'"'+v+'"',quoted:!0}:{value:v,quoted:v.length>0&&v[0]==='"'&&v[v.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(v=>v.pid,v=>-1):new Promise(v=>{this.pidResolve=v})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(v=>(this.terminateRequested=!0,u(v,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),v=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(v=>{if(!this.shell||!D.isWindows)return v(!1);const t=g.spawn(p(),["/s","/c"]);t.on("error",r=>v(!0)),t.on("exit",r=>v(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class A extends _{constructor(v,t,r,o){super(v,t,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(v,t,r,o,i){[o,i].forEach((c,h)=>{const m=new n.LineDecoder;m.write(c).forEach(s=>{t({line:s,source:h===0?0:1})});const S=m.end();S&&t({line:S,source:h===0?0:1})}),v({terminated:this.terminateRequested,error:r})}handleSpawn(v,t,r,o,i){const c=new n.LineDecoder,h=new n.LineDecoder;v.stdout.on("data",m=>{c.write(m).forEach(S=>r({line:S,source:0}))}),v.stderr.on("data",m=>{h.write(m).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(v,t,r,o){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=A;function E(l){let v=[],t=!1;const r=function(o){if(t){v.push(o);return}(!l.send(o,c=>{if(c&&console.error(c),t=!1,v.length>0){const h=v.slice(0);v=[],h.forEach(m=>r(m))}})||D.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=E;var a;(function(l){async function v(t,r,o){if(T.isAbsolute(t))return t;if(r===void 0&&(r=y.cwd()),T.dirname(t)!=="."||(o===void 0&&P.isString(y.env.PATH)&&(o=y.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(r,t);async function c(h){if(await k.Promises.exists(h)){let m;try{m=await k.Promises.stat(h)}catch(w){w.message.startsWith("EACCES")&&(m=await k.Promises.lstat(h))}return m?!m.isDirectory():!1}return!1}for(let h of o){let m;if(T.isAbsolute(h)?m=T.join(h,t):m=T.join(r,h,t),await c(m))return m;let w=m+".com";if(await c(w)||(w=m+".exe",await c(w)))return w}return T.join(r,t)}l.findExecutable=v})(a=e.win32||(e.win32={}))}),define(me[155],ge([18,19]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(me[156],ge([18,19]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[157],ge([18,19]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[158],ge([18,19]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[159],ge([18,19]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[160],ge([18,19]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(me[161],ge([18,19]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(me[162],ge([18,19]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(me[163],ge([18,19]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(me[164],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[165],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[166],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(me[167],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[168],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[169],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[170],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[171],ge([18,19]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[172],ge([18,19]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(me[173],ge([18,19]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(me[174],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[175],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[176],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[177],ge([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[178],ge([18,19]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[179],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var I;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[180],ge([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(d){return d=d.trim(),d==="*"||L.test(d)}e.isValidVersionStr=C;function T(d){if(!C(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=d.match(L);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=T;function D(d){if(!d)return null;let f=d.majorBase,u=d.majorMustEqual,p=d.minorBase,_=d.minorMustEqual,A=d.patchBase,E=d.patchMustEqual;d.hasCaret&&(f===0||(_=!1),E=!1);let a=0;if(d.preRelease){const l=I.exec(d.preRelease);if(l){const[,v,t,r]=l;a=Date.UTC(Number(v),Number(t)-1,Number(r))}}return{majorBase:f,majorMustEqual:u,minorBase:p,minorMustEqual:_,patchBase:A,patchMustEqual:E,isMinimum:d.hasGreaterEquals,notBefore:a}}e.normalizeVersion=D;function y(d,f,u){let p;typeof d=="string"?p=D(T(d)):p=d;let _;f instanceof Date?_=f.getTime():typeof f=="string"&&(_=new Date(f).getTime());let A;if(typeof u=="string"?A=D(T(u)):A=u,!p||!A)return!1;let E=p.majorBase,a=p.minorBase,l=p.patchBase,v=A.majorBase,t=A.minorBase,r=A.patchBase,o=A.notBefore,i=A.majorMustEqual,c=A.minorMustEqual,h=A.patchMustEqual;return A.isMinimum?E>v?!0:E<v?!1:a>t?!0:a<t||_&&_<o?!1:l>=r:(E===1&&v===0&&(!i||!c||!h)&&(v=1,t=0,r=0,i=!0,c=!1,h=!1),E<v?!1:E>v?!i:a<t?!1:a>t?!c:l<r?!1:l>r?!h:!(_&&_<o))}e.isValidVersion=y;function P(d,f,u,p){return u.isBuiltin||typeof u.main=="undefined"?!0:k(d,f,u.engines.vscode,p)}e.isValidExtensionVersion=P;function n(d,f,u){return d==="*"||k(f,u,d)}e.isEngineValid=n;function k(d,f,u,p=[]){let _=D(T(u));if(!_)return p.push(g.localize(0,null,u)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return p.push(g.localize(1,null,u)),!1}else if(!_.majorMustEqual)return p.push(g.localize(2,null,u)),!1;return y(d,f,_)?!0:(p.push(g.localize(3,null,d,u)),!1)}}),define(me[114],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(I,C=[],T=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=g}),define(me[82],ge([0,1,114]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function I(T,D,y){D instanceof g.SyncDescriptor||(D=new g.SyncDescriptor(D,[],y)),L.push([T,D])}e.registerSingleton=I;function C(){return L}e.getSingletonServiceDescriptors=C}),define(me[181],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=g;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const D=this.lookupOrInsertNode(C),y=this.lookupOrInsertNode(T);D.outgoing.set(this._hashFn(T),y),y.incoming.set(this._hashFn(C),D)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(let D of this._nodes.values())D.outgoing.delete(T),D.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let D=this._nodes.get(T);return D||(D=new g(C),this._nodes.set(T,D)),D}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[T,D]of this._nodes)C.push(`${T}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,T]of this._nodes){const D=new Set([C]),y=this._findCycle(T,D);if(y)return y}}_findCycle(C,T){for(let[D,y]of C.outgoing){if(T.has(D))return[...T,D].join(" -> ");T.add(D);const P=this._findCycle(y,T);if(P)return P;T.delete(D)}}}e.Graph=L}),define(me[4],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(P){return P[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(g=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function L(D,y,P,n){y[g.DI_TARGET]===y?y[g.DI_DEPENDENCIES].push({id:D,index:P,optional:n}):(y[g.DI_DEPENDENCIES]=[{id:D,index:P,optional:n}],y[g.DI_TARGET]=y)}function I(D){if(g.serviceIds.has(D))return g.serviceIds.get(D);const y=function(P,n,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,P,k,!1)};return y.toString=()=>D,g.serviceIds.set(D,y),y}e.createDecorator=I;function C(D){return D}e.refineServiceDecorator=C;function T(D){return function(y,P,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(D,y,n,!0)}}e.optional=T}),define(me[182],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[183],ge([0,1,3,58,6,24,77,81,182]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(P):!!p.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(_,A){let E={selector:_,provider:A,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(E){let a=this._entries.indexOf(E);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(_){return this.all(_).length>0}all(_){if(!_)return[];this._updateScores(_);const A=[];for(let E of this._entries)E._score>0&&A.push(E.provider);return A}ordered(_){const A=[];return this._orderedForEach(_,E=>A.push(E.provider)),A}orderedGroups(_){const A=[];let E,a;return this._orderedForEach(_,l=>{E&&a===l._score?E.push(l.provider):(a=l._score,E=[l.provider],A.push(E))}),A}_orderedForEach(_,A){if(!!_){this._updateScores(_);for(const E of this._entries)E._score>0&&A(E)}}_updateScores(_){let A={uri:_.uri.toString(),language:_.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===A.language&&this._lastCandidate.uri===A.uri)){this._lastCandidate=A;for(let E of this._entries)if(E._score=(0,D.score)(E.selector,_.uri,_.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(_)),P(E.selector)&&E._score>0){for(let a of this._entries)a._score=0;E._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(_,A){return _._score<A._score?1:_._score>A._score?-1:_._time<A._time?1:_._time>A._time?-1:0}}e.LanguageFeatureRegistry=n;const k=new WeakMap;let d=0;function f(p){let _=k.get(p);return _===void 0&&(_=++d,k.set(p,_)),_}class u{constructor(_,A,E=Number.MAX_SAFE_INTEGER){this._registry=_,this.min=A,this.max=E,this._cache=new C.LRUCache(50,.7)}_key(_){return _.id+this._registry.all(_).reduce((A,E)=>(0,L.doHash)(f(E),A),0)}_clamp(_){return _===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(_*1.3)))}get(_){const A=this._key(_),E=this._cache.get(A);return this._clamp(E?.value)}update(_,A){const E=this._key(_);let a=this._cache.get(E);return a||(a=new T.MovingAverage,this._cache.set(E,a)),a.update(A),this.get(_)}}e.LanguageFeatureRequestDelays=u}),define(me[83],ge([0,1,2,41,183,149,47]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(s){s[s.Null=0]="Null",s[s.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class y{constructor(b,R){this.language=b,this.id=R}}e.LanguageIdentifier=y;var P;(function(s){s[s.NotSet=-1]="NotSet",s[s.None=0]="None",s[s.Italic=1]="Italic",s[s.Bold=2]="Bold",s[s.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var n;(function(s){s[s.None=0]="None",s[s.DefaultForeground=1]="DefaultForeground",s[s.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var k;(function(s){s[s.Other=0]="Other",s[s.Comment=1]="Comment",s[s.String=2]="String",s[s.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(s){s[s.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",s[s.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",s[s.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",s[s.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",s[s.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",s[s.ITALIC_MASK=2048]="ITALIC_MASK",s[s.BOLD_MASK=4096]="BOLD_MASK",s[s.UNDERLINE_MASK=8192]="UNDERLINE_MASK",s[s.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",s[s.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",s[s.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",s[s.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",s[s.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",s[s.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",s[s.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",s[s.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",s[s.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",s[s.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let R=this.getForeground(b),O="mtk"+R,$=this.getFontStyle(b);return $&1&&(O+=" mtki"),$&2&&(O+=" mtkb"),$&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(b,R){const O=this.getForeground(b),$=this.getFontStyle(b);let G=`color: ${R[O]};`;return $&1&&(G+="font-style: italic;"),$&2&&(G+="font-weight: bold;"),$&4&&(G+="text-decoration: underline;"),G}}e.TokenMetadata=f;var u;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let s=Object.create(null);return s[0]="symbol-method",s[1]="symbol-function",s[2]="symbol-constructor",s[3]="symbol-field",s[4]="symbol-variable",s[5]="symbol-class",s[6]="symbol-struct",s[7]="symbol-interface",s[8]="symbol-module",s[9]="symbol-property",s[10]="symbol-event",s[11]="symbol-operator",s[12]="symbol-unit",s[13]="symbol-value",s[14]="symbol-constant",s[15]="symbol-enum",s[16]="symbol-enum-member",s[17]="symbol-keyword",s[27]="symbol-snippet",s[18]="symbol-text",s[19]="symbol-color",s[20]="symbol-file",s[21]="symbol-reference",s[22]="symbol-customcolor",s[23]="symbol-folder",s[24]="symbol-type-parameter",s[25]="account",s[26]="issues",function(b){const R=s[b];let O=R&&T.iconRegistry.get(R);return O||(console.info("No codicon found for CompletionItemKind "+b),O=T.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let s=Object.create(null);return s.method=0,s.function=1,s.constructor=2,s.field=3,s.variable=4,s.class=5,s.struct=6,s.interface=7,s.module=8,s.property=9,s.event=10,s.operator=11,s.unit=12,s.value=13,s.constant=14,s.enum=15,s["enum-member"]=16,s.enumMember=16,s.keyword=17,s.snippet=27,s.text=18,s.color=19,s.file=20,s.reference=21,s.customcolor=22,s.folder=23,s["type-parameter"]=24,s.typeParameter=24,s.account=25,s.issue=26,function(b,R){let O=s[b];return typeof O=="undefined"&&!R&&(O=9),O}}();var p;(function(s){s[s.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(s){s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var A;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(s){return s&&g.URI.isUri(s.uri)&&L.Range.isIRange(s.range)&&(L.Range.isIRange(s.originSelectionRange)||L.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=t;var r;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var o;(function(s){s[s.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var i;(function(s){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function O(Z){return b.get(Z)}s.fromString=O;function $(Z){return R.get(Z)}s.toString=$;function G(Z,U){const x=R.get(Z);let M=x&&T.iconRegistry.get("symbol-"+x);return M||(console.info("No codicon found for SymbolKind "+Z),M=T.Codicon.symbolProperty),`${U?"inline":"block"} ${M.classNames}`}s.toCssClassName=G})(i=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(b){this.value=b}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var h;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var w;(function(s){s[s.Other=0]="Other",s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var S;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(S=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[61],ge([0,1,11,9,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=g.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",g.isMacintosh),T.set("isLinux",g.isLinux),T.set("isWindows",g.isWindows),T.set("isWeb",g.isWeb),T.set("isMacNative",g.isMacintosh&&!g.isWeb),T.set("isEdge",C.indexOf("Edg/")>=0),T.set("isFirefox",C.indexOf("Firefox")>=0),T.set("isChrome",C.indexOf("Chrome")>=0),T.set("isSafari",C.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return k.INSTANCE}static true(){return d.INSTANCE}static has(s){return f.create(s)}static equals(s,b){return u.create(s,b)}static notEquals(s,b){return A.create(s,b)}static regex(s,b){return r.create(s,b)}static in(s,b){return p.create(s,b)}static not(s){return E.create(s)}static and(...s){return i.create(s)}static or(...s){return c.create(s)}static greater(s,b){return a.create(s,b)}static less(s,b){return v.create(s,b)}static deserialize(s,b=!1){if(!!s)return this._deserializeOrExpression(s,b)}static _deserializeOrExpression(s,b){let R=s.split("||");return c.create(R.map(O=>this._deserializeAndExpression(O,b)))}static _deserializeAndExpression(s,b){let R=s.split("&&");return i.create(R.map(O=>this._deserializeOne(O,b)))}static _deserializeOne(s,b){if(s=s.trim(),s.indexOf("!=")>=0){let R=s.split("!=");return A.create(R[0].trim(),this._deserializeValue(R[1],b))}if(s.indexOf("==")>=0){let R=s.split("==");return u.create(R[0].trim(),this._deserializeValue(R[1],b))}if(s.indexOf("=~")>=0){let R=s.split("=~");return r.create(R[0].trim(),this._deserializeRegexValue(R[1],b))}if(s.indexOf(" in ")>=0){let R=s.split(" in ");return p.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(s)){const R=s.split(">=");return l.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(s)){const R=s.split(">");return a.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(s)){const R=s.split("<=");return t.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(s)){const R=s.split("<");return v.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(s)?E.create(s.substr(1).trim()):f.create(s)}static _deserializeValue(s,b){if(s=s.trim(),s==="true")return!0;if(s==="false")return!1;let R=/^'([^']*)'$/.exec(s);return R?R[1].trim():s}static _deserializeRegexValue(s,b){if((0,L.isFalsyOrWhitespace)(s)){if(b)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let R=s.indexOf("/"),O=s.lastIndexOf("/");if(R===O||R<0){if(b)throw new Error(`bad regexp-value '${s}', missing /-enclosure`);return console.warn(`bad regexp-value '${s}', missing /-enclosure`),null}let $=s.slice(R+1,O),G=s[O+1]==="i"?"i":"";try{return new RegExp($,G)}catch(Z){if(b)throw new Error(`bad regexp-value '${s}', parse error: ${Z}`);return console.warn(`bad regexp-value '${s}', parse error: ${Z}`),null}}}e.ContextKeyExpr=P;function n(S,s){return S.cmp(s)}class k{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class d{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class f{constructor(s){this.key=s,this.type=2}static create(s){const b=T.get(s);return typeof b=="boolean"?b?d.INSTANCE:k.INSTANCE:new f(s)}cmp(s){return s.type!==this.type?this.type-s.type:m(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=f;class u{constructor(s,b){this.key=s,this.value=b,this.type=4}static create(s,b){if(typeof b=="boolean")return b?f.create(s):E.create(s);const R=T.get(s);return typeof R=="boolean"?b===(R?"true":"false")?d.INSTANCE:k.INSTANCE:new u(s,b)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(s){return s.mapEquals(this.key,this.value)}negate(){return A.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class p{constructor(s,b){this.key=s,this.valueKey=b,this.type=10}static create(s,b){return new p(s,b)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.valueKey,s.key,s.valueKey)}equals(s){return s.type===this.type?this.key===s.key&&this.valueKey===s.valueKey:!1}evaluate(s){const b=s.getValue(this.valueKey),R=s.getValue(this.key);return Array.isArray(b)?b.indexOf(R)>=0:typeof R=="string"&&typeof b=="object"&&b!==null?D.call(b,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(s){return s.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=p;class _{constructor(s){this._actual=s,this.type=11}static create(s){return new _(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new _(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class A{constructor(s,b){this.key=s,this.value=b,this.type=5}static create(s,b){if(typeof b=="boolean")return b?E.create(s):f.create(s);const R=T.get(s);return typeof R=="boolean"?b===(R?"true":"false")?k.INSTANCE:d.INSTANCE:new A(s,b)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(s){return s.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=A;class E{constructor(s){this.key=s,this.type=3}static create(s){const b=T.get(s);return typeof b=="boolean"?b?k.INSTANCE:d.INSTANCE:new E(s)}cmp(s){return s.type!==this.type?this.type-s.type:m(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!s.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(s){return s.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=E;class a{constructor(s,b){this.key=s,this.value=b,this.type=12}static create(s,b){return new a(s,b)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=a;class l{constructor(s,b){this.key=s,this.value=b,this.type=13}static create(s,b){return new l(s,b)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class v{constructor(s,b){this.key=s,this.value=b,this.type=14}static create(s,b){return new v(s,b)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(s,b){this.key=s,this.value=b,this.type=15}static create(s,b){return new t(s,b)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmallerEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(s,b){this.key=s,this.regexp=b,this.type=7}static create(s,b){return new r(s,b)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.key<s.key)return-1;if(this.key>s.key)return 1;const b=this.regexp?this.regexp.source:"",R=s.regexp?s.regexp.source:"";return b<R?-1:b>R?1:0}equals(s){if(s.type===this.type){const b=this.regexp?this.regexp.source:"",R=s.regexp?s.regexp.source:"";return this.key===s.key&&b===R}return!1}evaluate(s){let b=s.getValue(this.key);return this.regexp?this.regexp.test(b):!1}serialize(){const s=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${s}`}keys(){return[this.key]}map(s){return s.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=r;class o{constructor(s){this._actual=s,this.type=8}static create(s){return new o(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new o(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class i{constructor(s){this.expr=s,this.type=6}static create(s){return i._normalizeArr(s)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let b=0,R=this.expr.length;b<R;b++){const O=n(this.expr[b],s.expr[b]);if(O!==0)return O}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let b=0,R=this.expr.length;b<R;b++)if(!this.expr[b].equals(s.expr[b]))return!1;return!0}return!1}evaluate(s){for(let b=0,R=this.expr.length;b<R;b++)if(!this.expr[b].evaluate(s))return!1;return!0}static _normalizeArr(s){const b=[];let R=!1;for(const O of s)if(!!O){if(O.type===1){R=!0;continue}if(O.type===0)return k.INSTANCE;if(O.type===6){b.push(...O.expr);continue}b.push(O)}if(b.length===0&&R)return d.INSTANCE;if(b.length!==0){if(b.length===1)return b[0];for(b.sort(n);b.length>1;){const O=b[b.length-1];if(O.type!==9)break;b.pop();const $=b.pop(),G=c.create(O.expr.map(Z=>i.create([Z,$])));G&&(b.push(G),b.sort(n))}return b.length===1?b[0]:new i(b)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(let b of this.expr)s.push(...b.keys());return s}map(s){return new i(this.expr.map(b=>b.map(s)))}negate(){let s=[];for(let b of this.expr)s.push(b.negate());return c.create(s)}}e.ContextKeyAndExpr=i;class c{constructor(s){this.expr=s,this.type=9}static create(s){const b=c._normalizeArr(s);if(b.length!==0)return b.length===1?b[0]:new c(b)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let b=0,R=this.expr.length;b<R;b++){const O=n(this.expr[b],s.expr[b]);if(O!==0)return O}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let b=0,R=this.expr.length;b<R;b++)if(!this.expr[b].equals(s.expr[b]))return!1;return!0}return!1}evaluate(s){for(let b=0,R=this.expr.length;b<R;b++)if(this.expr[b].evaluate(s))return!0;return!1}static _normalizeArr(s){let b=[],R=!1;if(s){for(let O=0,$=s.length;O<$;O++){const G=s[O];if(!!G){if(G.type===0){R=!0;continue}if(G.type===1)return[d.INSTANCE];if(G.type===9){b=b.concat(G.expr);continue}b.push(G)}}if(b.length===0&&R)return[k.INSTANCE];b.sort(n)}return b}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(let b of this.expr)s.push(...b.keys());return s}map(s){return new c(this.expr.map(b=>b.map(s)))}negate(){let s=[];for(let R of this.expr)s.push(R.negate());const b=R=>R.type===9?R.expr:[R];for(;s.length>1;){const R=s.shift(),O=s.shift(),$=[];for(const G of b(R))for(const Z of b(O))$.push(P.and(G,Z));s.unshift(P.or(...$))}return s[0]}}e.ContextKeyOrExpr=c;class h extends f{constructor(s,b,R){super(s);this._defaultValue=b,typeof R=="object"?h._info.push({...R,key:s}):R!==!0&&h._info.push({key:s,description:R,type:b!=null?typeof b:void 0})}static all(){return h._info.values()}bindTo(s){return s.createKey(this.key,this._defaultValue)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(s){return P.equals(this.key,s)}notEqualsTo(s){return P.notEquals(this.key,s)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(S,s){return S<s?-1:S>s?1:0}function w(S,s,b,R){return S<b?-1:S>b?1:s<R?-1:s>R?1:0}}),define(me[184],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(me[185],ge([0,1,10,157,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=C;var T;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var D;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(D=e.SortOrder||(e.SortOrder={}));var y;(function(k){k.Install="install",k.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var P;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(d,f){super(d);this.code=f,this.name=f}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=I;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class D{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,d){if(typeof k=="undefined"||k===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof k=="string"||typeof d=="string"){let f=typeof k=="string"?k:k.value,u=typeof d=="string"?d:d.value;return g.equalsIgnoreCase(f,u)}return k._lower===d._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.ExtensionIdentifier=D;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function P(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[186],ge([0,1,9,26]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(u,p){return u.uuid&&p.uuid?u.uuid===p.uuid:u.id===p.id?!0:(0,g.compareIgnoreCase)(u.id,p.id)===0}e.areSameExtensions=I;class C{constructor(p,_){this.version=_,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof C?I(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=C;function T(u,p){return`${u}.${p}`}e.getExtensionId=T;function D(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(u,p){return D(T(u,p))}e.getGalleryExtensionId=y;function P(u,p){const _=[],A=E=>{for(const a of _)if(a.some(l=>I(p(l),p(E))))return a;return null};for(const E of u){const a=A(E);a?a.push(E):_.push([E])}return _}e.groupByExtension=P;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function k(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function d(u){const p=new Set;for(const _ of u)_.malicious&&p.add(_.id.id);return p}e.getMaliciousExtensionsSet=d;function f(u,p){const _=[],A=p.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const E=A.shift();if(E&&_.every(a=>!I(a.identifier,{id:E}))){const a=u.filter(l=>I(l.identifier,{id:E}));a.length===1&&(_.push(a[0]),A.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=f}),define(me[187],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(me[188],ge([0,1,39,10,8,11,141,28,113,159,187]),function(Y,e,g,L,I,C,T,D,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=P.localize(0,null);class d{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends d{openTerminal(l,v){return this.spawnTerminal(g,l,y.getWindowsShell(),v)}spawnTerminal(l,v,t,r){const o=v.windowsExec||f.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=I.basename(o).toLowerCase();if(i==="cmder"||i==="cmder.exe")return l.spawn(o,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return o.indexOf(" ")>=0&&c.push('""'),c.push(o),(i==="wt"||i==="wt.exe")&&c.push("-d ."),new Promise((h,m)=>{const w=_(process),S=l.spawn(t,c,{cwd:r,env:w});S.on("error",m),S.on("exit",()=>h())})}runInTerminal(l,v,t,r,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:f.getDefaultTerminalWindows();return new Promise((c,h)=>{const m=`"${v} - ${k}"`,w=`""${t.join('" "')}" & pause"`,S=["/c","start",m,"/wait",i,"/c",w],s=Object.assign({},_(process),r);Object.keys(s).filter(O=>s[O]===null).forEach(O=>delete s[O]);const b={cwd:v,env:s,windowsVerbatimArguments:!0};g.spawn(f.CMD,S,b).on("error",O=>{h(A(O))}),c(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class u extends d{openTerminal(l,v){return this.spawnTerminal(g,l,v)}runInTerminal(l,v,t,r,o){const i=o.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((c,h)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const m=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,Y).fsPath,"-t",l||k,"-w",v];for(let R of t)S.push("-a"),S.push(R);if(r){const R=Object.assign({},_(process),r);for(let O in R){const $=R[O];$===null?(S.push("-u"),S.push(O)):(S.push("-e"),S.push(`${O}=${$}`))}}let s="";const b=g.spawn(u.OSASCRIPT,S);b.on("error",R=>{h(A(R))}),b.stderr.on("data",R=>{s+=R.toString()}),b.on("exit",R=>{if(R===0)c(void 0);else if(s){const O=s.split(`
`,1);h(new Error(O[0]))}else h(new Error(P.localize(1,null,m,R)))})}else h(new Error(P.localize(2,null,i)))})}spawnTerminal(l,v,t){const r=v.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((o,i)=>{const c=["-a",r];t&&c.push(t);const h=_(process),m=l.spawn("/usr/bin/open",c,{cwd:t,env:h});m.on("error",i),m.on("exit",()=>o())})}}e.MacExternalTerminalService=u,u.OSASCRIPT="/usr/bin/osascript";class p extends d{openTerminal(l,v){return this.spawnTerminal(g,l,v)}runInTerminal(l,v,t,r,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,h)=>{let m=[];i.then(w=>{w.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const S=`${E(t)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;m.push(`''${S}''`);const s=Object.assign({},_(process),r);Object.keys(s).filter($=>s[$]===null).forEach($=>delete s[$]);const b={cwd:v,env:s};let R="";const O=g.spawn(w,m,b);O.on("error",$=>{h(A($))}),O.stderr.on("data",$=>{R+=$.toString()}),O.on("exit",$=>{if($===0)c(void 0);else if(R){const G=R.split(`
`,1);h(new Error(G[0]))}else h(new Error(P.localize(4,null,w,$)))})})})}static async getDefaultTerminalLinuxReady(){return p._DEFAULT_TERMINAL_LINUX_READY||(p._DEFAULT_TERMINAL_LINUX_READY=new Promise(async l=>{C.isLinux?await D.Promises.exists("/etc/debian_version")?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm"):l("xterm")})),p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,v,t){const r=v.linuxExec?Promise.resolve(v.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{r.then(c=>{const h=_(process),m=l.spawn(c,[],{cwd:t,env:h});m.on("error",i),m.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=P.localize(3,null);function _(a){const l={...a.env};return(0,T.sanitizeProcessEnvironment)(l),l}function A(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(P.localize(5,null,a.path)):a}function E(a){let l="";for(let v of a)v.indexOf(" ")>=0?l+='"'+v+'"':l+=v,l+=" ";return l}}),define(me[42],ge([0,1,24,8,9,13,2,160,4]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(U){return U.create===!0}e.isFileOpenForWriteOptions=P;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var k;(function(U){U[U.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var d;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=f;function u(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=u;function p(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function _(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=_;var A;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(x,M){super(x);this.code=M}}e.FileSystemProviderError=E;function a(U,x){const M=new E(U.toString(),x);return v(M,x),M}e.createFileSystemProviderError=a;function l(U){return U||a((0,D.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=l;function v(U,x){return U.name=x?`${x} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=v;function t(U){if(!U)return A.Unknown;if(U instanceof E)return U.code;const x=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!x)return A.Unknown;switch(x[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof w)return U.fileOperationResult;switch(t(U)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(o=e.FileOperation||(e.FileOperation={}));class i{constructor(x,M,H){this.resource=x,this.operation=M,this.target=H}isOperation(x){return this.operation===x}}e.FileOperationEvent=i;var c;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class h{constructor(x,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const H of x)switch(H.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>M)),this.added.set(H.resource,H);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>M)),this.updated.set(H.resource,H);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>M)),this.deleted.set(H.resource,H);break}}contains(x,...M){return this.doContains(x,{includeChildren:!1},...M)}affects(x,...M){return this.doContains(x,{includeChildren:!0},...M)}doContains(x,M,...H){if(!x)return!1;const F=H.length>0;return!!((!F||H.includes(1))&&(this.added?.get(x)||M.includeChildren&&this.added?.findSuperstr(x))||(!F||H.includes(0))&&(this.updated?.get(x)||M.includeChildren&&this.updated?.findSuperstr(x))||(!F||H.includes(2))&&(this.deleted?.findSubstr(x)||M.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function m(U,x,M){return!U||!x||U===x||x.length>U.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),M?(0,I.startsWithIgnoreCase)(U,x):U.indexOf(x)===0)}e.isParent=m;class w extends Error{constructor(x,M,H){super(x);this.fileOperationResult=M,this.options=H}}e.FileOperationError=w;class S extends w{constructor(x,M,H){super(x,2,H);this.stat=M}}e.NotModifiedSinceFileOperationError=S;var s;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(s=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var b;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(b=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=R;async function O(U,x){if(!x.canHandleResource(T.URI.from({scheme:U.scheme})))return new Promise(M=>{const H=x.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===U.scheme&&F.added&&(H.dispose(),M())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(x){return(0,C.isNumber)(x)||(x=0),x<$.KB?(0,D.localize)(1,null,x.toFixed(0)):x<$.MB?(0,D.localize)(2,null,(x/$.KB).toFixed(2)):x<$.GB?(0,D.localize)(3,null,(x/$.MB).toFixed(2)):x<$.TB?(0,D.localize)(4,null,(x/$.GB).toFixed(2)):(0,D.localize)(5,null,(x/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var G;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function Z(U){return{maxFileSize:U===0?300*$.MB:16*$.GB,maxHeapSize:U===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=Z}),define(me[84],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...I){this._entries=new Map;for(let[C,T]of I)this.set(C,T)}set(I,C){const T=this._entries.get(I);return this._entries.set(I,C),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=g}),define(me[189],ge([0,1,17,16,114,181,4,84]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new D.ServiceCollection,p=!1,_){this._activeInstantiations=new Set,this._services=u,this._strict=p,this._parent=_,this._services.set(T.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...p){let _=d.traceInvocation(u),A=!1;try{return u({get:(a,l)=>{if(A)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(a,_);if(!v&&l!==T.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return v}},...p)}finally{A=!0,_.stop()}}createInstance(u,...p){let _,A;return u instanceof I.SyncDescriptor?(_=d.traceCreation(u.ctor),A=this._createInstance(u.ctor,u.staticArguments.concat(p),_)):(_=d.traceCreation(u),A=this._createInstance(u,p,_)),_.stop(),A}_createInstance(u,p=[],_){let A=T._util.getServiceDependencies(u).sort((l,v)=>l.index-v.index),E=[];for(const l of A){let v=this._getOrCreateServiceInstance(l.id,_);if(!v&&this._strict&&!l.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${l.id}.`);E.push(v)}let a=A.length>0?A[0].index:p.length;if(p.length!==a){console.warn(`[createInstance] First service dependency of ${u.name} at position ${a+1} conflicts with ${p.length} static arguments`);let l=a-p.length;l>0?p=p.concat(new Array(l)):p=p.slice(0,a)}return new u(...[...p,...E])}_setServiceInstance(u,p){if(this._services.get(u)instanceof I.SyncDescriptor)this._services.set(u,p);else if(this._parent)this._parent._setServiceInstance(u,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let p=this._services.get(u);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):p}_getOrCreateServiceInstance(u,p){let _=this._getServiceInstanceOrDescriptor(u);return _ instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,_,p.branch(u,!0)):(p.branch(u,!1),_)}_safeCreateAndCacheServiceInstance(u,p,_){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,p,_)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,p,_){const A=new C.Graph(l=>l.id.toString());let E=0;const a=[{id:u,desc:p,_trace:_}];for(;a.length;){const l=a.pop();if(A.lookupOrInsertNode(l),E++>1e3)throw new P(A);for(let v of T._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${u} depends on ${v.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const r={id:v.id,desc:t,_trace:l._trace.branch(v.id,!0)};A.insertEdge(l,r),a.push(r)}}}for(;;){const l=A.roots();if(l.length===0){if(!A.isEmpty())throw new P(A);break}for(const{data:v}of l){if(this._getServiceInstanceOrDescriptor(v.id)instanceof I.SyncDescriptor){const r=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,r)}A.removeNode(v)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,p,_=[],A,E){if(this._services.get(u)instanceof I.SyncDescriptor)return this._createServiceInstance(p,_,A,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,p,_,A,E);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(u,p=[],_,A){if(_){const E=new g.IdleValue(()=>this._createInstance(u,p,A));return new Proxy(Object.create(null),{get(a,l){if(l in a)return a[l];let v=E.value,t=v[l];return typeof t!="function"||(t=t.bind(v),a[l]=t),t},set(a,l,v){return E.value[l]=v,!0}})}else return this._createInstance(u,p,A)}}e.InstantiationService=n;var k;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(k||(k={}));class d{constructor(u,p){this.type=u,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return y?new d(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(u){return y?new d(0,u.name):d._None}branch(u,p){let _=new d(2,u.toString());return this._dep.push([u,p,_]),_}stop(){let u=Date.now()-this._start;d._totals+=u;let p=!1;function _(E,a){let l=[],v=new Array(E+1).join("	");for(const[t,r,o]of a._dep)if(r&&o){p=!0,l.push(`${v}CREATES -> ${t}`);let i=_(E+1,o);i&&l.push(i)}else l.push(`${v}uses -> ${t}`);return l.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(u>2||p)&&console.log(A.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(me[12],ge([0,1,60,3,6,11,4]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function D(){return new Date().toISOString()}var y;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class P extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class n extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(y.Error,this.format(o))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let o=0;o<t.length;o++){let i=t[o];if(typeof i=="object")try{i=JSON.stringify(i)}catch(c){}r+=(o>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class k extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...r):console.warn(`[main ${D()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class d extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class f extends P{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,g.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class u extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class p extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=p;class _ extends I.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class A{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=A;function E(v){if(v.verbose)return y.Trace;if(typeof v.logLevel=="string"){const t=a(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function a(v){switch(v){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=a;function l(v){switch(v){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=l}),define(me[115],ge([0,1,42,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function I(y,P,n,k){try{const d=await new Promise((f,u)=>{Y(["spdlog"],f,u)});return d.setFlushOn(L.LogLevel.Trace),d.createAsyncRotatingLogger(y,P,n,k)}catch(d){console.error(d)}return null}function C(y,P,n,k){const d=Y.__$__nodeRequire("spdlog");return d.setFlushOn(L.LogLevel.Trace),d.createRotatingLogger(y,P,n,k)}e.createRotatingLogger=C;function T(y,P,n){switch(P){case L.LogLevel.Trace:y.trace(n);break;case L.LogLevel.Debug:y.debug(n);break;case L.LogLevel.Info:y.info(n);break;case L.LogLevel.Warning:y.warn(n);break;case L.LogLevel.Error:y.error(n);break;case L.LogLevel.Critical:y.critical(n);break;default:throw new Error("Invalid log level")}}class D extends L.AbstractMessageLogger{constructor(P,n,k,d){super();this.name=P,this.filepath=n,this.rotating=k,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const P=this.rotating?6:1,n=30/P*g.ByteSize.MB;return I(this.name,this.filepath,n,P).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:d,message:f}of this.buffer)T(this._logger,d,f);this.buffer=[]}})}log(P,n){this._logger?T(this._logger,P,n):this.getLevel()<=P&&this.buffer.push({level:P,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(me[116],ge([0,1,48,161,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(u,p){return p-u}y.compare=P;const n=Object.create(null);n[y.Error]=(0,L.localize)(0,null),n[y.Warning]=(0,L.localize)(1,null),n[y.Info]=(0,L.localize)(2,null);function k(u){return n[u]||""}y.toString=k;function d(u){switch(u){case g.default.Error:return y.Error;case g.default.Warning:return y.Warning;case g.default.Info:return y.Info;case g.default.Ignore:return y.Hint}}y.fromSeverity=d;function f(u){switch(u){case y.Error:return g.default.Error;case y.Warning:return g.default.Warning;case y.Info:return g.default.Info;case y.Hint:return g.default.Ignore}}y.toSeverity=f}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(y){const P="";function n(d){return k(d,!0)}y.makeKey=n;function k(d,f){let u=[P];return d.source?u.push(d.source.replace("\xA6","\\\xA6")):u.push(P),d.code?typeof d.code=="string"?u.push(d.code.replace("\xA6","\\\xA6")):u.push(d.code.value.replace("\xA6","\\\xA6")):u.push(P),d.severity!==void 0&&d.severity!==null?u.push(T.toString(d.severity)):u.push(P),d.message&&f?u.push(d.message.replace("\xA6","\\\xA6")):u.push(P),d.startLineNumber!==void 0&&d.startLineNumber!==null?u.push(d.startLineNumber.toString()):u.push(P),d.startColumn!==void 0&&d.startColumn!==null?u.push(d.startColumn.toString()):u.push(P),d.endLineNumber!==void 0&&d.endLineNumber!==null?u.push(d.endLineNumber.toString()):u.push(P),d.endColumn!==void 0&&d.endColumn!==null?u.push(d.endColumn.toString()):u.push(P),u.push(P),u.join("\xA6")}y.makeKeyOptionalMessage=k})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(me[190],ge([0,1,3,48,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,I.createDecorator)("notificationService");var C;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new y,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=D;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(me[191],ge([0,1,6,9,2,4]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function T(D,y){return I.URI.isUri(D)?(0,L.equalsIgnoreCase)(D.scheme,y):(0,L.startsWithIgnoreCase)(D,y+":")}e.matchesScheme=T}),define(me[117],ge([0,1,10,11,38,25]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const D=L.globals.vscode.context.configuration();if(D)T=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const D=(0,C.dirname)(g.FileAccess.asFileUri("",Y));T=Y.__$__nodeRequire((0,C.joinPath)(D,"product.json").fsPath);const y=Y.__$__nodeRequire((0,C.joinPath)(D,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:y.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(me[118],ge([0,1,155,11,110,117]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=D;class y{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=y;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class n{constructor(te,pe,Ve,tt){this.id=te,this.name=pe,this.defaultValue=Ve,this.schema=tt}compute(te,pe,Ve){return Ve}}class k{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class d{constructor(te,pe,Ve,tt){this.id=te,this.name=pe,this.defaultValue=Ve,this.schema=tt}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,Ve){return Ve}}function f(K,te){return typeof K=="undefined"?te:K==="false"?!1:Boolean(K)}e.boolean=f;class u extends d{constructor(te,pe,Ve,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=Ve),super(te,pe,Ve,tt)}validate(te){return f(te,this.defaultValue)}}class p extends d{constructor(te,pe,Ve,tt,st,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=Ve,lt.minimum=tt,lt.maximum=st),super(te,pe,Ve,lt),this.minimum=tt,this.maximum=st}static clampedInt(te,pe,Ve,tt){if(typeof te=="undefined")return pe;let st=parseInt(te,10);return isNaN(st)?pe:(st=Math.max(Ve,st),st=Math.min(tt,st),st|0)}validate(te){return p.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class _ extends d{constructor(te,pe,Ve,tt,st){typeof st!="undefined"&&(st.type="number",st.default=Ve),super(te,pe,Ve,st),this.validationFn=tt}static clamp(te,pe,Ve){return te<pe?pe:te>Ve?Ve:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const Ve=parseFloat(te);return isNaN(Ve)?pe:Ve}validate(te){return this.validationFn(_.float(te,this.defaultValue))}}class A extends d{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,Ve,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=Ve),super(te,pe,Ve,tt)}validate(te){return A.string(te,this.defaultValue)}}function E(K,te,pe){return typeof K!="string"||pe.indexOf(K)===-1?te:K}e.stringSet=E;class a extends d{constructor(te,pe,Ve,tt,st=void 0){typeof st!="undefined"&&(st.type="string",st.enum=tt,st.default=Ve),super(te,pe,Ve,st),this._allowedValues=tt}validate(te){return E(te,this.defaultValue,this._allowedValues)}}class l extends n{constructor(te,pe,Ve,tt,st,lt,vt=void 0){typeof vt!="undefined"&&(vt.type="string",vt.enum=st,vt.default=tt),super(te,pe,Ve,vt),this._allowedValues=st,this._convert=lt}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function v(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,Ve){return Ve===0?te.accessibilitySupport:Ve}}class r extends n{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:g.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:f(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(K){switch(K){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function m(K){switch(K){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class w extends k{constructor(){super(127,[65,32])}compute(te,pe,Ve){const tt=["monaco-editor"];return pe.get(32)&&tt.push(pe.get(32)),te.extraEditorClassName&&tt.push(te.extraEditorClassName),pe.get(65)==="default"?tt.push("mouse-default"):pe.get(65)==="copy"&&tt.push("mouse-copy"),pe.get(100)&&tt.push("showUnused"),pe.get(125)&&tt.push("showDeprecated"),tt.join(" ")}}class S extends u{constructor(){super(31,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(te,pe,Ve){return Ve&&te.emptySelectionClipboard}}class s extends n{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:g.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:f(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":E(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":E(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(pe.loop,this.defaultValue.loop)}}}class b extends n{constructor(){super(43,"fontLigatures",b.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?b.OFF:te==="true"?b.ON:te:Boolean(te)?b.ON:b.OFF}}e.EditorFontLigatures=b,b.OFF='"liga" off, "calt" off',b.ON='"liga" on, "calt" on';class R extends k{constructor(){super(42)}compute(te,pe,Ve){return te.fontInfo}}class O extends d{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(te){let pe=_.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(pe,6,100)}compute(te,pe,Ve){return te.fontInfo.fontSize}}class $ extends n{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(p.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class G extends n{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Ve,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Ve,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Ve,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Ve,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Ve,description:g.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:E(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??E(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??E(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??E(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??E(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??E(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:A.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:A.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:A.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:A.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:A.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends n{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:g.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:f(pe.enabled,this.defaultValue.enabled),delay:p.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:f(pe.sticky,this.defaultValue.sticky)}}}var U;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class x extends k{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,Ve){return x.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,Ve=te.scrollBeyondLastLine?pe-1:0,tt=(te.viewLineCount+Ve)/(te.pixelRatio*te.height),st=Math.floor(te.viewLineCount/tt);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ve,desiredRatio:tt,minimapLineCount:st}}static _computeMinimapLayout(te,pe){const Ve=te.outerWidth,tt=te.outerHeight,st=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const lt=pe.stableMinimapLayoutInput,vt=lt&&te.outerHeight===lt.outerHeight&&te.lineHeight===lt.lineHeight&&te.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&te.pixelRatio===lt.pixelRatio&&te.scrollBeyondLastLine===lt.scrollBeyondLastLine&&te.minimap.enabled===lt.minimap.enabled&&te.minimap.side===lt.minimap.side&&te.minimap.size===lt.minimap.size&&te.minimap.showSlider===lt.minimap.showSlider&&te.minimap.renderCharacters===lt.minimap.renderCharacters&&te.minimap.maxColumn===lt.minimap.maxColumn&&te.minimap.scale===lt.minimap.scale&&te.verticalScrollbarWidth===lt.verticalScrollbarWidth&&te.isViewportWrapping===lt.isViewportWrapping,Dt=te.lineHeight,ue=te.typicalHalfwidthCharacterWidth,Ie=te.scrollBeyondLastLine,Ne=te.minimap.renderCharacters;let Ge=st>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const We=te.minimap.maxColumn,ot=te.minimap.size,Re=te.minimap.side,Se=te.verticalScrollbarWidth,Ce=te.viewLineCount,ne=te.remainingWidth,de=te.isViewportWrapping,be=Ne?2:3;let we=Math.floor(st*tt);const Fe=we/st;let qe=!1,He=!1,Je=be*Ge,nt=Ge/st,ae=1;if(ot==="fill"||ot==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeyondLastLine:at,desiredRatio:wt,minimapLineCount:_t}=x.computeContainedMinimapLineCount({viewLineCount:Ce,scrollBeyondLastLine:Ie,height:tt,lineHeight:Dt,pixelRatio:st});if(Ce/_t>1)qe=!0,He=!0,Ge=1,Je=1,nt=Ge/st;else{let gt=!1,ft=Ge+1;if(ot==="fit"){const Tt=Math.ceil((Ce+at)*Je);de&&vt&&ne<=pe.stableFitRemainingWidth?(gt=!0,ft=pe.stableFitMaxMinimapScale):gt=Tt>we}if(ot==="fill"||gt){qe=!0;const Tt=Ge;Je=Math.min(Dt*st,Math.max(1,Math.floor(1/wt))),de&&vt&&ne<=pe.stableFitRemainingWidth&&(ft=pe.stableFitMaxMinimapScale),Ge=Math.min(ft,Math.max(1,Math.floor(Je/be))),Ge>Tt&&(ae=Math.min(2,Ge/Tt)),nt=Ge/st/ae,we=Math.ceil(Math.max(Xe,Ce+at)*Je),de?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ne,pe.stableFitMaxMinimapScale=Ge):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Ee=Math.floor(We*nt),ce=Math.min(Ee,Math.max(0,Math.floor((ne-Se-2)*nt/(ue+nt)))+e.MINIMAP_GUTTER_WIDTH);let q=Math.floor(st*ce);const Te=q/st;q=Math.floor(q*ae);const Pe=Ne?1:2,Ye=Re==="left"?0:Ve-ce-Se;return{renderMinimap:Pe,minimapLeft:Ye,minimapWidth:ce,minimapHeightIsEditorHeight:qe,minimapIsSampling:He,minimapScale:Ge,minimapLineHeight:Je,minimapCanvasInnerWidth:q,minimapCanvasInnerHeight:we,minimapCanvasOuterWidth:Te,minimapCanvasOuterHeight:Fe}}static computeLayout(te,pe){const Ve=pe.outerWidth|0,tt=pe.outerHeight|0,st=pe.lineHeight|0,lt=pe.lineNumbersDigitCount|0,vt=pe.typicalHalfwidthCharacterWidth,Dt=pe.maxDigitWidth,ue=pe.pixelRatio,Ie=pe.viewLineCount,Ne=te.get(122),Ge=Ne==="inherit"?te.get(121):Ne,We=Ge==="inherit"?te.get(117):Ge,ot=te.get(120),Re=te.get(2),Se=pe.isDominatedByLongLines,Ce=te.get(48),ne=te.get(59).renderType!==0,de=te.get(60),be=te.get(94),we=te.get(64),Fe=te.get(92),qe=Fe.verticalScrollbarSize,He=Fe.verticalHasArrows,Je=Fe.arrowSize,nt=Fe.horizontalScrollbarSize,ae=te.get(57),Ee=te.get(36);let ce;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const Bt=parseFloat(ae.substr(0,ae.length-2));ce=p.clampedInt(Bt*vt,0,0,1e3)}else ce=p.clampedInt(ae,0,0,1e3);Ee&&(ce+=16);let q=0;if(ne){const Bt=Math.max(lt,de);q=Math.round(Bt*Dt)}let Te=0;Ce&&(Te=st);let Pe=0,Ye=Pe+Te,Xe=Ye+q,at=Xe+ce;const wt=Ve-Te-q-ce;let _t=!1,ht=!1,gt=-1;Re!==2&&(Ge==="inherit"&&Se?(_t=!0,ht=!0):We==="on"||We==="bounded"?ht=!0:We==="wordWrapColumn"&&(gt=ot));const ft=x._computeMinimapLayout({outerWidth:Ve,outerHeight:tt,lineHeight:st,typicalHalfwidthCharacterWidth:vt,pixelRatio:ue,scrollBeyondLastLine:be,minimap:we,verticalScrollbarWidth:qe,viewLineCount:Ie,remainingWidth:wt,isViewportWrapping:ht},pe.memory||new P);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Pe+=ft.minimapWidth,Ye+=ft.minimapWidth,Xe+=ft.minimapWidth,at+=ft.minimapWidth);const Tt=wt-ft.minimapWidth,yt=Math.max(1,Math.floor((Tt-qe-2)/vt)),xt=He?Je:0;return ht&&(gt=Math.max(1,yt),We==="bounded"&&(gt=Math.min(gt,ot))),{width:Ve,height:tt,glyphMarginLeft:Pe,glyphMarginWidth:Te,lineNumbersLeft:Ye,lineNumbersWidth:q,decorationsLeft:Xe,decorationsWidth:ce,contentLeft:at,contentWidth:Tt,minimap:ft,viewportColumn:yt,isWordWrapMinified:_t,isViewportWrapping:ht,wrappingColumn:gt,verticalScrollbarWidth:qe,horizontalScrollbarHeight:nt,overviewRuler:{top:xt,width:qe,height:tt-2*xt,right:0}}}}e.EditorLayoutInfoComputer=x;class M extends n{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:g.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:f(te.enabled,this.defaultValue.enabled)}}}class H extends n{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:g.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:f(pe.enabled,this.defaultValue.enabled),fontSize:p.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:A.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class F extends _{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>_.clamp(te,0,150),{markdownDescription:g.localize(46,null)})}compute(te,pe,Ve){return te.fontInfo.lineHeight}}class N extends n{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:te.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:g.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:f(pe.enabled,this.defaultValue.enabled),size:E(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(pe.side,this.defaultValue.side,["right","left"]),showSlider:E(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(pe.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(pe.scale,1,1,3),maxColumn:p.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(K){return K==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends n{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:p.clampedInt(pe.top,0,0,1e3),bottom:p.clampedInt(pe.bottom,0,0,1e3)}}}class Q extends n{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:g.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:f(pe.enabled,this.defaultValue.enabled),cycle:f(pe.cycle,this.defaultValue.cycle)}}}class J extends k{constructor(){super(128)}compute(te,pe,Ve){return te.pixelRatio}}class fe extends n{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:g.localize(61,null)},comments:{type:"boolean",default:te.comments,description:g.localize(62,null)},other:{type:"boolean",default:te.other,description:g.localize(63,null)}}}],default:te,description:g.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,Ve={other:f(pe.other,this.defaultValue.other),comments:f(pe.comments,this.defaultValue.comments),strings:f(pe.strings,this.defaultValue.strings)};return Ve.other&&Ve.comments&&Ve.strings?!0:!Ve.other&&!Ve.comments&&!Ve.strings?!1:Ve}return this.defaultValue}}var _e;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends n{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,Ve=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ve}}}function Le(K){const te=K.get(87);return te==="editable"?K.get(80):te!=="on"}e.filterValidationDecorations=Le;class Be extends n{constructor(){const te=[],pe={type:"number",description:g.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:te,description:g.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let Ve of te)if(typeof Ve=="number")pe.push({column:p.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const tt=Ve;pe.push({column:p.clampedInt(tt.column,0,0,1e4),color:tt.color})}return pe.sort((Ve,tt)=>Ve.column-tt.column),pe}return this.defaultValue}}function xe(K,te){if(typeof K!="string")return te;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ke extends n{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:g.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,Ve=p.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=p.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:xe(pe.vertical,this.defaultValue.vertical),horizontal:xe(pe.horizontal,this.defaultValue.horizontal),useShadows:f(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:p.clampedInt(pe.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:p.clampedInt(pe.verticalSliderSize,tt,0,1e3),scrollByPage:f(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class z extends n{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:g.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:te.mode,description:g.localize(88,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:f(pe.enabled,this.defaultValue.enabled),mode:E(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends n{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:g.localize(89,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:f(te.enabled,this.defaultValue.enabled)}}}class re extends n{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(90,null),g.localize(91,null)],default:te.insertMode,description:g.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:g.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:g.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:g.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:g.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:g.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:g.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:g.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(100,null),g.localize(101,null),g.localize(102,null)],default:te.previewMode,description:g.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:g.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:E(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(pe.showIcons,this.defaultValue.showIcons),showStatusBar:f(pe.showStatusBar,this.defaultValue.showStatusBar),preview:f(pe.preview,this.defaultValue.preview),previewMode:E(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(pe.showMethods,this.defaultValue.showMethods),showFunctions:f(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:f(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:f(pe.showFields,this.defaultValue.showFields),showVariables:f(pe.showVariables,this.defaultValue.showVariables),showClasses:f(pe.showClasses,this.defaultValue.showClasses),showStructs:f(pe.showStructs,this.defaultValue.showStructs),showInterfaces:f(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:f(pe.showModules,this.defaultValue.showModules),showProperties:f(pe.showProperties,this.defaultValue.showProperties),showEvents:f(pe.showEvents,this.defaultValue.showEvents),showOperators:f(pe.showOperators,this.defaultValue.showOperators),showUnits:f(pe.showUnits,this.defaultValue.showUnits),showValues:f(pe.showValues,this.defaultValue.showValues),showConstants:f(pe.showConstants,this.defaultValue.showConstants),showEnums:f(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:f(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(pe.showKeywords,this.defaultValue.showKeywords),showWords:f(pe.showWords,this.defaultValue.showWords),showColors:f(pe.showColors,this.defaultValue.showColors),showFiles:f(pe.showFiles,this.defaultValue.showFiles),showReferences:f(pe.showReferences,this.defaultValue.showReferences),showFolders:f(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:f(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(pe.showSnippets,this.defaultValue.showSnippets),showUsers:f(pe.showUsers,this.defaultValue.showUsers),showIssues:f(pe.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(136,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class X extends k{constructor(){super(129,[80])}compute(te,pe,Ve){return pe.get(80)?!0:te.tabFocusMode}}var oe;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function ve(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Me extends k{constructor(){super(131,[130])}compute(te,pe,Ve){const tt=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const ze="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Qe:L.isLinux?et:ze,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:C.default.quality!=="stable"}},e.editorOptionsRegistry=[];function ke(K){return e.editorOptionsRegistry[K.id]=K,K}var ct;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.bracketPairColorization=12]="bracketPairColorization",K[K.codeLens=13]="codeLens",K[K.codeLensFontFamily=14]="codeLensFontFamily",K[K.codeLensFontSize=15]="codeLensFontSize",K[K.colorDecorators=16]="colorDecorators",K[K.columnSelection=17]="columnSelection",K[K.comments=18]="comments",K[K.contextmenu=19]="contextmenu",K[K.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",K[K.cursorBlinking=21]="cursorBlinking",K[K.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",K[K.cursorStyle=23]="cursorStyle",K[K.cursorSurroundingLines=24]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",K[K.cursorWidth=26]="cursorWidth",K[K.disableLayerHinting=27]="disableLayerHinting",K[K.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",K[K.domReadOnly=29]="domReadOnly",K[K.dragAndDrop=30]="dragAndDrop",K[K.emptySelectionClipboard=31]="emptySelectionClipboard",K[K.extraEditorClassName=32]="extraEditorClassName",K[K.fastScrollSensitivity=33]="fastScrollSensitivity",K[K.find=34]="find",K[K.fixedOverflowWidgets=35]="fixedOverflowWidgets",K[K.folding=36]="folding",K[K.foldingStrategy=37]="foldingStrategy",K[K.foldingHighlight=38]="foldingHighlight",K[K.foldingImportsByDefault=39]="foldingImportsByDefault",K[K.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=41]="fontFamily",K[K.fontInfo=42]="fontInfo",K[K.fontLigatures=43]="fontLigatures",K[K.fontSize=44]="fontSize",K[K.fontWeight=45]="fontWeight",K[K.formatOnPaste=46]="formatOnPaste",K[K.formatOnType=47]="formatOnType",K[K.glyphMargin=48]="glyphMargin",K[K.gotoLocation=49]="gotoLocation",K[K.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",K[K.hover=52]="hover",K[K.inDiffEditor=53]="inDiffEditor",K[K.inlineSuggest=54]="inlineSuggest",K[K.letterSpacing=55]="letterSpacing",K[K.lightbulb=56]="lightbulb",K[K.lineDecorationsWidth=57]="lineDecorationsWidth",K[K.lineHeight=58]="lineHeight",K[K.lineNumbers=59]="lineNumbers",K[K.lineNumbersMinChars=60]="lineNumbersMinChars",K[K.linkedEditing=61]="linkedEditing",K[K.links=62]="links",K[K.matchBrackets=63]="matchBrackets",K[K.minimap=64]="minimap",K[K.mouseStyle=65]="mouseStyle",K[K.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=67]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",K[K.multiCursorModifier=69]="multiCursorModifier",K[K.multiCursorPaste=70]="multiCursorPaste",K[K.occurrencesHighlight=71]="occurrencesHighlight",K[K.overviewRulerBorder=72]="overviewRulerBorder",K[K.overviewRulerLanes=73]="overviewRulerLanes",K[K.padding=74]="padding",K[K.parameterHints=75]="parameterHints",K[K.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",K[K.quickSuggestions=78]="quickSuggestions",K[K.quickSuggestionsDelay=79]="quickSuggestionsDelay",K[K.readOnly=80]="readOnly",K[K.renameOnType=81]="renameOnType",K[K.renderControlCharacters=82]="renderControlCharacters",K[K.renderIndentGuides=83]="renderIndentGuides",K[K.renderFinalNewline=84]="renderFinalNewline",K[K.renderLineHighlight=85]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=87]="renderValidationDecorations",K[K.renderWhitespace=88]="renderWhitespace",K[K.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",K[K.roundedSelection=90]="roundedSelection",K[K.rulers=91]="rulers",K[K.scrollbar=92]="scrollbar",K[K.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=94]="scrollBeyondLastLine",K[K.scrollPredominantAxis=95]="scrollPredominantAxis",K[K.selectionClipboard=96]="selectionClipboard",K[K.selectionHighlight=97]="selectionHighlight",K[K.selectOnLineNumbers=98]="selectOnLineNumbers",K[K.showFoldingControls=99]="showFoldingControls",K[K.showUnused=100]="showUnused",K[K.snippetSuggestions=101]="snippetSuggestions",K[K.smartSelect=102]="smartSelect",K[K.smoothScrolling=103]="smoothScrolling",K[K.stickyTabStops=104]="stickyTabStops",K[K.stopRenderingLineAfter=105]="stopRenderingLineAfter",K[K.suggest=106]="suggest",K[K.suggestFontSize=107]="suggestFontSize",K[K.suggestLineHeight=108]="suggestLineHeight",K[K.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",K[K.suggestSelection=110]="suggestSelection",K[K.tabCompletion=111]="tabCompletion",K[K.tabIndex=112]="tabIndex",K[K.unusualLineTerminators=113]="unusualLineTerminators",K[K.useShadowDOM=114]="useShadowDOM",K[K.useTabStops=115]="useTabStops",K[K.wordSeparators=116]="wordSeparators",K[K.wordWrap=117]="wordWrap",K[K.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=120]="wordWrapColumn",K[K.wordWrapOverride1=121]="wordWrapOverride1",K[K.wordWrapOverride2=122]="wordWrapOverride2",K[K.wrappingIndent=123]="wrappingIndent",K[K.wrappingStrategy=124]="wrappingStrategy",K[K.showDeprecated=125]="showDeprecated",K[K.inlayHints=126]="inlayHints",K[K.editorClassName=127]="editorClassName",K[K.pixelRatio=128]="pixelRatio",K[K.tabFocusMode=129]="tabFocusMode",K[K.layoutInfo=130]="layoutInfo",K[K.wrappingInfo=131]="wrappingInfo"})(ct=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(137,null)})),acceptSuggestionOnEnter:ke(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(138,null),""],markdownDescription:g.localize(139,null)})),accessibilitySupport:ke(new t),accessibilityPageSize:ke(new p(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(140,null)})),ariaLabel:ke(new A(4,"ariaLabel",g.localize(141,null))),autoClosingBrackets:ke(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(142,null),g.localize(143,null),""],description:g.localize(144,null)})),autoClosingDelete:ke(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(145,null),""],description:g.localize(146,null)})),autoClosingOvertype:ke(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(147,null),""],description:g.localize(148,null)})),autoClosingQuotes:ke(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(149,null),g.localize(150,null),""],description:g.localize(151,null)})),autoIndent:ke(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null),g.localize(156,null)],description:g.localize(157,null)})),automaticLayout:ke(new u(10,"automaticLayout",!1)),autoSurround:ke(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(158,null),g.localize(159,null),g.localize(160,null),""],description:g.localize(161,null)})),bracketPairColorization:ke(new ee),stickyTabStops:ke(new u(104,"stickyTabStops",!1,{description:g.localize(162,null)})),codeLens:ke(new u(13,"codeLens",!0,{description:g.localize(163,null)})),codeLensFontFamily:ke(new A(14,"codeLensFontFamily","",{description:g.localize(164,null)})),codeLensFontSize:ke(new p(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(165,null)})),colorDecorators:ke(new u(16,"colorDecorators",!0,{description:g.localize(166,null)})),columnSelection:ke(new u(17,"columnSelection",!1,{description:g.localize(167,null)})),comments:ke(new r),contextmenu:ke(new u(19,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new u(20,"copyWithSyntaxHighlighting",!0,{description:g.localize(168,null)})),cursorBlinking:ke(new l(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:g.localize(169,null)})),cursorSmoothCaretAnimation:ke(new u(22,"cursorSmoothCaretAnimation",!1,{description:g.localize(170,null)})),cursorStyle:ke(new l(23,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:g.localize(171,null)})),cursorSurroundingLines:ke(new p(24,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(172,null)})),cursorSurroundingLinesStyle:ke(new a(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(173,null),g.localize(174,null)],description:g.localize(175,null)})),cursorWidth:ke(new p(26,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(176,null)})),disableLayerHinting:ke(new u(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new u(28,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new u(29,"domReadOnly",!1)),dragAndDrop:ke(new u(30,"dragAndDrop",!0,{description:g.localize(177,null)})),emptySelectionClipboard:ke(new S),extraEditorClassName:ke(new A(32,"extraEditorClassName","")),fastScrollSensitivity:ke(new _(33,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:g.localize(178,null)})),find:ke(new s),fixedOverflowWidgets:ke(new u(35,"fixedOverflowWidgets",!1)),folding:ke(new u(36,"folding",!0,{description:g.localize(179,null)})),foldingStrategy:ke(new a(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(180,null),g.localize(181,null)],description:g.localize(182,null)})),foldingHighlight:ke(new u(38,"foldingHighlight",!0,{description:g.localize(183,null)})),foldingImportsByDefault:ke(new u(39,"foldingImportsByDefault",!1,{description:g.localize(184,null)})),unfoldOnClickAfterEndOfLine:ke(new u(40,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(185,null)})),fontFamily:ke(new A(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(186,null)})),fontInfo:ke(new R),fontLigatures2:ke(new b),fontSize:ke(new O),fontWeight:ke(new $),formatOnPaste:ke(new u(46,"formatOnPaste",!1,{description:g.localize(187,null)})),formatOnType:ke(new u(47,"formatOnType",!1,{description:g.localize(188,null)})),glyphMargin:ke(new u(48,"glyphMargin",!0,{description:g.localize(189,null)})),gotoLocation:ke(new G),hideCursorInOverviewRuler:ke(new u(50,"hideCursorInOverviewRuler",!1,{description:g.localize(190,null)})),highlightActiveIndentGuide:ke(new u(51,"highlightActiveIndentGuide",!0,{description:g.localize(191,null)})),hover:ke(new Z),inDiffEditor:ke(new u(53,"inDiffEditor",!1)),letterSpacing:ke(new _(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>_.clamp(K,-5,20),{description:g.localize(192,null)})),lightbulb:ke(new M),lineDecorationsWidth:ke(new d(57,"lineDecorationsWidth",10)),lineHeight:ke(new F),lineNumbers:ke(new ye),lineNumbersMinChars:ke(new p(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new u(61,"linkedEditing",!1,{description:g.localize(193,null)})),links:ke(new u(62,"links",!0,{description:g.localize(194,null)})),matchBrackets:ke(new a(63,"matchBrackets","always",["always","near","never"],{description:g.localize(195,null)})),minimap:ke(new N),mouseStyle:ke(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new _(66,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:g.localize(196,null)})),mouseWheelZoom:ke(new u(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(197,null)})),multiCursorMergeOverlapping:ke(new u(68,"multiCursorMergeOverlapping",!0,{description:g.localize(198,null)})),multiCursorModifier:ke(new l(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[g.localize(199,null),g.localize(200,null)],markdownDescription:g.localize(201,null)})),multiCursorPaste:ke(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),occurrencesHighlight:ke(new u(71,"occurrencesHighlight",!0,{description:g.localize(205,null)})),overviewRulerBorder:ke(new u(72,"overviewRulerBorder",!0,{description:g.localize(206,null)})),overviewRulerLanes:ke(new p(73,"overviewRulerLanes",3,0,3)),padding:ke(new W),parameterHints:ke(new Q),peekWidgetDefaultFocus:ke(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(207,null),g.localize(208,null)],description:g.localize(209,null)})),definitionLinkOpensInPeek:ke(new u(77,"definitionLinkOpensInPeek",!1,{description:g.localize(210,null)})),quickSuggestions:ke(new fe),quickSuggestionsDelay:ke(new p(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(211,null)})),readOnly:ke(new u(80,"readOnly",!1)),renameOnType:ke(new u(81,"renameOnType",!1,{description:g.localize(212,null),markdownDeprecationMessage:g.localize(213,null)})),renderControlCharacters:ke(new u(82,"renderControlCharacters",!1,{description:g.localize(214,null)})),renderIndentGuides:ke(new u(83,"renderIndentGuides",!0,{description:g.localize(215,null)})),renderFinalNewline:ke(new u(84,"renderFinalNewline",!0,{description:g.localize(216,null)})),renderLineHighlight:ke(new a(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(217,null)],description:g.localize(218,null)})),renderLineHighlightOnlyWhenFocus:ke(new u(86,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(219,null)})),renderValidationDecorations:ke(new a(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new a(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(220,null),g.localize(221,null),g.localize(222,null),""],description:g.localize(223,null)})),revealHorizontalRightPadding:ke(new p(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new u(90,"roundedSelection",!0,{description:g.localize(224,null)})),rulers:ke(new Be),scrollbar:ke(new Ke),scrollBeyondLastColumn:ke(new p(93,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(225,null)})),scrollBeyondLastLine:ke(new u(94,"scrollBeyondLastLine",!0,{description:g.localize(226,null)})),scrollPredominantAxis:ke(new u(95,"scrollPredominantAxis",!0,{description:g.localize(227,null)})),selectionClipboard:ke(new u(96,"selectionClipboard",!0,{description:g.localize(228,null),included:L.isLinux})),selectionHighlight:ke(new u(97,"selectionHighlight",!0,{description:g.localize(229,null)})),selectOnLineNumbers:ke(new u(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new a(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(230,null),g.localize(231,null)],description:g.localize(232,null)})),showUnused:ke(new u(100,"showUnused",!0,{description:g.localize(233,null)})),showDeprecated:ke(new u(125,"showDeprecated",!0,{description:g.localize(234,null)})),inlayHints:ke(new H),snippetSuggestions:ke(new a(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(235,null),g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),smartSelect:ke(new le),smoothScrolling:ke(new u(103,"smoothScrolling",!1,{description:g.localize(240,null)})),stopRenderingLineAfter:ke(new p(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new re),inlineSuggest:ke(new z),suggestFontSize:ke(new p(107,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(241,null)})),suggestLineHeight:ke(new p(108,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(242,null)})),suggestOnTriggerCharacters:ke(new u(109,"suggestOnTriggerCharacters",!0,{description:g.localize(243,null)})),suggestSelection:ke(new a(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),tabCompletion:ke(new a(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),tabIndex:ke(new p(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ke(new a(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(252,null),g.localize(253,null),g.localize(254,null)],description:g.localize(255,null)})),useShadowDOM:ke(new u(114,"useShadowDOM",!0)),useTabStops:ke(new u(115,"useTabStops",!0,{description:g.localize(256,null)})),wordSeparators:ke(new A(116,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:g.localize(257,null)})),wordWrap:ke(new a(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(258,null),g.localize(259,null),g.localize(260,null),g.localize(261,null)],description:g.localize(262,null)})),wordWrapBreakAfterCharacters:ke(new A(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new A(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new p(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(263,null)})),wordWrapOverride1:ke(new a(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new a(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new l(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[g.localize(264,null),g.localize(265,null),g.localize(266,null),g.localize(267,null)],description:g.localize(268,null)})),wrappingStrategy:ke(new a(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(269,null),g.localize(270,null)],description:g.localize(271,null)})),editorClassName:ke(new w),pixelRatio:ke(new J),tabFocusMode:ke(new X),layoutInfo:ke(new x),wrappingInfo:ke(new Me)}});var Ue=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(me[119],ge([0,1,17,21,6,4]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var T;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let y=class extends I.Disposable{constructor(k,d){super();this.deferred=new g.DeferredPromise,d.withProgress(k,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};y=je([Ue(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends I.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(k){this.stop();const d=++this.currentOperationId,f=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:f.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,54,13]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(T,D){g.ok(L.isString(T)),g.ok(L.isObject(D)),g.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,D)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new I}),define(me[120],ge([0,1,3,34]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class C{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[I(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;L.Registry.add(e.Extensions.JSONContribution,T)}),define(me[85],ge([0,1,3,13,156,120,34]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(A){A.Multiline="multilineText",A.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(A){A[A.APPLICATION=1]="APPLICATION",A[A.MACHINE=2]="MACHINE",A[A.WINDOW=3]="WINDOW",A[A.RESOURCE=4]="RESOURCE",A[A.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",A[A.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=T.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new g.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new g.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,a=!0){this.registerConfigurations([E],a)}registerConfigurations(E,a=!0){const l=[];E.forEach(v=>{l.push(...this.validateAndRegisterProperties(v,a,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(E){const a=[],l=v=>{if(v.properties)for(const t in v.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>l(t))};for(const v of E){l(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(E){const a=[],l=[];for(const v of E)for(const t in v)if(a.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const r={type:"object",default:this.defaultValues[t],description:I.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};l.push(d(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=v[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(E){const a=[];for(const l of E)for(const v in l)if(a.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const a of E)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,a=!0,l,v=3){v=L.isUndefinedOrNull(E.scope)?v:E.scope;let t=[],r=E.properties;if(r)for(let i in r){if(a&&p(i)){delete r[i];continue}const c=r[i];if(this.updatePropertyDefaultValue(i,c),e.OVERRIDE_PROPERTY_PATTERN.test(i)?c.scope=void 0:(c.scope=L.isUndefinedOrNull(c.scope)?v:c.scope,c.restricted=L.isUndefinedOrNull(c.restricted)?!!l?.restrictedConfigurations?.includes(i):c.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let o=E.allOf;if(o)for(let i of o)t.push(...this.validateAndRegisterProperties(i,a,l,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const a=l=>{let v=l.properties;if(v)for(const r in v)this.updateSchema(r,v[r]);let t=l.allOf;t&&t.forEach(a)};a(E)}updateSchema(E,a){switch(e.allSettings.properties[E]=a,a.scope){case 1:e.applicationSettings.properties[E]=a;break;case 2:e.machineSettings.properties[E]=a;break;case 6:e.machineOverridableSettings.properties[E]=a;break;case 3:e.windowSettings.properties[E]=a;break;case 4:e.resourceSettings.properties[E]=a;break;case 5:e.resourceSettings.properties[E]=a,this.resourceLanguageSettingsSchema.properties[E]=a;break}}removeFromSchema(E,a){switch(delete e.allSettings.properties[E],a.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const a=`[${E}]`,l={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,l),e.allSettings.properties[a]=l,e.applicationSettings.properties[a]=l,e.machineSettings.properties[a]=l,e.machineOverridableSettings.properties[a]=l,e.windowSettings.properties[a]=l,e.resourceSettings.properties[a]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,a){let l=this.defaultValues[E];L.isUndefined(l)&&(l=a.default),L.isUndefined(l)&&(l=f(a.type)),a.default=l}}const k="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(k);function d(A){return A.substring(1,A.length-1)}e.overrideIdentifierFromKey=d;function f(A){switch(Array.isArray(A)?A[0]:A){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const u=new n;T.Registry.add(e.Extensions.Configuration,u);function p(A){return A.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(A)?I.localize(5,null,A):u.getConfigurationProperties()[A]!==void 0?I.localize(6,null,A):null:I.localize(4,null)}e.validateProperty=p;function _(){const A=[],E=u.getConfigurationProperties();for(const a of Object.keys(E))A.push([a,E[a].scope]);return A.push(["launch",4]),A.push(["task",4]),A}e.getScopes=_}),define(me[121],ge([0,1,23,13,2,85,4,34]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof I.URI)}e.isConfigurationOverrides=y;var P;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function k(r,o){const i=o?r?o.keys.filter(b=>r.keys.indexOf(b)===-1):[...o.keys]:[],c=r?o?r.keys.filter(b=>o.keys.indexOf(b)===-1):[...r.keys]:[],h=[];if(o&&r){for(const b of r.keys)if(o.keys.indexOf(b)!==-1){const R=A(r.contents,b),O=A(o.contents,b);g.equals(R,O)||h.push(b)}}const m=[],w=b=>{const R={};for(const O of b)for(const $ of O.identifiers)R[v($)]=O;return R},S=o?w(o.overrides):{},s=r?w(r.overrides):{};if(Object.keys(S).length)for(const b of i){const R=S[b];R&&m.push([(0,C.overrideIdentifierFromKey)(b),R.keys])}if(Object.keys(s).length)for(const b of c){const R=s[b];R&&m.push([(0,C.overrideIdentifierFromKey)(b),R.keys])}if(Object.keys(S).length&&Object.keys(s).length)for(const b of h){const R=s[b],O=S[b];if(R&&O){const $=k({contents:R.contents,keys:R.keys,overrides:[]},{contents:O.contents,keys:O.keys,overrides:[]});m.push([(0,C.overrideIdentifierFromKey)(b),[...$.added,...$.removed,...$.updated]])}}return{added:i,removed:c,updated:h,overrides:m}}e.compare=k;function d(r,o){const i=[];for(const c of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(c)){const h={};for(const m in r[c])h[m]=r[c][m];i.push({identifiers:[(0,C.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(h),contents:f(h,o)})}return i}e.toOverrides=d;function f(r,o){const i=Object.create(null);for(let c in r)u(i,c,r[c],o);return i}e.toValuesTree=f;function u(r,o,i,c){const h=o.split("."),m=h.pop();let w=r;for(let S=0;S<h.length;S++){let s=h[S],b=w[s];switch(typeof b){case"undefined":b=w[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${o} as ${h.slice(0,S+1).join(".")} is ${JSON.stringify(b)}`);return}w=b}if(typeof w=="object"&&w!==null)try{w[m]=i}catch(S){c(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(w)}`)}else c(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=u;function p(r,o){const i=o.split(".");_(r,i)}e.removeFromValueTree=p;function _(r,o){const i=o.shift();if(o.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const c=r[i];typeof c=="object"&&!Array.isArray(c)&&(_(c,o),Object.keys(c).length===0&&delete r[i])}}function A(r,o,i){function c(w,S){let s=w;for(const b of S){if(typeof s!="object"||s===null)return;s=s[b]}return s}const h=o.split("."),m=c(r,h);return typeof m=="undefined"?i:m}e.getConfigurationValue=A;function E(r,o,i){Object.keys(o).forEach(c=>{c!=="__proto__"&&(c in r?L.isObject(r[c])&&L.isObject(o[c])?E(r[c],o[c],i):i&&(r[c]=o[c]):r[c]=o[c])})}e.merge=E;function a(){const r=D.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=a;function l(){const r=Object.create(null),o=D.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in o){let c=o[i].default;u(r,i,c,h=>console.error(`Conflict in default settings: ${h}`))}return r}e.getDefaultValues=l;function v(r){return`[${r}]`}e.keyFromOverrideIdentifier=v;function t(r,o,i){const c=r.inspect(o),h=r.inspect(i);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:c.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,20,3,57,6,24,23,13,2,121,85,34]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?(0,n.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const i of g.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[i],h=r[i];h&&(typeof c=="object"&&typeof h=="object"?(c=D.deepClone(c),this.mergeContents(c,h)):c=h),o[i]=c}return new f(o,this.keys,this.overrides)}merge(...t){const r=D.deepClone(this.contents),o=D.deepClone(this.overrides),i=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const h of c.overrides){const[m]=o.filter(w=>g.equals(w.identifiers,h.identifiers));m?this.mergeContents(m.contents,h.contents):o.push(D.deepClone(h))}for(const h of c.keys)i.indexOf(h)===-1&&i.push(h)}return new f(r,i,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&y.isObject(t[o])&&y.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=D.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class u extends f{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),o=[];for(const i of Object.keys(t))k.OVERRIDE_PROPERTY_PATTERN.test(i)&&o.push({identifiers:[(0,k.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,o)}}e.DefaultConfigurationModel=u;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!y.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:o,keys:i,overrides:c,restricted:h}=this.doParseRaw(t,r);this._configurationModel=new f(o,i,c),this._restrictedConfigurations=h||[]}doParseContent(t){let r={},o=null,i=[],c=[],h=[];function m(S){Array.isArray(i)?i.push(S):o!==null&&(i[o]=S)}let w={onObjectBegin:()=>{let S={};m(S),c.push(i),i=S,o=null},onObjectProperty:S=>{o=S},onObjectEnd:()=>{i=c.pop()},onArrayBegin:()=>{let S=[];m(S),c.push(i),i=S,o=null},onArrayEnd:()=>{i=c.pop()},onLiteralValue:m,onError:(S,s,b)=>{h.push({error:S,offset:s,length:b})}};if(t)try{I.visit(t,w),r=i[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(t,r){const o=d.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,o,!0,r);t=i.raw;const c=(0,n.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),h=Object.keys(t),m=(0,n.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:c,keys:h,overrides:m,restricted:i.restricted}}filter(t,r,o,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const c={},h=[];for(let m in t)if(k.OVERRIDE_PROPERTY_PATTERN.test(m)&&o){const w=this.filter(t[m],r,!1,i);c[m]=w.raw,h.push(...w.restricted)}else{const w=r[m],S=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&h.push(m),(S===void 0||i.scopes===void 0||i.scopes.includes(S))&&(i.skipRestricted&&w?.restricted||(c[m]=t[m]))}return{raw:c,restricted:h}}}e.ConfigurationModelParser=p;class _ extends C.Disposable{constructor(t,r,o,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class A{constructor(t,r,o=new f,i=new f,c=new T.ResourceMap,h=new f,m=new T.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=i,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let i;o.resource?(i=this._memoryConfigurationByResource.get(o.resource),i||(i=new f,this._memoryConfigurationByResource.set(o.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const i=this.getConsolidateConfigurationModel(r,o),c=this.getFolderConfigurationModelForResource(r.resource,o),h=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,m=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),s=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),b=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,R=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,O=r.overrideIdentifier?h.override(r.overrideIdentifier).getValue(t):h.getValue(t),$=i.getValue(t),G=g.distinct(g.flatten(i.overrides.map(Z=>Z.identifiers))).filter(Z=>i.getOverrideValue(t,Z)!==void 0);return{defaultValue:m,userValue:w,userLocalValue:S,userRemoteValue:s,workspaceValue:b,workspaceFolderValue:R,memoryValue:O,value:$,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:s!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:b!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:h.getValue(t),override:r.overrideIdentifier?h.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(i=>k.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const c=(0,k.overrideIdentifierFromKey)(i),h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),m=t.getKeysForOverrideIdentifier(c),w=[...m.filter(S=>h.indexOf(S)===-1),...h.filter(S=>m.indexOf(S)===-1),...h.filter(S=>!D.equals(this._defaultConfiguration.override(c).getValue(S),t.override(c).getValue(S)))];return[c,w]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:i,overrides:c}=(0,n.compare)(this.localUserConfiguration,t),h=[...r,...o,...i];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:i,overrides:c}=(0,n.compare)(this.remoteUserConfiguration,t);let h=[...r,...o,...i];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:i,overrides:c}=(0,n.compare)(this.workspaceConfiguration,t);let h=[...r,...o,...i];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:i,updated:c,removed:h,overrides:m}=(0,n.compare)(o,r);let w=[...i,...c,...h];return(w.length||!o)&&this.updateFolderConfiguration(t,r),{keys:w,overrides:m}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:i,removed:c,overrides:h}=(0,n.compare)(r,void 0);return{keys:[...o,...i,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(o=this.getFolderConsolidatedConfiguration(i.uri)||o);const c=this._memoryConfigurationByResource.get(t);c&&(o=o.merge(c))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=o.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:i,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:i,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((h,m)=>(h.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new T.ResourceMap);return new A(r,o,new f,i,c,new f,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=A;function E(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,r=new Map;for(const i of v)i.keys.forEach(c=>t.add(c)),i.overrides.forEach(([c,h])=>{const m=(0,T.getOrSet)(r,c,new Set);h.forEach(w=>m.add(w))});const o=[];return r.forEach((i,c)=>o.push([c,[...i.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=E;class a{constructor(t,r,o,i){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=i,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(m=>c.add(m)),t.overrides.forEach(([,m])=>m.forEach(w=>c.add(w))),this.affectedKeys=[...c.values()];const h=new f;this.affectedKeys.forEach(m=>h.setValue(m,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!D.equals(o,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=(0,n.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof o=="object"&&(i=Object.keys(o)[0]);){if(t=t[i],!t)return!1;o=o[i]}return!0}}e.ConfigurationChangeEvent=a;class l extends a{constructor(t,r,o,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l}),define(me[122],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(T,D=L.Unknown,y){super(T);this._message=T,this._code=D,this._detail=y,this.isHandled=D===L.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(T){return T instanceof I&&T._code===L.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof I&&T._code===L.NoResolverFound}static isHandled(T){return T instanceof I&&T.isHandled}}e.RemoteAuthorityResolverError=I}),define(me[86],ge([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(P){return P.scheme===g.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=L;function I(P){if(!P)return;const n=P.indexOf("+");return n<0?P:P.substr(0,n)}e.getRemoteName=I;function C(P){return P.scheme!==g.Schemas.file&&P.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=C;function T(P){if(P.folders.length)return P.folders.every(n=>C(n.uri))?P.folders[0].uri:void 0;if(P.configuration&&C(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=T;function D(P){return T(P)?.scheme}e.getVirtualWorkspaceScheme=D;function y(P){return T(P)!==void 0}e.isVirtualWorkspace=y}),define(me[193],ge([0,1,3,11,4,12]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService");var T;(function(f){f.Http="http",f.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=n;function k(f,u){return u?u!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=k;let d=class{constructor(u){this.logService=u,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,p){return this._tunnelProvider=u,u?(this._canElevate=p.elevation,this._canMakePublic=p.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async u=>{const p=[],_=Array.from(this._tunnels.values());for(let A of _){const E=Array.from(A.values());for(let a of E){const l=await a.value;l&&p.push(l)}}u(p)})}async dispose(){for(const u of this._tunnels.values()){for(const{value:p}of u.values())await p.then(_=>_?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,p,_,A,E=!1,a=!1,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${_} on local port ${A}.`),!u)return;p||(p="localhost");const v=this.retainOrCreateTunnel(u,p,_,A,E,a,l);return v?v.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,public:u.public,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const p=this._tunnels.get(u.tunnelRemoteHost);if(p){const _=p.get(u.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,_))}}}}async tryDisposeTunnel(u,p,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${p}.`);const A=_.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(p),A}}async closeTunnel(u,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${p} `);const _=this._tunnels.get(u);if(_&&_.has(p)){const A=_.get(p);A.refcount=0,await this.tryDisposeTunnel(u,p,A)}}addTunnelToMap(u,p,_){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(p,{refcount:1,value:_})}async removeEmptyTunnelFromMap(u,p){const _=this._tunnels.get(u);_&&(await _.get(p)||_.delete(p),_.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,p){let _=[u];P(u)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):n(u)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const A=_.map(E=>this._tunnels.get(E));for(const E of A){const a=E?.get(p);if(a)return a}}canTunnel(u){return!!y(u)}createWithProvider(u,p,_,A,E,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${_} on local port ${A}.`);const t={elevationRequired:E?k(A===void 0?_:A):!1},r={remoteAddress:{host:p,port:_},localAddressPort:A,public:a,protocol:l},o=u.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),o&&this.addTunnelToMap(p,_,o),o}};d=je([Ue(0,C.ILogService)],d),e.AbstractTunnelService=d}),define(me[194],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((I,C)=>Y(["vsda"],I,C))}async sign(I){try{const C=await this.vsda(),T=new C.signer;if(T)return T.sign(I)}catch(C){}return I}}e.SignService=g}),define(me[195],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,C,T=5){let D;return D=C(y=>{const P=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(I);if(n){n.data.push(P);return}const k=setTimeout(()=>this.flushBuffer(I),T);n={data:[P],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),D.dispose()}},this._terminalBufferMap.set(I,n)}),D}stopBuffering(I){const C=this._terminalBufferMap.get(I);C&&C.dispose()}flushBuffer(I){const C=this._terminalBufferMap.get(I);C&&(this._terminalBufferMap.delete(I),this._callback(I,C.data.join("")))}}e.TerminalDataBufferer=g}),define(me[196],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(me[62],ge([0,1,47,3,6,4,34,196]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var y;(function(_){function A(E){return E&&typeof E=="object"&&typeof E.id=="string"}_.isThemeColor=A})(y=e.ThemeColor||(e.ThemeColor={}));function P(_){return{id:_}}e.themeColorFromId=P;var n;(function(_){function A(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}_.isThemeIcon=A;const E=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const o=E.exec(r);if(!o)return;let[,i]=o;return{id:i}}_.fromString=a;function l(r,o){let i=r.id;const c=i.lastIndexOf("~");return c!==-1&&(i=i.substring(0,c)),o&&(i=`${i}~${o}`),{id:i}}_.modify=l;function v(r,o){return r.id===o.id&&r.color?.id===o.color?.id}_.isEqual=v;function t(r,o){return{id:r.id,color:o?P(o):void 0}}_.asThemeIcon=t,_.asClassNameArray=g.CSSIcon.asClassNameArray,_.asClassName=g.CSSIcon.asClassName,_.asCSSSelector=g.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function k(_){switch(_){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,I.toDisposable)(()=>{const E=this.themingParticipants.indexOf(A);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new d;T.Registry.add(e.Extensions.ThemingContribution,f);function u(_){return f.onColorThemeChange(_)}e.registerThemingParticipant=u;class p extends I.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,E){let a=this.theme.getColor(A);return a&&E&&(a=E(a,this.theme)),a?a.toString():null}}e.Themable=p}),define(me[197],ge([0,1,17,47,3,162,120,34,62]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(A,E,a,l){const v=this.iconsById[A];if(v){if(a&&!v.description){v.description=a,this.iconSchema.properties[A].markdownDescription=`${a} $(${A})`;const o=this.iconReferenceSchema.enum.indexOf(A);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=a),this._onDidChange.fire()}return v}let t={id:A,description:a,defaults:E,deprecationMessage:l};this.iconsById[A]=t;let r={$ref:"#/definitions/icons"};return l&&(r.deprecationMessage=l),a&&(r.markdownDescription=`${a}: $(${A})`),this.iconSchema.properties[A]=r,this.iconReferenceSchema.enum.push(A),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:A}}deregisterIcon(A){delete this.iconsById[A],delete this.iconSchema.properties[A];const E=this.iconReferenceSchema.enum.indexOf(A);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(A=>this.iconsById[A])}getIcon(A){return this.iconsById[A]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(A,E){const a=this.iconFontsById[A];if(a)return a;let l={id:A,definition:E};return this.iconFontsById[A]=l,this._onDidChange.fire(),l}deregisterIconFont(A){delete this.iconFontsById[A]}getIconFonts(){return Object.keys(this.iconFontsById).map(A=>this.iconFontsById[A])}getIconFont(A){return this.iconFontsById[A]}toString(){const A=(v,t)=>v.id.localeCompare(t.id),E=v=>{for(;y.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of l.filter(t=>!!t.description).sort(A))a.push(`|<i class="${E(v)}"></i>|${v.id}|${y.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const v of l.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(A))a.push(`|<i class="${E(v)}"></i>|${v.id}|`);return a.join(`
`)}}const n=new P;D.Registry.add(e.Extensions.IconContribution,n);function k(_,A,E,a){return n.registerIcon(_,A,E,a)}e.registerIcon=k;function d(){return n}e.getIconRegistry=d;function f(){for(const _ of L.iconRegistry.all)n.registerIcon(_.id,_.definition,_.description);L.iconRegistry.onDidRegister(_=>n.registerIcon(_.id,_.definition,_.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let u=D.Registry.as(T.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,n.getIconSchema());const p=new g.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.widgetClose=k("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=y.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[43],ge([0,1,24,25,2,4]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var T;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function D(d){const f=d;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=D;function y(d){const f=d;return!!(f&&typeof f=="object"&&I.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class P{constructor(f,u,p,_){this._id=f,this._configuration=p,this._ignorePathCasing=_,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class n{constructor(f,u){this.raw=u,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,L.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function k(d){return new n({uri:d,index:0,name:(0,L.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=k}),define(me[198],ge([0,1,29,57,139,79,10,8,11,25,2,163,4,86,43]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(U){return(typeof U=="string"?(0,D.extname)(U):(0,P.extname)(U))===p}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,d.createDecorator)("workspacesService");function A(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=A;function E(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=E;function a(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=a;function l(U){const x=U;return typeof x?.id=="string"&&n.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=l;function v(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(U){const x=U;return typeof x?.id=="string"&&n.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function r(U){const x=U;if(x?.uri)return{id:x.id,uri:n.URI.revive(x.uri)};const M=U;if(M?.configPath)return{id:M.id,configPath:n.URI.revive(M.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=r;function o(U,x){return P.extUriBiasedIgnorePathCase.isEqualOrParent(U,x.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function i(U){return c(U)||h(U)}e.isStoredWorkspaceFolder=i;function c(U){const x=U;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=c;function h(U){const x=U;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=h;function m(U,x,M,H,F=!y.isWindows,N){if(U.scheme!==H.scheme)return{name:M,uri:U.toString(!0)};let j=x?void 0:N.relativePath(H,U);if(j!==void 0)j.length===0?j=".":y.isWindows&&U.scheme===T.Schemas.file&&!F&&(j=j.replace(/\//g,"\\"));else if(U.scheme===T.Schemas.file)j=U.fsPath,y.isWindows&&(j=(0,C.normalizeDriveLetter)(j),F&&(j=(0,g.toSlashes)(j)));else{if(!N.isEqualAuthority(U.authority,H.authority))return{name:M,uri:U.toString(!0)};j=U.path}return{name:M,path:j}}e.getStoredWorkspaceFolder=m;function w(U,x,M){let H=[],F=new Set;const N=M.dirname(x);for(let j of U){let W;if(c(j))j.path&&(W=M.resolvePath(N,j.path));else if(h(j))try{W=n.URI.parse(j.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(Q){console.warn(Q)}if(W){let Q=M.getComparisonKey(W);if(!F.has(Q)){F.add(Q);const J=j.name||M.basenameOrAuthority(W);H.push(new u.WorkspaceFolder({uri:W,name:J,index:H.length},j))}}}return H}e.toWorkspaceFolders=w;function S(U,x,M,H,F){let N=s(x,U);const j=F.dirname(x),W=F.dirname(H),Q=[],J=b(N.folders);for(const Le of N.folders){const Be=c(Le)?F.resolvePath(j,Le.path):n.URI.parse(Le.uri);let xe;M?xe=!1:xe=!c(Le)||(0,D.isAbsolute)(Le.path),Q.push(m(Be,xe,Le.name,W,J,F))}const fe={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},_e=I.setProperty(U,["folders"],Q,fe);let ye=I.applyEdits(U,_e);return N.remoteAuthority===(0,f.getRemoteAuthority)(H)&&(ye=I.applyEdits(ye,I.removeProperty(ye,["remoteAuthority"],fe))),ye}e.rewriteWorkspaceFileForNewLocation=S;function s(U,x){let M=L.parse(x);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(H=>i(H));else throw new Error(`${U} looks like an invalid workspace file.`);return M}function b(U){return y.isWindows?U.some(x=>c(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=b;function R(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function O(U){return typeof U.folderUri=="string"}function $(U){return typeof U.fileUri=="string"}function G(U,x){const M={workspaces:[],files:[]};if(U){const H=function(N,j){for(let W=0;W<N.length;W++)try{j(N[W],W)}catch(Q){x.warn(`Error restoring recent entry ${JSON.stringify(N[W])}: ${Q.toString()}. Skip entry.`)}},F=U;if(Array.isArray(F.entries))H(F.entries,N=>{const j=N.label,W=N.remoteAuthority;R(N)?M.workspaces.push({label:j,remoteAuthority:W,workspace:{id:N.workspace.id,configPath:n.URI.parse(N.workspace.configPath)}}):O(N)?M.workspaces.push({label:j,remoteAuthority:W,folderUri:n.URI.parse(N.folderUri)}):$(N)&&M.files.push({label:j,remoteAuthority:W,fileUri:n.URI.parse(N.fileUri)})});else{const N=U;Array.isArray(N.workspaces3)&&H(N.workspaces3,(j,W)=>{const Q=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[W]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?M.workspaces.push({label:Q,workspace:{id:j.id,configPath:n.URI.parse(j.configURIPath)}}):typeof j=="string"&&M.workspaces.push({label:Q,folderUri:n.URI.parse(j)})}),Array.isArray(N.files2)&&H(N.files2,(j,W)=>{const Q=Array.isArray(N.fileLabels)&&N.fileLabels[W]||void 0;typeof j=="string"&&M.files.push({label:Q,fileUri:n.URI.parse(j)})})}}return M}e.restoreRecentlyOpened=G;function Z(U){const x={entries:[]};for(const M of U.workspaces)E(M)?x.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):x.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of U.files)x.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return x}e.toStoreData=Z}),define(me[87],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const C=this._idPool++;return this._data.set(C,I),this.logDebugInfo(),C}get(I,C){return this._data.has(I)?this._data.get(I)[C]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(me[51],ge([0,1,2,3,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class C{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(y=>({name:y.name,group:y.group,resource:g.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=C}),define(me[63],ge([0,1,10,4]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class I{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,D){D===null?this._providerInfo.delete(T):this._providerInfo.set(T,D)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=I,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(me[199],ge([0,1,17]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,D,y){this._deferredPromises=new Map,this._id=T,this._shared=D,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of P.values())n.complete()}catch(n){for(const k of P.values())k.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,D){let y=this._value[T];return typeof y=="undefined"&&(y=D),y}update(T,D){this._value[T]=D;let y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const P=new g.DeferredPromise;return this._deferredPromises.set(T,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class I extends L{constructor(T,D){super(T.identifier.value,!0,D);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=I}),define(me[200],ge([0,1,3,2,12]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(D,y){this._logService=D,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,y,P){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(D)).acceptModelChanged(y.value,P)}$acceptDirtyStateChanged(D,y){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(D)).acceptDirty(y)}$acceptModelSaved(D){const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(D));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(D,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,y);const P=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(D));P.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};C=je([Ue(0,I.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(me[14],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[201],ge([0,1,26,3]),function(Y,e,g,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(D,y){I.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(D.identifier),rt(this,I,y,"f"),$e(this,I,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(D){return $e(this,I,"f").get(this._id,D)}store(D,y){return $e(this,I,"f").store(this._id,D,y)}delete(D){return $e(this,I,"f").delete(this._id,D)}}e.ExtensionSecrets=C,I=new WeakMap}),define(me[123],ge([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(me[88],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,I=(E,a)=>{const l={controllerId:a};return L.set(E,l),l};e.createPrivateApiFor=I;const C=E=>L.get(E);e.getPrivateApiFor=C;const T=(E,a,l,v)=>{let t=l;return{enumerable:!0,configurable:!1,get(){return t},set(r){if(!v(t,r)){const o=t;t=r,E.listener?.({op:3,key:a,value:r,previous:o})}}}},D=(E,a)=>E===a,y={range:(E,a)=>E===a?!0:!E||!a?!1:E.isEqual(a),label:D,description:D,busy:D,error:D,canResolveChildren:D,tags:(E,a)=>!(E.length!==a.length||E.some(l=>!a.find(v=>l.id===v.id)))},P=Object.keys(y),n=(E,a)=>({range:T(E,"range",void 0,y.range),label:T(E,"label",a,y.label),description:T(E,"description",void 0,y.description),canResolveChildren:T(E,"canResolveChildren",!1,y.canResolveChildren),busy:T(E,"busy",!1,y.busy),error:T(E,"error",void 0,y.error),tags:T(E,"tags",[],y.tags)}),k=(E,a)=>{const l=new Map;for(const v of P)y[v](E[v],a[v])||l.set(v,a[v]);return l};e.diffTestItems=k;class d extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=d;class f extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class u extends Error{constructor(a,l,v){super(`TestItem with ID "${a}" is from controller "${l}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=u;const p=E=>{const a=(0,e.getPrivateApiFor)(E);let l=new Map;return{get size(){return l.size},forEach(v,t){for(const r of l.values())v.call(t,r,this)},replace(v){const t=new Map,r=new Set(l.keys()),o={op:4,ops:[]};for(const i of v){if(!(i instanceof _))throw new f(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==a.controllerId)throw new u(i.id,c,a.controllerId);if(t.has(i.id))throw new d(i.id);t.set(i.id,i),r.delete(i.id),o.ops.push({op:0,item:i})}for(const i of r.keys())o.ops.push({op:1,id:i});a.listener?.(o),l=t},add(v){if(!(v instanceof _))throw new f(v.id);l.set(v.id,v),a.listener?.({op:0,item:v})},delete(v){l.delete(v)&&a.listener?.({op:1,id:v})},get(v){return l.get(v)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};class _{constructor(a,l,v,t){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const r=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof A?void 0:r.parent}},children:{value:p(this),enumerable:!0,writable:!1},...n(r,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class A extends _{constructor(a,l){super(a,a,l,void 0)}}e.TestItemRootImpl=A}),define(me[52],ge([0,1,4,3,14]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var C;(function(D){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}D.fromApiTunnel=y;function P(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}D.fromServiceTunnel=P})(C=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let T=class{constructor(y){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,P){return{dispose:()=>{}}}async $providePortAttributes(y,P,n,k,d){return[]}async $forwardPort(y,P){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=je([Ue(0,I.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[7],ge([0,1,20,16,99,24,102,13,2,32,42,122]),function(Y,e,g,L,I,C,T,D,y,P,n,k){"use strict";var d,f,u,p,_,A,E,a,l,v,t,r,o,i,c,h,m,w,S,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function b(V){function B(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(B,V),Object.setPrototypeOf(B.prototype,V.prototype),B}let R=_=class{constructor(B){d.set(this,void 0),rt(this,d,B,"f")}static from(...B){let se=B;return new _(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}dispose(){typeof $e(this,d,"f")=="function"&&($e(this,d,"f").call(this),rt(this,d,void 0,"f"))}};d=new WeakMap,R=_=je([b],R),e.Disposable=R;let O=A=class{constructor(B,se){if(B<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=B,this._character=se}static Min(...B){if(B.length===0)throw new TypeError;let se=B[0];for(let De=1;De<B.length;De++){const Ze=B[De];Ze.isBefore(se)&&(se=Ze)}return se}static Max(...B){if(B.length===0)throw new TypeError;let se=B[0];for(let De=1;De<B.length;De++){const Ze=B[De];Ze.isAfter(se)&&(se=Ze)}return se}static isPosition(B){if(!B)return!1;if(B instanceof A)return!0;let{line:se,character:De}=B;return typeof se=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,se=0){if(B===null||se===null)throw(0,L.illegalArgument)();let De;return typeof B=="undefined"?De=0:typeof B=="number"?De=B:(De=typeof B.lineDelta=="number"?B.lineDelta:0,se=typeof B.characterDelta=="number"?B.characterDelta:0),De===0&&se===0?this:new A(this.line+De,this.character+se)}with(B,se=this.character){if(B===null||se===null)throw(0,L.illegalArgument)();let De;return typeof B=="undefined"?De=this.line:typeof B=="number"?De=B:(De=typeof B.line=="number"?B.line:this.line,se=typeof B.character=="number"?B.character:this.character),De===this.line&&se===this.character?this:new A(De,se)}toJSON(){return{line:this.line,character:this.character}}};O=A=je([b],O),e.Position=O;let $=E=class{constructor(B,se,De,Ze){let it,dt;if(typeof B=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ze=="number"?(it=new O(B,se),dt=new O(De,Ze)):B instanceof O&&se instanceof O&&(it=B,dt=se),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this._start=it,this._end=dt):(this._start=dt,this._end=it)}static isRange(B){return B instanceof E?!0:B?O.isPosition(B.start)&&O.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof E?this.contains(B._start)&&this.contains(B._end):B instanceof O?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const se=O.Max(B.start,this._start),De=O.Min(B.end,this._end);if(!se.isAfter(De))return new E(se,De)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const se=O.Min(B.start,this._start),De=O.Max(B.end,this.end);return new E(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,se=this.end){if(B===null||se===null)throw(0,L.illegalArgument)();let De;return B?O.isPosition(B)?De=B:(De=B.start||this.start,se=B.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new E(De,se)}toJSON(){return[this.start,this.end]}};$=E=je([b],$),e.Range=$;let G=a=class extends ${constructor(B,se,De,Ze){let it,dt;if(typeof B=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ze=="number"?(it=new O(B,se),dt=new O(De,Ze)):B instanceof O&&se instanceof O&&(it=B,dt=se),!it||!dt)throw new Error("Invalid arguments");super(it,dt);this._anchor=it,this._active=dt}static isSelection(B){return B instanceof a?!0:B?$.isRange(B)&&O.isPosition(B.anchor)&&O.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=a=je([b],G),e.Selection=G;class Z{constructor(B,se,De){if(typeof B!="string"||B.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,L.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=Z;class U extends Error{constructor(B,se=k.RemoteAuthorityResolverErrorCode.Unknown,De){super(B);this._message=B,this._code=se,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(B,se){return new U(B,k.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(B){return new U(B,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var x;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var M;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=l=class{constructor(B,se){this._range=B,this._newText=se}static isTextEdit(B){return B instanceof l?!0:B?$.isRange(B)&&typeof B.newText=="string":!1}static replace(B,se){return new l(B,se)}static insert(B,se){return l.replace(new $(B,B),se)}static delete(B){return l.replace(B,"")}static setEndOfLine(B){const se=new l(new $(new O(0,0),new O(0,0)),"");return se.newEol=B,se}get range(){return this._range}set range(B){if(B&&!$.isRange(B))throw(0,L.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,L.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,L.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};H=l=je([b],H),e.TextEdit=H;var F;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(F=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,se,De,Ze){this._edits.push({_type:1,from:B,to:se,options:De,metadata:Ze})}createFile(B,se,De){this._edits.push({_type:1,from:void 0,to:B,options:se,metadata:De})}deleteFile(B,se,De){this._edits.push({_type:1,from:B,to:void 0,options:se,metadata:De})}replaceNotebookMetadata(B,se,De){this._edits.push({_type:3,metadata:De,uri:B,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(B,se,De,Ze,it){let dt,mt,Ct=[],At;if(Ht.isNotebookRange(se)&&Lt.isNotebookCellDataArray(De)&&!Lt.isNotebookCellDataArray(Ze)?(dt=se.start,mt=se.end,Ct=De,At=Ze):typeof se=="number"&&typeof De=="number"&&Lt.isNotebookCellDataArray(Ze)&&(dt=se,mt=De,Ct=Ze,At=it),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||Ct.length>0)&&this._edits.push({_type:5,uri:B,index:dt,count:mt-dt,cells:Ct,metadata:At})}replaceNotebookCellMetadata(B,se,De,Ze){this._edits.push({_type:3,metadata:Ze,uri:B,edit:{editType:8,index:se,metadata:De}})}replace(B,se,De,Ze){this._edits.push({_type:2,uri:B,edit:new H(se,De),metadata:Ze})}insert(B,se,De,Ze){this.replace(B,new $(se,se),De,Ze)}delete(B,se,De){this.replace(B,se,"",De)}has(B){return this._edits.some(se=>se._type===2&&se.uri.toString()===B.toString())}set(B,se){if(se)for(const De of se)De&&this._edits.push({_type:2,uri:B,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ze=this._edits[De];Ze._type===2&&Ze.uri.toString()===B.toString()&&(this._edits[De]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(B){const se=[];for(let De of this._edits)De._type===2&&De.uri.toString()===B.toString()&&se.push(De.edit);return se}entries(){const B=new C.ResourceMap;for(let se of this._edits)if(se._type===2){let De=B.get(se.uri);De||(De=[se.uri,[]],B.set(se.uri,De)),De[1].push(se.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=je([b],N),e.WorkspaceEdit=N;let j=v=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof v?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=v._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,se=this._tabstop++){if(typeof B=="function"){const De=new v;De._tabstop=this._tabstop,B(De),this._tabstop=De._tabstop,B=De.value}else B=v._escape(B);return this.value+="${",this.value+=se,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,se=this._tabstop++){const De=B.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(B,se){if(typeof se=="function"){const De=new v;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,se&&(this.value+=":",this.value+=se),this.value+="}",this}};j=v=je([b],j),e.SnippetString=j;var W;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let J=t=class{constructor(B,se){if(this.uri=B,se)if(se instanceof $)this.range=se;else if(se instanceof O)this.range=new $(se,se);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof t?!0:B?$.isRange(B.range)&&y.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};J=t=je([b],J),e.Location=J;let fe=class{constructor(B,se){this.location=B,this.message=se}static is(B){return B?typeof B.message=="string"&&B.location&&$.isRange(B.location.range)&&y.URI.isUri(B.location.uri):!1}static isEqual(B,se){return B===se?!0:!B||!se?!1:B.message===se.message&&B.location.range.isEqual(se.location.range)&&B.location.uri.toString()===se.location.uri.toString()}};fe=je([b],fe),e.DiagnosticRelatedInformation=fe;let _e=class{constructor(B,se,De=Q.Error){if(!$.isRange(B))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=B,this.message=se,this.severity=De}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,se){return B===se?!0:!B||!se?!1:B.message===se.message&&B.severity===se.severity&&B.code===se.code&&B.severity===se.severity&&B.source===se.source&&B.range.isEqual(se.range)&&(0,g.equals)(B.tags,se.tags)&&(0,g.equals)(B.relatedInformation,se.relatedInformation,fe.isEqual)}};_e=je([b],_e),e.Diagnostic=_e;let ye=class{constructor(B,se){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=se}};ye=je([b],ye),e.Hover=ye;var Le;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Be=class{constructor(B,se=Le.Text){this.range=B,this.kind=se}toJSON(){return{range:this.range,kind:Le[this.kind]}}};Be=je([b],Be),e.DocumentHighlight=Be;var xe;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(V){V[V.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let z=r=class{constructor(B,se,De,Ze,it){this.name=B,this.kind=se,this.containerName=it,typeof De=="string"&&(this.containerName=De),Ze instanceof J?this.location=Ze:De instanceof $&&(this.location=new J(Ze,De)),r.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};z=r=je([b],z),e.SymbolInformation=z;let ee=o=class{constructor(B,se,De,Ze,it){this.name=B,this.detail=se,this.kind=De,this.range=Ze,this.selectionRange=it,this.children=[],o.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(o.validate)}};ee=o=je([b],ee),e.DocumentSymbol=ee;var re;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(B,se){this.title=B,this.kind=se}};le=je([b],le),e.CodeAction=le;let X=i=class{constructor(B){this.value=B}append(B){return new i(this.value?this.value+i.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+i.sep)}};X.sep=".",X=i=je([b],X),e.CodeActionKind=X,X.Empty=new X(""),X.QuickFix=X.Empty.append("quickfix"),X.Refactor=X.Empty.append("refactor"),X.RefactorExtract=X.Refactor.append("extract"),X.RefactorInline=X.Refactor.append("inline"),X.RefactorRewrite=X.Refactor.append("rewrite"),X.Source=X.Empty.append("source"),X.SourceOrganizeImports=X.Source.append("organizeImports"),X.SourceFixAll=X.Source.append("fixAll");let oe=class{constructor(B,se){if(this.range=B,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=je([b],oe),e.SelectionRange=oe;class ve{constructor(B,se,De,Ze,it,dt){this.kind=B,this.name=se,this.detail=De,this.uri=Ze,this.range=it,this.selectionRange=dt}}e.CallHierarchyItem=ve;class Me{constructor(B,se){this.fromRanges=se,this.from=B}}e.CallHierarchyIncomingCall=Me;class ze{constructor(B,se){this.fromRanges=se,this.to=B}}e.CallHierarchyOutgoingCall=ze;var Qe;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(B,se){this.range=B,this.command=se}get isResolved(){return!!this.command}};et=je([b],et),e.CodeLens=et;let ke=c=class{constructor(B,se=!1){f.set(this,void 0),rt(this,f,new I.MarkdownString(B,{supportThemeIcons:se}),"f")}static isMarkdownString(B){return B instanceof c?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return $e(this,f,"f").value}set value(B){$e(this,f,"f").value=B}get isTrusted(){return $e(this,f,"f").isTrusted}set isTrusted(B){$e(this,f,"f").isTrusted=B}get supportThemeIcons(){return $e(this,f,"f").supportThemeIcons}set supportThemeIcons(B){$e(this,f,"f").supportThemeIcons=B}appendText(B){return $e(this,f,"f").appendText(B),this}appendMarkdown(B){return $e(this,f,"f").appendMarkdown(B),this}appendCodeblock(B,se){return $e(this,f,"f").appendCodeblock(se??"",B),this}};f=new WeakMap,ke=c=je([b],ke),e.MarkdownString=ke;let ct=class{constructor(B,se){this.label=B,this.documentation=se}};ct=je([b],ct),e.ParameterInformation=ct;let K=class{constructor(B,se){this.label=B,this.documentation=se,this.parameters=[]}};K=je([b],K),e.SignatureInformation=K;let te=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};te=je([b],te),e.SignatureHelp=te;var pe;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(pe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(B,se,De){this.text=B,this.position=se,this.kind=De}};tt=je([b],tt),e.InlayHint=tt;var st;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var lt;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(lt=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(V){V[V.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let Dt=class{constructor(B,se){this.label=B,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&lt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Dt=je([b],Dt),e.CompletionItem=Dt;let ue=class{constructor(B=[],se=!1){this.items=B,this.isIncomplete=se}};ue=je([b],ue),e.CompletionList=ue;let Ie=class{constructor(B,se,De){this.text=B,this.range=se,this.command=De}};Ie=je([b],Ie),e.InlineSuggestion=Ie;let Ne=class{constructor(B){this.items=B}};Ne=je([b],Ne),e.InlineSuggestions=Ne;var Ge;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(Ge=e.ViewColumn||(e.ViewColumn={}));var We;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(We=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ot;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(ot=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Re;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function B(se){switch(se){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=B}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor(B,se){if(se&&!y.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!$.isRange(B)||B.isEmpty)throw(0,L.illegalArgument)("range");this.range=B,this.target=se}};be=je([b],be),e.DocumentLink=be;let we=class{constructor(B,se,De,Ze){this.red=B,this.green=se,this.blue=De,this.alpha=Ze}};we=je([b],we),e.Color=we;let Fe=class{constructor(B,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!$.isRange(B)||B.isEmpty)throw(0,L.illegalArgument)("range");this.range=B,this.color=se}};Fe=je([b],Fe),e.ColorInformation=Fe;let qe=class{constructor(B){if(!B||typeof B!="string")throw(0,L.illegalArgument)("label");this.label=B}};qe=je([b],qe),e.ColorPresentation=qe;var He;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var Je;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class nt{constructor(B,se,De){if(this.startIndex=B,this.length=se,this.tooltip=De,typeof B!="number"||B<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=nt;var ae;(function(V){V[V.Panel=0]="Panel",V[V.Editor=1]="Editor"})(ae=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(B){this.options=B,typeof B!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ce;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Te=h=class{constructor(B,se){if(typeof B!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};Te.Clean=new h("clean","Clean"),Te.Build=new h("build","Build"),Te.Rebuild=new h("rebuild","Rebuild"),Te.Test=new h("test","Test"),Te=h=je([b],Te),e.TaskGroup=Te;function Pe(V){let B="";for(let se=0;se<V.length;se++)B+=V[se].replace(/,/g,",,")+",";return B}let Ye=class{constructor(B,se,De){if(typeof B!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=B,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,L.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let se of this._args)B.push(se);return Pe(B)}};Ye=je([b],Ye),e.ProcessExecution=Ye;let Xe=class{constructor(B,se,De){if(this._args=[],Array.isArray(se)){if(!B)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,L.illegalArgument)("command");this._command=B,this._args=se,this._options=De}else{if(typeof B!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=B,this._options=se}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,L.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)B.push(typeof se=="string"?se:se.value);return Pe(B)}};Xe=je([b],Xe),e.ShellExecution=Xe;var at;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(at=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class _t{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=_t;let ht=m=class{constructor(B,se,De,Ze,it,dt){this.__deprecated=!1,this._definition=this.definition=B;let mt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=Ze,mt=it,this.__deprecated=!0):se===wt.Global||se===wt.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=Ze,this.execution=it,mt=dt):(this.target=se,this._name=this.name=De,this._source=this.source=Ze,this.execution=it,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ye?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const se=this._definition.type;(m.EmptyType===se||m.ProcessType===se||m.ShellType===se||m.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=m=je([b],ht),e.Task=ht;var gt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let ft=class{constructor(B,se=Tt.None){this.collapsibleState=se,y.URI.isUri(B)?this.resourceUri=B:this.label=B}};ft=je([b],ft),e.TreeItem=ft;var Tt;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(B,se){this.id=B,this.color=se}};yt=je([b],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let xt=class{constructor(B){this.id=B}};xt=je([b],xt),e.ThemeColor=xt;var Bt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Bt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(B,se){if(typeof B!="string"&&(!B||!y.URI.isUri(B)&&!y.URI.isUri(B.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=y.URI.file(B),this.base=B):y.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=se}};It=je([b],It),e.RelativePattern=It;let $t=class{constructor(B,se,De,Ze){this.enabled=typeof B=="boolean"?B:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=je([b],$t),e.Breakpoint=$t;let tn=class extends $t{constructor(B,se,De,Ze,it){super(se,De,Ze,it);if(B===null)throw(0,L.illegalArgument)("location");this.location=B}};tn=je([b],tn),e.SourceBreakpoint=tn;let bt=class extends $t{constructor(B,se,De,Ze,it){super(se,De,Ze,it);this.functionName=B}};bt=je([b],bt),e.FunctionBreakpoint=bt;let Xt=class extends $t{constructor(B,se,De,Ze,it,dt,mt){super(Ze,it,dt,mt);if(!se)throw(0,L.illegalArgument)("dataId");this.label=B,this.dataId=se,this.canPersist=De}};Xt=je([b],Xt),e.DataBreakpoint=Xt;let zt=class{constructor(B,se,De){this.command=B,this.args=se||[],this.options=De}};zt=je([b],zt),e.DebugAdapterExecutable=zt;let nn=class{constructor(B,se){this.port=B,this.host=se}};nn=je([b],nn),e.DebugAdapterServer=nn;let rn=class{constructor(B){this.path=B}};rn=je([b],rn),e.DebugAdapterNamedPipeServer=rn;let Pt=class{constructor(B){this.implementation=B}};Pt=je([b],Pt),e.DebugAdapterInlineImplementation=Pt;let Jt=class{constructor(B,se){this.range=B,this.expression=se}};Jt=je([b],Jt),e.EvaluatableExpression=Jt;var wn;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(wn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(B,se){this.range=B,this.text=se}};Wt=je([b],Wt),e.InlineValueText=Wt;let pt=class{constructor(B,se,De=!0){this.range=B,this.variableName=se,this.caseSensitiveLookup=De}};pt=je([b],pt),e.InlineValueVariableLookup=pt;let sn=class{constructor(B,se){this.range=B,this.expression=se}};sn=je([b],sn),e.InlineValueEvaluatableExpression=sn;let Ft=class{constructor(B,se){this.frameId=B,this.stoppedLocation=se}};Ft=je([b],Ft),e.InlineValueContext=Ft;var Vt;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Yt=w=class extends Error{constructor(B,se=n.FileSystemProviderErrorCode.Unknown,De){super(y.URI.isUri(B)?B.toString(!0):B);this.code=De?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(B){return new w(B,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(B){return new w(B,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(B){return new w(B,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(B){return new w(B,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(B){return new w(B,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(B){return new w(B,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Yt=w=je([b],Yt),e.FileSystemError=Yt;let on=class{constructor(B,se,De){this.start=B,this.end=se,this.kind=De}};on=je([b],on),e.FoldingRange=on;var dn;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(dn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bn;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(bn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hn;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(hn=e.CommentMode||(e.CommentMode={}));class an{constructor(B,se=[]){this.tokenTypes=B,this.tokenModifiers=se}}e.SemanticTokensLegend=an;function En(V){return typeof V=="undefined"||(0,D.isStringArray)(V)}class jt{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let se=0,De=B.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set(B.tokenTypes[se],se);for(let se=0,De=B.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set(B.tokenModifiers[se],se)}}push(B,se,De,Ze,it){if(typeof B=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ze=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(B,se,De,Ze,it);if($.isRange(B)&&typeof se=="string"&&En(De))return this._push(B,se,De);throw(0,L.illegalArgument)()}_push(B,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ze=B.start.line,it=B.start.character,dt=B.end.character-B.start.character,mt=this._tokenTypeStrToInt.get(se);let Ct=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(At);Ct|=1<<Mt>>>0}this._pushEncoded(Ze,it,dt,mt,Ct)}_pushEncoded(B,se,De,Ze,it){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Mt=0;for(let Ot=0;Ot<Ct;Ot++){let Nt=this._data[5*Ot],cn=this._data[5*Ot+1];Nt===0?(Nt=At,cn+=Mt):Nt+=At,this._data[5*Ot]=Nt,this._data[5*Ot+1]=cn,At=Nt,Mt=cn}}let dt=B,mt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=it,this._prevLine=B,this._prevChar=se}static _sortAndDeltaEncode(B){let se=[];const De=B.length/5|0;for(let mt=0;mt<De;mt++)se[mt]=mt;se.sort((mt,Ct)=>{const At=B[5*mt],Mt=B[5*Ct];if(At===Mt){const Ot=B[5*mt+1],Nt=B[5*Ct+1];return Ot-Nt}return At-Mt});const Ze=new Uint32Array(B.length);let it=0,dt=0;for(let mt=0;mt<De;mt++){const Ct=5*se[mt],At=B[Ct+0],Mt=B[Ct+1],Ot=B[Ct+2],Nt=B[Ct+3],cn=B[Ct+4],xn=At-it,Gn=xn===0?Mt-dt:Mt,un=5*mt;Ze[un+0]=xn,Ze[un+1]=Gn,Ze[un+2]=Ot,Ze[un+3]=Nt,Ze[un+4]=cn,it=At,dt=Mt}return Ze}build(B){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),B):new qt(jt._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=jt;class qt{constructor(B,se){this.resultId=se,this.data=B}}e.SemanticTokens=qt;class _n{constructor(B,se,De){this.start=B,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=_n;class Sn{constructor(B,se){this.resultId=se,this.edits=B}}e.SemanticTokensEdits=Sn;var Gt;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yn;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(yn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new yt("arrow-left")},Zt=je([b],Zt),e.QuickInputButtons=Zt;var Dn;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(B,se,De){this.badge=B,this.tooltip=se,this.color=De}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let Kt=class{constructor(B){this.kind=B}};Kt=je([b],Kt),e.ColorTheme=Kt;var fn;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(fn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(B,se){if(B<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");B<=se?(this._start=B,this._end=se):(this._start=se,this._end=B)}static isNotebookRange(B){return B instanceof Ht?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let se=this._start,De=this._end;return B.start!==void 0&&(se=B.start),B.end!==void 0&&(De=B.end),se===this._start&&De===this._end?this:new Ht(se,De)}}e.NotebookRange=Ht;class Lt{constructor(B,se,De,Ze,it,dt,mt){this.kind=B,this.value=se,this.languageId=De,this.mime=Ze,this.outputs=it??[],this.metadata=dt,this.executionSummary=mt,Lt.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(se=>Lt.isNotebookCellData(se))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Lt;class Oe{constructor(B){this.cells=B}}e.NotebookData=Oe;class Rt{constructor(B,se){this.data=B,this.mime=se;const De=(0,T.normalizeMimeType)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(B){return B instanceof Rt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const se={name:B.name,message:B.message,stack:B.stack};return Rt.json(se,"application/vnd.code.notebook.error")}static stdout(B){return Rt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Rt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,se="application/octet-stream"){return new Rt(B,se)}static text(B,se=T.Mimes.text){const De=$e(Rt,u,"f",p).encode(String(B));return new Rt(De,se)}static json(B,se="application/json"){const De=JSON.stringify(B,void 0,"	");return Rt.text(De,se)}}e.NotebookCellOutputItem=Rt,u=Rt,p={value:new TextEncoder};class Qt{constructor(B,se,De){this.items=Qt.ensureUniqueMimeTypes(B,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,P.generateUuid)(),this.metadata=se??De)}static isNotebookCellOutput(B){return B instanceof Qt?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&(0,D.isArray)(B.items)}static ensureUniqueMimeTypes(B,se=!1){const De=new Set,Ze=new Set;for(let it=0;it<B.length;it++){const dt=B[it],mt=(0,T.normalizeMimeType)(dt.mime);if(!De.has(mt)){De.add(mt);continue}Ze.add(it),se&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ze.size===0?B:B.filter((it,dt)=>!Ze.has(dt))}}e.NotebookCellOutput=Qt;var Et;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Et=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mn;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(mn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(B,se){this.text=B,this.alignment=se}}e.NotebookCellStatusBarItem=gn;var Pn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(B,se=[]){this.uri=B,this.provides=(0,g.asArray)(se)}}e.NotebookRendererScript=Tn;let ln=class{constructor(B,se){this.label=B,this.timestamp=se}};ln=je([b],ln),e.TimelineItem=ln;var An;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var pn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(pn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(B,se){this.ranges=B,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor(B,se){this._port=B,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor(B,se,De){this.include=B,this.exclude=se,this.profile=De}};ie=je([b],ie),e.TestRunRequest=ie;let he=S=class{constructor(B){this.message=B}static diff(B,se,De){const Ze=new S(B);return Ze.expectedOutput=se,Ze.actualOutput=De,Ze}};he=S=je([b],he),e.TestMessage=he;let Ae=class{constructor(B,se){if(this.id=B,this.label=se,/\s/.test(B))throw new Error(`Test tag ID "${B}" may not include whitespace`)}};Ae=je([b],Ae),e.TestTag=Ae;let ut=class{constructor(B,se){this.covered=B,this.total=se}};ut=je([b],ut),e.CoveredCount=ut;let St=s=class{constructor(B,se,De,Ze){this.uri=B,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=Ze}static fromDetails(B,se){const De=new ut(0,0),Ze=new ut(0,0),it=new ut(0,0);for(const mt of se)if("branches"in mt){De.total+=1,De.covered+=mt.executionCount>0?1:0;for(const Ct of mt.branches)Ze.total+=1,Ze.covered+=Ct.executionCount>0?1:0}else it.total+=1,it.covered+=mt.executionCount>0?1:0;const dt=new s(B,De,Ze.total>0?Ze:void 0,it.total>0?it:void 0);return dt.detailedCoverage=se,dt}};St=s=je([b],St),e.FileCoverage=St;let kt=class{constructor(B,se,De=[]){this.executionCount=B,this.location=se,this.branches=De}};kt=je([b],kt),e.StatementCoverage=kt;let Nn=class{constructor(B,se){this.executionCount=B,this.location=se}};Nn=je([b],Nn),e.BranchCoverage=Nn;let Un=class{constructor(B,se){this.executionCount=B,this.location=se}};Un=je([b],Un),e.FunctionCoverage=Un;var zn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(B,se,De,Ze,it,dt){this.kind=B,this.name=se,this.detail=De,this.uri=Ze,this.range=it,this.selectionRange=dt}}e.TypeHierarchyItem=qn}),define(me[124],ge([0,1,54,10,9,150,110,7,20]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function n(u,p){p?P.set(u,p):P.delete(u)}e.setWordDefinitionFor=n;function k(u){return P.get(u)}e.getWordDefinitionFor=k;class d extends C.MirrorTextModel{constructor(p,_,A,E,a,l,v,t){super(_,A,E,a);this._proxy=p,this._languageId=l,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,y.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===L.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(_){return _?p._getTextInRange(_):p.getText()},get eol(){return p._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(_){return p._lineAt(_)},offsetAt(_){return p._offsetAt(_)},positionAt(_){return p._positionAt(_)},validateRange(_){return p._validateRange(_)},validatePosition(_){return p._validatePosition(_)},getWordRangeAtPosition(_,A){return p._getWordRangeAtPosition(_,A)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,g.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,g.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const _=this._validateRange(p);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const A=this._eol,E=_.start.line,a=_.end.line,l=[];l.push(this._lines[E].substring(_.start.character));for(let v=E+1;v<a;v++)l.push(this._lines[v]);return l.push(this._lines[a].substring(0,_.end.character)),l.join(A)}_lineAt(p){let _;if(p instanceof D.Position?_=p.line:typeof p=="number"&&(_=p),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new f(_,this._lines[_],_===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(p),A=this._lines[_.index].length;return new D.Position(_.index,Math.min(_.remainder,A))}_validateRange(p){if(!(p instanceof D.Range))throw new Error("Invalid argument");const _=this._validatePosition(p.start),A=this._validatePosition(p.end);return _===p.start&&A===p.end?p:new D.Range(_.line,_.character,A.line,A.character)}_validatePosition(p){if(!(p instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:_,character:A}=p,E=!1;if(_<0)_=0,A=0,E=!0;else if(_>=this._lines.length)_=this._lines.length-1,A=this._lines[_].length,E=!0;else{const a=this._lines[_].length;A<0?(A=0,E=!0):A>a&&(A=a,E=!0)}return E?new D.Position(_,A):p}_getWordRangeAtPosition(p,_){const A=this._validatePosition(p);if(!_)_=k(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const E=(0,T.getWordAtText)(A.character+1,(0,T.ensureValidWordDefinition)(_),this._lines[A.line],0);if(E)return new D.Range(A.line,E.startColumn-1,A.line,E.endColumn-1)}}e.ExtHostDocumentData=d;class f{constructor(p,_,A){this._line=p,this._text=_,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(me[202],ge([0,1,7,3,112,6,81,24,2,32]),function(Y,e,g,L,I,C,T,D,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(d,f,u,p){this._notebook=u,this._selector=p,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(A=>{const E=this._cellUris.get(A.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(A=>_(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const d=[],f=[];for(const u of this._notebook.getCells())u.kind===g.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),d.push(u.document.getText().length+1),f.push(u.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(d){if(!d){let E="";for(const a of this._cells)E+=a.document.getText()+`
`;return E=E.slice(0,-1),E}if(d.isEmpty)return"";const f=this.locationAt(d.start),u=this.locationAt(d.end),p=this._cellUris.get(f.uri),_=this._cellUris.get(u.uri);if(p===void 0||_===void 0)return"";if(p===_)return this._cells[p].document.getText(new g.Range(f.range.start,u.range.end));const A=[this._cells[p].document.getText(new g.Range(f.range.start,new g.Position(this._cells[p].document.lineCount,0)))];for(let E=p+1;E<_;E++)A.push(this._cells[E].document.getText());return A.push(this._cells[_].document.getText(new g.Range(new g.Position(0,0),u.range.end))),A.join(`
`)}offsetAt(d){const f=this._cellLines.getIndexOf(d.line),u=this._cellLengths.getPrefixSum(f.index-1),p=this._cells[f.index].document.offsetAt(d.with(f.remainder));return u+p}positionAt(d){if(typeof d=="number"){const u=this._cellLengths.getIndexOf(d),p=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(p)}const f=this._cellUris.get(d.uri);if(f!==void 0){const u=this._cellLines.getPrefixSum(f-1);return new g.Position(u+d.range.start.line,d.range.start.character)}return new g.Position(0,0)}locationAt(d){g.Range.isRange(d)||(d=new g.Range(d,d));const f=this._cellLines.getIndexOf(d.start.line);let u=f;d.isEmpty||(u=this._cellLines.getIndexOf(d.end.line));const p=new g.Position(f.remainder,d.start.character),_=new g.Position(u.remainder,d.end.character),A=new g.Range(p,_),E=this._cells[f.index];return new g.Location(E.document.uri,E.document.validateRange(A))}contains(d){return this._cellUris.has(d)}validateRange(d){const f=this.validatePosition(d.start),u=this.validatePosition(d.end);return d.with(f,u)}validatePosition(d){const f=this._cellLines.getIndexOf(d.line),u=new g.Position(f.remainder,d.character),p=this._cells[f.index].document.validatePosition(u),_=this._cellLines.getPrefixSum(f.index-1);return new g.Position(_+p.line,p.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[203],ge([0,1,7,14,3]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(D){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let y=D==="light"?g.ColorThemeKind.Light:D==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=je([Ue(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(me[64],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(me[204],ge([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function I(D,y){if(y.serializeBuffersForPostMessage){const P=new L,n=(f,u)=>{if(u instanceof ArrayBuffer){const p=P.add(u);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(u)){const p=C(u);if(p){const _=P.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:p,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},k=JSON.stringify(D,n),d=P.buffers.map(f=>{const u=new Uint8Array(f);return g.VSBuffer.wrap(u)});return{message:k,buffers:d}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=I;function C(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(D,y){const P=y.map(d=>{const f=new ArrayBuffer(d.byteLength);return new Uint8Array(f).set(d.buffer),f}),n=y.length?(d,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const u=f,{index:p}=u,_=P[p];if(u.view)switch(u.view.type){case 1:return new Int8Array(_,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return f}:void 0;return{message:JSON.parse(D,n),arrayBuffers:P}}e.deserializeWebviewMessage=T}),define(me[205],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function I(T){const D={items:new Map};return T.types.forEach((y,P)=>{D.items.set(y,{asString:async()=>T.items[P].asString})}),D}L.toITreeDataTransfer=I;async function C(T){const D={types:[],items:[]},y=Array.from(T.items.entries());for(const P of y)D.types.push(P[0]),D.items.push({asString:await P[1].asString()});return D}L.toTreeDataTransferDTO=C})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[89],ge([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(D,y){return D.scheme===g.Schemas.http||D.scheme===g.Schemas.https?D:(y&&y.authority&&y.isRemote&&D.scheme===g.Schemas.file&&(D=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:y.authority,path:D.path})),L.URI.from({scheme:g.Schemas.https,authority:`${D.scheme}+${C(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=I;function C(D){return D.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function T(D){return D.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=T}),define(me[206],ge([0,1,3,6,89]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(D,y,P){this._proxy=D,this._editors=y,this._initData=P,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const k of this._insets.values())n.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,y,P,n,k){let d;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===D){d=a;break}if(!d)throw new Error("not a visible editor");const f=this,u=this._handlePool++,p=new g.Emitter,_=new g.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,I.asWebviewUri)(a,f._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(a){this._options=a,f._proxy.$setOptions(u,a)}get options(){return this._options}set html(a){this._html=a,f._proxy.$setHtml(u,a)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(a){return f._proxy.$postMessage(u,a)}},E=new class{constructor(){this.editor=D,this.line=y,this.height=P,this.webview=A,this.onDidDispose=_.event}dispose(){f._insets.has(u)&&(f._insets.delete(u),f._proxy.$disposeEditorInset(u),_.fire(),_.dispose(),p.dispose())}};return this._proxy.$createEditorInset(u,d.id,d.value.document.uri,y+1,P,n||{},k.identifier,k.extensionLocation),this._insets.set(u,{editor:D,inset:E,onDidReceiveMessage:p}),E}$onDidDispose(D){const y=this._insets.get(D);y&&y.inset.dispose()}$onDidReceiveMessage(D,y){const P=this._insets.get(D);P&&P.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=C}),define(me[207],ge([0,1,172,13,2,6,4,61,34,20,10]),function(Y,e,g,L,I,C,T,D,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new D.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new D.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new D.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new D.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new D.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new D.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new D.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new D.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new D.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new D.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new D.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new D.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new D.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.ActiveEditorGroupLockedContext=new D.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(15,null)),e.MultipleEditorGroupsContext=new D.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new D.RawContextKey("editorIsOpen",!1,(0,g.localize)(17,null)),e.InEditorZenModeContext=new D.RawContextKey("inZenMode",!1,(0,g.localize)(18,null)),e.IsCenteredLayoutContext=new D.RawContextKey("isCenteredLayout",!1,(0,g.localize)(19,null)),e.SplitEditorsVertically=new D.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(20,null)),e.EditorAreaVisibleContext=new D.RawContextKey("editorAreaVisible",!0,(0,g.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function k(s){return typeof s?.getViewState=="function"}e.isTextEditorPane=k;function d(s){if(a(s))return!1;const b=s;return I.URI.isUri(b?.resource)}e.isResourceEditorInput=d;function f(s){if(a(s))return!1;const b=s;return b?.original!==void 0&&b.modified!==void 0}e.isResourceDiffEditorInput=f;function u(s){if(a(s))return!1;const b=s;return b?b.resource===void 0||b.resource.scheme===n.Schemas.untitled||b.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var p;(function(s){s[s.SHORT=0]="SHORT",s[s.MEDIUM=1]="MEDIUM",s[s.LONG=2]="LONG"})(p=e.Verbosity||(e.Verbosity={}));var _;(function(s){s[s.EXPLICIT=1]="EXPLICIT",s[s.AUTO=2]="AUTO",s[s.FOCUS_CHANGE=3]="FOCUS_CHANGE",s[s.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var A;(function(s){s[s.None=0]="None",s[s.Readonly=2]="Readonly",s[s.Untitled=4]="Untitled",s[s.Singleton=8]="Singleton",s[s.RequiresTrust=16]="RequiresTrust"})(A=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends C.Disposable{}e.AbstractEditorInput=E;function a(s){return s instanceof E}e.isEditorInput=a;function l(s){const b=s;return I.URI.isUri(b?.preferredResource)}function v(s){const b=s;return a(b?.primary)&&a(b?.secondary)}e.isSideBySideEditorInput=v;function t(s){return a(s?.editor)}e.isEditorInputWithOptions=t;function r(s){const b=s;return t(s)&&b?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function o(s){const b=s;return typeof b?.groupId=="number"&&a(b.editor)}e.isEditorIdentifier=o;var i;(function(s){s[s.PRIMARY=1]="PRIMARY",s[s.SECONDARY=2]="SECONDARY",s[s.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(b,R){if(!b)return;const O=v(b)?b.primary:f(b)?b.modified:void 0,$=v(b)?b.secondary:f(b)?b.original:void 0;if(R?.supportSideBySide&&O&&$){if(R?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(O,{filterByScheme:R.filterByScheme}),secondary:this.getOriginalUri($,{filterByScheme:R.filterByScheme})};b=R.supportSideBySide===i.PRIMARY?O:$}if(f(b))return;const G=l(b)?b.preferredResource:b.resource;return!G||!R||!R.filterByScheme?G:this.filterUri(G,R.filterByScheme)}getCanonicalUri(b,R){if(!b)return;const O=v(b)?b.primary:f(b)?b.modified:void 0,$=v(b)?b.secondary:f(b)?b.original:void 0;if(R?.supportSideBySide&&O&&$){if(R?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(O,{filterByScheme:R.filterByScheme}),secondary:this.getCanonicalUri($,{filterByScheme:R.filterByScheme})};b=R.supportSideBySide===i.PRIMARY?O:$}if(f(b))return;const G=b.resource;return!G||!R||!R.filterByScheme?G:this.filterUri(G,R.filterByScheme)}filterUri(b,R){if(Array.isArray(R)){if(R.some(O=>b.scheme===O))return b}else if(R===b.scheme)return b}}e.EditorResourceAccessor=new c;var h;(function(s){s[s.LEFT=0]="LEFT",s[s.RIGHT=1]="RIGHT"})(h=e.CloseDirection||(e.CloseDirection={}));class m{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(b){const R=this.instantiationService=b.get(T.IInstantiationService);for(const[O,$]of this.editorSerializerConstructors)this.createEditorSerializer(O,$,R);this.editorSerializerConstructors.clear()}createEditorSerializer(b,R,O){const $=O.createInstance(R);this.editorSerializerInstances.set(b,$)}registerFileEditorFactory(b){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=b}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(b,R){if(this.editorSerializerConstructors.has(b)||this.editorSerializerInstances.has(b))throw new Error(`A editor serializer with type ID '${b}' was already registered.`);return this.instantiationService?this.createEditorSerializer(b,R,this.instantiationService):this.editorSerializerConstructors.set(b,R),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(b),this.editorSerializerInstances.delete(b)})}getEditorSerializer(b){return this.editorSerializerInstances.get(typeof b=="string"?b:b.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new m);async function w(s,b){if(!s||!s.length)return[];const R=await Promise.all(s.map(async O=>{const $=I.URI.revive(O.fileUri);if(!$||(await b.activateProvider($.scheme),!b.canHandleResource($)))return;const G=typeof O.exists=="boolean"?O.exists:await b.exists($);if(!G&&O.openOnlyIfExists)return;const Z=G&&!(0,L.isUndefined)(O.selection)?{selection:O.selection,pinned:!0,override:O.editorOverrideId}:{pinned:!0,override:O.editorOverrideId};let U;return G?U={resource:$,options:Z,forceFile:!0}:U={resource:$,options:Z,forceUntitled:!0},U}));return(0,P.coalesce)(R)}e.pathsToEditors=w;var S;(function(s){s[s.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",s[s.SEQUENTIAL=1]="SEQUENTIAL"})(S=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[208],ge([0,1,3,61,173,4,6,24,34,20,55,23,47,197]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",d.Codicon.window,(0,I.localize)(0,null));var u;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var p;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(p=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function A(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=A;class E extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(h,m,w){const S=this.get(h.id);if(S)return S;const s=h;return s.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,D.getOrSet)(this.viewContainers,m,[]).push(s),w?.isDefault&&this.defaultViewContainers.push(s),this._onDidRegister.fire({viewContainer:s,viewContainerLocation:m}),s}deregisterViewContainer(h){for(const m of this.viewContainers.keys()){const w=this.viewContainers.get(m),S=w?.indexOf(h);if(S!==-1){w?.splice(S,1),w.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:m});return}}}get(h){return this.all.filter(m=>m.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(w=>w?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===h)}}y.Registry.add(u.ViewContainersRegistry,new E);var a;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function l(c,h){const m=c.group??a.More,w=h.group??a.More;return m!==w?m.localeCompare(w):(c.order??5)-(h.order??5)}class v extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(h,m){this.registerViews2([{views:h,viewContainer:m}])}registerViews2(h){h.forEach(({views:m,viewContainer:w})=>this.addViews(m,w)),this._onViewsRegistered.fire(h)}deregisterViews(h,m){const w=this.removeViews(h,m);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:m})}moveViews(h,m){for(const w of this._views.keys())if(w!==m){const S=this.removeViews(h,w);S.length&&(this.addViews(S,m),this._onDidChangeContainer.fire({views:S,from:w,to:m}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const m of this._viewContainers){const w=(this._views.get(m)||[]).filter(S=>S.id===h)[0];if(w)return w}return null}getViewContainer(h){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(S=>S.id===h)[0])return m;return null}registerViewWelcomeContent(h,m){return this._viewWelcomeContents.add(h,m),this._onDidChangeViewWelcomeContent.fire(h),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,m),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,m){const w=new Map;for(const[S,s]of m)this._viewWelcomeContents.add(h,s),w.set(S,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,s),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),w}getViewWelcomeContent(h){const m=[];return this._viewWelcomeContents.forEach(h,w=>m.push(w)),m.sort(l)}addViews(h,m){let w=this._views.get(m);w||(w=[],this._views.set(m,w),this._viewContainers.push(m));for(const S of h){if(this.getView(S.id)!==null)throw new Error((0,I.localize)(1,null,S.id));w.push(S)}}removeViews(h,m){const w=this._views.get(m);if(!w)return[];const S=[],s=[];for(const b of w)h.includes(b)?S.push(b):s.push(b);return S.length&&(s.length?this._views.set(m,s):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),S}}y.Registry.add(u.ViewsRegistry,new v),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var r;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(h,m){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,h),this._hasResolve=!!m,this.resolve=async w=>{if(m&&!this.resolved){const S=await m(w);S&&(this.tooltip=this.tooltip??S.tooltip,this.command=this.command??S.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[125],ge([0,1,3,17,174]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,y,P,n){const k={command:D};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof n=="number"){const d=setTimeout(()=>{clearTimeout(d);const f=this.pendingRequests.get(k.seq);if(f){this.pendingRequests.delete(k.seq);const u={type:"response",seq:0,request_seq:k.seq,success:!1,command:D,message:(0,I.localize)(0,null,n,D)};f(u)}},n)}return P&&this.pendingRequests.set(k.seq,P),k.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,y){return D.type!=="event"||y.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,L.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const y=D,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}internalSend(D,y){y.type=D,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((y,P)=>D.set(P,y)),await(0,L.timeout)(500),D.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(me[209],ge([0,1,9,2,8,23,10]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function y(o,i,c){return o.replace(D,function(h,m){return i&&m.length>0&&m[0]!=="_"?h:c&&c.hasOwnProperty(m)?c[m]:h})}e.formatPII=y;function P(o){const i={};for(const c of Object.keys(o))c.startsWith("!")||(i[c]=o[c]);return i}e.filterExceptionsFromTelemetry=P;function n(o){return o.configuration.request==="attach"&&!k(o)&&(!o.parentSession||n(o.parentSession))}e.isSessionAttach=n;function k(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(i,"extensionhost")||(0,g.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?k(o.parentSession):void 0}e.getExtensionHostDebugSession=k;function d(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=d;function f(o,i,c){let h,m=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=w.exec(o);){let s=S.index+1,b=s+S[0].length;if(s<=i&&b>=c){h=S[0],m=s;break}}if(h){let s=/\w+/g,b=null;for(;(b=s.exec(h))&&!(b.index+1+m+b[0].length>=c););b&&(h=h.substring(0,s.lastIndex))}return h?{start:m,end:m+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(o){return!!(o&&o.match(u))}e.isUri=p;function _(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(p(o.path))return L.URI.parse(o.path);if((0,I.isAbsolute)(o.path))return L.URI.file(o.path)}return o.path}function A(o){if(typeof o.path=="object"){const i=L.URI.revive(o.path);if(i)return i.scheme===T.Schemas.file?i.fsPath:i.toString()}return o.path}function E(o,i){const c=i?_:A,h=(0,C.deepClone)(o);return l(h,(m,w)=>{m&&w&&(w.path=c(w))}),h}e.convertToDAPaths=E;function a(o,i){const c=i?_:A,h=(0,C.deepClone)(o);return l(h,(m,w)=>{!m&&w&&(w.path=c(w))}),h}e.convertToVSCPaths=a;function l(o,i){switch(o.type){case"event":const c=o;switch(c.event){case"output":i(!1,c.body.source);break;case"loadedSource":i(!1,c.body.source);break;case"breakpoint":i(!1,c.body.breakpoint.source);break;default:break}break;case"request":const h=o;switch(h.command){case"setBreakpoints":i(!0,h.arguments.source);break;case"breakpointLocations":i(!0,h.arguments.source);break;case"source":i(!0,h.arguments.source);break;case"gotoTargets":i(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(w=>i(!1,w));break;default:break}break;case"response":const m=o;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(w=>i(!1,w.source));break;case"loadedSources":m.body.sources.forEach(w=>i(!1,w));break;case"scopes":m.body.scopes.forEach(w=>i(!1,w.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(w=>i(!1,w.source));break;case"setBreakpoints":m.body.breakpoints.forEach(w=>i(!1,w.source));break;default:break}break}}function v(o){return o.filter(i=>!i.presentation?.hidden).sort((i,c)=>i.presentation?c.presentation?i.presentation.group?c.presentation.group?i.presentation.group!==c.presentation.group?i.presentation.group.localeCompare(c.presentation.group):t(i.presentation.order,c.presentation.order):-1:c.presentation.group?1:t(i.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=v;function t(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function r(o,i){const c=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(c!=="none"&&(await i.saveAll(),c==="allEditorsInActiveGroup")){const h=i.activeEditorPane;h&&await i.save({editor:h.input,groupId:h.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(me[210],ge([0,1,28,39,175,126,8,9,23,11,185,125]),function(Y,e,g,L,I,C,T,D,y,P,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class d extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",l=>this.handleData(l))}sendMessage(E){if(this.outputStream){const a=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${d.TWO_CRLF}${a}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+a))}continue}}else{const a=this.rawData.indexOf(d.TWO_CRLF);if(a!==-1){const v=this.rawData.toString("utf8",0,a).split(d.HEADER_LINESEPARATOR);for(const t of v){const r=t.split(d.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(a+d.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=d,d.TWO_CRLF=`\r
\r
`,d.HEADER_LINESEPARATOR=/\r?\n/,d.HEADER_FIELDSEPARATOR=/: */;class f extends d{startSession(){return new Promise((E,a)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",v=>{l?this._onError.fire(v):a(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class u extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=u;class p extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return C.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=p;class _ extends d{constructor(E,a,l){super();this.adapterExecutable=E,this.debugType=a,this.outputService=l}async startSession(){const E=this.adapterExecutable.command,a=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(E)if(T.isAbsolute(E)){if(!await g.Promises.exists(E))throw new Error(I.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let v=process.env;if(l.env&&Object.keys(l.env).length>0&&(v=y.mixin(y.deepClone(process.env),l.env)),E==="node")if(Array.isArray(a)&&a.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:v,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(o.cwd=l.cwd);const i=L.fork(a[0],a.slice(1),o);if(!i.pid)throw new Error(I.localize(2,null,a[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const r={env:v};l.cwd&&(r.cwd=l.cwd),this.serverProcess=L.spawn(E,a,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,o)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(r(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((E,a)=>{const l=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,r){if(v)return a(v)});l.on("exit",E),l.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,a){if(!E)return;const l=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?l.runtime=T.join(a,E.runtime):l.runtime=E.runtime),E.runtimeArgs&&(l.runtimeArgs=E.runtimeArgs),E.program&&(T.isAbsolute(E.program)?l.program=E.program:l.program=T.join(a,E.program)),E.args&&(l.args=E.args);const v=E;return v.win&&(l.win=_.extract(v.win,a)),v.winx86&&(l.winx86=_.extract(v.winx86,a)),v.windows&&(l.windows=_.extract(v.windows,a)),v.osx&&(l.osx=_.extract(v.osx,a)),v.linux&&(l.linux=_.extract(v.linux,a)),l}static platformAdapterExecutable(E,a){let l=Object.create(null);a=a.toLowerCase();for(const c of E)if(c.contributes){const h=c.contributes.debuggers;h&&h.length>0&&h.filter(m=>typeof m.type=="string"&&D.equalsIgnoreCase(m.type,a)).forEach(m=>{const w=_.extract(m,c.extensionLocation.fsPath);l=y.mixin(l,w,c.isBuiltin)})}let v;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=l.winx86||l.win||l.windows:P.isWindows?v=l.win||l.windows:P.isMacintosh?v=l.osx:P.isLinux&&(v=l.linux),v=v||l;let t=v.program||l.program;const r=v.args||l.args;let o=v.runtime||l.runtime;const i=v.runtimeArgs||l.runtimeArgs;if(o)return{type:"executable",command:o,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(me[211],ge([0,1,39,11,29,188]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(d,f){return new Promise((u,p)=>{let _="";const A=g.spawn(d,f);A.pid&&A.stdout.on("data",E=>{_+=E.toString()}),A.on("error",E=>{p(E)}),A.on("close",E=>{u(_)})})}let D;function y(d,f){if(!D)if(L.isWindows)D=new C.WindowsExternalTerminalService;else if(L.isMacintosh)D=new C.MacExternalTerminalService;else if(L.isLinux)D=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const u=f.getConfiguration("terminal");return D.runInTerminal(d.title,d.cwd,d.args,d.env||{},u.external||{})}e.runInExternalTerminal=y;function P(d){return d?L.isWindows?new Promise(async f=>{(await new Promise((p,_)=>{Y(["windows-process-tree"],p,_)})).getProcessTree(d,p=>{f(p.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(d)]).then(f=>{const u=f.trim();return!(u.length===0||u.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var n;(function(d){d[d.cmd=0]="cmd",d[d.powershell=1]="powershell",d[d.bash=2]="bash"})(n||(n={}));function k(d,f,u,p){d=d.trim().toLowerCase();let _;d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0?_=1:d.indexOf("cmd.exe")>=0?_=0:d.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let A,E=" ";switch(_){case 1:if(A=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),u){const l=(0,I.getDriveLetter)(u);l&&(E+=`${l}:; `),E+=`cd ${A(u)}; `}if(p)for(let l in p){const v=p[l];v===null?E+=`Remove-Item env:${l}; `:E+=`\${env:${l}}='${v}'; `}if(f.length>0){const l=A(f.shift());E+=l[0]==="'"?`& ${l} `:`${l} `;for(let v of f)E+=`${A(v)} `}break;case 0:if(A=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),u){const l=(0,I.getDriveLetter)(u);l&&(E+=`${l}: && `),E+=`cd ${A(u)} && `}if(p){E+='cmd /C "';for(let l in p){let v=p[l];v===null?E+=`set "${l}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${l}=${v}" && `)}}for(let l of f)E+=`${A(l)} `;p&&(E+='"');break;case 2:A=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const a=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(u&&(E+=`cd ${A(u)} ; `),p){E+="/usr/bin/env";for(let l in p){const v=p[l];v===null?E+=` -u ${a(l)}`:E+=` ${a(`${l}=${v}`)}`}E+=" "}for(let l of f)E+=`${A(l)} `;break}return E}e.prepareCommand=k}),define(me[127],ge([0,1,30,102,10,8,11,61]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(s){s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeLanguage=5]="ChangeLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var _;(function(s){s.scheme=I.Schemas.vscodeNotebookCell;const b=/^ch(\d{7,})/;function R(U,x){return U.with({scheme:s.scheme,fragment:`ch${x.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}s.generate=R;function O(U){if(U.scheme!==s.scheme)return;const x=b.exec(U.fragment);return x?{handle:Number(x[1]),notebook:U.with({scheme:U.fragment.substr(x[0].length)||I.Schemas.file,fragment:null})}:void 0}s.parse=O;function $(U){if(U.scheme!==I.Schemas.vscodeNotebookCellMetadata)return;const x=b.exec(U.fragment);return x?{handle:Number(x[1]),notebook:U.with({scheme:U.fragment.substr(x[0].length)||I.Schemas.file,fragment:null})}:void 0}s.parseCellMetadataUri=$;function G(U,x,M){return U.with({scheme:M,fragment:`ch${x.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}s.generateCellUri=G;function Z(U,x){if(U.scheme!==x)return;const M=b.exec(U.fragment);return M?{handle:Number(M[1]),notebook:U.with({scheme:U.fragment.substr(M[0].length)||I.Schemas.file,fragment:null})}:void 0}s.parseCellUri=Z})(_=e.CellUri||(e.CellUri={}));const A=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(s){return A.get(s)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function a(s){return A.get(s)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function l(s){return A.get(s)?.mergeable??!1}e.mimeTypeIsMergeable=l;function v(s,b){return T.isWindows&&(s=s.replace(/\//g,"\\"),b=b.replace(/\//g,"\\")),g.match(s,b)}function t(s,b,R){let O=0;for(let $=0;$<b.length;$++){if(v(b[$],s))return O;O++}for(let $=0;$<R.length;$++){if(v(R[$],s))return O;O++}return O}function r(s,b,R){return s.sort((O,$)=>t(O,b,R)-t($,b,R))}e.sortMimeTypes=r;function o(s,b,R,O=($,G)=>$===G){const $=[];function G(x,M,H){if(M===0&&H.length===0)return;const F=$[$.length-1];F&&F.start+F.deleteCount===x?(F.deleteCount+=M,F.toInsert.push(...H)):$.push({start:x,deleteCount:M,toInsert:H})}let Z=0,U=0;for(;;){if(Z===s.length){G(Z,0,b.slice(U));break}if(U===b.length){G(Z,s.length-Z,[]);break}const x=s[Z],M=b[U];if(O(x,M)){Z+=1,U+=1;continue}R(M)?(G(Z,1,[]),Z+=1):(G(Z,0,[M]),U+=1)}return $}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(s){s.default="default",s.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(s){const b=s;return!!((typeof b.include=="string"||g.isRelativePattern(b.include))&&(typeof b.exclude=="string"||g.isRelativePattern(b.exclude)))}e.isDocumentExcludePattern=c;function h(s,b,R){if(Array.isArray(s.viewType)&&s.viewType.indexOf(b)>=0||s.viewType===b)return!0;if(s.filenamePattern){let O=c(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,$=c(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(g.match(O,(0,C.basename)(R.fsPath).toLowerCase()))return!($&&g.match($,(0,C.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class m{constructor(b){this.textModel=b}getElements(){const b=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)b[R]=this.textModel.cells[R].getHashValue();return b}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class S{static create(b){return`${S._prefix}${b}`}static parse(b){if(b.startsWith(S._prefix))return b.substr(S._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=S,S._prefix="notebook/"}),define(me[212],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState",I[I.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(me[213],ge([0,1,177,4,61]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[214],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=g;function L(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=L}),define(me[128],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(k){k[k.Error=0]="Error",k[k.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var C;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(k,d)=>{d.expand!==void 0&&(k.expand=d.expand),d.item!==void 0&&(k.item=k.item?Object.assign(k.item,d.item):d.item)};e.applyTestItemUpdate=T;var D;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(D=e.DetailType||(e.DetailType={}));var y;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.Remove=2]="Remove",k[k.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",k[k.Retire=4]="Retire",k[k.AddTag=5]="AddTag",k[k.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(d){}update(d){}remove(d,f){}complete(){}}e.IncrementalChangeCollector=P;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(d){const f=this.createChangeCollector();for(const u of d)switch(u[0]){case 0:{const p=u[1];if(p.parent){if(this.items.has(p.parent)){const _=this.items.get(p.parent);_.children.add(p.item.extId);const A=this.createItem(p,_);this.items.set(p.item.extId,A),f.add(A)}}else{const _=this.createItem(p);this.roots.add(_),this.items.set(p.item.extId,_),f.add(_)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=u[1],_=this.items.get(p.extId);if(!_)break;p.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,p),f.update(_);break}case 2:{const p=this.items.get(u[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const _=[[u[1]]];for(;_.length;)for(const A of _.pop()){const E=this.items.get(A);E&&(_.push(E.children),this.items.delete(A),f.remove(E,E!==p),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break;case 5:this._tags.set(u[1].id,u[1]);break;case 6:this._tags.delete(u[1]);break}f.complete()}retireTest(d){}updatePendingRoots(d){this.pendingRootCount+=d}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=n}),define(me[90],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(C){C.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class I{constructor(T,D=T.length){if(this.path=T,this.viewEnd=D,T.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,D,y=T.parent){if(T.id===D)return new I([D]);let P=[T.id];for(let n=y;n&&n.id!==D;n=n.parent)P.push(n.id);return P.push(D),new I(P.reverse())}static isRoot(T){return!T.includes("\0")}static fromString(T){return new I(T.split("\0"))}static join(T,D){return new I([...T.path,D])}static joinToString(T,D){return T.toString()+"\0"+D}static compare(T,D){return T===D?0:D.startsWith(T+"\0")?2:T.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new I(this.path,T)}compare(T){if(typeof T=="string")return I.compare(this.toString(),T);for(let D=0;D<T.viewEnd&&D<this.viewEnd;D++)if(T.path[D]!==this.path[D])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=I}),define(me[215],ge([0,1,8,38,13,23,11,79,178]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(k,d,f){this._contributedVariables=new Map,this._context=k,this._labelService=d,f&&(this._envVariablesPromise=f.then(u=>this.prepareEnv(u)))}prepareEnv(k){if(T.isWindows){const d=Object.create(null);return Object.keys(k).forEach(f=>{d[f.toLowerCase()]=k[f]}),d}return k}resolveWithEnvironment(k,d,f){return this.recursiveResolve(this.prepareEnv(k),d?d.uri:void 0,f)}async resolveAsync(k,d){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,d)}async resolveAnyBase(k,d,f,u){const p=C.deepClone(d);return T.isWindows&&p.windows?Object.keys(p.windows).forEach(_=>p[_]=p.windows[_]):T.isMacintosh&&p.osx?Object.keys(p.osx).forEach(_=>p[_]=p.osx[_]):T.isLinux&&p.linux&&Object.keys(p.linux).forEach(_=>p[_]=p.linux[_]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,p,f,u)}async resolveAnyAsync(k,d,f){return this.resolveAnyBase(k,d,f)}async resolveAnyMap(k,d,f){const u=new Map;return{newConfig:await this.resolveAnyBase(k,d,f,u),resolvedVariables:u}}resolveWithInteractionReplace(k,d,f,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,d,f,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,d){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,d)}recursiveResolve(k,d,f,u,p){if(I.isString(f))return this.resolveString(k,d,f,u,p);if(I.isArray(f))return f.map(_=>this.recursiveResolve(k,d,_,u,p));if(I.isObject(f)){let _=Object.create(null);return Object.keys(f).forEach(A=>{const E=this.resolveString(k,d,A,u,p);_[E]=this.recursiveResolve(k,d,f[A],u,p)}),_}return f}resolveString(k,d,f,u,p){return f.replace(P.VARIABLE_REGEXP,(A,E)=>{if(E.includes(P.VARIABLE_LHS))return A;let a=this.evaluateSingleVariable(k,A,E,d,u);return p&&p.set(E,a),a!==A&&I.isString(a)&&a.match(P.VARIABLE_REGEXP)&&(a=this.resolveString(k,d,a,u,p)),a})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,d,f,u,p){let _;const A=f.split(":");A.length>1&&(f=A[0],_=A[1]);const E=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,y.localize)(0,null,d))},a=()=>{const v=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,d,g.basename(v)))},l=()=>{if(_){const v=this._context.getFolderUri(_);if(v)return v;throw new Error((0,y.localize)(2,null,d,_))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,d)):new Error((0,y.localize)(4,null,d))};switch(f){case"env":if(_){if(k){const v=k[T.isWindows?_.toLowerCase():_];if(I.isString(v))return v}return""}throw new Error((0,y.localize)(5,null,d));case"config":if(_){const v=this._context.getConfigurationValue(u,_);if(I.isUndefinedOrNull(v))throw new Error((0,y.localize)(6,null,d,_));if(I.isObject(v))throw new Error((0,y.localize)(7,null,d,_));return v}throw new Error((0,y.localize)(8,null,d));case"command":return this.resolveFromMap(d,_,p,"command");case"input":return this.resolveFromMap(d,_,p,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return u||_?(0,D.normalizeDriveLetter)(this.fsPath(l())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(l()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,y.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,d));case"file":return E();case"fileWorkspaceFolder":return a();case"relativeFile":return u||_?g.relative(this.fsPath(l()),E()):E();case"relativeFileDirname":const r=g.dirname(E());if(u||_){const h=g.relative(this.fsPath(l()),r);return h.length===0?".":h}return r;case"fileDirname":return g.dirname(E());case"fileExtname":return g.extname(E());case"fileBasename":return g.basename(E());case"fileBasenameNoExtension":const o=g.basename(E());return o.slice(0,o.length-g.extname(o).length);case"fileDirnameBasename":return g.basename(g.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||d;case"execInstallFolder":const c=this._context.getAppRoot();return c||d;case"pathSeparator":return g.sep;default:try{const h=_?`${f}:${_}`:f;return this.resolveFromMap(d,h,p,void 0)}catch(h){return d}}}}resolveFromMap(k,d,f,u){if(d&&f){const p=u===void 0?f[d]:f[u+":"+d];if(typeof p=="string")return p;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[129],ge([0,1,4,207]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var C;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var D;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const _=p;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=P;var n;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(p){p[p.GROUP_ACTIVE=0]="GROUP_ACTIVE",p[p.GROUP_INDEX=1]="GROUP_INDEX",p[p.GROUP_LOCKED=2]="GROUP_LOCKED",p[p.EDITOR_OPEN=3]="EDITOR_OPEN",p[p.EDITOR_CLOSE=4]="EDITOR_CLOSE",p[p.EDITOR_MOVE=5]="EDITOR_MOVE",p[p.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",p[p.EDITOR_LABEL=7]="EDITOR_LABEL",p[p.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",p[p.EDITOR_PIN=9]="EDITOR_PIN",p[p.EDITOR_STICKY=10]="EDITOR_STICKY",p[p.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var d;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(d=e.OpenEditorContext||(e.OpenEditorContext={}));function f(p){const _=p;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=f;function u(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(me[216],ge([0,1,4,129]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(C){const T=C;return typeof C=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=I}),define(me[15],ge([0,1,20,22,99,291,59,23,13,2,41,83,179,116,88,127,90,216,7]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ae){function Ee(q){const{selectionStartLineNumber:Te,selectionStartColumn:Pe,positionLineNumber:Ye,positionColumn:Xe}=q,at=new E.Position(Te-1,Pe-1),wt=new E.Position(Ye-1,Xe-1);return new E.Selection(at,wt)}ae.to=Ee;function ce(q){const{anchor:Te,active:Pe}=q;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ae.from=ce})(a=e.Selection||(e.Selection={}));var l;(function(ae){function Ee(q){if(!q)return;const{start:Te,end:Pe}=q;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ae.from=Ee;function ce(q){if(!q)return;const{startLineNumber:Te,startColumn:Pe,endLineNumber:Ye,endColumn:Xe}=q;return new E.Range(Te-1,Pe-1,Ye-1,Xe-1)}ae.to=ce})(l=e.Range||(e.Range={}));var v;(function(ae){function Ee(ce){switch(ce){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}ae.to=Ee})(v=e.TokenType||(e.TokenType={}));var t;(function(ae){function Ee(q){return new E.Position(q.lineNumber-1,q.column-1)}ae.to=Ee;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}ae.from=ce})(t=e.Position||(e.Position={}));var r;(function(ae){function Ee(q){switch(q){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}ae.from=Ee;function ce(q){switch(q){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}ae.to=ce})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(ae){function Ee(q){let Te;return q.code&&((0,y.isString)(q.code)||(0,y.isNumber)(q.code)?Te=String(q.code):Te={value:String(q.code.value),target:q.code.target}),{...l.from(q.range),message:q.message,source:q.source,code:Te,severity:c.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(i.from),tags:Array.isArray(q.tags)?(0,g.coalesce)(q.tags.map(r.from)):void 0}}ae.from=Ee;function ce(q){const Te=new E.Diagnostic(l.to(q),q.message,c.to(q.severity));return Te.source=q.source,Te.code=(0,y.isString)(q.code)?q.code:q.code?.value,Te.relatedInformation=q.relatedInformation&&q.relatedInformation.map(i.to),Te.tags=q.tags&&(0,g.coalesce)(q.tags.map(r.to)),Te}ae.to=ce})(o=e.Diagnostic||(e.Diagnostic={}));var i;(function(ae){function Ee(q){return{...l.from(q.location.range),message:q.message,resource:q.location.uri}}ae.from=Ee;function ce(q){return new E.DiagnosticRelatedInformation(new E.Location(q.resource,l.to(q)),q.message)}ae.to=ce})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(ae){function Ee(q){switch(q){case E.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ae.from=Ee;function ce(q){switch(q){case f.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}ae.to=ce})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(ae){function Ee(q){return typeof q=="number"&&q>=E.ViewColumn.One?q-1:q===E.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}ae.from=Ee;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ae.to=ce})(h=e.ViewColumn||(e.ViewColumn={}));function m(ae){return typeof ae.range!="undefined"}function w(ae){return ae.length===0?!0:!!m(ae[0])}e.isDecorationOptionsArr=w;var S;(function(ae){function Ee(Xe){return Xe.map(ae.from)}ae.fromMany=Ee;function ce(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let at;if(ce(Xe)){const{language:gt,value:ft}=Xe;at={value:"```"+gt+`
`+ft+"\n```\n"}}else E.MarkdownString.isMarkdownString(Xe)?at={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons}:typeof Xe=="string"?at={value:Xe}:at={value:""};const wt=Object.create(null);at.uris=wt;const _t=gt=>{try{let ft=P.URI.parse(gt,!0);ft=ft.with({query:Te(ft.query,wt)}),wt[gt]=ft}catch(ft){}return""},ht=new C.Renderer;return ht.link=_t,ht.image=gt=>_t(I.parseHrefAndDimensions(gt).href),C(at.value,{renderer:ht}),at}ae.from=q;function Te(Xe,at){if(!Xe)return Xe;let wt;try{wt=(0,T.parse)(Xe)}catch(ht){}if(!wt)return Xe;let _t=!1;return wt=(0,D.cloneAndChange)(wt,ht=>{if(P.URI.isUri(ht)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[gt]=ht,_t=!0,gt}else return}),_t?JSON.stringify(wt):Xe}function Pe(Xe){const at=new E.MarkdownString(Xe.value,Xe.supportThemeIcons);return at.isTrusted=Xe.isTrusted,at}ae.to=Pe;function Ye(Xe){if(!!Xe)return typeof Xe=="string"?Xe:ae.from(Xe)}ae.fromStrict=Ye})(S=e.MarkdownString||(e.MarkdownString={}));function s(ae){return w(ae)?ae.map(Ee=>({range:l.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?S.fromMany(Ee.hoverMessage):Ee.hoverMessage?S.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ae.map(Ee=>({range:l.from(Ee)}))}e.fromRangeOrRangeWithMessage=s;function b(ae){return typeof ae=="undefined"?ae:typeof ae=="string"?P.URI.file(ae):ae}e.pathOrURIToURI=b;var R;(function(ae){function Ee(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?b(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ae.from=Ee})(R=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(ae){function Ee(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?b(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?R.from(ce.before):void 0,after:ce.after?R.from(ce.after):void 0}}ae.from=Ee})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var $;(function(ae){function Ee(ce){if(typeof ce=="undefined")return ce;switch(ce){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}ae.from=Ee})($=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(ae){function Ee(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?$.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?O.from(ce.light):void 0,dark:ce.dark?O.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?b(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?R.from(ce.before):void 0,after:ce.after?R.from(ce.after):void 0}}ae.from=Ee})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Z;(function(ae){function Ee(q){return{text:q.newText,eol:q.newEol&&te.from(q.newEol),range:l.from(q.range)}}ae.from=Ee;function ce(q){const Te=new E.TextEdit(l.to(q.range),q.text);return Te.newEol=typeof q.eol=="undefined"?void 0:te.to(q.eol),Te}ae.to=ce})(Z=e.TextEdit||(e.TextEdit={}));var U;(function(ae){function Ee(q,Te,Pe){const Ye={edits:[]};if(q instanceof E.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)Ye.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const at=Te?.getDocument(Xe.uri);Ye.edits.push({_type:2,resource:Xe.uri,edit:Z.from(Xe.edit),modelVersionId:at?.version,metadata:Xe.metadata})}else Xe._type===3?Ye.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ye.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Ge.from)}});return Ye}ae.from=Ee;function ce(q){const Te=new E.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Te.replace(P.URI.revive(Pe.resource),l.to(Pe.edit.range),Pe.edit.text):Te.renameFile(P.URI.revive(Pe.oldUri),P.URI.revive(Pe.newUri),Pe.options);return Te}ae.to=ce})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var x;(function(ae){const Ee=Object.create(null);Ee[E.SymbolKind.File]=0,Ee[E.SymbolKind.Module]=1,Ee[E.SymbolKind.Namespace]=2,Ee[E.SymbolKind.Package]=3,Ee[E.SymbolKind.Class]=4,Ee[E.SymbolKind.Method]=5,Ee[E.SymbolKind.Property]=6,Ee[E.SymbolKind.Field]=7,Ee[E.SymbolKind.Constructor]=8,Ee[E.SymbolKind.Enum]=9,Ee[E.SymbolKind.Interface]=10,Ee[E.SymbolKind.Function]=11,Ee[E.SymbolKind.Variable]=12,Ee[E.SymbolKind.Constant]=13,Ee[E.SymbolKind.String]=14,Ee[E.SymbolKind.Number]=15,Ee[E.SymbolKind.Boolean]=16,Ee[E.SymbolKind.Array]=17,Ee[E.SymbolKind.Object]=18,Ee[E.SymbolKind.Key]=19,Ee[E.SymbolKind.Null]=20,Ee[E.SymbolKind.EnumMember]=21,Ee[E.SymbolKind.Struct]=22,Ee[E.SymbolKind.Event]=23,Ee[E.SymbolKind.Operator]=24,Ee[E.SymbolKind.TypeParameter]=25;function ce(Te){return typeof Ee[Te]=="number"?Ee[Te]:6}ae.from=ce;function q(Te){for(const Pe in Ee)if(Ee[Pe]===Te)return Number(Pe);return E.SymbolKind.Property}ae.to=q})(x=e.SymbolKind||(e.SymbolKind={}));var M;(function(ae){function Ee(q){switch(q){case E.SymbolTag.Deprecated:return 1}}ae.from=Ee;function ce(q){switch(q){case 1:return E.SymbolTag.Deprecated}}ae.to=ce})(M=e.SymbolTag||(e.SymbolTag={}));var H;(function(ae){function Ee(q){return{name:q.name,kind:x.from(q.kind),tags:q.tags&&q.tags.map(M.from),containerName:q.containerName,location:Q.from(q.location)}}ae.from=Ee;function ce(q){const Te=new E.SymbolInformation(q.name,x.to(q.kind),q.containerName,Q.to(q.location));return Te.tags=q.tags&&q.tags.map(M.to),Te}ae.to=ce})(H=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var F;(function(ae){function Ee(q){const Te={name:q.name||"!!MISSING: name!!",detail:q.detail,range:l.from(q.range),selectionRange:l.from(q.selectionRange),kind:x.from(q.kind),tags:q.tags?.map(M.from)??[]};return q.children&&(Te.children=q.children.map(Ee)),Te}ae.from=Ee;function ce(q){const Te=new E.DocumentSymbol(q.name,q.detail,x.to(q.kind),l.to(q.range),l.to(q.selectionRange));return(0,g.isNonEmptyArray)(q.tags)&&(Te.tags=q.tags.map(M.to)),q.children&&(Te.children=q.children.map(ce)),Te}ae.to=ce})(F=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(ae){function Ee(q){const Te=new E.CallHierarchyItem(x.to(q.kind),q.name,q.detail||"",P.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return Te._sessionId=q._sessionId,Te._itemId=q._itemId,Te}ae.to=Ee;function ce(q,Te,Pe){if(Te=Te??q._sessionId,Pe=Pe??q._itemId,Te===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Pe,name:q.name,detail:q.detail,kind:x.from(q.kind),uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(M.from)}}ae.from=ce})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(ae){function Ee(ce){return new E.CallHierarchyIncomingCall(N.to(ce.from),ce.fromRanges.map(q=>l.to(q)))}ae.to=Ee})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var W;(function(ae){function Ee(ce){return new E.CallHierarchyOutgoingCall(N.to(ce.to),ce.fromRanges.map(q=>l.to(q)))}ae.to=Ee})(W=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ae){function Ee(q){return{range:q.range&&l.from(q.range),uri:q.uri}}ae.from=Ee;function ce(q){return new E.Location(P.URI.revive(q.uri),l.to(q.range))}ae.to=ce})(Q=e.location||(e.location={}));var J;(function(ae){function Ee(q){const Te=q,Pe=q;return{originSelectionRange:Te.originSelectionRange?l.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Pe.uri,range:l.from(Te.targetRange?Te.targetRange:Pe.range),targetSelectionRange:Te.targetSelectionRange?l.from(Te.targetSelectionRange):void 0}}ae.from=Ee;function ce(q){return{targetUri:P.URI.revive(q.uri),targetRange:l.to(q.range),targetSelectionRange:q.targetSelectionRange?l.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?l.to(q.originSelectionRange):void 0}}ae.to=ce})(J=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(ae){function Ee(q){return{range:l.from(q.range),contents:S.fromMany(q.contents)}}ae.from=Ee;function ce(q){return new E.Hover(q.contents.map(S.to),l.to(q.range))}ae.to=ce})(fe=e.Hover||(e.Hover={}));var _e;(function(ae){function Ee(q){return{range:l.from(q.range),expression:q.expression}}ae.from=Ee;function ce(q){return new E.EvaluatableExpression(l.to(q.range),q.expression)}ae.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(ae){function Ee(q){if(q instanceof E.InlineValueText)return{type:"text",range:l.from(q.range),text:q.text};if(q instanceof E.InlineValueVariableLookup)return{type:"variable",range:l.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ae.from=Ee;function ce(q){switch(q.type){case"text":return{range:l.to(q.range),text:q.text};case"variable":return{range:l.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:l.to(q.range),expression:q.expression}}}ae.to=ce})(ye=e.InlineValue||(e.InlineValue={}));var Le;(function(ae){function Ee(q){return{frameId:q.frameId,stoppedLocation:l.from(q.stoppedLocation)}}ae.from=Ee;function ce(q){return new E.InlineValueContext(q.frameId,l.to(q.stoppedLocation))}ae.to=ce})(Le=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(ae){function Ee(q){return{range:l.from(q.range),kind:q.kind}}ae.from=Ee;function ce(q){return new E.DocumentHighlight(l.to(q.range),q.kind)}ae.to=ce})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(ae){function Ee(ce){switch(ce){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}ae.to=Ee})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(ae){function Ee(ce){return{triggerKind:xe.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ae.to=Ee})(Ke=e.CompletionContext||(e.CompletionContext={}));var z;(function(ae){function Ee(q){switch(q){case E.CompletionItemTag.Deprecated:return 1}}ae.from=Ee;function ce(q){switch(q){case 1:return E.CompletionItemTag.Deprecated}}ae.to=ce})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(ae){const Ee=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ce(Pe){return Ee.get(Pe)??9}ae.from=ce;const q=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Te(Pe){return q.get(Pe)??E.CompletionItemKind.Property}ae.to=Te})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(ae){function Ee(ce,q){const Te=new E.CompletionItem(ce.label);return Te.insertText=ce.insertText,Te.kind=ee.to(ce.kind),Te.tags=ce.tags?.map(z.to),Te.detail=ce.detail,Te.documentation=I.isMarkdownString(ce.documentation)?S.to(ce.documentation):ce.documentation,Te.sortText=ce.sortText,Te.filterText=ce.filterText,Te.preselect=ce.preselect,Te.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Te.range=l.to(ce.range):typeof ce.range=="object"&&(Te.range={inserting:l.to(ce.range.insert),replacing:l.to(ce.range.replace)}),Te.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Te.insertText=new E.SnippetString(ce.insertText):(Te.insertText=ce.insertText,Te.textEdit=Te.range instanceof E.Range?new E.TextEdit(Te.range,Te.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=ce.additionalTextEdits.map(Pe=>Z.to(Pe))),Te.command=q&&ce.command?q.fromInternal(ce.command):void 0,Te}ae.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var le;(function(ae){function Ee(q){return{label:q.label,documentation:q.documentation?S.fromStrict(q.documentation):void 0}}ae.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?S.to(q.documentation):q.documentation}}ae.to=ce})(le=e.ParameterInformation||(e.ParameterInformation={}));var X;(function(ae){function Ee(q){return{label:q.label,documentation:q.documentation?S.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(le.from):[],activeParameter:q.activeParameter}}ae.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?S.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(le.to):[],activeParameter:q.activeParameter}}ae.to=ce})(X=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(ae){function Ee(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(X.from):[]}}ae.from=Ee;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(X.to):[]}}ae.to=ce})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(ae){function Ee(q){return{text:q.text,position:t.from(q.position),kind:Me.from(q.kind??E.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}ae.from=Ee;function ce(q){const Te=new E.InlayHint(q.text,t.to(q.position),Me.to(q.kind));return Te.whitespaceAfter=q.whitespaceAfter,Te.whitespaceBefore=q.whitespaceBefore,Te}ae.to=ce})(ve=e.InlayHint||(e.InlayHint={}));var Me;(function(ae){function Ee(q){return q}ae.from=Ee;function ce(q){return q}ae.to=ce})(Me=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(ae){function Ee(q){return{range:l.from(q.range),url:q.target,tooltip:q.tooltip}}ae.from=Ee;function ce(q){let Te;if(q.url)try{Te=typeof q.url=="string"?P.URI.parse(q.url,!0):P.URI.revive(q.url)}catch(Pe){}return new E.DocumentLink(l.to(q.range),Te)}ae.to=ce})(ze=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ae){function Ee(q){const Te=new E.ColorPresentation(q.label);return q.textEdit&&(Te.textEdit=Z.to(q.textEdit)),q.additionalTextEdits&&(Te.additionalTextEdits=q.additionalTextEdits.map(Pe=>Z.to(Pe))),Te}ae.to=Ee;function ce(q){return{label:q.label,textEdit:q.textEdit?Z.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Te=>Z.from(Te)):void 0}}ae.from=ce})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ae){function Ee(q){return new E.Color(q[0],q[1],q[2],q[3])}ae.to=Ee;function ce(q){return[q.red,q.green,q.blue,q.alpha]}ae.from=ce})(et=e.Color||(e.Color={}));var ke;(function(ae){function Ee(q){return{range:l.from(q.range)}}ae.from=Ee;function ce(q){return new E.SelectionRange(l.to(q.range))}ae.to=ce})(ke=e.SelectionRange||(e.SelectionRange={}));var ct;(function(ae){function Ee(ce){switch(ce){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}ae.to=Ee})(ct=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var K;(function(ae){function Ee(q){switch(q){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}ae.from=Ee;function ce(q){switch(q){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}ae.to=ce})(K=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ae){function Ee(q){if(q===E.EndOfLine.CRLF)return 1;if(q===E.EndOfLine.LF)return 0}ae.from=Ee;function ce(q){if(q===1)return E.EndOfLine.CRLF;if(q===0)return E.EndOfLine.LF}ae.to=ce})(te=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ae){function Ee(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ae.from=Ee})(pe=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(ae){function Ee(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=tt.from(ce.kind)),q}ae.from=Ee})(Ve=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ae){function Ee(ce){if(ce)switch(ce){case E.FoldingRangeKind.Comment:return k.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return k.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return k.FoldingRangeKind.Region}}ae.from=Ee})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var st;(function(ae){function Ee(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?l.from(ce.selection):void 0,override:typeof ce.override=="boolean"?d.EditorResolution.DISABLED:void 0}}ae.from=Ee})(st=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var lt;(function(ae){function Ee(q){return q instanceof E.RelativePattern||typeof q=="string"?q:ce(q)?new E.RelativePattern(q.base,q.pattern):q}ae.from=Ee;function ce(q){const Te=q;return Te&&typeof Te.base=="string"&&typeof Te.pattern=="string"}})(lt=e.GlobPattern||(e.GlobPattern={}));var vt;(function(ae){function Ee(ce){if(ce){if(Array.isArray(ce))return ce.map(Ee);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:lt.from(q.pattern),exclusive:q.exclusive}}}else return}ae.from=Ee})(vt=e.LanguageSelector||(e.LanguageSelector={}));var Dt;(function(ae){function Ee(q){return{start:q.start,end:q.end}}ae.from=Ee;function ce(q){return new E.NotebookRange(q.start,q.end)}ae.to=ce})(Dt=e.NotebookRange||(e.NotebookRange={}));var ue;(function(ae){function Ee(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ae.to=Ee;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}ae.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(ae){function Ee(q){switch(q){case E.NotebookCellKind.Markup:return p.CellKind.Markup;case E.NotebookCellKind.Code:default:return p.CellKind.Code}}ae.from=Ee;function ce(q){switch(q){case p.CellKind.Markup:return E.NotebookCellKind.Markup;case p.CellKind.Code:default:return E.NotebookCellKind.Code}}ae.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Ne;(function(ae){function Ee(q){const Te={metadata:q.metadata??Object.create(null),cells:[]};for(let Pe of q.cells)E.NotebookCellData.validate(Pe),Te.cells.push(Ge.from(Pe));return Te}ae.from=Ee;function ce(q){const Te=new E.NotebookData(q.cells.map(Ge.to));return(0,y.isEmptyObject)(q.metadata)||(Te.metadata=q.metadata),Te}ae.to=ce})(Ne=e.NotebookData||(e.NotebookData={}));var Ge;(function(ae){function Ee(q){return{cellKind:Ie.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ue.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(ot.from):[]}}ae.from=Ee;function ce(q){return new E.NotebookCellData(Ie.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(ot.to):void 0,q.metadata,q.internalMetadata?ue.to(q.internalMetadata):void 0)}ae.to=ce})(Ge=e.NotebookCellData||(e.NotebookCellData={}));var We;(function(ae){function Ee(q){return{mime:q.mime,valueBytes:L.VSBuffer.wrap(q.data)}}ae.from=Ee;function ce(q){return new E.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}ae.to=ce})(We=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ot;(function(ae){function Ee(q){return{outputId:q.id,items:q.items.map(We.from),metadata:q.metadata}}ae.from=Ee;function ce(q){const Te=q.items.map(We.to);return new E.NotebookCellOutput(Te,q.outputId,q.metadata)}ae.to=ce})(ot=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Re;(function(ae){function Ee(Pe){if(Pe!=null){if(Pe instanceof E.RelativePattern||typeof Pe=="string")return Pe;if(Te(Pe))return new E.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:lt.from(Pe.include)||void 0,exclude:lt.from(Pe.exclude)||void 0}}}ae.from=Ee;function ce(Pe){return typeof Pe=="string"?Pe:Te(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ae.to=ce;function q(Pe){const Ye=Pe,Xe=lt.from(Ye.include);if(!(Xe&&Xe instanceof E.RelativePattern||typeof Xe=="string"))return!1;const at=lt.from(Ye.exclude);return!!(at&&at instanceof E.RelativePattern||typeof at=="string")}function Te(Pe){const Ye=Pe;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Re=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Se;(function(ae){function Ee(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?R.from(ce.top):void 0}}ae.from=Ee})(Se=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ce;(function(ae){function Ee(ce,q,Te){const Pe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Te),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}ae.from=Ee})(Ce=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(ae){function Ee(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}ae.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(ae){function Ee(q){return{uri:q.uri,provides:q.provides}}ae.from=Ee;function ce(q){return new E.NotebookRendererScript(P.URI.revive(q.uri),q.provides)}ae.to=ce})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(ae){function Ee(q){return{message:S.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?Q.from(q.location):void 0}}ae.from=Ee;function ce(q){const Te=new E.TestMessage(typeof q.message=="string"?q.message:S.to(q.message));return Te.actualOutput=q.actual,Te.expectedOutput=q.expected,Te}ae.to=ce})(be=e.TestMessage||(e.TestMessage={}));var we;(function(ae){let Ee;(function(ce){ce.Delimiter="\0"})(Ee||(Ee={})),ae.namespace=(ce,q)=>ce+"\0"+q,ae.denamespace=ce=>{const q=ce.indexOf("\0");return{ctrlId:ce.slice(0,q),tagId:ce.slice(q+1)}}})(we=e.TestTag||(e.TestTag={}));var Fe;(function(ae){function Ee(Pe){const Ye=(0,u.getPrivateApiFor)(Pe).controllerId;return{extId:_.TestId.fromExtHostTestItem(Pe,Ye).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Xe=>we.namespace(Ye,Xe.id)),range:l.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&S.fromStrict(Pe.error)||null}}ae.from=Ee;function ce(Pe){return{id:_.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:P.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ye=>{const{tagId:Xe}=we.denamespace(Ye);return new E.TestTag(Xe,Xe)}),range:l.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}ae.toPlain=ce;function q(Pe){const Ye=_.TestId.fromString(Pe.extId),Xe=new u.TestItemImpl(Ye.controllerId,Ye.localId,Pe.label,P.URI.revive(Pe.uri));return Xe.range=l.to(Pe.range||void 0),Xe.description=Pe.description||void 0,Xe}function Te(Pe){let Ye;for(const Xe of Pe.tests){const at=q(Xe.item);(0,u.getPrivateApiFor)(at).parent=Ye,Ye=at}return Ye}ae.toItemFromContext=Te})(Fe=e.TestItem||(e.TestItem={})),function(ae){function Ee(q){return{id:q.id,label:q.label}}ae.from=Ee;function ce(q){return new E.TestTag(q.id,q.label)}ae.to=ce}(we=e.TestTag||(e.TestTag={}));var qe;(function(ae){const Ee=(q,Te)=>{const Pe={...Fe.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:q.children.map(Ye=>Te.get(Ye)).filter(y.isDefined).map(Ye=>Ee(Ye,Te))};for(const Ye of Pe.children)Ye.parent=Pe;return Pe};function ce(q){const Te=[],Pe=new Map;for(const Ye of q.items)Pe.set(Ye.item.extId,Ye),q.request.targets.some(Xe=>Xe.controllerId===Ye.controllerId&&Xe.testIds.includes(Ye.item.extId))&&Te.push(Ye);return{completedAt:q.completedAt,results:Te.map(Ye=>Ee(Ye,Pe))}}ae.to=ce})(qe=e.TestResults||(e.TestResults={}));var He;(function(ae){function Ee(Pe){return{covered:Pe.covered,total:Pe.covered}}function ce(Pe){return"line"in Pe?t.from(Pe):l.from(Pe)}function q(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ce(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&ce(Ye.location)})):void 0}:{type:0,count:Pe.executionCount,location:ce(Pe.location)}}ae.fromDetailed=q;function Te(Pe){return{uri:Pe.uri,statement:Ee(Pe.statementCoverage),branch:Pe.branchCoverage&&Ee(Pe.branchCoverage),function:Pe.functionCoverage&&Ee(Pe.functionCoverage),details:Pe.detailedCoverage?.map(q)}}ae.fromFile=Te})(He=e.TestCoverage||(e.TestCoverage={}));var Je;(function(ae){function Ee(ce){switch(ce){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}ae.to=Ee})(Je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var nt;(function(ae){function Ee(q){const Te=new E.TypeHierarchyItem(x.to(q.kind),q.name,q.detail||"",P.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return Te._sessionId=q._sessionId,Te._itemId=q._itemId,Te}ae.to=Ee;function ce(q,Te,Pe){if(Te=Te??q._sessionId,Pe=Pe??q._itemId,Te===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Pe,kind:x.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(M.from)}}ae.from=ce})(nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[217],ge([0,1,2,16,7,15,95]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(P,n,k,d={timeout:1500,errors:3}){this._logService=P,this._documents=n,this._mainThreadBulkEdits=k,this._thresholds=d,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(n,k,d)=>{const u={dispose:this._callbacks.push([n,k,P])};return Array.isArray(d)&&d.push(u),u}}async $participateInSave(P,n){const k=g.URI.revive(P);let d=!1;const f=setTimeout(()=>d=!0,this._thresholds.timeout),u=[];try{for(let p of[...this._callbacks]){if(d)break;const _=this._documents.getDocument(k),A=await this._deliverEventAsyncAndBlameBadListeners(p,{document:_,reason:C.TextDocumentSaveReason.to(n)});u.push(A)}}finally{clearTimeout(f)}return u}_deliverEventAsyncAndBlameBadListeners([P,n,k],d){const f=this._badListeners.get(P);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,P,n,d).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const p=this._badListeners.get(P);this._badListeners.set(P,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,n,k,d){const f=[],u=Date.now(),{document:p,reason:_}=d,{version:A}=p,E=Object.freeze({document:p,reason:_,waitUntil(a){if(Object.isFrozen(f))throw(0,L.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(a))}});try{n.apply(k,[E])}catch(a){return Promise.reject(a)}return Object.freeze(f),new Promise((a,l)=>{const v=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(v),a(t)}).catch(t=>{clearTimeout(v),l(t)})}).then(a=>{const l={edits:[]};for(const v of a)if(Array.isArray(v)&&v.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:r,range:o}of v)l.edits.push({_type:2,resource:p.uri,edit:{range:o&&C.Range.from(o),text:t,eol:r&&C.EndOfLine.from(r)}});if(l.edits.length!==0)return A===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(me[218],ge([0,1,3,30,2,15,7]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(n,k,d,f,u){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,d&&(this._config+=1),f&&(this._config+=2),u&&(this._config+=4);const p=(0,L.parse)(k),_=n(A=>{if(!d)for(let E of A.created){const a=I.URI.revive(E);p(a.fsPath)&&this._onDidCreate.fire(a)}if(!f)for(let E of A.changed){const a=I.URI.revive(E);p(a.fsPath)&&this._onDidChange.fire(a)}if(!u)for(let E of A.deleted){const a=I.URI.revive(E);p(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(n,k,d){this._logService=k,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,k,d,f){return new D(this._onFileSystemEvent.event,n,k,d,f)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,k){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:k.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:k.map(d=>I.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:k.map(d=>I.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,k){return(d,f,u)=>{const p=function(A){d.call(f,A)};return p.extension=n,k.event(p,void 0,u)}}async $onWillRunFileOperation(n,k,d,f){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:k.map(u=>({oldUri:I.URI.revive(u.source),newUri:I.URI.revive(u.target)}))},d,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:k.map(u=>I.URI.revive(u.target))},d,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:k.map(u=>I.URI.revive(u.target))},d,f)}}async _fireWillEvent(n,k,d,f){const u=new Set,p=[];if(await n.fireAsync(k,f,async(A,E)=>{const a=Date.now(),l=await Promise.resolve(A);l instanceof T.WorkspaceEdit&&(p.push(l),u.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-a>d&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||p.length===0)return;const _={edits:[]};for(let A of p){let{edits:E}=C.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(E)}return{edit:_,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=y}),define(me[219],ge([0,1,10,23,2,15,7,127]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(d,f,u,p){this.start=d,this.deletedCount=f,this.deletedItems=u,this.items=p}static asApiEvents(d){return d.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(u=>u.apiCell)}))}}class P{constructor(d,f,u){this.notebook=d,this._extHostDocument=f,this._cellData=u,this.handle=u.handle,this.uri=I.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(d,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return d._mime},set mime(u){d._mime=u},get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(C.NotebookCellOutput.to)}setOutputItems(d,f,u){const p=u.map(C.NotebookCellOutputItem.to),_=this._outputs.find(A=>A.id===d);_&&(f||(_.items.length=0),_.items.push(...p))}setMetadata(d){this._metadata=Object.freeze(d)}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(d))}setMime(d){}}e.ExtHostCell=P;class n{constructor(d,f,u,p,_,A){this._proxy=d,this._textDocumentsAndEditors=f,this._textDocuments=u,this._emitter=p,this.uri=_,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=A.viewType,this._metadata=Object.freeze(A.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,A.cells]],!0),this._versionId=A.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get notebookType(){return d._notebookType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===g.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(f){return f=d._validateIndex(f),d._cells[f].apiCell},getCells(f){return(f?d._getCells(f):d._cells).map(p=>p.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=Object.freeze({...this._metadata,...d.metadata}))}acceptDirty(d){this._isDirty=d}acceptModelChanged(d,f){this._versionId=d.versionId,this._isDirty=f;for(const u of d.rawEvents)u.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===D.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let f=d.start|0,u=d.end|0;return f<0&&(f=0),u>this._cells.length&&(u=this._cells.length),d.with({start:f,end:u})}_getCells(d){d=this._validateRange(d);const f=[];for(let u=d.start;u<d.end;u++)f.push(this._cells[u]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,f){if(this._disposed)return;const u=[],p=[],_=[];d.reverse().forEach(A=>{const a=A[2].map(t=>{const r=new P(this,this._textDocumentsAndEditors,t);return f||p.push(P.asModelAddData(this.apiNotebook,t)),r}),l=new y(A[0],A[1],[],a),v=this._cells.splice(A[0],A[1],...a);for(const t of v)_.push(t.uri),l.deletedItems.push(t.apiCell);u.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:_}),f||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(u)}))}_moveCell(d,f){const u=this._cells.splice(d,1);this._cells.splice(f,0,...u);const p=[new y(d,1,u.map(_=>_.apiCell),[]),new y(f,0,[],u)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(p)}))}_setCellOutputs(d,f){const u=this._cells[d];u.setOutputs(f),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(d,f,u,p){const _=this._cells[d];_.setOutputItems(f,u,p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(d,f){const u=this._cells[d];u.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(u.uri,f)}_changeCellMime(d,f){const u=this._cells[d];u.apiCell.mime=f}_changeCellMetadata(d,f){const u=this._cells[d],p=u.apiCell.metadata;u.setMetadata(f);const _=u.apiCell.metadata;(0,L.equals)(p,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(d,f){const u=this._cells[d],p=u.internalMetadata;if(u.setInternalMetadata(f),p.runState!==f.runState){const _=f.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:_}))}}getCellFromApiCell(d){return this._cells.find(f=>f.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(f=>f.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[130],ge([0,1,7,15,16]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:P})}replaceCells(y,P,n){this._throwIfFinalized(),!(y===P&&n.length===0)&&this._collectedEdits.push({editType:1,index:y,count:P-y,cells:n.map(L.NotebookCellData.from)})}}class T{constructor(y,P,n,k,d,f){this.id=y,this._proxy=P,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._visibleRanges=k,this._viewColumn=f}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(P){if(!Array.isArray(P)||!P.every(g.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");y._selections=P,y._trySetSelections(P)},get visibleRanges(){return y._visibleRanges},revealRange(P,n){y._proxy.$tryRevealRange(y.id,L.NotebookRange.from(P),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(P){const n=new C(this.document.version);return P(n),y._applyEdit(n.finalize())},setDecorations(P,n){return y.setDecorations(P,n)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(L.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const P=[];let n=-1;for(let k=0;k<y.cellEdits.length;k++){if(n<0){P.push(y.cellEdits[k]),n++;continue}const f=P[n],u=y.cellEdits[k];if(f.editType===1&&u.editType===1&&f.index===u.index){f.cells.push(...y.cellEdits[k].cells),f.count+=y.cellEdits[k].count;continue}P.push(y.cellEdits[k]),n++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,P)}setDecorations(y,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return P.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(P),y.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(me[220],ge([0,1,15,119,166,21,56]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,d,f){const u=this._handles++,{title:p,location:_,cancellable:A}=d,E={label:(0,I.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(u,{location:g.ProgressLocation.from(_),title:p,source:E,cancellable:A},k),this._withProgress(u,f,!!A)}_withProgress(k,d,f){let u;f&&(u=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,u));const p=A=>{this._proxy.$progressEnd(A),this._mapHandleToCancellationSource.delete(A),u&&u.dispose()};let _;try{_=d(new P(this._proxy,k),f&&u?u.token:C.CancellationToken.None)}catch(A){throw p(k),A}return _.then(A=>p(k),A=>p(k)),_}$acceptProgressCanceled(k){const d=this._mapHandleToCancellationSource.get(k);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=D;function y(n,k){return n.message=k.message,typeof k.increment=="number"&&(typeof n.increment=="number"?n.increment+=k.increment:n.increment=k.increment),n}class P extends L.Progress{constructor(k,d){super(f=>this.throttledReport(f));this._proxy=k,this._handle=d}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,T.throttle)(100,(n,k)=>y(n,k),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(me[131],ge([0,1,54,16,75,15,7]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(d,f,u){const p=D._Keys.nextId();d.$registerTextEditorDecorationType(f.identifier,p,C.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:p,dispose(){d.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=D,D._Keys=new I.IdGenerator("TextEditorDecorationType");class y{constructor(d,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,f){this._throwIfFinalized();let u=null;if(d instanceof T.Position)u=new T.Range(d,d);else if(d instanceof T.Range)u=d;else throw new Error("Unrecognized location");this._pushEdit(u,f,!1)}insert(d,f){this._throwIfFinalized(),this._pushEdit(new T.Range(d,d),f,!0)}delete(d){this._throwIfFinalized();let f=null;if(d instanceof T.Range)f=d;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(d,f,u){const p=this._document.validateRange(d);this._collectedEdits.push({range:p,text:f,forceMoveMarkers:u})}setEndOfLine(d){if(this._throwIfFinalized(),d!==T.EndOfLine.LF&&d!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=y;class P{constructor(d,f,u,p){this._proxy=d,this._id=f,this._accept(u),this._logService=p;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(A){_._setTabSize(A)},get insertSpaces(){return _._insertSpaces},set insertSpaces(A){_._setInsertSpaces(A)},get cursorStyle(){return _._cursorStyle},set cursorStyle(A){_._setCursorStyle(A)},get lineNumbers(){return _._lineNumbers},set lineNumbers(A){_._setLineNumbers(A)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const f=Math.floor(d);return f>0?f:null}if(typeof d=="string"){const f=parseInt(d,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(d){const f=this._validateTabSize(d);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const f=this._validateInsertSpaces(d);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(d)})))}assign(d){const f={};let u=!1;if(typeof d.tabSize!="undefined"){const p=this._validateTabSize(d.tabSize);p==="auto"?(u=!0,f.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,u=!0,f.tabSize=p)}if(typeof d.insertSpaces!="undefined"){const p=this._validateInsertSpaces(d.insertSpaces);p==="auto"?(u=!0,f.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,u=!0,f.insertSpaces=p)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,u=!0,f.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,u=!0,f.lineNumbers=C.TextEditorLineNumbersStyle.from(d.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(d){d.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=P;class n{constructor(d,f,u,p,_,A,E,a){this.id=d,this._proxy=f,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new P(this._proxy,this.id,A,u),this._visibleRanges=E,this._viewColumn=a;const l=this;this.value=Object.freeze({get document(){return p.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(v){if(!(v instanceof T.Selection))throw(0,L.illegalArgument)("selection");l._selections=[v],l._trySetSelection()},get selections(){return l._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof T.Selection)))throw(0,L.illegalArgument)("selections");l._selections=v,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return l._options.value},set options(v){l._disposed||l._options.assign(v)},get viewColumn(){return l._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(p.getValue(),t);return v(r),l._applyEdit(r)},insertSnippet(v,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=l._selections.map(i=>C.Range.from(i));else if(t instanceof T.Position){const{lineNumber:i,column:c}=C.Position.from(t);o=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof T.Range)o=[C.Range.from(t)];else{o=[];for(const i of t)if(i instanceof T.Range)o.push(C.Range.from(i));else{const{lineNumber:c,column:h}=C.Position.from(i);o.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return f.$tryInsertSnippet(d,v.value,o,r)},setDecorations(v,t){const r=t.length===0;r&&!l._hasDecorationsForKey.has(v.key)||(r?l._hasDecorationsForKey.delete(v.key):l._hasDecorationsForKey.add(v.key),l._runOnProxy(()=>{if(C.isDecorationOptionsArr(t))return f.$trySetDecorations(d,v.key,C.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const h=t[i];o[4*i]=h.start.line+1,o[4*i+1]=h.start.character+1,o[4*i+2]=h.end.line+1,o[4*i+3]=h.end.character+1}return f.$trySetDecorationsFast(d,v.key,o)}}))},revealRange(v,t){l._runOnProxy(()=>f.$tryRevealRange(d,C.Range.from(v),t||T.TextEditorRevealType.Default))},show(v){f.$tryShowEditor(d,C.ViewColumn.from(v))},hide(){f.$tryHideEditor(d)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,g.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,g.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,g.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,g.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const f=d.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const u=f.edits.map(_=>_.range);u.sort((_,A)=>_.end.line===A.end.line?_.end.character===A.end.character?_.start.line===A.start.line?_.start.character-A.start.character:_.start.line-A.start.line:_.end.character-A.end.character:_.end.line-A.end.line);for(let _=0,A=u.length-1;_<A;_++){const E=u[_].end;if(u[_+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=f.edits.map(_=>({range:C.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,p,{setEndOfLine:typeof f.setEndOfLine=="number"?C.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(me[221],ge([0,1,169,25,2,3,6,208,17,7,13,20,15,21,205]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(E,a){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let l;return Array.isArray(E.highlights)&&(l=E.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),l=l.length?l:void 0),{label:E.label,highlights:l}}}class _{constructor(a,l,v){this._proxy=a,this.commands=l,this.logService=v,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}l.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(o=>t(o)?this.convertArgument(o):o):r})}registerTreeDataProvider(a,l,v){const t=this.createTreeView(a,{treeDataProvider:l},v);return{dispose:()=>t.dispose()}}createTreeView(a,l,v){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=l.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,canDragAndDrop:t}),o=this.createExtHostTreeView(a,l,v);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(i){o.message=i},get title(){return o.title},set title(i){o.title=i},get description(){return o.description},set description(i){o.description=i},reveal:(i,c)=>o.reveal(i,c),dispose:async()=>{await r,this.treeViews.delete(a),o.dispose()}}}$getChildren(a,l){const v=this.treeViews.get(a);return v?v.getChildren(l):Promise.reject(new Error((0,g.localize)(0,null,a)))}async $onDrop(a,l,v){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,a)));const r=u.TreeDataTransferConverter.toITreeDataTransfer(l);if(r.items.has(D.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(D.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>t.getExtensionElement(c)).filter(c=>!!c);i.length>0?r.items.set(D.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(D.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,v)}async $hasResolve(a){const l=this.treeViews.get(a);if(!l)throw new Error((0,g.localize)(2,null,a));return l.hasResolve}$resolve(a,l,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(3,null,a));return t.resolveTreeItem(l,v)}$setExpanded(a,l,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(4,null,a));t.setExpanded(l,v)}$setSelection(a,l){const v=this.treeViews.get(a);if(!v)throw new Error((0,g.localize)(5,null,a));v.setSelection(l)}$setVisible(a,l){const v=this.treeViews.get(a);if(!v)throw new Error((0,g.localize)(6,null,a));v.setVisible(l)}createExtHostTreeView(a,l,v){const t=new A(a,l,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(a,t),t}convertArgument(a){const l=this.treeViews.get(a.$treeViewId);return l?l.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=_;class A extends T.Disposable{constructor(a,l,v,t,r,o){super();if(this.viewId=a,this.proxy=v,this.commands=t,this.logService=r,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,o.contributes&&o.contributes.views)for(const h in o.contributes.views)for(const m of o.contributes.views[h])m.id===a&&(this._title=m.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let i,c;this._register(C.Event.debounce(this._onDidChangeData.event,(h,m)=>(h||(h={message:!1,elements:[]}),m.element!==!1&&(i||(i=new Promise(w=>c=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(m.element)?h.elements.push(...m.element):h.elements.push(m.element)),m.message&&(h.message=!0),h),200,!0)(({message:h,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=c;return i=null,this.refresh(m).then(()=>w())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}async getChildren(a){const l=a?this.getExtensionElement(a):void 0;if(a&&!l)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(a);return v||(v=await this.fetchChildrenNodes(l)),v?v.map(t=>t.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,l){l=l||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(l.select)?!0:l.select,t=(0,n.isUndefinedOrNull)(l.focus)?!1:l.focus,r=(0,n.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(o=>this.resolveTreeNode(a,o[o.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:o.map(c=>c.item)},{select:v,focus:t,expand:r})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,l){const v=this.getExtensionElement(a);v&&(l?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(a){(0,k.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,l){const v=this.getExtensionElement(l);if(!!v)return(0,y.asPromise)(()=>this.dndController?.onDrop(a,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,l){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(a);if(v){const t=this.nodes.get(v);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,v,l)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(l=>l?this.resolveUnknownParentChain(l).then(v=>this.resolveTreeNode(l,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(a){const l=this.nodes.get(a);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,l){const v=this.nodes.get(a);return v?Promise.resolve(v):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,l,!0)).then(t=>this.getChildren(l?l.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const o=this.nodes.get(r);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let l;if(typeof a=="string"){const v=this.getExtensionElement(a);l=v?this.nodes.get(v):void 0}else l=a;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const l=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(l.token.isCancellationRequested)return;const r=await Promise.all((0,k.coalesce)(t||[]).map(async o=>{const i=await this.dataProvider.getTreeItem(o);return i&&!l.token.isCancellationRequested?this.createAndRegisterTreeNode(o,i,v):null}));return l.token.isCancellationRequested?void 0:(0,k.coalesce)(r)}finally{l.dispose()}}refresh(a){if(a.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(a);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const l=new Set,v=a.map(r=>this.nodes.get(r));for(const r of v)if(r&&!l.has(r.item.handle)){let o=r;for(;o&&o.parent&&v.findIndex(i=>o&&o.parent&&i&&i.item.handle===o.parent.item.handle)===-1;){const i=this.elements.get(o.parent.item.handle);o=i?this.nodes.get(i):void 0}o&&!o.parent&&l.add(r.item.handle)}const t=[];return l.forEach(r=>{const o=this.elements.get(r);if(o){const i=this.nodes.get(o);i&&(!i.parent||!l.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(a){const l={};return Promise.all(a.map(v=>this.refreshNode(v).then(t=>{t&&(l[v]=t.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(a){const l=this.getExtensionElement(a);if(l){const v=this.nodes.get(l);if(v)return this.clearChildren(l),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(t=>{if(t){const r=this.createTreeNode(l,t,v.parent);return this.updateNodeCache(l,r,v,v.parent),v.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,l,v){const t=this.createTreeNode(a,l,v);if(l.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,l.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,v),t}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?d.MarkdownString.from(a):a}getCommand(a,l){return l?this.commands.toInternal(l,a):void 0}createTreeNode(a,l,v){const t=new T.DisposableStore,r=this.createHandle(a,l,v),o=this.getLightIconPath(l);return{item:{handle:r,parentHandle:v?v.item.handle:void 0,label:p(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(t,l.command),contextValue:l.contextValue,icon:o,iconDark:this.getDarkIconPath(l)||o,themeIcon:this.getThemeIcon(l),collapsibleState:(0,n.isUndefinedOrNull)(l.collapsibleState)?P.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation},extensionItem:l,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:l,label:v,resourceUri:t},r,o){if(l)return`${A.ID_HANDLE_PREFIX}/${l}`;const i=p(v,this.extension),c=r?r.item.handle:A.LABEL_HANDLE_PREFIX;let h=i?i.label:t?(0,L.basename)(t):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const m=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,w=this.getChildrenNodes(r)||[];let S,s=0;do{if(S=`${c}/${s}:${h}`,o||!this.elements.has(S)||m===S)break;s++}while(s<=w.length);return S}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||I.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return I.URI.isUri(a)?a:I.URI.file(a)}addNodeToCache(a,l){this.elements.set(l.item.handle,a),this.nodes.set(a,l)}updateNodeCache(a,l,v,t){this.elements.delete(l.item.handle),this.nodes.delete(a),l.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(a,l);const r=this.getChildrenNodes(t)||[],o=r.filter(i=>i.item.handle===v.item.handle)[0];o&&r.splice(r.indexOf(o),1,l)}addNodeToParentCache(a,l){l?(l.children||(l.children=[]),l.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const l=this.nodes.get(a);if(l){if(l.children)for(const v of l.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}l.children=void 0}}else this.clearAll()}clear(a){const l=this.nodes.get(a);if(l){if(l.children)for(const v of l.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}A.LABEL_HANDLE_PREFIX="0",A.ID_HANDLE_PREFIX="1"}),define(me[222],ge([0,1,17,3,6,13,88,15,128,90]),function(Y,e,g,L,I,C,T,D,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends I.Disposable{constructor(d){super();this.controllerId=d,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(d){this._resolveHandler=d;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const d=this.diff;return this.diff=[],d}pushDiff(d){const f=this.diff[this.diff.length-1];if(f&&d[0]===1){if(f[0]===1&&f[1].extId===d[1].extId){(0,y.applyTestItemUpdate)(f[1],d[1]);return}if(f[0]===0&&f[1].item.extId===d[1].extId){(0,y.applyTestItemUpdate)(f[1],d[1]);return}}this.diff.push(d),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(d,f){const u=this.tree.get(d);if(!!u){if((u.expandLevels===void 0||f>u.expandLevels)&&(u.expandLevels=f),u.expand===1){const p=this.resolveChildren(u);return p.isOpen()?this.expandChildren(u,f-1):p.wait().then(()=>this.expandChildren(u,f-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,f-1)):this.expandChildren(u,f-1)}}dispose(){for(const d of this.tree.values())(0,T.getPrivateApiFor)(d.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(d,f){switch(f.op){case 2:this.pushDiff([4,d.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(d.fullId,f.id));break;case 0:this.upsertItem(f.item,d);break;case 4:for(const E of f.ops)this.onTestItemEvent(d,E);break;case 3:const{key:u,value:p,previous:_}=f,A=d.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(d);break;case"tags":this.diffTagRefs(p,_,A);break;case"range":this.pushDiff([1,{extId:A,item:{range:D.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:A,item:{error:D.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:A,item:{[u]:p??null}}]);break}break;default:(0,C.assertNever)(f)}}upsertItem(d,f){if(!(d instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${d.id} did not`);const u=P.TestId.fromExtHostTestItem(d,this.root.id,f?.actual),p=(0,T.getPrivateApiFor)(d);p.parent&&p.parent!==f?.actual&&p.parent.children.delete(d.id);let _=this.tree.get(u.toString());if(!_){_={fullId:u,actual:d,parent:f?u.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},d.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(d,f),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:D.TestItem.from(d)}]),this.connectItemAndChildren(d,_,f);return}if(_.actual===d){this.connectItem(d,_,f);return}const A=_.actual.children,E=_.actual,a=(0,T.diffTestItems)(E,d);(0,T.getPrivateApiFor)(E).listener=void 0,_.actual=d,_.expand=0;for(const[l,v]of a)this.onTestItemEvent(_,{op:3,key:l,value:v,previous:E[l]});this.connectItemAndChildren(d,_,f);for(const l of A)d.children.get(l.id)||this.removeItem(P.TestId.joinToString(u,l.id))}diffTagRefs(d,f,u){const p=new Set(f.map(_=>_.id));for(const _ of d)p.delete(_.id)||this.incrementTagRefs(_);this.pushDiff([1,{extId:u,item:{tags:d.map(_=>D.TestTag.namespace(this.controllerId,_.id))}}]),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(d){const f=this.tags.get(d.id);f?f.refCount++:(this.tags.set(d.id,{label:d.label,refCount:1}),this.pushDiff([5,{id:D.TestTag.namespace(this.controllerId,d.id),ctrlLabel:this.root.label,label:d.label}]))}decrementTagRefs(d){const f=this.tags.get(d);f&&!--f.refCount&&(this.tags.delete(d),this.pushDiff([6,D.TestTag.namespace(this.controllerId,d)]))}setItemParent(d,f){(0,T.getPrivateApiFor)(d).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(d,f,u){this.setItemParent(d,u);const p=(0,T.getPrivateApiFor)(d);p.parent=u?.actual,p.listener=_=>this.onTestItemEvent(f,_),this.updateExpandability(f)}connectItemAndChildren(d,f,u){this.connectItem(d,f,u);for(const p of d.children)this.upsertItem(p,f)}updateExpandability(d){let f;this._resolveHandler?d.resolveBarrier?f=d.resolveBarrier.isOpen()?3:2:f=d.actual.canResolveChildren?1:0:f=0,f!==d.expand&&(d.expand=f,this.pushDiff([1,{extId:d.fullId.toString(),expand:f}]),f===1&&d.expandLevels!==void 0&&this.resolveChildren(d))}expandChildren(d,f){if(f<0)return;const u=[];for(const p of d.actual.children){const _=this.expand(P.TestId.joinToString(d.fullId,p.id),f);(0,g.isThenable)(_)&&u.push(_)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this._resolveHandler){const _=new g.Barrier;return _.open(),_}d.expand=2,this.pushExpandStateUpdate(d);const f=d.resolveBarrier=new g.Barrier,u=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),d.actual!==this.root&&(d.actual.error=_.stack||_.message||String(_))};let p;try{p=this._resolveHandler(d.actual===this.root?void 0:d.actual)}catch(_){u(_)}return(0,g.isThenable)(p)?p.catch(u).then(()=>{f.open(),this.updateExpandability(d)}):(f.open(),this.updateExpandability(d)),d.resolveBarrier}pushExpandStateUpdate(d){this.pushDiff([1,{extId:d.fullId.toString(),expand:d.expand}])}removeItem(d){const f=this.tree.get(d);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,d]);const u=[f];for(;u.length;){const p=u.pop();if(!!p){(0,T.getPrivateApiFor)(p.actual).listener=void 0;for(const _ of p.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(p.fullId.toString());for(const _ of p.actual.children)u.push(this.tree.get(P.TestId.joinToString(p.fullId,_.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.diffOpEmitter.fire(d)}}e.SingleUseTestCollection=n}),define(me[223],ge([0,1,4,184]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(me[224],ge([0,1,26,3,8]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=C;class T{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let k of n.activationEvents)k==="onUri"&&(k=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(n)}}keepOnly(n){const k=new Set;n.forEach(d=>k.add(g.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>k.has(g.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,k){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const d=T._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(d.map(f=>f.identifier)),k.length>0){const f=new Set;k.forEach(u=>f.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!f.has(g.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(d)}static _findLoopingExtensions(n){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,A){this.addNode(_),this.addNode(A),this._arcs.has(_)?this._arcs.get(_).push(A):this._arcs.set(_,[A])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,A){const E=k.getArcs(_);for(let a=0;a<E.length;a++)if(!A.has(E[a]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let _ of n){const A=g.ExtensionIdentifier.toKey(_.identifier);if(d.set(A,_),_.extensionDependencies)for(let E of _.extensionDependencies){const a=g.ExtensionIdentifier.toKey(E);k.addArc(A,a)}}let f=new Set;k.getNodes().filter(_=>k.getArcs(_).length===0).forEach(_=>f.add(_));let u=k.getNodes().filter(_=>!f.has(_)),p;do{p=!1;for(let _=0;_<u.length;_++){const A=u[_];k.hasOnlyGoodArcs(A,f)&&(u.splice(_,1),_--,f.add(A),p=!0)}}while(p);return u.map(_=>d.get(_))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const k=this._activationMap.get(n);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const k=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return k||void 0}}e.ExtensionDescriptionRegistry=T;var D;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(D||(D={}));function y(P,n){const k=P.isBuiltin?0:P.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(k!==d)return k-d;const f=I.posix.basename(P.extensionLocation.path),u=I.posix.basename(n.extensionLocation.path);return f<u?-1:f>u?1:0}}),define(me[225],ge([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function C(D){const y=g.VSBuffer.alloc(1);switch(D){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=C;function T(D,y){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=T}),define(me[35],ge([0,1,3,2,4,26,186]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var D;(function(E){E[E.None=0]="None",E[E.LocalProcess=1]="LocalProcess",E[E.LocalWebWorker=2]="LocalWebWorker",E[E.Remote=3]="Remote"})(D=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class y{constructor(a){this.dependency=a}}e.MissingExtensionDependency=y;var P;(function(E){E[E.LocalProcess=0]="LocalProcess",E[E.LocalWebWorker=1]="LocalWebWorker",E[E.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(a,l,v,t){this.codeLoadingTime=a,this.activateCallTime=l,this.activateResolvedTime=v,this.activationReason=t}}e.ActivationTimes=n;class k{constructor(a,l){this.description=a,this.value=l}}e.ExtensionPointContribution=k,e.ExtensionHostLogFileName="exthost";var d;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function f(E){E.enableProposedApi||u(E)}e.checkProposedApiEnabled=f;function u(E){throw new Error(`[${E.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.throwProposedApiError=u;function p(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation}}e.toExtension=p;function _(E,a){return{identifier:new C.ExtensionIdentifier(E.identifier.id),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!a,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid}}e.toExtensionDescription=_;class A{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(a){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,l){return Promise.resolve()}_onWillActivateExtension(a){}_onDidActivateExtension(a,l,v,t,r){}_onDidActivateExtensionError(a,l){}_onExtensionRuntimeError(a,l){}_onExtensionHostExit(a){}}e.NullExtensionService=A}),define(me[226],ge([0,1,26,35,12]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class T{constructor(u,p,_,A){this.startup=u,this.codeLoadingTime=p,this.activateCallTime=_,this.activateResolvedTime=A}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class D{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,p){return u===-1||p===-1?-1:p-u}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class y{constructor(u,p,_,A,E,a){this.activationFailed=u,this.activationFailedError=p,this.activationTimes=_,this.module=A,this.exports=E,this.subscriptions=a}}e.ActivatedExtension=y;class P extends y{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class n extends y{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class k extends y{constructor(u){super(!0,u,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=k;let d=class{constructor(u,p,_,A,E){this._logService=E,this._registry=u,this._resolvedExtensionsSet=new Set,p.forEach(a=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,_.forEach(a=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(a),a)),this._host=A,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const p=g.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(p)}getActivatedExtension(u){const p=g.ExtensionIdentifier.toKey(u),_=this._activatedExtensions.get(p);if(!_)throw new Error("Extension `"+u.value+"` is not known or not activated");return _}activateByEvent(u,p){if(this._alreadyActivatedEvents[u])return C;const _=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(_.map(A=>({id:A.identifier,reason:{startup:p,extensionId:A.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,p){const _=this._registry.getExtensionDescription(u);if(!_)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:_.identifier,reason:p}])}_handleActivateRequest(u,p,_){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(u.id))){p[g.ExtensionIdentifier.toKey(u.id)]=u;return}const A=this._registry.getExtensionDescription(u.id);if(!A){const l=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,l,new L.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(u.id),new k(l));return}const E=typeof A.extensionDependencies=="undefined"?[]:A.extensionDependencies;let a=!0;for(let l=0,v=E.length;l<v;l++){const t=E[l];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const h=A.displayName||A.identifier.value,m=this._registry.getExtensionDescription(t),w=m&&m.displayName||t,S=new Error(`Cannot activate the '${h}' extension because its dependency '${w}' failed to activate`);S.detail=r.activationFailedError,this._host.onExtensionActivationError(A.identifier,S,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(A.identifier),new k(S));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){a=!1,p[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const o=this._registry.getExtensionDescription(t);if(o){a=!1,p[g.ExtensionIdentifier.toKey(t)]={id:o.identifier,reason:u.reason};continue}const i=A.displayName||A.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(A.identifier,c,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(A.identifier),new k(c));return}a?p[g.ExtensionIdentifier.toKey(A.identifier)]=u:_.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(E=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(E.id))),u.length===0))return Promise.resolve(void 0);const p=Object.create(null),_=[];for(let E=0,a=u.length;E<a;E++)this._handleActivateRequest(u[E],p,_);for(let E=0,a=_.length;E<a;E++){const l=g.ExtensionIdentifier.toKey(_[E].id);p[l]&&delete p[l]}const A=Object.keys(p).map(E=>p[E]);return _.length===0?Promise.all(A.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(A).then(E=>this._activateExtensions(_))}_activateExtension(u,p){const _=g.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const A=this._activatingExtensions.get(_);if(A)return A;const E=this._host.actualActivateExtension(u,p).then(void 0,a=>{const l=new Error;return a&&a.name&&(l.name=a.name),a&&a.message?l.message=`Activating extension '${u.value}' failed: ${a.message}.`:l.message=`Activating extension '${u.value}' failed: ${a}.`,a&&a.stack&&(l.stack=a.stack),this._host.onExtensionActivationError(u,l,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(a),new k(a)}).then(a=>{this._activatedExtensions.set(_,a),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,E),E}};d=je([Ue(4,I.ILogService)],d),e.ExtensionsActivator=d}),define(me[227],ge([0,1,12,35,27,10,115]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends g.LogService{constructor(P){if(P.logFile.scheme!==C.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(L.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};D=je([Ue(0,I.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(me[228],ge([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,T)=>{this._actualOk=C,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,g.onUnexpectedError)(C))}then(C,T){return this._ensureActual().then(C,T)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(me[65],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(P,n){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=n,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function I(y){const P=new g(!0,y);return L[P.nid]=P,P}e.createMainContextProxyIdentifier=I;function C(y){const P=new g(!1,y);return L[P.nid]=P,P}e.createExtHostContextProxyIdentifier=C;function T(y){return L[y].sid}e.getStringIdentifierForProxy=T;class D{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=D}),define(me[5],ge([0,1,59,2,65]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(a){a.name="$ident";function l(t,r){return Object.defineProperty(t,a.name,{value:r,enumerable:!0}),t}a.mixin=l;function v(t){return t[a.name]}a.of=v})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(l){return l._id=f._n++,l}}e.IdObject=f,f._n=0;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function A(a){if(a&&a.edits)for(const l of a.edits)typeof l.resource=="object"?l.resource=L.URI.revive(l.resource):(l.newUri=L.URI.revive(l.newUri),l.oldUri=L.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,g.revive)(l.metadata));return a}e.reviveWorkspaceEditDto=A;var E;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[91],ge([0,1,5,3,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(D){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,y){return this._proxy.$getPassword(D,y)}store(D,y,P){return this._proxy.$setPassword(D,y,P)}delete(D,y){return this._proxy.$deletePassword(D,y)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(me[66],ge([0,1,4,12,5,14]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,P,n){const k=this.getUsageKey(y,P);this._reportedUsages.has(k)||(this._reportedUsages.add(k),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};T=je([Ue(0,C.IExtHostRpcService),Ue(1,L.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(D,y,P){}})}),define(me[229],ge([0,1,3,5,7,26]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,n,k={}){const d=C.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(d)||[],u=[...n].sort().join(" ");let p=f.find(_=>_.scopes===u);if(p)return p.result;{const _=this._getSession(y,d,P,n,k);p={scopes:u,result:_},f.push(p),this._inFlightRequests.set(d,f);try{await _}finally{const A=f.findIndex(E=>E.scopes===u);A>-1&&(f.splice(A),this._inFlightRequests.set(d,f))}return _}}async _getSession(y,P,n,k,d={}){await this._proxy.$ensureProvider(n);const f=y.displayName||y.name;return this._proxy.$getSession(n,k,P,f,d)}async removeSession(y,P){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,n,k){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:n,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===y)||this._providers.push({id:y,label:P});const d=n.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(y,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,k?.supportsMultipleAccounts??!1),new I.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(y);const f=this._providers.findIndex(u=>u.id===y);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(me[230],ge([0,1,5,14,15]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(D,y){this._extHostDocumentsAndEditors=y,this._proxy=D.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const y=I.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};C=je([Ue(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(me[231],ge([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const T=C.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(D){return T.$writeText(D)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,13,7,15,23,5,20,12,59,41,50,2,6,4,14]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=r,this.converter=new A(this,o=>{const i=this._apiCommands.get(o);return i?.result===a.Void?i:void 0},r),this._argumentProcessors=[{processArgument(o){return(0,P.revive)(o)}},{processArgument(o){return(0,C.cloneAndChange)(o,function(i){if(n.Range.isIRange(i))return I.Range.to(i);if(k.Position.isIPosition(i))return I.Position.to(i);if(n.Range.isIRange(i.range)&&d.URI.isUri(i.uri))return I.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...o)=>{const i=t.args.map((h,m)=>{if(!h.validate(o[m]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${o[m]}`);return h.convert(o[m])}),c=await this.executeCommand(t.internalId,...i);return t.result.convert(c,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,o,i,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:i,description:c}),t&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,o){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,C.cloneAndChange)(r,function(c){if(c instanceof L.Position)return I.Position.from(c);if(c instanceof L.Range)return I.Range.from(c);if(c instanceof L.Location)return I.location.from(c);if(L.NotebookRange.isNotebookRange(c))return I.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,i,o);return(0,P.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw c}}}async _executeContributedCommand(t,r){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:i,thisArg:c,description:h}=o;if(h)for(let m=0;m<h.args.length;m++)try{(0,g.validateConstraint)(r[m],h.args[m].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[m].name}' - ${h.args[m].description}`)}try{return await i.apply(c,r)}catch(m){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...r);w&&(t=w.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(o=>this._argumentProcessors.reduce((i,c)=>c.processArgument(i),o)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,o]of this._commands){let{description:i}=o;i&&(t[r]=i)}return Promise.resolve(t)}};_=je([Ue(0,p.IExtHostRpcService),Ue(1,y.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class A{constructor(t,r,o){this._commands=t,this._lookupApiCommand=r,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const i=this._lookupApiCommand(t.command);if(i)o.id=i.internalId,o.arguments=i.args.map((c,h)=>c.convert(t.arguments&&t.arguments[h]));else if((0,D.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),r.add((0,f.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),o.$ident=c,o.id=this.delegatingCommandId,o.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return o}fromInternal(t){const r=T.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=A;class E{constructor(t,r,o,i){this.name=t,this.description=r,this.validate=o,this.convert=i}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new E(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",v=>d.URI.isUri(v),v=>v),E.Position=new E("position","A position in a text document",v=>L.Position.isPosition(v),I.Position.from),E.Range=new E("range","A range in a text document",v=>L.Range.isRange(v),I.Range.from),E.Selection=new E("selection","A selection in a text document",v=>L.Selection.isSelection(v),I.Selection.from),E.Number=new E("number","",v=>typeof v=="number",v=>v),E.String=new E("string","",v=>typeof v=="string",v=>v),E.CallHierarchyItem=new E("item","A call hierarchy item",v=>v instanceof L.CallHierarchyItem,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",v=>v instanceof L.TypeHierarchyItem,I.TypeHierarchyItem.from);class a{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=a,a.Void=new a("no result",v=>v);class l{constructor(t,r,o,i,c){this.id=t,this.internalId=r,this.description=o,this.args=i,this.result=c}}e.ApiCommand=l}),define(me[232],ge([0,1,15,7,83,44,20,111]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,f)=>{if((0,T.isFalsyOrEmpty)(d))return;class u extends L.SymbolInformation{static to(_){const A=new u(_.name,g.SymbolKind.to(_.kind),_.containerName||"",new L.Location(f[0],g.Range.to(_.range)));return A.detail=_.detail,A.range=A.location.range,A.selectionRange=g.Range.to(_.selectionRange),A.children=_.children?_.children.map(u.to):[],A}}return d.map(u.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(f=>L.Position.isPosition(f)),d=>d.map(g.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(f=>{let u;for(const p of f.reverse())u=new L.SelectionRange(g.Range.to(p),u);return u}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>{const f=[];if(Array.isArray(d))for(let u of d)f.push(...u[1].map(g.WorkspaceSymbol.to));return f})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(g.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return g.WorkspaceEdit.to(d)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(g.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new L.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=(0,D.decodeSemanticTokensDto)(d);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new L.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=(0,D.decodeSemanticTokensDto)(d);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,f,u)=>{if(!d)return new L.CompletionList([]);const p=d.suggestions.map(_=>g.CompletionItem.to(_,u));return new L.CompletionList(p,d.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return g.SignatureHelp.to(d)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,f,u)=>n(p=>new L.CodeLens(g.Range.to(p.range),p.command&&u.fromInternal(p.command)))(d))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>L.Range.isRange(d),d=>L.Selection.isSelection(d)?g.Selection.from(d):g.Range.from(d)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,f,u)=>n(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(p.command)}else{const _=new L.CodeAction(p.title,p.kind?new L.CodeActionKind(p.kind):void 0);return p.edit&&(_.edit=g.WorkspaceEdit.to(p.edit)),p.command&&(_.command=u.fromInternal(p.command)),_.isPreferred=p.isPreferred,_}})(d))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(f=>new L.ColorInformation(g.Range.to(f.range),g.Color.to(f.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",d=>d instanceof L.Color,g.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:g.Range.from(d.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(g.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",d=>d.map(g.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(f=>g.NotebookExclusiveDocumentPattern.to(f))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(g.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[d,void 0]:[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[d,void 0]:[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[g.ViewColumn.from(d.viewColumn),g.TextEditorOpenOptions.from(d)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(g.TypeHierarchyItem.to)))];class P{static register(f){y.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=P;function n(d){return f=>{if(Array.isArray(f))return f.map(d)}}function k(d){if(!Array.isArray(d))return;const f=[];for(const u of d)I.isLocationLink(u)?f.push(g.DefinitionLink.to(u)):f.push(g.location.to(u));return f}}),define(me[233],ge([0,1,17,56,3,6,2,83,26,15,7,5]),function(Y,e,g,L,I,C,T,D,y,P,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function d(f,u,p){const _=f.getProxy(k.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const h=c.getCommentThread(i.commentThreadHandle);return h||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const h=c.getCommentThread(i.thread.commentThreadHandle);return h?{thread:h,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const h=c.getCommentThread(i.thread.commentThreadHandle);if(!h)return i;let m=i.commentUniqueId,w=h.getCommentByUniqueId(m);return w||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const h=c.getCommentThread(i.thread.commentThreadHandle);if(!h)return i;let m=i.text,w=i.commentUniqueId,S=h.getCommentByUniqueId(w);return S?(S.body=m,S):i}return i}})}createCommentController(i,c,h){const m=A.handlePool++,w=new a(i,m,c,h);this._commentControllers.set(w.handle,w);const S=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return S.push(w),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),S),w.value}$createCommentThreadTemplate(i,c,h){const m=this._commentControllers.get(i);!m||m.$createCommentThreadTemplate(c,h)}async $updateCommentThreadTemplate(i,c,h){const m=this._commentControllers.get(i);!m||m.$updateCommentThreadTemplate(c,h)}$deleteCommentThread(i,c){const h=this._commentControllers.get(i);h&&h.$deleteCommentThread(c)}$provideCommentingRanges(i,c,h){const m=this._commentControllers.get(i);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const w=p.getDocument(T.URI.revive(c));return(0,g.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(w,h)).then(S=>S?S.map(s=>P.Range.from(s)):void 0)}$toggleReaction(i,c,h,m,w){const S=this._commentControllers.get(i);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const s=S.getCommentThread(c);if(s){const b=s.getCommentByUniqueId(m.uniqueIdInThread);if(S!==void 0&&b&&S.reactionHandler)return S.reactionHandler(b,t(w))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class E{constructor(i,c,h,m,w,S,s){this._commentControllerHandle=c,this._id=h,this._uri=m,this._range=w,this._comments=S,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),_.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(c,this.handle)}});const b=this;this.value={get uri(){return b.uri},get range(){return b.range},set range(R){b.range=R},get comments(){return b.comments},set comments(R){b.comments=R},get collapsibleState(){return b.collapsibleState},set collapsibleState(R){b.collapsibleState=R},get canReply(){return b.canReply},set canReply(R){b.canReply=R},get contextValue(){return b.contextValue},set contextValue(R){b.contextValue=R},get label(){return b.label},set label(R){b.label=R},dispose:()=>{b.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const i=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),c={};i("range")&&(c.range=P.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue),i("comments")&&(c.comments=this._comments.map(h=>l(this,h,this._commentsMap))),i("collapsibleState")&&(c.collapseState=r(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let h=c[0],m=c[1];if(i===m)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}E._handlePool=0,je([(0,L.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,c,h,m){this._extension=i,this._handle=c,this._id=h,this._label=m,this._threads=new Map,_.$registerCommentController(this.handle,h,m);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(S){w.options=S},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(S){w.commentingRangeProvider=S},get reactionHandler(){return w.reactionHandler},set reactionHandler(S){w.reactionHandler=S},createCommentThread(S,s,b){return w.createCommentThread(S,s,b).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,h,m){if(typeof i=="string"){const w=new E(this.id,this.handle,i,c,h,m,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new E(this.id,this.handle,void 0,i,c,h,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(i,c){const h=new E(this.id,this.handle,void 0,T.URI.revive(i),P.Range.to(c),[],this._extension.identifier);return h.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(i,c){let h=this._threads.get(i);h&&(h.range=P.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function l(o,i,c){let h=c.get(i);h||(h=++o.commentHandle,c.set(i,h));const m=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:h,body:P.MarkdownString.from(i.body),userName:i.author.name,userIconPath:m,label:i.label,commentReactions:i.reactions?i.reactions.map(w=>v(w)):void 0}}function v(o){return{label:o.label,iconPath:o.iconPath?P.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function t(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?T.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function r(o){if(o!==void 0)switch(o){case n.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=d}),define(me[132],ge([0,1,2,5,7,4,14,12,20,9,8]),function(Y,e,g,L,I,C,T,D,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class vn{constructor(f,u){this._logService=u,this._provider=new Map,this._proxy=f.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,u){const p=vn._handlePool++;this._provider.set(p,{provider:f,extensionId:u}),this._proxy.$registerDecorationProvider(p,u.value);const _=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(p,null);return}let E=(0,y.asArray)(A);if(E.length<=vn._maxEventSize){this._proxy.$onDidChange(p,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,E.length);const a=E.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),l=(0,y.groupBy)(a,(t,r)=>t.rank-r.rank||(0,P.compare)(t.uri.path,r.uri.path));let v=[];e:for(let t of l){let r;for(let o of t){let i=(0,n.dirname)(o.uri.path);if(r!==i&&(r=i,v.push(o.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(p,v)});return new I.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(f,u,p){if(!this._provider.has(f))return Object.create(null);const _=Object.create(null),{provider:A,extensionId:E}=this._provider.get(f);return await Promise.all(u.map(async a=>{try{const{uri:l,id:v}=a,t=await Promise.resolve(A.provideFileDecoration(g.URI.revive(l),p));if(!t)return;try{I.FileDecoration.validate(t),_[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${E.value}': ${r}`)}}catch(l){this._logService.error(l)}})),_}};k._handlePool=0,k._maxEventSize=250,k=je([Ue(0,T.IExtHostRpcService),Ue(1,D.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")}),define(me[234],ge([0,1,164,116,2,5,7,15,3,12,24]),function(Y,e,g,L,I,C,T,D,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(u,p,_,A,E){this._name=u,this._owner=p,this._maxDiagnosticsPerFile=_,this._proxy=A,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,p){if(!u){this.clear();return}this._checkDisposed();let _=[];if(I.URI.isUri(u)){if(!p){this.delete(u);return}this._data.set(u,p.slice()),_=[u]}else if(Array.isArray(u)){_=[];let E;u=[...u].sort(k._compareIndexedTuplesByUri);for(const a of u){const[l,v]=a;if((!E||l.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=l,_.push(l),this._data.set(l,[])),v){const t=this._data.get(l);t&&t.push(...v)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const A=[];for(let E of _){let a=[];const l=this._data.get(E);if(l)if(l.length>this._maxDiagnosticsPerFile){a=[];const v=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of l)if(r.severity===v[t]&&a.push(D.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;a.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=l.map(v=>D.Diagnostic.from(v));A.push([E,a])}this._proxy.$changeMany(this._owner,A)}delete(u){this._checkDisposed(),this._onDidChangeDiagnostics.fire([u]),this._data.delete(u),this._proxy&&this._proxy.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(u,p){this._checkDisposed();for(let _ of this._data.keys())u.apply(p,[_,this.get(_),this])}get(u){this._checkDisposed();const p=this._data.get(u);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this._data.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,p){return u[0].toString()<p[0].toString()?-1:u[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=k;let d=class en{constructor(u,p){this._logService=p,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,en._mapper),this._proxy=u.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(u){const p=new n.ResourceMap;for(const _ of u)p.set(_,_);return{uris:Object.freeze(Array.from(p.values()))}}createDiagnosticCollection(u,p){const{_collections:_,_proxy:A,_onDidChangeDiagnostics:E,_logService:a}=this,l=new class{$changeMany(r,o){A.$changeMany(r,o),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,r,o.length===0?"CLEARING":o)}$clear(r){A.$clear(r),a.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,r)}dispose(){A.dispose()}};let v;if(!p)p="_generated_diagnostic_collection_name_#"+en._idPool++,v=p;else if(!_.has(p))v=p;else{this._logService.warn(`DiagnosticCollection with name '${p}' does already exist.`);do v=p+en._idPool++;while(_.has(v))}return new class extends k{constructor(){super(p,v,en._maxDiagnosticsPerFile,l,E);_.set(v,this)}dispose(){super.dispose(),_.delete(v)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const p=new Map,_=[];for(const A of this._collections.values())A.forEach((E,a)=>{let l=p.get(E.toString());typeof l=="undefined"&&(l=_.length,p.set(E.toString(),l),_.push([E,[]])),_[l][1]=_[l][1].concat(...a)});return _}}_getDiagnostics(u){let p=[];for(let _ of this._collections.values())_.has(u)&&(p=p.concat(_.get(u)));return p}$acceptMarkersChange(u){if(!this._mirrorCollection){const p="_generated_mirror",_=new k(p,p,en._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(p,_),this._mirrorCollection=_}for(const[p,_]of u)this._mirrorCollection.set(I.URI.revive(p),_.map(D.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=je([Ue(1,P.ILogService)],d),e.ExtHostDiagnostics=d}),define(me[235],ge([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(T){this._proxy=T.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(D=>D?D.map(y=>g.URI.revive(y)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(D=>D?g.URI.revive(D):void 0)}}e.ExtHostDialogs=I}),define(me[236],ge([0,1,16,2,7,5,10,21,9]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(k,d,f){this._documentsAndEditors=d,this._logService=f,this._documentContentProviders=new Map,this._proxy=k.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,d){if(Object.keys(T.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const f=P._handlePool++;this._documentContentProviders.set(f,d),this._proxy.$registerTextContentProvider(f,k);let u;return typeof d.onDidChange=="function"&&(u=d.onDidChange(p=>{if(p.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(f,p).then(_=>{if(!_&&typeof _!="string")return;const A=this._documentsAndEditors.getDocument(p);if(!A)return;const E=(0,y.splitLines)(_);if(!A.equalLines(E))return this._proxy.$onVirtualDocumentChange(p,_)},g.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(k,d){const f=this._documentContentProviders.get(k);return f?Promise.resolve(f.provideTextDocumentContent(L.URI.revive(d),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(me[237],ge([0,1,3,6,2,5,124,15,13,23,7]),function(Y,e,g,L,I,C,T,D,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(f,u){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const _ of p)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const _ of p)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const u=this._documentsAndEditors.getDocument(f);if(u)return u}getDocument(f){const u=this.getDocumentData(f);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return u.document}ensureDocumentData(f){const u=this._documentsAndEditors.getDocument(f);if(u)return Promise.resolve(u);let p=this._documentLoader.get(f.toString());return p||(p=this._proxy.$tryOpenDocument(f).then(_=>{this._documentLoader.delete(f.toString());const A=I.URI.revive(_);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(A))},_=>(this._documentLoader.delete(f.toString()),Promise.reject(_))),this._documentLoader.set(f.toString(),p)),p}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(u=>I.URI.revive(u))}$acceptModelModeChanged(f,u){const p=I.URI.revive(f),_=this._documentsAndEditors.getDocument(p);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(u),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(f){const u=I.URI.revive(f),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(f,u){const p=I.URI.revive(f),_=this._documentsAndEditors.getDocument(p);if(!_)throw new Error("unknown document");_._acceptIsDirty(u),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,u,p){const _=I.URI.revive(f),A=this._documentsAndEditors.getDocument(_);if(!A)throw new Error("unknown document");A._acceptIsDirty(p),A.onEvents(u);let E;u.isUndoing?E=n.TextDocumentChangeReason.Undo:u.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:A.document,contentChanges:u.changes.map(a=>({range:D.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:E}))}setWordDefinitionFor(f,u){(0,T.setWordDefinitionFor)(f,u)}}e.ExtHostDocuments=k}),define(me[45],ge([0,1,54,3,6,2,4,5,124,14,131,15,12,24,10,76,140]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(l,v){this._extHostRpc=l,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const v=[],t=[],r=[];if(l.removedDocuments)for(const o of l.removedDocuments){const i=C.URI.revive(o),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),v.push(c.value))}if(l.addedDocuments)for(const o of l.addedDocuments){const i=C.URI.revive(o.uri);let c=this._documents.get(i);if(c&&i.scheme!==u.Schemas.vscodeNotebookCell&&i.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new A(new y.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(l.removedEditors)for(const o of l.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&r.push(i)}if(l.addedEditors)for(const o of l.addedEditors){const i=C.URI.revive(o.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const c=this._documents.get(i).value,h=new n.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>c.document),o.selections.map(k.Selection.to),o.options,o.visibleRanges.map(m=>k.Range.to(m)),typeof o.editorPosition=="number"?k.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,h)}l.newActiveEditor!==void 0&&(g.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,I.dispose)(v),(0,I.dispose)(r),l.removedDocuments&&this._onDidRemoveDocuments.fire(v),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return l?v:v?.value}allEditors(){return[...this._editors.values()]}};E=je([Ue(0,P.IExtHostRpcService),Ue(1,d.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[238],ge([0,1,2,5,6,7,15,148,9,22]),function(Y,e,g,L,I,C,T,D,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const u=this._schemes.indexOf(f);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),u=[];let p,_,A=14,E=14;for(const a of f){let l=p?(0,y.commonPrefixLength)(p,a):0;for(l===0?_=1:_=E;l<a.length;l++)l+1===a.length?(A=E,E=9):E+=1,u.push([_,a.toUpperCase().charCodeAt(l),E]),u.push([_,a.toLowerCase().charCodeAt(l),E]),_=E;p=a,E=A}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new D.StateMachine(u)}}provideDocumentLinks(f){this._initStateMachine();const u=[],p=D.LinkComputer.computeLinks({getLineContent(_){return f.lineAt(_-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const _ of p){const A=T.DocumentLink.to(_);A.target&&u.push(A)}return u}}class k{constructor(f,u){this._extHostLanguageFeatures=u,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,u,p,_={},A){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(E,p),this._enableProposedApi.set(E,A??!1);let a=2;_.isCaseSensitive&&(a+=1024),_.isReadonly&&(a+=2048),typeof p.copy=="function"&&(a+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&(a+=4),this._proxy.$registerFileSystemProvider(E,u,a).catch(v=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${u}`),console.error(v)});const l=p.onDidChangeFile(v=>{const t=[];for(const r of v){let{uri:o,type:i}=r;if(o.scheme!==u)continue;let c;switch(i){case C.FileChangeType.Changed:c=0;break;case C.FileChangeType.Created:c=1;break;case C.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:o,type:c})}this._proxy.$onFileSystemChange(E,t)});return(0,I.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(f,u){const{type:p,ctime:_,mtime:A,size:E,permissions:a}=f;return u?{type:p,ctime:_,mtime:A,size:E,permissions:a}:{type:p,ctime:_,mtime:A,size:E}}$stat(f,u){return Promise.resolve(this._getFsProvider(f).stat(g.URI.revive(u))).then(p=>k._asIStat(p,this._enableProposedApi.get(f)??!1))}$readdir(f,u){return Promise.resolve(this._getFsProvider(f).readDirectory(g.URI.revive(u)))}$readFile(f,u){return Promise.resolve(this._getFsProvider(f).readFile(g.URI.revive(u))).then(p=>P.VSBuffer.wrap(p))}$writeFile(f,u,p,_){return Promise.resolve(this._getFsProvider(f).writeFile(g.URI.revive(u),p.buffer,_))}$delete(f,u,p){return Promise.resolve(this._getFsProvider(f).delete(g.URI.revive(u),p))}$rename(f,u,p,_){return Promise.resolve(this._getFsProvider(f).rename(g.URI.revive(u),g.URI.revive(p),_))}$copy(f,u,p,_){const A=this._getFsProvider(f);if(!A.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(A.copy(g.URI.revive(u),g.URI.revive(p),_))}$mkdir(f,u){return Promise.resolve(this._getFsProvider(f).createDirectory(g.URI.revive(u)))}$watch(f,u,p,_){const A=this._getFsProvider(f).watch(g.URI.revive(p),_);this._watches.set(u,A)}$unwatch(f,u){const p=this._watches.get(u);p&&(p.dispose(),this._watches.delete(u))}$open(f,u,p){const _=this._getFsProvider(f);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(g.URI.revive(u),p))}$close(f,u){const p=this._getFsProvider(f);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(u))}$read(f,u,p,_){const A=this._getFsProvider(f);if(!A.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(_);return Promise.resolve(A.read(u,p,E.buffer,0,_)).then(a=>E.slice(0,a))}$write(f,u,p,_){const A=this._getFsProvider(f);if(!A.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(A.write(u,p,_.buffer,0,_.byteLength))}_getFsProvider(f){const u=this._fsProvider.get(f);if(!u){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return u}}e.ExtHostFileSystem=k}),define(me[92],ge([0,1,5,42,7,22,4,14,63]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(k,d){const f=k.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return f.$stat(u).catch(Ut._handleError)},readDirectory(u){return f.$readdir(u).catch(Ut._handleError)},createDirectory(u){return f.$mkdir(u).catch(Ut._handleError)},async readFile(u){return f.$readFile(u).then(p=>p.buffer).catch(Ut._handleError)},writeFile(u,p){return f.$writeFile(u,C.VSBuffer.wrap(p)).catch(Ut._handleError)},delete(u,p){return f.$delete(u,{recursive:!1,useTrash:!1,...p}).catch(Ut._handleError)},rename(u,p,_){return f.$rename(u,p,{overwrite:!1,..._}).catch(Ut._handleError)},copy(u,p,_){return f.$copy(u,p,{overwrite:!1,..._}).catch(Ut._handleError)},isWritableFileSystem(u){const p=d.getCapabilities(u);if(typeof p=="number")return!(p&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new I.FileSystemError(String(k));if(k.name==="ENOPRO")throw I.FileSystemError.Unavailable(k.message);switch(k.name){case L.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(k.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(k.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(k.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(k.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(k.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(k.message);default:throw new I.FileSystemError(k.message,k.name)}}};P=je([Ue(0,D.IExtHostRpcService),Ue(1,y.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(me[239],ge([0,1,2,44]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(T,D,y,P){this._extHostNotebooks=D,this._textDocumentsAndEditors=y,this._commands=P;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",k=>!0,k=>k),new L.ApiCommandArgument("resource","Interactive resource Uri",k=>!0,k=>k),new L.ApiCommandArgument("controllerId","Notebook controller Id",k=>!0,k=>k),new L.ApiCommandArgument("title","Interactive editor title",k=>!0,k=>k)],new L.ApiCommandResult("Notebook and input URI",k=>{if(k.notebookEditorId!==void 0){const d=this._extHostNotebooks.getEditorById(k.notebookEditorId);return{notebookUri:g.URI.revive(k.notebookUri),inputUri:g.URI.revive(k.inputUri),notebookEditor:d.apiEditor}}return{notebookUri:g.URI.revive(k.notebookUri),inputUri:g.URI.revive(k.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(T,D,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],modeId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=I}),define(me[240],ge([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,T),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=I}),define(me[241],ge([0,1,2,23,15,7,5,9,41,20,13,145,6,111,75,87,46,16,3]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentSymbols(z,ee){const re=this._documents.getDocument(z),le=await this._provider.provideDocumentSymbols(re,ee);if(!(0,P.isFalsyOrEmpty)(le))return le[0]instanceof C.DocumentSymbol?le.map(I.DocumentSymbol.from):a._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((le,X)=>{let oe=le.location.range.start.compareTo(X.location.range.start);return oe===0&&(oe=X.location.range.end.compareTo(le.location.range.end)),oe});const ee=[],re=[];for(const le of z){const X={name:le.name||"!!MISSING: name!!",kind:I.SymbolKind.from(le.kind),tags:le.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:I.Range.from(le.location.range),selectionRange:I.Range.from(le.location.range),children:[]};for(;;){if(re.length===0){re.push(X),ee.push(X);break}const oe=re[re.length-1];if(y.Range.containsRange(oe.range,X.range)&&!y.Range.equalsRange(oe.range,X.range)){oe.children&&oe.children.push(X),re.push(X);break}re.pop()}}return ee}}class l{constructor(z,ee,re){this._documents=z,this._commands=ee,this._provider=re,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,ee){const re=this._documents.getDocument(z),le=await this._provider.provideCodeLenses(re,ee);if(!le||ee.isCancellationRequested)return;const X=this._cache.add(le),oe=new d.DisposableStore;this._disposables.set(X,oe);const ve={cacheId:X,lenses:[]};for(let Me=0;Me<le.length;Me++)ve.lenses.push({cacheId:[X,Me],range:I.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,oe)});return ve}async resolveCodeLens(z,ee){const re=z.cacheId&&this._cache.get(...z.cacheId);if(!re)return;let le;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?le=re:le=await this._provider.resolveCodeLens(re,ee),le||(le=re),ee.isCancellationRequested)return;const X=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!X)return z.command=this._commands.toInternal(le.command??l._badCmd,X),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(Ke){return Array.isArray(Ke)?Ke.map(I.DefinitionLink.from):Ke?[I.DefinitionLink.from(Ke)]:[]}class t{constructor(z,ee){this._documents=z,this._provider=ee}async provideDefinition(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.provideDefinition(le,X,re);return v(oe)}}class r{constructor(z,ee){this._documents=z,this._provider=ee}async provideDeclaration(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.provideDeclaration(le,X,re);return v(oe)}}class o{constructor(z,ee){this._documents=z,this._provider=ee}async provideImplementation(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.provideImplementation(le,X,re);return v(oe)}}class i{constructor(z,ee){this._documents=z,this._provider=ee}async provideTypeDefinition(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.provideTypeDefinition(le,X,re);return v(oe)}}class c{constructor(z,ee){this._documents=z,this._provider=ee}async provideHover(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.provideHover(le,X,re);if(!(!oe||(0,P.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=le.getWordRangeAtPosition(X)),oe.range||(oe.range=new C.Range(X,X)),I.Hover.from(oe)}}class h{constructor(z,ee){this._documents=z,this._provider=ee}async provideEvaluatableExpression(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(le,X,re);if(oe)return I.EvaluatableExpression.from(oe)}}class m{constructor(z,ee){this._documents=z,this._provider=ee}async provideInlineValues(z,ee,re,le){const X=this._documents.getDocument(z),oe=await this._provider.provideInlineValues(X,I.Range.to(ee),I.InlineValueContext.to(re),le);if(Array.isArray(oe))return oe.map(ve=>I.InlineValue.from(ve))}}class w{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentHighlights(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.provideDocumentHighlights(le,X,re);if(Array.isArray(oe))return oe.map(I.DocumentHighlight.from)}}class S{constructor(z,ee){this._documents=z,this._provider=ee}async provideLinkedEditingRanges(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(le,X,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,P.coalesce)(oe.ranges.map(I.Range.from)),wordPattern:oe.wordPattern}}}class s{constructor(z,ee){this._documents=z,this._provider=ee}async provideReferences(z,ee,re,le){const X=this._documents.getDocument(z),oe=I.Position.to(ee),ve=await this._provider.provideReferences(X,oe,re,le);if(Array.isArray(ve))return ve.map(I.location.from)}}class b{constructor(z,ee,re,le,X,oe,ve){this._documents=z,this._commands=ee,this._diagnostics=re,this._provider=le,this._logService=X,this._extension=oe,this._apiDeprecation=ve,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,ee,re,le){const X=this._documents.getDocument(z),oe=k.Selection.isISelection(ee)?I.Selection.to(ee):I.Range.to(ee),ve=[];for(const ct of this._diagnostics.getDiagnostics(z))if(oe.intersection(ct.range)&&ve.push(ct)>b._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:I.CodeActionTriggerKind.to(re.trigger)},ze=await this._provider.provideCodeActions(X,oe,Me,le);if(!(0,P.isNonEmptyArray)(ze)||le.isCancellationRequested)return;const Qe=this._cache.add(ze),et=new d.DisposableStore;this._disposables.set(Qe,et);const ke=[];for(let ct=0;ct<ze.length;ct++){const K=ze[ct];!K||(b._isCommand(K)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ke.push({_isSynthetic:!0,title:K.title,command:this._commands.toInternal(K,et)})):(Me.only&&(K.kind?Me.only.contains(K.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${K.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ke.push({cacheId:[Qe,ct],title:K.title,command:K.command&&this._commands.toInternal(K.command,et),diagnostics:K.diagnostics&&K.diagnostics.map(I.Diagnostic.from),edit:K.edit&&I.WorkspaceEdit.from(K.edit),kind:K.kind&&K.kind.value,isPreferred:K.isPreferred,disabled:K.disabled?.reason})))}return{cacheId:Qe,actions:ke}}async resolveCodeAction(z,ee){const[re,le]=z,X=this._cache.get(re,le);if(!X||b._isCommand(X)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(X,ee)??X;return oe?.edit?I.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}b._maxCodeActionsPerFile=1e3;class R{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentFormattingEdits(z,ee,re){const le=this._documents.getDocument(z),X=await this._provider.provideDocumentFormattingEdits(le,ee,re);if(Array.isArray(X))return X.map(I.TextEdit.from)}}class O{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentRangeFormattingEdits(z,ee,re,le){const X=this._documents.getDocument(z),oe=I.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(X,oe,re,le);if(Array.isArray(ve))return ve.map(I.TextEdit.from)}}class ${constructor(z,ee){this._documents=z,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,ee,re,le,X){const oe=this._documents.getDocument(z),ve=I.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,ve,re,le,X);if(Array.isArray(Me))return Me.map(I.TextEdit.from)}}class G{constructor(z,ee){this._provider=z,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(z,ee){const re=T.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(z,ee);if((0,P.isNonEmptyArray)(le))for(const X of le){if(!X)continue;if(!X.name){this._logService.warn("INVALID SymbolInformation, lacks name",X);continue}const oe=T.IdObject.mixin(I.WorkspaceSymbol.from(X));this._symbolCache.set(oe._id,X),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(z,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const re=this._symbolCache.get(z._id);if(re){const le=await this._provider.resolveWorkspaceSymbol(re,ee);return le&&(0,L.mixin)(z,I.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(z){const ee=this._resultCache.get(z);if(ee){for(let[re,le]=ee;re<=le;re++)this._symbolCache.delete(re);this._resultCache.delete(z)}}}class Z{constructor(z,ee,re){this._documents=z,this._provider=ee,this._logService=re}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,ee,re,le){const X=this._documents.getDocument(z),oe=I.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(X,oe,re,le);return ve?I.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=Z._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(z,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(z),X=I.Position.to(ee);try{const oe=await this._provider.prepareRename(le,X,re);let ve,Me;if(C.Range.isRange(oe)?(ve=oe,Me=le.getText(oe)):(0,n.isObject)(oe)&&(ve=oe.range,Me=oe.placeholder),!ve||!Me)return;if(ve.start.line>X.line||ve.end.line<X.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ve),text:Me}}catch(oe){const ve=Z._asMessage(oe);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class U{constructor(z,ee){this.resultId=z,this.tokens=ee}}class x{constructor(z,ee){this._documents=z,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,ee,re){const le=this._documents.getDocument(z),X=ee!==0?this._previousResults.get(ee):null;let oe=typeof X?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,X.resultId,re):await this._provider.provideDocumentSemanticTokens(le,re);return X&&this._previousResults.delete(ee),oe?(oe=x._fixProvidedSemanticTokens(oe),this._send(x._convertToEdits(X,oe),oe)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return x._isSemanticTokens(z)?x._isCorrectSemanticTokens(z)?z:new C.SemanticTokens(new Uint32Array(z.data),z.resultId):x._isSemanticTokensEdits(z)?x._isCorrectSemanticTokensEdits(z)?z:new C.SemanticTokensEdits(z.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const ee of z.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,ee){if(!x._isSemanticTokens(ee)||!z||!z.tokens)return ee;const re=z.tokens,le=re.length,X=ee.data,oe=X.length;let ve=0;const Me=Math.min(le,oe);for(;ve<Me&&re[ve]===X[ve];)ve++;if(ve===le&&ve===oe)return new C.SemanticTokensEdits([],ee.resultId);let ze=0;const Qe=Me-ve;for(;ze<Qe&&re[le-ze-1]===X[oe-ze-1];)ze++;return new C.SemanticTokensEdits([{start:ve,deleteCount:le-ve-ze,data:X.subarray(ve,oe-ze)}],ee.resultId)}_send(z,ee){if(x._isSemanticTokens(z)){const re=this._nextResultId++;return this._previousResults.set(re,new U(z.resultId,z.data)),(0,f.encodeSemanticTokensDto)({id:re,type:"full",data:z.data})}if(x._isSemanticTokensEdits(z)){const re=this._nextResultId++;return x._isSemanticTokens(ee)?this._previousResults.set(re,new U(ee.resultId,ee.data)):this._previousResults.set(re,new U(z.resultId)),(0,f.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(z.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class M{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentRangeSemanticTokens(z,ee,re){const le=this._documents.getDocument(z),X=await this._provider.provideDocumentRangeSemanticTokens(le,I.Range.to(ee),re);return X?this._send(X):null}_send(z){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=M;class H{constructor(z,ee,re,le,X){this._documents=z,this._commands=ee,this._provider=re,this._apiDeprecation=le,this._extension=X,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,ee,re,le){const X=this._documents.getDocument(z),oe=I.Position.to(ee),ve=X.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=ve.with({end:oe}),ze=new _.StopWatch(!0),Qe=await this._provider.provideCompletionItems(X,oe,le,I.CompletionContext.to(re));if(!Qe||le.isCancellationRequested)return;const et=Array.isArray(Qe)?new C.CompletionList(Qe):Qe,ke=H.supportsResolving(this._provider)?this._cache.add(et.items):this._cache.add([]),ct=new d.DisposableStore;this._disposables.set(ke,ct);const K=[],te={x:ke,b:K,a:{replace:I.Range.from(ve),insert:I.Range.from(Me)},c:et.isIncomplete||void 0,d:ze.elapsed()};for(let pe=0;pe<et.items.length;pe++){const Ve=et.items[pe],tt=this._convertCompletionItem(Ve,[ke,pe],Me,ve);K.push(tt)}return te}async resolveCompletionItem(z,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...z);if(!re)return;const le=await this._provider.resolveCompletionItem(re,ee);if(!!le)return this._convertCompletionItem(le,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,ee,re,le){const X=this._disposables.get(ee[0]);if(!X)throw Error("DisposableStore is missing...");const oe={x:ee,a:z.label,b:z.kind!==void 0?I.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(I.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(z.command,X)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=z.textEdit.newText):typeof z.insertText=="string"?oe.h=z.insertText:z.insertText instanceof C.SnippetString&&(oe.h=z.insertText.value,oe.i|=4);let ve;return z.textEdit?ve=z.textEdit.range:z.range&&(ve=z.range),C.Range.isRange(ve)?oe.j=I.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(oe.j={insert:I.Range.from(ve.inserting),replace:I.Range.from(ve.replacing)}),oe}}class F{constructor(z,ee,re){this._documents=z,this._provider=ee,this._commands=re,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,ee,re,le){const X=this._documents.getDocument(z),oe=I.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(X,oe,re,le);if(!ve||le.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,ze=this._cache.add(Me.items);let Qe;return{pid:ze,items:Me.items.map((et,ke)=>{let ct;return et.command&&(Qe||(Qe=new d.DisposableStore,this._disposables.set(ze,Qe)),ct=this._commands.toInternal(et.command,Qe)),{text:et.text,range:et.range?I.Range.from(et.range):void 0,command:ct,idx:ke}})}}disposeCompletions(z){this._cache.delete(z);const ee=this._disposables.get(z);ee&&ee.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,ee){const re=this._cache.get(z,ee);re&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let ee=N.map.get(z);return ee||(ee=new N,N.map.set(z,ee)),ee}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=N,N.map=new WeakMap;class j{constructor(z,ee){this._documents=z,this._provider=ee,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(z,ee,re,le){const X=this._documents.getDocument(z),oe=I.Position.to(ee),ve=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(X,oe,le,ve);if(Me){const ze=this._cache.add([Me]);return{...I.SignatureHelp.from(Me),id:ze}}}reviveContext(z){let ee;if(z.activeSignatureHelp){const re=I.SignatureHelp.to(z.activeSignatureHelp),le=this._cache.get(z.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...z,activeSignatureHelp:ee}}releaseSignatureHelp(z){this._cache.delete(z)}}class W{constructor(z,ee){this._documents=z,this._provider=ee}async provideInlayHints(z,ee,re){const le=this._documents.getDocument(z),X=await this._provider.provideInlayHints(le,I.Range.to(ee),re);return X?{hints:X.map(I.InlayHint.from)}:void 0}}class Q{constructor(z,ee){this._documents=z,this._provider=ee,this._cache=new p.Cache("DocumentLink")}async provideLinks(z,ee){const re=this._documents.getDocument(z),le=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(Q._validateLink).map(I.DocumentLink.from)};{const X=this._cache.add(le),oe={links:[],id:X};for(let ve=0;ve<le.length;ve++){if(!Q._validateLink(le[ve]))continue;const Me=I.DocumentLink.from(le[ve]);Me.cacheId=[X,ve],oe.links.push(Me)}return oe}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...z);if(!re)return;const le=await this._provider.resolveDocumentLink(re,ee);if(!(!le||!Q._validateLink(le)))return I.DocumentLink.from(le)}releaseLinks(z){this._cache.delete(z)}}class J{constructor(z,ee){this._documents=z,this._provider=ee}async provideColors(z,ee){const re=this._documents.getDocument(z),le=await this._provider.provideDocumentColors(re,ee);return Array.isArray(le)?le.map(oe=>({color:I.Color.from(oe.color),range:I.Range.from(oe.range)})):[]}async provideColorPresentations(z,ee,re){const le=this._documents.getDocument(z),X=I.Range.to(ee.range),oe=I.Color.to(ee.color),ve=await this._provider.provideColorPresentations(oe,{document:le,range:X},re);if(!!Array.isArray(ve))return ve.map(I.ColorPresentation.from)}}class fe{constructor(z,ee){this._documents=z,this._provider=ee}async provideFoldingRanges(z,ee,re){const le=this._documents.getDocument(z),X=await this._provider.provideFoldingRanges(le,ee,re);if(!!Array.isArray(X))return X.map(I.FoldingRange.from)}}class _e{constructor(z,ee,re){this._documents=z,this._provider=ee,this._logService=re}async provideSelectionRanges(z,ee,re){const le=this._documents.getDocument(z),X=ee.map(I.Position.to),oe=await this._provider.provideSelectionRanges(le,X,re);if(!(0,P.isNonEmptyArray)(oe))return[];if(oe.length!==X.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<X.length;Me++){const ze=[];ve.push(ze);let Qe=X[Me],et=oe[Me];for(;;){if(!et.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(ze.push(I.SelectionRange.from(et)),!et.parent)break;Qe=et.range,et=et.parent}}return ve}}class ye{constructor(z,ee){this._documents=z,this._provider=ee,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.prepareCallHierarchy(le,X,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideCallsTo(z,ee,re){const le=this._itemFromCache(z,ee);if(!le)throw new Error("missing call hierarchy item");const X=await this._provider.provideCallHierarchyIncomingCalls(le,re);if(!!X)return X.map(oe=>({from:this._cacheAndConvertItem(z,oe.from),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}async provideCallsFrom(z,ee,re){const le=this._itemFromCache(z,ee);if(!le)throw new Error("missing call hierarchy item");const X=await this._provider.provideCallHierarchyOutgoingCalls(le,re);if(!!X)return X.map(oe=>({to:this._cacheAndConvertItem(z,oe.to),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,ee){const re=this._cache.get(z),le=I.CallHierarchyItem.from(ee,z,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(z,ee){return this._cache.get(z)?.get(ee)}}class Le{constructor(z,ee){this._documents=z,this._provider=ee,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(z,ee,re){const le=this._documents.getDocument(z),X=I.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(le,X,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideSupertypes(z,ee,re){const le=this._itemFromCache(z,ee);if(!le)throw new Error("missing type hierarchy item");const X=await this._provider.provideTypeHierarchySupertypes(le,re);if(!!X)return X.map(oe=>this._cacheAndConvertItem(z,oe))}async provideSubtypes(z,ee,re){const le=this._itemFromCache(z,ee);if(!le)throw new Error("missing type hierarchy item");const X=await this._provider.provideTypeHierarchySubtypes(le,re);if(!!X)return X.map(oe=>this._cacheAndConvertItem(z,oe))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,ee){const re=this._cache.get(z),le=I.TypeHierarchyItem.from(ee,z,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(z,ee){return this._cache.get(z)?.get(ee)}}class Be{constructor(z,ee){this.adapter=z,this.extension=ee}}class xe{constructor(z,ee,re,le,X,oe,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=z.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=le,this._diagnostics=X,this._logService=oe,this._apiDeprecation=ve}_transformDocumentSelector(z){return(0,P.coalesce)((0,P.asArray)(z).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:I.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new C.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return xe._handlePool++}_withAdapter(z,ee,re,le,X=!1){const oe=this._adapter.get(z);if(!oe)return Promise.resolve(le);if(oe.adapter instanceof ee){let ve;oe.extension&&(ve=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),ze=oe.extension;return ze&&Promise.resolve(Me).then(()=>this._logService.trace(`[${ze.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Qe=>{X&&Qe instanceof A.CancellationError||(this._logService.error(`[${ze.identifier.value}] provider FAILED`),this._logService.error(Qe))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,ee){const re=this._nextHandle();return this._adapter.set(re,new Be(z,ee)),re}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,ee,re,le){const X=this._addNewAdapter(new a(this._documents,re),z),oe=le&&le.label||xe._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(X,this._transformDocumentSelector(ee),oe),this._createDisposable(X)}$provideDocumentSymbols(z,ee,re){return this._withAdapter(z,a,le=>le.provideDocumentSymbols(g.URI.revive(ee),re),void 0)}registerCodeLensProvider(z,ee,re){const le=this._nextHandle(),X=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new l(this._documents,this._commands.converter,re),z)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),X);let oe=this._createDisposable(le);if(X!==void 0){const ve=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(X));oe=C.Disposable.from(oe,ve)}return oe}$provideCodeLenses(z,ee,re){return this._withAdapter(z,l,le=>le.provideCodeLenses(g.URI.revive(ee),re),void 0)}$resolveCodeLens(z,ee,re){return this._withAdapter(z,l,le=>le.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(z,ee){this._withAdapter(z,l,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(z,ee,re){const le=this._addNewAdapter(new t(this._documents,re),z);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(z,ee,re,le){return this._withAdapter(z,t,X=>X.provideDefinition(g.URI.revive(ee),re,le),[])}registerDeclarationProvider(z,ee,re){const le=this._addNewAdapter(new r(this._documents,re),z);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(z,ee,re,le){return this._withAdapter(z,r,X=>X.provideDeclaration(g.URI.revive(ee),re,le),[])}registerImplementationProvider(z,ee,re){const le=this._addNewAdapter(new o(this._documents,re),z);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(z,ee,re,le){return this._withAdapter(z,o,X=>X.provideImplementation(g.URI.revive(ee),re,le),[])}registerTypeDefinitionProvider(z,ee,re){const le=this._addNewAdapter(new i(this._documents,re),z);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(z,ee,re,le){return this._withAdapter(z,i,X=>X.provideTypeDefinition(g.URI.revive(ee),re,le),[])}registerHoverProvider(z,ee,re,le){const X=this._addNewAdapter(new c(this._documents,re),z);return this._proxy.$registerHoverProvider(X,this._transformDocumentSelector(ee)),this._createDisposable(X)}$provideHover(z,ee,re,le){return this._withAdapter(z,c,X=>X.provideHover(g.URI.revive(ee),re,le),void 0)}registerEvaluatableExpressionProvider(z,ee,re,le){const X=this._addNewAdapter(new h(this._documents,re),z);return this._proxy.$registerEvaluatableExpressionProvider(X,this._transformDocumentSelector(ee)),this._createDisposable(X)}$provideEvaluatableExpression(z,ee,re,le){return this._withAdapter(z,h,X=>X.provideEvaluatableExpression(g.URI.revive(ee),re,le),void 0)}registerInlineValuesProvider(z,ee,re,le){const X=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new m(this._documents,re),z);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),X);let ve=this._createDisposable(oe);if(X!==void 0){const Me=re.onDidChangeInlineValues(ze=>this._proxy.$emitInlineValuesEvent(X));ve=C.Disposable.from(ve,Me)}return ve}$provideInlineValues(z,ee,re,le,X){return this._withAdapter(z,m,oe=>oe.provideInlineValues(g.URI.revive(ee),re,le,X),void 0)}registerDocumentHighlightProvider(z,ee,re){const le=this._addNewAdapter(new w(this._documents,re),z);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(z,ee,re,le){return this._withAdapter(z,w,X=>X.provideDocumentHighlights(g.URI.revive(ee),re,le),void 0)}registerLinkedEditingRangeProvider(z,ee,re){const le=this._addNewAdapter(new S(this._documents,re),z);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(z,ee,re,le){return this._withAdapter(z,S,async X=>{const oe=await X.provideLinkedEditingRanges(g.URI.revive(ee),re,le);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?xe._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(z,ee,re){const le=this._addNewAdapter(new s(this._documents,re),z);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(z,ee,re,le,X){return this._withAdapter(z,s,oe=>oe.provideReferences(g.URI.revive(ee),re,le,X),void 0)}registerCodeActionProvider(z,ee,re,le){const X=new d.DisposableStore,oe=this._addNewAdapter(new b(this._documents,this._commands.converter,this._diagnostics,re,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,X)}))},xe._extLabel(z),Boolean(re.resolveCodeAction)),X.add(this._createDisposable(oe)),X}$provideCodeActions(z,ee,re,le,X){return this._withAdapter(z,b,oe=>oe.provideCodeActions(g.URI.revive(ee),re,le,X),void 0)}$resolveCodeAction(z,ee,re){return this._withAdapter(z,b,le=>le.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(z,ee){this._withAdapter(z,b,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(z,ee,re){const le=this._addNewAdapter(new R(this._documents,re),z);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentFormattingEdits(z,ee,re,le){return this._withAdapter(z,R,X=>X.provideDocumentFormattingEdits(g.URI.revive(ee),re,le),void 0)}registerDocumentRangeFormattingEditProvider(z,ee,re){const le=this._addNewAdapter(new O(this._documents,re),z);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(z,ee,re,le,X){return this._withAdapter(z,O,oe=>oe.provideDocumentRangeFormattingEdits(g.URI.revive(ee),re,le,X),void 0)}registerOnTypeFormattingEditProvider(z,ee,re,le){const X=this._addNewAdapter(new $(this._documents,re),z);return this._proxy.$registerOnTypeFormattingSupport(X,this._transformDocumentSelector(ee),le,z.identifier),this._createDisposable(X)}$provideOnTypeFormattingEdits(z,ee,re,le,X,oe){return this._withAdapter(z,$,ve=>ve.provideOnTypeFormattingEdits(g.URI.revive(ee),re,le,X,oe),void 0)}registerWorkspaceSymbolProvider(z,ee){const re=this._addNewAdapter(new G(ee,this._logService),z);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(z,ee,re){return this._withAdapter(z,G,le=>le.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(z,ee,re){return this._withAdapter(z,G,le=>le.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(z,ee){this._withAdapter(z,G,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(z,ee,re){const le=this._addNewAdapter(new Z(this._documents,re,this._logService),z);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),Z.supportsResolving(re)),this._createDisposable(le)}$provideRenameEdits(z,ee,re,le,X){return this._withAdapter(z,Z,oe=>oe.provideRenameEdits(g.URI.revive(ee),re,le,X),void 0)}$resolveRenameLocation(z,ee,re,le){return this._withAdapter(z,Z,X=>X.resolveRenameLocation(g.URI.revive(ee),re,le),void 0)}registerDocumentSemanticTokensProvider(z,ee,re,le){const X=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(X,new Be(new x(this._documents,re),z)),this._proxy.$registerDocumentSemanticTokensProvider(X,this._transformDocumentSelector(ee),le,oe);let ve=this._createDisposable(X);if(oe){const Me=re.onDidChangeSemanticTokens(ze=>this._proxy.$emitDocumentSemanticTokensEvent(oe));ve=C.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(z,ee,re,le){return this._withAdapter(z,x,X=>X.provideDocumentSemanticTokens(g.URI.revive(ee),re,le),null,!0)}$releaseDocumentSemanticTokens(z,ee){this._withAdapter(z,x,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(z,ee,re,le){const X=this._addNewAdapter(new M(this._documents,re),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(X,this._transformDocumentSelector(ee),le),this._createDisposable(X)}$provideDocumentRangeSemanticTokens(z,ee,re,le){return this._withAdapter(z,M,X=>X.provideDocumentRangeSemanticTokens(g.URI.revive(ee),re,le),null,!0)}registerCompletionItemProvider(z,ee,re,le){const X=this._addNewAdapter(new H(this._documents,this._commands.converter,re,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(X,this._transformDocumentSelector(ee),le,H.supportsResolving(re),`${z.identifier.value}(${le.join("")})`),this._createDisposable(X)}$provideCompletionItems(z,ee,re,le,X){return this._withAdapter(z,H,oe=>oe.provideCompletionItems(g.URI.revive(ee),re,le,X),void 0)}$resolveCompletionItem(z,ee,re){return this._withAdapter(z,H,le=>le.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(z,ee){this._withAdapter(z,H,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(z,ee,re){const le=this._addNewAdapter(new F(this._documents,re,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(z,ee,re,le,X){return this._withAdapter(z,F,oe=>oe.provideInlineCompletions(g.URI.revive(ee),re,le,X),void 0)}$handleInlineCompletionDidShow(z,ee,re){this._withAdapter(z,F,async le=>{le.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(z,ee){this._withAdapter(z,F,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(z,ee,re,le){const X=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,oe=this._addNewAdapter(new j(this._documents,re),z);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),X),this._createDisposable(oe)}$provideSignatureHelp(z,ee,re,le,X){return this._withAdapter(z,j,oe=>oe.provideSignatureHelp(g.URI.revive(ee),re,le,X),void 0)}$releaseSignatureHelp(z,ee){this._withAdapter(z,j,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(z,ee,re){const le=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,X=this._addNewAdapter(new W(this._documents,re),z);this._proxy.$registerInlayHintsProvider(X,this._transformDocumentSelector(ee),le);let oe=this._createDisposable(X);if(le!==void 0){const ve=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));oe=C.Disposable.from(oe,ve)}return oe}$provideInlayHints(z,ee,re,le){return this._withAdapter(z,W,X=>X.provideInlayHints(g.URI.revive(ee),re,le),void 0)}registerDocumentLinkProvider(z,ee,re){const le=this._addNewAdapter(new Q(this._documents,re),z);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(z,ee,re){return this._withAdapter(z,Q,le=>le.provideLinks(g.URI.revive(ee),re),void 0)}$resolveDocumentLink(z,ee,re){return this._withAdapter(z,Q,le=>le.resolveLink(ee,re),void 0)}$releaseDocumentLinks(z,ee){this._withAdapter(z,Q,re=>re.releaseLinks(ee),void 0)}registerColorProvider(z,ee,re){const le=this._addNewAdapter(new J(this._documents,re),z);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(z,ee,re){return this._withAdapter(z,J,le=>le.provideColors(g.URI.revive(ee),re),[])}$provideColorPresentations(z,ee,re,le){return this._withAdapter(z,J,X=>X.provideColorPresentations(g.URI.revive(ee),re,le),void 0)}registerFoldingRangeProvider(z,ee,re){const le=this._nextHandle(),X=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new fe(this._documents,re),z)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),X);let oe=this._createDisposable(le);if(X!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(X));oe=C.Disposable.from(oe,ve)}return oe}$provideFoldingRanges(z,ee,re,le){return this._withAdapter(z,fe,X=>X.provideFoldingRanges(g.URI.revive(ee),re,le),void 0)}registerSelectionRangeProvider(z,ee,re){const le=this._addNewAdapter(new _e(this._documents,re,this._logService),z);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(z,ee,re,le){return this._withAdapter(z,_e,X=>X.provideSelectionRanges(g.URI.revive(ee),re,le),[])}registerCallHierarchyProvider(z,ee,re){const le=this._addNewAdapter(new ye(this._documents,re),z);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(z,ee,re,le){return this._withAdapter(z,ye,X=>Promise.resolve(X.prepareSession(g.URI.revive(ee),re,le)),void 0)}$provideCallHierarchyIncomingCalls(z,ee,re,le){return this._withAdapter(z,ye,X=>X.provideCallsTo(ee,re,le),void 0)}$provideCallHierarchyOutgoingCalls(z,ee,re,le){return this._withAdapter(z,ye,X=>X.provideCallsFrom(ee,re,le),void 0)}$releaseCallHierarchy(z,ee){this._withAdapter(z,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(z,ee,re){const le=this._addNewAdapter(new Le(this._documents,re),z);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(z,ee,re,le){return this._withAdapter(z,Le,X=>Promise.resolve(X.prepareSession(g.URI.revive(ee),re,le)),void 0)}$provideTypeHierarchySupertypes(z,ee,re,le){return this._withAdapter(z,Le,X=>X.provideSupertypes(ee,re,le),void 0)}$provideTypeHierarchySubtypes(z,ee,re,le){return this._withAdapter(z,Le,X=>X.provideSubtypes(ee,re,le),void 0)}$releaseTypeHierarchy(z,ee){this._withAdapter(z,Le,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,D.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:xe._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:xe._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?xe._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?xe._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:xe._serializeRegExp(z.beforeText),afterText:z.afterText?xe._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?xe._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(xe._serializeOnEnterRule)}setLanguageConfiguration(z,ee,re){let{wordPattern:le}=re;if(le&&(0,D.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const X=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?xe._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?xe._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?xe._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(X,ee,oe),this._createDisposable(X)}$setWordDefinitions(z){for(const ee of z)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=xe,xe._handlePool=0}),define(me[242],ge([0,1,5,15,7,48,17]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(P,n){this._handlePool=0,this._proxy=P.getProxy(g.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,n){await this._proxy.$changeLanguage(P,n);const k=this._documents.getDocumentData(P);if(!k)throw new Error(`document '${P.toString}' NOT found`);return k.document}async tokenAtPosition(P,n){const k=P.version,d=L.Position.from(n),f=await this._proxy.$tokensAtPosition(P.uri,d),u={type:I.StandardTokenType.Other,range:P.getWordRangeAtPosition(n)??new I.Range(n.line,n.character,n.line,n.character)};if(!f)return u;const p={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!p.range.contains(n)||k!==P.version?u:p}createLanguageStatusItem(P){const n=this._handlePool++,k=this._proxy,d={selector:P,text:"",detail:"",severity:I.LanguageStatusSeverity.Information};let f;const u=()=>{f?.dispose(),f=(0,T.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:d.selector,text:d.text,message:typeof d.detail=="string"?d.detail:L.MarkdownString.from(d.detail),severity:d.severity===I.LanguageStatusSeverity.Error?C.default.Error:d.severity===I.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info})},0)},p={get selector(){return d.selector},set selector(_){d.selector=_,u()},get text(){return d.text},set text(_){d.text=_,u()},get detail(){return d.detail},set detail(_){d.detail=_,u()},get severity(){return d.severity},set severity(_){d.severity=_,u()},dispose(){f?.dispose(),k.$removeLanguageStatus(n)}};return u(),p}}e.ExtHostLanguages=D}),define(me[243],ge([0,1,5,12,35]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(D){return D&&D.title}let T=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(g.MainContext.MainThreadMessageService)}showMessage(y,P,n,k,d){const f={extension:y};let u;typeof k=="string"||C(k)?u=[k,...d]:(f.modal=k?.modal,f.useCustom=k?.useCustom,f.detail=k?.detail,u=d),f.useCustom&&(0,I.checkProposedApiEnabled)(y);const p=[];for(let _=0;_<u.length;_++){const A=u[_];if(typeof A=="string")p.push({title:A,handle:_,isCloseAffordance:!1});else if(typeof A=="object"){let{title:E,isCloseAffordance:a}=A;p.push({title:E,isCloseAffordance:!!a,handle:_})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(P,n,f,p).then(_=>{if(typeof _=="number")return u[_]})}};T=je([Ue(1,L.ILogService)],T),e.ExtHostMessageService=T}),define(me[244],ge([0,1,22,3,58,6,24,9,13,2,87,5,15,7,65,219,130]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(a,l,v,t,r){this._textDocumentsAndEditors=v,this._textDocuments=t,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const i=o.notebookEditor?.notebookUri,c=o.cell.handle,m=this._documents.get(i)?.getCell(c);if(m)return m.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const l=this._editors.get(a);if(!l)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(a){for(const[l,v]of this._editors)if(v.apiEditor===a)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,l){const v=this._documents.get(a);if(!v&&!l)throw new Error(`NO notebook document for '${a}'`);return v}_getProviderData(a){const l=this._notebookContentProviders.get(a);if(!l)throw new Error(`NO provider for '${a}'`);return l}registerNotebookContentProvider(a,l,v,t,r){if((0,D.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:a,provider:v});let o;return v.onDidChangeNotebookContentOptions&&(o=v.onDidChangeNotebookContentOptions(()=>{const i=d.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(l,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},l,d.NotebookDocumentContentOptions.from(t),A._convertNotebookRegistrationData(a,r)),new f.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(a,l){if(!l)return;const v=l.filenamePattern.map(t=>d.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(l.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:l.displayName,filenamePattern:v,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,l,v){const t=A._notebookStatusBarItemProviderHandlePool++,r=typeof v.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,r,l);let o;return r!==void 0&&(o=v.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(r))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,r),o&&o.dispose()})}async createNotebookDocument(a){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&d.NotebookData.from(a.content)});return P.URI.revive(l)}async openNotebookDocument(a){const l=this._documents.get(a);if(l)return l.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(a),t=this._documents.get(P.URI.revive(v));return(0,y.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(a,l){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let v;typeof l=="object"?v={position:d.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(d.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,v),r=t&&this._editors.get(t)?.apiEditor;if(r)return r;throw t?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,l,v,t){const r=this._notebookStatusBarItemProviders.get(a),o=P.URI.revive(l),i=this._documents.get(o);if(!i||!r)return;const c=i.getCellFromIndex(v);if(!c)return;const h=await r.provideCellStatusBarItems(c.apiCell,t);if(!h)return;const m=new C.DisposableStore,w=this._statusBarCache.add([m]),s=(Array.isArray(h)?h:[h]).map(b=>d.NotebookStatusBarItem.from(b,this._commandsConverter,m));return{cacheId:w,items:s}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,l,v,t,r){if((0,D.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,v),this._notebookProxy.$registerNotebookSerializer(o,{id:a.identifier,location:a.extensionLocation},l,d.NotebookDocumentContentOptions.from(t),A._convertNotebookRegistrationData(a,r)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(a,l,v){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const r=await t.deserializeNotebook(l.buffer,v);return new u.SerializableObjectWithBuffers(d.NotebookData.from(r))}async $notebookToData(a,l,v){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const r=await t.serializeNotebook(d.NotebookData.to(l.value),v);return g.VSBuffer.wrap(r)}async $openNotebook(a,l,v,t,r){const{provider:o}=this._getProviderData(a),i=await o.openNotebook(P.URI.revive(l),{backupId:v,untitledDocumentData:t?.buffer},r);return new u.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(d.NotebookCellData.from)})}async $saveNotebook(a,l,v){const t=this.getNotebookDocument(P.URI.revive(l)),{provider:r}=this._getProviderData(a);return await r.saveNotebook(t.apiNotebook,v),!0}async $saveNotebookAs(a,l,v,t){const r=this.getNotebookDocument(P.URI.revive(l)),{provider:o}=this._getProviderData(a);return await o.saveNotebookAs(P.URI.revive(v),r.apiNotebook,t),!0}async $backupNotebook(a,l,v){const t=this.getNotebookDocument(P.URI.revive(l)),r=this._getProviderData(a),o=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),i=String((0,I.hash)([t.uri.toString(),this._backupIdPool++])),c=P.URI.joinPath(o,i),h=await r.provider.backupNotebook(t.apiNotebook,{destination:c},v);return t.updateBackup(h),h.id}_createExtHostEditor(a,l,v){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const t=new _.ExtHostNotebookEditor(l,this._notebookEditorsProxy,a,v.visibleRanges.map(d.NotebookRange.to),v.selections.map(d.NotebookRange.to),typeof v.viewColumn=="number"?d.ViewColumn.to(v.viewColumn):void 0);this._editors.set(l,t)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const v of a.value.removedDocuments){const t=P.URI.revive(v),r=this._documents.get(t);r&&(r.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===t.toString()&&this._editors.delete(o.id)}if(a.value.addedDocuments){const v=[];for(const t of a.value.addedDocuments){const r=P.URI.revive(t.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const o=this,i=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){o._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){o._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){o._onDidChangeCellMetadata.fire(c)},emitCellExecutionStateChange(c){o._onDidChangeCellExecutionState.fire(c)}},r,t);v.push(...t.cells.map(c=>p.ExtHostCell.asModelAddData(i.apiNotebook,c))),this._documents.get(r)?.dispose(),this._documents.set(r,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const v of a.value.addedEditors){if(this._editors.has(v.id))return;const t=P.URI.revive(v.documentUri),r=this._documents.get(t);r&&this._createExtHostEditor(r,v.id,v)}const l=[];if(a.value.removedEditors)for(const v of a.value.removedEditors){const t=this._editors.get(v);t&&(this._editors.delete(v),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),l.push(t))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const v=new Set;this._visibleNotebookEditors.forEach(t=>v.add(t.id));for(const t of this._editors.values()){const r=v.has(t.id);t._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(me[245],ge([0,1,3,75,12,5,14,15]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(k,d){const f=y._Keys.nextId();k.$registerNotebookEditorDecorationType(f,D.NotebookDecorationRenderOptions.from(d)),this.value={key:f,dispose(){k.$removeNotebookEditorDecorationType(f)}}}}y._Keys=new L.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(k,d,f){this._logService=k,this._extHostRpc=d,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(k){return new y(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),k).value}$acceptEditorPropertiesChanged(k,d){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,d);const f=this._notebooksAndEditors.getEditorById(k);d.visibleRanges&&f._acceptVisibleRanges(d.visibleRanges.ranges.map(D.NotebookRange.to)),d.selections&&f._acceptSelections(d.selections.selections.map(D.NotebookRange.to)),d.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),d.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const d in k)this._notebooksAndEditors.getEditorById(d)._acceptViewColumn(D.ViewColumn.to(k[d]))}};P=je([Ue(0,I.ILogService),Ue(1,T.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(me[246],ge([0,1,20,17,21,3,6,24,2,26,12,5,15,7,89,212,35,65]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(r,o,i,c){this._initData=o,this._extHostNotebook=i,this._logService=c,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(r,o,i,c,h,m){for(let N of this._kernelData.values())if(N.controller.id===o&&P.ExtensionIdentifier.equals(r.identifier,N.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const w=this._handlePool++,S=this;this._logService.trace(`NotebookController[${w}], CREATED by ${r.identifier.value}, ${o}`);const s=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${r.identifier}'`);let b=!1;const R=new T.DisposableStore,O=new C.Emitter,$=new C.Emitter,G={id:`${r.identifier.value}/${o}`,notebookType:i,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:c||r.identifier.value,preloads:m?m.map(d.NotebookRendererScript.from):[]};let Z=h??s,U;this._proxy.$addKernel(w,G).catch(N=>{console.log(N),b=!0});let x=0;const M=()=>{if(b)return;const N=++x;Promise.resolve().then(()=>{N===x&&this._proxy.$updateKernel(w,G)})},H=new D.ResourceMap,F={get id(){return o},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return G.label},set label(N){G.label=N??r.displayName??r.name,M()},get detail(){return G.detail??""},set detail(N){G.detail=N,M()},get description(){return G.description??""},set description(N){G.description=N,M()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(N){G.supportedLanguages=N,M()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(N){G.supportsExecutionOrder=N,M()},get rendererScripts(){return G.preloads?G.preloads.map(d.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(N){Z=N??s},get interruptHandler(){return U},set interruptHandler(N){U=N,G.supportsInterrupt=Boolean(N),M()},createNotebookCellExecution(N){if(b)throw new Error("notebook controller is DISPOSED");if(!H.has(N.notebook.uri))throw S._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return S._createNotebookCellExecution(N)},dispose:()=>{b||(this._logService.trace(`NotebookController[${w}], DISPOSED`),b=!0,this._kernelData.delete(w),R.dispose(),O.dispose(),$.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(N,j){S._proxy.$updateNotebookPriority(w,N.uri,j)},onDidReceiveMessage:$.event,postMessage(N,j){return(0,_.checkProposedApiEnabled)(r),S._proxy.$postMessage(w,j&&S._extHostNotebook.getIdByEditor(j),N)},asWebviewUri(N){return(0,_.checkProposedApiEnabled)(r),(0,u.asWebviewUri)(N,S._initData.remote)}};return this._kernelData.set(w,{extensionId:r.identifier,controller:F,onDidReceiveMessage:$,onDidChangeSelection:O,associatedNotebooks:H}),F}$acceptNotebookAssociation(r,o,i){const c=this._kernelData.get(r);if(c){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(o));i?c.associatedNotebooks.set(h.uri,!0):c.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,h.uri.toString(),i),c.onDidChangeSelection.fire({selected:i,notebook:h.apiNotebook})}}async $executeCells(r,o,i){const c=this._kernelData.get(r);if(!c)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(o)),m=[];for(let w of i){const S=h.getCell(w);S&&m.push(S.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,h.uri.toString(),m.length),await c.controller.executeHandler.call(c.controller,m,h.apiNotebook,c.controller)}catch(w){this._logService.error(`NotebookController[${r}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(r,o,i){const c=this._kernelData.get(r);if(!c)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(o));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,h.apiNotebook);else for(let m of i){const w=h.getCell(m);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,o,i){const c=this._kernelData.get(r);if(!c)return;const h=this._extHostNotebook.getEditorById(o);c.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:i}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const c=new l(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,c);const h=c.onDidChangeState(()=>{c.state===a.Resolved&&(c.dispose(),h.dispose(),this._activeExecutions.delete(i.uri))});return c.asApiObject()}};E=je([Ue(3,n.ILogService)],E),e.ExtHostNotebookKernels=E;var a;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(a||(a={}));class l extends T.Disposable{constructor(r,o,i){super();this._document=r,this._cell=o,this._proxy=i,this._handle=l.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new v(10,c=>this.update(c)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const o=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new A.SerializableObjectWithBuffers(o))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let o=this._cell;if(r&&(o=this._document.getCellFromApiCell(r)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(r){return r.map(o=>{const i=f.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return i===o.items?d.NotebookCellOutput.from(o):d.NotebookCellOutput.from({items:i,id:o.id,metadata:o.metadata})})}async updateOutputs(r,o,i){const c=this.cellIndexToHandle(o),h=this.validateAndConvertOutputs((0,g.asArray)(r));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:c,append:i,outputs:h})}async updateOutputItems(r,o,i){return r=f.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(r),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(d.NotebookCellOutputItem.from),outputId:o.id,append:i})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(i){r._executionOrder=i,r.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(i){if(r._state===a.Resolved||r._state===a.Started)throw new Error("Cannot call start again");r._state=a.Started,r._onDidChangeState.fire(),r.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:i})},end(i,c){if(r._state===a.Resolved)throw new Error("Cannot call resolve twice");r._state=a.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:c,lastRunSuccess:i}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(i){return r.verifyStateForOutput(),r.updateOutputs([],i,!1)},appendOutput(i,c){return r.verifyStateForOutput(),r.updateOutputs(i,c,!0)},replaceOutput(i,c){return r.verifyStateForOutput(),r.updateOutputs(i,c,!1)},appendOutputItems(i,c){return r.verifyStateForOutput(),r.updateOutputItems(i,c,!0)},replaceOutputItems(i,c){return r.verifyStateForOutput(),r.updateOutputItems(i,c,!1)}})}}l.HANDLE=0;class v{constructor(r,o){this.delay=r,this.callback=o,this.batch=[],this.lastFlush=Date.now()}addItem(r){return this.batch.push(r),this.waitPromise||(this.waitPromise=(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.lastFlush>this.delay&&this.flush(),this.waitPromise}flush(){if(this.batch.length===0)return;this.lastFlush=Date.now(),this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)}}}),define(me[247],ge([0,1,3,5,130]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(D,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,y,P){const n=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(y)?.fire({editor:n.apiEditor,message:P})}createRendererMessaging(D,y){if(!D.contributes?.notebookRenderer?.some(d=>d.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const P=!!D.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(d,f,u)=>{const p=P?d:_=>{const A={};n.set(A,_.editor),d({editor:A,message:_.message})};return this.getOrCreateEmitterFor(y).event(p,f,u)},postMessage:(d,f)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(d)&&([d,f]=[f,d]);const u=P?f:n.get(f),p=u&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(p?.id,y,d)}}}getOrCreateEmitterFor(D){let y=this._rendererMessageEmitters.get(D);return y||(y=new g.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,y),y)}}e.ExtHostNotebookRenderers=C}),define(me[67],ge([0,1,5,3,6,22,4,14]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends I.Disposable{constructor(u,p,_,A,E){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=E,this._id=E.$register(this.name,p,_,A),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?C.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(p=>this._proxy.$clear(p,u))}show(u,p){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof u=="boolean"?u:p)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class P extends y{constructor(u,p,_){super(u,!1,void 0,p,_)}append(u){super.append(u),this._id.then(p=>this._proxy.$append(p,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class n extends y{constructor(u,p,_){super(u,!0,p,void 0,_)}append(u){throw new Error("Not supported")}}class k{constructor(u,p){this.name=u,this._channel=p}append(u){this._channel.then(p=>p.append(u))}appendLine(u){this._channel.then(p=>p.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,p){this._channel.then(_=>_.show(u,p))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=k;let d=class{constructor(u){this._proxy=u.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,p){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new P(u,p.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,p){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!p)throw new Error("illegal argument `file`. must not be falsy");return new n(u,p,this._proxy)}};d=je([Ue(0,D.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(me[248],ge([0,1,17,21,3,6,5,2,7,16,20,48,62]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(u,p,_){const A=u.getProxy(T.MainContext.MainThreadQuickOpen);class E{constructor(h,m){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=m}showQuickPick(h,m,w,S=L.CancellationToken.None){this._onDidSelectItem=void 0;const s=Promise.resolve(h),b=++this._instances,R=A.$show(b,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},S),O={},$=R.then(()=>O);return Promise.race([$,s]).then(G=>{if(G!==O)return s.then(Z=>{const U=[];for(let x=0;x<Z.length;x++){const M=Z[x];let H,F,N,j,W;typeof M=="string"?H=M:(H=M.label,F=M.description,N=M.detail,j=M.picked,W=M.alwaysShow),U.push({label:H,description:F,handle:x,detail:N,picked:j,alwaysShow:W})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{w.onDidSelectItem(Z[x])}),A.$setItems(b,U),R.then(x=>{if(typeof x=="number")return Z[x];if(Array.isArray(x))return x.map(M=>Z[M])})})}).then(void 0,G=>{if(!(0,P.isPromiseCanceledError)(G))return A.$setError(b,G),Promise.reject(G)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,m=L.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,A.$input(h,typeof this._validateInput=="function",m).then(void 0,w=>{if(!(0,P.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(h){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,m=L.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!w)return;const S=await this._workspace.getWorkspaceFolders2();if(!!S)return S.find(s=>s.uri.toString()===w.uri.toString())}createQuickPick(h,m){const w=new o(h,m,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(h){const m=new i(h,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(h,m){const w=this._sessions.get(h);w&&w._fireDidChangeValue(m)}$onDidAccept(h){const m=this._sessions.get(h);m&&m._fireDidAccept()}$onDidChangeActive(h,m){const w=this._sessions.get(h);w instanceof o&&w._fireDidChangeActive(m)}$onDidChangeSelection(h,m){const w=this._sessions.get(h);w instanceof o&&w._fireDidChangeSelection(m)}$onDidTriggerButton(h,m){const w=this._sessions.get(h);w&&w._fireDidTriggerButton(m)}$onDidTriggerItemButton(h,m,w){const S=this._sessions.get(h);S instanceof o&&S._fireDidTriggerItemButton(m,w)}$onDidHide(h){const m=this._sessions.get(h);m&&m._fireDidHide()}}class a{constructor(h,m){this._extensionId=h,this._onDidDispose=m,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((m,w)=>{const S=m===y.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(S,m)}),this.update({buttons:h.map((m,w)=>({...r(m),tooltip:m.tooltip,handle:m===y.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const m=this._handlesToButtons.get(h);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),A.$dispose(this._id))}update(h){if(!this._disposed){for(const m of Object.keys(h)){const w=h[m];this._pendingUpdate[m]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){A.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function l(c){if(c instanceof y.ThemeIcon)return{id:c.id};const h=t(c),m=v(c);return{dark:typeof h=="string"?D.URI.file(h):h,light:typeof m=="string"?D.URI.file(m):m}}function v(c){return typeof c=="object"&&"light"in c?c.light:c}function t(c){return typeof c=="object"&&"dark"in c?c.dark:c}function r(c){const h=l(c.iconPath);let m,w;return"id"in h?w=d.ThemeIcon.asClassName(h):m=h,{iconPath:m,iconClass:w}}class o extends a{constructor(h,m,w){super(h,w);this.enableProposedApi=m,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((m,w)=>{this._handlesToItems.set(w,m),this._itemsToHandles.set(m,w)}),this.update({items:h.map((m,w)=>({label:m.label,description:m.description,handle:w,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons&&this.enableProposedApi?m.buttons.map((S,s)=>({...r(S),tooltip:S.tooltip,handle:s})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(h){const m=(0,n.coalesce)(h.map(w=>this._handlesToItems.get(w)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(h){const m=(0,n.coalesce)(h.map(w=>this._handlesToItems.get(w)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(h,m){const w=this._handlesToItems.get(h);if(!w||!w.buttons||!w.buttons.length)return;const S=w.buttons[m];S&&this._onDidTriggerItemButtonEmitter.fire({button:S,item:w})}}class i extends a{constructor(h,m){super(h,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?k.default.Error:k.default.Ignore})}}return new E(p,_)}e.createExtHostQuickOpen=f}),define(me[249],ge([0,1,2,3,56,6,17,5,20,100,12,26,35,62,15]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(h){if(h)return typeof h.iconPath=="string"?g.URI.file(h.iconPath):g.URI.isUri(h.iconPath)||f.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function _(h,m){if(!h.iconPath&&!m.iconPath)return 0;if(h.iconPath){if(!m.iconPath)return 1}else return-1;const w=typeof h.iconPath=="string"?h.iconPath:g.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,S=typeof m.iconPath=="string"?m.iconPath:g.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,P.comparePaths)(w,S)}function A(h,m){let w=0;if(h.strikeThrough!==m.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==m.faded)return h.faded?1:-1;if(h.tooltip!==m.tooltip)return(h.tooltip||"").localeCompare(m.tooltip||"");if(w=_(h,m),w!==0)return w;if(h.light&&m.light)w=_(h.light,m.light);else{if(h.light)return 1;if(m.light)return-1}if(w!==0)return w;if(h.dark&&m.dark)w=_(h.dark,m.dark);else{if(h.dark)return 1;if(m.dark)return-1}return w}function E(h,m){if(h.command!==m.command)return h.command<m.command?-1:1;if(h.title!==m.title)return h.title<m.title?-1:1;if(h.tooltip!==m.tooltip){if(h.tooltip!==void 0&&m.tooltip!==void 0)return h.tooltip<m.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(h.arguments===m.arguments)return 0;if(h.arguments)if(m.arguments){if(h.arguments.length!==m.arguments.length)return h.arguments.length-m.arguments.length}else return 1;else return-1;for(let w=0;w<h.arguments.length;w++){const S=h.arguments[w],s=m.arguments[w];if(S!==s)return S<s?-1:1}return 0}function a(h,m){let w=(0,P.comparePaths)(h.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(w!==0)return w;if(h.command&&m.command)w=E(h.command,m.command);else{if(h.command)return 1;if(m.command)return-1}if(w!==0)return w;if(h.decorations&&m.decorations)w=A(h.decorations,m.decorations);else{if(h.decorations)return 1;if(m.decorations)return-1}return w}function l(h,m){for(let w=0;w<h.length;w++)if(h[w]!==m[w])return!1;return!0}function v(h,m){return h.command===m.command&&h.title===m.title&&h.tooltip===m.tooltip&&(h.arguments&&m.arguments?l(h.arguments,m.arguments):h.arguments===m.arguments)}function t(h,m){return(0,y.equals)(h,m,v)}class r{constructor(m,w,S){this._extension=m,this._proxy=w,this._sourceControlHandle=S,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,d.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,w){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,w)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=r;class o{constructor(m,w,S,s,b){this._proxy=m,this._commands=w,this._sourceControlHandle=S,this._id=s,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,w){const S=this._resourceStatesCommandsMap.get(m);return S?(0,T.asPromise)(()=>this._commands.executeCommand(S.command,...S.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(a),S=(0,y.sortedDiff)(this._resourceSnapshot,m,a).map(R=>{const O=R.toInsert.map($=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,$);const Z=$.resourceUri;let U;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const fe=new C.DisposableStore;U=this._commands.converter.toInternal($.command,fe),this._resourceStatesDisposablesMap.set(G,fe)}else this._resourceStatesCommandsMap.set(G,$.command);const x=p($.decorations),M=$.decorations&&p($.decorations.light)||x,H=$.decorations&&p($.decorations.dark)||x,F=[M,H],N=$.decorations&&$.decorations.tooltip||"",j=$.decorations&&!!$.decorations.strikeThrough,W=$.decorations&&!!$.decorations.faded,Q=$.contextValue||"";return{rawResource:[G,Z,F,N,j,W,Q,U],handle:G}});return{start:R.start,deleteCount:R.deleteCount,toInsert:O}}),s=S.map(({start:R,deleteCount:O,toInsert:$})=>[R,O,$.map(G=>G.rawResource)]),b=S.reverse();for(const{start:R,deleteCount:O,toInsert:$}of b){const G=$.map(U=>U.handle),Z=this._handlesSnapshot.splice(R,O,...G);for(const U of Z)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=m,s}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class i{constructor(m,w,S,s,b,R){this._proxy=w,this._commands=S,this._id=s,this._label=b,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,s,b,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=m;const w=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&t(this._statusBarCommands,m))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=m;const w=(m||[]).map(S=>this._commands.converter.toInternal(S,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(m,w){const S=new o(this._proxy,this._commands,this.handle,m,w),s=L.Event.once(S.onDidDispose)(()=>this.createdResourceGroups.delete(S));return this.createdResourceGroups.set(S,s),this.eventuallyAddResourceGroups(),S}eventuallyAddResourceGroups(){const m=[],w=[];for(const[S,s]of this.createdResourceGroups){s.dispose();const b=S.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(S),this.eventuallyUpdateResourceStates()});L.Event.once(S.onDidDispose)(()=>{this.updatedResourceGroups.delete(S),b.dispose(),this._groups.delete(S.handle),this._proxy.$unregisterGroup(this.handle,S.handle)}),m.push([S.handle,S.id,S.label,S.features]);const R=S._takeResourceStateSnapshot();R.length>0&&w.push([S.handle,R]),this._groups.set(S.handle,S)}this._proxy.$registerGroups(this.handle,m,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(w=>{const S=w._takeResourceStateSnapshot();S.length!==0&&m.push([w.handle,S])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let c=class Bn{constructor(m,w,S){this._commands=w,this.logService=S,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=m.getProxy(D.MainContext.MainThreadSCM),this._telemetry=m.getProxy(D.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===3){const b=this._sourceControls.get(s.sourceControlHandle);if(!b)return s;const R=b.getResourceGroup(s.groupHandle);return R?R.getResourceState(s.handle):s}else if(s&&s.$mid===4){const b=this._sourceControls.get(s.sourceControlHandle);return b?b.getResourceGroup(s.groupHandle):s}else if(s&&s.$mid===5){const b=this._sourceControls.get(s.handle);return b||s}return s}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,w,S,s){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,w,S,s),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const b=Bn._handlePool++,R=new i(m,this._proxy,this._commands,w,S,s);this._sourceControls.set(b,R);const O=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(m.identifier))||[];return O.push(R),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(m.identifier),O),R}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const w=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(m.identifier)),S=w&&w[w.length-1];return S&&S.inputBox}$provideOriginalResource(m,w,S){const s=g.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,s.toString());const b=this._sourceControls.get(m);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>b.quickDiffProvider.provideOriginalResource(s,S)).then(R=>R||null)}$onInputBoxValueChange(m,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const S=this._sourceControls.get(m);return S&&S.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(m,w,S,s){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,w,S);const b=this._sourceControls.get(m);if(!b)return Promise.resolve(void 0);const R=b.getResourceGroup(w);return R?R.$executeResourceCommand(S,s):Promise.resolve(void 0)}$validateInput(m,w,S){this.logService.trace("ExtHostSCM#$validateInput",m);const s=this._sourceControls.get(m);return!s||!s.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>s.inputBox.validateInput(w,S)).then(b=>{if(!b)return Promise.resolve(void 0);const R=u.MarkdownString.fromStrict(b.message);return R?Promise.resolve([R,b.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};c._handlePool=0,c=je([Ue(2,n.ILogService)],c),e.ExtHostSCM=c});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[250],ge([0,1,7,5,167,6,15]),function(Y,e,g,L,I,C,T){"use strict";var D,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(f,u,p,_,A=g.StatusBarAlignment.Left,E){D.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,rt(this,D,f,"f"),rt(this,y,u,"f"),this._entryId=P.ID_GEN++,this._extension=p,this._id=_,this._alignment=A,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!P.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:$e(this,y,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:$e(this,y,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let u;this._name?u=this._name:u=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;$e(this,D,"f").$setEntry(this._entryId,f,u,this._text,_,this._command?.internal,p,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,D=new WeakMap,y=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const u={message:f};return this._messages.unshift(u),this._update(),new g.Disposable(()=>{const p=this._messages.indexOf(u);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class k{constructor(f,u){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new n(this)}createStatusBarEntry(f,u,p,_){return new P(this._proxy,this._commands,f,u,p,_)}setStatusBarMessage(f,u){const p=this._statusMessage.setMessage(f);let _;return typeof u=="number"?_=setTimeout(()=>p.dispose(),u):typeof u!="undefined"&&u.then(()=>p.dispose(),()=>p.dispose()),new g.Disposable(()=>{p.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=k}),define(me[93],ge([0,1,5,3,4]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(D){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,y){this._proxy.$registerExtensionStorageKeysToSync(D,y)}getValue(D,y,P){return this._proxy.$getValue(D,y).then(n=>n||P)}setValue(D,y,P){return this._proxy.$setValue(D,y,P)}$acceptValue(D,y,P){this._onDidChangeStorage.fire({shared:D,key:y,value:P})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(me[68],ge([0,1,4,27,12,92,2]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let D=class{constructor(P,n,k){this._logService=n,this._extHostFileSystem=k,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getWorkspaceStorageURI(P){return T.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,n=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(P){if(this._value)return T.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return T.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=je([Ue(0,L.IExtHostInitDataService),Ue(1,I.ILogService),Ue(2,C.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(me[33],ge([0,1,3,5,4,2,14,6,7,168,16,214,21,32,195,62,13]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class A{constructor(c,h,m,w){this._proxy=c,this._id=h,this._creationOptions=m,this._name=w,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(s=>this._pidPromiseComplete=s);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(s,b=!0){S._checkDisposed(),S._proxy.$sendText(S._id,s,b)},show(s){S._checkDisposed(),S._proxy.$show(S._id,s)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(c,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,_.withNullAsUndefined)(c.shellPath),shellArgs:(0,_.withNullAsUndefined)(c.shellArgs),cwd:(0,_.withNullAsUndefined)(c.cwd),env:(0,_.withNullAsUndefined)(c.env),icon:(0,_.withNullAsUndefined)(r(c.iconPath)),color:p.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,_.withNullAsUndefined)(c.message),strictEnv:(0,_.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(h?.useShellEnvironment),location:this._serializeParentTerminal(c.location,h?.resolvedExtHostIdentifier,h?.splitActiveTerminal)})}async createExtensionTerminal(c,h,m,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:p.ThemeColor.isThemeColor(w)?w.id:void 0,location:this._serializeParentTerminal(c,h)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,h,m){return typeof c=="object"&&"parentTerminal"in c?h?{parentTerminal:h}:void 0:m?{splitActiveTerminal:!0}:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,h){return c===this._cols&&h===this._rows||c===0||h===0?!1:(this._cols=c,this._rows=h,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=A;class E{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,h){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:h})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose&&this._pty.onDidClose((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(h=>this._onProcessOverrideDimensions.fire(h&&{cols:h.columns,rows:h.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(h=>this._onProcessTitleChanged.fire(h)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let a=1,l=class extends D.Disposable{constructor(c,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=h.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[m,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,h){const m=new A(this._proxy,(0,f.generateUuid)(),c,c.name),w=new E(c.pty);return m.createExtensionTerminal(this._resolveLocation(c.location),h?.resolvedExtHostIdentifier,r(c.iconPath),o(c.color)).then(S=>{const s=this._setupExtHostProcessListeners(S,w);this._terminalProcessDisposables[S]=s}),this._terminals.push(m),m.value}_resolveLocation(c){if(!(typeof c=="object"&&"parentTerminal"in c))return c}attachPtyToTerminal(c,h){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const w=new E(h),S=this._setupExtHostProcessListeners(c,w);this._terminalProcessDisposables[c]=S}async $acceptActiveTerminalChanged(c){const h=this._activeTerminal;if(c===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(c);m&&(this._activeTerminal=m,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,h){const m=this._getTerminalById(c);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:h})}async $acceptTerminalDimensions(c,h,m){const w=this._getTerminalById(c);w&&w.setDimensions(h,m)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(c,h,m){this._terminalProcesses.get(c)?.resize(h,m)}async $acceptTerminalTitleChange(c,h){const m=this._getTerminalById(c);m&&(m.name=h)}async $acceptTerminalClosed(c,h){const m=this._getTerminalObjectIndexById(this._terminals,c);if(m!==null){const w=this._terminals.splice(m,1)[0];w.setExitCode(h),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(c,h,m,w){if(h){const b=this._getTerminalObjectIndexById(this._terminals,h);if(b!==null){this._terminals[b]._id=c,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const S={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:C.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},s=new A(this._proxy,c,S,m);this._terminals.push(s),this._onDidOpenTerminal.fire(s.value),s.isOpen=!0}async $acceptTerminalProcessId(c,h){const m=this._getTerminalById(c);m&&m._setProcessId(h)}async $startExtensionTerminal(c,h){const m=this._getTerminalById(c);if(!m)return{message:(0,P.localize)(0,null,c)};m.isOpen||await new Promise(S=>{const s=this.onDidOpenTerminal(async b=>{b===m.value&&(s.dispose(),S())})});const w=this._terminalProcesses.get(c);w?w.startSendingEvents(h):this._extensionTerminalAwaitingStart[c]={initialDimensions:h}}_setupExtHostProcessListeners(c,h){const m=new D.DisposableStore;m.add(h.onProcessReady(S=>this._proxy.$sendProcessReady(c,S.pid,S.cwd))),m.add(h.onProcessTitleChanged(S=>this._proxy.$sendProcessTitle(c,S))),this._bufferer.startBuffering(c,h.onProcessData),m.add(h.onProcessExit(S=>this._onProcessExit(c,S))),h.onProcessOverrideDimensions&&m.add(h.onProcessOverrideDimensions(S=>this._proxy.$sendOverrideDimensions(c,S))),this._terminalProcesses.set(c,h);const w=this._extensionTerminalAwaitingStart[c];return w&&h instanceof E&&(h.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),m}$acceptProcessAckDataEvent(c,h){this._terminalProcesses.get(c)?.acknowledgeDataEvent(h)}$acceptProcessInput(c,h){this._terminalProcesses.get(c)?.input(h)}$acceptTerminalInteraction(c){const h=this._getTerminalById(c);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(c,h,m){try{this._terminalProcesses.get(c)?.resize(h,m)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(c,h){this._terminalProcesses.get(c)?.shutdown(h)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(h=>this._proxy.$sendProcessInitialCwd(c,h))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(h=>this._proxy.$sendProcessCwd(c,h))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,h,m){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,m),this._proxy.$registerProfileProvider(h,c.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(c,h){const m=new d.CancellationTokenSource().token,w=await this._profileProviders.get(c)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,h);return}this.createTerminalFromOptions(w.options,h)}}async $provideLinks(c,h){const m=this._getTerminalById(c);if(!m)return[];this._terminalLinkCache.delete(c);const w=this._terminalLinkCancellationSource.get(c);w&&w.dispose(!0);const S=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,S);const s=[],b={terminal:m.value,line:h},R=[];for(const G of this._linkProviders)R.push(new Promise(async Z=>{S.token.onCancellationRequested(()=>Z({provider:G,links:[]}));const U=await G.provideTerminalLinks(b,S.token)||[];S.token.isCancellationRequested||Z({provider:G,links:U})}));const O=await Promise.all(R);if(S.token.isCancellationRequested)return[];const $=new Map;for(const G of O)G&&G.links.length>0&&s.push(...G.links.map(Z=>{const U={id:a++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return $.set(U.id,{provider:G.provider,link:Z}),U}));return this._terminalLinkCache.set(c,$),s}$activateLink(c,h){const m=this._terminalLinkCache.get(c)?.get(h);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(c,h){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const m=this._terminalProcessDisposables[c];m&&(m.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,h)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,h){const m=this._getTerminalObjectIndexById(c,h);return m!==null?c[m]:null}_getTerminalObjectIndexById(c,h){let m=null;return c.some((w,S)=>w._id===h?(m=S,!0):!1),m}getEnvironmentVariableCollection(c){let h=this._environmentVariableCollections.get(c.identifier.value);return h||(h=new v,this._setEnvironmentVariableCollection(c.identifier.value,h)),h}_syncEnvironmentVariableCollection(c,h){const m=(0,k.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(c,h.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(c){c.forEach(h=>{const m=h[0],w=new v(h[1]);this._setEnvironmentVariableCollection(m,w)})}$acceptDefaultProfile(c,h){this._defaultProfile=c,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(c,h){this._environmentVariableCollections.set(c,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,h)})}};l=je([Ue(1,T.IExtHostRpcService)],l),e.BaseExtHostTerminalService=l;class v{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,h){this._setIfDiffers(c,{value:h,type:y.EnvironmentVariableMutatorType.Replace})}append(c,h){this._setIfDiffers(c,{value:h,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,h){this._setIfDiffers(c,{value:h,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,h){const m=this.map.get(c);(!m||m.value!==h.value||m.type!==h.type)&&(this.map.set(c,h),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,h){this.map.forEach((m,w)=>c.call(h,w,m,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends l{constructor(c){super(!1,c)}createTerminal(c,h,m){throw new n.NotSupportedError}createTerminalFromOptions(c,h){throw new n.NotSupportedError}};t=je([Ue(0,T.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function o(i){return p.ThemeColor.isThemeColor(i)?i:void 0}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[251],ge([0,1,22,21,3,74,58,76,6,23,13,32,5,14,88,15,7,222,128,90]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(R,O){this.resultsChangedEmitter=new I.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(d.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new r(this.proxy),O.registerArgumentProcessor({processArgument:$=>$?.$mid===13?p.TestItem.toItemFromContext($):$})}createTestController(R,O){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const $=new y.DisposableStore,G=$.add(new A.SingleUseTestCollection(R));G.root.label=O;const Z=new Map,U=this.proxy,x={items:G.root.children,get label(){return O},set label(H){O=H,G.root.label=H,U.$updateControllerLabel(R,O)},get id(){return R},createRunProfile:(H,F,N,j,W)=>{let Q=(0,T.hash)(H);for(;Z.has(Q);)Q++;const J=new S(this.proxy,R,Q,H,F,N,j,W);return Z.set(Q,J),J},createTestItem(H,F,N){return new u.TestItemImpl(R,H,F,N)},createTestRun:(H,F,N=!0)=>this.runTracker.createTestRun(R,G,H,F,N),set resolveHandler(H){G.resolveHandler=H},get resolveHandler(){return G.resolveHandler},dispose:()=>{$.dispose()}};x.createRunConfiguration=x.createRunProfile,U.$registerTestController(R,O),$.add((0,y.toDisposable)(()=>U.$unregisterTestController(R)));const M={controller:x,collection:G,profiles:Z};return this.controllers.set(R,M),$.add((0,y.toDisposable)(()=>this.controllers.delete(R))),$.add(G.onDidGenerateDiff(H=>U.$publishDiff(R,H))),x}createTestObserver(){return this.observer.checkout()}async runTests(R,O=L.CancellationToken.None){const $=o(R);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const G=this.controllers.get($.controllerId);if(!G)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(Z=>Z.id)??[G.collection.root.id],profileGroup:s[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:R.exclude?.map(Z=>Z.id)},O)}$provideFileCoverage(R,O,$){return D.Iterable.find(this.runTracker.trackers,G=>G.id===R)?.getCoverage(O)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(R,O,$,G){return D.Iterable.find(this.runTracker.trackers,Z=>Z.id===R)?.getCoverage(O)?.resolveFileCoverage($,G)??Promise.resolve([])}$configureRunProfile(R,O){this.controllers.get(R)?.profiles.get(O)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(O=>(0,P.deepFreeze)(p.TestResults.to(O))).concat(this.results).sort((O,$)=>$.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,O){const $=this.controllers.get(a.TestId.fromString(R).controllerId)?.collection;$&&(await $.expand(R,O<0?Infinity:O),$.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,O){const $=this.controllers.get(R.controllerId);if(!$)return;const{collection:G,profiles:Z}=$,U=Z.get(R.profileId);if(!U)return;const x=R.testIds.map(N=>G.tree.get(N)).filter(n.isDefined),M=R.excludeExtIds.map(N=>$.collection.tree.get(N)).filter(n.isDefined).filter(N=>x.some(j=>j.fullId.compare(N.fullId)===2));if(!x.length)return;const H=new _.TestRunRequest(x.some(N=>N.actual instanceof u.TestItemRootImpl)?void 0:x.map(N=>N.actual),M.map(N=>N.actual),U),F=this.runTracker.prepareForMainThreadTestRun(H,i.fromInternal(R,$.collection),O);try{await U.runHandler(H,O)}finally{F.isRunning&&!O.isCancellationRequested&&await I.Event.toPromise(F.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};v=je([Ue(0,f.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends y.Disposable{constructor(R,O,$){super();this.dto=R,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new I.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource($)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:G}of this.tasks.values())G.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const O=this.dto.id,$=this.dto.controllerId,G=(0,k.generateUuid)(),Z=new c(this.proxy,O,G),U=H=>(F,...N)=>{if(x){console.warn(`Setting the state of test "${F.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(F)||(this.ensureTestIsKnown(F),H(F,...N))};let x=!1;const M={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return Z.coverageProvider},set coverageProvider(H){Z.coverageProvider=H},enqueued:U(H=>{this.proxy.$updateTestStateInRun(O,G,a.TestId.fromExtHostTestItem(H,$).toString(),1)}),skipped:U(H=>{this.proxy.$updateTestStateInRun(O,G,a.TestId.fromExtHostTestItem(H,$).toString(),5)}),started:U(H=>{this.proxy.$updateTestStateInRun(O,G,a.TestId.fromExtHostTestItem(H,$).toString(),2)}),errored:U((H,F,N)=>{this.proxy.$appendTestMessagesInRun(O,G,a.TestId.fromExtHostTestItem(H,$).toString(),F instanceof Array?F.map(p.TestMessage.from):[p.TestMessage.from(F)]),this.proxy.$updateTestStateInRun(O,G,a.TestId.fromExtHostTestItem(H,$).toString(),6,N)}),failed:U((H,F,N)=>{this.proxy.$appendTestMessagesInRun(O,G,a.TestId.fromExtHostTestItem(H,$).toString(),F instanceof Array?F.map(p.TestMessage.from):[p.TestMessage.from(F)]),this.proxy.$updateTestStateInRun(O,G,a.TestId.fromExtHostTestItem(H,$).toString(),4,N)}),passed:U((H,F)=>{this.proxy.$updateTestStateInRun(O,G,a.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,F)}),appendOutput:(H,F,N)=>{x||(N&&(this.dto.isIncluded(N)?this.ensureTestIsKnown(N):N=void 0),this.proxy.$appendOutputToRun(O,G,g.VSBuffer.fromString(H),F&&p.location.from(F),N&&a.TestId.fromExtHostTestItem(N,$).toString()))},end:()=>{x||(x=!0,this.proxy.$finishedTestRunTask(O,G),this.tasks.delete(G),this.isRunning||this.dispose())}};return this.tasks.set(G,{run:M,coverage:Z}),this.proxy.$startedTestRunTask(O,{id:G,name:R,running:!0}),M}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof u.TestItemImpl))throw new u.InvalidTestItemError(R.id);if(this.sharedTestIds.has(R.id))return;const O=[];for(;O.unshift(p.TestItem.from(R)),!(this.sharedTestIds.has(R.id)||(this.sharedTestIds.add(R.id),!R.parent));)R=R.parent;const $=this.dto.colllection.root;this.sharedTestIds.has($.id)||(this.sharedTestIds.add($.id),O.unshift(p.TestItem.from($))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class r{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,O,$){return this.getTracker(R,O,$)}cancelRunById(R){for(const O of this.tracked.values())if(O.id===R){O.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,O,$,G,Z){const U=this.tracked.get($);if(U)return U.createRun(G);const x=i.fromPublic(R,O,$,Z),M=o($);this.proxy.$startedExtensionTestRun({controllerId:R,profile:M&&{group:s[M.kind],id:M.profileId},exclude:$.exclude?.map(F=>F.id)??[],id:x.id,include:$.include?.map(F=>F.id)??[O.root.id],persist:Z});const H=this.getTracker($,x);return H.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),H.createRun(G)}getTracker(R,O,$){const G=new t(O,this.proxy,$);return this.tracked.set(R,G),G.onEnd(()=>this.tracked.delete(R)),G}}e.TestRunCoordinator=r;const o=b=>{if(!!b.profile){if(!(b.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return b.profile}};class i{constructor(R,O,$,G,Z,U){this.controllerId=R,this.id=O,this.isPersisted=Z,this.colllection=U,this.includePrefix=$.map(x=>x+"\0"),this.excludePrefix=G.map(x=>x+"\0")}static fromPublic(R,O,$,G){return new i(R,(0,k.generateUuid)(),$.include?.map(Z=>a.TestId.fromExtHostTestItem(Z,R).toString())??[R],$.exclude?.map(Z=>a.TestId.fromExtHostTestItem(Z,R).toString())??[],G,O)}static fromInternal(R,O){return new i(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,O)}isIncluded(R){const O=a.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(O===$||O.startsWith($))return!1;for(const $ of this.includePrefix)if(O===$||O.startsWith($))return!0;return!1}}e.TestRunDto=i;class c{constructor(R,O,$){this.proxy=R,this.runId=O,this.taskId=$}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(R,O){const $=await this.fileCoverage;let G=$?.[R];return!this._coverageProvider||!$||!G?[]:(G.detailedCoverage||(G=$[R]=await this._coverageProvider.resolveFileCoverage?.(G,O)??G),G.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class h extends E.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,p.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:O,removed:$}=this;return{get added(){return[...R].map(G=>G.revived)},get updated(){return[...O].map(G=>G.revived)},get removed(){return[...$].map(G=>G.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new I.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,O){return{...R,revived:p.TestItem.toPlain(R.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=m;class w{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(O=>O.revived)},dispose:(0,C.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class S{constructor(R,O,$,G,Z,U,x=!1,M=void 0){this.controllerId=O,this.profileId=$,this._label=G,this.kind=Z,this.runHandler=U,this._isDefault=x,this._tag=M,l.set(this,void 0),rt(this,l,R,"f");const H=s[Z];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);$e(this,l,"f").$publishTestRunProfile({profileId:$,controllerId:O,tag:M?p.TestTag.namespace(this.controllerId,M.id):null,label:G,group:H,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,$e(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,$e(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,$e(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?p.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,$e(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){$e(this,l,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=S,l=new WeakMap;const s={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[252],ge([0,1,3,20,5,131,15,7]),function(Y,e,g,L,I,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const k=this._extHostDocumentsAndEditors.allEditors();return n?k:k.map(d=>d.value)}async showTextDocument(n,k,d){let f;typeof k=="number"?f={position:T.ViewColumn.from(k),preserveFocus:d}:typeof k=="object"?f={position:T.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?T.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:f={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(n.uri,f),p=u&&this._extHostDocumentsAndEditors.getEditor(u);if(p)return p.value;throw u?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,k){return new C.TextEditorDecorationType(this._proxy,n,k).value}$acceptEditorPropertiesChanged(n,k){const d=this._extHostDocumentsAndEditors.getEditor(n);if(!d)throw new Error("unknown text editor");if(k.options&&d._acceptOptions(k.options),k.selections){const f=k.selections.selections.map(T.Selection.to);d._acceptSelections(f)}if(k.visibleRanges){const f=L.coalesce(k.visibleRanges.map(T.Range.to));d._acceptVisibleRanges(f)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:{...k.options,lineNumbers:T.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const f=D.TextEditorSelectionChangeKind.fromValue(k.selections.source),u=k.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:u,kind:f})}if(k.visibleRanges){const f=L.coalesce(k.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const k in n){const d=this._extHostDocumentsAndEditors.getEditor(k);if(!d)throw new Error("Unknown text editor");const f=T.ViewColumn.to(n[k]);d.value.viewColumn!==f&&(d._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y}),define(me[253],ge([0,1,2,4,5,6,7]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class D{constructor(n,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(I.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===11){const f=d.uri===void 0?void 0:g.URI.revive(d.uri);return this._itemsBySourceAndUriMap.get(d.source)?.get(y(f))?.get(d.handle)}return d}})}async $getTimeline(n,k,d,f,u){return this._providers.get(n)?.provideTimeline(g.URI.revive(k),d,f,u)}registerTimelineProvider(n,k,d,f){const u=new C.DisposableStore,p=this.convertTimelineItem(k.id,f,u).bind(this);let _;k.onDidChange&&(_=k.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:k.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:n,onDidChange:void 0,async provideTimeline(E,a,l,v){v?.resetCache&&(u.clear(),A.get(k.id)?.clear());const t=await k.provideTimeline(E,a,l);if(t==null)return;const r=p(E,v);return{...t,source:k.id,items:t.items.map(r)}},dispose(){for(const E of A.values())E.get(k.id)?.clear();_?.dispose(),u.dispose()}})}convertTimelineItem(n,k,d){return(f,u)=>{let p;if(u?.cacheResults){let _=this._itemsBySourceAndUriMap.get(n);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(n,_));const A=y(f);p=_.get(A),p===void 0&&(p=new Map,_.set(A,p))}return _=>{const{iconPath:A,...E}=_,a=`${n}|${_.id??_.timestamp}`;p?.set(a,_);let l,v,t;return _.iconPath&&(A instanceof T.ThemeIcon?t={id:A.id,color:A.color}:g.URI.isUri(A)?(l=A,v=A):{light:l,dark:v}=A),{...E,id:E.id??void 0,handle:a,source:n,command:_.command?k.toInternal(_.command,d):void 0,icon:l,iconDark:v,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,C.toDisposable)(()=>{for(const d of this._itemsBySourceAndUriMap.values())d.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=D;function y(P){return P?.toString()}}),define(me[254],ge([0,1,6,10,2,5]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(y){this._openers=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,n,k){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const d=k.schemes.find(f=>!T.supportedSchemes.has(f));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,n),this._proxy.$registerUriOpener(P,k.schemes,y,k.label),(0,g.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,n){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const d=I.URI.revive(P);return k.canOpenExternalUri(d,n)}async $openUri(y,P,n){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(I.URI.revive(P.resolvedUri),{sourceUri:I.URI.revive(P.sourceUri)},n)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[255],ge([0,1,5,2,6,16,26]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(P,n){if(this.handles.has(T.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const k=D.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(P)),this.handlers.set(k,n),this._proxy.$registerUriHandler(k,P),(0,I.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(P)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(P,n){const k=this.handlers.get(P);if(!k)return Promise.resolve(void 0);try{k.handleUri(L.URI.revive(n))}catch(d){(0,C.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(P){return L.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=D,D.HandlePool=0});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[69],ge([0,1,3,2,180,204,89,5]),function(Y,e,g,L,I,C,T,D){"use strict";var y,P,n,k,d,f,u,p,_,A,E,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(m,w,S,s,b,R,O){y.set(this,void 0),P.set(this,void 0),n.set(this,void 0),k.set(this,void 0),d.set(this,void 0),f.set(this,void 0),u.set(this,""),p.set(this,void 0),_.set(this,!1),A.set(this,!1),E.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new g.Emitter),this._onDidDispose=$e(this,a,"f").event,rt(this,y,m,"f"),rt(this,P,w,"f"),rt(this,p,S,"f"),rt(this,k,s,"f"),rt(this,d,b,"f"),rt(this,f,R,"f"),rt(this,E,v(R),"f"),rt(this,n,O,"f")}dispose(){rt(this,_,!0,"f"),$e(this,a,"f").fire(),$e(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return rt(this,A,!0,"f"),(0,T.asWebviewUri)(m,$e(this,k,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),$e(this,u,"f")}set html(m){this.assertNotDisposed(),$e(this,u,"f")!==m&&(rt(this,u,m,"f"),!$e(this,A,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(rt(this,A,!0,"f"),$e(this,n,"f").report("Webview vscode-resource: uris",$e(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,P,"f").$setHtml($e(this,y,"f"),m))}get options(){return this.assertNotDisposed(),$e(this,p,"f")}set options(m){this.assertNotDisposed(),$e(this,P,"f").$setOptions($e(this,y,"f"),o($e(this,f,"f"),$e(this,d,"f"),m)),rt(this,p,m,"f")}async postMessage(m){if($e(this,_,"f"))return!1;const w=(0,C.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:$e(this,E,"f")});return $e(this,P,"f").$postMessage($e(this,y,"f"),w.message,...w.buffers)}assertNotDisposed(){if($e(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,y=new WeakMap,P=new WeakMap,n=new WeakMap,k=new WeakMap,d=new WeakMap,f=new WeakMap,u=new WeakMap,p=new WeakMap,_=new WeakMap,A=new WeakMap,E=new WeakMap,a=new WeakMap;function v(h){try{const m=(0,I.normalizeVersion)((0,I.parseVersion)(h.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(m,w,S,s,b){this.initData=w,this.workspace=S,this._logService=s,this._deprecationService=b,this._webviews=new Map,this._webviewProxy=m.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(m,w,...S){const s=this.getWebview(m);if(s){const{message:b}=(0,C.deserializeWebviewMessage)(w,S);s._onMessageEmitter.fire(b)}}$onMissingCsp(m,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,w,S){const s=new l(m,this._webviewProxy,i(w),this.initData,this.workspace,S,this._deprecationService);return this._webviews.set(m,s),s._onDidDispose(()=>{this._webviews.delete(m)}),s}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function r(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=r;function o(h,m,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||c(h,m)}}e.serializeWebviewOptions=o;function i(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(m=>L.URI.from(m))}}e.reviveOptions=i;function c(h,m){return[...(m?.getWorkspaceFolders()||[]).map(w=>w.uri),h.extensionLocation]}}),define(me[256],ge([0,1,21,58,6,10,25,2,15,69,87,5,7]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class u{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,o){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const c=new f(r,o);return this._documents.set(i,c),c}delete(t,r){const o=this.key(t,r.uri);this._documents.delete(o)}key(t,r){return`${t}@@@${r}`}}var p;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(p||(p={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,o){return this.add(0,t,r,o)}addCustomProvider(t,r,o){return this.add(1,t,r,o)}get(t){return this._providers.get(t)}add(t,r,o,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:o,provider:i}),new d.Disposable(()=>this._providers.delete(r))}}class A{constructor(t,r,o,i,c){this._extHostDocuments=r,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new _,this._documents=new u,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,o,i){const c=new I.DisposableStore;return E(o)?(c.add(this._editorProviders.addTextProvider(r,t,o)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(r,t,o)),this.supportEditing(o)&&c.add(o.onDidChangeCustomDocument(h=>{const m=this.getCustomDocumentEntry(r,h.document.uri);if(a(h)){const w=m.addEdit(h);this._proxy.$onDidEdit(h.document.uri,r,w,h.label)}else this._proxy.$onContentChange(h.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(c,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,o,i,c){const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${r}'`);const m=D.URI.revive(t),w=await h.provider.openCustomDocument(m,{backupId:o,untitledDocumentData:i?.buffer},c);let S;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(S=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(r,w,S),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=D.URI.revive(t),{document:c}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,c),c.dispose()}async $resolveWebviewEditor(t,r,o,i,c,h){const m=this._editorProviders.get(o);if(!m)throw new Error(`No provider found for '${o}'`);const w=y.ViewColumn.to(c),S=this._extHostWebview.createNewWebview(r,i.webviewOptions,m.extension),s=this._extHostWebviewPanels.createNewWebviewPanel(r,o,i.title,w,i.panelOptions,S),b=D.URI.revive(t);switch(m.type){case 1:{const{document:R}=this.getCustomDocumentEntry(o,b);return m.provider.resolveCustomEditor(R,s,h)}case 0:{const R=this._extHostDocuments.getDocument(b);return m.provider.resolveCustomTextEditor(R,s,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,o){this.getCustomDocumentEntry(r,t).disposeEdits(o)}async $onMoveCustomEditor(t,r,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const h=D.URI.revive(r),m=this._extHostDocuments.getDocument(h);await i.provider.moveCustomTextEditor(m,c,g.CancellationToken.None)}async $undo(t,r,o,i){return this.getCustomDocumentEntry(r,t).undo(o,i)}async $redo(t,r,o,i){return this.getCustomDocumentEntry(r,t).redo(o,i)}async $revert(t,r,o){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(t,r,o){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(t,r,o,i){const c=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(c.document,D.URI.revive(o),i)}async $backup(t,r,o){const i=this.getCustomDocumentEntry(r,t),h=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(h),h.id}getCustomDocumentEntry(t,r){const o=this._documents.get(t,D.URI.revive(r));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const o=this._editorProviders.get(t)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function E(v){return typeof v.resolveCustomTextEditor=="function"}function a(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function l(v){const t=v.scheme===C.Schemas.file||v.scheme===C.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(t)+""}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[257],ge([0,1,3,6,2,32,15,69,5,7]),function(Y,e,g,L,I,C,T,D,y,P){"use strict";var n,k,d,f,u,p,_,A,E,a,l,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends L.Disposable{constructor(h,m,w,S,s,b,R){super();n.set(this,void 0),k.set(this,void 0),d.set(this,void 0),f.set(this,void 0),u.set(this,void 0),p.set(this,void 0),_.set(this,void 0),A.set(this,void 0),E.set(this,!0),a.set(this,!0),l.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=$e(this,v,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,rt(this,n,h,"f"),rt(this,k,m,"f"),rt(this,d,w,"f"),rt(this,u,b,"f"),rt(this,A,s,"f"),rt(this,p,S,"f"),rt(this,f,R,"f")}dispose(){$e(this,l,"f")||(rt(this,l,!0,"f"),$e(this,v,"f").fire(),$e(this,k,"f").$disposeWebview($e(this,n,"f")),$e(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,f,"f")}get viewType(){return this.assertNotDisposed(),$e(this,d,"f")}get title(){return this.assertNotDisposed(),$e(this,p,"f")}set title(h){this.assertNotDisposed(),$e(this,p,"f")!==h&&(rt(this,p,h,"f"),$e(this,k,"f").$setTitle($e(this,n,"f"),h))}get iconPath(){return this.assertNotDisposed(),$e(this,_,"f")}set iconPath(h){this.assertNotDisposed(),$e(this,_,"f")!==h&&(rt(this,_,h,"f"),$e(this,k,"f").$setIconPath($e(this,n,"f"),I.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return $e(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,A,"f")=="number"&&$e(this,A,"f")<0))return $e(this,A,"f")}get active(){return this.assertNotDisposed(),$e(this,a,"f")}get visible(){return this.assertNotDisposed(),$e(this,E,"f")}_updateViewState(h){$e(this,l,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(rt(this,a,h.active,"f"),rt(this,E,h.visible,"f"),rt(this,A,h.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(h,m){this.assertNotDisposed(),$e(this,k,"f").$reveal($e(this,n,"f"),{viewColumn:h?T.ViewColumn.from(h):void 0,preserveFocus:!!m})}assertNotDisposed(){if($e(this,l,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,k=new WeakMap,d=new WeakMap,f=new WeakMap,u=new WeakMap,p=new WeakMap,_=new WeakMap,A=new WeakMap,E=new WeakMap,a=new WeakMap,l=new WeakMap,v=new WeakMap,t=new WeakMap;class o{constructor(h,m,w){this.webviews=m,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(h,m,w,S,s={}){const b=typeof S=="object"?S.viewColumn:S,R={viewColumn:T.ViewColumn.from(b),preserveFocus:typeof S=="object"&&!!S.preserveFocus},O=(0,D.shouldSerializeBuffersForPostMessage)(h),$=o.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(h),$,m,{title:w,panelOptions:i(s),webviewOptions:(0,D.serializeWebviewOptions)(h,this.workspace,s),serializeBuffersForPostMessage:O},R);const G=this.webviews.createNewWebview($,s,h);return this.createNewWebviewPanel($,m,w,b,s,G)}$onDidChangeWebviewPanelViewStates(h){const m=Object.keys(h);m.sort((w,S)=>{const s=h[w],b=h[S];return s.active?1:b.active?-1:+s.visible-+b.visible});for(const w of m){const S=this.getWebviewPanel(w);if(!S)continue;const s=h[w];S._updateViewState({active:s.active,visible:s.visible,viewColumn:T.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,m,w){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:w,extension:h}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(h)}),new P.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(h,m,w,S){const s=this._serializers.get(m);if(!s)throw new Error(`No serializer found for '${m}'`);const{serializer:b,extension:R}=s,O=this.webviews.createNewWebview(h,w.webviewOptions,R),$=this.createNewWebviewPanel(h,m,w.title,S,w.panelOptions,O);await b.deserializeWebviewPanel($,w.state)}createNewWebviewPanel(h,m,w,S,s,b){const R=new r(h,this._proxy,m,w,S,s,b);return this._webviewPanels.set(h,R),R}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=o;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[258],ge([0,1,3,6,69,5,7]),function(Y,e,g,L,I,C,T){"use strict";var D,y,P,n,k,d,f,u,p,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends L.Disposable{constructor(l,v,t,r,o,i){super();D.set(this,void 0),y.set(this,void 0),P.set(this,void 0),n.set(this,void 0),k.set(this,!1),d.set(this,void 0),f.set(this,void 0),u.set(this,void 0),p.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=$e(this,p,"f").event,_.set(this,this._register(new g.Emitter)),this.onDidDispose=$e(this,_,"f").event,rt(this,P,t,"f"),rt(this,f,r,"f"),rt(this,D,l,"f"),rt(this,y,v,"f"),rt(this,n,o,"f"),rt(this,d,i,"f")}dispose(){$e(this,k,"f")||(rt(this,k,!0,"f"),$e(this,_,"f").fire(),$e(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,f,"f")}set title(l){this.assertNotDisposed(),$e(this,f,"f")!==l&&(rt(this,f,l,"f"),$e(this,y,"f").$setWebviewViewTitle($e(this,D,"f"),l))}get description(){return this.assertNotDisposed(),$e(this,u,"f")}set description(l){this.assertNotDisposed(),$e(this,u,"f")!==l&&(rt(this,u,l,"f"),$e(this,y,"f").$setWebviewViewDescription($e(this,D,"f"),l))}get visible(){return $e(this,d,"f")}get webview(){return $e(this,n,"f")}get viewType(){return $e(this,P,"f")}_setVisible(l){l===$e(this,d,"f")||$e(this,k,"f")||(rt(this,d,l,"f"),$e(this,p,"f").fire())}show(l){this.assertNotDisposed(),$e(this,y,"f").$show($e(this,D,"f"),!!l)}assertNotDisposed(){if($e(this,k,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,y=new WeakMap,P=new WeakMap,n=new WeakMap,k=new WeakMap,d=new WeakMap,f=new WeakMap,u=new WeakMap,p=new WeakMap,_=new WeakMap;class E{constructor(l,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,v,t,r){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(l),v,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(l,v,t,r,o){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:c,extension:h}=i,m=this._extHostWebview.createNewWebview(l,{},h),w=new A(l,this._proxy,v,t,m,!0);this._webviewViews.set(l,w),await c.resolveWebviewView(w,{state:r},o)}async $onDidChangeWebviewViewVisibility(l,v){this.getWebviewView(l)._setVisible(v)}async $disposeWebviewView(l){const v=this.getWebviewView(l);this._webviewViews.delete(l),v.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const v=this._webviewViews.get(l);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=E}),define(me[133],ge([0,1,3,5,2,10,9,4,14]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class $n{constructor(k){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=k.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,d){let f;if(typeof k=="string"){f=k;try{k=I.URI.parse(k)}catch(u){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,T.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,f,d)}async asExternalUri(k,d){if((0,T.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(k,d);return I.URI.from(f)}};P.InitialState={focused:!0},P=je([Ue(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(me[259],ge([0,1,8,80,32,44,6,5,2,14]),function(Y,e,g,L,I,C,T,D,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends T.Disposable{constructor(d,f){super();const u=d.getProxy(D.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async p=>{const _=y.URI.file((0,g.join)((0,L.tmpdir)(),(0,I.generateUuid)()));return await u.$download(p,_),_})}};n=je([Ue(0,P.IExtHostRpcService),Ue(1,C.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[260],ge([0,1,2,8,152,28,67,27,14,6,12,115,42]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(A,E,a){this.name=A,this.file=E,this.appender=a}static async create(A,E){const a=await(0,k.createRotatingLogger)(A,E,30*d.ByteSize.MB,1);return a.clearFormatters(),new f(A,E,a)}append(A){this.appender.critical(A)}flush(){this.appender.flush()}}class u extends T.AbstractExtHostOutputChannel{constructor(A,E,a,l){super(A,!1,g.URI.file(E.file),a,l);this._appender=E}append(A){super.append(A),this._appender.append(A),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(A,E){this._appender.flush(),super.show(A,E)}clear(){this._appender.flush(),super.clear()}}let p=class extends T.ExtHostOutputService{constructor(A,E,a){super(A);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=a.logsLocation}$setVisibleChannel(A){if(A){const E=this._channels.get(A);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(A,E){if(A=A.trim(),!A)throw new Error("illegal argument `name`. must not be falsy");const a=this._doCreateOutChannel(A,E);return a.then(l=>l._id.then(v=>this._channels.set(v,l))),new T.LazyOutputChannel(A,a)}async _doCreateOutChannel(A,E){try{const a=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await C.SymlinkSupport.existsDirectory(a)||await C.Promises.mkdir(a,{recursive:!0});const v=`${this._namePool++}-${A.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,L.join)(a,`${v}.log`)),r=await f.create(v,t.fsPath);return new u(A,r,E.identifier.value,this._proxy)}catch(a){return this.logService.error(a),new T.ExtHostPushOutputChannel(A,E.identifier.value,this._proxy)}}};p=je([Ue(0,y.IExtHostRpcService),Ue(1,n.ILogService),Ue(2,D.IExtHostInitDataService)],p),e.ExtHostOutputService2=p}),define(me[261],ge([0,1,49,292,2,68,6,10,17]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(v){const t=await super._getWorkspaceStorageURI(v);if(t.scheme!==D.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const r=t.fsPath;let o=0;do{let i;o===0?i=r:i=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${o}`:`${r}-${o}`,await n(i);const c=L.join(i,"vscode.lock"),h=await u(this._logService,c,!1);if(h)return this._workspaceStorageLock=h,process.on("exit",()=>{h.dispose()}),I.URI.file(i);o++}while(o<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function n(l){try{await g.promises.stat(l);return}catch{}try{await g.promises.mkdir(l,{recursive:!0})}catch{}}const k=1e3,d=10*60*1e3;class f extends T.Disposable{constructor(v,t){super();this.logService=v,this.filename=t,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await p(v,t);(!r||r.pid!==process.pid)&&(v.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(o){v.error(o),v.info(`Lock '${t}': Could not update mtime.`)}},k)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(v){}}async setWillRelease(v){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${v} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+v};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function u(l,v,t){try{const o={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(v,JSON.stringify(o),{flag:"wx"})}catch(o){l.error(o)}const r=await p(l,v);return!r||r.pid!==process.pid?t?(l.info(`Lock '${v}': Could not acquire lock, giving up.`),null):(l.info(`Lock '${v}': Could not acquire lock, checking if the file is stale.`),E(l,v)):(l.info(`Lock '${v}': Lock acquired.`),new f(l,v))}async function p(l,v){let t;try{t=await g.promises.readFile(v)}catch(r){return l.error(r),null}try{return JSON.parse(String(t))}catch(r){return l.error(r),null}}async function _(l,v){let t;try{t=await g.promises.stat(v)}catch(r){return l.error(r),0}return t.mtime.getTime()}function A(l){try{return process.kill(l,0),!0}catch(v){return!1}}async function E(l,v){const t=await p(l,v);if(!t)return l.info(`Lock '${v}': Could not read pid of lock holder.`),a(l,v);if(t.willReleaseAt){let h=t.willReleaseAt-Date.now();if(h<5e3){for(h>0?l.info(`Lock '${v}': The lockfile is scheduled to be released in ${h} ms.`):l.info(`Lock '${v}': The lockfile is scheduled to have been released.`);h>0;){if(await(0,y.timeout)(Math.min(100,h)),await _(l,v)===0)return a(l,v);h=t.willReleaseAt-Date.now()}return a(l,v)}}if(!A(t.pid))return l.info(`Lock '${v}': The pid ${t.pid} appears to be gone.`),a(l,v);const r=await _(l,v),o=Date.now()-r;if(o<=d)return l.info(`Lock '${v}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;l.info(`Lock '${v}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const i=await _(l,v),c=Date.now()-i;return c<=d?(l.info(`Lock '${v}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(l.info(`Lock '${v}': The lock looks stale even after waiting for 2s.`),a(l,v))}async function a(l,v){l.info(`Lock '${v}': Deleting a stale lock.`);try{await g.promises.unlink(v)}catch(t){}return u(l,v,!0)}}),define(me[262],ge([0,1,32,14,33]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends I.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,y,P){return this.createTerminalFromOptions({name:D,shellPath:y,shellArgs:P})}createTerminalFromOptions(D,y){const P=new I.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),D,D.name);return this._terminals.push(P),P.create(D,this._serializeParentTerminal(D,y)),P.value}_serializeParentTerminal(D,y){if(y=y||{},D.location&&typeof D.location=="object"&&"parentTerminal"in D.location){const P=D.location.parentTerminal;if(P){const n=this._terminals.find(k=>k.value===P);n&&(y.resolvedExtHostIdentifier=n._id)}}return y}};C=je([Ue(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(me[263],ge([0,1,5,14,6,27,2,39,25,28,7,11,52,3,193,77,12]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class A{constructor(m,w,S){this.remoteAddress=m,this.localAddress=w,this._dispose=S,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(h){const m=h.trim().split(`
`),w=[];return m.forEach(s=>{const b=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(s);b&&b.length>=3&&w.push({pid:parseInt(b[1],10),socket:parseInt(b[2],10)})}),w.reduce((s,b)=>(s[b.socket]=b,s),{})}e.getSockets=E;function a(...h){const m=[].concat(...h.map(v));return[...new Map(m.filter(w=>w.st==="0A").map(w=>{const S=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:l(S[0]),port:parseInt(S[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=a;function l(h){let m="";if(h.length===8)for(let w=h.length-2;w>=0;w-=2)m+=parseInt(h.substr(w,2),16),w!==0&&(m+=".");else for(let w=h.length-4;w>=0;w-=4)m+=parseInt(h.substr(w,4),16).toString(16),w!==0&&(m+=":");return m}e.parseIpAddress=l;function v(h){const m=h.trim().split(`
`),w=m.shift().trim().split(/\s+/).filter(s=>s!=="rx_queue"&&s!=="tm->when");return m.map(s=>s.trim().split(/\s+/).reduce((b,R,O)=>(b[w[O]||O]=R,b),{}))}e.loadConnectionTable=v;function t(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/vs/server/main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function r(h){const m=h.trim().split(`
`),w=[];return m.forEach(S=>{const s=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);s&&s.length>=4&&w.push({pid:parseInt(s[1],10),ppid:parseInt(s[2]),cmd:s[3]})}),w}e.getRootProcesses=r;async function o(h,m,w){const S=w.reduce((b,R)=>(b[R.pid]=R,b),{}),s=[];return h.forEach(({socket:b,ip:R,port:O})=>{const $=m[b]?m[b].pid:void 0,G=$?S[$]?.cmd:void 0;$&&G&&!t(G)&&s.push({host:R,port:O,detail:G,pid:$})}),s}e.findPorts=o;function i(h,m,w){const S=new Map,s=r(m);for(const b of h){const R=w.get(b.port);if(R){S.set(b.port,R);continue}const O=s.find($=>$.cmd.includes(`${b.port}`));if(O){let $=O,G;do G=s.find(Z=>Z.ppid===$.pid),G&&($=G);while(G);S.set(b.port,{host:b.ip,port:b.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else S.set(b.port,{host:b.ip,port:b.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=i;let c=class extends I.Disposable{constructor(m,w,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTunnelService),k.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(w,m.displayName);if(S){const s=new A(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(s),s}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,w){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:m,provider:w}),this._proxy.$registerPortsAttributesProvider(m,S),new n.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(m,w,S,s,b){const R=[];for(const $ of m){const G=this._portAttributesProviders.get($);if(!G)return[];R.push(...await Promise.all(w.map(async Z=>G.provider.providePortAttributes(Z,S,s,b))))}const O=R.filter($=>!!$);return O.length>0?O.map($=>({autoForwardAction:$.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let w=new p.MovingAverage,S;for(;this._candidateFindingEnabled;){const s=new Date().getTime(),b=(await this.findCandidatePorts()).filter(O=>(0,u.isLocalhost)(O.host)||(0,u.isAllInterfaces)(O.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${b.map(O=>O.port).join(", ")}`);const R=new Date().getTime()-s;w.update(R),(!S||JSON.stringify(S)!==JSON.stringify(b))&&(S=b,await this._proxy.$onFoundNewCandidates(S)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(m){return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider(m.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,w){if(this._extensionTunnels.has(m.host)){const S=this._extensionTunnels.get(m.host);S.has(m.port)&&(w&&S.get(m.port).disposeListener.dispose(),await S.get(m.port).tunnel.dispose(),S.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(m,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const s=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const b=this._register(s.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(s.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:s,disposeListener:b}),d.TunnelDto.fromApiTunnel(s)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(S){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const w=await Promise.all(m.map(s=>this._showCandidatePort(s.host,s.port,s.detail??""))),S=m.filter((s,b)=>w[b]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(s=>s.port).join(", ")} to ${S.map(s=>s.port).join(", ")}`),S}async findCandidatePorts(){let m="",w="";try{m=await P.Promises.readFile("/proc/net/tcp","utf8"),w=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const S=a(m,w),s=await new Promise(x=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,H,F)=>{x(H)})}),b=E(s),R=await P.Promises.readdir("/proc"),O=[];for(let x of R)try{const M=Number(x),H=y.joinPath(T.URI.file("/proc"),x);if((await P.Promises.stat(H.fsPath)).isDirectory()&&!isNaN(M)){const N=await P.Promises.readlink(y.joinPath(H,"cwd").fsPath),j=await P.Promises.readFile(y.joinPath(H,"cmdline").fsPath,"utf8");O.push({pid:M,cwd:N,cmd:j})}}catch(M){}const $=[],G=S.filter(x=>{const M=b[x.socket];return M||$.push(x),M}),Z=o(G,b,O);let U;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const x=await new Promise(M=>{(0,D.exec)("ps -F -A -l | grep root",(H,F,N)=>{M(F)})});this._foundRootPorts=i($,x,this._foundRootPorts),U=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.join(", ")}`)}return Z.then(x=>U?x.concat(U):x)}};c=je([Ue(0,L.IExtHostRpcService),Ue(1,C.IExtHostInitDataService),Ue(2,_.ILogService)],c),e.ExtHostTunnelService=c}),define(me[264],ge([0,1,17,22,21,16,3,6,103,228,65]),function(Y,e,g,L,I,C,T,D,y,P,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function d(s,b){try{return JSON.stringify(s,b)}catch(R){return"null"}}const f="$$ref$$",u={[f]:-1};class p{constructor(b,R){this.jsonString=b,this.referencedBuffers=R}}function _(s,b=null,R=!1){const O=[];return{jsonString:(R?d:JSON.stringify)(s,(G,Z)=>{if(typeof Z=="undefined")return u;if(typeof Z=="object"){if(Z instanceof L.VSBuffer){const U=O.push(Z)-1;return{[f]:U}}if(b)return b(G,Z)}return Z}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=_;function A(s,b,R){return JSON.parse(s,(O,$)=>{if($){const G=$[f];if(typeof G=="number")return b[G];if(R&&$.$mid===1)return R.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=A;function E(s,b){return JSON.stringify(s,b)}function a(s){return s?(b,R)=>R&&R.$mid===1?s.transformOutgoing(R):R:null}var l;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},r=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends D.Disposable{constructor(b,R=null,O=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=b,this._logger=R,this._uriTransformer=O,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,G=n.ProxyIdentifier.count;$<G;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(b=>{this._pendingRPCReplies[b].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(b){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(b){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(b){this._responsiveState!==b&&(this._responsiveState=b,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(b){return this._uriTransformer?(0,y.transformIncomingURIs)(b,this._uriTransformer):b}getProxy(b){const{nid:R,sid:O}=b;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,O)),this._proxies[R]}_createProxy(b,R){let O={get:($,G)=>(typeof G=="string"&&!$[G]&&G.charCodeAt(0)===36&&($[G]=(...Z)=>this._remoteCall(b,G,Z)),G===o?R:$[G])};return new Proxy(Object.create(null),O)}set(b,R){return this._locals[b.nid]=R,R}assertRegistered(b){for(let R=0,O=b.length;R<O;R++){const $=b[R];if(!this._locals[$.nid])throw new Error(`Missing actor ${$.sid} (isMain: ${$.isMain})`)}}_receiveOneMessage(b){if(this._isDisposed)return;const R=b.byteLength,O=c.read(b,0),$=O.readUInt8(),G=O.readUInt32();switch($){case 1:case 2:{let{rpcId:Z,method:U,args:x}=m.deserializeRequestJSONArgs(O);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(R,G,Z,U,x,$===2);break}case 3:case 4:{let{rpcId:Z,method:U,args:x}=m.deserializeRequestMixedArgs(O);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(R,G,Z,U,x,$===4);break}case 5:{this._logger&&this._logger.logIncoming(R,G,0,"ack"),this._onDidReceiveAcknowledge(G);break}case 6:{this._receiveCancel(R,G);break}case 7:{this._receiveReply(R,G,void 0);break}case 9:{let Z=m.deserializeReplyOKJSON(O);this._uriTransformer&&(Z=(0,y.transformIncomingURIs)(Z,this._uriTransformer)),this._receiveReply(R,G,Z);break}case 10:{const Z=m.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(R,G,Z);break}case 8:{let Z=m.deserializeReplyOKVSBuffer(O);this._receiveReply(R,G,Z);break}case 11:{let Z=m.deserializeReplyErrError(O);this._uriTransformer&&(Z=(0,y.transformIncomingURIs)(Z,this._uriTransformer)),this._receiveReplyErr(R,G,Z);break}case 12:{this._receiveReplyErr(R,G,void 0);break}default:console.error("received unexpected message"),console.error(b)}}_receiveRequest(b,R,O,$,G,Z){this._logger&&this._logger.logIncoming(b,R,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(O)}.${$}(`,G);const U=String(R);let x,M;if(Z){const F=new I.CancellationTokenSource;G.push(F.token),x=this._invokeHandler(O,$,G),M=()=>F.cancel()}else x=this._invokeHandler(O,$,G),M=t;this._cancelInvokedHandlers[U]=M;const H=m.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(H.byteLength,R,1,"ack"),this._protocol.send(H),x.then(F=>{delete this._cancelInvokedHandlers[U];const N=m.serializeReplyOK(R,F,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,R,1,"reply:",F),this._protocol.send(N)},F=>{delete this._cancelInvokedHandlers[U];const N=m.serializeReplyErr(R,F);this._logger&&this._logger.logOutgoing(N.byteLength,R,1,"replyErr:",F),this._protocol.send(N)})}_receiveCancel(b,R){this._logger&&this._logger.logIncoming(b,R,1,"receiveCancel");const O=String(R);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(b,R,O){this._logger&&this._logger.logIncoming(b,R,0,"receiveReply:",O);const $=String(R);if(!this._pendingRPCReplies.hasOwnProperty($))return;const G=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],G.resolveOk(O)}_receiveReplyErr(b,R,O){this._logger&&this._logger.logIncoming(b,R,0,"receiveReplyErr:",O);const $=String(R);if(!this._pendingRPCReplies.hasOwnProperty($))return;const G=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let Z;O&&(O.$isError?(Z=new Error,Z.name=O.name,Z.message=O.message,Z.stack=O.stack):Z=O),G.resolveErr(Z)}_invokeHandler(b,R,O){try{return Promise.resolve(this._doInvokeHandler(b,R,O))}catch($){return Promise.reject($)}}_doInvokeHandler(b,R,O){const $=this._locals[b];if(!$)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(b));let G=$[R];if(typeof G!="function")throw new Error("Unknown method "+R+" on actor "+(0,n.getStringIdentifierForProxy)(b));return G.apply($,O)}_remoteCall(b,R,O){if(this._isDisposed)return Promise.reject(C.canceled());let $=null;if(O.length>0&&I.CancellationToken.isCancellationToken(O[O.length-1])&&($=O.pop()),$&&$.isCancellationRequested)return Promise.reject(C.canceled());const G=m.serializeRequestArguments(O,this._uriReplacer),Z=++this._lastMessageId,U=String(Z),x=new P.LazyPromise;$&&$.onCancellationRequested(()=>{const H=m.serializeCancel(Z);this._logger&&this._logger.logOutgoing(H.byteLength,Z,0,"cancel"),this._protocol.send(m.serializeCancel(Z))}),this._pendingRPCReplies[U]=x,this._onWillSendRequest(Z);const M=m.serializeRequest(Z,b,R,G,!!$);return this._logger&&this._logger.logOutgoing(M.byteLength,Z,0,`request: ${(0,n.getStringIdentifierForProxy)(b)}.${R}(`,O),this._protocol.send(M),x}}e.RPCProtocol=i,k=r,i.UNRESPONSIVE_TIME=3*1e3;class c{constructor(b,R){this._buff=b,this._offset=R}static alloc(b,R,O){let $=new c(L.VSBuffer.alloc(O+1+4),0);return $.writeUInt8(b),$.writeUInt32(R),$}static read(b,R){return new c(b,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(b){this._buff.writeUInt8(b,this._offset),this._offset+=1}readUInt8(){const b=this._buff.readUInt8(this._offset);return this._offset+=1,b}writeUInt32(b){this._buff.writeUInt32BE(b,this._offset),this._offset+=4}readUInt32(){const b=this._buff.readUInt32BE(this._offset);return this._offset+=4,b}static sizeShortString(b){return 1+b.byteLength}writeShortString(b){this._buff.writeUInt8(b.byteLength,this._offset),this._offset+=1,this._buff.set(b,this._offset),this._offset+=b.byteLength}readShortString(){const b=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,O}static sizeLongString(b){return 4+b.byteLength}writeLongString(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readLongString(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,O}writeBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}static sizeVSBuffer(b){return 4+b.byteLength}writeVSBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readVSBuffer(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+b);return this._offset+=b,R}static sizeMixedArray(b){let R=0;R+=1;for(let O=0,$=b.length;O<$;O++){const G=b[O];switch(R+=1,G.type){case 1:R+=this.sizeLongString(G.value);break;case 2:R+=this.sizeVSBuffer(G.value);break;case 3:R+=this.sizeUInt8(),R+=this.sizeLongString(G.value);for(let Z=0;Z<G.buffers.length;++Z)R+=this.sizeVSBuffer(G.buffers[Z]);break;case 4:break}}return R}writeMixedArray(b){this._buff.writeUInt8(b.length,this._offset),this._offset+=1;for(let R=0,O=b.length;R<O;R++){const $=b[R];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt8($.buffers.length),this.writeLongString($.value);for(let G=0;G<$.buffers.length;++G)this.writeBuffer($.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const b=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(b);for(let O=0;O<b;O++)switch(this.readUInt8()){case 1:R[O]=this.readLongString();break;case 2:R[O]=this.readVSBuffer();break;case 3:const G=this.readUInt8(),Z=this.readLongString(),U=[];for(let x=0;x<G;++x)U.push(this.readVSBuffer());R[O]=new n.SerializableObjectWithBuffers(A(Z,U,null));break;case 4:R[O]=void 0;break}return R}}var h;(function(s){s[s.Simple=0]="Simple",s[s.Mixed=1]="Mixed"})(h||(h={}));class m{static _useMixedArgSerialization(b){for(let R=0,O=b.length;R<O;R++)if(b[R]instanceof L.VSBuffer||b[R]instanceof n.SerializableObjectWithBuffers||typeof b[R]=="undefined")return!0;return!1}static serializeRequestArguments(b,R){if(this._useMixedArgSerialization(b)){const O=[];for(let $=0,G=b.length;$<G;$++){const Z=b[$];if(Z instanceof L.VSBuffer)O[$]={type:2,value:Z};else if(typeof Z=="undefined")O[$]={type:4};else if(Z instanceof n.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:x}=_(Z.value,R);O[$]={type:3,value:L.VSBuffer.fromString(U),buffers:x}}else O[$]={type:1,value:L.VSBuffer.fromString(E(Z,R))}}return{type:1,args:O}}return{type:0,args:E(b,R)}}static serializeRequest(b,R,O,$,G){switch($.type){case 0:return this._requestJSONArgs(b,R,O,$.args,G);case 1:return this._requestMixedArgs(b,R,O,$.args,G)}}static _requestJSONArgs(b,R,O,$,G){const Z=L.VSBuffer.fromString(O),U=L.VSBuffer.fromString($);let x=0;x+=c.sizeUInt8(),x+=c.sizeShortString(Z),x+=c.sizeLongString(U);let M=c.alloc(G?2:1,b,x);return M.writeUInt8(R),M.writeShortString(Z),M.writeLongString(U),M.buffer}static deserializeRequestJSONArgs(b){const R=b.readUInt8(),O=b.readShortString(),$=b.readLongString();return{rpcId:R,method:O,args:JSON.parse($)}}static _requestMixedArgs(b,R,O,$,G){const Z=L.VSBuffer.fromString(O);let U=0;U+=c.sizeUInt8(),U+=c.sizeShortString(Z),U+=c.sizeMixedArray($);let x=c.alloc(G?4:3,b,U);return x.writeUInt8(R),x.writeShortString(Z),x.writeMixedArray($),x.buffer}static deserializeRequestMixedArgs(b){const R=b.readUInt8(),O=b.readShortString(),$=b.readMixedArray(),G=new Array($.length);for(let Z=0,U=$.length;Z<U;Z++){const x=$[Z];typeof x=="string"?G[Z]=JSON.parse(x):G[Z]=x}return{rpcId:R,method:O,args:G}}static serializeAcknowledged(b){return c.alloc(5,b,0).buffer}static serializeCancel(b){return c.alloc(6,b,0).buffer}static serializeReplyOK(b,R,O){if(typeof R=="undefined")return this._serializeReplyOKEmpty(b);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(b,R);if(R instanceof n.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:G}=_(R.value,O,!0);return this._serializeReplyOKJSONWithBuffers(b,$,G)}else return this._serializeReplyOKJSON(b,d(R,O))}static _serializeReplyOKEmpty(b){return c.alloc(7,b,0).buffer}static _serializeReplyOKVSBuffer(b,R){let O=0;O+=c.sizeVSBuffer(R);let $=c.alloc(8,b,O);return $.writeVSBuffer(R),$.buffer}static deserializeReplyOKVSBuffer(b){return b.readVSBuffer()}static _serializeReplyOKJSON(b,R){const O=L.VSBuffer.fromString(R);let $=0;$+=c.sizeLongString(O);let G=c.alloc(9,b,$);return G.writeLongString(O),G.buffer}static _serializeReplyOKJSONWithBuffers(b,R,O){const $=L.VSBuffer.fromString(R);let G=0;G+=c.sizeUInt8(),G+=c.sizeLongString($);for(const U of O)G+=c.sizeVSBuffer(U);let Z=c.alloc(10,b,G);Z.writeUInt8(O.length),Z.writeLongString($);for(const U of O)Z.writeBuffer(U);return Z.buffer}static deserializeReplyOKJSON(b){const R=b.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(b,R){const O=b.readUInt8(),$=b.readLongString(),G=[];for(let Z=0;Z<O;++Z)G.push(b.readVSBuffer());return new n.SerializableObjectWithBuffers(A($,G,R))}static serializeReplyErr(b,R){return R?this._serializeReplyErrEror(b,R):this._serializeReplyErrEmpty(b)}static _serializeReplyErrEror(b,R){const O=L.VSBuffer.fromString(d(C.transformErrorForSerialization(R),null));let $=0;$+=c.sizeLongString(O);let G=c.alloc(11,b,$);return G.writeLongString(O),G.buffer}static deserializeReplyErrError(b){const R=b.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(b){return c.alloc(12,b,0).buffer}}var w;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",s[s.ReplyErrError=11]="ReplyErrError",s[s.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var S;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",s[s.Undefined=4]="Undefined"})(S||(S={}))}),define(me[265],ge([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(me[266],ge([0,1,10,8,11,2,4,86,43,223,265]),function(Y,e,g,L,I,C,T,D,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let k=class Wn{constructor(f,u,p,_){this.localUserHome=f,this.remoteAgentService=u,this.environmentService=p,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||I.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome||f})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,u){if(f.remoteAuthority)return g.Schemas.vscodeRemote;const p=(0,D.getVirtualWorkspaceScheme)(u.getWorkspace());if(p)return p;const _=u.getWorkspace().folders[0];if(_)return _.uri.scheme;const A=u.getWorkspace().configuration;return A?A.scheme:g.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?L.win32:L.posix)}async fileURI(f){let u="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const _=f.indexOf("/",2);_===-1?(u=f.substring(2),f="/"):(u=f.substring(2,_),f=f.substring(_)||"/")}return C.URI.from({scheme:g.Schemas.file,authority:u,path:f,query:"",fragment:""})}};k=je([Ue(1,n.IRemoteAgentService),Ue(2,P.IWorkbenchEnvironmentService),Ue(3,y.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(me[70],ge([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(T,D){this.line=T,this.character=D}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,D){return new g(0,0)}with(T){return new g(0,0)}}e.Position=g;class L{constructor(T,D,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,D),this.end=new g(y,P)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var I;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,20,30,23,29,9,4,8,16,70,13]),function(Y,e,g,L,I,C,T,D,y,P,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const d="\u27EA ",f=" characters skipped \u27EB",u=(d.length+f.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var p;(function(H){H[H.file=0]="file",H[H.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var _;(function(H){H[H.File=1]="File",H[H.Text=2]="Text"})(_=e.QueryType||(e.QueryType={}));function A(H){return!!H.preview}e.resultIsMatch=A;function E(H){return!!H.resource}e.isFileMatch=E;function a(H){return!!H.message}e.isProgressMessage=a;var l;(function(H){H[H.Normal=0]="Normal",H[H.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(F){this.resource=F,this.results=[]}}e.FileMatch=v;class t{constructor(F,N,j){this.ranges=N;const W=Array.isArray(N)?N:[N];if(j&&j.matchLines===1&&r(W)){F=(0,T.getNLines)(F,j.matchLines);let Q="",J=0,fe=0;const _e=Math.floor(j.charsPerLine/5),ye=[];for(const Le of W){const Be=Math.max(Le.startColumn-_e,0),xe=Le.startColumn+j.charsPerLine;if(Be>fe+_e+u){const Ke=d+(Be-fe)+f;Q+=Ke+F.slice(Be,xe),J+=Be-(fe+Ke.length)}else Q+=F.slice(fe,xe);ye.push(new i(0,Le.startColumn-J,Le.endColumn-J)),fe=xe}this.preview={text:Q,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const Q=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:F,matches:(0,g.mapArrayOrNot)(N,J=>new o(J.startLineNumber-Q,J.startColumn,J.endLineNumber-Q,J.endColumn))}}}}e.TextSearchMatch=t;function r(H){const F=H[0].startLineNumber;for(const N of H)if(N.startLineNumber!==F||N.endLineNumber!==F)return!1;return!0}class o{constructor(F,N,j,W){this.startLineNumber=F,this.startColumn=N,this.endLineNumber=j,this.endColumn=W}}e.SearchRange=o;class i extends o{constructor(F,N,j){super(F,N,F,j)}}e.OneLineRange=i;var c;(function(H){H.Default="default",H.FileNames="fileNames",H.Type="type",H.Modified="modified",H.CountDescending="countDescending",H.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function h(H,F=!0){const N=H&&H.files&&H.files.exclude,j=F&&H&&H.search&&H.search.exclude;if(!N&&!j)return;if(!N||!j)return N||j;let W=Object.create(null);return W=I.mixin(W,I.deepClone(N)),W=I.mixin(W,I.deepClone(j),!0),W}e.getExcludes=h;function m(H,F){return H.excludePattern&&L.match(H.excludePattern,F)?!1:H.includePattern||H.usingSearchPaths?H.includePattern&&L.match(H.includePattern,F)?!0:H.usingSearchPaths?!!H.folderQueries&&H.folderQueries.some(N=>{const j=N.folder.fsPath;if(C.isEqualOrParent(F,j)){const W=y.relative(j,F);return!N.includePattern||!!L.match(N.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var w;(function(H){H[H.unknownEncoding=1]="unknownEncoding",H[H.regexParseError=2]="regexParseError",H[H.globParseError=3]="globParseError",H[H.invalidLiteral=4]="invalidLiteral",H[H.rgProcessError=5]="rgProcessError",H[H.other=6]="other",H[H.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(F,N){super(F);this.code=N}}e.SearchError=S;function s(H){const F=H.message;if((0,P.isPromiseCanceledError)(H))return new S(F,w.canceled);try{const N=JSON.parse(F);return new S(N.message,N.code)}catch(N){return new S(F,w.other)}}e.deserializeSearchError=s;function b(H){const F={message:H.message,code:H.code};return new Error(JSON.stringify(F))}e.serializeSearchError=b;function R(H){return H.type==="error"?!0:H.type==="success"}e.isSerializedSearchComplete=R;function O(H){return H.type==="success"}e.isSerializedSearchSuccess=O;function $(H){return!!H.path}e.isSerializedFileMatch=$;function G(H,F){const N=H.searchPath?H.searchPath:H.relativePath;return(0,T.fuzzyContains)(N,F)}e.isFilePatternMatch=G;class Z{constructor(F){this.path=F,this.results=[]}addMatch(F){this.results.push(F)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Z;function U(H,F){const N={...H||{},...F||{}};return Object.keys(N).filter(j=>{const W=N[j];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=U;class x{constructor(F,N){this._parsedIncludeExpression=null,this._excludeExpression={...F.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let j=F.includePattern;N.includePattern&&(j?j={...j,...N.includePattern}:j=N.includePattern),j&&(this._parsedIncludeExpression=L.parse(j))}includedInQuerySync(F,N,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(F,N,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(F,N,j))}includedInQuery(F,N,j){const W=this._parsedExcludeExpression(F,N,j),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(F,N,j):!0;return(0,k.isPromise)(W)?W.then(J=>J?!1:Q()):Q()}hasSiblingExcludeClauses(){return M(this._excludeExpression)}}e.QueryGlobTester=x;function M(H){for(const F in H)if(typeof H[F]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,20,17,21,3,24,10,77,25,9,13,2,170,4,12,190,43,63,27,14,7,31,5]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a,l,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(b,R,O){return new P.ExtUri($=>m($,O)).isEqual(b,R)}function i(b,R,O){return o(b.uri,R.uri,O)?0:(0,n.compare)(b.uri.toString(),R.uri.toString())}function c(b,R,O){return b.index!==R.index?b.index<R.index?-1:1:o(b.uri,R.uri,O)?(0,n.compare)(b.name,R.name):(0,n.compare)(b.uri.toString(),R.uri.toString())}function h(b,R,O,$){const G=b.slice(0).sort((U,x)=>O(U,x,$)),Z=R.slice(0).sort((U,x)=>O(U,x,$));return(0,g.delta)(G,Z,(U,x)=>O(U,x,$))}function m(b,R){const O=R.getCapabilities(b.scheme);return!(O&&O&1024)}class w extends A.Workspace{constructor(R,O,$,G,Z,U){super(R,$.map(x=>new A.WorkspaceFolder(x)),G,U);this._name=O,this._isUntitled=Z,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(U),$.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(R,O,$,G){if(!R)return{workspace:null,added:[],removed:[]};const{id:Z,name:U,folders:x,configuration:M,isUntitled:H}=R,F=[],N=O;O?x.forEach((J,fe)=>{const _e=d.URI.revive(J.uri),ye=w._findFolder($||O,_e,G);ye?(ye.name=J.name,ye.index=J.index,F.push(ye)):F.push({uri:_e,name:J.name,index:fe})}):F.push(...x.map(({uri:J,name:fe,index:_e})=>({uri:d.URI.revive(J),name:fe,index:_e}))),F.sort((J,fe)=>J.index<fe.index?-1:1);const j=new w(Z,U,F,M?d.URI.revive(M):null,!!H,J=>m(J,G)),{added:W,removed:Q}=h(N?N.workspaceFolders:[],j.workspaceFolders,i,G);return{workspace:j,added:W,removed:Q}}static _findFolder(R,O,$){for(let G=0;G<R.folders.length;G++){const Z=R.workspaceFolders[G];if(o(Z.uri,O,$))return Z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,O){return O&&this._structure.get(R)&&(R=(0,P.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let S=class{constructor(R,O,$,G){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=G,this._extHostFileSystemInfo=$,this._requestIdProvider=new y.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(r.MainContext.MainThreadMessageService);const Z=O.workspace;this._confirmedWorkspace=Z?new w(Z.id,Z.name,[],Z.configuration?d.URI.revive(Z.configuration):null,!!Z.isUntitled,U=>m(U,$)):void 0}$initializeWorkspace(R,O){this._trusted=O,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:D.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,O,$,...G){const Z=[];if(Array.isArray(G)&&G.forEach(F=>{d.URI.isUri(F.uri)&&!Z.some(N=>o(N.uri,F.uri,this._extHostFileSystemInfo))&&Z.push({uri:F.uri,name:F.name||(0,P.basenameOrAuthority)(F.uri)})}),this._unconfirmedWorkspace||[O,$].some(F=>typeof F!="number"||F<0)||$===0&&Z.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(O+$>U.length)return!1;const x=U.slice(0);x.splice(O,$,...Z.map(F=>({uri:F.uri,name:F.name||(0,P.basenameOrAuthority)(F.uri),index:void 0})));for(let F=0;F<x.length;F++){const N=x[F];if(x.some((j,W)=>W!==F&&o(N.uri,j.uri,this._extHostFileSystemInfo)))return!1}x.forEach((F,N)=>F.index=N);const{added:M,removed:H}=h(U,x,c,this._extHostFileSystemInfo);if(M.length===0&&H.length===0)return!1;if(this._proxy){const F=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(F,O,$,Z).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,f.localize)(0,null,F,N.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(R,O){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,O)}async getWorkspaceFolder2(R,O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,O)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,O){let $,G="";if(typeof R=="string"?($=d.URI.file(R),G=R):typeof R!="undefined"&&($=R,G=R.fsPath),!$)return G;const Z=this.getWorkspaceFolder($,!0);if(!Z)return G;typeof O=="undefined"&&this._actualWorkspace&&(O=this._actualWorkspace.folders.length>1);let U=(0,P.relativePath)(Z.uri,$);return O&&Z.name&&(U=`${Z.name}/${U}`),U}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:O,added:$,removed:G}=w.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=O||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:G}))}findFiles(R,O,$,G,Z=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let U;if(O===null?U=!1:O&&(typeof O=="string"?U=O:U=O.pattern),Z&&Z.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:M}=s(R);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(x),(0,k.withUndefinedAsNull)(M),(0,k.withUndefinedAsNull)(U),(0,k.withUndefinedAsNull)($),Z).then(H=>Array.isArray(H)?H.map(F=>d.URI.revive(F)):[])}async findTextInFiles(R,O,$,G,Z=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),x=typeof O.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:M,folder:H}=s(O.include),F=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,N={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:x,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:M,excludePattern:F},j=!1;if(this._activeSearchCallbacks[U]=W=>{if(j)return;const Q=d.URI.revive(W.resource);W.results.forEach(J=>{(0,t.resultIsMatch)(J)?$({uri:Q,preview:{text:J.preview.text,matches:(0,g.mapArrayOrNot)(J.preview.matches,fe=>new v.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,g.mapArrayOrNot)(J.ranges,fe=>new v.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):$({uri:Q,text:J.text,lineNumber:J.lineNumber})})},Z.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(R,(0,k.withUndefinedAsNull)(H),N,U,Z);return delete this._activeSearchCallbacks[U],W||{}}catch(W){throw delete this._activeSearchCallbacks[U],W}}$handleTextSearchResult(R,O){this._activeSearchCallbacks[O]&&this._activeSearchCallbacks[O](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=je([Ue(0,l.IExtHostRpcService),Ue(1,a.IExtHostInitDataService),Ue(2,E.IExtHostFileSystemInfo),Ue(3,p.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function s(b){let R,O;return b&&(typeof b=="string"?R=b:(R=b.pattern,O=b.baseFolder||d.URI.file(b.base))),{includePattern:R,folder:O}}}),define(me[37],ge([0,1,23,3,36,5,7,192,85,13,17,4,14,12,2]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(r,o){if(o){const i=o.split(".");let c=r;for(let h=0;c&&h<i.length;h++)c=c[i[h]];return c}}function _(r){return r instanceof u.URI}function A(r){return r&&r.uri instanceof u.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&r.uri instanceof u.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function l(r){if(_(r))return{resource:r};if(A(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(a(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(o,i,c){this._proxy=o.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(o,i))}};v=je([Ue(0,d.IExtHostRpcService),Ue(1,I.IExtHostWorkspace),Ue(2,f.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(o,i,c,h){this._onDidChangeConfiguration=new L.Emitter,this._proxy=o,this._logService=h,this._extHostWorkspace=i,this._configuration=D.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(o,i,c){const h=l(i)||{},m=this._toReadonlyValue(o?p(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,h,c?.identifier);function w(s){if(s==null)return null;if(typeof s=="boolean")return s?1:4;switch(s){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const S={has(s){return typeof p(m,s)!="undefined"},get:(s,b)=>{this._validateConfigurationAccess(o?`${o}.${s}`:s,h,c?.identifier);let R=p(m,s);if(typeof R=="undefined")R=b;else{let O;const $=(G,Z)=>{let U;const x=()=>{O=O||(0,g.deepClone)(m),U=U||p(O,Z)};return(0,P.isObject)(G)?new Proxy(G,{get:(M,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return x(),()=>U;if(O)return U=U||p(O,Z),U[H];const F=M[H];return typeof H=="string"?$(F,`${Z}.${H}`):F},set:(M,H,F)=>(x(),U&&(U[H]=F),!0),deleteProperty:(M,H)=>(x(),U&&delete U[H],!0),defineProperty:(M,H,F)=>(x(),U&&Object.defineProperty(U,H,F),!0)}):G};R=$(R,s)}return R},update:(s,b,R,O)=>{s=o?`${o}.${s}`:s;const $=w(R);return b!==void 0?this._proxy.$updateConfigurationOption($,s,b,h,O):this._proxy.$removeConfigurationOption($,s,h,O)},inspect:s=>{s=o?`${o}.${s}`:s;const b=(0,g.deepClone)(this._configuration.inspect(s,h,this._extHostWorkspace.workspace));if(b)return{key:s,defaultValue:b.default?.value,globalValue:b.user?.value,workspaceValue:b.workspace?.value,workspaceFolderValue:b.workspaceFolder?.value,defaultLanguageValue:b.default?.override,globalLanguageValue:b.user?.override,workspaceLanguageValue:b.workspace?.override,workspaceFolderLanguageValue:b.workspaceFolder?.override,languageIds:b.overrideIdentifiers}}};return typeof m=="object"&&(0,g.mixin)(S,m,!1),Object.freeze(S)}_toReadonlyValue(o){const i=c=>(0,P.isObject)(c)?new Proxy(c,{get:(h,m)=>i(h[m]),set:(h,m,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(h,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(h,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(o)}_validateConfigurationAccess(o,i,c){const h=y.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),m=c?`[${c.value}] `:"";if(h===4){typeof i?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){i?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const c=new D.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,m)=>c.affectsConfiguration(h,l(m))})}_toMap(o){return o.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[71],ge([0,1,2,17,3,5,23,7,36,45,37,21,33,14,27,4,10,11,12,66,213,16]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a,l,v){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(U){function x(H){if(H!=null)return H}U.from=x;function M(H){if(H!=null)return H}U.to=M})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var o;(function(U){function x(H){if(H!=null)return H}U.from=x;function M(H){if(H!=null)return H}U.to=M})(o=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(U){function x(H){if(H!=null)return H}U.from=x;function M(H){if(H!=null)return H}U.to=M})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var c;(function(U){function x(F){if(F){const N=F;return N&&!!N.process}else return!1}U.is=x;function M(F){if(F==null)return;const N={process:F.process,args:F.args};return F.options&&(N.options=i.from(F.options)),N}U.from=M;function H(F){if(F!=null)return new D.ProcessExecution(F.process,F.args,F.options)}U.to=H})(c=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(U){function x(H){if(H!=null)return H}U.from=x;function M(H){if(H!=null)return H}U.to=M})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(U){function x(F){if(F){const N=F;return N&&(!!N.commandLine||!!N.command)}else return!1}U.is=x;function M(F){if(F==null)return;const N={};return F.commandLine!==void 0?N.commandLine=F.commandLine:(N.command=F.command,N.args=F.args),F.options&&(N.options=h.from(F.options)),N}U.from=M;function H(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new D.ShellExecution(F.commandLine,F.options):new D.ShellExecution(F.command,F.args?F.args:[],F.options)}U.to=H})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(U){function x(F){if(F){let N=F;return N&&N.customExecution==="customExecution"}else return!1}U.is=x;function M(F){return{customExecution:"customExecution"}}U.from=M;function H(F,N){return N.get(F)}U.to=H})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(U){function x(M,H){let F;return M.scope!==void 0&&typeof M.scope!="number"?F=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===D.TaskScope.Workspace&&H&&H.workspaceFile?F=H.workspaceFile:F=l.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:F}}U.from=x})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var s;(function(U){function x(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}U.from=x})(s=e.TaskGroupDTO||(e.TaskGroupDTO={}));var b;(function(U){function x(F,N){if(F==null)return[];const j=[];for(let W of F){const Q=M(W,N);Q&&j.push(Q)}return j}U.fromMany=x;function M(F,N){if(F==null)return;let j;F.execution instanceof D.ProcessExecution?j=c.from(F.execution):F.execution instanceof D.ShellExecution?j=m.from(F.execution):F.execution&&F.execution instanceof D.CustomExecution&&(j=w.from(F.execution));const W=r.from(F.definition);let Q;return F.scope?typeof F.scope=="number"?Q=F.scope:Q=F.scope.uri:Q=D.TaskScope.Workspace,!W||!Q?void 0:{_id:F._id,definition:W,name:F.name,source:{extensionId:N.identifier.value,label:F.source,scope:Q},execution:j,isBackground:F.isBackground,group:s.from(F.group),presentationOptions:o.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}U.from=M;async function H(F,N,j){if(F==null)return;let W;c.is(F.execution)?W=c.to(F.execution):m.is(F.execution)?W=m.to(F.execution):w.is(F.execution)&&(W=w.to(F._id,j));const Q=r.to(F.definition);let J;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?J=F.source.scope:J=await N.resolveWorkspaceFolder(g.URI.revive(F.source.scope)):J=D.TaskScope.Workspace),!Q||!J)return;const fe=new D.Task(Q,J,F.name,F.source.label,W,F.problemMatchers);return F.isBackground!==void 0&&(fe.isBackground=F.isBackground),F.group!==void 0&&(fe.group=D.TaskGroup.from(F.group._id),fe.group&&(fe.group=T.deepClone(fe.group),F.group.isDefault&&(fe.group.isDefault=F.group.isDefault))),F.presentationOptions&&(fe.presentationOptions=o.to(F.presentationOptions)),F._id&&(fe._id=F._id),F.detail&&(fe.detail=F.detail),fe}U.to=H})(b=e.TaskDTO||(e.TaskDTO={}));var R;(function(U){function x(H){return H}U.from=x;function M(H){if(!!H)return Object.assign(Object.create(null),H)}U.to=M})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class O{constructor(x,M,H){this._id=M,this._task=H,t.set(this,void 0),rt(this,t,x,"f")}get task(){return this._task}terminate(){$e(this,t,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}t=new WeakMap;var $;(function(U){function x(M){return{id:M._id,task:void 0}}U.from=x})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let G=class{constructor(x,M,H,F,N,j,W,Q){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=x.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=F,this._configurationService=N,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,M,H){if(!H)return new D.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:M,provider:H,extension:x}),this._proxy.$registerTaskProvider(F,M),new D.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(x,M){this._proxy.$registerTaskSystem(x,M)}fetchTasks(x){return this._proxy.$fetchTasks(R.from(x)).then(async M=>{const H=[];for(let F of M){const N=await b.to(F,this._workspaceProvider,this._providedCustomExecutions2);N&&H.push(N)}return H})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(M=>x.push(M)),x}terminateTask(x){if(!(x instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,M,H){const F=this._providedCustomExecutions2.get(x.id);if(F){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,F),this._terminalService.attachPtyToTerminal(M,await F.callback(H))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const M=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:M})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const M=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:M,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const M=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:M,exitCode:x.exitCode})}$provideTasks(x,M){const H=this._handlers.get(x);if(!H)return Promise.reject(new Error("no handler found"));const F=[],N=(0,L.asPromise)(()=>H.provider.provideTasks(k.CancellationToken.None)).then(j=>this.provideTasksInternal(M,F,H,j));return new Promise(j=>{N.then(W=>{Promise.all(F).then(()=>{j(W)})})})}async $resolveTask(x,M){const H=this._handlers.get(x);if(!H)return Promise.reject(new Error("no handler found"));if(M.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${H.type}].`);const F=await b.to(M,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const N=await H.provider.resolveTask(F,k.CancellationToken.None);if(!N)return;this.checkDeprecation(N,H);const j=b.from(N,H.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(j.execution)&&await this.addCustomExecution(j,N,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,M,H){const F=await this._proxy.$createTaskId(x);!H&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,M.execution)}async getTaskExecution(x,M){if(typeof x=="string"){const N=this._taskExecutionPromises.get(x);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let H=this._taskExecutionPromises.get(x.id);if(H)return H;const F=new Promise(async(N,j)=>{const W=M||await b.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);W?N(new O(this,x.id,W)):j("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,F),F.then(N=>(this._taskExecutions.set(x.id,N),N),N=>Promise.reject(N))}checkDeprecation(x,M){x._deprecated&&this._deprecationService.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let H=this._notProvidedCustomExecutions.values(),F=H.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=H.next()}};G=je([Ue(0,f.IExtHostRpcService),Ue(1,u.IExtHostInitDataService),Ue(2,y.IExtHostWorkspace),Ue(3,P.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,d.IExtHostTerminalService),Ue(6,E.ILogService),Ue(7,a.IExtHostApiDeprecationService)],G),e.ExtHostTaskBase=G;let Z=class extends G{constructor(x,M,H,F,N,j,W,Q){super(x,M,H,F,N,j,W,Q);this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:"",platform:A.PlatformToString(0)})}async executeTask(x,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const H=b.from(M,x);if(H===void 0)throw new Error("Task is not valid");if(w.is(H.execution))await this.addCustomExecution(H,M,!1);else throw new v.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),M);return this._proxy.$executeTask(H).catch(N=>{throw new Error(N)}),F}provideTasksInternal(x,M,H,F){const N=[];if(F)for(let j of F){this.checkDeprecation(j,H),(!j.definition||!x[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const W=b.from(j,H.extension);W&&w.is(W.execution)?(N.push(W),M.push(this.addCustomExecution(W,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:H.extension}}async resolveTaskInternal(x){if(w.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,M,H){}};Z=je([Ue(0,f.IExtHostRpcService),Ue(1,u.IExtHostInitDataService),Ue(2,y.IExtHostWorkspace),Ue(3,P.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,d.IExtHostTerminalService),Ue(6,E.ILogService),Ue(7,a.IExtHostApiDeprecationService)],Z),e.WorkerExtHostTask=Z,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(me[267],ge([0,1,20,55,30,79,24,10,8,25,9,13,2,146,176,121,43,129,266,31]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(w,S,s,b){this.configurationService=w,this.workspaceContextService=S,this.editorGroupsService=s,this.pathService=b}text(w,S,s={}){w=this.getContentPattern(w,s);const b=this.configurationService.getValue(),R=S&&S.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(S?.map(_.toWorkspaceFolder),s),type:2,contentPattern:w,previewOptions:s.previewOptions,maxFileSize:s.maxFileSize,usePCRE2:b.search.usePCRE2||R||!1,beforeContext:s.beforeContext,afterContext:s.afterContext,userDisabledExcludesAndIgnoreFiles:s.disregardExcludeSettings&&s.disregardIgnoreFiles}}getContentPattern(w,S){const s=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const b={...w,wordSeparators:s.editor.wordSeparators};return this.isCaseSensitive(w,S)&&(b.isCaseSensitive=!0),this.isMultiline(w)&&(b.isMultiline=!0),b}file(w,S={}){return{...this.commonQuery(w,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(w,S){return w?(w=Array.isArray(w)?w.map(i):i(w),S?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],S={}){const s=this.handleIncludeExclude(S.includePattern,S.expandPatterns),b=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),R=w.length>1,O=(s.searchPaths&&s.searchPaths.length?s.searchPaths.map(Z=>this.getFolderQueryForSearchPath(Z,S,b)):w.map(Z=>this.getFolderQueryForRoot(Z,S,b,R))).filter(Z=>!!Z),$={_reason:S._reason,folderQueries:O,usingSearchPaths:!!(s.searchPaths&&s.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:b.pattern,includePattern:s.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const U=g.coalesce(g.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(H=>H.resource)))).filter(M=>(0,a.pathIncludedInQuery)($,M.fsPath)),x=this.commonQueryFromFileList(U);return{...$,...x}}const G=S.extraFileResources&&S.extraFileResources.filter(Z=>(0,a.pathIncludedInQuery)($,Z.fsPath));return $.extraFileResources=G&&G.length?G:void 0,$}commonQueryFromFileList(w){const S=[],s=new T.ResourceMap,b={};let R=!1;return w.forEach(O=>{if(O.scheme===D.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(O)){const G=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:y.dirname(O.fsPath)});let Z=s.get(G);Z||(R=!0,Z={folder:G,includePattern:{}},S.push(Z),s.set(G,Z));const U=y.relative(G.fsPath,O.fsPath);(0,k.assertIsDefined)(Z.includePattern)[U.replace(/\\/g,"/")]=!0}else O.fsPath&&(R=!0,b[O.fsPath]=!0)}),{folderQueries:S,includePattern:b,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(w,S){if(S.isSmartCase){if(w.isRegExp){if(n.containsUppercaseCharacter(w.pattern,!0))return!0}else if(n.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,f.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const S=x=>y.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),b=(Array.isArray(w)?w:r(w)).map(x=>{const M=this.pathService.resolvedUserHome;return M?(0,C.untildify)(x,M.scheme===D.Schemas.file?M.fsPath:M.path):x}),R=L.groupBy(b,x=>S(x)?"searchPaths":"exprSegments"),O=(R.exprSegments||[]).map(x=>n.rtrim(x,"/")).map(x=>n.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),o(x))),$={},G=this.expandSearchPathPatterns(R.searchPaths||[]);G&&G.length&&($.searchPaths=G);const Z=g.flatten(O),U=t(...Z);return U&&($.pattern=U),$}getExcludesForFolder(w,S){return S.disregardExcludeSettings?void 0:(0,a.getExcludes)(w,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const S=g.flatten(w.map(b=>{let{pathPortion:R,globPortion:O}=v(b);O&&(O=c(O));const $=this.expandOneSearchPath(R);return g.flatten($.map(G=>this.resolveOneSearchPathPattern(G,O)))})),s=new Map;return S.forEach(b=>{const R=b.searchPath.toString(),O=s.get(R);O?b.pattern&&(O.pattern=O.pattern||{},O.pattern[b.pattern]=!0):s.set(R,{searchPath:b.searchPath,pattern:b.pattern?t(b.pattern):void 0})}),Array.from(s.values())}expandOneSearchPath(w){if(y.isAbsolute(w)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==D.Schemas.file?[{searchPath:S[0].uri.with({path:w})}]:[{searchPath:d.URI.file(y.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=i(w),w.startsWith("../")||w===".."){const b=y.posix.resolve(S.path,w);return[{searchPath:S.with({path:b})}]}const s=c(w);return[{searchPath:S,pattern:s}]}else{if(w==="./"||w===".\\")return[];{const S=w.replace(/^\.[\/\\]/,""),b=this.workspaceContextService.getWorkspace().folders.map(R=>{const O=S.match(new RegExp(`^${n.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return O?{match:O,folder:R}:null}).filter(k.isDefined);if(b.length)return b.map(R=>{const O=R.match[1];return{searchPath:R.folder.uri,pattern:O&&c(O)}});{const R=w.match(/\.[\/\\](.+)[\/\\]?/),O=R?R[1]:w,$=u.localize(0,null,O);throw new Error($)}}}}resolveOneSearchPathPattern(w,S){const s=w.pattern&&S?`${w.pattern}/${S}`:w.pattern||S,b=[{searchPath:w.searchPath,pattern:s}];return s&&!s.endsWith("**")&&b.push({searchPath:w.searchPath,pattern:s+"/**"}),b}getFolderQueryForSearchPath(w,S,s){const b=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(w.searchPath),S,s,!1);return b?{...b,includePattern:w.pattern}:null}getFolderQueryForRoot(w,S,s,b){let R;const O=d.URI.isUri(w)?w:w.uri;if(s.searchPaths){const x=s.searchPaths.filter(M=>(0,P.isEqual)(M.searchPath,O))[0];if(x&&!x.pattern)return null;x&&(R=x.pattern)}const $=this.configurationService.getValue({resource:O}),Z={...this.getExcludesForFolder($,S)||{},...R||{}},U=d.URI.isUri(w)?(0,P.basename)(w):w.name;return{folder:O,folderName:b?U:void 0,excludePattern:Object.keys(Z).length>0?Z:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!$.search.followSymlinks}}};l=je([Ue(0,p.IConfigurationService),Ue(1,_.IWorkspaceContextService),Ue(2,A.IEditorGroupsService),Ue(3,E.IPathService)],l),e.QueryBuilder=l;function v(m){const w=m.match(/[\*\{\}\(\)\[\]\?]/);if(w){const S=w.index,s=m.substr(0,S).match(/[/|\\][^/\\]*$/);if(s){let b=m.substr(0,s.index);return b.match(/[/\\]/)||(b+="/"),{pathPortion:b,globPortion:m.substr((s.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((w,S)=>(w[S]=!0,w),Object.create(null)):void 0}function r(m){return I.splitGlobAware(m,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(m){return[`**/${m}/**`,`**/${m}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function i(m){return m.replace(/\\/g,"/")}function c(m){return i(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(m,w){m=g.distinct(m,b=>b.toString());const S=[],s=w.getWorkspace();return m&&m.forEach(b=>{let R;if(w.getWorkbenchState()===2)R=(0,P.relativePath)(s.folders[0].uri,b),R&&R!=="."&&(R="./"+R);else{const O=w.getWorkspaceFolder(b);if(O){const $=O.name;if(s.folders.filter(Z=>Z.name===$).length===1){const Z=(0,P.relativePath)(O.uri,b);Z===""?R=`./${O.name}`:R=`./${O.name}/${Z}`}else R=b.fsPath}}R&&S.push(R)}),S}e.resolveResourcesForSearchIncludes=h}),define(me[268],ge([0,1,25,2,21,16,4,267,31,43]),function(Y,e,g,L,I,C,T,D,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function k(p,_){const A=_.activationEvents;if(!A)return Promise.resolve(void 0);const E=[],a=[];for(const i of A)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||p.forceUsingSearch?a.push(c):E.push(c)}if(E.length===0&&a.length===0)return Promise.resolve(void 0);let l;const v=new Promise((i,c)=>{l=i}),t=i=>l({activationEvent:i}),r=Promise.all(E.map(i=>d(p,i,t))).then(()=>{}),o=f(p,_.identifier,a,t);return Promise.all([r,o]).then(()=>{l(void 0)}),v}e.checkActivateWorkspaceContainsExtension=k;async function d(p,_,A){for(const E of p.folders)if(await p.exists(g.joinPath(L.URI.revive(E),_))){A(`workspaceContains:${_}`);return}}async function f(p,_,A,E){if(A.length===0)return Promise.resolve(void 0);const a=new I.CancellationTokenSource,l=p.checkExists(p.folders,A,a.token),v=setTimeout(async()=>{a.cancel(),E(`workspaceContainsTimeout:${A.join(",")}`)},n);let t=!1;try{t=await l}catch(r){C.isPromiseCanceledError(r)||C.onUnexpectedError(r)}a.dispose(),clearTimeout(v),t&&E(`workspaceContains:${A.join(",")}`)}function u(p,_,A,E){const a=p.get(T.IInstantiationService),l=p.get(y.ISearchService),t=a.createInstance(D.QueryBuilder).file(_.map(r=>(0,P.toWorkspaceFolder)(L.URI.revive(r))),{_reason:"checkExists",includePattern:A,exists:!0});return l.fileSearch(t,E).then(r=>!!r.limitHit,r=>C.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=u});var rt=this&&this.__classPrivateFieldSet||function(Y,e,g,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Y,g):I?I.value=g:e.set(Y,g),g},$e=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(me[40],ge([0,1,165,8,72,25,17,6,24,2,12,5,37,226,93,36,35,224,16,26,22,199,7,122,4,27,68,14,84,52,33,3,268,91,201]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a,l,v,t,r,o,i,c,h,m,w,S,s,b,R,O){"use strict";var $,G,Z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let U=class Hn extends D.Disposable{constructor(F,N,j,W,Q,J,fe,_e,ye,Le){super();this._onDidChangeRemoteConnectionData=this._register(new s.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=N,this._extHostContext=j,this._initData=fe,this._extHostWorkspace=W,this._extHostConfiguration=Q,this._logService=J,this._extHostTunnelService=ye,this._extHostTerminalService=Le,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=F.createChild(new m.ServiceCollection([u.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const Be=new Set;this._initData.hostExtensions.forEach(xe=>Be.add(a.ExtensionIdentifier.toKey(xe))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(xe,Ke,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(xe,E.transformErrorForSerialization(Ke),z)},actualActivateExtension:async(xe,Ke)=>{if(Be.has(a.ExtensionIdentifier.toKey(xe)))return await this._mainThreadExtensionsProxy.$activateExtension(xe,Ke),new f.HostExtension;const z=this._registry.getExtensionDescription(xe);return this._activateExtension(z,Ke)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){E.onUnexpectedError(F)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let F=[];try{F=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(N){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,N){return this._activator.activateByEvent(F,N)}_activateById(F,N){return this._activator.activateById(F,N)}activateByIdWithErrors(F,N){return this._activateById(F,N).then(()=>{const j=this._activator.getActivatedExtension(F);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=y.TernarySearchTree.forPaths(),N=this._registry.getAllExtensionDescriptions().map(j=>{if(!!this._getEntryPoint(j))return this._hostUtils.realpath(j.extensionLocation.fsPath).then(W=>F.set(P.URI.file(W).fsPath,j))});this._extensionPathIndex=Promise.all(N).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let N=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return N;const j=this._activator.getActivatedExtension(F);if(!j)return N;try{typeof j.module.deactivate=="function"&&(N=Promise.resolve(j.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,D.dispose)(j.subscriptions)}catch(W){this._logService.error(W)}return N}async _activateExtension(F,N){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,N).then(j=>{const W=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,N),this._logExtensionActivationTimes(F,N,"success",W),j},j=>{throw this._logExtensionActivationTimes(F,N,"failure"),j})}_logExtensionActivationTimes(F,N,j,W){const Q=x(F,N);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...W||{},outcome:j})}_doActivateExtension(F,N){const j=x(F,N);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const W=this._getEntryPoint(F);if(!W)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(N)}`),this._logService.flush();const Q=new f.ExtensionActivationTimesBuilder(N.startup);return Promise.all([this._loadCommonJSModule(F.identifier,(0,C.joinPath)(F.extensionLocation,W),Q),this._loadExtensionContext(F)]).then(J=>(I.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Hn._callActivate(this._logService,F.identifier,J[0],J[1],Q))).then(J=>(I.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),J))}_loadExtensionContext(F){const N=new v.ExtensionGlobalMemento(F,this._storage),j=new v.ExtensionMemento(F.identifier.value,!1,this._storage),W=new O.ExtensionSecrets(F,this._secretState),Q=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,J=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([N.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let _e;return Object.freeze({globalState:N,workspaceState:j,secrets:W,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(ye){return L.join(F.extensionLocation.fsPath,ye)},get storagePath(){return fe._storagePath.workspaceValue(F)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(F).fsPath},get logPath(){return L.join(fe._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return P.URI.joinPath(fe._initData.logsLocation,F.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(F)},get globalStorageUri(){return fe._storagePath.globalValue(F)},get extensionMode(){return Q},get extension(){return _e===void 0&&(_e=new M(fe,F.identifier,F,J)),_e},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(F),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,N,j,W,Q){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,N,j,W,Q).then(J=>new f.ActivatedExtension(!1,null,Q.build(),j,J,W.subscriptions))}static _callActivateOptional(F,N,j,W,Q){if(typeof j.activate=="function")try{Q.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${N.value}`);const J=typeof global=="object"?global:self,fe=j.activate.apply(J,[W]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(fe).then(_e=>(Q.activateResolveStop(),_e))}catch(J){return Promise.reject(J)}else return Promise.resolve(j)}_activateOneStartupFinished(F,N){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:N}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const N of F.activationEvents)N==="onStartupFinished"&&this._activateOneStartupFinished(F,N)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const N=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(N),W=Promise.all([F,j]).then(()=>{});return Promise.race([W,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(N=>this._handleWorkspaceContainsEagerExtension(F,N))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,N){if(this.isActivated(N.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:F.map(J=>J.uri),forceUsingSearch:j,exists:J=>this._hostUtils.exists(J.fsPath),checkExists:(J,fe,_e)=>this._mainThreadWorkspaceProxy.$checkExists(J,fe,_e)},Q=await(0,b.checkActivateWorkspaceContainsExtension)(W,N);if(!!Q)return this._activateById(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:Q.activationEvent}).then(void 0,J=>this._logService.error(J))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:N}=this._initData.environment;if(!F||!N)throw new Error(g.localize(0,null));const j=await this._loadCommonJSModule(null,N,new f.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(g.localize(1,null,N.toString()));return new Promise((W,Q)=>{const J=(ye,Le)=>{ye?Q(ye):W(typeof Le=="number"&&Le>0?1:0)},fe=(0,C.originalFSPath)(N),_e=j.run(fe,J);_e&&_e.then&&_e.then(()=>{W(0)}).catch(ye=>{Q(ye.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,N){return this._resolvers[F]=N,(0,D.toDisposable)(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const N=F.indexOf("+");if(N===-1)throw new Error("Not an authority that can be resolved!");const j=F.substr(0,N);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(F,N){const{authorityPrefix:j,resolver:W}=await this._activateAndGetResolver(F);if(!W)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),I.mark(`code/extHost/willResolveAuthority/${j}`);const Q=await W.resolve(F,{resolveAttempt:N});I.mark(`code/extHost/didResolveAuthorityOK/${j}`);const J={authority:F,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},fe={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:J,options:fe,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(I.mark(`code/extHost/didResolveAuthorityError/${j}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(F,N){const{authorityPrefix:j,resolver:W}=await this._activateAndGetResolver(F);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const Q=P.URI.revive(N);if(typeof W.getCanonicalURI=="undefined")return Q;const J=await(0,T.asPromise)(()=>W.getCanonicalURI(Q));return J||Q}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,N){return N===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(F,!1))}async $activate(F,N){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,N),!0):!1}async $deltaExtensions(F,N){F.forEach(W=>W.extensionLocation=P.URI.revive(W.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(N.map(async W=>{const Q=this._registry.getExtensionDescription(W);if(!Q)return;const J=await this._hostUtils.realpath(Q.extensionLocation.fsPath);j.delete(P.URI.file(J).fsPath)})),await Promise.all(F.map(async W=>{const Q=await this._hostUtils.realpath(W.extensionLocation.fsPath);j.set(P.URI.file(Q).fsPath,W)})),this._registry.deltaExtensions(F,N),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let N=l.VSBuffer.alloc(F),j=Math.random()%256;for(let W=0;W<F;W++)N.writeUInt8(j,W);return N}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};U=je([Ue(0,o.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,h.IExtHostRpcService),Ue(3,p.IExtHostWorkspace),Ue(4,d.IExtHostConfiguration),Ue(5,n.ILogService),Ue(6,i.IExtHostInitDataService),Ue(7,c.IExtensionStoragePaths),Ue(8,w.IExtHostTunnelService),Ue(9,S.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function x(H,F){return{id:H.identifier.value,name:H.name,extensionVersion:H.version,publisherDisplayName:H.publisher,activationEvents:H.activationEvents?H.activationEvents.join(","):null,isBuiltin:H.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class M{constructor(F,N,j,W){$.set(this,void 0),G.set(this,void 0),Z.set(this,void 0),rt(this,$,F,"f"),rt(this,G,N,"f"),rt(this,Z,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=W}get isActive(){return $e(this,$,"f").isActivated($e(this,Z,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,$,"f").getExtensionExports($e(this,Z,"f"))}activate(){return $e(this,$,"f").activateByIdWithErrors($e(this,Z,"f"),{startup:!1,extensionId:$e(this,G,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,$=new WeakMap,G=new WeakMap,Z=new WeakMap}),define(me[53],ge([0,1,8,2,3,17,5,7,125,36,40,45,215,37,209,14,4,13,38,51]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let l=class{constructor(m,w,S,s,b,R){this._workspaceService=w,this._extensionService=S,this._editorsService=s,this._configurationService=b,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=m.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange($=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,w){const S=m;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let s=`debug:${encodeURIComponent(S.path||"")}`,b="?";return w&&(s+=`${b}session=${encodeURIComponent(w.id)}`,b="&"),s+=`${b}ref=${S.sourceReference}`,L.URI.parse(s)}else{if(S.path)return L.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const w=[];for(const S of m.getAllExtensionDescriptions())if(S.contributes){const s=S.contributes.debuggers;if(s&&s.length>0)for(const b of s)(0,u.isDebuggerMainContribution)(b)&&w.push(b.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(w=>m.push(w)),m}addBreakpoints(m){this.startBreakpoints();const w=m.filter(b=>{const R=b.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,b),!0)});this.fireBreakpointChanges(w,[],[]);const S=[],s=new Map;for(const b of w)if(b instanceof D.SourceBreakpoint){let R=s.get(b.location.uri.toString());R||(R={type:"sourceMulti",uri:b.location.uri,lines:[]},s.set(b.location.uri.toString(),R),S.push(R)),R.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof D.FunctionBreakpoint&&S.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(m){this.startBreakpoints();const w=m.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],w,[]);const S=w.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),s=w.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),b=w.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(S,s,b)}startDebugging(m,w,S){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,w,{parentSessionID:S.parentSession?S.parentSession.id:void 0,lifecycleManagedByParent:S.lifecycleManagedByParent,repl:S.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact,debugUI:S.debugUI})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,w,S){if(!w)return new D.Disposable(()=>{});const s=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:s,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,S,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,s),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(s)})}registerDebugAdapterDescriptorFactory(m,w,S){if(!S)return new D.Disposable(()=>{});if(!this.definesDebugType(m,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const s=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:s,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,s),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(s)})}registerDebugAdapterTrackerFactory(m,w){if(!w)return new D.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:S,factory:w}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(s=>s.factory!==w)})}async $runInTerminal(m,w){return Promise.resolve(void 0)}async $substituteVariables(m,w){if(!this._variableResolver){const[b,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,R)}let S;const s=await this.getFolder(m);return s&&(S={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(S,w)}createDebugAdapter(m,w){if(m.type==="implementation")return new i(m.implementation)}createSignService(){}async $startDASession(m,w){const S=this,s=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(s.type),s).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}' (extension might have failed to activate)`);const R=this.convertToDto(b),O=this.createDebugAdapter(R,s);if(!O)throw new Error(`Couldn't create a debug adapter for type '${s.type}'.`);const $=O;return this._debugAdapters.set(m,$),this.getDebugAdapterTrackers(s).then(G=>(G&&this._debugAdaptersTrackers.set(m,G),$.onMessage(async Z=>{if(Z.type==="request"&&Z.command==="handshake"){const U=Z,x={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(U.arguments.value);x.body={signature:M},$.sendResponse(x)}else throw new Error("no signer")}catch(M){x.success=!1,x.message=M.message,$.sendResponse(x)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(Z),Z=(0,u.convertToVSCPaths)(Z,!0),S._debugServiceProxy.$acceptDAMessage(m,Z)}),$.onError(Z=>{G&&G.onError&&G.onError(Z),this._debugServiceProxy.$acceptDAError(m,Z.name,Z.message,Z.stack)}),$.onExit(Z=>{G&&G.onExit&&G.onExit((0,A.withNullAsUndefined)(Z),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,A.withNullAsUndefined)(Z),void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),$.startSession()))})}$sendDAMessage(m,w){w=(0,u.convertToDAPaths)(w,!1);const S=this._debugAdaptersTrackers.get(m);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(w);const s=this._debugAdapters.get(m);s&&s.sendMessage(w)}$stopDASession(m){const w=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),w&&w.onWillStopSession&&w.onWillStopSession();const S=this._debugAdapters.get(m);return this._debugAdapters.delete(m),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const w=[],S=[],s=[];if(m.added)for(const b of m.added){const R=b.id;if(R&&!this._breakpoints.has(R)){let O;if(b.type==="function")O=new D.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")O=new D.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const $=L.URI.revive(b.uri);O=new D.SourceBreakpoint(new D.Location($,new D.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}O._id=R,this._breakpoints.set(R,O),w.push(O)}}if(m.removed)for(const b of m.removed){const R=this._breakpoints.get(b);R&&(this._breakpoints.delete(b),S.push(R))}if(m.changed){for(const b of m.changed)if(b.id){const R=this._breakpoints.get(b.id);if(R){if(R instanceof D.FunctionBreakpoint&&b.type==="function"){const O=R;O.enabled=b.enabled,O.condition=b.condition,O.hitCondition=b.hitCondition,O.logMessage=b.logMessage,O.functionName=b.functionName}else if(R instanceof D.SourceBreakpoint&&b.type==="source"){const O=R;O.enabled=b.enabled,O.condition=b.condition,O.hitCondition=b.hitCondition,O.logMessage=b.logMessage,O.location=new D.Location(L.URI.revive(b.uri),new D.Position(b.line,b.character))}s.push(R)}}}this.fireBreakpointChanges(w,S,s)}$provideDebugConfigurations(m,w,S){return(0,C.asPromise)(async()=>{const s=this.getConfigProviderByHandle(m);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(w);return s.provideDebugConfigurations(b,S)}).then(s=>{if(!s)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return s})}$resolveDebugConfiguration(m,w,S,s){return(0,C.asPromise)(async()=>{const b=this.getConfigProviderByHandle(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(w);return b.resolveDebugConfiguration(R,S,s)})}$resolveDebugConfigurationWithSubstitutedVariables(m,w,S,s){return(0,C.asPromise)(async()=>{const b=this.getConfigProviderByHandle(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(w);return b.resolveDebugConfigurationWithSubstitutedVariables(R,S,s)})}async $provideDebugAdapter(m,w){const S=this.getAdapterDescriptorFactoryByHandle(m);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const s=await this.getSession(w);return this.getAdapterDescriptor(S,s).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(m){const w=await this.getSession(m);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(m){const w=await this.getSession(m);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,w){const S=await this.getSession(m);S&&S._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(m,w){const s={session:await this.getSession(m),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(s)}convertToDto(m){if(m instanceof D.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof D.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const w=this._adapterFactories.filter(S=>S.type===m);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(m){const w=this._adapterFactories.filter(S=>S.handle===m);if(w.length>0)return w[0].factory}getConfigProviderByHandle(m){const w=this._configProviders.filter(S=>S.handle===m);if(w.length>0)return w[0].provider}definesDebugType(m,w){if(m.contributes){const S=m.contributes.debuggers;if(S&&S.length>0){for(const s of S)if(s.label&&s.type&&s.type===w)return!0}}return!1}getDebugAdapterTrackers(m){const S=m.configuration.type,s=this._trackerFactories.filter(b=>b.type===S||b.type==="*").map(b=>(0,C.asPromise)(()=>b.factory.createDebugAdapterTracker(m)).then(R=>R,R=>null));return Promise.race([Promise.all(s).then(b=>{const R=b.filter(O=>!!O);if(R.length>0)return new o(R)}),new Promise((b,R)=>{const O=setTimeout(()=>{clearTimeout(O),R(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(m,w){const S=w.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new D.DebugAdapterServer(S));if(m){const b=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>m.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,b))).then(R=>{if(R)return R})}const s=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,s))}daExecutableFromPackage(m,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,w,S){(m.length>0||w.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:w,changed:S}))}async getSession(m){if(m)if(typeof m=="string"){const w=this._debugSessions.get(m);if(w)return w}else{let w=this._debugSessions.get(m.id);if(!w){const S=await this.getFolder(m.folderUri),s=m.parent?this._debugSessions.get(m.parent):void 0;w=new v(this._debugServiceProxy,m.id,m.type,m.name,S,m.configuration,s),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(m){if(m){const w=L.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};l=je([Ue(0,p.IExtHostRpcService),Ue(1,P.IExtHostWorkspace),Ue(2,n.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,f.IExtHostConfiguration),Ue(5,a.IExtHostEditorTabs)],l),e.ExtHostDebugServiceBase=l;class v{constructor(m,w,S,s,b,R,O){this._debugServiceProxy=m,this._id=w,this._type=S,this._name=s,this._workspaceFolder=b,this._configuration=R,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,w)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=v;class t{constructor(m){this.value=Object.freeze({append(w){m.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class r extends d.AbstractVariableResolverService{constructor(m,w,S,s,b){function R(){if(w){const O=w.activeEditor();if(O)return O.document.uri;const $=s.tabs.filter(G=>G.isActive);if($.length>0)return $[0].resource}}super({getFolderUri:O=>{const $=m.filter(G=>G.name===O);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(O,$)=>S.getConfiguration(void 0,O).get($),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const O=R();if(O)return g.normalize(O.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const O=R();if(O){const $=b.getWorkspaceFolder(O);if($)return g.normalize($.uri.fsPath)}}},getSelectedText:()=>{if(w){const O=w.activeEditor();if(O&&!O.selection.isEmpty)return O.document.getText(O.selection)}},getLineNumber:()=>{if(w){const O=w.activeEditor();if(O)return String(O.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=r;class o{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(w=>w.onError?w.onError(m):void 0)}onExit(m,w){this.trackers.forEach(S=>S.onExit?S.onExit(m,w):void 0)}}class i extends y.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends l{constructor(m,w,S,s,b,R){super(m,w,S,s,b,R)}createVariableResolver(m,w,S){return new r(m,w,S,this._editorTabs)}};c=je([Ue(0,p.IExtHostRpcService),Ue(1,P.IExtHostWorkspace),Ue(2,n.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,f.IExtHostConfiguration),Ue(5,a.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(me[269],ge([0,1,72,2,5,37,35,26,14,27,4,40,38,12]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(a,l,v,t,r,o,i){this._apiFactory=a,this._extensionRegistry=l,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=o,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,l,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,l,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let l of a.nodeModuleName)this._factories.set(l,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(l=>a.alternativeModuleName(l))}};u=je([Ue(2,n.IInstantiationService),Ue(3,C.IExtHostConfiguration),Ue(4,k.IExtHostExtensionService),Ue(5,P.IExtHostInitDataService),Ue(6,f.ILogService)],u),e.RequireInterceptor=u;class p{constructor(a,l,v,t,r){this._apiFactory=a,this._extensionPaths=l,this._extensionRegistry=v,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,l){const v=this._extensionPaths.findSubstr(l.fsPath);if(v){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,o)=>t+=`	${o} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(a,l){this.nodeModuleName="keytar";const{environment:v}=l,t=a.getProxy(I.MainContext.MainThreadKeytar);if(v.appRoot){let r=v.appRoot.fsPath;d.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,o)=>t.$getPassword(r,o),setPassword:(r,o,i)=>t.$setPassword(r,o,i),deletePassword:(r,o)=>t.$deletePassword(r,o),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(a,l){return this._impl}alternativeModuleName(a){const l=a.length;if(l<=7||!this.alternativeNames)return;const v=l-7;if((a.charAt(v)==="/"||a.charAt(v)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};_=je([Ue(0,y.IExtHostRpcService),Ue(1,P.IExtHostInitDataService)],_);let A=class{constructor(a,l,v){this._extensionPaths=a,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(I.MainContext.MainThreadTelemetry);const t=v.getProxy(I.MainContext.MainThreadWindow);this._impl=(r,o)=>{const i=L.URI.parse(r);return o?this.callOriginal(r,o):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,o)}}load(a,l,v){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(a),this._impl}callOriginal(a,l){return this.sendNoForwardTelemetry(),this._original(a,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=je([Ue(2,y.IExtHostRpcService)],A)}),define(me[270],ge([0,1,171,11,7,210,36,40,45,37,33,14,53,194,17,211,51]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let A=class extends d.ExtHostDebugServiceBase{constructor(l,v,t,r,o,i,c){super(l,v,t,r,o,c);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(l,v){switch(l.type){case"server":return new C.SocketDebugAdapter(l);case"pipeServer":return new C.NamedPipeDebugAdapter(l);case"executable":return new C.ExecutableDebugAdapter(l,v.type)}return super.createDebugAdapter(l,v)}daExecutableFromPackage(l,v){const t=C.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),l.type);if(t)return new I.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(l,v){if(l.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),i=l.title||g.localize(0,null),c=JSON.stringify({shell:r,shellArgs:o});let h=await this._integratedTerminalInstances.checkout(c,i),m,w=!1;if(h)m=l.cwd;else{const R={shellPath:r,shellArgs:o,cwd:l.cwd,name:i,iconPath:new I.ThemeIcon("debug")};w=!0,h=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,c)}h.show(!0);const S=await h.processId;w?await new Promise(R=>setTimeout(R,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?h.sendText("cls"):r.indexOf("bash")>=0?h.sendText("clear"):L.isWindows?h.sendText("cls"):h.sendText("clear"));const s=(0,p.prepareCommand)(r,l.args,m,l.env);h.sendText(s);const b=this.onDidTerminateDebugSession(R=>{R.id===v&&(this._integratedTerminalInstances.free(h),b.dispose())});return S}else if(l.kind==="external")return(0,p.runInExternalTerminal)(l,await this._configurationService.getConfigProvider());return super.$runInTerminal(l,v)}createVariableResolver(l,v,t){return new d.ExtHostVariableResolverService(l,v,t,this._editorTabs,this._workspaceService)}};A=je([Ue(0,k.IExtHostRpcService),Ue(1,T.IExtHostWorkspace),Ue(2,D.IExtHostExtensionService),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,P.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,_.IExtHostEditorTabs)],A),e.ExtHostDebugService=A;class E{constructor(){this._terminalInstances=new Map}async checkout(l,v){const r=[...this._terminalInstances.entries()].map(([o,i])=>(0,u.createCancelablePromise)(async c=>{if(o.name!==v||i.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await o.processId))return null;const h=Date.now();return i.lastUsedAt+E.minUseDelay>h||c.isCancellationRequested||i.config!==l?null:(i.lastUsedAt=h,o)}));return await(0,u.firstParallel)(r,o=>!!o)}insert(l,v){this._terminalInstances.set(l,{lastUsedAt:Date.now(),config:v})}free(l){const v=this._terminalInstances.get(l);v&&(v.lastUsedAt=-1)}onTerminalClosed(l){this._terminalInstances.delete(l)}}E.minUseDelay=1e3}),define(me[271],ge([0,1,8,2,113,36,53,45,37,43,33,14,27,71,10,12,66,51,25,80]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let l=class extends f.ExtHostTaskBase{constructor(t,r,o,i,c,h,m,w,S){super(t,r,o,i,c,h,m,w);this.workspaceService=o,this.editorTabs=S,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(u.Schemas.file,{scheme:u.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,r){const o=r;if(!r.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const i=f.TaskHandleDTO.from(o,this.workspaceService),c=await this._proxy.$getTaskExecution(i);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const h=await this.getTaskExecution(c,r);return this._proxy.$executeTask(i).catch(()=>{}),h}else{const i=f.TaskDTO.from(r,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,r,!1);const c=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),r);return this._proxy.$executeTask(i).catch(()=>{}),c}}provideTasksInternal(t,r,o,i){const c=[];if(i)for(let h of i){this.checkDeprecation(h,o),(!h.definition||!t[h.definition.type])&&this._logService.warn(`The task [${h.source}, ${h.name}] uses an undefined task type. The task will be ignored in the future.`);const m=f.TaskDTO.from(h,o.extension);m&&(c.push(m),f.CustomExecutionDTO.is(m.execution)&&r.push(this.addCustomExecution(m,h,!0)))}return{tasks:c,extension:o.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const r=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(t,this._editorService,r,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let r=t&&t.length>0?t[0]:void 0;if(!r){const o=L.URI.file((0,a.homedir)());r=new P.WorkspaceFolder({uri:o,name:E.basename(o),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,r){const o=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},c=await this._workspaceProvider.resolveWorkspaceFolder(o),h=await this._workspaceProvider.getWorkspaceFolders2()??[],m=await this.getVariableResolver(h),w=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(h);for(let S of r.variables)i.variables[S]=await m.resolveAsync(w,S);if(r.process!==void 0){let S;if(r.process.path!==void 0){S=r.process.path.split(g.delimiter);for(let s=0;s<S.length;s++)S[s]=await m.resolveAsync(w,S[s])}i.process=await I.win32.findExecutable(await m.resolveAsync(w,r.process.name),r.process.cwd!==void 0?await m.resolveAsync(w,r.process.cwd):void 0,S)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,r,o){return I.win32.findExecutable(t,r,o)}};l=je([Ue(0,k.IExtHostRpcService),Ue(1,d.IExtHostInitDataService),Ue(2,C.IExtHostWorkspace),Ue(3,D.IExtHostDocumentsAndEditors),Ue(4,y.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,p.ILogService),Ue(7,_.IExtHostApiDeprecationService),Ue(8,A.IExtHostEditorTabs)],l),e.ExtHostTask=l}),define(me[272],ge([0,1,17,16,72,6,2,5,264,12,82,84,27,189,14,64,40,33]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(l,v,t,r){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(l,null,r),v=E._transform(v,this._rpcProtocol);const o=new k.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());o.set(d.IExtHostInitDataService,{_serviceBrand:void 0,...v}),o.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),o.set(p.IURITransformerService,new p.URITransformerService(r)),o.set(_.IHostUtils,t);const i=new f.InstantiationService(o,!0),c=i.invokeFunction(S=>S.get(A.IExtHostTerminalService));this._disposables.add(c),this._logService=i.invokeFunction(S=>S.get(P.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(S=>S.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(S=>{Error.prepareStackTrace=(s,b)=>{let R="",O,$;for(const G of b)R+=`
	at ${G.toString()}`,$=G.getFileName(),!O&&$&&(O=S.findSubstr($));return h.set(s,O),`${s.name||"Error"}: ${s.message||""}${R}`}});const m=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(S=>{const s=L.transformErrorForSerialization(S),b=h.get(S);b?m.$onExtensionRuntimeError(b.identifier,s):w.$onUnexpectedError(s)})}terminate(l){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(l,v){l.extensions.forEach(r=>r.extensionLocation=T.URI.revive(v.transformIncomingURIs(r.extensionLocation))),l.environment.appRoot=T.URI.revive(v.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(r=>T.URI.revive(v.transformIncomingURIs(r)))),l.environment.extensionTestsLocationURI=T.URI.revive(v.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=T.URI.revive(v.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=T.URI.revive(v.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=T.URI.revive(v.transformIncomingURIs(l.logsLocation)),l.logFile=T.URI.revive(v.transformIncomingURIs(l.logFile)),l.workspace=v.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=E}),define(me[273],ge([0,1,8,21,60,30,25,46,31]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(d,f,u){this.config=d,this.provider=f,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&C.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&C.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const f=this.config.folderQueries||[];return new Promise((u,p)=>{const _=A=>{this.resultCount++,d(A)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const E=A.toString(),a=g.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,a)||this.matchFile(_,{base:A,basename:a})}),Promise.all(f.map(A=>this.searchInFolder(A,_))).then(A=>{u({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{p(new Error((0,I.toErrorMessage)(A)))})})}async searchInFolder(d,f){const u=new L.CancellationTokenSource,p=this.getSearchOptionsForFolder(d),_=this.initDirectoryTree(),A=new y.QueryGlobTester(this.config,d),E=!A.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(u),a=D.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,u.token),v=a.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(r=>{const o=g.posix.relative(d.folder.path,r.path);if(E){const i=g.basename(r.path);this.matchFile(f,{base:d.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(_,d.folder,o,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,A,f),{providerTime:v,postProcessTime:t.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(d){const f=(0,y.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),u=(0,y.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:u,includes:f,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},f,u,p){if(u===this.filePattern){const A=g.basename(this.filePattern);this.matchFile(p,{base:f,relativePath:this.filePattern,basename:A})}function _(A){const E=g.basename(A),a=g.dirname(A);let l=d[a];l||(l=d[a]=[],_(a)),l.push({base:f,relativePath:A,basename:E})}_(u)}matchDirectoryTree({rootEntries:d,pathToEntries:f},u,p){const _=this,A=this.filePattern;function E(a){const l=C.hasSiblingFn(()=>a.map(v=>v.basename));for(let v=0,t=a.length;v<t;v++){const r=a[v],{relativePath:o,basename:i}=r;if(!u.includedInQuerySync(o,i,A!==i?l:void 0))continue;const c=f[o];if(c)E(c);else{if(o===A)continue;_.matchFile(p,r)}if(_.isLimitHit)break}}E(d)}matchFile(d,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(f))}}class n{constructor(){this.sessions=new Map}fileSearch(d,f,u,p){const _=this.getSessionTokenSource(d.cacheKey),A=new P(d,f,_&&_.token);let E=0;const a=l=>{E+=l.length,u(l.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(A,n.BATCH_SIZE,a,p).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:l.stats}}))}clearCache(d){const f=this.getSessionTokenSource(d);f&&f.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new L.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:T.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,f,u,p){p.onCancellationRequested(()=>{d.cancel()});const _=E=>{E&&(A.push(E),f>0&&A.length>=f&&(u(A),A=[]))};let A=[];return d.search(_).then(E=>(A.length&&u(A),E),E=>(A.length&&u(A),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[134],ge([0,1,20,21,60,30,10,8,25,13,2,31]),function(Y,e,g,L,I,C,T,D,y,P,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(a,l,v,t){this.query=a,this.provider=l,this.fileUtils=v,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,l){const v=this.query.folderQueries||[],t=new L.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((r,o)=>{this.collector=new u(a);let i=!1;const c=(h,m)=>{if(!i&&!this.isLimitHit){const w=this.resultSize(h);_(h)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const S=this.resultSize(h);this.resultCount+=S,(S>0||!_(h))&&this.collector.add(h,m)}};Promise.all(v.map((h,m)=>this.searchInFolder(h,w=>c(w,m),t.token))).then(h=>{t.dispose(),this.collector.flush();const m=h.some(w=>!!w&&!!w.limitHit);r({limitHit:this.isLimitHit||m,messages:(0,g.flatten)(h.map(w=>w?.message?(0,P.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},h=>{t.dispose();const m=(0,I.toErrorMessage)(h);o(new Error(m))})})}resultSize(a){return _(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,l){const v=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:v.slice(0,l),preview:{matches:t.slice(0,l),text:a.preview.text},uri:a.uri}}async searchInFolder(a,l,v){const t=new k.QueryGlobTester(this.query,a),r=[],o={report:h=>{if(!this.validateProviderResult(h))return;const m=a.folder.scheme===T.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(h.uri))):void 0,w=y.relativePath(a.folder,h.uri);if(w){const S=t.includedInQuery(w,D.basename(w),m);(0,P.isPromise)(S)?r.push(S.then(s=>{s&&l(h)})):S&&l(h)}}},i=this.getSearchOptionsForFolder(a),c=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,o,v);return r.length&&await Promise.all(r),c}validateProviderResult(a){if(_(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const l=(0,k.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),v=(0,k.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:n.URI.from(a.folder),excludes:v,includes:l,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class u{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new A(512,l=>this.sendItems(l))}add(a,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!y.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(p(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=u;function p(E){return _(E)?{preview:{matches:(0,g.mapArrayOrNot)(E.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:E.preview.text},ranges:(0,g.mapArrayOrNot)(E.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function _(E){return!!E.preview}e.extensionResultIsMatch=_;class A{constructor(a,l){this.maxBatchSize=a,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,l){!a||this.addItemToBatch(a,l)}addItems(a,l){!a||this.addItemsToBatch(a,l)}addItemToBatch(a,l){this.batch.push(a),this.batchSize+=l,this.onUpdate()}addItemsToBatch(a,l){this.batch=this.batch.concat(a),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<A.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},A.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=A,A.TIMEOUT=4e3,A.START_BATCH_AFTER_COUNT=50}),define(me[73],ge([0,1,6,5,4,273,14,64,12,2,134]),function(Y,e,g,L,I,C,T,D,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let k=class{constructor(p,_,A){this.extHostRpc=p,this._uriTransformer=_,this._logService=A,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,_){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const A=this._handlePool++;return this._textSearchProvider.set(A,_),this._proxy.$registerTextSearchProvider(A,this._transformScheme(p)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(p,_){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const A=this._handlePool++;return this._fileSearchProvider.set(A,_),this._proxy.$registerFileSearchProvider(A,this._transformScheme(p)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(p,_,A,E){const a=d(A),l=this._fileSearchProvider.get(p);if(l)return this._fileSearchManager.fileSearch(a,l,v=>{this._proxy.$handleFileMatch(p,_,v.map(t=>t.resource))},E);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,_,A,E){const a=this._textSearchProvider.get(p);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const l=d(A);return this.createTextSearchManager(l,a).search(t=>this._proxy.$handleTextMatch(p,_,t),E)}$enableExtensionHostSearch(){}createTextSearchManager(p,_){return new n.TextSearchManager(p,_,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};k=je([Ue(0,T.IExtHostRpcService),Ue(1,D.IURITransformerService),Ue(2,y.ILogService)],k),e.ExtHostSearch=k;function d(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(f),extraFileResources:u.extraFileResources&&u.extraFileResources.map(p=>P.URI.revive(p))}}e.reviveQuery=d;function f(u){return{...u,folder:P.URI.revive(u.folder)}}}),define(me[274],ge([0,1,21,16,3,48,2,118,109,147,81,42,5,232,231,44,233,37,234,235,236,217,237,45,40,238,218,241,242,243,67,220,248,249,250,93,33,252,221,15,7,255,69,133,36,35,55,206,240,86,132,71,53,73,12,64,14,27,244,203,52,66,229,253,202,68,92,258,256,257,230,63,251,254,91,51,123,246,70,247,10,191,245,200,239]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a,l,v,t,r,o,i,c,h,m,w,S,s,b,R,O,$,G,Z,U,x,M,H,F,N,j,W,Q,J,fe,_e,ye,Le,Be,xe,Ke,z,ee,re,le,X,oe,ve,Me,ze,Qe,et,ke,ct,K,te,pe,Ve,tt,st,lt,vt,Dt,ue,Ie,Ne,Ge,We,ot,Re,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(Ve.IExtHostFileSystemInfo),we=ne.get(ke.IExtHostConsumerFileSystem),Fe=ne.get(o.IExtHostExtensionService),qe=ne.get(j.IExtHostWorkspace),He=ne.get(Dt.IExtHostTelemetry),Je=ne.get(A.IExtHostConfiguration),nt=ne.get(z.IURITransformerService),ae=ne.get(ee.IExtHostRpcService),Ee=ne.get($.IExtHostStorage),ce=ne.get(et.IExtensionStoragePaths),q=ne.get(Ke.ILogService),Te=ne.get(oe.IExtHostTunnelService),Pe=ne.get(ve.IExtHostApiDeprecationService),Ye=ne.get(N.IExtHostWindow),Xe=ne.get(lt.IExtHostSecretState),at=ne.get(vt.IExtHostEditorTabs);ae.set(d.ExtHostContext.ExtHostFileSystemInfo,be),ae.set(d.ExtHostContext.ExtHostLogService,q),ae.set(d.ExtHostContext.ExtHostWorkspace,qe),ae.set(d.ExtHostContext.ExtHostConfiguration,Je),ae.set(d.ExtHostContext.ExtHostExtensionService,Fe),ae.set(d.ExtHostContext.ExtHostStorage,Ee),ae.set(d.ExtHostContext.ExtHostTunnelService,Te),ae.set(d.ExtHostContext.ExtHostWindow,Ye),ae.set(d.ExtHostContext.ExtHostSecretState,Xe),ae.set(d.ExtHostContext.ExtHostTelemetry,He),ae.set(d.ExtHostContext.ExtHostEditorTabs,at);const wt=ae.set(d.ExtHostContext.ExtHostDecorations,ne.get(ye.IExtHostDecorations)),_t=ae.set(d.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(r.IExtHostDocumentsAndEditors)),ht=ae.set(d.ExtHostContext.ExtHostCommands,ne.get(p.IExtHostCommands)),gt=ae.set(d.ExtHostContext.ExtHostTerminalService,ne.get(G.IExtHostTerminalService)),ft=ae.set(d.ExtHostContext.ExtHostDebugService,ne.get(Be.IExtHostDebugService)),Tt=ae.set(d.ExtHostContext.ExtHostSearch,ne.get(xe.IExtHostSearch)),yt=ae.set(d.ExtHostContext.ExtHostTask,ne.get(Le.IExtHostTask)),xt=ae.set(d.ExtHostContext.ExtHostOutputService,ne.get(S.IExtHostOutputService)),Bt=ae.set(d.ExtHostContext.ExtHostUrls,new H.ExtHostUrls(ae)),It=ae.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ae,_t)),$t=ae.set(d.ExtHostContext.ExtHostDocumentContentProviders,new l.ExtHostDocumentContentProvider(ae,_t,q)),tn=ae.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(q,It,ae.getProxy(d.MainContext.MainThreadBulkEdits))),bt=ae.set(d.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(ae,ht,_t,It,ce)),Xt=ae.set(d.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(q,bt)),zt=ae.set(d.ExtHostContext.ExtHostNotebookEditors,new ot.ExtHostNotebookEditors(q,ae,bt)),nn=ae.set(d.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(ae,de,bt,q)),rn=ae.set(d.ExtHostContext.ExtHostNotebookRenderers,new Ne.ExtHostNotebookRenderers(ae,bt)),Pt=ae.set(d.ExtHostContext.ExtHostEditors,new Z.ExtHostEditors(ae,_t)),Jt=ae.set(d.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(ae.getProxy(d.MainContext.MainThreadTreeViews),ht,q)),wn=ae.set(d.ExtHostContext.ExtHostEditorInsets,new J.ExtHostEditorInsets(ae.getProxy(d.MainContext.MainThreadEditorInsets),Pt,de)),Wt=ae.set(d.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(ae,q)),pt=ae.set(d.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(ae,nt,It,ht,Wt,q,Pe)),sn=ae.set(d.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ae,pt)),Ft=ae.set(d.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(ae,q,_t)),Vt=ae.set(d.ExtHostContext.ExtHostQuickOpen,(0,b.createExtHostQuickOpen)(ae,qe,ht)),Yt=ae.set(d.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(ae,ht,q)),on=ae.set(d.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(ae,ht,It)),dn=ae.set(d.ExtHostContext.ExtHostProgress,new s.ExtHostProgress(ae.getProxy(d.MainContext.MainThreadProgress))),bn=ae.set(d.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(ae)),hn=ae.set(d.ExtHostContext.ExtHostTheming,new X.ExtHostTheming(ae)),an=ae.set(d.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(ae)),En=ae.set(d.ExtHostContext.ExtHostTimeline,new ze.ExtHostTimeline(ae,ht)),jt=ae.set(d.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(ae,{remote:de.remote},qe,q,Pe)),qt=ae.set(d.ExtHostContext.ExtHostWebviewPanels,new te.ExtHostWebviewPanels(ae,jt,qe)),_n=ae.set(d.ExtHostContext.ExtHostCustomEditors,new K.ExtHostCustomEditors(ae,It,ce,jt,qt)),Sn=ae.set(d.ExtHostContext.ExtHostWebviewViews,new ct.ExtHostWebviewViews(ae,jt)),Gt=ae.set(d.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ae,ht)),yn=ae.set(d.ExtHostContext.ExtHostUriOpeners,new st.ExtHostUriOpeners(ae));ae.set(d.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(ae,bt,_t,ht));const Zt=(0,Q.values)(d.ExtHostContext);ae.assertRegistered(Zt);const Dn=new pe.ExtHostBulkEdits(ae,_t),Cn=new u.ExtHostClipboard(ae),Kt=new w.ExtHostMessageService(ae,q),fn=new a.ExtHostDialogs(ae),Ht=new O.ExtHostStatusBar(ae,ht.converter),Lt=new m.ExtHostLanguages(ae,It);return f.ExtHostApiCommands.register(ht),function(Oe,Rt,Qt){const Et=function(){let ie=!Oe.isUnderDevelopment;function he(Ae){ie||(q.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Ae(ut){if(Array.isArray(ut))ut.forEach(Ae);else if(typeof ut=="string")he(ut);else{const St=ut;typeof St.scheme=="undefined"&&he(ut),!Oe.enableProposedApi&&typeof St.exclusive=="boolean"&&(0,W.throwProposedApiError)(Oe)}return ut}}(),kn={getSession(ie,he,Ae){return Ae?.forceNewSession&&(0,W.checkProposedApiEnabled)(Oe),an.getSession(Oe,ie,he,Ae)},get onDidChangeSessions(){return an.onDidChangeSessions},registerAuthenticationProvider(ie,he,Ae,ut){return an.registerAuthenticationProvider(ie,he,Ae,ut)}},In={registerCommand(ie,he,Ae){return ht.registerCommand(!0,ie,he,Ae)},registerTextEditorCommand(ie,he,Ae){return ht.registerCommand(!0,ie,(...ut)=>{const St=Pt.getActiveTextEditor();if(!St){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}return St.edit(kt=>{he.apply(Ae,[St,kt,...ut])}).then(kt=>{kt||q.warn("Edits from command "+ie+" were not applied.")},kt=>{q.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,he,Ae)=>((0,W.checkProposedApiEnabled)(Oe),ht.registerCommand(!0,ie,async(...ut)=>{const St=_t.activeEditor(!0);if(!St){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(St.id);he.apply(Ae,[kt,...ut])})),executeCommand(ie,...he){return ht.executeCommand(ie,...he)},getCommands(ie=!1){return ht.getCommands(ie)}},mn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get embedderIdentifier(){return de.environment.embedderIdentifier},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return Cn.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return He.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return He.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return Ye.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return Bt.createAppUri(ie);try{return await Ye.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(he){if((0,We.matchesScheme)(ie,Ge.Schemas.http)||(0,We.matchesScheme)(ie,Ge.Schemas.https))return ie;throw he}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=de.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pn={createTestController(ie,he){return Gt.createTestController(ie,he)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Oe),Gt.createTestObserver()},runTests(ie){return(0,W.checkProposedApiEnabled)(Oe),Gt.runTests(ie)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Oe),Gt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Oe),Gt.results}},Tn={getExtension(ie){const he=Rt.getExtensionDescription(ie);if(he)return new o.Extension(Fe,Oe.identifier,he,gn)},get all(){return Rt.getAllExtensionDescriptions().map(ie=>new o.Extension(Fe,Oe.identifier,ie,gn))},get onDidChange(){return Rt.onDidChange}},ln={createDiagnosticCollection(ie){return Wt.createDiagnosticCollection(Oe.identifier,ie)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:ie=>Wt.getDiagnostics(ie),getLanguages(){return Lt.getLanguages()},setTextDocumentLanguage(ie,he){return Lt.changeLanguage(ie.uri,he)},match(ie,he){return(0,n.score)(x.LanguageSelector.from(ie),he.uri,he.languageId,!0)},registerCodeActionsProvider(ie,he,Ae){return pt.registerCodeActionProvider(Oe,Et(ie),he,Ae)},registerCodeLensProvider(ie,he){return pt.registerCodeLensProvider(Oe,Et(ie),he)},registerDefinitionProvider(ie,he){return pt.registerDefinitionProvider(Oe,Et(ie),he)},registerDeclarationProvider(ie,he){return pt.registerDeclarationProvider(Oe,Et(ie),he)},registerImplementationProvider(ie,he){return pt.registerImplementationProvider(Oe,Et(ie),he)},registerTypeDefinitionProvider(ie,he){return pt.registerTypeDefinitionProvider(Oe,Et(ie),he)},registerHoverProvider(ie,he){return pt.registerHoverProvider(Oe,Et(ie),he,Oe.identifier)},registerEvaluatableExpressionProvider(ie,he){return pt.registerEvaluatableExpressionProvider(Oe,Et(ie),he,Oe.identifier)},registerInlineValuesProvider(ie,he){return pt.registerInlineValuesProvider(Oe,Et(ie),he,Oe.identifier)},registerDocumentHighlightProvider(ie,he){return pt.registerDocumentHighlightProvider(Oe,Et(ie),he)},registerLinkedEditingRangeProvider(ie,he){return pt.registerLinkedEditingRangeProvider(Oe,Et(ie),he)},registerReferenceProvider(ie,he){return pt.registerReferenceProvider(Oe,Et(ie),he)},registerRenameProvider(ie,he){return pt.registerRenameProvider(Oe,Et(ie),he)},registerDocumentSymbolProvider(ie,he,Ae){return pt.registerDocumentSymbolProvider(Oe,Et(ie),he,Ae)},registerWorkspaceSymbolProvider(ie){return pt.registerWorkspaceSymbolProvider(Oe,ie)},registerDocumentFormattingEditProvider(ie,he){return pt.registerDocumentFormattingEditProvider(Oe,Et(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return pt.registerDocumentRangeFormattingEditProvider(Oe,Et(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Ae,...ut){return pt.registerOnTypeFormattingEditProvider(Oe,Et(ie),he,[Ae].concat(ut))},registerDocumentSemanticTokensProvider(ie,he,Ae){return pt.registerDocumentSemanticTokensProvider(Oe,Et(ie),he,Ae)},registerDocumentRangeSemanticTokensProvider(ie,he,Ae){return pt.registerDocumentRangeSemanticTokensProvider(Oe,Et(ie),he,Ae)},registerSignatureHelpProvider(ie,he,Ae,...ut){return typeof Ae=="object"?pt.registerSignatureHelpProvider(Oe,Et(ie),he,Ae):pt.registerSignatureHelpProvider(Oe,Et(ie),he,typeof Ae=="undefined"?[]:[Ae,...ut])},registerCompletionItemProvider(ie,he,...Ae){return pt.registerCompletionItemProvider(Oe,Et(ie),he,Ae)},registerInlineCompletionItemProvider(ie,he){return(0,W.checkProposedApiEnabled)(Oe),pt.registerInlineCompletionsProvider(Oe,Et(ie),he)},registerDocumentLinkProvider(ie,he){return pt.registerDocumentLinkProvider(Oe,Et(ie),he)},registerColorProvider(ie,he){return pt.registerColorProvider(Oe,Et(ie),he)},registerFoldingRangeProvider(ie,he){return pt.registerFoldingRangeProvider(Oe,Et(ie),he)},registerSelectionRangeProvider(ie,he){return pt.registerSelectionRangeProvider(Oe,ie,he)},registerCallHierarchyProvider(ie,he){return pt.registerCallHierarchyProvider(Oe,ie,he)},setLanguageConfiguration:(ie,he)=>pt.setLanguageConfiguration(Oe,ie,he),getTokenInformationAtPosition(ie,he){return(0,W.checkProposedApiEnabled)(Oe),Lt.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return(0,W.checkProposedApiEnabled)(Oe),pt.registerInlayHintsProvider(Oe,ie,he)},registerTypeHierarchyProvider(ie,he){return(0,W.checkProposedApiEnabled)(Oe),pt.registerTypeHierarchyProvider(Oe,ie,he)},createLanguageStatusItem(ie){return(0,W.checkProposedApiEnabled)(Oe),Lt.createLanguageStatusItem(ie)}},An={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ie,he,Ae){const ut=await(T.URI.isUri(ie)?Promise.resolve(pn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(ut,he,Ae)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Oe,ie)},onDidChangeActiveTextEditor(ie,he,Ae){return Pt.onDidChangeActiveTextEditor(ie,he,Ae)},onDidChangeVisibleTextEditors(ie,he,Ae){return Pt.onDidChangeVisibleTextEditors(ie,he,Ae)},onDidChangeTextEditorSelection(ie,he,Ae){return Pt.onDidChangeTextEditorSelection(ie,he,Ae)},onDidChangeTextEditorOptions(ie,he,Ae){return Pt.onDidChangeTextEditorOptions(ie,he,Ae)},onDidChangeTextEditorVisibleRanges(ie,he,Ae){return Pt.onDidChangeTextEditorVisibleRanges(ie,he,Ae)},onDidChangeTextEditorViewColumn(ie,he,Ae){return Pt.onDidChangeTextEditorViewColumn(ie,he,Ae)},onDidCloseTerminal(ie,he,Ae){return gt.onDidCloseTerminal(ie,he,Ae)},onDidOpenTerminal(ie,he,Ae){return gt.onDidOpenTerminal(ie,he,Ae)},onDidChangeActiveTerminal(ie,he,Ae){return gt.onDidChangeActiveTerminal(ie,he,Ae)},onDidChangeTerminalDimensions(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),gt.onDidChangeTerminalDimensions(ie,he,Ae)},onDidChangeTerminalState(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),gt.onDidChangeTerminalState(ie,he,Ae)},onDidWriteTerminalData(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),gt.onDidWriteTerminalData(ie,he,Ae)},get state(){return Ye.state},onDidChangeWindowState(ie,he,Ae){return Ye.onDidChangeWindowState(ie,he,Ae)},showInformationMessage(ie,...he){return Kt.showMessage(Oe,C.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return Kt.showMessage(Oe,C.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return Kt.showMessage(Oe,C.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Ae){return Vt.showQuickPick(ie,!!Oe.enableProposedApi,he,Ae)},showWorkspaceFolderPick(ie){return Vt.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Vt.showInput(ie,he)},showOpenDialog(ie){return fn.showOpenDialog(ie)},showSaveDialog(ie){return fn.showSaveDialog(ie)},createStatusBarItem(ie,he,Ae){let ut,St,kt;return typeof ie=="string"?(ut=ie,St=he,kt=Ae):(St=ie,kt=he),Ht.createStatusBarEntry(Oe,ut,St,kt)},setStatusBarMessage(ie,he){return Ht.setStatusBarMessage(ie,he)},withScmProgress(ie){return Pe.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),dn.withProgress(Oe,{location:M.ProgressLocation.SourceControl},(he,Ae)=>ie({report(ut){}}))},withProgress(ie,he){return dn.withProgress(Oe,ie,he)},createOutputChannel(ie){return xt.createOutputChannel(ie,Oe)},createWebviewPanel(ie,he,Ae,ut){return qt.createWebviewPanel(Oe,ie,he,Ae,ut)},createWebviewTextEditorInset(ie,he,Ae,ut){return(0,W.checkProposedApiEnabled)(Oe),wn.createWebviewEditorInset(ie,he,Ae,ut,Oe)},createTerminal(ie,he,Ae){return typeof ie=="object"?("location"in ie&&(0,W.checkProposedApiEnabled)(Oe),"pty"in ie?gt.createExtensionTerminal(ie):gt.createTerminalFromOptions(ie)):gt.createTerminal(ie,he,Ae)},registerTerminalLinkProvider(ie){return gt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return gt.registerProfileProvider(Oe,ie,he)},registerTreeDataProvider(ie,he){return Jt.registerTreeDataProvider(ie,he,Oe)},createTreeView(ie,he){return Jt.createTreeView(ie,he,Oe)},registerWebviewPanelSerializer:(ie,he)=>qt.registerWebviewPanelSerializer(Oe,ie,he),registerCustomEditorProvider:(ie,he,Ae={})=>_n.registerCustomEditorProvider(Oe,ie,he,Ae),registerFileDecorationProvider(ie){return wt.registerFileDecorationProvider(ie,Oe.identifier)},registerUriHandler(ie){return Bt.registerUriHandler(Oe.identifier,ie)},createQuickPick(){return Vt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Oe.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Ae){return hn.onDidChangeActiveColorTheme(ie,he,Ae)},registerWebviewViewProvider(ie,he,Ae){return Sn.registerWebviewViewProvider(Oe,ie,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Oe),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeActiveNotebookEditor(ie,he,Ae)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Oe),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorSelection(ie,he,Ae)},onDidChangeNotebookEditorVisibleRanges(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorVisibleRanges(ie,he,Ae)},showNotebookDocument(ie,he){return(0,W.checkProposedApiEnabled)(Oe),bt.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),yn.registerExternalUriOpener(Oe.identifier,ie,he,Ae)},get openEditors(){return(0,W.checkProposedApiEnabled)(Oe),at.tabs},get onDidChangeOpenEditors(){return(0,W.checkProposedApiEnabled)(Oe),at.onDidChangeTabs},getInlineCompletionItemController(ie){return(0,W.checkProposedApiEnabled)(Oe),h.InlineCompletionController.get(ie)}},pn={get rootPath(){return Pe.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return qe.getWorkspaceFolder(ie)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(ie){throw L.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,he,...Ae)=>qe.updateWorkspaceFolders(Oe,ie,he||0,...Ae),onDidChangeWorkspaceFolders:function(ie,he,Ae){return qe.onDidChangeWorkspace(ie,he,Ae)},asRelativePath:(ie,he)=>qe.getRelativePath(ie,he),findFiles:(ie,he,Ae,ut)=>qe.findFiles(x.GlobPattern.from(ie),x.GlobPattern.from(he),Ae,Oe.identifier,ut),findTextInFiles:(ie,he,Ae,ut)=>{let St,kt;return typeof he=="object"?(St=he,kt=Ae):(St={},kt=he,ut=Ae),qe.findTextInFiles(ie,St||{},kt,Oe.identifier,ut)},saveAll:ie=>qe.saveAll(ie),applyEdit(ie){return Dn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Ae,ut)=>Ft.createFileSystemWatcher(x.GlobPattern.from(ie),he,Ae,ut),get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let he;const Ae=ie;if(typeof ie=="string")he=Promise.resolve(T.URI.file(ie));else if(T.URI.isUri(ie))he=Promise.resolve(ie);else if(!Ae||typeof Ae=="object")he=It.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ut=>It.ensureDocumentData(ut).then(St=>St.document))},onDidOpenTextDocument:(ie,he,Ae)=>It.onDidAddDocument(ie,he,Ae),onDidCloseTextDocument:(ie,he,Ae)=>It.onDidRemoveDocument(ie,he,Ae),onDidChangeTextDocument:(ie,he,Ae)=>It.onDidChangeDocument(ie,he,Ae),onDidSaveTextDocument:(ie,he,Ae)=>It.onDidSaveDocument(ie,he,Ae),onWillSaveTextDocument:(ie,he,Ae)=>tn.getOnWillSaveTextDocumentEvent(Oe)(ie,he,Ae),get notebookDocuments(){return bt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Ae;if(T.URI.isUri(ie))Ae=ie,await bt.openNotebookDocument(ie);else if(typeof ie=="string")Ae=T.URI.revive(await bt.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Ae,ut){return bt.registerNotebookSerializer(Oe,ie,he,Ae,Oe.enableProposedApi?ut:void 0)},registerNotebookContentProvider:(ie,he,Ae,ut)=>((0,W.checkProposedApiEnabled)(Oe),bt.registerNotebookContentProvider(Oe,ie,he,Ae,Oe.enableProposedApi?ut:void 0)),onDidChangeConfiguration:(ie,he,Ae)=>Qt.onDidChangeConfiguration(ie,he,Ae),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,Qt.getConfiguration(ie,he,Oe)},registerTextDocumentContentProvider(ie,he){return $t.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Pe.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Oe,ie,he)),registerFileSystemProvider(ie,he,Ae){return sn.registerFileSystemProvider(Oe.identifier,ie,he,Ae,Oe.enableProposedApi)},get fs(){return we.value},registerFileSearchProvider:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),Tt.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),Tt.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),Fe.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,W.checkProposedApiEnabled)(Oe),bn.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Ae)=>Ft.onDidCreateFile(ie,he,Ae),onDidDeleteFiles:(ie,he,Ae)=>Ft.onDidDeleteFile(ie,he,Ae),onDidRenameFiles:(ie,he,Ae)=>Ft.onDidRenameFile(ie,he,Ae),onWillCreateFiles:(ie,he,Ae)=>Ft.getOnWillCreateFileEvent(Oe)(ie,he,Ae),onWillDeleteFiles:(ie,he,Ae)=>Ft.getOnWillDeleteFileEvent(Oe)(ie,he,Ae),onWillRenameFiles:(ie,he,Ae)=>Ft.getOnWillRenameFileEvent(Oe)(ie,he,Ae),openTunnel:ie=>((0,W.checkProposedApiEnabled)(Oe),Te.openTunnel(Oe,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,W.checkProposedApiEnabled)(Oe),Te.getTunnels()},onDidChangeTunnels:(ie,he,Ae)=>((0,W.checkProposedApiEnabled)(Oe),Te.onDidChangeTunnels(ie,he,Ae)),registerPortAttributesProvider:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),Te.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,W.checkProposedApiEnabled)(Oe),En.registerTimelineProvider(ie,he,Oe.identifier,ht.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:ie=>((0,W.checkProposedApiEnabled)(Oe),qe.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Ae)=>qe.onDidGrantWorkspaceTrust(ie,he,Ae)},Rn={get inputBox(){return Pe.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Oe)},createSourceControl(ie,he,Ae){return Yt.createSourceControl(Oe,ie,he,Ae)}},Ln={createCommentController(ie,he){return on.createCommentController(Oe,ie,he)}},Fn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(ie,he,Ae){return ft.onDidStartDebugSession(ie,he,Ae)},onDidTerminateDebugSession(ie,he,Ae){return ft.onDidTerminateDebugSession(ie,he,Ae)},onDidChangeActiveDebugSession(ie,he,Ae){return ft.onDidChangeActiveDebugSession(ie,he,Ae)},onDidReceiveDebugSessionCustomEvent(ie,he,Ae){return ft.onDidReceiveDebugSessionCustomEvent(ie,he,Ae)},onDidChangeBreakpoints(ie,he,Ae){return ft.onDidChangeBreakpoints(ie,he,Ae)},registerDebugConfigurationProvider(ie,he,Ae){return ft.registerDebugConfigurationProvider(ie,he,Ae||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return ft.registerDebugAdapterDescriptorFactory(Oe,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return ft.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ft.startDebugging(ie,he,{parentSession:Ae}):ft.startDebugging(ie,he,Ae||{})},stopDebugging(ie){return ft.stopDebugging(ie)},addBreakpoints(ie){return ft.addBreakpoints(ie)},removeBreakpoints(ie){return ft.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return ft.asDebugSourceUri(ie,he)}},Mn={registerTaskProvider:(ie,he)=>yt.registerTaskProvider(Oe,ie,he),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Oe,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,he,Ae)=>yt.onDidStartTask(ie,he,Ae),onDidEndTask:(ie,he,Ae)=>yt.onDidEndTask(ie,he,Ae),onDidStartTaskProcess:(ie,he,Ae)=>yt.onDidStartTaskProcess(ie,he,Ae),onDidEndTaskProcess:(ie,he,Ae)=>yt.onDidEndTaskProcess(ie,he,Ae)},On={createNotebookController(ie,he,Ae,ut,St){return nn.createNotebookController(Oe,ie,he,Ae,ut,Oe.enableProposedApi?St:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>bt.registerNotebookCellStatusBarItemProvider(Oe,ie,he),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Oe),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,W.checkProposedApiEnabled)(Oe),zt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return rn.createRendererMessaging(Oe,ie)},onDidChangeNotebookDocumentMetadata(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),Xt.onDidChangeNotebookDocumentMetadata(ie,he,Ae)},onDidChangeNotebookCells(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeNotebookCells(ie,he,Ae)},onDidChangeNotebookCellExecutionState(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeNotebookCellExecutionState(ie,he,Ae)},onDidChangeCellOutputs(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeCellOutputs(ie,he,Ae)},onDidChangeCellMetadata(ie,he,Ae){return(0,W.checkProposedApiEnabled)(Oe),bt.onDidChangeCellMetadata(ie,he,Ae)},createConcatTextDocument(ie,he){return(0,W.checkProposedApiEnabled)(Oe),new Qe.ExtHostNotebookConcatDocument(bt,It,ie,he)}};return{version:de.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:mn,extensions:Tn,languages:ln,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:An,workspace:pn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:P.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:d.UIKind,Uri:T.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(me[275],ge([0,1,82,67,36,132,37,44,45,33,71,53,73,93,52,66,133,92,63,91,123,51]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,g.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,g.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,g.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,g.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,g.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,g.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,g.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,g.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,g.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,g.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,g.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,g.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,g.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,g.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(me[94],ge([0,1,20,12,31,70]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=T;function D(k,d,f,u){const p=(0,g.mapArrayOrNot)(f,y),_=new I.TextSearchMatch(d,p,u),A=_.preview.matches;return{ranges:(0,g.mapArrayOrNot)(p,P),uri:k,preview:{text:_.preview.text,matches:(0,g.mapArrayOrNot)(A,P)}}}e.createTextSearchResult=D;function y(k){return new I.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function P(k){return new C.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let n=class{constructor(d,f){this.prefix=d,this.logService=f}appendLine(d){this.logService.debug(`${this.prefix}#search`,d)}};n=je([Ue(1,L.ILogService)],n),e.OutputChannel=n}),define(me[276],ge([0,1,96,22]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,T=512,D=512*8,y=512*128;class P{constructor(r){this.iconvLiteDecoder=r}static async create(r){let o;if(r!==e.UTF8)o=(await new Promise((c,h)=>{Y(["iconv-lite-umd"],c,h)})).getDecoder(f(r));else{const i=new TextDecoder;o={write(c){return i.decode(c,{stream:!0})},end(){return i.decode()}}}return new P(o)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function n(t,r){const o=r.minBytesRequiredForDetection??r.guessEncoding?D:T;return new Promise((i,c)=>{const h=(0,g.newWriteableStream)(b=>b.join("")),m=[];let w=0,S;const s=async()=>{try{const b=await v({buffer:L.VSBuffer.concat(m),bytesRead:w},r.guessEncoding);b.encoding=await r.overwriteEncoding(b.encoding),S=await P.create(b.encoding);const R=S.write(L.VSBuffer.concat(m).buffer);h.write(R),m.length=0,w=0,i({stream:h,detected:b})}catch(b){c(b)}};(0,g.listenStream)(t,{onData:async b=>{S?h.write(S.write(b.buffer)):(m.push(b),w+=b.byteLength,w>=o&&(t.pause(),await s(),setTimeout(()=>t.resume())))},onError:b=>h.error(b),onEnd:async()=>{S||await s(),h.end(S?.end())}})})}e.toDecodeStream=n;async function k(t,r,o){const c=(await new Promise((w,S)=>{Y(["iconv-lite-umd"],w,S)})).getEncoder(f(r),o);let h=!1,m=!1;return{read(){if(m)return null;const w=t.read();if(typeof w!="string"){if(m=!0,!h&&o?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const S=c.end();return S&&S.length>0?(h=!0,L.VSBuffer.wrap(S)):null}return h=!0,L.VSBuffer.wrap(c.write(w))}}}e.toEncodeReadable=k;async function d(t){return(await new Promise((o,i)=>{Y(["iconv-lite-umd"],o,i)})).encodingExists(f(t))}e.encodingExists=d;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function u(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),i=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const c=t.readUInt8(2);return o===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=u;const p=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((m,w)=>{Y(["jschardet"],m,w)}),o=t.slice(0,y),i=a(o.buffer),c=r.detect(i);if(!c||!c.encoding)return null;const h=c.encoding.toLowerCase();return 0<=p.indexOf(h)?null:E(c.encoding)}const A={ibm866:"cp866",big5:"cp950"};function E(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return A[r]||r}function a(t){let r="";for(let o=0;o<t.length;o++)r+=String.fromCharCode(t[o]);return r}function l(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=l;function v({buffer:t,bytesRead:r},o){let i=u(t,r),c=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let h=!0,m=!0,w=!1;for(let S=0;S<r&&S<C;S++){const s=S%2==1,b=t.readUInt8(S)===0;if(b&&(w=!0),h&&(s&&!b||!s&&b)&&(h=!1),m&&(s&&b||!s&&!b)&&(m=!1),b&&!h&&!m)break}w&&(h?i=e.UTF16le:m?i=e.UTF16be:c=!0)}return o&&!c&&!i&&t?_(t.slice(0,r)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:c,encoding:i}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[135],ge([0,1,276,28,134]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends I.TextSearchManager{constructor(D,y,P=L,n="searchProcess"){super(D,y,{readdir:k=>P.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,g.toCanonicalName)(k)},n)}}e.NativeTextSearchManager=C}),define(me[277],ge([0,1,278,293,294,2,295]),function(Y,e,g,L,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(k,d,f,u,p,_){const A=_.environment.useHostProxy,E=typeof A=="boolean"?A:!_.remote.isRemote,a=(0,T.createProxyResolver)({resolveProxy:v=>k.resolveProxy(v),getHttpProxySetting:()=>d.getConfiguration("http").get("proxy"),log:(v,t,...r)=>{switch(v){case T.LogLevel.Trace:u.trace(t,...r);break;case T.LogLevel.Debug:u.debug(t,...r);break;case T.LogLevel.Info:u.info(t,...r);break;case T.LogLevel.Warning:u.warn(t,...r);break;case T.LogLevel.Error:u.error(t,...r);break;case T.LogLevel.Critical:u.critical(t,...r);break;case T.LogLevel.Off:break;default:o(v,t,r);break}function o(i,c,...h){u.error("Unknown log level",i),u.error(c,...h)}},getLogLevel:()=>u.getLevel(),proxyResolveTelemetry:v=>{p.$publicLog2("resolveProxy",v)},useHostProxy:E,env:process.env}),l=y(d,a);return n(f,l)}e.connectProxyResolver=D;function y(k,d){const f={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(p=>{f.config=k.getConfiguration("http").get("proxySupport")||"off"});const u={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(p=>{u.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,T.createHttpPatch)(g,d,{config:"off"},u,!0)),on:Object.assign({},g,(0,T.createHttpPatch)(g,d,{config:"on"},u,!0)),override:Object.assign({},g,(0,T.createHttpPatch)(g,d,{config:"override"},u,!0)),onRequest:Object.assign({},g,(0,T.createHttpPatch)(g,d,f,u,!0)),default:Object.assign(g,(0,T.createHttpPatch)(g,d,f,u,!1))},https:{off:Object.assign({},L,(0,T.createHttpPatch)(L,d,{config:"off"},u,!0)),on:Object.assign({},L,(0,T.createHttpPatch)(L,d,{config:"on"},u,!0)),override:Object.assign({},L,(0,T.createHttpPatch)(L,d,{config:"override"},u,!0)),onRequest:Object.assign({},L,(0,T.createHttpPatch)(L,d,f,u,!0)),default:Object.assign(L,(0,T.createHttpPatch)(L,d,f,u,!1))},tls:Object.assign(I,(0,T.createTlsPatch)(I))}}const P=new Map;function n(k,d){return k.getExtensionPathIndex().then(f=>{const u=Y.__$__nodeRequire("module"),p=u._load;u._load=function(A,E,a){if(A==="tls")return d.tls;if(A!=="http"&&A!=="https")return p.apply(this,arguments);const l=d[A],v=f.findSubstr(C.URI.file(E.filename).fsPath);let t=P.get(v);if(t||P.set(v,t={}),!t[A]){let r=l.default;v&&v.enableProposedApi&&(r=l[v.proxySupport]||l.onRequest),t[A]={...r}}return t[A]}})}}),define(me[279],ge([0,1,39,8,78,29,11,9,94,280]),function(Y,e,g,L,I,C,T,D,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(a,l,v,t){const r=d(a,l,v,t),o=l.folder.fsPath;return{cmd:g.spawn(n,r.args,{cwd:o}),rgDiskPath:n,siblingClauses:r.siblingClauses,rgArgs:r,cwd:o}}e.spawnRipgrepCmd=k;function d(a,l,v,t){const r=["--files","--hidden","--case-sensitive"];u([l],v,!1).forEach(i=>{const c=(0,y.anchorGlob)(i);if(r.push("-g",c),T.isMacintosh){const h=(0,I.normalizeNFD)(c);h!==c&&r.push("-g",h)}});const o=f([l],t,void 0,!1);return o.globArgs.forEach(i=>{const c=`!${(0,y.anchorGlob)(i)}`;if(r.push("-g",c),T.isMacintosh){const h=(0,I.normalizeNFD)(c);h!==c&&r.push("-g",h)}}),l.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),l.ignoreSymlinks||r.push("--follow"),a.exists&&r.push("--quiet"),r.push("--no-config"),l.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:o.siblingClauses}}function f(a,l,v,t=!0){const r=[];let o={};return a.forEach(i=>{const c=Object.assign({},i.excludePattern||{},l||{}),h=p(c,t?i.folder.fsPath:void 0,v);r.push(...h.globArgs),h.siblingClauses&&(o=Object.assign(o,h.siblingClauses))}),{globArgs:r,siblingClauses:o}}e.foldersToRgExcludeGlobs=f;function u(a,l,v=!0){const t=[];return a.forEach(r=>{const o=Object.assign({},l||{},r.includePattern||{}),i=p(o,v?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=u;function p(a,l,v){const t=[],r={};return Object.keys(a).forEach(o=>{if(v&&v.has(o)||!o)return;const i=a[o];o=A(l?_(l,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),t.push(E(o))):i&&i.when&&(r[o]=i)}),{globArgs:t,siblingClauses:r}}function _(a,l){return L.isAbsolute(l)?l:L.join(a,l)}e.getAbsoluteGlob=_;function A(a){return a=D.rtrim(a,"\\"),D.rtrim(a,"/")}function E(a){return C.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=E}),define(me[281],ge([0,1,39,49,8,104,20,60,30,78,29,11,46,9,13,28,31,279,101]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(o=>o())});class l{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),m=c.folder.fsPath;i.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==m).forEach(w=>{(0,n.isEqualOrParent)(w,m)&&(h[I.relative(m,w)]=!0)}),this.folderExcludePatterns.set(m,new t(h,m))})}cancel(){this.isCanceled=!0}walk(i,c,h,m,w){if(this.fileWalkSW=d.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);c.forEach(S=>{const s=I.basename(S.fsPath);this.globalExcludePattern&&this.globalExcludePattern(S.fsPath,s)||this.matchFile(h,{relativePath:S.fsPath,searchPath:void 0})}),this.cmdSW=d.StopWatch.create(!1),this.parallel(i,(S,s)=>{this.call(this.cmdTraversal,this,S,h,m,b=>{if(b){const R=(0,D.toErrorMessage)(b);console.error(R),this.errors.push(R),s(b,void 0)}else s(null,void 0)})},(S,s)=>{this.fileWalkSW.stop();const b=S?T.coalesce(S)[0]:null;w(b,this.isLimitHit)})}parallel(i,c,h){const m=new Array(i.length),w=new Array(i.length);let S=!1,s=0;if(i.length===0)return h(null,[]);i.forEach((b,R)=>{c(b,(O,$)=>{if(O?(S=!0,m[R]=null,w[R]=O):(m[R]=$,w[R]=null),++s===i.length)return h(S?w:null,m)})})}call(i,c,...h){try{i.apply(c,h)}catch(m){h[h.length-1](m)}}cmdTraversal(i,c,h,m){const w=i.folder.fsPath,S=k.isMacintosh;let s;const b=()=>s&&s.kill();a.add(b);let R=M=>{a.delete(b),R=()=>{},m(M)},O="";const $=this.initDirectoryTree();let G;const Z=(0,A.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);s=Z.cmd,G=!Object.keys(Z.siblingClauses).length;const U=Z.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let x=`${Z.rgDiskPath} ${U}
 - cwd: ${Z.cwd}`;Z.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(Z.rgArgs.siblingClauses)}`),h({message:x}),this.cmdResultCount=0,this.collectStdout(s,"utf8",h,(M,H,F)=>{if(M){R(M);return}if(this.isLimitHit){R();return}const j=(O+(S?P.normalizeNFC(H||""):H)).split(`
`);if(F){const W=j.length;j[W-1]=j[W-1].trim(),j[W-1]||j.pop()}else O=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,G){for(const W of j)if(this.matchFile(c,{base:w,relativePath:W,searchPath:this.getSearchPath(i,W)}),this.isLimitHit){b();break}(F||this.isLimitHit)&&R();return}this.addDirectoryEntries(i,$,w,j,c),F&&(this.matchDirectoryTree($,w,c),R())})}spawnFindCmd(i){const c=this.folderExcludePatterns.get(i.folder.fsPath),h=c.getBasenameTerms(),m=c.getPathTerms(),w=["-L","."];if(h.length||m.length){w.push("-not","(","(");for(const S of h)w.push("-name",S),w.push("-o");for(const S of m)w.push("-path",S),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),g.spawn("find",w,{cwd:i.folder.fsPath})}readStdout(i,c,h){let m="";this.collectStdout(i,c,()=>{},(w,S,s)=>{if(w){h(w);return}m+=S,s&&h(null,m)})}collectStdout(i,c,h,m){let w=(b,R,O)=>{(b||O)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),m(b,R,O)},S=!1;i.stdout?(this.forwardData(i.stdout,c,w),i.stdout.once("data",()=>S=!0)):h({message:"stdout is null"});let s;i.stderr?s=this.collectData(i.stderr):h({message:"stderr is null"}),i.on("error",b=>{w(b)}),i.on("close",b=>{let R;!S&&(R=this.decodeData(s,c))&&r(R)?w(new Error(`command failed with error code ${b}: ${this.decodeData(s,c)}`)):(this.exists&&b===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(i,c,h){const m=new C.StringDecoder(c);return i.on("data",w=>{h(null,m.write(w))}),m}collectData(i){const c=[];return i.on("data",h=>{c.push(h)}),c}decodeData(i,c){const h=new C.StringDecoder(c);return i.map(m=>h.write(m)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:c},h,m,w){m.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const S=s=>{const b=I.basename(s),R=I.dirname(s);let O=c[R];O||(O=c[R]=[],S(R)),O.push({base:h,relativePath:s,basename:b,searchPath:this.getSearchPath(i,s)})};m.forEach(S)}matchDirectoryTree({rootEntries:i,pathToEntries:c},h,m){const w=this,S=this.folderExcludePatterns.get(h),s=this.filePattern;function b(R){w.directoriesWalked++;const O=y.hasSiblingFn(()=>R.map($=>$.basename));for(let $=0,G=R.length;$<G;$++){const Z=R[$],{relativePath:U,basename:x}=Z;if(S.test(U,x,s!==x?O:void 0))continue;const M=c[U];if(M)b(M);else{if(w.filesWalked++,U===s)continue;w.matchFile(m,Z)}if(w.isLimitHit)break}}b(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,c,h,m,w){const S=i.folder,s=y.hasSiblingFn(()=>h);this.parallel(h,(b,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const O=c?[c,b].join(I.sep):b;if(this.folderExcludePatterns.get(i.folder.fsPath).test(O,b,this.config.filePattern!==b?s:void 0))return R(null);const $=[S.fsPath,O].join(I.sep);L.lstat($,(G,Z)=>{if(G||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded($,Z,(U,x)=>U||this.isCanceled||this.isLimitHit?R(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded($,Z,(M,H)=>M||this.isCanceled||this.isLimitHit||(H=H||"",this.walkedPaths[H])?R(null):(this.walkedPaths[H]=!0,p.Promises.readdir($).then(F=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(i,O,F,m,N=>R(N||null))},F=>{R(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&u.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(m,{base:S.fsPath,relativePath:O,searchPath:this.getSearchPath(i,O)}),R(null,void 0)))})},b=>{const R=b&&T.coalesce(b);return w(R&&R.length>0?R[0]:void 0)})}matchFile(i,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,I.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(c))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,c,h){return c.isSymbolicLink()?L.stat(i,h):h(null,c)}realPathIfNeeded(i,c,h){return c.isSymbolicLink()?L.realpath(i,(m,w)=>m?h(m):h(null,w)):h(null,i)}getSearchPath(i,c){return i.folderName?I.join(i.folderName,c):c}}e.FileWalker=l;class v{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new l(i)}search(i,c,h){this.walker.walk(this.folderQueries,this.extraFiles,i,c,(m,w)=>{h(m,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(i,c){this.expression=i,this.root=c,this.init(i)}init(i){let c,h;Object.keys(i).filter(m=>i[m]).forEach(m=>{I.isAbsolute(m)?(c=c||y.getEmptyExpression(),c[m]=i[m]):(h=h||y.getEmptyExpression(),h[m]=i[m])}),this.absoluteParsedExpr=c&&y.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=h&&y.parse(h,{trimForExclusions:!0})}test(i,c,h){return this.relativeParsedExpr&&this.relativeParsedExpr(i,c,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),c,h)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function r(o){const i=o.trim().split(`
`),c=i[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return f.uppercaseFirstLetter(i[i.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}e.rgErrorMsgForDisplay=r}),define(me[136],ge([0,1,39,296,104,20,55,30,8,9,2,31,70,297,280,94]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=u.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(S){this.outputChannel=S}provideTextSearchResults(S,s,b,R){return this.outputChannel.appendLine(`provideTextSearchResults ${S.pattern}, ${JSON.stringify({...s,folder:s.folder.toString()})}`),new Promise((O,$)=>{R.onCancellationRequested(()=>N());const G=r(S,s),Z=s.folder.fsPath,U=G.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${_} ${U}
 - cwd: ${Z}`);let x=g.spawn(_,G,{cwd:Z});x.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),$((0,k.serializeSearchError)(new k.SearchError(fe&&fe.message,k.SearchErrorCode.rgProcessError)))});let M=!1;const H=new l(s.maxResults,Z,s.previewOptions);H.on("result",fe=>{M=!0,W="",b.report(fe)});let F=!1;const N=()=>{F=!0,x&&x.kill(),H&&H.cancel()};let j=!1;H.on("hitLimit",()=>{j=!0,N()});let W="";x.stdout.on("data",fe=>{H.handleData(fe),M||(W+=fe)});let Q=!1;x.stdout.once("data",()=>Q=!0);let J="";x.stderr.on("data",fe=>{const _e=fe.toString();this.outputChannel.appendLine(_e),J+=_e}),x.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),W&&this.outputChannel.appendLine(`Got data without result: ${W}`),this.outputChannel.appendLine(""),F)O({limitHit:j});else{H.flush(),x=null;let fe;J&&!Q&&(fe=E(J))?$((0,k.serializeSearchError)(new k.SearchError(fe.message,fe.code))):O({limitHit:j})}})})}}e.RipgrepTextSearchEngine=A;function E(w){const S=w.split(`
`),s=S[0].trim();if(S.some(R=>R.startsWith("regex parse error")))return new k.SearchError(a(S),k.SearchErrorCode.regexParseError);const b=s.match(/grep config error: unknown encoding: (.*)/);if(b)return new k.SearchError(`Unknown encoding: ${b[1]}`,k.SearchErrorCode.unknownEncoding);if(s.startsWith("error parsing glob"))return new k.SearchError(s.charAt(0).toUpperCase()+s.substr(1),k.SearchErrorCode.globParseError);if(s.startsWith("the literal"))return new k.SearchError(s.charAt(0).toUpperCase()+s.substr(1),k.SearchErrorCode.invalidLiteral);if(s.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(s,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function a(w){const S=["Regex parse error"],s=w.filter(b=>b.startsWith("PCRE2:"));if(s.length>=1){const b=s[0].replace("PCRE2:","");if(b.indexOf(":")!==-1&&b.split(":").length>=2){const R=b.split(":")[1];S.push(":"+R)}}return S.join("")}e.buildRegexParseError=a;class l extends L.EventEmitter{constructor(S,s,b){super();this.maxResults=S,this.rootFolder=s,this.previewOptions=b,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(S,s){return super.on(S,s),this}handleData(S){if(this.isDone)return;const s=typeof S=="string"?S:this.stringDecoder.write(S);this.handleDecodedData(s)}handleDecodedData(S){let s=S.indexOf(`
`);const b=this.remainder+S;if(s>=0)s+=this.remainder.length;else{this.remainder=b;return}let R=0;for(;s>=0;)this.handleLine(b.substring(R,s).trim()),R=s+1,s=b.indexOf(`
`,R);this.remainder=b.substring(R)}handleLine(S){if(this.isDone||!S)return;let s;try{s=JSON.parse(S)}catch(b){throw new Error(`malformed line from rg: ${S}`)}if(s.type==="match"){const b=v(s.data.path),R=n.URI.file(y.join(this.rootFolder,b)),O=this.createTextSearchMatch(s.data,R);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(s.type==="context"){const b=v(s.data.path),R=n.URI.file(y.join(this.rootFolder,b));this.createTextSearchContext(s.data,R).forEach($=>this.onResult($))}}createTextSearchMatch(S,s){const b=S.line_number-1,R=v(S.lines),O=Buffer.from(R);let $=0,G=0,Z=b;S.submatches.length===0&&S.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const U=(0,C.coalesce)(S.submatches.map((x,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const H=v(x.match),F=O.slice($,x.start).toString().length,N=G+F,j=t(H),W=Z,Q=j.numLines+W,J=j.numLines>0?j.lastLineLength:j.lastLineLength+N;return $=x.end,G=J,Z=Q,new d.Range(W,N,Q,J)}));return(0,p.createTextSearchResult)(s,R,U,this.previewOptions)}createTextSearchContext(S,s){const b=v(S.lines),R=S.line_number;return b.replace(/\r?\n$/,"").split(`
`).map((O,$)=>({text:O,uri:s,lineNumber:R+$}))}onResult(S){this.emit("result",S)}}e.RipgrepParser=l;function v(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const S=/\n/g;let s=0,b=-1,R;for(;R=S.exec(w);)s++,b=R.index;const O=b>=0?w.length-b-1:w.length;return{numLines:s,lastLineLength:O}}function r(w,S){const s=["--hidden"];s.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:b,otherIncludes:R}=(0,T.groupBy)(S.includes,$=>$.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const $=new Set;R.forEach(G=>{$.add(G)}),s.push("-g","!*"),$.forEach(G=>{o(G).map(p.anchorGlob).forEach(Z=>{s.push("-g",Z)})})}b&&b.length&&b.forEach($=>{s.push("-g",$)}),S.excludes.map(p.anchorGlob).forEach($=>s.push("-g",`!${$}`)),S.maxFileSize&&s.push("--max-filesize",S.maxFileSize+""),S.useIgnoreFiles?s.push("--no-ignore-parent"):s.push("--no-ignore"),S.followSymlinks&&s.push("--follow"),S.encoding&&S.encoding!=="utf8"&&s.push("--encoding",S.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,P.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),S.usePCRE2&&s.push("--pcre2"),s.push("--crlf"),w.isRegExp&&(w.pattern=i(w.pattern),s.push("--auto-hybrid-regex"));let O;if(w.isWordMatch){const G=(0,P.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");s.push("--regexp",G)}else if(w.isRegExp){let $=h(w.pattern);$=m($),s.push("--regexp",$)}else O=w.pattern,s.push("--fixed-strings");return s.push("--no-config"),S.useGlobalIgnoreFiles||s.push("--no-ignore-global"),s.push("--json"),w.isMultiline&&s.push("--multiline"),S.beforeContext&&s.push("--before-context",S.beforeContext+""),S.afterContext&&s.push("--after-context",S.afterContext+""),s.push("--"),O&&s.push(O),s.push("."),s}function o(w){const S=(0,D.splitGlobAware)(w,"/");return S.map((s,b)=>S.slice(0,b+1).join("/"))}e.spreadGlobComponents=o;function i(w){const S=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(S);)w=w.replace(S,"$1\\x{$2}");const s=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(s);)w=w.replace(s,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=i;const c=w=>w.type==="Assertion"&&w.kind==="lookbehind";function h(w){let S;try{S=new f.RegExpParser().parsePattern(w)}catch{return w}let s="",b=0;const R=(G,Z,U)=>{s+=w.slice(b,G)+U,b=Z},O=[];return new f.RegExpVisitor({onCharacterEnter(G){if(G.raw!=="\\n")return;const Z=O[0];if(!Z)R(G.start,G.end,"\\r?\\n");else if(!O.some(c))if(Z.type==="CharacterClass")if(Z.negate){const U=w.slice(Z.start+2,G.start)+w.slice(G.end,Z.end-1);R(Z.start,Z.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=w.slice(Z.start+1,G.start)+w.slice(G.end,Z.end-1);R(Z.start,Z.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else Z.type==="Quantifier"&&R(G.start,G.end,"(?:\\r?\\n)")},onQuantifierEnter(G){O.unshift(G)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(G){O.unshift(G)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(G){O.unshift(G)},onCharacterClassLeave(){O.shift()},onAssertionEnter(G){c(G)&&O.push(G)},onAssertionLeave(G){O[0]===G&&O.shift()}}).visit(S),s+=w.slice(b),s}e.fixRegexNewline=h;function m(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(me[282],ge([0,1,21,136,119,10]),function(Y,e,g,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,n,k,d){const f=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===C.Schemas.userData){const u={...n,folder:n.folder.with({scheme:C.Schemas.file})},p=new I.Progress(_=>k.report({..._,uri:_.uri.with({scheme:n.folder.scheme})}));return this.withToken(d,_=>f.provideTextSearchResults(P,u,p,_))}else return this.withToken(d,u=>f.provideTextSearchResults(P,n,k,u))}async withToken(P,n){const k=D(P);this.inProgress.add(k);const d=await n(k.token);return this.inProgress.delete(k),d}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=T;function D(y){const P=new g.CancellationTokenSource;return y.onCancellationRequested(()=>P.cancel()),P}}),define(me[283],ge([0,1,28,136,135]),function(Y,e,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(y){this.query=y}search(y,P,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(f){n({message:f})}},d=new I.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(k),g);return new Promise((f,u)=>d.search(p=>{P(p.map(T))},y).then(p=>f({limitHit:p.limitHit,type:"success",stats:p.stats}),u))}}e.TextSearchEngineAdapter=C;function T(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((y,P)=>{if(P.ranges){const n=P;return y+(Array.isArray(n.ranges)?n.ranges.length:1)}else return y+1},0)}}}),define(me[284],ge([0,1,49,298,20,17,16,3,101,8,46,2,42,31,281,283]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class _{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let r;const o=a(t),i=new D.Emitter({onFirstListenerDidAdd:()=>{r=(0,C.createCancelablePromise)(c=>this.doFileSearchWithEngine(u.Engine,o,h=>i.fire(h),c)),r.then(c=>i.fire(c),c=>i.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}textSearch(t){let r;const o=a(t),i=new D.Emitter({onFirstListenerDidAdd:()=>{r=(0,C.createCancelablePromise)(c=>this.ripgrepTextSearch(o,h=>i.fire(h),c)),r.then(c=>i.fire(c),c=>i.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}ripgrepTextSearch(t,r,o){return t.maxFileSize=(0,d.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new p.TextSearchEngineAdapter(t).search(o,r,r)}doFileSearch(t,r,o){return this.doFileSearchWithEngine(u.Engine,t,r,o)}doFileSearchWithEngine(t,r,o,i,c=_.BATCH_SIZE){let h=0;const m=S=>{Array.isArray(S)?(h+=S.length,o(S.map(s=>this.rawMatchToSearchItem(s)))):S.relativePath?(h++,o(this.rawMatchToSearchItem(S))):o(S)};if(r.sortByScore){let S=this.trySortedSearchFromCache(r,m,i);if(!S){const s=r.maxResults?Object.assign({},r,{maxResults:null}):r,b=new t(s);S=this.doSortedSearch(b,r,o,m,i)}return new Promise((s,b)=>{S.then(([R,O])=>{const $=O.map(G=>this.rawMatchToSearchItem(G));this.sendProgress($,o,c),s(R)},b)})}const w=new t(r);return this.doSearch(w,m,c,i).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.processType,fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,o,i,c){const h=new D.Emitter;let m=(0,C.createCancelablePromise)(S=>{let s=[];const b=R=>{Array.isArray(R)?s=R:(i(R),h.fire(R))};return this.doSearch(t,b,-1,S).then(R=>[R,s])}),w;if(r.cacheKey){w=this.getOrCreateCache(r.cacheKey);const S={promise:m,event:h.event,resolved:!1};w.resultsToSearchCache[r.filePattern||""]=S,m.then(()=>{S.resolved=!0},s=>{delete w.resultsToSearchCache[r.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([S,s])=>{const b=w?w.scorerCache:Object.create(null),R=(typeof r.maxResults!="number"||r.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(r,s,b,c).then(O=>{const $=R?R.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:$,fromCache:!1,type:this.processType,workspaceFolderCount:r.folderQueries.length,resultCount:O.length},messages:S.messages,limitHit:S.limitHit||typeof r.maxResults=="number"&&s.length>r.maxResults},O]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new A)}trySortedSearchFromCache(t,r,o){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const c=this.getResultsFromCache(i,t.filePattern||"",r,o);if(c)return c.then(([h,m,w])=>{const S=n.StopWatch.create(!1);return this.sortResults(t,m,i.scorerCache,o).then(s=>{const b=S.elapsed(),R={fromCache:!0,detailStats:w,type:this.processType,resultCount:m.length,sortingTime:b};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:R},s]})})}sortResults(t,r,o,i){const c=(0,y.prepareQuery)(t.filePattern||""),h=(w,S)=>(0,y.compareItemsByFuzzyScore)(w,S,c,!0,E,o),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return I.topAsync(r,h,m,1e4,i)}sendProgress(t,r,o){if(o&&o>0)for(let i=0;i<t.length;i+=o)r(t.slice(i,i+o));else r(t)}getResultsFromCache(t,r,o,i){const c=n.StopWatch.create(!1),h=r.indexOf(P.sep)>=0;let m;for(const b in t.resultsToSearchCache)if(r.startsWith(b)){if(h&&b.indexOf(P.sep)<0&&b!=="")continue;const R=t.resultsToSearchCache[b];m={promise:this.preventCancellation(R.promise),event:R.event,resolved:R.resolved};break}if(!m)return null;const w=c.elapsed(),S=n.StopWatch.create(!1),s=m.event(o);return i&&i.onCancellationRequested(()=>{s.dispose()}),m.promise.then(([b,R])=>{if(i&&i.isCancellationRequested)throw(0,T.canceled)();const O=[],$=(0,y.prepareQuery)(r).normalizedLowercase;for(const G of R)!(0,f.isFilePatternMatch)(G,$)||O.push(G);return[b,O,{cacheWasResolved:m.resolved,cacheLookupTime:w,cacheFilterTime:S.elapsed(),cacheEntryCount:R.length}]})}doSearch(t,r,o,i){return new Promise((c,h)=>{let m=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(o?(m.push(w),o>0&&m.length>=o&&(r(m),m=[])):r(w))},w=>{r(w)},(w,S)=>{m.length&&r(m),w?h(w):c(S)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,o){return t.then(r,o)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class A{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(v){return(0,P.basename)(v.relativePath)}getItemDescription(v){return(0,P.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function a(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(l),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>k.URI.revive(t))}}function l(v){return{...v,folder:k.URI.revive(v.folder)}}}),define(me[285],ge([0,1,6,10,2,28,12,27,14,73,64,31,284,282,94,135]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends P.ExtHostSearch{constructor(E,a,l,v){super(E,l,v);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new u.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new f.RipgrepSearchProvider(t)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new u.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new f.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(L.Schemas.file,new d.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,a){const l=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(E)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(E,a,l,v){const t=(0,P.reviveQuery)(l);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,a,t,v):super.$provideFileSearchResults(E,a,l,v)}doInternalFileSearch(E,a,l,v){const t=r=>{if((0,k.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(E,a,r.map(o=>I.URI.file(o.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,t,v)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,a){return new p.NativeTextSearchManager(E,a,void 0,"textSearchProvider")}};_=je([Ue(0,y.IExtHostRpcService),Ue(1,D.IExtHostInitDataService),Ue(2,n.IURITransformerService),Ue(3,T.ILogService)],_),e.NativeExtHostSearch=_}),define(me[137],ge([0,1,299,126,80,22,16,3,6,8,11,32,106,107,300]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(m){this.socket=m,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const w=S=>m(C.VSBuffer.wrap(S));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(m){const w=S=>{m({type:0,hadError:S,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((m,w)=>{if(this.socket.bufferSize===0){m();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),m()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=p;var _;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var A;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(A||(A={}));class E extends y.Disposable{constructor(m,w,S,s){super();this._onDidZlibFlush=this._register(new D.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=s,w?(this._zlibInflate=u.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",b=>{console.error(b),(0,T.onUnexpectedError)(b),this._onClose.fire({type:0,hadError:!0,error:b})}),this._zlibInflate.on("data",b=>{this._pendingInflateData.push(b)}),S&&(this._zlibInflate.write(S.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",b=>{console.error(b),(0,T.onUnexpectedError)(b),this._onClose.fire({type:0,hadError:!0,error:b})}),this._zlibDeflate.on("data",b=>{this._pendingDeflateData.push(b)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(b=>this._acceptChunk(b))),this._register(this.socket.onClose(b=>this._onClose.fire(b)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(C.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,w){let S=2;m.byteLength<126?S+=0:m.byteLength<2**16?S+=2:S+=8;const s=C.VSBuffer.alloc(S);if(w?s.writeUInt8(194,0):s.writeUInt8(130,0),m.byteLength<126)s.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){s.writeUInt8(126,1);let b=1;s.writeUInt8(m.byteLength>>>8&255,++b),s.writeUInt8(m.byteLength>>>0&255,++b)}else{s.writeUInt8(127,1);let b=1;s.writeUInt8(0,++b),s.writeUInt8(0,++b),s.writeUInt8(0,++b),s.writeUInt8(0,++b),s.writeUInt8(m.byteLength>>>24&255,++b),s.writeUInt8(m.byteLength>>>16&255,++b),s.writeUInt8(m.byteLength>>>8&255,++b),s.writeUInt8(m.byteLength>>>0&255,++b)}this._totalOutgoingWireBytes+=s.byteLength+m.byteLength,this.socket.write(C.VSBuffer.concat([s,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),s=(w.readUInt8(0)&128)>>>7,b=w.readUInt8(1),R=(b&128)>>>7,O=b&127;this._state.state=2,this._state.readLen=2+(R?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=s,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),S=w.readUInt8(1),s=(S&128)>>>7;let b=S&127,R=1;b===126?b=w.readUInt8(++R)*2**8+w.readUInt8(++R):b===127&&(b=w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*2**24+w.readUInt8(++R)*2**16+w.readUInt8(++R)*2**8+w.readUInt8(++R));let O=0;s&&(O=w.readUInt8(++R)*2**24+w.readUInt8(++R)*2**16+w.readUInt8(++R)*2**8+w.readUInt8(++R)),this._state.state=3,this._state.readLen=b,this._state.mask=O}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);a(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const S=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=S.length,this._onData.fire(C.VSBuffer.wrap(S))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await D.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function a(h,m){if(m===0)return;let w=h.byteLength>>>2;for(let $=0;$<w;$++){const G=h.readUInt32BE($*4);h.writeUInt32BE(G^m,$*4)}let S=w*4,s=h.byteLength-S;const b=m>>>24&255,R=m>>>16&255,O=m>>>8&255;s>=1&&h.writeUInt8(h.readUInt8(S)^b,S),s>=2&&h.writeUInt8(h.readUInt8(S+1)^R,S+1),s>=3&&h.writeUInt8(h.readUInt8(S+2)^O,S+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function v(){const h=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):m=(0,P.join)((0,I.tmpdir)(),`vscode-ipc-${h}.sock`),r(m),m}e.createRandomIPCHandle=v;function t(h,m,w){const S=(0,g.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${w}-${m}-sock`;let s;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?s=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${w}-${m}.sock`):s=(0,P.join)(h,`${w}-${m}.sock`),r(s),s}e.createStaticIPCHandle=t;function r(h){const m=l[n.platform];typeof m=="number"&&h.length>=m&&console.warn(`WARNING: IPC handle "${h}" is longer than ${m} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{constructor(m){super(o.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const w=D.Event.fromNodeEventEmitter(m,"connection");return D.Event.map(w,S=>({protocol:new f.Protocol(new p(S)),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(S,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function i(h){return new Promise((m,w)=>{const S=(0,L.createServer)();S.on("error",w),S.listen(h,()=>{S.removeListener("error",w),m(new o(S))})})}e.serve=i;function c(h,m){return new Promise((w,S)=>{const s=(0,L.createConnection)(h,()=>{s.removeListener("error",S),w(f.Client.fromSocket(new p(s),m))});s.once("error",S)})}e.connect=c}),define(me[286],ge([0,1,137,278,49,44,2,198,12]),function(Y,e,g,L,I,C,T,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(d,f,u){this._commands=d,this.logService=f,this._ipcHandlePath=u,this._server=L.createServer((p,_)=>this.onRequest(p,_)),this.setup().catch(p=>(f.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch(d){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,f){const u=[];d.setEncoding("utf8"),d.on("data",p=>u.push(p)),d.on("end",()=>{const p=JSON.parse(u.join(""));switch(p.type){case"open":this.open(p,f);break;case"openExternal":this.openExternal(p,f);break;case"status":this.getStatus(p,f);break;case"extensionManagement":this.manageExtensions(p,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${p.type}`,_=>{_&&this.logService.error(_)}),f.end();break}})}open(d,f){let{fileURIs:u,folderURIs:p,forceNewWindow:_,diffMode:A,addMode:E,forceReuseWindow:a,gotoLineMode:l,waitMarkerFilePath:v}=d;const t=[];if(Array.isArray(p))for(const r of p)try{t.push({folderUri:T.URI.parse(r)})}catch(o){}if(Array.isArray(u))for(const r of u)try{(0,D.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:T.URI.parse(r)}):t.push({fileUri:T.URI.parse(r)})}catch(o){}if(t.length){const r=v?T.URI.file(v):void 0,i={forceNewWindow:_,diffMode:A,addMode:E,gotoLineMode:l,forceReuseWindow:a,preferNewWindow:!a&&!r&&!E,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}f.writeHead(200),f.end()}async openExternal(d,f){for(const u of d.uris){const p=T.URI.parse(u),_=p.scheme==="file"?p:u;await this._commands.executeCommand("_remoteCLI.openExternal",_)}f.writeHead(200),f.end()}async manageExtensions(d,f){try{const u=A=>A?.map(E=>/\.vsix$/i.test(E)?T.URI.parse(E):E),p={list:d.list,install:u(d.install),uninstall:u(d.uninstall),force:d.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);f.writeHead(200),f.write(_)}catch(u){f.writeHead(500),f.write(String(u),p=>{p&&this.logService.error(p)})}f.end()}async getStatus(d,f){try{const u=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(u),f.end()}catch(u){f.writeHead(500),f.write(String(u),p=>{p&&this.logService.error(p)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let n=class extends P{constructor(d,f){super(d,f,(0,g.createRandomIPCHandle)())}};n=je([Ue(0,C.IExtHostCommands),Ue(1,y.ILogService)],n),e.CLIServer=n}),define(me[287],ge([0,1,72,274,269,5,277,40,259,2,10,7,286,105]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class u extends I.RequireInterceptor{_installInterceptor(){const A=this,E=Y.__$__nodeRequire("module"),a=E._load;E._load=function(v,t,r){for(let o of A._alternatives){let i=o(v);if(i){v=i;break}}return A._factories.has(v)?A._factories.get(v).load(v,P.URI.file((0,f.realpathSync)(t.filename)),o=>a.apply(this,[o,t,r])):a.apply(this,arguments)}}}class p extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(d.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(u,A,this._registry).install(),g.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const l=process.send,v=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?l.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,E,a){if(E.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let l=null;a.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{A&&g.mark(`code/extHost/willLoadExtensionCode/${A.value}`),l=Y.__$__nodeRequire(E.fsPath)}catch(v){return Promise.reject(v)}finally{A&&g.mark(`code/extHost/didLoadExtensionCode/${A.value}`),a.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const E in A){const a=A[E];a===null?delete process.env[E]:process.env[E]=a}}}e.ExtHostExtensionService=p}),define(me[288],ge([0,1,82,260,262,271,270,285,287,227,263,53,40,67,73,71,33,52,12,68,261]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_,A,E,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(d.IExtHostExtensionService,y.ExtHostExtensionService),(0,g.registerSingleton)(E.ILogService,P.ExtHostLogService),(0,g.registerSingleton)(a.IExtensionStoragePaths,l.ExtensionStoragePaths),(0,g.registerSingleton)(k.IExtHostDebugService,T.ExtHostDebugService),(0,g.registerSingleton)(f.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(u.IExtHostSearch,D.NativeExtHostSearch),(0,g.registerSingleton)(p.IExtHostTask,C.ExtHostTask),(0,g.registerSingleton)(_.IExtHostTerminalService,I.ExtHostTerminalService),(0,g.registerSingleton)(A.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[289],ge([0,1,126,301,72,16,107,137,117,225,272,22,103,28,105,17,118,275,288]),function(Y,e,g,L,I,C,T,D,y,P,n,k,d,f,u,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let c=0;c<process.execArgv.length;c++)process.execArgv[c]==="--inspect-port=0"&&(process.execArgv.splice(c,1),c--)}();const A=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=Y.__$__nodeRequire("module"),c=i._load;i._load=function(h){if(h==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return c.apply(this,arguments)}})();const E=process.exit.bind(process);function a(i){process.exit=function(c){if(i)E(c);else{const h=new Error("An extension called process.exit() and this was prevented.");console.warn(h.stack)}},process.crash=function(){const c=new Error("An extension called process.crash() and this was prevented.");console.warn(c.stack)}}let l=function(i){E()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,c)=>{let h=null,m=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,S=3e5,s=new p.RunOnceScheduler(()=>l("renderer disconnected for too long (1)"),w),b=new p.RunOnceScheduler(()=>l("renderer disconnected for too long (2)"),S);process.on("message",(O,$)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=k.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let Z;if(O.skipWebSocketFrames)Z=new D.NodeSocket($);else{const U=k.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));Z=new D.WebSocketNodeSocket(new D.NodeSocket($),O.permessageDeflate,U,!1)}h?(s.cancel(),b.cancel(),h.beginAcceptReconnection(Z,G),h.endAcceptReconnection()):(clearTimeout(m),h=new T.PersistentProtocol(Z,G),h.onDidDispose(()=>l("renderer disconnected")),i(h),h.onSocketClose(()=>{s.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(b.isScheduled())return;s.isScheduled()&&b.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((c,h)=>{const m=g.createConnection(i,()=>{m.removeListener("error",h),c(new T.PersistentProtocol(new D.NodeSocket(m)))});m.once("error",h),m.on("close",()=>{l("renderer closed the socket")})})}}async function t(){const i=await v();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(c=>{(0,P.isMessageOfType)(c,2)?(this._terminating=!0,l("received terminate message from renderer")):this._onMessage.fire(c)})}send(c){this._terminating||i.send(c)}drain(){return i.drain()}}}function r(i){return new Promise(c=>{const h=i.onMessage(m=>{h.dispose();const w=JSON.parse(m.toString()),S=w.commit,s=y.default.commit;S&&s&&S!==s&&E(55);const b=[];process.on("unhandledRejection",($,G)=>{b.push(G),setTimeout(()=>{const Z=b.indexOf(G);Z>=0&&G.catch(U=>{b.splice(Z,1),(0,C.isPromiseCanceledError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,C.onUnexpectedError)($))})},1e3)}),process.on("rejectionHandled",$=>{const G=b.indexOf($);G>=0&&b.splice(G,1)}),process.on("uncaughtException",function($){(0,C.onUnexpectedError)($)});let R=0;setInterval(function(){try{process.kill(w.parentPid,0),R=0}catch($){$&&$.code==="EPERM"?(R++,R>=3&&l(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):l(`parent process ${w.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let O;try{O=Y.__$__nodeRequire("native-watchdog"),O.start(w.parentPid)}catch($){(0,C.onUnexpectedError)($)}i.send((0,P.createMessageOfType)(0)),c({protocol:i,initData:w})});i.send((0,P.createMessageOfType)(1))})}async function o(){I.mark("code/extHost/willConnectToRenderer");const i=await t();I.mark("code/extHost/didConnectToRenderer");const c=await r(i);I.mark("code/extHost/didWaitForInitData");const{initData:h}=c;a(!!h.environment.extensionTestsLocationURI),h.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,h.environment.skipWorkspaceStorageLock=(0,_.boolean)(A.skipWorkspaceStorageLock,!1);const m=new class{exit(b){E(b)}exists(b){return f.Promises.exists(b)}realpath(b){return(0,u.realpath)(b)}};let w=null;if(h.remote.authority&&A.uriTransformerPath)try{const b=Y.__$__nodeRequire(A.uriTransformerPath)(h.remote.authority);w=new d.URITransformer(b)}catch(s){console.error(s)}const S=new n.ExtensionHostMain(c.protocol,h,m,w);l=s=>S.terminate(s)}e.startExtensionHostProcess=o}),define(me[302],ge([0,1,289]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89bbd372f459ce72e9c0b60eb3b26b924f64f62d/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
