/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/iterator","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(ie){for(var e=[],d=0,F=ie.length;d<F;d++)e[d]=we[ie[d]];return e};define(we[39],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(F,E){if(!F)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=d}),define(we[50],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function F(t){const _=[];for(let r in t)d.call(t,r)&&_.push(t[r]);return _}e.values=F;function E(t,_){for(let r in t)if(d.call(t,r)&&_({key:r,value:t[r]},function(){delete t[r]})===!1)return}e.forEach=E;function A(t,_){const r=Object.create(null);for(const h of t){const a=_(h);let l=r[a];l||(l=r[a]=[]),l.push(h)}return r}e.groupBy=A;function R(t){const _=Object.create(null);return t&&t.forEach((r,h)=>{_[h]=r}),_}e.fromMap=R;function k(t,_){const r=[],h=[];for(let a of t)_.has(a)||r.push(a);for(let a of _)t.has(a)||h.push(a);return{removed:r,added:h}}e.diffSets=k;function y(t,_){const r=[],h=[];for(let[a,l]of t)_.has(a)||r.push(l);for(let[a,l]of _)t.has(a)||h.push(l);return{removed:r,added:h}}e.diffMaps=y;class T{constructor(){this.map=new Map}add(_,r){let h=this.map.get(_);h||(h=new Set,this.map.set(_,h)),h.add(r)}delete(_,r){const h=this.map.get(_);!h||(h.delete(r),h.size===0&&this.map.delete(_))}forEach(_,r){const h=this.map.get(_);!h||h.forEach(r)}}e.SetMap=T}),define(we[51],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(R){return(k,y,T)=>{let t=null,_=null;if(typeof T.value=="function"?(t="value",_=T.value):typeof T.get=="function"&&(t="get",_=T.get),!_)throw new Error("not supported");T[t]=R(_,y)}}e.createDecorator=d;function F(R,k,y){let T=null,t=null;if(typeof y.value=="function"?(T="value",t=y.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",t=y.get),!t)throw new Error("not supported");const _=`$memoize$${k}`;y[T]=function(...r){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,r)}),this[_]}}e.memoize=F;function E(R,k,y){return d((T,t)=>{const _=`$debounce$${t}`,r=`$debounce$result$${t}`;return function(...h){this[r]||(this[r]=y?y():void 0),clearTimeout(this[_]),k&&(this[r]=k(this[r],...h),h=[this[r]]),this[_]=setTimeout(()=>{T.apply(this,h),this[r]=y?y():void 0},R)}})}e.debounce=E;function A(R,k,y){return d((T,t)=>{const _=`$throttle$timer$${t}`,r=`$throttle$result$${t}`,h=`$throttle$lastRun$${t}`,a=`$throttle$pending$${t}`;return function(...l){if(this[r]||(this[r]=y?y():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[r]=k(this[r],...l)),this[a])return;const g=this[h]+R;g<=Date.now()?(this[h]=Date.now(),T.apply(this,[this[r]]),this[r]=y?y():void 0):(this[a]=!0,this[_]=setTimeout(()=>{this[a]=!1,this[h]=Date.now(),T.apply(this,[this[r]]),this[r]=y?y():void 0},g-Date.now()))}})}e.throttle=A}),define(we[16],be([0,1,15]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(V,le=0){return V[V.length-(1+le)]}e.tail=F;function E(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}e.tail2=E;function A(V,le,ae=(ve,Ae)=>ve===Ae){if(V===le)return!0;if(!V||!le||V.length!==le.length)return!1;for(let ve=0,Ae=V.length;ve<Ae;ve++)if(!ae(V[ve],le[ve]))return!1;return!0}e.equals=A;function R(V,le,ae){let ve=0,Ae=V.length-1;for(;ve<=Ae;){const Re=(ve+Ae)/2|0,Oe=ae(V[Re],le);if(Oe<0)ve=Re+1;else if(Oe>0)Ae=Re-1;else return Re}return-(ve+1)}e.binarySearch=R;function k(V,le){let ae=0,ve=V.length;if(ve===0)return 0;for(;ae<ve;){const Ae=Math.floor((ae+ve)/2);le(V[Ae])?ve=Ae:ae=Ae+1}return ae}e.findFirstInSorted=k;function y(V,le,ae){if(V=V|0,V>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Ae=[],Re=[],Oe=[];for(let Qe of le){const He=ae(Qe,ve);He<0?Ae.push(Qe):He>0?Re.push(Qe):Oe.push(Qe)}return V<Ae.length?y(V,Ae,ae):V<Ae.length+Oe.length?Oe[0]:y(V-(Ae.length+Oe.length),Re,ae)}e.quickSelect=y;function T(V,le){const ae=[];let ve;for(const Ae of V.slice(0).sort(le))!ve||le(ve[0],Ae)!==0?(ve=[Ae],ae.push(ve)):ve.push(Ae);return ae}e.groupBy=T;function t(V,le,ae){const ve=[];function Ae(Qe,He,je){if(He===0&&je.length===0)return;const N=ve[ve.length-1];N&&N.start+N.deleteCount===Qe?(N.deleteCount+=He,N.toInsert.push(...je)):ve.push({start:Qe,deleteCount:He,toInsert:je})}let Re=0,Oe=0;for(;;){if(Re===V.length){Ae(Re,0,le.slice(Oe));break}if(Oe===le.length){Ae(Re,V.length-Re,[]);break}const Qe=V[Re],He=le[Oe],je=ae(Qe,He);je===0?(Re+=1,Oe+=1):je<0?(Ae(Re,1,[]),Re+=1):je>0&&(Ae(Re,0,[He]),Oe+=1)}return ve}e.sortedDiff=t;function _(V,le,ae){const ve=t(V,le,ae),Ae=[],Re=[];for(const Oe of ve)Ae.push(...V.slice(Oe.start,Oe.start+Oe.deleteCount)),Re.push(...Oe.toInsert);return{removed:Ae,added:Re}}e.delta=_;function r(V,le,ae){if(ae===0)return[];const ve=V.slice(0,ae).sort(le);return a(V,le,ve,ae,V.length),ve}e.top=r;function h(V,le,ae,ve,Ae){return ae===0?Promise.resolve([]):new Promise((Re,Oe)=>{(async()=>{const Qe=V.length,He=V.slice(0,ae).sort(le);for(let je=ae,N=Math.min(ae+ve,Qe);je<Qe;je=N,N=Math.min(N+ve,Qe)){if(je>ae&&await new Promise(K=>setTimeout(K)),Ae&&Ae.isCancellationRequested)throw(0,d.canceled)();a(V,le,He,je,N)}return He})().then(Re,Oe)})}e.topAsync=h;function a(V,le,ae,ve,Ae){for(const Re=ae.length;ve<Ae;ve++){const Oe=V[ve];if(le(Oe,ae[Re-1])<0){ae.pop();const Qe=k(ae,He=>le(Oe,He)<0);ae.splice(Qe,0,Oe)}}}function l(V){return V.filter(le=>!!le)}e.coalesce=l;function g(V){let le=0;for(let ae=0;ae<V.length;ae++)V[ae]&&(V[le]=V[ae],le+=1);V.length=le}e.coalesceInPlace=g;function I(V,le,ae){V.splice(ae,0,V.splice(le,1)[0])}e.move=I;function b(V){return!Array.isArray(V)||V.length===0}e.isFalsyOrEmpty=b;function c(V){return Array.isArray(V)&&V.length>0}e.isNonEmptyArray=c;function p(V,le){if(!le)return V.filter((ve,Ae)=>V.indexOf(ve)===Ae);const ae=Object.create(null);return V.filter(ve=>{const Ae=le(ve);return ae[Ae]?!1:(ae[Ae]=!0,!0)})}e.distinct=p;function S(V){const le=new Set;return V.filter(ae=>le.has(ae)?!1:(le.add(ae),!0))}e.distinctES6=S;function i(V){const le=Object.create(null);return ae=>{const ve=V(ae);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=i;function s(V,le){for(let ae=V.length-1;ae>=0;ae--){const ve=V[ae];if(le(ve))return ae}return-1}e.lastIndex=s;function u(V,le){return V.length>0?V[0]:le}e.firstOrDefault=u;function o(V,le,ae=(ve,Ae)=>ve===Ae){let ve=0;for(let Ae=0,Re=Math.min(V.length,le.length);Ae<Re&&ae(V[Ae],le[Ae]);Ae++)ve++;return ve}e.commonPrefixLength=o;function f(V){return[].concat(...V)}e.flatten=f;function v(V,le){let ae=typeof le=="number"?V:0;typeof le=="number"?ae=V:(ae=0,le=V);const ve=[];if(ae<=le)for(let Ae=ae;Ae<le;Ae++)ve.push(Ae);else for(let Ae=ae;Ae>le;Ae--)ve.push(Ae);return ve}e.range=v;function w(V,le,ae){return V.reduce((ve,Ae)=>(ve[le(Ae)]=ae?ae(Ae):Ae,ve),Object.create(null))}e.index=w;function D(V,le){return V.push(le),()=>P(V,le)}e.insert=D;function P(V,le){const ae=V.indexOf(le);if(ae>-1)return V.splice(ae,1),le}e.remove=P;function n(V,le,ae){const ve=V.slice(0,le),Ae=V.slice(le);return ve.concat(ae,Ae)}e.arrayInsert=n;function m(V,le){let ae;if(typeof le=="number"){let ve=le;ae=()=>{const Ae=Math.sin(ve++)*179426549;return Ae-Math.floor(Ae)}}else ae=Math.random;for(let ve=V.length-1;ve>0;ve-=1){const Ae=Math.floor(ae()*(ve+1)),Re=V[ve];V[ve]=V[Ae],V[Ae]=Re}}e.shuffle=m;function C(V,le){const ae=V.indexOf(le);ae>-1&&(V.splice(ae,1),V.unshift(le))}e.pushToStart=C;function L(V,le){const ae=V.indexOf(le);ae>-1&&(V.splice(ae,1),V.push(le))}e.pushToEnd=L;function $(V,le){return Array.isArray(V)?V.map(le):le(V)}e.mapArrayOrNot=$;function Q(V){return Array.isArray(V)?V:[V]}e.asArray=Q;function se(V){return V[Math.floor(Math.random()*V.length)]}e.getRandomElement=se;function G(V,le){for(const ae of V){const ve=le(ae);if(ve!==void 0)return ve}}e.mapFind=G;function z(V,le,ae){const ve=j(V,le),Ae=V.length,Re=ae.length;V.length=Ae+Re;for(let Oe=Ae-1;Oe>=ve;Oe--)V[Oe+Re]=V[Oe];for(let Oe=0;Oe<Re;Oe++)V[Oe+ve]=ae[Oe]}e.insertInto=z;function x(V,le,ae,ve){const Ae=j(V,le),Re=V.splice(Ae,ae);return z(V,Ae,ve),Re}e.splice=x;function j(V,le){return le<0?Math.max(le+V.length,0):Math.min(le,V.length)}function B(V,le){let ae=Number.MAX_SAFE_INTEGER,ve=0;return V.forEach((Ae,Re)=>{const Oe=le(Ae);Oe<ae&&(ae=Oe,ve=Re)}),ve}e.minIndex=B;function q(V,le){let ae=Number.MIN_SAFE_INTEGER,ve=0;return V.forEach((Ae,Re)=>{const Oe=le(Ae);Oe>ae&&(ae=Oe,ve=Re)}),ve}e.maxIndex=q;class ce{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let ae=this.firstIdx;for(;ae<this.items.length&&le(this.items[ae]);)ae++;const ve=ae===this.firstIdx?null:this.items.slice(this.firstIdx,ae);return this.firstIdx=ae,ve}takeFromEndWhile(le){let ae=this.lastIdx;for(;ae>=0&&le(this.items[ae]);)ae--;const ve=ae===this.lastIdx?null:this.items.slice(ae+1,this.lastIdx+1);return this.lastIdx=ae,ve}}e.ArrayQueue=ce}),define(we[52],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(we[102],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(i,s=!1){let u=0,o=i.length,f="",v=0,w=16,D=0;function P(se){let G=0,z=0;for(;G<se;){const x=i.charCodeAt(u);if(x>=48&&x<=57)z=z*16+x-48;else if(x>=65&&x<=70)z=z*16+x-65+10;else if(x>=97&&x<=102)z=z*16+x-97+10;else break;u++,G++}return G<se&&(z=-1),z}function n(se){u=se,f="",v=0,w=16,D=0}function m(){const se=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&T(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&T(i.charCodeAt(u)))for(u++;u<i.length&&T(i.charCodeAt(u));)u++;else return D=3,i.substring(se,u);let G=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&T(i.charCodeAt(u))){for(u++;u<i.length&&T(i.charCodeAt(u));)u++;G=u}else D=3;return i.substring(se,G)}function C(){let se="",G=u;for(;;){if(u>=o){se+=i.substring(G,u),D=2;break}const z=i.charCodeAt(u);if(z===34){se+=i.substring(G,u),u++;break}if(z===92){if(se+=i.substring(G,u),u++,u>=o){D=2;break}switch(i.charCodeAt(u++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:const j=P(4);j>=0?se+=String.fromCharCode(j):D=4;break;default:D=5}G=u;continue}if(z>=0&&z<=31)if(y(z)){se+=i.substring(G,u),D=2;break}else D=6;u++}return se}function L(){if(f="",D=0,v=u,u>=o)return v=o,w=17;let se=i.charCodeAt(u);if(k(se)){do u++,f+=String.fromCharCode(se),se=i.charCodeAt(u);while(k(se));return w=15}if(y(se))return u++,f+=String.fromCharCode(se),se===13&&i.charCodeAt(u)===10&&(u++,f+=`
`),w=14;switch(se){case 123:return u++,w=1;case 125:return u++,w=2;case 91:return u++,w=3;case 93:return u++,w=4;case 58:return u++,w=6;case 44:return u++,w=5;case 34:return u++,f=C(),w=10;case 47:const G=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<o&&!y(i.charCodeAt(u));)u++;return f=i.substring(G,u),w=12}if(i.charCodeAt(u+1)===42){u+=2;const z=o-1;let x=!1;for(;u<z;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,x=!0;break}u++}return x||(u++,D=1),f=i.substring(G,u),w=13}return f+=String.fromCharCode(se),u++,w=16;case 45:if(f+=String.fromCharCode(se),u++,u===o||!T(i.charCodeAt(u)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=m(),w=11;default:for(;u<o&&$(se);)u++,se=i.charCodeAt(u);if(v!==u){switch(f=i.substring(v,u),f){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return f+=String.fromCharCode(se),u++,w=16}}function $(se){if(k(se)||y(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let se;do se=L();while(se>=12&&se<=15);return se}return{setPosition:n,getPosition:()=>u,scan:s?Q:L,getToken:()=>w,getTokenValue:()=>f,getTokenOffset:()=>v,getTokenLength:()=>u-v,getTokenError:()=>D}}e.createScanner=R;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function _(i,s){const u=[],o=new Object;let f;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function D(P,n,m,C){v.value=P,v.offset=n,v.length=m,v.type=C,v.colonOffset=void 0,f=v}try{c(i,{onObjectBegin:(P,n)=>{if(s<=P)throw o;f=void 0,w=s>P,u.push("")},onObjectProperty:(P,n,m)=>{if(s<n||(D(P,n,m,"property"),u[u.length-1]=P,s<=n+m))throw o},onObjectEnd:(P,n)=>{if(s<=P)throw o;f=void 0,u.pop()},onArrayBegin:(P,n)=>{if(s<=P)throw o;f=void 0,u.push(0)},onArrayEnd:(P,n)=>{if(s<=P)throw o;f=void 0,u.pop()},onLiteralValue:(P,n,m)=>{if(s<n||(D(P,n,m,S(P)),s<=n+m))throw o},onSeparator:(P,n,m)=>{if(s<=n)throw o;if(P===":"&&f&&f.type==="property")f.colonOffset=n,w=!1,f=void 0;else if(P===","){const C=u[u.length-1];typeof C=="number"?u[u.length-1]=C+1:(w=!0,u[u.length-1]=""),f=void 0}}})}catch(P){if(P!==o)throw P}return{path:u,previousNode:f,isAtPropertyKey:w,matches:P=>{let n=0;for(let m=0;n<P.length&&m<u.length;m++)if(P[n]===u[m]||P[n]==="*")n++;else if(P[n]!=="**")return!1;return n===P.length}}}e.getLocation=_;function r(i,s=[],u=A.DEFAULT){let o=null,f=[];const v=[];function w(P){Array.isArray(f)?f.push(P):o!==null&&(f[o]=P)}return c(i,{onObjectBegin:()=>{const P={};w(P),v.push(f),f=P,o=null},onObjectProperty:P=>{o=P},onObjectEnd:()=>{f=v.pop()},onArrayBegin:()=>{const P=[];w(P),v.push(f),f=P,o=null},onArrayEnd:()=>{f=v.pop()},onLiteralValue:w,onError:(P,n,m)=>{s.push({error:P,offset:n,length:m})}},u),f[0]}e.parse=r;function h(i,s=[],u=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(P){o.type==="property"&&(o.length=P-o.offset,o=o.parent)}function v(P){return o.children.push(P),P}c(i,{onObjectBegin:P=>{o=v({type:"object",offset:P,length:-1,parent:o,children:[]})},onObjectProperty:(P,n,m)=>{o=v({type:"property",offset:n,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:P,offset:n,length:m,parent:o})},onObjectEnd:(P,n)=>{o.length=P+n-o.offset,o=o.parent,f(P+n)},onArrayBegin:(P,n)=>{o=v({type:"array",offset:P,length:-1,parent:o,children:[]})},onArrayEnd:(P,n)=>{o.length=P+n-o.offset,o=o.parent,f(P+n)},onLiteralValue:(P,n,m)=>{v({type:S(P),offset:n,length:m,parent:o,value:P}),f(n+m)},onSeparator:(P,n,m)=>{o.type==="property"&&(P===":"?o.colonOffset=n:P===","&&f(n))},onError:(P,n,m)=>{s.push({error:P,offset:n,length:m})}},u);const D=o.children[0];return D&&delete D.parent,D}e.parseTree=h;function a(i,s){if(!i)return;let u=i;for(let o of s)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let f=!1;for(const v of u.children)if(Array.isArray(v.children)&&v.children[0].value===o){u=v.children[1],f=!0;break}if(!f)return}else{const f=o;if(u.type!=="array"||f<0||!Array.isArray(u.children)||f>=u.children.length)return;u=u.children[f]}return u}e.findNodeAtLocation=a;function l(i){if(!i.parent||!i.parent.children)return[];const s=l(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.getNodePath=l;function g(i){switch(i.type){case"array":return i.children.map(g);case"object":const s=Object.create(null);for(let u of i.children){const o=u.children[1];o&&(s[u.children[0].value]=g(o))}return s;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=g;function I(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.contains=I;function b(i,s,u=!1){if(I(i,s,u)){const o=i.children;if(Array.isArray(o))for(let f=0;f<o.length&&o[f].offset<=s;f++){const v=b(o[f],s,u);if(v)return v}return i}}e.findNodeAtOffset=b;function c(i,s,u=A.DEFAULT){const o=R(i,!1);function f(ae){return ae?()=>ae(o.getTokenOffset(),o.getTokenLength()):()=>!0}function v(ae){return ae?ve=>ae(ve,o.getTokenOffset(),o.getTokenLength()):()=>!0}const w=f(s.onObjectBegin),D=v(s.onObjectProperty),P=f(s.onObjectEnd),n=f(s.onArrayBegin),m=f(s.onArrayEnd),C=v(s.onLiteralValue),L=v(s.onSeparator),$=f(s.onComment),Q=v(s.onError),se=u&&u.disallowComments,G=u&&u.allowTrailingComma;function z(){for(;;){const ae=o.scan();switch(o.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:se||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ae){case 12:case 13:se?x(10):$();break;case 16:x(1);break;case 15:case 14:break;default:return ae}}}function x(ae,ve=[],Ae=[]){if(Q(ae),ve.length+Ae.length>0){let Re=o.getToken();for(;Re!==17;){if(ve.indexOf(Re)!==-1){z();break}else if(Ae.indexOf(Re)!==-1)break;Re=z()}}}function j(ae){const ve=o.getTokenValue();return ae?C(ve):D(ve),z(),!0}function B(){switch(o.getToken()){case 11:let ae=0;try{ae=JSON.parse(o.getTokenValue()),typeof ae!="number"&&(x(2),ae=0)}catch(ve){x(2)}C(ae);break;case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return z(),!0}function q(){return o.getToken()!==10?(x(3,[],[2,5]),!1):(j(!1),o.getToken()===6?(L(":"),z(),le()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function ce(){w(),z();let ae=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ae||x(4,[],[]),L(","),z(),o.getToken()===2&&G)break}else ae&&x(6,[],[]);q()||x(4,[],[2,5]),ae=!0}return P(),o.getToken()!==2?x(7,[2],[]):z(),!0}function V(){n(),z();let ae=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ae||x(4,[],[]),L(","),z(),o.getToken()===4&&G)break}else ae&&x(6,[],[]);le()||x(4,[],[4,5]),ae=!0}return m(),o.getToken()!==4?x(8,[4],[]):z(),!0}function le(){switch(o.getToken()){case 3:return V();case 1:return ce();case 10:return j(!0);default:return B()}}return z(),o.getToken()===17?u.allowEmptyContent?!0:(x(4,[],[]),!1):le()?(o.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=c;function p(i,s){let u=R(i),o=[],f,v=0,w;do switch(w=u.getPosition(),f=u.scan(),f){case 12:case 13:case 17:v!==w&&o.push(i.substring(v,w)),s!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,s)),v=u.getPosition();break}while(f!==17);return o.join("")}e.stripComments=p;function S(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),define(we[103],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new d(()=>E(this.getValue()))}}e.Lazy=d}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(Pe,ye){for(var De=0;De<ye.length;De++){var X=ye[De];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(Pe,X.key,X)}}function e(Pe,ye,De){return ye&&ie(Pe.prototype,ye),De&&ie(Pe,De),Pe}function d(Pe,ye){if(!!Pe){if(typeof Pe=="string")return F(Pe,ye);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return F(Pe,ye)}}function F(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var De=0,X=new Array(ye);De<ye;De++)X[De]=Pe[De];return X}function E(Pe,ye){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=d(Pe))||ye&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var X=0;return function(){return X>=Pe.length?{done:!0}:{done:!1,value:Pe[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Pe){A.exports.defaults=Pe}A.exports={defaults:R(),getDefaults:R,changeDefaults:k};var y=/[&<>"']/,T=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(ye){return r[ye]};function a(Pe,ye){if(ye){if(y.test(Pe))return Pe.replace(T,h)}else if(t.test(Pe))return Pe.replace(_,h);return Pe}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Pe){return Pe.replace(l,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var I=/(^|[^\[])\^/g;function b(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var De={replace:function(ue,ge){return ge=ge.source||ge,ge=ge.replace(I,"$1"),Pe=Pe.replace(ue,ge),De},getRegex:function(){return new RegExp(Pe,ye)}};return De}var c=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(Pe,ye,De){if(Pe){var X;try{X=decodeURIComponent(g(De)).replace(c,"").toLowerCase()}catch(ue){return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}ye&&!p.test(De)&&(De=f(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ue){return null}return De}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Pe,ye){i[" "+Pe]||(s.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=P(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Pe.replace(u,"$1")+ye:ye.charAt(0)==="/"?De?ye:Pe.replace(o,"$1")+ye:Pe+ye}var v={exec:function(){}};function w(Pe){for(var ye=1,De,X;ye<arguments.length;ye++){De=arguments[ye];for(X in De)Object.prototype.hasOwnProperty.call(De,X)&&(Pe[X]=De[X])}return Pe}function D(Pe,ye){var De=Pe.replace(/\|/g,function(ge,fe,Ie){for(var xe=!1,Le=fe;--Le>=0&&Ie[Le]==="\\";)xe=!xe;return xe?"|":" |"}),X=De.split(/ \|/),ue=0;if(X[0].trim()||X.shift(),X[X.length-1].trim()||X.pop(),X.length>ye)X.splice(ye);else for(;X.length<ye;)X.push("");for(;ue<X.length;ue++)X[ue]=X[ue].trim().replace(/\\\|/g,"|");return X}function P(Pe,ye,De){var X=Pe.length;if(X===0)return"";for(var ue=0;ue<X;){var ge=Pe.charAt(X-ue-1);if(ge===ye&&!De)ue++;else if(ge!==ye&&De)ue++;else break}return Pe.substr(0,X-ue)}function n(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var De=Pe.length,X=0,ue=0;ue<De;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===ye[0])X++;else if(Pe[ue]===ye[1]&&(X--,X<0))return ue;return-1}function m(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Pe,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Pe),ye>>=1,Pe+=Pe;return De+Pe}var L={escape:a,unescape:g,edit:b,cleanUrl:S,resolveUrl:f,noopTest:v,merge:w,splitCells:D,rtrim:P,findClosingBracket:n,checkSanitizeDeprecation:m,repeatString:C},$=A.exports.defaults,Q=L.rtrim,se=L.splitCells,G=L.escape,z=L.findClosingBracket;function x(Pe,ye,De,X){var ue=ye.href,ge=ye.title?G(ye.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");return Pe[0].charAt(0)!=="!"?(X.state.inLink=!0,{type:"link",raw:De,href:ue,title:ge,text:fe,tokens:X.inlineTokens(fe,[])}):{type:"image",raw:De,href:ue,title:ge,text:G(fe)}}function j(Pe,ye){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return ye;var X=De[1];return ye.split(`
`).map(function(ue){var ge=ue.match(/^\s+/);if(ge===null)return ue;var fe=ge[0];return fe.length>=X.length?ue.slice(X.length):ue}).join(`
`)}var B=function(){function Pe(De){this.options=De||$}var ye=Pe.prototype;return ye.space=function(X){var ue=this.rules.block.newline.exec(X);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(X){var ue=this.rules.block.code.exec(X);if(ue){var ge=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:Q(ge,`
`)}}},ye.fences=function(X){var ue=this.rules.block.fences.exec(X);if(ue){var ge=ue[0],fe=j(ge,ue[3]||"");return{type:"code",raw:ge,lang:ue[2]?ue[2].trim():ue[2],text:fe}}},ye.heading=function(X){var ue=this.rules.block.heading.exec(X);if(ue){var ge=ue[2].trim();if(/#$/.test(ge)){var fe=Q(ge,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ge=fe.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(X){var ue=this.rules.block.hr.exec(X);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(X){var ue=this.rules.block.blockquote.exec(X);if(ue){var ge=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(X){var ue=this.rules.block.list.exec(X);if(ue){var ge,fe,Ie,xe,Le,Ve,Xe,te,pe,ne,U=ue[1].trim(),Ce=U.length>1,Se={type:"list",raw:"",ordered:Ce,start:Ce?+U.slice(0,-1):"",loose:!1,items:[]};U=Ce?"\\d{1,9}\\"+U.slice(-1):"\\"+U,this.options.pedantic&&(U=Ce?U:"[*+-]");for(var qe=new RegExp("^( {0,3}"+U+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");X&&!(this.rules.block.hr.test(X)||!(ue=qe.exec(X)));){pe=ue[2].split(`
`),this.options.pedantic?(xe=2,ne=pe[0].trimLeft()):(xe=ue[2].search(/[^ ]/),xe=ue[1].length+(xe>4?1:xe),ne=pe[0].slice(xe-ue[1].length)),Ve=!1,ge=ue[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=ue[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<pe.length;Le++){if(te=pe[Le],this.options.pedantic&&(te=te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(te)){ge=ue[1]+pe.slice(0,Le).join(`
`)+`
`;break}if(!Ve){te.trim()||(Ve=!0),te.search(/[^ ]/)>=xe?ne+=`
`+te.slice(xe):ne+=`
`+te;continue}if(te.search(/[^ ]/)>=xe||!te.trim()){ne+=`
`+te.slice(xe);continue}else{ge=ue[1]+pe.slice(0,Le).join(`
`)+`
`;break}}Se.loose||(Xe?Se.loose=!0:/\n *\n *$/.test(ge)&&(Xe=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(ne),fe&&(Ie=fe[0]!=="[ ] ",ne=ne.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!fe,checked:Ie,loose:!1,text:ne}),Se.raw+=ge,X=X.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=ne.trimRight(),Se.raw=Se.raw.trimRight();var it=Se.items.length;for(Le=0;Le<it;Le++)this.lexer.state.top=!1,Se.items[Le].tokens=this.lexer.blockTokens(Se.items[Le].text,[]),Se.items[Le].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Le].loose=!0);return Se}},ye.html=function(X){var ue=this.rules.block.html.exec(X);if(ue){var ge={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ue[0]):G(ue[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(X){var ue=this.rules.block.def.exec(X);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ge=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(X){var ue=this.rules.block.table.exec(X);if(ue){var ge={type:"table",header:se(ue[1]).map(function(Xe){return{text:Xe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ue[0];var fe=ge.align.length,Ie,xe,Le,Ve;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(fe=ge.rows.length,Ie=0;Ie<fe;Ie++)ge.rows[Ie]=se(ge.rows[Ie],ge.header.length).map(function(Xe){return{text:Xe}});for(fe=ge.header.length,xe=0;xe<fe;xe++)ge.header[xe].tokens=[],this.lexer.inlineTokens(ge.header[xe].text,ge.header[xe].tokens);for(fe=ge.rows.length,xe=0;xe<fe;xe++)for(Ve=ge.rows[xe],Le=0;Le<Ve.length;Le++)Ve[Le].tokens=[],this.lexer.inlineTokens(Ve[Le].text,Ve[Le].tokens);return ge}}},ye.lheading=function(X){var ue=this.rules.block.lheading.exec(X);if(ue){var ge={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(X){var ue=this.rules.block.paragraph.exec(X);if(ue){var ge={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(X){var ue=this.rules.block.text.exec(X);if(ue){var ge={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(X){var ue=this.rules.inline.escape.exec(X);if(ue)return{type:"escape",raw:ue[0],text:G(ue[1])}},ye.tag=function(X){var ue=this.rules.inline.tag.exec(X);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):G(ue[0]):ue[0]}},ye.link=function(X){var ue=this.rules.inline.link.exec(X);if(ue){var ge=ue[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var fe=Q(ge.slice(0,-1),"\\");if((ge.length-fe.length)%2==0)return}else{var Ie=z(ue[2],"()");if(Ie>-1){var xe=ue[0].indexOf("!")===0?5:4,Le=xe+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Le).trim(),ue[3]=""}}var Ve=ue[2],Xe="";if(this.options.pedantic){var te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);te&&(Ve=te[1],Xe=te[3])}else Xe=ue[3]?ue[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(ge)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),x(ue,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(X,ue){var ge;if((ge=this.rules.inline.reflink.exec(X))||(ge=this.rules.inline.nolink.exec(X))){var fe=(ge[2]||ge[1]).replace(/\s+/g," ");if(fe=ue[fe.toLowerCase()],!fe||!fe.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return x(ge,fe,ge[0],this.lexer)}},ye.emStrong=function(X,ue,ge){ge===void 0&&(ge="");var fe=this.rules.inline.emStrong.lDelim.exec(X);if(!!fe&&!(fe[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var xe=fe[0].length-1,Le,Ve,Xe=xe,te=0,pe=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ue=ue.slice(-1*X.length+xe);(fe=pe.exec(ue))!=null;)if(Le=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Le){if(Ve=Le.length,fe[3]||fe[4]){Xe+=Ve;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+Ve)%3)){te+=Ve;continue}if(Xe-=Ve,!(Xe>0)){if(Ve=Math.min(Ve,Ve+Xe+te),Math.min(xe,Ve)%2){var ne=X.slice(1,xe+fe.index+Ve);return{type:"em",raw:X.slice(0,xe+fe.index+Ve+1),text:ne,tokens:this.lexer.inlineTokens(ne,[])}}var U=X.slice(2,xe+fe.index+Ve-1);return{type:"strong",raw:X.slice(0,xe+fe.index+Ve+1),text:U,tokens:this.lexer.inlineTokens(U,[])}}}}}},ye.codespan=function(X){var ue=this.rules.inline.code.exec(X);if(ue){var ge=ue[2].replace(/\n/g," "),fe=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return fe&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=G(ge,!0),{type:"codespan",raw:ue[0],text:ge}}},ye.br=function(X){var ue=this.rules.inline.br.exec(X);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(X){var ue=this.rules.inline.del.exec(X);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ye.autolink=function(X,ue){var ge=this.rules.inline.autolink.exec(X);if(ge){var fe,Ie;return ge[2]==="@"?(fe=G(this.options.mangle?ue(ge[1]):ge[1]),Ie="mailto:"+fe):(fe=G(ge[1]),Ie=fe),{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.url=function(X,ue){var ge;if(ge=this.rules.inline.url.exec(X)){var fe,Ie;if(ge[2]==="@")fe=G(this.options.mangle?ue(ge[0]):ge[0]),Ie="mailto:"+fe;else{var xe;do xe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(xe!==ge[0]);fe=G(ge[0]),ge[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.inlineText=function(X,ue){var ge=this.rules.inline.text.exec(X);if(ge){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):G(ge[0]):ge[0]:fe=G(this.options.smartypants?ue(ge[0]):ge[0]),{type:"text",raw:ge[0],text:fe}}},Pe}(),q=L.noopTest,ce=L.edit,V=L.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=ce(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=ce(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=ce(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=ce(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=ce(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=ce(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=V({},le),le.gfm=V({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=ce(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=V({},le.normal,{html:ce(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:q,paragraph:ce(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=ce(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=ce(le._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=ce(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=ce(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=ce(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=ce(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=ce(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=ce(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=ce(ae.reflink).replace("label",ae._label).getRegex(),ae.reflinkSearch=ce(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=V({},ae),ae.pedantic=V({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ce(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:ce(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=V({},ae.normal,{escape:ce(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=ce(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=V({},ae.gfm,{br:ce(ae.br).replace("{2,}","*").getRegex(),text:ce(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:ae},Ae=B,Re=A.exports.defaults,Oe=ve.block,Qe=ve.inline,He=L.repeatString;function je(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function N(Pe){var ye="",De,X,ue=Pe.length;for(De=0;De<ue;De++)X=Pe.charCodeAt(De),Math.random()>.5&&(X="x"+X.toString(16)),ye+="&#"+X+";";return ye}var K=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Re,this.options.tokenizer=this.options.tokenizer||new Ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:Oe.normal,inline:Qe.normal};this.options.pedantic?(X.block=Oe.pedantic,X.inline=Qe.pedantic):this.options.gfm&&(X.block=Oe.gfm,this.options.breaks?X.inline=Qe.breaks:X.inline=Qe.gfm),this.tokenizer.rules=X}Pe.lex=function(X,ue){var ge=new Pe(ue);return ge.lex(X)},Pe.lexInline=function(X,ue){var ge=new Pe(ue);return ge.inlineTokens(X)};var ye=Pe.prototype;return ye.lex=function(X){X=X.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(X,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(X,ue){var ge=this;ue===void 0&&(ue=[]),this.options.pedantic&&(X=X.replace(/^ +$/gm,""));for(var fe,Ie,xe,Le;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Xe){return(fe=Xe.call({lexer:ge},X,ue))?(X=X.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.space(X)){X=X.substring(fe.raw.length),fe.type&&ue.push(fe);continue}if(fe=this.tokenizer.code(X)){X=X.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(fe=this.tokenizer.fences(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.heading(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.hr(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.blockquote(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.list(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.html(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.def(X)){X=X.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.lheading(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(xe=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Xe=Infinity,te=X.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(ne){pe=ne.call({lexer:this},te),typeof pe=="number"&&pe>=0&&(Xe=Math.min(Xe,pe))}),Xe<Infinity&&Xe>=0&&(xe=X.substring(0,Xe+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Ie=ue[ue.length-1],Le&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe),Le=xe.length!==X.length,X=X.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(X)){X=X.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(X){var Ve="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return this.state.top=!0,ue},ye.inline=function(X,ue){this.inlineQueue.push({src:X,tokens:ue})},ye.inlineTokens=function(X,ue){var ge=this;ue===void 0&&(ue=[]);var fe,Ie,xe,Le=X,Ve,Xe,te;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)pe.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ve.index)+"["+He("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"["+He("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Xe||(te=""),Xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(U){return(fe=U.call({lexer:ge},X,ue))?(X=X.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.tag(X)){X=X.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.link(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.emStrong(X,Le,te)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.codespan(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.br(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.del(X)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.autolink(X,N)){X=X.substring(fe.raw.length),ue.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(X,N))){X=X.substring(fe.raw.length),ue.push(fe);continue}if(xe=X,this.options.extensions&&this.options.extensions.startInline&&function(){var U=Infinity,Ce=X.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(qe){Se=qe.call({lexer:this},Ce),typeof Se=="number"&&Se>=0&&(U=Math.min(U,Se))}),U<Infinity&&U>=0&&(xe=X.substring(0,U+1))}(),fe=this.tokenizer.inlineText(xe,je)){X=X.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(te=fe.raw.slice(-1)),Xe=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(X){var ne="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Qe}}}]),Pe}(),Z=A.exports.defaults,oe=L.cleanUrl,H=L.escape,re=function(){function Pe(De){this.options=De||Z}var ye=Pe.prototype;return ye.code=function(X,ue,ge){var fe=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(X,fe);Ie!=null&&Ie!==X&&(ge=!0,X=Ie)}return X=X.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+H(fe,!0)+'">'+(ge?X:H(X,!0))+`</code></pre>
`:"<pre><code>"+(ge?X:H(X,!0))+`</code></pre>
`},ye.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},ye.html=function(X){return X},ye.heading=function(X,ue,ge,fe){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+fe.slug(ge)+'">'+X+"</h"+ue+`>
`:"<h"+ue+">"+X+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(X,ue,ge){var fe=ue?"ol":"ul",Ie=ue&&ge!==1?' start="'+ge+'"':"";return"<"+fe+Ie+`>
`+X+"</"+fe+`>
`},ye.listitem=function(X){return"<li>"+X+`</li>
`},ye.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(X){return"<p>"+X+`</p>
`},ye.table=function(X,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+ue+`</table>
`},ye.tablerow=function(X){return`<tr>
`+X+`</tr>
`},ye.tablecell=function(X,ue){var ge=ue.header?"th":"td",fe=ue.align?"<"+ge+' align="'+ue.align+'">':"<"+ge+">";return fe+X+"</"+ge+`>
`},ye.strong=function(X){return"<strong>"+X+"</strong>"},ye.em=function(X){return"<em>"+X+"</em>"},ye.codespan=function(X){return"<code>"+X+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(X){return"<del>"+X+"</del>"},ye.link=function(X,ue,ge){if(X=oe(this.options.sanitize,this.options.baseUrl,X),X===null)return ge;var fe='<a href="'+H(X)+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=">"+ge+"</a>",fe},ye.image=function(X,ue,ge){if(X=oe(this.options.sanitize,this.options.baseUrl,X),X===null)return ge;var fe='<img src="'+X+'" alt="'+ge+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=this.options.xhtml?"/>":">",fe},ye.text=function(X){return X},Pe}(),he=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(X){return X},ye.em=function(X){return X},ye.codespan=function(X){return X},ye.del=function(X){return X},ye.html=function(X){return X},ye.text=function(X){return X},ye.link=function(X,ue,ge){return""+ge},ye.image=function(X,ue,ge){return""+ge},ye.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(X,ue){var ge=X,fe=0;if(this.seen.hasOwnProperty(ge)){fe=this.seen[X];do fe++,ge=X+"-"+fe;while(this.seen.hasOwnProperty(ge))}return ue||(this.seen[X]=fe,this.seen[ge]=0),ge},ye.slug=function(X,ue){ue===void 0&&(ue={});var ge=this.serialize(X);return this.getNextSafeSlug(ge,ue.dryrun)},Pe}(),Ue=re,$e=he,Ke=Te,_e=A.exports.defaults,rt=L.unescape,W=function(){function Pe(De){this.options=De||_e,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new Ke}Pe.parse=function(X,ue){var ge=new Pe(ue);return ge.parse(X)},Pe.parseInline=function(X,ue){var ge=new Pe(ue);return ge.parseInline(X)};var ye=Pe.prototype;return ye.parse=function(X,ue){ue===void 0&&(ue=!0);var ge="",fe,Ie,xe,Le,Ve,Xe,te,pe,ne,U,Ce,Se,qe,We,it,mt,wt,ot,ct,lt=X.length;for(fe=0;fe<lt;fe++){if(U=X[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(ct=this.options.extensions.renderers[U.type].call({parser:this},U),ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(U.type))){ge+=ct||"";continue}switch(U.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(U.tokens),U.depth,rt(this.parseInline(U.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(U.text,U.lang,U.escaped);continue}case"table":{for(pe="",te="",Le=U.header.length,Ie=0;Ie<Le;Ie++)te+=this.renderer.tablecell(this.parseInline(U.header[Ie].tokens),{header:!0,align:U.align[Ie]});for(pe+=this.renderer.tablerow(te),ne="",Le=U.rows.length,Ie=0;Ie<Le;Ie++){for(Xe=U.rows[Ie],te="",Ve=Xe.length,xe=0;xe<Ve;xe++)te+=this.renderer.tablecell(this.parseInline(Xe[xe].tokens),{header:!1,align:U.align[xe]});ne+=this.renderer.tablerow(te)}ge+=this.renderer.table(pe,ne);continue}case"blockquote":{ne=this.parse(U.tokens),ge+=this.renderer.blockquote(ne);continue}case"list":{for(Ce=U.ordered,Se=U.start,qe=U.loose,Le=U.items.length,ne="",Ie=0;Ie<Le;Ie++)it=U.items[Ie],mt=it.checked,wt=it.task,We="",it.task&&(ot=this.renderer.checkbox(mt),qe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=ot+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=ot+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:ot}):We+=ot),We+=this.parse(it.tokens,qe),ne+=this.renderer.listitem(We,wt,mt);ge+=this.renderer.list(ne,Ce,Se);continue}case"html":{ge+=this.renderer.html(U.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(U.tokens));continue}case"text":{for(ne=U.tokens?this.parseInline(U.tokens):U.text;fe+1<lt&&X[fe+1].type==="text";)U=X[++fe],ne+=`
`+(U.tokens?this.parseInline(U.tokens):U.text);ge+=ue?this.renderer.paragraph(ne):ne;continue}default:{var Tt='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(Tt);return}else throw new Error(Tt)}}}return ge},ye.parseInline=function(X,ue){ue=ue||this.renderer;var ge="",fe,Ie,xe,Le=X.length;for(fe=0;fe<Le;fe++){if(Ie=X[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(xe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=xe||"";continue}switch(Ie.type){case"escape":{ge+=ue.text(Ie.text);break}case"html":{ge+=ue.html(Ie.text);break}case"link":{ge+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{ge+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{ge+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{ge+=ue.codespan(Ie.text);break}case"br":{ge+=ue.br();break}case"del":{ge+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{ge+=ue.text(Ie.text);break}default:{var Ve='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return ge},Pe}(),Y=K,me=W,Ne=B,Ye=re,tt=he,at=Te,vt=L.merge,kt=L.checkSanitizeDeprecation,ht=L.escape,yt=A.exports.getDefaults,It=A.exports.changeDefaults,ft=A.exports.defaults;function Je(Pe,ye,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=vt({},Je.defaults,ye||{}),kt(ye),De){var X=ye.highlight,ue;try{ue=Y.lex(Pe,ye)}catch(xe){return De(xe)}var ge=function(Le){var Ve;if(!Le)try{ye.walkTokens&&Je.walkTokens(ue,ye.walkTokens),Ve=me.parse(ue,ye)}catch(Xe){Le=Xe}return ye.highlight=X,Le?De(Le):De(null,Ve)};if(!X||X.length<3||(delete ye.highlight,!ue.length))return ge();var fe=0;Je.walkTokens(ue,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){X(xe.text,xe.lang,function(Le,Ve){if(Le)return ge(Le);Ve!=null&&Ve!==xe.text&&(xe.text=Ve,xe.escaped=!0),fe--,fe===0&&ge()})},0))}),fe===0&&ge();return}try{var Ie=Y.lex(Pe,ye);return ye.walkTokens&&Je.walkTokens(Ie,ye.walkTokens),me.parse(Ie,ye)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(xe.message+"",!0)+"</pre>";throw xe}}Je.options=Je.setOptions=function(Pe){return vt(Je.defaults,Pe),It(Je.defaults),Je},Je.getDefaults=yt,Je.defaults=ft,Je.use=function(){for(var Pe=this,ye=arguments.length,De=new Array(ye),X=0;X<ye;X++)De[X]=arguments[X];var ue=vt.apply(void 0,[{}].concat(De)),ge=Je.defaults.extensions||{renderers:{},childTokens:{}},fe;De.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ve=ge.renderers?ge.renderers[Le.name]:null;Ve?ge.renderers[Le.name]=function(){for(var Xe=arguments.length,te=new Array(Xe),pe=0;pe<Xe;pe++)te[pe]=arguments[pe];var ne=Le.renderer.apply(this,te);return ne===!1&&(ne=Ve.apply(this,te)),ne}:ge.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Le.level]?ge[Le.level].unshift(Le.tokenizer):ge[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ge.startBlock?ge.startBlock.push(Le.start):ge.startBlock=[Le.start]:Le.level==="inline"&&(ge.startInline?ge.startInline.push(Le.start):ge.startInline=[Le.start]))}Le.childTokens&&(ge.childTokens[Le.name]=Le.childTokens)})),Ie.renderer&&function(){var Le=Je.defaults.renderer||new Ye,Ve=function(pe){var ne=Le[pe];Le[pe]=function(){for(var U=arguments.length,Ce=new Array(U),Se=0;Se<U;Se++)Ce[Se]=arguments[Se];var qe=Ie.renderer[pe].apply(Le,Ce);return qe===!1&&(qe=ne.apply(Le,Ce)),qe}};for(var Xe in Ie.renderer)Ve(Xe);ue.renderer=Le}(),Ie.tokenizer&&function(){var Le=Je.defaults.tokenizer||new Ne,Ve=function(pe){var ne=Le[pe];Le[pe]=function(){for(var U=arguments.length,Ce=new Array(U),Se=0;Se<U;Se++)Ce[Se]=arguments[Se];var qe=Ie.tokenizer[pe].apply(Le,Ce);return qe===!1&&(qe=ne.apply(Le,Ce)),qe}};for(var Xe in Ie.tokenizer)Ve(Xe);ue.tokenizer=Le}(),Ie.walkTokens){var xe=Je.defaults.walkTokens;ue.walkTokens=function(Le){Ie.walkTokens.call(Pe,Le),xe&&xe(Le)}}fe&&(ue.extensions=ge),Je.setOptions(ue)})},Je.walkTokens=function(Pe,ye){for(var De=function(){var fe=ue.value;switch(ye(fe),fe.type){case"table":{for(var Ie=E(fe.header),xe;!(xe=Ie()).done;){var Le=xe.value;Je.walkTokens(Le.tokens,ye)}for(var Ve=E(fe.rows),Xe;!(Xe=Ve()).done;)for(var te=Xe.value,pe=E(te),ne;!(ne=pe()).done;){var U=ne.value;Je.walkTokens(U.tokens,ye)}break}case"list":{Je.walkTokens(fe.items,ye);break}default:Je.defaults.extensions&&Je.defaults.extensions.childTokens&&Je.defaults.extensions.childTokens[fe.type]?Je.defaults.extensions.childTokens[fe.type].forEach(function(Ce){Je.walkTokens(fe[Ce],ye)}):fe.tokens&&Je.walkTokens(fe.tokens,ye)}},X=E(Pe),ue;!(ue=X()).done;)De()},Je.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=vt({},Je.defaults,ye||{}),kt(ye);try{var De=Y.lexInline(Pe,ye);return ye.walkTokens&&Je.walkTokens(De,ye.walkTokens),me.parseInline(De,ye)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(X.message+"",!0)+"</pre>";throw X}},Je.Parser=me,Je.parser=me.parse,Je.Renderer=Ye,Je.TextRenderer=tt,Je.Lexer=Y,Je.lexer=Y.lex,Je.Tokenizer=Ne,Je.Slugger=at,Je.parse=Je;var Et=Je;return Et}),define(we[76],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(R,k,y){return Math.min(Math.max(R,k),y)}e.clamp=d;function F(R,k){return(k+R%k)%k}e.rot=F;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function ie(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function R(y){A.push(y,Date.now())}function k(){const y=[];for(let T=0;T<A.length;T+=2)y.push({name:A[T],startTime:A[T+1]});return y}return{mark:R,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(E+R.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function d(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=d(F))}(),define(we[34],be([0,1,3]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(_){const r=this._icons.get(_.id);r?_.description?r.description=_.description:console.error(`Duplicate registration of codicon ${_.id}`):(this._icons.set(_.id,_),this._onDidRegister.fire(_))}get(_){return this._icons.get(_)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new F;e.iconRegistry=E;function A(t,_){return new k(t,_)}e.registerCodicon=A;function R(t){return t?t.replace(/\$\((.*?)\)/g,(_,r)=>` ${r} `).trim():""}e.getCodiconAriaLabel=R;class k{constructor(_,r,h){this.id=_,this.definition=r,this.description=h,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function y(t,_){const r=["codicon","codicon-"+t];return _&&r.push("codicon-modifier-"+_),r}e.getClassNamesArray=y;var T;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const _=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function r(l){if(l instanceof k)return["codicon","codicon-"+l.id];const g=_.exec(l.id);if(!g)return r(k.error);let[,I,b]=g;const c=["codicon","codicon-"+I];return b&&c.push("codicon-modifier-"+b.substr(1)),c}t.asClassNameArray=r;function h(l){return r(l).join(" ")}t.asClassName=h;function a(l){return"."+r(l).join(".")}t.asCSSSelector=a})(T=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(we[104],be([0,1,15,7]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(c){const p=c;return p?[p.on,p.pause,p.resume,p.destroy].every(S=>typeof S=="function"):!1}e.isReadableStream=E;function A(c){const p=c;return p?E(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=A;function R(c,p){return new k(c,p)}e.newWriteableStream=R;class k{constructor(p,S){this.reducer=p,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(S=>S(p))}emitError(p){this.listeners.error.length===0?(0,d.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(S=>S(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,S){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(p,S){if(this.state.destroyed)return;let i;switch(p){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(S);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(c,p){const S=[];let i;for(;(i=c.read())!==null;)S.push(i);return p(S)}e.consumeReadable=y;function T(c,p,S){const i=[];let s;for(;(s=c.read())!==null&&i.length<S;)i.push(s);return s===null&&i.length>0?p(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s!="undefined"){const u=s;return s=void 0,u}return c.read()}}}e.peekReadable=T;function t(c,p){return new Promise((S,i)=>{const s=[];_(c,{onData:u=>{p&&s.push(u)},onError:u=>{p?i(u):S(void 0)},onEnd:()=>{S(p?p(s):void 0)}})})}e.consumeStream=t;function _(c,p){c.on("error",S=>p.onError(S)),c.on("end",()=>p.onEnd()),c.on("data",S=>p.onData(S))}e.listenStream=_;function r(c,p){return new Promise((S,i)=>{const s=new F.DisposableStore,u=[],o=w=>{if(u.push(w),u.length>p)return s.dispose(),c.pause(),S({stream:c,buffer:u,ended:!1})},f=w=>i(w),v=()=>S({stream:c,buffer:u,ended:!0});s.add((0,F.toDisposable)(()=>c.removeListener("error",f))),c.on("error",f),s.add((0,F.toDisposable)(()=>c.removeListener("end",v))),c.on("end",v),s.add((0,F.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}e.peekStream=r;function h(c,p){const S=R(p);return S.end(c),S}e.toStream=h;function a(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=a;function l(c){let p=!1;return{read:()=>p?null:(p=!0,c)}}e.toReadable=l;function g(c,p,S){const i=R(S);return _(c,{onData:s=>i.write(p.data(s)),onError:s=>i.error(p.error?p.error(s):s),onEnd:()=>i.end()}),i}e.transform=g;function I(c,p,S){let i=!1;return{read:()=>{const s=p.read();return i?s:(i=!0,s!==null?S([c,s]):c)}}}e.prefixedReadable=I;function b(c,p,S){let i=!1;const s=R(S);return _(p,{onData:u=>i?s.write(u):(i=!0,s.write(S([c,u]))),onError:u=>s.error(u),onEnd:()=>{i||(i=!0,s.write(c)),s.end()}}),s}e.prefixedStream=b}),define(we[23],be([0,1,104]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let E,A;class R{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return F?new R(Buffer.allocUnsafe(o)):new R(new Uint8Array(o))}static wrap(o){return F&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new R(o)}static fromString(o,f){return!(f?.dontUseNodeBuffer||!1)&&F?new R(Buffer.from(o)):(E||(E=new TextEncoder),new R(E.encode(o)))}static concat(o,f){if(typeof f=="undefined"){f=0;for(let D=0,P=o.length;D<P;D++)f+=o[D].byteLength}const v=R.alloc(f);let w=0;for(let D=0,P=o.length;D<P;D++){const n=o[D];v.set(n,w),w+=n.byteLength}return v}toString(){return F?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(o,f){return new R(this.buffer.subarray(o,f))}set(o,f){o instanceof R?this.buffer.set(o.buffer,f):this.buffer.set(o,f)}readUInt32BE(o){return T(this.buffer,o)}writeUInt32BE(o,f){t(this.buffer,o,f)}readUInt32LE(o){return _(this.buffer,o)}writeUInt32LE(o,f){r(this.buffer,o,f)}readUInt8(o){return h(this.buffer,o)}writeUInt8(o,f){a(this.buffer,o,f)}}e.VSBuffer=R;function k(u,o){return u[o+0]<<0>>>0|u[o+1]<<8>>>0}e.readUInt16LE=k;function y(u,o,f){u[f+0]=o&255,o=o>>>8,u[f+1]=o&255}e.writeUInt16LE=y;function T(u,o){return u[o]*2**24+u[o+1]*2**16+u[o+2]*2**8+u[o+3]}e.readUInt32BE=T;function t(u,o,f){u[f+3]=o,o=o>>>8,u[f+2]=o,o=o>>>8,u[f+1]=o,o=o>>>8,u[f]=o}e.writeUInt32BE=t;function _(u,o){return u[o+0]<<0>>>0|u[o+1]<<8>>>0|u[o+2]<<16>>>0|u[o+3]<<24>>>0}e.readUInt32LE=_;function r(u,o,f){u[f+0]=o&255,o=o>>>8,u[f+1]=o&255,o=o>>>8,u[f+2]=o&255,o=o>>>8,u[f+3]=o&255}e.writeUInt32LE=r;function h(u,o){return u[o]}e.readUInt8=h;function a(u,o,f){u[f]=o}e.writeUInt8=a;function l(u){return d.consumeReadable(u,o=>R.concat(o))}e.readableToBuffer=l;function g(u){return d.toReadable(u)}e.bufferToReadable=g;function I(u){return d.consumeStream(u,o=>R.concat(o))}e.streamToBuffer=I;async function b(u){return u.ended?R.concat(u.buffer):R.concat([...u.buffer,await I(u.stream)])}e.bufferedStreamToBuffer=b;function c(u){return d.toStream(u,o=>R.concat(o))}e.bufferToStream=c;function p(u){return d.transform(u,{data:o=>typeof o=="string"?R.fromString(o):R.wrap(o)},o=>R.concat(o))}e.streamToBufferReadableStream=p;function S(u){return d.newWriteableStream(o=>R.concat(o),u)}e.newWriteableBufferStream=S;function i(u,o){return d.prefixedReadable(u,o,f=>R.concat(f))}e.prefixedBufferReadable=i;function s(u,o){return d.prefixedStream(u,o,f=>R.concat(f))}e.prefixedBufferStream=s}),define(we[35],be([0,1,9]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(F||(F={})),function(E){const A="error",R="warning",k="warn",y="info",T="ignore";function t(r){return r?d.equalsIgnoreCase(A,r)?E.Error:d.equalsIgnoreCase(R,r)||d.equalsIgnoreCase(k,r)?E.Warning:d.equalsIgnoreCase(y,r)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function _(r){switch(r){case E.Error:return A;case E.Warning:return R;case E.Info:return y;default:return T}}E.toString=_}(F||(F={})),e.default=F}),define(we[40],be([0,1,17,25,9,10]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(u){return u===47||u===92}e.isPathSeparator=R;function k(u){return u.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=k;function y(u){return u.indexOf("/")===-1&&(u=k(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=y;function T(u,o=d.posix.sep){if(!u)return"";const f=u.length,v=u.charCodeAt(0);if(R(v)){if(R(u.charCodeAt(1))&&!R(u.charCodeAt(2))){let D=3;const P=D;for(;D<f&&!R(u.charCodeAt(D));D++);if(P!==D&&!R(u.charCodeAt(D+1))){for(D+=1;D<f;D++)if(R(u.charCodeAt(D)))return u.slice(0,D+1).replace(/[\\/]/g,o)}}return o}else if(I(v)&&u.charCodeAt(1)===58)return R(u.charCodeAt(2))?u.slice(0,2)+o:u.slice(0,2);let w=u.indexOf("://");if(w!==-1){for(w+=3;w<f;w++)if(R(u.charCodeAt(w)))return u.slice(0,w+1)}return""}e.getRoot=T;function t(u){if(!F.isWindows||!u||u.length<5)return!1;let o=u.charCodeAt(0);if(o!==92||(o=u.charCodeAt(1),o!==92))return!1;let f=2;const v=f;for(;f<u.length&&(o=u.charCodeAt(f),o!==92);f++);return!(v===f||(o=u.charCodeAt(f+1),isNaN(o)||o===92))}e.isUNC=t;const _=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(u,o=F.isWindows){const f=o?_:r;return!(!u||u.length===0||/^\s+$/.test(u)||(f.lastIndex=0,f.test(u))||o&&h.test(u)||u==="."||u===".."||o&&u[u.length-1]==="."||o&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=a;function l(u,o,f){const v=u===o;return!f||v?v:!u||!o?!1:(0,E.equalsIgnoreCase)(u,o)}e.isEqual=l;function g(u,o,f,v=d.sep){if(u===o)return!0;if(!u||!o||o.length>u.length)return!1;if(f){if(!(0,E.startsWithIgnoreCase)(u,o))return!1;if(o.length===u.length)return!0;let D=o.length;return o.charAt(o.length-1)===v&&D--,u.charAt(D)===v}return o.charAt(o.length-1)!==v&&(o+=v),u.indexOf(o)===0}e.isEqualOrParent=g;function I(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=I;function b(u,o){return F.isWindows&&u.endsWith(":")&&(u+=d.sep),(0,d.isAbsolute)(u)||(u=(0,d.join)(o,u)),u=(0,d.normalize)(u),F.isWindows?(u=(0,E.rtrim)(u,d.sep),u.endsWith(":")&&(u+=d.sep)):(u=(0,E.rtrim)(u,d.sep),u||(u=d.sep)),u}e.sanitizeFilePath=b;function c(u){const o=(0,d.normalize)(u);return F.isWindows?u.length>3?!1:p(o)&&(u.length===2||o.charCodeAt(2)===92):o===d.posix.sep}e.isRootOrDriveLetter=c;function p(u){return F.isWindows?I(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function S(u){return p(u)?u[0]:void 0}e.getDriveLetter=S;function i(u,o,f){return o.length>u.length?-1:u===o?0:(f&&(u=u.toLowerCase(),o=o.toLowerCase()),u.indexOf(o))}e.indexOfPath=i;function s(u){const o=u.split(":");let f,v,w;if(o.forEach(D=>{const P=Number(D);(0,A.isNumber)(P)?v===void 0?v=P:w===void 0&&(w=P):f=f?[f,D].join(":"):D}),!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:v!==void 0?v:void 0,column:w!==void 0?w:v!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(we[22],be([0,1,10]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const g=Array.isArray(l)?[]:{};return Object.keys(l).forEach(I=>{l[I]&&typeof l[I]=="object"?g[I]=F(l[I]):g[I]=l[I]}),g}e.deepClone=F;function E(l){if(!l||typeof l!="object")return l;const g=[l];for(;g.length>0;){const I=g.shift();Object.freeze(I);for(const b in I)if(A.call(I,b)){const c=I[b];typeof c=="object"&&!Object.isFrozen(c)&&g.push(c)}}return l}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function R(l,g){return k(l,g,new Set)}e.cloneAndChange=R;function k(l,g,I){if((0,d.isUndefinedOrNull)(l))return l;const b=g(l);if(typeof b!="undefined")return b;if((0,d.isArray)(l)){const c=[];for(const p of l)c.push(k(p,g,I));return c}if((0,d.isObject)(l)){if(I.has(l))throw new Error("Cannot clone recursive data-structure");I.add(l);const c={};for(let p in l)A.call(l,p)&&(c[p]=k(l[p],g,I));return I.delete(l),c}return l}function y(l,g,I=!0){return(0,d.isObject)(l)?((0,d.isObject)(g)&&Object.keys(g).forEach(b=>{b in l?I&&((0,d.isObject)(l[b])&&(0,d.isObject)(g[b])?y(l[b],g[b],I):l[b]=g[b]):l[b]=g[b]}),l):g}e.mixin=y;function T(l,g){if(l===g)return!0;if(l==null||g===null||g===void 0||typeof l!=typeof g||typeof l!="object"||Array.isArray(l)!==Array.isArray(g))return!1;let I,b;if(Array.isArray(l)){if(l.length!==g.length)return!1;for(I=0;I<l.length;I++)if(!T(l[I],g[I]))return!1}else{const c=[];for(b in l)c.push(b);c.sort();const p=[];for(b in g)p.push(b);if(p.sort(),!T(c,p))return!1;for(I=0;I<c.length;I++)if(!T(l[c[I]],g[c[I]]))return!1}return!0}e.equals=T;function t(l){const g=new Set;return JSON.stringify(l,(I,b)=>{if((0,d.isObject)(b)||Array.isArray(b)){if(g.has(b))return"[Circular]";g.add(b)}return b})}e.safeStringify=t;function _(l,g,I){const b=g(l);return typeof b=="undefined"?I:b}e.getOrDefault=_;function r(l,g){const I=Object.create(null);return!l||!g||Object.keys(g).forEach(c=>{const p=l[c],S=g[c];T(p,S)||(I[c]=S)}),I}e.distinct=r;function h(l,g){const I=g.toLowerCase(),b=Object.keys(l).find(c=>c.toLowerCase()===I);return b?l[b]:l[g]}e.getCaseInsensitive=h;function a(l,g){const I=Object.create(null);for(const b of Object.keys(l))g(b,l[b])&&(I[b]=l[b]);return I}e.filter=a});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[20],be([0,1,9,2]),function(ie,e,d,F){"use strict";var E,A,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(i,s,u){let o=i.get(s);return o===void 0&&(o=u,i.set(s,o)),o}e.getOrSet=k;function y(i){const s=[];return i.forEach((u,o)=>{s.push(`${o} => ${u}`)}),`Map(${i.size}) {${s.join(", ")}}`}e.mapToString=y;function T(i){const s=[];return i.forEach(u=>{s.push(u)}),`Set(${i.size}) {${s.join(", ")}}`}e.setToString=T;class t{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const u=s.charCodeAt(0),o=this._value.charCodeAt(this._pos);return u-o}value(){return this._value[this._pos]}}e.StringIterator=t;class _{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,d.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,d.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class r{constructor(s=!0,u=!0){this._splitOnBackslash=s,this._caseSensitive=u}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,d.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,d.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=r;var h;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(h||(h={}));class a{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new r(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,d.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,d.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,d.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,d.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class l{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class g{constructor(s){this._iter=s}static forUris(s=()=>!1){return new g(new a(s))}static forPaths(){return new g(new r)}static forStrings(){return new g(new t)}static forConfigKeys(){return new g(new _)}clear(){this._root=void 0}set(s,u){const o=this._iter.reset(s);let f;for(this._root||(this._root=new l,this._root.segment=o.value()),f=this._root;;){const w=o.cmp(f.segment);if(w>0)f.left||(f.left=new l,f.left.segment=o.value()),f=f.left;else if(w<0)f.right||(f.right=new l,f.right.segment=o.value()),f=f.right;else if(o.hasNext())o.next(),f.mid||(f.mid=new l,f.mid.segment=o.value()),f=f.mid;else break}const v=f.value;return f.value=u,f.key=s,v}get(s){return this._getNode(s)?.value}_getNode(s){const u=this._iter.reset(s);let o=this._root;for(;o;){const f=u.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else break}return o}has(s){const u=this._getNode(s);return!(u?.value===void 0&&u?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,u){const o=this._iter.reset(s),f=[];let v=this._root;for(;v;){const w=o.cmp(v.segment);if(w>0)f.push([1,v]),v=v.left;else if(w<0)f.push([-1,v]),v=v.right;else if(o.hasNext())o.next(),f.push([0,v]),v=v.mid;else{for(u?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;f.length>0&&v.isEmpty();){let[D,P]=f.pop();switch(D){case 1:P.left=void 0;break;case 0:P.mid=void 0;break;case-1:P.right=void 0;break}v=P}break}}}findSubstr(s){const u=this._iter.reset(s);let o=this._root,f;for(;o;){const v=u.cmp(o.segment);if(v>0)o=o.left;else if(v<0)o=o.right;else if(u.hasNext())u.next(),f=o.value||f,o=o.mid;else break}return o&&o.value||f}findSuperstr(s){const u=this._iter.reset(s);let o=this._root;for(;o;){const f=u.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(s){for(const[u,o]of this)s(o,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const u=[s];for(;u.length>0;){const o=u.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&u.push(o.left),o.mid&&u.push(o.mid),o.right&&u.push(o.right))}}}e.TernarySearchTree=g;class I{constructor(s,u){this[E]="ResourceMap",s instanceof I?(this.map=new Map(s.map),this.toKey=u??I.defaultToKey):(this.map=new Map,this.toKey=s??I.defaultToKey)}set(s,u){return this.map.set(this.toKey(s),u),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,u){typeof u!="undefined"&&(s=s.bind(u));for(let[o,f]of this.map)s(f,F.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield F.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[F.URI.parse(s[0]),s[1]]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[F.URI.parse(s[0]),s[1]]}}e.ResourceMap=I,I.defaultToKey=i=>i.toString();var b;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class c{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,u=0){const o=this._map.get(s);if(!!o)return u!==0&&this.touch(o,u),o.value}set(s,u,o=0){let f=this._map.get(s);if(f)f.value=u,o!==0&&this.touch(f,o);else{switch(f={key:s,value:u,next:void 0,previous:void 0},o){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(s,f),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const u=this._map.get(s);if(!!u)return this._map.delete(s),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,u){const o=this._state;let f=this._head;for(;f;){if(u?s.bind(u)(f.value,f.key,this):s(f.value,f.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const s=this,u=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const v={value:o.key,done:!1};return o=o.next,v}else return{value:void 0,done:!0}}};return f}values(){const s=this,u=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const v={value:o.value,done:!1};return o=o.next,v}else return{value:void 0,done:!0}}};return f}entries(){const s=this,u=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const v={value:[o.key,o.value],done:!1};return o=o.next,v}else return{value:void 0,done:!0}}};return f}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let u=this._head,o=this.size;for(;u&&o>s;)this._map.delete(u.key),u=u.next,o--;this._head=u,this._size=o,u&&(u.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const u=s.next,o=s.previous;if(!u||!o)throw new Error("Invalid list");u.previous=o,o.next=u}s.next=void 0,s.previous=void 0,this._state++}touch(s,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(s===this._head)return;const o=s.next,f=s.previous;s===this._tail?(f.next=void 0,this._tail=f):(o.previous=f,f.next=o),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(u===2){if(s===this._tail)return;const o=s.next,f=s.previous;s===this._head?(o.previous=void 0,this._head=o):(o.previous=f,f.next=o),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((u,o)=>{s.push([o,u])}),s}fromJSON(s){this.clear();for(const[u,o]of s)this.set(u,o)}}e.LinkedMap=c;class p extends c{constructor(s,u=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,u=2){return super.get(s,u)}peek(s){return super.get(s,0)}set(s,u){return super.set(s,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class S{constructor(s){R.set(this,void 0),et(this,R,s,"f")}get size(){return Me(this,R,"f").size}forEach(s,u){Me(this,R,"f").forEach(s,u)}get(s){return Me(this,R,"f").get(s)}has(s){return Me(this,R,"f").has(s)}entries(){return Me(this,R,"f").entries()}keys(){return Me(this,R,"f").keys()}values(){return Me(this,R,"f").values()}[(R=new WeakMap,Symbol.iterator)](){return Me(this,R,"f").entries()}}e.ReadonlyMapView=S}),define(we[105],be([0,1,20,9]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...H){return function(re,he){for(let Te=0,Ue=H.length;Te<Ue;Te++){const $e=H[Te](re,he);if($e)return $e}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(H,re,he){if(!he||he.length<re.length)return null;let Te;return H?Te=F.startsWithIgnoreCase(he,re):Te=he.indexOf(re)===0,Te?re.length>0?[{start:0,end:re.length}]:[]:null}function R(H,re){const he=re.toLowerCase().indexOf(H.toLowerCase());return he===-1?null:[{start:he,end:he+H.length}]}e.matchesContiguousSubString=R;function k(H,re){return y(H.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=k;function y(H,re,he,Te){if(he===H.length)return[];if(Te===re.length)return null;if(H[he]===re[Te]){let Ue=null;return(Ue=y(H,re,he+1,Te+1))?I({start:Te,end:Te+1},Ue):null}return y(H,re,he,Te+1)}function T(H){return 97<=H&&H<=122}function t(H){return 65<=H&&H<=90}e.isUpper=t;function _(H){return 48<=H&&H<=57}function r(H){return H===32||H===9||H===10||H===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(H=>h.add(H.charCodeAt(0)));function a(H){return r(H)||h.has(H)}function l(H,re){return H===re||a(H)&&a(re)}function g(H){return T(H)||t(H)||_(H)}function I(H,re){return re.length===0?re=[H]:H.end===re[0].start?re[0].start=H.start:re.unshift(H),re}function b(H,re){for(let he=re;he<H.length;he++){const Te=H.charCodeAt(he);if(t(Te)||_(Te)||he>0&&!g(H.charCodeAt(he-1)))return he}return H.length}function c(H,re,he,Te){if(he===H.length)return[];if(Te===re.length)return null;if(H[he]!==re[Te].toLowerCase())return null;{let Ue=null,$e=Te+1;for(Ue=c(H,re,he+1,Te+1);!Ue&&($e=b(re,$e))<re.length;)Ue=c(H,re,he+1,$e),$e++;return Ue===null?null:I({start:Te,end:Te+1},Ue)}}function p(H){let re=0,he=0,Te=0,Ue=0,$e=0;for(let Y=0;Y<H.length;Y++)$e=H.charCodeAt(Y),t($e)&&re++,T($e)&&he++,g($e)&&Te++,_($e)&&Ue++;const Ke=re/H.length,_e=he/H.length,rt=Te/H.length,W=Ue/H.length;return{upperPercent:Ke,lowerPercent:_e,alphaPercent:rt,numericPercent:W}}function S(H){const{upperPercent:re,lowerPercent:he}=H;return he===0&&re>.6}function i(H){const{upperPercent:re,lowerPercent:he,alphaPercent:Te,numericPercent:Ue}=H;return he>.2&&re<.8&&Te>.6&&Ue<.2}function s(H){let re=0,he=0,Te=0,Ue=0;for(let $e=0;$e<H.length;$e++)Te=H.charCodeAt($e),t(Te)&&re++,T(Te)&&he++,r(Te)&&Ue++;return(re===0||he===0)&&Ue===0?H.length<=30:re<=5}function u(H,re){if(!re||(re=re.trim(),re.length===0)||!s(H)||re.length>60)return null;const he=p(re);if(!i(he)){if(!S(he))return null;re=re.toLowerCase()}let Te=null,Ue=0;for(H=H.toLowerCase();Ue<re.length&&(Te=c(H,re,0,Ue))===null;)Ue=b(re,Ue+1);return Te}e.matchesCamelCase=u;function o(H,re,he=!1){if(!re||re.length===0)return null;let Te=null,Ue=0;for(H=H.toLowerCase(),re=re.toLowerCase();Ue<re.length&&(Te=f(H,re,0,Ue,he))===null;)Ue=v(re,Ue+1);return Te}e.matchesWords=o;function f(H,re,he,Te,Ue){if(he===H.length)return[];if(Te===re.length)return null;if(l(H.charCodeAt(he),re.charCodeAt(Te))){let $e=null,Ke=Te+1;if($e=f(H,re,he+1,Te+1,Ue),!Ue)for(;!$e&&(Ke=v(re,Ke))<re.length;)$e=f(H,re,he+1,Ke,Ue),Ke++;return $e===null?null:I({start:Te,end:Te+1},$e)}else return null}function v(H,re){for(let he=re;he<H.length;he++)if(a(H.charCodeAt(he))||he>0&&a(H.charCodeAt(he-1)))return he;return H.length}const w=E(e.matchesPrefix,u,R),D=E(e.matchesPrefix,u,k),P=new d.LRUCache(1e4);function n(H,re,he=!1){if(typeof H!="string"||typeof re!="string")return null;let Te=P.get(H);Te||(Te=new RegExp(F.convertSimple2RegExpPattern(H),"i"),P.set(H,Te));const Ue=Te.exec(re);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?D(H,re):w(H,re)}e.matchesFuzzy=n;function m(H,re){const he=Qe(H,H.toLowerCase(),0,re,re.toLowerCase(),0,!0);return he?L(he):null}e.matchesFuzzy2=m;function C(H,re,he,Te,Ue,$e){const Ke=Math.min(13,H.length);for(;he<Ke;he++){const _e=Qe(H,re,he,Te,Ue,$e,!1);if(_e)return _e}return[0,$e]}e.anyScore=C;function L(H){if(typeof H=="undefined")return[];const re=[],he=H[1];for(let Te=H.length-1;Te>1;Te--){const Ue=H[Te]+he,$e=re[re.length-1];$e&&$e.end===Ue?$e.end=Ue+1:re.push({start:Ue,end:Ue+1})}return re}e.createMatches=L;const $=128;function Q(){const H=[],re=[];for(let he=0;he<=$;he++)re[he]=0;for(let he=0;he<=$;he++)H.push(re.slice(0));return H}function se(H){const re=[];for(let he=0;he<=H;he++)re[he]=0;return re}const G=se(2*$),z=se(2*$),x=Q(),j=Q(),B=Q(),q=!1;function ce(H,re,he,Te,Ue){function $e(_e,rt,W=" "){for(;_e.length<rt;)_e=W+_e;return _e}let Ke=` |   |${Te.split("").map(_e=>$e(_e,3)).join("|")}
`;for(let _e=0;_e<=he;_e++)_e===0?Ke+=" |":Ke+=`${re[_e-1]}|`,Ke+=H[_e].slice(0,Ue+1).map(rt=>$e(rt.toString(),3)).join("|")+`
`;return Ke}function V(H,re,he,Te){H=H.substr(re),he=he.substr(Te),console.log(ce(j,H,H.length,he,he.length)),console.log(ce(B,H,H.length,he,he.length)),console.log(ce(x,H,H.length,he,he.length))}function le(H,re){if(re<0||re>=H.length)return!1;const he=H.codePointAt(re);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(he)}}function ae(H,re){if(re<0||re>=H.length)return!1;switch(H.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function ve(H,re,he){return re[H]!==he[H]}function Ae(H,re,he,Te,Ue,$e,Ke=!1){for(;re<he&&Ue<$e;)H[re]===Te[Ue]&&(Ke&&(G[re]=Ue),re+=1),Ue+=1;return re===he}e.isPatternInWord=Ae;var Re;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var Oe;(function(H){H.Default=[-100,0];function re(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}H.isDefault=re})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Qe(H,re,he,Te,Ue,$e,Ke){const _e=H.length>$?$:H.length,rt=Te.length>$?$:Te.length;if(he>=_e||$e>=rt||_e-he>rt-$e||!Ae(re,he,_e,Ue,$e,rt,!0))return;He(_e,rt,he,$e,re,Ue);let W=1,Y=1,me=he,Ne=$e;const Ye=[!1];for(W=1,me=he;me<_e;W++,me++){const ht=G[me],yt=z[me],It=me+1<_e?z[me+1]:rt;for(Y=ht-$e+1,Ne=ht;Ne<It;Y++,Ne++){let ft=Number.MIN_SAFE_INTEGER,Je=!1;Ne<=yt&&(ft=je(H,re,me,he,Te,Ue,Ne,rt,$e,x[W-1][Y-1]===0,Ye));let Et=0;ft!==Number.MAX_SAFE_INTEGER&&(Je=!0,Et=ft+j[W-1][Y-1]);const Pe=Ne>ht,ye=Pe?j[W][Y-1]+(x[W][Y-1]>0?-5:0):0,De=Ne>ht+1&&x[W][Y-1]>0,X=De?j[W][Y-2]+(x[W][Y-2]>0?-5:0):0;if(De&&(!Pe||X>=ye)&&(!Je||X>=Et))j[W][Y]=X,B[W][Y]=3,x[W][Y]=0;else if(Pe&&(!Je||ye>=Et))j[W][Y]=ye,B[W][Y]=2,x[W][Y]=0;else if(Je)j[W][Y]=Et,B[W][Y]=1,x[W][Y]=x[W-1][Y-1]+1;else throw new Error("not possible")}}if(q&&V(H,he,Te,$e),!Ye[0]&&!Ke)return;W--,Y--;const tt=[j[W][Y],$e];let at=0,vt=0;for(;W>=1;){let ht=Y;do{const yt=B[W][ht];if(yt===3)ht=ht-2;else if(yt===2)ht=ht-1;else break}while(ht>=1);at>1&&re[he+W-1]===Ue[$e+Y-1]&&!ve(ht+$e-1,Te,Ue)&&at+1>x[W][ht]&&(ht=Y),ht===Y?at++:at=1,vt||(vt=ht),W--,Y=ht-1,tt.push(Y)}rt===_e&&(tt[0]+=2);const kt=vt-_e;return tt[0]-=kt,tt}e.fuzzyScore=Qe;function He(H,re,he,Te,Ue,$e){let Ke=H-1,_e=re-1;for(;Ke>=he&&_e>=Te;)Ue[Ke]===$e[_e]&&(z[Ke]=_e,Ke--),_e--}function je(H,re,he,Te,Ue,$e,Ke,_e,rt,W,Y){if(re[he]!==$e[Ke])return Number.MIN_SAFE_INTEGER;let me=1,Ne=!1;return Ke===he-Te?me=H[he]===Ue[Ke]?7:5:ve(Ke,Ue,$e)&&(Ke===0||!ve(Ke-1,Ue,$e))?(me=H[he]===Ue[Ke]?7:5,Ne=!0):le($e,Ke)&&(Ke===0||!le($e,Ke-1))?me=5:(le($e,Ke-1)||ae($e,Ke-1))&&(me=5,Ne=!0),me>1&&he===Te&&(Y[0]=!0),Ne||(Ne=ve(Ke,Ue,$e)||le($e,Ke-1)||ae($e,Ke-1)),he===Te?Ke>rt&&(me-=Ne?3:5):W?me+=Ne?2:0:me+=Ne?0:1,Ke+1===_e&&(me-=Ne?3:5),me}function N(H,re,he,Te,Ue,$e,Ke){return Z(H,re,he,Te,Ue,$e,!0,Ke)}e.fuzzyScoreGracefulAggressive=N;function K(H,re,he,Te,Ue,$e,Ke){return Z(H,re,he,Te,Ue,$e,!1,Ke)}e.fuzzyScoreGraceful=K;function Z(H,re,he,Te,Ue,$e,Ke,_e){let rt=Qe(H,re,he,Te,Ue,$e,_e);if(rt&&!Ke)return rt;if(H.length>=3){const W=Math.min(7,H.length-1);for(let Y=he+1;Y<W;Y++){const me=oe(H,Y);if(me){const Ne=Qe(me,me.toLowerCase(),he,Te,Ue,$e,_e);Ne&&(Ne[0]-=3,(!rt||Ne[0]>rt[0])&&(rt=Ne))}}}return rt}function oe(H,re){if(re+1>=H.length)return;const he=H[re],Te=H[re+1];if(he!==Te)return H.slice(0,re)+Te+he+H.slice(re+2)}}),define(we[106],be([0,1,34,105,9]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function k(l){return l.replace(R,(g,I)=>I?g:`\\${g}`)}e.escapeIcons=k;const y=new RegExp(`\\\\${A.source}`,"g");function T(l){return l.replace(y,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=T;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function _(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(t,(g,I,b,c)=>b?g:I||c||"")}e.stripIcons=_;function r(l){const g=l.indexOf(e.iconStartMarker);return g===-1?{text:l}:h(l,g)}e.parseLabelWithIcons=r;function h(l,g){const I=[];let b="";function c(v){if(v){b+=v;for(const w of v)I.push(i)}}let p=-1,S="",i=0,s,u,o=g;const f=l.length;for(c(l.substr(0,g));o<f;)s=l[o],u=l[o+1],s===e.iconStartMarker[0]&&u===e.iconStartMarker[1]?(p=o,c(S),S=e.iconStartMarker,o++):s===")"&&p!==-1?(i+=o-p+1,p=-1,S=""):p!==-1?/^[a-z0-9\-]$/i.test(s)?S+=s:(c(S),p=-1,S=""):c(s),o++;return c(S),{text:b,iconOffsets:I}}function a(l,g,I=!1){const{text:b,iconOffsets:c}=g;if(!c||c.length===0)return(0,F.matchesFuzzy)(l,b,I);const p=(0,E.ltrim)(b," "),S=b.length-p.length,i=(0,F.matchesFuzzy)(l,p,I);if(i)for(const s of i){const u=c[s.start+S]+S;s.start+=u,s.end+=u}return i}e.matchesFuzzyIconAware=a}),define(we[77],be([0,1,15,106]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(h="",a=!1){if(this.value=h,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1)}appendText(h,a=0){return this.value+=T(this.supportThemeIcons?(0,F.escapeIcons)(h):h).replace(/([ \t]+)/g,(l,g)=>"&nbsp;".repeat(g.length)).replace(/^>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,a){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=A;function R(r){return k(r)?!r.value:Array.isArray(r)?r.every(R):!0}e.isEmptyMarkdownString=R;function k(r){return r instanceof A?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function y(r,h){return r===h?!0:!r||!h?!1:r.value===h.value&&r.isTrusted===h.isTrusted&&r.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=y;function T(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function t(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function _(r){const h=[],a=r.split("|").map(g=>g.trim());r=a[0];const l=a[1];if(l){const g=/height=(\d+)/.exec(l),I=/width=(\d+)/.exec(l),b=g?g[1]:"",c=I?I[1]:"",p=isFinite(parseInt(c)),S=isFinite(parseInt(b));p&&h.push(`width="${c}"`),S&&h.push(`height="${b}"`)}return{href:r,dimensions:h}}e.parseHrefAndDimensions=_}),define(we[53],be([0,1,23,9,2]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,y)}e.stringify=A;function R(t){let _=JSON.parse(t);return _=T(_),_}e.parse=R;var k;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function y(t,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,F.regExpFlags)(_)}:_}function T(t,_=0){if(!t||_>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let r=0;r<t.length;++r)t[r]=T(t[r],_+1);else for(const r in t)Object.hasOwnProperty.call(t,r)&&(t[r]=T(t[r],_+1))}return t}e.revive=T}),define(we[11],be([0,1,25,2]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,T,t){this._hosts[y]=T,this._ports[y]=t}setConnectionToken(y,T){this._connectionTokens[y]=T}rewrite(y){if(this._delegate)return this._delegate(y);const T=y.authority;let t=this._hosts[T];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const _=this._ports[T],r=this._connectionTokens[T];let h=`path=${encodeURIComponent(y.path)}`;return typeof r=="string"&&(h+=`&tkn=${encodeURIComponent(r)}`),F.URI.from({scheme:d.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${_}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new A;class R{asBrowserUri(y,T){const t=this.toUri(y,T);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${E.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(y,T){const t=this.toUri(y,T);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==R.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(y,T){return F.URI.isUri(y)?y:F.URI.parse(T.toUrl(y))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(we[24],be([0,1,40,11,17,25,9,2]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(h){return(0,k.uriToFsPath)(h,!0)}e.originalFSPath=y;class T{constructor(a){this._ignorePathCasing=a}compare(a,l,g=!1){return a===l?0:(0,R.compare)(this.getComparisonKey(a,g),this.getComparisonKey(l,g))}isEqual(a,l,g=!1){return a===l?!0:!a||!l?!1:this.getComparisonKey(a,g)===this.getComparisonKey(l,g)}getComparisonKey(a,l=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,l,g=!1){if(a.scheme===l.scheme){if(a.scheme===F.Schemas.file)return d.isEqualOrParent(y(a),y(l),this._ignorePathCasing(a))&&a.query===l.query&&(g||a.fragment===l.fragment);if((0,e.isEqualAuthority)(a.authority,l.authority))return d.isEqualOrParent(a.path,l.path,this._ignorePathCasing(a),"/")&&a.query===l.query&&(g||a.fragment===l.fragment)}return!1}joinPath(a,...l){return k.URI.joinPath(a,...l)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return E.posix.basename(a.path)}extname(a){const l=E.posix.extname(a.path),g=l.indexOf("?");return g!==-1?l.substr(0,g):l}dirname(a){if(a.path.length===0)return a;let l;return a.scheme===F.Schemas.file?l=k.URI.file(E.dirname(y(a))).path:(l=E.posix.dirname(a.path),a.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),l="/")),a.with({path:l})}normalizePath(a){if(!a.path.length)return a;let l;return a.scheme===F.Schemas.file?l=k.URI.file(E.normalize(y(a))).path:l=E.posix.normalize(a.path),a.with({path:l})}relativePath(a,l){if(a.scheme!==l.scheme||!(0,e.isEqualAuthority)(a.authority,l.authority))return;if(a.scheme===F.Schemas.file){const b=E.relative(y(a),y(l));return A.isWindows?d.toSlashes(b):b}let g=a.path||"/",I=l.path||"/";if(this._ignorePathCasing(a)){let b=0;for(const c=Math.min(g.length,I.length);b<c&&!(g.charCodeAt(b)!==I.charCodeAt(b)&&g.charAt(b).toLowerCase()!==I.charAt(b).toLowerCase());b++);g=I.substr(0,b)+g.substr(b)}return E.posix.relative(g,I)}resolvePath(a,l){if(a.scheme===F.Schemas.file){const g=k.URI.file(E.resolve(y(a),l));return a.with({authority:g.authority,path:g.path})}return l=d.toPosixPath(l),a.with({path:E.posix.resolve(a.path,l)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,l){return a===l||(0,R.equalsIgnoreCase)(a,l)}hasTrailingPathSeparator(a,l=E.sep){if(a.scheme===F.Schemas.file){const g=y(a);return g.length>d.getRoot(g).length&&g[g.length-1]===l}else{const g=a.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,l=E.sep){return(0,e.hasTrailingPathSeparator)(a,l)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,l=E.sep){let g=!1;if(a.scheme===F.Schemas.file){const I=y(a);g=I!==void 0&&I.length===d.getRoot(I).length&&I[I.length-1]===l}else{l="/";const I=a.path;g=I.length===1&&I.charCodeAt(I.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(a,l)?a.with({path:a.path+"/"}):a}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(h=>h.scheme===F.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(h,a){const l=[];for(let g=0;g<h.length;g++){const I=a(h[g]);h.some((b,c)=>c===g?!1:(0,e.isEqualOrParent)(I,a(b)))||l.push(h[g])}return l}e.distinctParents=t;var _;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function a(l){const g=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(c=>{const[p,S]=c.split(":");p&&S&&g.set(p,S)});const b=l.path.substring(0,l.path.indexOf(";"));return b&&g.set(h.META_DATA_MIME,b),g}h.parseMetaData=a})(_=e.DataUri||(e.DataUri={}));function r(h,a,l){if(a){let g=h.path;return g&&g[0]!==E.posix.sep&&(g=E.posix.sep+g),h.with({scheme:l,authority:a,path:g})}return h.with({scheme:l})}e.toLocalResource=r}),define(we[13],be([0,1,21,15,3,7,24]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(z){return!!z&&typeof z.then=="function"}e.isThenable=k;function y(z){const x=new d.CancellationTokenSource,j=z(x.token),B=new Promise((q,ce)=>{const V=x.token.onCancellationRequested(()=>{V.dispose(),x.dispose(),ce((0,F.canceled)())});Promise.resolve(j).then(le=>{V.dispose(),x.dispose(),q(le)},le=>{V.dispose(),x.dispose(),ce(le)})});return new class{cancel(){x.cancel()}then(q,ce){return B.then(q,ce)}catch(q){return this.then(void 0,q)}finally(q){return B.finally(q)}}}e.createCancelablePromise=y;function T(z,x,j){return Promise.race([z,new Promise(B=>x.onCancellationRequested(()=>B(j)))])}e.raceCancellation=T;async function t(z){let x=-1;const j=z.map((q,ce)=>q.then(V=>(x=ce,V))),B=await Promise.race(j);return z.forEach((q,ce)=>{ce!==x&&q.cancel()}),B}e.raceCancellablePromises=t;function _(z,x,j){let B;const q=setTimeout(()=>{B?.(void 0),j?.()},x);return Promise.race([z.finally(()=>clearTimeout(q)),new Promise(ce=>B=ce)])}e.raceTimeout=_;function r(z){return new Promise((x,j)=>{const B=z();k(B)?B.then(x,j):x(B)})}e.asPromise=r;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(j,j).then(B)})}return new Promise((j,B)=>{this.queuedPromise.then(j,B)})}return this.activePromise=x(),new Promise((j,B)=>{this.activePromise.then(q=>{this.activePromise=null,j(q)},q=>{this.activePromise=null,B(q)})})}}e.Throttler=h;class a{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=a;class l{constructor(){this.promiseMap=new Map}queue(x,j){const q=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(x)===q&&this.promiseMap.delete(x)});return this.promiseMap.set(x,q),q}}e.SequencerByKey=l;class g{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,j=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,q)=>{this.doResolve=B,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class I{constructor(x){this.delayer=new g(x),this.throttler=new h}trigger(x,j){return this.delayer.trigger(()=>this.throttler.queue(x),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class b{constructor(){this._isOpen=!1,this._promise=new Promise((x,j)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class c extends b{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function p(z,x){return x?new Promise((j,B)=>{const q=setTimeout(()=>{ce.dispose(),j()},z),ce=x.onCancellationRequested(()=>{clearTimeout(q),ce.dispose(),B((0,F.canceled)())})}):y(j=>p(z,j))}e.timeout=p;function S(z,x=0){const j=setTimeout(z,x);return(0,A.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=S;function i(z){const x=[];let j=0;const B=z.length;function q(){return j<B?z[j++]():null}function ce(V){V!=null&&x.push(V);const le=q();return le?le.then(ce):Promise.resolve(x)}return Promise.resolve(null).then(ce)}e.sequence=i;function s(z,x=B=>!!B,j=null){let B=0;const q=z.length,ce=()=>{if(B>=q)return Promise.resolve(j);const V=z[B++];return Promise.resolve(V()).then(ae=>x(ae)?Promise.resolve(ae):ce())};return ce()}e.first=s;function u(z,x=B=>!!B,j=null){if(z.length===0)return Promise.resolve(j);let B=z.length;const q=()=>{B=-1;for(const ce of z)ce.cancel?.()};return new Promise((ce,V)=>{for(const le of z)le.then(ae=>{--B>=0&&x(ae)?(q(),ce(ae)):B===0&&ce(j)}).catch(ae=>{--B>=0&&(q(),V(ae))})})}e.firstParallel=u;class o{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((j,B)=>{this.outstandingPromises.push({factory:x,c:j,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const j=x.factory();j.then(x.c,x.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class f extends o{constructor(){super(1)}}e.Queue=f;class v{constructor(){this.queues=new Map}queueFor(x,j=R.extUri){const B=j.getComparisonKey(x);let q=this.queues.get(B);return q||(q=new f,E.Event.once(q.onFinished)(()=>{q?.dispose(),this.queues.delete(B)}),this.queues.set(B,q)),q}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=v;class w{constructor(x,j){this._token=-1,typeof x=="function"&&typeof j=="number"&&this.setIfNotSet(x,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},j)}setIfNotSet(x,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},j))}}e.TimeoutTimer=w;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,j){this.cancel(),this._token=setInterval(()=>{x()},j)}}e.IntervalTimer=D;class P{constructor(x,j){this.timeoutToken=-1,this.runner=x,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class n extends P{constructor(x,j){super(x,j);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=n;class m extends A.Disposable{constructor(x,j,B,q){super();this.maxWorkChunkSize=x,this.maxPendingWork=j,this.throttleDelay=B,this.handler=q,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=m,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const j=setTimeout(()=>x(z));let B=!1;return{dispose(){B||(B=!0,clearTimeout(j))}}}}else e.runWhenIdle=(z,x)=>{const j=requestIdleCallback(z,typeof x=="number"?{timeout:x}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(j))}}}}();class C{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=C;async function L(z,x,j){let B;for(let q=0;q<j;q++)try{return await z()}catch(ce){B=ce,await p(x)}throw B}e.retry=L;class ${hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,j,B){return this._pending={taskId:x,cancel:()=>B?.(),promise:j},j.then(()=>this.donePending(x),()=>this.donePending(x)),j}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let j,B;const q=new Promise((ce,V)=>{j=ce,B=V});this._next={run:x,promise:q,promiseResolve:j,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=$;class Q{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class se{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,j)=>{this.completeCallback=x,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(j=>{this.completeCallback(x),this.resolved=!0,j()})}error(x){return new Promise(j=>{this.errorCallback(x),this.rejected=!0,j()})}cancel(){new Promise(x=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=se;var G;(function(z){async function x(j){let B;const q=await Promise.all(j.map(ce=>ce.then(V=>V,V=>{B||(B=V)})));if(typeof B!="undefined")throw B;return q}z.settled=x})(G=e.Promises||(e.Promises={}))}),define(we[107],be([0,1,13,17]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new d.IdleValue(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(P,n,m=!1){const C=P||"",L=n||"",$=E.value.collator.compare(C,L);return E.value.collatorIsNumeric&&$===0&&C!==L?C<L?-1:1:$}e.compareFileNames=k;function y(P,n){const m=A.value.collator;return P=P||"",n=n||"",S(m,P,n)}e.compareFileNamesDefault=y;function T(P,n){const m=A.value.collator;return P=P||"",n=n||"",o(P,n)||S(m,P,n)}e.compareFileNamesUpper=T;function t(P,n){const m=A.value.collator;return P=P||"",n=n||"",u(P,n)||S(m,P,n)}e.compareFileNamesLower=t;function _(P,n){return P=P||"",n=n||"",P===n?0:P<n?-1:1}e.compareFileNamesUnicode=_;function r(P,n,m=!1){m||(P=P&&P.toLowerCase(),n=n&&n.toLowerCase());const[C,L]=c(P),[$,Q]=c(n);return C!==$?C<$?-1:1:L===Q?0:L<Q?-1:1}e.noIntlCompareFileNames=r;function h(P,n){const[m,C]=c(P),[L,$]=c(n);let Q=E.value.collator.compare(C,$);if(Q===0){if(E.value.collatorIsNumeric&&C!==$)return C<$?-1:1;if(Q=E.value.collator.compare(m,L),E.value.collatorIsNumeric&&Q===0&&m!==L)return m<L?-1:1}return Q}e.compareFileExtensions=h;function a(P,n){P=P||"",n=n||"";const m=p(P),C=p(n),L=A.value.collator,$=R.value.collator;return S($,m,C)||S(L,P,n)}e.compareFileExtensionsDefault=a;function l(P,n){P=P||"",n=n||"";const m=p(P),C=p(n),L=A.value.collator,$=R.value.collator;return S($,m,C)||o(P,n)||S(L,P,n)}e.compareFileExtensionsUpper=l;function g(P,n){P=P||"",n=n||"";const m=p(P),C=p(n),L=A.value.collator,$=R.value.collator;return S($,m,C)||u(P,n)||S(L,P,n)}e.compareFileExtensionsLower=g;function I(P,n){P=P||"",n=n||"";const m=p(P).toLowerCase(),C=p(n).toLowerCase();return m!==C?m<C?-1:1:P!==n?P<n?-1:1:0}e.compareFileExtensionsUnicode=I;const b=/^(.*?)(\.([^.]*))?$/;function c(P,n=!1){const m=P?b.exec(P):[];let C=[m&&m[1]||"",m&&m[3]||""];return n&&(!C[0]&&C[1]||C[0]&&C[0].charAt(0)===".")&&(C=[C[0]+"."+C[1],""]),C}function p(P){const n=P?b.exec(P):[];return n&&n[1]&&n[1].charAt(0)!=="."&&n[3]||""}function S(P,n,m){let C=P.compare(n,m);return C!==0?C:n.length!==m.length?n.length<m.length?-1:1:0}function i(P){const n=P.charAt(0);return n.toLocaleUpperCase()!==n}function s(P){const n=P.charAt(0);return n.toLocaleLowerCase()!==n}function u(P,n){return i(P)&&s(n)?-1:s(P)&&i(n)?1:0}function o(P,n){return s(P)&&i(n)?-1:i(P)&&s(n)?1:0}function f(P,n,m=!1){return m||(P=P&&P.toLowerCase(),n=n&&n.toLowerCase()),P===n?0:P<n?-1:1}function v(P,n,m=!1){const C=P.split(F.sep),L=n.split(F.sep),$=C.length-1,Q=L.length-1;let se,G;for(let z=0;;z++){if(se=$===z,G=Q===z,se&&G)return k(C[z],L[z],m);if(se)return-1;if(G)return 1;const x=f(C[z],L[z],m);if(x!==0)return x}}e.comparePaths=v;function w(P,n,m){const C=P.toLowerCase(),L=n.toLowerCase(),$=D(P,n,m);if($)return $;const Q=C.endsWith(m),se=L.endsWith(m);if(Q!==se)return Q?-1:1;const G=k(C,L);return G!==0?G:C.localeCompare(L)}e.compareAnything=w;function D(P,n,m){const C=P.toLowerCase(),L=n.toLowerCase(),$=C.startsWith(m),Q=L.startsWith(m);if($!==Q)return $?-1:1;if($&&Q){if(C.length<L.length)return-1;if(C.length>L.length)return 1}return 0}e.compareByPrefix=D}),define(we[27],be([0,1,13,40,20,17,9]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const y="**",T="/",t="[/\\\\]",_="[^/\\\\]",r=/\//g;function h(q){switch(q){case 0:return"";case 1:return`${_}*?`;default:return`(?:${t}|${_}+${t}|${t}${_}+)*?`}}function a(q,ce){if(!q)return[];const V=[];let le=!1,ae=!1,ve="";for(const Ae of q){switch(Ae){case ce:if(!le&&!ae){V.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}ve+=Ae}return ve&&V.push(ve),V}e.splitGlobAware=a;function l(q){if(!q)return"";let ce="";const V=a(q,T);if(V.every(le=>le===y))ce=".*";else{let le=!1;V.forEach((ae,ve)=>{if(ae===y){le||(ce+=h(2),le=!0);return}let Ae=!1,Re="",Oe=!1,Qe="";for(const He of ae){if(He!=="}"&&Ae){Re+=He;continue}if(Oe&&(He!=="]"||!Qe)){let je;He==="-"?je=He:(He==="^"||He==="!")&&!Qe?je="^":He===T?je="":je=R.escapeRegExpCharacters(He),Qe+=je;continue}switch(He){case"{":Ae=!0;continue;case"[":Oe=!0;continue;case"}":ce+=`(?:${a(Re,",").map(K=>l(K)).join("|")})`,Ae=!1,Re="";break;case"]":ce+="["+Qe+"]",Oe=!1,Qe="";break;case"?":ce+=_;continue;case"*":ce+=h(1);continue;default:ce+=R.escapeRegExpCharacters(He)}}ve<V.length-1&&(V[ve+1]!==y||ve+2<V.length)&&(ce+=t),le=!1})}return ce}const g=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),s=function(){return!1},u=function(){return null};function o(q,ce){if(!q)return u;let V;typeof q!="string"?V=q.pattern:V=q,V=V.trim();const le=`${V}_${!!ce.trimForExclusions}`;let ae=i.get(le);if(ae)return f(ae,q);let ve;if(g.test(V)){const Ae=V.substr(4);ae=function(Re,Oe){return typeof Re=="string"&&Re.endsWith(Ae)?V:null}}else(ve=I.exec(v(V,ce)))?ae=w(ve[1],V):(ce.trimForExclusions?c:b).test(V)?ae=D(V,ce):(ve=p.exec(v(V,ce)))?ae=P(ve[1].substr(1),V,!0):(ve=S.exec(v(V,ce)))?ae=P(ve[1],V,!1):ae=n(V);return i.set(le,ae),f(ae,q)}function f(q,ce){return typeof ce=="string"?q:function(V,le){return F.isEqualOrParent(V,ce.base)?q(A.relative(ce.base,V),le):null}}function v(q,ce){return ce.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function w(q,ce){const V=`/${q}`,le=`\\${q}`,ae=function(Ae,Re){return typeof Ae!="string"?null:Re?Re===q?ce:null:Ae===q||Ae.endsWith(V)||Ae.endsWith(le)?ce:null},ve=[q];return ae.basenames=ve,ae.patterns=[ce],ae.allBasenames=ve,ae}function D(q,ce){const V=B(q.slice(1,-1).split(",").map(Re=>o(Re,ce)).filter(Re=>Re!==u),q),le=V.length;if(!le)return u;if(le===1)return V[0];const ae=function(Re,Oe){for(let Qe=0,He=V.length;Qe<He;Qe++)if(V[Qe](Re,Oe))return q;return null},ve=V.find(Re=>!!Re.allBasenames);ve&&(ae.allBasenames=ve.allBasenames);const Ae=V.reduce((Re,Oe)=>Oe.allPaths?Re.concat(Oe.allPaths):Re,[]);return Ae.length&&(ae.allPaths=Ae),ae}function P(q,ce,V){const le=A.sep===A.posix.sep,ae=le?q:q.replace(r,A.sep),ve=A.sep+ae,Ae=A.posix.sep+q,Re=V?function(Oe,Qe){return typeof Oe=="string"&&(Oe===ae||Oe.endsWith(ve)||!le&&(Oe===q||Oe.endsWith(Ae)))?ce:null}:function(Oe,Qe){return typeof Oe=="string"&&(Oe===ae||!le&&Oe===q)?ce:null};return Re.allPaths=[(V?"*/":"./")+q],Re}function n(q){try{const ce=new RegExp(`^${l(q)}$`);return function(V){return ce.lastIndex=0,typeof V=="string"&&ce.test(V)?q:null}}catch(ce){return u}}function m(q,ce,V){return!q||typeof ce!="string"?!1:C(q)(ce,void 0,V)}e.match=m;function C(q,ce={}){if(!q)return s;if(typeof q=="string"||se(q)){const V=o(q,ce);if(V===u)return s;const le=function(ae,ve){return!!V(ae,ve)};return V.allBasenames&&(le.allBasenames=V.allBasenames),V.allPaths&&(le.allPaths=V.allPaths),le}return x(q,ce)}e.parse=C;function L(q){if(!q)return;let ce;return V=>(ce||(ce=(q()||Promise.resolve([])).then(le=>le?Q(le):{})),ce.then(le=>!!le[V]))}e.hasSiblingPromiseFn=L;function $(q){if(!q)return;let ce;return V=>{if(!ce){const le=q();ce=le?Q(le):{}}return!!ce[V]}}e.hasSiblingFn=$;function Q(q){const ce={};for(const V of q)ce[V]=!0;return ce}function se(q){const ce=q;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}e.isRelativePattern=se;function G(q){return q.allBasenames||[]}e.getBasenameTerms=G;function z(q){return q.allPaths||[]}e.getPathTerms=z;function x(q,ce){const V=B(Object.getOwnPropertyNames(q).map(Re=>j(Re,q[Re],ce)).filter(Re=>Re!==u)),le=V.length;if(!le)return u;if(!V.some(Re=>!!Re.requiresSiblings)){if(le===1)return V[0];const Re=function(He,je){for(let N=0,K=V.length;N<K;N++){const Z=V[N](He,je);if(Z)return Z}return null},Oe=V.find(He=>!!He.allBasenames);Oe&&(Re.allBasenames=Oe.allBasenames);const Qe=V.reduce((He,je)=>je.allPaths?He.concat(je.allPaths):He,[]);return Qe.length&&(Re.allPaths=Qe),Re}const ae=function(Re,Oe,Qe){let He;for(let je=0,N=V.length;je<N;je++){const K=V[je];K.requiresSiblings&&Qe&&(Oe||(Oe=A.basename(Re)),He||(He=Oe.substr(0,Oe.length-A.extname(Re).length)));const Z=K(Re,Oe,He,Qe);if(Z)return Z}return null},ve=V.find(Re=>!!Re.allBasenames);ve&&(ae.allBasenames=ve.allBasenames);const Ae=V.reduce((Re,Oe)=>Oe.allPaths?Re.concat(Oe.allPaths):Re,[]);return Ae.length&&(ae.allPaths=Ae),ae}function j(q,ce,V){if(ce===!1)return u;const le=o(q,V);if(le===u)return u;if(typeof ce=="boolean")return le;if(ce){const ae=ce.when;if(typeof ae=="string"){const ve=(Ae,Re,Oe,Qe)=>{if(!Qe||!le(Ae,Re))return null;const He=ae.replace("$(basename)",Oe),je=Qe(He);return(0,d.isThenable)(je)?je.then(N=>N?q:null):je?q:null};return ve.requiresSiblings=!0,ve}}return le}function B(q,ce){const V=q.filter(Re=>!!Re.basenames);if(V.length<2)return q;const le=V.reduce((Re,Oe)=>{const Qe=Oe.basenames;return Qe?Re.concat(Qe):Re},[]);let ae;if(ce){ae=[];for(let Re=0,Oe=le.length;Re<Oe;Re++)ae.push(ce)}else ae=V.reduce((Re,Oe)=>{const Qe=Oe.patterns;return Qe?Re.concat(Qe):Re},[]);const ve=function(Re,Oe){if(typeof Re!="string")return null;if(!Oe){let He;for(He=Re.length;He>0;He--){const je=Re.charCodeAt(He-1);if(je===47||je===92)break}Oe=Re.substr(He)}const Qe=le.indexOf(Oe);return Qe!==-1?ae[Qe]:null};ve.basenames=le,ve.patterns=ae,ve.allBasenames=le;const Ae=q.filter(Re=>!Re.basenames);return Ae.push(ve),Ae}}),define(we[78],be([0,1,40,11,17,25,24,9,2]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(o,f,v){if(typeof o=="string"&&(o=y.URI.file(o)),v){const D=v.getWorkspaceFolder(o);if(D){const P=v.getWorkspace().folders.length>1;let n;if((0,R.isEqual)(D.uri,o)?n="":n=(0,R.relativePath)(D.uri,o),P){const m=D.name?D.name:(0,R.basename)(D.uri);n=n?m+" \u2022 "+n:m}return n}}if(o.scheme!==F.Schemas.file&&o.scheme!==F.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(o.fsPath))return(0,E.normalize)(_(o.fsPath));let w=(0,E.normalize)(o.fsPath);return!A.isWindows&&f?.userHome&&(w=h(w,f.userHome.fsPath)),w}e.getPathLabel=T;function t(o){if(!o)return;typeof o=="string"&&(o=y.URI.file(o));const f=(0,R.basename)(o)||(o.scheme===F.Schemas.file?o.fsPath:o.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(f)?_(f):f}e.getBaseLabel=t;function _(o){return(0,d.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=_;let r=Object.create(null);function h(o,f){if(A.isWindows||!o||!f)return o;let v=r.original===f?r.normalized:void 0;return v||(v=`${(0,k.rtrim)(f,E.posix.sep)}${E.posix.sep}`,r={original:f,normalized:v}),(A.isLinux?o.startsWith(v):(0,k.startsWithIgnoreCase)(o,v))&&(o=`~/${o.substr(v.length)}`),o}e.tildify=h;function a(o,f){return o.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=a;const l="\u2026",g="\\\\",I="~";function b(o,f=E.sep){const v=new Array(o.length);let w=!1;for(let D=0;D<o.length;D++){let P=o[D];if(P===""){v[D]=`.${f}`;continue}if(!P){v[D]=P;continue}w=!0;let n="";P.indexOf(g)===0?(n=P.substr(0,P.indexOf(g)+g.length),P=P.substr(P.indexOf(g)+g.length)):P.indexOf(f)===0?(n=P.substr(0,P.indexOf(f)+f.length),P=P.substr(P.indexOf(f)+f.length)):P.indexOf(I)===0&&(n=P.substr(0,P.indexOf(I)+I.length),P=P.substr(P.indexOf(I)+I.length));const m=P.split(f);for(let C=1;w&&C<=m.length;C++)for(let L=m.length-C;w&&L>=0;L--){w=!1;let $=m.slice(L,L+C).join(f);for(let Q=0;!w&&Q<o.length;Q++)if(Q!==D&&o[Q]&&o[Q].indexOf($)>-1){const se=L+C===m.length,G=L>0&&o[Q].indexOf(f)>-1?f+$:$,z=o[Q].endsWith(G);w=!se||z}if(!w){let Q="";(m[0].endsWith(":")||n!=="")&&(L===1&&(L=0,C++,$=m[0]+f+$),L>0&&(Q=m[0]+f),Q=n+Q),L>0&&(Q=Q+l+f),Q=Q+$,L+C<m.length&&(Q=Q+f+l),v[D]=Q}}w&&(v[D]=P)}return v}e.shorten=b;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function p(o,f=Object.create(null)){const v=[];let w=!1,D="";for(const P of o)if(P==="$"||w&&P==="{")D&&v.push({value:D,type:c.TEXT}),D="",w=!0;else if(P==="}"&&w){const n=f[D];if(typeof n=="string")n.length&&v.push({value:n,type:c.VARIABLE});else if(n){const m=v[v.length-1];(!m||m.type!==c.SEPARATOR)&&v.push({value:n.label,type:c.SEPARATOR})}D="",w=!1}else D+=P;return D&&!w&&v.push({value:D,type:c.TEXT}),v.filter((P,n)=>{if(P.type===c.SEPARATOR){const m=v[n-1],C=v[n+1];return[m,C].every(L=>L&&(L.type===c.VARIABLE||L.type===c.TEXT)&&L.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=p;function S(o,f){return A.isMacintosh||f?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):o.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function i(o,f){return A.isMacintosh||f?o.replace(/\(&&\w\)|&&/g,""):A.isWindows?o.replace(/&&|&/g,v=>v==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(o){const f=o.indexOf("/")!==-1?E.posix:E.win32,v=f.basename(o),w=f.dirname(o);return v.length?{name:v,parentPath:w}:{name:w,parentPath:""}}e.splitName=u}),define(we[79],be([0,1,27,11,17,24,9]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(o){o.text="text/plain",o.binary="application/octet-stream",o.unknown="application/unknown",o.markdown="text/markdown"})(k=e.Mimes||(e.Mimes={}));let y=[],T=[],t=[];function _(o,f=!1){const v=r(o);y.push(v),v.userConfigured?t.push(v):T.push(v),f&&!v.userConfigured&&y.forEach(w=>{w.mime===v.mime||w.userConfigured||(v.extension&&w.extension===v.extension&&console.warn(`Overwriting extension <<${v.extension}>> to now point to mime <<${v.mime}>>`),v.filename&&w.filename===v.filename&&console.warn(`Overwriting filename <<${v.filename}>> to now point to mime <<${v.mime}>>`),v.filepattern&&w.filepattern===v.filepattern&&console.warn(`Overwriting filepattern <<${v.filepattern}>> to now point to mime <<${v.mime}>>`),v.firstline&&w.firstline===v.firstline&&console.warn(`Overwriting firstline <<${v.firstline}>> to now point to mime <<${v.mime}>>`))})}e.registerTextMime=_;function r(o){return{id:o.id,mime:o.mime,filename:o.filename,extension:o.extension,filepattern:o.filepattern,firstline:o.firstline,userConfigured:o.userConfigured,filenameLowercase:o.filename?o.filename.toLowerCase():void 0,extensionLowercase:o.extension?o.extension.toLowerCase():void 0,filepatternLowercase:o.filepattern?o.filepattern.toLowerCase():void 0,filepatternOnPath:o.filepattern?o.filepattern.indexOf(E.posix.sep)>=0:!1}}function h(o){o?(y=y.filter(f=>!f.userConfigured),t=[]):(y=[],T=[],t=[])}e.clearTextMimes=h;function a(o,f){let v;if(o)switch(o.scheme){case F.Schemas.file:v=o.fsPath;break;case F.Schemas.data:v=A.DataUri.parseMetaData(o).get(A.DataUri.META_DATA_LABEL);break;default:v=o.path}if(!v)return[k.unknown];v=v.toLowerCase();const w=(0,E.basename)(v),D=l(v,w,t);if(D)return[D,k.text];const P=l(v,w,T);if(P)return[P,k.text];if(f){const n=g(f);if(n)return[n,k.text]}return[k.unknown]}e.guessMimeTypes=a;function l(o,f,v){let w=null,D=null,P=null;for(let n=v.length-1;n>=0;n--){const m=v[n];if(f===m.filenameLowercase){w=m;break}if(m.filepattern&&(!D||m.filepattern.length>D.filepattern.length)){const C=m.filepatternOnPath?o:f;(0,d.match)(m.filepatternLowercase,C)&&(D=m)}m.extension&&(!P||m.extension.length>P.extension.length)&&f.endsWith(m.extensionLowercase)&&(P=m)}return w?w.mime:D?D.mime:P?P.mime:null}function g(o){if((0,R.startsWithUTF8BOM)(o)&&(o=o.substr(1)),o.length>0)for(let f=y.length-1;f>=0;f--){const v=y[f];if(!v.firstline)continue;const w=o.match(v.firstline);if(w&&w.length>0)return v.mime}return null}function I(o){return o?typeof o=="string"?o===k.binary||o===k.text||o===k.unknown:o.length===1&&I(o[0]):!0}e.isUnspecific=I;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(o){const f=(0,E.extname)(o),v=b[f.toLowerCase()];return v!==void 0?v:S(o)}e.getMediaOrTextMime=p;function S(o){const f=(0,E.extname)(o);return c[f.toLowerCase()]}e.getMediaMime=S;function i(o){for(const f in c)if(c[f]===o)return f}e.getExtensionForMimeType=i;const s=/^(.+)\/(.+?)(;.+)?$/;function u(o,f){const v=s.exec(o);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:f?void 0:o}e.normalizeMimeType=u}),define(we[108],be([0,1,2]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(t){return t.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const r=this._uriTransformer.transformIncoming(_);return r===_?_:F(d.URI.from(r))}transformOutgoing(_){const r=this._uriTransformer.transformOutgoing(_);return r===_?_:F(d.URI.from(r))}transformOutgoingURI(_){const r=this._uriTransformer.transformOutgoing(_);return r===_?_:d.URI.from(r)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,_,r){if(!t||r>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return _.transformOutgoing(t);for(let h in t)if(Object.hasOwnProperty.call(t,h)){const a=A(t[h],_,r+1);a!==null&&(t[h]=a)}}return null}function R(t,_){const r=A(t,_,0);return r===null?t:r}e.transformOutgoingURIs=R;function k(t,_,r,h){if(!t||h>200)return null;if(typeof t=="object"){if(t.$mid===1)return r?d.URI.revive(_.transformIncoming(t)):_.transformIncoming(t);for(let a in t)if(Object.hasOwnProperty.call(t,a)){const l=k(t[a],_,r,h+1);l!==null&&(t[a]=l)}}return null}function y(t,_){const r=k(t,_,!1,0);return r===null?t:r}e.transformIncomingURIs=y;function T(t,_){const r=k(t,_,!0,0);return r===null?t:r}e.transformAndReviveIncomingURIs=T}),define(we[36],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(y){return d.test(y)}e.isUUID=F;const E=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let T=0;T<y.length;T++)y[T]=Math.floor(Math.random()*256);return y};function k(){R(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let y=0,T="";return T+=A[E[y++]],T+=A[E[y++]],T+=A[E[y++]],T+=A[E[y++]],T+="-",T+=A[E[y++]],T+=A[E[y++]],T+="-",T+=A[E[y++]],T+=A[E[y++]],T+="-",T+=A[E[y++]],T+=A[E[y++]],T+="-",T+=A[E[y++]],T+=A[E[y++]],T+=A[E[y++]],T+=A[E[y++]],T+=A[E[y++]],T+=A[E[y++]],T}e.generateUuid=k}),define(we[109],be([0,1,227]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends d.CharacterClassifier{constructor(k){super(0);for(let y=0,T=k.length;y<T;y++)this.set(k.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(R){let k={};return y=>(k.hasOwnProperty(y)||(k[y]=R(y)),k[y])}e.getMapForWordSeparators=A(R=>new E(R))}),define(we[80],be([0,1,22]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),this.indentSize=g.tabSize|0,this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace),this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class T{constructor(g,I){this._findMatchBrand=void 0,this.range=g,this.matches=I}}e.FindMatch=T;var t;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(_=e.PositionAffinity||(e.PositionAffinity={}));var r;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(r=e.ModelConstants||(e.ModelConstants={}));class h{constructor(g,I,b,c,p,S){this.identifier=g,this.range=I,this.text=b,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=p,this._isTracked=S}}e.ValidAnnotatedEditOperation=h;class a{constructor(g,I,b){this.reverseEdits=g,this.changes=I,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=a}),define(we[110],be([0,1,9,109,111,41,80]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class y{constructor(c,p,S,i){this.searchString=c,this.isRegex=p,this.matchCase=S,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=T(this.searchString):c=this.searchString.indexOf(`
`)>=0;let p=null;try{p=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(i){return null}if(!p)return null;let S=!this.isRegex&&!c;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new t(p,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=y;function T(b){if(!b||b.length===0)return!1;for(let c=0,p=b.length;c<p;c++)if(b.charCodeAt(c)===92){if(c++,c>=p)break;const i=b.charCodeAt(c);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=T;class t{constructor(c,p,S){this.regex=c,this.wordSeparators=p,this.simpleSearch=S}}e.SearchData=t;function _(b,c,p){if(!p)return new R.FindMatch(b,null);let S=[];for(let i=0,s=c.length;i<s;i++)S[i]=c[i];return new R.FindMatch(b,S)}e.createFindMatch=_;class r{constructor(c){let p=[],S=0;for(let i=0,s=c.length;i<s;i++)c.charCodeAt(i)===10&&(p[S++]=i);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(c){const p=this._lineFeedsOffsets;let S=0,i=p.length-1;if(i===-1||c<=p[0])return 0;for(;S<i;){const s=S+((i-S)/2>>0);p[s]>=c?i=s-1:p[s+1]>=c?(S=s,i=s):S=s+1}return S+1}}class h{static findMatches(c,p,S,i,s){const u=p.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(c,S,new I(u.wordSeparators,u.regex),i,s):this._doFindMatchesLineByLine(c,S,u,i,s):[]}static _getMultilineMatchRange(c,p,S,i,s,u){let o,f=0;i?(f=i.findLineFeedCountBeforeOffset(s),o=p+s+f):o=p+s;let v;if(i){let n=i.findLineFeedCountBeforeOffset(s+u.length)-f;v=o+u.length+n}else v=o+u.length;const w=c.getPositionAt(o),D=c.getPositionAt(v);return new A.Range(w.lineNumber,w.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(c,p,S,i,s){const u=c.getOffsetAt(p.getStartPosition()),o=c.getValueInRange(p,1),f=c.getEOL()===`\r
`?new r(o):null,v=[];let w=0,D;for(S.reset(0);D=S.next(o);)if(v[w++]=_(this._getMultilineMatchRange(c,u,o,f,D.index,D[0]),D,i),w>=s)return v;return v}static _doFindMatchesLineByLine(c,p,S,i,s){const u=[];let o=0;if(p.startLineNumber===p.endLineNumber){const v=c.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return o=this._findMatchesInLine(S,v,p.startLineNumber,p.startColumn-1,o,u,i,s),u}const f=c.getLineContent(p.startLineNumber).substring(p.startColumn-1);o=this._findMatchesInLine(S,f,p.startLineNumber,p.startColumn-1,o,u,i,s);for(let v=p.startLineNumber+1;v<p.endLineNumber&&o<s;v++)o=this._findMatchesInLine(S,c.getLineContent(v),v,0,o,u,i,s);if(o<s){const v=c.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);o=this._findMatchesInLine(S,v,p.endLineNumber,0,o,u,i,s)}return u}static _findMatchesInLine(c,p,S,i,s,u,o,f){const v=c.wordSeparators;if(!o&&c.simpleSearch){const P=c.simpleSearch,n=P.length,m=p.length;let C=-n;for(;(C=p.indexOf(P,C+n))!==-1;)if((!v||g(v,p,m,C,n))&&(u[s++]=new R.FindMatch(new A.Range(S,C+1+i,S,C+1+n+i),null),s>=f))return s;return s}const w=new I(c.wordSeparators,c.regex);let D;w.reset(0);do if(D=w.next(p),D&&(u[s++]=_(new A.Range(S,D.index+1+i,S,D.index+1+D[0].length+i),D,o),s>=f))return s;while(D);return s}static findNextMatch(c,p,S,i){const s=p.parseSearchRequest();if(!s)return null;const u=new I(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(c,S,u,i):this._doFindNextMatchLineByLine(c,S,u,i)}static _doFindNextMatchMultiline(c,p,S,i){const s=new E.Position(p.lineNumber,1),u=c.getOffsetAt(s),o=c.getLineCount(),f=c.getValueInRange(new A.Range(s.lineNumber,s.column,o,c.getLineMaxColumn(o)),1),v=c.getEOL()===`\r
`?new r(f):null;S.reset(p.column-1);let w=S.next(f);return w?_(this._getMultilineMatchRange(c,u,f,v,w.index,w[0]),w,i):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(c,new E.Position(1,1),S,i):null}static _doFindNextMatchLineByLine(c,p,S,i){const s=c.getLineCount(),u=p.lineNumber,o=c.getLineContent(u),f=this._findFirstMatchInLine(S,o,u,p.column,i);if(f)return f;for(let v=1;v<=s;v++){const w=(u+v-1)%s,D=c.getLineContent(w+1),P=this._findFirstMatchInLine(S,D,w+1,1,i);if(P)return P}return null}static _findFirstMatchInLine(c,p,S,i,s){c.reset(i-1);const u=c.next(p);return u?_(new A.Range(S,u.index+1,S,u.index+1+u[0].length),u,s):null}static findPreviousMatch(c,p,S,i){const s=p.parseSearchRequest();if(!s)return null;const u=new I(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(c,S,u,i):this._doFindPreviousMatchLineByLine(c,S,u,i)}static _doFindPreviousMatchMultiline(c,p,S,i){const s=this._doFindMatchesMultiline(c,new A.Range(1,1,p.lineNumber,p.column),S,i,10*k);if(s.length>0)return s[s.length-1];const u=c.getLineCount();return p.lineNumber!==u||p.column!==c.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(c,new E.Position(u,c.getLineMaxColumn(u)),S,i):null}static _doFindPreviousMatchLineByLine(c,p,S,i){const s=c.getLineCount(),u=p.lineNumber,o=c.getLineContent(u).substring(0,p.column-1),f=this._findLastMatchInLine(S,o,u,i);if(f)return f;for(let v=1;v<=s;v++){const w=(s+u-v-1)%s,D=c.getLineContent(w+1),P=this._findLastMatchInLine(S,D,w+1,i);if(P)return P}return null}static _findLastMatchInLine(c,p,S,i){let s=null,u;for(c.reset(0);u=c.next(p);)s=_(new A.Range(S,u.index+1,S,u.index+1+u[0].length),u,i);return s}}e.TextModelSearch=h;function a(b,c,p,S,i){if(S===0)return!0;const s=c.charCodeAt(S-1);if(b.get(s)!==0||s===13||s===10)return!0;if(i>0){const u=c.charCodeAt(S);if(b.get(u)!==0)return!0}return!1}function l(b,c,p,S,i){if(S+i===p)return!0;const s=c.charCodeAt(S+i);if(b.get(s)!==0||s===13||s===10)return!0;if(i>0){const u=c.charCodeAt(S+i-1);if(b.get(u)!==0)return!0}return!1}function g(b,c,p,S,i){return a(b,c,p,S,i)&&l(b,c,p,S,i)}e.isValidMatch=g;class I{constructor(c,p){this._wordSeparators=c,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const p=c.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(S=this._searchRegex.exec(c),!S))return null;const i=S.index,s=S[0].length;if(i===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){d.getNextCodePoint(c,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=s,!this._wordSeparators||g(this._wordSeparators,c,p,i,s))return S}while(S);return null}}e.Searcher=I}),define(we[112],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class F{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let y=0,T=k.notIn.length;y<T;y++)switch(k.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=F;class E{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of k)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=E;function A(R,k,y){R.has(k)?R.get(k).push(y):R.set(k,[y])}}),define(we[54],be([0,1,27,17]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,R,k,y){if(Array.isArray(A)){let T=0;for(const t of A){const _=E(t,R,k,y);if(_===10)return _;_>T&&(T=_)}return T}else{if(typeof A=="string")return y?A==="*"?5:A===k?10:0:0;if(A){const{language:T,pattern:t,scheme:_,hasAccessToAllModels:r}=A;if(!y&&!r)return 0;let h=0;if(_)if(_===R.scheme)h=10;else if(_==="*")h=5;else return 0;if(T)if(T===k)h=10;else if(T==="*")h=Math.max(h,5);else return 0;if(t){let a;if(typeof t=="string"?a=t:a={...t,base:(0,F.normalize)(t.base)},a===R.fsPath||(0,d.match)(a,R.fsPath))h=10;else return 0}return h}else return 0}}e.score=E}),define(we[113],be([0,1,3,7]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,k){return this._map.set(R,k),this.fire([R]),(0,F.toDisposable)(()=>{this._map.get(R)===k&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,k){let y=null,T=!1;return this._promises.set(R,k.then(t=>{this._promises.delete(R),!(T||!t)&&(y=this.register(R,t))})),(0,F.toDisposable)(()=>{T=!0,y&&y.dispose()})}getPromise(R){const k=this.get(R);if(k)return Promise.resolve(k);const y=this._promises.get(R);return y?y.then(T=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(we[81],be([0,1,23,25]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function A(_){for(let r=0,h=_.length;r<h;r+=4){const a=_[r+0],l=_[r+1],g=_[r+2],I=_[r+3];_[r+0]=I,_[r+1]=g,_[r+2]=l,_[r+3]=a}}function R(_){const r=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return F.isLittleEndian()||A(r),d.VSBuffer.wrap(r)}function k(_){const r=_.buffer;if(F.isLittleEndian()||A(r),r.byteOffset%4==0)return new Uint32Array(r.buffer,r.byteOffset,r.length/4);{const h=new Uint8Array(r.byteLength);return h.set(r),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function y(_){const r=new Uint32Array(T(_));let h=0;if(r[h++]=_.id,_.type==="full")r[h++]=1,r[h++]=_.data.length,r.set(_.data,h),h+=_.data.length;else{r[h++]=2,r[h++]=_.deltas.length;for(const a of _.deltas)r[h++]=a.start,r[h++]=a.deleteCount,a.data?(r[h++]=a.data.length,r.set(a.data,h),h+=a.data.length):r[h++]=0}return R(r)}e.encodeSemanticTokensDto=y;function T(_){let r=0;if(r+=1+1,_.type==="full")r+=1+_.data.length;else{r+=1,r+=(1+1+1)*_.deltas.length;for(const h of _.deltas)h.data&&(r+=h.data.length)}return r}function t(_){const r=k(_);let h=0;const a=r[h++];if(r[h++]===1){const b=r[h++],c=r.subarray(h,h+b);return h+=b,{id:a,type:"full",data:c}}const g=r[h++];let I=[];for(let b=0;b<g;b++){const c=r[h++],p=r[h++],S=r[h++];let i;S>0&&(i=r.subarray(h,h+S),h+=S),I[b]={start:c,deleteCount:p,data:i}}return{id:a,type:"delta",deltas:I}}e.decodeSemanticTokensDto=t}),define(we[114],be([18,19]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(we[55],be([0,1,16,10,114]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,t){return t&&(T.stack||T.stacktrace)?E.localize(0,null,k(T),R(T.stack)||R(T.stacktrace)):k(T)}function R(T){return Array.isArray(T)?T.join(`
`):T}function k(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?E.localize(1,null,T.message):T.message||E.localize(2,null)}function y(T=null,t=!1){if(!T)return E.localize(3,null);if(Array.isArray(T)){const _=d.coalesce(T),r=y(_[0],t);return _.length>1?E.localize(4,null,r,_.length):r}if(F.isString(T))return T;if(T.detail){const _=T.detail;if(_.error)return A(_.error,t);if(_.exception)return A(_.exception,t)}return T.stack?A(T,t):T.message?T.message:E.localize(5,null)}e.toErrorMessage=y}),define(we[115],be([18,19]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(we[116],be([18,19]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[117],be([18,19]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[118],be([18,19]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(we[119],be([18,19]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(we[120],be([18,19]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(we[121],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[122],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[123],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(we[124],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[125],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[126],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[127],be([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[128],be([18,19]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(we[129],be([18,19]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(we[130],be([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[131],be([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[132],be([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[133],be([18,19]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[134],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var F;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var E;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[135],be([0,1,117]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(r){return r=r.trim(),r==="*"||F.test(r)}e.isValidVersionStr=A;function R(r){if(!A(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=r.match(F);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=R;function k(r){if(!r)return null;let h=r.majorBase,a=r.majorMustEqual,l=r.minorBase,g=r.minorMustEqual,I=r.patchBase,b=r.patchMustEqual;r.hasCaret&&(h===0||(g=!1),b=!1);let c=0;if(r.preRelease){const p=E.exec(r.preRelease);if(p){const[,S,i,s]=p;c=Date.UTC(Number(S),Number(i)-1,Number(s))}}return{majorBase:h,majorMustEqual:a,minorBase:l,minorMustEqual:g,patchBase:I,patchMustEqual:b,isMinimum:r.hasGreaterEquals,notBefore:c}}e.normalizeVersion=k;function y(r,h,a){let l;typeof r=="string"?l=k(R(r)):l=r;let g;h instanceof Date?g=h.getTime():typeof h=="string"&&(g=new Date(h).getTime());let I;if(typeof a=="string"?I=k(R(a)):I=a,!l||!I)return!1;let b=l.majorBase,c=l.minorBase,p=l.patchBase,S=I.majorBase,i=I.minorBase,s=I.patchBase,u=I.notBefore,o=I.majorMustEqual,f=I.minorMustEqual,v=I.patchMustEqual;return I.isMinimum?b>S?!0:b<S?!1:c>i?!0:c<i||g&&g<u?!1:p>=s:(b===1&&S===0&&(!o||!f||!v)&&(S=1,i=0,s=0,o=!0,f=!1,v=!1),b<S?!1:b>S?!o:c<i?!1:c>i?!f:p<s?!1:p>s?!v:!(g&&g<u))}e.isValidVersion=y;function T(r,h,a,l){return a.isBuiltin||typeof a.main=="undefined"?!0:_(r,h,a.engines.vscode,l)}e.isValidExtensionVersion=T;function t(r,h,a){return r==="*"||_(h,a,r)}e.isEngineValid=t;function _(r,h,a,l=[]){let g=k(R(a));if(!g)return l.push(d.localize(0,null,a)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return l.push(d.localize(1,null,a)),!1}else if(!g.majorMustEqual)return l.push(d.localize(2,null,a)),!1;return y(r,h,g)?!0:(l.push(d.localize(3,null,r,a)),!1)}}),define(we[82],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(E,A=[],R=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=d}),define(we[56],be([0,1,82]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function E(R,k,y){k instanceof d.SyncDescriptor||(k=new d.SyncDescriptor(k,[],y)),F.push([R,k])}e.registerSingleton=E;function A(){return F}e.getSingletonServiceDescriptors=A}),define(we[136],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class F{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const k=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(R);k.outgoing.set(this._hashFn(R),y),y.incoming.set(this._hashFn(A),k)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(let k of this._nodes.values())k.outgoing.delete(R),k.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let k=this._nodes.get(R);return k||(k=new d(A),this._nodes.set(R,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[R,k]of this._nodes)A.push(`${R}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,R]of this._nodes){const k=new Set([A]),y=this._findCycle(R,k);if(y)return y}}_findCycle(A,R){for(let[k,y]of A.outgoing){if(R.has(k))return[...R,k].join(" -> ");R.add(k);const T=this._findCycle(y,R);if(T)return T;R.delete(k)}}}e.Graph=F}),define(we[4],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function y(T){return T[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=y})(d=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function F(k,y,T,t){y[d.DI_TARGET]===y?y[d.DI_DEPENDENCIES].push({id:k,index:T,optional:t}):(y[d.DI_DEPENDENCIES]=[{id:k,index:T,optional:t}],y[d.DI_TARGET]=y)}function E(k){if(d.serviceIds.has(k))return d.serviceIds.get(k);const y=function(T,t,_){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(y,T,_,!1)};return y.toString=()=>k,d.serviceIds.set(k,y),y}e.createDecorator=E;function A(k){return k}e.refineServiceDecorator=A;function R(k){return function(y,T,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(k,y,t,!0)}}e.optional=R}),define(we[137],be([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function F(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(we[138],be([0,1,3,57,7,20,76,54,137]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(T):!!l.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(g,I){let b={selector:g,provider:I,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(b){let c=this._entries.indexOf(b);c>=0&&(this._entries.splice(c,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const I=[];for(let b of this._entries)b._score>0&&I.push(b.provider);return I}ordered(g){const I=[];return this._orderedForEach(g,b=>I.push(b.provider)),I}orderedGroups(g){const I=[];let b,c;return this._orderedForEach(g,p=>{b&&c===p._score?b.push(p.provider):(c=p._score,b=[p.provider],I.push(b))}),I}_orderedForEach(g,I){if(!!g){this._updateScores(g);for(const b of this._entries)b._score>0&&I(b)}}_updateScores(g){let I={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let b of this._entries)if(b._score=(0,k.score)(b.selector,g.uri,g.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(g)),T(b.selector)&&b._score>0){for(let c of this._entries)c._score=0;b._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(g,I){return g._score<I._score?1:g._score>I._score?-1:g._time<I._time?1:g._time>I._time?-1:0}}e.LanguageFeatureRegistry=t;const _=new WeakMap;let r=0;function h(l){let g=_.get(l);return g===void 0&&(g=++r,_.set(l,g)),g}class a{constructor(g,I,b=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=I,this.max=b,this._cache=new A.LRUCache(50,.7)}_key(g){return g.id+this._registry.all(g).reduce((I,b)=>(0,F.doHash)(h(b),I),0)}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const I=this._key(g),b=this._cache.get(I);return this._clamp(b?.value)}update(g,I){const b=this._key(g);let c=this._cache.get(b);return c||(c=new R.MovingAverage,this._cache.set(b,c)),c.update(I),this.get(g)}}e.LanguageFeatureRequestDelays=a}),define(we[58],be([0,1,2,41,138,113,34]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(n){n[n.Null=0]="Null",n[n.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class y{constructor(m,C){this.language=m,this.id=C}}e.LanguageIdentifier=y;var T;(function(n){n[n.NotSet=-1]="NotSet",n[n.None=0]="None",n[n.Italic=1]="Italic",n[n.Bold=2]="Bold",n[n.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var t;(function(n){n[n.None=0]="None",n[n.DefaultForeground=1]="DefaultForeground",n[n.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var _;(function(n){n[n.Other=0]="Other",n[n.Comment=1]="Comment",n[n.String=2]="String",n[n.RegEx=4]="RegEx"})(_=e.StandardTokenType||(e.StandardTokenType={}));var r;(function(n){n[n.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",n[n.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",n[n.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",n[n.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",n[n.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",n[n.ITALIC_MASK=2048]="ITALIC_MASK",n[n.BOLD_MASK=4096]="BOLD_MASK",n[n.UNDERLINE_MASK=8192]="UNDERLINE_MASK",n[n.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",n[n.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",n[n.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",n[n.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",n[n.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",n[n.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",n[n.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",n[n.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",n[n.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",n[n.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(r=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(m){return(m&255)>>>0}static getTokenType(m){return(m&1792)>>>8}static getFontStyle(m){return(m&14336)>>>11}static getForeground(m){return(m&8372224)>>>14}static getBackground(m){return(m&4286578688)>>>23}static getClassNameFromMetadata(m){let C=this.getForeground(m),L="mtk"+C,$=this.getFontStyle(m);return $&1&&(L+=" mtki"),$&2&&(L+=" mtkb"),$&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(m,C){const L=this.getForeground(m),$=this.getFontStyle(m);let Q=`color: ${C[L]};`;return $&1&&(Q+="font-style: italic;"),$&2&&(Q+="font-weight: bold;"),$&4&&(Q+="text-decoration: underline;"),Q}}e.TokenMetadata=h;var a;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let n=Object.create(null);return n[0]="symbol-method",n[1]="symbol-function",n[2]="symbol-constructor",n[3]="symbol-field",n[4]="symbol-variable",n[5]="symbol-class",n[6]="symbol-struct",n[7]="symbol-interface",n[8]="symbol-module",n[9]="symbol-property",n[10]="symbol-event",n[11]="symbol-operator",n[12]="symbol-unit",n[13]="symbol-value",n[14]="symbol-constant",n[15]="symbol-enum",n[16]="symbol-enum-member",n[17]="symbol-keyword",n[27]="symbol-snippet",n[18]="symbol-text",n[19]="symbol-color",n[20]="symbol-file",n[21]="symbol-reference",n[22]="symbol-customcolor",n[23]="symbol-folder",n[24]="symbol-type-parameter",n[25]="account",n[26]="issues",function(m){const C=n[m];let L=C&&R.iconRegistry.get(C);return L||(console.info("No codicon found for CompletionItemKind "+m),L=R.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let n=Object.create(null);return n.method=0,n.function=1,n.constructor=2,n.field=3,n.variable=4,n.class=5,n.struct=6,n.interface=7,n.module=8,n.property=9,n.event=10,n.operator=11,n.unit=12,n.value=13,n.constant=14,n.enum=15,n["enum-member"]=16,n.enumMember=16,n.keyword=17,n.snippet=27,n.text=18,n.color=19,n.file=20,n.reference=21,n.customcolor=22,n.folder=23,n["type-parameter"]=24,n.typeParameter=24,n.account=25,n.issue=26,function(m,C){let L=n[m];return typeof L=="undefined"&&!C&&(L=9),L}}();var l;(function(n){n[n.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(n){n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var S;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(S=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(n){return n&&d.URI.isUri(n.uri)&&F.Range.isIRange(n.range)&&(F.Range.isIRange(n.originSelectionRange)||F.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=i;var s;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var u;(function(n){n[n.Deprecated=1]="Deprecated"})(u=e.SymbolTag||(e.SymbolTag={}));var o;(function(n){const m=new Map;m.set("file",0),m.set("module",1),m.set("namespace",2),m.set("package",3),m.set("class",4),m.set("method",5),m.set("property",6),m.set("field",7),m.set("constructor",8),m.set("enum",9),m.set("interface",10),m.set("function",11),m.set("variable",12),m.set("constant",13),m.set("string",14),m.set("number",15),m.set("boolean",16),m.set("array",17),m.set("object",18),m.set("key",19),m.set("null",20),m.set("enum-member",21),m.set("struct",22),m.set("event",23),m.set("operator",24),m.set("type-parameter",25);const C=new Map;C.set(0,"file"),C.set(1,"module"),C.set(2,"namespace"),C.set(3,"package"),C.set(4,"class"),C.set(5,"method"),C.set(6,"property"),C.set(7,"field"),C.set(8,"constructor"),C.set(9,"enum"),C.set(10,"interface"),C.set(11,"function"),C.set(12,"variable"),C.set(13,"constant"),C.set(14,"string"),C.set(15,"number"),C.set(16,"boolean"),C.set(17,"array"),C.set(18,"object"),C.set(19,"key"),C.set(20,"null"),C.set(21,"enum-member"),C.set(22,"struct"),C.set(23,"event"),C.set(24,"operator"),C.set(25,"type-parameter");function L(se){return m.get(se)}n.fromString=L;function $(se){return C.get(se)}n.toString=$;function Q(se,G){const z=C.get(se);let x=z&&R.iconRegistry.get("symbol-"+z);return x||(console.info("No codicon found for SymbolKind "+se),x=R.Codicon.symbolProperty),`${G?"inline":"block"} ${x.classNames}`}n.toCssClassName=Q})(o=e.SymbolKinds||(e.SymbolKinds={}));class f{constructor(m){this.value=m}}e.FoldingRangeKind=f,f.Comment=new f("comment"),f.Imports=new f("imports"),f.Region=new f("region");var v;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var D;(function(n){n[n.Other=0]="Other",n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var P;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[42],be([0,1,25,9,4]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=d.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",d.isMacintosh),R.set("isLinux",d.isLinux),R.set("isWindows",d.isWindows),R.set("isWeb",d.isWeb),R.set("isMacNative",d.isMacintosh&&!d.isWeb),R.set("isEdge",A.indexOf("Edg/")>=0),R.set("isFirefox",A.indexOf("Firefox")>=0),R.set("isChrome",A.indexOf("Chrome")>=0),R.set("isSafari",A.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var y;(function(P){P[P.False=0]="False",P[P.True=1]="True",P[P.Defined=2]="Defined",P[P.Not=3]="Not",P[P.Equals=4]="Equals",P[P.NotEquals=5]="NotEquals",P[P.And=6]="And",P[P.Regex=7]="Regex",P[P.NotRegex=8]="NotRegex",P[P.Or=9]="Or",P[P.In=10]="In",P[P.NotIn=11]="NotIn",P[P.Greater=12]="Greater",P[P.GreaterEquals=13]="GreaterEquals",P[P.Smaller=14]="Smaller",P[P.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return _.INSTANCE}static true(){return r.INSTANCE}static has(n){return h.create(n)}static equals(n,m){return a.create(n,m)}static notEquals(n,m){return I.create(n,m)}static regex(n,m){return s.create(n,m)}static in(n,m){return l.create(n,m)}static not(n){return b.create(n)}static and(...n){return o.create(n)}static or(...n){return f.create(n)}static greater(n,m){return c.create(n,m)}static less(n,m){return S.create(n,m)}static deserialize(n,m=!1){if(!!n)return this._deserializeOrExpression(n,m)}static _deserializeOrExpression(n,m){let C=n.split("||");return f.create(C.map(L=>this._deserializeAndExpression(L,m)))}static _deserializeAndExpression(n,m){let C=n.split("&&");return o.create(C.map(L=>this._deserializeOne(L,m)))}static _deserializeOne(n,m){if(n=n.trim(),n.indexOf("!=")>=0){let C=n.split("!=");return I.create(C[0].trim(),this._deserializeValue(C[1],m))}if(n.indexOf("==")>=0){let C=n.split("==");return a.create(C[0].trim(),this._deserializeValue(C[1],m))}if(n.indexOf("=~")>=0){let C=n.split("=~");return s.create(C[0].trim(),this._deserializeRegexValue(C[1],m))}if(n.indexOf(" in ")>=0){let C=n.split(" in ");return l.create(C[0].trim(),C[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(n)){const C=n.split(">=");return p.create(C[0].trim(),C[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(n)){const C=n.split(">");return c.create(C[0].trim(),C[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(n)){const C=n.split("<=");return i.create(C[0].trim(),C[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(n)){const C=n.split("<");return S.create(C[0].trim(),C[1].trim())}return/^\!\s*/.test(n)?b.create(n.substr(1).trim()):h.create(n)}static _deserializeValue(n,m){if(n=n.trim(),n==="true")return!0;if(n==="false")return!1;let C=/^'([^']*)'$/.exec(n);return C?C[1].trim():n}static _deserializeRegexValue(n,m){if((0,F.isFalsyOrWhitespace)(n)){if(m)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let C=n.indexOf("/"),L=n.lastIndexOf("/");if(C===L||C<0){if(m)throw new Error(`bad regexp-value '${n}', missing /-enclosure`);return console.warn(`bad regexp-value '${n}', missing /-enclosure`),null}let $=n.slice(C+1,L),Q=n[L+1]==="i"?"i":"";try{return new RegExp($,Q)}catch(se){if(m)throw new Error(`bad regexp-value '${n}', parse error: ${se}`);return console.warn(`bad regexp-value '${n}', parse error: ${se}`),null}}}e.ContextKeyExpr=T;function t(P,n){return P.cmp(n)}class _{constructor(){this.type=0}cmp(n){return this.type-n.type}equals(n){return n.type===this.type}evaluate(n){return!1}serialize(){return"false"}keys(){return[]}map(n){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=_,_.INSTANCE=new _;class r{constructor(){this.type=1}cmp(n){return this.type-n.type}equals(n){return n.type===this.type}evaluate(n){return!0}serialize(){return"true"}keys(){return[]}map(n){return this}negate(){return _.INSTANCE}}e.ContextKeyTrueExpr=r,r.INSTANCE=new r;class h{constructor(n){this.key=n,this.type=2}static create(n){const m=R.get(n);return typeof m=="boolean"?m?r.INSTANCE:_.INSTANCE:new h(n)}cmp(n){return n.type!==this.type?this.type-n.type:w(this.key,n.key)}equals(n){return n.type===this.type?this.key===n.key:!1}evaluate(n){return!!n.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(n){return n.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=h;class a{constructor(n,m){this.key=n,this.value=m,this.type=4}static create(n,m){if(typeof m=="boolean")return m?h.create(n):b.create(n);const C=R.get(n);return typeof C=="boolean"?m===(C?"true":"false")?r.INSTANCE:_.INSTANCE:new a(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:D(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return n.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(n){return n.mapEquals(this.key,this.value)}negate(){return I.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class l{constructor(n,m){this.key=n,this.valueKey=m,this.type=10}static create(n,m){return new l(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:D(this.key,this.valueKey,n.key,n.valueKey)}equals(n){return n.type===this.type?this.key===n.key&&this.valueKey===n.valueKey:!1}evaluate(n){const m=n.getValue(this.valueKey),C=n.getValue(this.key);return Array.isArray(m)?m.indexOf(C)>=0:typeof C=="string"&&typeof m=="object"&&m!==null?k.call(m,C):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(n){return n.mapIn(this.key,this.valueKey)}negate(){return g.create(this)}}e.ContextKeyInExpr=l;class g{constructor(n){this._actual=n,this.type=11}static create(n){return new g(n)}cmp(n){return n.type!==this.type?this.type-n.type:this._actual.cmp(n._actual)}equals(n){return n.type===this.type?this._actual.equals(n._actual):!1}evaluate(n){return!this._actual.evaluate(n)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(n){return new g(this._actual.map(n))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class I{constructor(n,m){this.key=n,this.value=m,this.type=5}static create(n,m){if(typeof m=="boolean")return m?b.create(n):h.create(n);const C=R.get(n);return typeof C=="boolean"?m===(C?"true":"false")?_.INSTANCE:r.INSTANCE:new I(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:D(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return n.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(n){return n.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=I;class b{constructor(n){this.key=n,this.type=3}static create(n){const m=R.get(n);return typeof m=="boolean"?m?_.INSTANCE:r.INSTANCE:new b(n)}cmp(n){return n.type!==this.type?this.type-n.type:w(this.key,n.key)}equals(n){return n.type===this.type?this.key===n.key:!1}evaluate(n){return!n.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(n){return n.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=b;class c{constructor(n,m){this.key=n,this.value=m,this.type=12}static create(n,m){return new c(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:D(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(n){return n.mapGreater(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class p{constructor(n,m){this.key=n,this.value=m,this.type=13}static create(n,m){return new p(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:D(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(n){return n.mapGreaterEquals(this.key,this.value)}negate(){return S.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=p;class S{constructor(n,m){this.key=n,this.value=m,this.type=14}static create(n,m){return new S(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:D(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(n){return n.mapSmaller(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerExpr=S;class i{constructor(n,m){this.key=n,this.value=m,this.type=15}static create(n,m){return new i(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:D(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(n){return n.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=i;class s{constructor(n,m){this.key=n,this.regexp=m,this.type=7}static create(n,m){return new s(n,m)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.key<n.key)return-1;if(this.key>n.key)return 1;const m=this.regexp?this.regexp.source:"",C=n.regexp?n.regexp.source:"";return m<C?-1:m>C?1:0}equals(n){if(n.type===this.type){const m=this.regexp?this.regexp.source:"",C=n.regexp?n.regexp.source:"";return this.key===n.key&&m===C}return!1}evaluate(n){let m=n.getValue(this.key);return this.regexp?this.regexp.test(m):!1}serialize(){const n=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${n}`}keys(){return[this.key]}map(n){return n.mapRegex(this.key,this.regexp)}negate(){return u.create(this)}}e.ContextKeyRegexExpr=s;class u{constructor(n){this._actual=n,this.type=8}static create(n){return new u(n)}cmp(n){return n.type!==this.type?this.type-n.type:this._actual.cmp(n._actual)}equals(n){return n.type===this.type?this._actual.equals(n._actual):!1}evaluate(n){return!this._actual.evaluate(n)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(n){return new u(this._actual.map(n))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;class o{constructor(n){this.expr=n,this.type=6}static create(n){return o._normalizeArr(n)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.expr.length<n.expr.length)return-1;if(this.expr.length>n.expr.length)return 1;for(let m=0,C=this.expr.length;m<C;m++){const L=t(this.expr[m],n.expr[m]);if(L!==0)return L}return 0}equals(n){if(n.type===this.type){if(this.expr.length!==n.expr.length)return!1;for(let m=0,C=this.expr.length;m<C;m++)if(!this.expr[m].equals(n.expr[m]))return!1;return!0}return!1}evaluate(n){for(let m=0,C=this.expr.length;m<C;m++)if(!this.expr[m].evaluate(n))return!1;return!0}static _normalizeArr(n){const m=[];let C=!1;for(const L of n)if(!!L){if(L.type===1){C=!0;continue}if(L.type===0)return _.INSTANCE;if(L.type===6){m.push(...L.expr);continue}m.push(L)}if(m.length===0&&C)return r.INSTANCE;if(m.length!==0){if(m.length===1)return m[0];for(m.sort(t);m.length>1;){const L=m[m.length-1];if(L.type!==9)break;m.pop();const $=m.pop(),Q=f.create(L.expr.map(se=>o.create([se,$])));Q&&(m.push(Q),m.sort(t))}return m.length===1?m[0]:new o(m)}}serialize(){return this.expr.map(n=>n.serialize()).join(" && ")}keys(){const n=[];for(let m of this.expr)n.push(...m.keys());return n}map(n){return new o(this.expr.map(m=>m.map(n)))}negate(){let n=[];for(let m of this.expr)n.push(m.negate());return f.create(n)}}e.ContextKeyAndExpr=o;class f{constructor(n){this.expr=n,this.type=9}static create(n){const m=f._normalizeArr(n);if(m.length!==0)return m.length===1?m[0]:new f(m)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.expr.length<n.expr.length)return-1;if(this.expr.length>n.expr.length)return 1;for(let m=0,C=this.expr.length;m<C;m++){const L=t(this.expr[m],n.expr[m]);if(L!==0)return L}return 0}equals(n){if(n.type===this.type){if(this.expr.length!==n.expr.length)return!1;for(let m=0,C=this.expr.length;m<C;m++)if(!this.expr[m].equals(n.expr[m]))return!1;return!0}return!1}evaluate(n){for(let m=0,C=this.expr.length;m<C;m++)if(this.expr[m].evaluate(n))return!0;return!1}static _normalizeArr(n){let m=[],C=!1;if(n){for(let L=0,$=n.length;L<$;L++){const Q=n[L];if(!!Q){if(Q.type===0){C=!0;continue}if(Q.type===1)return[r.INSTANCE];if(Q.type===9){m=m.concat(Q.expr);continue}m.push(Q)}}if(m.length===0&&C)return[_.INSTANCE];m.sort(t)}return m}serialize(){return this.expr.map(n=>n.serialize()).join(" || ")}keys(){const n=[];for(let m of this.expr)n.push(...m.keys());return n}map(n){return new f(this.expr.map(m=>m.map(n)))}negate(){let n=[];for(let C of this.expr)n.push(C.negate());const m=C=>C.type===9?C.expr:[C];for(;n.length>1;){const C=n.shift(),L=n.shift(),$=[];for(const Q of m(C))for(const se of m(L))$.push(T.and(Q,se));n.unshift(T.or(...$))}return n[0]}}e.ContextKeyOrExpr=f;class v extends h{constructor(n,m,C){super(n);this._defaultValue=m,typeof C=="object"?v._info.push({...C,key:n}):C!==!0&&v._info.push({key:n,description:C,type:m!=null?typeof m:void 0})}static all(){return v._info.values()}bindTo(n){return n.createKey(this.key,this._defaultValue)}getValue(n){return n.getContextKeyValue(this.key)}toNegated(){return T.not(this.key)}isEqualTo(n){return T.equals(this.key,n)}notEqualsTo(n){return T.notEquals(this.key,n)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(P,n){return P<n?-1:P>n?1:0}function D(P,n,m,C){return P<m?-1:P>m?1:n<C?-1:n>C?1:0}}),define(we[139],be([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(we[26],be([0,1,9,4]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function E(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=E;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class k{constructor(_){this.value=_,this._lower=_.toLowerCase()}static equals(_,r){if(typeof _=="undefined"||_===null)return typeof r=="undefined"||r===null;if(typeof r=="undefined"||r===null)return!1;if(typeof _=="string"||typeof r=="string"){let h=typeof _=="string"?_:_.value,a=typeof r=="string"?r:r.value;return d.equalsIgnoreCase(h,a)}return _._lower===r._lower}static toKey(_){return typeof _=="string"?_.toLowerCase():_._lower}}e.ExtensionIdentifier=k;function y(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function T(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[140],be([0,1,9,26]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(a,l){return a.uuid&&l.uuid?a.uuid===l.uuid:a.id===l.id?!0:(0,d.compareIgnoreCase)(a.id,l.id)===0}e.areSameExtensions=E;class A{constructor(l,g){this.version=g,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof A?E(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=A;function R(a,l){return`${a}.${l}`}e.getExtensionId=R;function k(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function y(a,l){return k(R(a,l))}e.getGalleryExtensionId=y;function T(a,l){const g=[],I=b=>{for(const c of g)if(c.some(p=>E(l(p),l(b))))return c;return null};for(const b of a){const c=I(b);c?c.push(b):g.push([b])}return g}e.groupByExtension=T;function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function _(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function r(a){const l=new Set;for(const g of a)g.malicious&&l.add(g.id.id);return l}e.getMaliciousExtensionsSet=r;function h(a,l){const g=[],I=l.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const b=I.shift();if(b&&g.every(c=>!E(c.identifier,{id:b}))){const c=a.filter(p=>E(p.identifier,{id:b}));c.length===1&&(g.push(c[0]),I.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=h}),define(we[59],be([0,1,20,17,9,10,2,118,4]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function T(G){return G.create===!0}e.isFileOpenForWriteOptions=T;var t;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var _;(function(G){G[G.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var r;(function(G){G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock"})(r=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(G){return!!(G.capabilities&2)}e.hasReadWriteCapability=h;function a(G){return!!(G.capabilities&8)}e.hasFileFolderCopyCapability=a;function l(G){return!!(G.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function g(G){return!!(G.capabilities&16)}e.hasFileReadStreamCapability=g;var I;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,x){super(z);this.code=x}}e.FileSystemProviderError=b;function c(G,z){const x=new b(G.toString(),z);return S(x,z),x}e.createFileSystemProviderError=c;function p(G){return G||c((0,k.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=p;function S(G,z){return G.name=z?`${z} (FileSystemError)`:"FileSystemError",G}e.markAsFileSystemProviderError=S;function i(G){if(!G)return I.Unknown;if(G instanceof b)return G.code;const z=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!z)return I.Unknown;switch(z[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=i;function s(G){if(G instanceof D)return G.fileOperationResult;switch(i(G)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var u;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY"})(u=e.FileOperation||(e.FileOperation={}));class o{constructor(z,x,j){this.resource=z,this.operation=x,this.target=j}isOperation(z){return this.operation===z}}e.FileOperationEvent=o;var f;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class v{constructor(z,x){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const j of z)switch(j.type){case 1:this.added||(this.added=d.TernarySearchTree.forUris(()=>x)),this.added.set(j.resource,j);break;case 0:this.updated||(this.updated=d.TernarySearchTree.forUris(()=>x)),this.updated.set(j.resource,j);break;case 2:this.deleted||(this.deleted=d.TernarySearchTree.forUris(()=>x)),this.deleted.set(j.resource,j);break}}contains(z,...x){return this.doContains(z,{includeChildren:!1},...x)}affects(z,...x){return this.doContains(z,{includeChildren:!0},...x)}doContains(z,x,...j){if(!z)return!1;const B=j.length>0;return!!((!B||j.includes(1))&&(this.added?.get(z)||x.includeChildren&&this.added?.findSuperstr(z))||(!B||j.includes(0))&&(this.updated?.get(z)||x.includeChildren&&this.updated?.findSuperstr(z))||(!B||j.includes(2))&&(this.deleted?.findSubstr(z)||x.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function w(G,z,x){return!G||!z||G===z||z.length>G.length?!1:(z.charAt(z.length-1)!==F.sep&&(z+=F.sep),x?(0,E.startsWithIgnoreCase)(G,z):G.indexOf(z)===0)}e.isParent=w;class D extends Error{constructor(z,x,j){super(z);this.fileOperationResult=x,this.options=j}}e.FileOperationError=D;class P extends D{constructor(z,x,j){super(z,2,j);this.stat=x}}e.NotModifiedSinceFileOperationError=P;var n;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",G[G.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(n=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var m;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(m=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function C(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}e.etag=C;async function L(G,z){if(!z.canHandleResource(R.URI.from({scheme:G.scheme})))return new Promise(x=>{const j=z.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===G.scheme&&B.added&&(j.dispose(),x())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(z){return(0,A.isNumber)(z)||(z=0),z<$.KB?(0,k.localize)(1,null,z.toFixed(0)):z<$.MB?(0,k.localize)(2,null,(z/$.KB).toFixed(2)):z<$.GB?(0,k.localize)(3,null,(z/$.MB).toFixed(2)):z<$.TB?(0,k.localize)(4,null,(z/$.GB).toFixed(2)):(0,k.localize)(5,null,(z/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var Q;(function(G){G[G.IA32=0]="IA32",G[G.OTHER=1]="OTHER"})(Q=e.Arch||(e.Arch={}));function se(G){return{maxFileSize:G===0?300*$.MB:16*$.GB,maxHeapSize:G===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=se}),define(we[60],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...E){this._entries=new Map;for(let[A,R]of E)this.set(A,R)}set(E,A){const R=this._entries.get(E);return this._entries.set(E,A),R}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=d}),define(we[141],be([0,1,13,15,82,136,4,60]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class T extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class t{constructor(a=new k.ServiceCollection,l=!1,g){this._activeInstantiations=new Set,this._services=a,this._strict=l,this._parent=g,this._services.set(R.IInstantiationService,this)}createChild(a){return new t(a,this._strict,this)}invokeFunction(a,...l){let g=r.traceInvocation(a),I=!1;try{return a({get:(c,p)=>{if(I)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(c,g);if(!S&&p!==R.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return S}},...l)}finally{I=!0,g.stop()}}createInstance(a,...l){let g,I;return a instanceof E.SyncDescriptor?(g=r.traceCreation(a.ctor),I=this._createInstance(a.ctor,a.staticArguments.concat(l),g)):(g=r.traceCreation(a),I=this._createInstance(a,l,g)),g.stop(),I}_createInstance(a,l=[],g){let I=R._util.getServiceDependencies(a).sort((p,S)=>p.index-S.index),b=[];for(const p of I){let S=this._getOrCreateServiceInstance(p.id,g);if(!S&&this._strict&&!p.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${p.id}.`);b.push(S)}let c=I.length>0?I[0].index:l.length;if(l.length!==c){console.warn(`[createInstance] First service dependency of ${a.name} at position ${c+1} conflicts with ${l.length} static arguments`);let p=c-l.length;p>0?l=l.concat(new Array(p)):l=l.slice(0,c)}return new a(...[...l,...b])}_setServiceInstance(a,l){if(this._services.get(a)instanceof E.SyncDescriptor)this._services.set(a,l);else if(this._parent)this._parent._setServiceInstance(a,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let l=this._services.get(a);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):l}_getOrCreateServiceInstance(a,l){let g=this._getServiceInstanceOrDescriptor(a);return g instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,g,l.branch(a,!0)):(l.branch(a,!1),g)}_safeCreateAndCacheServiceInstance(a,l,g){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,l,g)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,l,g){const I=new A.Graph(p=>p.id.toString());let b=0;const c=[{id:a,desc:l,_trace:g}];for(;c.length;){const p=c.pop();if(I.lookupOrInsertNode(p),b++>1e3)throw new T(I);for(let S of R._util.getServiceDependencies(p.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(S.id);if(!i&&!S.optional&&console.warn(`[createInstance] ${a} depends on ${S.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const s={id:S.id,desc:i,_trace:p._trace.branch(S.id,!0)};I.insertEdge(p,s),c.push(s)}}}for(;;){const p=I.roots();if(p.length===0){if(!I.isEmpty())throw new T(I);break}for(const{data:S}of p){if(this._getServiceInstanceOrDescriptor(S.id)instanceof E.SyncDescriptor){const s=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,s)}I.removeNode(S)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,l,g=[],I,b){if(this._services.get(a)instanceof E.SyncDescriptor)return this._createServiceInstance(l,g,I,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,l,g,I,b);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(a,l=[],g,I){if(g){const b=new d.IdleValue(()=>this._createInstance(a,l,I));return new Proxy(Object.create(null),{get(c,p){if(p in c)return c[p];let S=b.value,i=S[p];return typeof i!="function"||(i=i.bind(S),c[p]=i),i},set(c,p,S){return b.value[p]=S,!0}})}else return this._createInstance(a,l,I)}}e.InstantiationService=t;var _;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(_||(_={}));class r{constructor(a,l){this.type=a,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return y?new r(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):r._None}static traceCreation(a){return y?new r(0,a.name):r._None}branch(a,l){let g=new r(2,a.toString());return this._dep.push([a,l,g]),g}stop(){let a=Date.now()-this._start;r._totals+=a;let l=!1;function g(b,c){let p=[],S=new Array(b+1).join("	");for(const[i,s,u]of c._dep)if(s&&u){l=!0,p.push(`${S}CREATES -> ${i}`);let o=g(b+1,u);o&&p.push(o)}else p.push(`${S}uses -> ${i}`);return p.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${r._totals.toFixed(2)}ms)`];(a>2||l)&&console.log(I.join(`
`))}}r._None=new class extends r{constructor(){super(-1,null)}stop(){}branch(){return this}},r._totals=0}),define(we[14],be([0,1,55,3,7,25,4]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function k(){return new Date().toISOString()}var y;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class T extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class t extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([i,...s]))}debug(i,...s){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([i,...s]))}info(i,...s){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([i,...s]))}warn(i,...s){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([i,...s]))}error(i,...s){if(this.checkLogLevel(y.Error))if(i instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=i.stack,this.log(y.Error,this.format(u))}else this.log(y.Error,this.format([i,...s]))}critical(i,...s){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([i,...s]))}flush(){}format(i){let s="";for(let u=0;u<i.length;u++){let o=i[u];if(typeof o=="object")try{o=JSON.stringify(o)}catch(f){}s+=(u>0?" ":"")+o}return s}}e.AbstractMessageLogger=t;class _ extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...s){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...s):console.log(`[main ${k()}]`,i,...s))}debug(i,...s){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...s):console.log(`[main ${k()}]`,i,...s))}info(i,...s){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...s):console.log(`[main ${k()}]`,i,...s))}warn(i,...s){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...s):console.warn(`[main ${k()}]`,i,...s))}error(i,...s){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...s):console.error(`[main ${k()}]`,i,...s))}critical(i,...s){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...s):console.error(`[main ${k()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class r extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=r;class h extends T{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class a extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const u of this.logServices)u.trace(i,...s)}debug(i,...s){for(const u of this.logServices)u.debug(i,...s)}info(i,...s){for(const u of this.logServices)u.info(i,...s)}warn(i,...s){for(const u of this.logServices)u.warn(i,...s)}error(i,...s){for(const u of this.logServices)u.error(i,...s)}critical(i,...s){for(const u of this.logServices)u.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=a;class l extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=l;class g extends E.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(u))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let u=this.loggers.get(i.toString());return u||(u=this.doCreateLogger(i,s?.always?y.Trace:this.logLevel,s),this.loggers.set(i.toString(),u),s?.always||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class I{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(i){}getLevel(){return y.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=I;function b(S){if(S.verbose)return y.Trace;if(typeof S.logLevel=="string"){const i=c(S.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function c(S){switch(S){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=c;function p(S){switch(S){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=p}),define(we[83],be([0,1,35,119,4]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(a,l){return l-a}y.compare=T;const t=Object.create(null);t[y.Error]=(0,F.localize)(0,null),t[y.Warning]=(0,F.localize)(1,null),t[y.Info]=(0,F.localize)(2,null);function _(a){return t[a]||""}y.toString=_;function r(a){switch(a){case d.default.Error:return y.Error;case d.default.Warning:return y.Warning;case d.default.Info:return y.Info;case d.default.Ignore:return y.Hint}}y.fromSeverity=r;function h(a){switch(a){case y.Error:return d.default.Error;case y.Warning:return d.default.Warning;case y.Info:return d.default.Info;case y.Hint:return d.default.Ignore}}y.toSeverity=h}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const T="";function t(r){return _(r,!0)}y.makeKey=t;function _(r,h){let a=[T];return r.source?a.push(r.source.replace("\xA6","\\\xA6")):a.push(T),r.code?typeof r.code=="string"?a.push(r.code.replace("\xA6","\\\xA6")):a.push(r.code.value.replace("\xA6","\\\xA6")):a.push(T),r.severity!==void 0&&r.severity!==null?a.push(R.toString(r.severity)):a.push(T),r.message&&h?a.push(r.message.replace("\xA6","\\\xA6")):a.push(T),r.startLineNumber!==void 0&&r.startLineNumber!==null?a.push(r.startLineNumber.toString()):a.push(T),r.startColumn!==void 0&&r.startColumn!==null?a.push(r.startColumn.toString()):a.push(T),r.endLineNumber!==void 0&&r.endLineNumber!==null?a.push(r.endLineNumber.toString()):a.push(T),r.endColumn!==void 0&&r.endColumn!==null?a.push(r.endColumn.toString()):a.push(T),a.push(T),a.join("\xA6")}y.makeKeyOptionalMessage=_})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(we[142],be([0,1,3,35,4]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new y,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=k;class y{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=y}),define(we[143],be([0,1,7,9,2,4]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function R(k,y){return E.URI.isUri(k)?(0,F.equalsIgnoreCase)(k.scheme,y):(0,F.startsWithIgnoreCase)(k,y+":")}e.matchesScheme=R}),define(we[144],be([0,1,11,25,61,24]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof F.globals.vscode!="undefined"&&typeof F.globals.vscode.context!="undefined"){const k=F.globals.vscode.context.configuration();if(k)R=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ie?.__$__nodeRequire=="function"){const k=(0,A.dirname)(d.FileAccess.asFileUri("",ie));R=ie.__$__nodeRequire((0,A.joinPath)(k,"product.json").fsPath);const y=ie.__$__nodeRequire((0,A.joinPath)(k,"package.json").fsPath);E.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:y.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.60.0-dev",nameShort:F.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:F.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R}),define(we[145],be([0,1,115,25,146,144]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var R;(function(W){W[W.None=0]="None",W[W.Keep=1]="Keep",W[W.Brackets=2]="Brackets",W[W.Advanced=3]="Advanced",W[W.Full=4]="Full"})(R=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=k;class y{constructor(){this._values=[]}_read(Y){return this._values[Y]}get(Y){return this._values[Y]}_write(Y,me){this._values[Y]=me}}e.ValidatedEditorOptions=y;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class t{constructor(Y,me,Ne,Ye){this.id=Y,this.name=me,this.defaultValue=Ne,this.schema=Ye}compute(Y,me,Ne){return Ne}}class _{constructor(Y,me=null){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(Y){return this.defaultValue}}class r{constructor(Y,me,Ne,Ye){this.id=Y,this.name=me,this.defaultValue=Ne,this.schema=Ye}validate(Y){return typeof Y=="undefined"?this.defaultValue:Y}compute(Y,me,Ne){return Ne}}function h(W,Y){return typeof W=="undefined"?Y:W==="false"?!1:Boolean(W)}e.boolean=h;class a extends r{constructor(Y,me,Ne,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ne),super(Y,me,Ne,Ye)}validate(Y){return h(Y,this.defaultValue)}}class l extends r{constructor(Y,me,Ne,Ye,tt,at=void 0){typeof at!="undefined"&&(at.type="integer",at.default=Ne,at.minimum=Ye,at.maximum=tt),super(Y,me,Ne,at),this.minimum=Ye,this.maximum=tt}static clampedInt(Y,me,Ne,Ye){if(typeof Y=="undefined")return me;let tt=parseInt(Y,10);return isNaN(tt)?me:(tt=Math.max(Ne,tt),tt=Math.min(Ye,tt),tt|0)}validate(Y){return l.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class g extends r{constructor(Y,me,Ne,Ye,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Ne),super(Y,me,Ne,tt),this.validationFn=Ye}static clamp(Y,me,Ne){return Y<me?me:Y>Ne?Ne:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y=="undefined")return me;const Ne=parseFloat(Y);return isNaN(Ne)?me:Ne}validate(Y){return this.validationFn(g.float(Y,this.defaultValue))}}class I extends r{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Ne,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ne),super(Y,me,Ne,Ye)}validate(Y){return I.string(Y,this.defaultValue)}}function b(W,Y,me){return typeof W!="string"||me.indexOf(W)===-1?Y:W}e.stringSet=b;class c extends r{constructor(Y,me,Ne,Ye,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ye,tt.default=Ne),super(Y,me,Ne,tt),this._allowedValues=Ye}validate(Y){return b(Y,this.defaultValue,this._allowedValues)}}class p extends t{constructor(Y,me,Ne,Ye,tt,at,vt=void 0){typeof vt!="undefined"&&(vt.type="string",vt.enum=tt,vt.default=Ye),super(Y,me,Ne,vt),this._allowedValues=tt,this._convert=at}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function S(W){switch(W){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends t{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Ne){return Ne===0?Y.accessibilitySupport:Ne}}class s extends t{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:d.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:h(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var u;(function(W){W[W.Hidden=0]="Hidden",W[W.Blink=1]="Blink",W[W.Smooth=2]="Smooth",W[W.Phase=3]="Phase",W[W.Expand=4]="Expand",W[W.Solid=5]="Solid"})(u=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(W){switch(W){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(W){W[W.Line=1]="Line",W[W.Block=2]="Block",W[W.Underline=3]="Underline",W[W.LineThin=4]="LineThin",W[W.BlockOutline=5]="BlockOutline",W[W.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function v(W){switch(W){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function w(W){switch(W){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class D extends _{constructor(){super(127,[65,32])}compute(Y,me,Ne){const Ye=["monaco-editor"];return me.get(32)&&Ye.push(me.get(32)),Y.extraEditorClassName&&Ye.push(Y.extraEditorClassName),me.get(65)==="default"?Ye.push("mouse-default"):me.get(65)==="copy"&&Ye.push("mouse-copy"),me.get(100)&&Ye.push("showUnused"),me.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class P extends a{constructor(){super(31,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(Y,me,Ne){return Ne&&Y.emptySelectionClipboard}}class n extends t{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:d.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:d.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:h(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":b(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(me.loop,this.defaultValue.loop)}}}class m extends t{constructor(){super(43,"fontLigatures",m.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(Y){return typeof Y=="undefined"?this.defaultValue:typeof Y=="string"?Y==="false"?m.OFF:Y==="true"?m.ON:Y:Boolean(Y)?m.ON:m.OFF}}e.EditorFontLigatures=m,m.OFF='"liga" off, "calt" off',m.ON='"liga" on, "calt" on';class C extends _{constructor(){super(42)}compute(Y,me,Ne){return Y.fontInfo}}class L extends r{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(Y){let me=g.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(me,6,100)}compute(Y,me,Ne){return Y.fontInfo.fontSize}}class $ extends t{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(l.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class Q extends t{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Ne,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Ne,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Ne,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Ne,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Ne,description:d.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:b(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??b(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??b(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??b(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??b(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??b(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class se extends t{constructor(){const Y={enabled:!0,delay:300,sticky:!0};super(52,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:d.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),delay:l.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:h(me.sticky,this.defaultValue.sticky)}}}var G;(function(W){W[W.None=0]="None",W[W.Text=1]="Text",W[W.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class z extends _{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(Y,me,Ne){return z.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Ne=Y.scrollBeyondLastLine?me-1:0,Ye=(Y.viewLineCount+Ne)/(Y.pixelRatio*Y.height),tt=Math.floor(Y.viewLineCount/Ye);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Ne,desiredRatio:Ye,minimapLineCount:tt}}static _computeMinimapLayout(Y,me){const Ne=Y.outerWidth,Ye=Y.outerHeight,tt=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const at=me.stableMinimapLayoutInput,vt=at&&Y.outerHeight===at.outerHeight&&Y.lineHeight===at.lineHeight&&Y.typicalHalfwidthCharacterWidth===at.typicalHalfwidthCharacterWidth&&Y.pixelRatio===at.pixelRatio&&Y.scrollBeyondLastLine===at.scrollBeyondLastLine&&Y.minimap.enabled===at.minimap.enabled&&Y.minimap.side===at.minimap.side&&Y.minimap.size===at.minimap.size&&Y.minimap.showSlider===at.minimap.showSlider&&Y.minimap.renderCharacters===at.minimap.renderCharacters&&Y.minimap.maxColumn===at.minimap.maxColumn&&Y.minimap.scale===at.minimap.scale&&Y.verticalScrollbarWidth===at.verticalScrollbarWidth&&Y.isViewportWrapping===at.isViewportWrapping,kt=Y.lineHeight,ht=Y.typicalHalfwidthCharacterWidth,yt=Y.scrollBeyondLastLine,It=Y.minimap.renderCharacters;let ft=tt>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Je=Y.minimap.maxColumn,Et=Y.minimap.size,Pe=Y.minimap.side,ye=Y.verticalScrollbarWidth,De=Y.viewLineCount,X=Y.remainingWidth,ue=Y.isViewportWrapping,ge=It?2:3;let fe=Math.floor(tt*Ye);const Ie=fe/tt;let xe=!1,Le=!1,Ve=ge*ft,Xe=ft/tt,te=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:We,extraLinesBeyondLastLine:it,desiredRatio:mt,minimapLineCount:wt}=z.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:yt,height:Ye,lineHeight:kt,pixelRatio:tt});if(De/wt>1)xe=!0,Le=!0,ft=1,Ve=1,Xe=ft/tt;else{let ct=!1,lt=ft+1;if(Et==="fit"){const Tt=Math.ceil((De+it)*Ve);ue&&vt&&X<=me.stableFitRemainingWidth?(ct=!0,lt=me.stableFitMaxMinimapScale):ct=Tt>fe}if(Et==="fill"||ct){xe=!0;const Tt=ft;Ve=Math.min(kt*tt,Math.max(1,Math.floor(1/mt))),ue&&vt&&X<=me.stableFitRemainingWidth&&(lt=me.stableFitMaxMinimapScale),ft=Math.min(lt,Math.max(1,Math.floor(Ve/ge))),ft>Tt&&(te=Math.min(2,ft/Tt)),Xe=ft/tt/te,fe=Math.ceil(Math.max(We,De+it)*Ve),ue?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=X,me.stableFitMaxMinimapScale=ft):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const pe=Math.floor(Je*Xe),ne=Math.min(pe,Math.max(0,Math.floor((X-ye-2)*Xe/(ht+Xe)))+e.MINIMAP_GUTTER_WIDTH);let U=Math.floor(tt*ne);const Ce=U/tt;U=Math.floor(U*te);const Se=It?1:2,qe=Pe==="left"?0:Ne-ne-ye;return{renderMinimap:Se,minimapLeft:qe,minimapWidth:ne,minimapHeightIsEditorHeight:xe,minimapIsSampling:Le,minimapScale:ft,minimapLineHeight:Ve,minimapCanvasInnerWidth:U,minimapCanvasInnerHeight:fe,minimapCanvasOuterWidth:Ce,minimapCanvasOuterHeight:Ie}}static computeLayout(Y,me){const Ne=me.outerWidth|0,Ye=me.outerHeight|0,tt=me.lineHeight|0,at=me.lineNumbersDigitCount|0,vt=me.typicalHalfwidthCharacterWidth,kt=me.maxDigitWidth,ht=me.pixelRatio,yt=me.viewLineCount,It=Y.get(122),ft=It==="inherit"?Y.get(121):It,Je=ft==="inherit"?Y.get(117):ft,Et=Y.get(120),Pe=Y.get(2),ye=me.isDominatedByLongLines,De=Y.get(48),X=Y.get(59).renderType!==0,ue=Y.get(60),ge=Y.get(94),fe=Y.get(64),Ie=Y.get(92),xe=Ie.verticalScrollbarSize,Le=Ie.verticalHasArrows,Ve=Ie.arrowSize,Xe=Ie.horizontalScrollbarSize,te=Y.get(57),pe=Y.get(36);let ne;if(typeof te=="string"&&/^\d+(\.\d+)?ch$/.test(te)){const Bt=parseFloat(te.substr(0,te.length-2));ne=l.clampedInt(Bt*vt,0,0,1e3)}else ne=l.clampedInt(te,0,0,1e3);pe&&(ne+=16);let U=0;if(X){const Bt=Math.max(at,ue);U=Math.round(Bt*kt)}let Ce=0;De&&(Ce=tt);let Se=0,qe=Se+Ce,We=qe+U,it=We+ne;const mt=Ne-Ce-U-ne;let wt=!1,ot=!1,ct=-1;Pe!==2&&(ft==="inherit"&&ye?(wt=!0,ot=!0):Je==="on"||Je==="bounded"?ot=!0:Je==="wordWrapColumn"&&(ct=Et));const lt=z._computeMinimapLayout({outerWidth:Ne,outerHeight:Ye,lineHeight:tt,typicalHalfwidthCharacterWidth:vt,pixelRatio:ht,scrollBeyondLastLine:ge,minimap:fe,verticalScrollbarWidth:xe,viewLineCount:yt,remainingWidth:mt,isViewportWrapping:ot},me.memory||new T);lt.renderMinimap!==0&&lt.minimapLeft===0&&(Se+=lt.minimapWidth,qe+=lt.minimapWidth,We+=lt.minimapWidth,it+=lt.minimapWidth);const Tt=mt-lt.minimapWidth,_t=Math.max(1,Math.floor((Tt-xe-2)/vt)),Ut=Le?Ve:0;return ot&&(ct=Math.max(1,_t),Je==="bounded"&&(ct=Math.min(ct,Et))),{width:Ne,height:Ye,glyphMarginLeft:Se,glyphMarginWidth:Ce,lineNumbersLeft:qe,lineNumbersWidth:U,decorationsLeft:We,decorationsWidth:ne,contentLeft:it,contentWidth:Tt,minimap:lt,viewportColumn:_t,isWordWrapMinified:wt,isViewportWrapping:ot,wrappingColumn:ct,verticalScrollbarWidth:xe,horizontalScrollbarHeight:Xe,overviewRuler:{top:Ut,width:xe,height:Ye-2*Ut,right:0}}}}e.EditorLayoutInfoComputer=z;class x extends t{constructor(){const Y={enabled:!0};super(56,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:d.localize(42,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:h(Y.enabled,this.defaultValue.enabled)}}}class j extends t{constructor(){const Y={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"boolean",default:Y.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,description:d.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(me.fontFamily,this.defaultValue.fontFamily)}}}class B extends g{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>g.clamp(Y,0,150),{markdownDescription:d.localize(46,null)})}compute(Y,me,Ne){return Y.fontInfo.lineHeight}}class q extends t{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:Y.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:d.localize(56,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(me.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(me.scale,1,1,3),maxColumn:l.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ce(W){return W==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends t{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:l.clampedInt(me.top,0,0,1e3),bottom:l.clampedInt(me.bottom,0,0,1e3)}}}class le extends t{constructor(){const Y={enabled:!0,cycle:!1};super(75,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:d.localize(60,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),cycle:h(me.cycle,this.defaultValue.cycle)}}}class ae extends _{constructor(){super(128)}compute(Y,me,Ne){return Y.pixelRatio}}class ve extends t{constructor(){const Y={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Y,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Y.strings,description:d.localize(61,null)},comments:{type:"boolean",default:Y.comments,description:d.localize(62,null)},other:{type:"boolean",default:Y.other,description:d.localize(63,null)}}}],default:Y,description:d.localize(64,null)});this.defaultValue=Y}validate(Y){if(typeof Y=="boolean")return Y;if(Y&&typeof Y=="object"){const me=Y,Ne={other:h(me.other,this.defaultValue.other),comments:h(me.comments,this.defaultValue.comments),strings:h(me.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Ae;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval",W[W.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends t{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(Y){let me=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Y!="undefined"&&(typeof Y=="function"?(me=4,Ne=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Ne}}}function Oe(W){const Y=W.get(87);return Y==="editable"?W.get(80):Y!=="on"}e.filterValidationDecorations=Oe;class Qe extends t{constructor(){const Y=[],me={type:"number",description:d.localize(70,null)};super(91,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:Y,description:d.localize(72,null)})}validate(Y){if(Array.isArray(Y)){let me=[];for(let Ne of Y)if(typeof Ne=="number")me.push({column:l.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ye=Ne;me.push({column:l.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return me.sort((Ne,Ye)=>Ne.column-Ye.column),me}return this.defaultValue}}function He(W,Y){if(typeof W!="string")return Y;switch(W){case"hidden":return 2;case"visible":return 3;default:return 1}}class je extends t{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:d.localize(83,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Ne=l.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=l.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:He(me.vertical,this.defaultValue.vertical),horizontal:He(me.horizontal,this.defaultValue.horizontal),useShadows:h(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:l.clampedInt(me.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:l.clampedInt(me.verticalSliderSize,Ye,0,1e3),scrollByPage:h(me.scrollByPage,this.defaultValue.scrollByPage)}}}class N extends t{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:d.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[d.localize(85,null),d.localize(86,null),d.localize(87,null)],default:Y.mode,description:d.localize(88,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends t{constructor(){const Y={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,description:d.localize(89,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:h(Y.enabled,this.defaultValue.enabled)}}}class Z extends t{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(90,null),d.localize(91,null)],default:Y.insertMode,description:d.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:d.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:d.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:d.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:d.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:d.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:d.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:d.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[d.localize(100,null),d.localize(101,null),d.localize(102,null)],default:Y.previewMode,description:d.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:d.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(me.showIcons,this.defaultValue.showIcons),showStatusBar:h(me.showStatusBar,this.defaultValue.showStatusBar),preview:h(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(me.showMethods,this.defaultValue.showMethods),showFunctions:h(me.showFunctions,this.defaultValue.showFunctions),showConstructors:h(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(me.showDeprecated,this.defaultValue.showDeprecated),showFields:h(me.showFields,this.defaultValue.showFields),showVariables:h(me.showVariables,this.defaultValue.showVariables),showClasses:h(me.showClasses,this.defaultValue.showClasses),showStructs:h(me.showStructs,this.defaultValue.showStructs),showInterfaces:h(me.showInterfaces,this.defaultValue.showInterfaces),showModules:h(me.showModules,this.defaultValue.showModules),showProperties:h(me.showProperties,this.defaultValue.showProperties),showEvents:h(me.showEvents,this.defaultValue.showEvents),showOperators:h(me.showOperators,this.defaultValue.showOperators),showUnits:h(me.showUnits,this.defaultValue.showUnits),showValues:h(me.showValues,this.defaultValue.showValues),showConstants:h(me.showConstants,this.defaultValue.showConstants),showEnums:h(me.showEnums,this.defaultValue.showEnums),showEnumMembers:h(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(me.showKeywords,this.defaultValue.showKeywords),showWords:h(me.showWords,this.defaultValue.showWords),showColors:h(me.showColors,this.defaultValue.showColors),showFiles:h(me.showFiles,this.defaultValue.showFiles),showReferences:h(me.showReferences,this.defaultValue.showReferences),showFolders:h(me.showFolders,this.defaultValue.showFolders),showTypeParameters:h(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(me.showSnippets,this.defaultValue.showSnippets),showUsers:h(me.showUsers,this.defaultValue.showUsers),showIssues:h(me.showIssues,this.defaultValue.showIssues)}}}class oe extends t{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(136,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class H extends _{constructor(){super(129,[80])}compute(Y,me,Ne){return me.get(80)?!0:Y.tabFocusMode}}var re;(function(W){W[W.None=0]="None",W[W.Same=1]="Same",W[W.Indent=2]="Indent",W[W.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function he(W){switch(W){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Te extends _{constructor(){super(131,[130])}compute(Y,me,Ne){const Ye=me.get(130);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",$e="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?$e:F.isLinux?Ke:Ue,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:A.default.quality!=="stable"}},e.editorOptionsRegistry=[];function _e(W){return e.editorOptionsRegistry[W.id]=W,W}var rt;(function(W){W[W.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",W[W.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",W[W.accessibilitySupport=2]="accessibilitySupport",W[W.accessibilityPageSize=3]="accessibilityPageSize",W[W.ariaLabel=4]="ariaLabel",W[W.autoClosingBrackets=5]="autoClosingBrackets",W[W.autoClosingDelete=6]="autoClosingDelete",W[W.autoClosingOvertype=7]="autoClosingOvertype",W[W.autoClosingQuotes=8]="autoClosingQuotes",W[W.autoIndent=9]="autoIndent",W[W.automaticLayout=10]="automaticLayout",W[W.autoSurround=11]="autoSurround",W[W.bracketPairColorization=12]="bracketPairColorization",W[W.codeLens=13]="codeLens",W[W.codeLensFontFamily=14]="codeLensFontFamily",W[W.codeLensFontSize=15]="codeLensFontSize",W[W.colorDecorators=16]="colorDecorators",W[W.columnSelection=17]="columnSelection",W[W.comments=18]="comments",W[W.contextmenu=19]="contextmenu",W[W.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",W[W.cursorBlinking=21]="cursorBlinking",W[W.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",W[W.cursorStyle=23]="cursorStyle",W[W.cursorSurroundingLines=24]="cursorSurroundingLines",W[W.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",W[W.cursorWidth=26]="cursorWidth",W[W.disableLayerHinting=27]="disableLayerHinting",W[W.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",W[W.domReadOnly=29]="domReadOnly",W[W.dragAndDrop=30]="dragAndDrop",W[W.emptySelectionClipboard=31]="emptySelectionClipboard",W[W.extraEditorClassName=32]="extraEditorClassName",W[W.fastScrollSensitivity=33]="fastScrollSensitivity",W[W.find=34]="find",W[W.fixedOverflowWidgets=35]="fixedOverflowWidgets",W[W.folding=36]="folding",W[W.foldingStrategy=37]="foldingStrategy",W[W.foldingHighlight=38]="foldingHighlight",W[W.foldingImportsByDefault=39]="foldingImportsByDefault",W[W.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",W[W.fontFamily=41]="fontFamily",W[W.fontInfo=42]="fontInfo",W[W.fontLigatures=43]="fontLigatures",W[W.fontSize=44]="fontSize",W[W.fontWeight=45]="fontWeight",W[W.formatOnPaste=46]="formatOnPaste",W[W.formatOnType=47]="formatOnType",W[W.glyphMargin=48]="glyphMargin",W[W.gotoLocation=49]="gotoLocation",W[W.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",W[W.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",W[W.hover=52]="hover",W[W.inDiffEditor=53]="inDiffEditor",W[W.inlineSuggest=54]="inlineSuggest",W[W.letterSpacing=55]="letterSpacing",W[W.lightbulb=56]="lightbulb",W[W.lineDecorationsWidth=57]="lineDecorationsWidth",W[W.lineHeight=58]="lineHeight",W[W.lineNumbers=59]="lineNumbers",W[W.lineNumbersMinChars=60]="lineNumbersMinChars",W[W.linkedEditing=61]="linkedEditing",W[W.links=62]="links",W[W.matchBrackets=63]="matchBrackets",W[W.minimap=64]="minimap",W[W.mouseStyle=65]="mouseStyle",W[W.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",W[W.mouseWheelZoom=67]="mouseWheelZoom",W[W.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",W[W.multiCursorModifier=69]="multiCursorModifier",W[W.multiCursorPaste=70]="multiCursorPaste",W[W.occurrencesHighlight=71]="occurrencesHighlight",W[W.overviewRulerBorder=72]="overviewRulerBorder",W[W.overviewRulerLanes=73]="overviewRulerLanes",W[W.padding=74]="padding",W[W.parameterHints=75]="parameterHints",W[W.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",W[W.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",W[W.quickSuggestions=78]="quickSuggestions",W[W.quickSuggestionsDelay=79]="quickSuggestionsDelay",W[W.readOnly=80]="readOnly",W[W.renameOnType=81]="renameOnType",W[W.renderControlCharacters=82]="renderControlCharacters",W[W.renderIndentGuides=83]="renderIndentGuides",W[W.renderFinalNewline=84]="renderFinalNewline",W[W.renderLineHighlight=85]="renderLineHighlight",W[W.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",W[W.renderValidationDecorations=87]="renderValidationDecorations",W[W.renderWhitespace=88]="renderWhitespace",W[W.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",W[W.roundedSelection=90]="roundedSelection",W[W.rulers=91]="rulers",W[W.scrollbar=92]="scrollbar",W[W.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",W[W.scrollBeyondLastLine=94]="scrollBeyondLastLine",W[W.scrollPredominantAxis=95]="scrollPredominantAxis",W[W.selectionClipboard=96]="selectionClipboard",W[W.selectionHighlight=97]="selectionHighlight",W[W.selectOnLineNumbers=98]="selectOnLineNumbers",W[W.showFoldingControls=99]="showFoldingControls",W[W.showUnused=100]="showUnused",W[W.snippetSuggestions=101]="snippetSuggestions",W[W.smartSelect=102]="smartSelect",W[W.smoothScrolling=103]="smoothScrolling",W[W.stickyTabStops=104]="stickyTabStops",W[W.stopRenderingLineAfter=105]="stopRenderingLineAfter",W[W.suggest=106]="suggest",W[W.suggestFontSize=107]="suggestFontSize",W[W.suggestLineHeight=108]="suggestLineHeight",W[W.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",W[W.suggestSelection=110]="suggestSelection",W[W.tabCompletion=111]="tabCompletion",W[W.tabIndex=112]="tabIndex",W[W.unusualLineTerminators=113]="unusualLineTerminators",W[W.useShadowDOM=114]="useShadowDOM",W[W.useTabStops=115]="useTabStops",W[W.wordSeparators=116]="wordSeparators",W[W.wordWrap=117]="wordWrap",W[W.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",W[W.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",W[W.wordWrapColumn=120]="wordWrapColumn",W[W.wordWrapOverride1=121]="wordWrapOverride1",W[W.wordWrapOverride2=122]="wordWrapOverride2",W[W.wrappingIndent=123]="wrappingIndent",W[W.wrappingStrategy=124]="wrappingStrategy",W[W.showDeprecated=125]="showDeprecated",W[W.inlayHints=126]="inlayHints",W[W.editorClassName=127]="editorClassName",W[W.pixelRatio=128]="pixelRatio",W[W.tabFocusMode=129]="tabFocusMode",W[W.layoutInfo=130]="layoutInfo",W[W.wrappingInfo=131]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(137,null)})),acceptSuggestionOnEnter:_e(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(138,null),""],markdownDescription:d.localize(139,null)})),accessibilitySupport:_e(new i),accessibilityPageSize:_e(new l(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(140,null)})),ariaLabel:_e(new I(4,"ariaLabel",d.localize(141,null))),autoClosingBrackets:_e(new c(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(142,null),d.localize(143,null),""],description:d.localize(144,null)})),autoClosingDelete:_e(new c(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(145,null),""],description:d.localize(146,null)})),autoClosingOvertype:_e(new c(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(147,null),""],description:d.localize(148,null)})),autoClosingQuotes:_e(new c(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(149,null),d.localize(150,null),""],description:d.localize(151,null)})),autoIndent:_e(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[d.localize(152,null),d.localize(153,null),d.localize(154,null),d.localize(155,null),d.localize(156,null)],description:d.localize(157,null)})),automaticLayout:_e(new a(10,"automaticLayout",!1)),autoSurround:_e(new c(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(158,null),d.localize(159,null),d.localize(160,null),""],description:d.localize(161,null)})),bracketPairColorization:_e(new K),stickyTabStops:_e(new a(104,"stickyTabStops",!1,{description:d.localize(162,null)})),codeLens:_e(new a(13,"codeLens",!0,{description:d.localize(163,null)})),codeLensFontFamily:_e(new I(14,"codeLensFontFamily","",{description:d.localize(164,null)})),codeLensFontSize:_e(new l(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(165,null)})),colorDecorators:_e(new a(16,"colorDecorators",!0,{description:d.localize(166,null)})),columnSelection:_e(new a(17,"columnSelection",!1,{description:d.localize(167,null)})),comments:_e(new s),contextmenu:_e(new a(19,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new a(20,"copyWithSyntaxHighlighting",!0,{description:d.localize(168,null)})),cursorBlinking:_e(new p(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:d.localize(169,null)})),cursorSmoothCaretAnimation:_e(new a(22,"cursorSmoothCaretAnimation",!1,{description:d.localize(170,null)})),cursorStyle:_e(new p(23,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:d.localize(171,null)})),cursorSurroundingLines:_e(new l(24,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(172,null)})),cursorSurroundingLinesStyle:_e(new c(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(173,null),d.localize(174,null)],description:d.localize(175,null)})),cursorWidth:_e(new l(26,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(176,null)})),disableLayerHinting:_e(new a(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new a(28,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new a(29,"domReadOnly",!1)),dragAndDrop:_e(new a(30,"dragAndDrop",!0,{description:d.localize(177,null)})),emptySelectionClipboard:_e(new P),extraEditorClassName:_e(new I(32,"extraEditorClassName","")),fastScrollSensitivity:_e(new g(33,"fastScrollSensitivity",5,W=>W<=0?5:W,{markdownDescription:d.localize(178,null)})),find:_e(new n),fixedOverflowWidgets:_e(new a(35,"fixedOverflowWidgets",!1)),folding:_e(new a(36,"folding",!0,{description:d.localize(179,null)})),foldingStrategy:_e(new c(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(180,null),d.localize(181,null)],description:d.localize(182,null)})),foldingHighlight:_e(new a(38,"foldingHighlight",!0,{description:d.localize(183,null)})),foldingImportsByDefault:_e(new a(39,"foldingImportsByDefault",!1,{description:d.localize(184,null)})),unfoldOnClickAfterEndOfLine:_e(new a(40,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(185,null)})),fontFamily:_e(new I(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(186,null)})),fontInfo:_e(new C),fontLigatures2:_e(new m),fontSize:_e(new L),fontWeight:_e(new $),formatOnPaste:_e(new a(46,"formatOnPaste",!1,{description:d.localize(187,null)})),formatOnType:_e(new a(47,"formatOnType",!1,{description:d.localize(188,null)})),glyphMargin:_e(new a(48,"glyphMargin",!0,{description:d.localize(189,null)})),gotoLocation:_e(new Q),hideCursorInOverviewRuler:_e(new a(50,"hideCursorInOverviewRuler",!1,{description:d.localize(190,null)})),highlightActiveIndentGuide:_e(new a(51,"highlightActiveIndentGuide",!0,{description:d.localize(191,null)})),hover:_e(new se),inDiffEditor:_e(new a(53,"inDiffEditor",!1)),letterSpacing:_e(new g(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,W=>g.clamp(W,-5,20),{description:d.localize(192,null)})),lightbulb:_e(new x),lineDecorationsWidth:_e(new r(57,"lineDecorationsWidth",10)),lineHeight:_e(new B),lineNumbers:_e(new Re),lineNumbersMinChars:_e(new l(60,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new a(61,"linkedEditing",!1,{description:d.localize(193,null)})),links:_e(new a(62,"links",!0,{description:d.localize(194,null)})),matchBrackets:_e(new c(63,"matchBrackets","always",["always","near","never"],{description:d.localize(195,null)})),minimap:_e(new q),mouseStyle:_e(new c(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new g(66,"mouseWheelScrollSensitivity",1,W=>W===0?1:W,{markdownDescription:d.localize(196,null)})),mouseWheelZoom:_e(new a(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(197,null)})),multiCursorMergeOverlapping:_e(new a(68,"multiCursorMergeOverlapping",!0,{description:d.localize(198,null)})),multiCursorModifier:_e(new p(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[d.localize(199,null),d.localize(200,null)],markdownDescription:d.localize(201,null)})),multiCursorPaste:_e(new c(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(202,null),d.localize(203,null)],markdownDescription:d.localize(204,null)})),occurrencesHighlight:_e(new a(71,"occurrencesHighlight",!0,{description:d.localize(205,null)})),overviewRulerBorder:_e(new a(72,"overviewRulerBorder",!0,{description:d.localize(206,null)})),overviewRulerLanes:_e(new l(73,"overviewRulerLanes",3,0,3)),padding:_e(new V),parameterHints:_e(new le),peekWidgetDefaultFocus:_e(new c(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(207,null),d.localize(208,null)],description:d.localize(209,null)})),definitionLinkOpensInPeek:_e(new a(77,"definitionLinkOpensInPeek",!1,{description:d.localize(210,null)})),quickSuggestions:_e(new ve),quickSuggestionsDelay:_e(new l(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(211,null)})),readOnly:_e(new a(80,"readOnly",!1)),renameOnType:_e(new a(81,"renameOnType",!1,{description:d.localize(212,null),markdownDeprecationMessage:d.localize(213,null)})),renderControlCharacters:_e(new a(82,"renderControlCharacters",!1,{description:d.localize(214,null)})),renderIndentGuides:_e(new a(83,"renderIndentGuides",!0,{description:d.localize(215,null)})),renderFinalNewline:_e(new a(84,"renderFinalNewline",!0,{description:d.localize(216,null)})),renderLineHighlight:_e(new c(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(217,null)],description:d.localize(218,null)})),renderLineHighlightOnlyWhenFocus:_e(new a(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(219,null)})),renderValidationDecorations:_e(new c(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new c(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(220,null),d.localize(221,null),d.localize(222,null),""],description:d.localize(223,null)})),revealHorizontalRightPadding:_e(new l(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new a(90,"roundedSelection",!0,{description:d.localize(224,null)})),rulers:_e(new Qe),scrollbar:_e(new je),scrollBeyondLastColumn:_e(new l(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(225,null)})),scrollBeyondLastLine:_e(new a(94,"scrollBeyondLastLine",!0,{description:d.localize(226,null)})),scrollPredominantAxis:_e(new a(95,"scrollPredominantAxis",!0,{description:d.localize(227,null)})),selectionClipboard:_e(new a(96,"selectionClipboard",!0,{description:d.localize(228,null),included:F.isLinux})),selectionHighlight:_e(new a(97,"selectionHighlight",!0,{description:d.localize(229,null)})),selectOnLineNumbers:_e(new a(98,"selectOnLineNumbers",!0)),showFoldingControls:_e(new c(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(230,null),d.localize(231,null)],description:d.localize(232,null)})),showUnused:_e(new a(100,"showUnused",!0,{description:d.localize(233,null)})),showDeprecated:_e(new a(125,"showDeprecated",!0,{description:d.localize(234,null)})),inlayHints:_e(new j),snippetSuggestions:_e(new c(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(235,null),d.localize(236,null),d.localize(237,null),d.localize(238,null)],description:d.localize(239,null)})),smartSelect:_e(new oe),smoothScrolling:_e(new a(103,"smoothScrolling",!1,{description:d.localize(240,null)})),stopRenderingLineAfter:_e(new l(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new Z),inlineSuggest:_e(new N),suggestFontSize:_e(new l(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(241,null)})),suggestLineHeight:_e(new l(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(242,null)})),suggestOnTriggerCharacters:_e(new a(109,"suggestOnTriggerCharacters",!0,{description:d.localize(243,null)})),suggestSelection:_e(new c(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(244,null),d.localize(245,null),d.localize(246,null)],description:d.localize(247,null)})),tabCompletion:_e(new c(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(248,null),d.localize(249,null),d.localize(250,null)],description:d.localize(251,null)})),tabIndex:_e(new l(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new c(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(252,null),d.localize(253,null),d.localize(254,null)],description:d.localize(255,null)})),useShadowDOM:_e(new a(114,"useShadowDOM",!0)),useTabStops:_e(new a(115,"useTabStops",!0,{description:d.localize(256,null)})),wordSeparators:_e(new I(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:d.localize(257,null)})),wordWrap:_e(new c(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(258,null),d.localize(259,null),d.localize(260,null),d.localize(261,null)],description:d.localize(262,null)})),wordWrapBreakAfterCharacters:_e(new I(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new I(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new l(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(263,null)})),wordWrapOverride1:_e(new c(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new c(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new p(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],he,{enumDescriptions:[d.localize(264,null),d.localize(265,null),d.localize(266,null),d.localize(267,null)],description:d.localize(268,null)})),wrappingStrategy:_e(new c(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(269,null),d.localize(270,null)],description:d.localize(271,null)})),editorClassName:_e(new D),pixelRatio:_e(new ae),tabFocusMode:_e(new H),layoutInfo:_e(new z),wrappingInfo:_e(new Te)}});var Be=this&&this.__decorate||function(ie,e,d,F){var E=arguments.length,A=E<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,d):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,d,F);else for(var k=ie.length-1;k>=0;k--)(R=ie[k])&&(A=(E<3?R(A):E>3?R(e,d,A):R(e,d))||A);return E>3&&A&&Object.defineProperty(e,d,A),A},ze=this&&this.__param||function(ie,e){return function(d,F){e(d,F,ie)}};define(we[147],be([0,1,13,21,7,4]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var R;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let y=class extends E.Disposable{constructor(_,r){super();this.deferred=new d.DeferredPromise,r.withProgress(_,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};y=Be([ze(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const r=++this.currentOperationId,h=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{r===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:r,token:h.token,stop:()=>this.doStop(r),isCurrent:()=>this.currentOperationId===r}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(we[28],be([0,1,39,10]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(R,k){d.ok(F.isString(R)),d.ok(F.isObject(k)),d.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,k)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new E}),define(we[84],be([0,1,3,28]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,T){this.schemasById[E(y)]=T,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;F.Registry.add(e.Extensions.JSONContribution,R)}),define(we[62],be([0,1,3,10,116,84,28]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=R.Registry.as(A.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new d.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new d.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,c=!0){this.registerConfigurations([b],c)}registerConfigurations(b,c=!0){const p=[];b.forEach(S=>{p.push(...this.validateAndRegisterProperties(S,c,S.extensionInfo)),this.configurationContributors.push(S),this.registerJSONConfiguration(S)}),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(b){const c=[],p=S=>{if(S.properties)for(const i in S.properties)c.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,S.properties[i]);S.allOf&&S.allOf.forEach(i=>p(i))};for(const S of b){p(S);const i=this.configurationContributors.indexOf(S);i!==-1&&this.configurationContributors.splice(i,1)}T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(b){const c=[],p=[];for(const S of b)for(const i in S)if(c.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...S[i]};const s={type:"object",default:this.defaultValues[i],description:E.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};p.push(r(i)),this.configurationProperties[i]=s,this.defaultLanguageConfigurationOverridesNode.properties[i]=s}else{this.defaultValues[i]=S[i];const s=this.configurationProperties[i];s&&(this.updatePropertyDefaultValue(i,s),this.updateSchema(i,s))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(b){const c=[];for(const p of b)for(const S in p)if(c.push(S),delete this.defaultValues[S],e.OVERRIDE_PROPERTY_PATTERN.test(S))delete this.configurationProperties[S],delete this.defaultLanguageConfigurationOverridesNode.properties[S];else{const i=this.configurationProperties[S];i&&(this.updatePropertyDefaultValue(S,i),this.updateSchema(S,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const c of b)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,c=!0,p,S=3){S=F.isUndefinedOrNull(b.scope)?S:b.scope;let i=[],s=b.properties;if(s)for(let o in s){if(c&&l(o)){delete s[o];continue}const f=s[o];if(this.updatePropertyDefaultValue(o,f),e.OVERRIDE_PROPERTY_PATTERN.test(o)?f.scope=void 0:(f.scope=F.isUndefinedOrNull(f.scope)?S:f.scope,f.restricted=F.isUndefinedOrNull(f.restricted)?!!p?.restrictedConfigurations?.includes(o):f.restricted),s[o].hasOwnProperty("included")&&!s[o].included){this.excludedConfigurationProperties[o]=s[o],delete s[o];continue}else this.configurationProperties[o]=s[o];!s[o].deprecationMessage&&s[o].markdownDeprecationMessage&&(s[o].deprecationMessage=s[o].markdownDeprecationMessage),i.push(o)}let u=b.allOf;if(u)for(let o of u)i.push(...this.validateAndRegisterProperties(o,c,p,S));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const c=p=>{let S=p.properties;if(S)for(const s in S)this.updateSchema(s,S[s]);let i=p.allOf;i&&i.forEach(c)};c(b)}updateSchema(b,c){switch(e.allSettings.properties[b]=c,c.scope){case 1:e.applicationSettings.properties[b]=c;break;case 2:e.machineSettings.properties[b]=c;break;case 6:e.machineOverridableSettings.properties[b]=c;break;case 3:e.windowSettings.properties[b]=c;break;case 4:e.resourceSettings.properties[b]=c;break;case 5:e.resourceSettings.properties[b]=c,this.resourceLanguageSettingsSchema.properties[b]=c;break}}removeFromSchema(b,c){switch(delete e.allSettings.properties[b],c.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const c=`[${b}]`,p={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,p),e.allSettings.properties[c]=p,e.applicationSettings.properties[c]=p,e.machineSettings.properties[c]=p,e.machineOverridableSettings.properties[c]=p,e.windowSettings.properties[c]=p,e.resourceSettings.properties[c]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,c){let p=this.defaultValues[b];F.isUndefined(p)&&(p=c.default),F.isUndefined(p)&&(p=h(c.type)),c.default=p}}const _="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(_);function r(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=r;function h(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const a=new t;R.Registry.add(e.Extensions.Configuration,a);function l(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?E.localize(5,null,I):a.getConfigurationProperties()[I]!==void 0?E.localize(6,null,I):null:E.localize(4,null)}e.validateProperty=l;function g(){const I=[],b=a.getConfigurationProperties();for(const c of Object.keys(b))I.push([c,b[c].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=g}),define(we[85],be([0,1,22,10,2,62,4,28]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function y(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof E.URI)}e.isConfigurationOverrides=y;var T;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function _(s,u){const o=u?s?u.keys.filter(m=>s.keys.indexOf(m)===-1):[...u.keys]:[],f=s?u?s.keys.filter(m=>u.keys.indexOf(m)===-1):[...s.keys]:[],v=[];if(u&&s){for(const m of s.keys)if(u.keys.indexOf(m)!==-1){const C=I(s.contents,m),L=I(u.contents,m);d.equals(C,L)||v.push(m)}}const w=[],D=m=>{const C={};for(const L of m)for(const $ of L.identifiers)C[S($)]=L;return C},P=u?D(u.overrides):{},n=s?D(s.overrides):{};if(Object.keys(P).length)for(const m of o){const C=P[m];C&&w.push([(0,A.overrideIdentifierFromKey)(m),C.keys])}if(Object.keys(n).length)for(const m of f){const C=n[m];C&&w.push([(0,A.overrideIdentifierFromKey)(m),C.keys])}if(Object.keys(P).length&&Object.keys(n).length)for(const m of v){const C=n[m],L=P[m];if(C&&L){const $=_({contents:C.contents,keys:C.keys,overrides:[]},{contents:L.contents,keys:L.keys,overrides:[]});w.push([(0,A.overrideIdentifierFromKey)(m),[...$.added,...$.removed,...$.updated]])}}return{added:o,removed:f,updated:v,overrides:w}}e.compare=_;function r(s,u){const o=[];for(const f of Object.keys(s))if(A.OVERRIDE_PROPERTY_PATTERN.test(f)){const v={};for(const w in s[f])v[w]=s[f][w];o.push({identifiers:[(0,A.overrideIdentifierFromKey)(f).trim()],keys:Object.keys(v),contents:h(v,u)})}return o}e.toOverrides=r;function h(s,u){const o=Object.create(null);for(let f in s)a(o,f,s[f],u);return o}e.toValuesTree=h;function a(s,u,o,f){const v=u.split("."),w=v.pop();let D=s;for(let P=0;P<v.length;P++){let n=v[P],m=D[n];switch(typeof m){case"undefined":m=D[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${u} as ${v.slice(0,P+1).join(".")} is ${JSON.stringify(m)}`);return}D=m}if(typeof D=="object"&&D!==null)try{D[w]=o}catch(P){f(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(D)}`)}else f(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=a;function l(s,u){const o=u.split(".");g(s,o)}e.removeFromValueTree=l;function g(s,u){const o=u.shift();if(u.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const f=s[o];typeof f=="object"&&!Array.isArray(f)&&(g(f,u),Object.keys(f).length===0&&delete s[o])}}function I(s,u,o){function f(D,P){let n=D;for(const m of P){if(typeof n!="object"||n===null)return;n=n[m]}return n}const v=u.split("."),w=f(s,v);return typeof w=="undefined"?o:w}e.getConfigurationValue=I;function b(s,u,o){Object.keys(u).forEach(f=>{f!=="__proto__"&&(f in s?F.isObject(s[f])&&F.isObject(u[f])?b(s[f],u[f],o):o&&(s[f]=u[f]):s[f]=u[f])})}e.merge=b;function c(){const s=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=c;function p(){const s=Object.create(null),u=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let o in u){let f=u[o].default;a(s,o,f,v=>console.error(`Conflict in default settings: ${v}`))}return s}e.getDefaultValues=p;function S(s){return`[${s}]`}e.keyFromOverrideIdentifier=S;function i(s,u,o){const f=s.inspect(u),v=s.inspect(o);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:f.defaultValue}e.getMigratedSettingValue=i}),define(we[148],be([0,1,16,3,102,7,20,22,10,2,85,62,28]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(i={},s=[],u=[]){this._contents=i,this._keys=s,this._overrides=u,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const u=this.getContentsForOverrideIdentifer(s);return u?i?(0,t.getConfigurationValue)(u,i):u:void 0}getKeysForOverrideIdentifier(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.keys;return[]}override(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let u={};for(const o of d.distinct([...Object.keys(this.contents),...Object.keys(s)])){let f=this.contents[o],v=s[o];v&&(typeof f=="object"&&typeof v=="object"?(f=k.deepClone(f),this.mergeContents(f,v)):f=v),u[o]=f}return new h(u,this.keys,this.overrides)}merge(...i){const s=k.deepClone(this.contents),u=k.deepClone(this.overrides),o=[...this.keys];for(const f of i){this.mergeContents(s,f.contents);for(const v of f.overrides){const[w]=u.filter(D=>d.equals(D.identifiers,v.identifiers));w?this.mergeContents(w.contents,v.contents):u.push(k.deepClone(v))}for(const v of f.keys)o.indexOf(v)===-1&&o.push(v)}return new h(s,o,u)}freeze(){return this.isFrozen=!0,this}mergeContents(i,s){for(const u of Object.keys(s)){if(u in i&&y.isObject(i[u])&&y.isObject(s[u])){this.mergeContents(i[u],s[u]);continue}i[u]=k.deepClone(s[u])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,t.addToValueTree)(this.contents,i,s,u=>{throw new Error(u)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let u=0;u<s;u++)i.indexOf(this.keys[u])===0&&(s=u);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=h;class a extends h{constructor(){const i=(0,t.getDefaultValues)(),s=(0,t.getConfigurationKeys)(),u=[];for(const o of Object.keys(i))_.OVERRIDE_PROPERTY_PATTERN.test(o)&&u.push({identifiers:[(0,_.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],f=>console.error(`Conflict in default settings file: ${f}`))});super(i,s,u)}}e.DefaultConfigurationModel=a;class l{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!y.isUndefinedOrNull(i)){const u=this.doParseContent(i);this.parseRaw(u,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:u,keys:o,overrides:f,restricted:v}=this.doParseRaw(i,s);this._configurationModel=new h(u,o,f),this._restrictedConfigurations=v||[]}doParseContent(i){let s={},u=null,o=[],f=[],v=[];function w(P){Array.isArray(o)?o.push(P):u!==null&&(o[u]=P)}let D={onObjectBegin:()=>{let P={};w(P),f.push(o),o=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{let P=[];w(P),f.push(o),o=P,u=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:w,onError:(P,n,m)=>{v.push({error:P,offset:n,length:m})}};if(i)try{E.visit(i,D),s=o[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return s}doParseRaw(i,s){const u=r.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,u,!0,s);i=o.raw;const f=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),v=Object.keys(i),w=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:f,keys:v,overrides:w,restricted:o.restricted}}filter(i,s,u,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const f={},v=[];for(let w in i)if(_.OVERRIDE_PROPERTY_PATTERN.test(w)&&u){const D=this.filter(i[w],s,!1,o);f[w]=D.raw,v.push(...D.restricted)}else{const D=s[w],P=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&v.push(w),(P===void 0||o.scopes===void 0||o.scopes.includes(P))&&(o.skipRestricted&&D?.restricted||(f[w]=i[w]))}return{raw:f,restricted:v}}}e.ConfigurationModelParser=l;class g extends A.Disposable{constructor(i,s,u,o){super();this.userSettingsResource=i,this.scopes=s,this.fileService=o,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class I{constructor(i,s,u=new h,o=new h,f=new R.ResourceMap,v=new h,w=new R.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=u,this._workspaceConfiguration=o,this._folderConfigurations=f,this._memoryConfiguration=v,this._memoryConfigurationByResource=w,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,s,u){return this.getConsolidateConfigurationModel(s,u).getValue(i)}updateValue(i,s,u={}){let o;u.resource?(o=this._memoryConfigurationByResource.get(u.resource),o||(o=new h,this._memoryConfigurationByResource.set(u.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(i):o.setValue(i,s),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,u){const o=this.getConsolidateConfigurationModel(s,u),f=this.getFolderConfigurationModelForResource(s.resource,u),v=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,w=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),P=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),n=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),m=u?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,C=f?s.overrideIdentifier?f.freeze().override(s.overrideIdentifier).getValue(i):f.freeze().getValue(i):void 0,L=s.overrideIdentifier?v.override(s.overrideIdentifier).getValue(i):v.getValue(i),$=o.getValue(i),Q=d.distinct(d.flatten(o.overrides.map(se=>se.identifiers))).filter(se=>o.getOverrideValue(i,se)!==void 0);return{defaultValue:w,userValue:D,userLocalValue:P,userRemoteValue:n,workspaceValue:m,workspaceFolderValue:C,memoryValue:L,value:$,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:n!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:m!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:C!==void 0?{value:f?.freeze().getValue(i),override:s.overrideIdentifier?f?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:v.getValue(i),override:s.overrideIdentifier?v.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Q.length?Q:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const u=s.filter(o=>_.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const f=(0,_.overrideIdentifierFromKey)(o),v=this._defaultConfiguration.getKeysForOverrideIdentifier(f),w=i.getKeysForOverrideIdentifier(f),D=[...w.filter(P=>v.indexOf(P)===-1),...v.filter(P=>w.indexOf(P)===-1),...v.filter(P=>!k.equals(this._defaultConfiguration.override(f).getValue(P),i.override(f).getValue(P)))];return[f,D]});return this.updateDefaultConfiguration(i),{keys:s,overrides:u}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:u,removed:o,overrides:f}=(0,t.compare)(this.localUserConfiguration,i),v=[...s,...u,...o];return v.length&&this.updateLocalUserConfiguration(i),{keys:v,overrides:f}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:u,removed:o,overrides:f}=(0,t.compare)(this.remoteUserConfiguration,i);let v=[...s,...u,...o];return v.length&&this.updateRemoteUserConfiguration(i),{keys:v,overrides:f}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:u,removed:o,overrides:f}=(0,t.compare)(this.workspaceConfiguration,i);let v=[...s,...u,...o];return v.length&&this.updateWorkspaceConfiguration(i),{keys:v,overrides:f}}compareAndUpdateFolderConfiguration(i,s){const u=this.folderConfigurations.get(i),{added:o,updated:f,removed:v,overrides:w}=(0,t.compare)(u,s);let D=[...o,...f,...v];return(D.length||!u)&&this.updateFolderConfiguration(i,s),{keys:D,overrides:w}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:u,updated:o,removed:f,overrides:v}=(0,t.compare)(s,void 0);return{keys:[...u,...o,...f],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let u=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?u.override(i.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:i},s){let u=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const o=s.getFolder(i);o&&(u=this.getFolderConsolidatedConfiguration(o.uri)||u);const f=this._memoryConfigurationByResource.get(i);f&&(u=u.merge(f))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const u=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(s=u.merge(o),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=u}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const u=s.getFolder(i);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:u,overrides:o,keys:f}=this._folderConfigurations.get(s);return i.push([s,{contents:u,overrides:o,keys:f}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(u=>i.add(u))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),u=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),f=i.folders.reduce((v,w)=>(v.set(T.URI.revive(w[0]),this.parseConfigurationModel(w[1])),v),new R.ResourceMap);return new I(s,u,new h,o,f,new h,new R.ResourceMap,!1)}static parseConfigurationModel(i){return new h(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=I;function b(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const i=new Set,s=new Map;for(const o of S)o.keys.forEach(f=>i.add(f)),o.overrides.forEach(([f,v])=>{const w=(0,R.getOrSet)(s,f,new Set);v.forEach(D=>w.add(D))});const u=[];return s.forEach((o,f)=>u.push([f,[...o.values()]])),{keys:[...i.values()],overrides:u}}e.mergeChanges=b;class c{constructor(i,s,u,o){this.change=i,this.previous=s,this.currentConfiguraiton=u,this.currentWorkspace=o,this._previousConfiguration=void 0;const f=new Set;i.keys.forEach(w=>f.add(w)),i.overrides.forEach(([,w])=>w.forEach(D=>f.add(D))),this.affectedKeys=[...f.values()];const v=new h;this.affectedKeys.forEach(w=>v.setValue(w,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!k.equals(u,o)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let u=(0,t.toValuesTree)({[s]:!0},()=>{}),o;for(;typeof u=="object"&&(o=Object.keys(u)[0]);){if(i=i[o],!i)return!1;u=u[o]}return!0}}e.ConfigurationChangeEvent=c;class p extends c{constructor(i,s,u,o){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=u,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=p}),define(we[86],be([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var F;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(R,k=F.Unknown,y){super(R);this._message=R,this._code=k,this._detail=y,this.isHandled=k===F.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(R){return R instanceof E&&R._code===F.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof E&&R._code===F.NoResolverFound}static isHandled(R){return R instanceof E&&R.isHandled}}e.RemoteAuthorityResolverError=E}),define(we[87],be([0,1,11]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(T){return T.scheme===d.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=F;function E(T){if(!T)return;const t=T.indexOf("+");return t<0?T:T.substr(0,t)}e.getRemoteName=E;function A(T){return T.scheme!==d.Schemas.file&&T.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=A;function R(T){if(T.folders.length)return T.folders.every(t=>A(t.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=R;function k(T){return R(T)?.scheme}e.getVirtualWorkspaceScheme=k;function y(T){return R(T)!==void 0}e.isVirtualWorkspace=y}),define(we[149],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,R=5){let k;return k=A(y=>{const T=typeof y=="string"?y:y.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(T);return}const _=setTimeout(()=>this.flushBuffer(E),R);t={data:[T],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),k.dispose()}},this._terminalBufferMap.set(E,t)}),k}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=d}),define(we[150],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(we[43],be([0,1,34,3,7,4,28,150]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var y;(function(g){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}g.isThemeColor=I})(y=e.ThemeColor||(e.ThemeColor={}));function T(g){return{id:g}}e.themeColorFromId=T;var t;(function(g){function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||y.isThemeColor(s.color))}g.isThemeIcon=I;const b=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function c(s){const u=b.exec(s);if(!u)return;let[,o]=u;return{id:o}}g.fromString=c;function p(s,u){let o=s.id;const f=o.lastIndexOf("~");return f!==-1&&(o=o.substring(0,f)),u&&(o=`${o}~${u}`),{id:o}}g.modify=p;function S(s,u){return s.id===u.id&&s.color?.id===u.color?.id}g.isEqual=S;function i(s,u){return{id:s.id,color:u?T(u):void 0}}g.asThemeIcon=i,g.asClassNameArray=d.CSSIcon.asClassNameArray,g.asClassName=d.CSSIcon.asClassName,g.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function _(g){switch(g){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class r{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,E.toDisposable)(()=>{const b=this.themingParticipants.indexOf(I);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new r;R.Registry.add(e.Extensions.ThemingContribution,h);function a(g){return h.onColorThemeChange(g)}e.registerThemingParticipant=a;class l extends E.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,b){let c=this.theme.getColor(I);return c&&b&&(c=b(c,this.theme)),c?c.toString():null}}e.Themable=l}),define(we[151],be([0,1,13,34,3,120,84,28,43]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,b,c,p){const S=this.iconsById[I];if(S){if(c&&!S.description){S.description=c,this.iconSchema.properties[I].markdownDescription=`${c} $(${I})`;const u=this.iconReferenceSchema.enum.indexOf(I);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=c),this._onDidChange.fire()}return S}let i={id:I,description:c,defaults:b,deprecationMessage:p};this.iconsById[I]=i;let s={$ref:"#/definitions/icons"};return p&&(s.deprecationMessage=p),c&&(s.markdownDescription=`${c}: $(${I})`),this.iconSchema.properties[I]=s,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const b=this.iconReferenceSchema.enum.indexOf(I);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,b){const c=this.iconFontsById[I];if(c)return c;let p={id:I,definition:b};return this.iconFontsById[I]=p,this._onDidChange.fire(),p}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(S,i)=>S.id.localeCompare(i.id),b=S=>{for(;y.ThemeIcon.isThemeIcon(S.defaults);)S=this.iconsById[S.defaults.id];return`codicon codicon-${S?S.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.iconsById).map(S=>this.iconsById[S]);for(const S of p.filter(i=>!!i.description).sort(I))c.push(`|<i class="${b(S)}"></i>|${S.id}|${y.ThemeIcon.isThemeIcon(S.defaults)?S.defaults.id:S.id}|${S.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const S of p.filter(i=>!y.ThemeIcon.isThemeIcon(i.defaults)).sort(I))c.push(`|<i class="${b(S)}"></i>|${S.id}|`);return c.join(`
`)}}const t=new T;k.Registry.add(e.Extensions.IconContribution,t);function _(g,I,b,c){return t.registerIcon(g,I,b,c)}e.registerIcon=_;function r(){return t}e.getIconRegistry=r;function h(){for(const g of F.iconRegistry.all)t.registerIcon(g.id,g.definition,g.description);F.iconRegistry.onDidRegister(g=>t.registerIcon(g.id,g.definition,g.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let a=k.Registry.as(R.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,t.getIconSchema());const l=new d.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=_("widget-close",F.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",F.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",F.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=y.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(we[44],be([0,1,20,24,2,4]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var R;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function k(r){const h=r;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=k;function y(r){const h=r;return!!(h&&typeof h=="object"&&E.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=y;class T{constructor(h,a,l,g){this._id=h,this._configuration=l,this._ignorePathCasing=g,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=T;class t{constructor(h,a){this.raw=a,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,F.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function _(r){return new t({uri:r,index:0,name:(0,F.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=_}),define(we[63],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(we[64],be([0,1,2,3,4]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,E.createDecorator)("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new F.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(k){this._tabs=k.map(y=>({name:y.name,group:y.group,resource:d.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(we[45],be([0,1,11,4]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class E{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(R,k){k===null?this._providerInfo.delete(R):this._providerInfo.set(R,k)}isFreeScheme(R){return!this._providerInfo.has(R)&&!this._systemSchemes.has(R)}getCapabilities(R){return this._providerInfo.get(R)}}e.ExtHostFileSystemInfo=E,e.IExtHostFileSystemInfo=(0,F.createDecorator)("IExtHostFileSystemInfo")}),define(we[29],be([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(we[152],be([0,1,13]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(R,k,y){this._deferredPromises=new Map,this._id=R,this._shared=k,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of T.values())t.complete()}catch(t){for(const _ of T.values())_.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,k){let y=this._value[R];return typeof y=="undefined"&&(y=k),y}update(R,k){this._value[R]=k;let y=this._deferredPromises.get(R);if(y!==void 0)return y.p;const T=new d.DeferredPromise;return this._deferredPromises.set(R,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class E extends F{constructor(R,k){super(R.identifier.value,!0,k);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=E}),define(we[153],be([0,1,3,2,14]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(k,y){this._logService=k,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,y,T){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(k)).acceptModelChanged(y.value,T)}$acceptDirtyStateChanged(k,y){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(k)).acceptDirty(y)}$acceptModelSaved(k){const y=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(k));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(k,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,y);const T=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(k));T.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=Be([ze(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(we[12],be([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class F{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=F});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[154],be([0,1,26,3]),function(ie,e,d,F){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,y){E.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(k.identifier),et(this,E,y,"f"),Me(this,E,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(k){return Me(this,E,"f").get(this._id,k)}store(k,y){return Me(this,E,"f").store(this._id,k,y)}delete(k){return Me(this,E,"f").delete(this._id,k)}}e.ExtensionSecrets=A,E=new WeakMap}),define(we[88],be([0,1,4,3]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(we[65],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,E=(b,c)=>{const p={controllerId:c};return F.set(b,p),p};e.createPrivateApiFor=E;const A=b=>F.get(b);e.getPrivateApiFor=A;const R=(b,c,p,S)=>{let i=p;return{enumerable:!0,configurable:!1,get(){return i},set(s){if(!S(i,s)){const u=i;i=s,b.listener?.({op:3,key:c,value:s,previous:u})}}}},k=(b,c)=>b===c,y={range:(b,c)=>b===c?!0:!b||!c?!1:b.isEqual(c),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(b,c)=>!(b.length!==c.length||b.some(p=>!c.find(S=>p.id===S.id)))},T=Object.keys(y),t=(b,c)=>({range:R(b,"range",void 0,y.range),label:R(b,"label",c,y.label),description:R(b,"description",void 0,y.description),canResolveChildren:R(b,"canResolveChildren",!1,y.canResolveChildren),busy:R(b,"busy",!1,y.busy),error:R(b,"error",void 0,y.error),tags:R(b,"tags",[],y.tags)}),_=(b,c)=>{const p=new Map;for(const S of T)y[S](b[S],c[S])||p.set(S,c[S]);return p};e.diffTestItems=_;class r extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=r;class h extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class a extends Error{constructor(c,p,S){super(`TestItem with ID "${c}" is from controller "${p}" and cannot be added as a child of an item from controller "${S}".`)}}e.MixedTestItemController=a;const l=b=>{const c=(0,e.getPrivateApiFor)(b);let p=new Map;return{get size(){return p.size},forEach(S,i){for(const s of p.values())S.call(i,s,this)},replace(S){const i=new Map,s=new Set(p.keys()),u={op:4,ops:[]};for(const o of S){if(!(o instanceof g))throw new h(o.id);const f=(0,e.getPrivateApiFor)(o).controllerId;if(f!==c.controllerId)throw new a(o.id,f,c.controllerId);if(i.has(o.id))throw new r(o.id);i.set(o.id,o),s.delete(o.id),u.ops.push({op:0,item:o})}for(const o of s.keys())u.ops.push({op:1,id:o});c.listener?.(u),p=i},add(S){if(!(S instanceof g))throw new h(S.id);p.set(S.id,S),c.listener?.({op:0,item:S})},delete(S){p.delete(S)&&c.listener?.({op:1,id:S})},get(S){return p.get(S)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class g{constructor(c,p,S,i){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const s=(0,e.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof I?void 0:s.parent}},children:{value:l(this),enumerable:!0,writable:!1},...t(s,S)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class I extends g{constructor(c,p){super(c,c,p,void 0)}}e.TestItemRootImpl=I}),define(we[66],be([0,1,4,3,12]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(k){function y(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}k.fromApiTunnel=y;function T(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}k.fromServiceTunnel=T})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let R=class{constructor(y){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,T){return{dispose:()=>{}}}async $providePortAttributes(y,T,t,_,r){return[]}async $forwardPort(y,T){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Be([ze(0,E.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[6],be([0,1,16,15,77,20,79,10,2,36,59,86]),function(ie,e,d,F,E,A,R,k,y,T,t,_){"use strict";var r,h,a,l,g,I,b,c,p,S,i,s,u,o,f,v,w,D,P,n;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function m(O){function M(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(M,O),Object.setPrototypeOf(M.prototype,O.prototype),M}let C=g=class{constructor(M){r.set(this,void 0),et(this,r,M,"f")}static from(...M){let ee=M;return new g(function(){if(ee){for(const Ee of ee)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ee=void 0}})}dispose(){typeof Me(this,r,"f")=="function"&&(Me(this,r,"f").call(this),et(this,r,void 0,"f"))}};r=new WeakMap,C=g=Be([m],C),e.Disposable=C;let L=I=class{constructor(M,ee){if(M<0)throw(0,F.illegalArgument)("line must be non-negative");if(ee<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=M,this._character=ee}static Min(...M){if(M.length===0)throw new TypeError;let ee=M[0];for(let Ee=1;Ee<M.length;Ee++){const Ge=M[Ee];Ge.isBefore(ee)&&(ee=Ge)}return ee}static Max(...M){if(M.length===0)throw new TypeError;let ee=M[0];for(let Ee=1;Ee<M.length;Ee++){const Ge=M[Ee];Ge.isAfter(ee)&&(ee=Ge)}return ee}static isPosition(M){if(!M)return!1;if(M instanceof I)return!0;let{line:ee,character:Ee}=M;return typeof ee=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ee=0){if(M===null||ee===null)throw(0,F.illegalArgument)();let Ee;return typeof M=="undefined"?Ee=0:typeof M=="number"?Ee=M:(Ee=typeof M.lineDelta=="number"?M.lineDelta:0,ee=typeof M.characterDelta=="number"?M.characterDelta:0),Ee===0&&ee===0?this:new I(this.line+Ee,this.character+ee)}with(M,ee=this.character){if(M===null||ee===null)throw(0,F.illegalArgument)();let Ee;return typeof M=="undefined"?Ee=this.line:typeof M=="number"?Ee=M:(Ee=typeof M.line=="number"?M.line:this.line,ee=typeof M.character=="number"?M.character:this.character),Ee===this.line&&ee===this.character?this:new I(Ee,ee)}toJSON(){return{line:this.line,character:this.character}}};L=I=Be([m],L),e.Position=L;let $=b=class{constructor(M,ee,Ee,Ge){let Ze,st;if(typeof M=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(Ze=new L(M,ee),st=new L(Ee,Ge)):M instanceof L&&ee instanceof L&&(Ze=M,st=ee),!Ze||!st)throw new Error("Invalid arguments");Ze.isBefore(st)?(this._start=Ze,this._end=st):(this._start=st,this._end=Ze)}static isRange(M){return M instanceof b?!0:M?L.isPosition(M.start)&&L.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof b?this.contains(M._start)&&this.contains(M._end):M instanceof L?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ee=L.Max(M.start,this._start),Ee=L.Min(M.end,this._end);if(!ee.isAfter(Ee))return new b(ee,Ee)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ee=L.Min(M.start,this._start),Ee=L.Max(M.end,this.end);return new b(ee,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ee=this.end){if(M===null||ee===null)throw(0,F.illegalArgument)();let Ee;return M?L.isPosition(M)?Ee=M:(Ee=M.start||this.start,ee=M.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ee.isEqual(this.end)?this:new b(Ee,ee)}toJSON(){return[this.start,this.end]}};$=b=Be([m],$),e.Range=$;let Q=c=class extends ${constructor(M,ee,Ee,Ge){let Ze,st;if(typeof M=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(Ze=new L(M,ee),st=new L(Ee,Ge)):M instanceof L&&ee instanceof L&&(Ze=M,st=ee),!Ze||!st)throw new Error("Invalid arguments");super(Ze,st);this._anchor=Ze,this._active=st}static isSelection(M){return M instanceof c?!0:M?$.isRange(M)&&L.isPosition(M.anchor)&&L.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Q=c=Be([m],Q),e.Selection=Q;class se{constructor(M,ee,Ee){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,F.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,F.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ee),this.connectionToken=Ee}}e.ResolvedAuthority=se;class G extends Error{constructor(M,ee=_.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(M);this._message=M,this._code=ee,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}static NotAvailable(M,ee){return new G(M,_.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(M){return new G(M,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=G;var z;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var x;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=p=class{constructor(M,ee){this._range=M,this._newText=ee}static isTextEdit(M){return M instanceof p?!0:M?$.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ee){return new p(M,ee)}static insert(M,ee){return p.replace(new $(M,M),ee)}static delete(M){return p.replace(M,"")}static setEndOfLine(M){const ee=new p(new $(new L(0,0),new L(0,0)),"");return ee.newEol=M,ee}get range(){return this._range}set range(M){if(M&&!$.isRange(M))throw(0,F.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,F.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,F.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=p=Be([m],j),e.TextEdit=j;var B;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ee,Ee,Ge){this._edits.push({_type:1,from:M,to:ee,options:Ee,metadata:Ge})}createFile(M,ee,Ee){this._edits.push({_type:1,from:void 0,to:M,options:ee,metadata:Ee})}deleteFile(M,ee,Ee){this._edits.push({_type:1,from:M,to:void 0,options:ee,metadata:Ee})}replaceNotebookMetadata(M,ee,Ee){this._edits.push({_type:3,metadata:Ee,uri:M,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(M,ee,Ee,Ge,Ze){let st,ut,St=[],At;if(zt.isNotebookRange(ee)&&Ft.isNotebookCellDataArray(Ee)&&!Ft.isNotebookCellDataArray(Ge)?(st=ee.start,ut=ee.end,St=Ee,At=Ge):typeof ee=="number"&&typeof Ee=="number"&&Ft.isNotebookCellDataArray(Ge)&&(st=ee,ut=Ee,St=Ge,At=Ze),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||St.length>0)&&this._edits.push({_type:5,uri:M,index:st,count:ut-st,cells:St,metadata:At})}replaceNotebookCellMetadata(M,ee,Ee,Ge){this._edits.push({_type:3,metadata:Ge,uri:M,edit:{editType:8,index:ee,metadata:Ee}})}replace(M,ee,Ee,Ge){this._edits.push({_type:2,uri:M,edit:new j(ee,Ee),metadata:Ge})}insert(M,ee,Ee,Ge){this.replace(M,new $(ee,ee),Ee,Ge)}delete(M,ee,Ee){this.replace(M,ee,"",Ee)}has(M){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===M.toString())}set(M,ee){if(ee)for(const Ee of ee)Ee&&this._edits.push({_type:2,uri:M,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ge=this._edits[Ee];Ge._type===2&&Ge.uri.toString()===M.toString()&&(this._edits[Ee]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(M){const ee=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===M.toString()&&ee.push(Ee.edit);return ee}entries(){const M=new A.ResourceMap;for(let ee of this._edits)if(ee._type===2){let Ee=M.get(ee.uri);Ee||(Ee=[ee.uri,[]],M.set(ee.uri,Ee)),Ee[1].push(ee.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};q=Be([m],q),e.WorkspaceEdit=q;let ce=S=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof S?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=S._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ee=this._tabstop++){if(typeof M=="function"){const Ee=new S;Ee._tabstop=this._tabstop,M(Ee),this._tabstop=Ee._tabstop,M=Ee.value}else M=S._escape(M);return this.value+="${",this.value+=ee,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ee=this._tabstop++){const Ee=M.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(M,ee){if(typeof ee=="function"){const Ee=new S;Ee._tabstop=this._tabstop,ee(Ee),this._tabstop=Ee._tabstop,ee=Ee.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};ce=S=Be([m],ce),e.SnippetString=ce;var V;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(V=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=i=class{constructor(M,ee){if(this.uri=M,ee)if(ee instanceof $)this.range=ee;else if(ee instanceof L)this.range=new $(ee,ee);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof i?!0:M?$.isRange(M.range)&&y.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ae=i=Be([m],ae),e.Location=ae;let ve=class{constructor(M,ee){this.location=M,this.message=ee}static is(M){return M?typeof M.message=="string"&&M.location&&$.isRange(M.location.range)&&y.URI.isUri(M.location.uri):!1}static isEqual(M,ee){return M===ee?!0:!M||!ee?!1:M.message===ee.message&&M.location.range.isEqual(ee.location.range)&&M.location.uri.toString()===ee.location.uri.toString()}};ve=Be([m],ve),e.DiagnosticRelatedInformation=ve;let Ae=class{constructor(M,ee,Ee=le.Error){if(!$.isRange(M))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=M,this.message=ee,this.severity=Ee}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ee){return M===ee?!0:!M||!ee?!1:M.message===ee.message&&M.severity===ee.severity&&M.code===ee.code&&M.severity===ee.severity&&M.source===ee.source&&M.range.isEqual(ee.range)&&(0,d.equals)(M.tags,ee.tags)&&(0,d.equals)(M.relatedInformation,ee.relatedInformation,ve.isEqual)}};Ae=Be([m],Ae),e.Diagnostic=Ae;let Re=class{constructor(M,ee){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ee}};Re=Be([m],Re),e.Hover=Re;var Oe;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(M,ee=Oe.Text){this.range=M,this.kind=ee}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};Qe=Be([m],Qe),e.DocumentHighlight=Qe;var He;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var je;(function(O){O[O.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let N=s=class{constructor(M,ee,Ee,Ge,Ze){this.name=M,this.kind=ee,this.containerName=Ze,typeof Ee=="string"&&(this.containerName=Ee),Ge instanceof ae?this.location=Ge:Ee instanceof $&&(this.location=new ae(Ge,Ee)),s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};N=s=Be([m],N),e.SymbolInformation=N;let K=u=class{constructor(M,ee,Ee,Ge,Ze){this.name=M,this.detail=ee,this.kind=Ee,this.range=Ge,this.selectionRange=Ze,this.children=[],u.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(u.validate)}};K=u=Be([m],K),e.DocumentSymbol=K;var Z;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(M,ee){this.title=M,this.kind=ee}};oe=Be([m],oe),e.CodeAction=oe;let H=o=class{constructor(M){this.value=M}append(M){return new o(this.value?this.value+o.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+o.sep)}};H.sep=".",H=o=Be([m],H),e.CodeActionKind=H,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll");let re=class{constructor(M,ee){if(this.range=M,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};re=Be([m],re),e.SelectionRange=re;class he{constructor(M,ee,Ee,Ge,Ze,st){this.kind=M,this.name=ee,this.detail=Ee,this.uri=Ge,this.range=Ze,this.selectionRange=st}}e.CallHierarchyItem=he;class Te{constructor(M,ee){this.fromRanges=ee,this.from=M}}e.CallHierarchyIncomingCall=Te;class Ue{constructor(M,ee){this.fromRanges=ee,this.to=M}}e.CallHierarchyOutgoingCall=Ue;var $e;(function(O){O[O.Information=0]="Information",O[O.Warning=1]="Warning",O[O.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(M,ee){this.range=M,this.command=ee}get isResolved(){return!!this.command}};Ke=Be([m],Ke),e.CodeLens=Ke;let _e=f=class{constructor(M,ee=!1){h.set(this,void 0),et(this,h,new E.MarkdownString(M,{supportThemeIcons:ee}),"f")}static isMarkdownString(M){return M instanceof f?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Me(this,h,"f").value}set value(M){Me(this,h,"f").value=M}get isTrusted(){return Me(this,h,"f").isTrusted}set isTrusted(M){Me(this,h,"f").isTrusted=M}get supportThemeIcons(){return Me(this,h,"f").supportThemeIcons}set supportThemeIcons(M){Me(this,h,"f").supportThemeIcons=M}appendText(M){return Me(this,h,"f").appendText(M),this}appendMarkdown(M){return Me(this,h,"f").appendMarkdown(M),this}appendCodeblock(M,ee){return Me(this,h,"f").appendCodeblock(ee??"",M),this}};h=new WeakMap,_e=f=Be([m],_e),e.MarkdownString=_e;let rt=class{constructor(M,ee){this.label=M,this.documentation=ee}};rt=Be([m],rt),e.ParameterInformation=rt;let W=class{constructor(M,ee){this.label=M,this.documentation=ee,this.parameters=[]}};W=Be([m],W),e.SignatureInformation=W;let Y=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Y=Be([m],Y),e.SignatureHelp=Y;var me;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let Ye=class{constructor(M,ee,Ee){this.text=M,this.position=ee,this.kind=Ee}};Ye=Be([m],Ye),e.InlayHint=Ye;var tt;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(tt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var at;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(at=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(O){O[O.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let kt=class{constructor(M,ee){this.label=M,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};kt=Be([m],kt),e.CompletionItem=kt;let ht=class{constructor(M=[],ee=!1){this.items=M,this.isIncomplete=ee}};ht=Be([m],ht),e.CompletionList=ht;let yt=class{constructor(M,ee,Ee){this.text=M,this.range=ee,this.command=Ee}};yt=Be([m],yt),e.InlineSuggestion=yt;let It=class{constructor(M){this.items=M}};It=Be([m],It),e.InlineSuggestions=It;var ft;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(ft=e.ViewColumn||(e.ViewColumn={}));var Je;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(Je=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Et;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(Et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var X;(function(O){O[O.Undo=1]="Undo",O[O.Redo=2]="Redo"})(X=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function M(ee){switch(ee){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=M}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(M,ee){if(ee&&!y.URI.isUri(ee))throw(0,F.illegalArgument)("target");if(!$.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.target=ee}};ge=Be([m],ge),e.DocumentLink=ge;let fe=class{constructor(M,ee,Ee,Ge){this.red=M,this.green=ee,this.blue=Ee,this.alpha=Ge}};fe=Be([m],fe),e.Color=fe;let Ie=class{constructor(M,ee){if(ee&&!(ee instanceof fe))throw(0,F.illegalArgument)("color");if(!$.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.color=ee}};Ie=Be([m],Ie),e.ColorInformation=Ie;let xe=class{constructor(M){if(!M||typeof M!="string")throw(0,F.illegalArgument)("label");this.label=M}};xe=Be([m],xe),e.ColorPresentation=xe;var Le;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var Ve;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(Ve=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Xe{constructor(M,ee,Ee){if(this.startIndex=M,this.length=ee,this.tooltip=Ee,typeof M!="number"||M<0)throw(0,F.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,F.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=Xe;var te;(function(O){O[O.Panel=0]="Panel",O[O.Editor=1]="Editor"})(te=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(M){this.options=M,typeof M!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=pe;var ne;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var U;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(U=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=v=class{constructor(M,ee){if(typeof M!="string"||typeof ee!="string")throw(0,F.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}get id(){return this._id}};Ce.Clean=new v("clean","Clean"),Ce.Build=new v("build","Build"),Ce.Rebuild=new v("rebuild","Rebuild"),Ce.Test=new v("test","Test"),Ce=v=Be([m],Ce),e.TaskGroup=Ce;function Se(O){let M="";for(let ee=0;ee<O.length;ee++)M+=O[ee].replace(/,/g,",,")+",";return M}let qe=class{constructor(M,ee,Ee){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=M,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=Ee):this._options=ee)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)M.push(ee);return Se(M)}};qe=Be([m],qe),e.ProcessExecution=qe;let We=class{constructor(M,ee,Ee){if(this._args=[],Array.isArray(ee)){if(!M)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M,this._args=ee,this._options=Ee}else{if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)M.push(typeof ee=="string"?ee:ee.value);return Se(M)}};We=Be([m],We),e.ShellExecution=We;var it;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class wt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=wt;let ot=w=class{constructor(M,ee,Ee,Ge,Ze,st){this.__deprecated=!1,this._definition=this.definition=M;let ut;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=Ee,this.execution=Ge,ut=Ze,this.__deprecated=!0):ee===mt.Global||ee===mt.Workspace?(this.target=ee,this._name=this.name=Ee,this._source=this.source=Ge,this.execution=Ze,ut=st):(this.target=ee,this._name=this.name=Ee,this._source=this.source=Ge,this.execution=Ze,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ee=this._definition.type;(w.EmptyType===ee||w.ProcessType===ee||w.ShellType===ee||w.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};ot.ExtensionCallbackType="customExecution",ot.ProcessType="process",ot.ShellType="shell",ot.EmptyType="$empty",ot=w=Be([m],ot),e.Task=ot;var ct;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(M,ee=Tt.None){this.collapsibleState=ee,y.URI.isUri(M)?this.resourceUri=M:this.label=M}};lt=Be([m],lt),e.TreeItem=lt;var Tt;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(M,ee){this.id=M,this.color=ee}};_t=Be([m],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Ut=class{constructor(M){this.id=M}};Ut=Be([m],Ut),e.ThemeColor=Ut;var Bt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(Bt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(M,ee){if(typeof M!="string"&&(!M||!y.URI.isUri(M)&&!y.URI.isUri(M.uri)))throw(0,F.illegalArgument)("base");if(typeof ee!="string")throw(0,F.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=y.URI.file(M),this.base=M):y.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=ee}};Ct=Be([m],Ct),e.RelativePattern=Ct;let $t=class{constructor(M,ee,Ee,Ge){this.enabled=typeof M=="boolean"?M:!0,typeof ee=="string"&&(this.condition=ee),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};$t=Be([m],$t),e.Breakpoint=$t;let ti=class extends $t{constructor(M,ee,Ee,Ge,Ze){super(ee,Ee,Ge,Ze);if(M===null)throw(0,F.illegalArgument)("location");this.location=M}};ti=Be([m],ti),e.SourceBreakpoint=ti;let gt=class extends $t{constructor(M,ee,Ee,Ge,Ze){super(ee,Ee,Ge,Ze);this.functionName=M}};gt=Be([m],gt),e.FunctionBreakpoint=gt;let Yt=class extends $t{constructor(M,ee,Ee,Ge,Ze,st,ut){super(Ge,Ze,st,ut);if(!ee)throw(0,F.illegalArgument)("dataId");this.label=M,this.dataId=ee,this.canPersist=Ee}};Yt=Be([m],Yt),e.DataBreakpoint=Yt;let Ht=class{constructor(M,ee,Ee){this.command=M,this.args=ee||[],this.options=Ee}};Ht=Be([m],Ht),e.DebugAdapterExecutable=Ht;let ii=class{constructor(M,ee){this.port=M,this.host=ee}};ii=Be([m],ii),e.DebugAdapterServer=ii;let ni=class{constructor(M){this.path=M}};ni=Be([m],ni),e.DebugAdapterNamedPipeServer=ni;let Pt=class{constructor(M){this.implementation=M}};Pt=Be([m],Pt),e.DebugAdapterInlineImplementation=Pt;let Jt=class{constructor(M,ee){this.range=M,this.expression=ee}};Jt=Be([m],Jt),e.EvaluatableExpression=Jt;var vi;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(vi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(M,ee){this.range=M,this.text=ee}};Wt=Be([m],Wt),e.InlineValueText=Wt;let dt=class{constructor(M,ee,Ee=!0){this.range=M,this.variableName=ee,this.caseSensitiveLookup=Ee}};dt=Be([m],dt),e.InlineValueVariableLookup=dt;let ri=class{constructor(M,ee){this.range=M,this.expression=ee}};ri=Be([m],ri),e.InlineValueEvaluatableExpression=ri;let Mt=class{constructor(M,ee){this.frameId=M,this.stoppedLocation=ee}};Mt=Be([m],Mt),e.InlineValueContext=Mt;var Vt;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Xt=D=class extends Error{constructor(M,ee=t.FileSystemProviderErrorCode.Unknown,Ee){super(y.URI.isUri(M)?M.toString(!0):M);this.code=Ee?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(M){return new D(M,t.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(M){return new D(M,t.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(M){return new D(M,t.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(M){return new D(M,t.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(M){return new D(M,t.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(M){return new D(M,t.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Xt=D=Be([m],Xt),e.FileSystemError=Xt;let si=class{constructor(M,ee,Ee){this.start=M,this.end=ee,this.kind=Ee}};si=Be([m],si),e.FoldingRange=si;var ci;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var di;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(di=e.CommentMode||(e.CommentMode={}));class oi{constructor(M,ee=[]){this.tokenTypes=M,this.tokenModifiers=ee}}e.SemanticTokensLegend=oi;function bi(O){return typeof O=="undefined"||(0,k.isStringArray)(O)}class jt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ee=0,Ee=M.tokenTypes.length;ee<Ee;ee++)this._tokenTypeStrToInt.set(M.tokenTypes[ee],ee);for(let ee=0,Ee=M.tokenModifiers.length;ee<Ee;ee++)this._tokenModifierStrToInt.set(M.tokenModifiers[ee],ee)}}push(M,ee,Ee,Ge,Ze){if(typeof M=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ge=="number"&&(typeof Ze=="number"||typeof Ze=="undefined"))return typeof Ze=="undefined"&&(Ze=0),this._pushEncoded(M,ee,Ee,Ge,Ze);if($.isRange(M)&&typeof ee=="string"&&bi(Ee))return this._push(M,ee,Ee);throw(0,F.illegalArgument)()}_push(M,ee,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ge=M.start.line,Ze=M.start.character,st=M.end.character-M.start.character,ut=this._tokenTypeStrToInt.get(ee);let St=0;if(Ee)for(const At of Ee){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);St|=1<<Lt>>>0}this._pushEncoded(Ge,Ze,st,ut,St)}_pushEncoded(M,ee,Ee,Ge,Ze){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Lt=0;for(let Ot=0;Ot<St;Ot++){let Nt=this._data[5*Ot],li=this._data[5*Ot+1];Nt===0?(Nt=At,li+=Lt):Nt+=At,this._data[5*Ot]=Nt,this._data[5*Ot+1]=li,At=Nt,Lt=li}}let st=M,ut=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Ze,this._prevLine=M,this._prevChar=ee}static _sortAndDeltaEncode(M){let ee=[];const Ee=M.length/5|0;for(let ut=0;ut<Ee;ut++)ee[ut]=ut;ee.sort((ut,St)=>{const At=M[5*ut],Lt=M[5*St];if(At===Lt){const Ot=M[5*ut+1],Nt=M[5*St+1];return Ot-Nt}return At-Lt});const Ge=new Uint32Array(M.length);let Ze=0,st=0;for(let ut=0;ut<Ee;ut++){const St=5*ee[ut],At=M[St+0],Lt=M[St+1],Ot=M[St+2],Nt=M[St+3],li=M[St+4],xi=At-Ze,qi=xi===0?Lt-st:Lt,ui=5*ut;Ge[ui+0]=xi,Ge[ui+1]=qi,Ge[ui+2]=Ot,Ge[ui+3]=Nt,Ge[ui+4]=li,Ze=At,st=Lt}return Ge}build(M){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),M):new qt(jt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=jt;class qt{constructor(M,ee){this.resultId=ee,this.data=M}}e.SemanticTokens=qt;class Ei{constructor(M,ee,Ee){this.start=M,this.deleteCount=ee,this.data=Ee}}e.SemanticTokensEdit=Ei;class _i{constructor(M,ee){this.resultId=ee,this.edits=M}}e.SemanticTokensEdits=_i;var Gt;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new _t("arrow-left")},Zt=Be([m],Zt),e.QuickInputButtons=Zt;var Si;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(M,ee,Ee){this.badge=M,this.tooltip=ee,this.color=Ee}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let Kt=class{constructor(M){this.kind=M}};Kt=Be([m],Kt),e.ColorTheme=Kt;var hi;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(hi=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(M,ee){if(M<0)throw(0,F.illegalArgument)("start must be positive");if(ee<0)throw(0,F.illegalArgument)("end must be positive");M<=ee?(this._start=M,this._end=ee):(this._start=ee,this._end=M)}static isNotebookRange(M){return M instanceof zt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let ee=this._start,Ee=this._end;return M.start!==void 0&&(ee=M.start),M.end!==void 0&&(Ee=M.end),ee===this._start&&Ee===this._end?this:new zt(ee,Ee)}}e.NotebookRange=zt;class Ft{constructor(M,ee,Ee,Ge,Ze,st,ut){this.kind=M,this.value=ee,this.languageId=Ee,this.mime=Ge,this.outputs=Ze??[],this.metadata=st,this.executionSummary=ut,Ft.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ee=>Ft.isNotebookCellData(ee))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Ft;class Fe{constructor(M){this.cells=M}}e.NotebookData=Fe;class Rt{constructor(M,ee){this.data=M,this.mime=ee;const Ee=(0,R.normalizeMimeType)(ee,!0);if(!Ee)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(M){return M instanceof Rt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ee={name:M.name,message:M.message,stack:M.stack};return Rt.json(ee,"application/vnd.code.notebook.error")}static stdout(M){return Rt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Rt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ee="application/octet-stream"){return new Rt(M,ee)}static text(M,ee=R.Mimes.text){const Ee=Me(Rt,a,"f",l).encode(String(M));return new Rt(Ee,ee)}static json(M,ee="application/json"){const Ee=JSON.stringify(M,void 0,"	");return Rt.text(Ee,ee)}}e.NotebookCellOutputItem=Rt,a=Rt,l={value:new TextEncoder};class Qt{constructor(M,ee,Ee){this.items=Qt.ensureUniqueMimeTypes(M,!0),typeof ee=="string"?(this.id=ee,this.metadata=Ee):(this.id=(0,T.generateUuid)(),this.metadata=ee??Ee)}static isNotebookCellOutput(M){return M instanceof Qt?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,k.isArray)(M.items)}static ensureUniqueMimeTypes(M,ee=!1){const Ee=new Set,Ge=new Set;for(let Ze=0;Ze<M.length;Ze++){const st=M[Ze],ut=(0,R.normalizeMimeType)(st.mime);if(!Ee.has(ut)){Ee.add(ut);continue}Ge.add(Ze),ee&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ge.size===0?M:M.filter((Ze,st)=>!Ge.has(st))}}e.NotebookCellOutput=Qt;var pt;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fi;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(fi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class mi{constructor(M,ee){this.text=M,this.alignment=ee}}e.NotebookCellStatusBarItem=mi;var Ii;(function(O){O[O.Default=1]="Default",O[O.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(M,ee=[]){this.uri=M,this.provides=(0,d.asArray)(ee)}}e.NotebookRendererScript=Pi;let ai=class{constructor(M,ee){this.label=M,this.timestamp=ee}};ai=Be([m],ai),e.TimelineItem=ai;var Ti;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var gi;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(gi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(M,ee){this.ranges=M,this.wordPattern=ee}}e.LinkedEditingRanges=Ri;class Fi{constructor(M,ee){this._port=M,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(O){O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let J=class{constructor(M,ee,Ee){this.include=M,this.exclude=ee,this.profile=Ee}};J=Be([m],J),e.TestRunRequest=J;let de=P=class{constructor(M){this.message=M}static diff(M,ee,Ee){const Ge=new P(M);return Ge.expectedOutput=ee,Ge.actualOutput=Ee,Ge}};de=P=Be([m],de),e.TestMessage=de;let ke=class{constructor(M,ee){if(this.id=M,this.label=ee,/\s/.test(M))throw new Error(`Test tag ID "${M}" may not include whitespace`)}};ke=Be([m],ke),e.TestTag=ke;let nt=class{constructor(M,ee){this.covered=M,this.total=ee}};nt=Be([m],nt),e.CoveredCount=nt;let bt=n=class{constructor(M,ee,Ee,Ge){this.uri=M,this.statementCoverage=ee,this.branchCoverage=Ee,this.functionCoverage=Ge}static fromDetails(M,ee){const Ee=new nt(0,0),Ge=new nt(0,0),Ze=new nt(0,0);for(const ut of ee)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const St of ut.branches)Ge.total+=1,Ge.covered+=St.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=ut.executionCount>0?1:0;const st=new n(M,Ee,Ge.total>0?Ge:void 0,Ze.total>0?Ze:void 0);return st.detailedCoverage=ee,st}};bt=n=Be([m],bt),e.FileCoverage=bt;let Dt=class{constructor(M,ee,Ee=[]){this.executionCount=M,this.location=ee,this.branches=Ee}};Dt=Be([m],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(M,ee){this.executionCount=M,this.location=ee}};Oi=Be([m],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(M,ee){this.executionCount=M,this.location=ee}};Ni=Be([m],Ni),e.FunctionCoverage=Ni;var zi;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hi;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(Hi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore",O[O.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(M,ee,Ee,Ge,Ze,st){this.kind=M,this.name=ee,this.detail=Ee,this.uri=Ge,this.range=Ze,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(we[89],be([0,1,39,11,9,228,146,6,16]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function t(a,l){l?T.set(a,l):T.delete(a)}e.setWordDefinitionFor=t;function _(a){return T.get(a)}e.getWordDefinitionFor=_;class r extends A.MirrorTextModel{constructor(l,g,I,b,c,p,S,i){super(g,I,b,c);this._proxy=l,this._languageId=p,this._isDirty=S,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,y.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===F.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(g){return g?l._getTextInRange(g):l.getText()},get eol(){return l._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(g){return l._lineAt(g)},offsetAt(g){return l._offsetAt(g)},positionAt(g){return l._positionAt(g)},validateRange(g){return l._validateRange(g)},validatePosition(g){return l._validatePosition(g)},getWordRangeAtPosition(g,I){return l._getWordRangeAtPosition(g,I)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,d.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,d.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const g=this._validateRange(l);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const I=this._eol,b=g.start.line,c=g.end.line,p=[];p.push(this._lines[b].substring(g.start.character));for(let S=b+1;S<c;S++)p.push(this._lines[S]);return p.push(this._lines[c].substring(0,g.end.character)),p.join(I)}_lineAt(l){let g;if(l instanceof k.Position?g=l.line:typeof l=="number"&&(g=l),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new h(g,this._lines[g],g===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(l),I=this._lines[g.index].length;return new k.Position(g.index,Math.min(g.remainder,I))}_validateRange(l){if(!(l instanceof k.Range))throw new Error("Invalid argument");const g=this._validatePosition(l.start),I=this._validatePosition(l.end);return g===l.start&&I===l.end?l:new k.Range(g.line,g.character,I.line,I.character)}_validatePosition(l){if(!(l instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:g,character:I}=l,b=!1;if(g<0)g=0,I=0,b=!0;else if(g>=this._lines.length)g=this._lines.length-1,I=this._lines[g].length,b=!0;else{const c=this._lines[g].length;I<0?(I=0,b=!0):I>c&&(I=c,b=!0)}return b?new k.Position(g,I):l}_getWordRangeAtPosition(l,g){const I=this._validatePosition(l);if(!g)g=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const b=(0,R.getWordAtText)(I.character+1,(0,R.ensureValidWordDefinition)(g),this._lines[I.line],0);if(b)return new k.Range(I.line,b.startColumn-1,I.line,b.endColumn-1)}}e.ExtHostDocumentData=r;class h{constructor(l,g,I){this._line=l,this._text=g,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[155],be([0,1,6,3,229,7,54,20,2,36]),function(ie,e,d,F,E,A,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(r,h,a,l){this._notebook=a,this._selector=l,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(I=>{const b=this._cellUris.get(I.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(r.onDidChangeNotebookCells(I=>g(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const r=[],h=[];for(const a of this._notebook.getCells())a.kind===d.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),r.push(a.document.getText().length+1),h.push(a.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(r)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(r){if(!r){let b="";for(const c of this._cells)b+=c.document.getText()+`
`;return b=b.slice(0,-1),b}if(r.isEmpty)return"";const h=this.locationAt(r.start),a=this.locationAt(r.end),l=this._cellUris.get(h.uri),g=this._cellUris.get(a.uri);if(l===void 0||g===void 0)return"";if(l===g)return this._cells[l].document.getText(new d.Range(h.range.start,a.range.end));const I=[this._cells[l].document.getText(new d.Range(h.range.start,new d.Position(this._cells[l].document.lineCount,0)))];for(let b=l+1;b<g;b++)I.push(this._cells[b].document.getText());return I.push(this._cells[g].document.getText(new d.Range(new d.Position(0,0),a.range.end))),I.join(`
`)}offsetAt(r){const h=this._cellLines.getIndexOf(r.line),a=this._cellLengths.getPrefixSum(h.index-1),l=this._cells[h.index].document.offsetAt(r.with(h.remainder));return a+l}positionAt(r){if(typeof r=="number"){const a=this._cellLengths.getIndexOf(r),l=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(l)}const h=this._cellUris.get(r.uri);if(h!==void 0){const a=this._cellLines.getPrefixSum(h-1);return new d.Position(a+r.range.start.line,r.range.start.character)}return new d.Position(0,0)}locationAt(r){d.Range.isRange(r)||(r=new d.Range(r,r));const h=this._cellLines.getIndexOf(r.start.line);let a=h;r.isEmpty||(a=this._cellLines.getIndexOf(r.end.line));const l=new d.Position(h.remainder,r.start.character),g=new d.Position(a.remainder,r.end.character),I=new d.Range(l,g),b=this._cells[h.index];return new d.Location(b.document.uri,b.document.validateRange(I))}contains(r){return this._cellUris.has(r)}validateRange(r){const h=this.validatePosition(r.start),a=this.validatePosition(r.end);return r.with(h,a)}validatePosition(r){const h=this._cellLines.getIndexOf(r.line),a=new d.Position(h.remainder,r.character),l=this._cells[h.index].document.validatePosition(a),g=this._cellLines.getPrefixSum(h.index-1);return new d.Position(g+l.line,l.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[156],be([0,1,6,12,3]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let y=k==="light"?d.ColorThemeKind.Light:k==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([ze(0,F.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(we[67],be([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class F{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=F}),define(we[157],be([0,1,23]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function E(k,y){if(y.serializeBuffersForPostMessage){const T=new F,t=(h,a)=>{if(a instanceof ArrayBuffer){const l=T.add(a);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(a)){const l=A(a);if(l){const g=T.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:l,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},_=JSON.stringify(k,t),r=T.buffers.map(h=>{const a=new Uint8Array(h);return d.VSBuffer.wrap(a)});return{message:_,buffers:r}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=E;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(k,y){const T=y.map(r=>{const h=new ArrayBuffer(r.byteLength);return new Uint8Array(h).set(r.buffer),h}),t=y.length?(r,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const a=h,{index:l}=a,g=T[l];if(a.view)switch(a.view.type){case 1:return new Int8Array(g,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return h}:void 0;return{message:JSON.parse(k,t),arrayBuffers:T}}e.deserializeWebviewMessage=R}),define(we[158],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(F){function E(R){const k={items:new Map};return R.types.forEach((y,T)=>{k.items.set(y,{asString:async()=>R.items[T].asString})}),k}F.toITreeDataTransfer=E;async function A(R){const k={types:[],items:[]},y=Array.from(R.items.entries());for(const T of y)k.types.push(T[0]),k.items.push({asString:await T[1].asString()});return k}F.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[68],be([0,1,11,2]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(k,y){return k.scheme===d.Schemas.http||k.scheme===d.Schemas.https?k:(y&&y.authority&&y.isRemote&&k.scheme===d.Schemas.file&&(k=F.URI.from({scheme:d.Schemas.vscodeRemote,authority:y.authority,path:k.path})),F.URI.from({scheme:d.Schemas.https,authority:`${k.scheme}+${A(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=E;function A(k){return k.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function R(k){return k.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=R}),define(we[159],be([0,1,3,7,68]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,y,T){this._proxy=k,this._editors=y,this._initData=T,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const t=y.getVisibleTextEditors();for(const _ of this._insets.values())t.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,y,T,t,_){let r;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===k){r=c;break}if(!r)throw new Error("not a visible editor");const h=this,a=this._handlePool++,l=new d.Emitter,g=new d.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,E.asWebviewUri)(c,h._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(c){this._options=c,h._proxy.$setOptions(a,c)}get options(){return this._options}set html(c){this._html=c,h._proxy.$setHtml(a,c)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(c){return h._proxy.$postMessage(a,c)}},b=new class{constructor(){this.editor=k,this.line=y,this.height=T,this.webview=I,this.onDidDispose=g.event}dispose(){h._insets.has(a)&&(h._insets.delete(a),h._proxy.$disposeEditorInset(a),g.fire(),g.dispose(),l.dispose())}};return this._proxy.$createEditorInset(a,r.id,r.value.document.uri,y+1,T,t||{},_.identifier,_.extensionLocation),this._insets.set(a,{editor:k,inset:b,onDidReceiveMessage:l}),b}$onDidDispose(k){const y=this._insets.get(k);y&&y.inset.dispose()}$onDidReceiveMessage(k,y){const T=this._insets.get(k);T&&T.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=A}),define(we[160],be([0,1,128,10,2,7,4,42,28,16,11]),function(ie,e,d,F,E,A,R,k,y,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,d.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(12,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(13,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(14,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(15,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,d.localize)(17,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,d.localize)(18,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,d.localize)(19,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(20,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,d.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function _(n){return typeof n?.getViewState=="function"}e.isTextEditorPane=_;function r(n){if(c(n))return!1;const m=n;return E.URI.isUri(m?.resource)}e.isResourceEditorInput=r;function h(n){if(c(n))return!1;const m=n;return m?.original!==void 0&&m.modified!==void 0}e.isResourceDiffEditorInput=h;function a(n){if(c(n))return!1;const m=n;return m?m.resource===void 0||m.resource.scheme===t.Schemas.untitled||m.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var l;(function(n){n[n.SHORT=0]="SHORT",n[n.MEDIUM=1]="MEDIUM",n[n.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var g;(function(n){n[n.EXPLICIT=1]="EXPLICIT",n[n.AUTO=2]="AUTO",n[n.FOCUS_CHANGE=3]="FOCUS_CHANGE",n[n.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g=e.SaveReason||(e.SaveReason={}));var I;(function(n){n[n.None=0]="None",n[n.Readonly=2]="Readonly",n[n.Untitled=4]="Untitled",n[n.Singleton=8]="Singleton",n[n.RequiresTrust=16]="RequiresTrust"})(I=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class b extends A.Disposable{}e.AbstractEditorInput=b;function c(n){return n instanceof b}e.isEditorInput=c;function p(n){const m=n;return E.URI.isUri(m?.preferredResource)}function S(n){const m=n;return c(m?.primary)&&c(m?.secondary)}e.isSideBySideEditorInput=S;function i(n){return c(n?.editor)}e.isEditorInputWithOptions=i;function s(n){const m=n;return i(n)&&m?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function u(n){const m=n;return typeof m?.groupId=="number"&&c(m.editor)}e.isEditorIdentifier=u;var o;(function(n){n[n.PRIMARY=1]="PRIMARY",n[n.SECONDARY=2]="SECONDARY",n[n.BOTH=3]="BOTH"})(o=e.SideBySideEditor||(e.SideBySideEditor={}));class f{getOriginalUri(m,C){if(!m)return;const L=S(m)?m.primary:h(m)?m.modified:void 0,$=S(m)?m.secondary:h(m)?m.original:void 0;if(C?.supportSideBySide&&L&&$){if(C?.supportSideBySide===o.BOTH)return{primary:this.getOriginalUri(L,{filterByScheme:C.filterByScheme}),secondary:this.getOriginalUri($,{filterByScheme:C.filterByScheme})};m=C.supportSideBySide===o.PRIMARY?L:$}if(h(m))return;const Q=p(m)?m.preferredResource:m.resource;return!Q||!C||!C.filterByScheme?Q:this.filterUri(Q,C.filterByScheme)}getCanonicalUri(m,C){if(!m)return;const L=S(m)?m.primary:h(m)?m.modified:void 0,$=S(m)?m.secondary:h(m)?m.original:void 0;if(C?.supportSideBySide&&L&&$){if(C?.supportSideBySide===o.BOTH)return{primary:this.getCanonicalUri(L,{filterByScheme:C.filterByScheme}),secondary:this.getCanonicalUri($,{filterByScheme:C.filterByScheme})};m=C.supportSideBySide===o.PRIMARY?L:$}if(h(m))return;const Q=m.resource;return!Q||!C||!C.filterByScheme?Q:this.filterUri(Q,C.filterByScheme)}filterUri(m,C){if(Array.isArray(C)){if(C.some(L=>m.scheme===L))return m}else if(C===m.scheme)return m}}e.EditorResourceAccessor=new f;var v;(function(n){n[n.LEFT=0]="LEFT",n[n.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class w{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(m){const C=this.instantiationService=m.get(R.IInstantiationService);for(const[L,$]of this.editorSerializerConstructors)this.createEditorSerializer(L,$,C);this.editorSerializerConstructors.clear()}createEditorSerializer(m,C,L){const $=L.createInstance(C);this.editorSerializerInstances.set(m,$)}registerFileEditorFactory(m){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=m}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(m,C){if(this.editorSerializerConstructors.has(m)||this.editorSerializerInstances.has(m))throw new Error(`A editor serializer with type ID '${m}' was already registered.`);return this.instantiationService?this.createEditorSerializer(m,C,this.instantiationService):this.editorSerializerConstructors.set(m,C),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(m),this.editorSerializerInstances.delete(m)})}getEditorSerializer(m){return this.editorSerializerInstances.get(typeof m=="string"?m:m.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new w);async function D(n,m){if(!n||!n.length)return[];const C=await Promise.all(n.map(async L=>{const $=E.URI.revive(L.fileUri);if(!$||(await m.activateProvider($.scheme),!m.canHandleResource($)))return;const Q=typeof L.exists=="boolean"?L.exists:await m.exists($);if(!Q&&L.openOnlyIfExists)return;const se=Q&&!(0,F.isUndefined)(L.selection)?{selection:L.selection,pinned:!0,override:L.editorOverrideId}:{pinned:!0,override:L.editorOverrideId};let G;return Q?G={resource:$,options:se,forceFile:!0}:G={resource:$,options:se,forceUntitled:!0},G}));return(0,T.coalesce)(C)}e.pathsToEditors=D;var P;(function(n){n[n.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",n[n.SEQUENTIAL=1]="SEQUENTIAL"})(P=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[161],be([0,1,3,42,129,4,7,20,28,16,50,22,34,151]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",r.Codicon.window,(0,E.localize)(0,null));var a;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var l;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={}));function g(f){switch(f){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=g;function I(f){return`viewContainer.${f}.enabled`}e.getEnabledViewContainerContextKey=I;class b extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(v,w,D){const P=this.get(v.id);if(P)return P;const n=v;return n.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,k.getOrSet)(this.viewContainers,w,[]).push(n),D?.isDefault&&this.defaultViewContainers.push(n),this._onDidRegister.fire({viewContainer:n,viewContainerLocation:w}),n}deregisterViewContainer(v){for(const w of this.viewContainers.keys()){const D=this.viewContainers.get(w),P=D?.indexOf(v);if(P!==-1){D?.splice(P,1),D.length===0&&this.viewContainers.delete(w),this._onDidDeregister.fire({viewContainer:v,viewContainerLocation:w});return}}}get(v){return this.all.filter(w=>w.id===v)[0]}getViewContainers(v){return[...this.viewContainers.get(v)||[]]}getViewContainerLocation(v){return[...this.viewContainers.keys()].filter(w=>this.getViewContainers(w).filter(D=>D?.id===v.id).length>0)[0]}getDefaultViewContainer(v){return this.defaultViewContainers.find(w=>this.getViewContainerLocation(w)===v)}}y.Registry.add(a.ViewContainersRegistry,new b);var c;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function p(f,v){const w=f.group??c.More,D=v.group??c.More;return w!==D?w.localeCompare(D):(f.order??5)-(v.order??5)}class S extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(v,w){this.registerViews2([{views:v,viewContainer:w}])}registerViews2(v){v.forEach(({views:w,viewContainer:D})=>this.addViews(w,D)),this._onViewsRegistered.fire(v)}deregisterViews(v,w){const D=this.removeViews(v,w);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:w})}moveViews(v,w){for(const D of this._views.keys())if(D!==w){const P=this.removeViews(v,D);P.length&&(this.addViews(P,w),this._onDidChangeContainer.fire({views:P,from:D,to:w}))}}getViews(v){return this._views.get(v)||[]}getView(v){for(const w of this._viewContainers){const D=(this._views.get(w)||[]).filter(P=>P.id===v)[0];if(D)return D}return null}getViewContainer(v){for(const w of this._viewContainers)if((this._views.get(w)||[]).filter(P=>P.id===v)[0])return w;return null}registerViewWelcomeContent(v,w){return this._viewWelcomeContents.add(v,w),this._onDidChangeViewWelcomeContent.fire(v),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(v,w),this._onDidChangeViewWelcomeContent.fire(v)})}registerViewWelcomeContent2(v,w){const D=new Map;for(const[P,n]of w)this._viewWelcomeContents.add(v,n),D.set(P,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(v,n),this._onDidChangeViewWelcomeContent.fire(v)}));return this._onDidChangeViewWelcomeContent.fire(v),D}getViewWelcomeContent(v){const w=[];return this._viewWelcomeContents.forEach(v,D=>w.push(D)),w.sort(p)}addViews(v,w){let D=this._views.get(w);D||(D=[],this._views.set(w,D),this._viewContainers.push(w));for(const P of v){if(this.getView(P.id)!==null)throw new Error((0,E.localize)(1,null,P.id));D.push(P)}}removeViews(v,w){const D=this._views.get(w);if(!D)return[];const P=[],n=[];for(const m of D)v.includes(m)?P.push(m):n.push(m);return P.length&&(n.length?this._views.set(w,n):(this._views.delete(w),this._viewContainers.splice(this._viewContainers.indexOf(w),1))),P}}y.Registry.add(a.ViewsRegistry,new S),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(f){return`view.${f}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var s;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(s=e.ViewVisibilityState||(e.ViewVisibilityState={}));var u;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(u=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(v,w){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,v),this._hasResolve=!!w,this.resolve=async D=>{if(w&&!this.resolved){const P=await w(D);P&&(this.tooltip=this.tooltip??P.tooltip,this.command=this.command??P.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[162],be([0,1,3,13,130]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,y,T,t){const _={command:k};if(y&&Object.keys(y).length>0&&(_.arguments=y),this.internalSend("request",_),typeof t=="number"){const r=setTimeout(()=>{clearTimeout(r);const h=this.pendingRequests.get(_.seq);if(h){this.pendingRequests.delete(_.seq);const a={type:"response",seq:0,request_seq:_.seq,success:!1,command:k,message:(0,E.localize)(0,null,t,k)};h(a)}},t)}return T&&this.pendingRequests.set(_.seq,T),_.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,y){return k.type!=="event"||y.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,F.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const y=k,T=this.pendingRequests.get(y.request_seq);T&&(this.pendingRequests.delete(y.request_seq),T(y));break}}}internalSend(k,y){y.type=k,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((y,T)=>k.set(T,y)),await(0,F.timeout)(500),k.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(we[163],be([0,1,9,2,17,22,11]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function y(u,o,f){return u.replace(k,function(v,w){return o&&w.length>0&&w[0]!=="_"?v:f&&f.hasOwnProperty(w)?f[w]:v})}e.formatPII=y;function T(u){const o={};for(const f of Object.keys(u))f.startsWith("!")||(o[f]=u[f]);return o}e.filterExceptionsFromTelemetry=T;function t(u){return u.configuration.request==="attach"&&!_(u)&&(!u.parentSession||t(u.parentSession))}e.isSessionAttach=t;function _(u){let o=u.configuration.type;if(!!o)return o==="vslsShare"&&(o=u.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(o,"extensionhost")||(0,d.equalsIgnoreCase)(o,"pwa-extensionhost")?u:u.parentSession?_(u.parentSession):void 0}e.getExtensionHostDebugSession=_;function r(u){return u.type&&(u.label||u.program||u.runtime)}e.isDebuggerMainContribution=r;function h(u,o,f){let v,w=0,D=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=D.exec(u);){let n=P.index+1,m=n+P[0].length;if(n<=o&&m>=f){v=P[0],w=n;break}}if(v){let n=/\w+/g,m=null;for(;(m=n.exec(v))&&!(m.index+1+w+m[0].length>=f););m&&(v=v.substring(0,n.lastIndex))}return v?{start:w,end:w+v.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(u){return!!(u&&u.match(a))}e.isUri=l;function g(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(l(u.path))return F.URI.parse(u.path);if((0,E.isAbsolute)(u.path))return F.URI.file(u.path)}return u.path}function I(u){if(typeof u.path=="object"){const o=F.URI.revive(u.path);if(o)return o.scheme===R.Schemas.file?o.fsPath:o.toString()}return u.path}function b(u,o){const f=o?g:I,v=(0,A.deepClone)(u);return p(v,(w,D)=>{w&&D&&(D.path=f(D))}),v}e.convertToDAPaths=b;function c(u,o){const f=o?g:I,v=(0,A.deepClone)(u);return p(v,(w,D)=>{!w&&D&&(D.path=f(D))}),v}e.convertToVSCPaths=c;function p(u,o){switch(u.type){case"event":const f=u;switch(f.event){case"output":o(!1,f.body.source);break;case"loadedSource":o(!1,f.body.source);break;case"breakpoint":o(!1,f.body.breakpoint.source);break;default:break}break;case"request":const v=u;switch(v.command){case"setBreakpoints":o(!0,v.arguments.source);break;case"breakpointLocations":o(!0,v.arguments.source);break;case"source":o(!0,v.arguments.source);break;case"gotoTargets":o(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(D=>o(!1,D));break;default:break}break;case"response":const w=u;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(D=>o(!1,D.source));break;case"loadedSources":w.body.sources.forEach(D=>o(!1,D));break;case"scopes":w.body.scopes.forEach(D=>o(!1,D.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(D=>o(!1,D.source));break;case"setBreakpoints":w.body.breakpoints.forEach(D=>o(!1,D.source));break;default:break}break}}function S(u){return u.filter(o=>!o.presentation?.hidden).sort((o,f)=>o.presentation?f.presentation?o.presentation.group?f.presentation.group?o.presentation.group!==f.presentation.group?o.presentation.group.localeCompare(f.presentation.group):i(o.presentation.order,f.presentation.order):-1:f.presentation.group?1:i(o.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=S;function i(u,o){return typeof u!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:u-o}async function s(u,o){const f=u.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorMode});if(f!=="none"&&(await o.saveAll(),f==="allEditorsInActiveGroup")){const v=o.activeEditorPane;v&&await o.save({editor:v.input,groupId:v.group.id})}await u.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(we[90],be([0,1,27,79,11,17,25,42]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(n){n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var r;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(r=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeLanguage=5]="ChangeLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var g;(function(n){n.scheme=E.Schemas.vscodeNotebookCell;const m=/^ch(\d{7,})/;function C(G,z){return G.with({scheme:n.scheme,fragment:`ch${z.toString().padStart(7,"0")}${G.scheme!==E.Schemas.file?G.scheme:""}`})}n.generate=C;function L(G){if(G.scheme!==n.scheme)return;const z=m.exec(G.fragment);return z?{handle:Number(z[1]),notebook:G.with({scheme:G.fragment.substr(z[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parse=L;function $(G){if(G.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const z=m.exec(G.fragment);return z?{handle:Number(z[1]),notebook:G.with({scheme:G.fragment.substr(z[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parseCellMetadataUri=$;function Q(G,z,x){return G.with({scheme:x,fragment:`ch${z.toString().padStart(7,"0")}${G.scheme!==E.Schemas.file?G.scheme:""}`})}n.generateCellUri=Q;function se(G,z){if(G.scheme!==z)return;const x=m.exec(G.fragment);return x?{handle:Number(x[1]),notebook:G.with({scheme:G.fragment.substr(x[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parseCellUri=se})(g=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(n){return I.get(n)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function c(n){return I.get(n)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function p(n){return I.get(n)?.mergeable??!1}e.mimeTypeIsMergeable=p;function S(n,m){return R.isWindows&&(n=n.replace(/\//g,"\\"),m=m.replace(/\//g,"\\")),d.match(n,m)}function i(n,m,C){let L=0;for(let $=0;$<m.length;$++){if(S(m[$],n))return L;L++}for(let $=0;$<C.length;$++){if(S(C[$],n))return L;L++}return L}function s(n,m,C){return n.sort((L,$)=>i(L,m,C)-i($,m,C))}e.sortMimeTypes=s;function u(n,m,C,L=($,Q)=>$===Q){const $=[];function Q(z,x,j){if(x===0&&j.length===0)return;const B=$[$.length-1];B&&B.start+B.deleteCount===z?(B.deleteCount+=x,B.toInsert.push(...j)):$.push({start:z,deleteCount:x,toInsert:j})}let se=0,G=0;for(;;){if(se===n.length){Q(se,0,m.slice(G));break}if(G===m.length){Q(se,n.length-se,[]);break}const z=n[se],x=m[G];if(L(z,x)){se+=1,G+=1;continue}C(x)?(Q(se,1,[]),se+=1):(Q(se,0,[x]),G+=1)}return $}e.diff=u,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(n){n.default="default",n.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function f(n){const m=n;return!!((typeof m.include=="string"||d.isRelativePattern(m.include))&&(typeof m.exclude=="string"||d.isRelativePattern(m.exclude)))}e.isDocumentExcludePattern=f;function v(n,m,C){if(Array.isArray(n.viewType)&&n.viewType.indexOf(m)>=0||n.viewType===m)return!0;if(n.filenamePattern){let L=f(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,$=f(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(d.match(L,(0,A.basename)(C.fsPath).toLowerCase()))return!($&&d.match($,(0,A.basename)(C.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class w{constructor(m){this.textModel=m}getElements(){const m=new Int32Array(this.textModel.cells.length);for(let C=0;C<this.textModel.cells.length;C++)m[C]=this.textModel.cells[C].getHashValue();return m}}e.CellSequence=w,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var D;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(m){return`${P._prefix}${m}`}static parse(m){if(m.startsWith(P._prefix))return m.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(we[164],be([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(we[165],be([0,1,132,4,42]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[166],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=d;function F(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=F}),define(we[91],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var F;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(_,r)=>{r.expand!==void 0&&(_.expand=r.expand),r.item!==void 0&&(_.item=_.item?Object.assign(_.item,r.item):r.item)};e.applyTestItemUpdate=R;var k;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var y;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(r){}update(r){}remove(r,h){}complete(){}}e.IncrementalChangeCollector=T;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(r){const h=this.createChangeCollector();for(const a of r)switch(a[0]){case 0:{const l=a[1];if(l.parent){if(this.items.has(l.parent)){const g=this.items.get(l.parent);g.children.add(l.item.extId);const I=this.createItem(l,g);this.items.set(l.item.extId,I),h.add(I)}}else{const g=this.createItem(l);this.roots.add(g),this.items.set(l.item.extId,g),h.add(g)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=a[1],g=this.items.get(l.extId);if(!g)break;l.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,l),h.update(g);break}case 2:{const l=this.items.get(a[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const g=[[a[1]]];for(;g.length;)for(const I of g.pop()){const b=this.items.get(I);b&&(g.push(b.children),this.items.delete(I),h.remove(b,b!==l),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break;case 5:this._tags.set(a[1].id,a[1]);break;case 6:this._tags.delete(a[1]);break}h.complete()}retireTest(r){}updatePendingRoots(r){this.pendingRootCount+=r}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=t}),define(we[69],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class E{constructor(R,k=R.length){if(this.path=R,this.viewEnd=k,R.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,k,y=R.parent){if(R.id===k)return new E([k]);let T=[R.id];for(let t=y;t&&t.id!==k;t=t.parent)T.push(t.id);return T.push(k),new E(T.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new E(R.split("\0"))}static join(R,k){return new E([...R.path,k])}static joinToString(R,k){return R.toString()+"\0"+k}static compare(R,k){return R===k?0:k.startsWith(R+"\0")?2:R.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new E(this.path,R)}compare(R){if(typeof R=="string")return E.compare(this.toString(),R);for(let k=0;k<R.viewEnd&&k<this.viewEnd;k++)if(R.path[k]!==this.path[k])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=E}),define(we[167],be([0,1,17,61,10,22,25,78,133]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(_,r,h){this._contributedVariables=new Map,this._context=_,this._labelService=r,h&&(this._envVariablesPromise=h.then(a=>this.prepareEnv(a)))}prepareEnv(_){if(R.isWindows){const r=Object.create(null);return Object.keys(_).forEach(h=>{r[h.toLowerCase()]=_[h]}),r}return _}resolveWithEnvironment(_,r,h){return this.recursiveResolve(this.prepareEnv(_),r?r.uri:void 0,h)}async resolveAsync(_,r){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,r)}async resolveAnyBase(_,r,h,a){const l=A.deepClone(r);return R.isWindows&&l.windows?Object.keys(l.windows).forEach(g=>l[g]=l.windows[g]):R.isMacintosh&&l.osx?Object.keys(l.osx).forEach(g=>l[g]=l.osx[g]):R.isLinux&&l.linux&&Object.keys(l.linux).forEach(g=>l[g]=l.linux[g]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,l,h,a)}async resolveAnyAsync(_,r,h){return this.resolveAnyBase(_,r,h)}async resolveAnyMap(_,r,h){const a=new Map;return{newConfig:await this.resolveAnyBase(_,r,h,a),resolvedVariables:a}}resolveWithInteractionReplace(_,r,h,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,r,h,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,r){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,r)}recursiveResolve(_,r,h,a,l){if(E.isString(h))return this.resolveString(_,r,h,a,l);if(E.isArray(h))return h.map(g=>this.recursiveResolve(_,r,g,a,l));if(E.isObject(h)){let g=Object.create(null);return Object.keys(h).forEach(I=>{const b=this.resolveString(_,r,I,a,l);g[b]=this.recursiveResolve(_,r,h[I],a,l)}),g}return h}resolveString(_,r,h,a,l){return h.replace(T.VARIABLE_REGEXP,(I,b)=>{if(b.includes(T.VARIABLE_LHS))return I;let c=this.evaluateSingleVariable(_,I,b,r,a);return l&&l.set(b,c),c!==I&&E.isString(c)&&c.match(T.VARIABLE_REGEXP)&&(c=this.resolveString(_,r,c,a,l)),c})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,r,h,a,l){let g;const I=h.split(":");I.length>1&&(h=I[0],g=I[1]);const b=()=>{const S=this._context.getFilePath();if(S)return S;throw new Error((0,y.localize)(0,null,r))},c=()=>{const S=b();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,y.localize)(1,null,r,d.basename(S)))},p=()=>{if(g){const S=this._context.getFolderUri(g);if(S)return S;throw new Error((0,y.localize)(2,null,r,g))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,r)):new Error((0,y.localize)(4,null,r))};switch(h){case"env":if(g){if(_){const S=_[R.isWindows?g.toLowerCase():g];if(E.isString(S))return S}return""}throw new Error((0,y.localize)(5,null,r));case"config":if(g){const S=this._context.getConfigurationValue(a,g);if(E.isUndefinedOrNull(S))throw new Error((0,y.localize)(6,null,r,g));if(E.isObject(S))throw new Error((0,y.localize)(7,null,r,g));return S}throw new Error((0,y.localize)(8,null,r));case"command":return this.resolveFromMap(r,g,l,"command");case"input":return this.resolveFromMap(r,g,l,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return a||g?(0,k.normalizeDriveLetter)(this.fsPath(p())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(p()));case"lineNumber":const S=this._context.getLineNumber();if(S)return S;throw new Error((0,y.localize)(9,null,r));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,y.localize)(10,null,r));case"file":return b();case"fileWorkspaceFolder":return c();case"relativeFile":return a||g?d.relative(this.fsPath(p()),b()):b();case"relativeFileDirname":const s=d.dirname(b());if(a||g){const v=d.relative(this.fsPath(p()),s);return v.length===0?".":v}return s;case"fileDirname":return d.dirname(b());case"fileExtname":return d.extname(b());case"fileBasename":return d.basename(b());case"fileBasenameNoExtension":const u=d.basename(b());return u.slice(0,u.length-d.extname(u).length);case"fileDirnameBasename":return d.basename(d.dirname(b()));case"execPath":const o=this._context.getExecPath();return o||r;case"execInstallFolder":const f=this._context.getAppRoot();return f||r;case"pathSeparator":return d.sep;default:try{const v=g?`${h}:${g}`:h;return this.resolveFromMap(r,v,l,void 0)}catch(v){return r}}}}resolveFromMap(_,r,h,a){if(r&&h){const l=a===void 0?h[r]:h[a+":"+r];if(typeof l=="string")return l;throw new Error((0,y.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[92],be([0,1,4,160]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var E;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var k;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(l){const g=l;return(0,F.isEditorInput)(g?.editor)&&(0,F.isEditorInput)(g?.replacement)}e.isEditorReplacement=T;var t;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.GROUP_LOCKED=2]="GROUP_LOCKED",l[l.EDITOR_OPEN=3]="EDITOR_OPEN",l[l.EDITOR_CLOSE=4]="EDITOR_CLOSE",l[l.EDITOR_MOVE=5]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=7]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=9]="EDITOR_PIN",l[l.EDITOR_STICKY=10]="EDITOR_STICKY",l[l.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function h(l){const g=l;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=h;function a(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(we[168],be([0,1,4,92]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const R=A;return typeof A=="number"||(0,F.isEditorGroup)(R)}e.isPreferredGroup=E}),define(we[8],be([0,1,16,23,77,230,53,22,10,2,41,58,134,83,65,90,69,168,6]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(te){function pe(U){const{selectionStartLineNumber:Ce,selectionStartColumn:Se,positionLineNumber:qe,positionColumn:We}=U,it=new b.Position(Ce-1,Se-1),mt=new b.Position(qe-1,We-1);return new b.Selection(it,mt)}te.to=pe;function ne(U){const{anchor:Ce,active:Se}=U;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}te.from=ne})(c=e.Selection||(e.Selection={}));var p;(function(te){function pe(U){if(!U)return;const{start:Ce,end:Se}=U;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}te.from=pe;function ne(U){if(!U)return;const{startLineNumber:Ce,startColumn:Se,endLineNumber:qe,endColumn:We}=U;return new b.Range(Ce-1,Se-1,qe-1,We-1)}te.to=ne})(p=e.Range||(e.Range={}));var S;(function(te){function pe(ne){switch(ne){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}te.to=pe})(S=e.TokenType||(e.TokenType={}));var i;(function(te){function pe(U){return new b.Position(U.lineNumber-1,U.column-1)}te.to=pe;function ne(U){return{lineNumber:U.line+1,column:U.character+1}}te.from=ne})(i=e.Position||(e.Position={}));var s;(function(te){function pe(U){switch(U){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}te.from=pe;function ne(U){switch(U){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}te.to=ne})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(te){function pe(U){let Ce;return U.code&&((0,y.isString)(U.code)||(0,y.isNumber)(U.code)?Ce=String(U.code):Ce={value:String(U.code.value),target:U.code.target}),{...p.from(U.range),message:U.message,source:U.source,code:Ce,severity:f.from(U.severity),relatedInformation:U.relatedInformation&&U.relatedInformation.map(o.from),tags:Array.isArray(U.tags)?(0,d.coalesce)(U.tags.map(s.from)):void 0}}te.from=pe;function ne(U){const Ce=new b.Diagnostic(p.to(U),U.message,f.to(U.severity));return Ce.source=U.source,Ce.code=(0,y.isString)(U.code)?U.code:U.code?.value,Ce.relatedInformation=U.relatedInformation&&U.relatedInformation.map(o.to),Ce.tags=U.tags&&(0,d.coalesce)(U.tags.map(s.to)),Ce}te.to=ne})(u=e.Diagnostic||(e.Diagnostic={}));var o;(function(te){function pe(U){return{...p.from(U.location.range),message:U.message,resource:U.location.uri}}te.from=pe;function ne(U){return new b.DiagnosticRelatedInformation(new b.Location(U.resource,p.to(U)),U.message)}te.to=ne})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(te){function pe(U){switch(U){case b.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}te.from=pe;function ne(U){switch(U){case h.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}te.to=ne})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var v;(function(te){function pe(U){return typeof U=="number"&&U>=b.ViewColumn.One?U-1:U===b.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}te.from=pe;function ne(U){if(typeof U=="number"&&U>=0)return U+1;throw new Error("invalid 'EditorGroupColumn'")}te.to=ne})(v=e.ViewColumn||(e.ViewColumn={}));function w(te){return typeof te.range!="undefined"}function D(te){return te.length===0?!0:!!w(te[0])}e.isDecorationOptionsArr=D;var P;(function(te){function pe(We){return We.map(te.from)}te.fromMany=pe;function ne(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function U(We){let it;if(ne(We)){const{language:ct,value:lt}=We;it={value:"```"+ct+`
`+lt+"\n```\n"}}else b.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons}:typeof We=="string"?it={value:We}:it={value:""};const mt=Object.create(null);it.uris=mt;const wt=ct=>{try{let lt=T.URI.parse(ct,!0);lt=lt.with({query:Ce(lt.query,mt)}),mt[ct]=lt}catch(lt){}return""},ot=new A.Renderer;return ot.link=wt,ot.image=ct=>wt(E.parseHrefAndDimensions(ct).href),A(it.value,{renderer:ot}),it}te.from=U;function Ce(We,it){if(!We)return We;let mt;try{mt=(0,R.parse)(We)}catch(ot){}if(!mt)return We;let wt=!1;return mt=(0,k.cloneAndChange)(mt,ot=>{if(T.URI.isUri(ot)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ct]=ot,wt=!0,ct}else return}),wt?JSON.stringify(mt):We}function Se(We){const it=new b.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it}te.to=Se;function qe(We){if(!!We)return typeof We=="string"?We:te.from(We)}te.fromStrict=qe})(P=e.MarkdownString||(e.MarkdownString={}));function n(te){return D(te)?te.map(pe=>({range:p.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?P.fromMany(pe.hoverMessage):pe.hoverMessage?P.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):te.map(pe=>({range:p.from(pe)}))}e.fromRangeOrRangeWithMessage=n;function m(te){return typeof te=="undefined"?te:typeof te=="string"?T.URI.file(te):te}e.pathOrURIToURI=m;var C;(function(te){function pe(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?m(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}te.from=pe})(C=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(te){function pe(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?m(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?C.from(ne.before):void 0,after:ne.after?C.from(ne.after):void 0}}te.from=pe})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var $;(function(te){function pe(ne){if(typeof ne=="undefined")return ne;switch(ne){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}te.from=pe})($=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Q;(function(te){function pe(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?$.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?L.from(ne.light):void 0,dark:ne.dark?L.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?m(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?C.from(ne.before):void 0,after:ne.after?C.from(ne.after):void 0}}te.from=pe})(Q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var se;(function(te){function pe(U){return{text:U.newText,eol:U.newEol&&Y.from(U.newEol),range:p.from(U.range)}}te.from=pe;function ne(U){const Ce=new b.TextEdit(p.to(U.range),U.text);return Ce.newEol=typeof U.eol=="undefined"?void 0:Y.to(U.eol),Ce}te.to=ne})(se=e.TextEdit||(e.TextEdit={}));var G;(function(te){function pe(U,Ce,Se){const qe={edits:[]};if(U instanceof b.WorkspaceEdit)for(let We of U._allEntries())if(We._type===1)qe.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const it=Ce?.getDocument(We.uri);qe.edits.push({_type:2,resource:We.uri,edit:se.from(We.edit),modelVersionId:it?.version,metadata:We.metadata})}else We._type===3?qe.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&qe.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(ft.from)}});return qe}te.from=pe;function ne(U){const Ce=new b.WorkspaceEdit;for(const Se of U.edits)Se.edit?Ce.replace(T.URI.revive(Se.resource),p.to(Se.edit.range),Se.edit.text):Ce.renameFile(T.URI.revive(Se.oldUri),T.URI.revive(Se.newUri),Se.options);return Ce}te.to=ne})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(te){const pe=Object.create(null);pe[b.SymbolKind.File]=0,pe[b.SymbolKind.Module]=1,pe[b.SymbolKind.Namespace]=2,pe[b.SymbolKind.Package]=3,pe[b.SymbolKind.Class]=4,pe[b.SymbolKind.Method]=5,pe[b.SymbolKind.Property]=6,pe[b.SymbolKind.Field]=7,pe[b.SymbolKind.Constructor]=8,pe[b.SymbolKind.Enum]=9,pe[b.SymbolKind.Interface]=10,pe[b.SymbolKind.Function]=11,pe[b.SymbolKind.Variable]=12,pe[b.SymbolKind.Constant]=13,pe[b.SymbolKind.String]=14,pe[b.SymbolKind.Number]=15,pe[b.SymbolKind.Boolean]=16,pe[b.SymbolKind.Array]=17,pe[b.SymbolKind.Object]=18,pe[b.SymbolKind.Key]=19,pe[b.SymbolKind.Null]=20,pe[b.SymbolKind.EnumMember]=21,pe[b.SymbolKind.Struct]=22,pe[b.SymbolKind.Event]=23,pe[b.SymbolKind.Operator]=24,pe[b.SymbolKind.TypeParameter]=25;function ne(Ce){return typeof pe[Ce]=="number"?pe[Ce]:6}te.from=ne;function U(Ce){for(const Se in pe)if(pe[Se]===Ce)return Number(Se);return b.SymbolKind.Property}te.to=U})(z=e.SymbolKind||(e.SymbolKind={}));var x;(function(te){function pe(U){switch(U){case b.SymbolTag.Deprecated:return 1}}te.from=pe;function ne(U){switch(U){case 1:return b.SymbolTag.Deprecated}}te.to=ne})(x=e.SymbolTag||(e.SymbolTag={}));var j;(function(te){function pe(U){return{name:U.name,kind:z.from(U.kind),tags:U.tags&&U.tags.map(x.from),containerName:U.containerName,location:le.from(U.location)}}te.from=pe;function ne(U){const Ce=new b.SymbolInformation(U.name,z.to(U.kind),U.containerName,le.to(U.location));return Ce.tags=U.tags&&U.tags.map(x.to),Ce}te.to=ne})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(te){function pe(U){const Ce={name:U.name||"!!MISSING: name!!",detail:U.detail,range:p.from(U.range),selectionRange:p.from(U.selectionRange),kind:z.from(U.kind),tags:U.tags?.map(x.from)??[]};return U.children&&(Ce.children=U.children.map(pe)),Ce}te.from=pe;function ne(U){const Ce=new b.DocumentSymbol(U.name,U.detail,z.to(U.kind),p.to(U.range),p.to(U.selectionRange));return(0,d.isNonEmptyArray)(U.tags)&&(Ce.tags=U.tags.map(x.to)),U.children&&(Ce.children=U.children.map(ne)),Ce}te.to=ne})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var q;(function(te){function pe(U){const Ce=new b.CallHierarchyItem(z.to(U.kind),U.name,U.detail||"",T.URI.revive(U.uri),p.to(U.range),p.to(U.selectionRange));return Ce._sessionId=U._sessionId,Ce._itemId=U._itemId,Ce}te.to=pe;function ne(U,Ce,Se){if(Ce=Ce??U._sessionId,Se=Se??U._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,name:U.name,detail:U.detail,kind:z.from(U.kind),uri:U.uri,range:p.from(U.range),selectionRange:p.from(U.selectionRange),tags:U.tags?.map(x.from)}}te.from=ne})(q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(te){function pe(ne){return new b.CallHierarchyIncomingCall(q.to(ne.from),ne.fromRanges.map(U=>p.to(U)))}te.to=pe})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var V;(function(te){function pe(ne){return new b.CallHierarchyOutgoingCall(q.to(ne.to),ne.fromRanges.map(U=>p.to(U)))}te.to=pe})(V=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(te){function pe(U){return{range:U.range&&p.from(U.range),uri:U.uri}}te.from=pe;function ne(U){return new b.Location(T.URI.revive(U.uri),p.to(U.range))}te.to=ne})(le=e.location||(e.location={}));var ae;(function(te){function pe(U){const Ce=U,Se=U;return{originSelectionRange:Ce.originSelectionRange?p.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Se.uri,range:p.from(Ce.targetRange?Ce.targetRange:Se.range),targetSelectionRange:Ce.targetSelectionRange?p.from(Ce.targetSelectionRange):void 0}}te.from=pe;function ne(U){return{targetUri:T.URI.revive(U.uri),targetRange:p.to(U.range),targetSelectionRange:U.targetSelectionRange?p.to(U.targetSelectionRange):void 0,originSelectionRange:U.originSelectionRange?p.to(U.originSelectionRange):void 0}}te.to=ne})(ae=e.DefinitionLink||(e.DefinitionLink={}));var ve;(function(te){function pe(U){return{range:p.from(U.range),contents:P.fromMany(U.contents)}}te.from=pe;function ne(U){return new b.Hover(U.contents.map(P.to),p.to(U.range))}te.to=ne})(ve=e.Hover||(e.Hover={}));var Ae;(function(te){function pe(U){return{range:p.from(U.range),expression:U.expression}}te.from=pe;function ne(U){return new b.EvaluatableExpression(p.to(U.range),U.expression)}te.to=ne})(Ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(te){function pe(U){if(U instanceof b.InlineValueText)return{type:"text",range:p.from(U.range),text:U.text};if(U instanceof b.InlineValueVariableLookup)return{type:"variable",range:p.from(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};if(U instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(U.range),expression:U.expression};throw new Error("Unknown 'InlineValue' type")}te.from=pe;function ne(U){switch(U.type){case"text":return{range:p.to(U.range),text:U.text};case"variable":return{range:p.to(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};case"expression":return{range:p.to(U.range),expression:U.expression}}}te.to=ne})(Re=e.InlineValue||(e.InlineValue={}));var Oe;(function(te){function pe(U){return{frameId:U.frameId,stoppedLocation:p.from(U.stoppedLocation)}}te.from=pe;function ne(U){return new b.InlineValueContext(U.frameId,p.to(U.stoppedLocation))}te.to=ne})(Oe=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(te){function pe(U){return{range:p.from(U.range),kind:U.kind}}te.from=pe;function ne(U){return new b.DocumentHighlight(p.to(U.range),U.kind)}te.to=ne})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(te){function pe(ne){switch(ne){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}te.to=pe})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(te){function pe(ne){return{triggerKind:He.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}te.to=pe})(je=e.CompletionContext||(e.CompletionContext={}));var N;(function(te){function pe(U){switch(U){case b.CompletionItemTag.Deprecated:return 1}}te.from=pe;function ne(U){switch(U){case 1:return b.CompletionItemTag.Deprecated}}te.to=ne})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(te){const pe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ne(Se){return pe.get(Se)??9}te.from=ne;const U=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Ce(Se){return U.get(Se)??b.CompletionItemKind.Property}te.to=Ce})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(te){function pe(ne,U){const Ce=new b.CompletionItem(ne.label);return Ce.insertText=ne.insertText,Ce.kind=K.to(ne.kind),Ce.tags=ne.tags?.map(N.to),Ce.detail=ne.detail,Ce.documentation=E.isMarkdownString(ne.documentation)?P.to(ne.documentation):ne.documentation,Ce.sortText=ne.sortText,Ce.filterText=ne.filterText,Ce.preselect=ne.preselect,Ce.commitCharacters=ne.commitCharacters,t.Range.isIRange(ne.range)?Ce.range=p.to(ne.range):typeof ne.range=="object"&&(Ce.range={inserting:p.to(ne.range.insert),replacing:p.to(ne.range.replace)}),Ce.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?Ce.insertText=new b.SnippetString(ne.insertText):(Ce.insertText=ne.insertText,Ce.textEdit=Ce.range instanceof b.Range?new b.TextEdit(Ce.range,Ce.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(Ce.additionalTextEdits=ne.additionalTextEdits.map(Se=>se.to(Se))),Ce.command=U&&ne.command?U.fromInternal(ne.command):void 0,Ce}te.to=pe})(Z=e.CompletionItem||(e.CompletionItem={}));var oe;(function(te){function pe(U){return{label:U.label,documentation:U.documentation?P.fromStrict(U.documentation):void 0}}te.from=pe;function ne(U){return{label:U.label,documentation:E.isMarkdownString(U.documentation)?P.to(U.documentation):U.documentation}}te.to=ne})(oe=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(te){function pe(U){return{label:U.label,documentation:U.documentation?P.fromStrict(U.documentation):void 0,parameters:Array.isArray(U.parameters)?U.parameters.map(oe.from):[],activeParameter:U.activeParameter}}te.from=pe;function ne(U){return{label:U.label,documentation:E.isMarkdownString(U.documentation)?P.to(U.documentation):U.documentation,parameters:Array.isArray(U.parameters)?U.parameters.map(oe.to):[],activeParameter:U.activeParameter}}te.to=ne})(H=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(te){function pe(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(H.from):[]}}te.from=pe;function ne(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(H.to):[]}}te.to=ne})(re=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(te){function pe(U){return{text:U.text,position:i.from(U.position),kind:Te.from(U.kind??b.InlayHintKind.Other),whitespaceBefore:U.whitespaceBefore,whitespaceAfter:U.whitespaceAfter}}te.from=pe;function ne(U){const Ce=new b.InlayHint(U.text,i.to(U.position),Te.to(U.kind));return Ce.whitespaceAfter=U.whitespaceAfter,Ce.whitespaceBefore=U.whitespaceBefore,Ce}te.to=ne})(he=e.InlayHint||(e.InlayHint={}));var Te;(function(te){function pe(U){return U}te.from=pe;function ne(U){return U}te.to=ne})(Te=e.InlayHintKind||(e.InlayHintKind={}));var Ue;(function(te){function pe(U){return{range:p.from(U.range),url:U.target,tooltip:U.tooltip}}te.from=pe;function ne(U){let Ce;if(U.url)try{Ce=typeof U.url=="string"?T.URI.parse(U.url,!0):T.URI.revive(U.url)}catch(Se){}return new b.DocumentLink(p.to(U.range),Ce)}te.to=ne})(Ue=e.DocumentLink||(e.DocumentLink={}));var $e;(function(te){function pe(U){const Ce=new b.ColorPresentation(U.label);return U.textEdit&&(Ce.textEdit=se.to(U.textEdit)),U.additionalTextEdits&&(Ce.additionalTextEdits=U.additionalTextEdits.map(Se=>se.to(Se))),Ce}te.to=pe;function ne(U){return{label:U.label,textEdit:U.textEdit?se.from(U.textEdit):void 0,additionalTextEdits:U.additionalTextEdits?U.additionalTextEdits.map(Ce=>se.from(Ce)):void 0}}te.from=ne})($e=e.ColorPresentation||(e.ColorPresentation={}));var Ke;(function(te){function pe(U){return new b.Color(U[0],U[1],U[2],U[3])}te.to=pe;function ne(U){return[U.red,U.green,U.blue,U.alpha]}te.from=ne})(Ke=e.Color||(e.Color={}));var _e;(function(te){function pe(U){return{range:p.from(U.range)}}te.from=pe;function ne(U){return new b.SelectionRange(p.to(U.range))}te.to=ne})(_e=e.SelectionRange||(e.SelectionRange={}));var rt;(function(te){function pe(ne){switch(ne){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}te.to=pe})(rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var W;(function(te){function pe(U){switch(U){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}te.from=pe;function ne(U){switch(U){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}te.to=ne})(W=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Y;(function(te){function pe(U){if(U===b.EndOfLine.CRLF)return 1;if(U===b.EndOfLine.LF)return 0}te.from=pe;function ne(U){if(U===1)return b.EndOfLine.CRLF;if(U===0)return b.EndOfLine.LF}te.to=ne})(Y=e.EndOfLine||(e.EndOfLine={}));var me;(function(te){function pe(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}te.from=pe})(me=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(te){function pe(ne){const U={start:ne.start+1,end:ne.end+1};return ne.kind&&(U.kind=Ye.from(ne.kind)),U}te.from=pe})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ye;(function(te){function pe(ne){if(ne)switch(ne){case b.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}te.from=pe})(Ye=e.FoldingRangeKind||(e.FoldingRangeKind={}));var tt;(function(te){function pe(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?p.from(ne.selection):void 0,override:typeof ne.override=="boolean"?r.EditorResolution.DISABLED:void 0}}te.from=pe})(tt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var at;(function(te){function pe(U){return U instanceof b.RelativePattern||typeof U=="string"?U:ne(U)?new b.RelativePattern(U.base,U.pattern):U}te.from=pe;function ne(U){const Ce=U;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(at=e.GlobPattern||(e.GlobPattern={}));var vt;(function(te){function pe(ne){if(ne){if(Array.isArray(ne))return ne.map(pe);if(typeof ne=="string")return ne;{const U=ne;return{language:U.language,scheme:U.scheme,pattern:typeof U.pattern=="undefined"?void 0:at.from(U.pattern),exclusive:U.exclusive}}}else return}te.from=pe})(vt=e.LanguageSelector||(e.LanguageSelector={}));var kt;(function(te){function pe(U){return{start:U.start,end:U.end}}te.from=pe;function ne(U){return new b.NotebookRange(U.start,U.end)}te.to=ne})(kt=e.NotebookRange||(e.NotebookRange={}));var ht;(function(te){function pe(U){return{timing:typeof U.runStartTime=="number"&&typeof U.runEndTime=="number"?{startTime:U.runStartTime,endTime:U.runEndTime}:void 0,executionOrder:U.executionOrder,success:U.lastRunSuccess}}te.to=pe;function ne(U){return{lastRunSuccess:U.success,runStartTime:U.timing?.startTime,runEndTime:U.timing?.endTime,executionOrder:U.executionOrder}}te.from=ne})(ht=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var yt;(function(te){function pe(U){switch(U){case b.NotebookCellKind.Markup:return l.CellKind.Markup;case b.NotebookCellKind.Code:default:return l.CellKind.Code}}te.from=pe;function ne(U){switch(U){case l.CellKind.Markup:return b.NotebookCellKind.Markup;case l.CellKind.Code:default:return b.NotebookCellKind.Code}}te.to=ne})(yt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(te){function pe(U){const Ce={metadata:U.metadata??Object.create(null),cells:[]};for(let Se of U.cells)b.NotebookCellData.validate(Se),Ce.cells.push(ft.from(Se));return Ce}te.from=pe;function ne(U){const Ce=new b.NotebookData(U.cells.map(ft.to));return(0,y.isEmptyObject)(U.metadata)||(Ce.metadata=U.metadata),Ce}te.to=ne})(It=e.NotebookData||(e.NotebookData={}));var ft;(function(te){function pe(U){return{cellKind:yt.from(U.kind),language:U.languageId,mime:U.mime,source:U.value,metadata:U.metadata,internalMetadata:ht.from(U.executionSummary??{}),outputs:U.outputs?U.outputs.map(Et.from):[]}}te.from=pe;function ne(U){return new b.NotebookCellData(yt.to(U.cellKind),U.source,U.language,U.mime,U.outputs?U.outputs.map(Et.to):void 0,U.metadata,U.internalMetadata?ht.to(U.internalMetadata):void 0)}te.to=ne})(ft=e.NotebookCellData||(e.NotebookCellData={}));var Je;(function(te){function pe(U){return{mime:U.mime,valueBytes:F.VSBuffer.wrap(U.data)}}te.from=pe;function ne(U){return new b.NotebookCellOutputItem(U.valueBytes.buffer,U.mime)}te.to=ne})(Je=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Et;(function(te){function pe(U){return{outputId:U.id,items:U.items.map(Je.from),metadata:U.metadata}}te.from=pe;function ne(U){const Ce=U.items.map(Je.to);return new b.NotebookCellOutput(Ce,U.outputId,U.metadata)}te.to=ne})(Et=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(te){function pe(Se){if(Se!=null){if(Se instanceof b.RelativePattern||typeof Se=="string")return Se;if(Ce(Se))return new b.RelativePattern(Se.base,Se.pattern);if(U(Se))return{include:at.from(Se.include)||void 0,exclude:at.from(Se.exclude)||void 0}}}te.from=pe;function ne(Se){return typeof Se=="string"?Se:Ce(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}te.to=ne;function U(Se){const qe=Se,We=at.from(qe.include);if(!(We&&We instanceof b.RelativePattern||typeof We=="string"))return!1;const it=at.from(qe.exclude);return!!(it&&it instanceof b.RelativePattern||typeof it=="string")}function Ce(Se){const qe=Se;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(te){function pe(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?C.from(ne.top):void 0}}te.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var De;(function(te){function pe(ne,U,Ce){const Se=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:U.toInternal(Se,Ce),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}te.from=pe})(De=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var X;(function(te){function pe(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}te.from=pe})(X=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ue;(function(te){function pe(U){return{uri:U.uri,provides:U.provides}}te.from=pe;function ne(U){return new b.NotebookRendererScript(T.URI.revive(U.uri),U.provides)}te.to=ne})(ue=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(te){function pe(U){return{message:P.fromStrict(U.message)||"",type:0,expected:U.expectedOutput,actual:U.actualOutput,location:U.location?le.from(U.location):void 0}}te.from=pe;function ne(U){const Ce=new b.TestMessage(typeof U.message=="string"?U.message:P.to(U.message));return Ce.actualOutput=U.actual,Ce.expectedOutput=U.expected,Ce}te.to=ne})(ge=e.TestMessage||(e.TestMessage={}));var fe;(function(te){let pe;(function(ne){ne.Delimiter="\0"})(pe||(pe={})),te.namespace=(ne,U)=>ne+"\0"+U,te.denamespace=ne=>{const U=ne.indexOf("\0");return{ctrlId:ne.slice(0,U),tagId:ne.slice(U+1)}}})(fe=e.TestTag||(e.TestTag={}));var Ie;(function(te){function pe(Se){const qe=(0,a.getPrivateApiFor)(Se).controllerId;return{extId:g.TestId.fromExtHostTestItem(Se,qe).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>fe.namespace(qe,We.id)),range:p.from(Se.range)||null,description:Se.description||null,error:Se.error&&P.fromStrict(Se.error)||null}}te.from=pe;function ne(Se){return{id:g.TestId.fromString(Se.extId).localId,label:Se.label,uri:T.URI.revive(Se.uri),tags:(Se.tags||[]).map(qe=>{const{tagId:We}=fe.denamespace(qe);return new b.TestTag(We,We)}),range:p.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}te.toPlain=ne;function U(Se){const qe=g.TestId.fromString(Se.extId),We=new a.TestItemImpl(qe.controllerId,qe.localId,Se.label,T.URI.revive(Se.uri));return We.range=p.to(Se.range||void 0),We.description=Se.description||void 0,We}function Ce(Se){let qe;for(const We of Se.tests){const it=U(We.item);(0,a.getPrivateApiFor)(it).parent=qe,qe=it}return qe}te.toItemFromContext=Ce})(Ie=e.TestItem||(e.TestItem={})),function(te){function pe(U){return{id:U.id,label:U.label}}te.from=pe;function ne(U){return new b.TestTag(U.id,U.label)}te.to=ne}(fe=e.TestTag||(e.TestTag={}));var xe;(function(te){const pe=(U,Ce)=>{const Se={...Ie.toPlain(U.item),parent:void 0,taskStates:U.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(We=>We.type===0).map(ge.to)})),children:U.children.map(qe=>Ce.get(qe)).filter(y.isDefined).map(qe=>pe(qe,Ce))};for(const qe of Se.children)qe.parent=Se;return Se};function ne(U){const Ce=[],Se=new Map;for(const qe of U.items)Se.set(qe.item.extId,qe),U.request.targets.some(We=>We.controllerId===qe.controllerId&&We.testIds.includes(qe.item.extId))&&Ce.push(qe);return{completedAt:U.completedAt,results:Ce.map(qe=>pe(qe,Se))}}te.to=ne})(xe=e.TestResults||(e.TestResults={}));var Le;(function(te){function pe(Se){return{covered:Se.covered,total:Se.covered}}function ne(Se){return"line"in Se?i.from(Se):p.from(Se)}function U(Se){return"branches"in Se?{count:Se.executionCount,location:ne(Se.location),type:1,branches:Se.branches.length?Se.branches.map(qe=>({count:qe.executionCount,location:qe.location&&ne(qe.location)})):void 0}:{type:0,count:Se.executionCount,location:ne(Se.location)}}te.fromDetailed=U;function Ce(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(U)}}te.fromFile=Ce})(Le=e.TestCoverage||(e.TestCoverage={}));var Ve;(function(te){function pe(ne){switch(ne){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}te.to=pe})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Xe;(function(te){function pe(U){const Ce=new b.TypeHierarchyItem(z.to(U.kind),U.name,U.detail||"",T.URI.revive(U.uri),p.to(U.range),p.to(U.selectionRange));return Ce._sessionId=U._sessionId,Ce._itemId=U._itemId,Ce}te.to=pe;function ne(U,Ce,Se){if(Ce=Ce??U._sessionId,Se=Se??U._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,kind:z.from(U.kind),name:U.name,detail:U.detail??"",uri:U.uri,range:p.from(U.range),selectionRange:p.from(U.selectionRange),tags:U.tags?.map(x.from)}}te.from=ne})(Xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[169],be([0,1,2,15,6,8,231]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(T,t,_,r={timeout:1500,errors:3}){this._logService=T,this._documents=t,this._mainThreadBulkEdits=_,this._thresholds=r,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(t,_,r)=>{const a={dispose:this._callbacks.push([t,_,T])};return Array.isArray(r)&&r.push(a),a}}async $participateInSave(T,t){const _=d.URI.revive(T);let r=!1;const h=setTimeout(()=>r=!0,this._thresholds.timeout),a=[];try{for(let l of[...this._callbacks]){if(r)break;const g=this._documents.getDocument(_),I=await this._deliverEventAsyncAndBlameBadListeners(l,{document:g,reason:A.TextDocumentSaveReason.to(t)});a.push(I)}}finally{clearTimeout(h)}return a}_deliverEventAsyncAndBlameBadListeners([T,t,_],r){const h=this._badListeners.get(T);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,T,t,r).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const l=this._badListeners.get(T);this._badListeners.set(T,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,t,_,r){const h=[],a=Date.now(),{document:l,reason:g}=r,{version:I}=l,b=Object.freeze({document:l,reason:g,waitUntil(c){if(Object.isFrozen(h))throw(0,F.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(c))}});try{t.apply(_,[b])}catch(c){return Promise.reject(c)}return Object.freeze(h),new Promise((c,p)=>{const S=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(S),c(i)}).catch(i=>{clearTimeout(S),p(i)})}).then(c=>{const p={edits:[]};for(const S of c)if(Array.isArray(S)&&S.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:s,range:u}of S)p.edits.push({_type:2,resource:l.uri,edit:{range:u&&A.Range.from(u),text:i,eol:s&&A.EndOfLine.from(s)}});if(p.edits.length!==0)return I===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(we[170],be([0,1,3,27,2,8,6]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(t,_,r,h,a){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,r&&(this._config+=1),h&&(this._config+=2),a&&(this._config+=4);const l=(0,F.parse)(_),g=t(I=>{if(!r)for(let b of I.created){const c=E.URI.revive(b);l(c.fsPath)&&this._onDidCreate.fire(c)}if(!h)for(let b of I.changed){const c=E.URI.revive(b);l(c.fsPath)&&this._onDidChange.fire(c)}if(!a)for(let b of I.deleted){const c=E.URI.revive(b);l(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(t,_,r){this._logService=_,this._extHostDocumentsAndEditors=r,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,_,r,h){return new k(this._onFileSystemEvent.event,t,_,r,h)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,_){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(r=>({oldUri:E.URI.revive(r.source),newUri:E.URI.revive(r.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(r=>E.URI.revive(r.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(r=>E.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,_){return(r,h,a)=>{const l=function(I){r.call(h,I)};return l.extension=t,_.event(l,void 0,a)}}async $onWillRunFileOperation(t,_,r,h){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(a=>({oldUri:E.URI.revive(a.source),newUri:E.URI.revive(a.target)}))},r,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(a=>E.URI.revive(a.target))},r,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(a=>E.URI.revive(a.target))},r,h)}}async _fireWillEvent(t,_,r,h){const a=new Set,l=[];if(await t.fireAsync(_,h,async(I,b)=>{const c=Date.now(),p=await Promise.resolve(I);p instanceof R.WorkspaceEdit&&(l.push(p),a.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-c>r&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),h.isCancellationRequested||l.length===0)return;const g={edits:[]};for(let I of l){let{edits:b}=A.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(b)}return{edit:g,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=y}),define(we[171],be([0,1,11,22,2,8,6,90]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(r,h,a,l){this.start=r,this.deletedCount=h,this.deletedItems=a,this.items=l}static asApiEvents(r){return r.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(a=>a.apiCell)}))}}class T{constructor(r,h,a){this.notebook=r,this._extHostDocument=h,this._cellData=a,this.handle=a.handle,this.uri=E.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=Object.freeze(a.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(a.internalMetadata??{}))}static asModelAddData(r,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:r}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const r=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return r.notebook.getCellIndex(r)},notebook:r.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return r._mime},set mime(a){r._mime=a},get outputs(){return r._outputs.slice(0)},get metadata(){return r._metadata},get executionSummary(){return r._previousResult}})}return this._apiCell}setOutputs(r){this._outputs=r.map(A.NotebookCellOutput.to)}setOutputItems(r,h,a){const l=a.map(A.NotebookCellOutputItem.to),g=this._outputs.find(I=>I.id===r);g&&(h||(g.items.length=0),g.items.push(...l))}setMetadata(r){this._metadata=Object.freeze(r)}setInternalMetadata(r){this._internalMetadata=r,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(r))}setMime(r){}}e.ExtHostCell=T;class t{constructor(r,h,a,l,g,I){this._proxy=r,this._textDocumentsAndEditors=h,this._textDocuments=a,this._emitter=l,this.uri=g,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const r=this;this._notebook={get uri(){return r.uri},get version(){return r._versionId},get notebookType(){return r._notebookType},get isDirty(){return r._isDirty},get isUntitled(){return r.uri.scheme===d.Schemas.untitled},get isClosed(){return r._disposed},get metadata(){return r._metadata},get cellCount(){return r._cells.length},cellAt(h){return h=r._validateIndex(h),r._cells[h].apiCell},getCells(h){return(h?r._getCells(h):r._cells).map(l=>l.apiCell)},save(){return r._save()}}}return this._notebook}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(r){r.metadata&&(this._metadata=Object.freeze({...this._metadata,...r.metadata}))}acceptDirty(r){this._isDirty=r}acceptModelChanged(r,h){this._versionId=r.versionId,this._isDirty=h;for(const a of r.rawEvents)a.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===k.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(r){return r=r|0,r<0?0:r>=this._cells.length?this._cells.length-1:r}_validateRange(r){let h=r.start|0,a=r.end|0;return h<0&&(h=0),a>this._cells.length&&(a=this._cells.length),r.with({start:h,end:a})}_getCells(r){r=this._validateRange(r);const h=[];for(let a=r.start;a<r.end;a++)h.push(this._cells[a]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(r,h){if(this._disposed)return;const a=[],l=[],g=[];r.reverse().forEach(I=>{const c=I[2].map(i=>{const s=new T(this,this._textDocumentsAndEditors,i);return h||l.push(T.asModelAddData(this.apiNotebook,i)),s}),p=new y(I[0],I[1],[],c),S=this._cells.splice(I[0],I[1],...c);for(const i of S)g.push(i.uri),p.deletedItems.push(i.apiCell);a.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:g}),h||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(a)}))}_moveCell(r,h){const a=this._cells.splice(r,1);this._cells.splice(h,0,...a);const l=[new y(r,1,a.map(g=>g.apiCell),[]),new y(h,0,[],a)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(l)}))}_setCellOutputs(r,h){const a=this._cells[r];a.setOutputs(h),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(r,h,a,l){const g=this._cells[r];g.setOutputItems(h,a,l),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(r,h){const a=this._cells[r];a.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(a.uri,h)}_changeCellMime(r,h){const a=this._cells[r];a.apiCell.mime=h}_changeCellMetadata(r,h){const a=this._cells[r],l=a.apiCell.metadata;a.setMetadata(h);const g=a.apiCell.metadata;(0,F.equals)(l,g)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(r,h){const a=this._cells[r],l=a.internalMetadata;if(a.setInternalMetadata(h),l.runState!==h.runState){const g=h.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:g}))}}getCellFromApiCell(r){return this._cells.find(h=>h.apiCell===r)}getCellFromIndex(r){return this._cells[r]}getCell(r){return this._cells.find(h=>h.handle===r)}getCellIndex(r){return this._cells.indexOf(r)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[93],be([0,1,6,8,15]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:T})}replaceCells(y,T,t){this._throwIfFinalized(),!(y===T&&t.length===0)&&this._collectedEdits.push({editType:1,index:y,count:T-y,cells:t.map(F.NotebookCellData.from)})}}class R{constructor(y,T,t,_,r,h){this.id=y,this._proxy=T,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=r,this._visibleRanges=_,this._viewColumn=h}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");y._selections=T,y._trySetSelections(T)},get visibleRanges(){return y._visibleRanges},revealRange(T,t){y._proxy.$tryRevealRange(y.id,F.NotebookRange.from(T),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(T){const t=new A(this.document.version);return T(t),y._applyEdit(t.finalize())},setDecorations(T,t){return y.setDecorations(T,t)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(F.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const T=[];let t=-1;for(let _=0;_<y.cellEdits.length;_++){if(t<0){T.push(y.cellEdits[_]),t++;continue}const h=T[t],a=y.cellEdits[_];if(h.editType===1&&a.editType===1&&h.index===a.index){h.cells.push(...y.cellEdits[_].cells),h.count+=y.cellEdits[_].count;continue}T.push(y.cellEdits[_]),t++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,T)}setDecorations(y,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return T.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(T),y.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(we[172],be([0,1,8,147,123,21,51]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}withProgress(_,r,h){const a=this._handles++,{title:l,location:g,cancellable:I}=r,b={label:(0,E.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(a,{location:d.ProgressLocation.from(g),title:l,source:b,cancellable:I},_),this._withProgress(a,h,!!I)}_withProgress(_,r,h){let a;h&&(a=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,a));const l=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),a&&a.dispose()};let g;try{g=r(new T(this._proxy,_),h&&a?a.token:A.CancellationToken.None)}catch(I){throw l(_),I}return g.then(I=>l(_),I=>l(_)),g}$acceptProgressCanceled(_){const r=this._mapHandleToCancellationSource.get(_);r&&(r.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=k;function y(t,_){return t.message=_.message,typeof _.increment=="number"&&(typeof t.increment=="number"?t.increment+=_.increment:t.increment=_.increment),t}class T extends F.Progress{constructor(_,r){super(h=>this.throttledReport(h));this._proxy=_,this._handle=r}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Be([(0,R.throttle)(100,(t,_)=>y(t,_),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(we[94],be([0,1,39,15,52,8,6]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(r,h,a){const l=k._Keys.nextId();r.$registerTextEditorDecorationType(h.identifier,l,A.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:l,dispose(){r.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=k,k._Keys=new E.IdGenerator("TextEditorDecorationType");class y{constructor(r,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=r,this._documentVersionId=r.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(r,h){this._throwIfFinalized();let a=null;if(r instanceof R.Position)a=new R.Range(r,r);else if(r instanceof R.Range)a=r;else throw new Error("Unrecognized location");this._pushEdit(a,h,!1)}insert(r,h){this._throwIfFinalized(),this._pushEdit(new R.Range(r,r),h,!0)}delete(r){this._throwIfFinalized();let h=null;if(r instanceof R.Range)h=r;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(r,h,a){const l=this._document.validateRange(r);this._collectedEdits.push({range:l,text:h,forceMoveMarkers:a})}setEndOfLine(r){if(this._throwIfFinalized(),r!==R.EndOfLine.LF&&r!==R.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=r}}e.TextEditorEdit=y;class T{constructor(r,h,a,l){this._proxy=r,this._id=h,this._accept(a),this._logService=l;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(I){g._setTabSize(I)},get insertSpaces(){return g._insertSpaces},set insertSpaces(I){g._setInsertSpaces(I)},get cursorStyle(){return g._cursorStyle},set cursorStyle(I){g._setCursorStyle(I)},get lineNumbers(){return g._lineNumbers},set lineNumbers(I){g._setLineNumbers(I)}}}_accept(r){this._tabSize=r.tabSize,this._insertSpaces=r.insertSpaces,this._cursorStyle=r.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(r.lineNumbers)}_validateTabSize(r){if(r==="auto")return"auto";if(typeof r=="number"){const h=Math.floor(r);return h>0?h:null}if(typeof r=="string"){const h=parseInt(r,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(r){const h=this._validateTabSize(r);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(r){return r==="auto"?"auto":r==="false"?!1:Boolean(r)}_setInsertSpaces(r){const h=this._validateInsertSpaces(r);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(r){this._cursorStyle!==r&&(this._cursorStyle=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:r})))}_setLineNumbers(r){this._lineNumbers!==r&&(this._lineNumbers=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(r)})))}assign(r){const h={};let a=!1;if(typeof r.tabSize!="undefined"){const l=this._validateTabSize(r.tabSize);l==="auto"?(a=!0,h.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,a=!0,h.tabSize=l)}if(typeof r.insertSpaces!="undefined"){const l=this._validateInsertSpaces(r.insertSpaces);l==="auto"?(a=!0,h.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,a=!0,h.insertSpaces=l)}typeof r.cursorStyle!="undefined"&&this._cursorStyle!==r.cursorStyle&&(this._cursorStyle=r.cursorStyle,a=!0,h.cursorStyle=r.cursorStyle),typeof r.lineNumbers!="undefined"&&this._lineNumbers!==r.lineNumbers&&(this._lineNumbers=r.lineNumbers,a=!0,h.lineNumbers=A.TextEditorLineNumbersStyle.from(r.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(r){r.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=T;class t{constructor(r,h,a,l,g,I,b,c){this.id=r,this._proxy=h,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new T(this._proxy,this.id,I,a),this._visibleRanges=b,this._viewColumn=c;const p=this;this.value=Object.freeze({get document(){return l.getValue()},set document(S){throw(0,F.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(S){if(!(S instanceof R.Selection))throw(0,F.illegalArgument)("selection");p._selections=[S],p._trySetSelection()},get selections(){return p._selections},set selections(S){if(!Array.isArray(S)||S.some(i=>!(i instanceof R.Selection)))throw(0,F.illegalArgument)("selections");p._selections=S,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(S){throw(0,F.readonly)("visibleRanges")},get options(){return p._options.value},set options(S){p._disposed||p._options.assign(S)},get viewColumn(){return p._viewColumn},set viewColumn(S){throw(0,F.readonly)("viewColumn")},edit(S,i={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(l.getValue(),i);return S(s),p._applyEdit(s)},insertSnippet(S,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=p._selections.map(o=>A.Range.from(o));else if(i instanceof R.Position){const{lineNumber:o,column:f}=A.Position.from(i);u=[{startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f}]}else if(i instanceof R.Range)u=[A.Range.from(i)];else{u=[];for(const o of i)if(o instanceof R.Range)u.push(A.Range.from(o));else{const{lineNumber:f,column:v}=A.Position.from(o);u.push({startLineNumber:f,startColumn:v,endLineNumber:f,endColumn:v})}}return h.$tryInsertSnippet(r,S.value,u,s)},setDecorations(S,i){const s=i.length===0;s&&!p._hasDecorationsForKey.has(S.key)||(s?p._hasDecorationsForKey.delete(S.key):p._hasDecorationsForKey.add(S.key),p._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return h.$trySetDecorations(r,S.key,A.fromRangeOrRangeWithMessage(i));{const u=new Array(4*i.length);for(let o=0,f=i.length;o<f;o++){const v=i[o];u[4*o]=v.start.line+1,u[4*o+1]=v.start.character+1,u[4*o+2]=v.end.line+1,u[4*o+3]=v.end.character+1}return h.$trySetDecorationsFast(r,S.key,u)}}))},revealRange(S,i){p._runOnProxy(()=>h.$tryRevealRange(r,A.Range.from(S),i||R.TextEditorRevealType.Default))},show(S){h.$tryShowEditor(r,A.ViewColumn.from(S))},hide(){h.$tryHideEditor(r)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(r){(0,d.ok)(!this._disposed),this._options._accept(r)}_acceptVisibleRanges(r){(0,d.ok)(!this._disposed),this._visibleRanges=r}_acceptViewColumn(r){(0,d.ok)(!this._disposed),this._viewColumn=r}_acceptSelections(r){(0,d.ok)(!this._disposed),this._selections=r}async _trySetSelection(){const r=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,r)),this.value}_applyEdit(r){const h=r.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const a=h.edits.map(g=>g.range);a.sort((g,I)=>g.end.line===I.end.line?g.end.character===I.end.character?g.start.line===I.start.line?g.start.character-I.start.character:g.start.line-I.start.line:g.end.character-I.end.character:g.end.line-I.end.line);for(let g=0,I=a.length-1;g<I;g++){const b=a[g].end;if(a[g+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=h.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,l,{setEndOfLine:typeof h.setEndOfLine=="number"?A.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(r){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):r().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=t}),define(we[173],be([0,1,126,24,2,3,7,161,13,6,10,16,8,21,158]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(b,c){if((0,t.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let p;return Array.isArray(b.highlights)&&(p=b.highlights.filter(S=>S.length===2&&typeof S[0]=="number"&&typeof S[1]=="number"),p=p.length?p:void 0),{label:b.label,highlights:p}}}class g{constructor(c,p,S){this._proxy=c,this.commands=p,this.logService=S,this.treeViews=new Map;function i(s){return s&&s.$treeViewId&&s.$treeItemHandle}p.registerArgumentProcessor({processArgument:s=>i(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(u=>i(u)?this.convertArgument(u):u):s})}registerTreeDataProvider(c,p,S){const i=this.createTreeView(c,{treeDataProvider:p},S);return{dispose:()=>i.dispose()}}createTreeView(c,p,S){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=p.dragAndDropController!==void 0,s=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,canDragAndDrop:i}),u=this.createExtHostTreeView(c,p,S);return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get message(){return u.message},set message(o){u.message=o},get title(){return u.title},set title(o){u.title=o},get description(){return u.description},set description(o){u.description=o},reveal:(o,f)=>u.reveal(o,f),dispose:async()=>{await s,this.treeViews.delete(c),u.dispose()}}}$getChildren(c,p){const S=this.treeViews.get(c);return S?S.getChildren(p):Promise.reject(new Error((0,d.localize)(0,null,c)))}async $onDrop(c,p,S){const i=this.treeViews.get(c);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,c)));const s=a.TreeDataTransferConverter.toITreeDataTransfer(p);if(s.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const o=JSON.parse(await s.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(f=>i.getExtensionElement(f)).filter(f=>!!f);o.length>0?s.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(o)}):s.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(s,S)}async $hasResolve(c){const p=this.treeViews.get(c);if(!p)throw new Error((0,d.localize)(2,null,c));return p.hasResolve}$resolve(c,p,S){const i=this.treeViews.get(c);if(!i)throw new Error((0,d.localize)(3,null,c));return i.resolveTreeItem(p,S)}$setExpanded(c,p,S){const i=this.treeViews.get(c);if(!i)throw new Error((0,d.localize)(4,null,c));i.setExpanded(p,S)}$setSelection(c,p){const S=this.treeViews.get(c);if(!S)throw new Error((0,d.localize)(5,null,c));S.setSelection(p)}$setVisible(c,p){const S=this.treeViews.get(c);if(!S)throw new Error((0,d.localize)(6,null,c));S.setVisible(p)}createExtHostTreeView(c,p,S){const i=new I(c,p,this._proxy,this.commands.converter,this.logService,S);return this.treeViews.set(c,i),i}convertArgument(c){const p=this.treeViews.get(c.$treeViewId);return p?p.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=g;class I extends R.Disposable{constructor(c,p,S,i,s,u){super();if(this.viewId=c,this.proxy=S,this.commands=i,this.logService=s,this.extension=u,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,u.contributes&&u.contributes.views)for(const v in u.contributes.views)for(const w of u.contributes.views[v])w.id===c&&(this._title=w.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(v=>this._onDidChangeData.fire({message:!1,element:v}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(v=>this._onDidChangeData.fire({message:!1,element:v})));let o,f;this._register(A.Event.debounce(this._onDidChangeData.event,(v,w)=>(v||(v={message:!1,elements:[]}),w.element!==!1&&(o||(o=new Promise(D=>f=D),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(w.element)?v.elements.push(...w.element):v.elements.push(w.element)),w.message&&(v.message=!0),v),200,!0)(({message:v,elements:w})=>{w.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=f;return o=null,this.refresh(w).then(()=>D())})),v&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,t.isUndefinedOrNull)(c))}async getChildren(c){const p=c?this.getExtensionElement(c):void 0;if(c&&!p)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let S=this.getChildrenNodes(c);return S||(S=await this.fetchChildrenNodes(p)),S?S.map(i=>i.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,p){p=p||{select:!0,focus:!1};const S=(0,t.isUndefinedOrNull)(p.select)?!0:p.select,i=(0,t.isUndefinedOrNull)(p.focus)?!1:p.focus,s=(0,t.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(u=>this.resolveTreeNode(c,u[u.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:u.map(f=>f.item)},{select:S,focus:i,expand:s})),u=>this.logService.error(u)):this.proxy.$reveal(this.viewId,void 0,{select:S,focus:i,expand:s})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}setExpanded(c,p){const S=this.getExtensionElement(c);S&&(p?this._onDidExpandElement.fire(Object.freeze({element:S})):this._onDidCollapseElement.fire(Object.freeze({element:S})))}setSelection(c){(0,_.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(c,p){const S=this.getExtensionElement(p);if(!!S)return(0,y.asPromise)(()=>this.dndController?.onDrop(c,S))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,p){if(!this.dataProvider.resolveTreeItem)return;const S=this.elements.get(c);if(S){const i=this.nodes.get(S);if(i){const s=await this.dataProvider.resolveTreeItem(i.extensionItem,S,p)??i.extensionItem;return i.item.tooltip=this.getTooltip(s.tooltip),i.item.command=this.getCommand(i.disposableStore,s.command),i.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(p=>p?this.resolveUnknownParentChain(p).then(S=>this.resolveTreeNode(p,S[S.length-1]).then(i=>(S.push(i),S))):Promise.resolve([]))}resolveParent(c){const p=this.nodes.get(c);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,p){const S=this.nodes.get(c);return S?Promise.resolve(S):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(i=>this.createHandle(c,i,p,!0)).then(i=>this.getChildren(p?p.item.handle:void 0).then(()=>{const s=this.getExtensionElement(i);if(s){const u=this.nodes.get(s);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(c){if(c){let p;if(typeof c=="string"){const S=this.getExtensionElement(c);p=S?this.nodes.get(S):void 0}else p=c;return p&&p.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const p=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const S=c?this.nodes.get(c):void 0,i=await this.dataProvider.getChildren(c);if(p.token.isCancellationRequested)return;const s=await Promise.all((0,_.coalesce)(i||[]).map(async u=>{const o=await this.dataProvider.getTreeItem(u);return o&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(u,o,S):null}));return p.token.isCancellationRequested?void 0:(0,_.coalesce)(s)}finally{p.dispose()}}refresh(c){if(c.some(S=>!S))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const S=this.getHandlesToRefresh(c);if(S.length)return this.refreshHandles(S)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const p=new Set,S=c.map(s=>this.nodes.get(s));for(const s of S)if(s&&!p.has(s.item.handle)){let u=s;for(;u&&u.parent&&S.findIndex(o=>u&&u.parent&&o&&o.item.handle===u.parent.item.handle)===-1;){const o=this.elements.get(u.parent.item.handle);u=o?this.nodes.get(o):void 0}u&&!u.parent&&p.add(s.item.handle)}const i=[];return p.forEach(s=>{const u=this.elements.get(s);if(u){const o=this.nodes.get(u);o&&(!o.parent||!p.has(o.parent.item.handle))&&i.push(s)}}),i}refreshHandles(c){const p={};return Promise.all(c.map(S=>this.refreshNode(S).then(i=>{i&&(p[S]=i.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(c){const p=this.getExtensionElement(c);if(p){const S=this.nodes.get(p);if(S)return this.clearChildren(p),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(i=>{if(i){const s=this.createTreeNode(p,i,S.parent);return this.updateNodeCache(p,s,S,S.parent),S.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,p,S){const i=this.createTreeNode(c,p,S);if(p.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,p.id));return this.addNodeToCache(c,i),this.addNodeToParentCache(i,S),i}getTooltip(c){return T.MarkdownString.isMarkdownString(c)?r.MarkdownString.from(c):c}getCommand(c,p){return p?this.commands.toInternal(p,c):void 0}createTreeNode(c,p,S){const i=new R.DisposableStore,s=this.createHandle(c,p,S),u=this.getLightIconPath(p);return{item:{handle:s,parentHandle:S?S.item.handle:void 0,label:l(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(i,p.command),contextValue:p.contextValue,icon:u,iconDark:this.getDarkIconPath(p)||u,themeIcon:this.getThemeIcon(p),collapsibleState:(0,t.isUndefinedOrNull)(p.collapsibleState)?T.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:S,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(c){return c.iconPath instanceof T.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:p,label:S,resourceUri:i},s,u){if(p)return`${I.ID_HANDLE_PREFIX}/${p}`;const o=l(S,this.extension),f=s?s.item.handle:I.LABEL_HANDLE_PREFIX;let v=o?o.label:i?(0,F.basename)(i):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const w=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,D=this.getChildrenNodes(s)||[];let P,n=0;do{if(P=`${f}/${n}:${v}`,u||!this.elements.has(P)||w===P)break;n++}while(n<=D.length);return P}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof T.ThemeIcon))return typeof c.iconPath=="string"||E.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof T.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return E.URI.isUri(c)?c:E.URI.file(c)}addNodeToCache(c,p){this.elements.set(p.item.handle,c),this.nodes.set(c,p)}updateNodeCache(c,p,S,i){this.elements.delete(p.item.handle),this.nodes.delete(c),p.item.handle!==S.item.handle&&this.elements.delete(S.item.handle),this.addNodeToCache(c,p);const s=this.getChildrenNodes(i)||[],u=s.filter(o=>o.item.handle===S.item.handle)[0];u&&s.splice(s.indexOf(u),1,p)}addNodeToParentCache(c,p){p?(p.children||(p.children=[]),p.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const p=this.nodes.get(c);if(p){if(p.children)for(const S of p.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}p.children=void 0}}else this.clearAll()}clear(c){const p=this.nodes.get(c);if(p){if(p.children)for(const S of p.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}this.nodes.delete(c),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(we[174],be([0,1,13,3,7,10,65,8,91,69]),function(ie,e,d,F,E,A,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(r){super();this.controllerId=r,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(r){this._resolveHandler=r;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){const h=this.diff[this.diff.length-1];if(h&&r[0]===1){if(h[0]===1&&h[1].extId===r[1].extId){(0,y.applyTestItemUpdate)(h[1],r[1]);return}if(h[0]===0&&h[1].item.extId===r[1].extId){(0,y.applyTestItemUpdate)(h[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,h){const a=this.tree.get(r);if(!!a){if((a.expandLevels===void 0||h>a.expandLevels)&&(a.expandLevels=h),a.expand===1){const l=this.resolveChildren(a);return l.isOpen()?this.expandChildren(a,h-1):l.wait().then(()=>this.expandChildren(a,h-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,h-1)):this.expandChildren(a,h-1)}}dispose(){for(const r of this.tree.values())(0,R.getPrivateApiFor)(r.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(r,h){switch(h.op){case 2:this.pushDiff([4,r.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(r.fullId,h.id));break;case 0:this.upsertItem(h.item,r);break;case 4:for(const b of h.ops)this.onTestItemEvent(r,b);break;case 3:const{key:a,value:l,previous:g}=h,I=r.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(r);break;case"tags":this.diffTagRefs(l,g,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:k.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:k.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[a]:l??null}}]);break}break;default:(0,A.assertNever)(h)}}upsertItem(r,h){if(!(r instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);const a=T.TestId.fromExtHostTestItem(r,this.root.id,h?.actual),l=(0,R.getPrivateApiFor)(r);l.parent&&l.parent!==h?.actual&&l.parent.children.delete(r.id);let g=this.tree.get(a.toString());if(!g){g={fullId:a,actual:r,parent:h?a.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},r.tags.forEach(this.incrementTagRefs,this),this.tree.set(g.fullId.toString(),g),this.setItemParent(r,h),this.pushDiff([0,{parent:g.parent&&g.parent.toString(),controllerId:this.controllerId,expand:g.expand,item:k.TestItem.from(r)}]),this.connectItemAndChildren(r,g,h);return}if(g.actual===r){this.connectItem(r,g,h);return}const I=g.actual.children,b=g.actual,c=(0,R.diffTestItems)(b,r);(0,R.getPrivateApiFor)(b).listener=void 0,g.actual=r,g.expand=0;for(const[p,S]of c)this.onTestItemEvent(g,{op:3,key:p,value:S,previous:b[p]});this.connectItemAndChildren(r,g,h);for(const p of I)r.children.get(p.id)||this.removeItem(T.TestId.joinToString(a,p.id))}diffTagRefs(r,h,a){const l=new Set(h.map(g=>g.id));for(const g of r)l.delete(g.id)||this.incrementTagRefs(g);this.pushDiff([1,{extId:a,item:{tags:r.map(g=>k.TestTag.namespace(this.controllerId,g.id))}}]),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(r){const h=this.tags.get(r.id);h?h.refCount++:(this.tags.set(r.id,{label:r.label,refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,r.id),ctrlLabel:this.root.label,label:r.label}]))}decrementTagRefs(r){const h=this.tags.get(r);h&&!--h.refCount&&(this.tags.delete(r),this.pushDiff([6,k.TestTag.namespace(this.controllerId,r)]))}setItemParent(r,h){(0,R.getPrivateApiFor)(r).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(r,h,a){this.setItemParent(r,a);const l=(0,R.getPrivateApiFor)(r);l.parent=a?.actual,l.listener=g=>this.onTestItemEvent(h,g),this.updateExpandability(h)}connectItemAndChildren(r,h,a){this.connectItem(r,h,a);for(const l of r.children)this.upsertItem(l,h)}updateExpandability(r){let h;this._resolveHandler?r.resolveBarrier?h=r.resolveBarrier.isOpen()?3:2:h=r.actual.canResolveChildren?1:0:h=0,h!==r.expand&&(r.expand=h,this.pushDiff([1,{extId:r.fullId.toString(),expand:h}]),h===1&&r.expandLevels!==void 0&&this.resolveChildren(r))}expandChildren(r,h){if(h<0)return;const a=[];for(const l of r.actual.children){const g=this.expand(T.TestId.joinToString(r.fullId,l.id),h);(0,d.isThenable)(g)&&a.push(g)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this._resolveHandler){const g=new d.Barrier;return g.open(),g}r.expand=2,this.pushExpandStateUpdate(r);const h=r.resolveBarrier=new d.Barrier,a=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),r.actual!==this.root&&(r.actual.error=g.stack||g.message||String(g))};let l;try{l=this._resolveHandler(r.actual===this.root?void 0:r.actual)}catch(g){a(g)}return(0,d.isThenable)(l)?l.catch(a).then(()=>{h.open(),this.updateExpandability(r)}):(h.open(),this.updateExpandability(r)),r.resolveBarrier}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.fullId.toString(),expand:r.expand}])}removeItem(r){const h=this.tree.get(r);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,r]);const a=[h];for(;a.length;){const l=a.pop();if(!!l){(0,R.getPrivateApiFor)(l.actual).listener=void 0;for(const g of l.actual.tags)this.decrementTagRefs(g.id);this.tree.delete(l.fullId.toString());for(const g of l.actual.children)a.push(this.tree.get(T.TestId.joinToString(l.fullId,g.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.diffOpEmitter.fire(r)}}e.SingleUseTestCollection=t}),define(we[175],be([0,1,4,139]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(F.IEnvironmentService)}),define(we[176],be([0,1,26,3,17]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class R{constructor(t){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let _ of t.activationEvents)_==="onUri"&&(_=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(t)}}keepOnly(t){const _=new Set;t.forEach(r=>_.add(d.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>_.has(d.ExtensionIdentifier.toKey(r.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,_){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const r=R._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(r.map(h=>h.identifier)),_.length>0){const h=new Set;_.forEach(a=>h.add(d.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!h.has(d.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(r)}static _findLoopingExtensions(t){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,I){this.addNode(g),this.addNode(I),this._arcs.has(g)?this._arcs.get(g).push(I):this._arcs.set(g,[I])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,I){const b=_.getArcs(g);for(let c=0;c<b.length;c++)if(!I.has(b[c]))return!1;return!0}getNodes(){return this._nodesArr}};let r=new Map;for(let g of t){const I=d.ExtensionIdentifier.toKey(g.identifier);if(r.set(I,g),g.extensionDependencies)for(let b of g.extensionDependencies){const c=d.ExtensionIdentifier.toKey(b);_.addArc(I,c)}}let h=new Set;_.getNodes().filter(g=>_.getArcs(g).length===0).forEach(g=>h.add(g));let a=_.getNodes().filter(g=>!h.has(g)),l;do{l=!1;for(let g=0;g<a.length;g++){const I=a[g];_.hasOnlyGoodArcs(I,h)&&(a.splice(g,1),g--,h.add(I),l=!0)}}while(l);return a.map(g=>r.get(g))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const _=this._activationMap.get(t);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const _=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return _||void 0}}e.ExtensionDescriptionRegistry=R;var k;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(k||(k={}));function y(T,t){const _=T.isBuiltin?0:T.isUnderDevelopment?2:1,r=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(_!==r)return _-r;const h=E.posix.basename(T.extensionLocation.path),a=E.posix.basename(t.extensionLocation.path);return h<a?-1:h>a?1:0}}),define(we[177],be([0,1,23]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(k){const y=d.VSBuffer.alloc(1);switch(k){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function R(k,y){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=R}),define(we[30],be([0,1,3,2,4,26,140]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var k;(function(b){b[b.None=0]="None",b[b.LocalProcess=1]="LocalProcess",b[b.LocalWebWorker=2]="LocalWebWorker",b[b.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class y{constructor(c){this.dependency=c}}e.MissingExtensionDependency=y;var T;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));class t{constructor(c,p,S,i){this.codeLoadingTime=c,this.activateCallTime=p,this.activateResolvedTime=S,this.activationReason=i}}e.ActivationTimes=t;class _{constructor(c,p){this.description=c,this.value=p}}e.ExtensionPointContribution=_,e.ExtensionHostLogFileName="exthost";var r;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function h(b){b.enableProposedApi||a(b)}e.checkProposedApiEnabled=h;function a(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=a;function l(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=l;function g(b,c){return{identifier:new A.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!c,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=g;class I{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(c){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(c,p){return Promise.resolve()}_onWillActivateExtension(c){}_onDidActivateExtension(c,p,S,i,s){}_onDidActivateExtensionError(c,p){}_onExtensionRuntimeError(c,p){}_onExtensionHostExit(c){}}e.NullExtensionService=I}),define(we[178],be([0,1,26,30,14]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class R{constructor(a,l,g,I){this.startup=a,this.codeLoadingTime=l,this.activateCallTime=g,this.activateResolvedTime=I}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class k{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,l){return a===-1||l===-1?-1:l-a}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class y{constructor(a,l,g,I,b,c){this.activationFailed=a,this.activationFailedError=l,this.activationTimes=g,this.module=I,this.exports=b,this.subscriptions=c}}e.ActivatedExtension=y;class T extends y{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class t extends y{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class _ extends y{constructor(a){super(!0,a,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let r=class{constructor(a,l,g,I,b){this._logService=b,this._registry=a,this._resolvedExtensionsSet=new Set,l.forEach(c=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,g.forEach(c=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(c),c)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const l=d.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(l)}getActivatedExtension(a){const l=d.ExtensionIdentifier.toKey(a),g=this._activatedExtensions.get(l);if(!g)throw new Error("Extension `"+a.value+"` is not known or not activated");return g}activateByEvent(a,l){if(this._alreadyActivatedEvents[a])return A;const g=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(g.map(I=>({id:I.identifier,reason:{startup:l,extensionId:I.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,l){const g=this._registry.getExtensionDescription(a);if(!g)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:g.identifier,reason:l}])}_handleActivateRequest(a,l,g){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(a.id))){l[d.ExtensionIdentifier.toKey(a.id)]=a;return}const I=this._registry.getExtensionDescription(a.id);if(!I){const p=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,p,new F.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(a.id),new _(p));return}const b=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let c=!0;for(let p=0,S=b.length;p<S;p++){const i=b[p];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const s=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const v=I.displayName||I.identifier.value,w=this._registry.getExtensionDescription(i),D=w&&w.displayName||i,P=new Error(`Cannot activate the '${v}' extension because its dependency '${D}' failed to activate`);P.detail=s.activationFailedError,this._host.onExtensionActivationError(I.identifier,P,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(I.identifier),new _(P));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){c=!1,l[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:a.reason};continue}const u=this._registry.getExtensionDescription(i);if(u){c=!1,l[d.ExtensionIdentifier.toKey(i)]={id:u.identifier,reason:a.reason};continue}const o=I.displayName||I.identifier.value,f=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(I.identifier,f,new F.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(I.identifier),new _(f));return}c?l[d.ExtensionIdentifier.toKey(I.identifier)]=a:g.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(b=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(b.id))),a.length===0))return Promise.resolve(void 0);const l=Object.create(null),g=[];for(let b=0,c=a.length;b<c;b++)this._handleActivateRequest(a[b],l,g);for(let b=0,c=g.length;b<c;b++){const p=d.ExtensionIdentifier.toKey(g[b].id);l[p]&&delete l[p]}const I=Object.keys(l).map(b=>l[b]);return g.length===0?Promise.all(I.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(I).then(b=>this._activateExtensions(g))}_activateExtension(a,l){const g=d.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const I=this._activatingExtensions.get(g);if(I)return I;const b=this._host.actualActivateExtension(a,l).then(void 0,c=>{const p=new Error;return c&&c.name&&(p.name=c.name),c&&c.message?p.message=`Activating extension '${a.value}' failed: ${c.message}.`:p.message=`Activating extension '${a.value}' failed: ${c}.`,c&&c.stack&&(p.stack=c.stack),this._host.onExtensionActivationError(a,p,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(c),new _(c)}).then(c=>{this._activatedExtensions.set(g,c),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,b),b}};r=Be([ze(4,E.ILogService)],r),e.ExtensionsActivator=r}),define(we[179],be([0,1,15]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=F}),define(we[46],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(T,t){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const F=[];function E(y){const T=new d(!0,y);return F[T.nid]=T,T}e.createMainContextProxyIdentifier=E;function A(y){const T=new d(!1,y);return F[T.nid]=T,T}e.createExtHostContextProxyIdentifier=A;function R(y){return F[y].sid}e.getStringIdentifierForProxy=R;class k{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=k}),define(we[5],be([0,1,53,2,46]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var R;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var r;(function(c){c.name="$ident";function p(i,s){return Object.defineProperty(i,c.name,{value:s,enumerable:!0}),i}c.mixin=p;function S(i){return i[c.name]}c.of=S})(r=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(p){return p._id=h._n++,p}}e.IdObject=h,h._n=0;var a;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(g=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(c){if(c&&c.edits)for(const p of c.edits)typeof p.resource=="object"?p.resource=F.URI.revive(p.resource):(p.newUri=F.URI.revive(p.newUri),p.oldUri=F.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,d.revive)(p.metadata));return c}e.reviveWorkspaceEditDto=I;var b;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[70],be([0,1,5,3,4]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,y){return this._proxy.$getPassword(k,y)}store(k,y,T){return this._proxy.$setPassword(k,y,T)}delete(k,y){return this._proxy.$deletePassword(k,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(we[71],be([0,1,4,14,5,12]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(y,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(E.MainContext.MainThreadTelemetry)}report(y,T,t){const _=this.getUsageKey(y,T);this._reportedUsages.has(_)||(this._reportedUsages.add(_),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}getUsageKey(y,T){return`${y}-${T.identifier.value}`}};R=Be([ze(0,A.IExtHostRpcService),ze(1,F.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(k,y,T){}})}),define(we[180],be([0,1,3,5,6,26]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,T,t,_={}){const r=A.ExtensionIdentifier.toKey(y.identifier),h=this._inFlightRequests.get(r)||[],a=[...t].sort().join(" ");let l=h.find(g=>g.scopes===a);if(l)return l.result;{const g=this._getSession(y,r,T,t,_);l={scopes:a,result:g},h.push(l),this._inFlightRequests.set(r,h);try{await g}finally{const I=h.findIndex(b=>b.scopes===a);I>-1&&(h.splice(I),this._inFlightRequests.set(r,h))}return g}}async _getSession(y,T,t,_,r={}){await this._proxy.$ensureProvider(t);const h=y.displayName||y.name;return this._proxy.$getSession(t,_,T,h,r)}async removeSession(y,T){const t=this._authenticationProviders.get(y);return t?t.provider.removeSession(T):this._proxy.$removeSession(y,T)}registerAuthenticationProvider(y,T,t,_){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:T,provider:t,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===y)||this._providers.push({id:y,label:T});const r=t.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(y,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,T,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{r.dispose(),this._authenticationProviders.delete(y);const h=this._providers.findIndex(a=>a.id===y);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this._onDidChangeSessions.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(we[181],be([0,1,5,12,8]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,y){this._extHostDocumentsAndEditors=y,this._proxy=k.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const y=E.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=Be([ze(0,F.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(we[182],be([0,1,5]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(A){const R=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(k){return R.$writeText(k)}})}}e.ExtHostClipboard=F}),define(we[47],be([0,1,10,6,8,22,5,16,14,53,41,111,2,7,4,12]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(i,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=i.getProxy(R.MainContext.MainThreadCommands),this._logService=s,this.converter=new I(this,u=>{const o=this._apiCommands.get(u);return o?.result===c.Void?o:void 0},s),this._argumentProcessors=[{processArgument(u){return(0,T.revive)(u)}},{processArgument(u){return(0,A.cloneAndChange)(u,function(o){if(t.Range.isIRange(o))return E.Range.to(o);if(_.Position.isIPosition(o))return E.Position.to(o);if(t.Range.isIRange(o.range)&&r.URI.isUri(o.uri))return E.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const s=this.registerCommand(!1,i.id,async(...u)=>{const o=i.args.map((v,w)=>{if(!v.validate(u[w]))throw new Error(`Invalid argument '${v.name}' when running '${i.id}', received: ${u[w]}`);return v.convert(u[w])}),f=await this.executeCommand(i.internalId,...o);return i.result.convert(f,u,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new F.Disposable(()=>{s.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,s,u,o,f){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:u,thisArg:o,description:f}),i&&this._proxy.$registerCommand(s),new F.Disposable(()=>{this._commands.delete(s)&&i&&this._proxy.$unregisterCommand(s)})}executeCommand(i,...s){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,s,!0)}async _doExecuteCommand(i,s,u){if(this._commands.has(i))return this._executeContributedCommand(i,s);{const o=(0,A.cloneAndChange)(s,function(f){if(f instanceof F.Position)return E.Position.from(f);if(f instanceof F.Range)return E.Range.from(f);if(f instanceof F.Location)return E.location.from(f);if(F.NotebookRange.isNotebookRange(f))return E.NotebookRange.from(f);if(!Array.isArray(f))return f});try{const f=await this._proxy.$executeCommand(i,o,u);return(0,T.revive)(f)}catch(f){if(f instanceof Error&&f.message==="$executeCommand:retry")return this._doExecuteCommand(i,s,!1);throw f}}}async _executeContributedCommand(i,s){const u=this._commands.get(i);if(!u)throw new Error("Unknown command");let{callback:o,thisArg:f,description:v}=u;if(v)for(let w=0;w<v.args.length;w++)try{(0,d.validateConstraint)(s[w],v.args[w].constraint)}catch(D){throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${v.args[w].name}' - ${v.args[w].description}`)}try{return await o.apply(f,s)}catch(w){if(i===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...s);D&&(i=D.command)}throw this._logService.error(w,i),new Error(`Running the contributed command: '${i}' failed.`)}}$executeContributedCommand(i,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(s=s.map(u=>this._argumentProcessors.reduce((o,f)=>f.processArgument(o),u)),this._executeContributedCommand(i,s)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),this._proxy.$getCommands().then(s=>(i&&(s=s.filter(u=>u[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[s,u]of this._commands){let{description:o}=u;o&&(i[s]=o)}return Promise.resolve(i)}};g=Be([ze(0,l.IExtHostRpcService),ze(1,y.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class I{constructor(i,s,u){this._commands=i,this._lookupApiCommand=s,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,s){if(!i)return;const u={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return u;const o=this._lookupApiCommand(i.command);if(o)u.id=o.internalId,u.arguments=o.args.map((f,v)=>f.convert(i.arguments&&i.arguments[v]));else if((0,k.isNonEmptyArray)(i.arguments)){const f=++this._cachIdPool;this._cache.set(f,i),s.add((0,h.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),u.$ident=f,u.id=this.delegatingCommandId,u.arguments=[f],this._logService.trace("CommandsConverter#CREATE",i.command,f)}return u}fromInternal(i){const s=R.ObjectIdentifier.of(i);return typeof s=="number"?this._cache.get(s):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const s=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=I;class b{constructor(i,s,u,o){this.name=i,this.description=s,this.validate=u,this.convert=o}optional(){return new b(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,s){return new b(i??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",S=>r.URI.isUri(S),S=>S),b.Position=new b("position","A position in a text document",S=>F.Position.isPosition(S),E.Position.from),b.Range=new b("range","A range in a text document",S=>F.Range.isRange(S),E.Range.from),b.Selection=new b("selection","A selection in a text document",S=>F.Selection.isSelection(S),E.Selection.from),b.Number=new b("number","",S=>typeof S=="number",S=>S),b.String=new b("string","",S=>typeof S=="string",S=>S),b.CallHierarchyItem=new b("item","A call hierarchy item",S=>S instanceof F.CallHierarchyItem,E.CallHierarchyItem.from),b.TypeHierarchyItem=new b("item","A type hierarchy item",S=>S instanceof F.TypeHierarchyItem,E.TypeHierarchyItem.from);class c{constructor(i,s){this.description=i,this.convert=s}}e.ApiCommandResult=c,c.Void=new c("no result",S=>S);class p{constructor(i,s,u,o,f){this.id=i,this.internalId=s,this.description=u,this.args=o,this.result=f}}e.ApiCommand=p}),define(we[183],be([0,1,8,6,58,47,16,81]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,h)=>{if((0,R.isFalsyOrEmpty)(r))return;class a extends F.SymbolInformation{static to(g){const I=new a(g.name,d.SymbolKind.to(g.kind),g.containerName||"",new F.Location(h[0],d.Range.to(g.range)));return I.detail=g.detail,I.range=I.location.range,I.selectionRange=d.Range.to(g.selectionRange),I.children=g.children?g.children.map(a.to):[],I}}return r.map(a.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new A.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(h=>F.Position.isPosition(h)),r=>r.map(d.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(h=>{let a;for(const l of h.reverse())a=new F.SelectionRange(d.Range.to(l),a);return a}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const h=[];if(Array.isArray(r))for(let a of r)h.push(...a[1].map(d.WorkspaceSymbol.to));return h})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(d.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(d.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(d.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return d.WorkspaceEdit.to(r)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(d.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new F.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const h=(0,k.decodeSemanticTokensDto)(r);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new F.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const h=(0,k.decodeSemanticTokensDto)(r);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,h,a)=>{if(!r)return new F.CompletionList([]);const l=r.suggestions.map(g=>d.CompletionItem.to(g,a));return new F.CompletionList(l,r.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return d.SignatureHelp.to(r)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,h,a)=>t(l=>new F.CodeLens(d.Range.to(l.range),l.command&&a.fromInternal(l.command)))(r))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>F.Range.isRange(r),r=>F.Selection.isSelection(r)?d.Selection.from(r):d.Range.from(r)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,h,a)=>t(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(l.command)}else{const g=new F.CodeAction(l.title,l.kind?new F.CodeActionKind(l.kind):void 0);return l.edit&&(g.edit=d.WorkspaceEdit.to(l.edit)),l.command&&(g.command=a.fromInternal(l.command)),g.isPreferred=l.isPreferred,g}})(r))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(h=>new F.ColorInformation(d.Range.to(h.range),d.Color.to(h.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",r=>r instanceof F.Color,d.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:d.Range.from(r.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(d.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(d.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(h=>d.NotebookExclusiveDocumentPattern.to(h))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(d.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[d.ViewColumn.from(r.viewColumn),d.TextEditorOpenOptions.from(r)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[d.ViewColumn.from(r.viewColumn),d.TextEditorOpenOptions.from(r)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[d.ViewColumn.from(r.viewColumn),d.TextEditorOpenOptions.from(r)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(d.TypeHierarchyItem.to)))];class T{static register(h){y.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=T;function t(r){return h=>{if(Array.isArray(h))return h.map(r)}}function _(r){if(!Array.isArray(r))return;const h=[];for(const a of r)E.isLocationLink(a)?h.push(d.DefinitionLink.to(a)):h.push(d.location.to(a));return h}}),define(we[184],be([0,1,13,51,3,7,2,58,26,8,6,5]),function(ie,e,d,F,E,A,R,k,y,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function r(h,a,l){const g=h.getProxy(_.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const f=this._commentControllers.get(o.handle);return f||o}else if(o&&o.$mid===7){const f=this._commentControllers.get(o.commentControlHandle);if(!f)return o;const v=f.getCommentThread(o.commentThreadHandle);return v||o}else if(o&&o.$mid===8){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const v=f.getCommentThread(o.thread.commentThreadHandle);return v?{thread:v,text:o.text}:o}else if(o&&o.$mid===9){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const v=f.getCommentThread(o.thread.commentThreadHandle);if(!v)return o;let w=o.commentUniqueId,D=v.getCommentByUniqueId(w);return D||o}else if(o&&o.$mid===10){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const v=f.getCommentThread(o.thread.commentThreadHandle);if(!v)return o;let w=o.text,D=o.commentUniqueId,P=v.getCommentByUniqueId(D);return P?(P.body=w,P):o}return o}})}createCommentController(o,f,v){const w=I.handlePool++,D=new c(o,w,f,v);this._commentControllers.set(D.handle,D);const P=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(o.identifier))||[];return P.push(D),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(o.identifier),P),D.value}$createCommentThreadTemplate(o,f,v){const w=this._commentControllers.get(o);!w||w.$createCommentThreadTemplate(f,v)}async $updateCommentThreadTemplate(o,f,v){const w=this._commentControllers.get(o);!w||w.$updateCommentThreadTemplate(f,v)}$deleteCommentThread(o,f){const v=this._commentControllers.get(o);v&&v.$deleteCommentThread(f)}$provideCommentingRanges(o,f,v){const w=this._commentControllers.get(o);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const D=l.getDocument(R.URI.revive(f));return(0,d.asPromise)(()=>w.commentingRangeProvider.provideCommentingRanges(D,v)).then(P=>P?P.map(n=>T.Range.from(n)):void 0)}$toggleReaction(o,f,v,w,D){const P=this._commentControllers.get(o);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const n=P.getCommentThread(f);if(n){const m=n.getCommentByUniqueId(w.uniqueIdInThread);if(P!==void 0&&m&&P.reactionHandler)return P.reactionHandler(m,i(D))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class b{constructor(o,f,v,w,D,P,n){this._commentControllerHandle=f,this._id=v,this._uri=w,this._range=D,this._comments=P,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${o}.${this.handle}`),g.$createCommentThread(f,this.handle,this._id,this._uri,T.Range.from(this._range),n),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(f,this.handle)}});const m=this;this.value={get uri(){return m.uri},get range(){return m.range},set range(C){m.range=C},get comments(){return m.comments},set comments(C){m.comments=C},get collapsibleState(){return m.collapsibleState},set collapsibleState(C){m.collapsibleState=C},get canReply(){return m.canReply},set canReply(C){m.canReply=C},get contextValue(){return m.contextValue},set contextValue(C){m.contextValue=C},get label(){return m.label},set label(C){m.label=C},dispose:()=>{m.dispose()}}}set threadId(o){this._id=o}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(o){o.isEqual(this._range)||(this._range=o,this.modifications.range=o,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(o){this._canReply!==o&&(this._canReply=o,this.modifications.canReply=o,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(o){this._label=o,this.modifications.label=o,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(o){this._contextValue=o,this.modifications.contextValue=o,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(o){this._comments=o,this.modifications.comments=o,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(o){this._collapseState=o,this.modifications.collapsibleState=o,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const o=v=>Object.prototype.hasOwnProperty.call(this.modifications,v),f={};o("range")&&(f.range=T.Range.from(this._range)),o("label")&&(f.label=this.label),o("contextValue")&&(f.contextValue=this.contextValue),o("comments")&&(f.comments=this._comments.map(v=>p(this,v,this._commentsMap))),o("collapsibleState")&&(f.collapseState=s(this._collapseState)),o("canReply")&&(f.canReply=this.canReply),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(o){for(let f of this._commentsMap){let v=f[0],w=f[1];if(o===w)return v}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(o=>o.dispose())}}b._handlePool=0,Be([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(o,f,v,w){this._extension=o,this._handle=f,this._id=v,this._label=w,this._threads=new Map,g.$registerCommentController(this.handle,v,w);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(P){D.options=P},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(P){D.commentingRangeProvider=P},get reactionHandler(){return D.reactionHandler},set reactionHandler(P){D.reactionHandler=P},createCommentThread(P,n,m){return D.createCommentThread(P,n,m).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(o){this._reactionHandler=o,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this._options}set options(o){this._options=o,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(o,f,v,w){if(typeof o=="string"){const D=new b(this.id,this.handle,o,f,v,w,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new b(this.id,this.handle,void 0,o,f,v,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(o,f){const v=new b(this.id,this.handle,void 0,R.URI.revive(o),T.Range.to(f),[],this._extension.identifier);return v.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(v.handle,v),v}$updateCommentThreadTemplate(o,f){let v=this._threads.get(o);v&&(v.range=T.Range.to(f))}$deleteCommentThread(o){let f=this._threads.get(o);f&&f.dispose(),this._threads.delete(o)}getCommentThread(o){return this._threads.get(o)}dispose(){this._threads.forEach(o=>{o.dispose()}),this._localDisposables.forEach(o=>o.dispose())}}function p(u,o,f){let v=f.get(o);v||(v=++u.commentHandle,f.set(o,v));const w=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:v,body:T.MarkdownString.from(o.body),userName:o.author.name,userIconPath:w,label:o.label,commentReactions:o.reactions?o.reactions.map(D=>S(D)):void 0}}function S(u){return{label:u.label,iconPath:u.iconPath?T.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function i(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?R.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function s(u){if(u!==void 0)switch(u){case t.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=r}),define(we[95],be([0,1,2,5,6,4,12,14,16,9,17]),function(ie,e,d,F,E,A,R,k,y,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class pi{constructor(h,a){this._logService=a,this._provider=new Map,this._proxy=h.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,a){const l=pi._handlePool++;this._provider.set(l,{provider:h,extensionId:a}),this._proxy.$registerDecorationProvider(l,a.value);const g=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(l,null);return}let b=(0,y.asArray)(I);if(b.length<=pi._maxEventSize){this._proxy.$onDidChange(l,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,b.length);const c=b.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),p=(0,y.groupBy)(c,(i,s)=>i.rank-s.rank||(0,T.compare)(i.uri.path,s.uri.path));let S=[];e:for(let i of p){let s;for(let u of i){let o=(0,t.dirname)(u.uri.path);if(s!==o&&(s=o,S.push(u.uri)>=pi._maxEventSize))break e}}this._proxy.$onDidChange(l,S)});return new E.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(h,a,l){if(!this._provider.has(h))return Object.create(null);const g=Object.create(null),{provider:I,extensionId:b}=this._provider.get(h);return await Promise.all(a.map(async c=>{try{const{uri:p,id:S}=c,i=await Promise.resolve(I.provideFileDecoration(d.URI.revive(p),l));if(!i)return;try{E.FileDecoration.validate(i),g[S]=[i.propagate,i.tooltip,i.badge,i.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${b.value}': ${s}`)}}catch(p){this._logService.error(p)}})),g}};_._handlePool=0,_._maxEventSize=250,_=Be([ze(0,R.IExtHostRpcService),ze(1,k.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(we[185],be([0,1,121,83,2,5,6,8,3,14,20]),function(ie,e,d,F,E,A,R,k,y,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class _{constructor(a,l,g,I,b){this._name=a,this._owner=l,this._maxDiagnosticsPerFile=g,this._proxy=I,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new t.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,l){if(!a){this.clear();return}this._checkDisposed();let g=[];if(E.URI.isUri(a)){if(!l){this.delete(a);return}this._data.set(a,l.slice()),g=[a]}else if(Array.isArray(a)){g=[];let b;a=[...a].sort(_._compareIndexedTuplesByUri);for(const c of a){const[p,S]=c;if((!b||p.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=p,g.push(p),this._data.set(p,[])),S){const i=this._data.get(p);i&&i.push(...S)}else{const i=this._data.get(p);i&&(i.length=0)}}}if(this._onDidChangeDiagnostics.fire(g),!this._proxy)return;const I=[];for(let b of g){let c=[];const p=this._data.get(b);if(p)if(p.length>this._maxDiagnosticsPerFile){c=[];const S=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(let s of p)if(s.severity===S[i]&&c.push(k.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;c.push({severity:F.MarkerSeverity.Info,message:(0,d.localize)(0,null,p.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=p.map(S=>k.Diagnostic.from(S));I.push([b,c])}this._proxy.$changeMany(this._owner,I)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,l){this._checkDisposed();for(let g of this._data.keys())a.apply(l,[g,this.get(g),this])}get(a){this._checkDisposed();const l=this._data.get(a);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,l){return a[0].toString()<l[0].toString()?-1:a[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=_;let r=class ei{constructor(a,l){this._logService=l,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,ei._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(a){const l=new t.ResourceMap;for(const g of a)l.set(g,g);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(a,l){const{_collections:g,_proxy:I,_onDidChangeDiagnostics:b,_logService:c}=this,p=new class{$changeMany(s,u){I.$changeMany(s,u),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,s,u.length===0?"CLEARING":u)}$clear(s){I.$clear(s),c.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,s)}dispose(){I.dispose()}};let S;if(!l)l="_generated_diagnostic_collection_name_#"+ei._idPool++,S=l;else if(!g.has(l))S=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do S=l+ei._idPool++;while(g.has(S))}return new class extends _{constructor(){super(l,S,ei._maxDiagnosticsPerFile,p,b);g.set(S,this)}dispose(){super.dispose(),g.delete(S)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const l=new Map,g=[];for(const I of this._collections.values())I.forEach((b,c)=>{let p=l.get(b.toString());typeof p=="undefined"&&(p=g.length,l.set(b.toString(),p),g.push([b,[]])),g[p][1]=g[p][1].concat(...c)});return g}}_getDiagnostics(a){let l=[];for(let g of this._collections.values())g.has(a)&&(l=l.concat(g.get(a)));return l}$acceptMarkersChange(a){if(!this._mirrorCollection){const l="_generated_mirror",g=new _(l,l,ei._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(l,g),this._mirrorCollection=g}for(const[l,g]of a)this._mirrorCollection.set(E.URI.revive(l),g.map(k.Diagnostic.to))}};r._idPool=0,r._maxDiagnosticsPerFile=1e3,r=Be([ze(1,T.ILogService)],r),e.ExtHostDiagnostics=r}),define(we[186],be([0,1,2,5]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(R){this._proxy=R.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(k=>k?k.map(y=>d.URI.revive(y)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(k=>k?d.URI.revive(k):void 0)}}e.ExtHostDialogs=E}),define(we[187],be([0,1,15,2,6,5,11,21,9]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(_,r,h){this._documentsAndEditors=r,this._logService=h,this._documentContentProviders=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,r){if(Object.keys(R.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const h=T._handlePool++;this._documentContentProviders.set(h,r),this._proxy.$registerTextContentProvider(h,_);let a;return typeof r.onDidChange=="function"&&(a=r.onDidChange(l=>{if(l.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(h,l).then(g=>{if(!g&&typeof g!="string")return;const I=this._documentsAndEditors.getDocument(l);if(!I)return;const b=(0,y.splitLines)(g);if(!I.equalLines(b))return this._proxy.$onVirtualDocumentChange(l,g)},d.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(_,r){const h=this._documentContentProviders.get(_);return h?Promise.resolve(h.provideTextDocumentContent(F.URI.revive(r),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${r.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(we[188],be([0,1,3,7,2,5,89,8,10,22,6]),function(ie,e,d,F,E,A,R,k,y,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(h,a){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const g of l)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const g of l)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const a=this._documentsAndEditors.getDocument(h);if(a)return a}getDocument(h){const a=this.getDocumentData(h);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return a.document}ensureDocumentData(h){const a=this._documentsAndEditors.getDocument(h);if(a)return Promise.resolve(a);let l=this._documentLoader.get(h.toString());return l||(l=this._proxy.$tryOpenDocument(h).then(g=>{this._documentLoader.delete(h.toString());const I=E.URI.revive(g);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(I))},g=>(this._documentLoader.delete(h.toString()),Promise.reject(g))),this._documentLoader.set(h.toString(),l)),l}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(a=>E.URI.revive(a))}$acceptModelModeChanged(h,a){const l=E.URI.revive(h),g=this._documentsAndEditors.getDocument(l);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(a),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(h){const a=E.URI.revive(h),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(h,a){const l=E.URI.revive(h),g=this._documentsAndEditors.getDocument(l);if(!g)throw new Error("unknown document");g._acceptIsDirty(a),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,a,l){const g=E.URI.revive(h),I=this._documentsAndEditors.getDocument(g);if(!I)throw new Error("unknown document");I._acceptIsDirty(l),I.onEvents(a);let b;a.isUndoing?b=t.TextDocumentChangeReason.Undo:a.isRedoing&&(b=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:I.document,contentChanges:a.changes.map(c=>({range:k.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:b}))}setWordDefinitionFor(h,a){(0,R.setWordDefinitionFor)(h,a)}}e.ExtHostDocuments=_}),define(we[48],be([0,1,39,3,7,2,4,5,89,12,94,8,14,20,11,189,103]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(p,S){this._extHostRpc=p,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const S=[],i=[],s=[];if(p.removedDocuments)for(const u of p.removedDocuments){const o=A.URI.revive(u),f=this._documents.get(o);f?.unref()&&(this._documents.delete(o),S.push(f.value))}if(p.addedDocuments)for(const u of p.addedDocuments){const o=A.URI.revive(u.uri);let f=this._documents.get(o);if(f&&o.scheme!==a.Schemas.vscodeNotebookCell&&o.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);f||(f=new I(new y.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.modeId,u.isDirty,u.notebook)),this._documents.set(o,f),i.push(f.value)),f.ref()}if(p.removedEditors)for(const u of p.removedEditors){const o=this._editors.get(u);this._editors.delete(u),o&&s.push(o)}if(p.addedEditors)for(const u of p.addedEditors){const o=A.URI.revive(u.documentUri);d.ok(this._documents.has(o),`document '${o}' does not exist`),d.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const f=this._documents.get(o).value,v=new t.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>f.document),u.selections.map(_.Selection.to),u.options,u.visibleRanges.map(w=>_.Range.to(w)),typeof u.editorPosition=="number"?_.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,v)}p.newActiveEditor!==void 0&&(d.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,E.dispose)(S),(0,E.dispose)(s),p.removedDocuments&&this._onDidRemoveDocuments.fire(S),p.addedDocuments&&this._onDidAddDocuments.fire(i),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return p?S:S?.value}allEditors(){return[...this._editors.values()]}};b=Be([ze(0,T.IExtHostRpcService),ze(1,r.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[190],be([0,1,2,5,7,6,8,232,9,23]),function(ie,e,d,F,E,A,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const a=this._schemes.indexOf(h);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),a=[];let l,g,I=14,b=14;for(const c of h){let p=l?(0,y.commonPrefixLength)(l,c):0;for(p===0?g=1:g=b;p<c.length;p++)p+1===c.length?(I=b,b=9):b+=1,a.push([g,c.toUpperCase().charCodeAt(p),b]),a.push([g,c.toLowerCase().charCodeAt(p),b]),g=b;l=c,b=I}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new k.StateMachine(a)}}provideDocumentLinks(h){this._initStateMachine();const a=[],l=k.LinkComputer.computeLinks({getLineContent(g){return h.lineAt(g-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const g of l){const I=R.DocumentLink.to(g);I.target&&a.push(I)}return a}}class _{constructor(h,a){this._extHostLanguageFeatures=a,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,a,l,g={},I){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(b,l),this._enableProposedApi.set(b,I??!1);let c=2;g.isCaseSensitive&&(c+=1024),g.isReadonly&&(c+=2048),typeof l.copy=="function"&&(c+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(b,a,c).catch(S=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${a}`),console.error(S)});const p=l.onDidChangeFile(S=>{const i=[];for(const s of S){let{uri:u,type:o}=s;if(u.scheme!==a)continue;let f;switch(o){case A.FileChangeType.Changed:f=0;break;case A.FileChangeType.Created:f=1;break;case A.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:u,type:f})}this._proxy.$onFileSystemChange(b,i)});return(0,E.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(h,a){const{type:l,ctime:g,mtime:I,size:b,permissions:c}=h;return a?{type:l,ctime:g,mtime:I,size:b,permissions:c}:{type:l,ctime:g,mtime:I,size:b}}$stat(h,a){return Promise.resolve(this._getFsProvider(h).stat(d.URI.revive(a))).then(l=>_._asIStat(l,this._enableProposedApi.get(h)??!1))}$readdir(h,a){return Promise.resolve(this._getFsProvider(h).readDirectory(d.URI.revive(a)))}$readFile(h,a){return Promise.resolve(this._getFsProvider(h).readFile(d.URI.revive(a))).then(l=>T.VSBuffer.wrap(l))}$writeFile(h,a,l,g){return Promise.resolve(this._getFsProvider(h).writeFile(d.URI.revive(a),l.buffer,g))}$delete(h,a,l){return Promise.resolve(this._getFsProvider(h).delete(d.URI.revive(a),l))}$rename(h,a,l,g){return Promise.resolve(this._getFsProvider(h).rename(d.URI.revive(a),d.URI.revive(l),g))}$copy(h,a,l,g){const I=this._getFsProvider(h);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(d.URI.revive(a),d.URI.revive(l),g))}$mkdir(h,a){return Promise.resolve(this._getFsProvider(h).createDirectory(d.URI.revive(a)))}$watch(h,a,l,g){const I=this._getFsProvider(h).watch(d.URI.revive(l),g);this._watches.set(a,I)}$unwatch(h,a){const l=this._watches.get(a);l&&(l.dispose(),this._watches.delete(a))}$open(h,a,l){const g=this._getFsProvider(h);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(d.URI.revive(a),l))}$close(h,a){const l=this._getFsProvider(h);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(a))}$read(h,a,l,g){const I=this._getFsProvider(h);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const b=T.VSBuffer.alloc(g);return Promise.resolve(I.read(a,l,b.buffer,0,g)).then(c=>b.slice(0,c))}$write(h,a,l,g){const I=this._getFsProvider(h);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(a,l,g.buffer,0,g.byteLength))}_getFsProvider(h){const a=this._fsProvider.get(h);if(!a){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return a}}e.ExtHostFileSystem=_}),define(we[72],be([0,1,5,59,6,23,4,12,45]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class xt{constructor(_,r){const h=_.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return h.$stat(a).catch(xt._handleError)},readDirectory(a){return h.$readdir(a).catch(xt._handleError)},createDirectory(a){return h.$mkdir(a).catch(xt._handleError)},async readFile(a){return h.$readFile(a).then(l=>l.buffer).catch(xt._handleError)},writeFile(a,l){return h.$writeFile(a,A.VSBuffer.wrap(l)).catch(xt._handleError)},delete(a,l){return h.$delete(a,{recursive:!1,useTrash:!1,...l}).catch(xt._handleError)},rename(a,l,g){return h.$rename(a,l,{overwrite:!1,...g}).catch(xt._handleError)},copy(a,l,g){return h.$copy(a,l,{overwrite:!1,...g}).catch(xt._handleError)},isWritableFileSystem(a){const l=r.getCapabilities(a);if(typeof l=="number")return!(l&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case F.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case F.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case F.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case F.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};T=Be([ze(0,k.IExtHostRpcService),ze(1,y.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(we[191],be([0,1,2,47]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(R,k,y,T){this._extHostNotebooks=k,this._textDocumentsAndEditors=y,this._commands=T;const t=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new F.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new F.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new F.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new F.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const r=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri),notebookEditor:r.apiEditor}}return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(R,k,y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],modeId:y,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=E}),define(we[192],be([0,1,7,5]),function(ie,e,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(R){this._handlePool=0,this._proxy=R.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,R),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=E}),define(we[193],be([0,1,2,22,8,6,5,9,41,16,10,233,7,81,52,63,194,15,3]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(N,K){this._documents=N,this._provider=K}async provideDocumentSymbols(N,K){const Z=this._documents.getDocument(N),oe=await this._provider.provideDocumentSymbols(Z,K);if(!(0,T.isFalsyOrEmpty)(oe))return oe[0]instanceof A.DocumentSymbol?oe.map(E.DocumentSymbol.from):c._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(N){N=N.slice(0).sort((oe,H)=>{let re=oe.location.range.start.compareTo(H.location.range.start);return re===0&&(re=H.location.range.end.compareTo(oe.location.range.end)),re});const K=[],Z=[];for(const oe of N){const H={name:oe.name||"!!MISSING: name!!",kind:E.SymbolKind.from(oe.kind),tags:oe.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:E.Range.from(oe.location.range),selectionRange:E.Range.from(oe.location.range),children:[]};for(;;){if(Z.length===0){Z.push(H),K.push(H);break}const re=Z[Z.length-1];if(y.Range.containsRange(re.range,H.range)&&!y.Range.equalsRange(re.range,H.range)){re.children&&re.children.push(H),Z.push(H);break}Z.pop()}}return K}}class p{constructor(N,K,Z){this._documents=N,this._commands=K,this._provider=Z,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,K){const Z=this._documents.getDocument(N),oe=await this._provider.provideCodeLenses(Z,K);if(!oe||K.isCancellationRequested)return;const H=this._cache.add(oe),re=new r.DisposableStore;this._disposables.set(H,re);const he={cacheId:H,lenses:[]};for(let Te=0;Te<oe.length;Te++)he.lenses.push({cacheId:[H,Te],range:E.Range.from(oe[Te].range),command:this._commands.toInternal(oe[Te].command,re)});return he}async resolveCodeLens(N,K){const Z=N.cacheId&&this._cache.get(...N.cacheId);if(!Z)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||Z.isResolved?oe=Z:oe=await this._provider.resolveCodeLens(Z,K),oe||(oe=Z),K.isCancellationRequested)return;const H=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!H)return N.command=this._commands.toInternal(oe.command??p._badCmd,H),N}releaseCodeLenses(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(je){return Array.isArray(je)?je.map(E.DefinitionLink.from):je?[E.DefinitionLink.from(je)]:[]}class i{constructor(N,K){this._documents=N,this._provider=K}async provideDefinition(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.provideDefinition(oe,H,Z);return S(re)}}class s{constructor(N,K){this._documents=N,this._provider=K}async provideDeclaration(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.provideDeclaration(oe,H,Z);return S(re)}}class u{constructor(N,K){this._documents=N,this._provider=K}async provideImplementation(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.provideImplementation(oe,H,Z);return S(re)}}class o{constructor(N,K){this._documents=N,this._provider=K}async provideTypeDefinition(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.provideTypeDefinition(oe,H,Z);return S(re)}}class f{constructor(N,K){this._documents=N,this._provider=K}async provideHover(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.provideHover(oe,H,Z);if(!(!re||(0,T.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=oe.getWordRangeAtPosition(H)),re.range||(re.range=new A.Range(H,H)),E.Hover.from(re)}}class v{constructor(N,K){this._documents=N,this._provider=K}async provideEvaluatableExpression(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.provideEvaluatableExpression(oe,H,Z);if(re)return E.EvaluatableExpression.from(re)}}class w{constructor(N,K){this._documents=N,this._provider=K}async provideInlineValues(N,K,Z,oe){const H=this._documents.getDocument(N),re=await this._provider.provideInlineValues(H,E.Range.to(K),E.InlineValueContext.to(Z),oe);if(Array.isArray(re))return re.map(he=>E.InlineValue.from(he))}}class D{constructor(N,K){this._documents=N,this._provider=K}async provideDocumentHighlights(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.provideDocumentHighlights(oe,H,Z);if(Array.isArray(re))return re.map(E.DocumentHighlight.from)}}class P{constructor(N,K){this._documents=N,this._provider=K}async provideLinkedEditingRanges(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.provideLinkedEditingRanges(oe,H,Z);if(re&&Array.isArray(re.ranges))return{ranges:(0,T.coalesce)(re.ranges.map(E.Range.from)),wordPattern:re.wordPattern}}}class n{constructor(N,K){this._documents=N,this._provider=K}async provideReferences(N,K,Z,oe){const H=this._documents.getDocument(N),re=E.Position.to(K),he=await this._provider.provideReferences(H,re,Z,oe);if(Array.isArray(he))return he.map(E.location.from)}}class m{constructor(N,K,Z,oe,H,re,he){this._documents=N,this._commands=K,this._diagnostics=Z,this._provider=oe,this._logService=H,this._extension=re,this._apiDeprecation=he,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(N,K,Z,oe){const H=this._documents.getDocument(N),re=_.Selection.isISelection(K)?E.Selection.to(K):E.Range.to(K),he=[];for(const rt of this._diagnostics.getDiagnostics(N))if(re.intersection(rt.range)&&he.push(rt)>m._maxCodeActionsPerFile)break;const Te={diagnostics:he,only:Z.only?new A.CodeActionKind(Z.only):void 0,triggerKind:E.CodeActionTriggerKind.to(Z.trigger)},Ue=await this._provider.provideCodeActions(H,re,Te,oe);if(!(0,T.isNonEmptyArray)(Ue)||oe.isCancellationRequested)return;const $e=this._cache.add(Ue),Ke=new r.DisposableStore;this._disposables.set($e,Ke);const _e=[];for(let rt=0;rt<Ue.length;rt++){const W=Ue[rt];!W||(m._isCommand(W)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:W.title,command:this._commands.toInternal(W,Ke)})):(Te.only&&(W.kind?Te.only.contains(W.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${W.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[$e,rt],title:W.title,command:W.command&&this._commands.toInternal(W.command,Ke),diagnostics:W.diagnostics&&W.diagnostics.map(E.Diagnostic.from),edit:W.edit&&E.WorkspaceEdit.from(W.edit),kind:W.kind&&W.kind.value,isPreferred:W.isPreferred,disabled:W.disabled?.reason})))}return{cacheId:$e,actions:_e}}async resolveCodeAction(N,K){const[Z,oe]=N,H=this._cache.get(Z,oe);if(!H||m._isCommand(H)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(H,K)??H;return re?.edit?E.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}m._maxCodeActionsPerFile=1e3;class C{constructor(N,K){this._documents=N,this._provider=K}async provideDocumentFormattingEdits(N,K,Z){const oe=this._documents.getDocument(N),H=await this._provider.provideDocumentFormattingEdits(oe,K,Z);if(Array.isArray(H))return H.map(E.TextEdit.from)}}class L{constructor(N,K){this._documents=N,this._provider=K}async provideDocumentRangeFormattingEdits(N,K,Z,oe){const H=this._documents.getDocument(N),re=E.Range.to(K),he=await this._provider.provideDocumentRangeFormattingEdits(H,re,Z,oe);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class ${constructor(N,K){this._documents=N,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,K,Z,oe,H){const re=this._documents.getDocument(N),he=E.Position.to(K),Te=await this._provider.provideOnTypeFormattingEdits(re,he,Z,oe,H);if(Array.isArray(Te))return Te.map(E.TextEdit.from)}}class Q{constructor(N,K){this._provider=N,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(N,K){const Z=R.IdObject.mixin({symbols:[]}),oe=await this._provider.provideWorkspaceSymbols(N,K);if((0,T.isNonEmptyArray)(oe))for(const H of oe){if(!H)continue;if(!H.name){this._logService.warn("INVALID SymbolInformation, lacks name",H);continue}const re=R.IdObject.mixin(E.WorkspaceSymbol.from(H));this._symbolCache.set(re._id,H),Z.symbols.push(re)}return Z.symbols.length>0&&this._resultCache.set(Z._id,[Z.symbols[0]._id,Z.symbols[Z.symbols.length-1]._id]),Z}async resolveWorkspaceSymbol(N,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return N;const Z=this._symbolCache.get(N._id);if(Z){const oe=await this._provider.resolveWorkspaceSymbol(Z,K);return oe&&(0,F.mixin)(N,E.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(N){const K=this._resultCache.get(N);if(K){for(let[Z,oe]=K;Z<=oe;Z++)this._symbolCache.delete(Z);this._resultCache.delete(N)}}}class se{constructor(N,K,Z){this._documents=N,this._provider=K,this._logService=Z}static supportsResolving(N){return typeof N.prepareRename=="function"}async provideRenameEdits(N,K,Z,oe){const H=this._documents.getDocument(N),re=E.Position.to(K);try{const he=await this._provider.provideRenameEdits(H,re,Z,oe);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Te=se._asMessage(he);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(N,K,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(N),H=E.Position.to(K);try{const re=await this._provider.prepareRename(oe,H,Z);let he,Te;if(A.Range.isRange(re)?(he=re,Te=oe.getText(re)):(0,t.isObject)(re)&&(he=re.range,Te=re.placeholder),!he||!Te)return;if(he.start.line>H.line||he.end.line<H.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Te}}catch(re){const he=se._asMessage(re);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class G{constructor(N,K){this.resultId=N,this.tokens=K}}class z{constructor(N,K){this._documents=N,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(N,K,Z){const oe=this._documents.getDocument(N),H=K!==0?this._previousResults.get(K):null;let re=typeof H?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,H.resultId,Z):await this._provider.provideDocumentSemanticTokens(oe,Z);return H&&this._previousResults.delete(K),re?(re=z._fixProvidedSemanticTokens(re),this._send(z._convertToEdits(H,re),re)):null}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return z._isSemanticTokens(N)?z._isCorrectSemanticTokens(N)?N:new A.SemanticTokens(new Uint32Array(N.data),N.resultId):z._isSemanticTokensEdits(N)?z._isCorrectSemanticTokensEdits(N)?N:new A.SemanticTokensEdits(N.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const K of N.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,K){if(!z._isSemanticTokens(K)||!N||!N.tokens)return K;const Z=N.tokens,oe=Z.length,H=K.data,re=H.length;let he=0;const Te=Math.min(oe,re);for(;he<Te&&Z[he]===H[he];)he++;if(he===oe&&he===re)return new A.SemanticTokensEdits([],K.resultId);let Ue=0;const $e=Te-he;for(;Ue<$e&&Z[oe-Ue-1]===H[re-Ue-1];)Ue++;return new A.SemanticTokensEdits([{start:he,deleteCount:oe-he-Ue,data:H.subarray(he,re-Ue)}],K.resultId)}_send(N,K){if(z._isSemanticTokens(N)){const Z=this._nextResultId++;return this._previousResults.set(Z,new G(N.resultId,N.data)),(0,h.encodeSemanticTokensDto)({id:Z,type:"full",data:N.data})}if(z._isSemanticTokensEdits(N)){const Z=this._nextResultId++;return z._isSemanticTokens(K)?this._previousResults.set(Z,new G(K.resultId,K.data)):this._previousResults.set(Z,new G(N.resultId)),(0,h.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(N.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class x{constructor(N,K){this._documents=N,this._provider=K}async provideDocumentRangeSemanticTokens(N,K,Z){const oe=this._documents.getDocument(N),H=await this._provider.provideDocumentRangeSemanticTokens(oe,E.Range.to(K),Z);return H?this._send(H):null}_send(N){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=x;class j{constructor(N,K,Z,oe,H){this._documents=N,this._commands=K,this._provider=Z,this._apiDeprecation=oe,this._extension=H,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,K,Z,oe){const H=this._documents.getDocument(N),re=E.Position.to(K),he=H.getWordRangeAtPosition(re)||new A.Range(re,re),Te=he.with({end:re}),Ue=new g.StopWatch(!0),$e=await this._provider.provideCompletionItems(H,re,oe,E.CompletionContext.to(Z));if(!$e||oe.isCancellationRequested)return;const Ke=Array.isArray($e)?new A.CompletionList($e):$e,_e=j.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),rt=new r.DisposableStore;this._disposables.set(_e,rt);const W=[],Y={x:_e,b:W,a:{replace:E.Range.from(he),insert:E.Range.from(Te)},c:Ke.isIncomplete||void 0,d:Ue.elapsed()};for(let me=0;me<Ke.items.length;me++){const Ne=Ke.items[me],Ye=this._convertCompletionItem(Ne,[_e,me],Te,he);W.push(Ye)}return Y}async resolveCompletionItem(N,K){if(typeof this._provider.resolveCompletionItem!="function")return;const Z=this._cache.get(...N);if(!Z)return;const oe=await this._provider.resolveCompletionItem(Z,K);if(!!oe)return this._convertCompletionItem(oe,N)}releaseCompletionItems(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,K,Z,oe){const H=this._disposables.get(K[0]);if(!H)throw Error("DisposableStore is missing...");const re={x:K,a:N.label,b:N.kind!==void 0?E.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(E.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(N.command,H)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=N.textEdit.newText):typeof N.insertText=="string"?re.h=N.insertText:N.insertText instanceof A.SnippetString&&(re.h=N.insertText.value,re.i|=4);let he;return N.textEdit?he=N.textEdit.range:N.range&&(he=N.range),A.Range.isRange(he)?re.j=E.Range.from(he):he&&(!Z?.isEqual(he.inserting)||!oe?.isEqual(he.replacing))&&(re.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),re}}class B{constructor(N,K,Z){this._documents=N,this._provider=K,this._commands=Z,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(N,K,Z,oe){const H=this._documents.getDocument(N),re=E.Position.to(K),he=await this._provider.provideInlineCompletionItems(H,re,Z,oe);if(!he||oe.isCancellationRequested)return;const Te=(0,t.isArray)(he)?{items:he}:he,Ue=this._cache.add(Te.items);let $e;return{pid:Ue,items:Te.items.map((Ke,_e)=>{let rt;return Ke.command&&($e||($e=new r.DisposableStore,this._disposables.set(Ue,$e)),rt=this._commands.toInternal(Ke.command,$e)),{text:Ke.text,range:Ke.range?E.Range.from(Ke.range):void 0,command:rt,idx:_e}})}}disposeCompletions(N){this._cache.delete(N);const K=this._disposables.get(N);K&&K.clear(),this._disposables.delete(N)}handleDidShowCompletionItem(N,K){const Z=this._cache.get(N,K);Z&&q.get(this._provider).fireOnDidShowCompletionItem({completionItem:Z})}}class q{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(N){let K=q.map.get(N);return K||(K=new q,q.map.set(N,K)),K}fireOnDidShowCompletionItem(N){this._onDidShowCompletionItemEmitter.fire(N)}}e.InlineCompletionController=q,q.map=new WeakMap;class ce{constructor(N,K){this._documents=N,this._provider=K,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(N,K,Z,oe){const H=this._documents.getDocument(N),re=E.Position.to(K),he=this.reviveContext(Z),Te=await this._provider.provideSignatureHelp(H,re,oe,he);if(Te){const Ue=this._cache.add([Te]);return{...E.SignatureHelp.from(Te),id:Ue}}}reviveContext(N){let K;if(N.activeSignatureHelp){const Z=E.SignatureHelp.to(N.activeSignatureHelp),oe=this._cache.get(N.activeSignatureHelp.id,0);oe?(K=oe,K.activeSignature=Z.activeSignature,K.activeParameter=Z.activeParameter):K=Z}return{...N,activeSignatureHelp:K}}releaseSignatureHelp(N){this._cache.delete(N)}}class V{constructor(N,K){this._documents=N,this._provider=K}async provideInlayHints(N,K,Z){const oe=this._documents.getDocument(N),H=await this._provider.provideInlayHints(oe,E.Range.to(K),Z);return H?{hints:H.map(E.InlayHint.from)}:void 0}}class le{constructor(N,K){this._documents=N,this._provider=K,this._cache=new l.Cache("DocumentLink")}async provideLinks(N,K){const Z=this._documents.getDocument(N),oe=await this._provider.provideDocumentLinks(Z,K);if(!(!Array.isArray(oe)||oe.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(le._validateLink).map(E.DocumentLink.from)};{const H=this._cache.add(oe),re={links:[],id:H};for(let he=0;he<oe.length;he++){if(!le._validateLink(oe[he]))continue;const Te=E.DocumentLink.from(oe[he]);Te.cacheId=[H,he],re.links.push(Te)}return re}}}static _validateLink(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,K){if(typeof this._provider.resolveDocumentLink!="function")return;const Z=this._cache.get(...N);if(!Z)return;const oe=await this._provider.resolveDocumentLink(Z,K);if(!(!oe||!le._validateLink(oe)))return E.DocumentLink.from(oe)}releaseLinks(N){this._cache.delete(N)}}class ae{constructor(N,K){this._documents=N,this._provider=K}async provideColors(N,K){const Z=this._documents.getDocument(N),oe=await this._provider.provideDocumentColors(Z,K);return Array.isArray(oe)?oe.map(re=>({color:E.Color.from(re.color),range:E.Range.from(re.range)})):[]}async provideColorPresentations(N,K,Z){const oe=this._documents.getDocument(N),H=E.Range.to(K.range),re=E.Color.to(K.color),he=await this._provider.provideColorPresentations(re,{document:oe,range:H},Z);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class ve{constructor(N,K){this._documents=N,this._provider=K}async provideFoldingRanges(N,K,Z){const oe=this._documents.getDocument(N),H=await this._provider.provideFoldingRanges(oe,K,Z);if(!!Array.isArray(H))return H.map(E.FoldingRange.from)}}class Ae{constructor(N,K,Z){this._documents=N,this._provider=K,this._logService=Z}async provideSelectionRanges(N,K,Z){const oe=this._documents.getDocument(N),H=K.map(E.Position.to),re=await this._provider.provideSelectionRanges(oe,H,Z);if(!(0,T.isNonEmptyArray)(re))return[];if(re.length!==H.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Te=0;Te<H.length;Te++){const Ue=[];he.push(Ue);let $e=H[Te],Ke=re[Te];for(;;){if(!Ke.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(E.SelectionRange.from(Ke)),!Ke.parent)break;$e=Ke.range,Ke=Ke.parent}}return he}}class Re{constructor(N,K){this._documents=N,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.prepareCallHierarchy(oe,H,Z);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,re)]}async provideCallsTo(N,K,Z){const oe=this._itemFromCache(N,K);if(!oe)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyIncomingCalls(oe,Z);if(!!H)return H.map(re=>({from:this._cacheAndConvertItem(N,re.from),fromRanges:re.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom(N,K,Z){const oe=this._itemFromCache(N,K);if(!oe)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyOutgoingCalls(oe,Z);if(!!H)return H.map(re=>({to:this._cacheAndConvertItem(N,re.to),fromRanges:re.fromRanges.map(he=>E.Range.from(he))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,K){const Z=this._cache.get(N),oe=E.CallHierarchyItem.from(K,N,Z.size.toString(36));return Z.set(oe._itemId,K),oe}_itemFromCache(N,K){return this._cache.get(N)?.get(K)}}class Oe{constructor(N,K){this._documents=N,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(N,K,Z){const oe=this._documents.getDocument(N),H=E.Position.to(K),re=await this._provider.prepareTypeHierarchy(oe,H,Z);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,re)]}async provideSupertypes(N,K,Z){const oe=this._itemFromCache(N,K);if(!oe)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySupertypes(oe,Z);if(!!H)return H.map(re=>this._cacheAndConvertItem(N,re))}async provideSubtypes(N,K,Z){const oe=this._itemFromCache(N,K);if(!oe)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySubtypes(oe,Z);if(!!H)return H.map(re=>this._cacheAndConvertItem(N,re))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,K){const Z=this._cache.get(N),oe=E.TypeHierarchyItem.from(K,N,Z.size.toString(36));return Z.set(oe._itemId,K),oe}_itemFromCache(N,K){return this._cache.get(N)?.get(K)}}class Qe{constructor(N,K){this.adapter=N,this.extension=K}}class He{constructor(N,K,Z,oe,H,re,he){this._adapter=new Map,this._uriTransformer=K,this._proxy=N.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=Z,this._commands=oe,this._diagnostics=H,this._logService=re,this._apiDeprecation=he}_transformDocumentSelector(N){return(0,T.coalesce)((0,T.asArray)(N).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(N){if(typeof N=="string")return{$serialized:!0,language:N};if(N)return{$serialized:!0,language:N.language,scheme:this._transformScheme(N.scheme),pattern:typeof N.pattern=="undefined"?void 0:E.GlobPattern.from(N.pattern),exclusive:N.exclusive}}_transformScheme(N){return this._uriTransformer&&typeof N=="string"?this._uriTransformer.transformOutgoingScheme(N):N}_createDisposable(N){return new A.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return He._handlePool++}_withAdapter(N,K,Z,oe,H=!1){const re=this._adapter.get(N);if(!re)return Promise.resolve(oe);if(re.adapter instanceof K){let he;re.extension&&(he=Date.now(),this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${K.name}'`));const Te=Z(re.adapter,re.extension),Ue=re.extension;return Ue&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),$e=>{H&&$e instanceof I.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error($e))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(N,K){const Z=this._nextHandle();return this._adapter.set(Z,new Qe(N,K)),Z}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,K,Z,oe){const H=this._addNewAdapter(new c(this._documents,Z),N),re=oe&&oe.label||He._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(H,this._transformDocumentSelector(K),re),this._createDisposable(H)}$provideDocumentSymbols(N,K,Z){return this._withAdapter(N,c,oe=>oe.provideDocumentSymbols(d.URI.revive(K),Z),void 0)}registerCodeLensProvider(N,K,Z){const oe=this._nextHandle(),H=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Qe(new p(this._documents,this._commands.converter,Z),N)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(K),H);let re=this._createDisposable(oe);if(H!==void 0){const he=Z.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(H));re=A.Disposable.from(re,he)}return re}$provideCodeLenses(N,K,Z){return this._withAdapter(N,p,oe=>oe.provideCodeLenses(d.URI.revive(K),Z),void 0)}$resolveCodeLens(N,K,Z){return this._withAdapter(N,p,oe=>oe.resolveCodeLens(K,Z),void 0)}$releaseCodeLenses(N,K){this._withAdapter(N,p,Z=>Promise.resolve(Z.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(N,K,Z){const oe=this._addNewAdapter(new i(this._documents,Z),N);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDefinition(N,K,Z,oe){return this._withAdapter(N,i,H=>H.provideDefinition(d.URI.revive(K),Z,oe),[])}registerDeclarationProvider(N,K,Z){const oe=this._addNewAdapter(new s(this._documents,Z),N);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDeclaration(N,K,Z,oe){return this._withAdapter(N,s,H=>H.provideDeclaration(d.URI.revive(K),Z,oe),[])}registerImplementationProvider(N,K,Z){const oe=this._addNewAdapter(new u(this._documents,Z),N);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideImplementation(N,K,Z,oe){return this._withAdapter(N,u,H=>H.provideImplementation(d.URI.revive(K),Z,oe),[])}registerTypeDefinitionProvider(N,K,Z){const oe=this._addNewAdapter(new o(this._documents,Z),N);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideTypeDefinition(N,K,Z,oe){return this._withAdapter(N,o,H=>H.provideTypeDefinition(d.URI.revive(K),Z,oe),[])}registerHoverProvider(N,K,Z,oe){const H=this._addNewAdapter(new f(this._documents,Z),N);return this._proxy.$registerHoverProvider(H,this._transformDocumentSelector(K)),this._createDisposable(H)}$provideHover(N,K,Z,oe){return this._withAdapter(N,f,H=>H.provideHover(d.URI.revive(K),Z,oe),void 0)}registerEvaluatableExpressionProvider(N,K,Z,oe){const H=this._addNewAdapter(new v(this._documents,Z),N);return this._proxy.$registerEvaluatableExpressionProvider(H,this._transformDocumentSelector(K)),this._createDisposable(H)}$provideEvaluatableExpression(N,K,Z,oe){return this._withAdapter(N,v,H=>H.provideEvaluatableExpression(d.URI.revive(K),Z,oe),void 0)}registerInlineValuesProvider(N,K,Z,oe){const H=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new w(this._documents,Z),N);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(K),H);let he=this._createDisposable(re);if(H!==void 0){const Te=Z.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(H));he=A.Disposable.from(he,Te)}return he}$provideInlineValues(N,K,Z,oe,H){return this._withAdapter(N,w,re=>re.provideInlineValues(d.URI.revive(K),Z,oe,H),void 0)}registerDocumentHighlightProvider(N,K,Z){const oe=this._addNewAdapter(new D(this._documents,Z),N);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentHighlights(N,K,Z,oe){return this._withAdapter(N,D,H=>H.provideDocumentHighlights(d.URI.revive(K),Z,oe),void 0)}registerLinkedEditingRangeProvider(N,K,Z){const oe=this._addNewAdapter(new P(this._documents,Z),N);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideLinkedEditingRanges(N,K,Z,oe){return this._withAdapter(N,P,async H=>{const re=await H.provideLinkedEditingRanges(d.URI.revive(K),Z,oe);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?He._serializeRegExp(re.wordPattern):void 0}},void 0)}registerReferenceProvider(N,K,Z){const oe=this._addNewAdapter(new n(this._documents,Z),N);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideReferences(N,K,Z,oe,H){return this._withAdapter(N,n,re=>re.provideReferences(d.URI.revive(K),Z,oe,H),void 0)}registerCodeActionProvider(N,K,Z,oe){const H=new r.DisposableStore,re=this._addNewAdapter(new m(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(K),{providedKinds:oe?.providedCodeActionKinds?.map(he=>he.value),documentation:oe?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,H)}))},He._extLabel(N),Boolean(Z.resolveCodeAction)),H.add(this._createDisposable(re)),H}$provideCodeActions(N,K,Z,oe,H){return this._withAdapter(N,m,re=>re.provideCodeActions(d.URI.revive(K),Z,oe,H),void 0)}$resolveCodeAction(N,K,Z){return this._withAdapter(N,m,oe=>oe.resolveCodeAction(K,Z),void 0)}$releaseCodeActions(N,K){this._withAdapter(N,m,Z=>Promise.resolve(Z.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(N,K,Z){const oe=this._addNewAdapter(new C(this._documents,Z),N);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(K),N.identifier,N.displayName||N.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(N,K,Z,oe){return this._withAdapter(N,C,H=>H.provideDocumentFormattingEdits(d.URI.revive(K),Z,oe),void 0)}registerDocumentRangeFormattingEditProvider(N,K,Z){const oe=this._addNewAdapter(new L(this._documents,Z),N);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(K),N.identifier,N.displayName||N.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(N,K,Z,oe,H){return this._withAdapter(N,L,re=>re.provideDocumentRangeFormattingEdits(d.URI.revive(K),Z,oe,H),void 0)}registerOnTypeFormattingEditProvider(N,K,Z,oe){const H=this._addNewAdapter(new $(this._documents,Z),N);return this._proxy.$registerOnTypeFormattingSupport(H,this._transformDocumentSelector(K),oe,N.identifier),this._createDisposable(H)}$provideOnTypeFormattingEdits(N,K,Z,oe,H,re){return this._withAdapter(N,$,he=>he.provideOnTypeFormattingEdits(d.URI.revive(K),Z,oe,H,re),void 0)}registerWorkspaceSymbolProvider(N,K){const Z=this._addNewAdapter(new Q(K,this._logService),N);return this._proxy.$registerNavigateTypeSupport(Z),this._createDisposable(Z)}$provideWorkspaceSymbols(N,K,Z){return this._withAdapter(N,Q,oe=>oe.provideWorkspaceSymbols(K,Z),{symbols:[]})}$resolveWorkspaceSymbol(N,K,Z){return this._withAdapter(N,Q,oe=>oe.resolveWorkspaceSymbol(K,Z),void 0)}$releaseWorkspaceSymbols(N,K){this._withAdapter(N,Q,Z=>Z.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(N,K,Z){const oe=this._addNewAdapter(new se(this._documents,Z,this._logService),N);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(K),se.supportsResolving(Z)),this._createDisposable(oe)}$provideRenameEdits(N,K,Z,oe,H){return this._withAdapter(N,se,re=>re.provideRenameEdits(d.URI.revive(K),Z,oe,H),void 0)}$resolveRenameLocation(N,K,Z,oe){return this._withAdapter(N,se,H=>H.resolveRenameLocation(d.URI.revive(K),Z,oe),void 0)}registerDocumentSemanticTokensProvider(N,K,Z,oe){const H=this._nextHandle(),re=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(H,new Qe(new z(this._documents,Z),N)),this._proxy.$registerDocumentSemanticTokensProvider(H,this._transformDocumentSelector(K),oe,re);let he=this._createDisposable(H);if(re){const Te=Z.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(re));he=A.Disposable.from(he,Te)}return he}$provideDocumentSemanticTokens(N,K,Z,oe){return this._withAdapter(N,z,H=>H.provideDocumentSemanticTokens(d.URI.revive(K),Z,oe),null,!0)}$releaseDocumentSemanticTokens(N,K){this._withAdapter(N,z,Z=>Z.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(N,K,Z,oe){const H=this._addNewAdapter(new x(this._documents,Z),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(H,this._transformDocumentSelector(K),oe),this._createDisposable(H)}$provideDocumentRangeSemanticTokens(N,K,Z,oe){return this._withAdapter(N,x,H=>H.provideDocumentRangeSemanticTokens(d.URI.revive(K),Z,oe),null,!0)}registerCompletionItemProvider(N,K,Z,oe){const H=this._addNewAdapter(new j(this._documents,this._commands.converter,Z,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(H,this._transformDocumentSelector(K),oe,j.supportsResolving(Z),`${N.identifier.value}(${oe.join("")})`),this._createDisposable(H)}$provideCompletionItems(N,K,Z,oe,H){return this._withAdapter(N,j,re=>re.provideCompletionItems(d.URI.revive(K),Z,oe,H),void 0)}$resolveCompletionItem(N,K,Z){return this._withAdapter(N,j,oe=>oe.resolveCompletionItem(K,Z),void 0)}$releaseCompletionItems(N,K){this._withAdapter(N,j,Z=>Z.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(N,K,Z){const oe=this._addNewAdapter(new B(this._documents,Z,this._commands.converter),N);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideInlineCompletions(N,K,Z,oe,H){return this._withAdapter(N,B,re=>re.provideInlineCompletions(d.URI.revive(K),Z,oe,H),void 0)}$handleInlineCompletionDidShow(N,K,Z){this._withAdapter(N,B,async oe=>{oe.handleDidShowCompletionItem(K,Z)},void 0)}$freeInlineCompletionsList(N,K){this._withAdapter(N,B,async Z=>{Z.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(N,K,Z,oe){const H=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,re=this._addNewAdapter(new ce(this._documents,Z),N);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(K),H),this._createDisposable(re)}$provideSignatureHelp(N,K,Z,oe,H){return this._withAdapter(N,ce,re=>re.provideSignatureHelp(d.URI.revive(K),Z,oe,H),void 0)}$releaseSignatureHelp(N,K){this._withAdapter(N,ce,Z=>Z.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(N,K,Z){const oe=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,H=this._addNewAdapter(new V(this._documents,Z),N);this._proxy.$registerInlayHintsProvider(H,this._transformDocumentSelector(K),oe);let re=this._createDisposable(H);if(oe!==void 0){const he=Z.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(oe));re=A.Disposable.from(re,he)}return re}$provideInlayHints(N,K,Z,oe){return this._withAdapter(N,V,H=>H.provideInlayHints(d.URI.revive(K),Z,oe),void 0)}registerDocumentLinkProvider(N,K,Z){const oe=this._addNewAdapter(new le(this._documents,Z),N);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(K),typeof Z.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(N,K,Z){return this._withAdapter(N,le,oe=>oe.provideLinks(d.URI.revive(K),Z),void 0)}$resolveDocumentLink(N,K,Z){return this._withAdapter(N,le,oe=>oe.resolveLink(K,Z),void 0)}$releaseDocumentLinks(N,K){this._withAdapter(N,le,Z=>Z.releaseLinks(K),void 0)}registerColorProvider(N,K,Z){const oe=this._addNewAdapter(new ae(this._documents,Z),N);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentColors(N,K,Z){return this._withAdapter(N,ae,oe=>oe.provideColors(d.URI.revive(K),Z),[])}$provideColorPresentations(N,K,Z,oe){return this._withAdapter(N,ae,H=>H.provideColorPresentations(d.URI.revive(K),Z,oe),void 0)}registerFoldingRangeProvider(N,K,Z){const oe=this._nextHandle(),H=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Qe(new ve(this._documents,Z),N)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(K),H);let re=this._createDisposable(oe);if(H!==void 0){const he=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(H));re=A.Disposable.from(re,he)}return re}$provideFoldingRanges(N,K,Z,oe){return this._withAdapter(N,ve,H=>H.provideFoldingRanges(d.URI.revive(K),Z,oe),void 0)}registerSelectionRangeProvider(N,K,Z){const oe=this._addNewAdapter(new Ae(this._documents,Z,this._logService),N);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideSelectionRanges(N,K,Z,oe){return this._withAdapter(N,Ae,H=>H.provideSelectionRanges(d.URI.revive(K),Z,oe),[])}registerCallHierarchyProvider(N,K,Z){const oe=this._addNewAdapter(new Re(this._documents,Z),N);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareCallHierarchy(N,K,Z,oe){return this._withAdapter(N,Re,H=>Promise.resolve(H.prepareSession(d.URI.revive(K),Z,oe)),void 0)}$provideCallHierarchyIncomingCalls(N,K,Z,oe){return this._withAdapter(N,Re,H=>H.provideCallsTo(K,Z,oe),void 0)}$provideCallHierarchyOutgoingCalls(N,K,Z,oe){return this._withAdapter(N,Re,H=>H.provideCallsFrom(K,Z,oe),void 0)}$releaseCallHierarchy(N,K){this._withAdapter(N,Re,Z=>Promise.resolve(Z.releaseSession(K)),void 0)}registerTypeHierarchyProvider(N,K,Z){const oe=this._addNewAdapter(new Oe(this._documents,Z),N);return this._proxy.$registerTypeHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareTypeHierarchy(N,K,Z,oe){return this._withAdapter(N,Oe,H=>Promise.resolve(H.prepareSession(d.URI.revive(K),Z,oe)),void 0)}$provideTypeHierarchySupertypes(N,K,Z,oe){return this._withAdapter(N,Oe,H=>H.provideSupertypes(K,Z,oe),void 0)}$provideTypeHierarchySubtypes(N,K,Z,oe){return this._withAdapter(N,Oe,H=>H.provideSubtypes(K,Z,oe),void 0)}$releaseTypeHierarchy(N,K){this._withAdapter(N,Oe,Z=>Promise.resolve(Z.releaseSession(K)),void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,k.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:He._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:He._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?He._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?He._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:He._serializeRegExp(N.beforeText),afterText:N.afterText?He._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?He._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(He._serializeOnEnterRule)}setLanguageConfiguration(N,K,Z){let{wordPattern:oe}=Z;if(oe&&(0,k.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(K,oe):this._documents.setWordDefinitionFor(K,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const H=this._nextHandle(),re={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?He._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?He._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?He._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(H,K,re),this._createDisposable(H)}$setWordDefinitions(N){for(const K of N)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=He,He._handlePool=0}),define(we[195],be([0,1,5,8,6,35,13]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class k{constructor(T,t){this._handlePool=0,this._proxy=T.getProxy(d.MainContext.MainThreadLanguages),this._documents=t}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(T,t){await this._proxy.$changeLanguage(T,t);const _=this._documents.getDocumentData(T);if(!_)throw new Error(`document '${T.toString}' NOT found`);return _.document}async tokenAtPosition(T,t){const _=T.version,r=F.Position.from(t),h=await this._proxy.$tokensAtPosition(T.uri,r),a={type:E.StandardTokenType.Other,range:T.getWordRangeAtPosition(t)??new E.Range(t.line,t.character,t.line,t.character)};if(!h)return a;const l={range:F.Range.to(h.range),type:F.TokenType.to(h.type)};return!l.range.contains(t)||_!==T.version?a:l}createLanguageStatusItem(T){const t=this._handlePool++,_=this._proxy,r={selector:T,text:"",detail:"",severity:E.LanguageStatusSeverity.Information};let h;const a=()=>{h?.dispose(),h=(0,R.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(t,{selector:r.selector,text:r.text,message:typeof r.detail=="string"?r.detail:F.MarkdownString.from(r.detail),severity:r.severity===E.LanguageStatusSeverity.Error?A.default.Error:r.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info})},0)},l={get selector(){return r.selector},set selector(g){r.selector=g,a()},get text(){return r.text},set text(g){r.text=g,a()},get detail(){return r.detail},set detail(g){r.detail=g,a()},get severity(){return r.severity},set severity(g){r.severity=g,a()},dispose(){h?.dispose(),_.$removeLanguageStatus(t)}};return a(),l}}e.ExtHostLanguages=k}),define(we[196],be([0,1,5,14,30]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let R=class{constructor(y,T){this._logService=T,this._proxy=y.getProxy(d.MainContext.MainThreadMessageService)}showMessage(y,T,t,_,r){const h={extension:y};let a;typeof _=="string"||A(_)?a=[_,...r]:(h.modal=_?.modal,h.useCustom=_?.useCustom,h.detail=_?.detail,a=r),h.useCustom&&(0,E.checkProposedApiEnabled)(y);const l=[];for(let g=0;g<a.length;g++){const I=a[g];if(typeof I=="string")l.push({title:I,handle:g,isCloseAffordance:!1});else if(typeof I=="object"){let{title:b,isCloseAffordance:c}=I;l.push({title:b,isCloseAffordance:!!c,handle:g})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(T,t,h,l).then(g=>{if(typeof g=="number")return a[g]})}};R=Be([ze(1,F.ILogService)],R),e.ExtHostMessageService=R}),define(we[197],be([0,1,23,3,57,7,20,9,10,2,63,5,8,6,46,171,93]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(c,p,S,i,s){this._textDocumentsAndEditors=S,this._textDocuments=i,this._extensionStoragePaths=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const o=u.notebookEditor?.notebookUri,f=u.cell.handle,w=this._documents.get(o)?.getCell(f);if(w)return w.apiCell}return u}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const p=this._editors.get(c);if(!p)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(c){for(const[p,S]of this._editors)if(S.apiEditor===c)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,p){const S=this._documents.get(c);if(!S&&!p)throw new Error(`NO notebook document for '${c}'`);return S}_getProviderData(c){const p=this._notebookContentProviders.get(c);if(!p)throw new Error(`NO provider for '${c}'`);return p}registerNotebookContentProvider(c,p,S,i,s){if((0,k.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:c,provider:S});let u;return S.onDidChangeNotebookContentOptions&&(u=S.onDidChangeNotebookContentOptions(()=>{const o=r.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(p,o)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},p,r.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(c,s)),new h.Disposable(()=>{u?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(c,p){if(!p)return;const S=p.filenamePattern.map(i=>r.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(p.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:p.displayName,filenamePattern:S,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,p,S){const i=I._notebookStatusBarItemProviderHandlePool++,s=typeof S.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,s,p);let u;return s!==void 0&&(u=S.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(s))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,s),u&&u.dispose()})}async createNotebookDocument(c){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&r.NotebookData.from(c.content)});return T.URI.revive(p)}async openNotebookDocument(c){const p=this._documents.get(c);if(p)return p.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(c),i=this._documents.get(T.URI.revive(S));return(0,y.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(c,p){T.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let S;typeof p=="object"?S={position:r.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(r.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:S={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,S),s=i&&this._editors.get(i)?.apiEditor;if(s)return s;throw i?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,p,S,i){const s=this._notebookStatusBarItemProviders.get(c),u=T.URI.revive(p),o=this._documents.get(u);if(!o||!s)return;const f=o.getCellFromIndex(S);if(!f)return;const v=await s.provideCellStatusBarItems(f.apiCell,i);if(!v)return;const w=new A.DisposableStore,D=this._statusBarCache.add([w]),n=(Array.isArray(v)?v:[v]).map(m=>r.NotebookStatusBarItem.from(m,this._commandsConverter,w));return{cacheId:D,items:n}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,p,S,i,s){if((0,k.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,S),this._notebookProxy.$registerNotebookSerializer(u,{id:c.identifier,location:c.extensionLocation},p,r.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(c,s)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(c,p,S){const i=this._notebookSerializer.get(c);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(p.buffer,S);return new a.SerializableObjectWithBuffers(r.NotebookData.from(s))}async $notebookToData(c,p,S){const i=this._notebookSerializer.get(c);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(r.NotebookData.to(p.value),S);return d.VSBuffer.wrap(s)}async $openNotebook(c,p,S,i,s){const{provider:u}=this._getProviderData(c),o=await u.openNotebook(T.URI.revive(p),{backupId:S,untitledDocumentData:i?.buffer},s);return new a.SerializableObjectWithBuffers({metadata:o.metadata??Object.create(null),cells:o.cells.map(r.NotebookCellData.from)})}async $saveNotebook(c,p,S){const i=this.getNotebookDocument(T.URI.revive(p)),{provider:s}=this._getProviderData(c);return await s.saveNotebook(i.apiNotebook,S),!0}async $saveNotebookAs(c,p,S,i){const s=this.getNotebookDocument(T.URI.revive(p)),{provider:u}=this._getProviderData(c);return await u.saveNotebookAs(T.URI.revive(S),s.apiNotebook,i),!0}async $backupNotebook(c,p,S){const i=this.getNotebookDocument(T.URI.revive(p)),s=this._getProviderData(c),u=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension),o=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),f=T.URI.joinPath(u,o),v=await s.provider.backupNotebook(i.apiNotebook,{destination:f},S);return i.updateBackup(v),v.id}_createExtHostEditor(c,p,S){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const i=new g.ExtHostNotebookEditor(p,this._notebookEditorsProxy,c,S.visibleRanges.map(r.NotebookRange.to),S.selections.map(r.NotebookRange.to),typeof S.viewColumn=="number"?r.ViewColumn.to(S.viewColumn):void 0);this._editors.set(p,i)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const S of c.value.removedDocuments){const i=T.URI.revive(S),s=this._documents.get(i);s&&(s.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(u=>u.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const u of this._editors.values())u.notebookData.uri.toString()===i.toString()&&this._editors.delete(u.id)}if(c.value.addedDocuments){const S=[];for(const i of c.value.addedDocuments){const s=T.URI.revive(i.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const u=this,o=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(f){u._onDidChangeNotebookCells.fire(f)},emitCellOutputsChange(f){u._onDidChangeCellOutputs.fire(f)},emitCellMetadataChange(f){u._onDidChangeCellMetadata.fire(f)},emitCellExecutionStateChange(f){u._onDidChangeCellExecutionState.fire(f)}},s,i);S.push(...i.cells.map(f=>l.ExtHostCell.asModelAddData(o.apiNotebook,f))),this._documents.get(s)?.dispose(),this._documents.set(s,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(c.value.addedEditors)for(const S of c.value.addedEditors){if(this._editors.has(S.id))return;const i=T.URI.revive(S.documentUri),s=this._documents.get(i);s&&this._createExtHostEditor(s,S.id,S)}const p=[];if(c.value.removedEditors)for(const S of c.value.removedEditors){const i=this._editors.get(S);i&&(this._editors.delete(S),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),p.push(i))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const S=new Set;this._visibleNotebookEditors.forEach(i=>S.add(i.id));for(const i of this._editors.values()){const s=S.has(i.id);i._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(we[198],be([0,1,3,52,14,5,12,8]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(_,r){const h=y._Keys.nextId();_.$registerNotebookEditorDecorationType(h,k.NotebookDecorationRenderOptions.from(r)),this.value={key:h,dispose(){_.$removeNotebookEditorDecorationType(h)}}}}y._Keys=new F.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(_,r,h){this._logService=_,this._extHostRpc=r,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new y(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,r){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,r);const h=this._notebooksAndEditors.getEditorById(_);r.visibleRanges&&h._acceptVisibleRanges(r.visibleRanges.ranges.map(k.NotebookRange.to)),r.selections&&h._acceptSelections(r.selections.selections.map(k.NotebookRange.to)),r.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),r.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const r in _)this._notebooksAndEditors.getEditorById(r)._acceptViewColumn(k.ViewColumn.to(_[r]))}};T=Be([ze(0,E.ILogService),ze(1,R.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(we[199],be([0,1,16,13,21,3,7,20,2,26,14,5,8,6,68,164,30,46]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(s,u,o,f){this._initData=u,this._extHostNotebook=o,this._logService=f,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(_.MainContext.MainThreadNotebookKernels)}createNotebookController(s,u,o,f,v,w){for(let q of this._kernelData.values())if(q.controller.id===u&&T.ExtensionIdentifier.equals(s.identifier,q.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const D=this._handlePool++,P=this;this._logService.trace(`NotebookController[${D}], CREATED by ${s.identifier.value}, ${u}`);const n=()=>console.warn(`NO execute handler from notebook controller '${Q.id}' of extension: '${s.identifier}'`);let m=!1;const C=new R.DisposableStore,L=new A.Emitter,$=new A.Emitter,Q={id:`${s.identifier.value}/${u}`,notebookType:o,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:f||s.identifier.value,preloads:w?w.map(r.NotebookRendererScript.from):[]};let se=v??n,G;this._proxy.$addKernel(D,Q).catch(q=>{console.log(q),m=!0});let z=0;const x=()=>{if(m)return;const q=++z;Promise.resolve().then(()=>{q===z&&this._proxy.$updateKernel(D,Q)})},j=new k.ResourceMap,B={get id(){return u},get notebookType(){return Q.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return Q.label},set label(q){Q.label=q??s.displayName??s.name,x()},get detail(){return Q.detail??""},set detail(q){Q.detail=q,x()},get description(){return Q.description??""},set description(q){Q.description=q,x()},get supportedLanguages(){return Q.supportedLanguages},set supportedLanguages(q){Q.supportedLanguages=q,x()},get supportsExecutionOrder(){return Q.supportsExecutionOrder??!1},set supportsExecutionOrder(q){Q.supportsExecutionOrder=q,x()},get rendererScripts(){return Q.preloads?Q.preloads.map(r.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler(q){se=q??n},get interruptHandler(){return G},set interruptHandler(q){G=q,Q.supportsInterrupt=Boolean(q),x()},createNotebookCellExecution(q){if(m)throw new Error("notebook controller is DISPOSED");if(!j.has(q.notebook.uri))throw P._logService.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${q.notebook.uri.toString()}`);return P._createNotebookCellExecution(q)},dispose:()=>{m||(this._logService.trace(`NotebookController[${D}], DISPOSED`),m=!0,this._kernelData.delete(D),C.dispose(),L.dispose(),$.dispose(),this._proxy.$removeKernel(D))},updateNotebookAffinity(q,ce){P._proxy.$updateNotebookPriority(D,q.uri,ce)},onDidReceiveMessage:$.event,postMessage(q,ce){return(0,g.checkProposedApiEnabled)(s),P._proxy.$postMessage(D,ce&&P._extHostNotebook.getIdByEditor(ce),q)},asWebviewUri(q){return(0,g.checkProposedApiEnabled)(s),(0,a.asWebviewUri)(q,P._initData.remote)}};return this._kernelData.set(D,{extensionId:s.identifier,controller:B,onDidReceiveMessage:$,onDidChangeSelection:L,associatedNotebooks:j}),B}$acceptNotebookAssociation(s,u,o){const f=this._kernelData.get(s);if(f){const v=this._extHostNotebook.getNotebookDocument(y.URI.revive(u));o?f.associatedNotebooks.set(v.uri,!0):f.associatedNotebooks.delete(v.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,v.uri.toString(),o),f.onDidChangeSelection.fire({selected:o,notebook:v.apiNotebook})}}async $executeCells(s,u,o){const f=this._kernelData.get(s);if(!f)return;const v=this._extHostNotebook.getNotebookDocument(y.URI.revive(u)),w=[];for(let D of o){const P=v.getCell(D);P&&w.push(P.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,v.uri.toString(),w.length),await f.controller.executeHandler.call(f.controller,w,v.apiNotebook,f.controller)}catch(D){this._logService.error(`NotebookController[${s}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(s,u,o){const f=this._kernelData.get(s);if(!f)return;const v=this._extHostNotebook.getNotebookDocument(y.URI.revive(u));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,v.apiNotebook);else for(let w of o){const D=v.getCell(w);D&&this._activeExecutions.get(D.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,u,o){const f=this._kernelData.get(s);if(!f)return;const v=this._extHostNotebook.getEditorById(u);f.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:o}))}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const f=new p(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,f);const v=f.onDidChangeState(()=>{f.state===c.Resolved&&(f.dispose(),v.dispose(),this._activeExecutions.delete(o.uri))});return f.asApiObject()}};b=Be([ze(3,t.ILogService)],b),e.ExtHostNotebookKernels=b;var c;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(c||(c={}));class p extends R.Disposable{constructor(s,u,o){super();this._document=s,this._cell=u,this._proxy=o,this._handle=p.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new S(10,f=>this.update(f)),this._executionOrder=u.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const u=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new I.SerializableObjectWithBuffers(u))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let u=this._cell;if(s&&(u=this._document.getCellFromApiCell(s)),!u)throw new Error("INVALID cell");return u.handle}validateAndConvertOutputs(s){return s.map(u=>{const o=h.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return o===u.items?r.NotebookCellOutput.from(u):r.NotebookCellOutput.from({items:o,id:u.id,metadata:u.metadata})})}async updateOutputs(s,u,o){const f=this.cellIndexToHandle(u),v=this.validateAndConvertOutputs((0,d.asArray)(s));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:f,append:o,outputs:v})}async updateOutputItems(s,u,o){return s=h.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(s),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:s.map(r.NotebookCellOutputItem.from),outputId:u.id,append:o})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(o){s._executionOrder=o,s.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,executionOrder:s._executionOrder}])},start(o){if(s._state===c.Resolved||s._state===c.Started)throw new Error("Cannot call start again");s._state=c.Started,s._onDidChangeState.fire(),s.update({editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,runStartTime:o})},end(o,f){if(s._state===c.Resolved)throw new Error("Cannot call resolve twice");s._state=c.Resolved,s._onDidChangeState.fire(),s.updateSoon({editType:l.CellExecutionUpdateType.Complete,executionHandle:s._handle,runEndTime:f,lastRunSuccess:o}),s._collector.flush(),s._proxy.$removeExecution(s._handle)},clearOutput(o){return s.verifyStateForOutput(),s.updateOutputs([],o,!1)},appendOutput(o,f){return s.verifyStateForOutput(),s.updateOutputs(o,f,!0)},replaceOutput(o,f){return s.verifyStateForOutput(),s.updateOutputs(o,f,!1)},appendOutputItems(o,f){return s.verifyStateForOutput(),s.updateOutputItems(o,f,!0)},replaceOutputItems(o,f){return s.verifyStateForOutput(),s.updateOutputItems(o,f,!1)}})}}p.HANDLE=0;class S{constructor(s,u){this.delay=s,this.callback=u,this.batch=[],this.lastFlush=Date.now()}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.lastFlush>this.delay&&this.flush(),this.waitPromise}flush(){if(this.batch.length===0)return;this.lastFlush=Date.now(),this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)}}}),define(we[200],be([0,1,3,5,93]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(k,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,y,T){const t=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(y)?.fire({editor:t.apiEditor,message:T})}createRendererMessaging(k,y){if(!k.contributes?.notebookRenderer?.some(r=>r.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const T=!!k.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(r,h,a)=>{const l=T?r:g=>{const I={};t.set(I,g.editor),r({editor:I,message:g.message})};return this.getOrCreateEmitterFor(y).event(l,h,a)},postMessage:(r,h)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(r)&&([r,h]=[h,r]);const a=T?h:t.get(h),l=a&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(a);return this.proxy.$postMessage(l?.id,y,r)}}}getOrCreateEmitterFor(k){let y=this._rendererMessageEmitters.get(k);return y||(y=new d.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,y),y)}}e.ExtHostNotebookRenderers=A}),define(we[96],be([0,1,5,3,7,23,4,12]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends E.Disposable{constructor(a,l,g,I,b){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=b,this._id=b.$register(this.name,l,g,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?A.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(l=>this._proxy.$clear(l,a))}show(a,l){this.validate(),this._id.then(g=>this._proxy.$reveal(g,!!(typeof a=="boolean"?a:l)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class T extends y{constructor(a,l,g){super(a,!1,void 0,l,g)}append(a){super.append(a),this._id.then(l=>this._proxy.$append(l,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class t extends y{constructor(a,l,g){super(a,!0,l,void 0,g)}append(a){throw new Error("Not supported")}}class _{constructor(a,l){this.name=a,this._channel=l}append(a){this._channel.then(l=>l.append(a))}appendLine(a){this._channel.then(l=>l.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,l){this._channel.then(g=>g.show(a,l))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=_;let r=class{constructor(a){this._proxy=a.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a,l){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new T(a,l.identifier.value,this._proxy)}createOutputChannelFromLogFile(a,l){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new t(a,l,this._proxy)}};r=Be([ze(0,k.IExtHostRpcService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(we[201],be([0,1,13,21,3,7,5,2,6,15,16,35,43]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(a,l,g){const I=a.getProxy(R.MainContext.MainThreadQuickOpen);class b{constructor(v,w){this._sessions=new Map,this._instances=0,this._workspace=v,this._commands=w}showQuickPick(v,w,D,P=F.CancellationToken.None){this._onDidSelectItem=void 0;const n=Promise.resolve(v),m=++this._instances,C=I.$show(m,{title:D?.title,placeHolder:D?.placeHolder,matchOnDescription:D?.matchOnDescription,matchOnDetail:D?.matchOnDetail,ignoreFocusLost:D?.ignoreFocusOut,canPickMany:D?.canPickMany},P),L={},$=C.then(()=>L);return Promise.race([$,n]).then(Q=>{if(Q!==L)return n.then(se=>{const G=[];for(let z=0;z<se.length;z++){const x=se[z];let j,B,q,ce,V;typeof x=="string"?j=x:(j=x.label,B=x.description,q=x.detail,ce=x.picked,V=x.alwaysShow),G.push({label:j,description:B,handle:z,detail:q,picked:ce,alwaysShow:V})}return D&&typeof D.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{D.onDidSelectItem(se[z])}),I.$setItems(m,G),C.then(z=>{if(typeof z=="number")return se[z];if(Array.isArray(z))return z.map(x=>se[x])})})}).then(void 0,Q=>{if(!(0,T.isPromiseCanceledError)(Q))return I.$setError(m,Q),Promise.reject(Q)})}$onItemSelected(v){this._onDidSelectItem&&this._onDidSelectItem(v)}showInput(v,w=F.CancellationToken.None){return this._validateInput=v?v.validateInput:void 0,I.$input(v,typeof this._validateInput=="function",w).then(void 0,D=>{if(!(0,T.isPromiseCanceledError)(D))return Promise.reject(D)})}$validateInput(v){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(v)):Promise.resolve(void 0)}async showWorkspaceFolderPick(v,w=F.CancellationToken.None){const D=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!D)return;const P=await this._workspace.getWorkspaceFolders2();if(!!P)return P.find(n=>n.uri.toString()===D.uri.toString())}createQuickPick(v,w){const D=new u(v,w,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}createInputBox(v){const w=new o(v,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}$onDidChangeValue(v,w){const D=this._sessions.get(v);D&&D._fireDidChangeValue(w)}$onDidAccept(v){const w=this._sessions.get(v);w&&w._fireDidAccept()}$onDidChangeActive(v,w){const D=this._sessions.get(v);D instanceof u&&D._fireDidChangeActive(w)}$onDidChangeSelection(v,w){const D=this._sessions.get(v);D instanceof u&&D._fireDidChangeSelection(w)}$onDidTriggerButton(v,w){const D=this._sessions.get(v);D&&D._fireDidTriggerButton(w)}$onDidTriggerItemButton(v,w,D){const P=this._sessions.get(v);P instanceof u&&P._fireDidTriggerItemButton(w,D)}$onDidHide(v){const w=this._sessions.get(v);w&&w._fireDidHide()}}class c{constructor(v,w){this._extensionId=v,this._onDidDispose=w,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(v){this._title=v,this.update({title:v})}get step(){return this._steps}set step(v){this._steps=v,this.update({step:v})}get totalSteps(){return this._totalSteps}set totalSteps(v){this._totalSteps=v,this.update({totalSteps:v})}get enabled(){return this._enabled}set enabled(v){this._enabled=v,this.update({enabled:v})}get busy(){return this._busy}set busy(v){this._busy=v,this.update({busy:v})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(v){this._ignoreFocusOut=v,this.update({ignoreFocusOut:v})}get value(){return this._value}set value(v){this._value=v,this.update({value:v})}get placeholder(){return this._placeholder}set placeholder(v){this._placeholder=v,this.update({placeholder:v})}get buttons(){return this._buttons}set buttons(v){this._buttons=v.slice(),this._handlesToButtons.clear(),v.forEach((w,D)=>{const P=w===y.QuickInputButtons.Back?-1:D;this._handlesToButtons.set(P,w)}),this.update({buttons:v.map((w,D)=>({...s(w),tooltip:w.tooltip,handle:w===y.QuickInputButtons.Back?-1:D}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(v){this._value=v,this._onDidChangeValueEmitter.fire(v)}_fireDidTriggerButton(v){const w=this._handlesToButtons.get(v);w&&this._onDidTriggerButtonEmitter.fire(w)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(v){if(!this._disposed){for(const w of Object.keys(v)){const D=v[w];this._pendingUpdate[w]=D===void 0?null:D}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}c._nextId=1;function p(f){if(f instanceof y.ThemeIcon)return{id:f.id};const v=i(f),w=S(f);return{dark:typeof v=="string"?k.URI.file(v):v,light:typeof w=="string"?k.URI.file(w):w}}function S(f){return typeof f=="object"&&"light"in f?f.light:f}function i(f){return typeof f=="object"&&"dark"in f?f.dark:f}function s(f){const v=p(f.iconPath);let w,D;return"id"in v?D=r.ThemeIcon.asClassName(v):w=v,{iconPath:w,iconClass:D}}class u extends c{constructor(v,w,D){super(v,D);this.enableProposedApi=w,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(v){this._items=v.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),v.forEach((w,D)=>{this._handlesToItems.set(D,w),this._itemsToHandles.set(w,D)}),this.update({items:v.map((w,D)=>({label:w.label,description:w.description,handle:D,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,buttons:w.buttons&&this.enableProposedApi?w.buttons.map((P,n)=>({...s(P),tooltip:P.tooltip,handle:n})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(v){this._canSelectMany=v,this.update({canSelectMany:v})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(v){this._matchOnDescription=v,this.update({matchOnDescription:v})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(v){this._matchOnDetail=v,this.update({matchOnDetail:v})}get sortByLabel(){return this._sortByLabel}set sortByLabel(v){this._sortByLabel=v,this.update({sortByLabel:v})}get activeItems(){return this._activeItems}set activeItems(v){this._activeItems=v.filter(w=>this._itemsToHandles.has(w)),this.update({activeItems:this._activeItems.map(w=>this._itemsToHandles.get(w))})}get selectedItems(){return this._selectedItems}set selectedItems(v){this._selectedItems=v.filter(w=>this._itemsToHandles.has(w)),this.update({selectedItems:this._selectedItems.map(w=>this._itemsToHandles.get(w))})}_fireDidChangeActive(v){const w=(0,t.coalesce)(v.map(D=>this._handlesToItems.get(D)));this._activeItems=w,this._onDidChangeActiveEmitter.fire(w)}_fireDidChangeSelection(v){const w=(0,t.coalesce)(v.map(D=>this._handlesToItems.get(D)));this._selectedItems=w,this._onDidChangeSelectionEmitter.fire(w)}_fireDidTriggerItemButton(v,w){const D=this._handlesToItems.get(v);if(!D||!D.buttons||!D.buttons.length)return;const P=D.buttons[w];P&&this._onDidTriggerItemButtonEmitter.fire({button:P,item:D})}}class o extends c{constructor(v,w){super(v,w);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(v){this._password=v,this.update({password:v})}get prompt(){return this._prompt}set prompt(v){this._prompt=v,this.update({prompt:v})}get validationMessage(){return this._validationMessage}set validationMessage(v){this._validationMessage=v,this.update({validationMessage:v,severity:v?_.default.Error:_.default.Ignore})}}return new b(l,g)}e.createExtHostQuickOpen=h}),define(we[202],be([0,1,2,3,51,7,13,5,16,107,14,26,30,43,8]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(v){if(v)return typeof v.iconPath=="string"?d.URI.file(v.iconPath):d.URI.isUri(v.iconPath)||h.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function g(v,w){if(!v.iconPath&&!w.iconPath)return 0;if(v.iconPath){if(!w.iconPath)return 1}else return-1;const D=typeof v.iconPath=="string"?v.iconPath:d.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,P=typeof w.iconPath=="string"?w.iconPath:d.URI.isUri(w.iconPath)?w.iconPath.fsPath:w.iconPath.id;return(0,T.comparePaths)(D,P)}function I(v,w){let D=0;if(v.strikeThrough!==w.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==w.faded)return v.faded?1:-1;if(v.tooltip!==w.tooltip)return(v.tooltip||"").localeCompare(w.tooltip||"");if(D=g(v,w),D!==0)return D;if(v.light&&w.light)D=g(v.light,w.light);else{if(v.light)return 1;if(w.light)return-1}if(D!==0)return D;if(v.dark&&w.dark)D=g(v.dark,w.dark);else{if(v.dark)return 1;if(w.dark)return-1}return D}function b(v,w){if(v.command!==w.command)return v.command<w.command?-1:1;if(v.title!==w.title)return v.title<w.title?-1:1;if(v.tooltip!==w.tooltip){if(v.tooltip!==void 0&&w.tooltip!==void 0)return v.tooltip<w.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(w.tooltip!==void 0)return-1}if(v.arguments===w.arguments)return 0;if(v.arguments)if(w.arguments){if(v.arguments.length!==w.arguments.length)return v.arguments.length-w.arguments.length}else return 1;else return-1;for(let D=0;D<v.arguments.length;D++){const P=v.arguments[D],n=w.arguments[D];if(P!==n)return P<n?-1:1}return 0}function c(v,w){let D=(0,T.comparePaths)(v.resourceUri.fsPath,w.resourceUri.fsPath,!0);if(D!==0)return D;if(v.command&&w.command)D=b(v.command,w.command);else{if(v.command)return 1;if(w.command)return-1}if(D!==0)return D;if(v.decorations&&w.decorations)D=I(v.decorations,w.decorations);else{if(v.decorations)return 1;if(w.decorations)return-1}return D}function p(v,w){for(let D=0;D<v.length;D++)if(v[D]!==w[D])return!1;return!0}function S(v,w){return v.command===w.command&&v.title===w.title&&v.tooltip===w.tooltip&&(v.arguments&&w.arguments?p(v.arguments,w.arguments):v.arguments===w.arguments)}function i(v,w){return(0,y.equals)(v,w,S)}class s{constructor(w,D,P){this._extension=w,this._proxy=D,this._sourceControlHandle=P,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(w){this._proxy.$setInputBoxValue(this._sourceControlHandle,w),this.updateValue(w)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(w){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,w),this._placeholder=w}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(w){if((0,r.checkProposedApiEnabled)(this._extension),w&&typeof w!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=w,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!w)}get visible(){return this._visible}set visible(w){w=!!w,this._visible!==w&&(this._visible=w,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,w))}focus(){(0,r.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(w,D){(0,r.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,w,D)}$onInputBoxValueChange(w){this.updateValue(w)}updateValue(w){this._value=w,this._onDidChange.fire(w)}}e.ExtHostSCMInputBox=s;class u{constructor(w,D,P,n,m){this._proxy=w,this._commands=D,this._sourceControlHandle=P,this._id=n,this._label=m,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=u._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(w){this._label=w,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,w)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(w){this._hideWhenEmpty=w,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(w){this._resourceStates=[...w],this._onDidUpdateResourceStates.fire()}getResourceState(w){return this._resourceStatesMap.get(w)}$executeResourceCommand(w,D){const P=this._resourceStatesCommandsMap.get(w);return P?(0,R.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const w=[...this._resourceStates].sort(c),P=(0,y.sortedDiff)(this._resourceSnapshot,w,c).map(C=>{const L=C.toInsert.map($=>{const Q=this._resourceHandlePool++;this._resourceStatesMap.set(Q,$);const se=$.resourceUri;let G;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ve=new A.DisposableStore;G=this._commands.converter.toInternal($.command,ve),this._resourceStatesDisposablesMap.set(Q,ve)}else this._resourceStatesCommandsMap.set(Q,$.command);const z=l($.decorations),x=$.decorations&&l($.decorations.light)||z,j=$.decorations&&l($.decorations.dark)||z,B=[x,j],q=$.decorations&&$.decorations.tooltip||"",ce=$.decorations&&!!$.decorations.strikeThrough,V=$.decorations&&!!$.decorations.faded,le=$.contextValue||"";return{rawResource:[Q,se,B,q,ce,V,le,G],handle:Q}});return{start:C.start,deleteCount:C.deleteCount,toInsert:L}}),n=P.map(({start:C,deleteCount:L,toInsert:$})=>[C,L,$.map(Q=>Q.rawResource)]),m=P.reverse();for(const{start:C,deleteCount:L,toInsert:$}of m){const Q=$.map(G=>G.handle),se=this._handlesSnapshot.splice(C,L,...Q);for(const G of se)this._resourceStatesMap.delete(G),this._resourceStatesCommandsMap.delete(G),this._resourceStatesDisposablesMap.get(G)?.dispose(),this._resourceStatesDisposablesMap.delete(G)}return this._resourceSnapshot=w,n}dispose(){this._disposed=!0,this._onDidDispose.fire()}}u._handlePool=0;class o{constructor(w,D,P,n,m,C){this._proxy=D,this._commands=P,this._id=n,this._label=m,this._rootUri=C,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(w,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,n,m,C)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(w){this._count!==w&&(this._count=w,this._proxy.$updateSourceControl(this.handle,{count:w}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(w){this._quickDiffProvider=w,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!w})}get commitTemplate(){return this._commitTemplate}set commitTemplate(w){w!==this._commitTemplate&&(this._commitTemplate=w,this._proxy.$updateSourceControl(this.handle,{commitTemplate:w}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(w){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=w;const D=this._commands.converter.toInternal(w,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:D})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(w){if(this._statusBarCommands&&w&&i(this._statusBarCommands,w))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=w;const D=(w||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:D})}get selected(){return this._selected}createResourceGroup(w,D){const P=new u(this._proxy,this._commands,this.handle,w,D),n=F.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,n),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const w=[],D=[];for(const[P,n]of this.createdResourceGroups){n.dispose();const m=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});F.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),m.dispose(),this._groups.delete(P.handle),this._proxy.$unregisterGroup(this.handle,P.handle)}),w.push([P.handle,P.id,P.label,P.features]);const C=P._takeResourceStateSnapshot();C.length>0&&D.push([P.handle,C]),this._groups.set(P.handle,P)}this._proxy.$registerGroups(this.handle,w,D),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const w=[];this.updatedResourceGroups.forEach(D=>{const P=D._takeResourceStateSnapshot();P.length!==0&&w.push([D.handle,P])}),w.length>0&&this._proxy.$spliceResourceStates(this.handle,w),this.updatedResourceGroups.clear()}getResourceGroup(w){return this._groups.get(w)}setSelectionState(w){this._selected=w,this._onDidChangeSelection.fire(w)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(w=>w.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}o._handlePool=0,Be([(0,E.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Be([(0,E.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let f=class Ui{constructor(w,D,P){this._commands=D,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=w.getProxy(k.MainContext.MainThreadSCM),this._telemetry=w.getProxy(k.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===3){const m=this._sourceControls.get(n.sourceControlHandle);if(!m)return n;const C=m.getResourceGroup(n.groupHandle);return C?C.getResourceState(n.handle):n}else if(n&&n.$mid===4){const m=this._sourceControls.get(n.sourceControlHandle);return m?m.getResourceGroup(n.groupHandle):n}else if(n&&n.$mid===5){const m=this._sourceControls.get(n.handle);return m||n}return n}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(w,D,P,n){this.logService.trace("ExtHostSCM#createSourceControl",w.identifier.value,D,P,n),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:w.identifier.value});const m=Ui._handlePool++,C=new o(w,this._proxy,this._commands,D,P,n);this._sourceControls.set(m,C);const L=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(w.identifier))||[];return L.push(C),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(w.identifier),L),C}getLastInputBox(w){this.logService.trace("ExtHostSCM#getLastInputBox",w.identifier.value);const D=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(w.identifier)),P=D&&D[D.length-1];return P&&P.inputBox}$provideOriginalResource(w,D,P){const n=d.URI.revive(D);this.logService.trace("ExtHostSCM#$provideOriginalResource",w,n.toString());const m=this._sourceControls.get(w);return!m||!m.quickDiffProvider||!m.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>m.quickDiffProvider.provideOriginalResource(n,P)).then(C=>C||null)}$onInputBoxValueChange(w,D){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",w);const P=this._sourceControls.get(w);return P&&P.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(w,D,P,n){this.logService.trace("ExtHostSCM#$executeResourceCommand",w,D,P);const m=this._sourceControls.get(w);if(!m)return Promise.resolve(void 0);const C=m.getResourceGroup(D);return C?C.$executeResourceCommand(P,n):Promise.resolve(void 0)}$validateInput(w,D,P){this.logService.trace("ExtHostSCM#$validateInput",w);const n=this._sourceControls.get(w);return!n||!n.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>n.inputBox.validateInput(D,P)).then(m=>{if(!m)return Promise.resolve(void 0);const C=a.MarkdownString.fromStrict(m.message);return C?Promise.resolve([C,m.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(w){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",w),w!==void 0&&this._sourceControls.get(w)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=w,Promise.resolve(void 0)}};f._handlePool=0,f=Be([ze(2,t.ILogService)],f),e.ExtHostSCM=f});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[203],be([0,1,6,5,124,7,8]),function(ie,e,d,F,E,A,R){"use strict";var k,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(h,a,l,g,I=d.StatusBarAlignment.Left,b){k.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,k,h,"f"),et(this,y,a,"f"),this._entryId=T.ID_GEN++,this._extension=l,this._id=g,this._alignment=I,this._priority=b}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!T.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Me(this,y,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Me(this,y,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,k,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let a;this._name?a=this._name:a=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const g=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Me(this,k,"f").$setEntry(this._entryId,h,a,this._text,g,this._command?.internal,l,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,k=new WeakMap,y=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const a={message:h};return this._messages.unshift(a),this._update(),new d.Disposable(()=>{const l=this._messages.indexOf(a);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(h,a){this._proxy=h.getProxy(F.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new t(this)}createStatusBarEntry(h,a,l,g){return new T(this._proxy,this._commands,h,a,l,g)}setStatusBarMessage(h,a){const l=this._statusMessage.setMessage(h);let g;return typeof a=="number"?g=setTimeout(()=>l.dispose(),a):typeof a!="undefined"&&a.then(()=>l.dispose(),()=>l.dispose()),new d.Disposable(()=>{l.dispose(),clearTimeout(g)})}}e.ExtHostStatusBar=_}),define(we[73],be([0,1,5,3,4]),function(ie,e,d,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,y){this._proxy.$registerExtensionStorageKeysToSync(k,y)}getValue(k,y,T){return this._proxy.$getValue(k,y).then(t=>t||T)}setValue(k,y,T){return this._proxy.$setValue(k,y,T)}$acceptValue(k,y,T){this._onDidChangeStorage.fire({shared:k,key:y,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(we[74],be([0,1,4,29,14,72,2]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let k=class{constructor(T,t,_){this._logService=t,this._extHostFileSystem=_,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(r=>this._value=r)}async _getWorkspaceStorageURI(T){return R.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,t=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(T){if(this._value)return R.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return R.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Be([ze(0,F.IExtHostInitDataService),ze(1,E.ILogService),ze(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(we[37],be([0,1,3,5,4,2,12,7,6,125,15,166,21,36,149,43,10]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class I{constructor(f,v,w,D){this._proxy=f,this._id=v,this._creationOptions=w,this._name=D,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(n=>this._pidPromiseComplete=n);const P=this;this.value={get name(){return P._name||""},get processId(){return P._pidPromise},get creationOptions(){return P._creationOptions},get exitStatus(){return P._exitStatus},get state(){return P._state},sendText(n,m=!0){P._checkDisposed(),P._proxy.$sendText(P._id,n,m)},show(n){P._checkDisposed(),P._proxy.$show(P._id,n)},hide(){P._checkDisposed(),P._proxy.$hide(P._id)},dispose(){P._disposed||(P._disposed=!0,P._proxy.$dispose(P._id))},get dimensions(){if(!(P._cols===void 0||P._rows===void 0))return{columns:P._cols,rows:P._rows}}}}async create(f,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,g.withNullAsUndefined)(f.shellPath),shellArgs:(0,g.withNullAsUndefined)(f.shellArgs),cwd:(0,g.withNullAsUndefined)(f.cwd),env:(0,g.withNullAsUndefined)(f.env),icon:(0,g.withNullAsUndefined)(s(f.iconPath)),color:l.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,g.withNullAsUndefined)(f.message),strictEnv:(0,g.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(v?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(v?.useShellEnvironment),location:this._serializeParentTerminal(f.location,v?.resolvedExtHostIdentifier,v?.splitActiveTerminal)})}async createExtensionTerminal(f,v,w,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:l.ThemeColor.isThemeColor(D)?D.id:void 0,location:this._serializeParentTerminal(f,v)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,v,w){return typeof f=="object"&&"parentTerminal"in f?v?{parentTerminal:v}:void 0:w?{splitActiveTerminal:!0}:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,v){return f===this._cols&&v===this._rows||f===0||v===0?!1:(this._cols=f,this._rows=v,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(v=>{v!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=I;class b{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput&&this._pty.handleInput(f)}resize(f,v){this._pty.setDimensions&&this._pty.setDimensions({columns:f,rows:v})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(v=>this._onProcessData.fire(v)),this._pty.onDidClose&&this._pty.onDidClose((v=void 0)=>{this._onProcessExit.fire(v===void 0?void 0:v)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(v=>this._onProcessOverrideDimensions.fire(v&&{cols:v.columns,rows:v.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(v=>this._onProcessTitleChanged.fire(v)),this._pty.open(f||void 0),this._pty.setDimensions&&f&&this._pty.setDimensions(f),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let c=1,p=class extends k.Disposable{constructor(f,v){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=v.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[w,D]of this._terminalProcesses)D.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,v){const w=new I(this._proxy,(0,h.generateUuid)(),f,f.name),D=new b(f.pty);return w.createExtensionTerminal(this._resolveLocation(f.location),v?.resolvedExtHostIdentifier,s(f.iconPath),u(f.color)).then(P=>{const n=this._setupExtHostProcessListeners(P,D);this._terminalProcessDisposables[P]=n}),this._terminals.push(w),w.value}_resolveLocation(f){if(!(typeof f=="object"&&"parentTerminal"in f))return f}attachPtyToTerminal(f,v){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const D=new b(v),P=this._setupExtHostProcessListeners(f,D);this._terminalProcessDisposables[f]=P}async $acceptActiveTerminalChanged(f){const v=this._activeTerminal;if(f===null){this._activeTerminal=void 0,v!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(f);w&&(this._activeTerminal=w,v!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,v){const w=this._getTerminalById(f);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:v})}async $acceptTerminalDimensions(f,v,w){const D=this._getTerminalById(f);D&&D.setDimensions(v,w)&&this._onDidChangeTerminalDimensions.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptTerminalMaximumDimensions(f,v,w){this._terminalProcesses.get(f)?.resize(v,w)}async $acceptTerminalTitleChange(f,v){const w=this._getTerminalById(f);w&&(w.name=v)}async $acceptTerminalClosed(f,v){const w=this._getTerminalObjectIndexById(this._terminals,f);if(w!==null){const D=this._terminals.splice(w,1)[0];D.setExitCode(v),this._onDidCloseTerminal.fire(D.value)}}$acceptTerminalOpened(f,v,w,D){if(v){const m=this._getTerminalObjectIndexById(this._terminals,v);if(m!==null){this._terminals[m]._id=f,this._onDidOpenTerminal.fire(this.terminals[m]),this._terminals[m].isOpen=!0;return}}const P={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:A.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},n=new I(this._proxy,f,P,w);this._terminals.push(n),this._onDidOpenTerminal.fire(n.value),n.isOpen=!0}async $acceptTerminalProcessId(f,v){const w=this._getTerminalById(f);w&&w._setProcessId(v)}async $startExtensionTerminal(f,v){const w=this._getTerminalById(f);if(!w)return{message:(0,T.localize)(0,null,f)};w.isOpen||await new Promise(P=>{const n=this.onDidOpenTerminal(async m=>{m===w.value&&(n.dispose(),P())})});const D=this._terminalProcesses.get(f);D?D.startSendingEvents(v):this._extensionTerminalAwaitingStart[f]={initialDimensions:v}}_setupExtHostProcessListeners(f,v){const w=new k.DisposableStore;w.add(v.onProcessReady(P=>this._proxy.$sendProcessReady(f,P.pid,P.cwd))),w.add(v.onProcessTitleChanged(P=>this._proxy.$sendProcessTitle(f,P))),this._bufferer.startBuffering(f,v.onProcessData),w.add(v.onProcessExit(P=>this._onProcessExit(f,P))),v.onProcessOverrideDimensions&&w.add(v.onProcessOverrideDimensions(P=>this._proxy.$sendOverrideDimensions(f,P))),this._terminalProcesses.set(f,v);const D=this._extensionTerminalAwaitingStart[f];return D&&v instanceof b&&(v.startSendingEvents(D.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),w}$acceptProcessAckDataEvent(f,v){this._terminalProcesses.get(f)?.acknowledgeDataEvent(v)}$acceptProcessInput(f,v){this._terminalProcesses.get(f)?.input(v)}$acceptTerminalInteraction(f){const v=this._getTerminalById(f);v?.setInteractedWith()&&this._onDidChangeTerminalState.fire(v.value)}$acceptProcessResize(f,v,w){try{this._terminalProcesses.get(f)?.resize(v,w)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(f,v){this._terminalProcesses.get(f)?.shutdown(v)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(v=>this._proxy.$sendProcessInitialCwd(f,v))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(v=>this._proxy.$sendProcessCwd(f,v))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,v,w){if(this._profileProviders.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this._profileProviders.set(v,w),this._proxy.$registerProfileProvider(v,f.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(v),this._proxy.$unregisterProfileProvider(v)})}async $createContributedProfileTerminal(f,v){const w=new r.CancellationTokenSource().token,D=await this._profileProviders.get(f)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,v);return}this.createTerminalFromOptions(D.options,v)}}async $provideLinks(f,v){const w=this._getTerminalById(f);if(!w)return[];this._terminalLinkCache.delete(f);const D=this._terminalLinkCancellationSource.get(f);D&&D.dispose(!0);const P=new r.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,P);const n=[],m={terminal:w.value,line:v},C=[];for(const Q of this._linkProviders)C.push(new Promise(async se=>{P.token.onCancellationRequested(()=>se({provider:Q,links:[]}));const G=await Q.provideTerminalLinks(m,P.token)||[];P.token.isCancellationRequested||se({provider:Q,links:G})}));const L=await Promise.all(C);if(P.token.isCancellationRequested)return[];const $=new Map;for(const Q of L)Q&&Q.links.length>0&&n.push(...Q.links.map(se=>{const G={id:c++,startIndex:se.startIndex,length:se.length,label:se.tooltip};return $.set(G.id,{provider:Q.provider,link:se}),G}));return this._terminalLinkCache.set(f,$),n}$activateLink(f,v){const w=this._terminalLinkCache.get(f)?.get(v);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(f,v){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const w=this._terminalProcessDisposables[f];w&&(w.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,v)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,v){const w=this._getTerminalObjectIndexById(f,v);return w!==null?f[w]:null}_getTerminalObjectIndexById(f,v){let w=null;return f.some((D,P)=>D._id===v?(w=P,!0):!1),w}getEnvironmentVariableCollection(f){let v=this._environmentVariableCollections.get(f.identifier.value);return v||(v=new S,this._setEnvironmentVariableCollection(f.identifier.value,v)),v}_syncEnvironmentVariableCollection(f,v){const w=(0,_.serializeEnvironmentVariableCollection)(v.map);this._proxy.$setEnvironmentVariableCollection(f,v.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(f){f.forEach(v=>{const w=v[0],D=new S(v[1]);this._setEnvironmentVariableCollection(w,D)})}$acceptDefaultProfile(f,v){this._defaultProfile=f,this._defaultAutomationProfile=v}_setEnvironmentVariableCollection(f,v){this._environmentVariableCollections.set(f,v),v.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,v)})}};p=Be([ze(1,R.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class S{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,v){this._setIfDiffers(f,{value:v,type:y.EnvironmentVariableMutatorType.Replace})}append(f,v){this._setIfDiffers(f,{value:v,type:y.EnvironmentVariableMutatorType.Append})}prepend(f,v){this._setIfDiffers(f,{value:v,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,v){const w=this.map.get(f);(!w||w.value!==v.value||w.type!==v.type)&&(this.map.set(f,v),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,v){this.map.forEach((w,D)=>f.call(v,D,w,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=S;let i=class extends p{constructor(f){super(!1,f)}createTerminal(f,v,w){throw new t.NotSupportedError}createTerminalFromOptions(f,v){throw new t.NotSupportedError}};i=Be([ze(0,R.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function s(o){if(!(!o||typeof o=="string"))return"id"in o?{id:o.id,color:o.color}:o}function u(o){return l.ThemeColor.isThemeColor(o)?o:void 0}});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[204],be([0,1,23,21,3,234,57,189,7,22,10,36,5,12,65,8,6,174,91,69]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let S=class{constructor(C,L){this.resultsChangedEmitter=new E.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=C.getProxy(r.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new s(this.proxy),L.registerArgumentProcessor({processArgument:$=>$?.$mid===13?l.TestItem.toItemFromContext($):$})}createTestController(C,L){if(this.controllers.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const $=new y.DisposableStore,Q=$.add(new I.SingleUseTestCollection(C));Q.root.label=L;const se=new Map,G=this.proxy,z={items:Q.root.children,get label(){return L},set label(j){L=j,Q.root.label=j,G.$updateControllerLabel(C,L)},get id(){return C},createRunProfile:(j,B,q,ce,V)=>{let le=(0,R.hash)(j);for(;se.has(le);)le++;const ae=new P(this.proxy,C,le,j,B,q,ce,V);return se.set(le,ae),ae},createTestItem(j,B,q){return new a.TestItemImpl(C,j,B,q)},createTestRun:(j,B,q=!0)=>this.runTracker.createTestRun(C,Q,j,B,q),set resolveHandler(j){Q.resolveHandler=j},get resolveHandler(){return Q.resolveHandler},dispose:()=>{$.dispose()}};z.createRunConfiguration=z.createRunProfile,G.$registerTestController(C,L),$.add((0,y.toDisposable)(()=>G.$unregisterTestController(C)));const x={controller:z,collection:Q,profiles:se};return this.controllers.set(C,x),$.add((0,y.toDisposable)(()=>this.controllers.delete(C))),$.add(Q.onDidGenerateDiff(j=>G.$publishDiff(C,j))),z}createTestObserver(){return this.observer.checkout()}async runTests(C,L=F.CancellationToken.None){const $=u(C);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const Q=this.controllers.get($.controllerId);if(!Q)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:C.include?.map(se=>se.id)??[Q.collection.root.id],profileGroup:n[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:C.exclude?.map(se=>se.id)},L)}$provideFileCoverage(C,L,$){return k.Iterable.find(this.runTracker.trackers,Q=>Q.id===C)?.getCoverage(L)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(C,L,$,Q){return k.Iterable.find(this.runTracker.trackers,se=>se.id===C)?.getCoverage(L)?.resolveFileCoverage($,Q)??Promise.resolve([])}$configureRunProfile(C,L){this.controllers.get(C)?.profiles.get(L)?.configureHandler?.()}$publishTestResults(C){this.results=Object.freeze(C.map(L=>(0,T.deepFreeze)(l.TestResults.to(L))).concat(this.results).sort((L,$)=>$.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(C,L){const $=this.controllers.get(c.TestId.fromString(C).controllerId)?.collection;$&&(await $.expand(C,L<0?Infinity:L),$.flushDiff())}$acceptDiff(C){this.observer.applyDiff(C)}async $runControllerTests(C,L){const $=this.controllers.get(C.controllerId);if(!$)return;const{collection:Q,profiles:se}=$,G=se.get(C.profileId);if(!G)return;const z=C.testIds.map(q=>Q.tree.get(q)).filter(t.isDefined),x=C.excludeExtIds.map(q=>$.collection.tree.get(q)).filter(t.isDefined).filter(q=>z.some(ce=>ce.fullId.compare(q.fullId)===2));if(!z.length)return;const j=new g.TestRunRequest(z.some(q=>q.actual instanceof a.TestItemRootImpl)?void 0:z.map(q=>q.actual),x.map(q=>q.actual),G),B=this.runTracker.prepareForMainThreadTestRun(j,o.fromInternal(C,$.collection),L);try{await G.runHandler(j,L)}finally{B.isRunning&&!L.isCancellationRequested&&await E.Event.toPromise(B.onEnd),this.runTracker.cancelRunById(C.runId)}}$cancelExtensionTestRun(C){C===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(C)}};S=Be([ze(0,h.IExtHostRpcService)],S),e.ExtHostTesting=S;class i extends y.Disposable{constructor(C,L,$){super();this.dto=C,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new E.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource($)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:Q}of this.tasks.values())Q.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(C){return this.tasks.get(C)?.coverage}createRun(C){const L=this.dto.id,$=this.dto.controllerId,Q=(0,_.generateUuid)(),se=new f(this.proxy,L,Q),G=j=>(B,...q)=>{if(z){console.warn(`Setting the state of test "${B.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(B)||(this.ensureTestIsKnown(B),j(B,...q))};let z=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:C,get coverageProvider(){return se.coverageProvider},set coverageProvider(j){se.coverageProvider=j},enqueued:G(j=>{this.proxy.$updateTestStateInRun(L,Q,c.TestId.fromExtHostTestItem(j,$).toString(),1)}),skipped:G(j=>{this.proxy.$updateTestStateInRun(L,Q,c.TestId.fromExtHostTestItem(j,$).toString(),5)}),started:G(j=>{this.proxy.$updateTestStateInRun(L,Q,c.TestId.fromExtHostTestItem(j,$).toString(),2)}),errored:G((j,B,q)=>{this.proxy.$appendTestMessagesInRun(L,Q,c.TestId.fromExtHostTestItem(j,$).toString(),B instanceof Array?B.map(l.TestMessage.from):[l.TestMessage.from(B)]),this.proxy.$updateTestStateInRun(L,Q,c.TestId.fromExtHostTestItem(j,$).toString(),6,q)}),failed:G((j,B,q)=>{this.proxy.$appendTestMessagesInRun(L,Q,c.TestId.fromExtHostTestItem(j,$).toString(),B instanceof Array?B.map(l.TestMessage.from):[l.TestMessage.from(B)]),this.proxy.$updateTestStateInRun(L,Q,c.TestId.fromExtHostTestItem(j,$).toString(),4,q)}),passed:G((j,B)=>{this.proxy.$updateTestStateInRun(L,Q,c.TestId.fromExtHostTestItem(j,this.dto.controllerId).toString(),3,B)}),appendOutput:(j,B,q)=>{z||(q&&(this.dto.isIncluded(q)?this.ensureTestIsKnown(q):q=void 0),this.proxy.$appendOutputToRun(L,Q,d.VSBuffer.fromString(j),B&&l.location.from(B),q&&c.TestId.fromExtHostTestItem(q,$).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(L,Q),this.tasks.delete(Q),this.isRunning||this.dispose())}};return this.tasks.set(Q,{run:x,coverage:se}),this.proxy.$startedTestRunTask(L,{id:Q,name:C,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(C){if(!(C instanceof a.TestItemImpl))throw new a.InvalidTestItemError(C.id);if(this.sharedTestIds.has(C.id))return;const L=[];for(;L.unshift(l.TestItem.from(C)),!(this.sharedTestIds.has(C.id)||(this.sharedTestIds.add(C.id),!C.parent));)C=C.parent;const $=this.dto.colllection.root;this.sharedTestIds.has($.id)||(this.sharedTestIds.add($.id),L.unshift(l.TestItem.from($))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class s{constructor(C){this.proxy=C,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(C,L,$){return this.getTracker(C,L,$)}cancelRunById(C){for(const L of this.tracked.values())if(L.id===C){L.dispose();return}}cancelAllRuns(){for(const C of this.tracked.values())C.dispose()}createTestRun(C,L,$,Q,se){const G=this.tracked.get($);if(G)return G.createRun(Q);const z=o.fromPublic(C,L,$,se),x=u($);this.proxy.$startedExtensionTestRun({controllerId:C,profile:x&&{group:n[x.kind],id:x.profileId},exclude:$.exclude?.map(B=>B.id)??[],id:z.id,include:$.include?.map(B=>B.id)??[L.root.id],persist:se});const j=this.getTracker($,z);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),j.createRun(Q)}getTracker(C,L,$){const Q=new i(L,this.proxy,$);return this.tracked.set(C,Q),Q.onEnd(()=>this.tracked.delete(C)),Q}}e.TestRunCoordinator=s;const u=m=>{if(!!m.profile){if(!(m.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return m.profile}};class o{constructor(C,L,$,Q,se,G){this.controllerId=C,this.id=L,this.isPersisted=se,this.colllection=G,this.includePrefix=$.map(z=>z+"\0"),this.excludePrefix=Q.map(z=>z+"\0")}static fromPublic(C,L,$,Q){return new o(C,(0,_.generateUuid)(),$.include?.map(se=>c.TestId.fromExtHostTestItem(se,C).toString())??[C],$.exclude?.map(se=>c.TestId.fromExtHostTestItem(se,C).toString())??[],Q,L)}static fromInternal(C,L){return new o(C.controllerId,C.runId,C.testIds,C.excludeExtIds,!0,L)}isIncluded(C){const L=c.TestId.fromExtHostTestItem(C,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(L===$||L.startsWith($))return!1;for(const $ of this.includePrefix)if(L===$||L.startsWith($))return!0;return!1}}e.TestRunDto=o;class f{constructor(C,L,$){this.proxy=C,this.runId=L,this.taskId=$}set coverageProvider(C){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!C||(this._coverageProvider=C,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(C){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(C))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(C,L){const $=await this.fileCoverage;let Q=$?.[C];return!this._coverageProvider||!$||!Q?[]:(Q.detailedCoverage||(Q=$[C]=await this._coverageProvider.resolveFileCoverage?.(Q,L)??Q),Q.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class v extends b.IncrementalChangeCollector{constructor(C){super();this.emitter=C,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(C){this.added.add(C)}update(C){Object.assign(C.revived,l.TestItem.toPlain(C.item)),this.added.has(C)||this.updated.add(C)}remove(C){if(this.added.has(C)){this.added.delete(C);return}if(this.updated.delete(C),C.parent&&this.alreadyRemoved.has(C.parent)){this.alreadyRemoved.add(C.item.extId);return}this.removed.add(C)}getChangeEvent(){const{added:C,updated:L,removed:$}=this;return{get added(){return[...C].map(Q=>Q.revived)},get updated(){return[...L].map(Q=>Q.revived)},get removed(){return[...$].map(Q=>Q.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class w extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new E.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(C){return this.items.get(C)}getMirroredTestDataByReference(C){return this.items.get(C.id)}createItem(C,L){return{...C,revived:l.TestItem.toPlain(C.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new v(this.changeEmitter)}}e.MirroredTestCollection=w;class D{constructor(C){this.proxy=C}checkout(){this.current||(this.current=this.createObserverData());const C=this.current;return C.observers++,{onDidChangeTest:C.tests.onDidChangeTests,get tests(){return[...C.tests.rootTests].map(L=>L.revived)},dispose:(0,A.once)(()=>{--C.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(C){return this.current?.tests.getMirroredTestDataByReference(C)}applyDiff(C){this.current?.tests.apply(C)}createObserverData(){const C=new w;return this.proxy.$subscribeToDiffs(),{observers:0,tests:C}}}class P{constructor(C,L,$,Q,se,G,z=!1,x=void 0){this.controllerId=L,this.profileId=$,this._label=Q,this.kind=se,this.runHandler=G,this._isDefault=z,this._tag=x,p.set(this,void 0),et(this,p,C,"f");const j=n[se];if(typeof j!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);Me(this,p,"f").$publishTestRunProfile({profileId:$,controllerId:L,tag:x?l.TestTag.namespace(this.controllerId,x.id):null,label:Q,group:j,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(C){C!==this._label&&(this._label=C,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:C}))}get isDefault(){return this._isDefault}set isDefault(C){C!==this._isDefault&&(this._isDefault=C,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:C}))}get tag(){return this._tag}set tag(C){C?.id!==this._tag?.id&&(this._tag=C,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:C?l.TestTag.namespace(this.controllerId,C.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(C){C!==this._configureHandler&&(this._configureHandler=C,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!C}))}dispose(){Me(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=P,p=new WeakMap;const n={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(we[205],be([0,1,3,16,5,94,8,6]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(t,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(r=>this._onDidChangeVisibleTextEditors.fire(r)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(r=>this._onDidChangeActiveTextEditor.fire(r))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const _=this._extHostDocumentsAndEditors.allEditors();return t?_:_.map(r=>r.value)}async showTextDocument(t,_,r){let h;typeof _=="number"?h={position:R.ViewColumn.from(_),preserveFocus:r}:typeof _=="object"?h={position:R.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?R.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:h={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(t.uri,h),l=a&&this._extHostDocumentsAndEditors.getEditor(a);if(l)return l.value;throw a?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,_){return new A.TextEditorDecorationType(this._proxy,t,_).value}$acceptEditorPropertiesChanged(t,_){const r=this._extHostDocumentsAndEditors.getEditor(t);if(!r)throw new Error("unknown text editor");if(_.options&&r._acceptOptions(_.options),_.selections){const h=_.selections.selections.map(R.Selection.to);r._acceptSelections(h)}if(_.visibleRanges){const h=F.coalesce(_.visibleRanges.map(R.Range.to));r._acceptVisibleRanges(h)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:r.value,options:{..._.options,lineNumbers:R.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const h=k.TextEditorSelectionChangeKind.fromValue(_.selections.source),a=_.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:r.value,selections:a,kind:h})}if(_.visibleRanges){const h=F.coalesce(_.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:r.value,visibleRanges:h})}}$acceptEditorPositionData(t){for(const _ in t){const r=this._extHostDocumentsAndEditors.getEditor(_);if(!r)throw new Error("Unknown text editor");const h=R.ViewColumn.to(t[_]);r.value.viewColumn!==h&&(r._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:r.value,viewColumn:h}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=y}),define(we[206],be([0,1,2,4,5,7,6]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class k{constructor(t,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===11){const h=r.uri===void 0?void 0:d.URI.revive(r.uri);return this._itemsBySourceAndUriMap.get(r.source)?.get(y(h))?.get(r.handle)}return r}})}async $getTimeline(t,_,r,h,a){return this._providers.get(t)?.provideTimeline(d.URI.revive(_),r,h,a)}registerTimelineProvider(t,_,r,h){const a=new A.DisposableStore,l=this.convertTimelineItem(_.id,h,a).bind(this);let g;_.onDidChange&&(g=_.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:_.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:t,onDidChange:void 0,async provideTimeline(b,c,p,S){S?.resetCache&&(a.clear(),I.get(_.id)?.clear());const i=await _.provideTimeline(b,c,p);if(i==null)return;const s=l(b,S);return{...i,source:_.id,items:i.items.map(s)}},dispose(){for(const b of I.values())b.get(_.id)?.clear();g?.dispose(),a.dispose()}})}convertTimelineItem(t,_,r){return(h,a)=>{let l;if(a?.cacheResults){let g=this._itemsBySourceAndUriMap.get(t);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(t,g));const I=y(h);l=g.get(I),l===void 0&&(l=new Map,g.set(I,l))}return g=>{const{iconPath:I,...b}=g,c=`${t}|${g.id??g.timestamp}`;l?.set(c,g);let p,S,i;return g.iconPath&&(I instanceof R.ThemeIcon?i={id:I.id,color:I.color}:d.URI.isUri(I)?(p=I,S=I):{light:p,dark:S}=I),{...b,id:b.id??void 0,handle:c,source:t,command:g.command?_.toInternal(g.command,r):void 0,icon:p,iconDark:S,themeIcon:i,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const r of this._itemsBySourceAndUriMap.values())r.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=k;function y(T){return T?.toString()}}),define(we[207],be([0,1,7,11,2,5]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,t,_){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const r=_.schemes.find(h=>!R.supportedSchemes.has(h));if(r)throw new Error(`Scheme '${r}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,t),this._proxy.$registerUriOpener(T,_.schemes,y,_.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(y,T,t){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener with id: ${y}`);const r=E.URI.revive(T);return _.canOpenExternalUri(r,t)}async $openUri(y,T,t){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener id: '${y}'`);return _.openExternalUri(E.URI.revive(T.resolvedUri),{sourceUri:E.URI.revive(T.sourceUri)},t)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(we[208],be([0,1,5,2,7,15,26]),function(ie,e,d,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,t){if(this.handles.has(R.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const _=k.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(T)),this.handlers.set(_,t),this._proxy.$registerUriHandler(_,T),(0,E.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(T)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(T,t){const _=this.handlers.get(T);if(!_)return Promise.resolve(void 0);try{_.handleUri(F.URI.revive(t))}catch(r){(0,A.onUnexpectedError)(r)}return Promise.resolve(void 0)}async createAppUri(T){return F.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=k,k.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[49],be([0,1,3,2,135,157,68,5]),function(ie,e,d,F,E,A,R,k){"use strict";var y,T,t,_,r,h,a,l,g,I,b,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(w,D,P,n,m,C,L){y.set(this,void 0),T.set(this,void 0),t.set(this,void 0),_.set(this,void 0),r.set(this,void 0),h.set(this,void 0),a.set(this,""),l.set(this,void 0),g.set(this,!1),I.set(this,!1),b.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new d.Emitter),this._onDidDispose=Me(this,c,"f").event,et(this,y,w,"f"),et(this,T,D,"f"),et(this,l,P,"f"),et(this,_,n,"f"),et(this,r,m,"f"),et(this,h,C,"f"),et(this,b,S(C),"f"),et(this,t,L,"f")}dispose(){et(this,g,!0,"f"),Me(this,c,"f").fire(),Me(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return et(this,I,!0,"f"),(0,R.asWebviewUri)(w,Me(this,_,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Me(this,a,"f")}set html(w){this.assertNotDisposed(),Me(this,a,"f")!==w&&(et(this,a,w,"f"),!Me(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(et(this,I,!0,"f"),Me(this,t,"f").report("Webview vscode-resource: uris",Me(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,T,"f").$setHtml(Me(this,y,"f"),w))}get options(){return this.assertNotDisposed(),Me(this,l,"f")}set options(w){this.assertNotDisposed(),Me(this,T,"f").$setOptions(Me(this,y,"f"),u(Me(this,h,"f"),Me(this,r,"f"),w)),et(this,l,w,"f")}async postMessage(w){if(Me(this,g,"f"))return!1;const D=(0,A.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Me(this,b,"f")});return Me(this,T,"f").$postMessage(Me(this,y,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Me(this,g,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,y=new WeakMap,T=new WeakMap,t=new WeakMap,_=new WeakMap,r=new WeakMap,h=new WeakMap,a=new WeakMap,l=new WeakMap,g=new WeakMap,I=new WeakMap,b=new WeakMap,c=new WeakMap;function S(v){try{const w=(0,E.normalizeVersion)((0,E.parseVersion)(v.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=S;class i{constructor(w,D,P,n,m){this.initData=D,this.workspace=P,this._logService=n,this._deprecationService=m,this._webviews=new Map,this._webviewProxy=w.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(w,D,...P){const n=this.getWebview(w);if(n){const{message:m}=(0,A.deserializeWebviewMessage)(D,P);n._onMessageEmitter.fire(m)}}$onMissingCsp(w,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,D,P){const n=new p(w,this._webviewProxy,o(D),this.initData,this.workspace,P,this._deprecationService);return this._webviews.set(w,n),n._onDidDispose(()=>{this._webviews.delete(w)}),n}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=i;function s(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=s;function u(v,w,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||f(v,w)}}e.serializeWebviewOptions=u;function o(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(w=>F.URI.from(w))}}e.reviveOptions=o;function f(v,w){return[...(w?.getWorkspaceFolders()||[]).map(D=>D.uri),v.extensionLocation]}}),define(we[209],be([0,1,21,57,7,11,24,2,8,49,63,5,6]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(i,s){this.document=i,this._storagePath=s,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,s){await this.getEdit(i).undo(),s||this.disposeBackup()}async redo(i,s){await this.getEdit(i).redo(),s||this.disposeBackup()}disposeEdits(i){for(const s of i)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=p(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const s=this._edits.get(i,0);if(!s)throw new Error("No edit found");return s}}class a{constructor(){this._documents=new Map}get(i,s){return this._documents.get(this.key(i,s))}add(i,s,u){const o=this.key(i,s.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${i} resource:${s.uri}`);const f=new h(s,u);return this._documents.set(o,f),f}delete(i,s){const u=this.key(i,s.uri);this._documents.delete(u)}key(i,s){return`${i}@@@${s}`}}var l;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(l||(l={}));class g{constructor(){this._providers=new Map}addTextProvider(i,s,u){return this.add(0,i,s,u)}addCustomProvider(i,s,u){return this.add(1,i,s,u)}get(i){return this._providers.get(i)}add(i,s,u,o){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:i,extension:u,provider:o}),new r.Disposable(()=>this._providers.delete(s))}}class I{constructor(i,s,u,o,f){this._extHostDocuments=s,this._extensionStoragePaths=u,this._extHostWebview=o,this._extHostWebviewPanels=f,this._editorProviders=new g,this._documents=new a,this._proxy=i.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,s,u,o){const f=new E.DisposableStore;return b(u)?(f.add(this._editorProviders.addTextProvider(s,i,u)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),s,o.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(f.add(this._editorProviders.addCustomProvider(s,i,u)),this.supportEditing(u)&&f.add(u.onDidChangeCustomDocument(v=>{const w=this.getCustomDocumentEntry(s,v.document.uri);if(c(v)){const D=w.addEdit(v);this._proxy.$onDidEdit(v.document.uri,s,D,v.label)}else this._proxy.$onContentChange(v.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),s,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),r.Disposable.from(f,new r.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(i,s,u,o,f){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${s}'`);const w=k.URI.revive(i),D=await v.provider.openCustomDocument(w,{backupId:u,untitledDocumentData:o?.buffer},f);let P;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(s,D,P),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(i,s){const u=this._editorProviders.get(s);if(!u)throw new Error(`No provider found for '${s}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${s}'`);const o=k.URI.revive(i),{document:f}=this.getCustomDocumentEntry(s,o);this._documents.delete(s,f),f.dispose()}async $resolveWebviewEditor(i,s,u,o,f,v){const w=this._editorProviders.get(u);if(!w)throw new Error(`No provider found for '${u}'`);const D=y.ViewColumn.to(f),P=this._extHostWebview.createNewWebview(s,o.webviewOptions,w.extension),n=this._extHostWebviewPanels.createNewWebviewPanel(s,u,o.title,D,o.panelOptions,P),m=k.URI.revive(i);switch(w.type){case 1:{const{document:C}=this.getCustomDocumentEntry(u,m);return w.provider.resolveCustomEditor(C,n,v)}case 0:{const C=this._extHostDocuments.getDocument(m);return w.provider.resolveCustomTextEditor(C,n,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,s,u){this.getCustomDocumentEntry(s,i).disposeEdits(u)}async $onMoveCustomEditor(i,s,u){const o=this._editorProviders.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const f=this._extHostWebviewPanels.getWebviewPanel(i);if(!f)throw new Error("No webview found");const v=k.URI.revive(s),w=this._extHostDocuments.getDocument(v);await o.provider.moveCustomTextEditor(w,f,d.CancellationToken.None)}async $undo(i,s,u,o){return this.getCustomDocumentEntry(s,i).undo(u,o)}async $redo(i,s,u,o){return this.getCustomDocumentEntry(s,i).redo(u,o)}async $revert(i,s,u){const o=this.getCustomDocumentEntry(s,i);await this.getCustomEditorProvider(s).revertCustomDocument(o.document,u),o.disposeBackup()}async $onSave(i,s,u){const o=this.getCustomDocumentEntry(s,i);await this.getCustomEditorProvider(s).saveCustomDocument(o.document,u),o.disposeBackup()}async $onSaveAs(i,s,u,o){const f=this.getCustomDocumentEntry(s,i);return this.getCustomEditorProvider(s).saveCustomDocumentAs(f.document,k.URI.revive(u),o)}async $backup(i,s,u){const o=this.getCustomDocumentEntry(s,i),v=await this.getCustomEditorProvider(s).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},u);return o.updateBackup(v),v.id}getCustomDocumentEntry(i,s){const u=this._documents.get(i,k.URI.revive(s));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(i){const u=this._editorProviders.get(i)?.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function b(S){return typeof S.resolveCustomTextEditor=="function"}function c(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function p(S){const i=S.scheme===A.Schemas.file||S.scheme===A.Schemas.untitled?S.fsPath:S.toString();return(0,F.hash)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[210],be([0,1,3,7,2,36,8,49,5,6]),function(ie,e,d,F,E,A,R,k,y,T){"use strict";var t,_,r,h,a,l,g,I,b,c,p,S,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends F.Disposable{constructor(v,w,D,P,n,m,C){super();t.set(this,void 0),_.set(this,void 0),r.set(this,void 0),h.set(this,void 0),a.set(this,void 0),l.set(this,void 0),g.set(this,void 0),I.set(this,void 0),b.set(this,!0),c.set(this,!0),p.set(this,!1),S.set(this,this._register(new d.Emitter)),this.onDidDispose=Me(this,S,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Me(this,i,"f").event,et(this,t,v,"f"),et(this,_,w,"f"),et(this,r,D,"f"),et(this,a,m,"f"),et(this,I,n,"f"),et(this,l,P,"f"),et(this,h,C,"f")}dispose(){Me(this,p,"f")||(et(this,p,!0,"f"),Me(this,S,"f").fire(),Me(this,_,"f").$disposeWebview(Me(this,t,"f")),Me(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,h,"f")}get viewType(){return this.assertNotDisposed(),Me(this,r,"f")}get title(){return this.assertNotDisposed(),Me(this,l,"f")}set title(v){this.assertNotDisposed(),Me(this,l,"f")!==v&&(et(this,l,v,"f"),Me(this,_,"f").$setTitle(Me(this,t,"f"),v))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(v){this.assertNotDisposed(),Me(this,g,"f")!==v&&(et(this,g,v,"f"),Me(this,_,"f").$setIconPath(Me(this,t,"f"),E.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Me(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,I,"f")=="number"&&Me(this,I,"f")<0))return Me(this,I,"f")}get active(){return this.assertNotDisposed(),Me(this,c,"f")}get visible(){return this.assertNotDisposed(),Me(this,b,"f")}_updateViewState(v){Me(this,p,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(et(this,c,v.active,"f"),et(this,b,v.visible,"f"),et(this,I,v.viewColumn,"f"),Me(this,i,"f").fire({webviewPanel:this}))}reveal(v,w){this.assertNotDisposed(),Me(this,_,"f").$reveal(Me(this,t,"f"),{viewColumn:v?R.ViewColumn.from(v):void 0,preserveFocus:!!w})}assertNotDisposed(){if(Me(this,p,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,_=new WeakMap,r=new WeakMap,h=new WeakMap,a=new WeakMap,l=new WeakMap,g=new WeakMap,I=new WeakMap,b=new WeakMap,c=new WeakMap,p=new WeakMap,S=new WeakMap,i=new WeakMap;class u{constructor(v,w,D){this.webviews=w,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(v,w,D,P,n={}){const m=typeof P=="object"?P.viewColumn:P,C={viewColumn:R.ViewColumn.from(m),preserveFocus:typeof P=="object"&&!!P.preserveFocus},L=(0,k.shouldSerializeBuffersForPostMessage)(v),$=u.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(v),$,w,{title:D,panelOptions:o(n),webviewOptions:(0,k.serializeWebviewOptions)(v,this.workspace,n),serializeBuffersForPostMessage:L},C);const Q=this.webviews.createNewWebview($,n,v);return this.createNewWebviewPanel($,w,D,m,n,Q)}$onDidChangeWebviewPanelViewStates(v){const w=Object.keys(v);w.sort((D,P)=>{const n=v[D],m=v[P];return n.active?1:m.active?-1:+n.visible-+m.visible});for(const D of w){const P=this.getWebviewPanel(D);if(!P)continue;const n=v[D];P._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,w,D){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:D,extension:v}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(v)}),new T.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(v,w,D,P){const n=this._serializers.get(w);if(!n)throw new Error(`No serializer found for '${w}'`);const{serializer:m,extension:C}=n,L=this.webviews.createNewWebview(v,D.webviewOptions,C),$=this.createNewWebviewPanel(v,w,D.title,P,D.panelOptions,L);await m.deserializeWebviewPanel($,D.state)}createNewWebviewPanel(v,w,D,P,n,m){const C=new s(v,this._proxy,w,D,P,n,m);return this._webviewPanels.set(v,C),C}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=u;function o(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[211],be([0,1,3,7,49,5,6]),function(ie,e,d,F,E,A,R){"use strict";var k,y,T,t,_,r,h,a,l,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends F.Disposable{constructor(p,S,i,s,u,o){super();k.set(this,void 0),y.set(this,void 0),T.set(this,void 0),t.set(this,void 0),_.set(this,!1),r.set(this,void 0),h.set(this,void 0),a.set(this,void 0),l.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Me(this,l,"f").event,g.set(this,this._register(new d.Emitter)),this.onDidDispose=Me(this,g,"f").event,et(this,T,i,"f"),et(this,h,s,"f"),et(this,k,p,"f"),et(this,y,S,"f"),et(this,t,u,"f"),et(this,r,o,"f")}dispose(){Me(this,_,"f")||(et(this,_,!0,"f"),Me(this,g,"f").fire(),Me(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,h,"f")}set title(p){this.assertNotDisposed(),Me(this,h,"f")!==p&&(et(this,h,p,"f"),Me(this,y,"f").$setWebviewViewTitle(Me(this,k,"f"),p))}get description(){return this.assertNotDisposed(),Me(this,a,"f")}set description(p){this.assertNotDisposed(),Me(this,a,"f")!==p&&(et(this,a,p,"f"),Me(this,y,"f").$setWebviewViewDescription(Me(this,k,"f"),p))}get visible(){return Me(this,r,"f")}get webview(){return Me(this,t,"f")}get viewType(){return Me(this,T,"f")}_setVisible(p){p===Me(this,r,"f")||Me(this,_,"f")||(et(this,r,p,"f"),Me(this,l,"f").fire())}show(p){this.assertNotDisposed(),Me(this,y,"f").$show(Me(this,k,"f"),!!p)}assertNotDisposed(){if(Me(this,_,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,y=new WeakMap,T=new WeakMap,t=new WeakMap,_=new WeakMap,r=new WeakMap,h=new WeakMap,a=new WeakMap,l=new WeakMap,g=new WeakMap;class b{constructor(p,S){this._extHostWebview=S,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,S,i,s){if(this._viewProviders.has(S))throw new Error(`View provider for '${S}' already registered`);return this._viewProviders.set(S,{provider:i,extension:p}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(p),S,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(S),this._proxy.$unregisterWebviewViewProvider(S)})}async $resolveWebviewView(p,S,i,s,u){const o=this._viewProviders.get(S);if(!o)throw new Error(`No view provider found for '${S}'`);const{provider:f,extension:v}=o,w=this._extHostWebview.createNewWebview(p,{},v),D=new I(p,this._proxy,S,i,w,!0);this._webviewViews.set(p,D),await f.resolveWebviewView(D,{state:s},u)}async $onDidChangeWebviewViewVisibility(p,S){this.getWebviewView(p)._setVisible(S)}async $disposeWebviewView(p){const S=this.getWebviewView(p);this._webviewViews.delete(p),S.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const S=this._webviewViews.get(p);if(!S)throw new Error("No webview found");return S}}e.ExtHostWebviewViews=b}),define(we[97],be([0,1,3,5,2,11,9,4,12]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Bi{constructor(_){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bi.InitialState,this._proxy=_.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(r=>this.$onDidChangeWindowFocus(r))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,r){let h;if(typeof _=="string"){h=_;try{_=E.URI.parse(_)}catch(a){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,R.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,h,r)}async asExternalUri(_,r){if((0,R.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(_,r);return E.URI.from(h)}};T.InitialState={focused:!0},T=Be([ze(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(we[212],be([0,1,14,5,29,12]),function(ie,e,d,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends d.AbstractLogger{constructor(y,T){super();this._proxy=y.getProxy(F.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...T){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(y,...T){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(y,...T){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(y,...T){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(y,...T){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(y,...T){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};R=Be([ze(0,A.IExtHostRpcService),ze(1,E.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(we[213],be([0,1,13,23,21,15,3,7,108,179,46]),function(ie,e,d,F,E,A,R,k,y,T,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function r(n,m){try{return JSON.stringify(n,m)}catch(C){return"null"}}const h="$$ref$$",a={[h]:-1};class l{constructor(m,C){this.jsonString=m,this.referencedBuffers=C}}function g(n,m=null,C=!1){const L=[];return{jsonString:(C?r:JSON.stringify)(n,(Q,se)=>{if(typeof se=="undefined")return a;if(typeof se=="object"){if(se instanceof F.VSBuffer){const G=L.push(se)-1;return{[h]:G}}if(m)return m(Q,se)}return se}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=g;function I(n,m,C){return JSON.parse(n,(L,$)=>{if($){const Q=$[h];if(typeof Q=="number")return m[Q];if(C&&$.$mid===1)return C.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=I;function b(n,m){return JSON.stringify(n,m)}function c(n){return n?(m,C)=>C&&C.$mid===1?n.transformOutgoing(C):C:null}var p;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class o extends k.Disposable{constructor(m,C=null,L=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=m,this._logger=C,this._uriTransformer=L,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,Q=t.ProxyIdentifier.count;$<Q;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(m=>{this._pendingRPCReplies[m].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(m){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(m){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(m){this._responsiveState!==m&&(this._responsiveState=m,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(m){return this._uriTransformer?(0,y.transformIncomingURIs)(m,this._uriTransformer):m}getProxy(m){const{nid:C,sid:L}=m;return this._proxies[C]||(this._proxies[C]=this._createProxy(C,L)),this._proxies[C]}_createProxy(m,C){let L={get:($,Q)=>(typeof Q=="string"&&!$[Q]&&Q.charCodeAt(0)===36&&($[Q]=(...se)=>this._remoteCall(m,Q,se)),Q===u?C:$[Q])};return new Proxy(Object.create(null),L)}set(m,C){return this._locals[m.nid]=C,C}assertRegistered(m){for(let C=0,L=m.length;C<L;C++){const $=m[C];if(!this._locals[$.nid])throw new Error(`Missing actor ${$.sid} (isMain: ${$.isMain})`)}}_receiveOneMessage(m){if(this._isDisposed)return;const C=m.byteLength,L=f.read(m,0),$=L.readUInt8(),Q=L.readUInt32();switch($){case 1:case 2:{let{rpcId:se,method:G,args:z}=w.deserializeRequestJSONArgs(L);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(C,Q,se,G,z,$===2);break}case 3:case 4:{let{rpcId:se,method:G,args:z}=w.deserializeRequestMixedArgs(L);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(C,Q,se,G,z,$===4);break}case 5:{this._logger&&this._logger.logIncoming(C,Q,0,"ack"),this._onDidReceiveAcknowledge(Q);break}case 6:{this._receiveCancel(C,Q);break}case 7:{this._receiveReply(C,Q,void 0);break}case 9:{let se=w.deserializeReplyOKJSON(L);this._uriTransformer&&(se=(0,y.transformIncomingURIs)(se,this._uriTransformer)),this._receiveReply(C,Q,se);break}case 10:{const se=w.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(C,Q,se);break}case 8:{let se=w.deserializeReplyOKVSBuffer(L);this._receiveReply(C,Q,se);break}case 11:{let se=w.deserializeReplyErrError(L);this._uriTransformer&&(se=(0,y.transformIncomingURIs)(se,this._uriTransformer)),this._receiveReplyErr(C,Q,se);break}case 12:{this._receiveReplyErr(C,Q,void 0);break}default:console.error("received unexpected message"),console.error(m)}}_receiveRequest(m,C,L,$,Q,se){this._logger&&this._logger.logIncoming(m,C,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(L)}.${$}(`,Q);const G=String(C);let z,x;if(se){const B=new E.CancellationTokenSource;Q.push(B.token),z=this._invokeHandler(L,$,Q),x=()=>B.cancel()}else z=this._invokeHandler(L,$,Q),x=i;this._cancelInvokedHandlers[G]=x;const j=w.serializeAcknowledged(C);this._logger&&this._logger.logOutgoing(j.byteLength,C,1,"ack"),this._protocol.send(j),z.then(B=>{delete this._cancelInvokedHandlers[G];const q=w.serializeReplyOK(C,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(q.byteLength,C,1,"reply:",B),this._protocol.send(q)},B=>{delete this._cancelInvokedHandlers[G];const q=w.serializeReplyErr(C,B);this._logger&&this._logger.logOutgoing(q.byteLength,C,1,"replyErr:",B),this._protocol.send(q)})}_receiveCancel(m,C){this._logger&&this._logger.logIncoming(m,C,1,"receiveCancel");const L=String(C);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(m,C,L){this._logger&&this._logger.logIncoming(m,C,0,"receiveReply:",L);const $=String(C);if(!this._pendingRPCReplies.hasOwnProperty($))return;const Q=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],Q.resolveOk(L)}_receiveReplyErr(m,C,L){this._logger&&this._logger.logIncoming(m,C,0,"receiveReplyErr:",L);const $=String(C);if(!this._pendingRPCReplies.hasOwnProperty($))return;const Q=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let se;L&&(L.$isError?(se=new Error,se.name=L.name,se.message=L.message,se.stack=L.stack):se=L),Q.resolveErr(se)}_invokeHandler(m,C,L){try{return Promise.resolve(this._doInvokeHandler(m,C,L))}catch($){return Promise.reject($)}}_doInvokeHandler(m,C,L){const $=this._locals[m];if(!$)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(m));let Q=$[C];if(typeof Q!="function")throw new Error("Unknown method "+C+" on actor "+(0,t.getStringIdentifierForProxy)(m));return Q.apply($,L)}_remoteCall(m,C,L){if(this._isDisposed)return Promise.reject(A.canceled());let $=null;if(L.length>0&&E.CancellationToken.isCancellationToken(L[L.length-1])&&($=L.pop()),$&&$.isCancellationRequested)return Promise.reject(A.canceled());const Q=w.serializeRequestArguments(L,this._uriReplacer),se=++this._lastMessageId,G=String(se),z=new T.LazyPromise;$&&$.onCancellationRequested(()=>{const j=w.serializeCancel(se);this._logger&&this._logger.logOutgoing(j.byteLength,se,0,"cancel"),this._protocol.send(w.serializeCancel(se))}),this._pendingRPCReplies[G]=z,this._onWillSendRequest(se);const x=w.serializeRequest(se,m,C,Q,!!$);return this._logger&&this._logger.logOutgoing(x.byteLength,se,0,`request: ${(0,t.getStringIdentifierForProxy)(m)}.${C}(`,L),this._protocol.send(x),z}}e.RPCProtocol=o,_=s,o.UNRESPONSIVE_TIME=3*1e3;class f{constructor(m,C){this._buff=m,this._offset=C}static alloc(m,C,L){let $=new f(F.VSBuffer.alloc(L+1+4),0);return $.writeUInt8(m),$.writeUInt32(C),$}static read(m,C){return new f(m,C)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(m){this._buff.writeUInt8(m,this._offset),this._offset+=1}readUInt8(){const m=this._buff.readUInt8(this._offset);return this._offset+=1,m}writeUInt32(m){this._buff.writeUInt32BE(m,this._offset),this._offset+=4}readUInt32(){const m=this._buff.readUInt32BE(this._offset);return this._offset+=4,m}static sizeShortString(m){return 1+m.byteLength}writeShortString(m){this._buff.writeUInt8(m.byteLength,this._offset),this._offset+=1,this._buff.set(m,this._offset),this._offset+=m.byteLength}readShortString(){const m=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+m).toString();return this._offset+=m,L}static sizeLongString(m){return 4+m.byteLength}writeLongString(m){this._buff.writeUInt32BE(m.byteLength,this._offset),this._offset+=4,this._buff.set(m,this._offset),this._offset+=m.byteLength}readLongString(){const m=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+m).toString();return this._offset+=m,L}writeBuffer(m){this._buff.writeUInt32BE(m.byteLength,this._offset),this._offset+=4,this._buff.set(m,this._offset),this._offset+=m.byteLength}static sizeVSBuffer(m){return 4+m.byteLength}writeVSBuffer(m){this._buff.writeUInt32BE(m.byteLength,this._offset),this._offset+=4,this._buff.set(m,this._offset),this._offset+=m.byteLength}readVSBuffer(){const m=this._buff.readUInt32BE(this._offset);this._offset+=4;const C=this._buff.slice(this._offset,this._offset+m);return this._offset+=m,C}static sizeMixedArray(m){let C=0;C+=1;for(let L=0,$=m.length;L<$;L++){const Q=m[L];switch(C+=1,Q.type){case 1:C+=this.sizeLongString(Q.value);break;case 2:C+=this.sizeVSBuffer(Q.value);break;case 3:C+=this.sizeUInt8(),C+=this.sizeLongString(Q.value);for(let se=0;se<Q.buffers.length;++se)C+=this.sizeVSBuffer(Q.buffers[se]);break;case 4:break}}return C}writeMixedArray(m){this._buff.writeUInt8(m.length,this._offset),this._offset+=1;for(let C=0,L=m.length;C<L;C++){const $=m[C];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt8($.buffers.length),this.writeLongString($.value);for(let Q=0;Q<$.buffers.length;++Q)this.writeBuffer($.buffers[Q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const m=this._buff.readUInt8(this._offset);this._offset+=1;let C=new Array(m);for(let L=0;L<m;L++)switch(this.readUInt8()){case 1:C[L]=this.readLongString();break;case 2:C[L]=this.readVSBuffer();break;case 3:const Q=this.readUInt8(),se=this.readLongString(),G=[];for(let z=0;z<Q;++z)G.push(this.readVSBuffer());C[L]=new t.SerializableObjectWithBuffers(I(se,G,null));break;case 4:C[L]=void 0;break}return C}}var v;(function(n){n[n.Simple=0]="Simple",n[n.Mixed=1]="Mixed"})(v||(v={}));class w{static _useMixedArgSerialization(m){for(let C=0,L=m.length;C<L;C++)if(m[C]instanceof F.VSBuffer||m[C]instanceof t.SerializableObjectWithBuffers||typeof m[C]=="undefined")return!0;return!1}static serializeRequestArguments(m,C){if(this._useMixedArgSerialization(m)){const L=[];for(let $=0,Q=m.length;$<Q;$++){const se=m[$];if(se instanceof F.VSBuffer)L[$]={type:2,value:se};else if(typeof se=="undefined")L[$]={type:4};else if(se instanceof t.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:z}=g(se.value,C);L[$]={type:3,value:F.VSBuffer.fromString(G),buffers:z}}else L[$]={type:1,value:F.VSBuffer.fromString(b(se,C))}}return{type:1,args:L}}return{type:0,args:b(m,C)}}static serializeRequest(m,C,L,$,Q){switch($.type){case 0:return this._requestJSONArgs(m,C,L,$.args,Q);case 1:return this._requestMixedArgs(m,C,L,$.args,Q)}}static _requestJSONArgs(m,C,L,$,Q){const se=F.VSBuffer.fromString(L),G=F.VSBuffer.fromString($);let z=0;z+=f.sizeUInt8(),z+=f.sizeShortString(se),z+=f.sizeLongString(G);let x=f.alloc(Q?2:1,m,z);return x.writeUInt8(C),x.writeShortString(se),x.writeLongString(G),x.buffer}static deserializeRequestJSONArgs(m){const C=m.readUInt8(),L=m.readShortString(),$=m.readLongString();return{rpcId:C,method:L,args:JSON.parse($)}}static _requestMixedArgs(m,C,L,$,Q){const se=F.VSBuffer.fromString(L);let G=0;G+=f.sizeUInt8(),G+=f.sizeShortString(se),G+=f.sizeMixedArray($);let z=f.alloc(Q?4:3,m,G);return z.writeUInt8(C),z.writeShortString(se),z.writeMixedArray($),z.buffer}static deserializeRequestMixedArgs(m){const C=m.readUInt8(),L=m.readShortString(),$=m.readMixedArray(),Q=new Array($.length);for(let se=0,G=$.length;se<G;se++){const z=$[se];typeof z=="string"?Q[se]=JSON.parse(z):Q[se]=z}return{rpcId:C,method:L,args:Q}}static serializeAcknowledged(m){return f.alloc(5,m,0).buffer}static serializeCancel(m){return f.alloc(6,m,0).buffer}static serializeReplyOK(m,C,L){if(typeof C=="undefined")return this._serializeReplyOKEmpty(m);if(C instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(m,C);if(C instanceof t.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:Q}=g(C.value,L,!0);return this._serializeReplyOKJSONWithBuffers(m,$,Q)}else return this._serializeReplyOKJSON(m,r(C,L))}static _serializeReplyOKEmpty(m){return f.alloc(7,m,0).buffer}static _serializeReplyOKVSBuffer(m,C){let L=0;L+=f.sizeVSBuffer(C);let $=f.alloc(8,m,L);return $.writeVSBuffer(C),$.buffer}static deserializeReplyOKVSBuffer(m){return m.readVSBuffer()}static _serializeReplyOKJSON(m,C){const L=F.VSBuffer.fromString(C);let $=0;$+=f.sizeLongString(L);let Q=f.alloc(9,m,$);return Q.writeLongString(L),Q.buffer}static _serializeReplyOKJSONWithBuffers(m,C,L){const $=F.VSBuffer.fromString(C);let Q=0;Q+=f.sizeUInt8(),Q+=f.sizeLongString($);for(const G of L)Q+=f.sizeVSBuffer(G);let se=f.alloc(10,m,Q);se.writeUInt8(L.length),se.writeLongString($);for(const G of L)se.writeBuffer(G);return se.buffer}static deserializeReplyOKJSON(m){const C=m.readLongString();return JSON.parse(C)}static deserializeReplyOKJSONWithBuffers(m,C){const L=m.readUInt8(),$=m.readLongString(),Q=[];for(let se=0;se<L;++se)Q.push(m.readVSBuffer());return new t.SerializableObjectWithBuffers(I($,Q,C))}static serializeReplyErr(m,C){return C?this._serializeReplyErrEror(m,C):this._serializeReplyErrEmpty(m)}static _serializeReplyErrEror(m,C){const L=F.VSBuffer.fromString(r(A.transformErrorForSerialization(C),null));let $=0;$+=f.sizeLongString(L);let Q=f.alloc(11,m,$);return Q.writeLongString(L),Q.buffer}static deserializeReplyErrError(m){const C=m.readLongString();return JSON.parse(C)}static _serializeReplyErrEmpty(m){return f.alloc(12,m,0).buffer}}var D;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",n[n.ReplyErrError=11]="ReplyErrError",n[n.ReplyErrEmpty=12]="ReplyErrEmpty"})(D||(D={}));var P;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",n[n.Undefined=4]="Undefined"})(P||(P={}))}),define(we[214],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(A){const R=k=>{self.removeEventListener("message",R);const y=k.data;Object.defineProperties(self,{postMessage:{value(T,t){y.postMessage(T,t)}},onmessage:{get(){return y.onmessage},set(T){y.onmessage=T}}}),y.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(A,R,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${d})('${R}'))`,T=new Blob([y],{type:"application/javascript"}),t=URL.createObjectURL(T),_=new MessageChannel,r=t,h={type:"_newWorker",id:r,port:_.port2,url:t,options:k};A(h,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:r};_.port1.postMessage(a),URL.revokeObjectURL(t),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(a){_.port1.onmessage=a}},onmessageerror:{get(){return _.port1.onmessageerror},set(a){_.port1.onmessageerror=a}}}),_.port1.addEventListener("messageerror",a=>{const l=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(l)}),_.port1.addEventListener("message",a=>{const l=new MessageEvent("message",{data:a.data});this.dispatchEvent(l)}),_.port1.start()}}e.NestedWorker=F}),define(we[215],be([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(we[216],be([0,1,11,17,25,2,4,87,44,175,215]),function(ie,e,d,F,E,A,R,k,y,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let _=class $i{constructor(h,a,l,g){this.localUserHome=h,this.remoteAgentService=a,this.environmentService=l,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||h})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,a){if(h.remoteAuthority)return d.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(a.getWorkspace());if(l)return l;const g=a.getWorkspace().folders[0];if(g)return g.uri.scheme;const I=a.getWorkspace().configuration;return I?I.scheme:d.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?F.win32:F.posix)}async fileURI(h){let a="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const g=h.indexOf("/",2);g===-1?(a=h.substring(2),h="/"):(a=h.substring(2,g),h=h.substring(g)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:a,path:h,query:"",fragment:""})}};_=Be([ze(1,t.IRemoteAgentService),ze(2,T.IWorkbenchEnvironmentService),ze(3,y.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(we[98],be([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(R,k){this.line=R,this.character=k}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,k){return new d(0,0)}with(R){return new d(0,0)}}e.Position=d;class F{constructor(R,k,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(R,k),this.end=new d(y,T)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.Range=F;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[38],be([0,1,16,27,22,40,9,4,17,15,98,10]),function(ie,e,d,F,E,A,R,k,y,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const r="\u27EA ",h=" characters skipped \u27EB",a=(r.length+h.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var l;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function I(j){return!!j.preview}e.resultIsMatch=I;function b(j){return!!j.resource}e.isFileMatch=b;function c(j){return!!j.message}e.isProgressMessage=c;var p;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=S;class i{constructor(B,q,ce){this.ranges=q;const V=Array.isArray(q)?q:[q];if(ce&&ce.matchLines===1&&s(V)){B=(0,R.getNLines)(B,ce.matchLines);let le="",ae=0,ve=0;const Ae=Math.floor(ce.charsPerLine/5),Re=[];for(const Oe of V){const Qe=Math.max(Oe.startColumn-Ae,0),He=Oe.startColumn+ce.charsPerLine;if(Qe>ve+Ae+a){const je=r+(Qe-ve)+h;le+=je+B.slice(Qe,He),ae+=Qe-(ve+je.length)}else le+=B.slice(ve,He);Re.push(new o(0,Oe.startColumn-ae,Oe.endColumn-ae)),ve=He}this.preview={text:le,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const le=Array.isArray(q)?q[0].startLineNumber:q.startLineNumber;this.preview={text:B,matches:(0,d.mapArrayOrNot)(q,ae=>new u(ae.startLineNumber-le,ae.startColumn,ae.endLineNumber-le,ae.endColumn))}}}}e.TextSearchMatch=i;function s(j){const B=j[0].startLineNumber;for(const q of j)if(q.startLineNumber!==B||q.endLineNumber!==B)return!1;return!0}class u{constructor(B,q,ce,V){this.startLineNumber=B,this.startColumn=q,this.endLineNumber=ce,this.endColumn=V}}e.SearchRange=u;class o extends u{constructor(B,q,ce){super(B,q,B,ce)}}e.OneLineRange=o;var f;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function v(j,B=!0){const q=j&&j.files&&j.files.exclude,ce=B&&j&&j.search&&j.search.exclude;if(!q&&!ce)return;if(!q||!ce)return q||ce;let V=Object.create(null);return V=E.mixin(V,E.deepClone(q)),V=E.mixin(V,E.deepClone(ce),!0),V}e.getExcludes=v;function w(j,B){return j.excludePattern&&F.match(j.excludePattern,B)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&F.match(j.includePattern,B)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(q=>{const ce=q.folder.fsPath;if(A.isEqualOrParent(B,ce)){const V=y.relative(ce,B);return!q.includePattern||!!F.match(q.includePattern,V)}else return!1}):!1:!0}e.pathIncludedInQuery=w;var D;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(D=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(B,q){super(B);this.code=q}}e.SearchError=P;function n(j){const B=j.message;if((0,T.isPromiseCanceledError)(j))return new P(B,D.canceled);try{const q=JSON.parse(B);return new P(q.message,q.code)}catch(q){return new P(B,D.other)}}e.deserializeSearchError=n;function m(j){const B={message:j.message,code:j.code};return new Error(JSON.stringify(B))}e.serializeSearchError=m;function C(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=C;function L(j){return j.type==="success"}e.isSerializedSearchSuccess=L;function $(j){return!!j.path}e.isSerializedFileMatch=$;function Q(j,B){const q=j.searchPath?j.searchPath:j.relativePath;return(0,R.fuzzyContains)(q,B)}e.isFilePatternMatch=Q;class se{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=se;function G(j,B){const q={...j||{},...B||{}};return Object.keys(q).filter(ce=>{const V=q[ce];return typeof V=="boolean"&&V})}e.resolvePatternsForProvider=G;class z{constructor(B,q){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...q.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let ce=B.includePattern;q.includePattern&&(ce?ce={...ce,...q.includePattern}:ce=q.includePattern),ce&&(this._parsedIncludeExpression=F.parse(ce))}includedInQuerySync(B,q,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,q,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,q,ce))}includedInQuery(B,q,ce){const V=this._parsedExcludeExpression(B,q,ce),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,q,ce):!0;return(0,_.isPromise)(V)?V.then(ae=>ae?!1:le()):le()}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=z;function x(j){for(const B in j)if(typeof j[B]!="boolean")return!0;return!1}}),define(we[31],be([0,1,16,13,21,3,20,11,76,24,9,10,2,127,4,14,142,44,45,29,12,6,38,5]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b,c,p,S,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(m,C,L){return new T.ExtUri($=>w($,L)).isEqual(m,C)}function o(m,C,L){return u(m.uri,C.uri,L)?0:(0,t.compare)(m.uri.toString(),C.uri.toString())}function f(m,C,L){return m.index!==C.index?m.index<C.index?-1:1:u(m.uri,C.uri,L)?(0,t.compare)(m.name,C.name):(0,t.compare)(m.uri.toString(),C.uri.toString())}function v(m,C,L,$){const Q=m.slice(0).sort((G,z)=>L(G,z,$)),se=C.slice(0).sort((G,z)=>L(G,z,$));return(0,d.delta)(Q,se,(G,z)=>L(G,z,$))}function w(m,C){const L=C.getCapabilities(m.scheme);return!(L&&L&1024)}class D extends I.Workspace{constructor(C,L,$,Q,se,G){super(C,$.map(z=>new I.WorkspaceFolder(z)),Q,G);this._name=L,this._isUntitled=se,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(G),$.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(C,L,$,Q){if(!C)return{workspace:null,added:[],removed:[]};const{id:se,name:G,folders:z,configuration:x,isUntitled:j}=C,B=[],q=L;L?z.forEach((ae,ve)=>{const Ae=r.URI.revive(ae.uri),Re=D._findFolder($||L,Ae,Q);Re?(Re.name=ae.name,Re.index=ae.index,B.push(Re)):B.push({uri:Ae,name:ae.name,index:ve})}):B.push(...z.map(({uri:ae,name:ve,index:Ae})=>({uri:r.URI.revive(ae),name:ve,index:Ae}))),B.sort((ae,ve)=>ae.index<ve.index?-1:1);const ce=new D(se,G,B,x?r.URI.revive(x):null,!!j,ae=>w(ae,Q)),{added:V,removed:le}=v(q?q.workspaceFolders:[],ce.workspaceFolders,o,Q);return{workspace:ce,added:V,removed:le}}static _findFolder(C,L,$){for(let Q=0;Q<C.folders.length;Q++){const se=C.workspaceFolders[Q];if(u(se.uri,L,$))return se}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(C,L){return L&&this._structure.get(C)&&(C=(0,T.dirname)(C)),this._structure.findSubstr(C)}resolveWorkspaceFolder(C){return this._structure.get(C)}}let P=class{constructor(C,L,$,Q){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=Q,this._extHostFileSystemInfo=$,this._requestIdProvider=new y.Counter,this._barrier=new F.Barrier,this._proxy=C.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=C.getProxy(s.MainContext.MainThreadMessageService);const se=L.workspace;this._confirmedWorkspace=se?new D(se.id,se.name,[],se.configuration?r.URI.revive(se.configuration):null,!!se.isUntitled,G=>w(G,$)):void 0}$initializeWorkspace(C,L){this._trusted=L,this.$acceptWorkspaceData(C),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?r.URI.from({scheme:k.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(C,L,$,...Q){const se=[];if(Array.isArray(Q)&&Q.forEach(B=>{r.URI.isUri(B.uri)&&!se.some(q=>u(q.uri,B.uri,this._extHostFileSystemInfo))&&se.push({uri:B.uri,name:B.name||(0,T.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[L,$].some(B=>typeof B!="number"||B<0)||$===0&&se.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+$>G.length)return!1;const z=G.slice(0);z.splice(L,$,...se.map(B=>({uri:B.uri,name:B.name||(0,T.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<z.length;B++){const q=z[B];if(z.some((ce,V)=>V!==B&&u(q.uri,ce.uri,this._extHostFileSystemInfo)))return!1}z.forEach((B,q)=>B.index=q);const{added:x,removed:j}=v(G,z,f,this._extHostFileSystemInfo);if(x.length===0&&j.length===0)return!1;if(this._proxy){const B=C.displayName||C.name;this._proxy.$updateWorkspaceFolders(B,L,$,se).then(void 0,q=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,h.localize)(0,null,B,q.toString()),{extension:C},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(C,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(C,L)}async getWorkspaceFolder2(C,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(C,L)}async resolveWorkspaceFolder(C){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(C)}getPath(){if(!this._actualWorkspace)return;const{folders:C}=this._actualWorkspace;if(C.length!==0)return C[0].uri.fsPath}getRelativePath(C,L){let $,Q="";if(typeof C=="string"?($=r.URI.file(C),Q=C):typeof C!="undefined"&&($=C,Q=C.fsPath),!$)return Q;const se=this.getWorkspaceFolder($,!0);if(!se)return Q;typeof L=="undefined"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let G=(0,T.relativePath)(se.uri,$);return L&&se.name&&(G=`${se.name}/${G}`),G}trySetWorkspaceFolders(C){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:C,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(C){const{workspace:L,added:$,removed:Q}=D.toExtHostWorkspace(C,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:Q}))}findFiles(C,L,$,Q,se=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let G;if(L===null?G=!1:L&&(typeof L=="string"?G=L:G=L.pattern),se&&se.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:x}=n(C);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)(x),(0,_.withUndefinedAsNull)(G),(0,_.withUndefinedAsNull)($),se).then(j=>Array.isArray(j)?j.map(B=>r.URI.revive(B)):[])}async findTextInFiles(C,L,$,Q,se=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),z=typeof L.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:x,folder:j}=n(L.include),B=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,q={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:z,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:x,excludePattern:B},ce=!1;if(this._activeSearchCallbacks[G]=V=>{if(ce)return;const le=r.URI.revive(V.resource);V.results.forEach(ae=>{(0,i.resultIsMatch)(ae)?$({uri:le,preview:{text:ae.preview.text,matches:(0,d.mapArrayOrNot)(ae.preview.matches,ve=>new S.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(ae.ranges,ve=>new S.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):$({uri:le,text:ae.text,lineNumber:ae.lineNumber})})},se.isCancellationRequested)return{};try{const V=await this._proxy.$startTextSearch(C,(0,_.withUndefinedAsNull)(j),q,G,se);return delete this._activeSearchCallbacks[G],V||{}}catch(V){throw delete this._activeSearchCallbacks[G],V}}$handleTextSearchResult(C,L){this._activeSearchCallbacks[L]&&this._activeSearchCallbacks[L](C)}saveAll(C){return this._proxy.$saveAll(C)}resolveProxy(C){return this._proxy.$resolveProxy(C)}get trusted(){return this._trusted}requestWorkspaceTrust(C){return this._proxy.$requestWorkspaceTrust(C)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};P=Be([ze(0,p.IExtHostRpcService),ze(1,c.IExtHostInitDataService),ze(2,b.IExtHostFileSystemInfo),ze(3,l.ILogService)],P),e.ExtHostWorkspace=P,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function n(m){let C,L;return m&&(typeof m=="string"?C=m:(C=m.pattern,L=m.baseFolder||r.URI.file(m.base))),{includePattern:C,folder:L}}}),define(we[32],be([0,1,22,3,31,5,6,148,62,10,13,4,12,14,2]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(s,u){if(u){const o=u.split(".");let f=s;for(let v=0;f&&v<o.length;v++)f=f[o[v]];return f}}function g(s){return s instanceof a.URI}function I(s){return s&&s.uri instanceof a.URI&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&s.uri instanceof a.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function p(s){if(g(s))return{resource:s};if(I(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(b(s))return{overrideIdentifier:s.languageId};if(c(s))return{resource:s.uri};if(s===null)return{resource:null}}let S=class{constructor(u,o,f){this._proxy=u.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=f,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new i(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(u,o))}};S=Be([ze(0,r.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,h.ILogService)],S),e.ExtHostConfiguration=S;class i{constructor(u,o,f,v){this._onDidChangeConfiguration=new F.Emitter,this._proxy=u,this._logService=v,this._extHostWorkspace=o,this._configuration=k.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,o){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,f))}getConfiguration(u,o,f){const v=p(o)||{},w=this._toReadonlyValue(u?l(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,v,f?.identifier);function D(n){if(n==null)return null;if(typeof n=="boolean")return n?1:4;switch(n){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const P={has(n){return typeof l(w,n)!="undefined"},get:(n,m)=>{this._validateConfigurationAccess(u?`${u}.${n}`:n,v,f?.identifier);let C=l(w,n);if(typeof C=="undefined")C=m;else{let L;const $=(Q,se)=>{let G;const z=()=>{L=L||(0,d.deepClone)(w),G=G||l(L,se)};return(0,T.isObject)(Q)?new Proxy(Q,{get:(x,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return z(),()=>G;if(L)return G=G||l(L,se),G[j];const B=x[j];return typeof j=="string"?$(B,`${se}.${j}`):B},set:(x,j,B)=>(z(),G&&(G[j]=B),!0),deleteProperty:(x,j)=>(z(),G&&delete G[j],!0),defineProperty:(x,j,B)=>(z(),G&&Object.defineProperty(G,j,B),!0)}):Q};C=$(C,n)}return C},update:(n,m,C,L)=>{n=u?`${u}.${n}`:n;const $=D(C);return m!==void 0?this._proxy.$updateConfigurationOption($,n,m,v,L):this._proxy.$removeConfigurationOption($,n,v,L)},inspect:n=>{n=u?`${u}.${n}`:n;const m=(0,d.deepClone)(this._configuration.inspect(n,v,this._extHostWorkspace.workspace));if(m)return{key:n,defaultValue:m.default?.value,globalValue:m.user?.value,workspaceValue:m.workspace?.value,workspaceFolderValue:m.workspaceFolder?.value,defaultLanguageValue:m.default?.override,globalLanguageValue:m.user?.override,workspaceLanguageValue:m.workspace?.override,workspaceFolderLanguageValue:m.workspaceFolder?.override,languageIds:m.overrideIdentifiers}}};return typeof w=="object"&&(0,d.mixin)(P,w,!1),Object.freeze(P)}_toReadonlyValue(u){const o=f=>(0,T.isObject)(f)?new Proxy(f,{get:(v,w)=>o(v[w]),set:(v,w,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(v,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(v,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return o(u)}_validateConfigurationAccess(u,o,f){const v=y.OVERRIDE_PROPERTY_PATTERN.test(u)?4:this._configurationScopes.get(u),w=f?`[${f.value}] `:"";if(v===4){typeof o?.resource=="undefined"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){o?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,o){const f=new k.ConfigurationChangeEvent(u,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,w)=>f.affectsConfiguration(v,p(w))})}_toMap(u){return u.reduce((o,f)=>(o.set(f[0],f[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[99],be([0,1,2,13,3,5,22,6,31,48,32,21,37,12,29,4,11,25,14,71,165,15]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b,c,p,S){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(G){function z(j){if(j!=null)return j}G.from=z;function x(j){if(j!=null)return j}G.to=x})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(G){function z(j){if(j!=null)return j}G.from=z;function x(j){if(j!=null)return j}G.to=x})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(G){function z(j){if(j!=null)return j}G.from=z;function x(j){if(j!=null)return j}G.to=x})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var f;(function(G){function z(B){if(B){const q=B;return q&&!!q.process}else return!1}G.is=z;function x(B){if(B==null)return;const q={process:B.process,args:B.args};return B.options&&(q.options=o.from(B.options)),q}G.from=x;function j(B){if(B!=null)return new k.ProcessExecution(B.process,B.args,B.options)}G.to=j})(f=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var v;(function(G){function z(j){if(j!=null)return j}G.from=z;function x(j){if(j!=null)return j}G.to=x})(v=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var w;(function(G){function z(B){if(B){const q=B;return q&&(!!q.commandLine||!!q.command)}else return!1}G.is=z;function x(B){if(B==null)return;const q={};return B.commandLine!==void 0?q.commandLine=B.commandLine:(q.command=B.command,q.args=B.args),B.options&&(q.options=v.from(B.options)),q}G.from=x;function j(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new k.ShellExecution(B.commandLine,B.options):new k.ShellExecution(B.command,B.args?B.args:[],B.options)}G.to=j})(w=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var D;(function(G){function z(B){if(B){let q=B;return q&&q.customExecution==="customExecution"}else return!1}G.is=z;function x(B){return{customExecution:"customExecution"}}G.from=x;function j(B,q){return q.get(B)}G.to=j})(D=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(G){function z(x,j){let B;return x.scope!==void 0&&typeof x.scope!="number"?B=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===k.TaskScope.Workspace&&j&&j.workspaceFile?B=j.workspaceFile:B=p.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:B}}G.from=z})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var n;(function(G){function z(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}G.from=z})(n=e.TaskGroupDTO||(e.TaskGroupDTO={}));var m;(function(G){function z(B,q){if(B==null)return[];const ce=[];for(let V of B){const le=x(V,q);le&&ce.push(le)}return ce}G.fromMany=z;function x(B,q){if(B==null)return;let ce;B.execution instanceof k.ProcessExecution?ce=f.from(B.execution):B.execution instanceof k.ShellExecution?ce=w.from(B.execution):B.execution&&B.execution instanceof k.CustomExecution&&(ce=D.from(B.execution));const V=s.from(B.definition);let le;return B.scope?typeof B.scope=="number"?le=B.scope:le=B.scope.uri:le=k.TaskScope.Workspace,!V||!le?void 0:{_id:B._id,definition:V,name:B.name,source:{extensionId:q.identifier.value,label:B.source,scope:le},execution:ce,isBackground:B.isBackground,group:n.from(B.group),presentationOptions:u.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}G.from=x;async function j(B,q,ce){if(B==null)return;let V;f.is(B.execution)?V=f.to(B.execution):w.is(B.execution)?V=w.to(B.execution):D.is(B.execution)&&(V=D.to(B._id,ce));const le=s.to(B.definition);let ae;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ae=B.source.scope:ae=await q.resolveWorkspaceFolder(d.URI.revive(B.source.scope)):ae=k.TaskScope.Workspace),!le||!ae)return;const ve=new k.Task(le,ae,B.name,B.source.label,V,B.problemMatchers);return B.isBackground!==void 0&&(ve.isBackground=B.isBackground),B.group!==void 0&&(ve.group=k.TaskGroup.from(B.group._id),ve.group&&(ve.group=R.deepClone(ve.group),B.group.isDefault&&(ve.group.isDefault=B.group.isDefault))),B.presentationOptions&&(ve.presentationOptions=u.to(B.presentationOptions)),B._id&&(ve._id=B._id),B.detail&&(ve.detail=B.detail),ve}G.to=j})(m=e.TaskDTO||(e.TaskDTO={}));var C;(function(G){function z(j){return j}G.from=z;function x(j){if(!!j)return Object.assign(Object.create(null),j)}G.to=x})(C=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(z,x,j){this._id=x,this._task=j,i.set(this,void 0),et(this,i,z,"f")}get task(){return this._task}terminate(){Me(this,i,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}i=new WeakMap;var $;(function(G){function z(x){return{id:x._id,task:void 0}}G.from=z})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let Q=class{constructor(z,x,j,B,q,ce,V,le){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=z.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=j,this._editorService=B,this._configurationService=q,this._terminalService=ce,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=V,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,x,j){if(!j)return new k.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:x,provider:j,extension:z}),this._proxy.$registerTaskProvider(B,x),new k.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(z,x){this._proxy.$registerTaskSystem(z,x)}fetchTasks(z){return this._proxy.$fetchTasks(C.from(z)).then(async x=>{const j=[];for(let B of x){const q=await m.to(B,this._workspaceProvider,this._providedCustomExecutions2);q&&j.push(q)}return j})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(x=>z.push(x)),z}terminateTask(z){if(!(z instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,x,j){const B=this._providedCustomExecutions2.get(z.id);if(B){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,B),this._terminalService.attachPtyToTerminal(x,await B.callback(j))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const x=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const x=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:x,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const x=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:z.exitCode})}$provideTasks(z,x){const j=this._handlers.get(z);if(!j)return Promise.reject(new Error("no handler found"));const B=[],q=(0,F.asPromise)(()=>j.provider.provideTasks(_.CancellationToken.None)).then(ce=>this.provideTasksInternal(x,B,j,ce));return new Promise(ce=>{q.then(V=>{Promise.all(B).then(()=>{ce(V)})})})}async $resolveTask(z,x){const j=this._handlers.get(z);if(!j)return Promise.reject(new Error("no handler found"));if(x.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${j.type}].`);const B=await m.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const q=await j.provider.resolveTask(B,_.CancellationToken.None);if(!q)return;this.checkDeprecation(q,j);const ce=m.from(q,j.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(ce.execution)&&await this.addCustomExecution(ce,q,!0),await this.resolveTaskInternal(ce)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,x,j){const B=await this._proxy.$createTaskId(z);!j&&!this._providedCustomExecutions2.has(B)&&this._notProvidedCustomExecutions.add(B),this._providedCustomExecutions2.set(B,x.execution)}async getTaskExecution(z,x){if(typeof z=="string"){const q=this._taskExecutionPromises.get(z);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let j=this._taskExecutionPromises.get(z.id);if(j)return j;const B=new Promise(async(q,ce)=>{const V=x||await m.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);V?q(new L(this,z.id,V)):ce("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,B),B.then(q=>(this._taskExecutions.set(z.id,q),q),q=>Promise.reject(q))}checkDeprecation(z,x){z._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let j=this._notProvidedCustomExecutions.values(),B=j.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=j.next()}};Q=Be([ze(0,h.IExtHostRpcService),ze(1,a.IExtHostInitDataService),ze(2,y.IExtHostWorkspace),ze(3,T.IExtHostDocumentsAndEditors),ze(4,t.IExtHostConfiguration),ze(5,r.IExtHostTerminalService),ze(6,b.ILogService),ze(7,c.IExtHostApiDeprecationService)],Q),e.ExtHostTaskBase=Q;let se=class extends Q{constructor(z,x,j,B,q,ce,V,le){super(z,x,j,B,q,ce,V,le);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:I.PlatformToString(0)})}async executeTask(z,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const j=m.from(x,z);if(j===void 0)throw new Error("Task is not valid");if(D.is(j.execution))await this.addCustomExecution(j,x,!1);else throw new S.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(j),x);return this._proxy.$executeTask(j).catch(q=>{throw new Error(q)}),B}provideTasksInternal(z,x,j,B){const q=[];if(B)for(let ce of B){this.checkDeprecation(ce,j),(!ce.definition||!z[ce.definition.type])&&this._logService.warn(`The task [${ce.source}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`);const V=m.from(ce,j.extension);V&&D.is(V.execution)?(q.push(V),x.push(this.addCustomExecution(V,ce,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:j.extension}}async resolveTaskInternal(z){if(D.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,x,j){}};se=Be([ze(0,h.IExtHostRpcService),ze(1,a.IExtHostInitDataService),ze(2,y.IExtHostWorkspace),ze(3,T.IExtHostDocumentsAndEditors),ze(4,t.IExtHostConfiguration),ze(5,r.IExtHostTerminalService),ze(6,b.ILogService),ze(7,c.IExtHostApiDeprecationService)],se),e.WorkerExtHostTask=se,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(we[217],be([0,1,16,50,27,78,20,11,17,24,9,10,2,110,131,85,44,92,216,38]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(D,P,n,m){this.configurationService=D,this.workspaceContextService=P,this.editorGroupsService=n,this.pathService=m}text(D,P,n={}){D=this.getContentPattern(D,n);const m=this.configurationService.getValue(),C=P&&P.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(P?.map(g.toWorkspaceFolder),n),type:2,contentPattern:D,previewOptions:n.previewOptions,maxFileSize:n.maxFileSize,usePCRE2:m.search.usePCRE2||C||!1,beforeContext:n.beforeContext,afterContext:n.afterContext,userDisabledExcludesAndIgnoreFiles:n.disregardExcludeSettings&&n.disregardIgnoreFiles}}getContentPattern(D,P){const n=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const m={...D,wordSeparators:n.editor.wordSeparators};return this.isCaseSensitive(D,P)&&(m.isCaseSensitive=!0),this.isMultiline(D)&&(m.isMultiline=!0),m}file(D,P={}){return{...this.commonQuery(D,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(D,P){return D?(D=Array.isArray(D)?D.map(o):o(D),P?this.parseSearchPaths(D):{pattern:i(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],P={}){const n=this.handleIncludeExclude(P.includePattern,P.expandPatterns),m=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),C=D.length>1,L=(n.searchPaths&&n.searchPaths.length?n.searchPaths.map(se=>this.getFolderQueryForSearchPath(se,P,m)):D.map(se=>this.getFolderQueryForRoot(se,P,m,C))).filter(se=>!!se),$={_reason:P._reason,folderQueries:L,usingSearchPaths:!!(n.searchPaths&&n.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:m.pattern,includePattern:n.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const G=d.coalesce(d.flatten(this.editorGroupsService.groups.map(x=>x.editors.map(j=>j.resource)))).filter(x=>(0,c.pathIncludedInQuery)($,x.fsPath)),z=this.commonQueryFromFileList(G);return{...$,...z}}const Q=P.extraFileResources&&P.extraFileResources.filter(se=>(0,c.pathIncludedInQuery)($,se.fsPath));return $.extraFileResources=Q&&Q.length?Q:void 0,$}commonQueryFromFileList(D){const P=[],n=new R.ResourceMap,m={};let C=!1;return D.forEach(L=>{if(L.scheme===k.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(L)){const Q=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:y.dirname(L.fsPath)});let se=n.get(Q);se||(C=!0,se={folder:Q,includePattern:{}},P.push(se),n.set(Q,se));const G=y.relative(Q.fsPath,L.fsPath);(0,_.assertIsDefined)(se.includePattern)[G.replace(/\\/g,"/")]=!0}else L.fsPath&&(C=!0,m[L.fsPath]=!0)}),{folderQueries:P,includePattern:m,usingSearchPaths:!0,excludePattern:C?void 0:{"**/*":!0}}}isCaseSensitive(D,P){if(P.isSmartCase){if(D.isRegExp){if(t.containsUppercaseCharacter(D.pattern,!0))return!0}else if(t.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,h.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const P=z=>y.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),m=(Array.isArray(D)?D:s(D)).map(z=>{const x=this.pathService.resolvedUserHome;return x?(0,A.untildify)(z,x.scheme===k.Schemas.file?x.fsPath:x.path):z}),C=F.groupBy(m,z=>P(z)?"searchPaths":"exprSegments"),L=(C.exprSegments||[]).map(z=>t.rtrim(z,"/")).map(z=>t.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),u(z))),$={},Q=this.expandSearchPathPatterns(C.searchPaths||[]);Q&&Q.length&&($.searchPaths=Q);const se=d.flatten(L),G=i(...se);return G&&($.pattern=G),$}getExcludesForFolder(D,P){return P.disregardExcludeSettings?void 0:(0,c.getExcludes)(D,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const P=d.flatten(D.map(m=>{let{pathPortion:C,globPortion:L}=S(m);L&&(L=f(L));const $=this.expandOneSearchPath(C);return d.flatten($.map(Q=>this.resolveOneSearchPathPattern(Q,L)))})),n=new Map;return P.forEach(m=>{const C=m.searchPath.toString(),L=n.get(C);L?m.pattern&&(L.pattern=L.pattern||{},L.pattern[m.pattern]=!0):n.set(C,{searchPath:m.searchPath,pattern:m.pattern?i(m.pattern):void 0})}),Array.from(n.values())}expandOneSearchPath(D){if(y.isAbsolute(D)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==k.Schemas.file?[{searchPath:P[0].uri.with({path:D})}]:[{searchPath:r.URI.file(y.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=o(D),D.startsWith("../")||D===".."){const m=y.posix.resolve(P.path,D);return[{searchPath:P.with({path:m})}]}const n=f(D);return[{searchPath:P,pattern:n}]}else{if(D==="./"||D===".\\")return[];{const P=D.replace(/^\.[\/\\]/,""),m=this.workspaceContextService.getWorkspace().folders.map(C=>{const L=P.match(new RegExp(`^${t.escapeRegExpCharacters(C.name)}(?:/(.*)|$)`));return L?{match:L,folder:C}:null}).filter(_.isDefined);if(m.length)return m.map(C=>{const L=C.match[1];return{searchPath:C.folder.uri,pattern:L&&f(L)}});{const C=D.match(/\.[\/\\](.+)[\/\\]?/),L=C?C[1]:D,$=a.localize(0,null,L);throw new Error($)}}}}resolveOneSearchPathPattern(D,P){const n=D.pattern&&P?`${D.pattern}/${P}`:D.pattern||P,m=[{searchPath:D.searchPath,pattern:n}];return n&&!n.endsWith("**")&&m.push({searchPath:D.searchPath,pattern:n+"/**"}),m}getFolderQueryForSearchPath(D,P,n){const m=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(D.searchPath),P,n,!1);return m?{...m,includePattern:D.pattern}:null}getFolderQueryForRoot(D,P,n,m){let C;const L=r.URI.isUri(D)?D:D.uri;if(n.searchPaths){const z=n.searchPaths.filter(x=>(0,T.isEqual)(x.searchPath,L))[0];if(z&&!z.pattern)return null;z&&(C=z.pattern)}const $=this.configurationService.getValue({resource:L}),se={...this.getExcludesForFolder($,P)||{},...C||{}},G=r.URI.isUri(D)?(0,T.basename)(D):D.name;return{folder:L,folderName:m?G:void 0,excludePattern:Object.keys(se).length>0?se:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!$.search.followSymlinks}}};p=Be([ze(0,l.IConfigurationService),ze(1,g.IWorkspaceContextService),ze(2,I.IEditorGroupsService),ze(3,b.IPathService)],p),e.QueryBuilder=p;function S(w){const D=w.match(/[\*\{\}\(\)\[\]\?]/);if(D){const P=D.index,n=w.substr(0,P).match(/[/|\\][^/\\]*$/);if(n){let m=w.substr(0,n.index);return m.match(/[/\\]/)||(m+="/"),{pathPortion:m,globPortion:w.substr((n.index||0)+1)}}}return{pathPortion:w}}function i(...w){return w.length?w.reduce((D,P)=>(D[P]=!0,D),Object.create(null)):void 0}function s(w){return E.splitGlobAware(w,",").map(D=>D.trim()).filter(D=>!!D.length)}function u(w){return[`**/${w}/**`,`**/${w}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function o(w){return w.replace(/\\/g,"/")}function f(w){return o(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(w,D){w=d.distinct(w,m=>m.toString());const P=[],n=D.getWorkspace();return w&&w.forEach(m=>{let C;if(D.getWorkbenchState()===2)C=(0,T.relativePath)(n.folders[0].uri,m),C&&C!=="."&&(C="./"+C);else{const L=D.getWorkspaceFolder(m);if(L){const $=L.name;if(n.folders.filter(se=>se.name===$).length===1){const se=(0,T.relativePath)(L.uri,m);se===""?C=`./${L.name}`:C=`./${L.name}/${se}`}else C=m.fsPath}}C&&P.push(C)}),P}e.resolveResourcesForSearchIncludes=v}),define(we[218],be([0,1,24,2,21,15,4,217,38,44]),function(ie,e,d,F,E,A,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function _(l,g){const I=g.activationEvents;if(!I)return Promise.resolve(void 0);const b=[],c=[];for(const o of I)if(/^workspaceContains:/.test(o)){const f=o.substr("workspaceContains:".length);f.indexOf("*")>=0||f.indexOf("?")>=0||l.forceUsingSearch?c.push(f):b.push(f)}if(b.length===0&&c.length===0)return Promise.resolve(void 0);let p;const S=new Promise((o,f)=>{p=o}),i=o=>p({activationEvent:o}),s=Promise.all(b.map(o=>r(l,o,i))).then(()=>{}),u=h(l,g.identifier,c,i);return Promise.all([s,u]).then(()=>{p(void 0)}),S}e.checkActivateWorkspaceContainsExtension=_;async function r(l,g,I){for(const b of l.folders)if(await l.exists(d.joinPath(F.URI.revive(b),g))){I(`workspaceContains:${g}`);return}}async function h(l,g,I,b){if(I.length===0)return Promise.resolve(void 0);const c=new E.CancellationTokenSource,p=l.checkExists(l.folders,I,c.token),S=setTimeout(async()=>{c.cancel(),b(`workspaceContainsTimeout:${I.join(",")}`)},t);let i=!1;try{i=await p}catch(s){A.isPromiseCanceledError(s)||A.onUnexpectedError(s)}c.dispose(),clearTimeout(S),i&&b(`workspaceContains:${I.join(",")}`)}function a(l,g,I,b){const c=l.get(R.IInstantiationService),p=l.get(y.ISearchService),i=c.createInstance(k.QueryBuilder).file(g.map(s=>(0,T.toWorkspaceFolder)(F.URI.revive(s))),{_reason:"checkExists",includePattern:I,exists:!0});return p.fileSearch(i,b).then(s=>!!s.limitHit,s=>A.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=a});var et=this&&this.__classPrivateFieldSet||function(ie,e,d,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Me=this&&this.__classPrivateFieldGet||function(ie,e,d,F){if(d==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?F:d==="a"?F.call(ie):F?F.value:e.get(ie)};define(we[33],be([0,1,122,17,75,24,13,7,20,2,14,5,32,178,73,31,30,176,15,26,23,152,6,86,4,29,74,12,60,66,37,3,218,70,154]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b,c,p,S,i,s,u,o,f,v,w,D,P,n,m,C,L){"use strict";var $,Q,se;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let G=class Wi extends k.Disposable{constructor(B,q,ce,V,le,ae,ve,Ae,Re,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new n.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=q,this._extHostContext=ce,this._initData=ve,this._extHostWorkspace=V,this._extHostConfiguration=le,this._logService=ae,this._extHostTunnelService=Re,this._extHostTerminalService=Oe,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new C.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=B.createChild(new w.ServiceCollection([a.IExtHostStorage,this._storage],[C.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(He=>Qe.add(c.ExtensionIdentifier.toKey(He))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,je,N)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(je),N)},actualActivateExtension:async(He,je)=>{if(Qe.has(c.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,je),new h.HostExtension;const N=this._registry.getExtensionDescription(He);return this._activateExtension(N,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){b.onUnexpectedError(B)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(q){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,q){return this._activator.activateByEvent(B,q)}_activateById(B,q){return this._activator.activateById(B,q)}activateByIdWithErrors(B,q){return this._activateById(B,q).then(()=>{const ce=this._activator.getActivatedExtension(B);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=y.TernarySearchTree.forPaths(),q=this._registry.getAllExtensionDescriptions().map(ce=>{if(!!this._getEntryPoint(ce))return this._hostUtils.realpath(ce.extensionLocation.fsPath).then(V=>B.set(T.URI.file(V).fsPath,ce))});this._extensionPathIndex=Promise.all(q).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return q;const ce=this._activator.getActivatedExtension(B);if(!ce)return q;try{typeof ce.module.deactivate=="function"&&(q=Promise.resolve(ce.module.deactivate()).then(void 0,V=>(this._logService.error(V),Promise.resolve(void 0))))}catch(V){this._logService.error(V)}try{(0,k.dispose)(ce.subscriptions)}catch(V){this._logService.error(V)}return q}async _activateExtension(B,q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,q).then(ce=>{const V=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,q),this._logExtensionActivationTimes(B,q,"success",V),ce},ce=>{throw this._logExtensionActivationTimes(B,q,"failure"),ce})}_logExtensionActivationTimes(B,q,ce,V){const le=z(B,q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...V||{},outcome:ce})}_doActivateExtension(B,q){const ce=z(B,q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const V=this._getEntryPoint(B);if(!V)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(q)}`),this._logService.flush();const le=new h.ExtensionActivationTimesBuilder(q.startup);return Promise.all([this._loadCommonJSModule(B.identifier,(0,A.joinPath)(B.extensionLocation,V),le),this._loadExtensionContext(B)]).then(ae=>(E.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Wi._callActivate(this._logService,B.identifier,ae[0],ae[1],le))).then(ae=>(E.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),ae))}_loadExtensionContext(B){const q=new S.ExtensionGlobalMemento(B,this._storage),ce=new S.ExtensionMemento(B.identifier.value,!1,this._storage),V=new L.ExtensionSecrets(B,this._secretState),le=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ae=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([q.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Ae;return Object.freeze({globalState:q,workspaceState:ce,secrets:V,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Re){return F.join(B.extensionLocation.fsPath,Re)},get storagePath(){return ve._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(B).fsPath},get logPath(){return F.join(ve._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return T.URI.joinPath(ve._initData.logsLocation,B.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(B)},get globalStorageUri(){return ve._storagePath.globalValue(B)},get extensionMode(){return le},get extension(){return Ae===void 0&&(Ae=new x(ve,B.identifier,B,ae)),Ae},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(B),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,q,ce,V,le){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,q,ce,V,le).then(ae=>new h.ActivatedExtension(!1,null,le.build(),ce,ae,V.subscriptions))}static _callActivateOptional(B,q,ce,V,le){if(typeof ce.activate=="function")try{le.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${q.value}`);const ae=typeof global=="object"?global:self,ve=ce.activate.apply(ae,[V]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(Ae=>(le.activateResolveStop(),Ae))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(ce)}_activateOneStartupFinished(B,q){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:q}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const q of B.activationEvents)q==="onStartupFinished"&&this._activateOneStartupFinished(B,q)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(q),V=Promise.all([B,ce]).then(()=>{});return Promise.race([V,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),V}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(q=>this._handleWorkspaceContainsEagerExtension(B,q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,q){if(this.isActivated(q.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,V={folders:B.map(ae=>ae.uri),forceUsingSearch:ce,exists:ae=>this._hostUtils.exists(ae.fsPath),checkExists:(ae,ve,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(ae,ve,Ae)},le=await(0,m.checkActivateWorkspaceContainsExtension)(V,q);if(!!le)return this._activateById(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:le.activationEvent}).then(void 0,ae=>this._logService.error(ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:q}=this._initData.environment;if(!B||!q)throw new Error(d.localize(0,null));const ce=await this._loadCommonJSModule(null,q,new h.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(d.localize(1,null,q.toString()));return new Promise((V,le)=>{const ae=(Re,Oe)=>{Re?le(Re):V(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,A.originalFSPath)(q),Ae=ce.run(ve,ae);Ae&&Ae.then&&Ae.then(()=>{V(0)}).catch(Re=>{le(Re.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,q){return this._resolvers[B]=q,(0,k.toDisposable)(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const q=B.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const ce=B.substr(0,q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(B,q){const{authorityPrefix:ce,resolver:V}=await this._activateAndGetResolver(B);if(!V)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(V)),E.mark(`code/extHost/willResolveAuthority/${ce}`);const le=await V.resolve(B,{resolveAttempt:q});E.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const ae={authority:B,host:le.host,port:le.port,connectionToken:le.connectionToken},ve={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:ae,options:ve,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(E.mark(`code/extHost/didResolveAuthorityError/${ce}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(B,q){const{authorityPrefix:ce,resolver:V}=await this._activateAndGetResolver(B);if(!V)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ce}`);const le=T.URI.revive(q);if(typeof V.getCanonicalURI=="undefined")return le;const ae=await(0,R.asPromise)(()=>V.getCanonicalURI(le));return ae||le}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,q){return q===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(B,!1))}async $activate(B,q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,q),!0):!1}async $deltaExtensions(B,q){B.forEach(V=>V.extensionLocation=T.URI.revive(V.extensionLocation));const ce=await this.getExtensionPathIndex();return await Promise.all(q.map(async V=>{const le=this._registry.getExtensionDescription(V);if(!le)return;const ae=await this._hostUtils.realpath(le.extensionLocation.fsPath);ce.delete(T.URI.file(ae).fsPath)})),await Promise.all(B.map(async V=>{const le=await this._hostUtils.realpath(V.extensionLocation.fsPath);ce.set(T.URI.file(le).fsPath,V)})),this._registry.deltaExtensions(B,q),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let q=p.VSBuffer.alloc(B),ce=Math.random()%256;for(let V=0;V<B;V++)q.writeUInt8(ce,V);return q}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};G=Be([ze(0,u.IInstantiationService),ze(1,e.IHostUtils),ze(2,v.IExtHostRpcService),ze(3,l.IExtHostWorkspace),ze(4,r.IExtHostConfiguration),ze(5,t.ILogService),ze(6,o.IExtHostInitDataService),ze(7,f.IExtensionStoragePaths),ze(8,D.IExtHostTunnelService),ze(9,P.IExtHostTerminalService)],G),e.AbstractExtHostExtensionService=G;function z(j,B){return{id:j.identifier.value,name:j.name,extensionVersion:j.version,publisherDisplayName:j.publisher,activationEvents:j.activationEvents?j.activationEvents.join(","):null,isBuiltin:j.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class x{constructor(B,q,ce,V){$.set(this,void 0),Q.set(this,void 0),se.set(this,void 0),et(this,$,B,"f"),et(this,Q,q,"f"),et(this,se,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=F.normalize((0,A.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=V}get isActive(){return Me(this,$,"f").isActivated(Me(this,se,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,$,"f").getExtensionExports(Me(this,se,"f"))}activate(){return Me(this,$,"f").activateByIdWithErrors(Me(this,se,"f"),{startup:!1,extensionId:Me(this,Q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,$=new WeakMap,Q=new WeakMap,se=new WeakMap}),define(we[100],be([0,1,17,2,3,13,5,6,162,31,33,48,167,32,163,12,4,10,61,64]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let p=class{constructor(w,D,P,n,m,C){this._workspaceService=D,this._extensionService=P,this._editorsService=n,this._configurationService=m,this._editorTabs=C,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=w.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange($=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(w,D){const P=w;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let n=`debug:${encodeURIComponent(P.path||"")}`,m="?";return D&&(n+=`${m}session=${encodeURIComponent(D.id)}`,m="&"),n+=`${m}ref=${P.sourceReference}`,F.URI.parse(n)}else{if(P.path)return F.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(w){const D=[];for(const P of w.getAllExtensionDescriptions())if(P.contributes){const n=P.contributes.debuggers;if(n&&n.length>0)for(const m of n)(0,a.isDebuggerMainContribution)(m)&&D.push(m.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const w=[];return this._breakpoints.forEach(D=>w.push(D)),w}addBreakpoints(w){this.startBreakpoints();const D=w.filter(m=>{const C=m.id;return this._breakpoints.has(C)?!1:(this._breakpoints.set(C,m),!0)});this.fireBreakpointChanges(D,[],[]);const P=[],n=new Map;for(const m of D)if(m instanceof k.SourceBreakpoint){let C=n.get(m.location.uri.toString());C||(C={type:"sourceMulti",uri:m.location.uri,lines:[]},n.set(m.location.uri.toString(),C),P.push(C)),C.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof k.FunctionBreakpoint&&P.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(w){this.startBreakpoints();const D=w.filter(C=>this._breakpoints.delete(C.id));this.fireBreakpointChanges([],D,[]);const P=D.filter(C=>C instanceof k.SourceBreakpoint).map(C=>C.id),n=D.filter(C=>C instanceof k.FunctionBreakpoint).map(C=>C.id),m=D.filter(C=>C instanceof k.DataBreakpoint).map(C=>C.id);return this._debugServiceProxy.$unregisterBreakpoints(P,n,m)}startDebugging(w,D,P){return this._debugServiceProxy.$startDebugging(w?w.uri:void 0,D,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,debugUI:P.debugUI})}stopDebugging(w){return this._debugServiceProxy.$stopDebugging(w?w.id:void 0)}registerDebugConfigurationProvider(w,D,P){if(!D)return new k.Disposable(()=>{});const n=this._configProviderHandleCounter++;return this._configProviders.push({type:w,handle:n,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(w,P,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,n),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(m=>m.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(n)})}registerDebugAdapterDescriptorFactory(w,D,P){if(!P)return new k.Disposable(()=>{});if(!this.definesDebugType(w,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const n=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:n,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,n),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(m=>m.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(n)})}registerDebugAdapterTrackerFactory(w,D){if(!D)return new k.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:w,handle:P,factory:D}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(n=>n.factory!==D)})}async $runInTerminal(w,D){return Promise.resolve(void 0)}async $substituteVariables(w,D){if(!this._variableResolver){const[m,C]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(m||[],this._editorsService,C)}let P;const n=await this.getFolder(w);return n&&(P={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,D)}createDebugAdapter(w,D){if(w.type==="implementation")return new o(w.implementation)}createSignService(){}async $startDASession(w,D){const P=this,n=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(n.type),n).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}' (extension might have failed to activate)`);const C=this.convertToDto(m),L=this.createDebugAdapter(C,n);if(!L)throw new Error(`Couldn't create a debug adapter for type '${n.type}'.`);const $=L;return this._debugAdapters.set(w,$),this.getDebugAdapterTrackers(n).then(Q=>(Q&&this._debugAdaptersTrackers.set(w,Q),$.onMessage(async se=>{if(se.type==="request"&&se.command==="handshake"){const G=se,z={type:"response",seq:0,command:G.command,request_seq:G.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const x=await this._signService.sign(G.arguments.value);z.body={signature:x},$.sendResponse(z)}else throw new Error("no signer")}catch(x){z.success=!1,z.message=x.message,$.sendResponse(z)}}else Q&&Q.onDidSendMessage&&Q.onDidSendMessage(se),se=(0,a.convertToVSCPaths)(se,!0),P._debugServiceProxy.$acceptDAMessage(w,se)}),$.onError(se=>{Q&&Q.onError&&Q.onError(se),this._debugServiceProxy.$acceptDAError(w,se.name,se.message,se.stack)}),$.onExit(se=>{Q&&Q.onExit&&Q.onExit((0,I.withNullAsUndefined)(se),void 0),this._debugServiceProxy.$acceptDAExit(w,(0,I.withNullAsUndefined)(se),void 0)}),Q&&Q.onWillStartSession&&Q.onWillStartSession(),$.startSession()))})}$sendDAMessage(w,D){D=(0,a.convertToDAPaths)(D,!1);const P=this._debugAdaptersTrackers.get(w);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(D);const n=this._debugAdapters.get(w);n&&n.sendMessage(D)}$stopDASession(w){const D=this._debugAdaptersTrackers.get(w);this._debugAdaptersTrackers.delete(w),D&&D.onWillStopSession&&D.onWillStopSession();const P=this._debugAdapters.get(w);return this._debugAdapters.delete(w),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(w){const D=[],P=[],n=[];if(w.added)for(const m of w.added){const C=m.id;if(C&&!this._breakpoints.has(C)){let L;if(m.type==="function")L=new k.FunctionBreakpoint(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")L=new k.DataBreakpoint(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const $=F.URI.revive(m.uri);L=new k.SourceBreakpoint(new k.Location($,new k.Position(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}L._id=C,this._breakpoints.set(C,L),D.push(L)}}if(w.removed)for(const m of w.removed){const C=this._breakpoints.get(m);C&&(this._breakpoints.delete(m),P.push(C))}if(w.changed){for(const m of w.changed)if(m.id){const C=this._breakpoints.get(m.id);if(C){if(C instanceof k.FunctionBreakpoint&&m.type==="function"){const L=C;L.enabled=m.enabled,L.condition=m.condition,L.hitCondition=m.hitCondition,L.logMessage=m.logMessage,L.functionName=m.functionName}else if(C instanceof k.SourceBreakpoint&&m.type==="source"){const L=C;L.enabled=m.enabled,L.condition=m.condition,L.hitCondition=m.hitCondition,L.logMessage=m.logMessage,L.location=new k.Location(F.URI.revive(m.uri),new k.Position(m.line,m.character))}n.push(C)}}}this.fireBreakpointChanges(D,P,n)}$provideDebugConfigurations(w,D,P){return(0,A.asPromise)(async()=>{const n=this.getConfigProviderByHandle(w);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.getFolder(D);return n.provideDebugConfigurations(m,P)}).then(n=>{if(!n)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return n})}$resolveDebugConfiguration(w,D,P,n){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(w);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.getFolder(D);return m.resolveDebugConfiguration(C,P,n)})}$resolveDebugConfigurationWithSubstitutedVariables(w,D,P,n){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(w);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.getFolder(D);return m.resolveDebugConfigurationWithSubstitutedVariables(C,P,n)})}async $provideDebugAdapter(w,D){const P=this.getAdapterDescriptorFactoryByHandle(w);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const n=await this.getSession(D);return this.getAdapterDescriptor(P,n).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}'`);return this.convertToDto(m)})}async $acceptDebugSessionStarted(w){const D=await this.getSession(w);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(w){const D=await this.getSession(w);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(w){this._activeDebugSession=w?await this.getSession(w):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(w,D){const P=await this.getSession(w);P&&P._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(w,D){const n={session:await this.getSession(w),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(n)}convertToDto(w){if(w instanceof k.DebugAdapterExecutable)return{type:"executable",command:w.command,args:w.args,options:w.options};if(w instanceof k.DebugAdapterServer)return{type:"server",port:w.port,host:w.host};if(w instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:w.path};if(w instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:w.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(w){const D=this._adapterFactories.filter(P=>P.type===w);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(w){const D=this._adapterFactories.filter(P=>P.handle===w);if(D.length>0)return D[0].factory}getConfigProviderByHandle(w){const D=this._configProviders.filter(P=>P.handle===w);if(D.length>0)return D[0].provider}definesDebugType(w,D){if(w.contributes){const P=w.contributes.debuggers;if(P&&P.length>0){for(const n of P)if(n.label&&n.type&&n.type===D)return!0}}return!1}getDebugAdapterTrackers(w){const P=w.configuration.type,n=this._trackerFactories.filter(m=>m.type===P||m.type==="*").map(m=>(0,A.asPromise)(()=>m.factory.createDebugAdapterTracker(w)).then(C=>C,C=>null));return Promise.race([Promise.all(n).then(m=>{const C=m.filter(L=>!!L);if(C.length>0)return new u(C)}),new Promise((m,C)=>{const L=setTimeout(()=>{clearTimeout(L),C(new Error("timeout"))},1e3)})]).catch(m=>{})}async getAdapterDescriptor(w,D){const P=D.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new k.DebugAdapterServer(P));if(w){const m=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>w.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,m))).then(C=>{if(C)return C})}const n=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,n))}daExecutableFromPackage(w,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(w,D,P){(w.length>0||D.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:w,removed:D,changed:P}))}async getSession(w){if(w)if(typeof w=="string"){const D=this._debugSessions.get(w);if(D)return D}else{let D=this._debugSessions.get(w.id);if(!D){const P=await this.getFolder(w.folderUri),n=w.parent?this._debugSessions.get(w.parent):void 0;D=new S(this._debugServiceProxy,w.id,w.type,w.name,P,w.configuration,n),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(w){if(w){const D=F.URI.revive(w);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};p=Be([ze(0,l.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,h.IExtHostConfiguration),ze(5,c.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class S{constructor(w,D,P,n,m,C,L){this._debugServiceProxy=w,this._id=D,this._type=P,this._name=n,this._workspaceFolder=m,this._configuration=C,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(w){this._name=w,this._debugServiceProxy.$setDebugSessionName(this._id,w)}get parentSession(){return this._parentSession}_acceptNameChanged(w){this._name=w}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(w,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,w,D)}getDebugProtocolBreakpoint(w){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,w.id)}}e.ExtHostDebugSession=S;class i{constructor(w){this.value=Object.freeze({append(D){w.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=i;class s extends r.AbstractVariableResolverService{constructor(w,D,P,n,m){function C(){if(D){const L=D.activeEditor();if(L)return L.document.uri;const $=n.tabs.filter(Q=>Q.isActive);if($.length>0)return $[0].resource}}super({getFolderUri:L=>{const $=w.filter(Q=>Q.name===L);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>w.length,getConfigurationValue:(L,$)=>P.getConfiguration(void 0,L).get($),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=C();if(L)return d.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const L=C();if(L){const $=m.getWorkspaceFolder(L);if($)return d.normalize($.uri.fsPath)}}},getSelectedText:()=>{if(D){const L=D.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(D){const L=D.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=s;class u{constructor(w){this.trackers=w}onWillStartSession(){this.trackers.forEach(w=>w.onWillStartSession?w.onWillStartSession():void 0)}onWillReceiveMessage(w){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(w):void 0)}onDidSendMessage(w){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(w):void 0)}onWillStopSession(){this.trackers.forEach(w=>w.onWillStopSession?w.onWillStopSession():void 0)}onError(w){this.trackers.forEach(D=>D.onError?D.onError(w):void 0)}onExit(w,D){this.trackers.forEach(P=>P.onExit?P.onExit(w,D):void 0)}}class o extends y.AbstractDebugAdapter{constructor(w){super();this.implementation=w,w.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(w){this.implementation.handleMessage(w)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let f=class extends p{constructor(w,D,P,n,m,C){super(w,D,P,n,m,C)}createVariableResolver(w,D,P){return new s(w,D,P,this._editorTabs)}};f=Be([ze(0,l.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,h.IExtHostConfiguration),ze(5,c.IExtHostEditorTabs)],f),e.WorkerExtHostDebugService=f}),define(we[219],be([0,1,75,2,5,32,30,26,12,29,4,33,61,14]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(c,p,S,i,s,u,o){this._apiFactory=c,this._extensionRegistry=p,this._instaService=S,this._extHostConfiguration=i,this._extHostExtensionService=s,this._initData=u,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,p,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,p,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let p of c.nodeModuleName)this._factories.set(p,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(p=>c.alternativeModuleName(p))}};a=Be([ze(2,t.IInstantiationService),ze(3,A.IExtHostConfiguration),ze(4,_.IExtHostExtensionService),ze(5,T.IExtHostInitDataService),ze(6,h.ILogService)],a),e.RequireInterceptor=a;class l{constructor(c,p,S,i,s){this._apiFactory=c,this._extensionPaths=p,this._extensionRegistry=S,this._configProvider=i,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,p){const S=this._extensionPaths.findSubstr(p.fsPath);if(S){let i=this._extApiImpl.get(k.ExtensionIdentifier.toKey(S.identifier));return i||(i=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(S.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((s,u)=>i+=`	${u} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(c,p){this.nodeModuleName="keytar";const{environment:S}=p,i=c.getProxy(E.MainContext.MainThreadKeytar);if(S.appRoot){let s=S.appRoot.fsPath;r.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,u)=>i.$getPassword(s,u),setPassword:(s,u,o)=>i.$setPassword(s,u,o),deletePassword:(s,u)=>i.$deletePassword(s,u),findPassword:s=>i.$findPassword(s),findCredentials(s){return i.$findCredentials(s)}}}load(c,p){return this._impl}alternativeModuleName(c){const p=c.length;if(p<=7||!this.alternativeNames)return;const S=p-7;if((c.charAt(S)==="/"||c.charAt(S)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};g=Be([ze(0,y.IExtHostRpcService),ze(1,T.IExtHostInitDataService)],g);let I=class{constructor(c,p,S){this._extensionPaths=c,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(E.MainContext.MainThreadTelemetry);const i=S.getProxy(E.MainContext.MainThreadWindow);this._impl=(s,u)=>{const o=F.URI.parse(s);return u?this.callOriginal(s,u):o.scheme==="http"||o.scheme==="https"?i.$openUri(o,s,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?i.$openUri(o,s,{}):this.callOriginal(s,u)}}load(c,p,S){const i=this._extensionPaths.findSubstr(p.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=S(c),this._impl}callOriginal(c,p){return this.sendNoForwardTelemetry(),this._original(c,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=Be([ze(2,y.IExtHostRpcService)],I)}),define(we[220],be([0,1,13,15,75,7,2,5,213,14,56,60,29,141,12,67,33,37]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(p,S,i,s){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new y.RPCProtocol(p,null,s),S=b._transform(S,this._rpcProtocol);const u=new _.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());u.set(r.IExtHostInitDataService,{_serviceBrand:void 0,...S}),u.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),u.set(l.IURITransformerService,new l.URITransformerService(s)),u.set(g.IHostUtils,i);const o=new h.InstantiationService(u,!0),f=o.invokeFunction(P=>P.get(I.IExtHostTerminalService));this._disposables.add(f),this._logService=o.invokeFunction(P=>P.get(T.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",S),this._extensionService=o.invokeFunction(P=>P.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(P=>{Error.prepareStackTrace=(n,m)=>{let C="",L,$;for(const Q of m)C+=`
	at ${Q.toString()}`,$=Q.getFileName(),!L&&$&&(L=P.findSubstr($));return v.set(n,L),`${n.name||"Error"}: ${n.message||""}${C}`}});const w=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(P=>{const n=F.transformErrorForSerialization(P),m=v.get(P);m?w.$onExtensionRuntimeError(m.identifier,n):D.$onUnexpectedError(n)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const S=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),S]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(p,S){p.extensions.forEach(s=>s.extensionLocation=R.URI.revive(S.transformIncomingURIs(s.extensionLocation))),p.environment.appRoot=R.URI.revive(S.transformIncomingURIs(p.environment.appRoot));const i=p.environment.extensionDevelopmentLocationURI;return i&&(p.environment.extensionDevelopmentLocationURI=i.map(s=>R.URI.revive(S.transformIncomingURIs(s)))),p.environment.extensionTestsLocationURI=R.URI.revive(S.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=R.URI.revive(S.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=R.URI.revive(S.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=R.URI.revive(S.transformIncomingURIs(p.logsLocation)),p.logFile=R.URI.revive(S.transformIncomingURIs(p.logFile)),p.workspace=S.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=b}),define(we[221],be([0,1,17,21,55,27,24,194,38]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(r,h,a){this.config=r,this.provider=h,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=r.filePattern,this.includePattern=r.includePattern&&A.parse(r.includePattern),this.maxResults=r.maxResults||void 0,this.exists=r.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=r.excludePattern&&A.parse(r.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(r=>r.cancel()),this.activeCancellationTokens=new Set}search(r){const h=this.config.folderQueries||[];return new Promise((a,l)=>{const g=I=>{this.resultCount++,r(I)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const b=I.toString(),c=d.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,c)||this.matchFile(g,{base:I,basename:c})}),Promise.all(h.map(I=>this.searchInFolder(I,g))).then(I=>{a({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{l(new Error((0,E.toErrorMessage)(I)))})})}async searchInFolder(r,h){const a=new F.CancellationTokenSource,l=this.getSearchOptionsForFolder(r),g=this.initDirectoryTree(),I=new y.QueryGlobTester(this.config,r),b=!I.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(a),c=k.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,a.token),S=c.elapsed(),i=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(s=>{const u=d.posix.relative(r.folder.path,s.path);if(b){const o=d.basename(s.path);this.matchFile(h,{base:r.folder,relativePath:u,basename:o});return}this.addDirectoryEntries(g,r.folder,u,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,I,h),{providerTime:S,postProcessTime:i.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(r){const h=(0,y.resolvePatternsForProvider)(this.config.includePattern,r.includePattern),a=(0,y.resolvePatternsForProvider)(this.config.excludePattern,r.excludePattern);return{folder:r.folder,excludes:a,includes:h,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,followSymlinks:!r.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries({pathToEntries:r},h,a,l){if(a===this.filePattern){const I=d.basename(this.filePattern);this.matchFile(l,{base:h,relativePath:this.filePattern,basename:I})}function g(I){const b=d.basename(I),c=d.dirname(I);let p=r[c];p||(p=r[c]=[],g(c)),p.push({base:h,relativePath:I,basename:b})}g(a)}matchDirectoryTree({rootEntries:r,pathToEntries:h},a,l){const g=this,I=this.filePattern;function b(c){const p=A.hasSiblingFn(()=>c.map(S=>S.basename));for(let S=0,i=c.length;S<i;S++){const s=c[S],{relativePath:u,basename:o}=s;if(!a.includedInQuerySync(u,o,I!==o?p:void 0))continue;const f=h[u];if(f)b(f);else{if(u===I)continue;g.matchFile(l,s)}if(g.isLimitHit)break}}b(r)}matchFile(r,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||r(h))}}class t{constructor(){this.sessions=new Map}fileSearch(r,h,a,l){const g=this.getSessionTokenSource(r.cacheKey),I=new T(r,h,g&&g.token);let b=0;const c=p=>{b+=p.length,a(p.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(I,t.BATCH_SIZE,c,l).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:p.stats}}))}clearCache(r){const h=this.getSessionTokenSource(r);h&&h.cancel()}getSessionTokenSource(r){if(!!r)return this.sessions.has(r)||this.sessions.set(r,new F.CancellationTokenSource),this.sessions.get(r)}rawMatchToSearchItem(r){return r.relativePath?{resource:R.joinPath(r.base,r.relativePath)}:{resource:r.base}}doSearch(r,h,a,l){l.onCancellationRequested(()=>{r.cancel()});const g=b=>{b&&(I.push(b),h>0&&I.length>=h&&(a(I),I=[]))};let I=[];return r.search(g).then(b=>(I.length&&a(I),b),b=>(I.length&&a(I),Promise.reject(b)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[222],be([0,1,16,21,55,27,11,17,24,10,2,38]),function(ie,e,d,F,E,A,R,k,y,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class r{constructor(c,p,S,i){this.query=c,this.provider=p,this.fileUtils=S,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,p){const S=this.query.folderQueries||[],i=new F.CancellationTokenSource;return p.onCancellationRequested(()=>i.cancel()),new Promise((s,u)=>{this.collector=new a(c);let o=!1;const f=(v,w)=>{if(!o&&!this.isLimitHit){const D=this.resultSize(v);g(v)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,o=!0,i.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const P=this.resultSize(v);this.resultCount+=P,(P>0||!g(v))&&this.collector.add(v,w)}};Promise.all(S.map((v,w)=>this.searchInFolder(v,D=>f(D,w),i.token))).then(v=>{i.dispose(),this.collector.flush();const w=v.some(D=>!!D&&!!D.limitHit);s({limitHit:this.isLimitHit||w,messages:(0,d.flatten)(v.map(D=>D?.message?(0,T.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:this.processType}})},v=>{i.dispose();const w=(0,E.toErrorMessage)(v);u(new Error(w))})})}resultSize(c){return g(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,p){const S=Array.isArray(c.ranges)?c.ranges:[c.ranges],i=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:S.slice(0,p),preview:{matches:i.slice(0,p),text:c.preview.text},uri:c.uri}}async searchInFolder(c,p,S){const i=new _.QueryGlobTester(this.query,c),s=[],u={report:v=>{if(!this.validateProviderResult(v))return;const w=c.folder.scheme===R.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(v.uri))):void 0,D=y.relativePath(c.folder,v.uri);if(D){const P=i.includedInQuery(D,k.basename(D),w);(0,T.isPromise)(P)?s.push(P.then(n=>{n&&p(v)})):P&&p(v)}}},o=this.getSearchOptionsForFolder(c),f=await this.provider.provideTextSearchResults(h(this.query.contentPattern),o,u,S);return s.length&&await Promise.all(s),f}validateProviderResult(c){if(g(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const p=(0,_.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),S=(0,_.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),i={folder:t.URI.from(c.folder),excludes:S,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=r;function h(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class a{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,p=>this.sendItems(p))}add(c,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!y.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(l(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=a;function l(b){return g(b)?{preview:{matches:(0,d.mapArrayOrNot)(b.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:b.preview.text},ranges:(0,d.mapArrayOrNot)(b.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function g(b){return!!b.preview}e.extensionResultIsMatch=g;class I{constructor(c,p){this.maxBatchSize=c,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,p){!c||this.addItemToBatch(c,p)}addItems(c,p){!c||this.addItemsToBatch(c,p)}addItemToBatch(c,p){this.batch.push(c),this.batchSize+=p,this.onUpdate()}addItemsToBatch(c,p){this.batch=this.batch.concat(c),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(we[101],be([0,1,7,5,4,221,12,67,14,2,222]),function(ie,e,d,F,E,A,R,k,y,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(l,g,I){this.extHostRpc=l,this._uriTransformer=g,this._logService=I,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,g){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const I=this._handlePool++;return this._textSearchProvider.set(I,g),this._proxy.$registerTextSearchProvider(I,this._transformScheme(l)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(l,g){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const I=this._handlePool++;return this._fileSearchProvider.set(I,g),this._proxy.$registerFileSearchProvider(I,this._transformScheme(l)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(l,g,I,b){const c=r(I),p=this._fileSearchProvider.get(l);if(p)return this._fileSearchManager.fileSearch(c,p,S=>{this._proxy.$handleFileMatch(l,g,S.map(i=>i.resource))},b);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,g,I,b){const c=this._textSearchProvider.get(l);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const p=r(I);return this.createTextSearchManager(p,c).search(i=>this._proxy.$handleTextMatch(l,g,i),b)}$enableExtensionHostSearch(){}createTextSearchManager(l,g){return new t.TextSearchManager(l,g,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};_=Be([ze(0,R.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,y.ILogService)],_),e.ExtHostSearch=_;function r(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(h),extraFileResources:a.extraFileResources&&a.extraFileResources.map(l=>T.URI.revive(l))}}e.reviveQuery=r;function h(a){return{...a,folder:T.URI.revive(a.folder)}}}),define(we[223],be([0,1,21,15,3,35,2,145,80,112,54,59,5,183,182,47,184,32,185,186,187,169,188,48,33,190,170,193,195,196,96,172,201,202,203,73,37,205,173,8,6,208,49,97,31,30,50,159,192,87,95,99,100,101,14,67,12,29,197,156,66,71,180,206,155,74,72,211,209,210,181,45,204,207,70,64,88,199,98,200,11,143,198,153,191]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b,c,p,S,i,s,u,o,f,v,w,D,P,n,m,C,L,$,Q,se,G,z,x,j,B,q,ce,V,le,ae,ve,Ae,Re,Oe,Qe,He,je,N,K,Z,oe,H,re,he,Te,Ue,$e,Ke,_e,rt,W,Y,me,Ne,Ye,tt,at,vt,kt,ht,yt,It,ft,Je,Et,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(X){const ue=X.get(Z.IExtHostInitDataService),ge=X.get(Ne.IExtHostFileSystemInfo),fe=X.get(_e.IExtHostConsumerFileSystem),Ie=X.get(u.IExtHostExtensionService),xe=X.get(ce.IExtHostWorkspace),Le=X.get(kt.IExtHostTelemetry),Ve=X.get(I.IExtHostConfiguration),Xe=X.get(N.IURITransformerService),te=X.get(K.IExtHostRpcService),pe=X.get($.IExtHostStorage),ne=X.get(Ke.IExtensionStoragePaths),U=X.get(je.ILogService),Ce=X.get(re.IExtHostTunnelService),Se=X.get(he.IExtHostApiDeprecationService),qe=X.get(q.IExtHostWindow),We=X.get(at.IExtHostSecretState),it=X.get(vt.IExtHostEditorTabs);te.set(r.ExtHostContext.ExtHostFileSystemInfo,ge),te.set(r.ExtHostContext.ExtHostLogService,U),te.set(r.ExtHostContext.ExtHostWorkspace,xe),te.set(r.ExtHostContext.ExtHostConfiguration,Ve),te.set(r.ExtHostContext.ExtHostExtensionService,Ie),te.set(r.ExtHostContext.ExtHostStorage,pe),te.set(r.ExtHostContext.ExtHostTunnelService,Ce),te.set(r.ExtHostContext.ExtHostWindow,qe),te.set(r.ExtHostContext.ExtHostSecretState,We),te.set(r.ExtHostContext.ExtHostTelemetry,Le),te.set(r.ExtHostContext.ExtHostEditorTabs,it);const mt=te.set(r.ExtHostContext.ExtHostDecorations,X.get(Re.IExtHostDecorations)),wt=te.set(r.ExtHostContext.ExtHostDocumentsAndEditors,X.get(s.IExtHostDocumentsAndEditors)),ot=te.set(r.ExtHostContext.ExtHostCommands,X.get(l.IExtHostCommands)),ct=te.set(r.ExtHostContext.ExtHostTerminalService,X.get(Q.IExtHostTerminalService)),lt=te.set(r.ExtHostContext.ExtHostDebugService,X.get(Qe.IExtHostDebugService)),Tt=te.set(r.ExtHostContext.ExtHostSearch,X.get(He.IExtHostSearch)),_t=te.set(r.ExtHostContext.ExtHostTask,X.get(Oe.IExtHostTask)),Ut=te.set(r.ExtHostContext.ExtHostOutputService,X.get(P.IExtHostOutputService)),Bt=te.set(r.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(te)),Ct=te.set(r.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(te,wt)),$t=te.set(r.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(te,wt,U)),ti=te.set(r.ExtHostContext.ExtHostDocumentSaveParticipant,new S.ExtHostDocumentSaveParticipant(U,Ct,te.getProxy(r.MainContext.MainThreadBulkEdits))),gt=te.set(r.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(te,ot,wt,Ct,ne)),Yt=te.set(r.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(U,gt)),Ht=te.set(r.ExtHostContext.ExtHostNotebookEditors,new Et.ExtHostNotebookEditors(U,te,gt)),ii=te.set(r.ExtHostContext.ExtHostNotebookKernels,new ht.ExtHostNotebookKernels(te,ue,gt,U)),ni=te.set(r.ExtHostContext.ExtHostNotebookRenderers,new It.ExtHostNotebookRenderers(te,gt)),Pt=te.set(r.ExtHostContext.ExtHostEditors,new se.ExtHostEditors(te,wt)),Jt=te.set(r.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(te.getProxy(r.MainContext.MainThreadTreeViews),ot,U)),vi=te.set(r.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(te.getProxy(r.MainContext.MainThreadEditorInsets),Pt,ue)),Wt=te.set(r.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(te,U)),dt=te.set(r.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(te,Xe,Ct,ot,Wt,U,Se)),ri=te.set(r.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(te,dt)),Mt=te.set(r.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(te,U,wt)),Vt=te.set(r.ExtHostContext.ExtHostQuickOpen,(0,m.createExtHostQuickOpen)(te,xe,ot)),Xt=te.set(r.ExtHostContext.ExtHostSCM,new C.ExtHostSCM(te,ot,U)),si=te.set(r.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(te,ot,Ct)),ci=te.set(r.ExtHostContext.ExtHostProgress,new n.ExtHostProgress(te.getProxy(r.MainContext.MainThreadProgress))),wi=te.set(r.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(te)),di=te.set(r.ExtHostContext.ExtHostTheming,new H.ExtHostTheming(te)),oi=te.set(r.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(te)),bi=te.set(r.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(te,ot)),jt=te.set(r.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(te,{remote:ue.remote},xe,U,Se)),qt=te.set(r.ExtHostContext.ExtHostWebviewPanels,new Y.ExtHostWebviewPanels(te,jt,xe)),Ei=te.set(r.ExtHostContext.ExtHostCustomEditors,new W.ExtHostCustomEditors(te,Ct,ne,jt,qt)),_i=te.set(r.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(te,jt)),Gt=te.set(r.ExtHostContext.ExtHostTesting,new Ye.ExtHostTesting(te,ot)),yi=te.set(r.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(te));te.set(r.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(te,gt,wt,ot));const Zt=(0,le.values)(r.ExtHostContext);te.assertRegistered(Zt);const Si=new me.ExtHostBulkEdits(te,wt),Di=new a.ExtHostClipboard(te),Kt=new D.ExtHostMessageService(te,U),hi=new c.ExtHostDialogs(te),zt=new L.ExtHostStatusBar(te,ot.converter),Ft=new w.ExtHostLanguages(te,Ct);return h.ExtHostApiCommands.register(ot),function(Fe,Rt,Qt){const pt=function(){let J=!Fe.isUnderDevelopment;function de(ke){J||(U.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(nt){if(Array.isArray(nt))nt.forEach(ke);else if(typeof nt=="string")de(nt);else{const bt=nt;typeof bt.scheme=="undefined"&&de(nt),!Fe.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,V.throwProposedApiError)(Fe)}return nt}}(),Ci={getSession(J,de,ke){return ke?.forceNewSession&&(0,V.checkProposedApiEnabled)(Fe),oi.getSession(Fe,J,de,ke)},get onDidChangeSessions(){return oi.onDidChangeSessions},registerAuthenticationProvider(J,de,ke,nt){return oi.registerAuthenticationProvider(J,de,ke,nt)}},ki={registerCommand(J,de,ke){return ot.registerCommand(!0,J,de,ke)},registerTextEditorCommand(J,de,ke){return ot.registerCommand(!0,J,(...nt)=>{const bt=Pt.getActiveTextEditor();if(!bt){U.warn("Cannot execute "+J+" because there is no active text editor.");return}return bt.edit(Dt=>{de.apply(ke,[bt,Dt,...nt])}).then(Dt=>{Dt||U.warn("Edits from command "+J+" were not applied.")},Dt=>{U.warn("An error occurred while running command "+J,Dt)})})},registerDiffInformationCommand:(J,de,ke)=>((0,V.checkProposedApiEnabled)(Fe),ot.registerCommand(!0,J,async(...nt)=>{const bt=wt.activeEditor(!0);if(!bt){U.warn("Cannot execute "+J+" because there is no active text editor.");return}const Dt=await Pt.getDiffInformation(bt.id);de.apply(ke,[Dt,...nt])})),executeCommand(J,...de){return ot.executeCommand(J,...de)},getCommands(J=!1){return ot.getCommands(J)}},fi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get embedderIdentifier(){return ue.environment.embedderIdentifier},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return Le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,de){return qe.openUri(J,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===ue.environment.appUriScheme)return Bt.createAppUri(J);try{return await qe.asExternalUri(J,{allowTunneling:!!ue.remote.authority})}catch(de){if((0,Je.matchesScheme)(J,ft.Schemas.http)||(0,Je.matchesScheme)(J,ft.Schemas.https))return J;throw de}},get remoteName(){return(0,Ae.getRemoteName)(ue.remote.authority)},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(fi);const mi=ue.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,Ii={createTestController(J,de){return Gt.createTestController(J,de)},createTestObserver(){return(0,V.checkProposedApiEnabled)(Fe),Gt.createTestObserver()},runTests(J){return(0,V.checkProposedApiEnabled)(Fe),Gt.runTests(J)},get onDidChangeTestResults(){return(0,V.checkProposedApiEnabled)(Fe),Gt.onResultsChanged},get testResults(){return(0,V.checkProposedApiEnabled)(Fe),Gt.results}},Pi={getExtension(J){const de=Rt.getExtensionDescription(J);if(de)return new u.Extension(Ie,Fe.identifier,de,mi)},get all(){return Rt.getAllExtensionDescriptions().map(J=>new u.Extension(Ie,Fe.identifier,J,mi))},get onDidChange(){return Rt.onDidChange}},ai={createDiagnosticCollection(J){return Wt.createDiagnosticCollection(Fe.identifier,J)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:J=>Wt.getDiagnostics(J),getLanguages(){return Ft.getLanguages()},setTextDocumentLanguage(J,de){return Ft.changeLanguage(J.uri,de)},match(J,de){return(0,t.score)(z.LanguageSelector.from(J),de.uri,de.languageId,!0)},registerCodeActionsProvider(J,de,ke){return dt.registerCodeActionProvider(Fe,pt(J),de,ke)},registerCodeLensProvider(J,de){return dt.registerCodeLensProvider(Fe,pt(J),de)},registerDefinitionProvider(J,de){return dt.registerDefinitionProvider(Fe,pt(J),de)},registerDeclarationProvider(J,de){return dt.registerDeclarationProvider(Fe,pt(J),de)},registerImplementationProvider(J,de){return dt.registerImplementationProvider(Fe,pt(J),de)},registerTypeDefinitionProvider(J,de){return dt.registerTypeDefinitionProvider(Fe,pt(J),de)},registerHoverProvider(J,de){return dt.registerHoverProvider(Fe,pt(J),de,Fe.identifier)},registerEvaluatableExpressionProvider(J,de){return dt.registerEvaluatableExpressionProvider(Fe,pt(J),de,Fe.identifier)},registerInlineValuesProvider(J,de){return dt.registerInlineValuesProvider(Fe,pt(J),de,Fe.identifier)},registerDocumentHighlightProvider(J,de){return dt.registerDocumentHighlightProvider(Fe,pt(J),de)},registerLinkedEditingRangeProvider(J,de){return dt.registerLinkedEditingRangeProvider(Fe,pt(J),de)},registerReferenceProvider(J,de){return dt.registerReferenceProvider(Fe,pt(J),de)},registerRenameProvider(J,de){return dt.registerRenameProvider(Fe,pt(J),de)},registerDocumentSymbolProvider(J,de,ke){return dt.registerDocumentSymbolProvider(Fe,pt(J),de,ke)},registerWorkspaceSymbolProvider(J){return dt.registerWorkspaceSymbolProvider(Fe,J)},registerDocumentFormattingEditProvider(J,de){return dt.registerDocumentFormattingEditProvider(Fe,pt(J),de)},registerDocumentRangeFormattingEditProvider(J,de){return dt.registerDocumentRangeFormattingEditProvider(Fe,pt(J),de)},registerOnTypeFormattingEditProvider(J,de,ke,...nt){return dt.registerOnTypeFormattingEditProvider(Fe,pt(J),de,[ke].concat(nt))},registerDocumentSemanticTokensProvider(J,de,ke){return dt.registerDocumentSemanticTokensProvider(Fe,pt(J),de,ke)},registerDocumentRangeSemanticTokensProvider(J,de,ke){return dt.registerDocumentRangeSemanticTokensProvider(Fe,pt(J),de,ke)},registerSignatureHelpProvider(J,de,ke,...nt){return typeof ke=="object"?dt.registerSignatureHelpProvider(Fe,pt(J),de,ke):dt.registerSignatureHelpProvider(Fe,pt(J),de,typeof ke=="undefined"?[]:[ke,...nt])},registerCompletionItemProvider(J,de,...ke){return dt.registerCompletionItemProvider(Fe,pt(J),de,ke)},registerInlineCompletionItemProvider(J,de){return(0,V.checkProposedApiEnabled)(Fe),dt.registerInlineCompletionsProvider(Fe,pt(J),de)},registerDocumentLinkProvider(J,de){return dt.registerDocumentLinkProvider(Fe,pt(J),de)},registerColorProvider(J,de){return dt.registerColorProvider(Fe,pt(J),de)},registerFoldingRangeProvider(J,de){return dt.registerFoldingRangeProvider(Fe,pt(J),de)},registerSelectionRangeProvider(J,de){return dt.registerSelectionRangeProvider(Fe,J,de)},registerCallHierarchyProvider(J,de){return dt.registerCallHierarchyProvider(Fe,J,de)},setLanguageConfiguration:(J,de)=>dt.setLanguageConfiguration(Fe,J,de),getTokenInformationAtPosition(J,de){return(0,V.checkProposedApiEnabled)(Fe),Ft.tokenAtPosition(J,de)},registerInlayHintsProvider(J,de){return(0,V.checkProposedApiEnabled)(Fe),dt.registerInlayHintsProvider(Fe,J,de)},registerTypeHierarchyProvider(J,de){return(0,V.checkProposedApiEnabled)(Fe),dt.registerTypeHierarchyProvider(Fe,J,de)},createLanguageStatusItem(J){return(0,V.checkProposedApiEnabled)(Fe),Ft.createLanguageStatusItem(J)}},Ti={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(J,de,ke){const nt=await(R.URI.isUri(J)?Promise.resolve(gi.openTextDocument(J)):Promise.resolve(J));return Pt.showTextDocument(nt,de,ke)},createTextEditorDecorationType(J){return Pt.createTextEditorDecorationType(Fe,J)},onDidChangeActiveTextEditor(J,de,ke){return Pt.onDidChangeActiveTextEditor(J,de,ke)},onDidChangeVisibleTextEditors(J,de,ke){return Pt.onDidChangeVisibleTextEditors(J,de,ke)},onDidChangeTextEditorSelection(J,de,ke){return Pt.onDidChangeTextEditorSelection(J,de,ke)},onDidChangeTextEditorOptions(J,de,ke){return Pt.onDidChangeTextEditorOptions(J,de,ke)},onDidChangeTextEditorVisibleRanges(J,de,ke){return Pt.onDidChangeTextEditorVisibleRanges(J,de,ke)},onDidChangeTextEditorViewColumn(J,de,ke){return Pt.onDidChangeTextEditorViewColumn(J,de,ke)},onDidCloseTerminal(J,de,ke){return ct.onDidCloseTerminal(J,de,ke)},onDidOpenTerminal(J,de,ke){return ct.onDidOpenTerminal(J,de,ke)},onDidChangeActiveTerminal(J,de,ke){return ct.onDidChangeActiveTerminal(J,de,ke)},onDidChangeTerminalDimensions(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),ct.onDidChangeTerminalDimensions(J,de,ke)},onDidChangeTerminalState(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),ct.onDidChangeTerminalState(J,de,ke)},onDidWriteTerminalData(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),ct.onDidWriteTerminalData(J,de,ke)},get state(){return qe.state},onDidChangeWindowState(J,de,ke){return qe.onDidChangeWindowState(J,de,ke)},showInformationMessage(J,...de){return Kt.showMessage(Fe,A.default.Info,J,de[0],de.slice(1))},showWarningMessage(J,...de){return Kt.showMessage(Fe,A.default.Warning,J,de[0],de.slice(1))},showErrorMessage(J,...de){return Kt.showMessage(Fe,A.default.Error,J,de[0],de.slice(1))},showQuickPick(J,de,ke){return Vt.showQuickPick(J,!!Fe.enableProposedApi,de,ke)},showWorkspaceFolderPick(J){return Vt.showWorkspaceFolderPick(J)},showInputBox(J,de){return Vt.showInput(J,de)},showOpenDialog(J){return hi.showOpenDialog(J)},showSaveDialog(J){return hi.showSaveDialog(J)},createStatusBarItem(J,de,ke){let nt,bt,Dt;return typeof J=="string"?(nt=J,bt=de,Dt=ke):(bt=J,Dt=de),zt.createStatusBarEntry(Fe,nt,bt,Dt)},setStatusBarMessage(J,de){return zt.setStatusBarMessage(J,de)},withScmProgress(J){return Se.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),ci.withProgress(Fe,{location:x.ProgressLocation.SourceControl},(de,ke)=>J({report(nt){}}))},withProgress(J,de){return ci.withProgress(Fe,J,de)},createOutputChannel(J){return Ut.createOutputChannel(J,Fe)},createWebviewPanel(J,de,ke,nt){return qt.createWebviewPanel(Fe,J,de,ke,nt)},createWebviewTextEditorInset(J,de,ke,nt){return(0,V.checkProposedApiEnabled)(Fe),vi.createWebviewEditorInset(J,de,ke,nt,Fe)},createTerminal(J,de,ke){return typeof J=="object"?("location"in J&&(0,V.checkProposedApiEnabled)(Fe),"pty"in J?ct.createExtensionTerminal(J):ct.createTerminalFromOptions(J)):ct.createTerminal(J,de,ke)},registerTerminalLinkProvider(J){return ct.registerLinkProvider(J)},registerTerminalProfileProvider(J,de){return ct.registerProfileProvider(Fe,J,de)},registerTreeDataProvider(J,de){return Jt.registerTreeDataProvider(J,de,Fe)},createTreeView(J,de){return Jt.createTreeView(J,de,Fe)},registerWebviewPanelSerializer:(J,de)=>qt.registerWebviewPanelSerializer(Fe,J,de),registerCustomEditorProvider:(J,de,ke={})=>Ei.registerCustomEditorProvider(Fe,J,de,ke),registerFileDecorationProvider(J){return mt.registerFileDecorationProvider(J,Fe.identifier)},registerUriHandler(J){return Bt.registerUriHandler(Fe.identifier,J)},createQuickPick(){return Vt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Fe.identifier)},get activeColorTheme(){return di.activeColorTheme},onDidChangeActiveColorTheme(J,de,ke){return di.onDidChangeActiveColorTheme(J,de,ke)},registerWebviewViewProvider(J,de,ke){return _i.registerWebviewViewProvider(Fe,J,de,ke?.webviewOptions)},get activeNotebookEditor(){return(0,V.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(J,de,ke)},get visibleNotebookEditors(){return(0,V.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,V.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),Ht.onDidChangeNotebookEditorSelection(J,de,ke)},onDidChangeNotebookEditorVisibleRanges(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),Ht.onDidChangeNotebookEditorVisibleRanges(J,de,ke)},showNotebookDocument(J,de){return(0,V.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(J,de)},registerExternalUriOpener(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),yi.registerExternalUriOpener(Fe.identifier,J,de,ke)},get openEditors(){return(0,V.checkProposedApiEnabled)(Fe),it.tabs},get onDidChangeOpenEditors(){return(0,V.checkProposedApiEnabled)(Fe),it.onDidChangeTabs},getInlineCompletionItemController(J){return(0,V.checkProposedApiEnabled)(Fe),v.InlineCompletionController.get(J)}},gi={get rootPath(){return Se.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(J){throw F.readonly()},getWorkspaceFolder(J){return xe.getWorkspaceFolder(J)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(J){throw F.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(J){throw F.readonly()},updateWorkspaceFolders:(J,de,...ke)=>xe.updateWorkspaceFolders(Fe,J,de||0,...ke),onDidChangeWorkspaceFolders:function(J,de,ke){return xe.onDidChangeWorkspace(J,de,ke)},asRelativePath:(J,de)=>xe.getRelativePath(J,de),findFiles:(J,de,ke,nt)=>xe.findFiles(z.GlobPattern.from(J),z.GlobPattern.from(de),ke,Fe.identifier,nt),findTextInFiles:(J,de,ke,nt)=>{let bt,Dt;return typeof de=="object"?(bt=de,Dt=ke):(bt={},Dt=de,nt=ke),xe.findTextInFiles(J,bt||{},Dt,Fe.identifier,nt)},saveAll:J=>xe.saveAll(J),applyEdit(J){return Si.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,de,ke,nt)=>Mt.createFileSystemWatcher(z.GlobPattern.from(J),de,ke,nt),get textDocuments(){return Ct.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw F.readonly()},openTextDocument(J){let de;const ke=J;if(typeof J=="string")de=Promise.resolve(R.URI.file(J));else if(R.URI.isUri(J))de=Promise.resolve(J);else if(!ke||typeof ke=="object")de=Ct.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(nt=>Ct.ensureDocumentData(nt).then(bt=>bt.document))},onDidOpenTextDocument:(J,de,ke)=>Ct.onDidAddDocument(J,de,ke),onDidCloseTextDocument:(J,de,ke)=>Ct.onDidRemoveDocument(J,de,ke),onDidChangeTextDocument:(J,de,ke)=>Ct.onDidChangeDocument(J,de,ke),onDidSaveTextDocument:(J,de,ke)=>Ct.onDidSaveDocument(J,de,ke),onWillSaveTextDocument:(J,de,ke)=>ti.getOnWillSaveTextDocumentEvent(Fe)(J,de,ke),get notebookDocuments(){return gt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,de){let ke;if(R.URI.isUri(J))ke=J,await gt.openNotebookDocument(J);else if(typeof J=="string")ke=R.URI.revive(await gt.createNotebookDocument({viewType:J,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(J,de,ke,nt){return gt.registerNotebookSerializer(Fe,J,de,ke,Fe.enableProposedApi?nt:void 0)},registerNotebookContentProvider:(J,de,ke,nt)=>((0,V.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,J,de,ke,Fe.enableProposedApi?nt:void 0)),onDidChangeConfiguration:(J,de,ke)=>Qt.onDidChangeConfiguration(J,de,ke),getConfiguration(J,de){return de=arguments.length===1?void 0:de,Qt.getConfiguration(J,de,Fe)},registerTextDocumentContentProvider(J,de){return $t.registerTextDocumentContentProvider(J,de)},registerTaskProvider:(J,de)=>(Se.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Fe,J,de)),registerFileSystemProvider(J,de,ke){return ri.registerFileSystemProvider(Fe.identifier,J,de,ke,Fe.enableProposedApi)},get fs(){return fe.value},registerFileSearchProvider:(J,de)=>((0,V.checkProposedApiEnabled)(Fe),Tt.registerFileSearchProvider(J,de)),registerTextSearchProvider:(J,de)=>((0,V.checkProposedApiEnabled)(Fe),Tt.registerTextSearchProvider(J,de)),registerRemoteAuthorityResolver:(J,de)=>((0,V.checkProposedApiEnabled)(Fe),Ie.registerRemoteAuthorityResolver(J,de)),registerResourceLabelFormatter:J=>((0,V.checkProposedApiEnabled)(Fe),wi.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,de,ke)=>Mt.onDidCreateFile(J,de,ke),onDidDeleteFiles:(J,de,ke)=>Mt.onDidDeleteFile(J,de,ke),onDidRenameFiles:(J,de,ke)=>Mt.onDidRenameFile(J,de,ke),onWillCreateFiles:(J,de,ke)=>Mt.getOnWillCreateFileEvent(Fe)(J,de,ke),onWillDeleteFiles:(J,de,ke)=>Mt.getOnWillDeleteFileEvent(Fe)(J,de,ke),onWillRenameFiles:(J,de,ke)=>Mt.getOnWillRenameFileEvent(Fe)(J,de,ke),openTunnel:J=>((0,V.checkProposedApiEnabled)(Fe),Ce.openTunnel(Fe,J).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,V.checkProposedApiEnabled)(Fe),Ce.getTunnels()},onDidChangeTunnels:(J,de,ke)=>((0,V.checkProposedApiEnabled)(Fe),Ce.onDidChangeTunnels(J,de,ke)),registerPortAttributesProvider:(J,de)=>((0,V.checkProposedApiEnabled)(Fe),Ce.registerPortsAttributesProvider(J,de)),registerTimelineProvider:(J,de)=>((0,V.checkProposedApiEnabled)(Fe),bi.registerTimelineProvider(J,de,Fe.identifier,ot.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:J=>((0,V.checkProposedApiEnabled)(Fe),xe.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,de,ke)=>xe.onDidGrantWorkspaceTrust(J,de,ke)},Ai={get inputBox(){return Se.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Fe)},createSourceControl(J,de,ke){return Xt.createSourceControl(Fe,J,de,ke)}},Ri={createCommentController(J,de){return si.createCommentController(Fe,J,de)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(J,de,ke){return lt.onDidStartDebugSession(J,de,ke)},onDidTerminateDebugSession(J,de,ke){return lt.onDidTerminateDebugSession(J,de,ke)},onDidChangeActiveDebugSession(J,de,ke){return lt.onDidChangeActiveDebugSession(J,de,ke)},onDidReceiveDebugSessionCustomEvent(J,de,ke){return lt.onDidReceiveDebugSessionCustomEvent(J,de,ke)},onDidChangeBreakpoints(J,de,ke){return lt.onDidChangeBreakpoints(J,de,ke)},registerDebugConfigurationProvider(J,de,ke){return lt.registerDebugConfigurationProvider(J,de,ke||x.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,de){return lt.registerDebugAdapterDescriptorFactory(Fe,J,de)},registerDebugAdapterTrackerFactory(J,de){return lt.registerDebugAdapterTrackerFactory(J,de)},startDebugging(J,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(J,de,{parentSession:ke}):lt.startDebugging(J,de,ke||{})},stopDebugging(J){return lt.stopDebugging(J)},addBreakpoints(J){return lt.addBreakpoints(J)},removeBreakpoints(J){return lt.removeBreakpoints(J)},asDebugSourceUri(J,de){return lt.asDebugSourceUri(J,de)}},Mi={registerTaskProvider:(J,de)=>_t.registerTaskProvider(Fe,J,de),fetchTasks:J=>_t.fetchTasks(J),executeTask:J=>_t.executeTask(Fe,J),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(J,de,ke)=>_t.onDidStartTask(J,de,ke),onDidEndTask:(J,de,ke)=>_t.onDidEndTask(J,de,ke),onDidStartTaskProcess:(J,de,ke)=>_t.onDidStartTaskProcess(J,de,ke),onDidEndTaskProcess:(J,de,ke)=>_t.onDidEndTaskProcess(J,de,ke)},Li={createNotebookController(J,de,ke,nt,bt){return ii.createNotebookController(Fe,J,de,ke,nt,Fe.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(J,de)=>gt.registerNotebookCellStatusBarItemProvider(Fe,J,de),get onDidSaveNotebookDocument(){return(0,V.checkProposedApiEnabled)(Fe),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,V.checkProposedApiEnabled)(Fe),Ht.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ni.createRendererMessaging(Fe,J)},onDidChangeNotebookDocumentMetadata(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),Yt.onDidChangeNotebookDocumentMetadata(J,de,ke)},onDidChangeNotebookCells(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(J,de,ke)},onDidChangeNotebookCellExecutionState(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(J,de,ke)},onDidChangeCellOutputs(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(J,de,ke)},onDidChangeCellMetadata(J,de,ke){return(0,V.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(J,de,ke)},createConcatTextDocument(J,de){return(0,V.checkProposedApiEnabled)(Fe),new $e.ExtHostNotebookConcatDocument(gt,Ct,J,de)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:fi,extensions:Pi,languages:ai,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:gi,Breakpoint:x.Breakpoint,CallHierarchyIncomingCall:x.CallHierarchyIncomingCall,CallHierarchyItem:x.CallHierarchyItem,CallHierarchyOutgoingCall:x.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:r.CandidatePortSource,CodeAction:x.CodeAction,CodeActionKind:x.CodeActionKind,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.CodeLens,Color:x.Color,ColorInformation:x.ColorInformation,ColorPresentation:x.ColorPresentation,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CompletionItem:x.CompletionItem,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.CompletionList,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.CustomExecution,DebugAdapterExecutable:x.DebugAdapterExecutable,DebugAdapterInlineImplementation:x.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:x.DebugAdapterNamedPipeServer,DebugAdapterServer:x.DebugAdapterServer,DebugConfigurationProviderTriggerKind:x.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.Diagnostic,DiagnosticRelatedInformation:x.DiagnosticRelatedInformation,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.Disposable,DocumentHighlight:x.DocumentHighlight,DocumentHighlightKind:x.DocumentHighlightKind,DocumentLink:x.DocumentLink,DocumentSymbol:x.DocumentSymbol,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.EvaluatableExpression,InlineValueText:x.InlineValueText,InlineValueVariableLookup:x.InlineValueVariableLookup,InlineValueEvaluatableExpression:x.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:x.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.FileDecoration,FileSystemError:x.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:x.FoldingRange,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.FunctionBreakpoint,InlineCompletionItem:x.InlineSuggestion,InlineCompletionList:x.InlineSuggestions,Hover:x.Hover,IndentAction:T.IndentAction,Location:x.Location,MarkdownString:x.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:x.ParameterInformation,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.Position,ProcessExecution:x.ProcessExecution,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.QuickInputButtons,Range:x.Range,RelativePattern:x.RelativePattern,Selection:x.Selection,SelectionRange:x.SelectionRange,SemanticTokens:x.SemanticTokens,SemanticTokensBuilder:x.SemanticTokensBuilder,SemanticTokensEdit:x.SemanticTokensEdit,SemanticTokensEdits:x.SemanticTokensEdits,SemanticTokensLegend:x.SemanticTokensLegend,ShellExecution:x.ShellExecution,ShellQuoting:x.ShellQuoting,SignatureHelp:x.SignatureHelp,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.SignatureInformation,SnippetString:x.SnippetString,SourceBreakpoint:x.SourceBreakpoint,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.SymbolInformation,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.Task,TaskGroup:x.TaskGroup,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TerminalLink:x.TerminalLink,TerminalLocation:x.TerminalLocation,TerminalProfile:x.TerminalProfile,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,TextDocumentChangeReason:x.TextDocumentChangeReason,ThemeColor:x.ThemeColor,ThemeIcon:x.ThemeIcon,TreeItem:x.TreeItem,TreeItemCollapsibleState:x.TreeItemCollapsibleState,TypeHierarchyItem:x.TypeHierarchyItem,UIKind:r.UIKind,Uri:R.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.WorkspaceEdit,InlayHint:x.InlayHint,InlayHintKind:x.InlayHintKind,RemoteAuthorityResolverError:x.RemoteAuthorityResolverError,ResolvedAuthority:x.ResolvedAuthority,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.TimelineItem,NotebookRange:x.NotebookRange,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookCellData:x.NotebookCellData,NotebookData:x.NotebookData,NotebookRendererScript:x.NotebookRendererScript,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.NotebookCellOutput,NotebookCellOutputItem:x.NotebookCellOutputItem,NotebookCellStatusBarItem:x.NotebookCellStatusBarItem,NotebookControllerAffinity:x.NotebookControllerAffinity,PortAttributes:x.PortAttributes,LinkedEditingRanges:x.LinkedEditingRanges,TestResultState:x.TestResultState,TestRunRequest:x.TestRunRequest,TestMessage:x.TestMessage,TestTag:x.TestTag,TestRunProfileKind:x.TestRunProfileKind,TextSearchCompleteMessageType:yt.TextSearchCompleteMessageType,CoveredCount:x.CoveredCount,FileCoverage:x.FileCoverage,StatementCoverage:x.StatementCoverage,BranchCoverage:x.BranchCoverage,FunctionCoverage:x.FunctionCoverage,WorkspaceTrustState:x.WorkspaceTrustState,LanguageStatusSeverity:x.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(we[224],be([0,1,56,96,31,95,32,47,48,37,99,100,101,73,66,71,97,72,45,70,88,64]),function(ie,e,d,F,E,A,R,k,y,T,t,_,r,h,a,l,g,I,b,c,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,d.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,d.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,d.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,d.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,d.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,d.registerSingleton)(r.IExtHostSearch,r.ExtHostSearch),(0,d.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,d.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,d.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,d.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,d.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,d.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs)}),define(we[225],be([0,1,223,33,219,6,13,5,11]),function(ie,e,d,F,E,A,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(a){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(I,...b)=>{b.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const c=b.slice(0,-1).join(","),p=b.pop().toString();return`(function anonymous(${c}) {
${p}
})`}});function g(...I){return l?self.eval(l.createScript("",...I)):new Function(...I)}a.create=g})(T||(T={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(l,g){for(let I of this._alternatives){let b=I(l);if(b){l=b;break}}if(this._factories.has(l))return this._factories.get(l).load(l,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);h(l,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,g,I){g=g.with({path:r(g.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const b=await fetch(y.FileAccess.asBrowserUri(g).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),b.status!==200)throw new Error(b.statusText);const c=await b.text(),p=`${g.toString(!0)}#vscode-extension`,S=`${c}
//# sourceURL=${p}`;let i;try{i=T.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(S)??S)}catch(f){throw console.error(l?`Loading code for extension ${l.value} failed: ${f.message}`:`Loading code failed: ${f.message}`),console.error(`${g.toString(!0)}${typeof f.line=="number"?` line ${f.line}`:""}${typeof f.column=="number"?` column ${f.column}`:""}`),console.error(f),f}const s={},u={exports:s},o=f=>{const v=this._fakeModules.getModule(f,g);if(v===void 0)throw new Error(`Cannot load module '${f}'`);return v};try{return I.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),i(u,s,o),u.exports!==s?u.exports:s}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),I.codeLoadingStop()}}async $setRemoteEnvironment(l){throw new Error("Not supported")}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+l;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function r(a,l){return a.endsWith(l)?a:a+l}function h(a,l){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(c,p){const S=console[c];console[c]=function(){a.$logExtensionHostMessage({type:"__$console",severity:p,arguments:b(arguments)}),l&&S.apply(console,arguments)}}const I=1e5;function b(c){const p=[],S=[];if(c.length)for(let i=0;i<c.length;i++){if(typeof c[i]=="undefined")c[i]="undefined";else if(c[i]instanceof Error){const s=c[i];s.stack?c[i]=s.stack:c[i]=s.toString()}S.push(c[i])}try{const i=JSON.stringify(S,function(s,u){if(u&&typeof u=="object"){if(p.indexOf(u)!==-1)return"[Circular]";p.push(u)}return u});return i.length>I?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(we[226],be([0,1,56,14,33,74,225,212]),function(ie,e,d,F,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(E.IExtHostExtensionService,R.ExtHostExtensionService),(0,d.registerSingleton)(F.ILogService,k.ExtHostLogService),(0,d.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(we[235],be([0,1,23,3,177,220,214,17,75,11,2,224,226]),function(ie,e,d,F,E,A,R,k,y,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const r=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const b=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:p=>p}),c=self.Worker;Worker=function(p,S){/^file:/i.test(p.toString())&&(p=T.FileAccess.asBrowserUri(t.URI.parse(p.toString())).toString(!0));const i=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${p}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;S=S||{},S.name=S.name||k.basename(p.toString());const s=new Blob([i],{type:"application/javascript"}),u=URL.createObjectURL(s);return new c(b?b.createScriptURL(u):u,S)}}else self.Worker=class extends R.NestedWorker{constructor(b,c){super(r,b,{name:k.basename(b.toString()),...c})}};const h=new class{exit(b){_()}async exists(b){return!0}async realpath(b){return b}};class a{constructor(){const c=new MessageChannel,p=new F.Emitter;let S=!1;r(c.port2,[c.port2]),c.port1.onmessage=i=>{const{data:s}=i;if(!(s instanceof ArrayBuffer)){console.warn("UNKNOWN data received",s);return}const u=d.VSBuffer.wrap(new Uint8Array(s,0,s.byteLength));if((0,E.isMessageOfType)(u,2)){S=!0,g("received terminate message from renderer");return}p.fire(u)},this.protocol={onMessage:p.event,send:i=>{if(!S){const s=i.buffer.buffer.slice(i.buffer.byteOffset,i.buffer.byteOffset+i.buffer.byteLength);c.port1.postMessage(s,[s])}}}}}function l(b){return new Promise(c=>{const p=b.onMessage(S=>{p.dispose();const i=JSON.parse(S.toString());b.send((0,E.createMessageOfType)(0)),c({protocol:b,initData:i})});b.send((0,E.createMessageOfType)(1))})}let g=b=>_();function I(){const b=new a;y.mark("code/extHost/willConnectToRenderer"),l(b.protocol).then(c=>{y.mark("code/extHost/didWaitForInitData");const p=new A.ExtensionHostMain(c.protocol,c.initData,h,null);g=S=>p.terminate(S)})}e.create=I})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89bbd372f459ce72e9c0b60eb3b26b924f64f62d/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
